<xsl:stylesheet version = '1.0'
     xmlns:xsl='http://www.w3.org/1999/XSL/Transform'>

<!-- this parameter can be overriden from Ant -->
<xsl:param name="docs">document('s:\p4\P2\javaportal\main\_buildcommon\scripts\ant\common\antlib\bootstrap.xml')|document('s:\p4\P2\javaportal\main\_buildcommon\scripts\ant\common\antlib\csharp.xml')</xsl:param>
<xsl:param name="title"/>

<xsl:template match="/">
<html><head><title><xsl:value-of select="$title" /></title></head>
<body>

<xsl:apply-templates select="//file" />
</body>
</html>
</xsl:template>

<xsl:template match="file">

	<xsl:variable name="dir" select="@dir" />
	<xsl:variable name="filename" select="." />
	<xsl:variable name="filepath" select="concat($dir,'/',$filename,'.xml')" />
	<xsl:variable name="tasks" select="document($filepath)//macrodef|document($filepath)//presetdef" />
	<xsl:if test="count($tasks) &gt; 0">
		<h2><xsl:value-of select="$filename" /></h2>
		<ul>
			<xsl:apply-templates select="$tasks">
				<xsl:with-param name="filename" select="." />
			</xsl:apply-templates>
		</ul>
	</xsl:if>

</xsl:template>

<xsl:template match="macrodef|presetdef">
<xsl:param name="filename" />
<li>
	<a target="mainFrame">
		<xsl:attribute name="href">
			<xsl:value-of select="concat($filename,'.html#',@name)" />
		</xsl:attribute>
		<xsl:value-of select="@name" />
	</a>
</li>
</xsl:template>


</xsl:stylesheet>