#!/bin/sh
###
### UpdateLicense.sh
### 
### How to 
### Execute:      sh UpdateLicense.sh <new_license_file>
### 
### Prerequisite 
### Environment:  This shell script must be executed from the directory
###               containing your license.bea (BEA Home directory).
###               java (Java2) must be located in your path.
### 
### Function:     Update current license.bea with new license sections.
###               Invokes LicenseMerger <existing_license> <new_license>.
###               This will result in merged license containing both existing
###               and new license sections.
###

if [ "${1}" = "" ]; then
  echo "${0}: missing new license file argument"
  echo "Usage: ${0} <new_license_file>"
  exit 1
fi
java -cp ./utils/utils.jar com.bea.plateng.common.registry.LicenseMerger license.bea $1 
