/*
 * Created on Feb 2, 2005
 */
 
using System;
using XPResourceManager=com.plumtree.openfoundation.internationalization.XPResourceManager;
using ResourceConstants=com.plumtree.nullnavigation.common.constants.ResourceConstants;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.portaluiinfrastructure.navtype;
using com.plumtree.uiinfrastructure.activityspace;
using AppConstants=com.plumtree.uiinfrastructure.application.varpacks.AppConstants;
using ApplicationManager=com.plumtree.uiinfrastructure.web.ApplicationManager;
using IApplication=com.plumtree.uiinfrastructure.web.IApplication;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.nullnavigation
{
  /// <summary>
  /// Class description
  /// </summary>
  /// <author>robertz</author>
  public class NavTypePortletNav : INavTypes
  {
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.navtype.INavTypes#GetID()"></seealso>
    public virtual int GetID()
    {
      return NavTypeConstants.NAVTYPE_ID_PORTLETNAV;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.navtype.INavTypes#GetName(java.lang.String)"></seealso>
    public virtual String GetName(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      return rm.GetString(797, ResourceConstants.PORTALCOMMONMSGS, _strLangID);
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.navtype.INavTypes#GetScope(java.lang.String)"></seealso>
    public virtual String GetScope(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      return rm.GetString(798, ResourceConstants.PORTALCOMMONMSGS, _strLangID);
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.navtype.INavTypes#JavaScriptIncludes(com.plumtree.uiinfrastructure.activityspace.AActivitySpace)"></seealso>
    public virtual HTMLScriptCollection JavaScriptIncludes(AActivitySpace owner)
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.navtype.INavTypes#IsFeatureEnabled(com.plumtree.portaluiinfrastructure.navtype.NavFeatureEnum)"></seealso>
    public virtual bool IsFeatureEnabled(NavFeatureEnum feature)
    {
      if (feature.Equals(NavFeatureEnum.TOPBAR))
      {
        return false;
      }
      return true;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.navtype.INavTypes#GetNavAreaView(com.plumtree.portaluiinfrastructure.navtype.NavAreaEnum)"></seealso>
    public virtual String GetNavAreaView(NavAreaEnum area)
    {
      return null;
    }
  }
}