/*
 * Created on May 20, 2003
 */
 
using System;
using com.plumtree.openlog;
using com.plumtree.portalpages.common.plugnav;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.nullnavigation.views
{
  /// <summary>
  /// View to draw an admin link
  /// </summary>
  /// <author>DavidP</author>
  public class NavigationAdminOnly : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_COMMON),
     "com.plumtree.nullnavigation.views.NavigationAdminOnly");
    
    /// <summary>
    /// MVC object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "NullNavigationAdminOnly";
    public const String PORTALCOMMONMSGS = "ptmsgs_portalcommonmsgs";
    private AActivitySpace m_asOwner;
    private IPluggableNavModelRO m_model;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new NavigationAdminOnly();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Display()"></seealso>
    public virtual HTMLElement Display()
    {
      HTMLElementCollection myGroup = new HTMLElementCollection();
      HTMLElement result = myGroup;
      try
      {
        // Only add something if they are administrator
        IPTSession ptSession = (IPTSession) m_asOwner.GetUserSession();
        // Return true if the current user is a system administrator
        if (PlumtreeHelpers.CheckCurrentUserIsAdmin(ptSession))
        {
          // *** JAVASCRIPT BEGIN
          // Populate the arrays	   	
          HTMLScriptCollection col = new HTMLScriptCollection();
          result.AddInnerHTMLElement(col);
          col.AddInnerHTMLElement(NavigationCommonHelpers.CreateMandatoryTabsArray(m_model.GetCategoryLinks(NavCategoryType.ADMIN,
           true), m_asOwner));
          col.AddInnerHTMLElement(NavigationCommonHelpers.GenerateJSHTMLHelperFunctions(m_asOwner));
          HTMLScript script = new HTMLScript("text/javaScript");
          result.AddInnerHTMLElement(script);
          // *** JAVASCRIPT END
          result.AddInnerHTMLString("<!-- start NAV DHTML MIDBAR -->");
          script = new HTMLScript("text/javaScript");
          script.AddInnerHTMLString("writeTabsRows(" + JSHelper.GetSafeJSVariableWarn(NavigationCommonHelpers.JSCRIPT_VAR_MANDTAB_ARRAY) + ");");
          result.AddInnerHTMLElement(script);
          result.AddInnerHTMLString("<!-- end NAV DHTML MIDBAR -->");
          script.AddInnerHTMLString("\ndocument.PCC.RegisterForWindowEvent(\"onload\", \"gbPageLoaded = true;\" );");
          }
      }
      catch (HTMLException he)
      {
        log.Error(he, "HTMLException in null (mand only) nav: ");
      }
      catch (Exception e)
      {
        log.Error(e, "Exception in null (mand only) nav: ");
      }
      return result;
    }
    
    /// <summary>
    /// This method returns the HTMLScript that encompasses the Javascript on the page.
    /// </summary>
    /// <returns>HTMLScript</returns>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_model = (IPluggableNavModelRO) model;
      m_asOwner = parent;
    }
  }
}