/*
 * Created on Apr 7, 2003
 */
 
using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portalpages.common.plugnav;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.portaluiinfrastructure.application.varpacks;
using com.plumtree.portaluiinfrastructure.compoundlist;
using com.plumtree.portaluiinfrastructure.login;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.web;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.nullnavigation.views
{
  /// <summary>
  /// Null navigation, but show mandatory links (if they exist)
  /// Note use of abstract view for js funcs
  /// </summary>
  /// <author>DavidP</author>
  public class NavigationMandatoryLinksOnly : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_COMMON),
     "com.plumtree.nullnavigation.views.NavigationMandatoryLinksOnly");
    
    /// <summary>
    /// Drop down view class name 
    /// </summary>
    public const String ObjectName = "PTHztlDDNavMandOnly";
    private AActivitySpace m_asOwner;
    private IPluggableNavModelRO m_model;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new NavigationMandatoryLinksOnly();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Display()"></seealso>
    public virtual HTMLElement Display()
    {
      HTMLElementCollection myGroup = new HTMLElementCollection();
      HTMLElement result = myGroup;
      try
      {
        // *** JAVASCRIPT BEGIN
        // Populate the arrays	   	
        HTMLScriptCollection col = new HTMLScriptCollection();
        result.AddInnerHTMLElement(col);
        CreateMandatoryLinksMenu(col);
        col.AddInnerHTMLElement(NavigationCommonHelpers.CreateMandatoryTabsArray(m_model.GetCategoryLinks(NavCategoryType.MANDATORYTABS,
         true), m_asOwner));
        col.AddInnerHTMLElement(CreateDDTabsArray());
        col.AddInnerHTMLElement(NavigationCommonHelpers.GenerateJSHTMLHelperFunctions(m_asOwner));
        HTMLScript script = new HTMLScript("text/javaScript");
        result.AddInnerHTMLElement(script);
        // *** JAVASCRIPT END
        result.AddInnerHTMLString("<!-- start NAV DHTML MIDBAR -->");
        // include jsportalmenus js files
        result.AddInnerHTMLElement(ConfigHelper.GetJSIncluderJSComponentInclude(ConfigHelper.JSCOMPONENT_JSPORTALMENU,
         m_asOwner));
        script = new HTMLScript("text/javaScript");
        // write div holders for the dropdown menus
        script.AddInnerHTMLString("writePortalMenuDivs(" + JSHelper.GetSafeJSVariableWarn(NavigationCommonHelpers.JSCRIPT_VAR_DDTABS_ARRAY) + ");\n");
        // get PTMenu.css location string	
        IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
        String defaultStyleSheet = ConfigHelper.GetImageServerBaseURL(m_asOwner) + "common/private/js/jsportalmenus/" + ConfigHelper.GetJSIncluderComponentVersion(ConfigHelper.JSCOMPONENT_JSPORTALMENU) + "/styles/css/PTPMMenu.css";
        // initialize menu	
        script.AddInnerHTMLString("initDDandManTabsRows(" + JSHelper.GetSafeJSVariableWarn(NavigationCommonHelpers.JSCRIPT_VAR_DDTABS_ARRAY) + "," + JSHelper.GetSafeJSVariableWarn(NavigationCommonHelpers.JSCRIPT_VAR_MANDTAB_ARRAY) + ",\'" + defaultStyleSheet + "\');");
        result.AddInnerHTMLElement(script);
        result.AddInnerHTMLString("<!-- end NAV DHTML MIDBAR -->");
        script.AddInnerHTMLString("\ndocument.PCC.RegisterForWindowEvent(\"onload\", \"gbPageLoaded = true;\" );");
        }
      catch (HTMLException he)
      {
        log.Error(he, "HTMLException in null (mand only) nav: ");
      }
      catch (Exception e)
      {
        log.Error(e, "Exception in null (mand only) nav: ");
      }
      return result;
    }
    
    /// <summary>
    /// This method returns the HTMLScript that encompasses the Javascript on the page.
    /// </summary>
    /// <returns>HTMLScript</returns>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public virtual String GetName()
    {
      return ObjectName;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_model = (IPluggableNavModelRO) model;
      m_asOwner = parent;
    }
    
    /// <summary>
    /// Craete the array of javascript objects for menu
    /// </summary>
    /// <param name="script"></param>
    /// <throws>HTMLException </throws>
    protected virtual HTMLScript CreateDDTabsArray()
    {
      // Roughly estimate the size of the buffer
      XPStringBuilder buf = new XPStringBuilder(300);
      String strMaxLength = (String) m_asOwner.GetVarPack(PTNavSettingsVarPack.VARPACK_ID).GetVarPackValue(PTNavSettingsVarPack.INTHORIZONTALNAVTAB_TRUNCATION_WIDTH);
      buf.Append("[");
      if (NavPageType.COMMUNITYPREVIEW != m_model.GetCurNavPageType())
      {
        String strMandLinksName = m_model.GetCategoryTitle(NavCategoryType.MANDATORYLINK);
        String strTruncMandLinksName = GeneralHelpers.TruncateLongString(strMandLinksName,
         XPConvert.ToInteger(strMaxLength), false);
        ICPListEntryIterator cpList = m_model.GetCategoryLinks(NavCategoryType.MANDATORYLINK,
         false);
        if ((null != strMandLinksName) && !("").Equals(strMandLinksName) && (cpList.GetTotalCount() != 0))
        {
          // Add tooltip if the string was truncated.
          String toolTip = (strTruncMandLinksName.Length == strMandLinksName.Length) ? "null" : JSHelper.JSEncodeString(XPHttpUtility.HtmlEncode(strMandLinksName));
          buf.Append("[\"" + JSHelper.JSEncodeString(XPHttpUtility.HtmlEncode(strTruncMandLinksName)) + "\",\"" + NavigationJSPortalMenuHelpers.m_strMandLinksID + "\",\"" + 
          // Need to HTMLEncode this, goes into the title attribute of a span.  
          toolTip + "\"]\n");
        }
      }
      buf.Append("]");
      return JSHelper.AddSafeJSVariable(NavigationCommonHelpers.JSCRIPT_VAR_DDTABS_ARRAY,
       buf.ToString());
    }
    
    /// <summary>
    /// Creat the mandatory links dropdown menu in javascript.
    /// </summary>
    /// <param name="script"></param>
    /// <throws>HTMLException </throws>
    protected virtual void CreateMandatoryLinksMenu(HTMLScriptCollection col)
    {
      ICPListEntryIterator cpList = m_model.GetCategoryLinks(NavCategoryType.MANDATORYLINK,
       true);
      String strMandLinksName = m_model.GetCategoryTitle(NavCategoryType.MANDATORYLINK);
      // bjf -- if there aren't any links, then don't show the menu
      if ((null != strMandLinksName) && !("").Equals(strMandLinksName) && (cpList.GetTotalCount() != 0))
      {
        NavigationJSPortalMenuHelpers.MakeDDMenu(col, m_asOwner, cpList, NavigationJSPortalMenuHelpers.m_strMandLinksID);
        }
    }
  }
}