/*
 * Created on Feb 2, 2005
 */
package com.plumtree.nullnavigation;

import com.plumtree.openfoundation.internationalization.XPResourceManager;
import com.plumtree.nullnavigation.common.constants.ResourceConstants;
import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.portaluiinfrastructure.navtype.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.application.varpacks.AppConstants;
import com.plumtree.uiinfrastructure.web.ApplicationManager;
import com.plumtree.uiinfrastructure.web.IApplication;
import com.plumtree.xpshared.htmlelements.*;

/**
 * Class description
 * 
 * @author robertz
 */
public class NavTypePortletNav implements INavTypes
{

	/**
	 * @see com.plumtree.portaluiinfrastructure.navtype.INavTypes#GetID()
	 */
	public int GetID()
	{
		return NavTypeConstants.NAVTYPE_ID_PORTLETNAV;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.navtype.INavTypes#GetName(java.lang.String)
	 */
	public String GetName(String _strLangID)
	{
        IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
        XPResourceManager rm     = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");

        return rm.GetString(797, ResourceConstants.PORTALCOMMONMSGS, _strLangID);
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.navtype.INavTypes#GetScope(java.lang.String)
	 */
	public String GetScope(String _strLangID)
	{
        IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
        XPResourceManager rm     = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");

        return rm.GetString(798, ResourceConstants.PORTALCOMMONMSGS, _strLangID);
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.navtype.INavTypes#JavaScriptIncludes(com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
	 */
	public HTMLScriptCollection JavaScriptIncludes(AActivitySpace owner)
	{
		return null;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.navtype.INavTypes#IsFeatureEnabled(com.plumtree.portaluiinfrastructure.navtype.NavFeatureEnum)
	 */
	public boolean IsFeatureEnabled(NavFeatureEnum feature)
	{
		if (feature.equals(NavFeatureEnum.TOPBAR))
			return false;
		
		return true;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.navtype.INavTypes#GetNavAreaView(com.plumtree.portaluiinfrastructure.navtype.NavAreaEnum)
	 */
	public String GetNavAreaView(NavAreaEnum area)
	{
		return null;
	}

}
