/*
 * Created on May 20, 2003
 */

package com.plumtree.nullnavigation.views;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.plugnav.*;
import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * View to draw an admin link
 * 
 * @author DavidP
 */
public class NavigationAdminOnly implements IView 
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_COMMON),
		"com.plumtree.nullnavigation.views.NavigationAdminOnly");

	
	/** MVC object name */
	public static final String STR_MVC_CLASS_NAME = "NullNavigationAdminOnly";
	
	public static final String PORTALCOMMONMSGS = "ptmsgs_portalcommonmsgs";


	private AActivitySpace m_asOwner;
	private IPluggableNavModelRO m_model;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new NavigationAdminOnly();
	}

	/**
	 * 
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection myGroup = new HTMLElementCollection();
		HTMLElement result			  = myGroup;

		try
		{
			// Only add something if they are administrator
			IPTSession ptSession = (IPTSession) m_asOwner.GetUserSession();

			// Return true if the current user is a system administrator
			if (PlumtreeHelpers.CheckCurrentUserIsAdmin(ptSession))
			{
				// *** JAVASCRIPT BEGIN
				// Populate the arrays	   	
				
				HTMLScriptCollection col = new HTMLScriptCollection();
				result.AddInnerHTMLElement(col);
	
				col.AddInnerHTMLElement(NavigationCommonHelpers.CreateMandatoryTabsArray(
					m_model.GetCategoryLinks(NavCategoryType.ADMIN, true), m_asOwner));
				col.AddInnerHTMLElement(NavigationCommonHelpers.GenerateJSHTMLHelperFunctions(m_asOwner));
				
				
				HTMLScript script = new HTMLScript("text/javaScript");
				result.AddInnerHTMLElement(script);
				
				// *** JAVASCRIPT END
				result.AddInnerHTMLString("<!-- start NAV DHTML MIDBAR -->");
				script = new HTMLScript("text/javaScript");
				script.AddInnerHTMLString("writeTabsRows(" +
					JSHelper.GetSafeJSVariableWarn(NavigationCommonHelpers.JSCRIPT_VAR_MANDTAB_ARRAY) + ");");
				result.AddInnerHTMLElement(script);
				result.AddInnerHTMLString("<!-- end NAV DHTML MIDBAR -->");
				script.AddInnerHTMLString("\ndocument.PCC.RegisterForWindowEvent(\"onload\", \"gbPageLoaded = true;\" );");
			}
		}
		catch (HTMLException he)
		{
			
				log.Error(he, "HTMLException in null (mand only) nav: ");
			
		}
		catch (Exception e)
		{
			
				log.Error(e, "Exception in null (mand only) nav: ");
			
		}

		return result;
	}

	/**
	 * This method returns the HTMLScript that encompasses the Javascript on the page.
	 *
	 * @return HTMLScript
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		return null;
	}

	/**
	 * 
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_model		  = (IPluggableNavModelRO) model;
		m_asOwner     = parent;
	}
}

