/*
 * Created on Apr 7, 2003
 */
package com.plumtree.nullnavigation.views;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.plugnav.*;
import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.portaluiinfrastructure.application.varpacks.*;
import com.plumtree.portaluiinfrastructure.compoundlist.*;
import com.plumtree.portaluiinfrastructure.login.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.web.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * Null navigation, but show mandatory links (if they exist)
 * Note use of abstract view for js funcs
 * 
 * @author DavidP
 */
public class NavigationMandatoryLinksOnly implements IView 
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_COMMON),
		"com.plumtree.nullnavigation.views.NavigationMandatoryLinksOnly");

	
	/** Drop down view class name */
	public static final String ObjectName = "PTHztlDDNavMandOnly";

	private AActivitySpace m_asOwner;
	private IPluggableNavModelRO m_model;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new NavigationMandatoryLinksOnly();
	}

	/**
	 * 
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection myGroup = new HTMLElementCollection();
		HTMLElement result			  = myGroup;

		try
		{		
			// *** JAVASCRIPT BEGIN
			// Populate the arrays	   	
			
			HTMLScriptCollection col = new HTMLScriptCollection();
			result.AddInnerHTMLElement(col);
			CreateMandatoryLinksMenu(col);

			col.AddInnerHTMLElement(NavigationCommonHelpers.CreateMandatoryTabsArray(
				m_model.GetCategoryLinks(NavCategoryType.MANDATORYTABS, true), m_asOwner));
			col.AddInnerHTMLElement(CreateDDTabsArray());
			col.AddInnerHTMLElement(NavigationCommonHelpers.GenerateJSHTMLHelperFunctions(m_asOwner));
			
			
			HTMLScript script = new HTMLScript("text/javaScript");
			result.AddInnerHTMLElement(script);
			
			// *** JAVASCRIPT END
			result.AddInnerHTMLString("<!-- start NAV DHTML MIDBAR -->");
			// include jsportalmenus js files
			
			result.AddInnerHTMLElement(ConfigHelper.GetJSIncluderJSComponentInclude(ConfigHelper.JSCOMPONENT_JSPORTALMENU, m_asOwner));
			script = new HTMLScript("text/javaScript");
			
			// write div holders for the dropdown menus
			script.AddInnerHTMLString("writePortalMenuDivs(" +
				JSHelper.GetSafeJSVariableWarn(NavigationCommonHelpers.JSCRIPT_VAR_DDTABS_ARRAY) + ");\n");
			
			// get PTMenu.css location string	
			IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
			
			String defaultStyleSheet = ConfigHelper.GetImageServerBaseURL(m_asOwner) + "common/private/js/jsportalmenus/" + 
			ConfigHelper.GetJSIncluderComponentVersion(ConfigHelper.JSCOMPONENT_JSPORTALMENU) + "/styles/css/PTPMMenu.css";
			
			// initialize menu	
			script.AddInnerHTMLString("initDDandManTabsRows(" +
				JSHelper.GetSafeJSVariableWarn(NavigationCommonHelpers.JSCRIPT_VAR_DDTABS_ARRAY) + "," +
				JSHelper.GetSafeJSVariableWarn(NavigationCommonHelpers.JSCRIPT_VAR_MANDTAB_ARRAY) + ",'" + 
				defaultStyleSheet + "');");		
			result.AddInnerHTMLElement(script);
			result.AddInnerHTMLString("<!-- end NAV DHTML MIDBAR -->");
			script.AddInnerHTMLString("\ndocument.PCC.RegisterForWindowEvent(\"onload\", \"gbPageLoaded = true;\" );");

		}
		catch (HTMLException he)
		{
			
				log.Error(he, "HTMLException in null (mand only) nav: ");
			
		}
		catch (Exception e)
		{
			
				log.Error(e, "Exception in null (mand only) nav: ");
			
		}

		return result;
	}

	/**
	 * This method returns the HTMLScript that encompasses the Javascript on the page.
	 *
	 * @return HTMLScript
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		return null;
	}

	/**
	 * 
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return ObjectName;
	}

	/**
	 * 
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_model		  = (IPluggableNavModelRO) model;
		m_asOwner     = parent;
	}

	/**
	 * Craete the array of javascript objects for menu
	 *
	 * @param script 
	 *
	 * @throws HTMLException 
	 */
	protected HTMLScript CreateDDTabsArray() throws HTMLException
	{
		// Roughly estimate the size of the buffer
		XPStringBuilder buf = new XPStringBuilder(300);
		String strMaxLength = (String)m_asOwner.GetVarPack(PTNavSettingsVarPack.VARPACK_ID).GetVarPackValue(PTNavSettingsVarPack.INTHORIZONTALNAVTAB_TRUNCATION_WIDTH);

		buf.Append("[");
		
		if (NavPageType.COMMUNITYPREVIEW != m_model.GetCurNavPageType()) 
		{
			String strMandLinksName     = m_model.GetCategoryTitle(NavCategoryType.MANDATORYLINK);
			String strTruncMandLinksName = GeneralHelpers.TruncateLongString(strMandLinksName, XPConvert.ToInteger(strMaxLength), false);
			ICPListEntryIterator cpList = m_model.GetCategoryLinks(NavCategoryType.MANDATORYLINK, false);
	
			if ((null != strMandLinksName) && !("").equals(strMandLinksName) &&
					(cpList.GetTotalCount() != 0) )
			{
				// Add tooltip if the string was truncated.
				String toolTip = (strTruncMandLinksName.length()==strMandLinksName.length()) ? "null" : JSHelper.JSEncodeString(XPHttpUtility.HtmlEncode(strMandLinksName)); 
				buf.Append("[\"" +  JSHelper.JSEncodeString(XPHttpUtility.HtmlEncode(strTruncMandLinksName)) + "\",\"" + 
									NavigationJSPortalMenuHelpers.m_strMandLinksID + "\",\"" +
									// Need to HTMLEncode this, goes into the title attribute of a span.  
									toolTip + "\"]\n");				
			} 
		} 
		buf.Append("]");
		
		return JSHelper.AddSafeJSVariable(NavigationCommonHelpers.JSCRIPT_VAR_DDTABS_ARRAY, buf.ToString());
	}

	/**
	 * Creat the mandatory links dropdown menu in javascript.
	 *
	 * @param script 
	 *
	 * @throws HTMLException 
	 */
	protected void CreateMandatoryLinksMenu(HTMLScriptCollection col)
		throws HTMLException
	{
		ICPListEntryIterator cpList = m_model.GetCategoryLinks(NavCategoryType.MANDATORYLINK, true);
		String strMandLinksName     = m_model.GetCategoryTitle(NavCategoryType.MANDATORYLINK);

		// bjf -- if there aren't any links, then don't show the menu
		if ((null != strMandLinksName) && !("").equals(strMandLinksName) &&
				(cpList.GetTotalCount() != 0))
		{
			NavigationJSPortalMenuHelpers.MakeDDMenu(col, m_asOwner, cpList, NavigationJSPortalMenuHelpers.m_strMandLinksID);
		}
	}
}

