@echo off
setlocal

rem
rem BEA BID Service Wrapper Script for Windows 
rem *********** 64 Bit Version ***************
rem 
rem Important Note - Beware application-specific problems with 
rem current directory on windows. Ask John Offenhartz for more details.
rem
rem

if "%OS%"=="Windows_NT" goto nt
echo This script only works with NT-based versions of Windows.
goto :eof

:nt
rem
rem Find the application home.
rem
rem %~dp0 is name of current script under NT
set _REALPATH=%~dp0
echo REALPATH = %_REALPATH%
set _WRAPPER_EXE=%_REALPATH%..\..\..\common\wrapper\3.2.3\bin\native\win32\wrapper.exe


set COMMON_PATH=%_REALPATH%..\..\..\common
set WRAPPER_PATH=%_REALPATH%..\..\..\common\wrapper\3.2.3
set WRAPPER_NATIVE_LIB_PATH=%WRAPPER_PATH%\lib\native\win32
set APPLICATION_PATH=%_REALPATH%..

rem 32 or 64 bit system?

rem force 32 bit on windows
rem change this to "force32" == "force32" to force a 32bit VM

if "%ProgramFiles(x86)%" == "" (

	set JRE_PATH=%COMMON_PATH%\jre\1.6.0_32
	rem bitmode setting is unsupported by jrocket. 
	set BIT_MODE=""
    echo BIT_DEPTH="32"
    
    goto processorcheck

)

set JRE_PATH=%COMMON_PATH%\jre\1.6.0_64
rem bitmode setting is unsupported by jrocket. 
set BIT_MODE=""
echo BIT_DEPTH="64"

:processorcheck



rem Find the requested command.
for /F %%v in ('echo %1^|findstr "^console$ ^start$ ^stop$ ^restart$ ^install$ ^status$ ^remove"') do call :exec set COMMAND=%%v

if "%COMMAND%" == "" (
    echo Usage: %0 { console : start : stop : restart : install : status : remove }
    goto :eof
) else (
    shift
)

rem
rem Find the ptportal.conf
rem Absolute path is required
:conf
set _WRAPPER_CONF="%_REALPATH%..\settings\config\ptportal.conf"

rem
rem Run the application.
rem At runtime, the current directory will be that of Wrapper.exe
rem
call :%COMMAND%
goto :eof

:console
"%_WRAPPER_EXE%" -c %_WRAPPER_CONF% "set.PLATFORM=win32"
goto :eof

:start
"%_WRAPPER_EXE%" -t %_WRAPPER_CONF% "set.PLATFORM=win32"
goto :eof

:stop
"%_WRAPPER_EXE%" -p %_WRAPPER_CONF% "set.PLATFORM=win32"
goto :eof

:install
"%_WRAPPER_EXE%" -i %_WRAPPER_CONF% "set.PLATFORM=win32" "set.COMMON_PATH=%COMMON_PATH%" "set.APPLICATION_PATH=%APPLICATION_PATH%" "set.WRAPPER_PATH=%WRAPPER_PATH%" "set.JRE_PATH=%JRE_PATH%" "set.WRAPPER_NATIVE_LIB_PATH=%WRAPPER_NATIVE_LIB_PATH%" "set.BIT_MODE=%BIT_MODE%"
goto :eof

:status
"%_WRAPPER_EXE%" -q %_WRAPPER_CONF% "set.PLATFORM=win32"
goto :eof

:remove
"%_WRAPPER_EXE%" -r %_WRAPPER_CONF% "set.PLATFORM=win32"
goto :eof

:restart
call :stop
call :start
goto :eof

:exec
%*
goto :eof
