using System;
using System.Collections;
using System.ComponentModel;
using System.Web;
using System.Web.SessionState;
using com.plumtree.portaluiinfrastructure.application;
using com.plumtree.server.portalpagesperf;
namespace portal 
{
	/// <summary>
	/// Summary description for Global.
	/// </summary>
	public class Global : System.Web.HttpApplication
	{
		public Global()
		{
			InitializeComponent();
		}	
		
		protected void Application_Start(Object sender, EventArgs e)
		{
			ApplicationStartup startup = new ApplicationStartup();
			startup.init();
		}
 
		protected void Session_Start(Object sender, EventArgs e)
		{
			com.plumtree.uiinfrastructure.web.PerfCounters.INSTANCE.IncrementCounter(PORTALPAGESPERF_COUNTERS.PORTALPAGESPERF_TOTAL_OPENSESSIONS);
			
			if (Response.Cookies.Count > 0)
			{
				foreach (string s in Response.Cookies.AllKeys)
				{
					if (s == System.Web.Security.FormsAuthentication.FormsCookieName || s.Equals("ASP.NET_SessionId"))
                 		Response.Cookies[s].HttpOnly = false;
				}
			}
		}

		protected void Application_BeginRequest(Object sender, EventArgs e)
		{
			if (Request.Path.IndexOf('\\') >= 0 ||
				System.IO.Path.GetFullPath(Request.PhysicalPath) != Request.PhysicalPath) 
			{
				throw new HttpException(404, "File not found.  Canonicalization error.  Please contact Portal Administrator.");
			}		
		}

		protected void Application_EndRequest(Object sender, EventArgs e)
		{			
			if (Response.Cookies.Count > 0)
			{
				foreach (string s in Response.Cookies.AllKeys)
				{
					if (s == System.Web.Security.FormsAuthentication.FormsCookieName || s.Equals("ASP.NET_SessionId"))
                 		Response.Cookies[s].HttpOnly = false;
				}
			}
		}

		protected void Application_AuthenticateRequest(Object sender, EventArgs e)
		{

		}

		protected void Application_Error(Object sender, EventArgs e)
		{

		}

		protected void Session_End(Object sender, EventArgs e)
		{
			com.plumtree.uiinfrastructure.web.PerfCounters.INSTANCE.DecrementCounter(PORTALPAGESPERF_COUNTERS.PORTALPAGESPERF_TOTAL_OPENSESSIONS);
		}

		protected void Application_End(Object sender, EventArgs e)
		{

		}
			
		#region Web Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
		}
		#endregion
	}
}

