namespace com.plumtree.portaluiinfrastructure.application
{
	using System;
	using System.Collections.Specialized;
	using System.Configuration;
	using System.Web;
	using com.plumtree.openfoundation.util;
	using com.plumtree.uiinfrastructure.application;
	using com.plumtree.uiinfrastructure.application.varpacks;
	using com.plumtree.uiinfrastructure.web;
	using System.Threading;

	
	/// <summary> This class used to load the application level settings
	/// 
	/// This implements a .NET .aspx page, and therefore must be completely
	/// re-written as a Java servlet in Java.
	/// 
	/// Any changes to this file need to be duplicated in the corresponding
	/// Java file (AppWarmUpServlet.java).
	/// </summary>
	/// <version> 1.0
	/// </version>
	/// <author> John Osborne
	/// 
	/// </author>	
	public class ApplicationStartup
	{

		public virtual void  init()
		{
			// We cannot use OpenLog yet at this point because it has not been initialized.
			XPSystem.Out.WriteLine("Starting Aqualogic Interaction Portal.");

			NameValueCollection context = ConfigurationSettings.AppSettings;												

			System.String strApplicationName = null;
			try 
			{
				strApplicationName = context[XPPage.APPLICATION_NAME];
			} 
			catch (Exception e) 
			{
				throw new XPException("Error getting " + XPPage.APPLICATION_NAME +
					" context parameter: " + e.Message, e);
			}

			if (null == strApplicationName)
			{
				strApplicationName = "";
			}
			XPSystem.Out.WriteLine("Delaying 30 seconds, then starting portal with application name="+strApplicationName);
			AppWarmUp.Init(strApplicationName);
		}					
	}
}