package com.plumtree.portal.application;

import javax.servlet.*;
import javax.servlet.http.*;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.application.*;
import com.plumtree.uiinfrastructure.web.*;

/**
 * This class used to load the application level settings.
 *
 * This implements a java servlet, and therefore must be completely re-written
 * as a .aspx page in C#.
 *
 * Any changes to this file need to be duplicated in the corresponding
 * .NET file (ApplicationStartup.cs).
 * 
 * @version 1.0
 * @author John Osborne
 */
@SuppressWarnings("serial")
public class AppWarmUpServlet extends HttpServlet
{
	/**
	 * Creates a new AppWarmUpServlet object.
	 */
	public AppWarmUpServlet()
	{
		super();
	}

	/**
	 * The init method does the loading of the Plumtree application.
	 *
	 * @throws ServletException
	 */
	public void init() throws ServletException
	{
		// We cannot use OpenLog yet at this point because it has not been initialized.
		XPSystem.Out.WriteLine("Starting WebCenter Interaction Portal.");

		ServletContext context = getServletContext();

		String strApplicationName = null;

		try 
		{
			strApplicationName = context.getInitParameter(XPPage.APPLICATION_NAME);
		} 
		catch (Exception e) 
		{
			throw new XPException("Error getting " + XPPage.APPLICATION_NAME +
				" init parameter: " + e.getMessage(), e);
		}

		if (null == strApplicationName)
		{
			strApplicationName = "";
		}

		AppWarmUp.Init(strApplicationName);
	}
}

