using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.portalnavigation.common.constants;
using com.plumtree.portalnavigation.views;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.portaluiinfrastructure.navtype;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.web;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalnavigation
{
  /// <summary>
  /// The NavType for Accessible Navigation
  /// </summary>
  /// <author>MichaelD</author>
  public class NavTypeAccessible : INavTypes
  {
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.navtype.INavTypes#GetID()"></seealso>
    public virtual int GetID()
    {
      return NavTypeConstants.NAVTYPE_ID_ACCESSIBLE;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.navtype.INavTypes#GetName(String)"></seealso>
    public virtual String GetName(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      return rm.GetString(759, ResourceConstants.PORTALCOMMONMSGS, _strLangID);
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.navtype.INavTypes#GetScope(String)"></seealso>
    public virtual String GetScope(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      return rm.GetString(760, ResourceConstants.PORTALCOMMONMSGS, _strLangID);
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.navtype.INavTypes#GetNavAreaView(com.plumtree.portaluiinfrastructure.navtype.NavAreaEnum)"></seealso>
    public virtual String GetNavAreaView(NavAreaEnum area)
    {
      if (area.Equals(NavAreaEnum.LEFTOFBODY))
      {
        return NavigationAccessibleLeftVerticalView.STR_MVC_CLASS_NAME;
      } else
      if (area.Equals(NavAreaEnum.ABOVEBODY))
      {
        return NavigationAccessibleAboveBodyView.STR_MVC_CLASS_NAME;
      } else
      if (area.Equals(NavAreaEnum.BELOWBODY))
      {
        return NavigationAccessibleBelowBodyView.STR_MVC_CLASS_NAME;
      } else
      if (area.Equals(NavAreaEnum.TOPBAR))
      {
        return PlumtreeTopBarView.STR_MVC_CLASS_NAME;
      }
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.navtype.INavTypes#JavaScriptIncludes()"></seealso>
    public virtual HTMLScriptCollection JavaScriptIncludes(AActivitySpace owner)
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.navtype.INavTypes#IsFeatureEnabled(com.plumtree.portaluiinfrastructure.navtype.NavFeatureEnum)"></seealso>
    public virtual bool IsFeatureEnabled(NavFeatureEnum feature)
    {
      return true;
    }
  }
}