using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.portalnavigation.common.constants;
using com.plumtree.portalnavigation.views;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.portaluiinfrastructure.navtype;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.web;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalnavigation
{
  /// <summary>
  /// The NavType for Left Vertical with Horizontal Tabs below the banner that groups 
  /// Mypage, Communities, Directory links together and a tab for Administration.
  /// The vertical sections are collapsable/expandable and stored as personal preferences. 
  /// </summary>
  /// <author>robertz</author>
  /// <author>DavidP</author>
  public class NavTypeTabGroupsLeftVertical : INavTypes
  {
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.navtype.INavTypes#GetID()"></seealso>
    public virtual int GetID()
    {
      return NavTypeConstants.NAVTYPE_ID_VERTICAL_TABGROUPSLEFT;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.navtype.INavTypes#GetName(java.lang.String)"></seealso>
    public virtual String GetName(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      return rm.GetString(674, ResourceConstants.PORTALCOMMONMSGS, _strLangID);
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.navtype.INavTypes#GetScope(java.lang.String)"></seealso>
    public virtual String GetScope(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      return rm.GetString(675, ResourceConstants.PORTALCOMMONMSGS, _strLangID);
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.navtype.INavTypes#GetNavAreaView(com.plumtree.portaluiinfrastructure.navtype.NavAreaEnum)"></seealso>
    public virtual String GetNavAreaView(NavAreaEnum area)
    {
      if (area.Equals(NavAreaEnum.LEFTOFBODY))
      {
        return NavigationTabGroupsLeftVerticalView.STR_MVC_CLASS_NAME;
      } else
      if (area.Equals(NavAreaEnum.BELOWBANNER))
      {
        return NavigationTabGroupsTabsView.STR_MVC_CLASS_NAME;
      } else
      if (area.Equals(NavAreaEnum.TOPBAR))
      {
        return PlumtreeTopBarView.STR_MVC_CLASS_NAME;
      }
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.navtype.INavTypes#JavaScriptIncludes()"></seealso>
    public virtual HTMLScriptCollection JavaScriptIncludes(AActivitySpace owner)
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.navtype.INavTypes#IsFeatureEnabled(com.plumtree.portaluiinfrastructure.navtype.NavFeatureEnum)"></seealso>
    public virtual bool IsFeatureEnabled(NavFeatureEnum feature)
    {
      return true;
    }
  }
}