/**
 * Created on Mar 20, 2003
  */
package com.plumtree.portalnavigation;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.portalnavigation.common.constants.*;
import com.plumtree.portalnavigation.views.*;
import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.portaluiinfrastructure.application.varpacks.*;
import com.plumtree.portaluiinfrastructure.navtype.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.web.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * Horizontal combobox implementation of key views
 *  
 * @author robertz
 * @author DavidP
 *
 */
public class NavTypeHorizontalComboBox implements INavTypes 
{

	/**
	 * @see com.plumtree.portaluiinfrastructure.navtype.INavTypes#GetID()
	 */
	public int GetID() {
		return NavTypeConstants.NAVTYPE_ID_HORIZONTAL_COMBOBOX_DROPDOWN;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.navtype.INavTypes#GetName(java.lang.String)
	 */
	public String GetName(String _strLangID) {
		IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
   		XPResourceManager rm     = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");

		return rm.GetString(669, ResourceConstants.PORTALCOMMONMSGS, _strLangID);
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.navtype.INavTypes#GetScope(java.lang.String)
	 */
	public String GetScope(String _strLangID) {
		IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
   		XPResourceManager rm     = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");

		return rm.GetString(670, ResourceConstants.PORTALCOMMONMSGS, _strLangID);
	}
	
	 /**
	  * @see com.plumtree.portaluiinfrastructure.navtype.INavTypes#GetNavAreaView(com.plumtree.portaluiinfrastructure.navtype.NavAreaEnum
	  */
	public String GetNavAreaView(NavAreaEnum area)
	{
		if (area.equals(NavAreaEnum.BELOWBANNER))
		{
			return NavigationCommSectionComboBoxView.STR_MVC_CLASS_NAME;
		}
		else if (area.equals(NavAreaEnum.ABOVEBANNER))
		{
			return NavigationHorizontalComboBoxView.STR_MVC_CLASS_NAME;
		}
		else if (area.equals(NavAreaEnum.TOPBAR))
		{
			return PlumtreeTopBarView.STR_MVC_CLASS_NAME;
		}
		
		
		return null;
	}
	
	/**
	 * 
	 * @see com.plumtree.portaluiinfrastructure.navtype.INavTypes#JavaScriptIncludes()
	 */
	public HTMLScriptCollection JavaScriptIncludes(AActivitySpace owner)
	{
		HTMLScriptCollection result = new HTMLScriptCollection();
		String strPortalImageServerJavaScriptURL = ConfigHelper.GetPortalImageServerJavaScriptURL(owner);

		// javascript file to display tabmandatory community tabs
		HTMLScript commonScript = new HTMLScript("text/javaScript");
							commonScript.SetSrc(strPortalImageServerJavaScriptURL +
								"navigationhorizontalcommon.js");
		result.AddInnerHTMLElement(commonScript);
		// Override js variables from NavigationSettings.xml
		int nNavTabWidth = NavigationCommonHelpers.GetNavSettingsValueAsInt(PTNavSettingsVarPack.INTHORIZONTALNAVTAB_WIDTH, owner); 
		if ( -1 != nNavTabWidth )
		{ 
			HTMLScript script = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
			script.AddInnerHTMLString(" // Overriding default value with NavigationSettings.xml value");
			script.AddInnerHTMLString("\n\tgHorizontalTabWidth = "+nNavTabWidth+";");
			result.AddInnerHTMLElement(script);
		}

		return result;
	}
	
	 /**
	  * @see com.plumtree.portaluiinfrastructure.navtype.INavTypes#IsFeatureEnabled(com.plumtree.portaluiinfrastructure.navtype.NavFeatureEnum)
	  */
	public boolean IsFeatureEnabled( NavFeatureEnum feature )
	{	
		return true;
	}
}

