using System;
using com.plumtree.openlog;
using com.plumtree.portalpages.common.constants;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.tips;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.approval.document
{
  /// <version>$Revision$</version>
  /// <author>BenG</author>
  public class DocumentApprovalAS : PTEditorAS
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.approval.document.DocumentApprovalAS");
    public const String STR_MVC_CLASS_NAME = "DocumentApproval";
    private const String sClassName = "com.plumtree.portalpages.admin.approval.document.DocumentApprovalAS";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new DocumentApprovalAS();
    }
    
    /// <summary>
    /// Returns the Editor title.
    /// </summary>
    /// <returns>String</returns>
    public override String GetEditorTitle()
    {
      return (GetString(0, ResourceConstants.PORTALADMINMSGS));
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the class name of the Property Repost Control.
    /// </summary>
    /// <returns>String</returns>
    public override String GetRepostControlName()
    {
      return (DocumentApprovalControl.STR_MVC_CLASS_NAME);
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(String,String,boolean)"></seealso>
    public override bool CheckBasicAccess(String strPage, String strControl,
     bool bSameSpace)
    {
      if (!((IPTSession) GetUserSession()).GetSessionInfo().CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_ACCESS_UTILITIES))
      {
        return false;
      }
      return base.CheckBasicAccess(strPage, strControl, bSameSpace);
    }
    
    /// <summary>
    /// Registers all the classes of the Property Activity Space.
    /// </summary>
    public override void Init()
    {
      log.Debug("ENTERING Init()");
      // ***CHANGE_HERE*** Replace Misc2Model below with your Model.
      m_strModelName = DocumentApprovalModel.STR_MVC_CLASS_NAME;
      // Warning: m_strModelName must be initialized before super.Init() is called.
      base.Init();
      //Sets left nav menu
      // ***CHANGE_HERE*** Set the left nav menu using StartNewSubMenu and AddLinkToSubMenu.
      // ***COMMENT_1*** If you don't want any left nav menu just remove the lines below.
      // BEGIN Sub menu "General Settings"
      int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(1, ResourceConstants.PORTALADMINMSGS));
      IModel myModel = GetModel(DocumentApprovalModel.STR_MVC_CLASS_NAME);
      DocumentApprovalDP dpTemp;
      dpTemp = new DocumentApprovalDP();
      RegisterPage(dpTemp);
      m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, dpTemp.GetName());
      SetCurrentPage(dpTemp);
      // Register Views
      RegisterView(DocumentApprovalView.STR_MVC_CLASS_NAME, myModel);
      // Register Controls
      RegisterControl(DocumentApprovalControl.STR_MVC_CLASS_NAME, myModel);
      // END Sub menu "General Settings"
      //	TIPS
      TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);
      if (tm != null)
      {
        try
        {
          tm.SetGeneratingClass(sClassName);
          int iTitleId = 0;
          int iTipId = 1;
          int iSecondaryTipId = 2;
          tm.SetTipTitle(this.GetString(iTitleId, ResourceConstants.TIPS));
          HTMLGenericElement e = new HTMLGenericElement(this.GetString(iTipId,
           ResourceConstants.TIPS));
          tm.SetTip(e);
          String sSecondary = this.GetString(iSecondaryTipId, ResourceConstants.TIPS);
          if (!("none_do_not_translate".Equals(sSecondary)))
          {
            e = new HTMLGenericElement(sSecondary);
            tm.SetSecondarTip(e);
          }
        }
        catch (Exception ex)
        {
          log.Error(ex, "Couldn\'t generate tip.");
        }
      }
      //	Got the tips model
      this.SetHelpTopic("PT_ApproveDocuments_DocumentsforApproval");
    }
  }
}