using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.approval;
using com.plumtree.uiinfrastructure.tree;
namespace com.plumtree.portalpages.admin.approval.document
{
  public class DocumentApprovalControl : ApprovalControl
  {
    public const String STR_MVC_CLASS_NAME = "DocumentApprovalControl";
    public const int POSTTOSELF_ACTION_FILTER_BY = 90;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new DocumentApprovalControl();
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IView#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    protected override void PerformAction(int arg)
    {
      base.PerformAction(arg);
      // this is the override method
      // card IDs begin at 200
      if (arg > 199)
      {
        if (m_asOwner.GetSubSpaceExists("CatFolderTree"))
        {
          ATreeAS asFolderTree = (ATreeAS) m_asOwner.GetSubSpace("CatFolderTree");
          ITreeModelRO myTree = (ITreeModelRO) asFolderTree.GetModel(ATreeAS.TREEMODEL);
          XPArrayList mySelected = myTree.GetSelectedItems();
          int[] FolderIDs = new int[mySelected.GetSize()];
          for (int i = 0;i < mySelected.GetSize();i++)
          {
            FolderIDs[i] = ((TreeLeafNode) mySelected.GetElement(i)).m_nObjectID;
            }
          DocumentApprovalModel model = (DocumentApprovalModel) m_asOwner.GetModel(DocumentApprovalModel.STR_MVC_CLASS_NAME);
          model.ModifyCardFolders(arg, FolderIDs);
        }
      } else
      if (arg == POSTTOSELF_ACTION_FILTER_BY)
      {
        if (m_asOwner.GetSubSpaceExists("CrawlerTree"))
        {
          /* get the tree */
          ATreeAS asCrawlerTree = (ATreeAS) m_asOwner.GetSubSpace("CrawlerTree");
          ITreeModelRO myTree = (ITreeModelRO) asCrawlerTree.GetModel(ATreeAS.TREEMODEL);
          /* get the selected items */
          XPArrayList mySelected = myTree.GetSelectedItems();
          /* create array of selected ids */
          Object[] crawlerIDs = null;
          if (mySelected.GetSize() > 0)
          {
            crawlerIDs = new Object[mySelected.GetSize()];
            for (int i = 0;i < mySelected.GetSize();i++)
            {
              crawlerIDs[i] = ((TreeLeafNode) mySelected.GetElement(i)).m_nObjectID;
              }
          }
          /* store it on the model */
          DocumentApprovalModel model = (DocumentApprovalModel) m_asOwner.GetModel(DocumentApprovalModel.STR_MVC_CLASS_NAME);
          model.SetFilterByIDs(crawlerIDs);
          /* clear the cache so we can query with filter of selected ids */
          model.ClearCache();
        }
      }
      return;
    }
  }
}