using System;
using com.plumtree.portalpages.common.constants;
using com.plumtree.portaluiinfrastructure.approval;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.approval.document
{
  /// <author>$author$</author>
  public class DocumentApprovalDP : EditorDP
  {
    //	private String _ui_approveDocuments = "Approve Documents";
    public const String STR_MVC_CLASS_NAME = "DocumentApprovalDP";
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,
    /// linking to that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      String sOut = this.m_asOwner.GetString(2364, ResourceConstants.PORTALADMINMSGS);
      return (sOut);
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1676, ResourceConstants.PORTALADMINMSGS),
       this.m_asOwner);
    }
    
    /// <returns></returns>
    /// <throws>HTMLException</throws>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // Insert super class HTML
      result.AddInnerHTMLElement(base.PageDisplay());
      HTMLElementCollection views = new HTMLElementCollection();
      // ***CHANGE_HERE*** For each Section you want to display on that page,
      //       copy the line below and replace Misc2View with your Section name.
      views.AddInnerHTMLElement(((DocumentApprovalView) m_asOwner.GetView(DocumentApprovalView.STR_MVC_CLASS_NAME)).Display(ApprovalPortalItemType.DOCUMENT));
      result.AddInnerHTMLElement(CreateLeftNavBar(views));
      return result;
    }
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      // ***CHANGE_HERE SELECTPTOBJECT*** Display JavaScripts for the Select PTObject list.
      myScripts.AddInnerHTMLElement(((DocumentApprovalView) m_asOwner.GetView(DocumentApprovalView.STR_MVC_CLASS_NAME)).DisplayJavaScript());
      return myScripts;
    }
  }
}