using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.common.constants;
using com.plumtree.portaluiinfrastructure.tree;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.approval;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.uiinfrastructure.htmlconstructs;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.tree;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.approval.document
{
  /// <version>$Revision$</version>
  /// <author>MikeSample</author>
  public class DocumentApprovalView : ApprovalView
  {
    public const String STR_MVC_CLASS_NAME = "DocumentApprovalView";
    
    /// <summary>
    /// Catalog folder open javascript function name 
    /// </summary>
    public const String JAVASCRIPT_CATALOGFOLDERTREE = "openRemoteCatalogFolderTree";
    
    /// <summary>
    /// Hidden HTML field for the catalog activity space id 
    /// </summary>
    public const String HTMLHIDDEN_CATSPACEID = "in_hi_CatalogFolderSpaceID";
    public virtual HTMLScript DisplayJavaScript()
    {
      HTMLScript script = new HTMLScript("text/javaScript");
      XPStringBuilder sb = new XPStringBuilder(200);
      // Submit function
      sb.Append("\n// Global variable used to identify a card ID for folder modification\n");
      sb.Append("\ng_SelectedCardID = 1;\n\n\n");
      sb.Append("function treeSubmit()\n");
      sb.Append("{\n");
      sb.Append("  " + AFormDP.JAVASCRIPT_SUBMIT_FORM + "(g_SelectedCardID);\n");
      sb.Append("}\n");
      script.AddInnerHTMLString(sb.ToString());
      // filter by function
      sb = new XPStringBuilder(200);
      // Submit function
      sb.Append("function treeSubmitFilterBy()\n");
      sb.Append("{\n");
      sb.Append("  " + AFormDP.JAVASCRIPT_SUBMIT_FORM + "(" + DocumentApprovalControl.POSTTOSELF_ACTION_FILTER_BY + ");\n");
      sb.Append("}\n");
      script.AddInnerHTMLString(sb.ToString());
      return script;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new DocumentApprovalView();
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IView#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    public override HTMLElement Display(ApprovalItemType type)
    {
      return base.Display(type);
    }
    public override void AddEditItemLink(HTMLTable myTable, ApprovalItemType type,
     String strSelectedItems, AItemDescriptor item)
    {
      DocumentItemDescriptor DocItem = (DocumentItemDescriptor) item;
      HTMLTableRow addFolderRow = new HTMLTableRow();
      //HTMLTableCell spacerCell = new HTMLTableCell();
      //spacerCell.SetColSpan(CommonHTMLStrings.THREE);
      //addFolderRow.AddInnerHTMLElement(spacerCell);
      HTMLTableCell popUpCell = new HTMLTableCell();
      popUpCell.SetColSpan(CommonHTMLStrings.FOUR);
      //popUpCell.AddInnerHTMLString("ADD FOLDER");
      //Get the Add Catalog Folder button
      PTConstruct myConstruct = ConstructFactory.GetConstruct(PTImageType.ICON_FOLDER);
      HTMLImg myImg = (HTMLImg) myConstruct.GetHTMLElement();
      XPStringBuilder sb = new XPStringBuilder(200);
      String strFormName = AFormDP.HTMLFORM_NAME;
      // The URL to open a new remote catalog folder tree
      ASURL newCatalogFolderTree = new ASURL(m_asOwner);
      newCatalogFolderTree.SetLinkCreateNewSpace(TreeAS.STR_MVC_CLASS_NAME,
       m_asOwner);
      newCatalogFolderTree.SetSubSpaceKey("CatFolderTree");
      //newCatalogFolderTree.SetControl(StartTreeControl.)
      newCatalogFolderTree.SetControl(StartTreeControl.STR_MVC_CLASS_NAME);
      newCatalogFolderTree.AddControlArgument(StartTreeControl.TITLE, m_asOwner.GetString(782,
       "ptmsgs_portaladminmsgs"));
      newCatalogFolderTree.AddControlArgument(StartTreeControl.ACTIONSUBTITLE,
       " " + m_asOwner.GetString(784, "ptmsgs_portaladminmsgs"));
      newCatalogFolderTree.AddControlArgument(StartTreeControl.CLASS_IDS_TO_DISPLAY,
       XPConvert.ToString(PT_CLASSIDS.PT_CATALOGFOLDER_ID));
      newCatalogFolderTree.AddControlArgument(StartTreeControl.ROOT_ID, XPConvert.ToString(PT_INTRINSICS.PT_FOLDER_ROOTFOLDER));
      newCatalogFolderTree.AddControlArgument(StartTreeControl.SHOW_ROOT,
       XPConvert.ToString(true));
      newCatalogFolderTree.AddControlArgument(StartTreeControl.MULTI_SELECT,
       XPConvert.ToString(true));
      newCatalogFolderTree.AddControlArgument(StartTreeControl.SELECT_MODE,
       XPConvert.ToString(TreeConstants.N_COMPOSITESELECT));
      newCatalogFolderTree.AddControlArgument(StartTreeControl.SUBMIT_MODE,
       XPConvert.ToString(TreeConstants.N_SERVERSUBMIT));
      newCatalogFolderTree.AddControlArgument(StartTreeControl.PARENT_FORM_NAME,
       strFormName);
      newCatalogFolderTree.AddControlArgument(StartTreeControl.SELECTED_ITEMS,
       strSelectedItems);
      newCatalogFolderTree.AddControlArgument(StartTreeControl.PARENT_SUBMIT_CALL,
       "treeSubmit");
      String strJSUtilVersionPrefix = ConfigHelper.GetJSIncluderVersionPrefix(ConfigHelper.JSCOMPONENT_JSUTIL);
      sb.Append(" g_SelectedCardID = " + XPConvert.ToString(DocItem.GetObjectID()) + ";   " + strJSUtilVersionPrefix + "PTWindowUtil.openWindow(\'").Append(newCatalogFolderTree.GetURLAsString()).Append("\',\'TREE\',400,400,false); return false;");
      HTMLAnchor myAnchor = HTMLConstructHelpers.GetActionBarAnchor(1, myImg,
       m_asOwner.GetString(782, "ptmsgs_portaladminmsgs"), m_asOwner.GetString(782,
       "ptmsgs_portaladminmsgs"), sb.ToString(), m_asOwner);
      myAnchor.SetStyleClass(PTStyleClass.LIST_TEXT);
      popUpCell.SetAlign(CommonHTMLStrings.LEFT);
      popUpCell.AddInnerHTMLElement(myAnchor);
      addFolderRow.AddInnerHTMLElement(popUpCell);
      myTable.AddInnerHTMLElement(addFolderRow);
      return;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.approval.ApprovalView#AddActionButtons(com.plumtree.xpshared.htmlconstructs.PTConstruct, com.plumtree.xpshared.htmlconstructs.PTBannerType)
     */
     
    public override void AddActionButtons(PTConstruct _actionConstruct, PTBannerType _bannerType)
    {
      String strFormName = AFormDP.HTMLFORM_NAME;
      /* get the selected filter by items */
      Object[] arrSelectedItems = ((DocumentApprovalModel) m_asOwner.GetModel(DocumentApprovalModel.STR_MVC_CLASS_NAME)).GetFilterByIDs();
      XPStringBuilder sb = new XPStringBuilder(50);
      if (null != arrSelectedItems)
      {
        for (int i = 0;i < arrSelectedItems.Length;i++)
        {
          sb.Append(XPConvert.ToString(PT_CLASSIDS.PT_CRAWLER_ID)).Append(",").Append(XPConvert.ToString(arrSelectedItems[i]));
          if (i + 1 < arrSelectedItems.Length)
          {
            sb.Append(",");
          }
        }
      }
      // The URL to open a new remote crawler tree
      ASURL crawlerTree = new ASURL(m_asOwner);
      crawlerTree.SetLinkCreateNewSpace(TreeAS.STR_MVC_CLASS_NAME, m_asOwner);
      crawlerTree.SetSubSpaceKey("CrawlerTree");
      crawlerTree.SetControl(StartTreeControl.STR_MVC_CLASS_NAME);
      crawlerTree.AddControlArgument(StartTreeControl.TITLE, m_asOwner.GetString(2598,
       ResourceConstants.PORTALADMINMSGS));
      crawlerTree.AddControlArgument(StartTreeControl.ACTIONSUBTITLE, " " + m_asOwner.GetString(2599,
       ResourceConstants.PORTALADMINMSGS));
      crawlerTree.AddControlArgument(StartTreeControl.CLASS_IDS_TO_DISPLAY,
       XPConvert.ToString(PT_CLASSIDS.PT_CRAWLER_ID));
      crawlerTree.AddControlArgument(StartTreeControl.ROOT_ID, XPConvert.ToString(PT_INTRINSICS.PT_FOLDER_ROOTFOLDER));
      crawlerTree.AddControlArgument(StartTreeControl.SHOW_ROOT, XPConvert.ToString(true));
      crawlerTree.AddControlArgument(StartTreeControl.MULTI_SELECT, XPConvert.ToString(true));
      crawlerTree.AddControlArgument(StartTreeControl.SELECT_MODE, XPConvert.ToString(TreeConstants.N_LEAFSELECT));
      crawlerTree.AddControlArgument(StartTreeControl.SUBMIT_MODE, XPConvert.ToString(TreeConstants.N_SERVERSUBMIT));
      crawlerTree.AddControlArgument(StartTreeControl.PARENT_FORM_NAME, strFormName);
      crawlerTree.AddControlArgument(StartTreeControl.SELECTED_ITEMS, sb.ToString());
      crawlerTree.AddControlArgument(StartTreeControl.PARENT_SUBMIT_CALL,
       "treeSubmitFilterBy");
      crawlerTree.AddControlArgument(StartTreeControl.ALLOW_EMPTY_SUBMISSION,
       XPConvert.ToString(true));
      String strJSUtilVersionPrefix = ConfigHelper.GetJSIncluderVersionPrefix(ConfigHelper.JSCOMPONENT_JSUTIL);
      String onClickJS = strJSUtilVersionPrefix + " PTWindowUtil.openWindow(\'" + crawlerTree.GetURLAsString() + "\',\'TREE\',400,400,false); return false;";
      PTConstruct myButtonConstruct;
      PTButtonType myBType;
      HTMLAnchor myAnchor;
      //   FILTER button
      myBType = PTButtonType.FILTER;
      myButtonConstruct = UIConstructFactory.GetConstruct(myBType, true, this.m_asOwner);
      myButtonConstruct.ReplaceNestedElementsWithHTMLString(myBType.TITLE_ELEMENT_NAME,
       m_asOwner.GetString(2597, ResourceConstants.PORTALADMINMSGS));
      myAnchor = (HTMLAnchor) myButtonConstruct.GetNestedElement(myBType.ANCHOR_ELEMENT_NAME);
      myAnchor.SetOnClick(onClickJS);
      _actionConstruct.AddElementToNestedElement(_bannerType.EXTENDABLE_CELL_ELEMENT_NAME,
       myButtonConstruct.GetHTMLElement());
      ConstructFactory.SetAltOnButtonImages(myButtonConstruct, m_asOwner.GetString(2597,
       ResourceConstants.PORTALADMINMSGS));
      ConstructFactory.SetTitleOnButtonImages(myButtonConstruct, m_asOwner.GetString(2597,
       ResourceConstants.PORTALADMINMSGS));
    }
  }
}