using System;
// Framework imports
using com.plumtree.openlog;
using com.plumtree.portalpages.common.constants;
using com.plumtree.portalpages.common.helpers;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.authsource
{
  /// <summary>
  /// This Section contains the HTML for the dependencies page.
  /// </summary>
  /// <author></author>
  public class AuthSourceDependenciesView : ObjDependenciesView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.authsource.AuthSourceDependenciesView");
    
    /// <summary>
    /// Class name for the activity space
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "AuthSourceDependencies";
    // <0 use default, 0 none, >0 use specified
    public const int OFFSET = -1;
    // <0 use default, 0 none, >0 use specified
    public const int BREAK = -1;
    protected CreatedHelper m_helper;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new AuthSourceDependenciesView();
    }
    
    /// <returns></returns>
    public override HTMLScript DisplayJavascript()
    {
      HTMLScript myScript = base.DisplayJavascript();
      try
      {
        helper().addJobJavascript(myScript);
      }
      catch (HTMLException he)
      {
        log.Error(he, "AuthSourceDependenciesView::DisplayJavascript An error occured when trying to display the JavaScript.");
        }
      return myScript;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.ObjDependenciesView#GetHTMLForDependencies()"></seealso>
    protected override HTMLElementCollection GetHTMLForDependencies()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      helper().displayEmptyRow(result);
      helper().displayTextRow(result, m_asOwner.GetString(1718, ResourceConstants.PORTALADMINMSGS),
       null);
      helper().displayTextRow(result, OFFSET, m_asOwner.GetString(1712, ResourceConstants.PORTALADMINMSGS) + ":",
       model().GetObjectName());
      helper().displayTextRow(result, OFFSET, m_asOwner.GetString(1716, ResourceConstants.PORTALADMINMSGS) + ":",
       model().GetParentFolderPath(), BREAK);
      helper().displayJobRows(result, m_asOwner.GetString(1713, ResourceConstants.PORTALADMINMSGS),
       m_asOwner.GetString(1714, ResourceConstants.PORTALADMINMSGS));
      String folderpath = model().userFolderPathIfSingle();
      if (folderpath != null)
      {
        helper().displayTextRow(result, m_asOwner.GetString(1717, ResourceConstants.PORTALADMINMSGS),
         null);
        helper().displayTextRow(result, OFFSET, m_asOwner.GetString(1719,
         ResourceConstants.PORTALADMINMSGS), folderpath);
      } else
      {
        helper().displayTextRow(result, m_asOwner.GetString(1715, ResourceConstants.PORTALADMINMSGS),
         null);
      }
      helper().displayEmptyRow(result);
      helper().displayEveryoneWarning(result, (AuthSourceModel) m_model, m_asOwner.GetString(1712,
       ResourceConstants.PORTALADMINMSGS));
      return result;
    }
    
    /// <returns></returns>
    protected virtual CreatedHelper helper()
    {
      if (m_helper == null)
      {
        m_helper = new CreatedHelper(m_asOwner, model());
      }
      return m_helper;
    }
    
    /// <returns></returns>
    protected virtual AuthSourceModel model()
    {
      return (AuthSourceModel) m_model;
    }
  }
}