using System;
using com.plumtree.openlog;
using com.plumtree.portalpages.admin.editors.common.setjob;
using com.plumtree.portalpages.common.constants;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.editor.commonpages.localizednames;
using com.plumtree.portaluiinfrastructure.expandablelist.selectptobject;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.expandablelist;
using com.plumtree.uiinfrastructure.tips;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.authsource
{
  /// <author>OlegS</author>
  public abstract class AuthSourceEditorAS : ObjEditorAS
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.authsource.AuthSourceEditorAS");
    public abstract String GetPageName2();
    public abstract String GetPageName3();
    public abstract String GetPageName4();
    public abstract String GetPageNameMain();
    public abstract String GetViewName2();
    public abstract String GetViewName3();
    public abstract String GetViewName4();
    public abstract String GetViewNameMain();
    public override void Init()
    {
      base.Init();
      RegisterView(AuthSourceDependenciesView.STR_MVC_CLASS_NAME, GetModel(m_strModelName));
      // JYS: Re-Enable Users popup
      RegisterPage(new AuthSourceReenableUsersPopupDP());
      RegisterView(AuthSourceReenableUsersPopupView.STR_MVC_CLASS_NAME, GetModel(m_strModelName));
      RegisterPage(new AuthSourceReenableUsersConfirmPopupDP());
      RegisterView(AuthSourceReenableUsersConfirmPopupView.STR_MVC_CLASS_NAME,
       GetModel(m_strModelName));
      // Register plug-in sections
      RegisterPage(new SetJobDP());
      // Register classes for the set job and for the object owner
      RegisterModel(SetJobModel.STR_MVC_CLASS_NAME);
      RegisterControl(SetJobRepostControl.STR_MVC_CLASS_NAME, GetModel(SetJobModel.STR_MVC_CLASS_NAME));
      RegisterView(ObjectOwnerView.STR_MVC_CLASS_NAME, GetModel(SetJobModel.STR_MVC_CLASS_NAME));
      // Register classes for Job selector
      RegisterModel(SelectPTObjectModel.STR_MVC_CLASS_NAME, SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB);
      RegisterView(SelectPTObjectView.STR_MVC_CLASS_NAME, SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB,
       GetModel(SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB));
      RegisterControl(ExpListControl.STR_MVC_CLASS_NAME, SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB,
       GetModel(SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB));
      //	TIPS
      TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);
      if (tm != null)
      {
        try
        {
          int iTitleId = 12;
          int iTipId = 13;
          int iSecondaryTipId = 14;
          tm.SetTipTitle(this.GetString(iTitleId, ResourceConstants.TIPS));
          HTMLGenericElement e = new HTMLGenericElement(this.GetString(iTipId,
           ResourceConstants.TIPS));
          tm.SetTip(e);
          String sSecondary = this.GetString(iSecondaryTipId, ResourceConstants.TIPS);
          if (!("none_do_not_translate".Equals(sSecondary)))
          {
            e = new HTMLGenericElement(sSecondary);
            tm.SetSecondarTip(e);
          }
        }
        catch (Exception ex)
        {
          log.Error(ex, "Couldn\'t generate tip.");
        }
      }
    }
    //	Got the tips model
    
    /// <returns></returns>
    public abstract bool WantTemplatesSection();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor#GetDependenciesViewName()"></seealso>
    public override String GetDependenciesViewName()
    {
      return (AuthSourceDependenciesView.STR_MVC_CLASS_NAME);
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage()"></seealso>
    /// <param name="IDisplayPage">the current Display Page</param>
    public override void SetCurrentPage(IDisplayPage page)
    {
      base.SetCurrentPage(page);
      String sPageName = page.GetName();
      if (SetJobDP.STR_MVC_CLASS_NAME.Equals(sPageName))
      {
        SetHelpTopic("PT_SetJob");
      } else
      if (LocNamesDP.STR_MVC_CLASS_NAME.Equals(sPageName))
      {
        SetHelpTopic("PT_AuthenticationSource_PropertiesandNames");
      }
    }
  }
}