using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.authsource
{
  /// <summary>
  /// Popup Display Page for confirming that a bulk re-enable operation succeeded.
  /// </summary>
  /// <author>Jennifer Sun</author>
  public class AuthSourceReenableUsersConfirmPopupDP : AFormDP
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.authsource.AuthSourceReenableUsersConfirmPopupDP");
    
    /// <summary>
    /// object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "AuthSourceReenableUsersConfirmPopup";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Display()"></seealso>
    public override void Display(IWebData pageData)
    {
      HTMLPage myPage = new HTMLPage();
      // Set the HTMLPage as the data to be sent to the browser.
      pageData.SetData(myPage);
      HTMLHead myHead = new HTMLHead();
      myPage.SetHead(myHead);
      HTMLTitle myTitle = new HTMLTitle(m_asOwner.GetString(2665, "ptmsgs_portaladminmsgs"));
      HTMLBody myBody = new HTMLBody();
      myPage.SetBody(myBody);
      myBody.SetMarginHeight("0");
      myBody.SetMarginWidth("0");
      myBody.SetLeftMargin("0");
      myBody.SetTopMargin("0");
      try
      {
        // Set to dark background color
        myBody.SetStyleClass(PTStyleClass.ALERT_DIALOG_BG);
        myHead.AddInnerHTMLElement(myTitle);
        myHead.AddInnerHTMLElement(m_asOwner.GetStyleSheetLinks());
        myHead.AddInnerHTMLElement(DisplayJavascript());
        myHead.AddInnerHTMLElement(DisplayJavaScriptFromChild());
        HTMLForm myForm;
        HTMLInput myInput;
        // Form and hidden inputs
        myForm = new HTMLForm("");
        myBody.AddInnerHTMLElement(myForm);
        myForm.AddInnerHTMLElement(new HTMLComment("Begin: Display Form and hidden inputs"));
        myForm.SetAction(ConfigHelper.GetApplicationBaseURLToAS(m_asOwner.GetCurrentNormalizedBaseURL(),
         m_asOwner.GetName(), m_asOwner.IsSubSpace()));
        myForm.SetMethod(GetRepostTypeIsPost() ? POST : GET);
        myForm.SetName(HTMLFORM_NAME);
        // Hidden Inputs
        // The action for the repost control to perform (repost, finish, cancel, etc...)
        myInput = new HTMLInput(HTMLInputTypes.HIDDEN, RepostControl.HTMLINPUT_POSTTOSELF,
         "");
        myForm.AddInnerHTMLElement(myInput);
        myInput.SetValue(XPConvert.ToString(RepostControl.POSTTOSELF_ACTION_UNDEFINED));
        // Name of passthru control to run when PASSTHRU action is selected
        myInput = new HTMLInput(HTMLInputTypes.HIDDEN, RepostControl.HTMLINPUT_PASSTHRU_CONTROL,
         "");
        myForm.AddInnerHTMLElement(myInput);
        // Arguments to pass to passthru control when PASSTHRU action is selected
        myInput = new HTMLInput(HTMLInputTypes.HIDDEN, RepostControl.HTMLINPUT_PASSTHRU_ARGS,
         "");
        myForm.AddInnerHTMLElement(myInput);
        // Name of space to POST this form to.
        myInput = new HTMLInput(HTMLInputTypes.HIDDEN, ASConstants.SPACENAME_INPUT,
         "");
        myForm.AddInnerHTMLElement(myInput);
        myInput.SetValue(GetOwner().GetName());
        // ID of space to POST this form to.
        myInput = new HTMLInput(HTMLInputTypes.HIDDEN, ASConstants.SPACEID_INPUT,
         "");
        myForm.AddInnerHTMLElement(myInput);
        myInput.SetValue(GetOwner().GetSpaceID());
        // Name of control to POST this form to.
        myInput = new HTMLInput(HTMLInputTypes.HIDDEN, ASConstants.CONTROL_INPUT,
         "");
        myForm.AddInnerHTMLElement(myInput);
        myInput.SetValue(GetRepostControlName());
        // Name of display page to display after POST.
        myInput = new HTMLInput(HTMLInputTypes.HIDDEN, ASConstants.PAGE_INPUT,
         "");
        myForm.AddInnerHTMLElement(myInput);
        myInput.SetValue(GetOwner().GetCurrentPage().GetName());
        myForm.AddInnerHTMLElement(new HTMLComment("End: Display Form and hidden inputs"));
        myForm.AddInnerHTMLElement(m_asOwner.GetView(AuthSourceReenableUsersConfirmPopupView.STR_MVC_CLASS_NAME).Display());
        }
      catch (HTMLException he)
      {
        log.Error(he, "Display: The following HTML error occured when trying to display the HTML.");
        }
      catch (Exception e)
      {
        log.Error(e, "Display: The following error occured when trying to display the HTML.");
        }
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IDisplayPage#GetOwner()"></seealso>
    public override AActivitySpace GetOwner()
    {
      return m_asOwner;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Init(AActivitySpace)"></seealso>
    public override void Init(AActivitySpace parent)
    {
      m_asOwner = parent;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      return m_asOwner.GetView(AuthSourceReenableUsersConfirmPopupView.STR_MVC_CLASS_NAME).Display();
      }
    
    /// <summary>
    /// Display the javascript from the view
    /// </summary>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection scripts = new HTMLScriptCollection();
      scripts.AddInnerHTMLElement(m_asOwner.GetView(AuthSourceReenableUsersConfirmPopupView.STR_MVC_CLASS_NAME).DisplayJavascript());
      return scripts;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()
     */
     
    public override String GetFormTitle()
    {
      return null;
    }
  }
}