using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.authsource
{
  /// <summary>
  /// Popup view for confirming that a bulk re-enable operation succeeded.
  /// </summary>
  /// <author>Jennifer Sun</author>
  public class AuthSourceReenableUsersConfirmPopupView : IView
  {
    
    /// <summary>
    /// object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "AuthSourceReenableUsersConfirmPopup";
    
    /// <summary>
    /// HTML Object names 
    /// </summary>
    public const String HTMLBUTTON_CLOSE_WINDOW = "in_bu_Close";
    
    /// <summary>
    /// mvc objects 
    /// </summary>
    internal AActivitySpace m_asOwner;
    internal IAuthSourceModelRO m_asModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new AuthSourceReenableUsersConfirmPopupView();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Display()"></seealso>
    public virtual HTMLElement Display()
    {
      HTMLElement result = new HTMLElementCollection();
      HTMLTable myTable;
      HTMLInput myInput;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      //		HTMLBr myBr			= new HTMLBr();
      //Create a banner table
      result.AddInnerHTMLElement(new HTMLComment("Begin: BANNER table"));
      myTable = new HTMLTable();
      result.AddInnerHTMLElement(myTable);
      myTable.SetBorder(CommonHTMLStrings.ZERO);
      myTable.SetWidth(CommonHTMLStrings.ZERO);
      myTable.SetCellPadding(CommonHTMLStrings.ZERO);
      myTable.SetCellSpacing("10");
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
      myCell.SetStyleClass(PTStyleClass.ALERT_DIALOG_TITLE);
      myCell.AddInnerHTMLString(m_asOwner.GetString(2665, "ptmsgs_portaladminmsgs"));
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myCell.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);
      myCell.SetVAlign(CommonHTMLStrings.TOP);
      myRow.AddInnerHTMLElement(myCell);
      Object[] args = {XPConvert.ToString(m_asModel.GetNumReenabledUsers())};
      myCell.AddInnerHTMLString(XPFormat.Format(m_asOwner.GetString(2666,
       "ptmsgs_portaladminmsgs"), args));
      result.AddInnerHTMLElement(new HTMLComment("End: BANNER table"));
      // Add buttons
      result.AddInnerHTMLElement(new HTMLComment("Begin: Footer buttons table"));
      myTable = new HTMLTable();
      result.AddInnerHTMLElement(myTable);
      myTable.SetBorder(CommonHTMLStrings.ZERO);
      myTable.SetWidth(CommonHTMLStrings.ZERO);
      myTable.SetCellPadding(CommonHTMLStrings.ZERO);
      myTable.SetCellSpacing("10");
      // 1st Row
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myCell.SetHeight("20");
      myCell.SetVAlign(CommonHTMLStrings.MIDDLE);
      myCell.SetNoWrap(true);
      myRow.AddInnerHTMLElement(myCell);
      // Cancel button
      myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_CLOSE_WINDOW,
       "");
      myCell.AddInnerHTMLElement(myInput);
      myInput.SetValue(m_asOwner.GetString(1210, "ptmsgs_portaladminmsgs"));
      myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
      myInput.SetOnClick("window.close(); return false;");
      result.AddInnerHTMLElement(new HTMLComment("End: Footer buttons table"));
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asOwner = parent;
      m_asModel = (IAuthSourceModelRO) model;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
     */
     
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
  }
}