using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.editor;
namespace com.plumtree.portalpages.admin.editors.authsource
{
  /// <author>OlegS</author>
  public interface IAuthSourceModelRO : IObjEditorModelRO
  {
    int GetNumDisabledUsers();
    int GetNumReenabledUsers();
    
    /// <returns></returns>
    String GetAuthSourceCategory();
    
    /// <returns></returns>
    String GetEmptyListInstructions();
    
    /// <returns></returns>
    String GetEmptyListMainMessage();
    
    /// <param name="doFilterByAuthSource"></param>
    /// <returns></returns>
    Object[][] allGroups(bool doFilterByAuthSource);
    
    /// <returns></returns>
    Object[][] authPartners();
    
    /// <returns></returns>
    int bulkCopyNum();
    
    /// <returns></returns>
    Object[][] defaultProfiles();
    
    /// <returns></returns>
    int deferredGroupFolderID();
    
    /// <returns></returns>
    int deletedUserFolderID();
    
    /// <returns></returns>
    Object[][] fullySyncedGroups();
    
    /// <param name="j"></param>
    /// <returns></returns>
    int groupsOrder(int j);
    
    /// <returns></returns>
    String lastTreeSpaceId_ADMINFOLDERTREESPACE();
    
    /// <returns></returns>
    String lastTreeSpaceId_USERGROUPTREESPACE();
    
    /// <returns></returns>
    String listOfMappedGroups();
    
    /// <returns></returns>
    String listOfUnmappedGroups();
    
    /// <returns></returns>
    String listOfAlienGroups();
    
    /// <returns></returns>
    String listOfSyncGroups();
    
    /// <returns></returns>
    String listOfNewGroupsFolder();
    
    /// <returns></returns>
    String joinLists(String lst1, String lst2);
    
    /// <param name="reserveTopRows"></param>
    /// <returns></returns>
    Object[][] mappedGroups(int reserveTopRows);
    
    /// <returns></returns>
    int newGroupFolderId();
    
    /// <returns></returns>
    int numTemplates();
    
    /// <returns></returns>
    int selectedPartnerId();
    
    /// <returns></returns>
    int selectedTemplate();
    
    /// <returns></returns>
    int supportSyncMode();
    
    /// <returns></returns>
    int syncType();
    
    /// <param name="index"></param>
    /// <returns></returns>
    IXPPropertyBag templateContents(int index);
    
    /// <param name="index"></param>
    /// <returns></returns>
    String templateName(int index);
    
    /// <returns></returns>
    Object[][] unmappedGroups();
    
    /// <summary>
    /// Indicates whether or not the underlying Authentication Source
    /// should resolve cross authentication source memberships.
    /// </summary>
    /// <returns>
    /// - <c>true</c> if it should, <c>false</c> if the
    /// authentication source shouldn't.
    /// </returns>
    bool ImportCrossASMemberships();
  }
}