using System;
using XPHashtable=com.plumtree.openfoundation.util.XPHashtable;
using com.plumtree.portalpages.common.constants;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.search;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.admin.editors.bestbets
{
  /// <author>CraigS, based on JulieF template</author>
  public class BestBetEditorAS : PTEditorAS
  {
    public const String STR_MVC_CLASS_NAME = "BestBetEditor";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new BestBetEditorAS();
    }
    
    /// <summary>
    /// Returns the Editor title.
    /// </summary>
    /// <returns>String</returns>
    public override String GetEditorTitle()
    {
      return GetString(155, ResourceConstants.PORTALADMINMSGS);
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the class name of the Property Repost Control.
    /// </summary>
    /// <returns>String</returns>
    public override String GetRepostControlName()
    {
      return BestBetRepostControl.STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Registers all the classes of the Property Activity Space.
    /// </summary>
    public override void Init()
    {
      m_strModelName = BestBetModel.STR_MVC_CLASS_NAME;
      // Warning: m_strModelName must be initialized before super.Init() is called.
      base.Init();
      // Get search classes as well.
      IntegratedSearchAS.RegisterSearchClasses(this);
      IModel editorModel = GetModel(BestBetModel.STR_MVC_CLASS_NAME);
      IBaseSearchResultModelRO searchModel = (IBaseSearchResultModelRO) GetModel(SearchResultModel.STR_MVC_CLASS_NAME);
      // Register DisplayPages
      RegisterPage(new BestBetEditorDP());
      // Register Views
      RegisterView(BestBetEditorView.STR_MVC_CLASS_NAME, editorModel);
      RegisterView(SearchBoxView.STR_MVC_CLASS_NAME, searchModel);
      RegisterView(SearchResultsView.STR_MVC_CLASS_NAME, searchModel);
      // Register Controls
      RegisterControl(BestBetRepostControl.STR_MVC_CLASS_NAME, editorModel);
      // Set default page
      SetCurrentPage(BestBetEditorDP.STR_MVC_CLASS_NAME);
    }
    // Sets left nav menu
    // Commented out: no left nav menu needed
    // int nMenuOneID = m_mEditorMenu.StartNewSubMenu(_ui_LeftNavTitleMain);
    // m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, Misc2DP.STR_MVC_CLASS_NAME);
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage()"></seealso>
    /// <param name="IDisplayPage">the current Display Page</param>
    public override void SetCurrentPage(IDisplayPage page)
    {
      base.SetCurrentPage(page);
      this.SetHelpTopic("PT_EditBestBet");
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentFormData(com.plumtree.openfoundation.util.XPHashtable)
     */
     
    public override void SetCurrentFormData(XPHashtable _htFormData)
    {
      // TODO Auto-generated method stub
      //if(_htFormData.GetElement(""))
      base.SetCurrentFormData(_htFormData);
    }
  }
}