using System;
using com.plumtree.portalpages.common.constants;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.errordisplay;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.bestbets
{
  /// <author>CraigS, based on JulieF template</author>
  public class BestBetEditorDP : EditorDP
  {
    public const String STR_MVC_CLASS_NAME = "BestBetEditorDP";
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,
    /// linking to that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(160, ResourceConstants.PORTALADMINMSGS);
      }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for the page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()"></seealso>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // Insert super class HTML
      result.AddInnerHTMLElement(base.PageDisplay());
      // Add link to help
      result.AddInnerHTMLElement(HTMLConstructHelpers.GetSubHeader("", this.m_asOwner));
      // Add error view
      result.AddInnerHTMLElement(m_asOwner.GetView(ErrorView.STR_MVC_CLASS_NAME).Display());
      // Add editor view
      result.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(BestBetEditorView.STR_MVC_CLASS_NAME)).Display());
      return result;
    }
    
    /// <returns></returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(BestBetEditorView.STR_MVC_CLASS_NAME).DisplayJavascript());
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(SearchResultsView.STR_MVC_CLASS_NAME).DisplayJavascript());
      return myScripts;
    }
  }
}