using System;
// Framework Imports
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.admin.editors.common.setjob
{
  /// <summary>
  /// This class handles the repost actions for the
  /// Job Owner section.
  /// </summary>
  /// <author>Julie Fournier</author>
  public class SetJobRepostControl : EditorHelperRepostControl
  {
    
    /// <summary>
    /// Class name for the activity space 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "SetJob";
    
    /// <summary>
    /// Will add one or more items to the list. 
    /// </summary>
    public const int POSTTOSELF_ACTION_CHANGE_OWNER = 20;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SetJobRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Calls the method associated to the repost action.
    /// Editors using this framework need to call that method from
    /// the PerformRepostAction method of the main RepostControl.
    /// </summary>
    /// <param name="_nAction"></param>
    /// <param name="_htFormData"></param>
    public override void PerformRepostAction(int _nAction, XPHashtable _htFormData)
    {
      switch (_nAction){
      case POSTTOSELF_ACTION_CHANGE_OWNER:
      ((SetJobModel) m_model).ChangeOwner();
      break;
      }
      ((ExpListControl) m_asOwner.GetControl(SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB)).PerformRepostAction(_nAction,
       _htFormData);
    }
  }
}