using System;
using com.plumtree.portalpages.common.constants;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.communitytemplate
{
  /// <author>michaeld</author>
  public class CommunityTemplateCommunitiesDP : EditorDP
  {
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "CommTempComms";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.editor.EditorDP#GetLeftNavString()"></seealso>
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(3042, ResourceConstants.PORTALADMINMSGS);
      }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for the Community Template Page Templates page.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // Insert super class HTML
      result.AddInnerHTMLElement(base.PageDisplay());
      HTMLElementCollection views = new HTMLElementCollection();
      // Display the list.
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(CommunityTemplateEditorAS.PLUGIN_COMMUNITIES)).Display());
      result.AddInnerHTMLElement(CreateLeftNavBar(views));
      return result;
    }
    
    /// <summary>
    /// This is a helper method that all classes that inherit from PlumtreeDP need
    /// to implement.  The method should add whatever HTML the child class wants to
    /// use the DisplayJavaScript and add it to the head.
    /// </summary>
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.PlumtreeDP#DisplayJavaScriptFromChild()"></seealso>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection result = base.DisplayJavaScriptFromChild();
      // Display JavaScripts for the Select PTObject list.
      result.AddInnerHTMLElement(m_asOwner.GetView(CommunityTemplateEditorAS.PLUGIN_COMMUNITIES).DisplayJavascript());
      return result;
    }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(3043, ResourceConstants.PORTALADMINMSGS),
       this.m_asOwner);
    }
  }
}