using System;
using com.plumtree.portaluiinfrastructure.expandablelist.selectptobject;
using com.plumtree.uiinfrastructure.arraywrapper;
using com.plumtree.uiinfrastructure.htmlconstructs;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.communitytemplate
{
  /// <author>michaeld</author>
  public class SelectPageTemplateView : SelectPTObjectView
  {
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "SelectPageTemplate";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SelectPageTemplateView();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectView#GetHTMLForNameColumn(IPTGrowableSortedArrayWrapperRO,int)"></seealso>
    protected override HTMLTableCell GetHTMLForNameColumn(IPTGrowableSortedArrayWrapperRO _saData,
     int _nRowIndex)
    {
      if (0 == _nRowIndex)
      {
        HTMLTableCell myCell;
        myCell = new HTMLTableCell();
        myCell.SetWidth("100%");
        myCell.SetHeight("30");
        myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
        myCell.SetNoWrap(true);
        myCell.AddInnerHTMLString(SPACE);
        // row icon
        PTImageType imgRowIcon = ((ISelectPTObjectModelRO) m_model).GetDefaultRowIcon();
        if (null != imgRowIcon)
        {
          myCell.AddInnerHTMLElement(GetIcon(imgRowIcon));
        }
        // Object Name
        Object oPTObjectName = _saData.GetItem(_nRowIndex, SelectPTObjectModel.EXPLIST_COL_STRING);
        PTConstruct myConstruct = UIConstructFactory.GetConstruct(PTImageType.SPACER);
        HTMLImg spacerImage = (HTMLImg) myConstruct.GetHTMLElement();
        spacerImage.SetAlt("---");
        spacerImage.SetWidth(CommonHTMLStrings.FIVE);
        spacerImage.SetBorder("0");
        myCell.AddInnerHTMLElement(spacerImage);
        myCell.AddInnerHTMLEncodedString((String) oPTObjectName);
        myCell.AddInnerHTMLString(SPACE + "(" + m_asOwner.GetString(214, "ptmsgs_portaladminmsgs") + ")");
        return myCell;
      } else
      {
        return base.GetHTMLForNameColumn(_saData, _nRowIndex);
      }
    }
  }
}