using System;
// Server Imports
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.portaluiinfrastructure.tree;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.uiinfrastructure.tree;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.condition
{
  public class CreateRuleView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.condition.CreateRuleView");
    public const String STR_MVC_CLASS_NAME = "CreateRuleView";
    public const String HTMLTEXT_RULE_NAME = "in_tx_Name";
    public const String HTMLHIDDEN_RULE_SUBPORTAL = "in_hi_Subportal";
    public const String HTMLHIDDEN_SUBPORTAL_TREESPACEID = "in_hi_SubportalTreeSpaceID";
    public const String HTMLBUTTON_RULE_SELECTSUBPORTAL = "in_bu_SelectSubportal";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new CreateRuleView();
    }
    
    /// <returns></returns>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLSpan mySpan;
      HTMLInput myInput;
      try
      {
        result.AddInnerHTMLElement(base.GetHeaderView(m_asOwner.GetString(2851,
         "ptmsgs_portaladminmsgs")));
        myTable = new HTMLTable();
        result.AddInnerHTMLElement(myTable);
        myTable.SetWidth("100%");
        myTable.SetBorder("0");
        myTable.SetCellPadding("5");
        myTable.SetCellSpacing("0");
        // Spacer Rows begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetColSpan("3");
        myCell.SetHeight("5");
        //Spacer Rows ends
        // Name Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.SetWidth("25%");
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(21, "ptmsgs_portaladminmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetColSpan("2");
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        // adding text field
        myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLTEXT_RULE_NAME, "");
        myInput.SetValue(((IRuleEditorModelRO) m_model).GetExpressionName());
        myInput.SetSize(50);
        myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
        myCell.AddInnerHTMLElement(myInput);
        myCell.AddInnerHTMLElement(new HTMLBr());
        // Name Row end
        // Subportal Picker Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.SetWidth("25%");
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(2852, "ptmsgs_portaladminmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.SetWidth("25%");
        myCell.SetNoWrap(true);
        // Subportal currently selected
        String strSubportalActionName = ((IRuleEditorModelRO) m_model).GetSubportalActionName();
        if (strSubportalActionName != null)
        {
          myCell.AddInnerHTMLEncodedString(strSubportalActionName);
        } else
        {
          myCell.AddInnerHTMLString(m_asOwner.GetString(2853, "ptmsgs_portaladminmsgs"));
          }
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.SetNoWrap(true);
        // hidden input user Folder Name for validation
        myInput = new HTMLInput(HTMLInputTypes.HIDDEN, HTMLHIDDEN_RULE_SUBPORTAL,
         "");
        result.AddInnerHTMLElement(myInput);
        myInput.SetValue(strSubportalActionName);
        // hidden input with the tree space ID
        myInput = new HTMLInput(HTMLInputTypes.HIDDEN, HTMLHIDDEN_SUBPORTAL_TREESPACEID,
         "");
        result.AddInnerHTMLElement(myInput);
        String strUserServerSpaceID = ((IRuleEditorModelRO) m_model).GetSubportalTreeSpaceID();
        if (null == strUserServerSpaceID)
        {
          myInput.SetValue("");
        } else
        {
          myInput.SetValue(strUserServerSpaceID);
        }
        myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_RULE_SELECTSUBPORTAL,
         "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetValue(m_asOwner.GetString(2857, "ptmsgs_portaladminmsgs"));
        myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
        myInput.SetOnClick("openSubportalTree(document." + AFormDP.HTMLFORM_NAME + "." + HTMLHIDDEN_SUBPORTAL_TREESPACEID + ");");
        // Subportal Picker Row end
        // Spacer Rows begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetColSpan("3");
        myCell.SetHeight("5");
        //Spacer Rows ends
        // Text Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.SetWidth("25%");
        myCell.SetColSpan("3");
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(2854, "ptmsgs_portaladminmsgs"));
        }
      // Text Row end
      catch (Exception e)
      {
        log.Error(e, "CreateRuleView::Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(2855, "ptmsgs_portaladminmsgs"),
         e);
      }
      return result;
    }
    
    /// <summary>
    /// This method returns the HTMLScript that encompasses the Javascript on the page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    /// <returns>HTMLScript</returns>
    public override HTMLScript DisplayJavascript()
    {
      String strFormName = AFormDP.HTMLFORM_NAME;
      // The URL to open a new user Folder tree
      ASURL newSubportalTreeURL = new ASURL(m_asOwner);
      newSubportalTreeURL.SetLinkCreateNewSpace(TreeAS.STR_MVC_CLASS_NAME,
       m_asOwner);
      newSubportalTreeURL.SetSubSpaceKey("SubportalTree");
      newSubportalTreeURL.SetControl(StartTreeControl.STR_MVC_CLASS_NAME);
      newSubportalTreeURL.AddControlArgument(StartTreeControl.ROOT_ID, "1");
      newSubportalTreeURL.AddControlArgument(StartTreeControl.MULTI_SELECT,
       XPConvert.ToString(false));
      newSubportalTreeURL.AddControlArgument(StartTreeControl.SUBMIT_MODE,
       XPConvert.ToString(TreeConstants.N_SERVERSUBMIT));
      newSubportalTreeURL.AddControlArgument(StartTreeControl.PARENT_FORM_NAME,
       strFormName);
      newSubportalTreeURL.AddControlArgument(StartTreeControl.PARENT_FORM_SPACE_ID,
       HTMLHIDDEN_SUBPORTAL_TREESPACEID);
      newSubportalTreeURL.AddControlArgument(StartTreeControl.PARENT_SUBMIT_CALL,
       "subportalSubmit");
      newSubportalTreeURL.AddControlArgument(StartTreeControl.TITLE, m_asOwner.GetString(2857,
       "ptmsgs_portaladminmsgs"));
      newSubportalTreeURL.AddControlArgument(StartTreeControl.ACTIONSUBTITLE,
       m_asOwner.GetString(2857, "ptmsgs_portaladminmsgs"));
      newSubportalTreeURL.AddControlArgument(StartTreeControl.ACCESS_LEVEL,
       PT_ACCESS_LEVELS.PT_ACCESS_LEVEL_SELECT);
      newSubportalTreeURL.AddControlArgument(StartTreeControl.CLASS_IDS_TO_DISPLAY,
       XPConvert.ToString(PT_CLASSIDS.PT_SUBPORTAL_ID));
      // The url to open a previously opened server user tree
      // This needs to have the SpaceID added to it.
      ASURL oldSubportalTreeURL = new ASURL(m_asOwner);
      oldSubportalTreeURL.SetLinkCreateNewSpace(TreeAS.STR_MVC_CLASS_NAME,
       m_asOwner);
      oldSubportalTreeURL.IsSubSpace();
      HTMLScript myScript = new HTMLScript("text/javaScript");
      XPStringBuilder sb;
      try
      {
        // Open user tree function
        sb = new XPStringBuilder(200);
        sb.Append("function ").Append("openSubportalTree").Append("(myInput)\n");
        sb.Append("{\n");
        sb.Append("  if (myInput.value == \'\') {\n");
        sb.Append("    window.open(\'").Append(newSubportalTreeURL.GetURLAsString()).Append("\', \'_blank3\', \'").Append(TreeConstants.GetJavascriptTreeWindowAttributes()).Append("\');\n");
        sb.Append("  } else {\n");
        sb.Append("    window.open(\'").Append(oldSubportalTreeURL.GetURLAsString()).Append("&").Append(ASConstants.SPACEID).Append("=\' + myInput.value").Append(", \'_blank3\', \'").Append(TreeConstants.GetJavascriptTreeWindowAttributes()).Append("\');\n");
        sb.Append("  }\n");
        sb.Append("}\n");
        myScript.AddInnerHTMLString(sb.ToString());
        // Submit function
        sb = new XPStringBuilder(100);
        sb.Append("function subportalSubmit()\n");
        sb.Append("{\n");
        sb.Append("  postToSelf(").Append(RuleEditorRepostControl.POSTTOSELF_ACTION_SELECTSUBPORTAL).Append(");\n");
        sb.Append("}\n");
        myScript.AddInnerHTMLString(sb.ToString());
        sb = new XPStringBuilder(100);
        sb.Append("function CheckSubportal()\n");
        sb.Append("{\n");
        sb.Append("  if (document." + AFormDP.HTMLFORM_NAME + "." + HTMLHIDDEN_RULE_SUBPORTAL + ".value == \'\') { \n");
        sb.Append("\t\talert(\"" + m_asOwner.GetString(2858, "ptmsgs_portaladminmsgs") + "\");\n");
        sb.Append("      return false;\n");
        sb.Append("  }\n");
        sb.Append("  return true;\n");
        sb.Append("}\n");
        myScript.AddInnerHTMLString(sb.ToString());
        sb = new XPStringBuilder(100);
        sb.Append("function CheckName()\n");
        sb.Append("{\n");
        sb.Append("  if (document." + AFormDP.HTMLFORM_NAME + "." + HTMLTEXT_RULE_NAME + ".value == \'\') { \n");
        sb.Append("\t\talert(\"" + m_asOwner.GetString(60, "ptmsgs_portalinfrastructure") + "\");\n");
        sb.Append("      return false;\n");
        sb.Append("  }\n");
        sb.Append("  return true;\n");
        sb.Append("}\n");
        myScript.AddInnerHTMLString(sb.ToString());
      }
      catch (HTMLException e)
      {
        log.Error(e, "CreateRuleView::DisplayJavascript The following error occured when trying to display the JavaScript: " + e.GetMessage());
        throw new XPException(m_asOwner.GetString(2856, "ptmsgs_portaladminmsgs"),
         e);
      }
      return myScript;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}