using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.condition;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.admin.editors.condition
{
  /// <summary>
  /// Delete that class if you don't have any repost actions.
  /// </summary>
  public class RuleEditorRepostControl : ObjEditorRepostControl
  {
    public const String STR_MVC_CLASS_NAME = "RuleEditorRepostControl";
    public const int POSTTOSELF_ACTION_SELECTSUBPORTAL = 11;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new RuleEditorRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call  the associated method for each
    /// action.
    /// </summary>
    /// <param name="_nAction"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      // Initialize Condition Type Expandable Lists
      IXPEnumerator condTypes = ConditionTypeManager.GetInstance().GetArrayConditionTypes().GetEnumerator();
      while (condTypes.MoveNext())
      {
        AConditionType current = (AConditionType) condTypes.GetCurrent();
        ExpListControl condListControl = (ExpListControl) m_asOwner.GetControl(current.GetConditionTypeIdentifier());
        condListControl.PerformRepostAction(_nAction, m_htFormData);
      }
      switch (_nAction){
      case POSTTOSELF_ACTION_SELECTSUBPORTAL:
      ((RuleEditorModel) m_model).SetSubportalActionOnRepost();
      break;
      }
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.ObjEditorRepostControl#DisableSavePopUp()"></seealso>
    protected override bool DisableSavePopUp()
    {
      return true;
    }
  }
}