using System;
// Framework Imports
using com.plumtree.portalpages.admin.editors.common.setjob;
using com.plumtree.portalpages.common.documentlanguage;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.admin.editors.crawler
{
  /// <summary>
  /// This is the main repost control for the Crawler Editor.
  /// </summary>
  /// <author>Julie Fournier</author>
  public abstract class CrawlerRepostControl : ObjEditorRepostControl
  {
    
    /// <summary>
    /// Repost action: Clear deletion history 
    /// </summary>
    public const int POSTTOSELF_ACTION_CLEAR_DELETION_HISTORY = 10;
    
    /// <summary>
    /// Repost action: Clear rejection history 
    /// </summary>
    public const int POSTTOSELF_ACTION_CLEAR_REJECTION_HISTORY = 11;
    
    /// <summary>
    /// Repost action: change mirroring status 
    /// </summary>
    public const int POSTTOSELF_ACTION_CHANGE_MIRRORING_STATUS = 12;
    
    /// <summary>
    /// Switch between the action modes and call
    /// the associated method for each action.
    /// </summary>
    /// <param name="_nAction"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      ((ExpListControl) m_asOwner.GetControl(CrawlerEditorAS.STR_MVC_STORAGE_NAME_SELECT_FOLDER)).PerformRepostAction(_nAction,
       m_htFormData);
      ((SetJobRepostControl) m_asOwner.GetControl(SetJobRepostControl.STR_MVC_CLASS_NAME)).PerformRepostAction(_nAction,
       m_htFormData);
      ((CardLanguagePlugInRepostControl) m_asOwner.GetControl(CrawlerEditorAS.STR_MVC_STORAGE_NAME_LANGUAGE)).PerformRepostAction(_nAction,
       m_htFormData);
      ((ExpListControl) m_asOwner.GetControl(CrawlerEditorAS.STR_MVC_STORAGE_NAME_CARD_SECURITY)).PerformRepostAction(_nAction,
       m_htFormData);
      int nDocTypeSectionCount = ((CrawlerModel) m_model).GetDocMapSectionCount();
      for (int i = 0;i < nDocTypeSectionCount;i++)
      {
        ((ExpListControl) m_asOwner.GetControl(CrawlerEditorAS.STR_MVC_STORAGE_NAME_TYPE_MAP + i)).PerformRepostAction(_nAction,
         m_htFormData);
      }
      switch (_nAction){
      case POSTTOSELF_ACTION_CLEAR_DELETION_HISTORY:
      ((CrawlerModel) m_model).ClearDeletionHistory();
      break;
      case POSTTOSELF_ACTION_CLEAR_REJECTION_HISTORY:
      ((CrawlerModel) m_model).ClearRejectionHistory();
      break;
      case POSTTOSELF_ACTION_CHANGE_MIRRORING_STATUS:
      ((CrawlerModel) m_model).ChangeMirroringStatus();
      break;
      }
    }
  }
}