using System;
using IXPPropertyBag=com.plumtree.openfoundation.util.IXPPropertyBag;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.server;
namespace com.plumtree.portalpages.admin.editors.crawler
{
  /// <summary>
  /// This interface is implemented by the Model.
  /// It contains all the read-only mothods of the Model
  /// accessed by the Views.
  /// </summary>
  /// <author>Julie Fournier</author>
  public interface ICrawlerModelRO : IObjEditorModelRO
  {
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.crawler.CrawlerModel#GetCrawlerSettings()"></seealso>
    int GetCrawlerSettings();
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.crawler.CrawlerModel#GetDocMapSectionCount()"></seealso>
    int GetDocMapSectionCount();
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.crawler.CrawlerModel#GetImportOnlyNewLinks()"></seealso>
    bool GetImportOnlyNewLinks();
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.crawler.CrawlerModel#GetSupportMirroring()"></seealso>
    bool GetSupportMirroring();
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.crawler.CrawlerModel#GetTaxSettings()"></seealso>
    int GetTaxSettings();
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.crawler.CrawlerModel#GetUnmappedExternalDomains()"></seealso>
    IPTQueryResult GetUnmappedExternalDomains();
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.crawler.CrawlerModel#GetCrawlerTag()"></seealso>
    String GetCrawlerTag();
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.crawler.CrawlerModel#GetApplyExisting()"></seealso>
    bool GetApplyExisting();
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.crawler.CrawlerModel#GetSupportsACLImport()"></seealso>
    bool GetSupportsACLImport();
    
    /// <summary>
    /// Get the runtime configuration property bag IXPProperty bag containing the runtime configuration values such
    /// as number of threads used for fetching, number of threads used for
    /// inexing, etc. 
    /// </summary>
    IXPPropertyBag GetRuntimeConfiguration();
  }
}