using System;
// Framework Imports
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.tips;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.datasource
{
  public abstract class DSEditorAS : ObjEditorAS
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.datasource.DSEditorAS");
    
    /// <summary>
    /// The unique identifer for the Web Service SelectPTObject plug in 
    /// </summary>
    public const String STR_MVC_STORAGE_NAME_SELECT_PTOBJECT = "PTWebServiceList";
    public const String strSelectWSModel = "SelectWSModel";
    
    /// <summary>
    /// Subspace key for the gateway subspace 
    /// </summary>
    public const String WSTREE_SUBSPACE = "WSTreeSubSpace";
    public override void Init()
    {
      base.Init();
      //	TIPS
      TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);
      if (tm != null)
      {
        try
        {
          int iTitleId = 21;
          int iTipId = 22;
          int iSecondaryTipId = 23;
          tm.SetTipTitle(this.GetString(iTitleId, "ptmsgs_tips"));
          HTMLGenericElement e = new HTMLGenericElement(this.GetString(iTipId,
           "ptmsgs_tips"));
          tm.SetTip(e);
          String sSecondary = this.GetString(iSecondaryTipId, "ptmsgs_tips");
          if (!("none_do_not_translate".Equals(sSecondary)))
          {
            e = new HTMLGenericElement(sSecondary);
            tm.SetSecondarTip(e);
          }
        }
        catch (Exception ex)
        {
          log.Error(ex, "Couldn\'t generate tip.");
        }
      }
    }
    //	Got the tips model
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor#GetDependenciesViewName()"></seealso>
    public override String GetDependenciesViewName()
    {
      return (DataSourceDependenciesView.STR_MVC_CLASS_NAME);
    }
    
    /// <summary>
    /// Registers all the classes for this Activity Space.
    /// </summary>
    public virtual void RegisterCommonDSClasses(IModel _myModel)
    {
      // Register Common Views
      RegisterView(DSURLTypeView.STR_MVC_CLASS_NAME, _myModel);
      RegisterView(DataSourceDependenciesView.STR_MVC_CLASS_NAME, _myModel);
      RegisterModel(DataSourceSelectWebServiceModel.STR_MVC_CLASS_NAME, strSelectWSModel);
      DataSourceSelectWebServiceModel wsModel = (DataSourceSelectWebServiceModel) GetModel(strSelectWSModel);
      RegisterView(DataSourceSelectWebServiceView.STR_MVC_CLASS_NAME, wsModel);
      }
  }
}
//		//Register the model, view and control for the web service list
//		RegisterModel(SelectPTObjectModel.STR_MVC_CLASS_NAME,
//			STR_MVC_STORAGE_NAME_SELECT_PTOBJECT);
//
//		// Get back the Model we just registered because we need it to register the View and the Control
//		IModel mySelectPTObjectModel = GetModel(STR_MVC_STORAGE_NAME_SELECT_PTOBJECT);
//		RegisterView(SelectPTObjectView.STR_MVC_CLASS_NAME,
//			STR_MVC_STORAGE_NAME_SELECT_PTOBJECT, mySelectPTObjectModel);
//		RegisterControl(ExpListControl.STR_MVC_CLASS_NAME,
//			STR_MVC_STORAGE_NAME_SELECT_PTOBJECT, mySelectPTObjectModel);
