using System;
// Framework Imports
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.datasource
{
  public abstract class DSMainDP : EditorDP
  {
    
    /// <summary>
    /// Returns HTML for common Datasource Views.
    /// </summary>
    /// <returns>HTMLElement</returns>
    public virtual HTMLElement GetHTMLForCommonView()
    {
      HTMLElementCollection views = new HTMLElementCollection();
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(DSURLTypeView.STR_MVC_CLASS_NAME)).Display());
      views.AddInnerHTMLElement(EditorView.GetSpacerTable());
      return views;
    }
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,
    /// linking to that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return (m_asOwner.GetString(280, "ptmsgs_portaladminmsgs"));
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      /* JHQ 021104 - bug 28266: we need to display both the html (Display())
       * and the JavaScript (DisplayJavascript()) for the view.
       */
       
      myScripts.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(DataSourceSelectWebServiceView.STR_MVC_CLASS_NAME)).DisplayJavascript());
      //		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
      //				DSEditorAS.STR_MVC_STORAGE_NAME_SELECT_PTOBJECT)
      //			.DisplayJavascript());
      //
      return myScripts;
    }
  }
}