using System;
// Framework Imports
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.uiinfrastructure.errordisplay;
namespace com.plumtree.portalpages.admin.editors.datasource
{
  /// <summary>
  /// Delete that class if you don't have any repost actions.
  /// </summary>
  public abstract class DSRepostControl : ObjEditorRepostControl
  {
    public const String STR_MVC_CLASS_NAME = "DSRepostControl";
    
    /// <summary>
    /// Set the URL type 
    /// </summary>
    public const int POSTTOSELF_ACTION_CHANGEURLTYPE = 10;
    
    /// <summary>
    /// Set the WS 
    /// </summary>
    public const int POSTTOSELF_ACTION_WEB_SERVICE_CHOSEN = 11;
    
    /// <summary>
    /// Remove the WS 
    /// </summary>
    public const int POSTTOSELF_ACTION_WEBSERVICE_REMOVED = 12;
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call  the associated method for each
    /// action.
    /// </summary>
    /// <param name="_nAction"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      //		((ExpListControl) m_asOwner.GetControl(DSEditorAS.STR_MVC_STORAGE_NAME_SELECT_PTOBJECT)).PerformRepostAction(_nAction,
      //			m_htFormData);
      switch (_nAction){
      case POSTTOSELF_ACTION_WEB_SERVICE_CHOSEN:
      // Save page is called before we get here - it may error that the package is not
      // up-to-date (or that the remote server's not selected). It shouldn't do that.
      UIErrorHandler.ClearErrors(m_asOwner.GetSubSession(), m_asOwner.GetApplication());
      break;
      case POSTTOSELF_ACTION_WEBSERVICE_REMOVED:
      ((DataSourceSelectWebServiceModel) m_asOwner.GetModel(DSEditorAS.strSelectWSModel)).ClearWebService();
      break;
      }
    }
  }
}