using System;
// Framework Imports
using com.plumtree.openfoundation.util;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.datasource
{
  public class DSURLTypeView : EditorView
  {
    public const String STR_MVC_CLASS_NAME = "DSURLType";
    // HTML Object names.
    public const String HTMLRADIO_USEGATEWAY = "in_ra_DisplayPage";
    
    /// <seealso cref="com.plumtree.xpshared.infrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new DSURLTypeView();
    }
    
    /// <returns></returns>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTableCell myCell;
      HTMLTableRow myRow;
      HTMLInput myInput;
      try
      {
        result.AddInnerHTMLElement(base.GetHeaderView(m_asOwner.GetString(285,
         "ptmsgs_portaladminmsgs")));
        HTMLTable myTable = new HTMLTable();
        result.AddInnerHTMLElement(myTable);
        myTable.SetWidth("100%");
        myTable.SetBorder("0");
        myTable.SetCellPadding("5");
        myTable.SetCellSpacing("0");
        //First Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        //First cell
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
        myCell.SetVAlign("top");
        myRow.AddInnerHTMLElement(myCell);
        myCell.AddInnerHTMLString(m_asOwner.GetString(287, "ptmsgs_portaladminmsgs"));
        //Second cell
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myRow.AddInnerHTMLElement(myCell);
        int intDisplayPage = ((IDSModelRO) m_model).GetURLType();
        myInput = new HTMLInput(HTMLInputTypes.RADIO, HTMLRADIO_USEGATEWAY,
         m_asOwner.GetString(288, "ptmsgs_portaladminmsgs"));
        myInput.SetStyleClass(PTStyleClass.FORM_RADIO);
        myInput.SetValue(XPConvert.ToString(PT_URL_TYPES.PT_URL_TYPE_SIMPLE_FIELD_MAPPING));
        if (PT_URL_TYPES.PT_URL_TYPE_SIMPLE_FIELD_MAPPING == intDisplayPage)
        {
          myInput.SetChecked(true);
        }
        myInput.SetOnClick(AFormDP.JAVASCRIPT_SUBMIT_FORM + "(" + DSRepostControl.POSTTOSELF_ACTION_SIMPLEREPOST + ")");
        myCell.AddInnerHTMLElement(myInput);
        myCell.AddInnerHTMLString(m_asOwner.GetString(288, "ptmsgs_portaladminmsgs"));
        myCell.AddInnerHTMLElement(new HTMLBr());
        myInput = new HTMLInput(HTMLInputTypes.RADIO, HTMLRADIO_USEGATEWAY,
         m_asOwner.GetString(289, "ptmsgs_portaladminmsgs"));
        myInput.SetStyleClass(PTStyleClass.FORM_RADIO);
        myInput.SetValue(XPConvert.ToString(PT_URL_TYPES.PT_URL_TYPE_DATASOURCE_GENERATED));
        if (PT_URL_TYPES.PT_URL_TYPE_DATASOURCE_GENERATED == intDisplayPage)
        {
          myInput.SetChecked(true);
        }
        //myInput.SetOnClick(AFormDP.JAVASCRIPT_SUBMIT_FORM + "(" + DSRepostControl.POSTTOSELF_ACTION_CHANGEURLTYPE + ")");
        myInput.SetOnClick(AFormDP.JAVASCRIPT_SUBMIT_FORM + "(" + DSRepostControl.POSTTOSELF_ACTION_SIMPLEREPOST + ")");
        myCell.AddInnerHTMLElement(myInput);
        myCell.AddInnerHTMLString(m_asOwner.GetString(289, "ptmsgs_portaladminmsgs"));
        }
      catch (Exception e)
      {
        throw new XPException(m_asOwner.GetString(286, "ptmsgs_portaladminmsgs"),
         e);
      }
      return result;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}