using System;
// Framework imports
using com.plumtree.portalpages.common.helpers;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.datasource
{
  /// <summary>
  /// This Section contains the HTML for the dependencies page.
  /// </summary>
  /// <author></author>
  public class DataSourceDependenciesView : ObjDependenciesView
  {
    //Member variables
    private CreatedHelper m_chHelper = null;
    
    /// <summary>
    /// Class name for the activity space
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "DataSourceDependenciesView";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new DataSourceDependenciesView();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(com.plumtree.uiinfrastructure.activityspace.IModelRO,com.plumtree.uiinfrastructure.activityspace.AActivitySpace)"></seealso>
    public override void Init(IModelRO model, AActivitySpace parent)
    {
      base.Init(model, parent);
      m_chHelper = new CreatedHelper(parent, (DSModel) model);
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.ObjDependenciesView#GetHTMLForDependencies()"></seealso>
    protected override HTMLElementCollection GetHTMLForDependencies()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      //Display the standard success message
      m_chHelper.displaySuccessMessage(result, m_asOwner.GetString(2105, "ptmsgs_portaladminmsgs"),
       ((ObjEditorModel) m_model).GetObjectName(), ((ObjEditorModel) m_model).GetParentFolderPath());
      m_chHelper.displayTextRow(result, m_asOwner.GetString(2106, "ptmsgs_portaladminmsgs"),
       null);
      m_chHelper.beginList(result);
      //Display Create Crawler link
      int nFolderID = ((ObjEditorModel) m_model).GetFolderID();
      //Get the providerCLSID from the data source object
      IPTDataSource myDataSource = (IPTDataSource) ((ObjEditorModel) m_model).GetObject();
      String strProviderCLSID = myDataSource.GetDataSourceProviderCLSID();
      String strArg = "&dataSourceID=" + ((DSModel) m_model).GetObjectID();
      m_chHelper.displayListRow(PlumtreeHelpers.MakeCreateObjectLink(PT_CLASSIDS.PT_CRAWLER_ID,
       strProviderCLSID, nFolderID, m_asOwner.GetString(2107, "ptmsgs_portaladminmsgs"),
       m_asOwner, strArg, true));
      //Display the standard warning if everyone has access to this object
      m_chHelper.displayEveryoneWarning(result, (DSModel) m_model, m_asOwner.GetString(2105,
       "ptmsgs_portaladminmsgs"));
      return result;
    }
  }
}