using System;
using com.plumtree.openlog;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.form;
namespace com.plumtree.portalpages.admin.editors.defaultprofile
{
  /// <summary>
  /// File: EditDefaultProfileAS.java
  /// -------------------------------
  /// </summary>
  /// <author>NaveenP</author>
  public class EditDefaultProfileAS : PlumtreeAS
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.defaultprofile.EditDefaultProfileAS");
    public const String STR_MVC_CLASS_NAME = "EditDefaultProfile";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new EditDefaultProfileAS();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    public override String GetRepostControlName()
    {
      return EditDefaultProfileRepostControl.STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Registers all the classes of the Property Activity Space.
    /// </summary>
    public override void Init()
    {
      base.Init();
      // Display Pages
      RegisterPage(new EditDefaultProfileDP());
      RegisterPage(new EditDefaultProfileTopDP());
      RegisterPage(new ClosePopUpDP());
      // Models
      RegisterModel(EditDefaultProfileModel.STR_MVC_CLASS_NAME);
      EditDefaultProfileModel myModel = (EditDefaultProfileModel) GetModel(EditDefaultProfileModel.STR_MVC_CLASS_NAME);
      // Views
      RegisterView(EditDefaultProfileTopView.STR_MVC_CLASS_NAME, myModel);
      // Controls
      RegisterControl(SetEditDefaultProfileControl.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(EditDefaultProfileRepostControl.STR_MVC_CLASS_NAME,
       myModel);
    }
  }
}
/*
 //	TIPS
 // We need to explicitly register the Tips Model, View, and Control
 // because PlumtreeAS doesn't do it for us.  Only EditorAS does it for
 // us.  This is commented out because the current display page has no
 // support for Tips.  We need to be able to view the tips before there
 // is any point in registering the model.
 //		RegisterModel(TipsModel.STR_MVC_CLASS_NAME);
 
 //		TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);
 
 //		RegisterView(TipsView.STR_MVC_CLASS_NAME, tm);
 //		RegisterControl(TipsControl.STR_MVC_CLASS_NAME, tm);
 
 // Use GetModelExists rather than GetModel, because GetModel throws
 // an exception if the model is not found.
 if (GetModelExists(TipsModel.STR_MVC_CLASS_NAME))
 {
 TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);
 
 try
 {
 
 
 int iTitleId = 24;
 int iTipId = 25;
 int iSecondaryTipId = 26;
 
 tm.SetTipTitle( this.GetString( iTitleId, "ptmsgs_tips") );
 
 HTMLGenericElement e = new HTMLGenericElement( this.GetString( iTipId, "ptmsgs_tips") );
 
 tm.SetTip( e );
 
 String sSecondary = this.GetString( iSecondaryTipId, "ptmsgs_tips");
 
 if( !("none_do_not_translate".equals( sSecondary )) )
 {
 
 e = new HTMLGenericElement( sSecondary );
 
 tm.SetSecondarTip( e );
 }
 
 
 }
 catch (Exception ex)
 {
 
 log.Error(ex, "Couldn't generate tip.");
 
 }
 }
 //	Got the tips model
 */
 
