using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.common;
namespace com.plumtree.portalpages.admin.editors.defaultprofile
{
  /// <summary>
  /// File: EditDefaultProfileDP.java
  /// -------------------------------
  /// </summary>
  /// <author>NaveenP</author>
  public class EditDefaultProfileDP : FrameSetDP
  {
    public const String STR_MVC_CLASS_NAME = "EditDefaultProfile";
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Set Frame Scroll Body
    /// </summary>
    /// <returns>boolean true implies scrolling</returns>
    public override bool GetFrameScrollBody()
    {
      return true;
    }
    
    /// <summary>
    /// Set FrameSet Attributes
    /// </summary>
    /// <returns>String</returns>
    public override String GetFrameSetAttributes()
    {
      return "60px,50%";
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.dialogheader.FrameSetDialog#GetFrameSetTitle()"></seealso>
    public override String GetFrameSetTitle()
    {
      return m_asOwner.GetString(328, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.dialogheader.FrameSetDialog#GetFrameURLBody()"></seealso>
    public override ASURL GetFrameURLBody()
    {
      EditDefaultProfileModel asModel = (EditDefaultProfileModel) m_asOwner.GetModel(EditDefaultProfileModel.STR_MVC_CLASS_NAME);
      return asModel.GetDefaultURL();
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.dialogheader.FrameSetDialog#GetFrameURLTop()"></seealso>
    public override ASURL GetFrameURLTop()
    {
      ASURL url = new ASURL(m_asOwner);
      url.SetLinkGetCachedSpace(m_asOwner);
      url.SetDisplayPage(EditDefaultProfileTopDP.STR_MVC_CLASS_NAME);
      return url;
    }
  }
}