using System;
using com.plumtree.openfoundation.web;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
namespace com.plumtree.portalpages.admin.editors.defaultprofile
{
  /// <summary>
  /// File: EditDefaultProfileRepostControl.java
  /// ------------------------------------------
  /// </summary>
  /// <author>NaveenP</author>
  public class EditDefaultProfileRepostControl : RepostControl,ILoginControl,
  IHTTPControl
  {
    public const String STR_MVC_CLASS_NAME = "EditDefaultProfile";
    
    /// <summary>
    /// Activity Space 
    /// </summary>
    private AActivitySpace m_asOwner;
    
    /// <summary>
    /// Model 
    /// </summary>
    private EditDefaultProfileModel m_asModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new EditDefaultProfileRepostControl();
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.ILoginControl#DoGetSession()"></seealso>
    public virtual bool DoGetSession()
    {
      // The interpreter should ask us for the session.
      return true;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IControl#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.ILoginControl#GetSession()"></seealso>
    public virtual Object GetSession()
    {
      return m_asModel.GetSession();
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IControl#Init(IModel,AActivitySpace)"></seealso>
    public override void Init(IModel model, AActivitySpace space)
    {
      base.Init(model, space);
      m_asModel = (EditDefaultProfileModel) model;
      m_asOwner = space;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.ILoginControl#SetRedirectForUseAfterLogin(Redirect)"></seealso>
    public virtual void SetRedirectForUseAfterLogin(Redirect r)
    {
    }
    
    /// <param name="r"></param>
    /// <param name="webdata"></param>
    public virtual void SetHTTPItems(IXPRequest request, IWebData webdata)
    {
      m_asModel.SetHTTPItems(request, webdata);
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.RepostControl#PerformAction(int)"></seealso>
    protected override void PerformAction(int _nAction)
    {
      int nAction;
      if (_nAction == POSTTOSELF_ACTION_UNDEFINED)
      {
        // need to check for undefined here because switching between 508
        // and standard returns undefined.
        nAction = POSTTOSELF_ACTION_FINISH;
      } else
      {
        nAction = _nAction;
      }
      base.PerformAction(nAction);
    }
  }
}