using System;
// Framework Imports
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.doctype
{
  public class GenInfoView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.doctype.GenInfoView");
    public const String STR_MVC_CLASS_NAME = "DTGenInfo";
    public const String HTMLSELECT_ACCESSORS = "in_se_Accessors";
    public const String HTMLCHECKBOX_INDEX = "in_cb_Index";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new GenInfoView();
    }
    
    /// <returns></returns>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTableCell myCell;
      HTMLTableRow myRow;
      HTMLSpan mySpan;
      HTMLInput myInput;
      HTMLSelect mySelect;
      HTMLOption myOption;
      try
      {
        result.AddInnerHTMLElement(base.GetHeaderView(m_asOwner.GetString(315,
         "ptmsgs_portaladminmsgs")));
        HTMLTable myTable = new HTMLTable();
        result.AddInnerHTMLElement(myTable);
        myTable.SetWidth("100%");
        myTable.SetBorder("0");
        myTable.SetCellPadding("5");
        myTable.SetCellSpacing("0");
        //First row begin
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myCell.SetWidth("150");
        myCell.SetNoWrap(true);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(316, "ptmsgs_portaladminmsgs"));
        myCell.AddInnerHTMLElement(mySpan);
        //Second cell
        myCell = new HTMLTableCell();
        myCell.SetWidth("100%");
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myRow.AddInnerHTMLElement(myCell);
        mySelect = new HTMLSelect(HTMLSELECT_ACCESSORS, HTMLSELECT_ACCESSORS);
        myCell.AddInnerHTMLElement(mySelect);
        mySelect.SetStyleClass(PTStyleClass.FORM_PULLDOWN_TEXT);
        //Add the options
        XPHashtable myHashTable = ((IDocTypeModelRO) m_model).GetAccessors();
        Object[] arrKeys = myHashTable.GetArray(XPHashtable.KEYS);
        //String[] arrKeys = new String[myHashTable.GetSize()];
        //arrKeys = (String[]) myHashTable.GetArray(XPHashtable.KEYS);
        for (int i = 0;i < arrKeys.Length;i++)
        {
          //The argument is the value
          myOption = new HTMLOption((String) arrKeys[i]);
          if (arrKeys[i].Equals(((IDocTypeModelRO) m_model).GetAccessorCLSID()))
          {
            myOption.SetSelected(true);
          }
          mySpan = new HTMLSpan();
          myOption.AddInnerHTMLElement(mySpan);
          mySpan.AddInnerHTMLString((String) myHashTable.GetElement(arrKeys[i]));
          mySelect.AddInnerHTMLElement(myOption);
        }
        //Second row begin
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myCell.SetWidth("150");
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.AddInnerHTMLString("&nbsp");
        myRow.AddInnerHTMLElement(myCell);
        //Second cell
        myCell = new HTMLTableCell();
        myCell.SetWidth("100%");
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myRow.AddInnerHTMLElement(myCell);
        myInput = new HTMLInput(HTMLInputTypes.CHECKBOX, HTMLCHECKBOX_INDEX,
         m_asOwner.GetString(318, "ptmsgs_portaladminmsgs"));
        myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
        if (((IDocTypeModelRO) m_model).GetFullTextIndex())
        {
          myInput.SetChecked(true);
        }
        myInput.SetValue("1");
        myCell.AddInnerHTMLElement(myInput);
        myCell.AddInnerHTMLString(m_asOwner.GetString(318, "ptmsgs_portaladminmsgs"));
        }
      catch (Exception e)
      {
        log.Error(e, "GenInfoView::Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(317, "ptmsgs_portaladminmsgs"),
         e);
      }
      return result;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}