using System;
// Framework Imports
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.admin.editors.doctypemap
{
  /// <summary>
  /// This class contains the additional repost actions.
  /// The ones specific to the Document Type Map Editor (other than
  /// "change page", "finish" and "cancel" actions).
  /// </summary>
  /// <author>SudhaS</author>
  public class GbDocTypeRepostControl : EditorRepostControl
  {
    // ***CHANGE_HERE*** Change the name of the class.
    // ***COMMENT_1*** Delete the comments prefixed by CHANGE_HERE and COMMENT
    //       when you are done.
    // ***CHANGE_HERE*** Set the class name.
    // ***COMMENT_1*** All the Controls in Plumtree need to have a unique name.
    public const String STR_MVC_CLASS_NAME = "GbDocTypeMapRepost";
    // ***CHANGE_HERE*** create a new constant for each repost action
    //       you have in the entire Editor.
    // ***COMMENT_1*** The repost action value should not be below 10
    // ***COMMENT_2*** If you are using any plug-in section, you need to make sure
    //       there is no conflict between your actions below and the plug-in actions.
    public const int POSTTOSELF_ACTION_DTM = 10;
    public const int POSTTOSELF_ACTION_DONE_POPUP = 11;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new GbDocTypeRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call
    /// the associated method for each action.
    /// </summary>
    /// <param name="_nAction"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      IDisplayPage currDP = (IDisplayPage) m_asOwner.GetCurrentPage();
      if (!XPStringUtility.EqualsIgnoreCase(currDP.GetName(), "MigrationHistoryPlugin"))
      {
        int nCurrPageID = ((GbDocTypeMainDP) m_asOwner.GetCurrentPage()).GetGbDocTypeID();
        ((ExpListControl) m_asOwner.GetControl(GbDocTypeEditorAS.strStorageGbDocTypeList + nCurrPageID)).PerformRepostAction(_nAction,
         m_htFormData);
      }
      //***CHANGE_HERE*** if you don't have any repost action, delete the switch statement.
      switch (_nAction){
      //***CHANGE_HERE*** Create a new case for each of your action.
      case POSTTOSELF_ACTION_DTM:
      //***CHANGE_HERE*** For each action call the associated method in your model.
      ((GbDocTypeModel) m_model).ActionOnRepost();
      break;
      }
    }
  }
}