using System;
// Framework Imports
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.doctypemapextension
{
  /// <author>SudhaS</author>
  public class GbDocTypeExtDP : EditorDP
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.doctypemapextension.GbDocTypeExtDP");
    public const String STR_MVC_CLASS_NAME = "GbDocTypeExtMain";
    public const String HTMLHIDDEN_POPUP_NAME = "in_hi_PopUpName";
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,
    /// linking to that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return (m_asOwner.GetString(336, "ptmsgs_portaladminmsgs"));
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for the General Info page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)"></seealso>
    /// <returns>HTMLElement</returns>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // Insert super class HTML
      result.AddInnerHTMLElement(base.PageDisplay());
      HTMLElementCollection views = new HTMLElementCollection();
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(GbDocTypeExtView.STR_MVC_CLASS_NAME)).Display());
      views.AddInnerHTMLElement(EditorView.GetSpacerTable());
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(GbDocTypeExtEditorAS.strStorageGbDocTypeExtList)).Display());
      HTMLInput myInput = new HTMLInput(HTMLInputTypes.HIDDEN, HTMLHIDDEN_POPUP_NAME,
       "");
      result.AddInnerHTMLElement(myInput);
      result.AddInnerHTMLElement(CreateLeftNavBar(views));
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      try
      {
        HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
        // ***CHANGE_HERE SELECTPTOBJECT*** Display JavaScripts for the Select PTObject list.
        //GbDocTypeExtListView temp = (GbDocTypeExtListView) m_asOwner.GetView(GbDocTypeExtEditorAS.strStorageGbDocTypeExtList);
        myScripts.AddInnerHTMLElement(m_asOwner.GetView(GbDocTypeExtEditorAS.strStorageGbDocTypeExtList).DisplayJavascript());
        myScripts.AddInnerHTMLElement(m_asOwner.GetView(GbDocTypeExtView.STR_MVC_CLASS_NAME).DisplayJavascript());
        return myScripts;
      }
      //myScripts.AddInnerHTMLElement(m_asOwner.GetView(GeneralInfoView.STR_MVC_CLASS_NAME).DisplayJavascript());
      catch (Exception e)
      {
        log.Error("GbDocTypeExtDP" + e);
      }
      return null;
    }
  }
}