using System;
// Framework Imports
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.admin.editors.doctypemapextension
{
  /// <author>SudhaS</author>
  public class GbDocTypeExtEditorAS : ObjEditorAS
  {
    public const String STR_MVC_CLASS_NAME = "GbDocTypeExtEditor";
    public const String strStorageGbDocTypeExtList = "GbDocTypeExtListStorage";
    public const String strStorageGbDocTypePopUp = "GbDocTypePopUpStorage";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new GbDocTypeExtEditorAS();
    }
    
    /// <summary>
    /// Sets the Editor title.
    /// </summary>
    /// <returns></returns>
    public override String GetEditorTitle()
    {
      return (GetString(337, "ptmsgs_portaladminmsgs"));
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the class name of the Repost Control.
    /// </summary>
    /// <returns>String</returns>
    public override String GetRepostControlName()
    {
      return (GbDocTypeExtRepostControl.STR_MVC_CLASS_NAME);
    }
    
    /// <summary>
    /// Registers all the classes for this Activity Space.
    /// </summary>
    public override void Init()
    {
      m_strModelName = GbDocTypeExtModel.STR_MVC_CLASS_NAME;
      base.Init();
      IModel myModel = GetModel(m_strModelName);
      // Register DisplayPages
      //RegisterPage(new MainDP());
      GbDocTypeExtDP mainDP = new GbDocTypeExtDP();
      RegisterPage(mainDP);
      mainDP.AddToValidationFunction("CheckBlankExtension");
      mainDP.AddToValidationFunction("VerifySelect");
      //RegisterPage(new GbDocTypeExtPopUpDP());
      // Register Views
      RegisterView(GbDocTypeExtView.STR_MVC_CLASS_NAME, myModel);
      //RegisterView(GbDocTypeExtPopUpView.STR_MVC_CLASS_NAME, myModel);
      // Register Controls
      RegisterControl(GbDocTypeExtRepostControl.STR_MVC_CLASS_NAME, myModel);
      // Default page
      SetCurrentPage(GbDocTypeExtDP.STR_MVC_CLASS_NAME);
      // Get back the Model we just registered because we need it to register the Section and the Control
      RegisterModel(GbDocTypeExtListModel.STR_MVC_CLASS_NAME, strStorageGbDocTypeExtList);
      IModel myGbDocTypeExtListModel = GetModel(strStorageGbDocTypeExtList);
      RegisterView(GbDocTypeExtListView.STR_MVC_CLASS_NAME, strStorageGbDocTypeExtList,
       myGbDocTypeExtListModel);
      RegisterControl(ExpListControl.STR_MVC_CLASS_NAME, strStorageGbDocTypeExtList,
       myGbDocTypeExtListModel);
      //Sets left nav menu
      int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(339, "ptmsgs_portaladminmsgs"));
      m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, GbDocTypeExtDP.STR_MVC_CLASS_NAME);
      }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage()"></seealso>
    /// <param name="IDisplayPage">the current Display Page</param>
    public override void SetCurrentPage(IDisplayPage page)
    {
      base.SetCurrentPage(page);
      String sPageName = page.GetName();
      if (GbDocTypeExtDP.STR_MVC_CLASS_NAME.Equals(sPageName))
      {
        this.SetHelpTopic("PT_CreateExtension_MainSettings");
      }
    }
  }
}