using System;
// Framework Imports
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.admin.editors.doctype;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.arraywrapper;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
using com.plumtree.uiinfrastructure.htmlconstructs;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.doctypemapextension
{
  /// <summary>
  /// This is the implementation of the Expandable List
  /// framework for the Growable Array.
  /// Is constains the HTML to display the Growable Array.
  /// It gets the data to display from GrowableListModel.
  /// </summary>
  /// <author>SudhaS</author>
  public class GbDocTypeExtListView : ExpListView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.doctypemapextension.GbDocTypeExtListView");
    
    /// <summary>
    /// Class name for the activity space 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "GbDocTypeExtList";
    
    /// <summary>
    /// Class name for the activity space 
    /// </summary>
    public const String HTMLINPUT_ITEM = "in_tx_Item";
    public const String HTMLHIDDEN_PROPEDITORKEY = "in_hi_PropEditorKey";
    public const String HTMLRADIOBTN_SELECT = "in_ra_SelectRow";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new GbDocTypeExtListView();
    }
    
    /// <summary>
    /// Returns Java Script for goToPage function.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    /// <returns>HTMLScript</returns>
    public override HTMLScript DisplayJavascript()
    {
      HTMLScript myScript = null;
      myScript = new HTMLScript("text/javaScript");
      try
      {
        XPStringBuilder sb;
        sb = new XPStringBuilder(300);
        // JavaScript to sort by column
        sb.Append("function " + ((IExpListModelRO) m_model).GetUniqueString("SortBy") + "(varColumnID)\n");
        sb.Append("{\n");
        sb.Append("  document." + EditorDP.HTMLFORM_NAME + "." + ((IExpListModelRO) m_model).GetUniqueString(HTMLHIDDEN_COLUMNID) + ".value= varColumnID;\n");
        sb.Append("  postToSelf(" + ((IExpListModelRO) m_model).GetUniqueInt(ExpListControl.POSTTOSELF_ACTION_SORTBYCOLUMN) + ");\n");
        sb.Append("}\n");
        myScript.AddInnerHTMLString(sb.ToString());
        sb = new XPStringBuilder(300);
        // JavaScript to check all the rows
        sb.Append("function " + ((IExpListModelRO) m_model).GetUniqueString("CheckRows") + "()\n");
        sb.Append("{ \n");
        sb.Append("  var frm = document." + EditorDP.HTMLFORM_NAME + "; \n");
        sb.Append("  var len = frm.elements.length; \n");
        sb.Append("  var nValue = frm." + ((IExpListModelRO) m_model).GetUniqueString(HTMLCHECKBOX_CHECKALL) + ".checked; \n");
        sb.Append("  var i = 0; \n");
        sb.Append("  \n");
        sb.Append("  for(i=0 ; i<len ; i++) \n");
        sb.Append("  { \n");
        sb.Append("    if (frm.elements[i].name == \'" + ((IExpListModelRO) m_model).GetUniqueString(HTMLCHECKBOX_DELROW) + "\') \n");
        sb.Append("    { \n");
        sb.Append("       frm.elements[i].checked = nValue;\n");
        sb.Append("    } \n");
        sb.Append("  } \n");
        sb.Append("}\n");
        sb.Append("function CreateDocumentType()\n");
        sb.Append("{\n");
        sb.Append("    window.open(\'").Append(((IGbDocTypeExtListModelRO) m_model).GetASURLToProperty(null,
         DocTypeEditorAS.STR_MVC_CLASS_NAME).GetURLAsString()).Append("\', \'_blank3\', \'location=no,menubar=no,scrollbars=yes, height=600,width=1000\');\n");
        sb.Append("}\n");
        sb.Append("function EditProperty(varSubSpaceURL,varSubSpaceKey)\n");
        sb.Append("{\n");
        sb.Append("    window.open(varSubSpaceURL, \'PopUpEditMode\' + varSubSpaceKey, \'location=no,menubar=no,height=400,width=800\');\n");
        sb.Append("}\n");
        sb.Append("function VerifySelect()\n");
        sb.Append("{ \n");
        sb.Append("  var frm = document." + EditorDP.HTMLFORM_NAME + "; \n");
        sb.Append("  var len = frm.elements.length; \n");
        sb.Append("  var i = 0; \n");
        sb.Append("  for(i=0 ; i<len ; i++) \n");
        sb.Append("  { \n");
        sb.Append("    if (frm.elements[i].checked == 1)\n");
        sb.Append("    { \n");
        sb.Append("\t\t return true;\n");
        sb.Append("    }\n");
        sb.Append("  }\n");
        sb.Append("  alert(\"" + m_asOwner.GetString(1816, "ptmsgs_portaladminmsgs") + "\");\n");
        sb.Append("  return false;\n");
        sb.Append("}\n");
        // Edit object
        //sb = new XPStringBuilder( 200 );
        /*
         sb.Append(" function " + ((IGbDocTypeExtListModelRO)m_model).GetUniqueString("EditObject") + "(varURL,varIndex)");
         sb.Append(" {");
         sb.Append("    window.open(varURL,'PopUpEditMode' + varIndex,'location=no,menubar=no,height=600,width=800');\n");
         sb.Append(" }");
         */
         
        /*
         sb.Append("function RemoveProperty(varSubSpaceKey)\n" );
         sb.Append("{\n" );
         sb.Append("  document." + EditorDP.HTMLFORM_NAME + "." + HTMLHIDDEN_PROPEDITORKEY + ".value= varSubSpaceKey;\n");
         sb.Append("  postToSelf(" + GbDocTypeRepostControl.POSTTOSELF_ACTION_REMOVEPROPERTY + ");\n");
         sb.Append("}\n" );
         */
         
        myScript.AddInnerHTMLString(sb.ToString());
        if (((IExpListModelRO) m_model).GetEnableMoveRowActions())
        {
          sb = new XPStringBuilder(300);
          // JavaScript to sort by column
          sb.Append("function " + ((IExpListModelRO) m_model).GetUniqueString("MoveRow") + "(varMoveAction, varRowIndex)\n");
          sb.Append("{\n");
          sb.Append("  document." + EditorDP.HTMLFORM_NAME + "." + ((IExpListModelRO) m_model).GetUniqueString(HTMLHIDDEN_ROWINDEX) + ".value= varRowIndex;\n");
          sb.Append("  document." + EditorDP.HTMLFORM_NAME + "." + ((IExpListModelRO) m_model).GetUniqueString(HTMLHIDDEN_MOVEACTION) + ".value= varMoveAction;\n");
          sb.Append("  postToSelf(\'" + ((IExpListModelRO) m_model).GetUniqueInt(ExpListControl.POSTTOSELF_ACTION_MOVEROW) + "\');\n");
          sb.Append("}\n");
          myScript.AddInnerHTMLString(sb.ToString());
        }
      }
      catch (Exception e)
      {
        log.Error(e, "ExpListView::DisplayJavascript The following error occured when trying to display the JavaScript: " + e.Message);
        throw new XPException(m_asOwner.GetString(53, 
        //m_asOwner.GetString(15, "ptmsgs_portaladminmsgs")
        "ptmsgs_infrastructure"), e);
      }
      return myScript;
    }
    
    /// <summary>
    /// Returns the HTML for the row _nRowIndex.
    /// Each row contains just an icon and input text.
    /// </summary>
    /// <param name="_saData"></param>
    /// <param name="_nRowIndex"></param>
    /// <returns>HTMLElement</returns>
    /// <throws>Exception</throws>
    public override HTMLElement GetHTMLForRow(IPTGrowableSortedArrayWrapperRO _saData,
     int _nRowIndex)
    {
      try
      {
        HTMLElementCollection result = new HTMLElementCollection();
        HTMLTableCell myCell;
        // input text
        myCell = new HTMLTableCell();
        result.AddInnerHTMLElement(myCell);
        myCell.SetWidth("100%");
        myCell.SetHeight("30");
        myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
        String strDocTypeName = (String) _saData.GetItem(_nRowIndex, GbDocTypeExtListModel.EXPLIST_COL_DOCTYPENAME);
        //String strDocTypeIdentifier = XPConvert.ToString(nDocTypeIdentifier);
        //String strDocTypeID = XPConvert.ToString(nDocTypeID);
        myCell.AddInnerHTMLEncodedString(strDocTypeName);
        return result;
      }
      catch (HTMLException e)
      {
        log.Error("GbDocTypeExtListView : " + e);
      }
      catch (Exception e)
      {
        log.Error("GbDocTypeExtListView : " + e);
      }
      return null;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for the space below the Action bar.
    /// (The one with the add and delete icons).
    /// </summary>
    /// <returns>HTMLTable</returns>
    /// <throws>Exception</throws>
    protected override HTMLTable GetHTMLBelowActionBar()
    {
      HTMLTable myTable = new HTMLTable();
      myTable.SetWidth("100%");
      myTable.SetCellPadding("5");
      HTMLTableRow myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
      HTMLTableCell myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
      myCell.AddInnerHTMLString(m_asOwner.GetString(1815, "ptmsgs_portaladminmsgs"));
      return myTable;
    }
    
    /// <summary>
    /// Returns the HTML for the Action bar.
    /// (The one with the add and delete icons).
    /// </summary>
    /// <returns>HTMLTable</returns>
    /// <throws>Exception</throws>
    protected override HTMLTable GetHTMLForActionBar()
    {
      try
      {
        HTMLTable myTable;
        HTMLTableRow myRow;
        HTMLTableCell myCell;
        myTable = new HTMLTable();
        myTable.SetBorder("0");
        myTable.SetCellPadding("0");
        myTable.SetCellSpacing("0");
        // 1st Row begin (there is only one row)
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BG);
        // Empty Cell
        myRow.AddInnerHTMLElement(GetHTMLForEmptyCellInActionBar());
        // Add icon cell
        myRow.AddInnerHTMLElement(GetHTMLForAddAction());
        // Empty Cell
        myRow.AddInnerHTMLElement(GetHTMLForEmptyCellInActionBar());
        myRow.AddInnerHTMLElement(GetHTMLForEmptyCellInActionBar());
        /*
         // JF- No need to display the delete icon, if the list is empty.
         if (0 != ((IExpListModelRO) m_model).GetReadOnlyItems().GetCount())
         {
         // Delete icon cell
         myRow.AddInnerHTMLElement(GetHTMLForDeleteAction());
         }
         */
         
        // Add Extra HTML to the action bar (like a "create" button)
        AddHTMLToActionBar(myRow);
        // Last Empty Cell
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetWidth("100%");
        myCell.SetHeight("25");
        myCell.AddInnerHTMLString(SPACE);
        // 1st Row ends
        return myTable;
      }
      catch (HTMLException e)
      {
        log.Error("GbDocTypeExtListView : " + e);
      }
      catch (Exception e)
      {
        log.Error("GbDocTypeExtListView : " + e);
      }
      return null;
    }
    
    /// <summary>
    /// Returns the HTML for the add cell in the action bar.
    /// </summary>
    /// <returns>HTMLTableCell</returns>
    /// <throws>Exception</throws>
    protected override HTMLTableCell GetHTMLForAddAction()
    {
      try
      {
        HTMLTableCell myCell;
        PTConstruct myConstruct;
        HTMLImg myImage;
        HTMLImg myAddIcon;
        HTMLAnchor myAnchor;
        HTMLSpan mySpan;
        myCell = new HTMLTableCell();
        myCell.SetHeight("25");
        myCell.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BTN);
        myCell.SetNoWrap(true);
        myCell.AddInnerHTMLString(SPACE);
        // Add icon
        myConstruct = UIConstructFactory.GetConstruct(PTImageType.ACTION_NEW,
         true, this.m_asOwner);
        myAddIcon = (HTMLImg) myConstruct.GetHTMLElement();
        myAddIcon.SetAlt("");
        myAddIcon.SetAlign("absmiddle");
        // Add icon
        myConstruct = UIConstructFactory.GetConstruct(((IExpListModelRO) m_model).GetAddIcon(),
         true, this.m_asOwner);
        myImage = (HTMLImg) myConstruct.GetHTMLElement();
        myImage.SetAlt("");
        myImage.SetAlign("absmiddle");
        //myAnchor = new HTMLAnchor("postToSelf('"	// mj: removed 'Javascript:' from function name
        //	+ ((IExpListModelRO)m_model).GetUniqueInt(ExpListControl.POSTTOSELF_ACTION_ADD) + "');");
        // mj: replaced the following line with a blank constructur and SetOnClick()
        // myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
        myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
        myAnchor.SetOnClick(ConstructStaticHelpers.BLANK_URL);
        myAnchor.SetOnClick("CreateDocumentType(); return false;");
        myAnchor.AddInnerHTMLElement(myAddIcon);
        myAnchor.AddInnerHTMLElement(myImage);
        mySpan = new HTMLSpan();
        myAnchor.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.ACTIONBAR_TEXT);
        // Add label
        mySpan.AddInnerHTMLString(((IExpListModelRO) m_model).GetAddLabel());
        mySpan.AddInnerHTMLString(SPACE);
        mySpan.AddInnerHTMLString(SPACE);
        myCell.AddInnerHTMLElement(myAnchor);
        myCell.AddInnerHTMLString(SPACE);
        return myCell;
      }
      catch (HTMLException e)
      {
        log.Error("GbDocTypeExtListView : " + e);
      }
      catch (Exception e)
      {
        log.Error("GbDocTypeExtListView : " + e);
      }
      return null;
    }
    
    /// <summary>
    /// Returns the HTML for the checkbox on row _nRowIndex.
    /// </summary>
    /// <param name="_nRowIndex"></param>
    /// <returns>HTMLTableCell</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLTableCell GetHTMLForCheckBox(int _nRowIndex)
    {
      HTMLTableCell myCell;
      HTMLInput myInput;
      myCell = new HTMLTableCell();
      myCell.SetWidth("20");
      myCell.SetHeight("30");
      myCell.SetAlign("center");
      myCell.SetVAlign("middle");
      myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
      // radio button
      myInput = new HTMLInput(HTMLInputTypes.RADIO, HTMLRADIOBTN_SELECT, "");
      myInput.SetStyleClass(PTStyleClass.FORM_RADIO);
      int nDocTypeID = XPConvert.ToInteger(((IGbDocTypeExtListModelRO) m_model).GetDocTypeFromRowIndex(_nRowIndex));
      myInput.SetValue(XPConvert.ToString(nDocTypeID));
      if (nDocTypeID == ((IGbDocTypeExtModelRO) m_asOwner.GetModel(GbDocTypeExtModel.STR_MVC_CLASS_NAME)).GetDocTypeID())
      {
        myInput.SetChecked(true);
      }
      myCell.AddInnerHTMLElement(myInput);
      return (myCell);
    }
    
    /// <summary>
    /// Helper method to get the HTML for the icon.
    /// (Each row has an icon before the input text.)
    /// </summary>
    /// <returns>HTMLImg</returns>
    /// <throws>Exception</throws>
    protected virtual HTMLImg GetHTMLForIcon(PTImageType _imgRowIcon)
    {
      HTMLImg myImage;
      PTConstruct myConstruct;
      myConstruct = UIConstructFactory.GetConstruct(_imgRowIcon, true, this.m_asOwner);
      myImage = (HTMLImg) myConstruct.GetHTMLElement();
      myImage.SetAlt("");
      myImage.SetAlign("absmiddle");
      return (myImage);
    }
    
    /// <summary>
    /// Returns the HTML for the sub header.
    /// </summary>
    /// <returns>HTMLTableRow</returns>
    /// <throws>Exception</throws>
    protected override HTMLTableRow GetHTMLForSubHeader()
    {
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLAnchor myAnchor;
      //HTMLInput myInput;
      HTMLImg myImage;
      PTConstruct myConstruct;
      myRow = new HTMLTableRow();
      myRow.SetStyleClass(PTStyleClass.LIST_SORT_HEADER_BG);
      // Empty Cell
      //myRow.AddInnerHTMLElement(GetHTMLForEmptyCellInActionBar());
      // Row 1 - Cell 1 - checkbox
      /*
       myCell = new HTMLTableCell();
       myRow.AddInnerHTMLElement(myCell);
       myCell.SetWidth("20");
       myCell.SetAlign("center");
       myCell.SetVAlign("middle");
       myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
       // checkbox
       myInput = new HTMLInput(HTMLInputTypes.CHECKBOX,
       ((IExpListModelRO) m_model).GetUniqueString(HTMLCHECKBOX_CHECKALL),
       ((IExpListModelRO) m_model).GetAddIconAlt());
       myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
       myInput.SetOnClick(((IExpListModelRO)m_model).GetUniqueString("CheckRows") + "();");	// mj: removed 'Javascript:' from function name
       myCell.AddInnerHTMLElement(myInput);
       */
       
      Object[][] oArrExpListColInfo = ((IExpListModelRO) m_model).GetArrExpListColInfo();
      int nColumnID;
      // JF- We loop through the column array and print out each one
      for (int i = 0;i < oArrExpListColInfo.Length;i++)
      {
        // Row 1 - Cell i
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetWidth((String) oArrExpListColInfo[i][ExpListModel.EXPLIST_COLUMN_WIDTH]);
        myCell.SetColSpan((String) oArrExpListColInfo[i][ExpListModel.EXPLIST_COLUMN_COLSPAN]);
        myCell.SetHeight("20");
        myCell.SetNoWrap(true);
        myCell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        myCell.AddInnerHTMLString(SPACE);
        // JF- Print out the column title with information we get from the array (oArrExpListColInfo)
        if (XPConvert.ToBoolean(oArrExpListColInfo[i][ExpListModel.EXPLIST_COLUMN_ENABLESORT]))
        {
          // JF- If the sort is enabled for this column we need to know what to display:
          // - If the list is not sorted by this column, we display just a link to sort by this column
          // - If the list is currently sorted by this column, we display an arrow that shows the current
          //   sort direction and a link to reverse the sort.
          nColumnID = XPConvert.ToInteger(oArrExpListColInfo[i][ExpListModel.EXPLIST_COLUMN_ID]);
          // JF- The list is currently sorted by this column
          if (nColumnID == ((IExpListModelRO) m_model).GetMainColumnSort())
          {
            // JF- We build the link to reverse the sort
            myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
            // mj: removed 'Javascript:' from function name
            myAnchor.SetOnClick("postToSelf(\'" + ((IExpListModelRO) m_model).GetUniqueInt(ExpListControl.POSTTOSELF_ACTION_REVERSESORT) + "\'); return false;");
            myCell.AddInnerHTMLElement(myAnchor);
            myAnchor.AddInnerHTMLString((String) oArrExpListColInfo[i][ExpListModel.EXPLIST_COLUMN_TITLE]);
            // JF- We figure out the sort direction to know which arrow to display
            if (PTSortedArrayWrapper.PTSAW_SORT_ASCENDING == ((IExpListModelRO) m_model).GetMainColumnSortDirection())
            {
              myConstruct = UIConstructFactory.GetConstruct(PTImageType.ICON_ARROW_DESCEND,
               true, this.m_asOwner);
              myImage = (HTMLImg) myConstruct.GetHTMLElement();
              myImage.SetAlt(m_asOwner.GetString(55, 
              //_ui_DescendingIconAlt
              "ptmsgs_infrastructure"));
              myImage.SetAlign("absmiddle");
              myAnchor.AddInnerHTMLElement(myImage);
            } else
            {
              myConstruct = UIConstructFactory.GetConstruct(PTImageType.ICON_ARROW_ASCEND,
               true, this.m_asOwner);
              myImage = (HTMLImg) myConstruct.GetHTMLElement();
              myImage.SetAlt(m_asOwner.GetString(54, 
              //_ui_AscendingIconAlt
              "ptmsgs_infrastructure"));
              myImage.SetAlign("absmiddle");
              myAnchor.AddInnerHTMLElement(myImage);
            }
          } else
          // JF- The list is currently NOT sorted by this column
          {
            // JF- We build the link to sort by this column
            myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
            // mj: removed 'Javascript:' from function name
            myAnchor.SetOnClick(((IExpListModelRO) m_model).GetUniqueString("SortBy") + "(\'" + oArrExpListColInfo[i][ExpListModel.EXPLIST_COLUMN_ID] + "\'); return false;");
            myCell.AddInnerHTMLElement(myAnchor);
            myAnchor.AddInnerHTMLString((String) oArrExpListColInfo[i][ExpListModel.EXPLIST_COLUMN_TITLE]);
            }
        } else
        // JF- The sort was not enabled, just print out the title
        // (we don't need to worry about the link or the arrows)
        {
          myCell.AddInnerHTMLString((String) oArrExpListColInfo[i][ExpListModel.EXPLIST_COLUMN_TITLE]);
          }
      }
      return myRow;
    }
  }
}