using System;
// Plumtree Server
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.admin.editors.crawler;
using com.plumtree.portalpages.admin.editors.doctypemap;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.resultwrapper;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.arraywrapper;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlconstructs;
namespace com.plumtree.portalpages.admin.editors.doctypemapextension
{
  /// <author>SudhaS</author>
  public class GbDocTypeExtModel : GbObjEditorModel,IGbDocTypeExtModelRO
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.doctypemapextension.GbDocTypeExtModel");
    public const String STR_MVC_CLASS_NAME = "GbDocTypeExtModel";
    protected String m_sSetting1;
    protected String m_sSetting2;
    protected String m_strDocTypeName = "";
    protected String m_strExtension = "";
    protected bool m_bAdded = false;
    protected bool m_bEdit = false;
    protected int m_nDocTypeID = -1;
    protected int m_nGbDocTypeSectionID = -1;
    protected int m_nGbDocTypeModelID = -1;
    protected int m_nRowIndex = -1;
    
    /// <summary>
    /// That method is called by the EditorStartControl.
    /// It creates the global object and puts it in m_ptGlobalObject.
    /// </summary>
    /// <param name="_htFormData"></param>
    /// <returns>boolean Is true if the current user has the rights to access this Editor.</returns>
    public override bool CheckEditorAccessAndStart(XPHashtable _htFormData)
    {
      // Set global object ID with values from QS.
      SetMemberVariablesFromQS(_htFormData);
      try
      {
        // JF- We open the Global Obejct with the ID provided in the QS.
        // check to see if this is editing the global document type map or the crawler document type map =mgs
        if (GbDocTypeEditorAS.STR_MVC_CLASS_NAME.Equals(m_asOwner.GetParentSpace().GetName()))
        {
          m_ptGlobalObject = m_Session.OpenGlobalObject(m_nGlobalObjectID,
           false);
        } else
        //not the global editor, open up this specific crawler's document type map
        {
          AActivitySpace myParentAS = m_asOwner.GetParentSpace();
          if (myParentAS is CrawlerEditorAS)
          {
            CrawlerEditorAS crawlerAS = (CrawlerEditorAS) myParentAS;
            CrawlerModel crawlerModel = (CrawlerModel) myParentAS.GetModel(crawlerAS.m_strModelName);
            m_ptGlobalObject = ((IPTCrawler) crawlerModel.GetObject()).GetDocumentTypeMap();
            }
        }
      }
      catch (Exception e)
      {
        log.Error(e, "GbObjEditorModel::StartEditor Unable to create Global Object with ID: " + m_nGlobalObjectID + ". The following exception occured: " + e.Message);
        throw new XPException(m_asOwner.GetString(152, 
        //_ui_CreateGlobalObjectError
        "ptmsgs_portalinfrastructure"), e);
      }
      String[] data = (String[]) _htFormData.GetElement(GbDocTypeListModel.CURRENTSECTION_ID);
      if (data != null)
      {
        m_nGbDocTypeSectionID = XPConvert.ToInteger(data[0]);
      }
      data = (String[]) _htFormData.GetElement(GbDocTypeListModel.DOCTYPE_ID);
      if (data != null)
      {
        m_nDocTypeID = XPConvert.ToInteger(data[0]);
      }
      data = (String[]) _htFormData.GetElement(GbDocTypeListModel.DOCTYPE_NAME);
      if (data != null)
      {
        m_strExtension = data[0];
      }
      data = (String[]) _htFormData.GetElement(GbDocTypeListModel.ROW_INDEX);
      if (data != null)
      {
        m_nRowIndex = XPConvert.ToInteger(data[0]);
        m_bEdit = true;
      }
      data = (String[]) _htFormData.GetElement(GbDocTypeListModel.CURRENTGBDOCTYPEMODEL_ID);
      if (data != null)
      {
        m_nGbDocTypeModelID = XPConvert.ToInteger(data[0]);
      }
      UpdateDocTypeHashTable();
      StartGbDocTypeExtList();
      DoTaskOnStartEditor(_htFormData);
      //StartSelectPTObject();
      //if (m_nActivityID != -1) RemoveAllGroups();
      return true;
    }
    private void UpdateDocTypeHashTable()
    {
      try
      {
        GbDocTypeEditorAS gbDocTypeEditorAS = (GbDocTypeEditorAS) m_asOwner.GetParentSpace();
        GbDocTypeListModel gbDocTypeListModel = (GbDocTypeListModel) gbDocTypeEditorAS.GetModel(GbDocTypeEditorAS.strStorageGbDocTypeList + m_nGbDocTypeModelID);
        IASQueryResult asqrDocTypes = gbDocTypeListModel.GetValidDocumentTypes(m_nGbDocTypeSectionID);
        XPHashtable htDocTypes = gbDocTypeListModel.GetDocTypeMappings(m_nGbDocTypeModelID);
        for (int i = 0;i < asqrDocTypes.GetCount();i++)
        {
          int nServerSavedObjID = XPConvert.ToInteger(asqrDocTypes.GetFields(i,
           PT_PROPIDS.PT_PROPID_OBJECTID));
          String strServerSavedObjName = XPConvert.ToString(asqrDocTypes.GetFields(i,
           PT_PROPIDS.PT_PROPID_NAME));
          if (!htDocTypes.ContainsKey(nServerSavedObjID))
          {
            gbDocTypeListModel.SetSingleDocTypeIDToNameMapping(strServerSavedObjName,
             nServerSavedObjID, m_nGbDocTypeModelID);
          }
        }
      }
      catch (Exception e)
      {
        log.Error("GbDocTypeExtModel " + e);
      }
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new GbDocTypeExtModel();
    }
    public override void DoTaskOnComeBackFromSubEditor()
    {
      IASQueryResult ptasqrValidDocTypes = null;
      try
      {
        ptasqrValidDocTypes = GetValidDocumentTypes(m_nGbDocTypeSectionID);
        }
      catch (Exception e)
      {
        log.Error("GbDocTypeExtModel : " + e);
      }
      bool bFound = false;
      if (ptasqrValidDocTypes != null)
      {
        PTGrowableSortedArrayWrapper aDocTypeList = ((GbDocTypeExtListModel) m_asOwner.GetModel(GbDocTypeExtEditorAS.strStorageGbDocTypeExtList)).GetItems();
        GbDocTypeExtListModel myGbDocTypeExtModel = (GbDocTypeExtListModel) m_asOwner.GetModel(GbDocTypeExtEditorAS.strStorageGbDocTypeExtList);
        for (int i = 0;i < ptasqrValidDocTypes.GetCount();i++)
        {
          if (!m_bAdded)
          {
            int nServerSavedObjID = XPConvert.ToInteger(ptasqrValidDocTypes.GetFields(i,
             PT_PROPIDS.PT_PROPID_OBJECTID));
            for (int j = 0;j < aDocTypeList.GetCount();j++)
            {
              if (!bFound)
              {
                int nArraySavedObjID = XPConvert.ToInteger(aDocTypeList.GetItem(j,
                 GbDocTypeExtListModel.EXPLIST_COL_DOCTYPEID));
                if (nArraySavedObjID == nServerSavedObjID)
                {
                  bFound = true;
                }
              }
            }
            if (!bFound)
            {
              Object[] oRow = new Object[GbDocTypeListModel.EXPLIST_COL_MAX];
              oRow[GbDocTypeExtListModel.EXPLIST_SORTEDARRAY_PROPID_INDEX] = myGbDocTypeExtModel.m_nNextIndex;
              myGbDocTypeExtModel.m_nNextIndex++;
              oRow[GbDocTypeExtListModel.EXPLIST_COL_DOCTYPENAME] = (String) ptasqrValidDocTypes.GetFields(i,
               PT_PROPIDS.PT_PROPID_NAME);
              oRow[GbDocTypeExtListModel.EXPLIST_COL_DOCTYPEID] = nServerSavedObjID;
              myGbDocTypeExtModel.AddRow(oRow);
              m_strDocTypeName = (String) ptasqrValidDocTypes.GetFields(i,
               PT_PROPIDS.PT_PROPID_NAME);
              m_bAdded = true;
            }
            bFound = false;
          }
        }
      }
    }
    public override void Finish()
    {
      // ***CHANGE_HERE*** Copy the code below to lock, sore and unlock the global object.
      try
      {
        Object[][] ptMappings;
        Object[][] oRows = null;
        ptMappings = (Object[][]) ((IPTDocumentTypeMap) base.m_ptGlobalObject).GetMappings(m_nGbDocTypeSectionID);
        if (!m_bEdit)
        {
          // ***CHANGE_HERE*** Put the code here to set the new settings on the Global Object, before you sore it.
          oRows = new Object[2][];
          for (int j2c_index = 0;j2c_index < 2;j2c_index++)
          {
            oRows[j2c_index] = new Object[ptMappings[0].Length + 1];
          }
          for (int i = 0;i < ptMappings[0].Length;i++)
          {
            oRows[0][i] = ptMappings[0][i];
            oRows[1][i] = ptMappings[1][i];
          }
          oRows[0][ptMappings[0].Length] = m_strExtension;
          oRows[1][ptMappings[0].Length] = m_nDocTypeID;
          m_nRowIndex = ptMappings[0].Length;
        } else
        {
          oRows = new Object[2][];
          for (int j2c_index = 0;j2c_index < 2;j2c_index++)
          {
            oRows[j2c_index] = new Object[ptMappings[0].Length];
          }
          for (int i = 0;i < ptMappings[0].Length;i++)
          {
            oRows[0][i] = ptMappings[0][i];
            oRows[1][i] = ptMappings[1][i];
          }
          oRows[0][m_nRowIndex] = m_strExtension;
          oRows[1][m_nRowIndex] = m_nDocTypeID;
        }
        IPTServerContext ptscDocTypeMap;
        ptscDocTypeMap = (IPTServerContext) ((IPTDocumentTypeMap) m_ptGlobalObject).GetInterfaces("IPTServerContext");
        //only lock this object if editing the global document type map, if editing a crawler doc type map, the doc type object doesn't need to be locked -mgs
        if (GbDocTypeEditorAS.STR_MVC_CLASS_NAME.Equals(m_asOwner.GetParentSpace().GetName()))
        {
          ptscDocTypeMap.LockObject();
        }
        ((IPTDocumentTypeMap) m_ptGlobalObject).SetMappings(m_nGbDocTypeSectionID,
         oRows);
        if (GbDocTypeEditorAS.STR_MVC_CLASS_NAME.Equals(m_asOwner.GetParentSpace().GetName()))
        {
          ptscDocTypeMap.Store();
          ptscDocTypeMap.UnlockObject();
        }
      }
      catch (Exception e)
      {
        log.Error("GbDocTypeExtModel : " + e);
      }
    }
    //ResetInputs();
    
    /// <returns></returns>
    public virtual int GetDocTypeID()
    {
      return m_nDocTypeID;
    }
    
    /// <returns></returns>
    public virtual String GetDocTypeName()
    {
      return m_strDocTypeName;
    }
    
    /// <returns></returns>
    public virtual String GetExtName()
    {
      return m_strExtension;
    }
    
    /// <returns></returns>
    public virtual bool GetIsAdded()
    {
      return m_bAdded;
    }
    
    /// <returns></returns>
    public virtual bool GetIsEdit()
    {
      return m_bEdit;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual int GetRow()
    {
      return m_nRowIndex;
    }
    
    /// <param name="_nSectionID"></param>
    /// <returns></returns>
    /// <throws>Exception</throws>
    /// <throws>XPException</throws>
    public virtual IASQueryResult GetValidDocumentTypes(int _nSectionID)
    {
      IPTQueryResult qrDocTypes;
      try
      {
        qrDocTypes = ((IPTDocumentTypeMap) base.m_ptGlobalObject).GetValidDocumentTypes(_nSectionID);
        }
      catch (Exception e)
      {
        log.Error("GbDocTypeModel::GetValidDocumentTypes Unable to get document types from Document Type Map." + " The following exception occured: " + e);
        throw new XPException(m_asOwner.GetString(347, "ptmsgs_portaladminmsgs"),
         e);
      }
      return (new ASQueryResultWrapper(qrDocTypes));
    }
    
    /// <param name="_htFormData"></param>
    /// <returns></returns>
    public virtual int SaveMainPage(XPHashtable _htFormData)
    {
      String[] data;
      data = (String[]) _htFormData.GetElement(GbDocTypeExtDP.HTMLHIDDEN_POPUP_NAME);
      if (data != null)
      {
        data = (String[]) _htFormData.GetElement(GbDocTypeExtListView.HTMLRADIOBTN_SELECT);
        }
      if (data != null)
      {
        m_nDocTypeID = XPConvert.ToInteger(data[0]);
      }
      data = (String[]) _htFormData.GetElement(GbDocTypeExtView.HTMLINPUT_CREATE_EXT);
      if (data != null)
      {
        m_strExtension = data[0];
      }
      return RepostControl.PAGE_STATUS_VALID;
    }
    
    /// <summary>
    /// Calls the right save function according to the page name passed in argument.
    /// </summary>
    /// <param name="_sPageName"></param>
    /// <param name="_htFormData"></param>
    /// <returns>int Page status for server side validation</returns>
    public override int SavePage(String _sPageName, XPHashtable _htFormData)
    {
      if (_sPageName.Equals(GbDocTypeExtDP.STR_MVC_CLASS_NAME))
      {
        // ***EXAMPLE*** Server validation - get back the status from SaveMainPage
        SaveMainPage(_htFormData);
      }
      //} else if (_sPageName.equals(DevicesDP.STR_MVC_CLASS_NAME)) {
      //	nPageStatus = SaveDevicesPage(_htFormData);
      return RepostControl.PAGE_STATUS_VALID;
    }
    
    /// <param name="_bAdded"></param>
    public virtual void SetAdded(bool _bAdded)
    {
      m_bAdded = _bAdded;
    }
    
    /// <param name="_bEdit"></param>
    public virtual void SetEdit(bool _bEdit)
    {
      m_bEdit = _bEdit;
    }
    protected virtual void StartGbDocTypeExtList()
    {
      GbDocTypeExtListModel myGbDocTypeExtModel = (GbDocTypeExtListModel) m_asOwner.GetModel(GbDocTypeExtEditorAS.strStorageGbDocTypeExtList);
      // ***CHANGE_HERE SELECTPTOBJECT*** Initialize the Select PTObject list.
      //      _sSectionTitle: Main title.
      //      _sSectionSubTitle: Sub title.
      //      _imgAddIcon: Icon for the add action.
      //      _sAddLabel: Text to display next to the add icon.
      //      _arrObjectClassIDs Class ID of the Objects displayed on the list.
      //      _nListKey: In case you have multiple Expandable Lists on
      //                 the same DP, they should have a different key
      //                 (otherwise, just set it to 1).
      myGbDocTypeExtModel.InitializeGbDocTypeExtList(m_asOwner.GetString(341,
       "ptmsgs_portaladminmsgs"), m_asOwner.GetString(342, "ptmsgs_portaladminmsgs"),
       PTImageType.ICON_DOCUMENT_TYPE, m_asOwner.GetString(343, "ptmsgs_portaladminmsgs"),
       1);
      // ***CHANGE_HERE SELECTPTOBJECT*** Optional setting
      //     Use the method bellow to set the icon to display on each row.
      //     (By default there will be no icon.)
      //myGbDocTypeModel.SetRowIcon(PTImageType.ICON_ADD_GROUP);
      IASQueryResult ptasqrValidDocTypes = null;
      try
      {
        ptasqrValidDocTypes = GetValidDocumentTypes(m_nGbDocTypeSectionID);
        }
      catch (Exception e)
      {
        log.Error("GbDocTypeExtModel : " + e);
      }
      // JF- The 2 lines below are only needed if you are going to enable the move row actions
      if (ptasqrValidDocTypes != null)
      {
        Object[][] oRows = new Object[ptasqrValidDocTypes.GetCount()][];
        for (int j2c_index = 0;j2c_index < ptasqrValidDocTypes.GetCount();
        j2c_index++)
        {
          oRows[j2c_index] = new Object[GbDocTypeExtListModel.EXPLIST_COL_MAX];
          }
        for (int i = 0;i < ptasqrValidDocTypes.GetCount();i++)
        {
          oRows[i][GbDocTypeExtListModel.EXPLIST_SORTEDARRAY_PROPID_INDEX] = myGbDocTypeExtModel.m_nNextIndex;
          myGbDocTypeExtModel.m_nNextIndex++;
          oRows[i][GbDocTypeExtListModel.EXPLIST_COL_DOCTYPENAME] = (String) ptasqrValidDocTypes.GetFields(i,
           PT_PROPIDS.PT_PROPID_NAME);
          oRows[i][GbDocTypeExtListModel.EXPLIST_COL_DOCTYPEID] = ptasqrValidDocTypes.GetFields(i,
           PT_PROPIDS.PT_PROPID_OBJECTID);
        }
        myGbDocTypeExtModel.SetDefaultObjects(oRows);
      }
    }
  }
}