using System;
// Framework Imports
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.doctypemapextension
{
  /// <author>SudhaS</author>
  public class GbDocTypeExtView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.doctypemapextension.GbDocTypeExtView");
    public const String STR_MVC_CLASS_NAME = "GbDocTypeExt";
    public const String HTMLINPUT_CREATE_EXT = "in_tx_CreateExt";
    private const String CREATE_EXT_SIZE = "45";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new GbDocTypeExtView();
    }
    
    /// <returns></returns>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTableCell myCell;
      HTMLTableRow myRow;
      HTMLInput myInput;
      try
      {
        result.AddInnerHTMLElement(base.GetHeaderView(m_asOwner.GetString(348,
         "ptmsgs_portaladminmsgs")));
        HTMLTable myTable = new HTMLTable();
        result.AddInnerHTMLElement(myTable);
        myTable.SetWidth("100%");
        myTable.SetBorder("0");
        myTable.SetCellPadding("5");
        myTable.SetCellSpacing("0");
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myCell.SetWidth("15%");
        myRow.AddInnerHTMLElement(myCell);
        myCell.AddInnerHTMLString(m_asOwner.GetString(350, "ptmsgs_portaladminmsgs"));
        myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
        //myCell.SetColSpan("3");
        myRow.AddInnerHTMLElement(myCell);
        myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_CREATE_EXT,
         "This is an input");
        myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
        myInput.SetValue(((IGbDocTypeExtModelRO) m_model).GetExtName());
        myInput.SetSize(CREATE_EXT_SIZE);
        myCell.AddInnerHTMLElement(myInput);
      }
      catch (Exception e)
      {
        log.Error(e, "GbDocTypeExtView::Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(349, "ptmsgs_portaladminmsgs"),
         e);
      }
      return result;
    }
    
    /// <returns></returns>
    public override HTMLScript DisplayJavascript()
    {
      HTMLScript myScript;
      // ***CHANGE_HERE*** Write all the JavaScripts for that Section bellow.
      // ***COMMENT_1*** Note that you also need to call that method from the
      //       DP (see PropMainDP)
      // ***COMMENT_2*** Put all your JavaScripts bellow (validation or no) they
      //       will be printed out in the header.
      // ***COMMENT_3*** If that Section doesn't have any JavaScripts,
      //      you can delete the entire DisplayJavascript() method.
      // ***COMMENT_4*** If this is a client side validation, you should use
      //      the AddToValidationFunction in your AS class (see PropEditorAS).
      try
      {
        XPStringBuilder sb = new XPStringBuilder(300);
        myScript = new HTMLScript("text/javaScript");
        sb.Append("function CheckBlankExtension()\n");
        sb.Append("{\n");
        sb.Append("  if (document." + EditorDP.HTMLFORM_NAME + "." + HTMLINPUT_CREATE_EXT + ".value.length == 0)\n");
        sb.Append("  {\n");
        sb.Append("      alert(\"" + m_asOwner.GetString(1817, "ptmsgs_portaladminmsgs") + "\");\n");
        sb.Append("      return false;\n");
        sb.Append("  }\n");
        sb.Append("  return true;\n");
        sb.Append("}\n");
        myScript.AddInnerHTMLString(sb.ToString());
      }
      catch (Exception e)
      {
        log.Error(e, "LoginView::DisplayJavascript The following error occured when trying to display the JavaScript: " + e.Message);
        throw XPException.GetInstance(e);
      }
      return (myScript);
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}