using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.openlog;
using com.plumtree.portalpages.admin.editors.common.setjob;
using com.plumtree.portalpages.common.constants;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.editor.commonpages.localizednames;
using com.plumtree.portaluiinfrastructure.editor.commonpages.migrationhistory;
using com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity;
using com.plumtree.portaluiinfrastructure.expandablelist.selectptobject;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.uiinfrastructure.tips;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.externaloperations
{
  /// <author>OlegS</author>
  public class ExternalOperationEditorAS : ObjEditorAS
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.externaloperations.ExternalOperationEditorAS");
    public const String STR_MVC_CLASS_NAME = "ExternalOperationEditor";
    private const String sClassName = "com.plumtree.portalpages.admin.editors.externaloperations.ExternalOperationEditorAS";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new ExternalOperationEditorAS();
    }
    
    /// <returns></returns>
    public override String GetEditorTitle()
    {
      if (EditorStartControl.EDITOR_START_FLAG_CREATE == ((EditorModel) GetModel(m_strModelName)).GetEditorType())
      {
        return (GetString(2606, "ptmsgs_portaladminmsgs"));
      } else
      {
        return (XPResourceManager.FormatMessage(GetString(2607, "ptmsgs_portaladminmsgs"),
         GetObjectName()));
      }
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public override String GetRepostControlName()
    {
      return (ExternalOperationEditorRepostControl.STR_MVC_CLASS_NAME);
    }
    public override void Init()
    {
      m_strModelName = ExternalOperationEditorModel.STR_MVC_CLASS_NAME;
      base.Init();
      RegisterView(ExternalOperationDependenciesView.STR_MVC_CLASS_NAME, GetModel(m_strModelName));
      // Register plug-in sections
      RegisterPage(new SetJobDP());
      // Register classes for the set job and for the object owner
      RegisterModel(SetJobModel.STR_MVC_CLASS_NAME);
      RegisterControl(SetJobRepostControl.STR_MVC_CLASS_NAME, GetModel(SetJobModel.STR_MVC_CLASS_NAME));
      RegisterView(ObjectOwnerView.STR_MVC_CLASS_NAME, GetModel(SetJobModel.STR_MVC_CLASS_NAME));
      // Register classes for Job selector
      RegisterModel(SelectPTObjectModel.STR_MVC_CLASS_NAME, SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB);
      RegisterView(SelectPTObjectView.STR_MVC_CLASS_NAME, SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB,
       GetModel(SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB));
      RegisterControl(ExpListControl.STR_MVC_CLASS_NAME, SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB,
       GetModel(SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB));
      // external operation stuff
      IModel myModel = GetModel(ExternalOperationEditorModel.STR_MVC_CLASS_NAME);
      AFormDP mainDP = new ExternalOperationEditorMainDP();
      RegisterPage(mainDP);
      RegisterView(ExternalOperationEditorMainView.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(ExternalOperationEditorRepostControl.STR_MVC_CLASS_NAME,
       myModel);
      SetCurrentPage(ExternalOperationEditorMainDP.STR_MVC_CLASS_NAME);
      // Set left nav menu
      int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(1823, "ptmsgs_portaladminmsgs"));
      m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, ExternalOperationEditorMainDP.STR_MVC_CLASS_NAME);
      m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, SetJobDP.STR_MVC_CLASS_NAME);
      // BEGIN Sub menu "Additional Settings"
      int nMenuTwoID = m_mEditorMenu.StartNewSubMenu(GetString(1824, "ptmsgs_portaladminmsgs"));
      //Properties and Names
      m_mEditorMenu.AddLinkToSubMenu(nMenuTwoID, LocNamesDP.STR_MVC_CLASS_NAME);
      //Security
      m_mEditorMenu.AddLinkToSubMenu(nMenuTwoID, ObjectSecurityDP.STR_MVC_CLASS_NAME);
      //Migration History
      m_mEditorMenu.AddLinkToSubMenu(nMenuTwoID, MigrationHistoryPluginDP.STR_MVC_CLASS_NAME);
      // END Sub menu "Additional Settings"
      // for clisent-side validation
      // JHQ ExtOpRedesign: we no longer use the RunAsUser/RunAsUserPassword
      //		mainDP.AddToValidationFunction("CheckPassword");
      //	TIPS
      TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);
      if (tm != null)
      {
        try
        {
          tm.SetGeneratingClass(sClassName);
          int iTitleId = 108;
          int iTipId = 109;
          int iSecondaryTipId = 110;
          tm.SetTipTitle(this.GetString(iTitleId, ResourceConstants.TIPS));
          HTMLGenericElement e = new HTMLGenericElement(this.GetString(iTipId,
           ResourceConstants.TIPS));
          tm.SetTip(e);
          String sSecondary = this.GetString(iSecondaryTipId, ResourceConstants.TIPS);
          if (!("none_do_not_translate".Equals(sSecondary)))
          {
            e = new HTMLGenericElement(sSecondary);
            tm.SetSecondarTip(e);
          }
        }
        catch (Exception ex)
        {
          log.Error(ex, "Couldn\'t generate tip.");
        }
      }
    }
    //	Got the tips model
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor#GetDependenciesViewName()"></seealso>
    public override String GetDependenciesViewName()
    {
      return (ExternalOperationDependenciesView.STR_MVC_CLASS_NAME);
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage()"></seealso>
    /// <param name="IDisplayPage">the current Display Page</param>
    public override void SetCurrentPage(IDisplayPage page)
    {
      base.SetCurrentPage(page);
      String sPageName = page.GetName();
      if (SetJobDP.STR_MVC_CLASS_NAME.Equals(sPageName))
      {
        SetHelpTopic("PT_SetJob");
      } else
      if (ExternalOperationEditorMainDP.STR_MVC_CLASS_NAME.Equals(sPageName))
      {
        SetHelpTopic("PT_ExternalOperation_MainSettings");
      }
    }
  }
}