using System;
using com.plumtree.openfoundation.web;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.externaloperations
{
  /// <author>OlegS</author>
  public class ExternalOperationEditorMainDP : EditorDP
  {
    public const String STR_MVC_CLASS_NAME = "ExternalOperationEditorMain";
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(356, "ptmsgs_portaladminmsgs");
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    /// <throws>HTMLException</throws>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      result.AddInnerHTMLElement(base.PageDisplay());
      HTMLElementCollection views = new HTMLElementCollection();
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(ExternalOperationEditorMainView.STR_MVC_CLASS_NAME)).Display());
      result.AddInnerHTMLElement(CreateLeftNavBar(views));
      return result;
    }
    
    /// <returns></returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(ExternalOperationEditorMainView.STR_MVC_CLASS_NAME).DisplayJavascript());
      return myScripts;
    }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      //m_asOwner.GetString(1678, "ptmsgs_portaladminmsgs");
      String s = m_asOwner.GetString(2684, "ptmsgs_portaladminmsgs");
      s = XPHttpUtility.HtmlEncode(s);
      //fixing bug 21946 where {br} tags were not being replaced;  TODO This is really bad style and needs to be cleaned up.  
      //These strings need to be broken up and reformatted. -mgs
      s = GeneralHelpers.Replace(s, "{", "<");
      // there are {br} in the string which we want as <br>
      s = GeneralHelpers.Replace(s, "}", ">");
      return HTMLConstructHelpers.GetSubHeader(s, this.m_asOwner);
    }
  }
}