using System;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.admin.editors.externaloperations
{
  /// <summary>
  /// JHQ 050604: External Operations have been re-architected to run script files instead of 
  /// commands from the command line.  These scripts must reside in the automation server's
  /// portal_home/scripts directory.  This directory can be secured as necessary.  Therefore,
  /// we no longer use the RunAsUser/RunAsUserPassword.  Corresponding methods will be 
  /// deprecated and should not be implemented.
  /// </summary>
  /// <author>OlegS</author>
  public interface IExternalOperationEditorModelRO : IEditorModelRO
  {
    
    /// <returns></returns>
    String GetCommandLine();
    
    /// <returns></returns>
    /// <deprecated>This method should not be implemented.</deprecated>
    String GetPasswordToDisplay();
    
    /// <returns></returns>
    int GetTimeout();
    
    /// <returns></returns>
    /// <deprecated>This method should not be implemented.</deprecated>
    String GetUser();
  }
}