using System;
// Framework Imports
using com.plumtree.portaluiinfrastructure.editor;
namespace com.plumtree.portalpages.admin.editors.filter
{
  /// <author>MikeS</author>
  public class FilterRepostControl : ObjEditorRepostControl
  {
    public const String STR_MVC_CLASS_NAME = "FilterRepost";
    public const int POSTTOSELF_ACTION_TEST_FILTER = 13;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new FilterRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call
    /// the associated method for each action.
    /// </summary>
    /// <param name="_nAction"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      switch (_nAction){
      case FilterRepostControl.POSTTOSELF_ACTION_GOTOPAGE:
      case FilterRepostControl.POSTTOSELF_ACTION_FINISH:
      case FilterRepostControl.POSTTOSELF_ACTION_SIMPLEREPOST:
      break;
      case POSTTOSELF_ACTION_TEST_FILTER:
      FilterModel model = (FilterModel) m_asOwner.GetModel(FilterModel.STR_MVC_CLASS_NAME);
      model.SetTestFilterArgs(m_htFormData);
      break;
      }
    }
  }
}