using System;
// Framework Imports
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.common.search;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.filter
{
  /// <author>MikeS</author>
  public class SettingsView : FilterView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.filter.SettingsView");
    public const String STR_MVC_CLASS_NAME = "FilSettings";
    public const String TEST_FILTER_FXN_NAME = "testFilter";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SettingsView();
    }
    public override bool QueryContainsValidationProblemsOnRender()
    {
      HTMLElement throwaway = Display();
      throwaway.ClearInnerHTMLElements();
      return base.QueryContainsValidationProblemsOnRender();
    }
    public SettingsView() : base()
    {
      SetAddTestButton();
      DoSetTestButtonScript();
    }
    public override HTMLElement Display()
    {
      try
      {
        SetStatementCount(5);
        base.SetViewTitle(m_asOwner.GetString(378, "ptmsgs_portaladminmsgs"));
        return base.Display();
      }
      catch (Exception e)
      {
        log.Error(e, "SettingsView::Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(379, "ptmsgs_portaladminmsgs"),
         e);
      }
    }
    
    /// <returns></returns>
    public override HTMLScript DisplayJavascript()
    {
      base.SetRepostAction(FilterRepostControl.POSTTOSELF_ACTION_SIMPLEREPOST);
      return base.DisplayJavascript();
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    protected virtual void DoSetTestButtonScript()
    {
      SetTestButtonOnClickScript(TEST_FILTER_FXN_NAME + "();");
      String val = "function " + TEST_FILTER_FXN_NAME + "() {\n";
      val+="    postToSelf(" + FilterRepostControl.POSTTOSELF_ACTION_TEST_FILTER + ");\n";
      val+="}\n";
      SetTestButtonScript(val);
    }
  }
}