using System;
// Framework Imports
using com.plumtree.openfoundation.internationalization;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.search;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.filter
{
  /// <author>MatthewF</author>
  public class TestFilterView : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.filter.TestFilterView");
    public const String STR_MVC_CLASS_NAME = "TestFilterView";
    private FilterModel _model;
    private AActivitySpace m_asOwner;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new TestFilterView();
    }
    public virtual HTMLElement Display()
    {
      try
      {
        HTMLElementCollection result = new HTMLElementCollection();
        FilterModel.FilterReport report = _model.GetTestFilterReport();
        if (report == null)
        {
          return result;
        }
        // Don't leave report generation on.
        _model.TurnOffFilterReport();
        HTMLTable table = new HTMLTable();
        result.AddInnerHTMLElement(table);
        table.SetWidth("100%");
        table.SetCellSpacing("0");
        table.SetCellPadding("0");
        table.SetBorder("0");
        HTMLTableRow row = new HTMLTableRow();
        table.AddInnerHTMLElement(row);
        row.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);
        HTMLTableCell cell = new HTMLTableCell();
        row.AddInnerHTMLElement(cell);
        cell.SetWidth("100%");
        cell.SetHeight("20");
        cell.SetVAlign("middle");
        cell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        HTMLSpan span = new HTMLSpan();
        cell.AddInnerHTMLElement(span);
        span.AddInnerHTMLString(m_asOwner.GetString(2667, "ptmsgs_portaladminmsgs"));
        span.SetStyleClass(PTStyleClass.OBJECT_HEADER);
        row = new HTMLTableRow();
        row.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        table.AddInnerHTMLElement(row);
        cell = new HTMLTableCell();
        cell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        row.AddInnerHTMLElement(cell);
        String report_summary;
        if (!report.threwException)
        {
          report_summary = XPResourceManager.FormatMessage(m_asOwner.GetString(2601,
           "ptmsgs_portaladminmsgs"), XPConvert.ToString(report.numResults));
          if (report.numResults == 0)
          {
            report_summary+=m_asOwner.GetString(2602, "ptmsgs_portaladminmsgs");
            }
          cell.AddInnerHTMLString(report_summary);
        } else
        {
          report_summary = m_asOwner.GetString(2603, "ptmsgs_portaladminmsgs");
          cell.AddInnerHTMLString(report_summary);
          HTMLB b = new HTMLB();
          b.AddInnerHTMLString(report.exceptionMessage);
          cell.AddInnerHTMLElement(b);
        }
        result.AddInnerHTMLElement(SearchUIUtility.makeSpacer(m_asOwner, "10"));
        return result;
      }
      catch (Exception e)
      {
        log.Error(e, "TestFilterView::Display The following error occured when trying to display the HTML: " + e.Message);
        }
      return null;
    }
    
    /// <returns></returns>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    public virtual void Init(IModelRO model, AActivitySpace space)
    {
      _model = (FilterModel) model;
      m_asOwner = space;
    }
    
    /// <returns></returns>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}