using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.tree;
namespace com.plumtree.portalpages.admin.editors.group
{
  /// <summary>
  /// This version of the tree allows for browsing and
  /// selecting of objects with no hierarchical structure
  /// </summary>
  /// <author>RickyW</author>
  public class ActivityRightsTreeAS : ATreeAS
  {
    
    /// <summary>
    /// object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "ActivityRightsTree";
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IPTActivitySpace#CheckBasicAccess(String,String,boolean)"></seealso>
    public override bool CheckBasicAccess(String strPage, String strControl,
     bool bSameSpace)
    {
      return true;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new ActivityRightsTreeAS();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AActivitySpace#Init()"></seealso>
    public override void Init()
    {
      base.Init();
      RegisterModel(ActivityRightsTreeModel.STR_MVC_CLASS_NAME, TREEMODEL);
      IModel myModel = GetModel(TREEMODEL);
      RegisterView(TreeView.STR_MVC_CLASS_NAME, myModel);
      RegisterView(TreeBarView.STR_MVC_CLASS_NAME, TreeDP.TREE_BAR_STORAGE_NAME,
       myModel);
      RegisterControl(ActivityRightsStartTreeControl.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(TreeRepostControl.STR_MVC_CLASS_NAME, myModel);
    }
  }
}