/*
 * Created on Dec 8, 2004
 */
 
using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using SelectPTObjectModel=com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.group
{
  /// <author>AkashJ</author>
  public class DynamicMembersPreviewView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.group.DynamicMembersPreviewView");
    public const String STR_MVC_CLASS_NAME = "DynamicMembersPreview";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new DynamicMembersPreviewView();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Display()"></seealso>
    public override HTMLElement Display()
    {
      // SE: logging
      log.FunctionBegin("DynamicMembersPreviewView::Display");
      SelectPTObjectModel myMemberSelectPTObjectModel = (SelectPTObjectModel) this.m_asOwner.GetModel(GroupEditorAS.strStorageDynMemberPreviewPopup);
      if (null != myMemberSelectPTObjectModel)
      {
        log.Debug("Current number of items in GroupEditorAS.strStorageDynMemberPreviewPopup: " + myMemberSelectPTObjectModel.GetItems().GetCount());
        }
      HTMLElementCollection result = new HTMLElementCollection();
      // aj: set title of this section
      String sViewTitle = m_asOwner.GetString(2714, "ptmsgs_portaladminmsgs");
      result.AddInnerHTMLElement(GetHeaderView(sViewTitle));
      HTMLTable myTable = new HTMLTable();
      myTable.SetWidth("100%");
      myTable.SetCellPadding("5");
      myTable.SetCellSpacing("0");
      myTable.SetBorder("0");
      result.AddInnerHTMLElement(myTable);
      HTMLTableRow myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
      HTMLTableCell myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetColSpan("2");
      myCell.SetHeight("20");
      myCell.SetNoWrap(true);
      // aj: "Preview Members" button, should call
      //      OpenPreviewMembersPopup() which will 
      //      call PostToSelf() as appropriate...
      HTMLInput myInput = new HTMLInput(HTMLInputTypes.BUTTON, "in_bu_previewmembers",
       m_asOwner.GetString(2715, "ptmsgs_portaladminmsgs"));
      myCell.AddInnerHTMLElement(myInput);
      myInput.SetValue(m_asOwner.GetString(2715, "ptmsgs_portaladminmsgs"));
      myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
      myInput.SetOnClick("OpenPreviewMembersPopup(); return false;");
      // SE: logging
      log.FunctionEnd("DynamicMembersPreviewView::Display");
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    public override HTMLScript DisplayJavascript()
    {
      HTMLScript myScript = new HTMLScript("text/javascript");
      XPStringBuilder sb = new XPStringBuilder(200);
      sb.Append("function OpenPreviewMembersPopup()\n");
      sb.Append("{\n");
      sb.Append("\tpostToSelf(");
      sb.Append(GroupRepostControl.POSTTOSELF_ACTION_PREVIEW_DYNAMIC_MEMBERS);
      sb.Append(");\n");
      sb.Append("}\n");
      myScript.AddInnerHTMLString(sb.ToString());
      return myScript;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}