using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.common.search;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.group
{
  /// <summary>
  /// This View is a hack of the SavSrchSettingView by MikeS.
  /// </summary>
  /// <author>AkashJ</author>
  public class DynamicRulesView : FilterView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.group.DynamicRulesView");
    
    /// <summary>
    /// The unique identifier for the class 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "DynamicRules";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new DynamicRulesView();
    }
    
    /// <summary>
    /// Display for the HTML for this view
    /// </summary>
    /// <returns>HTMLElement</returns>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      try
      {
        // aj: we need to suppress the search box, so tell FilterView (our parent) not
        //     to show it...
        base.SetShowSearchBox(false);
        base.SetViewTitle(m_asOwner.GetString(2713, "ptmsgs_portaladminmsgs"));
        result.AddInnerHTMLElement(base.Display());
      }
      catch (Exception e)
      {
        log.Error(e, "DynamicRulesView::Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(779, "ptmsgs_portaladminmsgs"),
         e);
      }
      return result;
    }
    public override HTMLScript DisplayJavascript()
    {
      HTMLScript script = null;
      try
      {
        base.SetRepostAction(GroupRepostControl.POSTTOSELF_ACTION_SIMPLEREPOST);
        script = base.DisplayJavascript();
      }
      catch (Exception e)
      {
        log.Error(e, "DynamicRulesView::Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(779, "ptmsgs_portaladminmsgs"),
         e);
      }
      return script;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the read-only model
    /// </summary>
    /// <returns>IGroupModelRO</returns>
    protected virtual IGroupModelRO GetModel()
    {
      return (IGroupModelRO) m_model;
    }
  }
}