using System;
// Server import
using com.plumtree.portalpages.common.helpers;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.expandablelist.selectptobject;
using com.plumtree.portaluiinfrastructure.opener;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.arraywrapper;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.group
{
  /// <summary>
  /// This Section contains the HTML for the dependencies page.
  /// </summary>
  /// <author></author>
  public class GroupDependenciesView : ObjDependenciesView
  {
    //Member variables
    private CreatedHelper m_chHelper = null;
    
    /// <summary>
    /// Class name for the activity space 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "GroupDependencies";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new GroupDependenciesView();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(com.plumtree.uiinfrastructure.activityspace.IModelRO,com.plumtree.uiinfrastructure.activityspace.AActivitySpace)"></seealso>
    public override void Init(IModelRO model, AActivitySpace parent)
    {
      base.Init(model, parent);
      m_chHelper = new CreatedHelper(parent, (GroupModel) model);
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.ObjDependenciesView#GetHTMLForDependencies()"></seealso>
    protected override HTMLElementCollection GetHTMLForDependencies()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      //Display the standard success message
      m_chHelper.displaySuccessMessage(result, m_asOwner.GetString(2204, "ptmsgs_portaladminmsgs"),
       ((ObjEditorModel) m_model).GetObjectName(), ((ObjEditorModel) m_model).GetParentFolderPath());
      SelectActivityRightsModel mySelectActivityRightsModel = ((SelectActivityRightsModel) m_asOwner.GetModel(GroupEditorAS.strStorageSelectActivityRights));
      PTGrowableSortedArrayWrapper arrRights = mySelectActivityRightsModel.GetItems();
      //If there are no activity rights, warn the user and provide a link back to the group editor
      if (null == arrRights || arrRights.GetCount() == 0)
      {
        m_chHelper.displayTextRow(result, m_asOwner.GetString(2205, "ptmsgs_portaladminmsgs"),
         null);
        m_chHelper.beginList(result);
        String strArgs = null;
        strArgs = strArgs + "&" + ASConstants.PAGE + "=" + GroupActivityRightsDP.STR_MVC_CLASS_NAME;
        m_chHelper.displayListRow(PlumtreeHelpers.MakeCreateObjectLink(PT_CLASSIDS.PT_USERGROUP_ID,
         null, ((GroupModel) m_model).GetObjectID(), m_asOwner.GetString(2206,
         "ptmsgs_portaladminmsgs"), m_asOwner, IPTOpenerConstants.OPENER_MODE_EDIT,
         strArgs, true));
      } else
      {
        //Text: The following rights have been assigned to this group:
        m_chHelper.displayTextRow(result, m_asOwner.GetString(2207, "ptmsgs_portaladminmsgs"),
         null);
        //Start a list of activity rights
        m_chHelper.beginList(result);
        for (int i = 0;i < arrRights.GetCount();i++)
        {
          m_chHelper.displayListRow((String) arrRights.GetItem(i, SelectActivityRightsModel.EXPLIST_COL_STRING));
          }
      }
      SelectPTObjectModel mySelectPTObjectModel = (SelectPTObjectModel) m_asOwner.GetModel(GroupEditorAS.strStorageMemberSelectPTObject);
      PTGrowableSortedArrayWrapper arrMembers = mySelectPTObjectModel.GetItems();
      //If there are no members, warn the user and provide a link back to the group editor
      if (null == arrMembers || arrMembers.GetCount() == 0)
      {
        m_chHelper.displayTextRow(result, m_asOwner.GetString(2208, "ptmsgs_portaladminmsgs"),
         null);
        m_chHelper.beginList(result);
        String strArgs = null;
        strArgs = strArgs + "&" + ASConstants.PAGE + "=" + GroupMainSettingsDP.STR_MVC_CLASS_NAME;
        m_chHelper.displayListRow(PlumtreeHelpers.MakeCreateObjectLink(PT_CLASSIDS.PT_USERGROUP_ID,
         null, ((GroupModel) m_model).GetObjectID(), m_asOwner.GetString(2209,
         "ptmsgs_portaladminmsgs"), m_asOwner, IPTOpenerConstants.OPENER_MODE_EDIT,
         strArgs, true));
      }
      return result;
    }
  }
}