using System;
using OpenLogService=com.plumtree.openlog.OpenLogService;
using OpenLogger=com.plumtree.openlog.OpenLogger;
using com.plumtree.portalpages.common.constants;
using SelectPTObjectModel=com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel;
using PTDebugHelpers=com.plumtree.portaluiinfrastructure.statichelpers.PTDebugHelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.group
{
  public class GroupDynamicMembersPreviewPopupDP : AFormDP
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.group.GroupDynamicMembersPreviewPopupDP");
    
    /// <summary>
    /// Class name for the activity space
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "GroupDynamicMembersPreviewPopup";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new GroupDynamicMembersPreviewPopupDP();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public override void Init(AActivitySpace parent)
    {
      base.Init(parent);
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()
     */
     
    public override String GetFormTitle()
    {
      return m_asOwner.GetString(3182, ResourceConstants.PORTALADMINMSGS);
      }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()
     */
     
    public override HTMLElement PageDisplay()
    {
      // SE: logging
      log.FunctionBegin("GroupDynamicMembersPreviewPopupDP::PageDisplay");
      SelectPTObjectModel myMemberSelectPTObjectModel = (SelectPTObjectModel) this.GetOwner().GetModel(GroupEditorAS.strStorageDynMemberPreviewPopup);
      if (null != myMemberSelectPTObjectModel)
      {
        log.Debug("Current number of items in GroupEditorAS.strStorageDynMemberPreviewPopup: " + myMemberSelectPTObjectModel.GetItems().GetCount());
        }
      log.Debug("Space name: " + m_asOwner.GetName() + ", Space ID: " + m_asOwner.GetSpaceID() + ", Parent Space Name: " + m_asOwner.GetParentSpaceName() + ", Parent Space ID: " + m_asOwner.GetParentSpaceID());
      HTMLElementCollection result = new HTMLElementCollection();
      result.AddInnerHTMLElement(ExpListView.GetHiddenInputsForPagination());
      // aj: add the preview list
      result.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(GroupEditorAS.strStorageDynMemberPreviewPopup)).Display());
      // SE: logging
      log.FunctionEnd("GroupDynamicMembersPreviewPopupDP::PageDisplay");
      return result;
    }
    
    /// <returns></returns>
    /// <throws>HTMLException </throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection sc = new HTMLScriptCollection();
      return sc;
    }
  }
}