using System;
using com.plumtree.portaluiinfrastructure.expandablelist.selectptobject;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.invitation
{
  /// <author>DustinA</author>
  public class GroupListView : SelectPTObjectView
  {
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "GroupListView";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new GroupListView();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for the space below the Action bar.
    /// (The one with the add and delete icons).
    /// </summary>
    /// <returns>HTMLTable</returns>
    /// <throws>Exception</throws>
    protected override HTMLTable GetHTMLBelowActionBar()
    {
      HTMLTableCell myCell;
      HTMLTableRow myRow;
      HTMLTable myTable = new HTMLTable();
      myTable.SetWidth("100%");
      myTable.SetBorder("0");
      myTable.SetCellPadding("5");
      myTable.SetCellSpacing("0");
      //Spacer Row begin
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetHeight("5");
      //Spacer Row ends
      //Instruction Row begin
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
      myCell.AddInnerHTMLString(m_asOwner.GetString(435, "ptmsgs_portaladminmsgs"));
      myCell.AddInnerHTMLElement(new HTMLBr());
      // Instruction Row end
      //Spacer Row begin
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetHeight("5");
      //Spacer Row ends
      return myTable;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListView#GetHTMLForCheckBox(int)"></seealso>
    protected override HTMLTableCell GetHTMLForCheckBox(int _nRowIndex)
    {
      // Page cannot be deleted. It is from the community template or it is the home page.
      if (((IGroupListModelRO) m_model).IsEveryoneGroup(_nRowIndex))
      {
        HTMLTableCell myCell = new HTMLTableCell();
        myCell.SetWidth("20");
        myCell.SetHeight("30");
        myCell.SetAlign("center");
        myCell.SetVAlign("middle");
        myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
        myCell.AddInnerHTMLString(SPACE);
        return (myCell);
      } else
      {
        return base.GetHTMLForCheckBox(_nRowIndex);
      }
    }
  }
}