using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.admin.editors.invitation
{
  /// <summary>
  /// Delete that class if you don't have any repost actions.
  /// </summary>
  public class InvitationRepostControl : ObjEditorRepostControl
  {
    public const String STR_MVC_CLASS_NAME = "InvitationRepost";
    public const int POSTTOSELF_ACTION_FOLDER = 10;
    public const int POSTTOSELF_ACTION_PROFILE = 11;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new InvitationRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call  the associated method for each
    /// action.
    /// </summary>
    /// <param name="_nAction"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      ((ExpListControl) m_asOwner.GetControl(InvitationEditorAS.strStorageSelectPTObject)).PerformRepostAction(_nAction,
       m_htFormData);
      switch (_nAction){
      case POSTTOSELF_ACTION_FOLDER:
      ((InvitationModel) m_model).SetUserFolderOnRepost();
      break;
      case POSTTOSELF_ACTION_PROFILE:
      String[] data = (String[]) m_htFormData.GetElement(GenInfoView.HTMLSELECT_INV_USERPROF);
      ((InvitationModel) m_model).SetDefaultProfileID(XPConvert.ToInteger(data[0]));
      break;
      }
    }
  }
}