using System;
// Framework Imports
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.admin.editors.lockbox
{
  /// <author>jennifersu</author>
  public interface ILockboxEditorModelRO : IEditorModelRO
  {
    
    /// <summary>
    /// Get Row index of Lockbox in the main Lockbox list of
    /// Credential Vault Manager.
    /// </summary>
    /// <returns></returns>
    int GetRow();
    
    /// <summary>
    /// Returns true if the lockbox was just created.
    /// </summary>
    /// <returns></returns>
    bool IsNewLockbox();
    
    /// <summary>
    /// Get property object ID of the lockbox's
    /// username property.
    /// </summary>
    /// <returns></returns>
    int GetUsernamePropID();
    
    /// <summary>
    /// Get property object ID of the lockbox's
    /// password property.
    /// </summary>
    /// <returns></returns>
    int GetPasswordPropID();
    
    /// <summary>
    /// Get property object name of the lockbox's
    /// username property.
    /// </summary>
    /// <returns></returns>
    String GetUsernamePropName();
    
    /// <summary>
    /// Get property object name of the lockbox's
    /// password property.
    /// </summary>
    /// <returns></returns>
    String GetPasswordPropName();
    
    /// <summary>
    /// Get the property editor URL.
    /// </summary>
    /// <param name="_nPropertyID"></param>
    /// <returns></returns>
    ASURL GetEditPropertyURL(int _nPropertyID);
  }
}