using System;
// Framework Imports
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.editor.commonpages.keywords;
using com.plumtree.portaluiinfrastructure.editor.commonpages.localizednames;
using com.plumtree.portaluiinfrastructure.editor.commonpages.migrationhistory;
using com.plumtree.portaluiinfrastructure.editor.commonpages.objectproperties;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.admin.editors.lockbox
{
  public class LockboxEditorAS : PTEditorAS
  {
    public const String STR_MVC_CLASS_NAME = "LockboxEditor";
    
    /// <summary>
    /// MJD- Storage name for Keywords classes
    /// </summary>
    public const String STR_MVC_STORAGE_NAME_KEYWORDS = "ObjectKeywordsObjEditor";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new LockboxEditorAS();
    }
    
    /// <summary>
    /// Sets the Editor title.
    /// </summary>
    public override String GetEditorTitle()
    {
      if (EditorStartControl.EDITOR_START_FLAG_CREATE == ((EditorModel) GetModel(m_strModelName)).GetEditorType())
      {
        return (GetString(2907, "ptmsgs_portaladminmsgs"));
      } else
      {
        return (GetString(2908, "ptmsgs_portaladminmsgs"));
      }
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the class name of the Repost Control.
    /// </summary>
    /// <returns>String</returns>
    public override String GetRepostControlName()
    {
      return (LockboxEditorRepostControl.STR_MVC_CLASS_NAME);
    }
    
    /// <summary>
    /// Registers all the classes for this Activity Space.
    /// </summary>
    public override void Init()
    {
      m_strModelName = LockboxEditorModel.STR_MVC_CLASS_NAME;
      base.Init();
      IModel myModel = GetModel(m_strModelName);
      // JF- Register the Repost Control
      RegisterControl(LockboxEditorRepostControl.STR_MVC_CLASS_NAME, myModel);
      RegisterModel(LocNamesModel.STR_MVC_CLASS_NAME);
      RegisterView(LocNamesView.STR_MVC_CLASS_NAME, GetModel(LocNamesModel.STR_MVC_CLASS_NAME));
      RegisterView(LocNamesPrimaryNameView.STR_MVC_CLASS_NAME, GetModel(LocNamesModel.STR_MVC_CLASS_NAME));
      RegisterView(LocNamesPopUpView.STR_MVC_CLASS_NAME, GetModel(LocNamesModel.STR_MVC_CLASS_NAME));
      RegisterControl(LocNamesRepostControl.STR_MVC_CLASS_NAME, GetModel(LocNamesModel.STR_MVC_CLASS_NAME));
      // Register Plug-In: Object Properties
      RegisterModel(ObjPropModel.STR_MVC_CLASS_NAME);
      RegisterView(ObjPropEditView.STR_MVC_CLASS_NAME, GetModel(ObjPropModel.STR_MVC_CLASS_NAME));
      RegisterControl(ExpListControl.STR_MVC_CLASS_NAME, GetModel(ObjPropModel.STR_MVC_CLASS_NAME));
      // Register Plug-In: Keywords
      RegisterModel(KeywordsModel.STR_MVC_CLASS_NAME, STR_MVC_STORAGE_NAME_KEYWORDS);
      RegisterView(KeywordsView.STR_MVC_CLASS_NAME, STR_MVC_STORAGE_NAME_KEYWORDS,
       GetModel(STR_MVC_STORAGE_NAME_KEYWORDS));
      RegisterControl(ExpListControl.STR_MVC_CLASS_NAME, STR_MVC_STORAGE_NAME_KEYWORDS,
       GetModel(STR_MVC_STORAGE_NAME_KEYWORDS));
      RegisterView(LockboxEditorPropertiesView.STR_MVC_CLASS_NAME, myModel);
      LockboxEditorLocNamesDP dpLocNames = new LockboxEditorLocNamesDP();
      dpLocNames.AddToValidationFunction(LocNamesPrimaryNameView.VALIDATION_FUNC_NAME);
      RegisterPage(dpLocNames);
      RegisterPage(new LocNamesPopUpDP());
      // Register Migration History Plugin
      RegisterModel(MigrationHistoryPluginModel.STR_MVC_CLASS_NAME);
      RegisterView(MigrationHistoryView.STR_MVC_CLASS_NAME, GetModel(MigrationHistoryPluginModel.STR_MVC_CLASS_NAME));
      RegisterPage(new MigrationHistoryPluginDP());
      SetCurrentPage(GetPage(LockboxEditorLocNamesDP.STR_MVC_CLASS_NAME));
      //Sets left nav menu
      int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(1905, "ptmsgs_portaladminmsgs"));
      m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, LockboxEditorLocNamesDP.STR_MVC_CLASS_NAME);
      m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, MigrationHistoryPluginDP.STR_MVC_CLASS_NAME);
      }
    
    /// <summary>
    /// Set the help page for this editor. 
    /// </summary>
    /// <param name="page"></param>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage(com.plumtree.uiinfrastructure.activityspace.IDisplayPage)"></seealso>
    public override void SetCurrentPage(IDisplayPage page)
    {
      base.SetCurrentPage(page);
      String sPageName = page.GetName();
      if (MigrationHistoryPluginDP.STR_MVC_CLASS_NAME.Equals(sPageName))
      {
        this.SetHelpTopic("PT_MigrationHistoryandStatus");
      } else
      if (LockboxEditorLocNamesDP.STR_MVC_CLASS_NAME.Equals(sPageName))
      {
        this.SetHelpTopic("PT_CredentialVaultManager_LockboxMainSettings");
        }
    }
  }
}