using System;
// Plumtree Server Imports
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.statichelpers;
namespace com.plumtree.portalpages.admin.editors.lockbox
{
  public class LockboxEditorRepostControl : ObjEditorRepostControl
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_UI_INFRASTRUCTURE),
     "com.plumtree.portalpages.admin.editors.lockbox.LockboxEditorRepostControl");
    
    /// <summary>
    /// Class name for the Activity Space. 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "LockboxEditorRepost";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new LockboxEditorRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Override this method to disable the save pop up.
    /// </summary>
    /// <returns>false</returns>
    protected override bool DisableSavePopUp()
    {
      return true;
    }
  }
}