using System;
// Framework imports
using com.plumtree.portalpages.common.helpers;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.page
{
  /// <summary>
  /// This Section contains the HTML for the dependencies page.
  /// </summary>
  /// <author></author>
  public class PageDependenciesView : ObjDependenciesView
  {
    //Member variables
    private CreatedHelper m_chHelper = null;
    
    /// <summary>
    /// Class name for the activity space
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "PageDependenciesView";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new PageDependenciesView();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(com.plumtree.uiinfrastructure.activityspace.IModelRO,com.plumtree.uiinfrastructure.activityspace.AActivitySpace)"></seealso>
    public override void Init(IModelRO model, AActivitySpace parent)
    {
      base.Init(model, parent);
      m_chHelper = new CreatedHelper(parent, (PageEditorModel) model);
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.ObjDependenciesView#GetHTMLForDependencies()"></seealso>
    protected override HTMLElementCollection GetHTMLForDependencies()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      //Display the standard success message
      m_chHelper.displaySuccessMessage(result, m_asOwner.GetString(2720, "ptmsgs_portaladminmsgs"),
       ((ObjEditorModel) m_model).GetObjectName(), ((ObjEditorModel) m_model).GetParentFolderPath());
      //Display the standard warning if everyone has access to this object
      m_chHelper.displayEveryoneWarning(result, m_model, m_asOwner.GetString(2720,
       "ptmsgs_portaladminmsgs"));
      return result;
    }
  }
}