using System;
// Framework Imports
using com.plumtree.portalpages.common.editpage;
using com.plumtree.portaluiinfrastructure.editor;
namespace com.plumtree.portalpages.admin.editors.page
{
  /// <author>michaeld</author>
  public class PageRepostControl : ObjEditorRepostControl
  {
    public const String STR_MVC_CLASS_NAME = "PageRepost";
    public const int POSTTOSELF_ACTION_PAGE1 = 10;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new PageRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call  the associated method for each
    /// action.
    /// </summary>
    /// <param name="nAction"></param>
    protected override void PerformAction(int nAction)
    {
      base.PerformAction(nAction);
      // You need to call the PerformRepostAction on the page layout control
      ((PageLayoutControl) m_asOwner.GetControl(PageLayoutControl.STR_MVC_CLASS_NAME)).PerformRepostAction(nAction,
       m_htFormData);
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.ObjEditorRepostControl#DisableSavePopUp()"></seealso>
    protected override bool DisableSavePopUp()
    {
      if (0 > ((ObjEditorModel) m_model).GetFolderID())
      {
        return true;
      } else
      {
        return base.DisableSavePopUp();
      }
    }
  }
}