using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.common.constants;
using com.plumtree.portaluiinfrastructure.expandablelist.template;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.xpshared.htmlconstructs;
namespace com.plumtree.portalpages.admin.editors.page
{
  /// <author>michaeld</author>
  public class PageTemplateListModel : TemplateListModel
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.page.PageTemplateListModel");
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "PageTemplateList";
    public virtual void InitializePageTemplateList(IPTSession _Session, int _nPageTemplateID,
     bool bInheritPageTemplate, int _nListKey)
    {
      InitializeTemplateList(_Session, PT_CLASSIDS.PT_PAGETEMPLATE_ID, _nPageTemplateID,
       bInheritPageTemplate, m_asOwner.GetString(1816, ResourceConstants.PORTALBROWSINGMSGS),
       PTImageType.ICON_COMMUNITY_TEMPLATE, _nListKey);
      SetIsListReadOnly(true);
    }
    
    /// <summary>
    /// We don't all add rows for this list.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#AddRowsOnRepost(XPHashtable)"></seealso>
    public override void AddRowsOnRepost(XPHashtable _htFormData)
    {
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new PageTemplateListModel();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}