using System;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.pagetemplate
{
  /// <author>michaeld</author>
  public class DefaultPageNamePopUpDP : AFormDP
  {
    
    /// <summary>
    /// MES- The name of this object 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "DefaultPageNamePopUp";
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,  linking to
    /// that page.
    /// </summary>
    /// <returns>String</returns>
    public virtual String GetLeftNavString()
    {
      // MJD- This is not used here.
      return "";
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#GetFormPageType()"></seealso>
    public override FormPageTypes GetFormPageType()
    {
      return FormPageTypes.NO_BUTTONS;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()"></seealso>
    public override String GetFormTitle()
    {
      //MES- Localized Default Page Name
      return m_asOwner.GetString(2727, "ptmsgs_portaladminmsgs");
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for that Page.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      //MES- Just ask the popup view to write itself
      HTMLElementCollection result = new HTMLElementCollection();
      result.AddInnerHTMLElement((m_asOwner.GetView(PageTemplateEditorAS.PLUGIN_DEFAULT_PAGE_NAME_POPUP_VIEW)).Display());
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      //MES- Ask the superclass if it's got anything.
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      //MES- And ask the popup view if it's got anything
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(PageTemplateEditorAS.PLUGIN_DEFAULT_PAGE_NAME_POPUP_VIEW).DisplayJavascript());
      return myScripts;
    }
  }
}