using System;
using com.plumtree.portaluiinfrastructure.editor.commonpages.localizednames;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.pagetemplate
{
  /// <author>michaeld</author>
  public class PageTemplateDefaultPageNameDP : EditorDP
  {
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "PageTemplateDefaultPageName";
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,  linking to
    /// that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(2725, "ptmsgs_portaladminmsgs");
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(2726, "ptmsgs_portaladminmsgs"),
       this.m_asOwner);
    }
    
    /// <summary>
    /// Returns the HTML for the General Info page.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException on error</throws>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // Insert super class HTML
      result.AddInnerHTMLElement(base.PageDisplay());
      HTMLElementCollection views = new HTMLElementCollection();
      //MES- Add the primary name/desc
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(PageTemplateEditorAS.PLUGIN_DEFAULT_PAGE_PRIMARY_NAME_VIEW)).Display());
      //MES- Add the list of languages we're localized into, IF we support localization AND we're localized!
      ILocNamesModelRO locNamesModel = (ILocNamesModelRO) m_asOwner.GetModel(PageTemplateEditorAS.PLUGIN_DEFAULT_PAGE_NAME);
      if (locNamesModel.SupportsLocalization() && locNamesModel.GetIsLocalized())
      {
        views.AddInnerHTMLElement(new HTMLBr());
        views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(PageTemplateEditorAS.PLUGIN_DEFAULT_PAGE_NAME_VIEW)).Display());
        }
      result.AddInnerHTMLElement(CreateLeftNavBar(views));
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection scripts = base.DisplayJavaScriptFromChild();
      scripts.AddInnerHTMLElement(m_asOwner.GetView(PageTemplateEditorAS.PLUGIN_DEFAULT_PAGE_PRIMARY_NAME_VIEW).DisplayJavascript());
      //MES- Add the JavaScript for the list of languages we're localized into, IF we support localization!
      ILocNamesModelRO model = (ILocNamesModelRO) m_asOwner.GetModel(PageTemplateEditorAS.PLUGIN_DEFAULT_PAGE_NAME);
      if (model.GetIsLocalized())
      {
        scripts.AddInnerHTMLElement(m_asOwner.GetView(PageTemplateEditorAS.PLUGIN_DEFAULT_PAGE_NAME_VIEW).DisplayJavascript());
        }
      return scripts;
    }
  }
}