using System;
// Framework Imports
using com.plumtree.portalpages.common.editpage;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.editor.commonpages.localizednames;
namespace com.plumtree.portalpages.admin.editors.pagetemplate
{
  /// <author>michaeld</author>
  public class PageTemplateRepostControl : ObjEditorRepostControl
  {
    public const String STR_MVC_CLASS_NAME = "PageTemplateRepost";
    public const int POSTTOSELF_ACTION_PAGETEMPLATE1 = 10;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new PageTemplateRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call  the associated method for each
    /// action.
    /// </summary>
    /// <param name="nAction"></param>
    protected override void PerformAction(int nAction)
    {
      base.PerformAction(nAction);
      // You need to call the PerformRepostAction on the page layout control
      ((PageLayoutControl) m_asOwner.GetControl(PageLayoutControl.STR_MVC_CLASS_NAME)).PerformRepostAction(nAction,
       m_htFormData);
      // Default Page Name
      ((LocNamesRepostControl) m_asOwner.GetControl(PageTemplateEditorAS.PLUGIN_DEFAULT_PAGE_NAME)).PerformRepostAction(nAction,
       m_htFormData);
    }
  }
}