using System;
using com.plumtree.server;
namespace com.plumtree.portalpages.admin.editors.portlet
{
  /// <author>
  /// adolfoc
  /// This interface must be implemented by any plugin model that wishes to receive
  /// updates from the WebServiceModel. Each plugin model must also be registered with
  /// the WebServiceModel using
  /// WebServiceModel.RegisterWSSubModel(String strPluginModelStorageName).
  /// </author>
  public interface IPSubModel
  {
    
    /// <summary>
    /// Sub models are expected to store themselves to the ptWebService object passed in
    /// in InitWSModel during this call.
    /// </summary>
    void DoTaskBeforePStore();
    
    /// <summary>
    /// Called when the Portlet editor mode is changed.
    /// </summary>
    void DoTaskOnPModeUpdate(int nNewWSMode);
    
    /// <summary>
    /// Called when the Remote Server is changed. This is mostly used to update the base-url
    /// displayed before URL edit boxes.
    /// </summary>
    void DoTaskOnWebServiceUpdate(IPTWebService ptWebService);
    
    /// <summary>
    /// Initializes the sub-model. Provides an opportunity for the submodel to
    /// load it's state from the WebService.
    /// </summary>
    void InitPModel(IPTGadget ptPortlet);
  }
}