using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.portlet
{
  /// <author>adolfoc</author>
  public class MainDP : PPluginDP
  {
    
    /// <summary>
    /// Class Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "PortletMain";
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,  linking to
    /// that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(606, "ptmsgs_portaladminmsgs");
    }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1673, "ptmsgs_portaladminmsgs"),
       this.m_asOwner);
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetOrderedViewList(int)"></seealso>
    public override XPArrayList GetOrderedViewList(int nPMode)
    {
      XPArrayList xpPViews = new XPArrayList();
      switch (nPMode){
      case PortletModel.PMODE_PRECREATE:
      break;
      case PortletModel.PMODE_CREATE_FROMTEMPLATE:
      case PortletModel.PMODE_CREATE:
      case PortletModel.PMODE_EDIT:
      xpPViews.Add(PortletEditorAS.Storage_SelectWebServiceView);
      xpPViews.Add(PortletEditorAS.Storage_PortletSettingsView);
      break;
      //PortletModel.PMODE_INVALID :
      case -1:
      default:
      break;
      }
      return xpPViews;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.admin.editors.portlet.PPluginDP#GetPluginHelpTopic()
     */
     
    public override String GetPluginHelpTopic()
    {
      IPortletModelRO mParentModel = (IPortletModelRO) m_asOwner.GetModel(PortletModel.STR_MVC_CLASS_NAME);
      if (mParentModel.IsTemplate())
      {
        return "PT_PortletTemplate_MainSettings";
      } else
      {
        return "PT_Portlet_MainSettings";
      }
    }
  }
}