using System;
using com.plumtree.openfoundation.util;
namespace com.plumtree.portalpages.admin.editors.portlet
{
  /// <author>adolfoc</author>
  public class PreCreateDP : PPluginDP
  {
    
    /// <summary>
    /// Class Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "PortletPreCreate";
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,  linking to
    /// that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(1857, "ptmsgs_portaladminmsgs");
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetOrderedViewList(int)"></seealso>
    public override XPArrayList GetOrderedViewList(int nPMode)
    {
      XPArrayList xpPViews = new XPArrayList();
      switch (nPMode){
      case PortletModel.PMODE_PRECREATE:
      // AGC- This is the old pre-selection view. I've left this in so that
      // it is easy for future developers to switch to this view for debugging
      // purposes. The view is no longer used otherwise (rebuilt due to a UI
      // change).
      // xpPViews.Add(PortletEditorAS.Storage_PChooseSelectionView);
      //AGC- This is the new pre-selection view.
      xpPViews.Add(PortletEditorAS.Storage_PSelectTemplateView);
      break;
      case PortletModel.PMODE_CREATE_FROMTEMPLATE:
      case PortletModel.PMODE_CREATE:
      case PortletModel.PMODE_EDIT:
      break;
      case PortletModel.PMODE_INVALID:
      default:
      break;
      }
      return xpPViews;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.editor.EditorDP#GetEditorHeaderViewName()"></seealso>
    protected override String GetEditorHeaderViewName()
    {
      return PortletEditorHeaderView.STR_MVC_CLASS_NAME;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.admin.editors.portlet.PPluginDP#GetPluginHelpTopic()
     */
     
    public override String GetPluginHelpTopic()
    {
      return "PT_Portlet_ChoosePorletTemplate";
    }
  }
}