using System;
using com.plumtree.portaluiinfrastructure.resultwrapper;
namespace com.plumtree.portalpages.admin.editors.portlet.plugins
{
  /// <author>adolfoc</author>
  public interface IPSelectTemplateModelRO
  {
    
    /// <summary>
    /// Returns the ID of the currently selected portlet template or 0
    /// if nothing is selected.
    /// </summary>
    /// <returns>String</returns>
    int GetPortletTemplateID();
    
    /// <summary>
    /// Returns the array of currently available templates.
    /// </summary>
    /// <returns>XPArrayList</returns>
    PTObjectManagerQueryWrapper GetAvailableTemplates();
    
    /// <summary>
    /// Returns a boolean indicating whether to show freeform templates.
    /// </summary>
    /// <returns>boolean</returns>
    bool GetShowFreeForm();
    
    /// <summary>
    /// Returns a boolean indicating whether to show header and footer templates.
    /// </summary>
    /// <returns>boolean</returns>
    bool GetShowHeaderAndFooter();
  }
}