using System;
namespace com.plumtree.portalpages.admin.editors.portlet.plugins
{
  /// <author>adolfoc</author>
  public interface ISelectWebServiceModelRO
  {
    
    /// <seealso cref="com.plumtree.portalpagessample.form.ISampleFormModelRO#GetData(String)"></seealso>
    String GetData(String name);
    
    /// <summary>
    /// Returns the name of the web service
    /// </summary>
    /// <returns>String</returns>
    String GetWebServiceName();
    
    /// <summary>
    /// Returns the Plumtree Path to the web service
    /// </summary>
    /// <returns>String</returns>
    String GetWebServicePath();
    
    /// <summary>
    /// Returns the object ID of the web service
    /// </summary>
    /// <returns>int</returns>
    int GetWebServiceID();
    
    /// <summary>
    /// Returns whether or not the WebService should be changeable in the view.
    /// </summary>
    /// <returns>boolean</returns>
    bool IsReadOnly();
    
    /// <summary>
    /// Returns the Admin Prefs URL (if none, returns blank.);
    /// </summary>
    /// <returns>String</returns>
    String GetAdminPrefsURL();
  }
}