using System;
// Framework Imports
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.profilesource
{
  public class ClearHistoryView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.profilesource.ClearHistoryView");
    
    /// <summary>
    /// Class name for the activity space 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "ClearHistory";
    public const String BUTTON_CLEAR = "in_bu_clearhistory";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new ClearHistoryView();
    }
    
    /// <returns></returns>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTableCell myCell;
      HTMLTableRow myRow;
      HTMLTable myTable;
      try
      {
        result.AddInnerHTMLElement(base.GetHeaderView(m_asOwner.GetString(1860,
         "ptmsgs_portaladminmsgs")));
        //result.AddInnerHTMLElement(super.GetShortSpacerTable());
        // mj: do the instructions table
        myTable = ProfileSourceHelper.ConstructInstructionsTable(m_asOwner.GetString(1861,
         "ptmsgs_portaladminmsgs"));
        result.AddInnerHTMLElement(myTable);
        result.AddInnerHTMLElement(EditorView.GetShortSpacerTable());
        // mj: construct the control
        myTable = new HTMLTable();
        result.AddInnerHTMLElement(myTable);
        myTable.SetWidth("100%");
        myTable.SetBorder("0");
        myTable.SetCellPadding("5");
        myTable.SetCellSpacing("0");
        //myTable.SetAlign("left");
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        // mj: cell for dropdown
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        HTMLInput myButton = new HTMLInput(HTMLInputTypes.BUTTON, BUTTON_CLEAR,
         "");
        myCell.AddInnerHTMLElement(myButton);
        myButton.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
        myButton.SetValue(m_asOwner.GetString(1860, "ptmsgs_portaladminmsgs"));
        myButton.SetOnClick("postToSelf(" + ProfileSourceRepostControl.POSTTOSELF_ACTION_CLEAR_HISTORY + "); return false;");
        }
      catch (Exception e)
      {
        log.Error(e, "AuthPartnerView::Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(1862, "ptmsgs_portaladminmsgs"),
         e);
      }
      return result;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}