using System;
// Framework Imports
using com.plumtree.portaluiinfrastructure.editor;
namespace com.plumtree.portalpages.admin.editors.profilesource
{
  public interface IProfileSourceModelRO : IObjEditorModelRO
  {
    
    /// <returns></returns>
    String[][] GetPartnerList();
    
    /// <returns></returns>
    Object[][] GetPartnerQueryFilter();
    
    /// <returns></returns>
    String GetProviderCLSID();
    
    /// <returns></returns>
    int GetSelectedPartner();
    
    /// <returns></returns>
    bool IsPartnerSupported();
    
    /// <returns></returns>
    String GetPropertyMapInstructions();
    
    /// <summary>
    /// Returns the unique key (property ID) that will be sent to 
    /// the providers during a profile sync.  If the unique key
    /// returned is <0, It should be checked against the 
    /// PT_PROFILE_UNIQUE_KEYS enum.
    /// </summary>
    /// <returns>the unique key prop id</returns>
    int GetUniqueKey();
    
    /// <summary>
    /// If a real property is selected, return the name of the 
    /// property for easy viewing...
    /// </summary>
    /// <returns>the name of the property...</returns>
    String GetUniqueKeyPropertyName();
    
    /// <summary>
    /// Returns the unique key picker space ID.  This is used to
    /// track tree picker instances so that if you click the 
    /// button to pick a group twice, you get the same tree.
    /// </summary>
    /// <returns>the unique key picker space id</returns>
    String GetUniqueKeyPickerSpaceID();
    
    /// <summary>
    /// Returns a comma-delimited list of property IDs that
    /// are mapped to the user object.
    /// </summary>
    String GetUserProperties();
  }
}