using System;
// Framework imports
using com.plumtree.openlog;
using com.plumtree.portalpages.common.constants;
using com.plumtree.portalpages.common.helpers;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.profilesource
{
  /// <summary>
  /// This Section contains the HTML for the dependencies page.
  /// </summary>
  /// <author></author>
  public class ProfileSourceDependenciesView : ObjDependenciesView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.profilesource.ProfileSourceDependenciesView");
    
    /// <summary>
    /// Class name for the activity space
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "ProfileSourceDependencies";
    // <0 use default, 0 none, >0 use specified
    public const int OFFSET = -1;
    // <0 use default, 0 none, >0 use specified
    public const int BREAK = -1;
    protected CreatedHelper m_helper;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new ProfileSourceDependenciesView();
    }
    
    /// <returns></returns>
    public override HTMLScript DisplayJavascript()
    {
      HTMLScript myScript = base.DisplayJavascript();
      try
      {
        helper().addJobJavascript(myScript);
      }
      catch (HTMLException he)
      {
        log.Error(he, "ProfileSourceDependenciesView::DisplayJavascript An error occured when trying to display the JavaScript.");
        }
      return myScript;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.ObjDependenciesView#GetHTMLForDependencies()"></seealso>
    protected override HTMLElementCollection GetHTMLForDependencies()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      helper().displayEmptyRow(result);
      helper().displayTextRow(result, m_asOwner.GetString(3156, ResourceConstants.PORTALADMINMSGS),
       null);
      helper().displayTextRow(result, OFFSET, m_asOwner.GetString(2350, ResourceConstants.PORTALADMINMSGS) + ":",
       model().GetObjectName());
      helper().displayTextRow(result, OFFSET, m_asOwner.GetString(1716, ResourceConstants.PORTALADMINMSGS) + ":",
       model().GetParentFolderPath(), BREAK);
      helper().displayJobRows(result, m_asOwner.GetString(3157, ResourceConstants.PORTALADMINMSGS),
       m_asOwner.GetString(3158, ResourceConstants.PORTALADMINMSGS));
      helper().displayEmptyRow(result);
      helper().displayEveryoneWarning(result, (ProfileSourceModel) m_model,
       m_asOwner.GetString(2350, ResourceConstants.PORTALADMINMSGS));
      return result;
    }
    
    /// <returns></returns>
    protected virtual CreatedHelper helper()
    {
      if (m_helper == null)
      {
        m_helper = new CreatedHelper(m_asOwner, model());
      }
      return m_helper;
    }
    
    /// <returns></returns>
    protected virtual ProfileSourceModel model()
    {
      return (ProfileSourceModel) m_model;
    }
  }
}