using System;
// Framework Imports
using com.plumtree.portalpages.admin.editors.common.setjob;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.admin.editors.profilesource
{
  /// <summary>
  /// Delete that class if you don't have any repost actions.***
  /// </summary>
  public class ProfileSourceRepostControl : ObjEditorRepostControl
  {
    public const String STR_MVC_CLASS_NAME = "ProfileSourceRepost";
    public const int POSTTOSELF_ACTION_CLEAR_HISTORY = 10;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new ProfileSourceRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call
    /// the associated method for each action.
    /// </summary>
    /// <param name="_nAction"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      // You need to call the PerformRepostAction on the select ptobject control
      ((ExpListControl) m_asOwner.GetControl(ProfileSourceEditorAS.strStorageSelectPTObject)).PerformRepostAction(_nAction,
       m_htFormData);
      ((ExpListControl) m_asOwner.GetControl(ProfileSourceEditorAS.strPTMultiColumnList)).PerformRepostAction(_nAction,
       m_htFormData);
      ((SetJobRepostControl) m_asOwner.GetControl(SetJobRepostControl.STR_MVC_CLASS_NAME)).PerformRepostAction(_nAction,
       m_htFormData);
      switch (_nAction){
      case POSTTOSELF_ACTION_CLEAR_HISTORY:
      ((ProfileSourceModel) m_model).ClearHistory();
      break;
      }
    }
  }
}