using System;
//Server import
using com.plumtree.portalpages.common.helpers;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.property
{
  /// <summary>
  /// This Section contains the HTML for the dependencies page.
  /// </summary>
  /// <author>JosephC</author>
  public class PropDependenciesView : ObjDependenciesView
  {
    
    /// <summary>
    /// Class name for the activity space
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "PropDependencies";
    
    /// <summary>
    /// Helper class for generating view 
    /// </summary>
    private CreatedHelper m_chHelper = null;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new PropDependenciesView();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(com.plumtree.uiinfrastructure.activityspace.IModelRO,com.plumtree.uiinfrastructure.activityspace.AActivitySpace)"></seealso>
    public override void Init(IModelRO model, AActivitySpace parent)
    {
      base.Init(model, parent);
      m_chHelper = new CreatedHelper(parent, (PropModel) model);
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.ObjDependenciesView#GetHTMLForDependencies()"></seealso>
    protected override HTMLElementCollection GetHTMLForDependencies()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      //Display the standard success message
      m_chHelper.displaySuccessMessage(result, m_asOwner.GetString(2220, "ptmsgs_portaladminmsgs"),
       ((ObjEditorModel) m_model).GetObjectName(), ((ObjEditorModel) m_model).GetParentFolderPath());
      IPTProperty myProperty = (IPTProperty) ((ObjEditorModel) m_model).GetObject();
      int intSearchable = myProperty.GetCharacteristicsAsInt(PT_PROPERTY_CHARACTERISTICS.PT_PROPCHAR_SEARCHABLE);
      int[] myMappings = myProperty.GetMappings();
      //Display the mappings
      if (null != myMappings && myMappings.Length > 0)
      {
        m_chHelper.beginList(result);
        for (int i = 0;i < myMappings.Length;i++)
        {
          m_chHelper.displayListRow(GetClassString(myMappings[i]));
        }
        if (0 == intSearchable)
        {
          //Show a warning
          m_chHelper.displayWarning(result, m_asOwner.GetString(2221, "ptmsgs_portaladminmsgs"));
          }
      }
      return result;
    }
    private String GetClassString(int intClassID)
    {
      String strTemp = "";
      switch (intClassID){
      case PT_CLASSIDS.PT_GLOBALOBJECT_ID:
      strTemp = m_asOwner.GetString(2222, "ptmsgs_portaladminmsgs");
      break;
      default:
      // security
      case PT_CLASSIDS.PT_USER_ID:
      strTemp = m_asOwner.GetString(2223, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_USERGROUP_ID:
      strTemp = m_asOwner.GetString(2224, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_AUTHSOURCE_ID:
      strTemp = m_asOwner.GetString(2225, "ptmsgs_portaladminmsgs");
      break;
      /*amcd - breakingbuild		case PT_CLASSIDS.PT_SYNCNTUSERS_ID:
       strTemp = m_asOwner.GetString(2226, "ptmsgs_portaladminmsgs");
       break; */
       
      case PT_CLASSIDS.PT_SYNCAGENT_ID:
      strTemp = m_asOwner.GetString(2226, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_ACTIVITY_ID:
      strTemp = m_asOwner.GetString(2227, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_PROFILESOURCE_ID:
      strTemp = m_asOwner.GetString(2228, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_SUBPORTAL_ID:
      strTemp = m_asOwner.GetString(2229, "ptmsgs_portaladminmsgs");
      break;
      // catalog
      case PT_CLASSIDS.PT_CATALOG_ID:
      strTemp = m_asOwner.GetString(2230, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_CATALOGFOLDER_ID:
      strTemp = m_asOwner.GetString(2231, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_CATALOGCARD_ID:
      strTemp = m_asOwner.GetString(2232, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_ADMIN_CATALOG_ID:
      strTemp = m_asOwner.GetString(2233, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_ADMIN_FOLDER_ID:
      strTemp = m_asOwner.GetString(2234, "ptmsgs_portaladminmsgs");
      break;
      // system objects
      case PT_CLASSIDS.PT_FILTER_ID:
      strTemp = m_asOwner.GetString(2235, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_SAVEDSEARCH_ID:
      strTemp = m_asOwner.GetString(2236, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_DATASOURCE_ID:
      strTemp = m_asOwner.GetString(2237, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_PROPERTY_ID:
      strTemp = m_asOwner.GetString(2238, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_DOCUMENTTYPE_ID:
      strTemp = m_asOwner.GetString(2239, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_CRAWLER_ID:
      strTemp = m_asOwner.GetString(2240, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_DOCUMENTTYPEMAP_ID:
      strTemp = m_asOwner.GetString(2241, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_PROPERTYMAP_ID:
      strTemp = m_asOwner.GetString(2242, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_TAXONOMIST_ID:
      strTemp = m_asOwner.GetString(2243, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_GADGET_ID:
      strTemp = m_asOwner.GetString(2244, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_INVITATION_ID:
      strTemp = m_asOwner.GetString(2245, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_ACLSYNCMAP_ID:
      strTemp = m_asOwner.GetString(2246, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_FEDERATEDPORTAL_ID:
      strTemp = m_asOwner.GetString(2650, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_GADGETCONTENTSERVER_ID:
      strTemp = m_asOwner.GetString(2248, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_AUDITMSGS_ID:
      strTemp = m_asOwner.GetString(2249, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_USERINTERFACE_ID:
      strTemp = m_asOwner.GetString(2250, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_COMMUNITYTEMPLATE_ID:
      strTemp = m_asOwner.GetString(2251, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_GADGETBUNDLE_ID:
      strTemp = m_asOwner.GetString(2252, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_PAGETEMPLATE_ID:
      strTemp = m_asOwner.GetString(2253, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_WEBSERVICE_ID:
      strTemp = m_asOwner.GetString(2254, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_EXTOPERATION_ID:
      strTemp = m_asOwner.GetString(2255, "ptmsgs_portaladminmsgs");
      break;
      // profile layout elements
      case PT_CLASSIDS.PT_PROFILEPAGE_ID:
      strTemp = m_asOwner.GetString(2256, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_PROFILESECTION_ID:
      strTemp = m_asOwner.GetString(2257, "ptmsgs_portaladminmsgs");
      break;
      // scheduler objects
      case PT_CLASSIDS.PT_JOB_ID:
      strTemp = m_asOwner.GetString(2258, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_SCHEDULE_ID:
      strTemp = m_asOwner.GetString(2259, "ptmsgs_portaladminmsgs");
      break;
      // portal objects
      case PT_CLASSIDS.PT_COMMUNITY_ID:
      strTemp = m_asOwner.GetString(2260, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_PAGE_ID:
      strTemp = m_asOwner.GetString(2262, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_SITEMAPFOLDER_ID:
      strTemp = m_asOwner.GetString(2263, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_SITEMAPLINK_ID:
      strTemp = m_asOwner.GetString(2264, "ptmsgs_portaladminmsgs");
      break;
      case PT_CLASSIDS.PT_SITEMAPWEBLINK_ID:
      strTemp = m_asOwner.GetString(2265, "ptmsgs_portaladminmsgs");
      break;
      // Search update agent (used to allow concurrent SUA)
      case PT_CLASSIDS.PT_SEARCHUPDATE_CLASSID:
      strTemp = m_asOwner.GetString(2266, "ptmsgs_portaladminmsgs");
      break;
      // Search repair (used control search repair)
      case PT_CLASSIDS.PT_WEEKLYHOUSEKEEPING_CLASSID:
      strTemp = m_asOwner.GetString(2267, "ptmsgs_portaladminmsgs");
      break;
      // card refresh group (used by the Card Refresh Agent)
      case PT_CLASSIDS.PT_CARDREFRESHGROUP_ID:
      strTemp = m_asOwner.GetString(2268, "ptmsgs_portaladminmsgs");
      break;
      }
      return strTemp;
    }
  }
}