using System;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.admin.editors.propertymap
{
  /// <author>OlegS</author>
  public interface IPropertyMapEditorModelRO : IEditorModelRO
  {
    
    /// <returns></returns>
    String GetLastTreeSpaceId();
    
    /// <returns></returns>
    bool GetSortAscending();
    
    /// <returns></returns>
    int GetNumProperties();
    
    /// <param name="propId"></param>
    /// <returns></returns>
    bool IsPropertyAdded(int propId);
    
    /// <param name="propId"></param>
    /// <param name="index"></param>
    /// <returns></returns>
    String GetPropertyAttribute(int propId, int index);
    
    /// <param name="propId"></param>
    /// <returns></returns>
    bool IsPropertyDeleted(int propId);
    
    /// <returns></returns>
    // does not include deleted properties
    Object[] GetPropertyIDs();
    
    /// <param name="propId"></param>
    /// <returns></returns>
    bool IsPropertyInEditMode(int propId);
    
    /// <param name="propId"></param>
    /// <returns></returns>
    bool IsPropertyMandatory(int propId);
    
    /// <param name="propId"></param>
    /// <returns></returns>
    bool IsPropertyModified(int propId);
    
    /// <param name="propId"></param>
    /// <returns></returns>
    int GetPropertyNumberOfAttributes(int propId);
    
    /// <returns></returns>
    int WherePropertiesLive();
  }
}