using System;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.editor.commonpages.migrationhistory;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.tips;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.propertymap
{
  /// <author>OlegS</author>
  public class PropertyMapEditorAS : ObjEditorAS
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.propertymap.PropertyMapEditorAS");
    public const String STR_MVC_CLASS_NAME = "PropertyMapEditor";
    private const String sClassName = "com.plumtree.portalpages.admin.editors.propertymap.PropertyMapEditorAS";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new PropertyMapEditorAS();
    }
    public override String GetEditorTitle()
    {
      return GetString(700, "ptmsgs_portaladminmsgs");
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public override String GetRepostControlName()
    {
      return (PropertyMapEditorRepostControl.STR_MVC_CLASS_NAME);
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(String,String,boolean)"></seealso>
    public override bool CheckBasicAccess(String strPage, String strControl,
     bool bSameSpace)
    {
      bool bInAdminGroup = PlumtreeHelpers.CheckCurrentUserIsAdmin((IPTSession) GetUserSession());
      if (!bInAdminGroup)
      {
        return false;
      }
      return base.CheckBasicAccess(strPage, strControl, bSameSpace);
    }
    public override void Init()
    {
      m_strModelName = PropertyMapEditorModel.STR_MVC_CLASS_NAME;
      // Warning: m_myModel must be initialized before super.Init() is called.
      base.Init();
      IModel myModel = GetModel(PropertyMapEditorModel.STR_MVC_CLASS_NAME);
      // Register DisplayPages
      RegisterPage(new PropertyMapEditorMainDP());
      // Register Views
      RegisterView(PropertyMapEditorMainView.STR_MVC_CLASS_NAME, myModel);
      // Register Controls
      RegisterControl(PropertyMapEditorRepostControl.STR_MVC_CLASS_NAME, myModel);
      // Register Migration History Plugin
      if (!GetModelExists(MigrationHistoryPluginModel.STR_MVC_CLASS_NAME))
      {
        RegisterModel(MigrationHistoryPluginModel.STR_MVC_CLASS_NAME);
      }
      if (!GetViewExists(MigrationHistoryView.STR_MVC_CLASS_NAME))
      {
        RegisterView(MigrationHistoryView.STR_MVC_CLASS_NAME, GetModel(MigrationHistoryPluginModel.STR_MVC_CLASS_NAME));
        }
      if (!GetPageExists(MigrationHistoryPluginDP.STR_MVC_CLASS_NAME))
      {
        RegisterPage(new MigrationHistoryPluginDP());
      }
      // Set default page
      // (It will be the page selected by default when the user starts the Editor).
      SetCurrentPage(PropertyMapEditorMainDP.STR_MVC_CLASS_NAME);
      //Sets left nav menu
      int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(1866, "ptmsgs_portaladminmsgs"));
      m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, PropertyMapEditorMainDP.STR_MVC_CLASS_NAME);
      int nMenuTwoID = m_mEditorMenu.StartNewSubMenu(GetString(1867, "ptmsgs_portaladminmsgs"));
      m_mEditorMenu.AddLinkToSubMenu(nMenuTwoID, MigrationHistoryPluginDP.STR_MVC_CLASS_NAME);
      //	TIPS
      TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);
      if (tm != null)
      {
        try
        {
          tm.SetGeneratingClass(sClassName);
          int iTitleId = 60;
          int iTipId = 61;
          int iSecondaryTipId = 62;
          tm.SetTipTitle(this.GetString(iTitleId, "ptmsgs_tips"));
          HTMLGenericElement e = new HTMLGenericElement(this.GetString(iTipId,
           "ptmsgs_tips"));
          tm.SetTip(e);
          String sSecondary = this.GetString(iSecondaryTipId, "ptmsgs_tips");
          if (!("none_do_not_translate".Equals(sSecondary)))
          {
            e = new HTMLGenericElement(sSecondary);
            tm.SetSecondarTip(e);
          }
        }
        catch (Exception ex)
        {
          log.Error(ex, "Couldn\'t generate tip.");
        }
      }
    }
    //	Got the tips model
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage()"></seealso>
    /// <param name="IDisplayPage">the current Display Page</param>
    public override void SetCurrentPage(IDisplayPage page)
    {
      base.SetCurrentPage(page);
      String sPageName = page.GetName();
      if (PropertyMapEditorMainDP.STR_MVC_CLASS_NAME.Equals(sPageName))
      {
        SetHelpTopic("PT_GlobalDocumentPropertyMap_DocumentPropertyMap");
        }
    }
  }
}