using System;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.admin.editors.propertymap
{
  /// <author>OlegS</author>
  public class PropertyMapEditorRepostControl : EditorRepostControl
  {
    public const String STR_MVC_CLASS_NAME = "PropertyMapEditorRepost";
    public const int ACTION_ADD = 10;
    public const int ACTION_DEL = 11;
    public const int ACTION_SORT = 12;
    // + property id
    public const int ACTION_EDIT = 1000;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new PropertyMapEditorRepostControl();
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <param name="_nAction"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      PropertyMapEditorModel m = (PropertyMapEditorModel) m_model;
      switch (_nAction){
      case POSTTOSELF_ACTION_FINISH:
      // we use DoTaskBeforeStore()
      break;
      case ACTION_ADD:
      m.OnAdd();
      break;
      case ACTION_DEL:
      m.OnDel();
      break;
      case ACTION_SORT:
      m.OnSort();
      break;
      default:
      if (_nAction >= 1000)
      {
        m.OnEdit(_nAction - 1000);
      }
      break;
      }
    }
    protected override void SetRepostAction()
    {
      base.SetRepostAction();
      GetModel().m_nAction = m_nAction;
    }
    
    /// <returns></returns>
    protected virtual PropertyMapEditorModel GetModel()
    {
      return (PropertyMapEditorModel) m_model;
    }
  }
}