using System;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.resultwrapper;
namespace com.plumtree.portalpages.admin.editors.remoteserver
{
  /// <author>adolfoc</author>
  public interface IRemoteServerModelRO : IObjEditorModelRO
  {
    
    /// <summary>
    /// Returns a QueryResult of all of the Associated Web Services
    /// </summary>
    /// <returns>IPTQueryResult</returns>
    IASQueryResult GetAssocWebServices();
    
    /// <summary>
    /// Returns the strAuthTypeRadio.
    /// </summary>
    /// <returns>int</returns>
    int GetAuthType();
    
    /// <summary>
    /// Returns the strBaseURL.
    /// </summary>
    /// <returns>String</returns>
    String GetBaseURL();
    
    /// <summary>
    /// Returns the strLoginName.
    /// </summary>
    /// <returns>String</returns>
    String GetLoginName();
    
    /// <summary>
    /// Returns the public key.
    /// </summary>
    /// <returns>String</returns>
    String GetPublicKey();
  }
}