using System;
// Framework imports
using com.plumtree.portalpages.common.helpers;
using com.plumtree.portaluiinfrastructure.classtypedescriptors.classtypes;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.remoteserver
{
  /// <summary>
  /// This Section contains the HTML for the dependencies page.
  /// </summary>
  /// <author></author>
  public class RemoteServerDependenciesView : ObjDependenciesView
  {
    
    /// <summary>
    /// Class name for the activity space
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "RemoteServerDependencies";
    // <0 use default, 0 none, >0 use specified
    public const int OFFSET = -1;
    // <0 use default, 0 none, >0 use specified
    public const int BREAK = -1;
    protected CreatedHelper m_chHelper = null;
    
    /// <summary>
    /// Function name for the javascript used to open Web services based on this remote server 
    /// </summary>
    public const String JS_OPENWS = "OpenWebServiceDependency";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new RemoteServerDependenciesView();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(com.plumtree.uiinfrastructure.activityspace.IModelRO,com.plumtree.uiinfrastructure.activityspace.AActivitySpace)"></seealso>
    public override void Init(IModelRO model, AActivitySpace parent)
    {
      base.Init(model, parent);
      m_chHelper = new CreatedHelper(parent, (RemoteServerModel) model);
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.ObjDependenciesView#GetHTMLForDependencies()"></seealso>
    protected override HTMLElementCollection GetHTMLForDependencies()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      m_chHelper.displayEmptyRow(result);
      m_chHelper.displayTextRow(result, m_asOwner.GetString(1871, "ptmsgs_portaladminmsgs"),
       null);
      m_chHelper.displayTextRow(result, OFFSET, m_asOwner.GetString(1870,
       "ptmsgs_portaladminmsgs"), ((ObjEditorModel) m_model).GetObjectName());
      m_chHelper.displayTextRow(result, OFFSET, m_asOwner.GetString(1872,
       "ptmsgs_portaladminmsgs"), ((ObjEditorModel) m_model).GetParentFolderPath(),
       BREAK);
      m_chHelper.displayEmptyRow(result);
      m_chHelper.displayTextRow(result, m_asOwner.GetString(1873, "ptmsgs_portaladminmsgs"),
       null);
      m_chHelper.beginList(result);
      String strArg = "&" + PTWebServices.QS_WS_REMOTE_SERVER + "=" + ((RemoteServerModel) m_model).GetObjectID();
      int nFolderID = ((ObjEditorModel) m_model).GetFolderID();
      m_chHelper.displayListRow(RSViewHelper.MakeCreateObjectLink(PT_CLASSIDS.PT_WEBSERVICE_ID,
       RSModelHelper.WSTYPE_AWS, nFolderID, m_asOwner.GetString(1874, "ptmsgs_portaladminmsgs"),
       m_asOwner, strArg, true));
      m_chHelper.displayListRow(RSViewHelper.MakeCreateObjectLink(PT_CLASSIDS.PT_WEBSERVICE_ID,
       RSModelHelper.WSTYPE_CWS, nFolderID, m_asOwner.GetString(1876, "ptmsgs_portaladminmsgs"),
       m_asOwner, strArg, true));
      m_chHelper.displayListRow(RSViewHelper.MakeCreateObjectLink(PT_CLASSIDS.PT_WEBSERVICE_ID,
       RSModelHelper.WSTYPE_HTTPGP, nFolderID, m_asOwner.GetString(1875, "ptmsgs_portaladminmsgs"),
       m_asOwner, strArg, true));
      m_chHelper.displayListRow(RSViewHelper.MakeCreateObjectLink(PT_CLASSIDS.PT_WEBSERVICE_ID,
       RSModelHelper.WSTYPE_SWS, nFolderID, m_asOwner.GetString(1877, "ptmsgs_portaladminmsgs"),
       m_asOwner, strArg, true));
      m_chHelper.displayListRow(RSViewHelper.MakeCreateObjectLink(PT_CLASSIDS.PT_WEBSERVICE_ID,
       RSModelHelper.WSTYPE_PWS, nFolderID, m_asOwner.GetString(1878, "ptmsgs_portaladminmsgs"),
       m_asOwner, strArg, true));
      m_chHelper.displayEmptyRow(result);
      //Display the standard warning if everyone has access to this object
      m_chHelper.displayEveryoneWarning(result, (RemoteServerModel) m_model,
       m_asOwner.GetString(2270, "ptmsgs_portaladminmsgs"));
      return result;
    }
  }
}