using System;
// Framework Imports
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.filter;
using com.plumtree.portaluiinfrastructure.resultwrapper;
using com.plumtree.server;
namespace com.plumtree.portalpages.admin.editors.savedsearch
{
  /// <author>
  /// MikeS
  /// ???
  /// </author>
  public interface ISavedSearchModelRO : IObjEditorModelRO,IFilterIteratorContainerRO
  {
    
    /// <returns></returns>
    bool AreClassIDsShown();
    
    /// <returns></returns>
    IPTSearchResponse GenerateResponse();
    
    /// <returns></returns>
    XPArrayList GetAdmFolderIDs();
    
    /// <returns></returns>
    XPArrayList GetCatFolderIDs();
    
    /// <returns></returns>
    XPArrayList GetSelectedFolderIDs(int _type, bool _accessible);
    
    /// <returns></returns>
    String GetLastAdmTreeSpaceId();
    
    /// <returns></returns>
    String GetLastCatTreeSpaceId();
    
    /// <returns></returns>
    int GetMaxResults();
    
    /// <returns></returns>
    /// <deprecated>the portlet format & presentation style are now set via the portlet editor </deprecated>
    String GetPortletFormat();
    
    /// <returns></returns>
    IASQueryResult GetProperties();
    
    /// <returns></returns>
    String GetSelectedOrderProp();
    
    /// <returns></returns>
    bool GetSortAscending();
    
    /// <returns></returns>
    bool IsAscending();
    
    /// <param name="strClassid"></param>
    /// <returns></returns>
    bool IsClassIDChecked(String strClassid);
    
    /// <returns></returns>
    bool ShouldRegenerate();
    
    /// <returns></returns>
    bool SubscriptionEnabled();
    
    /// <returns></returns>
    bool GetApplyRecursive();
    
    /// <returns></returns>
    int[] GetDisplayFields();
    
    /// <returns></returns>
    Object[][] GetDisplayFieldsInfo();
    
    /// <summary>
    /// Returns a bitmask of the enabled repositories.
    /// Possible Repositories:
    /// SavedSearchModel.REPOSITORY_KD
    /// SavedSearchModel.REPOSITORY_ADMIN
    /// SavedSearchModel.REPOSITORY_COLLAB
    /// SavedSearchModel.REPOSITORY_CONTENT
    /// </summary>
    /// <returns>bitmask of enabled repsitories.</returns>
    int GetRepositories();
    
    /// <summary>
    /// Returns a bitmask of the enabled knowledge directory types.
    /// Possible KD Types:
    /// SavedSearchModel.KDTYPES_FOLDERS
    /// SavedSearchModel.KDTYPES_DOCUMENTS
    /// </summary>
    /// <returns>bitmask of enabled knowledge directory types.</returns>
    int GetKDTypes();
    bool IsCollabInstalled();
    bool IsContentInstalled();
  }
}