using System;
using com.plumtree.portalpages.common.objects.sort;
using com.plumtree.server;
namespace com.plumtree.portalpages.admin.editors.savedsearch
{
  /// <author>RajaM</author>
  public class PTFolderObjectNameGetter : IPTObjectNameGetter
  {
    private int m_classid;
    
    /// <summary>
    /// Creates a new PTFolderObjectNameGetter object.
    /// </summary>
    /// <param name="classid"></param>
    public PTFolderObjectNameGetter(int classid)
    {
      m_classid = classid;
    }
    public virtual String GetName(int id, IPTSession ptSession)
    {
      String[] strName = GetItem(id, ptSession);
      if (null != strName)
      {
        return strName[0];
      } else
      {
        return null;
      }
    }
    
    /// <param name="id"></param>
    /// <param name="ptSession"></param>
    /// <returns></returns>
    public virtual String[] GetItem(int id, IPTSession ptSession)
    {
      String[] strFolderInfo = new String[2];
      try
      {
        if (m_classid == PT_CLASSIDS.PT_CATALOGFOLDER_ID)
        {
          IPTFolder ptFolder;
          ptFolder = ptSession.GetCatalog().OpenFolder(id, false);
          if (null != ptFolder)
          {
            strFolderInfo[0] = ptFolder.GetLocalizedName();
            strFolderInfo[1] = ptFolder.GetPath();
            return strFolderInfo;
          } else
          {
            return null;
          }
        } else
        {
          IPTAdminFolder ptFolder = ptSession.GetAdminCatalog().OpenAdminFolder(id,
           false);
          if (null != ptFolder)
          {
            strFolderInfo[0] = ptFolder.GetLocalizedName();
            strFolderInfo[1] = ptFolder.GetPath();
            return strFolderInfo;
          } else
          {
            return null;
          }
        }
      }
      catch (Exception e)
      {
        strFolderInfo[0] = "";
        strFolderInfo[1] = "";
        return strFolderInfo;
      }
    }
  }
}