using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.common.constants;
using com.plumtree.portaluiinfrastructure.classtypedescriptors.classtypes;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.expandablelist.selectptobject;
using com.plumtree.portaluiinfrastructure.opener;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.arraywrapper;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.opener;
using com.plumtree.xpshared.htmlconstructs;
namespace com.plumtree.portalpages.admin.editors.savedsearch
{
  /// <author>
  /// joseq
  /// This class doesn't change much from SelectPTObjectModel.  The purpose of it is just to 
  /// use the QS variables of IPTOpenerConstant for the edit links instead
  /// of the ObjEditorModel ones.
  /// </author>
  public class PortletSelectModel : SelectPTObjectModel,IPortletSelectModelRO
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_UI_INFRASTRUCTURE),
     "com.plumtree.portalpages.admin.editors.savedsearch.PortletSelectModel");
    
    /// <summary>
    /// Class name for the activity space 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "SQPortletSelect";
    private IPTSession m_ptSession;
    private int m_iSnapshotID;
    public PortletSelectModel() : base()
    {
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new PortletSelectModel();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    public virtual void InitializePortletSelectModel(IPTSession _ptSession,
     int _iSnapshotID, String _sSectionTitle, String _sSectionSubTitle, int _id)
    {
      m_ptSession = _ptSession;
      m_iSnapshotID = _iSnapshotID;
      InitializeSelectPTObject(_sSectionTitle, _sSectionSubTitle, PTImageType.ICON_PORTLET,
       m_asOwner.GetString(3016, ResourceConstants.PORTALADMINMSGS), new int[]{PT_CLASSIDS.PT_GADGET_ID},
       _id);
      if (CanCreatePortlet())
      {
        SetTableInstructions(m_asOwner.GetString(3017, ResourceConstants.PORTALADMINMSGS));
        } else
      {
        SetTableInstructions(m_asOwner.GetString(3140, ResourceConstants.PORTALADMINMSGS));
        }
      SetTreeTitle(m_asOwner.GetString(3018, ResourceConstants.PORTALADMINMSGS));
      SetTreeSubTitle(m_asOwner.GetString(3018, ResourceConstants.PORTALADMINMSGS));
      SetEmptyListMessages(m_asOwner.GetString(3019, ResourceConstants.PORTALADMINMSGS),
       CanCreatePortlet() ? m_asOwner.GetString(3020, ResourceConstants.PORTALADMINMSGS) : "");
      /* set our options */
      SetDefaultRowIcon(PTImageType.ICON_PORTLET);
      SetEnableMoveRowActions(false);
      DisableAddButton();
      DisableCheckBoxes();
      /* set our create array */
      Object[][] arrCreateNewInfo = new Object[1][];
      for (int j2c_index = 0;j2c_index < 1;j2c_index++)
      {
        arrCreateNewInfo[j2c_index] = new Object[SelectPTObjectModel.CREATE_NEW_COL_MAX];
        }
      arrCreateNewInfo[0][SelectPTObjectModel.CREATE_NEW_COL_CLASSID] = PT_CLASSIDS.PT_GADGET_ID;
      arrCreateNewInfo[0][SelectPTObjectModel.CREATE_NEW_COL_ASNAME] = BaseOpenerAS.STR_MVC_CLASS_NAME;
      arrCreateNewInfo[0][SelectPTObjectModel.CREATE_NEW_COL_LABEL] = m_asOwner.GetString(3021,
       ResourceConstants.PORTALADMINMSGS);
      arrCreateNewInfo[0][SelectPTObjectModel.CREATE_NEW_COL_ICON] = PTImageType.ICON_PORTLET;
      SetEnableCreateNew(arrCreateNewInfo);
      /* sets our list.  UNKNOWN ID is when we are in create mode, that's ok, we just
       * don't have any default rows */
       
      if (ObjEditorModel.EDITOR_OBJECTID_UNKNOWN != m_iSnapshotID)
      {
        RefreshPortletList();
        /* sort it */
        int[][] arrSort = m_saData.GetSort();
        arrSort[0][PTSortedArrayWrapper.PTSAW_SORT_ROW_PROPID] = EXPLIST_COL_STRING;
        arrSort[0][PTSortedArrayWrapper.PTSAW_SORT_ROW_DIRECTION] = PTSortedArrayWrapper.PTSAW_SORT_ASCENDING;
        m_saData.Sort(arrSort);
      }
    }
    /* (non-Javadoc)
     * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#DoTaskOnComeBackFromSubEditor()
     */
     
    public override void DoTaskOnComeBackFromSubEditor()
    {
      RefreshPortletList();
    }
    /* (non-Javadoc)
     * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#AddControlParamsToURL(int, com.plumtree.uiinfrastructure.activityspace.ASURL)
     *
     * This the same code that is in SelectPTObjectModel, except that we are using the
     * QS variables in IPTOpenerConstants instead of ObjEditorModel ones.
     */
     
    public override void AddControlParamsToURL(int _nClassID, ASURL myURL)
    {
      Object oParams = null;
      String[][] arParams = null;
      bool bFoundFolderID = false;
      for (int i = 0;i < m_arrCreateNewInfo.Length;i++)
      {
        int nClassIDFromArray = XPConvert.ToInteger(m_arrCreateNewInfo[i][CREATE_NEW_COL_CLASSID]);
        if (nClassIDFromArray == _nClassID)
        {
          if (m_arrCreateNewInfo[i].Length >= CREATE_NEW_COL_MAXWITHPARAMS)
          {
            oParams = m_arrCreateNewInfo[i][CREATE_NEW_COL_PARAMS];
            break;
          }
        }
      }
      if (null != oParams)
      {
        arParams = (String[][]) oParams;
        for (int j = 0;j < arParams.Length;j++)
        {
          if ((null != arParams[j]) && (2 == arParams[j].Length))
          {
            String strName = arParams[j][PARAM_COL_PARAMNAME];
            if ((null != strName) && (0 != strName.Length))
            {
              String strValue = arParams[j][PARAM_COL_PARAMVALUE];
              // Add the parameter to the url.
              myURL.AddControlArgument(strName, strValue);
              if (XPStringUtility.EqualsIgnoreCase(strName, IPTOpenerConstants.QS_FOLDERID))
              {
                bFoundFolderID = true;
              }
            }
          }
        }
      } else
      {
        log.Debug("AddControlParamsToURL: Unable to retrieve control info.");
        }
      if (!bFoundFolderID)
      {
        try
        {
          ObjEditorModel myModel = (ObjEditorModel) m_asOwner.GetModel(((ObjEditorAS) m_asOwner).m_strModelName);
          int nFolderID = myModel.GetFolderID();
          myURL.AddControlArgument(IPTOpenerConstants.QS_FOLDERID, XPConvert.ToString(nFolderID));
          }
        catch (Exception e)
        {
          log.Warn("Could not retrieve the Admin Folder ID from the current Editor." + " No Admin Folder will be pre-selected in the save-as pop-up of sub Editors.");
          }
      }
    }
    /* (non-Javadoc)
     * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.ISelectPTObjectModelRO#GetCreateNewURL(int, java.lang.String)
     */
     
    public override ASURL GetCreateNewURL(int _nClassID, String _sEditorASName)
    {
      ASURL myURL = new ASURL(m_asOwner);
      myURL.SetLinkCreateNewSpace(_sEditorASName, m_asOwner);
      myURL.SetControl(EditorStartControl.STR_MVC_CLASS_NAME);
      myURL.SetSubSpaceKey(_sEditorASName);
      myURL.AddControlArgument(EditorStartControl.QS_EDITOR_TYPE, XPConvert.ToString(EditorStartControl.EDITOR_START_FLAG_CREATE));
      myURL.AddControlArgument(EditorStartControl.QS_DELETE_ON_CANCEL, XPConvert.ToString(true));
      myURL.AddControlArgument(IPTOpenerConstants.QS_CLASSID, XPConvert.ToString(_nClassID));
      myURL.AddControlArgument(IPTOpenerConstants.QS_MODE, XPConvert.ToString(IPTOpenerConstants.OPENER_MODE_CREATE));
      myURL.AddControlArgument(PTPortlets.PORTLET_EDITOR_QS_INT_CREATOR_CLASSID,
       XPConvert.ToString(PT_CLASSIDS.PT_GADGETTEMPLATE_ID));
      myURL.AddControlArgument(PTPortlets.PORTLET_EDITOR_QS_INT_CREATOR_ID,
       XPConvert.ToString(PT_INTRINSICS.PT_GADGET_SAVEDSEARCHES));
      // Get the extra control arguments
      AddControlParamsToURL(_nClassID, myURL);
      return myURL;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.ISelectPTObjectModelRO#GetEditObjectURL(int, int)
     *
     * This the same code that is in SelectPTObjectModel, except that we are using the
     * QS variables in IPTOpenerConstants instead of ObjEditorModel ones.
     */
     
    public override ASURL GetEditObjectURL(int _nClassID, int _nObjectID)
    {
      ASURL myURL = new ASURL(m_asOwner);
      // JF- For any Object in the list, the sub space key will be 
      // this Model name with the object class id and the object id.
      String sSubEditorKey = STR_MVC_CLASS_NAME + _nClassID + _nObjectID;
      if (m_asOwner.GetSubSpaceExists(sSubEditorKey))
      {
        EditorAS mySubEditor = (EditorAS) m_asOwner.GetSubSpace(sSubEditorKey);
        myURL.SetLinkGetCachedSpace(mySubEditor);
      } else
      {
        myURL.SetLinkCreateNewSpace(GetEditorASName(_nClassID), m_asOwner);
        myURL.SetSubSpaceKey(sSubEditorKey);
        myURL.AddControlArgument(EditorStartControl.QS_EDITOR_TYPE, XPConvert.ToString(EditorStartControl.EDITOR_START_FLAG_EDIT));
        myURL.AddControlArgument(IPTOpenerConstants.QS_CLASSID, XPConvert.ToString(_nClassID));
        myURL.AddControlArgument(IPTOpenerConstants.QS_OBJECTID, XPConvert.ToString(_nObjectID));
        myURL.AddControlArgument(IPTOpenerConstants.QS_MODE, XPConvert.ToString(IPTOpenerConstants.OPENER_MODE_EDIT));
        }
      AddControlParamsToURL(_nClassID, myURL);
      return myURL;
    }
    
    /// <summary>
    /// sets the id of the query to use.  The list can optionally be refreshed, otherwise,
    /// RefreshPortletList() must be called to refresh the list using the newly added 
    /// snapshot query id. 
    /// </summary>
    /// <param name="_iSnapshotID">snapshot query id</param>
    /// <param name="_bRefresh">true to refresh the list</param>
    public virtual void SetSnapshotQueryID(int _iSnapshotID, bool _bRefresh)
    {
      m_iSnapshotID = _iSnapshotID;
      if (_bRefresh)
      {
        RefreshPortletList();
      }
    }
    
    /// <summary>
    /// method to refresh the snapshot query's list of portlets.
    /// </summary>
    public virtual void RefreshPortletList()
    {
      /* update the portlet list */
      m_saData.ClearArray();
      if (ObjEditorModel.EDITOR_OBJECTID_UNKNOWN != m_iSnapshotID)
      {
        IPTQueryResult qrPortlets = ((IPTSavedSearch) m_ptSession.GetSavedSearches().Open(m_iSnapshotID,
         false)).QueryPortletList();
        if (qrPortlets.RowCount() > 0)
        {
          int cnt = qrPortlets.RowCount();
          Object[][] arPortlets = new Object[cnt][];
          for (int j2c_index = 0;j2c_index < cnt;j2c_index++)
          {
            arPortlets[j2c_index] = new Object[SelectPTObjectModel.EXPLIST_COL_MAX];
            }
          for (int i = 0;i < cnt;i++)
          {
            int id = qrPortlets.ItemAsInt(i, PT_PROPIDS.PT_PROPID_OBJECTID);
            //TODO: jhq error check
            IPTQueryResult qrResults = m_ptSession.GetGadgets().QuerySingleObject(id);
            String name = qrResults.ItemAsString(0, PT_PROPIDS.PT_PROPID_NAME);
            arPortlets[i][EXPLIST_SORTEDARRAY_PROPID_INDEX] = m_nNextIndex;
            m_nNextIndex++;
            arPortlets[i][EXPLIST_COL_CLASSID] = PT_CLASSIDS.PT_GADGET_ID;
            arPortlets[i][EXPLIST_COL_OBJECTID] = id;
            arPortlets[i][EXPLIST_COL_STRING] = name;
          }
          m_saData.AddRows(arPortlets);
        }
      }
    }
    public virtual bool CanCreatePortlet()
    {
      return m_ptSession.GetSessionInfo().CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_CREATE_PORTLETS);
      }
    
    /// <summary>
    /// Helper method to get the EditorAS object name from the class ID.
    /// </summary>
    /// <param name="_nClassID"></param>
    /// <returns>String</returns>
    private String GetEditorASName(int _nClassID)
    {
      String sASName = null;
      int nClassIDFromArray;
      for (int i = 0;i < m_arrCreateNewInfo.Length;i++)
      {
        nClassIDFromArray = XPConvert.ToInteger(m_arrCreateNewInfo[i][CREATE_NEW_COL_CLASSID]);
        if (nClassIDFromArray == _nClassID)
        {
          sASName = (String) m_arrCreateNewInfo[i][CREATE_NEW_COL_ASNAME];
          break;
        }
      }
      return sASName;
    }
  }
}