using System;
// Framework Imports
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.common.constants;
using com.plumtree.portaluiinfrastructure.resultwrapper;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.savedsearch
{
  /// <author>MikeS</author>
  public class ResultFormatView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.savedsearch.ResultFormatView");
    public const String STR_MVC_CLASS_NAME = "ResultFormatView";
    public const String HTMLSELECTORDERPROP = "in_se_OrderProp";
    public const String HTMLINPUT_MAXRESULTS = "in_tx_MaxResults";
    public const String HTMLSELECTRESULTDETAIL = "in_se_ResultDetail";
    public const String HTMLRADIO_RESULTDIRECTION = "in_ra_Direction";
    public const String HTMLCHECKBOX_MAIL = "in_cb_mail";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new ResultFormatView();
    }
    
    /// <returns></returns>
    public override HTMLElement Display()
    {
      //	    TODO: jhq- inplace refresh
      //		HTMLElementCollection resultWrapper = new HTMLElementCollection();
      //
      //		HTMLSpan resultSpan = new HTMLSpan();
      // 		resultSpan.SetID("myuniquestringtestOK");
      // 		resultWrapper.AddInnerHTMLElement(resultSpan);
      HTMLElementCollection result = new HTMLElementCollection();
      // 		resultSpan.AddInnerHTMLElement(result);
      try
      {
        AddResultParameters(result);
      }
      catch (Exception e)
      {
        log.Error(e, "SavedSearchResultFormat::Display. " + m_asOwner.GetString(746,
         "ptmsgs_portaladminmsgs") + ": " + e.Message);
        throw new XPException(m_asOwner.GetString(746, "ptmsgs_portaladminmsgs"),
         e);
      }
      return result;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
     */
     
    public override HTMLScript DisplayJavascript()
    {
      HTMLScript script = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
      //TODO: jhq try to do inplace refresh
      //        XPStringBuilder sb = new XPStringBuilder();
      //        sb.Append("function OnDone()\n");
      //		sb.Append("{\n");
      //			if (m_asOwner.GetIsInPlaceRefreshEnabled())
      //			{
      //					sb.Append(InPlaceRefreshHelper.GetJSSendPOSTOnAFormDP(
      //		    		    	m_asOwner.GetCurrentNormalizedBaseURL(),
      //		    		    	"myuniquestringtestOK",
      //		    		    	RepostControl.POSTTOSELF_ACTION_SIMPLEREPOST)+";\n")
      //		    		  .Append("\n");		    		    	
      //			}
      //			else
      //			{
      //				// JF- Then we repost the main form
      //			    
      //				sb.Append(AFormDP.JAVASCRIPT_SUBMIT_FORM+"("+RepostControl.POSTTOSELF_ACTION_SIMPLEREPOST+");\n");
      //			}
      //			sb.Append("		return true;\n");
      //			sb.Append("}\n");
      //			
      //			script.AddInnerHTMLString(sb.ToString());
      // add prop selector js
      script.AddInnerHTMLString(((EditorView) m_asOwner.GetView(SavedSearchEditorAS.STR_MVC_SELECT_DISPLAY_PROPS)).DisplayJavascript().GetInnerHTML());
      return script;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    private HTMLSelect GetOrderByDropdown()
    {
      HTMLSelect mySelect = new HTMLSelect(HTMLSELECTORDERPROP, "");
      mySelect.SetStyleClass(PTStyleClass.FORM_PULLDOWN_TEXT);
      mySelect.SetOnChange(AFormDP.JAVASCRIPT_SUBMIT_FORM + "(" + RepostControl.POSTTOSELF_ACTION_SIMPLEREPOST + ")");
      IASQueryResult Properties = ((ISavedSearchModelRO) m_model).GetProperties();
      String strSelected = ((ISavedSearchModelRO) m_model).GetSelectedOrderProp();
      HTMLOption relOption = new HTMLOption("0");
      relOption.AddInnerHTMLString(m_asOwner.GetString(750, "ptmsgs_portaladminmsgs"));
      mySelect.AddInnerHTMLElement(relOption);
      if (strSelected.Equals("0"))
      {
        relOption.SetSelected(true);
      }
      for (int i = 0;i < Properties.GetCount();i++)
      {
        int type = XPConvert.ToInteger(Properties.GetFields(i, PT_PROPIDS.PT_PROPID_PROP_VALUETYPE));
        String strID = XPConvert.ToString(Properties.GetFields(i, PT_PROPIDS.PT_PROPID_OBJECTID));
        if ((PT_PROPERTY_TYPES.PT_PROPTYPE_DATE == type) || (PT_PROPERTY_TYPES.PT_PROPTYPE_DOUBLE == type) || (PT_PROPERTY_TYPES.PT_PROPTYPE_LONG == type) || 
        // name too!
        strID.Equals("1"))
        {
          HTMLOption myOption = new HTMLOption(strID);
          myOption.AddInnerHTMLEncodedString((String) Properties.GetFields(i,
           PT_PROPIDS.PT_PROPID_NAME));
          if (strID.Equals(strSelected))
          {
            myOption.SetSelected(true);
          }
          mySelect.AddInnerHTMLElement(myOption);
        }
      }
      return mySelect;
    }
    
    /// <param name="result"></param>
    /// <throws>HTMLException</throws>
    private void AddResultParameters(HTMLElementCollection result)
    {
      result.AddInnerHTMLElement(base.GetHeaderView(m_asOwner.GetString(747,
       "ptmsgs_portaladminmsgs")));
      String tab = CommonHTMLStrings.SPACE + CommonHTMLStrings.SPACE + CommonHTMLStrings.SPACE;
      result.AddInnerHTMLElement(GetShortSpacerTable());
      HTMLTable myTable;
      myTable = new HTMLTable();
      result.AddInnerHTMLElement(myTable);
      myTable.SetWidth("100%");
      myTable.SetBorder("0");
      myTable.SetCellPadding("2");
      myTable.SetCellSpacing("0");
      //**** FIRST, query settings
      HTMLTableRow myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
      HTMLTableCell myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetColSpan("2");
      myCell.SetStyleClass(PTStyleClass.OBJECT_SUBHEAD);
      myCell.AddInnerHTMLString(m_asOwner.GetString(3014, ResourceConstants.PORTALADMINMSGS));
      myCell.SetHeight("30");
      // max items returned
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
      // max item text
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
      myCell.AddInnerHTMLString(m_asOwner.GetString(3015, ResourceConstants.PORTALADMINMSGS));
      myCell.SetNoWrap(true);
      // max item input box
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetWidth("100%");
      HTMLInput myInput = new HTMLInput(HTMLInputTypes.TEXT_TYPE, HTMLINPUT_MAXRESULTS,
       "");
      myCell.AddInnerHTMLElement(myInput);
      int resultcount = ((ISavedSearchModelRO) m_model).GetMaxResults();
      myInput.SetValue(XPConvert.ToString(resultcount));
      myInput.SetSize(3);
      myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
      // orderby row
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
      // orderby text
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
      myCell.AddInnerHTMLString(tab + m_asOwner.GetString(748, "ptmsgs_portaladminmsgs"));
      myCell.SetAlign(CommonHTMLStrings.RIGHT);
      // orderby dropdown 
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.AddInnerHTMLElement(GetOrderByDropdown());
      // order direction row - you can not change the sort order of relevancy
      if (!XPStringUtility.EqualsIgnoreCase("0", ((ISavedSearchModelRO) m_model).GetSelectedOrderProp()))
      {
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        // direction text
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.AddInnerHTMLString(tab + m_asOwner.GetString(749, "ptmsgs_portaladminmsgs"));
        myCell.SetVAlign(CommonHTMLStrings.TOP);
        myCell.SetAlign(CommonHTMLStrings.RIGHT);
        // ascending radio
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myInput = new HTMLInput(HTMLInputTypes.RADIO, HTMLRADIO_RESULTDIRECTION,
         "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetValue("asc");
        myInput.SetChecked(((ISavedSearchModelRO) m_model).IsAscending());
        myCell.AddInnerHTMLString(m_asOwner.GetString(1880, "ptmsgs_portaladminmsgs"));
        myCell.AddInnerHTMLElement(new HTMLBr());
        // descending radio
        myInput = new HTMLInput(HTMLInputTypes.RADIO, HTMLRADIO_RESULTDIRECTION,
         "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetValue("dsc");
        myInput.SetChecked(!((ISavedSearchModelRO) m_model).IsAscending());
        myCell.AddInnerHTMLString(m_asOwner.GetString(1881, "ptmsgs_portaladminmsgs"));
        }
      //**** add display properties select view
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
      /* cells to hold inner table */
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.AddInnerHTMLElement(new HTMLBr());
      myCell.SetColSpan("2");
      /* inner table to hold select view */
      HTMLTable myInnerTable = new HTMLTable();
      myCell.AddInnerHTMLElement(myInnerTable);
      myInnerTable.SetWidth("90%");
      myInnerTable.SetBorder("0");
      myInnerTable.SetCellPadding("0");
      myInnerTable.SetCellSpacing("0");
      myRow = new HTMLTableRow();
      myInnerTable.AddInnerHTMLElement(myRow);
      myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
      /* first cell a spacer cell */
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      myCell.SetWidth("90");
      /* second cell to hold view */
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetStyleClass(PTStyleClass.PLATPORTLET_BORDER);
      myCell.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(SavedSearchEditorAS.STR_MVC_SELECT_DISPLAY_PROPS)).Display());
      AddEmptyRowToTable(myTable, "3");
      //**** THIRD, OTHER OPTIONS + email subs
      AddEmptyRowToTable(myTable, "3");
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetColSpan("2");
      myCell.SetStyleClass(PTStyleClass.OBJECT_SUBHEAD);
      myCell.AddInnerHTMLString(m_asOwner.GetString(3165, ResourceConstants.PORTALADMINMSGS));
      myCell.SetHeight("30");
      // email subscription row 
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
      // email subscriptions checkbox
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetColSpan("2");
      myCell.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
      myCell.AddInnerHTMLString(tab);
      myInput = new HTMLInput(HTMLInputTypes.CHECKBOX, HTMLCHECKBOX_MAIL,
       "");
      myCell.AddInnerHTMLElement(myInput);
      myInput.SetChecked(((ISavedSearchModelRO) m_model).SubscriptionEnabled());
      myInput.SetValue("mail");
      myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
      // email subscription text
      myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      myCell.AddInnerHTMLString(m_asOwner.GetString(761, "ptmsgs_portaladminmsgs"));
      AddEmptyRowToTable(myTable, "3");
    }
  }
}