using System;
// Framework Imports
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.common.constants;
using com.plumtree.portalpages.common.search;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.savedsearch
{
  /// <author>
  /// MichaelS
  /// This class used be named SavSrchSettingsView and contained code for displaying
  /// filtering settings & folder constraints settings.  All the code for folder constraints
  /// have been moved elsewhere as follows:
  /// SavSrchMainDP - All common tree control code
  /// SnapshotADConstraintsView - Display of Admin folders
  /// SnapshotKDConstraintsView - Display of Knowledge Dir folders
  /// </author>
  public class SavSrchFilterView : FilterView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.savedsearch.SavSrchFilterView");
    
    /// <summary>
    /// The unique identifier for the class 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "SavSrchFilter";
    
    /// <summary>
    /// Checkbox for move 
    /// </summary>
    public const String HTMLCHECKBOX_MOVE = "in_cb_move";
    // member variables
    protected PTStyleClass m_styleListItem = null;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SavSrchFilterView();
    }
    
    /// <summary>
    /// Display for the HTML for this view
    /// </summary>
    /// <returns>HTMLElement</returns>
    public override HTMLElement Display()
    {
      SetStatementCount(5);
      HTMLElementCollection result = new HTMLElementCollection();
      try
      {
        base.SetViewTitle(m_asOwner.GetString(777, "ptmsgs_portaladminmsgs"));
        result.AddInnerHTMLElement(base.Display());
      }
      catch (Exception e)
      {
        log.Error(e, "SavSrchFilterView::Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(2974, ResourceConstants.PORTALADMINMSGS),
         e);
      }
      return result;
    }
    
    /// <summary>
    /// Display the javascript for this view
    /// </summary>
    /// <returns>HTMLScript</returns>
    public override HTMLScript DisplayJavascript()
    {
      base.SetRepostAction(SavedSearchRepostControl.POSTTOSELF_ACTION_SIMPLEREPOST);
      return base.DisplayJavascript();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}