using System;
// Framework imports
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.browsing.objectselection;
using com.plumtree.portalpages.browsing.objectselection.portlets;
using com.plumtree.portalpages.browsing.portletpreview;
using com.plumtree.portalpages.common.helpers;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.resultwrapper;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.savedsearch
{
  /// <summary>
  /// This Section contains the HTML for the dependencies page.
  /// </summary>
  /// <author></author>
  public class SavedSearchDependenciesView : ObjDependenciesView
  {
    //Member variables
    private CreatedHelper m_chHelper = null;
    
    /// <summary>
    /// Class name for the activity space
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "SavedSearchDependencies";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SavedSearchDependenciesView();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(com.plumtree.uiinfrastructure.activityspace.IModelRO,com.plumtree.uiinfrastructure.activityspace.AActivitySpace)"></seealso>
    public override void Init(IModelRO model, AActivitySpace parent)
    {
      base.Init(model, parent);
      m_chHelper = new CreatedHelper(parent, (SavedSearchModel) model);
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.ObjDependenciesView#GetHTMLForDependencies()"></seealso>
    protected override HTMLElementCollection GetHTMLForDependencies()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLAnchor myAnchor;
      //Display the standard success message
      String strName = ((ObjEditorModel) m_model).GetObjectName();
      m_chHelper.displaySuccessMessage(result, m_asOwner.GetString(2271, "ptmsgs_portaladminmsgs"),
       strName, ((ObjEditorModel) m_model).GetParentFolderPath());
      /* qry for all portlets created with this qry */
      IPTSession mySession = ((ObjEditorModel) m_model).GetPTSession();
      ASQueryResultWrapper myQR = new ASQueryResultWrapper(((IPTSavedSearch) ((ObjEditorModel) m_model).GetObject()).QueryPortletList());
      /* for each portlet, display name and invite link */
      for (int i = 0;i < myQR.GetCount();i++)
      {
        Object intPortletID = myQR.GetFields(i, PT_PROPIDS.PT_PROPID_OBJECTID);
        if (null != intPortletID && XPConvert.ToInteger(intPortletID) > 0)
        {
          IPTQueryResult qrPortlet = mySession.GetGadgets().QuerySingleObject(XPConvert.ToInteger(intPortletID));
          /* show portlet name */
          m_chHelper.displayTextRow(result, 5, m_asOwner.GetString(2272, "ptmsgs_portaladminmsgs"),
           qrPortlet.ItemAsString(0, PT_PROPIDS.PT_PROPID_NAME));
          //Generate a popup URL to invite people to the portlet
          ASURL asurl = new ASURL(m_asOwner);
          asurl.SetLinkGetSpaceIfCached(PortletSelectionEditorAS.STR_MVC_CLASS_NAME,
           m_asOwner);
          asurl.SetControl(InvitationPopupControl.STR_MVC_CLASS_NAME);
          asurl.SetDisplayPage(PortletInvitationPopupDP.STR_MVC_CLASS_NAME);
          asurl.AddControlArgument(InvitationPopupControl.strTemporaryInvitationID,
           XPConvert.ToString(intPortletID));
          asurl.AddControlArgument(InvitationPopupControl.strTemporaryInvitationName,
           ((SavedSearchModel) m_model).GetObjectName());
          String strJSUtilVersionPrefix = ConfigHelper.GetJSIncluderVersionPrefix(ConfigHelper.JSCOMPONENT_JSUTIL);
          myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
          myAnchor.SetHRef(ConstructStaticHelpers.BLANK_URL);
          myAnchor.SetOnClick(strJSUtilVersionPrefix + "PTWindowUtil.openWindow(\'" + asurl.GetURLAsString() + "\', \'SendToOthers\', \'250\',\'600\'); return false;");
          m_chHelper.beginList(result);
          HTMLSpan mySpan = new HTMLSpan();
          mySpan.AddInnerHTMLString(m_asOwner.GetString(2273, "ptmsgs_portaladminmsgs"));
          myAnchor.AddInnerHTMLElement(mySpan);
          m_chHelper.displayListRow(myAnchor);
        }
      }
      //Display the standard warning if everyone has access to this object
      m_chHelper.displayEveryoneWarning(result, (SavedSearchModel) m_model,
       m_asOwner.GetString(2271, "ptmsgs_portaladminmsgs"));
      return result;
    }
  }
}