using System;
// Framework Imports
using com.plumtree.portalpages.common.documentlanguage;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.admin.editors.savedsearch
{
  /// <author>MikeS</author>
  public class SavedSearchRepostControl : ObjEditorRepostControl
  {
    
    /// <summary>
    /// The unique name for this class 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "SavedSearchRepost";
    
    /// <summary>
    /// Add an admin folder 
    /// </summary>
    public const int ACTION_ADDADMINFOLDER = 10;
    
    /// <summary>
    /// Delete an Admin folder 
    /// </summary>
    public const int ACTION_DEL = 11;
    
    /// <summary>
    /// Sort the folders 
    /// </summary>
    public const int ACTION_SORT = 12;
    
    /// <summary>
    /// Add a catalog folder 
    /// </summary>
    public const int ACTION_ADDCATALOGFOLDER = 13;
    
    /// <summary>
    /// Add a catalog folder 
    /// </summary>
    public const int ACTION_CREATE_PORTLET = 14;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SavedSearchRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call
    /// the associated method for each action.
    /// </summary>
    /// <param name="_nAction"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      ((CardLanguagePlugInRepostControl) m_asOwner.GetControl(SavedSearchEditorAS.strCardLanguagePlugInKey)).PerformRepostAction(_nAction,
       m_htFormData);
      ((ExpListControl) m_asOwner.GetControl(SavedSearchEditorAS.STR_MVC_SELECT_COLLAB_PROJECT)).PerformRepostAction(_nAction,
       m_htFormData);
      ((ExpListControl) m_asOwner.GetControl(SavedSearchEditorAS.STR_MVC_SELECT_DISPLAY_PROPS)).PerformRepostAction(_nAction,
       m_htFormData);
      ((ExpListControl) m_asOwner.GetControl(SavedSearchEditorAS.STR_MVC_SELECT_CONTENT)).PerformRepostAction(_nAction,
       m_htFormData);
      ((ExpListControl) m_asOwner.GetControl(SavedSearchEditorAS.STR_MVC_SELECT_PORTLETS)).PerformRepostAction(_nAction,
       m_htFormData);
      if (_nAction > 1000)
      {
        _nAction-=1000;
      }
      switch (_nAction){
      case SavedSearchRepostControl.POSTTOSELF_ACTION_GOTOPAGE:
      case SavedSearchRepostControl.POSTTOSELF_ACTION_FINISH:
      case CardLanguagePlugInRepostControl.POSTTOSELF_ACTION_SHOW_POPULAR:
      case CardLanguagePlugInRepostControl.POSTTOSELF_ACTION_SHOW_ALL:
      case SavedSearchRepostControl.POSTTOSELF_ACTION_SIMPLEREPOST:
      break;
      case ACTION_ADDADMINFOLDER:
      ((SavedSearchModel) m_model).OnAdd(ACTION_ADDADMINFOLDER);
      break;
      case ACTION_ADDCATALOGFOLDER:
      ((SavedSearchModel) m_model).OnAdd(ACTION_ADDCATALOGFOLDER);
      break;
      case ACTION_DEL:
      ((SavedSearchModel) m_model).OnDel();
      break;
      case ACTION_SORT:
      ((SavedSearchModel) m_model).OnSort();
      break;
      case ACTION_CREATE_PORTLET:
      ((SavedSearchModel) m_model).OnCreatePortlet();
      break;
      }
    }
    
    /// <summary>
    /// Set the repost action
    /// </summary>
    protected override void SetRepostAction()
    {
      base.SetRepostAction();
      GetModel().m_nAction = m_nAction;
    }
    
    /// <returns></returns>
    protected virtual SavedSearchModel GetModel()
    {
      return (SavedSearchModel) m_model;
    }
  }
}