using System;
// Server import
using com.plumtree.portalpages.common.helpers;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.subportal
{
  /// <summary>
  /// This Section contains the HTML for the dependencies page.
  /// </summary>
  /// <author></author>
  public class SubPortalDependenciesView : ObjDependenciesView
  {
    //Member variables
    private CreatedHelper m_chHelper = null;
    
    /// <summary>
    /// Class name for the activity space
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "SubPortalDependenciesView";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SubPortalDependenciesView();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(com.plumtree.uiinfrastructure.activityspace.IModelRO,com.plumtree.uiinfrastructure.activityspace.AActivitySpace)"></seealso>
    public override void Init(IModelRO model, AActivitySpace parent)
    {
      base.Init(model, parent);
      m_chHelper = new CreatedHelper(parent, (SubPortalModel) model);
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.ObjDependenciesView#GetHTMLForDependencies()"></seealso>
    protected override HTMLElementCollection GetHTMLForDependencies()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      //Display the standard success message
      m_chHelper.displayEmptyRow(result);
      //fixed string concatenation	m_chHelper.displayTextRow(result, m_asOwner.GetString(635, "ptmsgs_portalcommonmsgs") + m_asOwner.GetString(2275, "ptmsgs_portaladminmsgs"), null);
      m_chHelper.displayTextRow(result, m_asOwner.GetString(696, "ptmsgs_portalcommonmsgs"),
       null);
      m_chHelper.displayTextRow(result, -1, m_asOwner.GetString(2275, "ptmsgs_portaladminmsgs") + ":",
       ((ObjEditorModel) m_model).GetObjectName());
      m_chHelper.displayTextRow(result, m_asOwner.GetString(2276, "ptmsgs_portaladminmsgs"),
       null);
      //Start a list of portlets
      m_chHelper.beginList(result);
      int intAccessType = ((ISubPortalModelRO) m_model).GetAccessType();
      if ((PT_SUBPORTAL_ACCESS_TYPES.PT_SUBPORTAL_MYPAGES_ACCESS & intAccessType) != 0)
      {
        m_chHelper.displayListRow(m_asOwner.GetString(2277, "ptmsgs_portaladminmsgs"));
        }
      if ((PT_SUBPORTAL_ACCESS_TYPES.PT_SUBPORTAL_COMMUNITIES_ACCESS & intAccessType) != 0)
      {
        m_chHelper.displayListRow(m_asOwner.GetString(2278, "ptmsgs_portaladminmsgs"));
        }
      if ((PT_SUBPORTAL_ACCESS_TYPES.PT_SUBPORTAL_DIRECTORY_ACCESS & intAccessType) != 0)
      {
        m_chHelper.displayListRow(m_asOwner.GetString(2279, "ptmsgs_portaladminmsgs"));
        }
      int intDefaultAccess = ((ISubPortalModelRO) m_model).GetDefaultFirstPageType();
      String strDefaultAccess = "";
      if (PT_SUBPORTAL_ACCESS_TYPES.PT_SUBPORTAL_MYPAGES_ACCESS == intDefaultAccess)
      {
        strDefaultAccess = m_asOwner.GetString(2277, "ptmsgs_portaladminmsgs");
        } else
      if (PT_SUBPORTAL_ACCESS_TYPES.PT_SUBPORTAL_COMMUNITIES_ACCESS == intDefaultAccess)
      {
        strDefaultAccess = m_asOwner.GetString(2278, "ptmsgs_portaladminmsgs");
        } else
      if (PT_SUBPORTAL_ACCESS_TYPES.PT_SUBPORTAL_DIRECTORY_ACCESS == intDefaultAccess)
      {
        strDefaultAccess = m_asOwner.GetString(2279, "ptmsgs_portaladminmsgs");
        }
      m_chHelper.displayTextRow(result, m_asOwner.GetString(2280, "ptmsgs_portaladminmsgs") + strDefaultAccess,
       null);
      //Display the standard warning if everyone has access to this object
      m_chHelper.displayEveryoneWarning(result, (SubPortalModel) m_model,
       m_asOwner.GetString(2275, "ptmsgs_portaladminmsgs"));
      return result;
    }
  }
}