using System;
// Framework Imports
using com.plumtree.portalpages.browsing.myportal;
using com.plumtree.portalpages.browsing.myportal.communities;
using com.plumtree.uiinfrastructure.activityspace;
using AccessStyles=com.plumtree.uiinfrastructure.constants.AccessStyles;
using com.plumtree.uiinfrastructure.editor;
using HTMLConstructHelpers=com.plumtree.uiinfrastructure.statichelpers.HTMLConstructHelpers;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.user
{
  /// <author>SudhaS</author>
  public class MainDP : EditorDP
  {
    public const String STR_MVC_CLASS_NAME = "UsrMain";
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Init(com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
     */
     
    public override void Init(AActivitySpace parent)
    {
      base.Init(parent);
    }
    // expandable lists will do in place refresh.
    //parent.SetIsInPlaceRefreshEnabled(true);
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,
    /// linking to that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return (m_asOwner.GetString(954, "ptmsgs_portaladminmsgs"));
    }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      //return HTMLConstructHelpers.GetSubHeader(
      //	m_asOwner.GetString(1665, "ptmsgs_portaladminmsgs"),
      //	this.m_asOwner);
      HTMLTable myTable = new HTMLTable();
      myTable.SetWidth("100%");
      myTable.SetStyleClass(PTStyleClass.DIR_CONTENT_BG);
      HTMLTableRow myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      HTMLTableCell myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetStyleClass(PTStyleClass.DIR_CONTENT_TEXT);
      myCell.AddInnerHTMLString(m_asOwner.GetString(1665, "ptmsgs_portaladminmsgs") + "  ");
      IUserModelRO _model = (IUserModelRO) m_asOwner.GetModel(UserModel.STR_MVC_CLASS_NAME);
      int userID = _model.GetObjectID();
      if (userID != -1)
      {
        ASURL asURL = new ASURL(m_asOwner);
        asURL.SetLinkCreateNewSpace(CommunityPageAS.STR_MVC_CLASS_NAME, m_asOwner);
        asURL.SetControl(SetCommunityControl.STR_MVC_CLASS_NAME);
        String strQuery = "&" + SetCommunityControl.STR_COMMUNITY_ID + "=2&" + SetCommunityControl.STR_PAGE_ID + "=0&" + SetCommunityControl.PROFILEID + "=" + userID;
        String strSettingURL = asURL.GetURLAsString() + strQuery;
        HTMLAnchor myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
        myAnchor.SetOnClick("EditUserProfile(\'" + strSettingURL + "\'); return false;");
        myAnchor.AddInnerHTMLString(m_asOwner.GetString(2539, "ptmsgs_portaladminmsgs"));
        myCell.AddInnerHTMLElement(myAnchor);
      }
      HTMLTableCell helpCell = new HTMLTableCell();
      helpCell.SetStyleClass(PTStyleClass.DIR_CONTENT_TEXT);
      helpCell.SetAlign(CommonHTMLStrings.RIGHT);
      myRow.AddInnerHTMLElement(helpCell);
      HTMLAnchor help = HTMLConstructHelpers.GetHelpAnchor(m_asOwner);
      if (m_asOwner.GetAccessStyle() != AccessStyles.STANDARD)
      {
        help.SetAccessKey(m_asOwner.GetString(11, "ptmsgs_portal508quickkeymsgs"));
        }
      helpCell.AddInnerHTMLElement(help);
      return myTable;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.form.AFormDP#PartialContentDisplay()
     */
     
    public override HTMLElement PartialContentDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      result.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(UserEditorAS.strStorageSelectPTObject)).Display());
      return result;
    }
    
    /// <summary>
    /// Returns the HTML for the General Info page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)"></seealso>
    /// <returns>HTMLElement</returns>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // Insert super class HTML
      result.AddInnerHTMLElement(base.PageDisplay());
      HTMLElementCollection views = new HTMLElementCollection();
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(LoginView.STR_MVC_CLASS_NAME)).Display());
      views.AddInnerHTMLElement(EditorView.GetSpacerTable());
      // aj: display the static memberships RW view
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(UserEditorAS.strStorageSelectPTObject)).Display());
      // aj: display the dynamic memberships RO view
      views.AddInnerHTMLElement(EditorView.GetSpacerTable());
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(UserEditorAS.strDynamicMembershipSelectPTObject)).Display());
      result.AddInnerHTMLElement(CreateLeftNavBar(views));
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(UserEditorAS.strStorageSelectPTObject).DisplayJavascript());
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(LoginView.STR_MVC_CLASS_NAME).DisplayJavascript());
      return myScripts;
    }
  }
}