using System;
using com.plumtree.portalpages.admin.ptutilities.userinfopropmap;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.admin.editors.userprofilemanager
{
  /// <author>JHQ</author>
  /// <author>
  /// jennifersu
  /// Controls repost actions via the usr profile manager.  It calls the following
  /// repost controls: UsrProfCommRepostControl and UserInfoPropMapAS
  /// </author>
  public class UsrProfMgrRepostControl : EditorRepostControl
  {
    
    /// <summary>
    /// object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "UserProfileManagerRepost";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new UsrProfMgrRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call
    /// the associated method for each action.
    /// </summary>
    /// <param name="_nAction"></param>
    protected override void PerformAction(int _nAction)
    {
      // this will do performaction on the user profile community objects 
      base.PerformAction(_nAction);
      IDisplayPage page;
      // do action specific stuff
      page = m_asOwner.GetCurrentPage();
      // this will perform action on the user info property map objects
      if (_nAction != EditorRepostControl.POSTTOSELF_ACTION_FINISH)
      {
        if (page is MainDP)
        {
          ((ExpListControl) m_asOwner.GetControl(UserInfoPropMapAS.STR_MVC_STORAGE_NAME_PLUG_IN)).PerformRepostAction(_nAction,
           m_htFormData);
        } else
        // this will perform action on the user prof community control
        {
          UsrProfCommRepostControl commControl = (UsrProfCommRepostControl) m_asOwner.GetControl(UsrProfCommRepostControl.STR_MVC_CLASS_NAME);
          commControl.InitializeArguments(m_htFormData);
          commControl.PublicPerformAction(_nAction);
        }
      }
    }
  }
}