using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.webservice
{
  /// <author>adolfoc</author>
  public class AssocObjectsDP : WSPluginDP
  {
    
    /// <summary>
    /// Class Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "AssocObjectsDP";
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetAllPossibleViews()"></seealso>
    public override XPArrayList GetAllPossibleViews()
    {
      XPArrayList xpWSViews = new XPArrayList();
      xpWSViews.Add(WebServiceEditorAS.strStorage_AssocObjectsPluginView);
      return xpWSViews;
    }
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,  linking to
    /// that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(1186, "ptmsgs_portaladminmsgs");
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetOrderedViewList(int)"></seealso>
    public override XPArrayList GetOrderedViewList(int nWSMode)
    {
      XPArrayList xpWSViews = new XPArrayList();
      //		switch (nWSMode)
      //		{
      //		case WebServiceModel.WSMODE_PORTLET:
      //		case WebServiceModel.WSMODE_INTRINSIC_PORTLET:
      //
      // AGC- Only show the associated objects view in EDIT MODE (it will always be empty in create mode).		
      if (EditorStartControl.EDITOR_START_FLAG_EDIT == ((WebServiceModel) m_asOwner.GetModel(WebServiceModel.STR_MVC_CLASS_NAME)).GetEditorType())
      {
        xpWSViews.Add(WebServiceEditorAS.strStorage_AssocObjectsPluginView);
        }
      //			break;
      //
      //		case WebServiceModel.WSMODE_NONE:default:
      //			break;
      //		}
      return xpWSViews;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetPluginHelpTopic()
     */
     
    public override String GetPluginHelpTopic()
    {
      WebServiceModel mParentModel = (WebServiceModel) m_asOwner.GetModel(WebServiceModel.STR_MVC_CLASS_NAME);
      switch (mParentModel.GetWSMode()){
      case WebServiceModel.WSMODE_PORTLET:
      return "PT_WebService_Portlet_AssociatedObjects";
      goto case WebServiceModel.WSMODE_PAGELET;
      case WebServiceModel.WSMODE_PAGELET:
      return "PT_WebService_Pagelet_AssociatedObjects";
      goto case WebServiceModel.WSMODE_INTRINSIC_PORTLET;
      case WebServiceModel.WSMODE_INTRINSIC_PORTLET:
      return "PT_WebService_Portlet_AssociatedObjects";
      goto case WebServiceModel.WSMODE_AWS;
      case WebServiceModel.WSMODE_AWS:
      return "PT_WebService_Portlet_AssociatedObjects";
      goto case WebServiceModel.WSMODE_PWS;
      case WebServiceModel.WSMODE_PWS:
      return "PT_WebService_Portlet_AssociatedObjects";
      goto case WebServiceModel.WSMODE_CWS;
      case WebServiceModel.WSMODE_CWS:
      return "PT_WebService_Portlet_AssociatedObjects";
      goto case WebServiceModel.WSMODE_SWS;
      case WebServiceModel.WSMODE_SWS:
      return "PT_WebService_Portlet_AssociatedObjects";
      goto case WebServiceModel.WSMODE_MWS;
      case WebServiceModel.WSMODE_MWS:
      return "PT_WebService_Portlet_AssociatedObjects";
      goto case WebServiceModel.WSMODE_NONE;
      case WebServiceModel.WSMODE_NONE:
      return "PT_WebService_Portlet_AssociatedObjects";
      goto default;
      default:
      break;
      }
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.editor.EditorDP#GetHTMLBelowSubHeader()
     */
     
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(2503, "ptmsgs_portaladminmsgs"),
       m_asOwner);
    }
  }
}