using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.webservice
{
  /// <author>adolfoc</author>
  public class MainDP : WSPluginDP
  {
    //MES- CR: Doesn't match the class name
    //AGC- CR-Response: Doesn't have to. See the other DP's for why.
    
    /// <summary>
    /// Class Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "WebServiceMainDP";
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetAllPossibleViews()"></seealso>
    public override XPArrayList GetAllPossibleViews()
    {
      XPArrayList xpWSViews = new XPArrayList();
      xpWSViews.Add(WebServiceEditorAS.strStorage_RemoteServerPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_HTTPSettingsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_AWSSettingsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_PWSSettingsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_CWSSettingsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_SWSSettingsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_IntrinsicPortletWSSettingsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_MWSSettingsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_AddSettingsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_RemotePageletPickerView);
      return xpWSViews;
    }
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,  linking to
    /// that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(1189, "ptmsgs_portaladminmsgs");
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetOrderedViewList(int)"></seealso>
    public override XPArrayList GetOrderedViewList(int nWSMode)
    {
      XPArrayList xpWSViews = new XPArrayList();
      switch (nWSMode){
      case WebServiceModel.WSMODE_PORTLET:
      xpWSViews.Add(WebServiceEditorAS.strStorage_RemoteServerPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_HTTPSettingsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_AddSettingsPluginView);
      break;
      case WebServiceModel.WSMODE_PAGELET:
      xpWSViews.Add(WebServiceEditorAS.strStorage_RemoteServerPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_RemotePageletPickerView);
      // Display HTTP Settings section, but the URL text box is hidden in Pagelet Portlet Editor
      xpWSViews.Add(WebServiceEditorAS.strStorage_HTTPSettingsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_AddSettingsPluginView);
      break;
      case WebServiceModel.WSMODE_AWS:
      xpWSViews.Add(WebServiceEditorAS.strStorage_RemoteServerPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_AWSSettingsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_AddSettingsPluginView);
      break;
      case WebServiceModel.WSMODE_PWS:
      xpWSViews.Add(WebServiceEditorAS.strStorage_RemoteServerPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_PWSSettingsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_AddSettingsPluginView);
      break;
      case WebServiceModel.WSMODE_CWS:
      xpWSViews.Add(WebServiceEditorAS.strStorage_RemoteServerPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_CWSSettingsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_AddSettingsPluginView);
      break;
      case WebServiceModel.WSMODE_SWS:
      xpWSViews.Add(WebServiceEditorAS.strStorage_RemoteServerPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_SWSSettingsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_AddSettingsPluginView);
      break;
      case WebServiceModel.WSMODE_INTRINSIC_PORTLET:
      xpWSViews.Add(WebServiceEditorAS.strStorage_IntrinsicPortletWSSettingsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_AddSettingsPluginView);
      break;
      case WebServiceModel.WSMODE_MWS:
      xpWSViews.Add(WebServiceEditorAS.strStorage_RemoteServerPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_MWSSettingsPluginView);
      xpWSViews.Add(WebServiceEditorAS.strStorage_AddSettingsPluginView);
      break;
      case WebServiceModel.WSMODE_NONE:
      default:
      break;
      }
      return xpWSViews;
    }
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      WebServiceModel myWSModel = (WebServiceModel) m_asOwner.GetModel(m_asOwner.m_strModelName);
      String s = myWSModel.GetWSObjectMiniHelp();
      if (s == null)
      {
        return base.GetHTMLBelowSubHeader();
      } else
      {
        return HTMLConstructHelpers.GetSubHeader(s, m_asOwner);
      }
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetPluginHelpTopic()
     */
     
    public override String GetPluginHelpTopic()
    {
      WebServiceModel mParentModel = (WebServiceModel) m_asOwner.GetModel(WebServiceModel.STR_MVC_CLASS_NAME);
      switch (mParentModel.GetWSMode()){
      case WebServiceModel.WSMODE_PORTLET:
      return "PT_WebService_Portlet_Remote_MainSettings";
      goto case WebServiceModel.WSMODE_PAGELET;
      case WebServiceModel.WSMODE_PAGELET:
      return "PT_WebService_Pagelet_MainSettings";
      goto case WebServiceModel.WSMODE_INTRINSIC_PORTLET;
      case WebServiceModel.WSMODE_INTRINSIC_PORTLET:
      return "PT_WebService_Portlet_Intrinsic_MainSettings";
      goto case WebServiceModel.WSMODE_AWS;
      case WebServiceModel.WSMODE_AWS:
      return "PT_WebService_Authentication_MainSettings";
      goto case WebServiceModel.WSMODE_PWS;
      case WebServiceModel.WSMODE_PWS:
      return "PT_WebService_Profile_MainSettings";
      goto case WebServiceModel.WSMODE_CWS;
      case WebServiceModel.WSMODE_CWS:
      return "PT_WebService_Crawler_MainSettings";
      goto case WebServiceModel.WSMODE_SWS;
      case WebServiceModel.WSMODE_SWS:
      return "PT_WebService_Search_MainSettings";
      goto case WebServiceModel.WSMODE_MWS;
      case WebServiceModel.WSMODE_MWS:
      return "PT_WebService_Migration_MainSettings";
      goto case WebServiceModel.WSMODE_NONE;
      case WebServiceModel.WSMODE_NONE:
      default:
      break;
      }
      return null;
    }
  }
}