using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.common.constants;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.webservice
{
  /// <author>rozhang</author>
  public class ParameterMappingDP : WSPluginDP
  {
    public const String STR_MVC_CLASS_NAME = "ParameterMappingDP";
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetAllPossibleViews()"></seealso>
    public override XPArrayList GetAllPossibleViews()
    {
      XPArrayList xpWSViews = new XPArrayList();
      xpWSViews.Add(WebServiceEditorAS.strStorage_PageletParamMapPluginView);
      return xpWSViews;
    }
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetOrderedViewList(int)"></seealso>
    public override XPArrayList GetOrderedViewList(int mode)
    {
      XPArrayList xpWSViews = new XPArrayList();
      switch (mode){
      case WebServiceModel.WSMODE_PAGELET:
      xpWSViews.Add(WebServiceEditorAS.strStorage_PageletParamMapPluginView);
      break;
      default:
      // only used on pagelet webservices
      break;
      }
      return xpWSViews;
    }
    
    /// <seealso cref="com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetPluginHelpTopic()"></seealso>
    public override String GetPluginHelpTopic()
    {
      WebServiceModel mParentModel = (WebServiceModel) m_asOwner.GetModel(WebServiceModel.STR_MVC_CLASS_NAME);
      switch (mParentModel.GetWSMode()){
      case WebServiceModel.WSMODE_PAGELET:
      return "PT_WebService_Pagelet_ParameterMapping";
      goto case WebServiceModel.WSMODE_PORTLET;
      case WebServiceModel.WSMODE_PORTLET:
      case WebServiceModel.WSMODE_AWS:
      case WebServiceModel.WSMODE_PWS:
      case WebServiceModel.WSMODE_CWS:
      case WebServiceModel.WSMODE_SWS:
      case WebServiceModel.WSMODE_MWS:
      case WebServiceModel.WSMODE_INTRINSIC_PORTLET:
      case WebServiceModel.WSMODE_NONE:
      default:
      break;
      }
      return null;
    }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(3271, ResourceConstants.PORTALADMINMSGS),
       this.m_asOwner);
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.editor.EditorDP#GetLeftNavString()"></seealso>
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(3270, ResourceConstants.PORTALADMINMSGS);
      }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.editor.EditorDP#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}