using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.portalpages.admin.editors.webservice.plugins;
using com.plumtree.portalpages.common.helpers;
using com.plumtree.portaluiinfrastructure.opener;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.webservice
{
  /// <author>adolfoc</author>
  public class WSViewHelper : ViewHelper
  {
    
    /// <summary>
    /// Returns a collection of HTMLElements that make a link to the object with
    /// the specified CLASSID and objectID. strLink will be the string used as
    /// the link string.
    /// </summary>
    /// <param name="ptSession"></param>
    /// <param name="nCLASSID"></param>
    /// <param name="nObjectID"></param>
    /// <param name="strLink"></param>
    /// <returns>HTMLElement</returns>
    public static HTMLElement MakeEditObjectLink(int nClassID, int nObjectID,
     String strLink, AActivitySpace asOwner)
    {
      HTMLAnchor myAnchor = new HTMLAnchor("#");
      XPStringBuilder sbQSArgs = new XPStringBuilder(256);
      // TODO: This should use the GetOpenerURLObjID method
      // using the open ended opener method, thus need to supply QS args.
      HTTPHelpers.AppendQSArgument(sbQSArgs, IPTOpenerConstants.QS_OPEN, nClassID);
      HTTPHelpers.AppendQSArgument(sbQSArgs, IPTOpenerConstants.QS_OBJECTID,
       nObjectID);
      // indicate that this link should be opened as a subeditor.
      HTTPHelpers.AppendQSArgument(sbQSArgs, ASConstants.SUBSPACE, AssocObjectsPluginView.STR_MVC_CLASS_NAME + nClassID + nObjectID);
      // using the open ended get common opener url method.
      String strURL = PTOpenerLinks.GetOpenerURL(sbQSArgs.ToString(), IPTOpenerConstants.OPENER_MODE_EDIT,
       asOwner);
      myAnchor.SetHRef(strURL);
      myAnchor.SetTarget("_blank");
      myAnchor.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strLink));
      return myAnchor;
    }
  }
}