using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.tree;
namespace com.plumtree.portalpages.admin.editors.webservice.credvaulttree
{
  /// <summary>
  /// This version of the tree allows for browsing and
  /// selecting of objects with no hierarchical structure
  /// </summary>
  /// <author>JosephS</author>
  public class CredVaultStartTreeControl : AStartTreeControl
  {
    
    /// <summary>
    /// object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "CredVaultStartTree";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IControl#Execute()"></seealso>
    public override Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      Redirect result = base.CheckActionSecurityAndExecute(arguments);
      String[] sValues;
      // CredVault's to select
      sValues = (String[]) arguments.GetElement(CredVaultRefreshTreeControl.SELECTED_CREDVAULTS);
      if (sValues != null)
      {
        ((CredVaultTreeModel) m_asModel).SetCredVaultsToSelect(CredVaultRefreshTreeControl.StringToCredVaults(sValues[0]));
        }
      // Now load the bugger.
      ((CredVaultTreeModel) m_asModel).LoadCredVault();
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new CredVaultStartTreeControl();
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IControl#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}