using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portalpages.admin.editors.webservice;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.webservice.plugins
{
  /// <author>adolfoc</author>
  public class AddSettingsPluginView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.webservice.plugins.AddSettingsPluginView");
    public const String STR_MVC_CLASS_NAME = "AddSettingsPluginView";
    // HTML Object names.
    
    /// <summary>
    /// Localized String: Disabled with message: 
    /// </summary>
    public const String HTMLRADIO_ENABLED = "in_ra_Enabled";
    public const String HTMLINPUT_DISABLED_TEXT = "in_ta_DisabledText";
    
    /// <summary>
    /// Our parent Activity space.
    /// </summary>
    private AActivitySpace m_asasParent;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new AddSettingsPluginView();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Display()"></seealso>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable myTable;
      HTMLTableRow myRow;
      try
      {
        result.AddInnerHTMLElement(base.GetHeaderView(m_asOwner.GetString(1025,
         "ptmsgs_portaladminmsgs")));
        myTable = WSViewHelper.AddTable(result);
        // Top Margin
        WSViewHelper.AddEmptyRow(myTable, "7");
        // Radio Category Label
        WSViewHelper.AddSimpleLabel(myTable, 7, m_asOwner.GetString(1027,
         "ptmsgs_portaladminmsgs"));
        // Enabled/Disabled Radio Selection.
        bool bEnabled = (((IAddSettingsPluginModelRO) m_model).GetEnabled());
        WSViewHelper.AddSimpleRadio(myTable, -7, m_asOwner.GetString(1028,
         "ptmsgs_portaladminmsgs"), HTMLRADIO_ENABLED, "1", bEnabled);
        WSViewHelper.AddSimpleRadio(myTable, -7, m_asOwner.GetString(1029,
         "ptmsgs_portaladminmsgs"), HTMLRADIO_ENABLED, "0", !bEnabled);
        myRow = WSViewHelper.AddRow(myTable);
        WSViewHelper.AddLeftMargin(myRow, 7);
        WSViewHelper.AddTextAreaCell(myRow, CommonHTMLStrings.ONE, XPHttpUtility.HtmlDecode(XPHttpUtility.HtmlDecode(((IAddSettingsPluginModelRO) m_model).GetDisabledMessage())),
         HTMLINPUT_DISABLED_TEXT);
        WSViewHelper.AddIndentCell(myRow, CommonHTMLStrings.ONE);
        WSViewHelper.AddIndentCell(myRow, CommonHTMLStrings.ONE);
        WSViewHelper.AddIndentCell(myRow, CommonHTMLStrings.ONE);
        WSViewHelper.AddRightMargin(myRow, 7);
        // Bottom Margin
        WSViewHelper.AddEmptyRow(myTable, "7");
      }
      catch (HTMLException e)
      {
        log.Error(e, STR_MVC_CLASS_NAME + "::Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(1026, "ptmsgs_portaladminmsgs"),
         e);
      }
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    public override HTMLScript DisplayJavascript()
    {
      HTMLScript result = new HTMLScript("text/javaScript");
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public override void Init(IModelRO model, AActivitySpace parent)
    {
      base.Init(model, parent);
      m_asasParent = parent;
    }
  }
}