using System;
using EditorView=com.plumtree.uiinfrastructure.editor.EditorView;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portalpages.admin.editors.webservice;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.webservice.plugins
{
  /// <summary>
  /// View for editing advanced gateway settings.
  /// </summary>
  /// <author>josephs</author>
  public class GatewaySettingsPluginView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     typeof(GatewaySettingsPluginView));
    public const String STR_MVC_CLASS_NAME = "GatewaySettingsPluginView";
    public const String HTMLCHECKBOX_HOSTED_DISPLAY_MODE = "in_cb_HostedDisplayMode";
    public const String HTMLCHECKBOX_TRANSFORM_JAVASCRIPT = "in_cb_TransformJS";
    public const String HTMLCHECKBOX_TRANSFORM_CSS = "in_cb_TransformCSS";
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
     */
     
    public override Object Create()
    {
      return new GatewaySettingsPluginView();
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
     */
     
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
     */
     
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLSpan mySpan;
      HTMLInput myInput;
      try
      {
        result.AddInnerHTMLElement(base.GetHeaderView(m_asOwner.GetString(1033,
         "ptmsgs_portaladminmsgs")));
        myTable = WSViewHelper.AddTable(result);
        // 1st row begins (Top Margin)
        WSViewHelper.AddEmptyRow(myTable, "5");
        // 1st row ends
        // 2nd row
        IGatewaySettingsPluginModelRO modelRO = (IGatewaySettingsPluginModelRO) m_model;
        DrawCheckBox(myTable, HTMLCHECKBOX_HOSTED_DISPLAY_MODE, "1", m_asOwner.GetString(2822,
         "ptmsgs_portaladminmsgs"), modelRO.GetUseHostedDisplayMode());
        DrawCheckBox(myTable, HTMLCHECKBOX_TRANSFORM_JAVASCRIPT, "1", m_asOwner.GetString(2823,
         "ptmsgs_portaladminmsgs"), modelRO.GetTransformJS());
        DrawCheckBox(myTable, HTMLCHECKBOX_TRANSFORM_CSS, "1", m_asOwner.GetString(2824,
         "ptmsgs_portaladminmsgs"), modelRO.GetTransformCSS());
        // last row (spacer row)
        WSViewHelper.AddEmptyRow(myTable, "5");
      }
      catch (HTMLException e)
      {
        log.Error(e, STR_MVC_CLASS_NAME + "::Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(1032, "ptmsgs_portaladminmsgs"),
         e);
      }
      return result;
    }
    // Helper Function:
    private void DrawCheckBox(HTMLTable myTable, String strHTTP, String strValue,
     String strUI, bool bChecked)
    {
      WSViewHelper.AddSimpleCheckbox(myTable, 5, strUI, strHTTP, strValue,
       bChecked, "");
    }
  }
}