using System;
namespace com.plumtree.portalpages.admin.editors.webservice.plugins
{
  /// <author>akashj</author>
  public interface IFormLoginPluginModelRO
  {
    
    /// <summary>
    /// The URL to that identifies a login URL - this can be a pattern
    /// with '*' characters to do wildcard matches.
    /// </summary>
    /// <returns>the login URL as a String</returns>
    String GetLoginURL();
    
    /// <summary>
    /// The URL that credentials should be POSTed to.
    /// </summary>
    /// <returns>the POST URL as a String</returns>
    String GetPostURL();
    
    /// <summary>
    /// Returns a series of constants representing the
    /// type of credential to send.  The choices are:
    /// 0 - none (relies on the form fields only)
    /// 1 - Portal Username/Password
    /// 2 - Lockbox Username/Password
    /// </summary>
    /// <returns>the credential type as an int</returns>
    int GetCredentialType();
    
    /// <summary>
    /// Returns the HTML field to send the username as
    /// to the POST URL.
    /// </summary>
    /// <returns>the username field name as a String</returns>
    String GetUsernameFieldName();
    
    /// <summary>
    /// Returns the HTML field to send the password as
    /// to the POST URL.
    /// </summary>
    /// <returns>the password field name as a String</returns>
    String GetPasswordFieldName();
  }
}