using System;
namespace com.plumtree.portalpages.admin.editors.webservice.plugins
{
  /// <summary>
  /// This interface contains read-only methods for the intrinsic portlet web service preferences plugin.
  /// </summary>
  /// <author>josephc</author>
  public interface IIntrinsicUserPrefsPluginModelRO
  {
    
    /// <summary>
    /// Gets the preference mode.
    /// </summary>
    /// <returns>Preference mode</returns>
    int GetPrefMode();
    
    /// <summary>
    /// Gets the preference space value for the current type of preference.
    /// </summary>
    /// <returns>Preference space</returns>
    String GetPrefsSpace();
    
    /// <summary>
    /// Gets the preference space value for portlet template admin preferences.
    /// </summary>
    /// <returns>Portlet template admin preference space</returns>
    String GetTemplatePrefsSpace();
  }
}