using System;
using com.plumtree.openfoundation.util;
namespace com.plumtree.portalpages.admin.editors.webservice.plugins
{
  /// <author>adolfoc</author>
  public interface ISelectDevicesPluginModelRO
  {
    
    /// <summary>
    /// Returns whether or not a particular device is selected for this WebService.
    /// </summary>
    bool DeviceChecked(String strUnique);
    
    /// <summary>
    /// Returns an ArrayList of all of the available userinterface objectids.
    /// </summary>
    XPArrayList GetAvailableUIs();
    
    /// <returns></returns>
    String GetBaseURL();
    
    /// <summary>
    /// Returns the Description of the interface with a particular Object ID (use GetAvailableUIs to
    /// get a list of valid objectids).
    /// </summary>
    String GetUIDescription(String strUnique);
    
    /// <summary>
    /// Returns the Name of the interface with a particular Object ID (use GetAvailableUIs to
    /// get a list of valid objectids).
    /// </summary>
    String GetUIName(String strUniqueID);
  }
}