using System;
using com.plumtree.portalpages.admin.editors.webservice;
using com.plumtree.uiinfrastructure.expandablelist.growablelist;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.webservice.plugins
{
  /// <author>adolfoc</author>
  public class PrefsListPluginView : GrowableListView
  {
    
    /// <summary>
    /// Class name for the activity space 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "PrefsListView";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new PrefsListPluginView();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListView#GetHTMLBelowActionBar()"></seealso>
    protected override HTMLTable GetHTMLBelowActionBar()
    {
      String strViewToGet = "";
      switch (((IPrefsListPluginModelRO) m_model).GetWSMode()){
      case WebServiceModel.WSMODE_AWS:
      case WebServiceModel.WSMODE_CWS:
      case WebServiceModel.WSMODE_SWS:
      case WebServiceModel.WSMODE_NONE:
      //AGC- Don't show the Prefs URL selection for any mode except Portlet!
      return null;
      goto case WebServiceModel.WSMODE_PORTLET;
      case WebServiceModel.WSMODE_PORTLET:
      default:
      switch (((IPrefsListPluginModelRO) m_model).GetPrefMode()){
      case PrefsListPluginModel.PLPM_PREFMODE_USERPREFS:
      strViewToGet = WebServiceEditorAS.strStorage_UserPrefsPluginView;
      break;
      case PrefsListPluginModel.PLPM_PREFMODE_COMMUNITYPREFS:
      strViewToGet = WebServiceEditorAS.strStorage_CommunityPrefsPluginView;
      break;
      case PrefsListPluginModel.PLPM_PREFMODE_SESSIONPREFS:
      strViewToGet = WebServiceEditorAS.strStorage_SessionPrefsPluginView;
      break;
      }
      break;
      }
      return (((UserPrefsPluginView) m_asOwner.GetView(strViewToGet)).GetDisplayAsTable());
      }
  }
}