using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.admin.editors.webservice;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.webservice.plugins
{
  /// <author>adolfoc</author>
  public class RemoteConfigPluginView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.webservice.plugins.RemoteConfigPluginView");
    public const String STR_MVC_CLASS_NAME = "RemoteConfigPluginView";
    public const String HTMLINPUT_CONFIGURL_ADMIN = "in_tx_RemoteConfigAdmin";
    public const String HTMLINPUT_CONFIGURL_USER = "in_tx_RemoteConfigUser";
    
    /// <summary>
    /// Our parent Activity space.
    /// </summary>
    private AActivitySpace m_asasParent;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new RemoteConfigPluginView();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Display()"></seealso>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable myTable;
      try
      {
        result.AddInnerHTMLElement(base.GetHeaderView(m_asOwner.GetString(1128,
         "ptmsgs_portaladminmsgs")));
        myTable = WSViewHelper.AddTable(result);
        // 1st row begins (Top Margin)
        WSViewHelper.AddEmptyRow(myTable, "5");
        // 2nd row begins
        String strBaseURL = ((IRemoteConfigPluginModelRO) m_model).GetBaseURL();
        String strDefault = ((IRemoteConfigPluginModelRO) m_model).GetConfigURLAdmin();
        WSViewHelper.AddSimpleEditBox(myTable, 5, m_asOwner.GetString(1129,
         "ptmsgs_portaladminmsgs"), strBaseURL, strDefault, HTMLINPUT_CONFIGURL_ADMIN);
        WSViewHelper.AddEmptyRow(myTable, "5");
        strDefault = ((IRemoteConfigPluginModelRO) m_model).GetConfigURLUser();
        WSViewHelper.AddSimpleEditBox(myTable, 5, m_asOwner.GetString(1131,
         "ptmsgs_portaladminmsgs"), strBaseURL, strDefault, HTMLINPUT_CONFIGURL_USER);
        WSViewHelper.AddEmptyRow(myTable, "5");
      }
      catch (HTMLException e)
      {
        log.Error(e, STR_MVC_CLASS_NAME + "::Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(1127, "ptmsgs_portaladminmsgs"),
         e);
      }
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    public override HTMLScript DisplayJavascript()
    {
      HTMLScript result = new HTMLScript("text/javaScript");
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public override void Init(IModelRO model, AActivitySpace parent)
    {
      base.Init(model, parent);
      m_asasParent = parent;
    }
  }
}