using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.admin.editors.webservice;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.editors.webservice.plugins
{
  /// <author>adolfoc</author>
  public class SOAPEncodingPluginView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.editors.webservice.plugins.SOAPEncodingPluginView");
    public const String STR_MVC_CLASS_NAME = "SOAPEncodingPluginView";
    public const String HTMLRADIO_SOAPENCODING = "in_ra_SOAPEncoding";
    
    /// <summary>
    /// Our parent Activity space.
    /// </summary>
    private AActivitySpace m_asasParent;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SOAPEncodingPluginView();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Display()"></seealso>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable myTable;
      try
      {
        result.AddInnerHTMLElement(base.GetHeaderView(m_asOwner.GetString(1147,
         "ptmsgs_portaladminmsgs")));
        myTable = WSViewHelper.AddTable(result);
        // first row (margin)
        WSViewHelper.AddEmptyRow(myTable, "5");
        int nEnabled = (((ISOAPEncodingPluginModelRO) m_model).GetSOAPEncoding());
        WSViewHelper.AddSimpleLabel(myTable, 5, m_asOwner.GetString(1149,
         "ptmsgs_portaladminmsgs"));
        WSViewHelper.AddSimpleRadio(myTable, 5, m_asOwner.GetString(1150,
         "ptmsgs_portaladminmsgs"), HTMLRADIO_SOAPENCODING, XPConvert.ToString(SOAPEncodingPluginModel.SOAPENC_RPC),
         (nEnabled == SOAPEncodingPluginModel.SOAPENC_RPC), null);
        WSViewHelper.AddSimpleRadio(myTable, 5, m_asOwner.GetString(1151,
         "ptmsgs_portaladminmsgs"), HTMLRADIO_SOAPENCODING, XPConvert.ToString(SOAPEncodingPluginModel.SOAPENC_DOCUMENTLITERAL),
         (nEnabled == SOAPEncodingPluginModel.SOAPENC_DOCUMENTLITERAL), null);
        // last row (margin)
        WSViewHelper.AddEmptyRow(myTable, "5");
      }
      // 3rd row ends            
      catch (HTMLException e)
      {
        log.Error(e, STR_MVC_CLASS_NAME + "::Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(1148, "ptmsgs_portaladminmsgs"),
         e);
      }
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    public override HTMLScript DisplayJavascript()
    {
      HTMLScript result = new HTMLScript("text/javaScript");
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public override void Init(IModelRO model, AActivitySpace parent)
    {
      base.Init(model, parent);
      m_asasParent = parent;
    }
  }
}