using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.tree;
namespace com.plumtree.portalpages.admin.editors.webservice.userinfotree
{
  /// <summary>
  /// This version of the tree allows for browsing and
  /// selecting of objects with no hierarchical structure
  /// </summary>
  /// <author>AdolfoC</author>
  public class UserInfoStartTreeControl : AStartTreeControl
  {
    
    /// <summary>
    /// object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "UserInfoStartTree";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IControl#Execute()"></seealso>
    public override Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      Redirect result = base.CheckActionSecurityAndExecute(arguments);
      String[] sValues;
      // UserInfo's to select
      sValues = (String[]) arguments.GetElement(UserInfoRefreshTreeControl.SELECTED_USERINFOS);
      if (sValues != null)
      {
        ((UserInfoTreeModel) m_asModel).SetUserInfosToSelect(UserInfoRefreshTreeControl.StringToUserInfos(sValues[0]));
        }
      // Now load the bugger.
      ((UserInfoTreeModel) m_asModel).LoadUserInfo();
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new UserInfoStartTreeControl();
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IControl#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}