using System;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.httpmemorydebugging
{
  /// <summary>
  /// This Display Page displays HTTPMemoryDebugView.
  /// </summary>
  /// <author>Julie Fournier</author>
  public class HTTPMemoryDebugDP : PlumtreeDP
  {
    
    /// <summary>
    /// Class name for the activity space 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "HTTPMemoryDebug";
    public override String GetTitleForBanner()
    {
      return m_asOwner.GetString(1953, "ptmsgs_portaladminmsgs");
    }
    public override String GetSubtitleForBanner()
    {
      return "";
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      return m_asOwner.GetView(HTTPMemoryDebugView.STR_MVC_CLASS_NAME).Display();
      }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = new HTMLScriptCollection();
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(HTTPMemoryDebugView.STR_MVC_CLASS_NAME).DisplayJavascript());
      return myScripts;
    }
  }
}