using System;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.editor.commonpages.migrationhistory;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.admin.migrationhistory
{
  /// <version>$Revision$</version>
  /// <author>arvinds</author>
  public class MigrationHistoryAS : PTEditorAS
  {
    
    /// <summary>
    /// The name of this activity space 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "MigrationHistory";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new MigrationHistoryAS();
    }
    
    /// <summary>
    /// Returns the title of this editor
    /// </summary>
    public override String GetEditorTitle()
    {
      return GetString(1199, "ptmsgs_portaladminmsgs");
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the class name of the Repost Control.
    /// </summary>
    /// <returns>String</returns>
    public override String GetRepostControlName()
    {
      return (EditorRepostControl.STR_MVC_CLASS_NAME);
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.AActivitySpace#Init()"></seealso>
    public override void Init()
    {
      m_strModelName = MigrationHistoryModel.STR_MVC_CLASS_NAME;
      base.Init();
      // Display Page
      MigrationHistoryDP myPage = new MigrationHistoryDP();
      RegisterPage(myPage);
      IModel myModel = GetModel(MigrationHistoryModel.STR_MVC_CLASS_NAME);
      // Section
      RegisterView(MigrationHistoryView.STR_MVC_CLASS_NAME, myModel);
      SetCurrentPage(myPage);
    }
  }
}