using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.opener;
namespace com.plumtree.portalpages.admin.objmgr
{
  /// <author>dustina</author>
  public class AdminLoginTokenControl : IControl
  {
    
    /// <summary>
    /// Name of this control 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "AdminLoginTokenControl";
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IControl#CheckActionSecurityAndExecute(com.plumtree.openfoundation.util.XPHashtable)
     */
     
    public virtual Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      String adminURL = PTConfigHelper.GetFullAdminSiteURL() + "?" + IOpenerConstants.QS_OPEN + "=" + PT_CLASSIDS.PT_ADMIN_FOLDER_ID + "&" + IOpenerConstants.QS_OBJECTID + "=" + PT_INTRINSICS.PT_ADMIN_FOLDER_ROOTFOLDER + "&" + IOpenerConstants.QS_MODE + "=" + IOpenerConstants.OPENER_MODE_VIEW + "&" + ASConstants.CACHED + "=" + XPConvert.ToString(true);
      Redirect redirect = new Redirect();
      redirect.SetLinkToExternalURL(adminURL);
      return redirect;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IControl#Init(com.plumtree.uiinfrastructure.activityspace.IModel, com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
     */
     
    public virtual void Init(IModel model, AActivitySpace space)
    {
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
     */
     
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
     */
     
    public virtual Object Create()
    {
      return new AdminLoginTokenControl();
    }
  }
}