using System;
using com.plumtree.portalpages.admin.objsearch;
using com.plumtree.portalpages.common.folder;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.objmgr
{
  /// <author>Don Hayler</author>
  public class ObjMgrSearchView : IView
  {
    
    /// <summary>
    /// object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "ObjMgrSearchView";
    
    /// <summary>
    /// localized strings 
    /// </summary>
    protected AActivitySpace m_asOwner;
    protected IFolderModelRO m_asModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new ObjMgrSearchView();
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IView#Display()"></seealso>
    public virtual HTMLElement Display()
    {
      // Just call AdminSearchForm.GetObjectSearchForm()
      // to do all the work..
      return AdminSearchForm.GetObjectSearchForm(m_asOwner, 
      // Give the form a unique name
      /* name= */
      AFormDP.HTMLFORM_NAME, 
      // When form is submitted, results appear on page SampleResultsDP of the current space
      /* targetSpace= */
      AdminSearchAS.STR_MVC_CLASS_NAME, 
      // null means create a new space
      null, /* targetPage= */
      AdminSearchDP.STR_MVC_CLASS_NAME, 
      // Display a prompt
      /* prompt= */
      m_asOwner.GetString(1982, "ptmsgs_portaladminmsgs"), 
      // Restrict to this folder
      /* currentAdminFolder= */
      m_asModel.GetCurrentFolderID(), 
      // No object type restriction; type is selectable from a pulldown
      /* objectClassIDs= */
      null, 
      // Not needed if you've implemented your own view of search results
      /* makeEditLinks= */
      true, /* return complete form= */
      false, /* overrideEnclosingForm */
      true, /* additional elements */
      AdminFollowupSearchView.GetAdvancedAdminSearchLink(m_asOwner), /* validate alert */
      true);
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    public virtual HTMLScript DisplayJavascript()
    {
      // by default, return nothing
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IView#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asModel = (IFolderModelRO) model;
      m_asOwner = parent;
    }
  }
}