using System;
using com.plumtree.portalpages.admin.objmgr;
using com.plumtree.portalpages.common.createfolder;
namespace com.plumtree.portalpages.admin.objmgr.popups
{
  /// <author>
  /// Don Hayler
  /// This view is for a simple pop-up to create an admin folder.
  /// </author>
  public class ObjMgrCreateFolderView : CreateFolderView
  {
    
    /// <summary>
    /// name of this view 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "ObjMgrCreateFolder";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new ObjMgrCreateFolderView();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.createfolder.CreateFolderView#GetBannerTitle()"></seealso>
    public override String GetBannerTitle()
    {
      return m_asOwner.GetString(1977, "ptmsgs_portaladminmsgs");
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.createfolder.CreateFolderView#GetCreateFolderRepostAction()"></seealso>
    public override int GetCreateFolderRepostAction()
    {
      return ObjMgrRepostControl.POSTTOSELF_ACTION_CREATE_FOLDER;
    }
  }
}