using System;
using com.plumtree.portalpages.browsing.settings;
namespace com.plumtree.portalpages.admin.ptutilities
{
  /// <version>5.0</version>
  /// <author>SudhaSathiaseelan</author>
  /// <author>Mark Schaaf</author>
  public interface IPlumtreeUtilities : ISettings
  {
    
    /// <summary>
    /// Activity rights now restrict certain utility menu items;  this method allows access to the restricting
    /// activity right
    /// The following table outlines the utility security menu access:
    /// Utility\u0009\u0009\u0009\u0009\u0009\u0009Activity Right or Group Required for Access
    /// Activity Manager\u0009\u0009\u0009\u0009Create Activities
    /// Approve Documents\u0009\u0009\u0009Access Utilities
    /// Approve Objects for Migration\u0009Administrators Group Only
    /// Audit Manager\u0009\u0009\u0009\u0009Administrators Group Only
    /// Automation Server\u0009\u0009\u0009Administrators Group Only
    /// Default Profiles\u0009\u0009\u0009\u0009Create User
    /// Global ACL Sync Map\u0009\u0009\u0009Administrators Group Only
    /// Global Document Property Map\u0009Administrators Group Only
    /// Global Document Type Map\u0009\u0009Administrators Group Only
    /// Global Object Properties Map\u0009Administrators Group Only
    /// Knowledge Directory Preferences\u0009Administrators Group Only
    /// Localization Manager\u0009\u0009\u0009Administrators Group Only
    /// Object Migration Status\u0009\u0009Access Utilities
    /// Portal Resources - Export\u0009Administrators Group Only
    /// Portal Resources - Import\u0009Administrators Group Only
    /// Portal Server Settings\u0009\u0009Administrators Group Only
    /// Release Item Locks\u0009\u0009\u0009Administrators Group Only
    /// Release User Locks\u0009\u0009\u0009Administrators Group Only
    /// Search Server Manager\u0009\u0009Administrators Group Only
    /// Smart Sort\u0009\u0009\u0009\u0009\u0009Create Taxonomists
    /// Subportal Manager\u0009\u0009\u0009Create Subportals
    /// Tag Libraries Manager\u0009\u0009Administrators Group Only
    /// User Profile Manager\u0009\u0009\u0009Edit User Info Map
    /// Custom\u0009\u0009\u0009\u0009\u0009\u0009Read access to the Custom Utilities Web Service
    /// </summary>
    /// <returns>PT_ACTIVITY_RIGHTS value which restricts the access to this utility</returns>
    int GetActivityRightRestriction();
  }
}