using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.login;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.web;
namespace com.plumtree.portalpages.admin.ptutilities
{
  /// <author>SudhaS</author>
  public class PlumtreeUtilitiesModel : IPlumtreeUtilitiesModel,IPlumtreeUtilitiesModelRO
  {
    public const String STR_MVC_CLASS_NAME = "PlumtreeUtilities";
    private AActivitySpace m_asOwner;
    private XPArrayList m_SettingItems;
    public PlumtreeUtilitiesModel()
    {
      m_SettingItems = new XPArrayList();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IModel#CleanupTempData()"></seealso>
    public virtual void CleanupTempData()
    {
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IModel#CleanupAllData()"></seealso>
    public virtual void CleanupAllData()
    {
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new PlumtreeUtilitiesModel();
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IModelRO#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpagessample.PlumtreeUtilities.IPlumtreeUtilitiesModelRO#getString()"></seealso>
    public virtual int GetNumSettingItems()
    {
      return m_SettingItems.GetSize();
    }
    
    /// <param name="_nIndex"></param>
    /// <returns></returns>
    public virtual String GetSettingItemName(int _nIndex)
    {
      return ((SettingItem) m_SettingItems.GetElement(_nIndex)).m_strName;
      }
    
    /// <param name="_nIndex"></param>
    /// <returns></returns>
    public virtual String GetSettingItemURL(int _nIndex)
    {
      return ((SettingItem) m_SettingItems.GetElement(_nIndex)).m_strURL;
      }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.admin.ptutilities.IPlumtreeUtilitiesModelRO#GetActivityRightRestriction(int)
     */
     
    public virtual int GetActivityRightRestriction(int _nIndex)
    {
      return ((SettingItem) m_SettingItems.GetElement(_nIndex)).m_intActivityRight;
      }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.admin.ptutilities.IPlumtreeUtilitiesModelRO#IsPluggableAdmin(int)
     */
     
    public virtual bool IsPluggableAdmin(int _nIndex)
    {
      return ((SettingItem) m_SettingItems.GetElement(_nIndex)).m_bIsPluggableAdmin;
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IModel#Init(IActivitySpace)"></seealso>
    public virtual void Init(AActivitySpace _asOwner)
    {
      m_asOwner = _asOwner;
      IPTSession ptSession = (IPTSession) m_asOwner.GetUserSession();
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      Object[] oaSettings = (Object[]) application.GetCachingManager().GetEntry("DisplayPlumtreeUtilities");
      String strLang = XPConvert.ToString(PTPersonalSettingsHelper.GetPersonalSettingValue(PersonalSettingsHelper.LANGUAGE,
       _asOwner));
      for (int i = 0;i < oaSettings.Length;i++)
      {
        IPlumtreeUtilities objPlumtreeUtilities = (IPlumtreeUtilities) oaSettings[i];
        //this is not a pluggable admin utility menu item
        m_SettingItems.Add(new SettingItem(objPlumtreeUtilities.GetLinkText(strLang),
         GetLinkFromPortalSetting(objPlumtreeUtilities), objPlumtreeUtilities.GetActivityRightRestriction(),
         false));
      }
      // Pluggable Admin Setting Pages
      IPTSessionInfo ptSessionInfo = ptSession.GetSessionInfo();
      IPTQueryResult ptQueryResult = ptSessionInfo.GetCurrentUserCachedPluggablePages();
      for (int i = 0;i < ptQueryResult.RowCount();i++)
      {
        int nPersonalization = ptQueryResult.ItemAsInt(i, PT_PROPIDS.PT_PROPID_WEBSERVICE_PERSONALIZATION);
        //JD - Get the bit for admin personalization.
        int nUserPersonalization = nPersonalization & PT_GADGETPERSONALIZATION_ROLES.PT_WEBSERVICEPERSONALIZATION_ADMIN;
        //JD- Flag to keep track of whether Return URI was set correctly
        bool bReturnURISet = false;
        //JD- Compare the bitmasked number to the right value
        if (nUserPersonalization == PT_GADGETPERSONALIZATION_ROLES.PT_WEBSERVICEPERSONALIZATION_ADMIN)
        {
          //JD- This web service has admin personalization.
          String strName = ptQueryResult.ItemAsString(i, PT_PROPIDS.PT_PROPID_NAME);
          int nObjectID = ptQueryResult.ItemAsInt(i, PT_PROPIDS.PT_PROPID_OBJECTID);
          String strURL = GatewayHelpers.ConstructPrefPageLink(m_asOwner,
           nObjectID, 0, 0, GatewayHelpers.ADMINPLUGPAGE | GatewayHelpers.REDIRECTGUEST,
           PT_CLASSIDS.PT_WEBSERVICE_ID);
          //this is a pluggable admin menu item;  set the activity right to no activity right -mgs 9/2/03
          m_SettingItems.Add(new SettingItem(strName, strURL, PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_NONE,
           true));
          //JD- Add return URI.
          if (!bReturnURISet)
          {
            ASURL url = new ASURL(m_asOwner);
            bool bSetURL = url.SetLinkGetCachedSpace(m_asOwner);
            if (bSetURL)
            {
              HttpUtils.SetReturnURI(url.GetURLAsString(), m_asOwner.GetSubSession());
              bReturnURISet = true;
            }
          }
        }
      }
    }
    
    /// <param name="_ptUtility"></param>
    /// <returns></returns>
    private String GetLinkFromPortalSetting(IPlumtreeUtilities _ptUtility)
    {
      ASURL asURL = new ASURL(m_asOwner);
      String strUtilityURL = null;
      // The space
      asURL.SetLinkCreateNewSpace(_ptUtility.GetASName(), m_asOwner);
      // The control
      String strControl = _ptUtility.GetASControlName();
      if (strControl != null)
      {
        asURL.SetControl(strControl);
      }
      // The display page
      String strDP = _ptUtility.GetASDPName();
      if (strDP != null)
      {
        asURL.SetDisplayPage(strDP);
      }
      // The query string
      String strQueryString = _ptUtility.GetASQueryString();
      if (strQueryString != null)
      {
        strUtilityURL = asURL.GetURLAsString() + strQueryString;
      } else
      {
        strUtilityURL = asURL.GetURLAsString();
      }
      return strUtilityURL;
    }
    
    /// <author>SudhaS</author>
    private class SettingItem
    {
      public String m_strName;
      public String m_strURL;
      public int m_intActivityRight;
      public bool m_bIsPluggableAdmin;
      
      /// <summary>
      /// Creates a new SettingItem object.
      /// </summary>
      /// <param name="_strName"></param>
      /// <param name="_strURL"></param>
      public SettingItem(String _strName, String _strURL, int _intActivityRight,
       bool _bIsPluggableAdmin)
      {
        m_strName = _strName;
        m_strURL = _strURL;
        m_intActivityRight = _intActivityRight;
        m_bIsPluggableAdmin = _bIsPluggableAdmin;
      }
    }
  }
}