using System;
// Framework Imports
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.ptutilities.activitysecurity
{
  /// <summary>
  /// This is class is used to print out together the Views for
  /// the Sub Editors page of the Main Editor.
  /// </summary>
  /// <author>SudhaS</author>
  public class MainActivityRightsDP : EditorDP
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.ptutilities.activitysecurity.MainActivityRightsDP");
    public const String STR_MVC_CLASS_NAME = "MainActivityRights";
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,
    /// linking to that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return (m_asOwner.GetString(1349, "ptmsgs_portaladminmsgs"));
    }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1646, "ptmsgs_portaladminmsgs"),
       this.m_asOwner);
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for that Page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()"></seealso>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // Insert super class HTML
      try
      {
        result.AddInnerHTMLElement(base.PageDisplay());
        HTMLElementCollection views = new HTMLElementCollection();
        views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(MainActivityRightsEditorAS.strStorageActivityRightsList)).Display());
        result.AddInnerHTMLElement(CreateLeftNavBar(views));
      }
      catch (HTMLException e)
      {
        log.Error(e, "MainActivityRightsDP::PageDisplay.");
      }
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      // ***CHANGE_HERE*** If that DP doesn't have any JavaScripts, 
      //      you can delete the entire DisplayJavaScriptFromChild() method.
      HTMLScriptCollection myScripts = null;
      myScripts = base.DisplayJavaScriptFromChild();
      // ***CHANGE_HERE*** Call the DisplayJavascript() method for all the Views having JavaScripts 
      //      displayed by that DP.
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(MainActivityRightsEditorAS.strStorageActivityRightsList).DisplayJavascript());
      return myScripts;
    }
  }
}