using System;
// Framework Imports
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.admin.ptutilities.activitysecurity
{
  /// <summary>
  /// This class contains the additional repost actions.
  /// The ones specific to the Main Editor (other than
  /// "change page", "finish" and "cancel" actions).
  /// </summary>
  /// <author>SudhaS</author>
  public class MainActivityRightsRepostControl : EditorRepostControl
  {
    // ***CHANGE_HERE*** Change the name of the class.
    // ***COMMENT_1*** Delete the comments prefixed by CHANGE_HERE and COMMENT
    //       when you are done.
    // ***CHANGE_HERE*** Set the class name.
    // ***COMMENT_1*** All the Controls in Plumtree need to have a unique name.
    public const String STR_MVC_CLASS_NAME = "MainActivityRightsRepost";
    // ***CHANGE_HERE*** create a new constant for each repost action 
    //       you have in the entire Editor.
    // ***COMMENT_1*** The repost action value should not be below 10 
    // ***COMMENT_2*** If you are using any plug-in section, you need to make sure
    //       there is no conflict between your actions below and the plug-in actions.
    public const int POSTTOSELF_ACTION_REMOVEPROPERTY = 10;
    // ***CHANGE_HERE*** Note that you can also implement the method below 
    //      if you need to execute any code when the user finishes the sub Editor.
    /*
     protected void PerformFinishSubEditorAction()
     {
     
     }*/
     
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new MainActivityRightsRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call
    /// the associated method for each action.
    /// </summary>
    /// <param name="int"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      ((ExpListControl) m_asOwner.GetControl(MainActivityRightsEditorAS.strStorageActivityRightsList)).PerformRepostAction(_nAction,
       m_htFormData);
      switch (_nAction){
      case POSTTOSELF_ACTION_REMOVEPROPERTY:
      // ***EXAMPLE SUB EDITORS*** How to remove a sub Editor?
      String[] data = (String[]) m_htFormData.GetElement(MainActivityRightsListView.HTMLHIDDEN_PROPEDITORKEY);
      if ((null != data) && (0 != data.Length))
      {
        ((EditorAS) m_asOwner).DeleteSubEditorFromList(data[0]);
      }
      break;
      }
    }
  }
}