using System;
// Framework Imports
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.ptutilities.automationserver
{
  /// <summary>
  /// This is class is used to print out together the Views for
  /// the Sub Editors page of the Main Editor.
  /// </summary>
  /// <author>SudhaS</author>
  public class AutomationServerDP : EditorDP
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.ptutilities.automationserver.AutomationServerDP");
    public const String STR_MVC_CLASS_NAME = "AutomationServer";
    public const String HTMLHIDDEN_POPUP_NAME = "in_hi_PopUpName";
    public const String HTMLHIDDEN_POPUP_NETADDR = "in_hi_PopUpNetAddr";
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,
    /// linking to that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return (m_asOwner.GetString(1434, "ptmsgs_portaladminmsgs"));
    }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1657, "ptmsgs_portaladminmsgs"),
       this.m_asOwner);
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for that Page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()"></seealso>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // Insert super class HTML
      try
      {
        result.AddInnerHTMLElement(base.PageDisplay());
        HTMLElementCollection views = new HTMLElementCollection();
        // ***CHANGE_HERE*** For each Section you want to display on that page, 
        //       copy the line below and replace MainView with your Section name.
        views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(AutomationServerEditorAS.strStorageAutomationServerList)).Display());
        result.AddInnerHTMLElement(CreateLeftNavBar(views));
        HTMLInput myInput = new HTMLInput(HTMLInputTypes.HIDDEN, HTMLHIDDEN_POPUP_NAME,
         "");
        result.AddInnerHTMLElement(myInput);
        myInput = new HTMLInput(HTMLInputTypes.HIDDEN, HTMLHIDDEN_POPUP_NETADDR,
         "");
        result.AddInnerHTMLElement(myInput);
      }
      catch (HTMLException e)
      {
        log.Error(e, "AutomationServerDP Error");
      }
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      // ***CHANGE_HERE*** If that DP doesn't have any JavaScripts, 
      //      you can delete the entire DisplayJavaScriptFromChild() method.
      HTMLScriptCollection myScripts = null;
      myScripts = base.DisplayJavaScriptFromChild();
      // ***CHANGE_HERE*** Call the DisplayJavascript() method for all the Views having JavaScripts 
      //      displayed by that DP.
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(AutomationServerEditorAS.strStorageAutomationServerList).DisplayJavascript());
      return myScripts;
    }
  }
}