using System;
// Framework Imports
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.ptutilities.automationserver
{
  /// <summary>
  /// This is class is used to print out together the Views for
  /// the Misc Settings page of the Misc Editor.
  /// </summary>
  /// <author>SudhaS</author>
  public class AutomationServerPopUpDP : EditorDP
  {
    // ***CHANGE_HERE*** Change the name of the class.
    // ***COMMENT_1*** Delete the comments prefixed by CHANGE_HERE and COMMENT
    //       when you are done.
    // ***CHANGE_HERE*** Set the class name.
    // COMMENT1- All the DPs in your AS need to have a unique name.
    public const String STR_MVC_CLASS_NAME = "AutomationServerPopUp";
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,
    /// linking to that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      // JF- This is not used here.
      return "";
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for that Page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()"></seealso>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    public override HTMLElement PageDisplay()
    {
      // ***CHANGE_HERE*** For each Section you want to display on that page, 
      //       copy the line below and replace Misc2View with your Section name.		
      HTMLElementCollection result = new HTMLElementCollection();
      result.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(AutomationServerPopUpView.STR_MVC_CLASS_NAME)).Display());
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      // ***CHANGE_HERE*** If that DP doesn't have any JavaScripts, 
      //      you can delete the entire DisplayJavaScriptFromChild() method.
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      // ***CHANGE_HERE*** Call the DisplayJavascript() method for all the Views having JavaScripts 
      //      displayed by that DP.
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(AutomationServerPopUpView.STR_MVC_CLASS_NAME).DisplayJavascript());
      return myScripts;
    }
    public override String GetFormTitle()
    {
      return (m_asOwner.GetString(1454, "ptmsgs_portaladminmsgs"));
    }
  }
}