using System;
// Framework Imports
using com.plumtree.portalpages.common.joblogs;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.admin.ptutilities.automationserver
{
  /// <summary>
  /// This class contains the additional repost actions.
  /// The ones specific to the Main Editor (other than
  /// "change page", "finish" and "cancel" actions).
  /// </summary>
  /// <author>SudhaS</author>
  public class AutomationServerRepostControl : EditorRepostControl
  {
    public const String STR_MVC_CLASS_NAME = "AutomationServerRepost";
    public const int POSTTOSELF_ACTION_REMOVEPROPERTY = 10;
    public const int POSTTOSELF_ACTION_DONE_POPUP = 11;
    public const int POSTTOSELF_ACTION_SHOW_NEWDATES = 12;
    public const int POSTTOSELF_ACTION_DELETE_FROMDATE = 13;
    // ***CHANGE_HERE*** Note that you can also implement the method below 
    //      if you need to execute any code when the user finishes the sub Editor.
    /*
     protected void PerformFinishSubEditorAction()
     {
     
     }*/
     
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new AutomationServerRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call
    /// the associated method for each action.
    /// </summary>
    /// <param name="int"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      ((ExpListControl) m_asOwner.GetControl(AutomationServerEditorAS.strStorageAutomationServerList)).PerformRepostAction(_nAction,
       m_htFormData);
      switch (_nAction){
      case POSTTOSELF_ACTION_REMOVEPROPERTY:
      // ***EXAMPLE SUB EDITORS*** How to remove a sub Editor?
      String[] data = (String[]) m_htFormData.GetElement(AutomationServerListView.HTMLHIDDEN_PROPEDITORKEY);
      if ((null != data) && (0 != data.Length))
      {
        ((EditorAS) m_asOwner).DeleteSubEditorFromList(data[0]);
      }
      break;
      case POSTTOSELF_ACTION_DONE_POPUP:
      ((AutomationServerModel) m_model).DoTaskOnComeBackFromPopUp();
      break;
      case POSTTOSELF_ACTION_SHOW_NEWDATES:
      ((AutomationServerModel) m_model).DoTaskOnShowNewDates();
      break;
      case POSTTOSELF_ACTION_DELETE_FROMDATE:
      ((AutomationServerModel) m_model).DoTaskOnDeleteFromDate();
      //((AutomationServerListModel) m_asOwner.GetModel(AutomationServerEditorAS.m_strStorageAutomationServerList)).DoTaskOnComeBackFromPopUp();
      break;
      default:
      //Call the repost action on the JobLogRepostControl
      JobLogRepostControl myControl = (JobLogRepostControl) m_asOwner.GetControl(JobLogRepostControl.STR_MVC_CLASS_NAME);
      Redirect myRedirect;
      myRedirect = myControl.CheckActionSecurityAndExecute(m_htFormData);
      if (null != myRedirect)
      {
        m_rRedirect = myRedirect;
      }
      break;
      }
    }
  }
}