using System;
// Framework Imports
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.admin.ptutilities.condition
{
  public class SubportalRulesManagerAS : EditorAS
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.ptutilities.condition.SubportalRulesManagerAS");
    public const String STR_MVC_CLASS_NAME = "SubportalRulesManagerAS";
    public const String SUBPORTAL_RULES_LIST = "SubportalRulesList";
    public const String GUEST_RULES_LIST = "GuestRulesList";
    public const String FOLDER_RULES_LIST = "FolderRulesList";
    private const String sClassName = "com.plumtree.portalpages.admin.editors.condition.SubportalRulesManagerAS";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SubportalRulesManagerAS();
    }
    
    /// <summary>
    /// Sets the Editor title.
    /// </summary>
    public override String GetEditorTitle()
    {
      return GetString(2863, "ptmsgs_portaladminmsgs");
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the class name of the Repost Control.
    /// </summary>
    /// <returns>String</returns>
    public override String GetRepostControlName()
    {
      return (SubportalRulesManagerRepostControl.STR_MVC_CLASS_NAME);
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage()"></seealso>
    /// <param name="IDisplayPage">the current Display Page</param>
    public override void SetCurrentPage(IDisplayPage page)
    {
      base.SetCurrentPage(page);
      String sPageName = page.GetName();
      if (SubportalRulesManagerMainDP.STR_MVC_CLASS_NAME.Equals(sPageName))
      {
        this.SetHelpTopic("PT_SubportalRulesManager_SubportalRules");
      } else
      if (SubportalRulesManagerGuestDP.STR_MVC_CLASS_NAME.Equals(sPageName))
      {
        this.SetHelpTopic("PT_SubportalRulesManager_GuestLoginRules");
      } else
      if (SubportalRulesManagerFolderDP.STR_MVC_CLASS_NAME.Equals(sPageName))
      {
        this.SetHelpTopic("PT_SubportalRulesManager_FolderRules");
      }
    }
    
    /// <summary>
    /// Registers all the classes for this Activity Space.
    /// </summary>
    public override void Init()
    {
      m_strModelName = SubportalRulesManagerModel.STR_MVC_CLASS_NAME;
      base.Init();
      IModel myModel = GetModel(m_strModelName);
      // Main DP
      SubportalRulesManagerMainDP smMainDP = new SubportalRulesManagerMainDP();
      // Register DisplayPages
      RegisterPage(smMainDP);
      // Guest Rules DP
      SubportalRulesManagerGuestDP smGuestDP = new SubportalRulesManagerGuestDP();
      // Register DisplayPages
      RegisterPage(smGuestDP);
      // Folder Rules DP
      SubportalRulesManagerFolderDP smFolderDP = new SubportalRulesManagerFolderDP();
      // Register DisplayPages
      RegisterPage(smFolderDP);
      // Register Subportal Rules Expandable List
      RegisterModel(RulesListModel.STR_MVC_CLASS_NAME, SUBPORTAL_RULES_LIST);
      // Get back the Model we just registered because we need it to register the Section and the Control
      IModel rulesListModel = GetModel(SUBPORTAL_RULES_LIST);
      RegisterView(RulesListView.STR_MVC_CLASS_NAME, SUBPORTAL_RULES_LIST,
       rulesListModel);
      RegisterControl(ExpListControl.STR_MVC_CLASS_NAME, SUBPORTAL_RULES_LIST,
       rulesListModel);
      // Register Guest Rules Expandable List
      RegisterModel(RulesListModel.STR_MVC_CLASS_NAME, GUEST_RULES_LIST);
      // Get back the Model we just registered because we need it to register the Section and the Control
      rulesListModel = GetModel(GUEST_RULES_LIST);
      RegisterView(RulesListView.STR_MVC_CLASS_NAME, GUEST_RULES_LIST, rulesListModel);
      // Register Folder Rules Expandable List
      RegisterModel(RulesListModel.STR_MVC_CLASS_NAME, FOLDER_RULES_LIST);
      // Get back the Model we just registered because we need it to register the Section and the Control
      rulesListModel = GetModel(FOLDER_RULES_LIST);
      RegisterView(RulesListView.STR_MVC_CLASS_NAME, FOLDER_RULES_LIST, rulesListModel);
      RegisterControl(ExpListControl.STR_MVC_CLASS_NAME, FOLDER_RULES_LIST,
       rulesListModel);
      // Register Controls
      RegisterControl(SubportalRulesManagerRepostControl.STR_MVC_CLASS_NAME,
       myModel);
      // Default page
      SetCurrentPage(SubportalRulesManagerMainDP.STR_MVC_CLASS_NAME);
      //Sets left nav menu
      int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(2864, "ptmsgs_portaladminmsgs"));
      m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, SubportalRulesManagerMainDP.STR_MVC_CLASS_NAME);
      m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, SubportalRulesManagerGuestDP.STR_MVC_CLASS_NAME);
      m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, SubportalRulesManagerFolderDP.STR_MVC_CLASS_NAME);
      }
  }
}