using System;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.admin.ptutilities.condition
{
  /// <summary>
  /// Delete that class if you don't have any repost actions.
  /// </summary>
  public class SubportalRulesManagerRepostControl : EditorRepostControl
  {
    public const String STR_MVC_CLASS_NAME = "SubportalRulesManagerRepostControl";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SubportalRulesManagerRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call  the associated method for each
    /// action.
    /// </summary>
    /// <param name="_nAction"></param>
    protected override void PerformAction(int _nAction)
    {
      ExpListControl listControl = (ExpListControl) m_asOwner.GetControl(SubportalRulesManagerAS.SUBPORTAL_RULES_LIST);
      listControl.PerformRepostAction(_nAction, m_htFormData);
      listControl = (ExpListControl) m_asOwner.GetControl(SubportalRulesManagerAS.FOLDER_RULES_LIST);
      listControl.PerformRepostAction(_nAction, m_htFormData);
      base.PerformAction(_nAction);
    }
  }
}