using System;
// Framework Imports
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.admin.ptutilities.credentialvaultmanager
{
  /// <author>jennifersu</author>
  public class CredentialVaultManagerRepostControl : EditorRepostControl
  {
    public const String STR_MVC_CLASS_NAME = "CredentialVaultManagerRepost";
    public const int POSTTOSELF_ACTION_REMOVEPROPERTY = 10;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new CredentialVaultManagerRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call
    /// the associated method for each action.
    /// </summary>
    /// <param name="int"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      ((ExpListControl) m_asOwner.GetControl(CredentialVaultManagerAS.strLockboxList)).PerformRepostAction(_nAction,
       m_htFormData);
      switch (_nAction){
      case POSTTOSELF_ACTION_REMOVEPROPERTY:
      // ***EXAMPLE SUB EDITORS*** How to remove a sub Editor?
      String[] data = (String[]) m_htFormData.GetElement(LockboxListView.HTMLHIDDEN_LOCKBOXEDITORKEY);
      if ((null != data) && (0 != data.Length))
      {
        ((EditorAS) m_asOwner).DeleteSubEditorFromList(data[0]);
      }
      break;
      }
    }
  }
}