using System;
// Framework Imports
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.editor.commonpages.migrationhistory;
using com.plumtree.portaluiinfrastructure.expandablelist.selectptobject;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.admin.ptutilities.customactivity
{
  /// <author>SudhaS</author>
  public class CustomActivityEditorAS : PTEditorAS
  {
    public const String STR_MVC_CLASS_NAME = "CustomActivityEditor";
    public const String strStorageSelectPTObject = "SelectUserPTObject";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new CustomActivityEditorAS();
    }
    
    /// <summary>
    /// Sets the Editor title.
    /// </summary>
    public override String GetEditorTitle()
    {
      if (EditorStartControl.EDITOR_START_FLAG_CREATE == ((EditorModel) GetModel(m_strModelName)).GetEditorType())
      {
        return (GetString(1459, "ptmsgs_portaladminmsgs"));
      } else
      {
        return (GetString(1460, "ptmsgs_portaladminmsgs"));
      }
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the class name of the Repost Control.
    /// </summary>
    /// <returns>String</returns>
    public override String GetRepostControlName()
    {
      return (CustomActivityRepostControl.STR_MVC_CLASS_NAME);
    }
    
    /// <summary>
    /// Registers all the classes for this Activity Space.
    /// </summary>
    public override void Init()
    {
      m_strModelName = CustomActivityModel.STR_MVC_CLASS_NAME;
      base.Init();
      IModel myModel = GetModel(m_strModelName);
      // Get back the Model we just registered because we need it to register the Section and the Control
      RegisterModel(SelectPTObjectModel.STR_MVC_CLASS_NAME, strStorageSelectPTObject);
      IModel mySelectPTObjectModel = GetModel(strStorageSelectPTObject);
      RegisterView(CustomActivityListView.STR_MVC_CLASS_NAME, strStorageSelectPTObject,
       mySelectPTObjectModel);
      RegisterControl(ExpListControl.STR_MVC_CLASS_NAME, strStorageSelectPTObject,
       mySelectPTObjectModel);
      // Register DisplayPages
      //RegisterPage(new MainDP());
      CustomActivityDP mainDP = new CustomActivityDP();
      RegisterPage(mainDP);
      mainDP.AddToValidationFunction("CheckName");
      mainDP.AddToValidationFunction("CheckURI");
      // Register Views
      RegisterView(GeneralInfoView.STR_MVC_CLASS_NAME, myModel);
      // Register Controls
      RegisterControl(CustomActivityRepostControl.STR_MVC_CLASS_NAME, myModel);
      // Default page
      SetCurrentPage(CustomActivityDP.STR_MVC_CLASS_NAME);
      // Register Migration History Plugin
      RegisterModel(MigrationHistoryPluginModel.STR_MVC_CLASS_NAME);
      RegisterView(MigrationHistoryView.STR_MVC_CLASS_NAME, GetModel(MigrationHistoryPluginModel.STR_MVC_CLASS_NAME));
      RegisterPage(new MigrationHistoryPluginDP());
      //Sets left nav menu
      int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(1461, "ptmsgs_portaladminmsgs"));
      m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, CustomActivityDP.STR_MVC_CLASS_NAME);
      m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, MigrationHistoryPluginDP.STR_MVC_CLASS_NAME);
      }
    
    /// <summary>
    /// Set the help page for this editor. 
    /// </summary>
    /// <param name="page"></param>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage(com.plumtree.uiinfrastructure.activityspace.IDisplayPage)"></seealso>
    public override void SetCurrentPage(IDisplayPage page)
    {
      base.SetCurrentPage(page);
      String sPageName = page.GetName();
      if (CustomActivityDP.STR_MVC_CLASS_NAME.Equals(sPageName))
      {
        this.SetHelpTopic("PT_PortalActivity_MainSettings");
      }
    }
  }
}