using System;
using com.plumtree.portaluiinfrastructure.expandablelist.selectptobject;
using com.plumtree.uiinfrastructure.arraywrapper;
using com.plumtree.uiinfrastructure.expandablelist;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.ptutilities.customactivity
{
  /// <author>
  /// SudhaS
  /// To change this generated comment edit the template variable "typecomment":
  /// Window>Preferences>Java>Templates.
  /// To enable and disable the creation of type comments go to
  /// Window>Preferences>Java>Code Generation.
  /// </author>
  public class CustomActivityListView : SelectPTObjectView
  {
    
    /// <summary>
    /// Class name for the activity space 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "CustomActivityList";
    public override Object Create()
    {
      return new CustomActivityListView();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for the Action bar.
    /// (The one with the add and delete icons).
    /// </summary>
    /// <returns>HTMLTable</returns>
    /// <throws>Exception</throws>
    protected override HTMLTable GetHTMLForActionBar()
    {
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      myTable = new HTMLTable();
      myTable.SetBorder("0");
      myTable.SetCellPadding("0");
      myTable.SetCellSpacing("0");
      CustomActivityModel customActivityModel = (CustomActivityModel) m_asOwner.GetModel(CustomActivityModel.STR_MVC_CLASS_NAME);
      bool bDelegateRight = customActivityModel.GetDelegateRight();
      // 1st Row begin (there is only one row)
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myRow.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BG);
      // JF- Get the Object array from the Model.
      IPTGrowableSortedArrayWrapperRO saData = ((IExpListModelRO) m_model).GetReadOnlyItems();
      if (bDelegateRight)
      {
        // DCA - check if add button wants to be shown
        // JF- Don't display the add button if we have reached the max number
        if (!((IExpListModelRO) m_model).IsAddButtonDisabled() && (saData.GetCount() < ExpListModel.MAX_ROWS))
        {
          // Add icon cell
          myRow.AddInnerHTMLElement(GetHTMLForAddAction());
          // Empty Cell
          myRow.AddInnerHTMLElement(GetHTMLForEmptyCellInActionBar());
        }
        // Add Extra HTML to the action bar (like a "create" button)
        AddHTMLToActionBar(myRow);
        // Empty Cell
        myRow.AddInnerHTMLElement(GetHTMLForEmptyCellInActionBar());
        // JF- No need to display the delete icon, if the list is empty.
        if (0 != ((IExpListModelRO) m_model).GetReadOnlyItems().GetCount())
        {
          // Delete icon cell
          myRow.AddInnerHTMLElement(GetHTMLForDeleteAction());
        }
        // Last Empty Cell
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetWidth("100%");
        myCell.SetHeight("25");
        myCell.AddInnerHTMLString(SPACE);
      } else
      {
        //Add message to tell user that they do not have rights to create/delete an activity
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        //myCell.SetWidth("100%");
        myCell.SetHeight("25");
        myCell.AddInnerHTMLString(SPACE);
        myCell = new HTMLTableCell();
        myCell.SetWidth("100%");
        myCell.SetHeight("25");
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
        myCell.AddInnerHTMLString(m_asOwner.GetString(2369, "ptmsgs_portaladminmsgs"));
        }
      // 1st Row ends
      return myTable;
    }
  }
}