using System;
// Framework Imports
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.ptutilities.customactivity
{
  /// <author>SudhaS</author>
  public class GeneralInfoView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.ptutilities.customactivity.GeneralInfoView");
    public const String STR_MVC_CLASS_NAME = "CustomInfo";
    public const String HTMLINPUT_CREATE_NAME = "in_tx_CreateName";
    public const String HTMLINPUT_CREATE_DESC = "in_tx_CreateDesc";
    public const String HTMLINPUT_CREATE_URI = "in_tx_CreateURI";
    private const String CREATE_NAME_SIZE = "25";
    private const String CREATE_DESC_SIZE = "45";
    private const String CREATE_URI_SIZE = "45";
    private static int INTRINSIC_ACTIVITY_CEILING = 200;
    private static int INTRINSIC_ACTIVITY_FLOOR = 0;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new GeneralInfoView();
    }
    
    /// <returns></returns>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTableCell myCell;
      HTMLTableRow myRow;
      HTMLInput myInput;
      try
      {
        result.AddInnerHTMLElement(base.GetHeaderView(m_asOwner.GetString(1468,
         "ptmsgs_portaladminmsgs")));
        HTMLTable myTable = new HTMLTable();
        result.AddInnerHTMLElement(myTable);
        myTable.SetWidth("100%");
        myTable.SetBorder("0");
        myTable.SetCellPadding("5");
        myTable.SetCellSpacing("0");
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myCell.SetWidth("15%");
        myRow.AddInnerHTMLElement(myCell);
        myCell.AddInnerHTMLString(m_asOwner.GetString(1470, "ptmsgs_portaladminmsgs"));
        myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
        int nActivityID = ((ICustomActivityModelRO) m_model).GetActivityID();
        String strActivityName = ((ICustomActivityModelRO) m_model).GetActivityName();
        String strActivityDescription = ((ICustomActivityModelRO) m_model).GetActivityDescription();
        String strActivityURI = ((ICustomActivityModelRO) m_model).GetActivityURI();
        bool bIntrinsic = ((nActivityID < INTRINSIC_ACTIVITY_CEILING) && (nActivityID >= INTRINSIC_ACTIVITY_FLOOR));
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
        myRow.AddInnerHTMLElement(myCell);
        if (bIntrinsic)
        {
          myCell.AddInnerHTMLString(strActivityName);
        } else
        {
          myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_CREATE_NAME,
           "This is an input");
          myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
          myInput.SetValue(strActivityName);
          myInput.SetSize(CREATE_NAME_SIZE);
          myCell.AddInnerHTMLElement(myInput);
        }
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myCell.SetWidth("15%");
        myCell.AddInnerHTMLString(m_asOwner.GetString(1471, "ptmsgs_portaladminmsgs"));
        myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
        myRow.AddInnerHTMLElement(myCell);
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
        myRow.AddInnerHTMLElement(myCell);
        if (bIntrinsic)
        {
          myCell.AddInnerHTMLString(strActivityDescription);
        } else
        {
          myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_CREATE_DESC,
           "This is an input");
          myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
          myInput.SetValue(strActivityDescription);
          myInput.SetSize(CREATE_DESC_SIZE);
          myCell.AddInnerHTMLElement(myInput);
        }
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetWidth("15%");
        myCell.AddInnerHTMLString(m_asOwner.GetString(1472, "ptmsgs_portaladminmsgs"));
        myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
        myRow.AddInnerHTMLElement(myCell);
        if (bIntrinsic)
        {
          myCell.AddInnerHTMLString(strActivityURI);
        } else
        {
          myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_CREATE_URI,
           "This is an input");
          myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
          myInput.SetValue(strActivityURI);
          myInput.SetSize(CREATE_URI_SIZE);
          myCell.AddInnerHTMLElement(myInput);
        }
      }
      catch (Exception e)
      {
        log.Error(e, "GeneralInfoView::Display The following error occured when trying to display the HTML.");
        throw new XPException(m_asOwner.GetString(1469, "ptmsgs_portaladminmsgs"),
         e);
      }
      return result;
    }
    
    /// <returns></returns>
    public override HTMLScript DisplayJavascript()
    {
      HTMLScript myScript = null;
      // ***CHANGE_HERE*** Write all the JavaScripts for that Section bellow.
      // ***COMMENT_1*** Note that you also need to call that method from the 
      //       DP (see PropMainDP)
      // ***COMMENT_2*** Put all your JavaScripts bellow (validation or no) they 
      //       will be printed out in the header.
      // ***COMMENT_3*** If that Section doesn't have any JavaScripts, 
      //      you can delete the entire DisplayJavascript() method.
      // ***COMMENT_4*** If this is a client side validation, you should use 
      //      the AddToValidationFunction in your AS class (see PropEditorAS).
      try
      {
        XPStringBuilder sb = new XPStringBuilder(300);
        myScript = new HTMLScript("text/javaScript");
        int nActivityID = ((ICustomActivityModelRO) m_model).GetActivityID();
        if ((nActivityID >= INTRINSIC_ACTIVITY_CEILING) || (nActivityID < INTRINSIC_ACTIVITY_FLOOR))
        {
          // The JavaScript bellow checks if the Property Name is empty.
          sb.Append("function CheckName()\n");
          sb.Append("{\n");
          sb.Append("  if (document." + EditorDP.HTMLFORM_NAME + ".in_tx_CreateName.value.length == 0)\n");
          sb.Append("  {\n");
          sb.Append("      alert(\"").Append(m_asOwner.GetString(1990, "ptmsgs_portaladminmsgs")).Append("\");\n");
          sb.Append("      return false;\n");
          sb.Append("  }\n");
          sb.Append("  return true;\n");
          sb.Append("}\n");
          sb.Append("function CheckURI()\n");
          sb.Append("{\n");
          sb.Append("  if (document." + EditorDP.HTMLFORM_NAME + ".in_tx_CreateURI.value.length == 0)\n");
          sb.Append("  {\n");
          sb.Append("      alert(\"").Append(m_asOwner.GetString(1991, "ptmsgs_portaladminmsgs")).Append("\");\n");
          sb.Append("      return false;\n");
          sb.Append("  }\n");
          sb.Append("  return true;\n");
          sb.Append("}\n");
        } else
        {
          sb.Append("function CheckName()\n");
          sb.Append("{\n");
          sb.Append("  return true;\n");
          sb.Append("}\n");
          sb.Append("function CheckURI()\n");
          sb.Append("{\n");
          sb.Append("  return true;\n");
          sb.Append("}\n");
        }
        myScript.AddInnerHTMLString(sb.ToString());
      }
      catch (Exception e)
      {
        log.Error(e, "GeneralInfoView::DisplayJavascript The following error occured when trying to display the JavaScript: " + e.Message);
        }
      return (myScript);
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}