using System;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
namespace com.plumtree.portalpages.admin.ptutilities.diagnostic.dynamicloads.varpacks
{
  /// <summary>
  /// This Activity Space displays the currently loaded VarPacks.
  /// </summary>
  /// <author>DonH</author>
  public class VarPackAS : AFormAS
  {
    
    /// <summary>
    /// Class name for the activity space 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "VarPack";
    
    /// <summary>
    /// Registers all the classes of the Activity Space.
    /// </summary>
    public override void Init()
    {
      base.Init();
      // Main VarPack Popup Page
      RegisterPage(new VarPackPopupDP());
      RegisterView(VarPackView.STR_MVC_CLASS_NAME, null);
      // View VarPack Contents Popup Page
      RegisterPage(new VarPackContentDP());
      RegisterModel(VarPackModel.STR_MVC_CLASS_NAME);
      IModel model = GetModel(VarPackModel.STR_MVC_CLASS_NAME);
      RegisterView(VarPackContentView.STR_MVC_CLASS_NAME, model);
      RegisterControl(ViewVarPackControl.STR_MVC_CLASS_NAME, model);
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(java.lang.String,java.lang.String,boolean)"></seealso>
    public override bool CheckBasicAccess(String strPage, String strControl,
     bool bSameSpace)
    {
      if (!PlumtreeHelpers.CheckCurrentUserIsAdmin((IPTSession) GetUserSession()))
      {
        return false;
      }
      // Check for right to access administration
      return ((IPTSession) GetUserSession()).GetSessionInfo().CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_ACCESS_ADMINISTRATION);
      }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new VarPackAS();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}