using System;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.ptutilities.diagnostic.dynamicloads.varpacks
{
  /// <summary>
  /// This Display Page displays HTTPMemoryDebugVarPackContentView.
  /// </summary>
  /// <author>Julie Fournier</author>
  public class VarPackContentDP : AFormDP
  {
    
    /// <summary>
    /// Class name for the activity space 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "VarPackContent";
    public override String GetFormTitle()
    {
      return m_asOwner.GetString(1954, "ptmsgs_portaladminmsgs");
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      return m_asOwner.GetView(VarPackContentView.STR_MVC_CLASS_NAME).Display();
      }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = new HTMLScriptCollection();
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(VarPackContentView.STR_MVC_CLASS_NAME).DisplayJavascript());
      return myScripts;
    }
  }
}