using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.admin.ptutilities.diagnostic.dynamicloads.varpacks
{
  /// <summary>
  /// This control processes which VarPack to display.
  /// </summary>
  /// <author>DonH</author>
  public class ViewVarPackControl : IControl
  {
    public const String STR_MVC_CLASS_NAME = "ViewVarPack";
    
    /// <summary>
    /// HTML Object: hidden input for var pack ID to view 
    /// </summary>
    public const String HTMLHIDDEN_VIEW_VARPACK_ID = "in_hi_ViewVarPackID";
    protected IVarPackModelRO m_model = null;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IControl#CheckActionSecurityAndExecute(com.plumtree.openfoundation.util.XPHashtable)"></seealso>
    public virtual Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      String[] data = (String[]) arguments.GetElement(HTMLHIDDEN_VIEW_VARPACK_ID);
      if ((null != data) && !(0 == data.Length))
      {
        ((VarPackModel) m_model).SetCurrentVarPackID(data[0]);
      }
      return null;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IControl#Init(com.plumtree.uiinfrastructure.activityspace.IModel,com.plumtree.uiinfrastructure.activityspace.AActivitySpace)"></seealso>
    public virtual void Init(IModel model, AActivitySpace space)
    {
      m_model = (IVarPackModelRO) model;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new ViewVarPackControl();
    }
  }
}