using System;
using com.plumtree.portalpages.admin.ptutilities.diagnostic;
using com.plumtree.portalpages.admin.ptutilities.diagnostic.dynamicloads;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.admin.ptutilities.diagnostic.pages
{
  /// <summary>
  /// This page displays the portal dynamic (custom objects and PEIs). 
  /// </summary>
  /// <author>DonH</author>
  public class DynamicLoadsPage : IDiagnosticPage
  {
    
    /// <seealso cref="com.plumtree.portalpages.admin.ptutilities.diagnostic.IDiagnosticPage#GetDiagnosticPage()"></seealso>
    public virtual EditorDP GetDiagnosticPage()
    {
      return new DynamicLoadsDP();
    }
    
    /// <seealso cref="com.plumtree.portalpages.admin.ptutilities.diagnostic.IDiagnosticPage#GetHelperRepostControlName()"></seealso>
    public virtual String GetHelperRepostControlName()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.portalpages.admin.ptutilities.diagnostic.IDiagnosticPage#Init(com.plumtree.uiinfrastructure.activityspace.AActivitySpace)"></seealso>
    public virtual void Init(AActivitySpace _asOwner)
    {
      _asOwner.RegisterView(DynamicLoadsView.STR_MVC_CLASS_NAME, null);
    }
    
    /// <seealso cref="com.plumtree.portalpages.admin.ptutilities.diagnostic.IDiagnosticPage#RunDiagnosticTest(com.plumtree.uiinfrastructure.activityspace.AActivitySpace)"></seealso>
    public virtual void RunDiagnosticTest(AActivitySpace _asOwner)
    {
    }
    
    /// <seealso cref="com.plumtree.portalpages.admin.ptutilities.diagnostic.IDiagnosticPage#GetHelpTopic()"></seealso>
    public virtual String GetHelpTopic()
    {
      return "PT_Diagnostic_DynamicLoads";
    }
    
    /// <seealso cref="com.plumtree.portalpages.admin.ptutilities.diagnostic.IDiagnosticPage#HasTip()"></seealso>
    public virtual bool HasTip()
    {
      // This diagnostic page does not have a tip.
      return false;
    }
    
    /// <seealso cref="com.plumtree.portalpages.admin.ptutilities.diagnostic.IDiagnosticPage#GetTipTitleID()"></seealso>
    public virtual int GetTipTitleID()
    {
      return 0;
    }
    
    /// <seealso cref="com.plumtree.portalpages.admin.ptutilities.diagnostic.IDiagnosticPage#GetTipID()"></seealso>
    public virtual int GetTipID()
    {
      return 0;
    }
    
    /// <seealso cref="com.plumtree.portalpages.admin.ptutilities.diagnostic.IDiagnosticPage#GetSecondaryTipID()"></seealso>
    public virtual int GetSecondaryTipID()
    {
      return 0;
    }
  }
}