using System;
using com.plumtree.portalpages.admin.serversettings.search;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.admin.ptutilities.diagnostic.relatedservers.search
{
  /// <summary>
  /// This space shows a popup search server status page.
  /// </summary>
  /// <author>DonH</author>
  public class SearchServerStatusAS : AActivitySpace
  {
    
    /// <summary>
    /// Class name for the activity space 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "SearchStatus";
    
    /// <summary>
    /// Registers all the classes of the Activity Space.
    /// </summary>
    public override void Init()
    {
      base.Init();
      // Main Search Status Popup Page
      RegisterPage(new SearchServerStatusPopupDP());
      RegisterModel(SearchServerSettingsEditorModel.STR_MVC_CLASS_NAME);
      SearchServerSettingsEditorModel model = (SearchServerSettingsEditorModel) GetModel(SearchServerSettingsEditorModel.STR_MVC_CLASS_NAME);
      // This normally gets called by the editor framework in
      // CheckEditorAccessAndStart(), but since we are using this
      // model outside of the editor framework, we need to call
      // this manually.
      model.InitializePropertyValues();
      RegisterView(SearchServerStatusView.STR_MVC_CLASS_NAME, model);
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(java.lang.String,java.lang.String,boolean)"></seealso>
    public override bool CheckBasicAccess(String strPage, String strControl,
     bool bSameSpace)
    {
      if (!PlumtreeHelpers.CheckCurrentUserIsAdmin((IPTSession) GetUserSession()))
      {
        return false;
      }
      // Check for right to access administration
      return ((IPTSession) GetUserSession()).GetSessionInfo().CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_ACCESS_ADMINISTRATION);
      }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SearchServerStatusAS();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}