using System;
using com.plumtree.portalpages.common.constants;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.ptutilities.diagnostic.relatedservers.search
{
  /// <summary>
  /// This shows a popup search server status page.
  /// </summary>
  /// <author>DonH</author>
  public class SearchServerStatusPopupDP : SimplePopUpDP
  {
    public const String STR_MVC_CLASS_NAME = "SearchStatusPopUp";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.SimplePopUpDP#GetTitle()"></seealso>
    public override String GetTitle()
    {
      // "Search Server Status"
      return m_asOwner.GetString(3099, ResourceConstants.PORTALADMINMSGS);
      }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.SimplePopUpDP#PageDisplay()"></seealso>
    protected override HTMLElement PageDisplay()
    {
      return m_asOwner.GetView(SearchServerStatusView.STR_MVC_CLASS_NAME).Display();
      }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.SimplePopUpDP#DisplayJavaScriptFromChild()"></seealso>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection result = new HTMLScriptCollection();
      result.AddInnerHTMLElement(m_asOwner.GetView(SearchServerStatusView.STR_MVC_CLASS_NAME).DisplayJavascript());
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}