using System;
using com.plumtree.portalpages.common.constants;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.ptutilities.diagnostic.remotehosts.hostservices
{
  /// <summary>
  /// Displays a list of all the portlet web services associated
  /// with a given host machine.
  /// </summary>
  /// <author>DonH</author>
  public class HostServicesPopupDP : SimplePopUpDP
  {
    
    /// <summary>
    /// Name for the page 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "HostServices";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.SimplePopUpDP#GetTitle()"></seealso>
    public override String GetTitle()
    {
      // "Remote Host Portlet Web Services"
      return m_asOwner.GetString(3118, ResourceConstants.PORTALADMINMSGS);
      }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.SimplePopUpDP#PageDisplay()"></seealso>
    protected override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      result.AddInnerHTMLElement(m_asOwner.GetView(ContentCollabLinksView.STR_MVC_CLASS_NAME).Display());
      result.AddInnerHTMLElement(m_asOwner.GetView(HostServicesAS.STR_MVC_STORAGE_NAME_MULTI_COLUMN_LIST).Display());
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.SimplePopUpDP#DisplayJavaScriptFromChild()"></seealso>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection result = new HTMLScriptCollection();
      result.AddInnerHTMLElement(m_asOwner.GetView(ContentCollabLinksView.STR_MVC_CLASS_NAME).DisplayJavascript());
      result.AddInnerHTMLElement(m_asOwner.GetView(HostServicesAS.STR_MVC_STORAGE_NAME_MULTI_COLUMN_LIST).DisplayJavascript());
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}