using System;
using com.plumtree.portalpages.admin.ptutilities.diagnostic;
using com.plumtree.portalpages.common.constants;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.uiinfrastructure.htmlconstructs;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.ptutilities.diagnostic.serverstatuslist
{
  /// <summary>
  /// This view overrides the server status list and adds a refresh action.
  /// </summary>
  /// <author>DonH</author>
  public class RefreshServerStatusListView : ServerStatusListView
  {
    
    /// <summary>
    /// Class name for the activity space 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "RefreshServerStatusList";
    
    /// <summary>
    /// Empty method that sub classes can override to add
    /// actions to the action bar (like a create object action).
    /// </summary>
    /// <param name="_myRow">Action bar row object.</param>
    protected override void AddHTMLToActionBar(HTMLTableRow _myRow)
    {
      HTMLTableCell myCell = new HTMLTableCell();
      myCell.SetHeight("25");
      myCell.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BTN);
      myCell.SetNoWrap(true);
      _myRow.AddInnerHTMLElement(myCell);
      // Create refresh test button
      PTConstruct myConstruct;
      HTMLImg myImage;
      HTMLImg myAddIcon;
      HTMLAnchor refreshAnchor;
      HTMLSpan mySpan;
      // Refresh icon
      myConstruct = UIConstructFactory.GetConstruct(PTImageType.ACTION_REFRESH,
       true, m_asOwner);
      myAddIcon = (HTMLImg) myConstruct.GetHTMLElement();
      // Refresh
      // "Refresh"
      myAddIcon.SetAlt(m_asOwner.GetString(3119, ResourceConstants.PORTALADMINMSGS));
      myAddIcon.SetAlign("absmiddle");
      refreshAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
      refreshAnchor.AddInnerHTMLString("&nbsp;");
      refreshAnchor.SetOnClick(AFormDP.JAVASCRIPT_SUBMIT_FORM + "(" + DiagnosticPageRepostControl.POSTTOSELF_ACTION_REFRESH_TEST + "); return false;");
      refreshAnchor.AddInnerHTMLElement(myAddIcon);
      mySpan = new HTMLSpan();
      refreshAnchor.AddInnerHTMLElement(mySpan);
      mySpan.SetStyleClass(PTStyleClass.ACTIONBAR_TEXT);
      // Add label - Refresh
      // "Refresh"
      mySpan.AddInnerHTMLString(m_asOwner.GetString(3119, ResourceConstants.PORTALADMINMSGS));
      mySpan.AddInnerHTMLString("&nbsp;");
      mySpan.AddInnerHTMLString("&nbsp;");
      myCell.AddInnerHTMLElement(refreshAnchor);
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new RefreshServerStatusListView();
    }
  }
}