using System;
// Framework Imports
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.admin.ptutilities.jobfolders
{
  /// <author>SudhaS</author>
  public class JobFoldersEditorAS : PTEditorAS
  {
    public const String STR_MVC_CLASS_NAME = "JobFoldersEditor";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new JobFoldersEditorAS();
    }
    
    /// <summary>
    /// Sets the Editor title.
    /// </summary>
    public override String GetEditorTitle()
    {
      if (EditorStartControl.EDITOR_START_FLAG_CREATE == ((EditorModel) GetModel(m_strModelName)).GetEditorType())
      {
        return (GetString(1502, "ptmsgs_portaladminmsgs"));
      } else
      {
        return (GetString(1503, "ptmsgs_portaladminmsgs"));
      }
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    //public static final String strStorageSelectPTObject = "SelectUserPTObject";
    
    /// <summary>
    /// Returns the class name of the Repost Control.
    /// </summary>
    /// <returns>String</returns>
    public override String GetRepostControlName()
    {
      return (JobFoldersRepostControl.STR_MVC_CLASS_NAME);
    }
    
    /// <summary>
    /// Registers all the classes for this Activity Space.
    /// </summary>
    public override void Init()
    {
      m_strModelName = JobFoldersModel.STR_MVC_CLASS_NAME;
      base.Init();
      IModel myModel = GetModel(m_strModelName);
      // Register DisplayPages
      //RegisterPage(new MainDP());
      JobFoldersDP mainDP = new JobFoldersDP();
      RegisterPage(mainDP);
      // Get back the Model we just registered because we need it to register the Section and the Control
      RegisterModel(JobFoldersListModel.STR_MVC_CLASS_NAME);
      IModel myJobFoldersModel = GetModel(JobFoldersListModel.STR_MVC_CLASS_NAME);
      RegisterView(JobFoldersListView.STR_MVC_CLASS_NAME, myJobFoldersModel);
      RegisterControl(ExpListControl.STR_MVC_CLASS_NAME, JobFoldersListModel.STR_MVC_CLASS_NAME,
       myJobFoldersModel);
      // Register Views
      //RegisterView(JobFoldersView.STR_MVC_CLASS_NAME, myModel);
      // Register Controls
      RegisterControl(JobFoldersRepostControl.STR_MVC_CLASS_NAME, myModel);
      // Default page
      SetCurrentPage(JobFoldersDP.STR_MVC_CLASS_NAME);
      //Sets left nav menu
      int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(1504, "ptmsgs_portaladminmsgs"));
      m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, JobFoldersDP.STR_MVC_CLASS_NAME);
      }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage()"></seealso>
    /// <param name="IDisplayPage">the current Display Page</param>
    public override void SetCurrentPage(IDisplayPage page)
    {
      base.SetCurrentPage(page);
      String sPageName = page.GetName();
      if (JobFoldersDP.STR_MVC_CLASS_NAME.Equals(sPageName))
      {
        this.SetHelpTopic("PT_RegisterAutomationServerFolders");
      }
    }
  }
}