using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.ptutilities.migrationutility
{
  /// <author>jennifersu</author>
  public class MigrationStatusPopupDP : AFormDP
  {
    // Seconds until we redirect to ourself to check the status 
    private const String META_REFRESH_PREFIX = "3;URL=";
    
    /// <summary>
    /// Class name for the activity space
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "MigrationStatusPopupDP";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new MigrationStatusPopupDP();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public override void Init(AActivitySpace parent)
    {
      base.Init(parent);
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()
     */
     
    public override String GetFormTitle()
    {
      return m_asOwner.GetString(2752, "ptmsgs_portaladminmsgs");
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()
     */
     
    public override HTMLElement PageDisplay()
    {
      return m_asOwner.GetView(MigrationStatusPopupView.STR_MVC_CLASS_NAME).Display();
      }
    
    /// <summary>
    /// Displays a meta refresh in the HEAD.
    /// Refreshes after 5 seconds.
    /// </summary>
    public override HTMLElementCollection DisplayHTMLinHEAD()
    {
      HTMLElementCollection htmlHead = new HTMLElementCollection();
      // Construct URL to the status popup DP
      ASURL pollPage = new ASURL(m_asOwner);
      pollPage.SetLinkGetCachedSpace(m_asOwner);
      pollPage.SetDisplayPage(MigrationStatusPopupDP.STR_MVC_CLASS_NAME);
      pollPage.SetControl(((MigrationUtilityAS) m_asOwner).GetRepostControlName());
      pollPage.AddControlArgument(RepostControl.HTMLINPUT_POSTTOSELF, MigrationUtilityRepostControl.POSTTOSELF_ACTION_MIGRATION_POLL);
      HTMLMeta metaRefresh = new HTMLMeta(META_REFRESH_PREFIX + pollPage.GetURLAsString());
      metaRefresh.SetHTTPEquiv("refresh");
      htmlHead.AddInnerHTMLElement(metaRefresh);
      return htmlHead;
    }
    
    /// <returns></returns>
    /// <throws>HTMLException </throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection scripts = new HTMLScriptCollection();
      scripts.AddInnerHTMLElement(m_asOwner.GetView(MigrationStatusPopupView.STR_MVC_CLASS_NAME).DisplayJavascript());
      return scripts;
    }
    // mel: Fix for 45278, prevent migration status window from continually popping up
    public override bool GetWindowFocusEnabled()
    {
      return false;
    }
  }
}