using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.ptutilities.migrationutility
{
  /// <author>jennifersu</author>
  public class MigrationStatusPopupView : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.ptutilities.migrationutility.MigrationStatusPopupView");
    public const String STR_MVC_CLASS_NAME = "MigrationStatusPopup";
    private const int MIGRATION_STATUS_TEXT_ID = 3160;
    
    /// <summary>
    /// Activity Space
    /// </summary>
    private MigrationUtilityAS m_asOwner;
    
    /// <summary>
    /// Model
    /// </summary>
    private IModelRO m_model;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new MigrationStatusPopupView();
    }
    // Note that the display page for successful migration export is MigrationDownloadFilePopupDP.
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Display()"></seealso>
    public virtual HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable myMainTable;
      HTMLTableRow myMainTableRow;
      HTMLTableCell myMainTableCell;
      HTMLSpan mySpan;
      try
      {
        // Main table
        myMainTable = new HTMLTable();
        result.AddInnerHTMLElement(myMainTable);
        myMainTable.SetWidth("100%");
        myMainTable.SetHeight("100%");
        myMainTable.SetBorder("0");
        myMainTable.SetCellPadding("0");
        myMainTable.SetCellSpacing("0");
        myMainTableRow = new HTMLTableRow();
        myMainTable.AddInnerHTMLElement(myMainTableRow);
        myMainTableCell = new HTMLTableCell();
        myMainTableRow.AddInnerHTMLElement(myMainTableCell);
        myMainTableCell.SetColSpan("3");
        myMainTableCell.SetHeight("10%");
        myMainTableCell.SetStyleClass(PTStyleClass.DIALOGUE_BG);
        myMainTableCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        // 1st Row: Progress bar
        myMainTableRow = new HTMLTableRow();
        myMainTable.AddInnerHTMLElement(myMainTableRow);
        myMainTableCell = new HTMLTableCell();
        myMainTableRow.AddInnerHTMLElement(myMainTableCell);
        myMainTableCell.SetWidth("15");
        myMainTableCell = new HTMLTableCell();
        myMainTableRow.AddInnerHTMLElement(myMainTableCell);
        mySpan = new HTMLSpan();
        myMainTableCell.AddInnerHTMLElement(mySpan);
        myMainTableCell.SetAlign("center");
        mySpan.SetStyleClass(PTStyleClass.DIALOGUE_TEXT);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(MIGRATION_STATUS_TEXT_ID,
         "ptmsgs_portaladminmsgs"));
        HTMLP myP = new HTMLP();
        mySpan.AddInnerHTMLElement(myP);
        HTMLImg myImg = new HTMLImg("portal/public/img/icon_status_bar.gif",
         m_asOwner.GetString(MIGRATION_STATUS_TEXT_ID, "ptmsgs_portaladminmsgs"));
        mySpan.AddInnerHTMLElement(myImg);
        myMainTableCell = new HTMLTableCell();
        myMainTableRow.AddInnerHTMLElement(myMainTableCell);
        myMainTableCell.SetWidth("15");
        // 2nd Row: Cancel button
        myMainTableRow = new HTMLTableRow();
        myMainTable.AddInnerHTMLElement(myMainTableRow);
        myMainTableCell = new HTMLTableCell();
        myMainTableRow.AddInnerHTMLElement(myMainTableCell);
        myMainTableCell.SetWidth("15");
        myMainTableCell = new HTMLTableCell();
        myMainTableRow.AddInnerHTMLElement(myMainTableCell);
        myMainTableCell.SetAlign("right");
        mySpan = new HTMLSpan();
        myMainTableCell.AddInnerHTMLElement(mySpan);
        HTMLInput cancelButton = new HTMLInput(HTMLInputTypes.BUTTON_TYPE,
         m_asOwner.GetString(980, "ptmsgs_portaladminmsgs"));
        cancelButton.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
        cancelButton.SetValue(m_asOwner.GetString(980, "ptmsgs_portaladminmsgs"));
        cancelButton.SetOnClick("CancelMigration(); return false;");
        mySpan.AddInnerHTMLElement(cancelButton);
        myMainTableCell = new HTMLTableCell();
        myMainTableRow.AddInnerHTMLElement(myMainTableCell);
        myMainTableCell.SetWidth("15");
        myMainTableRow = new HTMLTableRow();
        myMainTable.AddInnerHTMLElement(myMainTableRow);
        myMainTableCell = new HTMLTableCell();
        myMainTableRow.AddInnerHTMLElement(myMainTableCell);
        myMainTableCell.SetColSpan("3");
        myMainTableCell.SetHeight("20%");
        myMainTableCell.SetStyleClass(PTStyleClass.DIALOGUE_BG);
        myMainTableCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      }
      catch (Exception e)
      {
        log.Error(e, "Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(24, "ptmsgs_portalcommonmsgs"),
         e);
      }
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    public virtual HTMLScript DisplayJavascript()
    {
      HTMLScript myScript = new HTMLScript("text/javaScript");
      XPStringBuilder sb = new XPStringBuilder(300);
      sb.Append("\n");
      // redirect the parent window when we popup.
      Object objAction = m_asOwner.GetCurrentFormData().GetElement(RepostControl.HTMLINPUT_POSTTOSELF);
      if (objAction != null)
      {
        String strAction = ((String[]) objAction)[0];
        if (strAction.Equals(XPConvert.ToString(MigrationUtilityRepostControl.POSTTOSELF_ACTION_MIGRATION_START)))
        {
          sb.Append("  window.opener.postToSelf(\'" + MigrationUtilityRepostControl.POSTTOSELF_ACTION_REDIRECT_ON_POPUP + "\'); \n");
          sb.Append("\n");
        }
      }
      // CancelMigration() function
      // posttoself() and pass in the cancel migration repost action
      sb.Append("function ").Append("CancelMigration").Append("()\n");
      sb.Append("{\n");
      sb.Append(AFormDP.JAVASCRIPT_SUBMIT_FORM).Append("(").Append(MigrationUtilityRepostControl.POSTTOSELF_ACTION_MIGRATION_CANCEL).Append(");\n");
      sb.Append("}\n");
      sb.Append("\n");
      myScript.AddInnerHTMLString(sb.ToString());
      return myScript;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_model = (IModelRO) model;
      m_asOwner = (MigrationUtilityAS) parent;
    }
  }
}