using System;
using com.plumtree.openlog;
using com.plumtree.portalpages.admin.ptutilities.migrationutility.exp;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.admin.ptutilities.migrationutility
{
  /// <author>jennifersu</author>
  public class MigrationUtilityExportAS : MigrationUtilityAS
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.ptutilities.migrationutility.MigrationUtilityExportAS");
    public const String STR_MVC_CLASS_NAME = "MigrationUtilityExport";
    private const String sClassName = "com.plumtree.portalpages.admin.ptutilities.migrationutility.MigrationUtilityExportAS";
    
    /// <summary>
    /// Storage key for SelectForExport *
    /// </summary>
    public const String strStorageSelectForExport = "STOR_SelectForExport";
    public const String SUBSPACEKEY_AYS = "EXPORT_SUBSPACEKEY_AYS";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new MigrationUtilityExportAS();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.editor.EditorAS#GetEditorTitle()"></seealso>
    public override String GetEditorTitle()
    {
      return GetString(2773, "ptmsgs_portaladminmsgs");
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Set the Migration Mode in order to initialize AS correctly.
    /// </summary>
    public override void Init()
    {
      m_intMode = MODE_EXPORT;
      base.Init();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage()"></seealso>
    /// <param name="IDisplayPage">the current Display Page</param>
    public override void SetCurrentPage(IDisplayPage page)
    {
      base.SetCurrentPage(page);
      String sPageName = page.GetName();
      if (sPageName.Equals(MigrationAddExistingPackageDP.STR_MVC_CLASS_NAME))
      {
        SetHelpTopic("PT_MigrationExport_AddExistingPackage");
      } else
      if (sPageName.Equals(MigrationExportMainDP.STR_MVC_CLASS_NAME))
      {
        SetHelpTopic("PT_MigrationExport_PackageSettings");
      } else
      if (sPageName.Equals(MigrationExportPortalResourcesDP.STR_MVC_CLASS_NAME))
      {
        SetHelpTopic("PT_ExportPortalResources_ResourcestoExport");
      }
    }
  }
}