using System;
using com.plumtree.openlog;
using com.plumtree.portalpages.admin.ptutilities.migrationutility.imp;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.admin.ptutilities.migrationutility
{
  /// <author>jennifersu</author>
  public class MigrationUtilityImportAS : MigrationUtilityAS
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.ptutilities.migrationutility.MigrationUtilityImportAS");
    public const String STR_MVC_CLASS_NAME = "MigrationUtilityImport";
    private const String sClassName = "com.plumtree.portalpages.admin.ptutilities.migrationutility.MigrationUtilityImportAS";
    
    /// <summary>
    /// Storage key for SelectForImport *
    /// </summary>
    public const String strStorageSelectForImport = "STOR_SelectForImport";
    public const String SUBSPACEKEY_AYS = "IMPORT_SUBSPACEKEY_AYS";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new MigrationUtilityImportAS();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.editor.EditorAS#GetEditorTitle()"></seealso>
    public override String GetEditorTitle()
    {
      return GetString(2774, "ptmsgs_portaladminmsgs");
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Set the Migration Mode in order to initialize AS correctly.
    /// </summary>
    public override void Init()
    {
      m_intMode = MODE_IMPORT;
      base.Init();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage()"></seealso>
    /// <param name="IDisplayPage">the current Display Page</param>
    public override void SetCurrentPage(IDisplayPage page)
    {
      base.SetCurrentPage(page);
      String sPageName = page.GetName();
      if (sPageName.Equals(MigrationDependenciesDP.STR_MVC_CLASS_NAME))
      {
        SetHelpTopic("PT_MigrationImport_MissingDependencies");
      } else
      if (sPageName.Equals(MigrationImportMainDP.STR_MVC_CLASS_NAME))
      {
        SetHelpTopic("PT_ImportPortalResources_ResourcePackageInformation");
        } else
      if (sPageName.Equals(MigrationImportPortalResourcesDP.STR_MVC_CLASS_NAME))
      {
        SetHelpTopic("PT_ImportPortalResources_ResourcestoImport");
      }
    }
  }
}