using System;
using com.plumtree.portalpages.admin.ptutilities.migrationutility;
namespace com.plumtree.portalpages.admin.ptutilities.migrationutility.exp
{
  /// <author>jennifersu</author>
  public interface IMigrationUtilityExportModelRO : IMigrationUtilityModelRO
  {
    
    /// <summary>
    /// Get Package name
    /// </summary>
    /// <returns>String</returns>
    String GetPackageName();
    
    /// <summary>
    /// Get Package description
    /// </summary>
    /// <returns>String</returns>
    String GetPackageDescription();
    
    /// <summary>
    /// Get Package publisher
    /// </summary>
    /// <returns>String</returns>
    String GetPublisher();
    
    /// <summary>
    /// When exporting dependencies, should the parent folders
    /// and their dependencies also be exported?
    /// </summary>
    /// <returns>
    /// true to export parent folder dependencies as
    /// objects and pull in their dependencies as well,
    /// false to only add references in the dependency map
    /// </returns>
    bool IsExportParentFoldersEnabled();
  }
}