using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.editors.objectdelivery.common;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.ptutilities.migrationutility.exp
{
  /// <author>jennifersu</author>
  public class MigrationGeneralInfoView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.ptutilities.migrationutility.exp.MigrationGeneralInfoView");
    public const String STR_MVC_CLASS_NAME = "MigrationGeneralInfoView";
    public const String HTMLINPUT_PACKAGE_NAME = "in_tx_PackageName";
    public const String HTMLINPUT_PACKAGE_DESCRIPTION = "in_ta_PackageDesc";
    public const String HTMLINPUT_PUBLISHER_NAME = "in_tx_PublisherName";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new MigrationGeneralInfoView();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Display()"></seealso>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable myTable;
      HTMLTableRow myRow;
      try
      {
        IMigrationUtilityExportModelRO myModel = (IMigrationUtilityExportModelRO) m_model;
        result.AddInnerHTMLElement(base.GetHeaderView(m_asOwner.GetString(472,
         "ptmsgs_portalbrowsingmsgs")));
        myTable = ODViewHelper.AddTable(result);
        // 1st row begins (Top Margin)
        ODViewHelper.AddEmptyRow(myTable, "5");
        // 2nd row			
        ODViewHelper.AddSimpleEditBox(myTable, 5, m_asOwner.GetString(473,
         "ptmsgs_portalbrowsingmsgs"), "", myModel.GetPackageName(), HTMLINPUT_PACKAGE_NAME);
        // 3rd row 
        myRow = ODViewHelper.AddRow(myTable);
        // Left Margin
        ODViewHelper.AddLeftMargin(myRow, 5);
        // Label
        ODViewHelper.AddLabelCell(myRow, "2", m_asOwner.GetString(475, "ptmsgs_portalbrowsingmsgs"));
        // Right Margin
        ODViewHelper.AddRightMargin(myRow, 5);
        // 4th row
        myRow = ODViewHelper.AddRow(myTable);
        // Left Margin
        ODViewHelper.AddLeftMargin(myRow, 5);
        // Text Input box
        ODViewHelper.AddTextAreaCell(myRow, "2", myModel.GetPackageDescription(),
         HTMLINPUT_PACKAGE_DESCRIPTION);
        // Right Margin
        ODViewHelper.AddRightMargin(myRow, 5);
        // 5th row
        ODViewHelper.AddSimpleEditBox(myTable, 5, m_asOwner.GetString(474,
         "ptmsgs_portalbrowsingmsgs"), "", myModel.GetPublisher(), HTMLINPUT_PUBLISHER_NAME);
        // last row begins (Bottom Margin)
        ODViewHelper.AddEmptyRow(myTable, "5");
      }
      catch (HTMLException e)
      {
        log.Error(e, STR_MVC_CLASS_NAME + "::Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(476, "ptmsgs_portalbrowsingmsgs"),
         e);
      }
      return result;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}