using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.admin.ptutilities.migrationutility;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.admin.ptutilities.migrationutility.exp
{
  /// <author>jennifersu</author>
  public class MigrationSelectForExportRepostControl : ExpListControl
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.ptutilities.migrationutility.exp.MigrationSelectForExportRepostControl");
    public const String STR_MVC_CLASS_NAME = "MigrationSelectForExportRepostControl";
    public const int POSTTOSELF_ACTION_ADD_APPROVED = 15;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new MigrationSelectForExportRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call
    /// the associated method for each action.
    /// </summary>
    /// <param name="int"></param>
    public override void PerformRepostAction(int _nAction, XPHashtable _htFormData)
    {
      // Editor repost actions (Finish, Cancel, Change Page, etc.)
      base.PerformRepostAction(_nAction, _htFormData);
      // Migration repost actions
      switch (_nAction){
      case POSTTOSELF_ACTION_ADD_APPROVED:
      MigrationSelectForExportModel listModel = (MigrationSelectForExportModel) m_asOwner.GetModel(MigrationUtilityExportAS.strStorageSelectForExport);
      listModel.AddAllApproved();
      break;
      }
    }
  }
}