using System;
using com.plumtree.server;
using com.plumtree.openfoundation.util;
namespace com.plumtree.portalpages.admin.ptutilities.migrationutility.imp
{
  /// <author>jennifersu</author>
  public class CPTMigrationDependency
  {
    protected String m_strUUID;
    protected int m_nClassID;
    protected String m_strName;
    protected XPHashtable m_xphtResolvableObjects;
    
    /// <summary>
    /// Creates a new CPTMigrationDependency object.
    /// </summary>
    /// <param name="strUUID">DOCUMENT ME!</param>
    /// <param name="nClassID">DOCUMENT ME!</param>
    /// <param name="strName">DOCUMENT ME!</param>
    public CPTMigrationDependency(String strUUID, int nClassID, String strName)
    {
      m_strUUID = strUUID;
      m_nClassID = nClassID;
      m_strName = strName;
      m_xphtResolvableObjects = new XPHashtable();
    }
    
    /// <summary>
    /// DOCUMENT ME!
    /// </summary>
    /// <returns>DOCUMENT ME!</returns>
    public virtual String GetUUID()
    {
      return m_strUUID;
    }
    
    /// <summary>
    /// DOCUMENT ME!
    /// </summary>
    /// <returns>DOCUMENT ME!</returns>
    public virtual int GetClassID()
    {
      return m_nClassID;
    }
    
    /// <summary>
    /// DOCUMENT ME!
    /// </summary>
    /// <returns>DOCUMENT ME!</returns>
    public virtual String GetName()
    {
      return m_strName;
    }
    
    /// <summary>
    /// DOCUMENT ME!
    /// </summary>
    /// <param name="ptME">DOCUMENT ME!</param>
    public virtual void AddResolvableObject(IPTMigrationElement ptME)
    {
      m_xphtResolvableObjects.PutElement(ptME.GetUUID(), ptME);
    }
    
    /// <summary>
    /// DOCUMENT ME!
    /// </summary>
    /// <returns>DOCUMENT ME!</returns>
    public virtual int GetResolvableObjectCount()
    {
      return m_xphtResolvableObjects.GetSize();
    }
    
    /// <summary>
    /// DOCUMENT ME!
    /// </summary>
    /// <param name="nIndex">DOCUMENT ME!</param>
    /// <returns>DOCUMENT ME!</returns>
    public virtual IPTMigrationElement GetResolvableObject(String _strUUID)
    {
      return (IPTMigrationElement) m_xphtResolvableObjects.GetElement(_strUUID);
      }
    
    /// <summary>
    /// Gets an XPHashtable of all resolvable objects
    /// that depend on this CPTMigrationDependency
    /// </summary>
    /// <returns></returns>
    public virtual XPHashtable GetAllResolvableObjects()
    {
      return m_xphtResolvableObjects;
    }
    
    /// <summary>
    /// Removes object with UUID
    /// from XPHashtable of resolvable
    /// objects.
    /// </summary>
    /// <param name="_strUUID"></param>
    public virtual void RemoveResolvableObject(String _strUUID)
    {
      m_xphtResolvableObjects.RemoveElement(_strUUID);
    }
  }
}