using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
using com.plumtree.uiinfrastructure.tree;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.ptutilities.migrationutility.imp
{
  /// <author>jennifersu</author>
  public class MigrationDependencyListRepostControl : ExpListControl
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.ptutilities.migrationutility.imp.MigrationDependencyListRepostControl");
    public const String STR_MVC_CLASS_NAME = "MigrationDependencyListRepostControl";
    public const int POSTTOSELF_ACTION_EDIT_DEPENDENCY = 15;
    public const int POSTTOSELF_ACTION_OPEN_DEPENDENCY_TREE = 16;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new MigrationDependencyListRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Sets the editor to perform the tree popup.
    /// </summary>
    protected virtual void PerformTreePopup(ASURL _treeURL)
    {
      try
      {
        // Set up the popup
        HTMLScript myScript = new HTMLScript("text/javaScript");
        XPStringBuilder sb;
        sb = new XPStringBuilder(200);
        sb.Append("window.open(\'").Append(_treeURL.GetURLAsString()).Append("\', \'_DependencyTree\', \'").Append(TreeConstants.GetJavascriptTreeWindowAttributes()).Append("\');\n");
        myScript.AddInnerHTMLString(sb.ToString());
        ((EditorDP) ((EditorAS) m_asOwner).GetCurrentPage()).AddScriptToHead(myScript);
        }
      catch (Exception e)
      {
        log.Error(e, STR_MVC_CLASS_NAME + "::PerformTreePopup  Unknown error attempting to open Dependency Tree. e: " + e.Message);
        }
    }
    
    /// <summary>
    /// Switch between the action modes and call
    /// the associated method for each action.
    /// </summary>
    /// <param name="int"></param>
    public override void PerformRepostAction(int _nAction, XPHashtable _htFormData)
    {
      // Editor repost actions (Finish, Cancel, Change Page, etc.)
      base.PerformRepostAction(_nAction, _htFormData);
      // Migration repost actions
      switch (_nAction){
      case POSTTOSELF_ACTION_EDIT_DEPENDENCY:
      MigrationDependencyListModel listModel = (MigrationDependencyListModel) m_asOwner.GetModel(MigrationDependencyListModel.STR_MVC_CLASS_NAME);
      listModel.DoEditDependency(_htFormData);
      break;
      case POSTTOSELF_ACTION_OPEN_DEPENDENCY_TREE:
      ASURL treeURL = ((MigrationDependencyListModel) m_model).DoOpenDependencyTree(_htFormData);
      PerformTreePopup(treeURL);
      break;
      }
    }
  }
}