using System;
// Framework Imports
using com.plumtree.uiinfrastructure.arraywrapper;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.admin.ptutilities.objectlockmanager
{
  /// <summary>
  /// This interface is implemented by the Model.
  /// It contains all the read-only mothods of the Model
  /// accessed by the Views.
  /// </summary>
  /// <author>Julie Fournier</author>
  public interface IObjectLockManagerModelRO : IEditorModelRO
  {
    
    /// <summary>
    /// Returns the classID.
    /// </summary>
    /// <returns>int</returns>
    int GetClassID();
    
    /// <summary>
    /// Returns the sortColumn.
    /// </summary>
    /// <returns>int</returns>
    int GetSortColumn();
    
    /// <summary>
    /// Returns the sortDirection.
    /// </summary>
    /// <returns>int</returns>
    int GetSortDirection();
    
    /// <summary>
    /// Returns whether we are just sorting the list of locked items, or whether
    /// we should retrieve new data from the database.
    /// </summary>
    /// <returns>boolean</returns>
    bool GetSortOnly();
    
    /// <summary>
    /// Returns the value of the member variable "m_arrLockedItems".
    /// </summary>
    /// <returns>PTSortedArrayWrapper</returns>
    PTGrowableSortedArrayWrapper GetLockedItems(int intClassID);
    
    /// <summary>
    /// Returns the value of the growable array of locked items for the current
    /// classID in the hashtable.
    /// </summary>
    /// <returns>PTSortedArrayWrapper</returns>
    PTGrowableSortedArrayWrapper GetLockedItemsFromHashtable(int _nClassID);
    }
}