using System;
// Framework Imports
using XPConvert=com.plumtree.openfoundation.util.XPConvert;
using IPTClassTypeDesc=com.plumtree.portaluiinfrastructure.classtypedescriptors.IPTClassTypeDesc;
using PersonalSettingsHelper=com.plumtree.uiinfrastructure.statichelpers.PersonalSettingsHelper;
namespace com.plumtree.portalpages.admin.ptutilities.objectlockmanager
{
  /// <summary>
  /// This is class is used to print out together the Views for 
  /// all class types for the object lock manager.
  /// </summary>
  /// <author>Okan Alper</author>
  public class LockManagerObjectDP : MainDP
  {
    internal IPTClassTypeDesc m_classType = null;
    public LockManagerObjectDP(IPTClassTypeDesc classType)
    {
      m_classType = classType;
    }
    
    /// <summary>
    /// Returns the classID for this subclass
    /// </summary>
    /// <seealso cref="com.plumtree.portalpages.admin.ptutilities.objectlockmanager.MainDP#GetChildClassID()"></seealso>
    public override int GetChildClassID()
    {
      return m_classType.GetClassID();
    }
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,
    /// linking to that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      ObjectLockManagerModel myModel = (ObjectLockManagerModel) (m_asOwner.GetModel(ObjectLockManagerModel.STR_MVC_CLASS_NAME));
      int lockedCount = myModel.GetLockedCount(m_classType.GetClassID());
      return m_classType.GetObjectLockManagerLocalizedName(XPConvert.ToString(PersonalSettingsHelper.GetPersonalSettingValue(PersonalSettingsHelper.LANGUAGE,
       m_asOwner))) + (lockedCount > 0 ? " (" + lockedCount + ")" : "");
    }
    
    /// <summary>
    /// Returns the page title. This implementation displays the left nav string without the # of locked objs
    /// </summary>
    /// <returns>String</returns>
    public override String GetFormTitle()
    {
      return m_classType.GetObjectLockManagerLocalizedName(XPConvert.ToString(PersonalSettingsHelper.GetPersonalSettingValue(PersonalSettingsHelper.LANGUAGE,
       m_asOwner)));
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return "ObjectLockManager" + m_classType.GetClassKey();
    }
  }
}