using System;
// Framework Imports
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.admin.ptutilities.objectlockmanager
{
  /// <summary>
  /// This class contains the additional repost actions.
  /// The ones specific to the Object Lock Manager (other than
  /// "change page", "finish" and "cancel" actions).
  /// </summary>
  /// <author>John Hogan</author>
  public class ObjectLockManagerRepostControl : EditorRepostControl
  {
    
    /// <summary>
    /// Unique identifier for the class 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "ObjectLockManagerRepost";
    public const int POSTTOSELF_ACTION_UNLOCK = 10;
    public const int POSTTOSELF_ACTION_SORT = 20;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new ObjectLockManagerRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call
    /// the associated method for each action.
    /// </summary>
    /// <param name="int"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      switch (_nAction){
      case POSTTOSELF_ACTION_UNLOCK:
      ((ObjectLockManagerModel) m_model).UnlockObjects();
      break;
      case POSTTOSELF_ACTION_SORT:
      ((ObjectLockManagerModel) m_model).ChangeSort();
      break;
      }
    }
  }
}