using System;
using XPResourceManager=com.plumtree.openfoundation.internationalization.XPResourceManager;
using IPlumtreeUtilities=com.plumtree.portalpages.admin.ptutilities.IPlumtreeUtilities;
using DirAS=com.plumtree.portalpages.browsing.directory.DirAS;
using DirConstants=com.plumtree.portalpages.browsing.directory.DirConstants;
using OpenSubFolderControl=com.plumtree.portalpages.common.folder.OpenSubFolderControl;
using PT_ACTIVITY_RIGHTS=com.plumtree.server.PT_ACTIVITY_RIGHTS;
using PT_INTRINSICS=com.plumtree.server.PT_INTRINSICS;
using AppConstants=com.plumtree.uiinfrastructure.application.varpacks.AppConstants;
using ApplicationManager=com.plumtree.uiinfrastructure.web.ApplicationManager;
using IApplication=com.plumtree.uiinfrastructure.web.IApplication;
namespace com.plumtree.portalpages.admin.ptutilities.settings
{
  /*
   * A PTUtility item which lets users within groups with 'Access Unclassifed Document'
   * ActivityRight go to edit mode within the unclassifed documents. This lets users to
   * modify unclassified documents even if they dont have edit rights on the knowledge
   * directory. However, they would need a way to access the PTUtilies.
   */
   
  
  /// <author>ShivaB</author>
  public class AccessUnclassifiedDocumentsPlumtreeUtilities : IPlumtreeUtilities
  {
    /* Only group with access to unclassified documents should be able
     * to view this utility in the PTUtility drop-down menu.
     */
     
    public virtual int GetActivityRightRestriction()
    {
      return PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_ACCESS_UNCLASSIFIED_FOLDER;
      }
    /* Returns the control to open a folder.
     *
     */
     
    public virtual String GetASControlName()
    {
      return OpenSubFolderControl.STR_MVC_CLASS_NAME;
    }
    /* (non-Javadoc)
     *
     */
     
    public virtual String GetASDPName()
    {
      return null;
    }
    /*
     * @return the Directory ActivitySpace
     */
     
    public virtual String GetASName()
    {
      return DirAS.STR_MVC_CLASS_NAME;
    }
    /* This adds the parameters to the OpenSubFolderControl
     * DirMode -> Edit mode, subFolderID -> unclassified documents
     */
     
    public virtual String GetASQueryString()
    {
      String strQuery = "&" + DirConstants.QS_DIRECTORY_MODE + "=" + DirConstants.EDIT_MODE + "&subfolderID=" + PT_INTRINSICS.PT_FOLDER_UNCLASSIFIEDCARDS;
      return strQuery;
    }
    /* This is the text that gets displayed in the dropdown menu of the
     * PTUtility
     */
     
    public virtual String GetLinkText(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      return (rm.GetString(2703, "ptmsgs_portaladminmsgs", _strLangID));
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.settings.ISettings#IsStandardPortalOption()
     */
     
    public virtual bool IsStandardPortalOption()
    {
      return true;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.settings.ISettings#IsViewable()
     */
     
    public virtual bool IsViewable()
    {
      return true;
    }
  }
}