using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.portalpages.admin.objmgr;
using com.plumtree.portalpages.admin.ptutilities;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.web;
namespace com.plumtree.portalpages.admin.ptutilities.settings
{
  /// <version>5.0</version>
  /// <author>Sudha Sathiaseelan</author>
  public class DefaultProfilesPlumtreeUtilities : IPlumtreeUtilities
  {
    
    /// <returns></returns>
    public virtual String GetASControlName()
    {
      return ObjMgrSettingsControl.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASDPName()
    {
      return null;
    }
    
    /// <returns></returns>
    public virtual String GetASName()
    {
      return ObjMgrAS.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASQueryString()
    {
      String strFolderQuery = ObjMgrSettingsControl.FOLDER_ID + "=" + PT_INTRINSICS.PT_ADMIN_FOLDER_DEFAULTPROFILES;
      String strObjectQuery = ObjMgrSettingsControl.OBJECT_IDS + "=" + PT_CLASSIDS.PT_USER_ID;
      String strQuery = "&" + strFolderQuery + "&" + strObjectQuery;
      return strQuery;
    }
    //Return link text
    public virtual String GetLinkText(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      return (rm.GetString(2007, "ptmsgs_portaladminmsgs", _strLangID));
    }
    //Describes whether the setting comes with the standard portal
    public virtual bool IsStandardPortalOption()
    {
      return (true);
    }
    //Describes whether the setting is currently viewable
    public virtual bool IsViewable()
    {
      return (true);
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.admin.ptutilities.IPlumtreeUtilities#GetActivityRightRestriction()
     */
     
    public virtual int GetActivityRightRestriction()
    {
      return PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_CREATE_USERS;
    }
  }
}