using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.portalpages.admin.ptutilities;
using com.plumtree.portalpages.admin.ptutilities.localizedstrings;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.web;
namespace com.plumtree.portalpages.admin.ptutilities.settings
{
  /// <author>
  /// MichaelS
  /// This class causes the Localized Strings link to show up in the
  /// Plumtree Utilities menu.
  /// </author>
  public class LocalizedStringsPlumtreeUtilities : IPlumtreeUtilities
  {
    
    /// <returns></returns>
    public virtual String GetASControlName()
    {
      return EditorStartControl.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASDPName()
    {
      return LocalizedStringsDP.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASName()
    {
      return LocalizedStringsAS.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASQueryString()
    {
      return "&" + EditorStartControl.QS_EDITOR_TYPE + "=" + EditorStartControl.EDITOR_START_FLAG_MISC;
      }
    //@todo add class name to Plumtree Utilities XML file
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#GetLinkText()"></seealso>
    public virtual String GetLinkText(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      return rm.GetString(1603, "ptmsgs_portaladminmsgs", _strLangID);
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#IsStandardPortalOption()"></seealso>
    public virtual bool IsStandardPortalOption()
    {
      return true;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#IsViewable()"></seealso>
    public virtual bool IsViewable()
    {
      return true;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.admin.ptutilities.IPlumtreeUtilities#GetActivityRightRestriction()
     */
     
    public virtual int GetActivityRightRestriction()
    {
      return PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_NONE;
    }
  }
}