using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.portalpages.admin.editors.userprofilemanager;
using com.plumtree.portalpages.admin.ptutilities;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.web;
namespace com.plumtree.portalpages.admin.ptutilities.settings
{
  /// <version>$Revision$</version>
  /// <author>$author$</author>
  public class ProfileLayoutPlumtreeUtilities : IPlumtreeUtilities
  {
    
    /// <returns></returns>
    public virtual String GetASControlName()
    {
      return EditorStartControl.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASDPName()
    {
      return null;
    }
    
    /// <returns></returns>
    public virtual String GetASName()
    {
      return UsrProfMgrEditorAS.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASQueryString()
    {
      String strQuery = "&" + EditorStartControl.QS_EDITOR_TYPE + "=10";
      return strQuery;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#GetLinkText()"></seealso>
    public virtual String GetLinkText(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      return rm.GetString(967, "ptmsgs_portaladminmsgs", _strLangID);
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#IsStandardPortalOption()"></seealso>
    public virtual bool IsStandardPortalOption()
    {
      return true;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#IsViewable()"></seealso>
    public virtual bool IsViewable()
    {
      return true;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.admin.ptutilities.IPlumtreeUtilities#GetActivityRightRestriction()
     */
     
    public virtual int GetActivityRightRestriction()
    {
      return PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_EDIT_USERINFO_MAP;
    }
  }
}