using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.portalpages.admin.ptutilities;
using com.plumtree.portalpages.admin.serversettings.search;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.web;
namespace com.plumtree.portalpages.admin.ptutilities.settings
{
  /// <author>MatthewF</author>
  public class SearchServerTuningPlumtreeUtilities : IPlumtreeUtilities
  {
    
    /// <returns></returns>
    public virtual String GetASControlName()
    {
      return EditorStartControl.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASDPName()
    {
      return null;
    }
    
    /// <returns></returns>
    public virtual String GetASName()
    {
      return SearchServerTuningEditorAS.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASQueryString()
    {
      return "&editorType=10";
    }
    //Return link text
    public virtual String GetLinkText(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      return rm.GetString(2574, "ptmsgs_portaladminmsgs", _strLangID);
    }
    //Describes whether the setting comes with the standard portal
    public virtual bool IsStandardPortalOption()
    {
      return (true);
    }
    //Describes whether the setting is currently viewable
    public virtual bool IsViewable()
    {
      return (true);
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.admin.ptutilities.IPlumtreeUtilities#GetActivityRightRestriction()
     */
     
    public virtual int GetActivityRightRestriction()
    {
      return PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_ACCESS_SEARCH_SERVER_TUNING;
      }
  }
}