using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.portalpages.admin.ptutilities;
using com.plumtree.portalpages.admin.ptutilities.condition;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.web;
namespace com.plumtree.portalpages.admin.ptutilities.settings
{
  /// <version>5.0</version>
  /// <author>John Osborne</author>
  public class SubPortalRulesManagerPlumtreeUtilities : IPlumtreeUtilities
  {
    
    /// <returns></returns>
    public virtual String GetASControlName()
    {
      return EditorStartControl.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASDPName()
    {
      return SubportalRulesManagerMainDP.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASName()
    {
      return SubportalRulesManagerAS.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASQueryString()
    {
      String strEdiorTypeQuery = "&" + EditorStartControl.QS_EDITOR_TYPE + "=" + EditorStartControl.EDITOR_START_FLAG_MISC;
      return strEdiorTypeQuery;
    }
    
    /// <summary>
    /// Return link text
    /// </summary>
    /// <returns></returns>
    public virtual String GetLinkText(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      return rm.GetString(2888, "ptmsgs_portaladminmsgs", _strLangID);
    }
    
    /// <summary>
    /// Describes whether the setting comes with the standard portal
    /// </summary>
    /// <returns></returns>
    public virtual bool IsStandardPortalOption()
    {
      return true;
    }
    
    /// <summary>
    /// Describes whether the setting is currently viewable
    /// </summary>
    /// <returns></returns>
    public virtual bool IsViewable()
    {
      return true;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.admin.ptutilities.IPlumtreeUtilities#GetActivityRightRestriction()
     */
     
    public virtual int GetActivityRightRestriction()
    {
      return PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_ACCESS_SUBPORTAL_RULES_MANAGER;
      }
  }
}