using System;
// Framework Imports
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.ptmulticolumnlist;
using com.plumtree.portaluiinfrastructure.tree;
using com.plumtree.uiinfrastructure.tree;
namespace com.plumtree.portalpages.admin.ptutilities.userinfopropmap
{
  public class UserInfoPropMapListModel : PTMultiColumnListModel
  {
    
    /// <summary>
    /// The unique identifier for the class 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "UserInfoPropMapListModel";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new UserInfoPropMapListModel();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Clear the list and add all the values selected from the tree, as well as
    /// values or defaults for the other columns in the control.
    /// </summary>
    /// <param name="_htFormData">Form data</param>
    public override void AddRowsOnRepost(XPHashtable _htFormData)
    {
      if (m_bIncludePTSelect)
      {
        //Validate that the proposed position of the selected Plumtree
        //object is not greater than the number of other columns
        if (m_intPTObjectPosition > m_intNumColumns)
        {
          m_intPTObjectPosition = 0;
        }
        SaveTreeID(_htFormData);
        TreeAS asTree = (TreeAS) m_asOwner.GetSubSpace(GetUniqueString(SUBSPACE_KEY_SELECTTREE));
        if (null != asTree)
        {
          ITreeModelRO myTree = (ITreeModelRO) asTree.GetModel(ATreeAS.TREEMODEL);
          XPArrayList mySelected = myTree.GetSelectedItems();
          Object[] oNewRow;
          int nClassID;
          //First, save the data so we can re-populate the non-tree items
          XPHashtable[] arrHashtables = new XPHashtable[m_intNumColumns + 3];
          for (int i = 0;i < (m_intNumColumns + 3);i++)
          {
            arrHashtables[i] = new XPHashtable();
          }
          for (int i = 0;i < m_saData.GetCount();i++)
          {
            //skip the index column
            for (int j = 1;j < (m_intNumColumns + 4);j++)
            {
              arrHashtables[j - 1].PutElement(m_saData.GetItem(i, EXPLIST_COL_STRING + m_intPTObjectPosition),
               m_saData.GetItem(i, j));
            }
          }
          // JF- We clear the array before we start adding the selected items from the tree.
          base.GetItems().ClearArray();
          for (int i = 0;i < mySelected.GetSize();i++)
          {
            oNewRow = new Object[m_intNumColumns + 4];
            oNewRow[EXPLIST_SORTEDARRAY_PROPID_INDEX] = m_nNextIndex;
            m_nNextIndex++;
            nClassID = ((TreeLeafNode) mySelected.GetElement(i)).m_nClassID;
            oNewRow[EXPLIST_COL_CLASSID + m_intPTObjectPosition] = nClassID;
            oNewRow[EXPLIST_COL_OBJECTID + m_intPTObjectPosition] = ((TreeLeafNode) mySelected.GetElement(i)).m_nObjectID;
            oNewRow[EXPLIST_COL_STRING + m_intPTObjectPosition] = ((TreeLeafNode) mySelected.GetElement(i)).GetName();
            //Add the other empty columns
            String strValue;
            int intColIndex;
            for (int j = 0;j < m_intNumColumns;j++)
            {
              if (j < m_intPTObjectPosition)
              {
                intColIndex = j + 1;
              } else
              {
                intColIndex = j + 4;
              }
              //TODO - get the right hashtable - only j when m_intPTObjectPosition is 1
              strValue = (String) arrHashtables[intColIndex - 1].GetElement(oNewRow[EXPLIST_COL_STRING + m_intPTObjectPosition]);
              if ((null == strValue) || strValue.Equals(""))
              {
                // Default to the property name
                strValue = XPConvert.ToString(oNewRow[EXPLIST_COL_STRING + m_intPTObjectPosition]);
                }
              oNewRow[intColIndex] = strValue;
            }
            base.GetItems().AddRow(oNewRow);
          }
        }
      } else
      {
        String[][] arrDefault = new String[m_intNumColumns][];
        for (int j2c_index = 0;j2c_index < m_intNumColumns;j2c_index++)
        {
          arrDefault[j2c_index] = new String[1];
        }
        for (int i = 0;i < m_intNumColumns;i++)
        {
          arrDefault[i][0] = m_arrDefaultValue[i];
        }
        AddRowsToList(arrDefault);
      }
    }
  }
}