using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.login.createaccount;
using com.plumtree.portaluiinfrastructure.application.varpacks;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.sendinvitation
{
  /// <author>dustina</author>
  public class CodePopUpView : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.sendinvitation.CodePopUpView");
    public const String STR_MVC_CLASS_NAME = "CodePopUpView";
    public const String HTMLBUTTON_DONE = "in_bu_Done";
    protected AActivitySpace m_asOwner;
    protected IModelRO m_model;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new CodePopUpView();
    }
    
    /// <returns></returns>
    public virtual HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable myTable;
      HTMLTableCell myCell;
      HTMLTableRow myRow;
      HTMLTextArea myTextArea;
      HTMLInput myInput;
      try
      {
        myTable = new HTMLTable();
        result.AddInnerHTMLElement(myTable);
        myTable.SetStyleClass(PTStyleClass.DIALOGUE_BG);
        myTable.SetWidth("460");
        myTable.SetHeight("220");
        myTable.SetBorder("0");
        myTable.SetCellPadding("5");
        myTable.SetCellSpacing("0");
        //Header Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.ALERT_DIALOG_TITLE);
        myCell.AddInnerHTMLString(m_asOwner.GetString(1272, "ptmsgs_portaladminmsgs"));
        myCell.AddInnerHTMLElement(new HTMLBr());
        // Header Row end
        //Instruction Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);
        myCell.AddInnerHTMLString(m_asOwner.GetString(1273, "ptmsgs_portaladminmsgs"));
        myCell.AddInnerHTMLElement(new HTMLBr());
        // Instruction Row end
        //Email Text Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetAlign(CommonHTMLStrings.CENTER);
        // ***<textarea>*** begins here
        myTextArea = new HTMLTextArea("60", "6");
        myTextArea.SetReadOnly(true);
        myCell.AddInnerHTMLElement(myTextArea);
        myTextArea.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
        bool bIsInviteURLSecure = (1 == PTConfigHelper.GetConfigVariableAsInt(PTConfigConstants.INVITATIONS_SECTION,
         PTConfigConstants.IS_INVITATION_URL_SECURE, "value", m_asOwner));
        // The URL to open the pop-up
        ASURL myURL = new ASURL(m_asOwner);
        myURL.SetUseMainServerURL(true, bIsInviteURLSecure);
        myURL.SetLinkGetSpaceIfCached(CreateAccountAS.STR_MVC_CLASS_NAME,
         this.m_asOwner);
        myURL.SetControl(InterceptInvitationControl.STR_MVC_CLASS_NAME);
        myURL.AddControlArgument(InvCodesListView.CONTROLARGUMENT_INVCODE,
         ((IInvCodeListModelRO) m_model).GetInvitationCode());
        myTextArea.AddInnerHTMLString(m_asOwner.GetString(1274, "ptmsgs_portaladminmsgs"));
        myTextArea.AddInnerHTMLString(myURL.GetURLAsString());
        // ***<textarea>*** ends here
        // Email Text Row end
        // Done Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_DONE, m_asOwner.GetString(1270,
         "ptmsgs_portaladminmsgs"));
        myCell.AddInnerHTMLElement(myInput);
        myCell.SetAlign(CommonHTMLStrings.CENTER);
        myInput.SetValue(m_asOwner.GetString(1269, "ptmsgs_portaladminmsgs"));
        myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
        // mj: removed 'Javascript:' from function name
        myInput.SetOnClick("window.close();");
      }
      // Done Row end
      catch (Exception e)
      {
        log.Error(e, "CodePopUpView::Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(1271, "ptmsgs_portaladminmsgs"),
         e);
      }
      return result;
    }
    
    /// <summary>
    /// This method returns the HTMLScript that encompasses the Javascript on the page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    /// <returns>HTMLScript</returns>
    public virtual HTMLScript DisplayJavascript()
    {
      HTMLScript myScript = new HTMLScript("text/javaScript");
      return myScript;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Inits the Section with the read-only Model and the Activity Space.
    /// </summary>
    /// <param name="model"></param>
    /// <param name="parent"></param>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_model = model;
      try
      {
        m_asOwner = (SendInvitationAS) parent;
      }
      catch (Exception e)
      {
        log.Error(e, "NewLinkPopUpView::Init Unable to cast the Object " + parent + " to SendInvitationAS. The following exception occured: " + e.Message);
        // JF- No need to extract, this is an unexpected error.
        throw new XPException("Unable to cast the Object " + parent + " to SendInvitationAS.",
         e);
      }
    }
  }
}