using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.uiinfrastructure.pagecontrols.jsdatepicker;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.sendinvitation
{
  /// <author>dustina</author>
  public class NewLinkPopUpView : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.sendinvitation.NewLinkPopUpView");
    public const String STR_MVC_CLASS_NAME = "NewLinkPopUpView";
    public const String HTMLBUTTON_DONE = "in_bu_Done";
    public const String HTMLBUTTON_CANCEL = "in_bu_Cancel";
    public const String HTMLINPUT_NAME = "in_tx_Name";
    public const String HTMLINPUT_NOI = "in_tx_NumOfInv";
    public const String JS_ON_DONE = "OnDone";
    public const String JS_VALIDATE_NAME = "CheckName";
    public const String JS_VALIDATE_NOI = "CheckNumberOfInvite";
    public const String JS_VALIDATE_DATE = "CheckExprDate";
    protected AActivitySpace m_asOwner;
    protected IModelRO m_model;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new NewLinkPopUpView();
    }
    
    /// <returns></returns>
    public virtual HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTableCell myCell;
      HTMLTableRow myRow;
      HTMLInput myInput;
      HTMLSpan mySpan;
      try
      {
        HTMLTable myTable = new HTMLTable();
        result.AddInnerHTMLElement(myTable);
        myTable.SetStyleClass(PTStyleClass.DIALOGUE_BG);
        myTable.SetWidth("535");
        myTable.SetHeight("270");
        myTable.SetBorder("0");
        myTable.SetCellPadding("5");
        myTable.SetCellSpacing("0");
        //Header Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetColSpan("2");
        myCell.SetStyleClass(PTStyleClass.ALERT_DIALOG_TITLE);
        myCell.AddInnerHTMLString(m_asOwner.GetString(1302, "ptmsgs_portaladminmsgs"));
        // Header Row end
        // Name Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);
        // ***EXAMPLE*** How to display a String?
        mySpan.AddInnerHTMLString(m_asOwner.GetString(1303, "ptmsgs_portaladminmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        // ***EXAMPLE*** How to display an input text?
        // ***<input text>*** begins here
        myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_NAME, "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
        myInput.SetValue(((IInvCodeListModelRO) m_model).GetInvitationCodeName());
        myInput.SetSize(40);
        // ***<input text>*** ends here
        // Name Row end
        // Number of invitations Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);
        // ***EXAMPLE*** How to display a String?
        mySpan.AddInnerHTMLString(m_asOwner.GetString(1304, "ptmsgs_portaladminmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        // ***EXAMPLE*** How to display an input text?
        // ***<input text>*** begins here
        myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_NOI, "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
        myInput.SetValue(((IInvCodeListModelRO) m_model).GetNumberOfInvitations());
        myInput.SetSize(5);
        // ***<input text>*** ends here
        // Number of invitations Row end
        // Expiration Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);
        // ***EXAMPLE*** How to display a String?
        mySpan.AddInnerHTMLString(m_asOwner.GetString(1305, "ptmsgs_portaladminmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        JSDatePickerMgr ptDatePickerMgr = ((IInvCodeListModelRO) m_model).GetDatePickerControlManager();
        myCell.AddInnerHTMLElement(ptDatePickerMgr.GetComponentHTML("DP_One"));
        HTMLScript datePickerScript = new HTMLScript("text/javaScript");
        datePickerScript.AddInnerHTMLString("varName_DP_One.disablePastDates = true;");
        datePickerScript.AddInnerHTMLString("varName_DP_One.disableToday = true;");
        datePickerScript.AddInnerHTMLString("varName_DP_One.minYearChoice = new Date().getFullYear();");
        myCell.AddInnerHTMLElement(datePickerScript);
        // Expiration Row end
        // Done and Cancel Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetColSpan("2");
        myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_DONE, m_asOwner.GetString(1306,
         "ptmsgs_portaladminmsgs"));
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetValue(m_asOwner.GetString(1299, "ptmsgs_portaladminmsgs"));
        myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
        // mj: removed 'Javascript:' from function name
        myInput.SetOnClick(JS_ON_DONE + "();");
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_CANCEL,
         m_asOwner.GetString(1307, "ptmsgs_portaladminmsgs"));
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetValue(m_asOwner.GetString(1300, "ptmsgs_portaladminmsgs"));
        myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
        // mj: removed 'Javascript:' from function name
        myInput.SetOnClick("window.close();");
        // Done and Cancel Row end
        //spacer Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetColSpan("2");
        myCell.SetHeight("100%");
      }
      // spacer Row end
      catch (Exception e)
      {
        log.Error(e, "NewLinkPopUpView::Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(1301, "ptmsgs_portaladminmsgs"),
         e);
      }
      return result;
    }
    
    /// <summary>
    /// This method returns the HTMLScript that encompasses the Javascript on the page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    /// <returns>HTMLScript</returns>
    public virtual HTMLScript DisplayJavascript()
    {
      HTMLScript myScript = new HTMLScript("text/javaScript");
      XPStringBuilder sb;
      try
      {
        sb = new XPStringBuilder(200);
        sb.Append("function " + JS_ON_DONE + "()\n");
        sb.Append("{\n");
        sb.Append("  if ( " + JS_VALIDATE_NAME + "() && " + JS_VALIDATE_NOI + "() && " + JS_VALIDATE_DATE + "() ) { \n");
        sb.Append("  \tdocument." + AFormDP.HTMLFORM_NAME + "." + ASConstants.PAGE_INPUT + ".value = \'CreateInvCodeDP\';\n");
        sb.Append("  \tpostToSelf(").Append(SendInvitationRepostControl.POSTTOSELF_ACTION_ADD).Append(");\n");
        sb.Append("  }\n");
        sb.Append("}\n");
        myScript.AddInnerHTMLString(sb.ToString());
        sb = new XPStringBuilder(200);
        sb.Append("function " + JS_VALIDATE_NAME + "()\n");
        sb.Append("{\n");
        sb.Append("  if (document." + AFormDP.HTMLFORM_NAME + "." + HTMLINPUT_NAME + ".value == \'\') { \n");
        sb.Append("\t\talert(\"" + m_asOwner.GetString(1290, "ptmsgs_portaladminmsgs") + "\");\n");
        sb.Append("      return false;\n");
        sb.Append("  }\n");
        sb.Append("  return true;\n");
        sb.Append("}\n");
        myScript.AddInnerHTMLString(sb.ToString());
        sb = new XPStringBuilder(200);
        sb.Append("function " + JS_VALIDATE_NOI + "()\n");
        sb.Append("{\n");
        sb.Append("\t var iTempNum = parseInt( document." + AFormDP.HTMLFORM_NAME + "." + HTMLINPUT_NOI + ".value );\n");
        sb.Append("  if ( isNaN(iTempNum) ) { \n");
        sb.Append("\t\talert(\"" + m_asOwner.GetString(1291, "ptmsgs_portaladminmsgs") + "\");\n");
        sb.Append("      return false;\n");
        sb.Append("  } else if (iTempNum < 1) {\n");
        sb.Append("\t\talert(\"" + m_asOwner.GetString(1292, "ptmsgs_portaladminmsgs") + "\");\n");
        sb.Append("      return false;\n");
        sb.Append("  }\n");
        sb.Append("  return true;\n");
        sb.Append("}\n");
        myScript.AddInnerHTMLString(sb.ToString());
        JSDatePicker ptJSDatePicker = (JSDatePicker) ((IInvCodeListModelRO) m_model).GetDatePickerControlManager().GetComponent("DP_One");
        //DCA - only need to check is input is blank, datepicker handles date formats
        sb = new XPStringBuilder(200);
        sb.Append("function " + JS_VALIDATE_DATE + "()\n");
        sb.Append("{\n");
        sb.Append("  if ( document." + AFormDP.HTMLFORM_NAME + "." + ptJSDatePicker.GetDateInputName() + ".value == \'\' ) { \n");
        sb.Append("\t\talert(\"" + m_asOwner.GetString(1294, "ptmsgs_portaladminmsgs") + "\");\n");
        sb.Append("      return false;\n");
        sb.Append("  }\n");
        sb.Append("  return true;\n");
        sb.Append("}\n");
        myScript.AddInnerHTMLString(sb.ToString());
      }
      catch (HTMLException he)
      {
        log.Error(he, "NewLinkPopUpView::DisplayJavascript The following error occured when trying to display the JavaScript: " + he.Message);
        }
      return myScript;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Inits the Section with the read-only Model and the Activity Space.
    /// </summary>
    /// <param name="model"></param>
    /// <param name="parent"></param>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_model = model;
      try
      {
        m_asOwner = (SendInvitationAS) parent;
      }
      catch (Exception e)
      {
        log.Error(e, "NewLinkPopUpView::Init Unable to cast the Object " + parent + " to SendInvitationAS. The following exception occured: " + e.Message);
        // JF- No need to extract, this is an unexpected error.
        throw new XPException("Unable to cast the Object " + parent + " to SendInvitationAS.",
         e);
      }
    }
  }
}