using System;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.sendinvitation
{
  /// <author>DustinA</author>
  public class SendInvitationDP : AFormDP
  {
    public const String STR_MVC_CLASS_NAME = "SendInvitationDP";
    
    /// <summary>
    /// This is a helper method that all classes that inherit from AFormDP and want to
    /// have the Done and Cancel buttons displayed in the header for them need to
    /// implement.  The method should return the title add whatever HTML the child
    /// class wants to display to the body argument.  The parent class will then add
    /// that HTML to the HTMLPage after filling in the banner and navigation.
    /// Override this method to set the form title
    /// </summary>
    /// <returns>String the title for the form header (if used)</returns>
    public override String GetFormTitle()
    {
      return m_asOwner.GetString(1309, "ptmsgs_portaladminmsgs");
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.PlumtreeDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      result.AddInnerHTMLElement(m_asOwner.GetView(SendInvitationView.STR_MVC_CLASS_NAME).Display());
      result.AddInnerHTMLElement(m_asOwner.GetView(InvCodesListView.STR_MVC_CLASS_NAME).Display());
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(InvCodesListView.STR_MVC_CLASS_NAME).DisplayJavascript());
      return myScripts;
    }
  }
}