using System;
using com.plumtree.openfoundation.util;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
namespace com.plumtree.portalpages.admin.sendinvitation
{
  /// <author>DustinA</author>
  public class SendInvitationModel : IRepostModel,ISendInvitationModelRO
  {
    public const String STR_MVC_CLASS_NAME = "SendInvitationModel";
    protected AActivitySpace m_asOwner;
    protected IPTSession m_Session;
    protected String m_sCreateErrorMessage;
    protected bool m_bCreateStatus;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IModel#CleanupTempData()"></seealso>
    public virtual void CleanupTempData()
    {
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IModel#CleanupAllData()"></seealso>
    public virtual void CleanupAllData()
    {
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new SendInvitationModel();
    }
    
    /// <summary>
    /// Implement some code to execute when the user clicks on "Finish".
    /// </summary>
    public virtual void Finish()
    {
    }
    
    /// <summary>
    /// Returns the Create Code Statue.
    /// </summary>
    /// <returns>boolean</returns>
    public virtual bool GetCreateCodeStatus()
    {
      return m_bCreateStatus;
    }
    
    /// <summary>
    /// Returns the Create Error Message.
    /// </summary>
    /// <returns>String</returns>
    public virtual String GetCreateErrorMessage()
    {
      return m_sCreateErrorMessage;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the Redirect object
    /// (this is were we need to go at the end).
    /// This is going to the previous AS
    /// </summary>
    /// <returns>Redirect</returns>
    public virtual Redirect GetRedirectAfterFinish()
    {
      Redirect result = new Redirect();
      // JF- If the parent space is already in the cache, we redirect to it.
      if (null != m_asOwner.GetParentSpace())
      {
        result.SetLinkGetCachedSpace(m_asOwner.GetParentSpace());
      } else
      // JF- If not, we redirect to a new one.
      {
        result.SetLinkCreateNewSpace(m_asOwner.GetParentSpaceName(), m_asOwner);
        }
      return (result);
    }
    
    /// <returns></returns>
    public virtual XPDateTime GetTodaysDate()
    {
      return new XPDateTime();
    }
    
    /// <summary>
    /// Inits the Model with the IPTSession.
    /// </summary>
    /// <param name="parent"></param>
    public virtual void Init(AActivitySpace parent)
    {
      m_asOwner = parent;
      // JF- Get the Session object from the associated AS.
      m_Session = (IPTSession) m_asOwner.GetUserSession();
    }
    
    /// <summary>
    /// Calls the right save function according to the page name passed in argument.
    /// </summary>
    /// <param name="_sPageName"></param>
    /// <param name="_htFormData"></param>
    /// <returns>int Page status for server side validation</returns>
    public virtual int SavePage(String _sPageName, XPHashtable _htFormData)
    {
      return ((InvCodesListModel) m_asOwner.GetModel(InvCodesListModel.STR_MVC_CLASS_NAME)).SaveSection(_htFormData);
      }
    
    /// <summary>
    /// Sets the Create Code Statue.
    /// </summary>
    /// <param name="_bStatus"></param>
    public virtual void SetCreateCodeStatus(bool _bStatus)
    {
      m_bCreateStatus = _bStatus;
    }
    
    /// <summary>
    /// Sets the Create Error Message.
    /// </summary>
    /// <param name="_sErrorMessage"></param>
    public virtual void SetCreateErrorMessage(String _sErrorMessage)
    {
      m_sCreateErrorMessage = _sErrorMessage;
    }
  }
}