using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.errordisplay;
using com.plumtree.uiinfrastructure.htmlconstructs;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.sendinvitation
{
  /// <author>DustinA</author>
  public class SendInvitationView : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.sendinvitation.SendInvitationView");
    public const String STR_MVC_CLASS_NAME = "SendInvitationView";
    public const String HTMLBUTTON_DONE = "in_bu_Done";
    public const String HTMLBUTTON_CANCEL = "in_bu_Cancel";
    protected AActivitySpace m_asOwner;
    
    /// <summary>
    /// Localized String 
    /// </summary>
    protected IModelRO m_model;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new SendInvitationView();
    }
    
    /// <returns></returns>
    public virtual HTMLElement Display()
    {
      HTMLElementCollection myResult = new HTMLElementCollection();
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLImg myImage;
      HTMLInput myInput;
      HTMLH1 headerH1;
      PTConstruct myConstruct;
      try
      {
        // header copied from JulieF's editor framework header
        HTMLComment myComment = new HTMLComment("Begin: Header main table");
        myResult.AddInnerHTMLElement(myComment);
        myTable = new HTMLTable();
        myResult.AddInnerHTMLElement(myTable);
        myTable.SetBorder("0");
        myTable.SetWidth("100%");
        myTable.SetCellPadding("0");
        myTable.SetCellSpacing("0");
        // 1st Row
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.BAN_HEADER_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetWidth("10");
        myConstruct = UIConstructFactory.GetConstruct(PTImageType.SPACER,
         true, this.m_asOwner);
        myImage = (HTMLImg) myConstruct.GetHTMLElement();
        myImage.SetAlt("");
        myImage.SetWidth("10");
        myImage.SetHeight("1");
        myImage.SetBorder("0");
        myCell.AddInnerHTMLElement(myImage);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetWidth("100%");
        myCell.SetHeight("30");
        myCell.SetStyleClass(PTStyleClass.BAN_TEXT);
        myCell.SetNoWrap(true);
        headerH1 = new HTMLH1();
        myCell.AddInnerHTMLElement(headerH1);
        headerH1.AddInnerHTMLString(m_asOwner.GetString(1313, "ptmsgs_portaladminmsgs"));
        headerH1.SetStyleClass(PTStyleClass.BAN_HEADER);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetWidth("300");
        myCell.SetAlign("right");
        myCell.SetStyleClass(PTStyleClass.BAN_TEXT);
        myComment = new HTMLComment("Begin: Header buttons table");
        myCell.AddInnerHTMLElement(myComment);
        // Begin Header buttons table
        HTMLTable mySubTable = new HTMLTable();
        myCell.AddInnerHTMLElement(mySubTable);
        mySubTable.SetBorder("0");
        mySubTable.SetCellPadding("5");
        mySubTable.SetCellSpacing("0");
        // button table 1st Row
        HTMLTableRow mySubRow = new HTMLTableRow();
        mySubTable.AddInnerHTMLElement(mySubRow);
        HTMLTableCell mySubCell = new HTMLTableCell();
        mySubRow.AddInnerHTMLElement(mySubCell);
        mySubCell.SetHeight("20");
        mySubCell.SetAlign("right");
        mySubCell.SetVAlign("middle");
        mySubCell.SetNoWrap(true);
        // Done button
        myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_DONE, "");
        mySubCell.AddInnerHTMLElement(myInput);
        myInput.SetValue(m_asOwner.GetString(1310, "ptmsgs_portaladminmsgs"));
        myInput.SetStyleClass(PTStyleClass.FORM_EDITOR_BTN_TEXT);
        // mj: removed 'Javascript:' from function name
        myInput.SetOnClick("postToSelf(" + SendInvitationRepostControl.POSTTOSELF_ACTION_FINISH + ");");
        mySubCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        mySubCell = new HTMLTableCell();
        mySubRow.AddInnerHTMLElement(mySubCell);
        mySubCell.SetWidth("1");
        myConstruct = UIConstructFactory.GetConstruct(PTImageType.SPACER,
         true, this.m_asOwner);
        myImage = (HTMLImg) myConstruct.GetHTMLElement();
        myImage.SetAlt("");
        myImage.SetWidth("1");
        myImage.SetHeight("1");
        myImage.SetBorder("0");
        mySubCell.AddInnerHTMLElement(myImage);
        // End Header buttons table
        myComment = new HTMLComment("End: Header buttons table");
        myCell.AddInnerHTMLElement(myComment);
        myComment = new HTMLComment("End: Header main table");
        myCell.AddInnerHTMLElement(myComment);
        myResult.AddInnerHTMLElement(HTMLConstructHelpers.GetSubHeader("",
         this.m_asOwner));
        //	add the error display view.
        myResult.AddInnerHTMLElement(this.m_asOwner.GetView(ErrorView.STR_MVC_CLASS_NAME).Display());
        }
      catch (Exception e)
      {
        log.Error(e, "SendInvitationView::Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(1312, "ptmsgs_portaladminmsgs"),
         e);
      }
      return myResult;
    }
    
    /// <summary>
    /// This method returns the HTMLScript that encompasses the Javascript on the page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    /// <returns>HTMLScript</returns>
    public virtual HTMLScript DisplayJavascript()
    {
      //String strFormName = ((AFormDP)m_asOwner.GetCurrentPage()).HTMLFORM_NAME; JAO
      HTMLScript myScript = new HTMLScript("text/javaScript");
      return myScript;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Inits the Section with the read-only Model and the Activity Space.
    /// </summary>
    /// <param name="model"></param>
    /// <param name="parent"></param>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_model = model;
      try
      {
        m_asOwner = (SendInvitationAS) parent;
      }
      catch (Exception e)
      {
        log.Error(e, "SendInvitationView::Init Unable to cast the Object " + parent + " to SendInvitationAS. The following exception occured: " + e.Message);
        // JF- No need to extract, this is an unexpected error.
        throw new XPException("Unable to cast the Object " + parent + " to SendInvitationAS.",
         e);
      }
    }
  }
}