using System;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.web;
namespace com.plumtree.portalpages.admin.serversettings
{
  /// <author>SudhaS</author>
  public class ServerSettingsModel : IServerSettingsModel,IServerSettingsModelRO
  {
    public const String STR_MVC_CLASS_NAME = "ServerSettings";
    private AActivitySpace m_asasParent;
    private IPTSession m_ptSession;
    private String m_strData = "Portal Utilities";
    private Object[] settings;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IModel#CleanupTempData()"></seealso>
    public virtual void CleanupTempData()
    {
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IModel#CleanupAllData()"></seealso>
    public virtual void CleanupAllData()
    {
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new ServerSettingsModel();
    }
    
    /// <seealso cref="com.plumtree.portalpagessample.ServerSettings.IServerSettingsModelRO#getString()"></seealso>
    public virtual String GetData()
    {
      // Methods like this are where you return data to your Section to be displayed.
      return m_strData;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IModelRO#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual Object[] GetServerSettings()
    {
      return settings;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IModel#Init(IActivitySpace)"></seealso>
    public virtual void Init(AActivitySpace parent)
    {
      m_asasParent = parent;
      m_ptSession = (IPTSession) parent.GetUserSession();
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      settings = (Object[]) application.GetCachingManager().GetEntry("DisplayServerSettings");
      }
    
    /// <summary>
    /// Set method for Hello World data
    /// </summary>
    public virtual void SetData(String value)
    {
      // Methods like this are how your Controls perform actions on your Models.
      m_strData = value;
    }
  }
}