using System;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.serversettings.auditmanager
{
  /// <version>$Revision$</version>
  /// <author>$author$</author>
  public class AuditManagerDP : EditorDP
  {
    public const String STR_MVC_CLASS_NAME = "AuditManager";
    
    /// <summary>
    /// The date-picker needs to print some stuff before the form.
    /// </summary>
    /// <returns>HTMLElementCollection</returns>
    public override HTMLElementCollection DisplayHTMLBeforeForm()
    {
      IAuditManagerModelRO ptROModel = (IAuditManagerModelRO) m_asOwner.GetModel(AuditManagerModel.STR_MVC_CLASS_NAME);
      return ptROModel.GetDatePickerControlManager(AuditManagerModel.N_DATE_PICKER_PAGE_TYPE_MESSAGES).GetPagePreFormContent();
      }
    
    /// <summary>
    /// Returns the HTML that is placed in the HEAD section of this HTML page.
    /// </summary>
    /// <returns>HTMLElement</returns>
    public override HTMLElementCollection DisplayHTMLinHEAD()
    {
      IAuditManagerModelRO ptROModel = (IAuditManagerModelRO) m_asOwner.GetModel(AuditManagerModel.STR_MVC_CLASS_NAME);
      return ptROModel.GetDatePickerControlManager(AuditManagerModel.N_DATE_PICKER_PAGE_TYPE_MESSAGES).GetJSIncludes();
      }
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,  linking to
    /// that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      // ***CHANGE_HERE*** Returns the String to display on the left navigation menu, 
      //       linking to that page.
      // ***COMMENT_1*** That String will also be printed out in the page header, so
      //     even if you don't use the left nav menu, it should still return something.
      return (m_asOwner.GetString(1613, "ptmsgs_portaladminmsgs"));
    }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1639, "ptmsgs_portaladminmsgs"),
       this.m_asOwner);
    }
    // Strings to localize.
    // ***CHANGE_HERE*** List of the Strings that need to be localized.
    // ***COMMENT_1*** The names should all start with "_ui_".
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for that Page.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // Insert super class HTML
      result.AddInnerHTMLElement(base.PageDisplay());
      HTMLElementCollection views = new HTMLElementCollection();
      // ***CHANGE_HERE SELECTPTOBJECT*** Display the list.
      //views.AddInnerHTMLElement(((EditorView)
      //	m_asOwner.GetView(AuditManagerEditorAS.m_strStorageSelectPTObject)).Display());
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(MessageTypesView.STR_MVC_CLASS_NAME)).Display());
      result.AddInnerHTMLElement(CreateLeftNavBar(views));
      views.AddInnerHTMLElement(EditorView.GetSpacerTable());
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(ArchivingAgentView.STR_MVC_CLASS_NAME)).Display());
      views.AddInnerHTMLElement(EditorView.GetSpacerTable());
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(MessageDeleteView.STR_MVC_CLASS_NAME)).Display());
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      // ***CHANGE_HERE GROWABLELIST*** Display JavaScripts for the Growable Array.
      //myScripts.AddInnerHTMLElement(m_asOwner.GetView(AuditManagerEditorAS.m_strStorageGrowableList).DisplayJavascript());
      // ***CHANGE_HERE SELECTPTOBJECT*** Display JavaScripts for the Select PTObject list.
      //myScripts.AddInnerHTMLElement(m_asOwner.GetView(AuditManagerEditorAS.m_strStorageSelectPTObject).DisplayJavascript());
      return myScripts;
    }
  }
}