using System;
// Framework Imports
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.admin.serversettings.auditmanager
{
  /// <summary>
  /// This is the RepostControl class for the Audit manager. It handles the Repost
  /// actions for that Editor.
  /// </summary>
  /// <author>JohnH</author>
  public class AuditManagerRepostControl : EditorRepostControl
  {
    
    /// <summary>
    /// The unique identifier for the class 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "AuditManagerRepost";
    
    /// <summary>
    /// Post query result to previous page 
    /// </summary>
    public const int POSTTOSELF_ACTION_PREVIOUS = 10;
    
    /// <summary>
    /// Post query result to next page 
    /// </summary>
    public const int POSTTOSELF_ACTION_NEXT = 11;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new AuditManagerRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call
    /// the associated method for each action.
    /// </summary>
    /// <param name="_nAction"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      switch (_nAction){
      case POSTTOSELF_ACTION_PREVIOUS:
      ((AuditManagerModel) m_model).RepostQueryResultPageOnPrevious();
      break;
      case POSTTOSELF_ACTION_NEXT:
      ((AuditManagerModel) m_model).RepostQueryResultPageOnNext();
      break;
      }
    }
  }
}