using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.serversettings.general
{
  /// <author>$author$</author>
  public class DefaultLanguageSettingsView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.serversettings.general.DefaultLanguageSettingsView");
    // ***COMMENT_1*** All the Views in Plumtree need to have a unique name.
    public const String STR_MVC_CLASS_NAME = "DefaultLanguageSettingsView";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new DefaultLanguageSettingsView();
    }
    
    /// <summary>
    /// Returns the HTML for the Section.
    /// </summary>
    /// <returns>HTMLElement</returns>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLSpan mySpan;
      try
      {
        result.AddInnerHTMLElement(base.GetHeaderView(m_asOwner.GetString(1326,
         "ptmsgs_portaladminmsgs")));
        myTable = new HTMLTable();
        result.AddInnerHTMLElement(myTable);
        myTable.SetWidth("100%");
        myTable.SetBorder("0");
        myTable.SetCellPadding("5");
        myTable.SetCellSpacing("0");
        // 1st Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myCell.SetWidth("50%");
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(1324, "ptmsgs_portaladminmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myCell.SetAlign(CommonHTMLStrings.LEFT);
        myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        String sSetVal = ((ISetServerSettingsModelRO) this.m_model).GetDefaultLocale();
        HTMLSelect mySelect;
        try
        {
          mySelect = com.plumtree.portalpages.browsing.portalsettings.localesettings.LocaleSettingsView.GetLocalesDropdown(m_asOwner,
           sSetVal);
          mySelect.SetName(SetServerSettingsRepostControl.PARAM_DEFAULT_LOCALE);
          myCell.AddInnerHTMLElement(mySelect);
        }
        catch (Exception ex)
        {
          log.Error(ex, "Couldn\'t get locale dropdown.");
        }
        /*
         String[] supportedLocales = rm.GetSupportedLocales("en");
         
         
         
         if ( log.IsDebugEnabled() )
         {
         log.Debug("Set locale: " + sSetVal);
         }
         
         for (int i = 0; i < supportedLocales.length; i++)
         {
         String strLocale    = rm.GetDisplayLocaleFromLocaleID(supportedLocales[i], "en");
         HTMLOption myOption = new HTMLOption(strLocale);
         mySelect.AddInnerHTMLElement(myOption);
         
         if (strLocale.equals(sSetVal))
         {
         myOption.SetSelected(true);
         }
         
         myOption.AddInnerHTMLString(strLocale);
         }
         
         */
         
        // 1st Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myCell.SetNoWrap(true);
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(1325, "ptmsgs_portaladminmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myCell.SetAlign(CommonHTMLStrings.LEFT);
        myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        sSetVal = ((ISetServerSettingsModelRO) this.m_model).GetDefaultTimeZone();
        //            mySelect = new HTMLSelect(SetServerSettingsRepostControl.PARAM_DEFAULT_TIMEZONE, SetServerSettingsRepostControl.PARAM_DEFAULT_TIMEZONE);
        try
        {
          mySelect = com.plumtree.portalpages.browsing.portalsettings.localesettings.LocaleSettingsView.GetTimeZoneDropdown(m_asOwner,
           sSetVal);
          mySelect.SetName(SetServerSettingsRepostControl.PARAM_DEFAULT_TIMEZONE);
          myCell.AddInnerHTMLElement(mySelect);
        }
        catch (Exception ex)
        {
        }
        /*
         if ( log.IsDebugEnabled() )
         {
         log.Debug("Set timezone: " + sSetVal);
         }
         
         for (int i = 0; i < supportedLocales.length; i++)
         {
         String strLocale    = rm.GetDisplayLocaleFromLocaleID(supportedLocales[i], "en");
         HTMLOption myOption = new HTMLOption(strLocale);
         mySelect.AddInnerHTMLElement(myOption);
         
         if (strLocale.equals(sSetVal))
         {
         myOption.SetSelected(true);
         }
         
         myOption.AddInnerHTMLString(strLocale);
         }
         */
         
        /*
         
         // 1st Row begin
         myRow = new HTMLTableRow();
         myTable.AddInnerHTMLElement(myRow);
         myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
         
         myCell = new HTMLTableCell();
         myCell.SetNoWrap(true);
         myRow.AddInnerHTMLElement(myCell);
         
         mySpan = new HTMLSpan();
         myCell.AddInnerHTMLElement(mySpan);
         mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
         
         mySpan.AddInnerHTMLString(m_asOwner.GetString(1327, "ptmsgs_portaladminmsgs"));
         
         myCell = new HTMLTableCell();
         myRow.AddInnerHTMLElement(myCell);
         myCell.SetNoWrap(true);
         myCell.SetAlign(CommonHTMLStrings.LEFT);
         myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
         
         mySelect = new HTMLSelect(SetServerSettingsRepostControl.PARAM_DEFAULT_CHARSET, SetServerSettingsRepostControl.PARAM_DEFAULT_CHARSET);
         myCell.AddInnerHTMLElement(mySelect);
         mySelect.SetStyleClass(PTStyleClass.FORM_PULLDOWN_TEXT);
         
         sSetVal = ((ISetServerSettingsModelRO) this.m_model).GetDefaultCharSet();
         
         if ( log.IsDebugEnabled() )
         {
         log.Debug("Set charset: " + sSetVal);
         }
         
         for (int i = 0; i < supportedLocales.length; i++)
         {
         String strLocale    = rm.GetDisplayLocaleFromLocaleID(supportedLocales[i], "en");
         HTMLOption myOption = new HTMLOption(strLocale);
         mySelect.AddInnerHTMLElement(myOption);
         
         if (strLocale.equals(sSetVal))
         {
         myOption.SetSelected(true);
         }
         
         myOption.AddInnerHTMLString(strLocale);
         }
         
         */
         
        HTMLComment myComment = new HTMLComment("End: Display PropMainView");
        result.AddInnerHTMLElement(myComment);
      }
      catch (Exception e)
      {
        log.Error(e, "PropMainView::Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(1323, "ptmsgs_portaladminmsgs"),
         e);
      }
      return result;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}