using System;
// Framework Imports
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.admin.serversettings.general
{
  /// <author>$author$</author>
  public interface ISetServerSettingsModelRO : IEditorModelRO
  {
    
    /// <returns></returns>
    bool GetAllowNumericAuthentication();
    
    /// <returns></returns>
    bool GetAutoAssignNumericID();
    
    /// <returns></returns>
    String GetDefaultLocale();
    
    /// <returns></returns>
    String GetDefaultTimeZone();
    
    /// <returns></returns>
    String GetDocumentDisplayURL();
    
    /// <returns></returns>
    bool GetEnableAccountLocking();
    //	/**
    //	 * 
    //	 *
    //	 * @return 
    //	 */
    //	public String GetIncomingSearchURL();
    
    /// <returns></returns>
    String GetSoapServerURL();
    
    /// <returns></returns>
    String GetSharedFilesPath();
    
    /// <returns></returns>
    int GetMinutesToLockAccounts();
    
    /// <returns></returns>
    int GetMinutesToTrackFailedLogins();
    
    /// <returns>Whether or not there was an error on the MinutesToLockAccounts setting.</returns>
    bool HasMinutesToLockAccountsError();
    
    /// <returns>Whether or not there was an error on the MinutesToTrackFailedLogins setting.</returns>
    bool HasMinutesToTrackFailedLoginsError();
    
    /// <returns></returns>
    int GetNumberOfFailedLoginsAllowed();
    
    /// <returns>Whether or not there was an error on the NumberOfFailedLoginsAllowed setting.</returns>
    bool HasNumberOfFailedLoginsAllowedError();
    
    /// <returns></returns>
    String GetPrimaryWebServerURL();
    
    /// <returns></returns>
    Object[] GetServerSettings();
    
    /// <returns></returns>
    bool GetAllowUserCreation();
    
    /// <returns></returns>
    bool GetEnableSubportalRulesDebugMode();
    
    /// <returns></returns>
    bool GetEnablePortletErrorsDebugMode();
    
    /// <returns>The minimum password length.</returns>
    int GetPasswordLength();
    
    /// <returns>whether or not there was an error in saving the minimum password length.</returns>
    bool HasPasswordLengthError();
    
    /// <returns>Whether or not numbers are required in the passwords.</returns>
    bool GetPasswordIncludeNumbers();
    
    /// <returns>Whether or not both upper and lower case letters are required in the passwords.</returns>
    bool GetPasswordIncludeCasing();
    
    /// <returns>Whether or not punctuation is required in the passwords.</returns>
    bool GetPasswordIncludePunctuation();
    
    /// <returns>Whether or not user IDs should be dissalowed in the passwords.</returns>
    bool GetPasswordNoUserIDs();
    
    /// <returns>The number of passwords to keep in history to check for reuse.</returns>
    int GetPasswordReuseHistory();
    
    /// <returns>Whether or not there was an error in saving the number of passwords to keep in history to check for reuse.</returns>
    bool HasPasswordReuseHistoryError();
    
    /// <returns>The password expiration in days.</returns>
    int GetPasswordExpiration();
    
    /// <returns>Whether or not there was an error in saving the password expiration in days.</returns>
    bool HasPasswordExpirationError();
    
    /// <returns>The password expiration warning in days.</returns>
    int GetPasswordExpirationWarning();
    
    /// <returns>Whether or not there was an error in saving the password expiration warning in days.</returns>
    bool HasPasswordExpirationWarningError();
  }
}