using System;
// Framework Imports
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.serversettings.general
{
  /// <author>$author$</author>
  public class NewUserCreationView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.serversettings.general.NewUserCreationView");
    // ***COMMENT_1*** All the Views in Plumtree need to have a unique name.
    public const String STR_MVC_CLASS_NAME = "NewUserCreationView";
    // HTML Object names.
    // ***CHANGE_HERE*** Declare some constans for each
    //        HTML object you are using in the display method
    // ***COMMENT_1*** You should follow the HTMLElements naming standards:
    //       <select> starts with in_se
    //       <input button> starts with in_bu
    //       <input text> starts with in_tx
    //       <input checkbox> starts with in_cb
    //       <input radio> starts with in_ra
    //       <textarea> starts with in_ta
    public const String HTMLINPUT_PROP_NAME = "in_tx_Name";
    public const String HTMLINPUT_PROP_DESCRIPTION = "in_ta_Description";
    public const String HTMLBUTTON_REPOST = "in_bu_repost";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new NewUserCreationView();
    }
    
    /// <summary>
    /// Returns the HTML for the Section.
    /// </summary>
    /// <returns>HTMLElement</returns>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLInput myInput;
      HTMLSpan mySpan;
      try
      {
        HTMLComment myComment = new HTMLComment("Begin: Display PropMainView");
        result.AddInnerHTMLElement(myComment);
        result.AddInnerHTMLElement(base.GetHeaderView(m_asOwner.GetString(1329,
         "ptmsgs_portaladminmsgs")));
        myTable = new HTMLTable();
        result.AddInnerHTMLElement(myTable);
        myTable.SetWidth("100%");
        myTable.SetBorder("0");
        myTable.SetCellPadding("5");
        myTable.SetCellSpacing("0");
        // 1st Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myCell.SetWidth("50%");
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        //mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(1332, "ptmsgs_portaladminmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myCell.SetAlign(CommonHTMLStrings.LEFT);
        myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        myInput = new HTMLInput(HTMLInputTypes.CHECKBOX_TYPE, SetServerSettingsRepostControl.PARAM_ALLOW_USER_CREATION,
         SetServerSettingsRepostControl.PARAM_ALLOW_USER_CREATION);
        if (((ISetServerSettingsModelRO) this.m_model).GetAllowUserCreation())
        {
          myInput.SetChecked(true);
        }
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
        myInput.SetValue(XPConvert.ToString(true));
        // 1st Row end
        myComment = new HTMLComment("End: Display PropMainView");
        result.AddInnerHTMLElement(myComment);
      }
      catch (Exception e)
      {
        // ***CHANGE_HERE*** Update the error messages (log and exception).
        log.Error(e, "PropMainView::Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(1328, "ptmsgs_portaladminmsgs"),
         e);
      }
      return result;
    }
    // ***CHANGE_HERE*** Update the class name below.
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}