using System;
// Framework Imports
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.serversettings.general
{
  /// <summary>
  /// This is class is used to print out together the Views for
  /// the Advanced Settings page of the Property Editor.
  /// </summary>
  /// <author>Julie Fournier</author>
  public class PortalURLsDP : EditorDP
  {
    // ***CHANGE_HERE*** Change the name of the class.
    // ***COMMENT_1*** Delete the comments prefixed by CHANGE_HERE and COMMENT
    //       when you are done.
    // ***CHANGE_HERE*** Set the class name.
    // ***COMMENT_1*** All the DPs in your AS need to have a unique name.
    public const String STR_MVC_CLASS_NAME = "PortalURLsDP";
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,
    /// linking to that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      // ***CHANGE_HERE*** Returns the String to display on the left navigation menu, 
      //       linking to that page.
      return (m_asOwner.GetString(1340, "ptmsgs_portaladminmsgs"));
    }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1644, "ptmsgs_portaladminmsgs"),
       this.m_asOwner);
    }
    // Strings to localize.
    // ***CHANGE_HERE*** List of the Strings that need to be localized.
    // ***COMMENT_1*** The names should all start with "_ui_".
    // ***CHANGE_HERE*** If you want to customize the empty space on the left 
    //      and right sides of the content table, use the SetContentTableCellSpacing
    //      method as shown below. This is optional, the default value of the 
    //      framework is 15. If you set it to 0 the Views won't get indented.
    /*
     public PropAdvDP()
     {
     super();
     super.SetContentTableCellSpacing("0");
     }*/
     
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for the Advanced Settings page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)"></seealso>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // Insert super class HTML
      result.AddInnerHTMLElement(base.PageDisplay());
      HTMLElementCollection views = new HTMLElementCollection();
      // ***CHANGE_HERE*** For each Section you want to display on that page, 
      //       copy the line below and change the name of the Section.
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(PortalURLsView.STR_MVC_CLASS_NAME)).Display());
      result.AddInnerHTMLElement(CreateLeftNavBar(views));
      return result;
    }
  }
}