using System;
// Plumtree Server Imports
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.serversettings.general
{
  /// <author>$author$</author>
  public class PortalURLsView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.serversettings.general.PortalURLsView");
    // ***COMMENT_1*** All the Views in Plumtree need to have a unique name.
    public const String STR_MVC_CLASS_NAME = "PortalURLsView";
    public const String HTMLSELECT_PROP_TYPE = "in_se_PropType";
    public const String HTMLBUTTON_REPOST = "in_bu_repost";
    public const String HTMLCHECKBOX_SAMPLE = "in_cb_sample";
    public const String HTMLRADIO_SAMPLE = "in_ra_sample";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new PortalURLsView();
    }
    
    /// <summary>
    /// Returns the HTML for the Section.
    /// </summary>
    /// <returns>HTMLElement</returns>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLInput myInput;
      HTMLSpan mySpan;
      try
      {
        //	PRIMARY WEB SERVER URL		
        result.AddInnerHTMLElement(base.GetHeaderView(m_asOwner.GetString(1341,
         "ptmsgs_portaladminmsgs")));
        HTMLTable myTable = new HTMLTable();
        result.AddInnerHTMLElement(myTable);
        myTable.SetWidth("100%");
        myTable.SetBorder("0");
        myTable.SetCellPadding("5");
        myTable.SetCellSpacing("0");
        // 1st Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(1342, "ptmsgs_portaladminmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myCell.SetAlign(CommonHTMLStrings.LEFT);
        myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        myInput = new HTMLInput(HTMLInputTypes.TEXT_TYPE, SetServerSettingsRepostControl.PARAM_PRIMARY_WEB_SERVER_URL,
         SetServerSettingsRepostControl.PARAM_PRIMARY_WEB_SERVER_URL);
        myInput.SetSize(50);
        myInput.SetValue(((ISetServerSettingsModelRO) this.m_model).GetPrimaryWebServerURL());
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
        //	DISPLAY FILES URL
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(1343, "ptmsgs_portaladminmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myCell.SetAlign(CommonHTMLStrings.LEFT);
        myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        myInput = new HTMLInput(HTMLInputTypes.TEXT_TYPE, SetServerSettingsRepostControl.PARAM_DISPLAY_FILES_URL,
         SetServerSettingsRepostControl.PARAM_DISPLAY_FILES_URL);
        myInput.SetSize(50);
        myInput.SetValue(((ISetServerSettingsModelRO) this.m_model).GetDocumentDisplayURL());
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
        //
        //			//	FEDERATED SEARCH URL
        //
        //			myRow = new HTMLTableRow();
        //			myTable.AddInnerHTMLElement(myRow);
        //			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        //
        //			myCell = new HTMLTableCell();
        //			myRow.AddInnerHTMLElement(myCell);
        //			myCell.SetNoWrap(true);
        //
        //			mySpan = new HTMLSpan();
        //			myCell.AddInnerHTMLElement(mySpan);
        //			mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
        //
        //			mySpan.AddInnerHTMLString(m_asOwner.GetString(1344,
        //					"ptmsgs_portaladminmsgs"));
        //
        //			myCell = new HTMLTableCell();
        //			myRow.AddInnerHTMLElement(myCell);
        //			myCell.SetNoWrap(true);
        //			myCell.SetAlign(CommonHTMLStrings.LEFT);
        //			myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        //
        //			myInput = new HTMLInput(HTMLInputTypes.TEXT_TYPE,
        //					SetServerSettingsRepostControl.PARAM_INCOMING_SEARCH_URL,
        //					SetServerSettingsRepostControl.PARAM_INCOMING_SEARCH_URL);
        //
        //			myInput.SetSize(90);
        //			myInput.SetValue(((ISetServerSettingsModelRO) this.m_model).GetIncomingSearchURL());
        //			
        //			
        //			myCell.AddInnerHTMLElement(myInput);
        //			myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
        //
        //
        //	SOAP SERVER URL
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
        mySpan.AddInnerHTMLString(this.m_asOwner.GetString(2363, "ptmsgs_portaladminmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myCell.SetAlign(CommonHTMLStrings.LEFT);
        myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        myInput = new HTMLInput(HTMLInputTypes.TEXT_TYPE, SetServerSettingsRepostControl.PARAM_SOAP_SERVER_URL,
         SetServerSettingsRepostControl.PARAM_SOAP_SERVER_URL);
        myInput.SetSize(50);
        myInput.SetValue(((ISetServerSettingsModelRO) this.m_model).GetSoapServerURL());
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
        //	SHARED FILES URL
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
        mySpan.AddInnerHTMLString(this.m_asOwner.GetString(2542, "ptmsgs_portaladminmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myCell.SetAlign(CommonHTMLStrings.LEFT);
        myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        myInput = new HTMLInput(HTMLInputTypes.TEXT_TYPE, SetServerSettingsRepostControl.PARAM_SHARED_FILES_PATH,
         SetServerSettingsRepostControl.PARAM_SHARED_FILES_PATH);
        myInput.SetSize(50);
        myInput.SetValue(((ISetServerSettingsModelRO) this.m_model).GetSharedFilesPath());
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
      }
      catch (Exception e)
      {
        log.Error(e, "PropAdvView::Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(1345, "ptmsgs_portaladminmsgs"),
         e);
      }
      return result;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}