using System;
// Framework Imports
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.admin.serversettings.globalaclsyncmap
{
  /// <summary>
  /// This class contains the additional repost actions.
  /// The ones specific to the Misc Editor (other than
  /// "change page", "finish" and "cancel" actions).
  /// </summary>
  /// <author>JohnH</author>
  public class GlobalACLSyncMapRepostControl : EditorRepostControl
  {
    public const String STR_MVC_CLASS_NAME = "GlobalACLSyncMapRepost";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new GlobalACLSyncMapRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call
    /// the associated method for each action.
    /// </summary>
    /// <param name="int"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      //Domain map
      ((ExpListControl) m_asOwner.GetControl(GlobalACLSyncMapAS.STR_MVC_STORAGE_NAME_DOMAIN_PLUG_IN)).PerformRepostAction(_nAction,
       m_htFormData);
      //Group map
      ((ExpListControl) m_asOwner.GetControl(GlobalACLSyncMapAS.STR_MVC_STORAGE_NAME_GROUP_PLUG_IN)).PerformRepostAction(_nAction,
       m_htFormData);
      switch (_nAction){
      }
    }
  }
}