using System;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.admin.serversettings.objectpropertymap
{
  /// <summary>
  /// Repost control for object properties map.
  /// </summary>
  /// <author>josephc</author>
  public class ObjPropMapRepostControl : EditorRepostControl
  {
    
    /// <summary>
    /// Class name for ObjPropMapRepostControl 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "ObjPropMapRepost";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new ObjPropMapRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call  the associated method for each
    /// action.
    /// </summary>
    /// <param name="_nAction"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      ((ExpListControl) m_asOwner.GetControl(ObjPropMapEditorAS.strStorageObjPropMapPlugin)).PerformRepostAction(_nAction,
       m_htFormData);
    }
  }
}