using System;
using com.plumtree.uiinfrastructure.expandablelist;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.serversettings.objectpropertymap.plugin
{
  /// <summary>
  /// This interface is implemented by the Model. It contains all the read-only
  /// mothods of the Model accessed by the Views.
  /// </summary>
  /// <author>josephc</author>
  public interface IObjPropMapPluginModelRO : IExpListModelRO
  {
    
    /// <summary>
    /// Returns the class icon
    /// </summary>
    /// <param name="_nRowIndex">Row index</param>
    /// <returns>Icon for class</returns>
    HTMLImg GetClassIcon(int _nRowIndex);
    
    /// <summary>
    /// Returns array of property names and descriptions.
    /// </summary>
    /// <param name="_nRowIndex">Row index</param>
    /// <returns>Array of property names and descriptions</returns>
    String[][] GetPropertyInfo(int _nRowIndex);
    
    /// <summary>
    /// Returns a String of Class IDs and Object IDs of the Objects  to select
    /// in the tree. E.g.: "propertyClassID,ObjID1,propertyClassID,objID2".  In
    /// our case, propertyClassID is the classID for properties.
    /// </summary>
    /// <param name="_nRowIndex">Row index</param>
    /// <returns>String</returns>
    String GetSelectedItems(int _nRowIndex);
  }
}