using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portalpages.admin.editors.bestbets;
using com.plumtree.portalpages.common.constants;
using com.plumtree.portaluiinfrastructure.search;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.htmlconstructs;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.serversettings.search
{
  /// <author>CraigS</author>
  public class BestBetsListView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.serversettings.search.BestBetsListView");
    public const String STR_MVC_CLASS_NAME = "BestBetsListView";
    public const String DEL_ALL_CB = "in_cb_uber";
    // Constants
    //public static final int MAX_BEST_BETS = 200;
    public const int NUM_BEST_BETS_PER_PAGE = 10;
    private SearchServerTuningEditorModel _model;
    private int nKeyForNewItems = 0;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new BestBetsListView();
    }
    
    /// <returns></returns>
    public override HTMLElement Display()
    {
      _model = (SearchServerTuningEditorModel) m_model;
      int numBBsOnPage = _model.GetNumBestBetsOnPage();
      // This needs to be an input parameter!
      int nBBsStartNum = 1;
      try
      {
        HTMLElementCollection result0 = new HTMLElementCollection();
        HTMLComment comment1 = new HTMLComment("Begin: Display BestBetsListMainView");
        result0.AddInnerHTMLElement(comment1);
        HTMLInput startCountHidden = new HTMLInput(HTMLInputTypes.HIDDEN,
         SearchServerTuningEditorRepostControl.HTMLINPUT_FIRST_BEST_BET_TO_SHOW,
         SearchServerTuningEditorRepostControl.HTMLINPUT_FIRST_BEST_BET_TO_SHOW,
         XPConvert.ToString(_model.GetBestBetStartCount()));
        startCountHidden.SetValue(XPConvert.ToString(_model.GetBestBetStartCount()));
        result0.AddInnerHTMLElement(startCountHidden);
        HTMLTable searchBoxTable = new HTMLTable();
        searchBoxTable.SetWidth("100%");
        searchBoxTable.SetCellSpacing("0");
        searchBoxTable.SetCellPadding("3");
        result0.AddInnerHTMLElement(searchBoxTable);
        HTMLTableRow searchBoxRow = new HTMLTableRow();
        searchBoxRow.SetStyleClass(PTStyleClass.OBJECTSEARCH_BG);
        searchBoxTable.AddInnerHTMLElement(searchBoxRow);
        HTMLTableCell searchTextCell = new HTMLTableCell();
        searchTextCell.SetColSpan("1");
        searchTextCell.SetStyleClass(PTStyleClass.OBJECTSEARCH_HEADER);
        searchTextCell.SetVAlign("middle");
        searchTextCell.SetNoWrap(true);
        searchTextCell.SetHeight("25");
        searchBoxRow.AddInnerHTMLElement(searchTextCell);
        searchTextCell.AddInnerHTMLString(m_asOwner.GetString(2455, ResourceConstants.PORTALADMINMSGS));
        HTMLTableCell searchBoxCell = new HTMLTableCell();
        searchBoxCell.SetWidth("100%");
        searchBoxCell.SetColSpan("1");
        searchBoxCell.SetVAlign("middle");
        searchBoxCell.SetNoWrap(true);
        searchBoxCell.SetHeight("25");
        searchBoxRow.AddInnerHTMLElement(searchBoxCell);
        HTMLInput searchTextBox = new HTMLInput(HTMLInputTypes.TEXT, SearchServerTuningEditorRepostControl.HTMLINPUT_SEARCH_TEXT,
         SearchServerTuningEditorRepostControl.HTMLINPUT_SEARCH_TEXT, "");
        String strSearchString = _model.GetBestBetSearchString();
        if (strSearchString != null)
        {
          searchTextBox.SetValue(strSearchString);
        }
        searchTextBox.SetOnKeyDown("document.mainform.in_hi_PostToSelf.value= " + SearchServerTuningEditorRepostControl.POSTTOSELF_ACTION_BB_SEARCH + ";");
        searchTextBox.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
        searchBoxCell.AddInnerHTMLElement(searchTextBox);
        searchBoxCell.AddInnerHTMLString("&nbsp;");
        HTMLComment comment2 = new HTMLComment("Search");
        searchBoxCell.AddInnerHTMLElement(comment2);
        HTMLAnchor searchAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
        searchAnchor.SetOnClick("postToSelf(" + SearchServerTuningEditorRepostControl.POSTTOSELF_ACTION_BB_SEARCH + "); return false;");
        searchBoxCell.AddInnerHTMLElement(searchAnchor);
        HTMLImg searchButton = SearchUIUtility.GetImage(m_asOwner, PTImageType.ACTION_SEARCH_BUTTON,
         m_asOwner.GetString(2372, ResourceConstants.PORTALADMINMSGS), "30",
         "20");
        searchButton.SetAlign("absmiddle");
        searchAnchor.AddInnerHTMLElement(searchButton);
        if (!_model.GetIsShowAllBestBets())
        {
          searchBoxCell.AddInnerHTMLString("&nbsp;");
          searchBoxCell.AddInnerHTMLString("|");
          searchBoxCell.AddInnerHTMLString("&nbsp;");
          searchBoxCell.AddInnerHTMLString("&nbsp;");
          searchBoxCell.AddInnerHTMLString("&nbsp;");
          HTMLAnchor a2 = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
          a2.SetOnClick("postToSelf(" + SearchServerTuningEditorRepostControl.POSTTOSELF_ACTION_BB_SHOWALL + "); return false;");
          searchBoxCell.AddInnerHTMLElement(a2);
          a2.AddInnerHTMLString(m_asOwner.GetString(3065, ResourceConstants.PORTALADMINMSGS));
          }
        result0.AddInnerHTMLElement(SearchUIUtility.makeSpacer(m_asOwner,
         "5"));
        HTMLTable bbHdrTable = new HTMLTable();
        bbHdrTable.SetWidth("100%");
        bbHdrTable.SetBorder("0");
        bbHdrTable.SetCellSpacing("0");
        bbHdrTable.SetCellPadding("0");
        result0.AddInnerHTMLElement(bbHdrTable);
        HTMLTableRow tr2 = new HTMLTableRow();
        tr2.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);
        bbHdrTable.AddInnerHTMLElement(tr2);
        HTMLTableCell td3 = new HTMLTableCell();
        td3.SetWidth("100%");
        td3.SetColSpan("1");
        td3.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        td3.SetVAlign("middle");
        td3.SetHeight("20");
        tr2.AddInnerHTMLElement(td3);
        HTMLSpan hdrSpan = new HTMLSpan();
        hdrSpan.SetStyleClass(PTStyleClass.OBJECT_HEADER);
        td3.AddInnerHTMLElement(hdrSpan);
        hdrSpan.AddInnerHTMLString(m_asOwner.GetString(2403, ResourceConstants.PORTALADMINMSGS));
        td3.AddInnerHTMLString("&nbsp;");
        td3.AddInnerHTMLString("&nbsp;");
        HTMLSpan numBBsSpan = new HTMLSpan();
        numBBsSpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        td3.AddInnerHTMLElement(numBBsSpan);
        if (numBBsOnPage > 0)
        {
          String strPaginationStatus = XPResourceManager.FormatMessage(m_asOwner.GetString(1689,
           ResourceConstants.PORTALADMINMSGS), _model.GetBestBetStartCount(),
           _model.GetBestBetStartCount() + _model.GetNumBestBetsOnPage() - 1,
           _model.GetTotalBestBetCount());
          numBBsSpan.AddInnerHTMLString(strPaginationStatus);
        }
        HTMLTable table3 = new HTMLTable();
        table3.SetWidth("100%");
        table3.SetBorder("0");
        table3.SetCellSpacing("0");
        table3.SetCellPadding("0");
        result0.AddInnerHTMLElement(table3);
        HTMLTableRow tr3 = new HTMLTableRow();
        tr3.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BG);
        table3.AddInnerHTMLElement(tr3);
        HTMLTableCell td4 = new HTMLTableCell();
        td4.SetColSpan("1");
        td4.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BTN);
        td4.SetAlign("absmiddle");
        td4.SetVAlign("middle");
        td4.SetNoWrap(true);
        td4.SetHeight("25");
        tr3.AddInnerHTMLElement(td4);
        // Empty key for new items.
        String newBBKey = "newBB" + XPConvert.ToString(this.nKeyForNewItems++);
        ASURL newBBURL = ((EditorAS) m_asOwner).GoToSubEditor(/* subEditorName= */
        BestBetEditorAS.STR_MVC_CLASS_NAME, /* subEditorKey= */
        newBBKey, /* subEditorType= */
        EditorStartControl.EDITOR_START_FLAG_MISC, /* controlKey= */
        BestBetRepostControl.HTMLINPUT_ITEM_TO_EDIT_ON_START, /* controlValue= */
        "-1");
        HTMLAnchor newBBAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
        newBBAnchor.SetOnClick("editBB(\'" + newBBURL.GetURLAsString() + "\', \'" + newBBKey + "\'); return false;");
        td4.AddInnerHTMLElement(newBBAnchor);
        newBBAnchor.AddInnerHTMLString("&nbsp;");
        HTMLImg imgNew = SearchUIUtility.GetImage(m_asOwner, PTImageType.ACTION_NEW,
         m_asOwner.GetString(2670, ResourceConstants.PORTALADMINMSGS), "6",
         "25");
        imgNew.SetAlign("absmiddle");
        newBBAnchor.AddInnerHTMLElement(imgNew);
        HTMLImg imgDoc = SearchUIUtility.GetImage(m_asOwner, PTImageType.ICON_DOCUMENT,
         "", "15", "20");
        imgDoc.SetAlign("absmiddle");
        newBBAnchor.AddInnerHTMLElement(imgDoc);
        HTMLSpan span3 = new HTMLSpan();
        span3.SetStyleClass(PTStyleClass.ACTIONBAR_TEXT);
        newBBAnchor.AddInnerHTMLElement(span3);
        span3.AddInnerHTMLString(m_asOwner.GetString(2400, "ptmsgs_portaladminmsgs"));
        newBBAnchor.AddInnerHTMLString("&nbsp;");
        newBBAnchor.AddInnerHTMLString("&nbsp;");
        HTMLTableCell td5 = new HTMLTableCell();
        td5.SetColSpan("1");
        td5.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_DIVIDER);
        td5.SetHeight("25");
        tr3.AddInnerHTMLElement(td5);
        HTMLImg img4 = SearchUIUtility.GetImage(m_asOwner, PTImageType.SPACER,
         "", "1", "1");
        td5.AddInnerHTMLElement(img4);
        HTMLTableCell td6 = new HTMLTableCell();
        td6.SetColSpan("1");
        td6.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BTN);
        td6.SetNoWrap(true);
        td6.SetHeight("25");
        tr3.AddInnerHTMLElement(td6);
        HTMLAnchor delBBAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
        if (_model.GetTotalBestBetCount() > 0)
        {
          delBBAnchor.SetOnClick("DeleteBestBets();");
        }
        td6.AddInnerHTMLElement(delBBAnchor);
        HTMLImg img5 = SearchUIUtility.GetImage(m_asOwner, PTImageType.ACTION_DELETE,
         m_asOwner.GetString(2450, ResourceConstants.PORTALADMINMSGS), "25",
         "25");
        img5.SetAlign("absmiddle");
        delBBAnchor.AddInnerHTMLElement(img5);
        HTMLTableCell td7 = new HTMLTableCell();
        td7.SetColSpan("1");
        td7.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_DIVIDER);
        td7.SetHeight("25");
        tr3.AddInnerHTMLElement(td7);
        HTMLImg img6 = SearchUIUtility.GetImage(m_asOwner, PTImageType.SPACER,
         "", "1", "1");
        td7.AddInnerHTMLElement(img6);
        HTMLTableCell td8 = new HTMLTableCell();
        td8.SetWidth("100%");
        td8.SetColSpan("1");
        td8.SetHeight("25");
        tr3.AddInnerHTMLElement(td8);
        td8.AddInnerHTMLString("&nbsp;");
        result0.AddInnerHTMLElement(SearchUIUtility.makeSpacer(m_asOwner,
         "5"));
        if (numBBsOnPage > 0)
        {
          /* best bet table */
          HTMLTable bbListTable = new HTMLTable();
          bbListTable.SetWidth("100%");
          bbListTable.SetBorder("0");
          bbListTable.SetCellSpacing("2");
          bbListTable.SetCellPadding("2");
          bbListTable.SetSummary(m_asOwner.GetString(2013, "ptmsgs_portaladminmsgs"));
          result0.AddInnerHTMLElement(bbListTable);
          HTMLTableRow bbTableHdrRow = new HTMLTableRow();
          bbTableHdrRow.SetStyleClass(PTStyleClass.LIST_SORT_HEADER_BG);
          bbListTable.AddInnerHTMLElement(bbTableHdrRow);
          HTMLTableCell td9 = new HTMLTableCell();
          td9.SetWidth("20");
          td9.SetColSpan("1");
          td9.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
          td9.SetAlign("center");
          td9.SetVAlign("middle");
          bbTableHdrRow.AddInnerHTMLElement(td9);
          HTMLInput input2 = new HTMLInput(HTMLInputTypes.CHECKBOX, DEL_ALL_CB,
           DEL_ALL_CB, "");
          input2.SetValue("");
          input2.SetChecked(false);
          input2.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
          input2.SetOnClick("DoToggleAllCBs();");
          td9.AddInnerHTMLElement(input2);
          HTMLTableCell td10 = new HTMLTableCell();
          td10.SetWidth("90%");
          td10.SetColSpan("1");
          td10.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
          td10.SetHeight("20");
          bbTableHdrRow.AddInnerHTMLElement(td10);
          td10.AddInnerHTMLString(m_asOwner.GetString(2392, ResourceConstants.PORTALADMINMSGS));
          HTMLTableCell td11 = new HTMLTableCell();
          td11.SetWidth("10%");
          td11.SetColSpan("1");
          td11.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
          td11.SetHeight("20");
          bbTableHdrRow.AddInnerHTMLElement(td11);
          td11.AddInnerHTMLString(m_asOwner.GetString(2405, ResourceConstants.PORTALADMINMSGS));
          /* for each best bet */
          for (int j = 0;j < numBBsOnPage;j++)
          {
            HTMLTableRow bbRow = new HTMLTableRow();
            if (j % 2 == 0)
            {
              bbRow.SetStyleClass(PTStyleClass.LIST_ITEM_TWO_BG);
            } else
            {
              bbRow.SetStyleClass(PTStyleClass.LIST_ITEM_ONE_BG);
            }
            bbListTable.AddInnerHTMLElement(bbRow);
            HTMLTableCell td12 = new HTMLTableCell();
            td12.SetWidth("20");
            td12.SetColSpan("1");
            td12.SetStyleClass(PTStyleClass.LIST_TEXT);
            td12.SetAlign("center");
            td12.SetVAlign("middle");
            bbRow.AddInnerHTMLElement(td12);
            String strItemNum = XPConvert.ToString(j);
            long lTime = XPSystem.GetCurrentTimeMilliSec();
            String strTimeStamp = XPConvert.ToString(lTime);
            if (strTimeStamp.Length > 8)
            {
              strTimeStamp = XPStringUtility.Substring(strTimeStamp, strTimeStamp.Length - 8);
              }
            String strPopupUniqueKey = XPConvert.ToString(_model.GetBestBetStartCount() + j) + strTimeStamp;
            HTMLInput input3 = new HTMLInput(HTMLInputTypes.CHECKBOX, SearchServerTuningEditorRepostControl.HTMLINPUT_SELECTED_ITEM,
             SearchServerTuningEditorRepostControl.HTMLINPUT_SELECTED_ITEM,
             "");
            input3.SetValue(strItemNum);
            input3.SetChecked(false);
            if (_model.HasBestBetBeenDeleted(j))
            {
              input3.SetDisabled(true);
            }
            td12.AddInnerHTMLElement(input3);
            HTMLTableCell bbNameCell = new HTMLTableCell();
            bbNameCell.SetWidth("90%");
            bbNameCell.SetColSpan("1");
            if (!_model.HasBestBetBeenDeleted(j))
            {
              bbNameCell.SetStyleClass(PTStyleClass.LIST_TEXT);
            }
            bbNameCell.SetVAlign("middle");
            bbNameCell.SetHeight("20");
            bbRow.AddInnerHTMLElement(bbNameCell);
            String bbQuery = _model.GetBestBetTrigger(j);
            if (!_model.HasBestBetBeenDeleted(j))
            {
              HTMLAnchor editBBAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
              // Create the URL to open the editor for the individual BB in a subspace
              ASURL url = ((EditorAS) m_asOwner).GoToSubEditor(/* subEditorName= */
              BestBetEditorAS.STR_MVC_CLASS_NAME, /* subEditorKey= */
              strPopupUniqueKey, /* subEditorType= */
              EditorStartControl.EDITOR_START_FLAG_MISC, /* controlKey= */
              BestBetRepostControl.HTMLINPUT_ITEM_TO_EDIT_ON_START, /* controlValue= */
              strItemNum);
              editBBAnchor.SetOnClick("editBB(\'" + url.GetURLAsString() + "\', \'" + strPopupUniqueKey + "\'); return false;");
              bbNameCell.AddInnerHTMLElement(editBBAnchor);
              editBBAnchor.AddInnerHTMLString(XPHttpUtility.HtmlEncode(bbQuery));
              } else
            {
              HTMLSpan spanDel = new HTMLSpan();
              spanDel.SetStyleClass("lineThrough");
              // TODO: Replace hardcoded style with constant in PTStyleClass
              // spanDel.SetStyleClass(PTStyleClass.LINE_THROUGH);
              spanDel.AddInnerHTMLString(XPHttpUtility.HtmlEncode(bbQuery));
              bbNameCell.AddInnerHTMLElement(spanDel);
            }
            // Determine wether to add a "new" or "updated" label after the trigger string.
            if (_model.HasBestBetBeenNewlyAdded(j))
            {
              HTMLSpan span1 = new HTMLSpan();
              span1.SetStyleClass(PTStyleClass.LIST_NEW_TEXT);
              span1.AddInnerHTMLString("&nbsp;");
              // This is an "updated" item, not a new item.
              if (_model.HasBestBetStringBeenDeleted(bbQuery))
              {
                span1.AddInnerHTMLString(m_asOwner.GetString(1578, "ptmsgs_portalbrowsingmsgs"));
                } else
              {
                span1.AddInnerHTMLString(m_asOwner.GetString(1577, "ptmsgs_portalbrowsingmsgs"));
                }
              bbNameCell.AddInnerHTMLElement(span1);
            }
            HTMLTableCell bbTargetCountCell = new HTMLTableCell();
            bbTargetCountCell.SetWidth("10%");
            bbTargetCountCell.SetColSpan("1");
            bbTargetCountCell.SetStyleClass(PTStyleClass.LIST_TEXT);
            bbTargetCountCell.SetAlign("middle");
            bbTargetCountCell.SetHeight("20");
            bbRow.AddInnerHTMLElement(bbTargetCountCell);
            bbTargetCountCell.AddInnerHTMLString(XPConvert.ToString(_model.GetBestBetTargets(j).GetSize()));
            }
          /* end for each best bet */
          /* Last row for pagination */
          if (_model.GetTotalBestBetCount() > _model.GetNumBestBetsAskedFor())
          {
            HTMLTableRow paginateBBRow = new HTMLTableRow();
            paginateBBRow.SetStyleClass(PTStyleClass.LIST_ITEM_TWO_BG);
            bbListTable.AddInnerHTMLElement(paginateBBRow);
            HTMLTableCell paginateBBCell = new HTMLTableCell();
            paginateBBCell.SetWidth("100%");
            paginateBBCell.SetColSpan("3");
            paginateBBCell.SetStyleClass(PTStyleClass.LIST_PAGINATION_TEXT);
            paginateBBCell.SetAlign("right");
            paginateBBCell.SetVAlign("top");
            paginateBBRow.AddInnerHTMLElement(paginateBBCell);
            String strPrevLabel = "&lt;&lt;&nbsp;" + m_asOwner.GetString(1381,
             ResourceConstants.PORTALADMINMSGS) + "&nbsp;|&nbsp;";
            if (_model.GetShowPreviousBestBet())
            {
              HTMLAnchor prevPageAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
              prevPageAnchor.SetOnClick("paginate(\'" + XPConvert.ToString(_model.GetBestBetStartCount() - _model.GetNumBestBetsAskedFor()) + "\')");
              paginateBBCell.AddInnerHTMLElement(prevPageAnchor);
              prevPageAnchor.AddInnerHTMLString(strPrevLabel);
            } else
            {
              paginateBBCell.AddInnerHTMLString(strPrevLabel);
            }
            int nNumPagesBeforeNext = 6;
            int nStartForPaginationLinks = ((_model.GetBestBetStartCount() / (nNumPagesBeforeNext * _model.GetNumBestBetsAskedFor())) * (nNumPagesBeforeNext * _model.GetNumBestBetsAskedFor())) + 1;
            if (_model.GetNumBestBetsAskedFor() < _model.GetTotalBestBetCount())
            {
              for (int i = 0;i < nNumPagesBeforeNext;i++)
              {
                int nStartCount = nStartForPaginationLinks + (i * _model.GetNumBestBetsAskedFor());
                if (nStartCount <= _model.GetTotalBestBetCount())
                {
                  int nEndNum = nStartCount + _model.GetNumBestBetsAskedFor() - 1;
                  if (nEndNum > _model.GetTotalBestBetCount())
                  {
                    nEndNum = _model.GetTotalBestBetCount();
                  }
                  // Not on current page.
                  if (nStartCount != _model.GetBestBetStartCount())
                  {
                    HTMLAnchor paginateBBsAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
                    paginateBBsAnchor.SetOnClick("paginate(\'" + XPConvert.ToString(nStartCount) + "\')");
                    paginateBBCell.AddInnerHTMLElement(paginateBBsAnchor);
                    paginateBBsAnchor.AddInnerHTMLString(XPConvert.ToString(nStartCount));
                    paginateBBsAnchor.AddInnerHTMLString(" - ");
                    paginateBBsAnchor.AddInnerHTMLString(XPConvert.ToString(nEndNum));
                    } else
                  {
                    paginateBBCell.AddInnerHTMLString(XPConvert.ToString(nStartCount));
                    paginateBBCell.AddInnerHTMLString(" - ");
                    paginateBBCell.AddInnerHTMLString(XPConvert.ToString(nEndNum));
                    }
                  paginateBBCell.AddInnerHTMLString("&nbsp;|&nbsp;");
                }
              }
            }
            String strNextLabel = m_asOwner.GetString(1383, ResourceConstants.PORTALADMINMSGS) + "&nbsp;&gt;&gt;";
            if (_model.GetShowNextBestBet())
            {
              //paginateBBCell.AddInnerHTMLString("&nbsp;|&nbsp;");
              HTMLAnchor nextPageAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
              nextPageAnchor.SetOnClick("paginate(\'" + XPConvert.ToString(_model.GetBestBetStartCount() + _model.GetNumBestBetsAskedFor()) + "\')");
              paginateBBCell.AddInnerHTMLElement(nextPageAnchor);
              nextPageAnchor.AddInnerHTMLString(strNextLabel);
            } else
            {
              paginateBBCell.AddInnerHTMLString(strNextLabel);
            }
          }
          result0.AddInnerHTMLElement(new HTMLBr());
          result0.AddInnerHTMLElement(new HTMLBr());
          result0.AddInnerHTMLElement(new HTMLBr());
          result0.AddInnerHTMLElement(new HTMLBr());
        } else
        /* End best bet table */
        {
          HTMLTable myTable = new HTMLTable();
          result0.AddInnerHTMLElement(myTable);
          myTable.SetCellSpacing("0");
          myTable.SetCellPadding("5");
          myTable.SetWidth("100%");
          HTMLTableRow myRow = new HTMLTableRow();
          myTable.AddInnerHTMLElement(myRow);
          HTMLTableCell myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          myCell.SetWidth("100%");
          myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
          if (!_model.GetIsShowAllBestBets())
          {
            String strMessage = XPResourceManager.FormatMessage(m_asOwner.GetString(3066,
             ResourceConstants.PORTALADMINMSGS), _model.GetBestBetSearchString());
            HTMLSpan span = new HTMLSpan();
            span.SetStyleClass(PTStyleClass.ALERT_ERROR_TITLE);
            span.AddInnerHTMLString(strMessage);
            myCell.AddInnerHTMLElement(span);
            myCell.AddInnerHTMLElement(new HTMLBr());
            myCell.AddInnerHTMLString(m_asOwner.GetString(2402, "ptmsgs_portaladminmsgs"));
            } else
          {
            /*
             * <table width="100%" border="0" cellspacing="0" cellpadding="5" summary="summaryFoo">
             <tr>
             <td width="100%" class="ObjectText"><span class="alertErrorTitle">No
             Best Bets have been created.</span><br>
             To create a Best Bet, click <span class="alertTitle">New Best
             Bet</span></td>
             </tr>
             </table>
             
             */
             
            HTMLSpan span = new HTMLSpan();
            span.SetStyleClass(PTStyleClass.ALERT_ERROR_TITLE);
            span.AddInnerHTMLString(m_asOwner.GetString(2401, "ptmsgs_portaladminmsgs"));
            myCell.AddInnerHTMLElement(span);
            myCell.AddInnerHTMLElement(new HTMLBr());
            myCell.AddInnerHTMLString(m_asOwner.GetString(2402, "ptmsgs_portaladminmsgs"));
            }
        }
        result0.AddInnerHTMLElement(new HTMLBr());
        result0.AddInnerHTMLElement(new HTMLBr());
        /*	}
         else
         {
         span = new HTMLSpan();
         span.SetStyleClass(PTStyleClass.LIST_TEXT);
         
         span.AddInnerHTMLString(m_asOwner.GetString(143,
         "ptmsgs_portalcommonmsgs"));
         result.AddInnerHTMLElement(span);
         }
         */
         
        HTMLComment myComment = new HTMLComment("End: Display BestBetsListMainView");
        result0.AddInnerHTMLElement(myComment);
        return result0;
      }
      catch (Exception e)
      {
        log.Error(e, "Exception in BestBetsListView.Display.");
        throw XPException.GetInstance(e);
      }
    }
    
    /// <summary>
    /// Returns Java Script for editBB function.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    /// <returns>HTMLScript</returns>
    public override HTMLScript DisplayJavascript()
    {
      HTMLScript script;
      try
      {
        XPStringBuilder sb = new XPStringBuilder(400);
        script = new HTMLScript("text/javaScript");
        sb.Append("function editBB(varSubSpaceURL, varSubSpaceKey) {\n");
        sb.Append("  window.open(varSubSpaceURL, \'PopUpEditMode\' + varSubSpaceKey, \'location=no,menubar=no,scrollbars,height=700,width=750\');\n");
        sb.Append("}\n");
        sb.Append("\n\nfunction paginate(varStartNum) {\n");
        sb.Append("document.mainform." + SearchServerTuningEditorRepostControl.HTMLINPUT_FIRST_BEST_BET_TO_SHOW + ".value = varStartNum;\n");
        sb.Append("document.mainform.in_hi_PostToSelf.value= " + SearchServerTuningEditorRepostControl.POSTTOSELF_ACTION_BB_PAGINATE + ";\n");
        sb.Append("document.mainform.submit();\n");
        sb.Append("}\n");
        sb.Append("\n\nfunction DoToggleAllCBs() {\n");
        sb.Append("    var fElem = document.mainform;\n");
        sb.Append("    var feLen = fElem.elements.length;\n");
        sb.Append("    var checkVal = false;\n");
        sb.Append("    for (var i = 0; i < feLen; i++) {\n");
        sb.Append("        if (fElem.elements[i].name == \'" + DEL_ALL_CB + "\') {\n");
        sb.Append("            checkVal = fElem.elements[i].checked;\n");
        sb.Append("        }\n");
        sb.Append("    }\n");
        sb.Append("    for (var i = 0; i < feLen; i++) {\n");
        sb.Append("        if (fElem.elements[i].name == \'" + SearchServerTuningEditorRepostControl.HTMLINPUT_SELECTED_ITEM + "\') {\n");
        sb.Append("             fElem.elements[i].checked = checkVal;\n");
        sb.Append("        }\n");
        sb.Append("    }\n");
        sb.Append("    return true;\n");
        sb.Append("}\n");
        sb.Append("\n\nfunction maxCreated() {\n");
        sb.Append("    alert(\'" + m_asOwner.GetString(143, "ptmsgs_portalcommonmsgs") + "\');\n");
        sb.Append("}\n");
        sb.Append("\n\nfunction DeleteBestBets() {\n");
        sb.Append("    var fElem = document.mainform;\n");
        sb.Append("    var feLen = fElem.elements.length;\n");
        sb.Append("    var bCanDelete = false;\n");
        sb.Append("    for (var i = 0; i < feLen; i++) {\n");
        sb.Append("        if (fElem.elements[i].name == \'" + SearchServerTuningEditorRepostControl.HTMLINPUT_SELECTED_ITEM + "\') {\n");
        sb.Append("             if(fElem.elements[i].checked) bCanDelete = true;\n");
        sb.Append("        }\n");
        sb.Append("    }\n");
        sb.Append("    if(bCanDelete) {\n");
        sb.Append("        postToSelf(" + SearchServerTuningEditorRepostControl.POSTTOSELF_ACTION_BB_DELETE + ");\n");
        sb.Append("        return true;\n");
        sb.Append("    }\n");
        sb.Append("    else\n");
        sb.Append("    {\n");
        sb.Append("        alert(\'" + m_asOwner.GetString(2577, ResourceConstants.PORTALADMINMSGS) + "\');\n");
        sb.Append("        return false;\n");
        sb.Append("    }\n");
        sb.Append("}\n");
        script.AddInnerHTMLString(sb.ToString());
      }
      catch (Exception e)
      {
        log.Error(e, "BestBetsListView::DisplayJavascript An error occured when trying to display the JavaScript.");
        throw XPException.GetInstance(e);
      }
      return script;
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    protected virtual HTMLImg GetImage(PTImageType imageType, String altText,
     String width, String height)
    {
      PTConstruct iconButton = null;
      try
      {
        iconButton = UIConstructFactory.GetConstruct(imageType, true, this.m_asOwner);
        }
      catch (Exception e)
      {
      }
      //PTDebug.Trace message here.
      if (null != iconButton)
      {
        HTMLImg buttonImg = (HTMLImg) iconButton.GetHTMLElement();
        buttonImg.SetAlt(altText);
        buttonImg.SetWidth(width);
        buttonImg.SetHeight(height);
        return buttonImg;
      }
      return null;
    }
  }
}