using System;
using com.plumtree.uiinfrastructure.editor;
using IXPList=com.plumtree.openfoundation.util.IXPList;
namespace com.plumtree.portalpages.admin.serversettings.search
{
  /// <author>MatthewF</author>
  public interface ISearchServerTuningEditorModelRO : IEditorModelRO
  {
    /* Best bet related view elements */
    bool GetIsShowAllBestBets();
    String GetBestBetSearchString();
    int GetNumBestBetsAskedFor();
    int GetNumBestBetsOnPage();
    int GetBestBetStartCount();
    bool GetShowPreviousBestBet();
    bool GetShowNextBestBet();
    int GetTotalBestBetCount();
    int GetNumDeletedBestBets();
    int GetNumAddedBestBets();
    bool CheckDuplicateBestBetQuery(String originalTrigger, String strTrigger,
     bool bNewlyAdded);
    // This isn't a read only call!
    /* IPTBestBetTarget */
    void UpdateBestBetFromSubEditor(String originalTrigger, bool bModifiedBBWasFromDB,
     String strTrigger, String setup, IXPList arrTargets);
    String GetBestBetTrigger(int i);
    String GetBestBetSetupString(int i);
    // This used to be 3 calls to get id, target & name.
    IXPList GetBestBetTargets(int i);
    bool HasBestBetBeenDeleted(int i);
    bool HasBestBetBeenNewlyAdded(int i);
    /* Alias related view elements */
    
    /// <returns>set of AliasElement objects defining terms of banner field alias.</returns>
    Object[] GetCurrentAliasElements();
    
    /// <summary>
    /// Returns true if a sufficient number of terms (1) would be left after the delete.
    /// </summary>
    /// <param name="number">of terms to delete</param>
    /// <returns></returns>
    bool OkToDeleteThisManyAliasTerms(int number);
    
    /// <summary>
    /// Restore banner search field alias to default value.
    /// </summary>
    void RestoreDefaultFieldAlias();
    
    /// <returns>true if thesaurus usage is on.</returns>
    bool GetThesaurusOn();
    
    /// <summary>
    /// Set thesaurus usage on if tf is true.
    /// </summary>
    /// <param name="tf"></param>
    void SetThesaurusOn(bool tf);
    
    /// <returns>true if spell checking is on.</returns>
    bool GetSpellCheckOn();
    
    /// <summary>
    /// Set spell checking on if tf is true.
    /// </summary>
    /// <param name="tf"></param>
    void SetSpellCheckOn(bool tf);
  }
}