using System;
using IXPPropertyBag=com.plumtree.openfoundation.util.IXPPropertyBag;
namespace com.plumtree.portalpages.admin.serversettings.search
{
  public class NodeInfo
  {
    internal String address;
    internal String name;
    internal String port;
    internal String partition;
    internal String indexState;
    internal String searchState;
    internal String docsetTID;
    internal String lexiconTID;
    public NodeInfo(IXPPropertyBag bag)
    {
      address = bag.ReadAsString("ADDRESS");
      name = bag.ReadAsString("NAME");
      port = bag.ReadAsString("PORT");
      partition = bag.ReadAsString("PARTITION");
      indexState = bag.ReadAsString("INDEX_STATE");
      searchState = bag.ReadAsString("STATE");
      docsetTID = bag.ReadAsString("DOCSET_TID");
      lexiconTID = bag.ReadAsString("LEXICON_TID");
    }
    
    /// <returns>Returns the address.</returns>
    public virtual String getAddress()
    {
      return this.address;
    }
    
    /// <returns>Returns the docsetTID.</returns>
    public virtual String getDocsetTID()
    {
      return this.docsetTID;
    }
    
    /// <returns>Returns the indexState.</returns>
    public virtual String getIndexState()
    {
      return this.indexState;
    }
    
    /// <returns>Returns the lexiconTID.</returns>
    public virtual String getLexiconTID()
    {
      return this.lexiconTID;
    }
    
    /// <returns>Returns the name.</returns>
    public virtual String getName()
    {
      return this.name;
    }
    
    /// <returns>Returns the partition.</returns>
    public virtual String getPartition()
    {
      return this.partition;
    }
    
    /// <returns>Returns the port.</returns>
    public virtual String getPort()
    {
      return this.port;
    }
    
    /// <returns>Returns the searchState.</returns>
    public virtual String getSearchState()
    {
      return this.searchState;
    }
  }
}