using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.admin.serversettings.search
{
  /// <author>OlegS</author>
  public class SearchServerSettingsEditorRepostControl : EditorRepostControl
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.serversettings.search.SearchServerSettingsEditorRepostControl");
    public const String STR_MVC_CLASS_NAME = "SearchServerSettingsEditorRepost";
    public const int POSTTOSELF_ACTION_MISC = 10;
    public const int POSTTOSELF_ACTION_IS_DEL_ROWS = 41;
    public const int POSTTOSELF_ACTION_IS_ADD_TYPE = 61;
    public const int POSTTOSELF_ACTION_OPEN_POPUP = 71;
    // HTML object names.
    public const String HTMLINPUT_ADD = "in_bu_add";
    public const String HTMLINPUT_DELETE = "in_bu_delete";
    public const String HTMLINPUT_SELECTED_ITEM = "in_cb_selected";
    public const String HTMLINPUT_IS_SELECTED_ITEM = "in_cb_is_selected";
    public const String HTMLINPUT_HIDDEN_SELECTED_ITEM = "in_hi_selected";
    private const String TRUE = "true";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SearchServerSettingsEditorRepostControl();
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <param name="_nAction"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      switch (_nAction){
      case POSTTOSELF_ACTION_APPLY_CHANGES:
      ((SearchServerSettingsEditorModel) m_model).DoApplyChanges();
      break;
      case POSTTOSELF_ACTION_MISC:
      ((SearchServerSettingsEditorModel) m_model).ActionOnRepost();
      break;
      case POSTTOSELF_ACTION_IS_ADD_TYPE:
      if (m_htFormData.ContainsKey(IndexingStatusPopUpView.CHECKBOX_ADD_ALL) && IsTrue((String[]) m_htFormData.GetElement(IndexingStatusPopUpView.CHECKBOX_ADD_ALL)))
      {
        ((SearchServerSettingsEditorModel) m_model).AddAllUnusedISTypes();
        } else
      if (m_htFormData.ContainsKey(IndexingStatusPopUpView.SELECT_NAME))
      {
        String[] item = (String[]) m_htFormData.GetElement(IndexingStatusPopUpView.SELECT_NAME);
        for (int j = 0;j < item.Length;j++)
        {
          int itemId = -1;
          try
          {
            itemId = XPConvert.ToInteger(item[j]);
          }
          catch (Exception e)
          {
            throw XPException.GetInstance(e);
          }
          if (itemId >= 0)
          {
            log.Error("Got POSTTOSELF_ACTION_IS_ADD_TYPE : " + itemId);
            ((SearchServerSettingsEditorModel) m_model).AddTypeToIndexingStatus(itemId);
            }
        }
      }
      break;
      case POSTTOSELF_ACTION_IS_DEL_ROWS:
      if (m_htFormData.ContainsKey(IndexingStatusView.CB_CHECK_ONE))
      {
        String[] item = (String[]) m_htFormData.GetElement(IndexingStatusView.CB_CHECK_ONE);
        for (int j = 0;j < item.Length;j++)
        {
          int itemId = -1;
          try
          {
            itemId = XPConvert.ToInteger(item[j]);
          }
          catch (Exception e)
          {
            throw XPException.GetInstance(e);
          }
          if (itemId >= 0)
          {
            ((SearchServerSettingsEditorModel) m_model).DeleteTypeFromIndexingStatus(itemId);
            }
        }
      }
      break;
      default:
      break;
      }
    }
    protected virtual bool IsTrue(String[] vals)
    {
      if (vals == null)
      {
        return false;
      }
      for (int i = 0;i < vals.Length;i++)
      {
        if (TRUE.Equals(vals[i]))
        {
          return true;
        }
      }
      return false;
    }
  }
}