using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.pagecontrols.jsdatetimepicker;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.admin.serversettings.search
{
  /// <author>OlegS</author>
  public class SearchServerSettingsEditorView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.admin.serversettings.search.SearchServerSettingsEditorView");
    public const String SEARCH_MSG_BUNDLE = "ptmsgs_searchAdminUI";
    public const String COMMON_MSG_BUNDLE = "ptmsgs_portalcommonmsgs";
    public const String STR_MVC_CLASS_NAME = "SearchServerSettingsEditor";
    // HTML Object names.
    public const String HTMLINPUT_IndexingHostName = "in_tx_IndexingHostName";
    public const String HTMLINPUT_IndexingPortNumber = "in_tx_IndexingPortNumber";
    public const String HTMLINPUT_QueryHostName = "in_tx_QueryHostName";
    public const String HTMLINPUT_QueryPortNumber = "in_tx_QueryPortNumber";
    public const String HTMLINPUT_FailoverHostName = "in_tx_FailoverHostName";
    public const String HTMLINPUT_FailoverPortNumber = "in_tx_FailoverPortNumber";
    public const String HTMLINPUT_MaxTermsForKeywordHighlighting = "in_tx_MaxTermsForKeywordHighlighting";
    public const String HTMLINPUT_MaxCharsPerDocument = "in_tx_MaxCharsPerDocument";
    public const String HTMLINPUT_NumCardsPerBulkImport = "in_tx_NumCardsPerBulkImport";
    public const String HTMLINPUT_FileSizePerBulkImport = "in_tx_FileSizePerBulkImport";
    public const String HTMLINPUT_NextRepairDatePicker = "in_tx_NextRepairDatePicker";
    public const String HTMLINPUT_NumberOfDaysBetweenRepair = "in_tx_NumberOfDaysBetweenRepair";
    public const String HTMLBUTTON_OPENPOPUP = "in_bu_open";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SearchServerSettingsEditorView();
    }
    
    /// <returns></returns>
    public override HTMLElement Display()
    {
      try
      {
        HTMLElementCollection result = new HTMLElementCollection();
        HTMLComment myComment = new HTMLComment("Begin: Display SearchServerSettingsEditorMainView");
        result.AddInnerHTMLElement(myComment);
        DisplayObjectHeader(result, m_asOwner.GetString(168, "ptmsgs_portalcommonmsgs"));
        DisplayHosts(result);
        DisplayBreak(result);
        DisplayObjectHeader(result, m_asOwner.GetString(169, "ptmsgs_portalcommonmsgs"));
        DisplayAdvanced(result);
        DisplayBreak(result);
        DisplayObjectHeader(result, m_asOwner.GetString(170, "ptmsgs_portalcommonmsgs"));
        DisplayMaintenance(result);
        DisplayBreak(result);
        DisplayObjectHeader(result, m_asOwner.GetString(171, "ptmsgs_portalcommonmsgs"));
        DisplayStatus(result);
        DisplayBreak(result);
        myComment = new HTMLComment("End: Display SearchServerSettingsEditorMainView");
        result.AddInnerHTMLElement(myComment);
        return result;
      }
      catch (Exception e)
      {
        log.Error(e, "SearchServerSettingsEditorView::Display An error occured when trying to display the HTML.");
        throw new XPException(m_asOwner.GetString(167, "ptmsgs_portalcommonmsgs"),
         e);
      }
    }
    
    /// <returns></returns>
    public override HTMLScript DisplayJavascript()
    {
      HTMLScript myScript = new HTMLScript("text/javaScript");
      // The URL to open the pop-up
      ASURL myPopUp = new ASURL(m_asOwner);
      myPopUp.SetLinkGetCachedSpace(m_asOwner);
      myPopUp.SetDisplayPage(SearchServerSettingsPopUpDP.STR_MVC_CLASS_NAME);
      // Add the following 2 lines only if you need to have an "on open pop-up" action
      // The code to execute when the pop-up gets opened should go in Misc2RepostControl under "case POSTTOSELF_ACTION_OPEN_POPUP"
      myPopUp.SetControl(SearchServerSettingsEditorRepostControl.STR_MVC_CLASS_NAME);
      myPopUp.AddControlArgument(EditorRepostControl.HTMLINPUT_POSTTOSELF,
       XPConvert.ToString(SearchServerSettingsEditorRepostControl.POSTTOSELF_ACTION_OPEN_POPUP));
      XPStringBuilder sb;
      try
      {
        // Open Pop Up function
        sb = new XPStringBuilder(200);
        sb.Append("function OpenPopUp()\n");
        sb.Append("{\n");
        sb.Append("    window.open(\'").Append(myPopUp.GetURLAsString()).Append("\', \'_blank3\', \'location=no,menubar=no,scrollbars=yes,height=400,width=600\');\n");
        sb.Append("}\n");
        myScript.AddInnerHTMLString(sb.ToString());
      }
      catch (HTMLException he)
      {
        log.Error(he, "SearchServerSettingsEditorMainView::DisplayJavascript The following error occured when trying to display the JavaScript: " + he.Message);
        }
      return myScript;
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    protected virtual SearchServerSettingsEditorModel GetModel()
    {
      return (SearchServerSettingsEditorModel) m_model;
    }
    
    /// <param name="result"></param>
    /// <throws>HTMLException </throws>
    protected virtual void DisplayAdvanced(HTMLElementCollection result)
    {
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLInput myInput;
      HTMLComment myComment = new HTMLComment("Begin: DisplayAdvanced SearchServerSettingsEditorMainView");
      result.AddInnerHTMLElement(myComment);
      String[] label = new String[]{m_asOwner.GetString(756, "ptmsgs_portalcommonmsgs"),
       m_asOwner.GetString(164, "ptmsgs_portalcommonmsgs"), m_asOwner.GetString(165,
       "ptmsgs_portalcommonmsgs"), m_asOwner.GetString(166, "ptmsgs_portalcommonmsgs")};
      String[] input = new String[]{HTMLINPUT_MaxTermsForKeywordHighlighting,
       HTMLINPUT_MaxCharsPerDocument, HTMLINPUT_NumCardsPerBulkImport, HTMLINPUT_FileSizePerBulkImport};
      String[] value = new String[]{GetModel().GetMaxTermsForKeywordHighlighting(),
       GetModel().GetMaxCharsPerDocument(), GetModel().GetNumCardsPerBulkImport(),
       GetModel().GetFileSizePerBulkImport()};
      myTable = new HTMLTable();
      result.AddInnerHTMLElement(myTable);
      myTable.SetWidth("100%");
      myTable.SetBorder("0");
      myTable.SetCellPadding("5");
      myTable.SetCellSpacing("0");
      for (int i = 0;i < label.Length;i++)
      {
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myRow.AddInnerHTMLElement(myCell);
        HTMLB bold = new HTMLB();
        myCell.AddInnerHTMLElement(bold);
        myCell.SetNoWrap(true);
        bold.AddInnerHTMLString(XPHttpUtility.HtmlEncode(label[i]));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myInput = new HTMLInput(HTMLInputTypes.TEXT, input[i], "");
        myCell.AddInnerHTMLElement(myInput);
        myCell.SetNoWrap(true);
        myCell.SetWidth("55%");
        myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
        myInput.SetValue(value[i]);
        myInput.SetMaxLength(7);
        myInput.SetSize(11);
      }
      myComment = new HTMLComment("End: DisplayAdvanced SearchServerSettingsEditorMainView");
      result.AddInnerHTMLElement(myComment);
    }
    
    /// <param name="result"></param>
    /// <throws>HTMLException </throws>
    protected virtual void DisplayBreak(HTMLElementCollection result)
    {
      result.AddInnerHTMLElement(new HTMLBr());
    }
    
    /// <param name="result"></param>
    /// <throws>HTMLException </throws>
    protected virtual void DisplayHosts(HTMLElementCollection result)
    {
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLInput myInput;
      HTMLComment myComment = new HTMLComment("Begin: DisplayHosts SearchServerSettingsEditorMainView");
      result.AddInnerHTMLElement(myComment);
      String[] label = new String[]{m_asOwner.GetString(0, SEARCH_MSG_BUNDLE)};
      //				m_asOwner.GetString(158, "ptmsgs_portalcommonmsgs"),
      //				m_asOwner.GetString(159, "ptmsgs_portalcommonmsgs")
      String[] ihost = new String[]{HTMLINPUT_IndexingHostName};
      //              HTMLINPUT_QueryHostName,
      //				HTMLINPUT_FailoverHostName
      String[] iport = new String[]{HTMLINPUT_IndexingPortNumber, HTMLINPUT_QueryPortNumber,
       HTMLINPUT_FailoverPortNumber};
      String[] vhost = new String[]{GetModel().GetIndexingHost()};
      //              GetModel().GetQueryHost(),
      //				GetModel().GetFailoverHost()
      String[] vport = new String[]{GetModel().GetIndexingPort()};
      //              GetModel().GetQueryPort(),
      //				GetModel().GetFailoverPort()
      myTable = new HTMLTable();
      result.AddInnerHTMLElement(myTable);
      myTable.SetWidth("100%");
      myTable.SetBorder("0");
      myTable.SetCellPadding("5");
      myTable.SetCellSpacing("0");
      for (int i = 0;i < label.Length;i++)
      {
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.SetNoWrap(true);
        HTMLB bold = new HTMLB();
        myCell.AddInnerHTMLElement(bold);
        bold.AddInnerHTMLString(XPHttpUtility.HtmlEncode(label[i]));
        myCell = new HTMLTableCell();
        myCell.SetNoWrap(true);
        myCell.SetWidth("35%");
        myRow.AddInnerHTMLElement(myCell);
        myInput = new HTMLInput(HTMLInputTypes.TEXT, ihost[i], "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
        myInput.SetValue(vhost[i]);
        myCell = new HTMLTableCell();
        myCell.SetNoWrap(true);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myRow.AddInnerHTMLElement(myCell);
        bold = new HTMLB();
        myCell.AddInnerHTMLElement(bold);
        bold.AddInnerHTMLString(m_asOwner.GetString(157, "ptmsgs_portalcommonmsgs"));
        myCell = new HTMLTableCell();
        myCell.SetNoWrap(true);
        myCell.SetWidth("35%");
        myRow.AddInnerHTMLElement(myCell);
        myInput = new HTMLInput(HTMLInputTypes.TEXT, iport[i], "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
        myInput.SetValue(vport[i]);
        myInput.SetMaxLength(5);
        myInput.SetSize(6);
      }
      myComment = new HTMLComment("End: DisplayHosts SearchServerSettingsEditorMainView");
      result.AddInnerHTMLElement(myComment);
    }
    
    /// <param name="result"></param>
    /// <throws>HTMLException </throws>
    protected virtual void DisplayMaintenance(HTMLElementCollection result)
    {
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLInput myInput;
      HTMLComment myComment = new HTMLComment("Begin: DisplayMaintenance SearchServerSettingsEditorMainView");
      result.AddInnerHTMLElement(myComment);
      //		String[] label=new String[]{getModel()._ui_MaxTermsForKeywordHighlighting,getModel()._ui_MaxCharsPerDocument,getModel()._ui_NumCardsPerBulkImport,getModel()._ui_FileSizePerBulkImport};
      //		String[] input=new String[]{HTMLINPUT_MaxTermsForKeywordHighlighting,HTMLINPUT_MaxCharsPerDocument,HTMLINPUT_NumCardsPerBulkImport,HTMLINPUT_FileSizePerBulkImport};
      //		String[] value=new String[]{getModel().getMaxTermsForKeywordHighlighting(),getModel().getMaxCharsPerDocument(),getModel().getNumCardsPerBulkImport(),getModel().getFileSizePerBulkImport()};
      myTable = new HTMLTable();
      result.AddInnerHTMLElement(myTable);
      myTable.SetBorder("0");
      myTable.SetWidth("100%");
      myTable.SetCellPadding("5");
      myTable.SetCellSpacing("0");
      //
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
      myCell = new HTMLTableCell();
      myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
      myRow.AddInnerHTMLElement(myCell);
      HTMLB bold = new HTMLB();
      myCell.AddInnerHTMLElement(bold);
      myCell.SetNoWrap(true);
      bold.AddInnerHTMLString(m_asOwner.GetString(160, "ptmsgs_portalcommonmsgs"));
      myCell = new HTMLTableCell();
      myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
      myRow.AddInnerHTMLElement(myCell);
      ISearchServerSettingsEditorModelRO model = ((ISearchServerSettingsEditorModelRO) m_model);
      JSDateTimePickerMgr ptDateTimePickerMgr = model.GetDateTimePickerControlManager();
      HTMLElement e = ptDateTimePickerMgr.GetComponentHTML(SearchServerSettingsEditorModel.DateTimePickerKey);
      myCell.AddInnerHTMLElement(e);
      myCell.SetWidth("70%");
      //
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
      myCell = new HTMLTableCell();
      myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
      myRow.AddInnerHTMLElement(myCell);
      bold = new HTMLB();
      myCell.AddInnerHTMLElement(bold);
      bold.AddInnerHTMLString(m_asOwner.GetString(162, "ptmsgs_portalcommonmsgs"));
      myCell.SetNoWrap(true);
      myCell = new HTMLTableCell();
      myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
      myRow.AddInnerHTMLElement(myCell);
      myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_NumberOfDaysBetweenRepair,
       "");
      myCell.AddInnerHTMLElement(myInput);
      myCell.SetWidth("70%");
      myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
      myInput.SetValue(GetModel().GetNumberOfDaysBetweenRepair());
      myInput.SetSize(8);
      myComment = new HTMLComment("End: DisplayMaintenance SearchServerSettingsEditorMainView");
      result.AddInnerHTMLElement(myComment);
    }
    
    /// <param name="result"></param>
    /// <param name="name"></param>
    /// <throws>HTMLException </throws>
    protected virtual void DisplayObjectHeader(HTMLElementCollection result,
     String name)
    {
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLSpan mySpan;
      HTMLComment myComment = new HTMLComment("Begin: DisplayObjectHeader SearchServerSettingsEditorMainView");
      result.AddInnerHTMLElement(myComment);
      myTable = new HTMLTable();
      result.AddInnerHTMLElement(myTable);
      myTable.SetWidth("100%");
      myTable.SetBorder("0");
      myTable.SetCellPadding("0");
      myTable.SetCellSpacing("0");
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myRow.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetWidth("100%");
      myCell.SetHeight("20");
      myCell.SetVAlign("center");
      myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
      mySpan = new HTMLSpan();
      myCell.AddInnerHTMLElement(mySpan);
      mySpan.SetStyleClass(PTStyleClass.OBJECT_HEADER);
      mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(name));
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetWidth("10");
      myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      myComment = new HTMLComment("End: DisplayObjectHeader SearchServerSettingsEditorMainView");
      result.AddInnerHTMLElement(myComment);
    }
    
    /// <param name="result"></param>
    /// <throws>HTMLException </throws>
    protected virtual void DisplayStatus(HTMLElementCollection result)
    {
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLInput myInput;
      HTMLComment myComment = new HTMLComment("Begin: DisplayStatus SearchServerSettingsEditorMainView");
      result.AddInnerHTMLElement(myComment);
      //DisplayBreak(result);
      myTable = new HTMLTable();
      result.AddInnerHTMLElement(myTable);
      myTable.SetWidth("100%");
      myTable.SetBorder("0");
      myTable.SetCellPadding("5");
      myTable.SetCellSpacing("0");
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
      myCell = new HTMLTableCell();
      myCell.SetHeight("40");
      myCell.SetVAlign("middle");
      myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
      myRow.AddInnerHTMLElement(myCell);
      myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_OPENPOPUP,
       "");
      myCell.AddInnerHTMLElement(myInput);
      myInput.SetValue(m_asOwner.GetString(172, "ptmsgs_portalcommonmsgs"));
      myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
      // Disable the button if there are errors.
      if (((SearchServerSettingsEditorModel) m_model).GetErrorString().GetLength() > 0)
      {
        myInput.SetDisabled(true);
      }
      // mj: removed 'Javascript:' from function name
      myInput.SetOnClick("OpenPopUp();");
      myComment = new HTMLComment("End: DisplayStatus SearchServerSettingsEditorMainView");
      result.AddInnerHTMLElement(myComment);
    }
  }
}
// Strings to localize.
