using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.portalpages.admin.serversettings;
using com.plumtree.portalpages.admin.serversettings.auditmanager;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.web;
namespace com.plumtree.portalpages.admin.serversettings.settings
{
  /// <author>ErickS</author>
  public class AuditManagerServerSetting : IServerSettings
  {
    
    /// <returns></returns>
    public virtual String GetASControlName()
    {
      return EditorStartControl.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASDPName()
    {
      return null;
    }
    // Strings to localize.
    
    /// <summary>
    /// Return the name of the Editor framework activity space
    /// for this settings class.
    /// </summary>
    public virtual String GetASName()
    {
      return AuditManagerEditorAS.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASQueryString()
    {
      return "&" + EditorStartControl.QS_EDITOR_TYPE + "=" + EditorStartControl.EDITOR_START_FLAG_MISC;
      }
    
    /// <param name="_strLangID"></param>
    /// <returns></returns>
    public virtual String GetLinkText(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      //_ui_LinkText
      return rm.GetString(1637, "ptmsgs_portaladminmsgs", _strLangID);
    }
    
    /// <returns></returns>
    public virtual String GetLinkURL()
    {
      return null;
    }
    
    /// <returns></returns>
    public virtual bool IsStandardPortalOption()
    {
      return true;
    }
    
    /// <returns></returns>
    public virtual bool IsViewable()
    {
      return true;
    }
  }
}