using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.portalpages.admin.editors.doctypemap;
using com.plumtree.portalpages.admin.serversettings;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.web;
namespace com.plumtree.portalpages.admin.serversettings.settings
{
  /// <author>
  /// SudhaS
  /// This class causes the Localized Strings link to show up in the
  /// Plumtree Utilities menu.
  /// </author>
  public class GbDocTypeMapServerSetting : IServerSettings
  {
    
    /// <returns></returns>
    public virtual String GetASControlName()
    {
      return EditorStartControl.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASDPName()
    {
      //return GbDocTypeMainDP.STR_MVC_CLASS_NAME;
      return null;
    }
    
    /// <returns></returns>
    public virtual String GetASName()
    {
      return GbDocTypeEditorAS.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASQueryString()
    {
      String strControl = "&" + EditorStartControl.QS_EDITOR_TYPE + "=" + EditorStartControl.EDITOR_START_FLAG_MISC;
      String strObjectID = "&globalObjectID=1";
      String strQuery = strControl + strObjectID;
      return strQuery;
    }
    //@todo add class name to Plumtree Utilities XML file
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#GetLinkText()"></seealso>
    public virtual String GetLinkText(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      return rm.GetString(1602, "ptmsgs_portaladminmsgs", _strLangID);
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#IsStandardPortalOption()"></seealso>
    public virtual bool IsStandardPortalOption()
    {
      return true;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#IsViewable()"></seealso>
    public virtual bool IsViewable()
    {
      return true;
    }
  }
}