using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.admin.editors.propertymap;
using com.plumtree.portalpages.admin.serversettings;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.web;
namespace com.plumtree.portalpages.admin.serversettings.settings
{
  /// <version>5.0</version>
  /// <author>MikeSample</author>
  public class GbPropMapServerSetting : IServerSettings
  {
    
    /// <returns></returns>
    public virtual String GetASControlName()
    {
      return EditorStartControl.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASDPName()
    {
      return null;
    }
    
    /// <returns></returns>
    public virtual String GetASName()
    {
      return PropertyMapEditorAS.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASQueryString()
    {
      String strQuery = "&" + EditorStartControl.QS_EDITOR_TYPE + "=" + EditorStartControl.EDITOR_START_FLAG_MISC;
      strQuery+=("&globalObjectID=" + XPConvert.ToString(PT_GLOBALOBJECTS.PT_GLOBAL_PROPERTYMAP));
      return strQuery;
    }
    //Return link text
    public virtual String GetLinkText(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      return (rm.GetString(2008, "ptmsgs_portaladminmsgs", _strLangID));
    }
    //Describes whether the setting comes with the standard portal
    public virtual bool IsStandardPortalOption()
    {
      return (true);
    }
    //Describes whether the setting is currently viewable
    public virtual bool IsViewable()
    {
      return (true);
    }
  }
}
//public HTMLElement GetHTMLElement();
