using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.portalpages.admin.serversettings;
using com.plumtree.portalpages.admin.serversettings.globalaclsyncmap;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.web;
namespace com.plumtree.portalpages.admin.serversettings.settings
{
  /// <summary>
  /// The user lock manager is used to remove locks on users that have been left in
  /// place due to a system error or a security violation.
  /// </summary>
  /// <version>5.0</version>
  /// <author>JohnH</author>
  public class GlobalACLSyncMapServerSetting : IServerSettings
  {
    
    /// <returns></returns>
    public virtual String GetASControlName()
    {
      return EditorStartControl.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASDPName()
    {
      return null;
    }
    
    /// <returns></returns>
    public virtual String GetASName()
    {
      return GlobalACLSyncMapAS.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASQueryString()
    {
      String strQuery = "&" + EditorStartControl.QS_EDITOR_TYPE + "=" + EditorStartControl.EDITOR_START_FLAG_MISC;
      return strQuery;
    }
    //Return link text
    public virtual String GetLinkText(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      return (rm.GetString(1547, "ptmsgs_portaladminmsgs", _strLangID));
    }
    //Describes whether the setting comes with the standard portal
    public virtual bool IsStandardPortalOption()
    {
      return (true);
    }
    //Describes whether the setting is currently viewable
    public virtual bool IsViewable()
    {
      return (true);
    }
  }
}