using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.admin.serversettings;
using com.plumtree.portalpages.admin.serversettings.objectpropertymap;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.web;
namespace com.plumtree.portalpages.admin.serversettings.settings
{
  /// <author>josephc</author>
  public class ObjPropMapServerSetting : IServerSettings
  {
    
    /// <returns></returns>
    public virtual String GetASControlName()
    {
      return EditorStartControl.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASDPName()
    {
      return ObjPropMapDP.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASName()
    {
      return ObjPropMapEditorAS.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASQueryString()
    {
      XPStringBuilder sb = new XPStringBuilder(100);
      sb.Append("&").Append(EditorStartControl.QS_EDITOR_TYPE).Append("=").Append(EditorStartControl.EDITOR_START_FLAG_MISC);
      return sb.ToString();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#GetLinkText()"></seealso>
    public virtual String GetLinkText(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      return rm.GetString(542, "ptmsgs_portaladminmsgs", _strLangID);
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#IsStandardPortalOption()"></seealso>
    public virtual bool IsStandardPortalOption()
    {
      return true;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#IsViewable()"></seealso>
    public virtual bool IsViewable()
    {
      return true;
    }
  }
}