using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.portalpages.admin.serversettings;
using com.plumtree.portalpages.admin.serversettings.search;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.web;
namespace com.plumtree.portalpages.admin.serversettings.settings
{
  /// <author>$author$</author>
  public class SearchServerSetting : IServerSettings
  {
    
    /// <returns></returns>
    public virtual String GetASControlName()
    {
      return "EditorStart";
    }
    
    /// <returns></returns>
    public virtual String GetASDPName()
    {
      return null;
    }
    
    /// <summary>
    /// Return the name of the Editor framework activity space
    /// for this settings class. The static variable holding the
    /// string name is:<p />
    /// com.plumtree.portalpages.common.search.serversettings.SearchServerSettingsEditorAS.STR_MVC_CLASS_NAME
    /// </summary>
    public virtual String GetASName()
    {
      return SearchServerSettingsEditorAS.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASQueryString()
    {
      return "&editorType=10";
    }
    
    /// <param name="_strLangID"></param>
    /// <returns></returns>
    public virtual String GetLinkText(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      //_ui_LinkText
      return rm.GetString(1638, "ptmsgs_portaladminmsgs", _strLangID);
    }
    
    /// <returns></returns>
    public virtual String GetLinkURL()
    {
      return null;
    }
    
    /// <returns></returns>
    public virtual bool IsStandardPortalOption()
    {
      return true;
    }
    
    /// <returns></returns>
    public virtual bool IsViewable()
    {
      return true;
    }
  }
}