using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.portalpages.admin.serversettings;
using com.plumtree.portalpages.common.constants;
using com.plumtree.portaluiinfrastructure.tags.manager.taglibmanager;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.web;
namespace com.plumtree.portalpages.admin.serversettings.settings
{
  /// <summary>
  /// Link to the Tag Library Manager page.
  /// </summary>
  /// <author>DonH</author>
  public class TagLibManagerServerSetting : IServerSettings
  {
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#GetASControlName()"></seealso>
    public virtual String GetASControlName()
    {
      return EditorStartControl.STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#GetASDPName()"></seealso>
    public virtual String GetASDPName()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#GetASName()"></seealso>
    public virtual String GetASName()
    {
      return TagLibManagerAS.STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#GetASQueryString()"></seealso>
    public virtual String GetASQueryString()
    {
      return "&" + EditorStartControl.QS_EDITOR_TYPE + "=" + EditorStartControl.EDITOR_START_FLAG_MISC;
      }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#GetLinkText(java.lang.String)"></seealso>
    public virtual String GetLinkText(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      // Tag Library Manager
      return rm.GetString(771, ResourceConstants.PORTALCOMMONMSGS, _strLangID);
      }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#IsStandardPortalOption()"></seealso>
    public virtual bool IsStandardPortalOption()
    {
      return true;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#IsViewable()"></seealso>
    public virtual bool IsViewable()
    {
      return true;
    }
  }
}