using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
namespace com.plumtree.portalpages.ajax
{
  /// <summary>
  /// Activity Space for all AJAX-related calls
  /// </summary>
  /// <author>MattC</author>
  public class AjaxAS : AFormAS
  {
    public const String STR_MVC_CLASS_NAME = "Ajax";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new AjaxAS();
    }
    
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(String,String,boolean)"></seealso>
    /// <returns>boolean</returns>
    public override bool CheckBasicAccess(String strPage, String strControl,
     bool bSameSpace)
    {
      return true;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.AActivitySpace#Init()"></seealso>
    public override void Init()
    {
      base.Init();
      RegisterModel(AjaxModel.STR_MVC_CLASS_NAME);
      RegisterPage(new AjaxDP());
      IModel myModel = GetModel(AjaxModel.STR_MVC_CLASS_NAME);
      RegisterView(AjaxView.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(AjaxControl.STR_MVC_CLASS_NAME, myModel);
    }
  }
}