using System;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.ajax
{
  /// <summary>
  /// This model contains data for both the Browse and Edit Modes of the
  /// Directory.
  /// </summary>
  /// <author>StephenC</author>
  public class AjaxModel : IModel
  {
    
    /// <summary>
    /// Activity space name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "Ajax";
    private AActivitySpace m_asOwner;
    private IPTSession m_ptSession;
    private int objectID = 0;
    private int classID = 0;
    private String oldName = "";
    private String newName = "";
    private int status = 0;
    private String message = "";
    public AjaxModel() : base()
    {
    }
    public virtual void Init(AActivitySpace parent)
    {
      m_asOwner = parent;
      m_ptSession = (IPTSession) m_asOwner.GetUserSession();
    }
    public virtual void CleanupAllData()
    {
    }
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    public virtual Object Create()
    {
      return new AjaxModel();
    }
    public virtual void CleanupTempData()
    {
    }
    /////////////////////////////////////////
    // Write methods for Model
    /////////////////////////////////////////
    public virtual void setObjectId(int newObjectId)
    {
      objectID = newObjectId;
    }
    public virtual void setClassId(int newClassId)
    {
      classID = newClassId;
    }
    public virtual void setOldName(String newOldName)
    {
      oldName = newOldName;
    }
    public virtual void setNewName(String newNewName)
    {
      newName = newNewName;
    }
    public virtual void setMessage(String newMessage, int newStatus)
    {
      message = newMessage;
      status = newStatus;
    }
    /////////////////////////////////////////
    // Read methods for Model
    /////////////////////////////////////////
    public virtual int getObjectId()
    {
      return objectID;
    }
    public virtual int getClassId()
    {
      return classID;
    }
    public virtual String getOldName()
    {
      return oldName;
    }
    public virtual String getNewName()
    {
      return newName;
    }
    public virtual int getStatus()
    {
      return status;
    }
    public virtual String getMessage()
    {
      return message;
    }
  }
}