using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.browsing.directory;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.browsing.directory.abodelete
{
  /// <author>MikeSample</author>
  public class DirCheckDeleteControl : IControl
  {
    
    /// <summary>
    /// object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "DirCheckDelete";
    
    /// <summary>
    /// Control argument names 
    /// </summary>
    public const String DELETEFOLDERS = "DeleteFolders";
    public const String OBJECTIDPAIRS = "ObjectIDPairs";
    
    /// <summary>
    /// internal data 
    /// </summary>
    private AActivitySpace m_asOwner;
    private DirModel m_asModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IControl#Execute()"></seealso>
    public virtual Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      Redirect result = new Redirect();
      result.SetLinkGetCachedSpace(m_asOwner);
      bool bFolders = false;
      String[] sValues = (String[]) arguments.GetElement(DELETEFOLDERS);
      if (sValues != null)
      {
        bFolders = XPConvert.ToBoolean(sValues[0]);
      }
      m_asModel.SetFoldersForDeleteCheck(bFolders);
      result.SetDisplayPage(DirDeleteWarningsDP.STR_MVC_CLASS_NAME);
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new DirCheckDeleteControl();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IControl#Init(IModel,AActivitySpace)"></seealso>
    public virtual void Init(IModel model, AActivitySpace space)
    {
      m_asModel = (DirModel) model;
      m_asOwner = space;
    }
  }
}/* */
