using System;
using com.plumtree.openlog;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.directory.browse_D
{
  /// <author>StephenC</author>
  public class DirCardPropertiesDP_D : PlumtreeDP
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.directory.browse_D.DirCardPropertiesDP_D");
    public const String STR_MVC_CLASS_NAME = "DirCardPropertiesDP_D";
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetSubtitleForBanner()"></seealso>
    public override String GetSubtitleForBanner()
    {
      return m_asOwner.GetString(46, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetTitleForBanner()"></seealso>
    public override String GetTitleForBanner()
    {
      return m_asOwner.GetString(45, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#Init(AActivitySpace)"></seealso>
    public override void Init(AActivitySpace parent)
    {
      base.Init(parent);
      SetAddMainForm(true);
    }
    
    /// <summary>
    /// helper display method for PlumtreeDP
    /// Fill in the body argument with HTML to display in the page.
    /// </summary>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection wholePageGroup = new HTMLElementCollection();
      try
      {
        wholePageGroup.AddInnerHTMLElement(m_asOwner.GetView(DirCardPropertiesView_D.STR_MVC_CLASS_NAME).Display());
        }
      catch (HTMLException he)
      {
        log.Error(he, "Error in DirCardPropertiesDP_D::Display: " + he.Message);
        }
      return wholePageGroup;
    }
  }
}