using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.directory;
using com.plumtree.portalpages.browsing.editors.dircommon;
using com.plumtree.portaluiinfrastructure.opener;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.directory.browse_D
{
  /// <author>StephenC</author>
  public class DirCardPropertiesView_D : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.directory.browse_D.DirCardPropertiesView_D");
    public const String STR_MVC_CLASS_NAME = "DirCardPropertiesView_D";
    private AActivitySpace m_asOwner;
    private IDirModelRO m_asModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new DirCardPropertiesView_D();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Display()"></seealso>
    public virtual HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLSpan mySpan;
      HTMLAnchor myAnchor;
      HTMLTable mainTable;
      HTMLTable sectionTable;
      HTMLTable innerTable;
      try
      {
        HTMLComment myComment = new HTMLComment("Begin: Display DirCardPropertiesView_D");
        result.AddInnerHTMLElement(myComment);
        mainTable = new HTMLTable();
        mainTable.SetBorder("0");
        mainTable.SetWidth("100%");
        mainTable.SetCellPadding("0");
        mainTable.SetCellSpacing("0");
        mainTable.SetSummary(m_asOwner.GetString(1176, "ptmsgs_portalbrowsingmsgs"));
        result.AddInnerHTMLElement(mainTable);
        // BEGIN Go Back Row
        myRow = new HTMLTableRow();
        mainTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myAnchor = new HTMLAnchor(HTMLConstructHelpers.GetPreviousSpaceURL(m_asOwner));
        myAnchor.AddInnerHTMLString(m_asOwner.GetString(47, "ptmsgs_portalbrowsingmsgs"));
        myAnchor.SetTitle(m_asOwner.GetString(47, "ptmsgs_portalbrowsingmsgs"));
        myCell.SetStyleClass(PTStyleClass.OBJECT_HEADER);
        myCell.AddInnerHTMLElement(myAnchor);
        // END Go Back Row
        // Add extra spacer row
        mainTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(1, 5));
        myRow = new HTMLTableRow();
        mainTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        sectionTable = new HTMLTable();
        sectionTable.SetBorder("0");
        sectionTable.SetWidth("100%");
        sectionTable.SetCellPadding("5");
        sectionTable.SetCellSpacing("0");
        sectionTable.SetSummary(m_asOwner.GetString(1175, "ptmsgs_portalbrowsingmsgs"));
        myCell.AddInnerHTMLElement(sectionTable);
        // BEGIN Banner
        myRow = new HTMLTableRow();
        sectionTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.DIR_HEADER_BG);
        // title
        String strCardName = m_asModel.GetCardName();
        String strTitle = m_asOwner.GetString(50, "ptmsgs_portalbrowsingmsgs") + XPHttpUtility.HtmlEncode(strCardName);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        myCell.SetHeight("30");
        mySpan.SetStyleClass(PTStyleClass.DIR_HEADER);
        mySpan.AddInnerHTMLString(strTitle);
        // END Banner
        // Add extra spacer row
        mainTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(1, 5));
        myRow = new HTMLTableRow();
        mainTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        sectionTable = new HTMLTable();
        sectionTable.SetBorder("0");
        sectionTable.SetWidth("100%");
        sectionTable.SetCellPadding("5");
        sectionTable.SetCellSpacing("0");
        sectionTable.SetSummary(m_asOwner.GetString(1177, "ptmsgs_portalbrowsingmsgs"));
        myCell.AddInnerHTMLElement(sectionTable);
        // BEGIN Title Text ROW
        myRow = new HTMLTableRow();
        sectionTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        // title
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(51, "ptmsgs_portalbrowsingmsgs"));
        // END Title Text ROW
        // Add extra spacer row
        mainTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(2, 5));
        myRow = new HTMLTableRow();
        mainTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        sectionTable = new HTMLTable();
        sectionTable.SetBorder("0");
        sectionTable.SetWidth("100%");
        sectionTable.SetCellPadding("0");
        sectionTable.SetCellSpacing("5");
        sectionTable.SetSummary(m_asOwner.GetString(1179, "ptmsgs_portalbrowsingmsgs"));
        myCell.AddInnerHTMLElement(sectionTable);
        myRow = new HTMLTableRow();
        sectionTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        innerTable = new HTMLTable();
        innerTable.SetBorder("0");
        innerTable.SetWidth("100%");
        innerTable.SetCellPadding("2");
        innerTable.SetCellSpacing("2");
        innerTable.SetSummary(m_asOwner.GetString(1178, "ptmsgs_portalbrowsingmsgs"));
        myCell.AddInnerHTMLElement(innerTable);
        /////////////////////////
        // Basic Card Properties
        // BEGIN Basic Card Header ROW
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);
        innerTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myCell.SetColSpan("2");
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(52, "ptmsgs_portalbrowsingmsgs"));
        // END Basic Card Header ROW
        // BEGIN Basic Column Headers ROW
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.LIST_SORT_HEADER_BG);
        innerTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(55, "ptmsgs_portalbrowsingmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(56, "ptmsgs_portalbrowsingmsgs"));
        // END Basic Column Headers ROW
        XPSortedDictionary xpBasicProperties = m_asModel.GetBasicCardProperties();
        XPSortedDictionary xpCustomProperties = m_asModel.GetCustomCardProperties();
        XPSortedDictionary xpCardInformation = m_asModel.GetCardInformation();
        IXPEnumerator xpEnum;
        CardPropertyObject cpo;
        CardStatisticObject cso;
        String strPropValue;
        String strPropName;
        bool bIsURL;
        xpEnum = xpBasicProperties.GetElements();
        bool bOdd = false;
        while (xpEnum.MoveNext())
        {
          cpo = (CardPropertyObject) xpEnum.GetCurrent();
          strPropName = cpo.m_sPropName;
          strPropValue = cpo.m_sPropValue;
          bIsURL = cpo.m_bIsURL;
          myRow = new HTMLTableRow();
          innerTable.AddInnerHTMLElement(myRow);
          myRow.SetStyleClass(bOdd ? PTStyleClass.LIST_ITEM_ONE_BG : PTStyleClass.LIST_ITEM_TWO_BG);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          mySpan = new HTMLSpan();
          myCell.AddInnerHTMLElement(mySpan);
          mySpan.SetStyleClass(PTStyleClass.LIST_SUBTITLE);
          mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strPropName));
          myCell = new HTMLTableCell();
          //						myCell.SetNoWrap(false);
          myRow.AddInnerHTMLElement(myCell);
          mySpan = new HTMLSpan();
          myCell.AddInnerHTMLElement(mySpan);
          mySpan.SetStyleClass(PTStyleClass.LIST_TEXT);
          if (bIsURL)
          {
            myAnchor = new HTMLAnchor(strPropValue);
            myAnchor.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strPropValue));
            myAnchor.SetTitle(XPHttpUtility.HtmlEncode(strPropValue));
            mySpan.AddInnerHTMLElement(myAnchor);
          } else
          {
            mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strPropValue));
            }
          bOdd = !bOdd;
        }
        // Add extra spacer row
        innerTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(2, 25));
        /////////////////////////
        // Custom Card Properties
        // BEGIN Custom Card Header ROW
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);
        innerTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myCell.SetColSpan("2");
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(53, "ptmsgs_portalbrowsingmsgs"));
        // END Custom Card Header ROW
        // BEGIN Custom Column Headers ROW
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.LIST_SORT_HEADER_BG);
        innerTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(55, "ptmsgs_portalbrowsingmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(56, "ptmsgs_portalbrowsingmsgs"));
        // END Custom Column Headers ROW
        xpEnum = xpCustomProperties.GetElements();
        bOdd = false;
        while (xpEnum.MoveNext())
        {
          cpo = (CardPropertyObject) xpEnum.GetCurrent();
          strPropName = cpo.m_sPropName;
          strPropValue = cpo.m_sPropValue;
          bIsURL = cpo.m_bIsURL;
          myRow = new HTMLTableRow();
          innerTable.AddInnerHTMLElement(myRow);
          myRow.SetStyleClass(bOdd ? PTStyleClass.LIST_ITEM_ONE_BG : PTStyleClass.LIST_ITEM_TWO_BG);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          mySpan = new HTMLSpan();
          myCell.AddInnerHTMLElement(mySpan);
          mySpan.SetStyleClass(PTStyleClass.LIST_SUBTITLE);
          mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strPropName));
          myCell = new HTMLTableCell();
          //						myCell.SetNoWrap(false);
          myRow.AddInnerHTMLElement(myCell);
          mySpan = new HTMLSpan();
          myCell.AddInnerHTMLElement(mySpan);
          mySpan.SetStyleClass(PTStyleClass.LIST_TEXT);
          if (null == strPropValue || XPStringUtility.EqualsIgnoreCase("",
           strPropValue))
          {
            mySpan.AddInnerHTMLString(CommonHTMLStrings.SPACE);
          } else
          if (bIsURL)
          {
            myAnchor = new HTMLAnchor(strPropValue);
            myAnchor.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strPropValue));
            myAnchor.SetTitle(XPHttpUtility.HtmlEncode(strPropValue));
            mySpan.AddInnerHTMLElement(myAnchor);
          } else
          {
            mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strPropValue));
            }
          bOdd = !bOdd;
        }
        // Add extra spacer row
        innerTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(2, 25));
        /////////////////////////
        // Card Information
        // BEGIN Custom Card Header ROW
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);
        innerTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myCell.SetColSpan("2");
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(54, "ptmsgs_portalbrowsingmsgs"));
        // END Custom Card Header ROW
        // BEGIN Custom Column Headers ROW
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.LIST_SORT_HEADER_BG);
        innerTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(55, "ptmsgs_portalbrowsingmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(56, "ptmsgs_portalbrowsingmsgs"));
        // END Custom Column Headers ROW
        xpEnum = xpCardInformation.GetElements();
        bOdd = false;
        while (xpEnum.MoveNext())
        {
          cso = (CardStatisticObject) xpEnum.GetCurrent();
          strPropName = cso.m_sPropName;
          strPropValue = cso.m_sPropValue;
          myRow = new HTMLTableRow();
          innerTable.AddInnerHTMLElement(myRow);
          myRow.SetStyleClass(bOdd ? PTStyleClass.LIST_ITEM_ONE_BG : PTStyleClass.LIST_ITEM_TWO_BG);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          mySpan = new HTMLSpan();
          myCell.AddInnerHTMLElement(mySpan);
          mySpan.SetStyleClass(PTStyleClass.LIST_SUBTITLE);
          mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strPropName));
          myCell = new HTMLTableCell();
          //						myCell.SetNoWrap(false);
          myRow.AddInnerHTMLElement(myCell);
          mySpan = new HTMLSpan();
          myCell.AddInnerHTMLElement(mySpan);
          mySpan.SetStyleClass(PTStyleClass.LIST_TEXT);
          if (cso.m_bIsMoreLikeThis)
          // special case
          {
            Object[][] oParentFolderPaths = (Object[][]) cso.m_oParentFolderPaths;
            for (int i = 0;i < oParentFolderPaths.Length;i++)
            {
              int nParentFolderID = XPConvert.ToInteger(oParentFolderPaths[i][0]);
              String strParentFolderPath = (String) oParentFolderPaths[i][1];
              String strURL = PTOpenerLinks.GetOpenerURLOpenObjID(PT_CLASSIDS.PT_CATALOGFOLDER_ID,
               nParentFolderID, IPTOpenerConstants.OPENER_MODE_VIEW, m_asOwner);
              myAnchor = new HTMLAnchor(strURL);
              myAnchor.AddInnerHTMLEncodedString(strParentFolderPath);
              myAnchor.SetTitle(XPHttpUtility.HtmlEncode(strParentFolderPath));
              mySpan.AddInnerHTMLElement(myAnchor);
              mySpan.AddInnerHTMLElement(new HTMLBr());
            }
          } else
          {
            mySpan.AddInnerHTMLEncodedString(strPropValue);
          }
          bOdd = !bOdd;
        }
        myComment = new HTMLComment("End: Display DirCardPropertiesView_D");
        result.AddInnerHTMLElement(myComment);
      }
      catch (HTMLException he)
      {
        log.Error(he, STR_MVC_CLASS_NAME + "::MainView::Display The following error occured when trying to display the HTML: " + he.Message);
        throw new XPException(m_asOwner.GetString(49, "ptmsgs_portalbrowsingmsgs"),
         he);
      }
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asModel = (IDirModelRO) model;
      m_asOwner = parent;
    }
  }
}