using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.directory;
using com.plumtree.portalpages.common.folder;
using com.plumtree.portaluiinfrastructure.opener;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.directory.browse_D
{
  /// <author>StephenC</author>
  public class DirRelatedResourcesMoreView_D : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.directory.browse_D.DirRelatedResourcesMoreView_D");
    public const String STR_MVC_CLASS_NAME = "DirRelatedResourcesMoreView_D";
    public const String HTMLBUTTON_EDITOR_OKAY = "in_bu_Okay";
    private AActivitySpace m_asOwner;
    private IDirModelRO m_asModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new DirRelatedResourcesMoreView_D();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Display()"></seealso>
    public virtual HTMLElement Display()
    {
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLSpan mySpan;
      HTMLAnchor myAnchor;
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable mainTable;
      HTMLTable sectionTable;
      HTMLTable innerTable;
      try
      {
        HTMLComment myComment = new HTMLComment("Begin: Display DirRelatedResourcesMoreView_D");
        result.AddInnerHTMLElement(myComment);
        mainTable = new HTMLTable();
        mainTable.SetBorder("0");
        mainTable.SetWidth("100%");
        mainTable.SetCellPadding("0");
        mainTable.SetCellSpacing("0");
        mainTable.SetSummary(m_asOwner.GetString(1181, "ptmsgs_portalbrowsingmsgs"));
        int nCategoryID = m_asModel.GetRRCategory();
        Object[][] arRRMoreInfo = m_asModel.GetMoreRelatedResources(nCategoryID);
        // BEGIN Go Back Row
        myRow = new HTMLTableRow();
        mainTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        int nFolderID = m_asModel.GetCurrentFolderID();
        String strURL = PTOpenerLinks.GetOpenerURLOpenObjID(PT_CLASSIDS.PT_CATALOGFOLDER_ID,
         nFolderID, IPTOpenerConstants.OPENER_MODE_VIEW, m_asOwner);
        myAnchor = new HTMLAnchor(strURL);
        myAnchor.AddInnerHTMLString(m_asOwner.GetString(59, "ptmsgs_portalbrowsingmsgs"));
        myAnchor.SetTitle(m_asOwner.GetString(59, "ptmsgs_portalbrowsingmsgs"));
        myCell.SetStyleClass(PTStyleClass.OBJECT_HEADER);
        myCell.AddInnerHTMLElement(myAnchor);
        // END Go Back Row
        // Add extra spacer row
        mainTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(1, 5));
        myRow = new HTMLTableRow();
        mainTable.AddInnerHTMLElement(myRow);
        result.AddInnerHTMLElement(mainTable);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        sectionTable = new HTMLTable();
        sectionTable.SetBorder("0");
        sectionTable.SetWidth("100%");
        sectionTable.SetCellPadding("5");
        sectionTable.SetCellSpacing("0");
        sectionTable.SetSummary(m_asOwner.GetString(1180, "ptmsgs_portalbrowsingmsgs"));
        myCell.AddInnerHTMLElement(sectionTable);
        // BEGIN Banner 
        myRow = new HTMLTableRow();
        sectionTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.DIR_HEADER_BG);
        // title
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        myCell.SetHeight("30");
        mySpan.SetStyleClass(PTStyleClass.DIR_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(61, "ptmsgs_portalbrowsingmsgs"));
        // BEGIN Banner 
        // Add extra spacer row
        mainTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(1, 5));
        myRow = new HTMLTableRow();
        mainTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        sectionTable = new HTMLTable();
        sectionTable.SetBorder("0");
        sectionTable.SetWidth("100%");
        sectionTable.SetCellPadding("5");
        sectionTable.SetCellSpacing("0");
        sectionTable.SetSummary(m_asOwner.GetString(1182, "ptmsgs_portalbrowsingmsgs"));
        myCell.AddInnerHTMLElement(sectionTable);
        // BEGIN Title Text ROW
        myRow = new HTMLTableRow();
        sectionTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);
        // title
        String strFolderName = ((IFolderModelRO) m_asModel).GetCurrentFolderName();
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_HEADER);
        mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strFolderName));
        // END Title Text ROW
        // Add extra spacer row
        mainTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(1, 5));
        myRow = new HTMLTableRow();
        mainTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        sectionTable = new HTMLTable();
        sectionTable.SetBorder("0");
        sectionTable.SetWidth("100%");
        sectionTable.SetCellPadding("0");
        sectionTable.SetCellSpacing("5");
        sectionTable.SetSummary(m_asOwner.GetString(1184, "ptmsgs_portalbrowsingmsgs"));
        myCell.AddInnerHTMLElement(sectionTable);
        myRow = new HTMLTableRow();
        sectionTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        innerTable = new HTMLTable();
        innerTable.SetBorder("0");
        innerTable.SetWidth("100%");
        innerTable.SetCellPadding("2");
        innerTable.SetCellSpacing("2");
        innerTable.SetSummary(m_asOwner.GetString(1183, "ptmsgs_portalbrowsingmsgs"));
        myCell.AddInnerHTMLElement(innerTable);
        // BEGIN Header ROW
        String strCategoryName = m_asModel.GetRelatedResourceString(nCategoryID);
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);
        innerTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_HEADER);
        mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strCategoryName));
        // END Header ROW
        String strName;
        String strDescription;
        int nObjectID;
        int nNumRRs = arRRMoreInfo.Length;
        bool bOdd = false;
        for (int i = 0;i < nNumRRs;i++)
        {
          nObjectID = XPConvert.ToInteger(arRRMoreInfo[i][0]);
          strName = (String) arRRMoreInfo[i][1];
          strDescription = (String) arRRMoreInfo[i][2];
          myRow = new HTMLTableRow();
          innerTable.AddInnerHTMLElement(myRow);
          myRow.SetStyleClass(bOdd ? PTStyleClass.LIST_ITEM_ONE_BG : PTStyleClass.LIST_ITEM_TWO_BG);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          mySpan = new HTMLSpan();
          myCell.AddInnerHTMLElement(mySpan);
          mySpan.SetStyleClass(PTStyleClass.LIST_SUBTITLE);
          strURL = "";
          switch (nCategoryID){
          case PT_INTRINSICS.PT_RELATED_RESOURCE_COMMUNITIES:
          strURL = PTOpenerLinks.GetOpenerURLOpenObjID(PT_CLASSIDS.PT_COMMUNITY_ID,
           nObjectID, IPTOpenerConstants.OPENER_MODE_VIEW, m_asOwner);
          break;
          case PT_INTRINSICS.PT_RELATED_RESOURCE_FOLDERS:
          strURL = PTOpenerLinks.GetOpenerURLOpenObjID(PT_CLASSIDS.PT_CATALOGFOLDER_ID,
           nObjectID, IPTOpenerConstants.OPENER_MODE_VIEW, m_asOwner);
          break;
          case PT_INTRINSICS.PT_RELATED_RESOURCE_GADGETS:
          strURL = PTOpenerLinks.GetOpenerURLOpenObjID(PT_CLASSIDS.PT_GADGET_ID,
           nObjectID, IPTOpenerConstants.OPENER_MODE_VIEW, m_asOwner);
          break;
          case PT_INTRINSICS.PT_RELATED_RESOURCE_EXPERTS:
          case PT_INTRINSICS.PT_RELATED_RESOURCE_CONTENT_MANAGERS:
          strURL = PTOpenerLinks.GetOpenerURLOpenObjID(PT_CLASSIDS.PT_USER_ID,
           nObjectID, IPTOpenerConstants.OPENER_MODE_VIEW, m_asOwner);
          break;
          }
          myAnchor = new HTMLAnchor(strURL);
          myAnchor.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strName));
          myAnchor.SetTitle(XPHttpUtility.HtmlEncode(strName));
          mySpan.AddInnerHTMLElement(myAnchor);
          myCell.AddInnerHTMLElement(new HTMLBr());
          mySpan = new HTMLSpan();
          myCell.AddInnerHTMLElement(mySpan);
          mySpan.SetStyleClass(PTStyleClass.LIST_TEXT);
          mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strDescription));
          bOdd = !bOdd;
        }
        myComment = new HTMLComment("End: Display DirRelatedResourcesMoreView_D");
        result.AddInnerHTMLElement(myComment);
      }
      catch (HTMLException he)
      {
        log.Error(he, STR_MVC_CLASS_NAME + "::MainView::Display The following error occured when trying to display the HTML: " + he.Message);
        throw new XPException(m_asOwner.GetString(65, "ptmsgs_portalbrowsingmsgs"),
         he);
      }
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asModel = (IDirModelRO) model;
      m_asOwner = parent;
    }
  }
}