using System;
// Framework imports
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.directory.documentsubmitsimple
{
  /// <summary>
  /// This is the DP for the dependencies page. It's the
  /// last page of the save pop-up and has a confirmation
  /// message and some links to create other objects that
  /// depend on the one that was just created.
  /// </summary>
  /// <author>StephenC</author>
  public class DirCardSubmitDependenciesDP : AFormDP
  {
    
    /// <summary>
    /// Class name for the activity space
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "DirCardSubmitDependencies";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()"></seealso>
    public override String GetFormTitle()
    {
      return m_asOwner.GetString(1199, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#Init(AActivitySpace)"></seealso>
    public override void Init(AActivitySpace parent)
    {
      base.Init(parent);
      parent.SetHelpTopic("PT_Submit_SimpleDocument");
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      return m_asOwner.GetView(DirCardSubmitDependenciesView.STR_MVC_CLASS_NAME).Display();
      }
  }
}