using System;
using com.plumtree.portalpages.browsing.directory;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.directory.documentsubmitsimple
{
  /// <author>StephenC</author>
  public class DirCardSubmitSimpleDP : AFormDP
  {
    public const String STR_MVC_CLASS_NAME = "DirCardSubmitSimple";
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#Init(AActivitySpace)"></seealso>
    public override void Init(AActivitySpace parent)
    {
      base.Init(parent);
      parent.SetHelpTopic("PT_Submit_SimpleDocument");
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()"></seealso>
    public override String GetFormTitle()
    {
      return m_asOwner.GetString(83, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#GetFormPageType()"></seealso>
    public override FormPageTypes GetFormPageType()
    {
      return FormPageTypes.NO_BUTTONS;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      int nCardSubmitMode = ((IDirModelRO) this.m_asOwner.GetModel(DirModel.STR_MVC_CLASS_NAME)).GetCardSubmitMode();
      switch (nCardSubmitMode){
      case DirConstants.CARDSUBMITMODE_DONE:
      return m_asOwner.GetView(DirCardSubmitDoneView.STR_MVC_CLASS_NAME).Display();
      goto case DirConstants.CARDSUBMITMODE_UPLOADING;
      case DirConstants.CARDSUBMITMODE_UPLOADING:
      return m_asOwner.GetView(DirCardSubmitUploadingView.STR_MVC_CLASS_NAME).Display();
      goto default;
      default:
      case DirConstants.CARDSUBMITMODE_MAIN:
      return m_asOwner.GetView(DirCardSubmitSimpleView.STR_MVC_CLASS_NAME).Display();
      break;
      }
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      int nCardSubmitMode = ((IDirModelRO) this.m_asOwner.GetModel(DirModel.STR_MVC_CLASS_NAME)).GetCardSubmitMode();
      switch (nCardSubmitMode){
      case DirConstants.CARDSUBMITMODE_DONE:
      case DirConstants.CARDSUBMITMODE_UPLOADING:
      break;
      case DirConstants.CARDSUBMITMODE_MAIN:
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(DirCardSubmitSimpleView.STR_MVC_CLASS_NAME).DisplayJavascript());
      break;
      }
      return myScripts;
    }
    
    /// <summary>
    /// logger 
    /// </summary>
    public override 
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.form.AFormDP#DisplayHTMLAfterForm()
     */
     
    HTMLElementCollection DisplayHTMLAfterForm()
    {
      /* JHQ 010704: bug 26798 - adding a dhtml div containing a
       * pretty uploading message section which is hidden unless
       * some JS changes the visiblitity style
       */
       
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLDiv myDiv;
      // BEGIN uploading progress section			
      myDiv = new HTMLDiv();
      result.AddInnerHTMLElement(myDiv);
      myDiv.SetID("ProgressMessage");
      myDiv.SetStyle("position:relative; visibility:hidden");
      myDiv.SetStyleClass(PTStyleClass.DIALOGUE_TEXT);
      HTMLTable divTable = new HTMLTable();
      myDiv.AddInnerHTMLElement(divTable);
      divTable.SetBorder("0");
      divTable.SetWidth("100%");
      divTable.SetCellPadding("0");
      divTable.SetCellSpacing("0");
      // BEGIN Message Row
      myRow = new HTMLTableRow();
      divTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetAlign(CommonHTMLStrings.CENTER);
      myCell.SetStyleClass(PTStyleClass.OBJECT_HEADER);
      myCell.AddInnerHTMLString(m_asOwner.GetString(1473, "ptmsgs_portalbrowsingmsgs"));
      // END Message Row
      // BEGIN Animated GIF Row
      myRow = new HTMLTableRow();
      divTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetNoWrap(true);
      myCell.SetAlign(CommonHTMLStrings.CENTER);
      HTMLImg mySendDocImg = (HTMLImg) PTImageType.ICON_PROGRESS.GetHTMLElement();
      mySendDocImg.SetAlt(m_asOwner.GetString(1473, "ptmsgs_portalbrowsingmsgs"));
      myCell.AddInnerHTMLElement(mySendDocImg);
      // END Animated GIF Row
      // END uploading progress section
      return result;
    }
  }
}