using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.directory;
using com.plumtree.portalpages.browsing.editors.document;
using com.plumtree.portalpages.common.objects;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.opener;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.htmlconstructs;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.directory.edit
{
  /// <summary>
  /// Displays a document item in Edit Mode.
  /// </summary>
  /// <author>StephenC</author>
  public class EditDocViewHelper : IObjectViewHelper
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.directory.edit.EditDocViewHelper");
    public const String QS_CHECKBOX = "in_cb_document";
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#AddObjectViewHTML()"></seealso>
    public virtual HTMLElement AddObjectViewHTML(IObjectModelRO model)
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#Display508Object(int,HTMLTable,IObjectModelRO,AActivitySpace)"></seealso>
    public virtual void Display508Object(int nObjectIndex, HTMLTable tableObjects,
     IObjectModelRO model, AActivitySpace parent)
    {
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#GetThereAreNoItemsString(AActivitySpace)"></seealso>
    public virtual String GetThereAreNoItemsString(AActivitySpace asOwner)
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#DisplayJavascriptCollection(AActivitySpace)"></seealso>
    public virtual HTMLScriptCollection DisplayJavascriptCollection(AActivitySpace asOwner,
     IObjectModelRO model)
    {
      return null;
    }
    
    /// <summary>
    /// Displays the object at the given index in the query result. This must be
    /// overridden by all subclasses.
    /// </summary>
    /// <param name="nObjectIndex"></param>
    /// <param name="tableObjects"></param>
    /// <param name="model"></param>
    /// <param name="asOwner"></param>
    public virtual void DisplayObject(int nObjectIndex, int nRowIndex, HTMLTable tableObjects,
     IObjectModelRO model, AActivitySpace asOwner)
    {
      //HTML elements
      HTMLTableCell cell;
      HTMLTableRow row;
      ASURL url;
      try
      {
        IDirModelRO dirModel = (IDirModelRO) model;
        // CardID
        int nCardID = XPConvert.ToInteger(model.GetObjectFields(nObjectIndex,
         PT_PROPIDS.PT_PROPID_OBJECTID));
        String strCardID = XPConvert.ToString(nCardID);
        // Card Name
        String strCardName = (String) model.GetObjectFields(nObjectIndex,
         PT_PROPIDS.PT_PROPID_NAME);
        //Get the image uiid
        String strImageUIID = (String) model.GetObjectFields(nObjectIndex,
         PT_PROPIDS.PT_PROPID_IMAGEUUID);
        // Description
        String strDescType = dirModel.GetDocDescriptionType();
        String strCardDesc = "";
        if (false == XPStringUtility.EqualsIgnoreCase(DirConstants.DIR_DOC_DESC_NONE,
         strDescType))
        {
          strCardDesc = (String) model.GetObjectFields(nObjectIndex, PT_PROPIDS.PT_PROPID_DESCRIPTION);
          if (null == strCardDesc)
          {
            strCardDesc = "";
          }
          // abbreviate the description if necessary
          if (true == XPStringUtility.EqualsIgnoreCase(DirConstants.DIR_DOC_DESC_ABBR,
           strDescType))
          {
            if (DirConstants.DESCRIPTION_ABBR_LENGTH < strCardDesc.Length)
            {
              strCardDesc = XPStringUtility.Substring(strCardDesc, 0, DirConstants.DESCRIPTION_ABBR_LENGTH) + "...";
              }
          }
          // HTMLEncode
          strCardDesc = XPHttpUtility.HtmlEncode(strCardDesc);
        }
        XPDateFormat xpDateTimeFormat = XPDateFormat.GetDateTimeInstance(XPDateFormat.SHORT,
         XPDateFormat.SHORT, dirModel.GetUserPrefLocale(), dirModel.GetUserPrefTimeZone());
        // Last Modified
        XPDateTime dtLastModifiedDate = (XPDateTime) model.GetObjectFields(nObjectIndex,
         PT_PROPIDS.PT_PROPID_LASTMODIFIED);
        String strLastModifiedDate = xpDateTimeFormat.Format(dtLastModifiedDate);
        // Created
        XPDateTime dtCreatedDate = (XPDateTime) model.GetObjectFields(nObjectIndex,
         PT_PROPIDS.PT_PROPID_CREATED);
        String strCreatedDate = xpDateTimeFormat.Format(dtCreatedDate);
        // Card Approval State
        int nApprovalState = XPConvert.ToInteger(model.GetObjectFields(nObjectIndex,
         PT_PROPIDS.PT_PROPID_FOLDER_CARDAPPROVALSTATE));
        String strURL;
        if (dirModel.GetUserPrefOpenDocInNewWindow())
        {
          // open document URL in new window.
          strURL = PTOpenerLinks.GetJSOpenInNewWindow(PTOpenerLinks.GetOpenerJSURLOpenObjID(PT_CLASSIDS.PT_CATALOGCARD_ID,
           nCardID, null, IPTOpenerConstants.OPENER_MODE_VIEW), PTOpenerLinks.GetWindowName("" + PT_CLASSIDS.PT_CATALOGCARD_ID + "_" + nCardID),
           "800", "600", true);
        } else
        {
          // open document URL in same window.
          strURL = PTOpenerLinks.GetJSOpenInSameWindow(PTOpenerLinks.GetOpenerJSURLOpenObjID(PT_CLASSIDS.PT_CATALOGCARD_ID,
           nCardID, null, IPTOpenerConstants.OPENER_MODE_VIEW));
        }
        // use list item construct
        String strFittedName = DirConstants.BreakUpLongWordsInStringAndHTMLEncode(strCardName,
         100);
        HTMLAnchor nameAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
        nameAnchor.SetOnClick(strURL + "; return false;");
        nameAnchor.AddInnerHTMLString(strFittedName);
        UIListItem itemConstruct = new UIListItem(nameAnchor, asOwner);
        itemConstruct.SetTitleStyleClass(PTStyleClass.LIST_SUBTITLE);
        bool bNeedsNewTag = dirModel.GetObjectNewTagDate().Before(dtCreatedDate);
        if (bNeedsNewTag)
        {
          itemConstruct.SetNew(true);
        } else
        {
          itemConstruct.SetUpdated(dirModel.GetObjectUpdateTagDate().Before(dtLastModifiedDate));
          }
        if ((false == XPStringUtility.EqualsIgnoreCase(DirConstants.DIR_DOC_DESC_NONE,
         strDescType)) && (0 != strCardDesc.Length))
        {
          itemConstruct.SetDescription(strCardDesc);
        }
        if ((null != strLastModifiedDate) && !("").Equals(strLastModifiedDate))
        {
          itemConstruct.AddProperty(asOwner.GetString(113, "ptmsgs_portalbrowsingmsgs"),
           strLastModifiedDate);
        }
        // CheckBox
        itemConstruct.EnableCheckbox(QS_CHECKBOX, strCardID, strCardID, 
        //to do: specify value
        model.GetIsObjectSelected(nCardID));
        // Image UIID
        HTMLImg myImg = PlumtreeHelpers.GetHTMLImage(strImageUIID, true);
        myImg.SetAlt(XPHttpUtility.HtmlEncode(strCardName));
        myImg.SetWidth("20");
        itemConstruct.SetItemTypeImage(myImg);
        // Approve
        if (PT_FOLDER_SUBMITACCESSLEVELS.PT_SUBMITACCESSLEVEL_UNAPPROVED == nApprovalState)
        {
          itemConstruct.SetApprovalStateImage(PTImageType.ICON_UNAPPROVE,
           asOwner.GetString(1656, "ptmsgs_portalbrowsingmsgs"));
        }
        //Edit Properties URL
        HTMLAnchor myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
        myAnchor.SetOnClick(DirConstants.JAVASCRIPT_CARDPROPERTIES_POPUP + "(" + nCardID + "); return false;\n");
        myAnchor.AddInnerHTMLString(asOwner.GetString(112, "ptmsgs_portalbrowsingmsgs"));
        itemConstruct.AddSubLink(myAnchor, false, false);
        // convert the construct to table
        try
        {
          row = new HTMLTableRow();
          // alternating gray and white rows
          row.SetStyleClass(((nRowIndex % 2) == 1) ? PTStyleClass.LIST_ITEM_ONE_BG : PTStyleClass.LIST_ITEM_TWO_BG);
          itemConstruct.AddItemCellsToRow(row);
          // Created
          HTMLImg spacer = (HTMLImg) ConstructFactory.GetConstruct(PTImageType.SPACER).GetHTMLElement();
          spacer.SetHeight("13");
          spacer.SetWidth("1");
          cell = new HTMLTableCell();
          row.AddInnerHTMLElement(cell);
          cell.SetVAlign(CommonHTMLStrings.TOP);
          cell.SetStyleClass(PTStyleClass.LIST_TEXT);
          cell.SetNoWrap(true);
          cell.AddInnerHTMLElement(spacer);
          cell.AddInnerHTMLString(strCreatedDate);
          //Edit Card URL
          cell = new HTMLTableCell();
          row.AddInnerHTMLElement(cell);
          cell.SetVAlign(CommonHTMLStrings.TOP);
          cell.SetStyleClass(PTStyleClass.LIST_TEXT);
          url = new ASURL(asOwner);
          url.SetLinkCreateNewSpace(CardEditorAS.STR_MVC_CLASS_NAME, asOwner);
          url.SetControl(EditorStartControl.STR_MVC_CLASS_NAME);
          url.AddControlArgument(EditorStartControl.QS_EDITOR_TYPE, XPConvert.ToString(EditorStartControl.EDITOR_START_FLAG_EDIT));
          url.AddControlArgument(ObjEditorModel.EDITOR_QS_INT_CLASS_ID, XPConvert.ToString(PT_CLASSIDS.PT_CATALOGCARD_ID));
          url.AddControlArgument(ObjEditorModel.EDITOR_QS_INT_QS_OBJECT_ID,
           strCardID);
          String strEditCardURL = url.GetURLAsString();
          HTMLImg myEditItemImg = (HTMLImg) PTImageType.ICON_EDIT.GetHTMLElement();
          myEditItemImg.SetAlt(asOwner.GetString(111, "ptmsgs_portalbrowsingmsgs"));
          myEditItemImg.SetTitle(asOwner.GetString(111, "ptmsgs_portalbrowsingmsgs"));
          myAnchor = new HTMLAnchor(strEditCardURL);
          myAnchor.AddInnerHTMLElement(myEditItemImg);
          cell.AddInnerHTMLElement(myAnchor);
          tableObjects.AddInnerHTMLElement(row);
        }
        catch (Exception e)
        {
          log.Error(e, e.Message);
        }
      }
      catch (Exception e)
      {
        log.Error(e, e.Message);
      }
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#SetExpandButton(HTMLAnchor,IObjectModelRO)"></seealso>
    public virtual void SetExpandAnchor(HTMLAnchor anchor, IObjectModelRO model)
    {
    }
  }
}