using System;
using com.plumtree.portalpages.browsing.directory;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.directory.properties
{
  /// <author>StephenC</author>
  public class DirCardPropertiesDP : AFormDP
  {
    public const String STR_MVC_CLASS_NAME = "DirCardProperties";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()"></seealso>
    public override String GetFormTitle()
    {
      return m_asOwner.GetString(114, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // card properties view
      result.AddInnerHTMLElement(m_asOwner.GetView(DirCardPropertiesView.STR_MVC_CLASS_NAME).Display());
      // bestbets view
      result.AddInnerHTMLElement(m_asOwner.GetView(DirAS.STR_MVC_STORAGE_NAME_KEYWORDS).Display());
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(DirCardPropertiesView.STR_MVC_CLASS_NAME).DisplayJavascript());
      // bestbets view
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(DirAS.STR_MVC_STORAGE_NAME_KEYWORDS).DisplayJavascript());
      return myScripts;
    }
  }
}