using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.directory;
using com.plumtree.portalpages.browsing.editors.dircommon;
using com.plumtree.portaluiinfrastructure.application.varpacks;
using com.plumtree.portaluiinfrastructure.login;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.uiinfrastructure.web;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.directory.properties
{
  /// <author>StephenC</author>
  public class DirCardPropertiesView : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.directory.properties.DirCardPropertiesView");
    public const String STR_MVC_CLASS_NAME = "DirCardProperties";
    
    /// <summary>
    /// Logging stuff 
    /// </summary>
    public const String HTMLBUTTON_EDITOR_EDIT = "in_bu_Edit";
    public const String HTMLBUTTON_EDITOR_CLOSE = "in_bu_Close";
    private AActivitySpace m_asOwner;
    private IModelRO m_model;
    private const int CARD_NAME_TITLE_LENGTH = 45;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new DirCardPropertiesView();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Display()"></seealso>
    public virtual HTMLElement Display()
    {
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLSpan mySpan;
      HTMLInput myInput;
      HTMLH1 headerH1;
      HTMLTable mainTable = new HTMLTable();
      mainTable.SetBorder("0");
      mainTable.SetWidth("100%");
      mainTable.SetCellPadding("0");
      mainTable.SetCellSpacing("0");
      HTMLTable sectionTable;
      HTMLTable innerTable;
      String strFittedAndEncodedValue;
      try
      {
        myRow = new HTMLTableRow();
        mainTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        sectionTable = new HTMLTable();
        sectionTable.SetBorder("0");
        sectionTable.SetWidth("100%");
        sectionTable.SetCellPadding("5");
        sectionTable.SetCellSpacing("0");
        myCell.AddInnerHTMLElement(sectionTable);
        // BEGIN Banner and Edit and Close buttons
        myRow = new HTMLTableRow();
        sectionTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.BAN_HEADER_BG);
        // title
        String strOriginalCardName = ((IDirModelRO) m_model).GetCardName();
        String strFittedAndEncodedCardName = DirConstants.BreakUpLongWordsInStringAndHTMLEncode(strOriginalCardName,
         CARD_NAME_TITLE_LENGTH);
        String strViewProperties = m_asOwner.GetString(115, "ptmsgs_portalbrowsingmsgs");
        String strTitle = strViewProperties + 
        // add a <br> here if the name is long 
        ((CARD_NAME_TITLE_LENGTH < strFittedAndEncodedCardName.Length) ? DirConstants.BREAK : "") + strFittedAndEncodedCardName;
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        headerH1 = new HTMLH1();
        myCell.AddInnerHTMLElement(headerH1);
        myCell.SetHeight("30");
        headerH1.AddInnerHTMLString(strTitle);
        headerH1.SetStyleClass(PTStyleClass.BAN_HEADER);
        // buttons
        myCell = new HTMLTableCell();
        myCell.SetAlign(CommonHTMLStrings.RIGHT);
        myCell.SetVAlign(CommonHTMLStrings.TOP);
        myCell.SetWidth("300");
        myRow.AddInnerHTMLElement(myCell);
        if (true == ((IDirModelRO) m_model).HasAccessToEditCard())
        {
          // Edit button
          myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_EDITOR_EDIT,
           "");
          myCell.AddInnerHTMLElement(myInput);
          myInput.SetValue(" " + m_asOwner.GetString(117, "ptmsgs_portalbrowsingmsgs") + " ");
          myInput.SetStyleClass(PTStyleClass.FORM_EDITOR_BTN_TEXT);
          myInput.SetOnClick(AFormDP.JAVASCRIPT_SUBMIT_FORM + "(" + DirRepostControl.POSTTOSELF_ACTION_EDITCARDPROPERTIES + ");");
          myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        }
        // Close button
        myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_EDITOR_CLOSE,
         "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetValue(m_asOwner.GetString(118, "ptmsgs_portalbrowsingmsgs"));
        myInput.SetStyleClass(PTStyleClass.FORM_EDITOR_BTN_TEXT);
        // mj: removed 'Javascript:' from function name
        myInput.SetOnClick("self.close();");
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        // BEGIN Banner and Edit and Close buttons
        // Add extra spacer row
        mainTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(1, 5));
        myRow = new HTMLTableRow();
        mainTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        sectionTable = new HTMLTable();
        sectionTable.SetBorder("0");
        sectionTable.SetWidth("100%");
        sectionTable.SetCellPadding("5");
        sectionTable.SetCellSpacing("0");
        myCell.AddInnerHTMLElement(sectionTable);
        // BEGIN Title Text ROW
        myRow = new HTMLTableRow();
        sectionTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        // title
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(116, "ptmsgs_portalbrowsingmsgs"));
        // END Title Text ROW
        // Add extra spacer row
        mainTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(2, 5));
        myRow = new HTMLTableRow();
        mainTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        sectionTable = new HTMLTable();
        sectionTable.SetBorder("0");
        sectionTable.SetWidth("100%");
        sectionTable.SetCellPadding("0");
        sectionTable.SetCellSpacing("5");
        myCell.AddInnerHTMLElement(sectionTable);
        myRow = new HTMLTableRow();
        sectionTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        innerTable = new HTMLTable();
        innerTable.SetBorder("0");
        innerTable.SetWidth("100%");
        innerTable.SetCellPadding("2");
        innerTable.SetCellSpacing("2");
        myCell.AddInnerHTMLElement(innerTable);
        /////////////////////////
        // Basic Card Properties
        // BEGIN Basic Card Header ROW
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);
        innerTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myCell.SetColSpan("2");
        myCell.SetHeight("25");
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(120, "ptmsgs_portalbrowsingmsgs"));
        // END Basic Card Header ROW
        // BEGIN Basic Column Headers ROW
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.LIST_SORT_HEADER_BG);
        innerTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(123, "ptmsgs_portalbrowsingmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(124, "ptmsgs_portalbrowsingmsgs"));
        // END Basic Column Headers ROW
        XPSortedDictionary xpBasicProperties = ((IDirModelRO) m_model).GetBasicCardProperties();
        XPSortedDictionary xpCustomProperties = ((IDirModelRO) m_model).GetCustomCardProperties();
        XPSortedDictionary xpCardInformation = ((IDirModelRO) m_model).GetCardInformation();
        IXPEnumerator xpEnum;
        CardPropertyObject cpo;
        CardStatisticObject cso;
        int nPropID;
        String strPropValue;
        String strPropName;
        xpEnum = xpBasicProperties.GetElements();
        bool bOdd = false;
        while (xpEnum.MoveNext())
        {
          cpo = (CardPropertyObject) xpEnum.GetCurrent();
          nPropID = cpo.m_nPropID;
          strPropName = cpo.m_sPropName;
          strPropValue = cpo.m_sPropValue;
          if (null == strPropValue)
          {
            strPropValue = "";
          }
          if (PT_INTRINSICS.PT_PROPERTY_CONTENTLANGUAGE == nPropID)
          {
            String strCardLanguageCode = (String) PTPersonalSettingsHelper.GetPersonalSettingValue(PersonalSettingNames.LANGUAGE,
             m_asOwner);
            IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
            PTSearchLocaleVarPack vpPTSearchLocales = (PTSearchLocaleVarPack) application.GetVarPackManager().GetVariablePackage(PTSearchLocaleVarPack.VARPACK_ID);
            strPropValue = vpPTSearchLocales.GetLanguageNameForCode(strPropValue,
             strCardLanguageCode);
          }
          myRow = new HTMLTableRow();
          innerTable.AddInnerHTMLElement(myRow);
          myRow.SetStyleClass(bOdd ? PTStyleClass.LIST_ITEM_ONE_BG : PTStyleClass.LIST_ITEM_TWO_BG);
          myCell = new HTMLTableCell();
          myCell.SetVAlign(CommonHTMLStrings.TOP);
          myRow.AddInnerHTMLElement(myCell);
          mySpan = new HTMLSpan();
          myCell.AddInnerHTMLElement(mySpan);
          mySpan.SetStyleClass(PTStyleClass.LIST_SUBTITLE);
          mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strPropName));
          myCell = new HTMLTableCell();
          //						myCell.SetNoWrap(false);
          myRow.AddInnerHTMLElement(myCell);
          mySpan = new HTMLSpan();
          myCell.AddInnerHTMLElement(mySpan);
          mySpan.SetStyleClass(PTStyleClass.LIST_TEXT);
          strFittedAndEncodedValue = DirConstants.BreakUpLongWordsInStringAndHTMLEncode(strPropValue);
          // Verifying if the 'Open Document URL' property has been set and converting the url to a clickable link
          if (cpo.m_bIsURL)
          {
            HTMLAnchor m_link = new HTMLAnchor(strPropName);
            m_link.AddInnerHTMLString(strFittedAndEncodedValue);
            m_link.SetHRef(strPropValue);
            m_link.SetTarget("_blank");
            mySpan.AddInnerHTMLElement(m_link);
          } else
          {
            mySpan.AddInnerHTMLString(strFittedAndEncodedValue);
          }
          bOdd = !bOdd;
        }
        /* basic object ids */
        // the class ID -jas
        int iClassID = ((IDirModelRO) m_model).GetClassID();
        if (0 != iClassID)
        {
          myRow = new HTMLTableRow();
          innerTable.AddInnerHTMLElement(myRow);
          myRow.SetStyleClass(bOdd ? PTStyleClass.LIST_ITEM_ONE_BG : PTStyleClass.LIST_ITEM_TWO_BG);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          myCell.SetHeight("25");
          mySpan = new HTMLSpan();
          mySpan.SetStyleClass(PTStyleClass.LIST_SUBTITLE);
          mySpan.AddInnerHTMLString(m_asOwner.GetString(1881, "ptmsgs_portalbrowsingmsgs"));
          myCell.AddInnerHTMLElement(mySpan);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          myCell.SetAlign(CommonHTMLStrings.LEFT);
          myCell.AddInnerHTMLString(XPConvert.ToString(iClassID));
          bOdd = !bOdd;
        }
        // Fourth row, the object ID -jas
        int iObjectID = ((IDirModelRO) m_model).GetObjectID();
        if (0 != iObjectID)
        {
          myRow = new HTMLTableRow();
          innerTable.AddInnerHTMLElement(myRow);
          myRow.SetStyleClass(bOdd ? PTStyleClass.LIST_ITEM_ONE_BG : PTStyleClass.LIST_ITEM_TWO_BG);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          mySpan = new HTMLSpan();
          mySpan.SetStyleClass(PTStyleClass.LIST_SUBTITLE);
          mySpan.AddInnerHTMLString(m_asOwner.GetString(1882, "ptmsgs_portalbrowsingmsgs"));
          myCell.AddInnerHTMLElement(mySpan);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          myCell.SetAlign(CommonHTMLStrings.LEFT);
          myCell.AddInnerHTMLString(XPConvert.ToString(iObjectID));
          bOdd = !bOdd;
        }
        // Fifth row, the UUID -jas
        String strUUID = ((IDirModelRO) m_model).GetObjectUUID();
        if (null != strUUID)
        {
          myRow = new HTMLTableRow();
          innerTable.AddInnerHTMLElement(myRow);
          myRow.SetStyleClass(bOdd ? PTStyleClass.LIST_ITEM_ONE_BG : PTStyleClass.LIST_ITEM_TWO_BG);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          mySpan = new HTMLSpan();
          mySpan.SetStyleClass(PTStyleClass.LIST_SUBTITLE);
          mySpan.AddInnerHTMLString(m_asOwner.GetString(1883, "ptmsgs_portalbrowsingmsgs"));
          myCell.AddInnerHTMLElement(mySpan);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          myCell.SetAlign(CommonHTMLStrings.LEFT);
          myCell.AddInnerHTMLString(strUUID);
          bOdd = !bOdd;
        }
        // Add extra spacer row
        innerTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(2, 25));
        /////////////////////////
        // Custom Card Properties
        // BEGIN Custom Card Header ROW
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);
        innerTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myCell.SetColSpan("2");
        myCell.SetHeight("25");
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(121, "ptmsgs_portalbrowsingmsgs"));
        // END Custom Card Header ROW
        // BEGIN Custom Column Headers ROW
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.LIST_SORT_HEADER_BG);
        innerTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(123, "ptmsgs_portalbrowsingmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(124, "ptmsgs_portalbrowsingmsgs"));
        // END Custom Column Headers ROW
        xpEnum = xpCustomProperties.GetElements();
        bOdd = false;
        while (xpEnum.MoveNext())
        {
          cpo = (CardPropertyObject) xpEnum.GetCurrent();
          strPropName = cpo.m_sPropName;
          strPropValue = cpo.m_sPropValue;
          if (null == strPropValue)
          {
            strPropValue = "";
          }
          myRow = new HTMLTableRow();
          innerTable.AddInnerHTMLElement(myRow);
          myRow.SetStyleClass(bOdd ? PTStyleClass.LIST_ITEM_ONE_BG : PTStyleClass.LIST_ITEM_TWO_BG);
          myCell = new HTMLTableCell();
          myCell.SetVAlign(CommonHTMLStrings.TOP);
          myRow.AddInnerHTMLElement(myCell);
          mySpan = new HTMLSpan();
          myCell.AddInnerHTMLElement(mySpan);
          mySpan.SetStyleClass(PTStyleClass.LIST_SUBTITLE);
          mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strPropName));
          myCell = new HTMLTableCell();
          //						myCell.SetNoWrap(false);
          myRow.AddInnerHTMLElement(myCell);
          mySpan = new HTMLSpan();
          myCell.AddInnerHTMLElement(mySpan);
          mySpan.SetStyleClass(PTStyleClass.LIST_TEXT);
          strFittedAndEncodedValue = DirConstants.BreakUpLongWordsInStringAndHTMLEncode(strPropValue);
          mySpan.AddInnerHTMLString(strFittedAndEncodedValue);
          bOdd = !bOdd;
        }
        // Add extra spacer row
        innerTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(2, 25));
        /////////////////////////
        // Card Information
        // BEGIN Custom Card Header ROW
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);
        innerTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myCell.SetColSpan("2");
        myCell.SetHeight("25");
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(122, "ptmsgs_portalbrowsingmsgs"));
        // END Custom Card Header ROW
        // BEGIN Custom Column Headers ROW
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.LIST_SORT_HEADER_BG);
        innerTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(123, "ptmsgs_portalbrowsingmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(124, "ptmsgs_portalbrowsingmsgs"));
        // END Custom Column Headers ROW
        xpEnum = xpCardInformation.GetElements();
        bOdd = false;
        while (xpEnum.MoveNext())
        {
          cso = (CardStatisticObject) xpEnum.GetCurrent();
          strPropName = cso.m_sPropName;
          strPropValue = cso.m_sPropValue;
          myRow = new HTMLTableRow();
          innerTable.AddInnerHTMLElement(myRow);
          myRow.SetStyleClass(bOdd ? PTStyleClass.LIST_ITEM_ONE_BG : PTStyleClass.LIST_ITEM_TWO_BG);
          myCell = new HTMLTableCell();
          myCell.SetVAlign(CommonHTMLStrings.TOP);
          myRow.AddInnerHTMLElement(myCell);
          mySpan = new HTMLSpan();
          myCell.AddInnerHTMLElement(mySpan);
          mySpan.SetStyleClass(PTStyleClass.LIST_SUBTITLE);
          mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strPropName));
          myCell = new HTMLTableCell();
          //						myCell.SetNoWrap(false);
          myRow.AddInnerHTMLElement(myCell);
          mySpan = new HTMLSpan();
          myCell.AddInnerHTMLElement(mySpan);
          mySpan.SetStyleClass(PTStyleClass.LIST_TEXT);
          if (cso.m_bIsMoreLikeThis)
          // special case
          {
            Object[][] oParentFolderPaths = (Object[][]) cso.m_oParentFolderPaths;
            for (int i = 0;i < oParentFolderPaths.Length;i++)
            {
              int nParentFolderID = XPConvert.ToInteger(oParentFolderPaths[i][0]);
              String strParentFolderPath = (String) oParentFolderPaths[i][1];
              // mj: replaced the following line with a blank constructur and SetOnClick()
              // HTMLAnchor myAnchor = new HTMLAnchor(
              HTMLAnchor myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
              myAnchor.SetOnClick(DirConstants.JAVASCRIPT_CARDPROPERTIES_MOREDOCS + "(" + nParentFolderID + ");");
              myAnchor.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strParentFolderPath));
              mySpan.AddInnerHTMLElement(myAnchor);
              mySpan.AddInnerHTMLElement(new HTMLBr());
            }
          } else
          {
            strFittedAndEncodedValue = DirConstants.BreakUpLongWordsInStringAndHTMLEncode(strPropValue);
            mySpan.AddInnerHTMLString(strFittedAndEncodedValue);
          }
          bOdd = !bOdd;
        }
      }
      catch (HTMLException he)
      {
        log.Error(he, STR_MVC_CLASS_NAME + "::Display An error occured when trying to display the HTML.");
        throw new XPException(m_asOwner.GetString(119, "ptmsgs_portalbrowsingmsgs"),
         he);
      }
      return mainTable;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    public virtual HTMLScript DisplayJavascript()
    {
      HTMLScript myScript = new HTMLScript("text/javaScript");
      ASURL myMoreRRURL = new ASURL(m_asOwner);
      myMoreRRURL.SetLinkGetCachedSpace(m_asOwner);
      myMoreRRURL.SetControl(DirRepostControl.STR_MVC_CLASS_NAME);
      try
      {
        // Open create folder popup function
        XPStringBuilder sb = new XPStringBuilder(200);
        sb.Append("function ").Append(DirConstants.JAVASCRIPT_CARDPROPERTIES_MOREDOCS).Append("(rrFolderID)\n");
        sb.Append("{\n");
        sb.Append("  location=\'").Append(myMoreRRURL.GetURLAsString()).Append("&").Append(DirConstants.QS_MOREFOLDERID).Append("=\'+").Append("rrFolderID;\n");
        sb.Append("}\n");
        myScript.AddInnerHTMLString(sb.ToString());
      }
      catch (HTMLException he)
      {
        log.Error(he, "DirCardPropertiesView::DisplayJavascript An error occured when trying to display the JavaScript.");
        throw new XPException(m_asOwner.GetString(125, "ptmsgs_portalbrowsingmsgs"),
         he);
      }
      return myScript;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_model = model;
      m_asOwner = parent;
    }
  }
}