using System;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.directory.senddoc
{
  /// <author>
  /// stephenc
  /// copied from CodePopUpDP
  /// </author>
  public class SendDocPopUpDP : AFormDP
  {
    public const String STR_MVC_CLASS_NAME = "SendDocPopUpDP";
    
    /// <summary>
    /// This is a helper method that all classes that inherit from AFormDP and want to
    /// have the Done and Cancel buttons displayed in the header for them need to
    /// implement.  The method should return the title add whatever HTML the child
    /// class wants to display to the body argument.  The parent class will then add
    /// that HTML to the HTMLPage after filling in the banner and navigation.
    /// Override this method to set the form title
    /// </summary>
    /// <returns>String the title for the form header (if used)</returns>
    public override String GetFormTitle()
    {
      return m_asOwner.GetString(1508, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.PlumtreeDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      result.AddInnerHTMLElement(m_asOwner.GetView(SendDocPopUpView.STR_MVC_CLASS_NAME).Display());
      return result;
    }
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection scripts = new HTMLScriptCollection();
      HTMLScript myScript;
      myScript = m_asOwner.GetView(SendDocPopUpView.STR_MVC_CLASS_NAME).DisplayJavascript();
      if (null != myScript)
      {
        scripts.AddInnerHTMLElement(myScript);
      }
      return scripts;
    }
  }
}