using System;
// Framework imports
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.browsing.objectselection;
using com.plumtree.portalpages.browsing.objectselection.communities;
using com.plumtree.portalpages.common.helpers;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.editors.community
{
  /// <summary>
  /// This Section contains the HTML for the dependencies page.
  /// </summary>
  /// <author></author>
  public class CommunityDependenciesView : ObjDependenciesView
  {
    //Member variables
    private CreatedHelper m_chHelper = null;
    // <0 use default, 0 none, >0 use specified
    
    /// <summary>
    /// <0 use default, 0 none, >0 use specified 
    /// </summary>
    public const int OFFSET = -1;
    // <0 use default, 0 none, >0 use specified
    
    /// <summary>
    /// <0 use default, 0 none, >0 use specified 
    /// </summary>
    public const int BREAK = -1;
    
    /// <summary>
    /// Class name for the activity space
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "CommunityDependencies";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new CommunityDependenciesView();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(com.plumtree.uiinfrastructure.activityspace.IModelRO,com.plumtree.uiinfrastructure.activityspace.AActivitySpace)"></seealso>
    public override void Init(IModelRO model, AActivitySpace parent)
    {
      base.Init(model, parent);
      m_chHelper = new CreatedHelper(parent, (CommunityEditorModel) model);
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.ObjDependenciesView#GetHTMLForDependencies()"></seealso>
    protected override HTMLElementCollection GetHTMLForDependencies()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLAnchor myAnchor;
      // PAI - have to take the object name off the folder path because communities have their own admin folder,
      // so it looks like the community name is being shown in the path
      String strOriginalParentFolderPath = ((ObjEditorModel) m_model).GetParentFolderPath();
      String strObjectName = ((ObjEditorModel) m_model).GetObjectName();
      int nLengthOfRealFolderPath = strOriginalParentFolderPath.Length - strObjectName.Length;
      String strNewParentFolderPath = XPStringUtility.Substring(strOriginalParentFolderPath,
       0, nLengthOfRealFolderPath - 1);
      //Display the standard success message		
      m_chHelper.displaySuccessMessage(result, m_asOwner.GetString(1468, "ptmsgs_portalbrowsingmsgs"),
       strObjectName, strNewParentFolderPath);
      //Generate a popup URL to invite people to this community
      ASURL asurl = new ASURL(m_asOwner);
      asurl.SetLinkCreateNewSpace(CommunitySelectionEditorAS.STR_MVC_CLASS_NAME,
       m_asOwner);
      asurl.SetControl(InvitationPopupControl.STR_MVC_CLASS_NAME);
      asurl.SetDisplayPage(CommunityInvitationPopupDP.STR_MVC_CLASS_NAME);
      asurl.AddControlArgument(InvitationPopupControl.strTemporaryInvitationID,
       XPConvert.ToString(((CommunityEditorModel) m_model).GetObjectID()));
      asurl.AddControlArgument(InvitationPopupControl.strTemporaryInvitationName,
       ((CommunityEditorModel) m_model).GetObjectName());
      String strJSUtilVersionPrefix = ConfigHelper.GetJSIncluderVersionPrefix(ConfigHelper.JSCOMPONENT_JSUTIL);
      myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
      myAnchor.SetOnClick(strJSUtilVersionPrefix + "PTWindowUtil.openWindow(\'" + asurl.GetURLAsString() + "\', \'SendToOthers\', \'250\',\'600\'); return false;");
      m_chHelper.beginList(result);
      HTMLSpan mySpan = new HTMLSpan();
      mySpan.AddInnerHTMLString(m_asOwner.GetString(1467, "ptmsgs_portalbrowsingmsgs"));
      myAnchor.AddInnerHTMLElement(mySpan);
      m_chHelper.displayListRow(myAnchor);
      //Display the standard warning if everyone has access to this object		
      m_chHelper.displayEveryoneWarning(result, m_model, m_asOwner.GetString(1468,
       "ptmsgs_portalbrowsingmsgs"));
      return result;
    }
  }
}