using System;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.editors.community
{
  // Framework Imports
  
  /// <summary>
  /// This is class is used to print out together the Views for
  /// the Expandable List page of the List Editor.
  /// </summary>
  /// <author>Julie Fournier</author>
  public class CommunityEditorCommPortletDP : EditorDP
  {
    public const String STR_MVC_CLASS_NAME = "CommunityPortlet";
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,
    /// linking to that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      // ***CHANGE_HERE*** Returns the String to display on the left navigation menu, 
      //       linking to that page.
      // ***COMMENT_1*** That String will also be printed out in the page header, so
      //     even if you don't use the left nav menu, it should still return something.
      return (m_asOwner.GetString(232, "ptmsgs_portalbrowsingmsgs"));
    }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1081, "ptmsgs_portalbrowsingmsgs"),
       this.m_asOwner);
    }
    // Strings to localize.
    // ***CHANGE_HERE*** List of the Strings that need to be localized.
    // ***COMMENT_1*** The names should all start with "_ui_".
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for that Page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()"></seealso>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // Insert super class HTML
      result.AddInnerHTMLElement(base.PageDisplay());
      HTMLElementCollection views = new HTMLElementCollection();
      // ***CHANGE_HERE SELECTPTOBJECT*** Display the list.
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(CommunityEditorAS.PLUGIN_COMMUNITY_PORTLET_LIST)).Display());
      result.AddInnerHTMLElement(CreateLeftNavBar(views));
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(CommunityEditorAS.PLUGIN_COMMUNITY_PORTLET_LIST).DisplayJavascript());
      return myScripts;
    }
  }
}