using System;
// Framework Imports
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.editors.community
{
  /// <author>MichaelD</author>
  public class CommunityEditorPortletPreferencesDP : EditorDP
  {
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "CommunityEditorPortletPreferences";
    
    /// <summary>
    /// Constructor for CommunityEditorPortletPreferencesDP 
    /// </summary>
    public CommunityEditorPortletPreferencesDP() : base()
    {
      base.SetContentTableCellSpacing("0");
    }
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,  linking to
    /// that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(233, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1082, "ptmsgs_portalbrowsingmsgs"),
       this.m_asOwner);
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for the General Info page.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException </throws>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // Insert super class HTML
      result.AddInnerHTMLElement(base.PageDisplay());
      HTMLElementCollection views = new HTMLElementCollection();
      // ***CHANGE_HERE*** For each Section you want to display on that page, 
      //       copy the line bellow and change the name of the Section.
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(PortletPreferencesView.STR_MVC_CLASS_NAME)).Display());
      // ***CHANGE_HERE PLUG-IN ONLY*** (delete if you are not using a plug-in section)
      //      This is where you print out the plug-in view.
      //views.AddInnerHTMLElement(m_asOwner.GetView(SamplePlugInView.STR_MVC_CLASS_NAME).Display());
      result.AddInnerHTMLElement(CreateLeftNavBar(views));
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      // ***CHANGE_HERE*** If that DP doesn't have any JavaScripts, 
      //      you can delete the entire DisplayJavaScriptFromChild() method.
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      // ***CHANGE_HERE*** Call the DisplayJavascript() method for all the Views having JavaScripts 
      //      displayed by that DP.
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(PortletPreferencesView.STR_MVC_CLASS_NAME).DisplayJavascript());
      HTMLScript script = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
      script.SetSrc(ConfigHelper.GetPortalImageServerJavaScriptURL(m_asOwner) + "opennewwindow.js");
      myScripts.AddInnerHTMLElement(script);
      return myScripts;
    }
  }
}