using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.common.constants;
using com.plumtree.portaluiinfrastructure.expandablelist.template;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.xpshared.htmlconstructs;
namespace com.plumtree.portalpages.browsing.editors.community
{
  /// <author>michaeld</author>
  public class CommunityTemplateSelectorModel : TemplateListModel
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.editors.community.CommunityTemplateSelectorModel");
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "CommunityTemplateSelector";
    public virtual void InitializeCommunityTemplateSelector(IPTSession _Session,
     int _nCommunityTemplateID, bool bInheritCommunityTemplate, int _nListKey)
    {
      if (0 == _nCommunityTemplateID)
      {
        // template not selected yet
        SetAddLabel(m_asOwner.GetString(307, ResourceConstants.PORTALBROWSINGMSGS));
        } else
      {
        SetAddLabel(m_asOwner.GetString(1236, ResourceConstants.PORTALBROWSINGMSGS));
        }
      InitializeTemplateList(_Session, PT_CLASSIDS.PT_COMMUNITYTEMPLATE_ID,
       _nCommunityTemplateID, bInheritCommunityTemplate, m_asOwner.GetString(1817,
       ResourceConstants.PORTALBROWSINGMSGS), PTImageType.ICON_COMMUNITY_TEMPLATE,
       _nListKey);
    }
    
    /// <summary>
    /// Instead of adding rows on repost we are setting the community template which can add a few rows at once.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListModel#AddRowsOnRepost(XPHashtable)"></seealso>
    public override void AddRowsOnRepost(XPHashtable _htFormData)
    {
      base.AddRowsOnRepost(_htFormData);
      String strCommunityTemplateName = XPConvert.ToString(m_saData.GetItem(0,
       TemplateListModel.EXPLIST_COL_TEMPLATE_NAME));
      int nCommunityTemplateID = XPConvert.ToInteger(m_saData.GetItem(0, TemplateListModel.EXPLIST_COL_TEMPLATE_ID));
      if (!("").Equals(strCommunityTemplateName))
      {
        // store the community.
        ((CommunityEditorModel) m_asOwner.GetModel(CommunityEditorAS.STR_MVC_CLASS_NAME)).CommunityTempStore();
        if (0 != nCommunityTemplateID)
        {
          m_sAddLabel = m_asOwner.GetString(1236, "ptmsgs_portalbrowsingmsgs");
          }
      }
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new CommunityTemplateSelectorModel();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}