using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.browsing.editors.community
{
  /// <author>robertz</author>
  public class HeaderAndFooterRepostControl : EditorHelperRepostControl
  {
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "HeaderAndFooterRepost";
    public const int POSTTOSELF_ACTION_SELECTHEADER = 50;
    public const int POSTTOSELF_ACTION_SELECTFOOTER = 51;
    public const int POSTTOSELF_ACTION_USEDEFAULTHEADER = 52;
    public const int POSTTOSELF_ACTION_USEDEFAULTFOOTER = 53;
    public const int POSTTOSELF_ACTION_SETUSEFORCE_SUBPORTAL = 54;
    public const int POSTTOSELF_ACTION_DONOTFORCE_SUBPORTAL = 55;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new HeaderAndFooterRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call  the associated method for each
    /// action.
    /// </summary>
    /// <param name="_nAction"></param>
    public override void PerformRepostAction(int _nAction, XPHashtable _htFormData)
    {
      switch (_nAction){
      case POSTTOSELF_ACTION_SELECTHEADER:
      ((IHeaderAndFooterModel) m_model).RefreshItemFromHeaderTree(_htFormData);
      break;
      case POSTTOSELF_ACTION_SELECTFOOTER:
      ((IHeaderAndFooterModel) m_model).RefreshItemFromFooterTree(_htFormData);
      break;
      case POSTTOSELF_ACTION_USEDEFAULTHEADER:
      ((IHeaderAndFooterModel) m_model).SetDefaultHeaderOrFooter(true);
      break;
      case POSTTOSELF_ACTION_USEDEFAULTFOOTER:
      ((IHeaderAndFooterModel) m_model).SetDefaultHeaderOrFooter(false);
      break;
      case POSTTOSELF_ACTION_SETUSEFORCE_SUBPORTAL:
      ((IHeaderAndFooterModel) m_model).SetUseForceSubPortal(true);
      break;
      case POSTTOSELF_ACTION_DONOTFORCE_SUBPORTAL:
      ((IHeaderAndFooterModel) m_model).SetUseForceSubPortal(false);
      break;
      }
    }
  }
}