using System;
namespace com.plumtree.portalpages.browsing.editors.community
{
  /// <summary>
  /// This interface is implemented by CommunityEditorModel. It
  /// contains all the read-only mothods needed for PageListView.
  /// </summary>
  /// <author>MichaelD</author>
  public interface IPageListModelRO
  {
    
    /// <summary>
    /// Get the value for the given input.
    /// </summary>
    /// <returns>String</returns>
    String GetInputValue(String name);
    
    /// <summary>
    /// Returns the number of pages selected.
    /// </summary>
    /// <returns>int nPageCount</returns>
    int GetPageCount();
  }
}