using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.browsing.editors.dircommon.doctype
{
  /// <summary>
  /// This Control contains the repost actions of the plug-in section.
  /// </summary>
  /// <author>StephenC</author>
  public class DocTypePlugInRepostControl : EditorHelperRepostControl
  {
    public const String STR_MVC_CLASS_NAME = "DocTypePlugIn";
    // JF- repost actions for that section
    
    /// <summary>
    /// Repost that occurs when the DocType is chosen via Tree Section 
    /// </summary>
    public const int POSTTOSELF_ACTION_DOCTYPE_CHOSEN = 40;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new DocTypePlugInRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Performs action on repost.
    /// </summary>
    /// <param name="_nAction"></param>
    /// <param name="_htFormData"></param>
    public override void PerformRepostAction(int _nAction, XPHashtable _htFormData)
    {
      switch (_nAction){
      case POSTTOSELF_ACTION_DOCTYPE_CHOSEN:
      ((DocTypePlugInModel) m_model).RefreshItemFromTree();
      break;
      }
    }
  }
}