using System;
// Plumtree Server
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.portaluiinfrastructure.tree;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.uiinfrastructure.tree;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.editors.dircommon.doctype
{
  /// <author>
  /// StephenC
  /// This Section represents a section of the Main Settings page
  /// of the Card Subimt Editor.
  /// This Section is printed out by CardEditorMainDP.
  /// </author>
  public class DocTypePlugInView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.editors.dircommon.doctype.DocTypePlugInView");
    public const String STR_MVC_CLASS_NAME = "DocTypePlugIn";
    
    /// <summary>
    /// Private String that is the function name for the repost javascript called
    /// when the tree control returns
    /// </summary>
    private const String JSREPOST_DOCTYPE_FUNC = "frmRepostDocTypeChosen";
    // HTML Object names.
    public const String HTMLRADIO_DOCTYPE = "in_ra_DocType";
    public const String HTMLHIDDEN_DOCTYPE = "in_hi_DocTypeServerSpaceID";
    public const String HTMLBUTTON_EDITOR_CHOOSEDOCTYPE = "in_bu_ChooseDocType";
    
    /// <summary>
    /// Our parent Activity space.
    /// </summary>
    private AActivitySpace m_asasParent;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new DocTypePlugInView();
    }
    
    /// <returns></returns>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLInput myInput;
      HTMLSpan mySpan;
      try
      {
        HTMLComment myComment = new HTMLComment("Begin: Display DocTypePlugInView");
        result.AddInnerHTMLElement(myComment);
        result.AddInnerHTMLElement(base.GetHeaderView(m_asOwner.GetString(336,
         "ptmsgs_portalbrowsingmsgs")));
        myTable = new HTMLTable();
        result.AddInnerHTMLElement(myTable);
        myTable.SetWidth("100%");
        myTable.SetBorder("0");
        myTable.SetCellPadding("5");
        myTable.SetCellSpacing("0");
        // BEGIN DocType Row: Default DocType
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(338, "ptmsgs_portalbrowsingmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        int nDocTypeID = ((IDocTypePlugInModelRO) m_model).GetSelectedDocTypeID();
        // ***<input radiobutton>*** begins here
        myInput = new HTMLInput(HTMLInputTypes.RADIO, HTMLRADIO_DOCTYPE, "");
        myInput.SetChecked(0 == nDocTypeID);
        myInput.SetValue("" + 0);
        myCell.AddInnerHTMLElement(myInput);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.FORM_RADIO);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(339, "ptmsgs_portalbrowsingmsgs"));
        // END DocType Row: Default DocType
        // BEGIN DocType Row: THIS DocType
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myInput = new HTMLInput(HTMLInputTypes.RADIO, HTMLRADIO_DOCTYPE, "");
        myInput.SetValue("" + 1);
        myInput.SetChecked(0 != nDocTypeID);
        myCell.AddInnerHTMLElement(myInput);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.FORM_RADIO);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(340, "ptmsgs_portalbrowsingmsgs"));
        // ***<input radio>*** ends here
        // BEGIN doctype tree:
        String strDocTypeName = ((IDocTypePlugInModelRO) m_model).GetSelectedDocTypeName();
        if (("").Equals(strDocTypeName))
        {
          strDocTypeName = m_asOwner.GetString(343, "ptmsgs_portalbrowsingmsgs");
          }
        mySpan.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strDocTypeName));
        mySpan.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        // Hidden input for the Space ID for the tree.  That way if you hit the user
        // tree link twice, it will open the same tree both times.
        myInput = new HTMLInput(HTMLInputTypes.HIDDEN, HTMLHIDDEN_DOCTYPE,
         "");
        result.AddInnerHTMLElement(myInput);
        String strDocTypeServerSpaceID = ((IDocTypePlugInModelRO) m_model).GetDocTypeSubSpaceID();
        if (strDocTypeServerSpaceID.Equals(DocTypePlugInModel.DEFAULTDATA))
        {
          myInput.SetValue("");
        } else
        {
          myInput.SetValue(strDocTypeServerSpaceID);
        }
        // Choose DocType button
        myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_EDITOR_CHOOSEDOCTYPE,
         "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetValue(m_asOwner.GetString(342, "ptmsgs_portalbrowsingmsgs"));
        myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
        // mj: removed 'Javascript:' from function name
        myInput.SetOnClick("OpenDocTypeTree(document." + AFormDP.HTMLFORM_NAME + "." + HTMLHIDDEN_DOCTYPE + ");");
        // END doctype tree:
        // END DocType Row: THIS DocType
        /////////////////////////////////////////////
        myComment = new HTMLComment("End: Display CardSubmitAdvancedDataSourceView");
        result.AddInnerHTMLElement(myComment);
      }
      catch (HTMLException he)
      {
        log.Error(he, STR_MVC_CLASS_NAME + "::Display The following error occured when trying to display the HTML: " + he.Message);
        throw new XPException(m_asOwner.GetString(341, "ptmsgs_portalbrowsingmsgs"),
         he);
      }
      return result;
    }
    
    /// <summary>
    /// This method returns the HTMLScript that encompasses the Javascript on the page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    /// <returns>HTMLScript</returns>
    public override HTMLScript DisplayJavascript()
    {
      String strFormName = AFormDP.HTMLFORM_NAME;
      HTMLScript result = new HTMLScript("text/javaScript");
      XPStringBuilder sb;
      try
      {
        // The URL to open a new tree
        ASURL myNewTree = new ASURL(m_asOwner);
        myNewTree.SetLinkCreateNewSpace(TreeAS.STR_MVC_CLASS_NAME, m_asOwner);
        myNewTree.SetSubSpaceKey(((IDocTypePlugInModelRO) m_model).GetDocTypeTREESUBSPACE());
        myNewTree.SetControl(StartTreeControl.STR_MVC_CLASS_NAME);
        myNewTree.AddControlArgument(StartTreeControl.MULTI_SELECT, XPConvert.ToString(false));
        myNewTree.AddControlArgument(StartTreeControl.ROOT_ID, "1");
        myNewTree.AddControlArgument(StartTreeControl.SUBMIT_MODE, XPConvert.ToString(TreeConstants.N_SERVERSUBMIT));
        myNewTree.AddControlArgument(StartTreeControl.SELECT_MODE, XPConvert.ToString(TreeConstants.N_LEAFSELECT));
        myNewTree.AddControlArgument(StartTreeControl.PARENT_FORM_NAME, strFormName);
        myNewTree.AddControlArgument(StartTreeControl.PARENT_FORM_SPACE_ID,
         HTMLHIDDEN_DOCTYPE);
        //See DisplayJavascript below for the definition of frmRepostRemoteViewChosen
        myNewTree.AddControlArgument(StartTreeControl.PARENT_SUBMIT_CALL,
         JSREPOST_DOCTYPE_FUNC);
        myNewTree.AddControlArgument(StartTreeControl.CLASS_IDS_TO_DISPLAY,
         XPConvert.ToString(PT_CLASSIDS.PT_DOCUMENTTYPE_ID));
        // The url to open a previously opened server user tree
        // This needs to have the SpaceID added to it.
        ASURL myOldTree = new ASURL(m_asOwner);
        myOldTree.SetLinkCreateNewSpace(TreeAS.STR_MVC_CLASS_NAME, m_asOwner);
        myOldTree.IsSubSpace();
        // Open server user tree function
        sb = new XPStringBuilder(200);
        sb.Append("function OpenDocTypeTree(myInput)\n");
        sb.Append("{\n");
        sb.Append("  if (myInput.value == \'\') {\n");
        sb.Append("    window.open(\'").Append(myNewTree.GetURLAsString()).Append("\', \'_blank3\', \'").Append(TreeConstants.GetJavascriptTreeWindowAttributes()).Append("\');\n");
        sb.Append("  } else {\n");
        sb.Append("    window.open(\'").Append(myOldTree.GetURLAsString()).Append("&").Append(ASConstants.SPACEID).Append("=\' + myInput.value").Append(", \'_blank3\', \'").Append(TreeConstants.GetJavascriptTreeWindowAttributes()).Append("\');\n");
        sb.Append("  }\n");
        sb.Append("}\n");
        result.AddInnerHTMLString(sb.ToString());
        sb = new XPStringBuilder(150);
        sb.Append("function ");
        sb.Append(JSREPOST_DOCTYPE_FUNC);
        sb.Append("()\n {\n\t").Append(AFormDP.JAVASCRIPT_SUBMIT_FORM).Append("(");
        sb.Append(DocTypePlugInRepostControl.POSTTOSELF_ACTION_DOCTYPE_CHOSEN);
        sb.Append(");\n}\n");
        result.AddInnerHTMLString(sb.ToString());
      }
      catch (HTMLException he)
      {
        log.Error(he, STR_MVC_CLASS_NAME + "::DisplayJavascript couldn\'t add javascript to the HTMLScript element: " + he.Message);
        }
      return result;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public override void Init(IModelRO model, AActivitySpace parent)
    {
      base.Init(model, parent);
      m_asasParent = parent;
    }
  }
}