using System;
namespace com.plumtree.portalpages.browsing.editors.dircommon.doctype
{
  /// <author>
  /// StephenC
  /// This interface is implemented by the Model.
  /// It contains all the read-only mothods of the Model
  /// accessed by the Views.
  /// </author>
  public interface IDocTypePlugInModelRO
  {
    
    /// <summary>
    /// returns the value of the radio control (0 for default doctype, 1 otherwise)
    /// </summary>
    int GetDocTypeChoice();
    
    /// <summary>
    /// returns the name of a given doctype.
    /// </summary>
    String GetDocTypeName(int nDocTypeID);
    
    /// <returns></returns>
    String GetDocTypeSubSpaceID();
    
    /// <returns></returns>
    String GetDocTypeTREESUBSPACE();
    
    /// <summary>
    /// returns the currently selected DocType ID
    /// </summary>
    int GetSelectedDocTypeID();
    
    /// <summary>
    /// returns the currently selected DocType Name
    /// </summary>
    String GetSelectedDocTypeName();
  }
}