using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.directory;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.resultwrapper;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.activityspace.utils;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
//Put explicit import for Interpreter (to avoid ambiguity of using the deprecated class)
using Interpreter=com.plumtree.uiinfrastructure.interpreter.Interpreter;
namespace com.plumtree.portalpages.browsing.editors.directory.submit_D
{
  /// <author>
  /// joseq
  /// This view shows datasource that user can select before 
  /// submitting a document in 508. 
  /// </author>
  public class DirDataSourceView_D : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.editors.directory.submit_D.DirDataSourceView_D");
    public const String STR_MVC_CLASS_NAME = "DirDataSourceView_D";
    public const String HTMLSELECT_CardDataSource = "in_se_CardDataSource";
    private AActivitySpace m_asOwner;
    private IDirModelRO m_asModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new DirDataSourceView_D();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Display()"></seealso>
    public virtual HTMLElement Display()
    {
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLSpan mySpan;
      HTMLInput myInput;
      HTMLSelect mySelect;
      // TODO CR not used, commenting out.
      //HTMLOption myOption;
      HTMLTable myTable = new HTMLTable();
      myTable.SetBorder("0");
      myTable.SetWidth("100%");
      myTable.SetCellPadding("1");
      myTable.SetCellSpacing("0");
      myTable.SetSummary(m_asOwner.GetString(1147, "ptmsgs_portalbrowsingmsgs"));
      HTMLElementCollection result = new HTMLElementCollection();
      try
      {
        HTMLComment myComment = new HTMLComment("Begin: Display DirDataSourceView_D");
        result.AddInnerHTMLElement(myComment);
        result.AddInnerHTMLElement(myTable);
        // create the datasource dropdown and also find out the active datasource id
        mySelect = new HTMLSelect(HTMLSELECT_CardDataSource, "e");
        mySelect.SetStyleClass(PTStyleClass.FORM_PULLDOWN_TEXT);
        // TODO CR not used, commenting out.
        InitiateDataSources(mySelect);
        // BEGIN Choose Data Source Step1 Row
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(1753, "ptmsgs_portalbrowsingmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        // END Choose Data Source Step1 Row
        // BEGIN Choose Data Source Instructions Row & help
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(1754, "ptmsgs_portalbrowsingmsgs"));
        /* help */
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.SetAlign(CommonHTMLStrings.RIGHT);
        HTMLAnchor helpAnchor = HTMLConstructHelpers.GetHelpAnchor(m_asOwner);
        helpAnchor.SetAccessKey(m_asOwner.GetString(11, "ptmsgs_portal508quickkeymsgs"));
        myCell.AddInnerHTMLElement(helpAnchor);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        // END Choose Data Source Instructions Row
        // Add extra spacer row
        myTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(3, 20));
        // BEGIN Card Source Select Box Title Row
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_BTN_TEXT);
        myCell.AddInnerHTMLString(m_asOwner.GetString(1755, "ptmsgs_portalbrowsingmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        // END Card Source Select Box Title Row
        // BEGIN Card Source Select Box Row
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.FORM_PULLDOWN_TEXT);
        myCell.AddInnerHTMLElement(mySelect);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        // END Card Source Select Box Row
        // Add extra spacer row
        myTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(3, 40));
        // BEGIN Next and Cancel buttons
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.BAN_HEADER_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetHeight("40");
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetHeight("40");
        myCell.SetStyleClass(PTStyleClass.OBJECT_BTN);
        myCell.SetAlign(CommonHTMLStrings.CENTER);
        // Next button
        myInput = new HTMLInput(HTMLInputTypes.SUBMIT, RepostControl.HTMLSUBMIT_508_POSTTOSELF + DirRepostControl.POSTTOSELF_ACTION_CARDSUBMIT508_SUBMIT_DS,
         "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetValue(m_asOwner.GetString(1139, "ptmsgs_portalbrowsingmsgs"));
        myInput.SetAccessKey(m_asOwner.GetString(26, "ptmsgs_portal508quickkeymsgs"));
        myInput.SetTitle(m_asOwner.GetString(28, "ptmsgs_portal508quickkeymsgs"));
        myInput.SetStyleClass(PTStyleClass.OBJECT_BTN_TEXT);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        // Cancel button
        myInput = new HTMLInput(HTMLInputTypes.SUBMIT, RepostControl.HTMLSUBMIT_508_POSTTOSELF + DirRepostControl.POSTTOSELF_ACTION_CARDSUBMIT508_CANCEL,
         "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetValue(m_asOwner.GetString(82, "ptmsgs_portalbrowsingmsgs"));
        myInput.SetAccessKey(m_asOwner.GetString(27, "ptmsgs_portal508quickkeymsgs"));
        myInput.SetTitle(m_asOwner.GetString(29, "ptmsgs_portal508quickkeymsgs"));
        myInput.SetStyleClass(PTStyleClass.OBJECT_BTN_TEXT);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetHeight("40");
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        // END Next and Cancel buttons
        myComment = new HTMLComment("End: Display DirDataSourceView_D");
        result.AddInnerHTMLElement(myComment);
      }
      catch (HTMLException he)
      {
        log.Error(he, STR_MVC_CLASS_NAME + "::MainView::Display The following error occured when trying to display the HTML: " + he.Message);
        throw new XPException(m_asOwner.GetString(80, "ptmsgs_portalbrowsingmsgs"),
         he);
      }
      return result;
    }
    private int InitiateDataSources(HTMLSelect _myDSHtmlSelect)
    {
      // get the availabe datasources for this user
      int nDefaultDataSource = m_asModel.GetCardSubmitDataSource();
      IASQueryResult asqrFilters = m_asModel.GetFilteredDataSources();
      // TODO CR not used, commenting out.
      //boolean bHasAccessToAtLeastOneDataSource 	= false;
      bool bDefaultDataSourceVisible = false;
      int nFirstDataSource = -1;
      int nDataSourceCount = 0;
      if (null != asqrFilters)
      {
        nDataSourceCount = asqrFilters.GetCount();
        if (0 != nDataSourceCount)
        {
        }
      }
      // TODO CR not used, commenting out.
      //bHasAccessToAtLeastOneDataSource = true;
      // BEGIN DATASOURCE DROPDOWN
      if (null != asqrFilters)
      {
        // set up some html variables that we will use in the for loop
        HTMLOption myOption;
        HTMLSpan mySpan;
        BrowserType browser = (BrowserType) m_asOwner.GetSubSession().GetAttribute(Interpreter.BROWSERTYPE);
        bool isNetscape = browser.IsNetscape() || browser.IsNetscape4();
        // iterate thru datasources
        String strPropName;
        for (int i = 0;i < nDataSourceCount;i++)
        {
          int nDataSourceID = XPConvert.ToInteger(asqrFilters.GetFields(i,
           PT_PROPIDS.PT_PROPID_OBJECTID));
          // If the default datasource does not appear (because of security),
          // then the first datasource will be selected by default.
          if (0 == i)
          {
            nFirstDataSource = nDataSourceID;
          }
          /* we need to remove extra chars for display purposes */
          // SCC: it should be noted that the "m" charater is much wider than the "i" character.
          //      so while a name like "iiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii" might fit, the
          //      same name with "m"'s will not with non fixed-length fonts.
          // need bigger text boxes for netscape
          strPropName = GeneralHelpers.TruncateLongString(m_asModel.GetDataSourceName(nDataSourceID),
           ObjEditorModel.OBJECT_NAME_TRUNCATE - (isNetscape ? 20 : 15), false);
          myOption = new HTMLOption(XPConvert.ToString(nDataSourceID));
          mySpan = new HTMLSpan();
          myOption.AddInnerHTMLElement(mySpan);
          mySpan.AddInnerHTMLEncodedString(strPropName);
          _myDSHtmlSelect.AddInnerHTMLElement(myOption);
          if (nDataSourceID == nDefaultDataSource)
          {
            myOption.SetSelected(true);
            bDefaultDataSourceVisible = true;
          }
        }
      }
      // END DATASOURCE DROPDOWN
      // Which Datasource is currently active?
      return bDefaultDataSourceVisible ? nDefaultDataSource : nFirstDataSource;
      }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asModel = (IDirModelRO) model;
      m_asOwner = parent;
    }
  }
}