using System;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.directory;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.errordisplay;
namespace com.plumtree.portalpages.browsing.editors.directory.submit_D
{
  /// <author>
  /// joseq
  /// TODO To change the template for this generated type comment go to
  /// Window - Preferences - Java - Code Style - Code Templates
  /// </author>
  public class DirSubmitAS_D : PTEditorAS
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.editors.directory.submit_D.DirSubmitAS_D");
    public const String STR_MVC_CLASS_NAME = "DirSubmitAS_D";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new DirSubmitAS_D();
    }
    
    /// <summary>
    /// Returns the Editor title.
    /// </summary>
    /// <returns>String</returns>
    public override String GetEditorTitle()
    {
      return GetString(1188, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.AActivitySpace#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the name of the repost control class.
    /// </summary>
    /// <seealso cref="com.plumtree.xpshared.form.IRepostAS#GetRepostControlName()"></seealso>
    /// <returns>String</returns>
    public override String GetRepostControlName()
    {
      return DirRepostControl.STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.AActivitySpace#Init()"></seealso>
    public override void Init()
    {
      m_strModelName = DirSubmitModel_D.STR_MVC_CLASS_NAME;
      base.Init();
      // This activity space is only valid if the parent is the DirAS
      // the DirModel does all the work.
      AActivitySpace parentAS = GetParentSpace();
      if (null == parentAS)
      {
        UIError myError = new UIError(UIErrorLevel.FRIENDLY, UIErrorScope.CURRENT_USER,
         GetString(1801, "ptmsgs_portalbrowsingmsgs"), "DirSubmitAS_D.Init - The parent AS is null.");
        UIErrorHandler.RaiseError(myError, GetSubSession(), GetApplication());
        return;
      }
      IModel dirModel = parentAS.GetModel(DirModel.STR_MVC_CLASS_NAME);
      // Start a menu but hide it.
      int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(71, "ptmsgs_portalbrowsingmsgs"));
      m_mEditorMenu.HideSubMenu(true, nMenuOneID);
      // Directory Controls
      RegisterControl(DirRepostControl.STR_MVC_CLASS_NAME, dirModel);
      // 508 pages and views
      RegisterPage(new DirSubmitCardDP_D());
      RegisterPage(new DirDataSourceDP_D());
      RegisterPage(new DirSubmitDoneDP_D());
      RegisterView(DirSubmitDoneView_D.STR_MVC_CLASS_NAME, dirModel);
      RegisterView(DirSubmitCardView_D.STR_MVC_CLASS_NAME, dirModel);
      RegisterView(DirDataSourceView_D.STR_MVC_CLASS_NAME, dirModel);
      SetCurrentPage(DirDataSourceDP_D.STR_MVC_CLASS_NAME);
      this.SetHelpTopic("PT_Submit_SimpleDocument");
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(java.lang.String, java.lang.String, boolean)
     */
     
    public override bool CheckBasicAccess(String strPage, String strControl,
     bool bSameSpace)
    {
      AActivitySpace myParentAS = GetParentSpace();
      if (null == myParentAS || !(myParentAS is DirAS))
      {
        log.Error("DirSubmitAS_D.CheckBasicAccess - The parent editor must be DirAS.");
        return false;
      }
      return true;
    }
  }
}