using System;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.directory;
using com.plumtree.portalpages.browsing.directory.documentsubmitsimple;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.editors.directory.submit_D
{
  /// <author>StephenC</author>
  public class DirSubmitCardDP_D : EditorDP
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.editors.directory.submit_D.DirSubmitCardDP_D");
    public const String STR_MVC_CLASS_NAME = "DirSubmitCardDP_D";
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.editor.EditorDP#GetLeftNavString()
     */
     
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(1188, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#Init(AActivitySpace)"></seealso>
    public override void Init(AActivitySpace parent)
    {
      base.Init(parent);
      SetShow508FormFooter(false);
      parent.SetHelpTopic("PT_Submit_SimpleDocument");
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.form.AFormDP#DisplayForm()
     */
     
    public override HTMLForm DisplayForm()
    {
      // if the datasource selected was the file upload ds, then we need to 
      // change the form's action to submit to the FU webservice
      //((DirSubmitModel_D) m_asOwner.GetModel(DirSubmitModel_D.STR_MVC_CLASS_NAME)).GetDirModel();
      IDirModelRO myModel = (IDirModelRO) m_asOwner.GetParentSpace().GetModel(DirModel.STR_MVC_CLASS_NAME);
      int nDataSource = myModel.GetCardSubmitDataSource();
      if (myModel.SupportsUpload(nDataSource))
      {
        int webServiceID = ((DirModel) myModel).GetWebServiceID(nDataSource);
        // create a gateway prefix
        String gwUrl = GatewayHelpers.ConstructPrefPageLink(m_asOwner, webServiceID,
         0, 0, 0, PT_CLASSIDS.PT_WEBSERVICE_ID);
        // create an asurl for the return url 
        ASURL myCardSubmitURL = new ASURL(m_asOwner);
        myCardSubmitURL.SetLinkCreateNewSpace(DirSubmitAS_D.STR_MVC_CLASS_NAME,
         m_asOwner.GetParentSpace());
        myCardSubmitURL.SetControl(DirRepostControl.STR_MVC_CLASS_NAME);
        // the upload url is the gatewayed WS url with the returnURL as a QS parameter
        String sUploadUrl = gwUrl + GatewayHelpers.CreateGatewayFriendlyURL(myModel.GetUploadWSURL(nDataSource) + "?" + DirCardSubmitSimpleView.HTMLINPUT_ReturnURL + "=" + myCardSubmitURL.GetURLAsString());
        // set the form to be multipart; must do this before calling super.DispalyForm()
        // to get the form.
        ((AFormDP) m_asOwner.GetPage(DirSubmitCardDP_D.STR_MVC_CLASS_NAME)).SetMultiPartEncoding(true);
        // set the action
        HTMLForm myForm = base.DisplayForm();
        myForm.SetAction(sUploadUrl);
        return myForm;
      } else
      {
        return base.DisplayForm();
      }
    }
    
    /// <summary>
    /// helper display method for PlumtreeDP
    /// Fill in the body argument with HTML to display in the page.
    /// </summary>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection wholePageGroup = new HTMLElementCollection();
      try
      {
        wholePageGroup.AddInnerHTMLElement(m_asOwner.GetView(DirSubmitCardView_D.STR_MVC_CLASS_NAME).Display());
        }
      catch (HTMLException he)
      {
        log.Error(he, "Error in DirSubmitCardDP_D::Display: " + he.Message);
        }
      return wholePageGroup;
    }
  }
}