using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.directory;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.browsing.editors.directory.submit_D
{
  /// <author>
  /// joseq
  /// This Model doesn't do anything.  It's a dummy model for DirSubmitAS_D,
  /// the 508 Editor for submitting cards in the KD.  It's purpose is just 
  /// so that the DIrSubmitAS_D has an Editor model to register and to check 
  /// that the parent AS/Model is the DirAS.  All the real work is done in
  /// DirModel. 
  /// </author>
  public class DirSubmitModel_D : EditorModel
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.editors.directory.submit_D.DirSubmitModel_D");
    public const String STR_MVC_CLASS_NAME = "DirSubmitModel_D";
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IModel#Init(com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
     */
     
    public override void Init(AActivitySpace parent)
    {
      base.Init(parent);
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
     */
     
    public override Object Create()
    {
      return new DirSubmitModel_D();
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
     */
     
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.editor.EditorModel#CheckEditorAccessAndStart(com.plumtree.openfoundation.util.XPHashtable)
     */
     
    public override bool CheckEditorAccessAndStart(XPHashtable _htFormData)
    {
      AActivitySpace myParentAS = m_asOwner.GetParentSpace();
      if (null == myParentAS || !(myParentAS is DirAS))
      {
        log.Error("DirSubmitModel_D.CheckEditorAccessAndStart - The parent editor must be DirAS.");
        return false;
      }
      return true;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.form.IRepostModel#Finish()
     */
     
    public override void Finish()
    {
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.form.IRepostModel#SavePage(java.lang.String, com.plumtree.openfoundation.util.XPHashtable)
     */
     
    public override int SavePage(String _sPageName, XPHashtable _htFormData)
    {
      return DirRepostControl.PAGE_STATUS_VALID;
    }
  }
}