using System;
// Framework Imports
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.directory;
using com.plumtree.portalpages.browsing.editors.dircommon;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.editors.document
{
  /// <author>
  /// StephenC
  /// This Section represents a section of the Main Settings page
  /// of the Card Editor.
  /// This Section is printed out by CardEditorMainDP.
  /// </author>
  public class CardEditorMainView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.editors.document.CardEditorMainView");
    public const String STR_MVC_CLASS_NAME = "CardEditorMain";
    // HTML Object names.
    public const String HTMLINPUT_CARD_NAME = "in_tx_Name";
    public const String HTMLINPUT_CARD_DESCRIPTION = "in_tx_Description";
    public const String HTMLINPUT_CARD_CRAWLERTAG = "in_tx_CrawlerTag";
    
    /// <summary>
    /// JavaScript function to check name field. 
    /// </summary>
    public const String JAVASCRIPT_CHECKNAME = "CheckName";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new CardEditorMainView();
    }
    
    /// <returns></returns>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLInput myInput;
      HTMLSpan mySpan;
      bool bOdd = false;
      try
      {
        HTMLComment myComment = new HTMLComment("Begin: Display CardEditorMainView MainView");
        result.AddInnerHTMLElement(myComment);
        result.AddInnerHTMLElement(base.GetHeaderView(m_asOwner.GetString(200,
         "ptmsgs_portalbrowsingmsgs")));
        myTable = new HTMLTable();
        result.AddInnerHTMLElement(myTable);
        myTable.SetWidth("100%");
        myTable.SetBorder("0");
        myTable.SetCellPadding("2");
        myTable.SetCellSpacing("2");
        /////////////////////////
        // Basic Card Properties
        // BEGIN Basic Column Headers ROW
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.LIST_SORT_HEADER_BG);
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myCell.SetWidth("25%");
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(201, "ptmsgs_portalbrowsingmsgs"));
        myCell = new HTMLTableCell();
        myCell.SetWidth("80%");
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(202, "ptmsgs_portalbrowsingmsgs"));
        // END Basic Column Headers ROW
        // BEGIN Card Name
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(bOdd ? PTStyleClass.LIST_ITEM_ONE_BG : PTStyleClass.LIST_ITEM_TWO_BG);
        myCell = new HTMLTableCell();
        myCell.SetHeight("25");
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.LIST_SUBTITLE);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(203, "ptmsgs_portalbrowsingmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_CARD_NAME,
         "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
        myInput.SetValue(((ObjEditorModel) m_model).GetObjectName());
        myInput.SetMaxLength(255);
        myInput.SetSize(80);
        bOdd = !bOdd;
        // END Card Name
        // BEGIN Card Description
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(bOdd ? PTStyleClass.LIST_ITEM_ONE_BG : PTStyleClass.LIST_ITEM_TWO_BG);
        myCell = new HTMLTableCell();
        myCell.SetHeight("25");
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.LIST_SUBTITLE);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(204, "ptmsgs_portalbrowsingmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_CARD_DESCRIPTION,
         "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
        myInput.SetValue(((ObjEditorModel) m_model).GetObjectDescription());
        myInput.SetMaxLength(255);
        myInput.SetSize(80);
        bOdd = !bOdd;
        // END Card Description
        // BEGIN Crawler Tag
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(bOdd ? PTStyleClass.LIST_ITEM_ONE_BG : PTStyleClass.LIST_ITEM_TWO_BG);
        myCell = new HTMLTableCell();
        myCell.SetHeight("25");
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.LIST_SUBTITLE);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(1636, "ptmsgs_portalbrowsingmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_CARD_CRAWLERTAG,
         "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
        myInput.SetValue(((ICardEditorModelRO) m_model).GetCrawlerTag());
        myInput.SetMaxLength(255);
        myInput.SetSize(80);
        bOdd = !bOdd;
        // END Crawler Tag
        /* basic object ids */
        // the class ID -jas
        int iClassID = ((ICardEditorModelRO) m_model).GetClassID();
        if (0 != iClassID)
        {
          myRow = new HTMLTableRow();
          myTable.AddInnerHTMLElement(myRow);
          myRow.SetStyleClass(bOdd ? PTStyleClass.LIST_ITEM_ONE_BG : PTStyleClass.LIST_ITEM_TWO_BG);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          myCell.SetHeight("25");
          mySpan = new HTMLSpan();
          mySpan.SetStyleClass(PTStyleClass.LIST_SUBTITLE);
          mySpan.AddInnerHTMLString(m_asOwner.GetString(1881, "ptmsgs_portalbrowsingmsgs"));
          myCell.AddInnerHTMLElement(mySpan);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          myCell.SetAlign(CommonHTMLStrings.LEFT);
          myCell.AddInnerHTMLString(XPConvert.ToString(iClassID));
          bOdd = !bOdd;
        }
        // Fourth row, the object ID -jas
        int iObjectID = ((ICardEditorModelRO) m_model).GetObjectID();
        if (0 != iObjectID)
        {
          myRow = new HTMLTableRow();
          myTable.AddInnerHTMLElement(myRow);
          myRow.SetStyleClass(bOdd ? PTStyleClass.LIST_ITEM_ONE_BG : PTStyleClass.LIST_ITEM_TWO_BG);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          myCell.SetHeight("25");
          mySpan = new HTMLSpan();
          mySpan.SetStyleClass(PTStyleClass.LIST_SUBTITLE);
          mySpan.AddInnerHTMLString(m_asOwner.GetString(1882, "ptmsgs_portalbrowsingmsgs"));
          myCell.AddInnerHTMLElement(mySpan);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          myCell.SetAlign(CommonHTMLStrings.LEFT);
          myCell.AddInnerHTMLString(XPConvert.ToString(iObjectID));
          bOdd = !bOdd;
        }
        // Fifth row, the UUID -jas
        String strUUID = ((ICardEditorModelRO) m_model).GetObjectUUID();
        if (null != strUUID)
        {
          myRow = new HTMLTableRow();
          myTable.AddInnerHTMLElement(myRow);
          myRow.SetStyleClass(bOdd ? PTStyleClass.LIST_ITEM_ONE_BG : PTStyleClass.LIST_ITEM_TWO_BG);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          myCell.SetHeight("25");
          mySpan = new HTMLSpan();
          mySpan.SetStyleClass(PTStyleClass.LIST_SUBTITLE);
          mySpan.AddInnerHTMLString(m_asOwner.GetString(1883, "ptmsgs_portalbrowsingmsgs"));
          myCell.AddInnerHTMLElement(mySpan);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          myCell.SetAlign(CommonHTMLStrings.LEFT);
          myCell.AddInnerHTMLString(strUUID);
          bOdd = !bOdd;
        }
        XPSortedDictionary xpBasicProperties = ((ICardEditorModelRO) m_model).GetBasicCardProperties();
        IXPEnumerator xpEnum;
        CardPropertyObject cpo;
        String strPropValue;
        String strPropName;
        bool bIsURL;
        xpEnum = xpBasicProperties.GetElements();
        while (xpEnum.MoveNext())
        {
          cpo = (CardPropertyObject) xpEnum.GetCurrent();
          strPropName = cpo.m_sPropName;
          strPropValue = cpo.m_sPropValue;
          bIsURL = cpo.m_bIsURL;
          myRow = new HTMLTableRow();
          myTable.AddInnerHTMLElement(myRow);
          myRow.SetStyleClass(bOdd ? PTStyleClass.LIST_ITEM_ONE_BG : PTStyleClass.LIST_ITEM_TWO_BG);
          myCell = new HTMLTableCell();
          myCell.SetHeight("25");
          myRow.AddInnerHTMLElement(myCell);
          mySpan = new HTMLSpan();
          myCell.AddInnerHTMLElement(mySpan);
          mySpan.SetStyleClass(PTStyleClass.LIST_SUBTITLE);
          mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strPropName));
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          mySpan = new HTMLSpan();
          myCell.AddInnerHTMLElement(mySpan);
          mySpan.SetStyleClass(PTStyleClass.LIST_TEXT);
          if (bIsURL)
          {
            String strFittedAndEncodedString = DirConstants.BreakUpStringAndHTMLEncode(strPropValue);
            HTMLAnchor myAnchor = new HTMLAnchor(strPropValue);
            myAnchor.AddInnerHTMLString(strFittedAndEncodedString);
            myAnchor.SetTitle(XPHttpUtility.HtmlEncode(strPropValue));
            mySpan.AddInnerHTMLElement(myAnchor);
          } else
          {
            mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strPropValue));
            }
          bOdd = !bOdd;
        }
        // END Card Document Type
        myComment = new HTMLComment("End: Display CardEditorMainView");
        result.AddInnerHTMLElement(myComment);
      }
      catch (HTMLException he)
      //*CRC olegs - Exception is better
      {
        log.Error(he, STR_MVC_CLASS_NAME + "::Display The following error occured when trying to display the HTML: " + he.Message);
        throw new XPException(m_asOwner.GetString(205, "ptmsgs_portalbrowsingmsgs"),
         he);
      }
      return result;
    }
    
    /// <summary>
    /// Returns Java Script for that Section.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    /// <returns>HTMLScript</returns>
    public override HTMLScript DisplayJavascript()
    {
      HTMLScript myScript;
      try
      {
        XPStringBuilder sb = new XPStringBuilder(300);
        myScript = new HTMLScript("text/javaScript");
        // The JavaScript below checks if the Folder Name is empty.
        sb.Append("function " + JAVASCRIPT_CHECKNAME + "()\n");
        sb.Append("{\n");
        sb.Append("  if (\"\" == document." + EditorDP.HTMLFORM_NAME + "." + HTMLINPUT_CARD_NAME + ".value)\n");
        sb.Append("  {\n");
        sb.Append("      alert(\"" + m_asOwner.GetString(1239, "ptmsgs_portalbrowsingmsgs") + "\");\n");
        sb.Append("      return false;\n");
        sb.Append("  }\n");
        sb.Append("  return true;\n");
        sb.Append("}\n");
        myScript.AddInnerHTMLString(sb.ToString());
      }
      catch (Exception e)
      {
        log.Error(e, STR_MVC_CLASS_NAME + "::DisplayJavascript The following error occured when trying to display the JavaScript: " + e.Message);
        throw new XPException(m_asOwner.GetString(418, "ptmsgs_portalbrowsingmsgs"),
         e);
      }
      return myScript;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}