using System;
// Framework Imports
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.editors.community;
using com.plumtree.portalpages.common.constants;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.tips;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.editors.editportletprefs
{
  /// <version>$Revision$</version>
  /// <author>$author$</author>
  public class EditPortletPrefsAS : PTEditorAS
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.editors.editportletprefs.EditPortletPrefsAS");
    public const String STR_MVC_CLASS_NAME = "EditGadgetPrefs";
    public const String QS_PARAM_COMMUNITYID = "PortletsCommunityID";
    public const String QS_PARAM_PAGEID = "PortletsPageID";
    private const String sClassName = "com.plumtree.portalpages.browsing.editors.editportletprefs.EditPortletPrefsAS";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new EditPortletPrefsAS();
    }
    public override bool CheckBasicAccess(String strPage, String strControl,
     bool bSameSpace)
    {
      return true;
    }
    
    /// <summary>
    /// Returns the Editor title.
    /// </summary>
    /// <returns>String</returns>
    public override String GetEditorTitle()
    {
      return (GetString(377, "ptmsgs_portalbrowsingmsgs"));
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the class name of the Property Repost Control.
    /// </summary>
    /// <returns>String</returns>
    public override String GetRepostControlName()
    {
      // ***CHANGE_HERE*** Replace Misc2RepostControl below with your RepostControl.
      return (EditPortletPrefsRepostControl.STR_MVC_CLASS_NAME);
    }
    
    /// <summary>
    /// Registers all the classes of the Property Activity Space.
    /// </summary>
    public override void Init()
    {
      // ***CHANGE_HERE*** Replace Misc2Model below with your Model.
      m_strModelName = EditPortletPrefsModel.STR_MVC_CLASS_NAME;
      // Warning: m_strModelName must be initialized before super.Init() is called.
      base.Init();
      IModel myModel = GetModel(EditPortletPrefsModel.STR_MVC_CLASS_NAME);
      RegisterModel(PageListModel.STR_MVC_CLASS_NAME);
      // Register DisplayPages
      RegisterPage(new EditPortletPrefsDP());
      // Register Views
      RegisterView(PortletPreferencesView.STR_MVC_CLASS_NAME, myModel);
      // Register Controls
      RegisterControl(EditPortletPrefsRepostControl.STR_MVC_CLASS_NAME, myModel);
      // Set default page
      // (It will be the page selected by default when the user starts the Editor).
      SetCurrentPage(EditPortletPrefsDP.STR_MVC_CLASS_NAME);
      // END Sub menu "General Settings"
      this.SetHelpTopic("PT_EditPortletPreferences");
      //	TIPS
      TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);
      if (tm != null)
      {
        try
        {
          tm.SetGeneratingClass(sClassName);
          int iTitleId = 123;
          int iTipId = 124;
          int iSecondaryTipId = 125;
          tm.SetTipTitle(this.GetString(iTitleId, ResourceConstants.TIPS));
          HTMLGenericElement e = new HTMLGenericElement(this.GetString(iTipId,
           ResourceConstants.TIPS));
          tm.SetTip(e);
          String sSecondary = this.GetString(iSecondaryTipId, ResourceConstants.TIPS);
          if (!("none_do_not_translate".Equals(sSecondary)))
          {
            e = new HTMLGenericElement(sSecondary);
            tm.SetSecondarTip(e);
          }
        }
        catch (Exception ex)
        {
          log.Error(ex, "Couldn\'t generate tip.");
        }
      }
    }
  }
}
//	Got the tips model
