using System;
// Framework Imports
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.browsing.editors.editportletprefs
{
  /// <summary>
  /// This class contains the additional repost actions.
  /// The ones specific to the Misc Editor (other than
  /// "change page", "finish" and "cancel" actions).
  /// </summary>
  /// <author>MichaelD</author>
  public class EditPortletPrefsRepostControl : EditorRepostControl
  {
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "EditPortletPrefsRepost";
    public const int POSTTOSELF_ACTION_CHANGEGADGETPREFSSORT = 13;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new EditPortletPrefsRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call
    /// the associated method for each action.
    /// </summary>
    /// <param name="int"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      switch (_nAction){
      case POSTTOSELF_ACTION_CHANGEGADGETPREFSSORT:
      ((EditPortletPrefsModel) m_model).ReversePortletPrefsSort(m_htFormData);
      break;
      }
    }
  }
}