using System;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.editors.folder
{
  /// <author>
  /// joseq
  /// prints views for the popup asking if folder ACL changes should 
  /// propagate to its children.
  /// </author>
  public class FolderEditorACLPropagateDP : EditorDP
  {
    public const String STR_MVC_CLASS_NAME = "FolderEditorACLProp";
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,
    /// linking to that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return (m_asOwner.GetString(1698, "ptmsgs_portalbrowsingmsgs"));
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for the General Info page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)"></seealso>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      /* set the dialog body */
      HTMLBody myBody = new HTMLBody();
      result.AddInnerHTMLElement(myBody);
      myBody.SetStyleClass(PTStyleClass.DIALOGUE_BG);
      // Insert super class HTML
      result.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(FolderEditorACLPropagateView.STR_MVC_CLASS_NAME)).Display());
      return result;
    }
  }
}