using System;
// UI Imports
using com.plumtree.portalpages.browsing.editors.sitemap.sitemapfolderplugin;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.browsing.editors.sitemap
{
  /// <summary>
  /// File: SiteMapFolderRepostControl.java
  /// -------------------------------------
  /// </summary>
  /// <author>NaveenP</author>
  public class SiteMapFolderRepostControl : ObjEditorRepostControl
  {
    
    /// <summary>
    /// Unique identifier for the class 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "SiteMapFolderRepost";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SiteMapFolderRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// For the Object Editor we don't want to store the object yet.  We need to
    /// pop-up the save Object window so the user can select the folder, set
    /// the security and and set the name and description. Do do this we add a
    /// JavaScript to the current DP to open the pop-up window.
    /// </summary>
    public override void PerformFinishAction()
    {
      if ((EditorStartControl.EDITOR_START_FLAG_CREATE == ((ObjEditorModel) m_model).GetEditorType()) && !((SiteMapFolderModel) m_model).GetStartedInSiteMap())
      {
        OpenSavePopUp();
      } else
      {
        base.PerformFinishAction();
      }
    }
    
    /// <summary>
    /// Switch between the action modes and call
    /// the associated method for each action.
    /// </summary>
    /// <param name="_nAction"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      // You need to call the PerformRepostAction on the plug-in control
      ((SiteMapFolderPlugInControl) m_asOwner.GetControl(SiteMapFolderEditorAS.STR_MVC_SITEMAP_PLUGIN)).PerformRepostAction(_nAction,
       m_htFormData);
      switch (_nAction){
      case POSTTOSELF_ACTION_FINISH:
      if ((EditorStartControl.EDITOR_START_FLAG_CREATE == ((ObjEditorModel) m_model).GetEditorType()) && !((SiteMapFolderModel) m_model).FolderHasParent())
      {
        base.OpenSavePopUp();
      }
      break;
      case POSTTOSELF_ACTION_CANCEL:
      ((SiteMapFolderModel) m_model).DeleteFolderOnCancel();
      break;
      }
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.ObjEditorRepostControl#DisableSavePopUp()"></seealso>
    protected override bool DisableSavePopUp()
    {
      return true;
    }
  }
}