using System;
// Framework Imports
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.editors.sitemap.sitemapfolderplugin
{
  /// <summary>
  /// This class extends EditorDP and displays the Select Web Links page for the
  /// Site Map folder plug-in.
  /// </summary>
  public class SiteMapCreateWebLinkDP : AFormDP
  {
    
    /// <summary>
    /// The unique identifier for the class 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "SiteMapCreateWebLinkDP";
    public override String GetFormTitle()
    {
      return (m_asOwner.GetString(1489, "ptmsgs_portalbrowsingmsgs"));
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for the Site Map Folder Create Links page.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      //Just ask the view to display itself
      result.AddInnerHTMLElement((m_asOwner.GetView(SiteMapCreateWebLinkView.STR_MVC_CLASS_NAME)).Display());
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(SiteMapCreateWebLinkView.STR_MVC_CLASS_NAME).DisplayJavascript());
      return myScripts;
    }
  }
}