using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.common.helpers;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.editor.commonpages.migrationhistory;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.errordisplay;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.uiinfrastructure.tree;
namespace com.plumtree.portalpages.browsing.editors.smartsort
{
  /* job is auto created
   import com.plumtree.portalpages.admin.editors.common.setjob.*;
   import com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.*;
   */
   
  
  /// <author>OlegS</author>
  public class SmartSortEditorModel : ObjEditorModel,ISmartSortEditorModelRO
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.editors.smartsort.SmartSortEditorModel");
    public const String STR_MVC_CLASS_NAME = "SmartSortEditor";
    public const int SOURCE_FOLDER_GROUP = 0;
    public const int DESTINATION_FOLDER_GROUP = 1;
    public const int TOTAL_GROUPS = 2;
    // Strings to localize.
    
    /// <summary>
    /// Localized String:  No 
    /// </summary>
    public String m_lastTreeSpaceId = null;
    public int m_nAction = 0;
    // logging
    // member variables
    protected IPTTaxonomist m_ptTaxonomist = null;
    protected XPArrayList m_ActionData = null;
    protected bool[] m_sortAscending = null;
    protected int m_taxonomistSettings = 0;
    
    /// <summary>
    /// Creates a new SmartSortEditorModel object.
    /// </summary>
    public SmartSortEditorModel() : base()
    {
      // set just before SaveMainPage() from SmartSortEditorRepostControl.SetRepostAction() hook
      m_nAction = RepostControl.POSTTOSELF_ACTION_UNDEFINED;
      m_sortAscending = new bool[TOTAL_GROUPS];
      for (int i = 0;i < TOTAL_GROUPS;i++)
      {
        m_sortAscending[i] = true;
      }
    }
    // (not actually needed - handled via URL in SmartSortPlumtreeUtilities)
    // m_nFolderID = PT_INTRINSICS.PT_ADMIN_FOLDER_INTRINSICOPS; // override default
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SmartSortEditorModel();
    }
    public override void DoTaskAfterStore()
    {
      /* job is auto created
       ((SetJobModel) m_asOwner.GetModel(SetJobModel.STR_MVC_CLASS_NAME)).DoTaskAfterStoreSetJob();
       */
       
      CreateJob();
    }
    public virtual String makeListOfDestinationFoldersAlreadyShown()
    {
      String clsid = XPConvert.ToString(PT_CLASSIDS.PT_CATALOGFOLDER_ID);
      Object[] ids = (Object[]) m_ptTaxonomist.GetDestinationFolders();
      XPStringBuilder sb = new XPStringBuilder(100);
      char sep = (char) 0;
      if (null == ids)
      {
        return null;
      } else
      {
        for (int i = 0;i < ids.Length;i++)
        {
          if (sep == 0)
          {
            sep = ',';
          } else
          {
            sb.Append(sep);
          }
          sb.Append(clsid).Append(',').Append(ids[i]);
        }
        return sb.ToString();
      }
    }
    public virtual String makeListOfSourceFoldersAlreadyShown()
    {
      String clsid = XPConvert.ToString(PT_CLASSIDS.PT_CATALOGFOLDER_ID);
      Object[] ids = (Object[]) m_ptTaxonomist.GetSourceFolders();
      XPStringBuilder sb = new XPStringBuilder(100);
      char sep = (char) 0;
      if (null == ids)
      {
        return null;
      } else
      {
        for (int i = 0;i < ids.Length;i++)
        {
          if (sep == 0)
          {
            sep = ',';
          } else
          {
            sb.Append(sep);
          }
          sb.Append(clsid).Append(',').Append(ids[i]);
        }
        return sb.ToString();
      }
    }
    private void CreateJob()
    {
      try
      {
        IPTJob ptJob = (IPTJob) m_Session.GetScheduler().GetScheduledJobs().Create(PT_INTRINSICS.PT_ADMIN_FOLDER_INTRINSICOPS);
        String[] objects = {m_Session.GetSessionInfo().GetCurrentUserName()};
        String jobName = XPFormat.Format(m_asOwner.GetString(1678, "ptmsgs_portalbrowsingmsgs"),
         objects);
        ptJob.SetName(jobName);
        ptJob.SetDeleteWhenDone(true);
        XPDateTime ptdtRun = new XPDateTime();
        ptJob.SetSettings(PT_JOB_SETTINGS.PT_JOB_NEXTRUNTIME, ptdtRun);
        IPTSchedule ptSchedule = ptJob.GetSchedule();
        ptSchedule.SetScheduleType(PT_SCHEDULETYPES.PT_SCHEDULETYPE_ONCE);
        ptSchedule.SetStartTimestamp(ptdtRun);
        IPTServerContext ptSC = (IPTServerContext) ptJob.GetInterfaces("IPTServerContext");
        ptSC.Store();
        ptSC.UnlockObject();
        IPTServerContext ptSCt = (IPTServerContext) m_ptTaxonomist.GetInterfaces("IPTServerContext");
        int taxId = ptSCt.GetObjectID();
        ptSC.LockObject();
        ptJob.AddJobListEntry(-1, PT_CLASSIDS.PT_TAXONOMIST_ID, taxId);
        ptSC.Store();
        ptSC.UnlockObject();
      }
      catch (Exception e)
      {
        log.Error(e, GetName() + ": Failed to create job.");
        throw new XPException(m_asOwner.GetString(571, "ptmsgs_portalbrowsingmsgs") + 5,
         e);
      }
    }
    public override void DoTaskBeforeStore()
    {
    }
    /* job is auto created
     ((SetJobModel) m_asOwner.GetModel(SetJobModel.STR_MVC_CLASS_NAME)).DoTaskBeforeStoreSetJob();
     */
     
    public override void DoTaskOnComeBackFromSubEditor()
    {
      base.DoTaskOnComeBackFromSubEditor();
    }
    /* job is auto created
     ((SelectPTObjectModel) m_asOwner.GetModel(SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB)).DoTaskOnComeBackFromSubEditor();
     */
     
    // implementation
    public override void DoTaskOnStartEditor(XPHashtable _htFormData)
    {
      base.DoTaskOnStartEditor(_htFormData);
      // check editor type
      int nEditorType = GetEditorType();
      if (EditorStartControl.EDITOR_START_FLAG_EDIT != nEditorType)
      {
        ((EditorAS) m_asOwner).GetLeftMenu().HideLink(true, MigrationHistoryPluginDP.STR_MVC_CLASS_NAME);
        }
      switch (nEditorType){
      case EditorStartControl.EDITOR_START_FLAG_CREATE:
      break;
      case EditorStartControl.EDITOR_START_FLAG_EDIT:
      break;
      default:
      log.Error(GetName() + ": Unsupported editor type " + GetEditorType());
      throw new XPException(m_asOwner.GetString(571, "ptmsgs_portalbrowsingmsgs") + 1);
      break;
      }
      // check object
      if (GetObject() == null)
      {
        log.Error(GetName() + ": Null object ");
        throw new XPException(m_asOwner.GetString(571, "ptmsgs_portalbrowsingmsgs") + 2);
        }
      // prepare object
      m_ptTaxonomist = (IPTTaxonomist) GetObject();
      m_ptTaxonomist.Initialize(m_Session);
      // (not actually needed - handled via URL in SmartSortPlumtreeUtilities)
      // auto-set admin foder (user option to choose is supressed by &ObjEditorModel.EDITOR_QS_BOL_QS_FORCESAVEINFOLDER=true option in URL
      // m_ptTaxonomist.SetAdminFolderID(PT_INTRINSICS.PT_ADMIN_FOLDER_INTRINSICOPS);
      String[] objects = {m_Session.GetSessionInfo().GetCurrentUserName()};
      String taxName = XPFormat.Format(m_asOwner.GetString(1677, "ptmsgs_portalbrowsingmsgs"),
       objects);
      m_ptTaxonomist.SetName(taxName);
      //no reason the root folder should already be in the destination folder list
      //remove this folder when starting the editor -mgs
      m_ptTaxonomist.RemoveDestinationFolder(PT_INTRINSICS.PT_FOLDER_ROOTFOLDER);
      }
    /* job is auto created
     // job plug-in page
     ((SetJobModel) m_asOwner.GetModel(SetJobModel.STR_MVC_CLASS_NAME)).DoTaskOnStartSetJob(m_ptObject,m_Session, GetEditorType());
     */
     
    public virtual String GetEmptyListInstructions()
    {
      return m_asOwner.GetString(573, "ptmsgs_portalbrowsingmsgs");
    }
    public virtual String GetEmptyListMainMessage()
    {
      return m_asOwner.GetString(572, "ptmsgs_portalbrowsingmsgs");
    }
    // interface ISmartSortEditorModelRO
    public virtual Object[] GetFolderIDs(int group)
    {
      Object[] result = null;
      switch (group){
      case SOURCE_FOLDER_GROUP:
      result = (Object[]) m_ptTaxonomist.GetSourceFolders();
      break;
      case DESTINATION_FOLDER_GROUP:
      result = (Object[]) m_ptTaxonomist.GetDestinationFolders();
      break;
      }
      return result;
    }
    
    /// <returns></returns>
    public virtual String GetLastTreeSpaceId()
    {
      return m_lastTreeSpaceId;
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <param name="n"></param>
    /// <returns></returns>
    public virtual bool GetSetting(int n)
    {
      if (m_taxonomistSettings == 0)
      {
        m_taxonomistSettings = m_ptTaxonomist.GetSettings();
      }
      return (m_taxonomistSettings & n) != 0;
    }
    
    /// <param name="group"></param>
    /// <returns></returns>
    public virtual bool GetSortAscending(int group)
    {
      return m_sortAscending[group];
    }
    // repost actions
    public virtual void OnAdd(int group)
    {
      for (IXPEnumerator i = m_ActionData.GetEnumerator();i.MoveNext();)
      {
        int id = XPConvert.ToInteger(i.GetCurrent());
        AddFolder(group, id);
      }
    }
    
    /// <param name="group"></param>
    public virtual void OnDel(int group)
    {
      //reset trees
      if (m_asOwner.GetSubSpaceExists("FolderTreeDestination"))
      {
        ATreeAS asFolderTree = (ATreeAS) m_asOwner.GetSubSpace("FolderTreeDestination");
        asFolderTree.CleanupAllData();
      }
      if (m_asOwner.GetSubSpaceExists("FolderTreeSource"))
      {
        ATreeAS asFolderTree = (ATreeAS) m_asOwner.GetSubSpace("FolderTreeSource");
        asFolderTree.CleanupAllData();
      }
      for (IXPEnumerator i = m_ActionData.GetEnumerator();i.MoveNext();)
      {
        int id = XPConvert.ToInteger(i.GetCurrent());
        DeleteFolder(group, id);
        if (id == -1)
        {
          // delete all
          break;
        }
      }
    }
    
    /// <param name="group"></param>
    public virtual void OnSort(int group)
    {
      m_sortAscending[group] = !m_sortAscending[group];
    }
    
    /// <summary>
    /// Calls the right save function according to the page name passed in argument.
    /// </summary>
    /// <param name="_sPageName"></param>
    /// <param name="_htFormData"></param>
    /// <returns>int Page status for server side validation</returns>
    public override int SavePage(String _sPageName, XPHashtable _htFormData)
    {
      TraceHelper.Trace("SavePage(" + _sPageName + ")");
      TraceHelper.TraceQueryString(_htFormData);
      int result = base.SavePage(_sPageName, _htFormData);
      if (_sPageName.Equals(SmartSortEditorMainDP.STR_MVC_CLASS_NAME))
      {
        result = SaveMainPage(_htFormData);
      }
      /* job is auto created
       else if (_sPageName.equals(SetJobDP.STR_MVC_CLASS_NAME))
       {
       ((SetJobModel) m_asOwner.GetModel(SetJobModel.STR_MVC_CLASS_NAME)).SaveSection(_htFormData);
       }
       */
       
      return result;
    }
    
    /// <param name="group"></param>
    /// <param name="id"></param>
    protected virtual void AddFolder(int group, int id)
    {
      try
      {
        switch (group){
        case SOURCE_FOLDER_GROUP:
        m_ptTaxonomist.AddSourceFolder(id);
        break;
        case DESTINATION_FOLDER_GROUP:
        m_ptTaxonomist.AddDestinationFolder(id);
        break;
        default:
        throw new Exception("unexpected group");
        break;
        }
      }
      catch (Exception e)
      {
        log.Error(e, GetName() + ": Failed to add folder.");
        throw new XPException(m_asOwner.GetString(571, "ptmsgs_portalbrowsingmsgs") + 3,
         e);
      }
    }
    protected virtual void ClearActionData()
    {
      if (m_ActionData == null)
      {
        m_ActionData = new XPArrayList();
      } else
      {
        m_ActionData.Clear();
      }
    }
    
    /// <param name="group"></param>
    /// <param name="id"></param>
    protected virtual void DeleteFolder(int group, int id)
    {
      try
      {
        switch (group){
        case SOURCE_FOLDER_GROUP:
        m_ptTaxonomist.RemoveSourceFolder(id);
        break;
        case DESTINATION_FOLDER_GROUP:
        m_ptTaxonomist.RemoveDestinationFolder(id);
        break;
        default:
        throw new Exception("unexpected group");
        break;
        }
      }
      catch (Exception e)
      {
        log.Error(e, GetName() + ": Failed to remove folder.");
        throw new XPException(m_asOwner.GetString(571, "ptmsgs_portalbrowsingmsgs") + 4,
         e);
      }
    }
    
    /// <param name="o"></param>
    protected virtual void ExtractActionData_FoldersFromCheckboxes(Object o)
    {
      ClearActionData();
      String[] sa = (String[]) o;
      for (int i = 0;(sa != null) && (i < sa.Length);i++)
      {
        int id;
        try
        {
          id = XPConvert.ToInteger(sa[i]);
        }
        catch (Exception e)
        {
          continue;
        }
        m_ActionData.Add(id);
      }
    }
    protected virtual void ExtractActionData_FoldersFromDestinationTree()
    {
      ClearActionData();
      if (m_asOwner.GetSubSpaceExists("FolderTreeDestination"))
      {
        ATreeAS asFolderTree = (ATreeAS) m_asOwner.GetSubSpace("FolderTreeDestination");
        ITreeModelRO myTree = (ITreeModelRO) asFolderTree.GetModel(ATreeAS.TREEMODEL);
        XPArrayList mySelected = myTree.GetSelectedItems();
        for (int i = 0;i < mySelected.GetSize();i++)
        {
          int id = ((TreeLeafNode) mySelected.GetElement(i)).m_nObjectID;
          m_ActionData.Add(id);
        }
      } else
      // we're doomed
      {
        throw new XPException(m_asOwner.GetString(571, "ptmsgs_portalbrowsingmsgs") + 5);
        }
    }
    protected virtual void ExtractActionData_FoldersFromSourceTree()
    {
      ClearActionData();
      if (m_asOwner.GetSubSpaceExists("FolderTreeSource"))
      {
        ATreeAS asFolderTree = (ATreeAS) m_asOwner.GetSubSpace("FolderTreeSource");
        ITreeModelRO myTree = (ITreeModelRO) asFolderTree.GetModel(ATreeAS.TREEMODEL);
        XPArrayList mySelected = myTree.GetSelectedItems();
        for (int i = 0;i < mySelected.GetSize();i++)
        {
          int id = ((TreeLeafNode) mySelected.GetElement(i)).m_nObjectID;
          m_ActionData.Add(id);
        }
      } else
      // we're doomed
      {
        throw new XPException(m_asOwner.GetString(571, "ptmsgs_portalbrowsingmsgs") + 5);
        }
    }
    
    /// <param name="_htFormData"></param>
    protected virtual void ExtractActionData_OptionsFromCheckboxes(XPHashtable _htFormData)
    {
      ClearActionData();
      m_ActionData.Add(ExtractOneBoolElement(_htFormData.GetElement(SmartSortEditorMainView.HTMLCHECKBOX_RECOURSIVE)));
      m_ActionData.Add(ExtractOneBoolElement(_htFormData.GetElement(SmartSortEditorMainView.HTMLCHECKBOX_MOVE)));
      m_ActionData.Add(ExtractOneBoolElement(_htFormData.GetElement(SmartSortEditorMainView.HTMLCHECKBOX_APPROVE)));
      m_ActionData.Add(ExtractOneBoolElement(_htFormData.GetElement(SmartSortEditorMainView.HTMLCHECKBOX_FILTER)));
      }
    
    /// <param name="o"></param>
    /// <returns></returns>
    protected virtual bool ExtractOneBoolElement(Object o)
    {
      String[] sa = (String[]) o;
      return ((sa == null) || (sa.Length < 1) || (XPStringUtility.CharAt(sa[0],
       0) != '1')) ? false : true;
    }
    
    /// <param name="o"></param>
    /// <returns></returns>
    protected virtual String ExtractOneElement(Object o)
    {
      String[] sa = (String[]) o;
      return ((sa == null) || (sa.Length < 1)) ? null : sa[0];
    }
    
    /// <returns></returns>
    protected virtual int GetAction()
    {
      return m_nAction;
    }
    protected static int GetActionGroup(int action)
    {
      return SmartSortEditorRepostControl.GetActionGroup(action);
    }
    public static int RemoveGroupFromAction(int action)
    {
      return SmartSortEditorRepostControl.RemoveGroupFromAction(action);
    }
    
    /// <param name="_htFormData"></param>
    /// <returns></returns>
    protected virtual int SaveMainPage(XPHashtable _htFormData)
    {
      ExtractActionData_OptionsFromCheckboxes(_htFormData);
      // options from checkboxes are saved for any action
      SetAllSettings();
      ClearActionData();
      int group = GetActionGroup(GetAction());
      int action = RemoveGroupFromAction(GetAction());
      switch (action){
      case SmartSortEditorRepostControl.ACTION_ADD:
      if (SOURCE_FOLDER_GROUP == group)
      {
        ExtractActionData_FoldersFromSourceTree();
      } else
      if (DESTINATION_FOLDER_GROUP == group)
      {
        ExtractActionData_FoldersFromDestinationTree();
      }
      m_lastTreeSpaceId = ExtractOneElement(_htFormData.GetElement(SmartSortEditorMainView.HTMLHIDDEN_SPACEID));
      OnAdd(group);
      break;
      case SmartSortEditorRepostControl.ACTION_DEL:
      ExtractActionData_FoldersFromCheckboxes(_htFormData.GetElement(SmartSortEditorMainView.HTMLCHECKBOX_FOLDER + group));
      OnDel(group);
      break;
      case SmartSortEditorRepostControl.ACTION_SORT:
      ClearActionData();
      OnSort(group);
      break;
      }
      int nPageStatus = validate();
      return nPageStatus;
    }
    protected virtual void SetAllSettings()
    {
      int oldSettings = m_taxonomistSettings;
      // HTMLCHECKBOX_RECOURSIVE
      int setting = PT_TAXONOMIST_SETTINGS.PT_TAXONOMIST_TAXONOMIZE_FOLDER_BRANCH;
      bool newval = XPConvert.ToBoolean(m_ActionData.GetElement(0));
      bool oldval = GetSetting(setting);
      if (newval != oldval)
      {
        SetSettings(setting, newval);
      }
      // HTMLCHECKBOX_MOVE
      setting = PT_TAXONOMIST_SETTINGS.PT_TAXONOMIST_REMOVE_CARDS_FROM_PRESENT_LOCATION;
      newval = XPConvert.ToBoolean(m_ActionData.GetElement(1));
      oldval = GetSetting(setting);
      if (newval != oldval)
      {
        SetSettings(setting, newval);
        SetSettings(PT_TAXONOMIST_SETTINGS.PT_TAXONOMIST_LEAVE_CARDS_IN_PRESENT_LOCATION,
         !newval);
      }
      // HTMLCHECKBOX_APPROVE
      setting = PT_TAXONOMIST_SETTINGS.PT_TAXONOMIST_ADD_CARDS_TO_FOLDERS_APPROVED;
      newval = XPConvert.ToBoolean(m_ActionData.GetElement(2));
      oldval = GetSetting(setting);
      if (newval != oldval)
      {
        SetSettings(setting, newval);
      }
      // HTMLCHECKBOX_FILTER
      setting = PT_TAXONOMIST_SETTINGS.PT_TAXONOMIST_ONLY_APPLY_SUBFOLDER_FILTERS;
      // checkbox displays inverted setting
      newval = !XPConvert.ToBoolean(m_ActionData.GetElement(3));
      oldval = GetSetting(setting);
      if (newval != oldval)
      {
        SetSettings(setting, newval);
      }
      // save if changed
      if (m_taxonomistSettings != oldSettings)
      {
        m_ptTaxonomist.SetSettings(m_taxonomistSettings);
      }
    }
    
    /// <param name="setting"></param>
    /// <param name="newval"></param>
    protected virtual void SetSettings(int setting, bool newval)
    {
      if (newval)
      {
        m_taxonomistSettings|=setting;
      } else
      {
        m_taxonomistSettings&=~setting;
      }
    }
    
    /// <returns></returns>
    protected virtual int validate()
    {
      int nPageStatus = RepostControl.PAGE_STATUS_VALID;
      Object[] oad = GetFolderIDs(DESTINATION_FOLDER_GROUP);
      Object[] oas = GetFolderIDs(SOURCE_FOLDER_GROUP);
      if ((oad == null) || (oad.Length == 0) || (oas == null) || (oas.Length == 0))
      {
        nPageStatus = RepostControl.PAGE_STATUS_INVALID;
        XPStringBuilder err = new XPStringBuilder();
        if ((oas == null) || (oas.Length == 0))
        {
          if (err.GetLength() > 0)
          {
            err.Append("; ");
          }
          err.Append(m_asOwner.GetString(1247, "ptmsgs_portalbrowsingmsgs"));
          err.Append(m_asOwner.GetString(1245, "ptmsgs_portalbrowsingmsgs"));
          err.Append(m_asOwner.GetString(1243, "ptmsgs_portalbrowsingmsgs"));
          }
        if ((oad == null) || (oad.Length == 0))
        {
          if (err.GetLength() > 0)
          {
            err.Append("; ");
          }
          err.Append(m_asOwner.GetString(1941, "ptmsgs_portalbrowsingmsgs"));
          }
        String msg = m_asOwner.GetString(1246, "ptmsgs_portalbrowsingmsgs") + err.ToString();
        UIError myError = new UIError(UIErrorLevel.FRIENDLY, UIErrorScope.CURRENT_USER,
         null, msg, msg);
        UIErrorHandler.RaiseError(myError, m_asOwner.GetSubSession(), m_asOwner.GetApplication());
        }
      return nPageStatus;
    }
  }
}