using System;
using com.plumtree.portaluiinfrastructure.editor;
namespace com.plumtree.portalpages.browsing.editors.smartsort
{
  /* job is auto created
   import com.plumtree.portalpages.admin.editors.common.setjob.*;
   */
   
  
  /// <summary>
  /// This class contains the additional repost actions.
  /// The ones specific to the Smart Sort Editor (other than
  /// "change page", "finish" and "cancel" actions).
  /// </summary>
  /// <author>OlegS</author>
  public class SmartSortEditorRepostControl : ObjEditorRepostControl
  {
    public const String STR_MVC_CLASS_NAME = "SmartSortEditorRepost";
    // +GROUP_SHIFT*group
    public const int ACTION_ADD = 80;
    // +GROUP_SHIFT*group
    public const int ACTION_DEL = 81;
    // +GROUP_SHIFT*group
    public const int ACTION_SORT = 82;
    // +GROUP_SHIFT*group
    public const int GROUP_SHIFT = 1000;
    
    /// <param name="action"></param>
    /// <returns></returns>
    public static int GetActionGroup(int action)
    {
      return (action >= GROUP_SHIFT) ? SmartSortEditorModel.DESTINATION_FOLDER_GROUP : SmartSortEditorModel.SOURCE_FOLDER_GROUP;
      }
    public static int RemoveGroupFromAction(int action)
    {
      if (action >= GROUP_SHIFT)
      {
        action-=GROUP_SHIFT;
      }
      return action;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SmartSortEditorRepostControl();
    }
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    /* job is auto created
     protected void PerformAction(int _nAction)
     {
     TraceHelper.Trace("PerformAction " + _nAction);
     super.PerformAction(_nAction);
     
     // for job plugin
     ((SetJobRepostControl) m_asOwner.GetControl(SetJobRepostControl.STR_MVC_CLASS_NAME)).PerformRepostAction(_nAction,
     m_htFormData);
     }
     */
     
    protected override void SetRepostAction()
    {
      base.SetRepostAction();
      // copy to model for convenience
      GetModel().m_nAction = m_nAction;
    }
    
    /// <returns></returns>
    protected virtual SmartSortEditorModel GetModel()
    {
      return (SmartSortEditorModel) m_model;
    }
  }
}