using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.editors.userprofile
{
  /// <summary>
  /// This is the General Profile Display Page that will be used to display all of
  /// the sections for each of the Profile pages.   It will retrieve the title and
  /// names from the different pages.
  /// </summary>
  public class ProfilePageListDP_D : EditorDP
  {
    
    /// <summary>
    /// object name it is overridden below*
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "ProfilePageList";
    
    /// <summary>
    /// object title - it is overridden below *
    /// </summary>
    public String _ui_PageTitle = "";
    public XPArrayList m_alPortlets = null;
    public ProfilePageListDP_D(XPArrayList _alPortlets) : base()
    {
      m_alPortlets = _alPortlets;
    }
    
    /// <summary>
    /// Returns the HTML that is placed in the HEAD section of this HTML page.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException </throws>
    public override HTMLElementCollection DisplayHTMLinHEAD()
    {
      HTMLElementCollection retVal = new HTMLElementCollection();
      return retVal;
    }
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,
    /// linking to that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      // If it hasn't been overridden and set by GeneralProfileDP() call, use default
      if (m_asOwner.GetString(1286, "ptmsgs_portalbrowsingmsgs").Equals(""))
      {
        _ui_PageTitle = m_asOwner.GetString(576, "ptmsgs_portalbrowsingmsgs");
        }
      return m_asOwner.GetString(1286, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for the Profile List page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)"></seealso>
    /// <returns>HTMLElement</returns>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // Insert super class HTML
      result.AddInnerHTMLElement(base.PageDisplay());
      HTMLElementCollection views = new HTMLElementCollection();
      // display the list view
      for (int i = 0;i < m_alPortlets.GetSize();i++)
      {
        views.AddInnerHTMLElement(((ProfilePageListView_D) m_asOwner.GetView(ProfilePageListView_D.STR_MVC_CLASS_NAME)).Display(m_alPortlets.GetElement(i)));
        }
      // add a spacer table
      views.AddInnerHTMLElement(EditorView.GetSpacerTable());
      result.AddInnerHTMLElement(CreateLeftNavBar(views));
      return result;
    }
    
    /// <summary>
    /// Display no Javascripts.  This page is only used in 508 mode.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      return myScripts;
    }
  }
}