using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.editors.userprofile
{
  /// <author>jennifersu</author>
  public class ProfilePageListView_D : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.editors.userprofile.ProfilePageListView_D");
    public const String STR_MVC_CLASS_NAME = "ProfilePageListView_D";
    public const String HTMLHIDDEN_EDITOR_REDIRECT_PAGENAME = "in_hi_EditorRedirectPageName";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new ProfilePageListView_D();
    }
    
    /// <summary>
    /// Returns the HTML for the Profile Page.
    /// </summary>
    /// <returns>HTMLElement</returns>
    public virtual HTMLElement Display(Object _ptPortlet)
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      try
      {
        HTMLComment myComment = new HTMLComment("Begin: Display ProfilePageListView_D");
        result.AddInnerHTMLElement(myComment);
        myTable = new HTMLTable();
        result.AddInnerHTMLElement(myTable);
        myTable.SetWidth("100%");
        myTable.SetBorder("0");
        myTable.SetCellPadding("5");
        myTable.SetCellSpacing("0");
        // TODO extract this string
        myTable.SetSummary("This table contains a list of links to the user\'s profile pages.");
        // make a row for each page in the list
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        String portletName = ((IPTGadget) _ptPortlet).GetLocalizedName();
        int portletID = ((IPTGadget) _ptPortlet).GetObjectID();
        ASURL myAsurl = ((AFormDP) m_asOwner.GetCurrentPage()).Get508RepostURL(UserProfileRepostControl.POSTTOSELF_ACTION_GOTOPAGE);
        myAsurl.AddControlArgument(EditorLeftNavView.HTMLHIDDEN_EDITOR_REDIRECT_SPACENAME,
         m_asOwner.GetName());
        myAsurl.AddControlArgument(EditorLeftNavView.HTMLHIDDEN_EDITOR_REDIRECT_PAGENAME,
         "portlet_" + portletID);
        myAsurl.AddInnerHTMLString(XPHttpUtility.HtmlEncode(portletName));
        myCell.AddInnerHTMLElement(myAsurl.GetURLAsHTMLElement());
      }
      catch (Exception e)
      {
        log.Error(e, "ProfilePageListView_D::Display An error occured when trying to display the HTML.");
        throw new XPException(m_asOwner.GetString(461, "ptmsgs_portalcommonmsgs"),
         e);
      }
      return result;
    }
    
    /// <summary>
    /// This  is the default Display method.  This class dynamically draws the
    /// Section based on Profile Category information. This method will not work in
    /// this case and should not be called. It will return a blank
    /// HTMLElementCollection.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Display()"></seealso>
    public override HTMLElement Display()
    {
      log.Error(STR_MVC_CLASS_NAME + "The incorrect Display() method is being called.  This class does not use the default display method.");
      throw new XPException(m_asOwner.GetString(575, "ptmsgs_portalbrowsingmsgs"));
      }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}