using System;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server.portalpagesperf;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.web;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.gateway
{
  /// <author>daniilk</author>
  public class GatewayHostedDP : PlumtreeDP
  {
    public const String STR_MVC_CLASS_NAME = "GatewayHosted";
    
    /// <param name="webData"></param>
    public override void Display(IWebData webData)
    {
      IGatewayModelRO gwModel = (IGatewayModelRO) m_asOwner.GetModel(GatewayModel.STR_MVC_CLASS_NAME);
      GatewayUtils.AddHeadersToResponse(gwModel.GetHeaders(), webData);
      base.Display(webData);
      webData.SetStatus(gwModel.GetStatus());
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetSubtitleForBanner()"></seealso>
    public override String GetSubtitleForBanner()
    {
      IGatewayModelRO gwModel = (IGatewayModelRO) m_asOwner.GetModel(GatewayModel.STR_MVC_CLASS_NAME);
      String strSubtitle = gwModel.GetSubtitle();
      if (strSubtitle == null)
      {
        strSubtitle = "";
      }
      return strSubtitle;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetTitleForBanner()"></seealso>
    public override String GetTitleForBanner()
    {
      IGatewayModelRO gwModel = (IGatewayModelRO) m_asOwner.GetModel(GatewayModel.STR_MVC_CLASS_NAME);
      String strTitle = gwModel.GetTitle();
      if (strTitle == null || strTitle.Length < 1)
      {
        strTitle = HttpUtils.GetHeaderValue(gwModel.GetHeaders(), "CSP-Title-Bar");
        }
      return strTitle;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      GatewayModel gwModel = (GatewayModel) m_asOwner.GetModel(GatewayModel.STR_MVC_CLASS_NAME);
      HTMLElement result = new HTMLElementCollection();
      HTMLElement resultHTML = gwModel.GetDisplayElement();
      String strHTML = null;
      if (resultHTML != null)
      {
        strHTML = resultHTML.GetDisplayString();
      }
      // increment perfcounter
      PerfCounters.INSTANCE.IncrementCounter(PORTALPAGESPERF_COUNTERS.PORTALPAGESPERF_CLICKTHROUGHS);
      if (null != strHTML)
      {
        result.AddInnerHTMLString(strHTML);
      } else
      {
        result.AddInnerHTMLString("<B>" + m_asOwner.GetString(623, "ptmsgs_portalbrowsingmsgs") + "</B>\r\n" + 
        // the following line can stay non-localized, since it's going to be in the HTML comments
        // and will not be displayed in the browser.
        "<!-- GetTextBody call returned NULL. There was a problem accessing gateway content. -->");
        }
      // Moose: save the url on the session
      if (gwModel.GetUserURL() != null)
      {
        m_asOwner.GetSubSession().SetAttribute(GatewayHelpers.LAST_VISITED_HOSTED_PAGE,
         gwModel.GetUserURL());
      }
      return result;
    }
  }
}