using System;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using PT_RESULTCODES=com.plumtree.server.PT_RESULTCODES;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
using com.plumtree.openfoundation.util;
namespace com.plumtree.portalpages.browsing.gateway
{
  /// <author>daniilk</author>
  public class GatewayRefreshErrorDP : IDisplayPage
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.gateway.GatewayRefreshErrorDP");
    public const String STR_MVC_CLASS_NAME = "GatewayRefreshError";
    private AActivitySpace m_asOwner = null;
    private static String strHeaderName = "PT-HTTPResponse-Type";
    private static String strTimeoutHeaderValue = "PORTLET_TIMEOUT";
    private static String strPortletErrorHeaderValue = "PORTLET_ERROR";
    private static String strPortletXMLError = "<?xml version=\"1.0\"?><error>" + "<field><name>Error Code</name><value><![CDATA[{0}]]></value></field>" + "<field><name>Error Message</name><value><![CDATA[{1}]]></value></field>" + "<field><name>Extended Error Information</name><value><![CDATA[{2}]]]></value></field>" + "</error>";
    private const String strContentTypeHeaderName = "Content-Type";
    private const String strTextXML = "text/xml";
    
    /// <param name="webData"></param>
    public virtual void Display(IWebData webData)
    {
      IGatewayModelRO gwModel = (IGatewayModelRO) m_asOwner.GetModel(GatewayModel.STR_MVC_CLASS_NAME);
      String[] strArgs = new String[3];
      strArgs[0] = XPConvert.ToString(gwModel.GetErrorCode());
      strArgs[1] = gwModel.GetErrorMessage();
      strArgs[2] = gwModel.GetErrorHTMLComment();
      String strErrorBody = XPFormat.Format(strPortletXMLError, strArgs);
      webData.SetData(strErrorBody);
      if (gwModel.GetErrorCode() == PT_RESULTCODES.PT_E_GADGET_TIMEOUT)
      {
        webData.SetHeader(strHeaderName, strTimeoutHeaderValue);
      } else
      {
        webData.SetHeader(strHeaderName, strPortletErrorHeaderValue);
      }
      webData.SetHeader(strContentTypeHeaderName, strTextXML);
      return;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual AActivitySpace GetOwner()
    {
      return m_asOwner;
    }
    
    /// <param name="parent"></param>
    public virtual void Init(AActivitySpace parent)
    {
      m_asOwner = parent;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()"></seealso>
    public virtual HTMLElement PageDisplay()
    {
      return null;
    }
  }
}