using System;
using com.plumtree.portaluiinfrastructure.tags.displaytree;
namespace com.plumtree.portalpages.browsing.gateway
{
  /// <summary>
  /// This class contains constants necessary for the Tag Engine integration. 
  /// </summary>
  public class TagConstants
  {
    
    /// <summary>
    /// The name of the standard tag library.
    /// </summary>
    public const String STANDARD_LIBRARY = "standard";
    
    /// <summary>
    /// The fully qualified name of the display mode tag. 
    /// </summary>
    public static readonly String DISPLAY_MODE_TAG_FULL_NAME = STANDARD_LIBRARY + TagDisplayElement.LIBRARY_SEPARATOR + "displaymode";
    
    /// <summary>
    /// The name of the hosted mode attribute in the display mode tag.
    /// </summary>
    public const String DISPLAY_MODE_TAG_MODE_ATTRIBUTE = "mode";
    
    /// <summary>
    /// The display mode attribute to set the page to hosted mode.
    /// </summary>
    public const String DISPLAY_MODE_ATTRIBUTE_HOSTED_VALUE = "Hosted";
  }
}