using System;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.browsing.layoutselection
{
  /// <author>michaeld</author>
  public interface ILayoutSelectionModelRO : IEditorModelRO
  {
    
    /// <summary>
    /// Get the count of columns to display on the select layout page.
    /// </summary>
    /// <returns>int nLayoutColumnCount</returns>
    int GetLayoutColumnCount();
    
    /// <returns>whether the page has a content canvas portlet on it</returns>
    bool GetPageHasFreeFormPortlet();
    
    /// <returns>whether the page supports a content canvas section</returns>
    bool GetPageSupportsFreeFormSection();
    
    /// <summary>
    /// Get the name of the parent window's form.
    /// </summary>
    /// <returns>String</returns>
    String GetParentFormName();
    
    /// <summary>
    /// Get the name of the form element for selected items.
    /// </summary>
    /// <returns>String</returns>
    String GetParentFormSelectInput();
    
    /// <summary>
    /// Get the string that is the parent form space ID.
    /// </summary>
    /// <returns>String</returns>
    String GetParentFormSpaceID();
    
    /// <summary>
    /// Get the string that is the parent form submit function.
    /// </summary>
    /// <returns>String</returns>
    String GetParentFormSubmitFunction();
    
    /// <summary>
    /// Get the currently selected layout.
    /// </summary>
    /// <returns>nSelectedLayout</returns>
    int GetSelectedLayout();
    
    /// <returns>Available portlet page layouts</returns>
    IPTQueryResult GetAdaptiveLayouts();
  }
}