using System;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.layoutselection
{
  /// <author>michaeld</author>
  public class LayoutSelectionDP : EditorDP
  {
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "LayoutSelection";
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,  linking to
    /// that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(627, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      if (((ILayoutSelectionModelRO) m_asOwner.GetModel(LayoutSelectionModel.STR_MVC_CLASS_NAME)).GetPageSupportsFreeFormSection())
      {
        return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1077,
         "ptmsgs_portalbrowsingmsgs"), this.m_asOwner);
      }
      return HTMLConstructHelpers.GetSubHeader("", this.m_asOwner);
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // Insert super class HTML
      result.AddInnerHTMLElement(base.PageDisplay());
      HTMLElementCollection views = new HTMLElementCollection();
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(LayoutSelectionView.STR_MVC_CLASS_NAME)).Display());
      result.AddInnerHTMLElement(CreateContentTable(views, null));
      return result;
    }
    
    /// <returns></returns>
    /// <throws>HTMLException </throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection scripts = new HTMLScriptCollection();
      scripts.AddInnerHTMLElement(m_asOwner.GetView(LayoutSelectionView.STR_MVC_CLASS_NAME).DisplayJavascript());
      return scripts;
    }
  }
}