using System;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.browsing.login
{
  /// <summary>
  /// Activity Space for login.
  /// </summary>
  /// <author>BenG</author>
  public class LoginAS : PlumtreeAS
  {
    public const String STR_MVC_CLASS_NAME = "Login";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new LoginAS();
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.AActivitySpace#Init()"></seealso>
    public override void Init()
    {
      base.Init();
      RegisterPage(new LoginDP());
      RegisterModel(LoginModel.STR_MVC_CLASS_NAME);
      IModel myModel = GetModel(LoginModel.STR_MVC_CLASS_NAME);
      RegisterView(LoginView.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(DefaultLoginControl.STR_MVC_CLASS_NAME, "", myModel);
      RegisterControl(LoginControl.STR_MVC_CLASS_NAME, myModel);
    }
  }
}