using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.login;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.constants;
namespace com.plumtree.portalpages.browsing.login
{
  /// <author>donh</author>
  public class LoginControlHelpers
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.login.LoginControlHelpers");
    
    /// <summary>
    /// This helper method check to see if there is a valid access style cookie
    /// and sets the result on the model if there is one.
    /// </summary>
    /// <param name="xpRequest"></param>
    /// <param name="loginModel"></param>
    public static void CheckAccessStyleCookie(IXPRequest xpRequest, LoginModel loginModel)
    {
      XPCookie[] cookies = null;
      if (xpRequest != null)
      {
        cookies = xpRequest.GetCookies();
      }
      if (cookies != null)
      {
        int nNumCookies = cookies.Length;
        XPCookie currentCookie;
        log.Debug("CheckActionSecurityAndExecute() - got " + nNumCookies + " cookies!");
        for (int i = 0;i < nNumCookies;i++)
        {
          currentCookie = cookies[i];
          if (PTPersonalSettingsHelper.ACCESS_STYLE_COOKIE_NAME.Equals(currentCookie.GetName()))
          {
            //	access style cookie
            log.Debug("CheckActionSecurityAndExecute() - Found an access style cookie.");
            String sStyleFromCookie = currentCookie.GetValue();
            try
            {
              if ((null != sStyleFromCookie) && AccessStyles.IsValidAccessID(XPConvert.ToInteger(sStyleFromCookie)))
              {
                loginModel.SetAccessStyle(XPConvert.ToInteger(sStyleFromCookie));
                return;
              }
            }
            catch (Exception e)
            {
              log.Error(e, "Unable to process access style cookie.");
            }
          }
        }
      }
    }
  }
}