using System;
using com.plumtree.openlog;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.portaluiinfrastructure.layout;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.login
{
  /// <author>BenG</author>
  public class LoginDP : PlumtreeDP
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.login.LoginDP");
    public const String STR_MVC_CLASS_NAME = "Login";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Init(AActivitySpace)"></seealso>
    public override void Init(AActivitySpace parent)
    {
      base.Init(parent);
      parent.SetHelpTopic("PT_Login");
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetSubtitleForBanner()"></seealso>
    public override String GetSubtitleForBanner()
    {
      return "";
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetTitleForBanner()"></seealso>
    public override String GetTitleForBanner()
    {
      return m_asOwner.GetString(630, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      log.Debug("PageDisplay()");
      HTMLElementCollection myCollection = new HTMLElementCollection();
      try
      {
        HTMLElement element = DisplayLayout(Layouts.LOGIN_PAGE);
        if (null != element)
        {
          return element;
        }
        myCollection.AddInnerHTMLElement(m_asOwner.GetView(LoginView.STR_MVC_CLASS_NAME).Display());
        }
      catch (HTMLException he)
      {
        log.Error("he: " + he);
      }
      return myCollection;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#DisplayJavaScriptFromChild()"></seealso>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScriptCollection = new HTMLScriptCollection();
      HTMLScript myScript = m_asOwner.GetView(LoginView.STR_MVC_CLASS_NAME).DisplayJavascript();
      if (myScript != null)
      {
        myScriptCollection.AddInnerHTMLElement(myScript);
      }
      return myScriptCollection;
    }
  }
}