using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.directory;
using com.plumtree.portalpages.browsing.myportal;
using com.plumtree.portalpages.browsing.myportal.editpage;
using com.plumtree.portalpages.browsing.myportal.mypages;
using com.plumtree.portalpages.browsing.objectselection.communities;
using com.plumtree.portalpages.browsing.search.advanced;
using com.plumtree.portalpages.common.editpage;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.login.createaccount
{
  /// <author>BenG</author>
  public class WelcomeView : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.login.createaccount.WelcomeView");
    public const String STR_MVC_CLASS_NAME = "WelcomeView";
    internal const String sFormName = "lform";
    private AActivitySpace m_asOwner;
    private CreateAccountModel m_asmModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new WelcomeView();
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#display()"></seealso>
    public virtual HTMLElement Display()
    {
      HTMLTable myTable = new HTMLTable();
      myTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
      myTable.SetStyleClass(PTStyleClass.LOGIN_TEXT);
      myTable.SetBorder(CommonHTMLStrings.ZERO);
      myTable.SetCellPadding(CommonHTMLStrings.ZERO);
      myTable.SetCellSpacing(CommonHTMLStrings.ZERO);
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      try
      {
        IPTSubPortalInfo ptSubPortalInfo = ((IPTSession) m_asOwner.GetUserSession()).GetSessionInfo().GetCurrentUserCachedSubPortalInfo();
        int nAccessType = ptSubPortalInfo.GetAccessType();
        //	WELCOME
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.BAN_HEADER_BG);
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.BAN_HEADER);
        myRow.AddInnerHTMLElement(myCell);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell = new HTMLTableCell();
        myCell.SetHeight("30");
        myCell.SetStyleClass(PTStyleClass.BAN_HEADER);
        myCell.SetNoWrap(true);
        myRow.AddInnerHTMLElement(myCell);
        myCell.AddInnerHTMLString(m_asOwner.GetString(7, "ptmsgs_portalbrowsingmsgs"));
        //	CONGRATS  YOU HAVE SUCCEEDED
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.DIR_CONTENT_BG);
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.DIR_CONTENT_BG);
        myRow.AddInnerHTMLElement(myCell);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.DIR_CONTENT_TEXT);
        myCell.SetHeight("50");
        myRow.AddInnerHTMLElement(myCell);
        myCell.AddInnerHTMLString(m_asOwner.GetString(8, "ptmsgs_portalbrowsingmsgs"));
        //	EMPTY ROW
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.DIR_TEXT);
        myCell = new HTMLTableCell();
        myCell.SetHeight("10");
        myCell.SetStyleClass(PTStyleClass.DIR_TEXT);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell.SetAutoFit(true);
        myRow.AddInnerHTMLElement(myCell);
        //	EXPLORE
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.DIR_HEADER_BG);
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.DIR_TEXT);
        myRow.AddInnerHTMLElement(myCell);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetHeight("20");
        myCell.SetStyleClass(PTStyleClass.DIR_TEXT);
        myCell.AddInnerHTMLString(m_asOwner.GetString(9, "ptmsgs_portalbrowsingmsgs"));
        //	EMPTY ROW
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.DIR_TEXT);
        myCell = new HTMLTableCell();
        myCell.SetHeight("20");
        myCell.SetStyleClass(PTStyleClass.DIR_TEXT);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell.SetAutoFit(true);
        myRow.AddInnerHTMLElement(myCell);
        //	LINKS ROW
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        HTMLTable linksTable = new HTMLTable();
        myCell.AddInnerHTMLElement(linksTable);
        ASURL url;
        HTMLImg myImg;
        PTConstruct myConstruct;
        if ((PT_SUBPORTAL_ACCESS_TYPES.PT_SUBPORTAL_MYPAGES_ACCESS & nAccessType) != 0)
        {
          //	MY PAGES LINK
          url = new ASURL(m_asOwner);
          //	MYPAGE url
          url.SetLinkGetSpaceIfCached(MyPageAS.STR_MVC_CLASS_NAME, this.m_asOwner);
          url.SetControl(SetPageControl.STR_MVC_CLASS_NAME);
          url.AddControlArgument(SetPageControl.STR_PAGE_ID, SetPageControl.N_HOME_PAGE_ID);
          url.AddInnerHTMLString(m_asOwner.GetString(10, "ptmsgs_portalbrowsingmsgs"));
          myRow = new HTMLTableRow();
          myRow.SetStyleClass(PTStyleClass.LOGIN_TEXT);
          linksTable.AddInnerHTMLElement(myRow);
          myCell = new HTMLTableCell();
          myCell.SetStyleClass(PTStyleClass.LOGIN_TEXT);
          myRow.AddInnerHTMLElement(myCell);
          myConstruct = ConstructFactory.GetConstruct(PTImageType.ICON_MYPAGE);
          myImg = (HTMLImg) myConstruct.GetHTMLElement();
          myImg.SetAlt(m_asOwner.GetString(10, "ptmsgs_portalbrowsingmsgs"));
          myCell.AddInnerHTMLElement(myImg);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          myCell.AddInnerHTMLElement(url.GetURLAsHTMLElement());
          //	MY PAGES TEXT
          myRow = new HTMLTableRow();
          myRow.SetStyleClass(PTStyleClass.LOGIN_TEXT);
          linksTable.AddInnerHTMLElement(myRow);
          myCell = new HTMLTableCell();
          myCell.SetStyleClass(PTStyleClass.LOGIN_TEXT);
          myRow.AddInnerHTMLElement(myCell);
          myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
          myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          myCell.AddInnerHTMLString(m_asOwner.GetString(11, "ptmsgs_portalbrowsingmsgs"));
          //	EMPTY ROW
          myRow = new HTMLTableRow();
          linksTable.AddInnerHTMLElement(myRow);
          myRow.SetStyleClass(PTStyleClass.DIR_TEXT);
          myCell = new HTMLTableCell();
          myCell.SetHeight("10");
          myCell.SetStyleClass(PTStyleClass.DIR_TEXT);
          myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
          myCell.SetAutoFit(true);
          myRow.AddInnerHTMLElement(myCell);
          //	EDIT MY PAGES LINK
          url = new ASURL(m_asOwner);
          url.SetLinkGetSpaceIfCached(EditMyPortalPageAS.STR_MVC_CLASS_NAME,
           this.m_asOwner);
          url.SetControl(EditorStartControl.STR_MVC_CLASS_NAME);
          url.AddControlArgument(EditPageQueryArguments.HTMLINPUT_EDITPAGE_OPENERPAGEID,
           m_asmModel.GetSession().GetSessionInfo().GetCurrentMyPage(0).GetObjectID());
          url.AddControlArgument(EditorStartControl.QS_EDITOR_TYPE, EditorStartControl.EDITOR_START_FLAG_MISC);
          url.AddInnerHTMLString(m_asOwner.GetString(12, "ptmsgs_portalbrowsingmsgs"));
          myRow = new HTMLTableRow();
          myRow.SetStyleClass(PTStyleClass.LOGIN_TEXT);
          linksTable.AddInnerHTMLElement(myRow);
          myCell = new HTMLTableCell();
          myCell.SetStyleClass(PTStyleClass.LOGIN_TEXT);
          myRow.AddInnerHTMLElement(myCell);
          myConstruct = ConstructFactory.GetConstruct(PTImageType.ICON_MYPAGE);
          myImg = (HTMLImg) myConstruct.GetHTMLElement();
          myImg.SetAlt(m_asOwner.GetString(10, "ptmsgs_portalbrowsingmsgs"));
          myCell.AddInnerHTMLElement(myImg);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          myCell.AddInnerHTMLElement(url.GetURLAsHTMLElement());
          //	EDIT MY PAGES TEXT
          myRow = new HTMLTableRow();
          myRow.SetStyleClass(PTStyleClass.LOGIN_TEXT);
          linksTable.AddInnerHTMLElement(myRow);
          myCell = new HTMLTableCell();
          myCell.SetStyleClass(PTStyleClass.LOGIN_TEXT);
          myRow.AddInnerHTMLElement(myCell);
          myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
          myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          myCell.AddInnerHTMLString(m_asOwner.GetString(13, "ptmsgs_portalbrowsingmsgs"));
          //	EMPTY ROW
          myRow = new HTMLTableRow();
          linksTable.AddInnerHTMLElement(myRow);
          myRow.SetStyleClass(PTStyleClass.DIR_TEXT);
          myCell = new HTMLTableCell();
          myCell.SetHeight("10");
          myCell.SetStyleClass(PTStyleClass.DIR_TEXT);
          myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
          myCell.SetAutoFit(true);
          myRow.AddInnerHTMLElement(myCell);
        }
        if ((PT_SUBPORTAL_ACCESS_TYPES.PT_SUBPORTAL_COMMUNITIES_ACCESS & nAccessType) != 0)
        {
          //	COMMUNITIES LINK
          url = new ASURL(m_asOwner);
          url.SetLinkGetSpaceIfCached(CommunitySelectionEditorAS.STR_MVC_CLASS_NAME,
           this.m_asOwner);
          url.SetControl(EditorStartControl.STR_MVC_CLASS_NAME);
          url.AddControlArgument(EditorStartControl.QS_EDITOR_TYPE, EditorStartControl.EDITOR_START_FLAG_MISC);
          url.AddInnerHTMLString(m_asOwner.GetString(14, "ptmsgs_portalbrowsingmsgs"));
          myRow = new HTMLTableRow();
          myRow.SetStyleClass(PTStyleClass.LOGIN_TEXT);
          linksTable.AddInnerHTMLElement(myRow);
          myCell = new HTMLTableCell();
          myCell.SetStyleClass(PTStyleClass.LOGIN_TEXT);
          myRow.AddInnerHTMLElement(myCell);
          myConstruct = ConstructFactory.GetConstruct(PTImageType.ICON_COMMUNITY);
          myImg = (HTMLImg) myConstruct.GetHTMLElement();
          myImg.SetAlt(m_asOwner.GetString(14, "ptmsgs_portalbrowsingmsgs"));
          myCell.AddInnerHTMLElement(myImg);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          myCell.AddInnerHTMLElement(url.GetURLAsHTMLElement());
          //	COMMUNITIES TEXT
          myRow = new HTMLTableRow();
          myRow.SetStyleClass(PTStyleClass.LOGIN_TEXT);
          linksTable.AddInnerHTMLElement(myRow);
          myCell = new HTMLTableCell();
          myCell.SetStyleClass(PTStyleClass.LOGIN_TEXT);
          myRow.AddInnerHTMLElement(myCell);
          myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
          myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          myCell.AddInnerHTMLString(m_asOwner.GetString(15, "ptmsgs_portalbrowsingmsgs"));
          //	EMPTY ROW
          myRow = new HTMLTableRow();
          linksTable.AddInnerHTMLElement(myRow);
          myRow.SetStyleClass(PTStyleClass.DIR_TEXT);
          myCell = new HTMLTableCell();
          myCell.SetHeight("10");
          myCell.SetStyleClass(PTStyleClass.DIR_TEXT);
          myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
          myCell.SetAutoFit(true);
          myRow.AddInnerHTMLElement(myCell);
        }
        if ((PT_SUBPORTAL_ACCESS_TYPES.PT_SUBPORTAL_DIRECTORY_ACCESS & nAccessType) != 0)
        {
          //	DOCUMENTS LINK
          url = new ASURL(m_asOwner);
          url.SetLinkGetSpaceIfCached(DirAS.STR_MVC_CLASS_NAME, this.m_asOwner);
          url.SetControl(DirRepostControl.STR_MVC_CLASS_NAME);
          url.AddInnerHTMLString(m_asOwner.GetString(1582, "ptmsgs_portalbrowsingmsgs"));
          myRow = new HTMLTableRow();
          myRow.SetStyleClass(PTStyleClass.LOGIN_TEXT);
          linksTable.AddInnerHTMLElement(myRow);
          myCell = new HTMLTableCell();
          myCell.SetStyleClass(PTStyleClass.LOGIN_TEXT);
          myRow.AddInnerHTMLElement(myCell);
          myConstruct = ConstructFactory.GetConstruct(PTImageType.ICON_KNOWLEDGE_DIRECTORY);
          myImg = (HTMLImg) myConstruct.GetHTMLElement();
          myImg.SetAlt(m_asOwner.GetString(1582, "ptmsgs_portalbrowsingmsgs"));
          myCell.AddInnerHTMLElement(myImg);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          myCell.AddInnerHTMLElement(url.GetURLAsHTMLElement());
          //	DOCUMENTS TEXT
          myRow = new HTMLTableRow();
          myRow.SetStyleClass(PTStyleClass.LOGIN_TEXT);
          linksTable.AddInnerHTMLElement(myRow);
          myCell = new HTMLTableCell();
          myCell.SetStyleClass(PTStyleClass.LOGIN_TEXT);
          myRow.AddInnerHTMLElement(myCell);
          myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
          myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
          myCell = new HTMLTableCell();
          myRow.AddInnerHTMLElement(myCell);
          myCell.AddInnerHTMLString(m_asOwner.GetString(1583, "ptmsgs_portalbrowsingmsgs"));
          //	EMPTY ROW
          myRow = new HTMLTableRow();
          linksTable.AddInnerHTMLElement(myRow);
          myRow.SetStyleClass(PTStyleClass.DIR_TEXT);
          myCell = new HTMLTableCell();
          myCell.SetHeight("10");
          myCell.SetStyleClass(PTStyleClass.DIR_TEXT);
          myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
          myCell.SetAutoFit(true);
          myRow.AddInnerHTMLElement(myCell);
        }
        //	DOCUMENT SEARCH LINK
        url = new ASURL(m_asOwner);
        url.SetLinkGetSpaceIfCached(AdvancedSearchAS.STR_MVC_CLASS_NAME, this.m_asOwner);
        url.SetControl(EditorStartControl.STR_MVC_CLASS_NAME);
        url.AddControlArgument(EditorStartControl.QS_EDITOR_TYPE, EditorStartControl.EDITOR_START_FLAG_MISC);
        url.AddInnerHTMLString(m_asOwner.GetString(1584, "ptmsgs_portalbrowsingmsgs"));
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.LOGIN_TEXT);
        linksTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.LOGIN_TEXT);
        myRow.AddInnerHTMLElement(myCell);
        myConstruct = ConstructFactory.GetConstruct(PTImageType.ICON_SEARCH);
        myImg = (HTMLImg) myConstruct.GetHTMLElement();
        myImg.SetAlt(m_asOwner.GetString(1584, "ptmsgs_portalbrowsingmsgs"));
        myCell.AddInnerHTMLElement(myImg);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.AddInnerHTMLElement(url.GetURLAsHTMLElement());
        //	DOCUMENT SEARCH TEXT
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.LOGIN_TEXT);
        linksTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.LOGIN_TEXT);
        myRow.AddInnerHTMLElement(myCell);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.AddInnerHTMLString(m_asOwner.GetString(1585, "ptmsgs_portalbrowsingmsgs"));
        //	EMPTY ROW
        myRow = new HTMLTableRow();
        linksTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.DIR_TEXT);
        myCell = new HTMLTableCell();
        myCell.SetHeight("10");
        myCell.SetStyleClass(PTStyleClass.DIR_TEXT);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell.SetAutoFit(true);
        myRow.AddInnerHTMLElement(myCell);
        //	HELP LINK
        if (m_asOwner.GetIsAccessStyleStandard())
        {
          this.m_asOwner.SetHelpTopic("webhelp");
        } else
        {
          // there is no general help page for 508.
          this.m_asOwner.SetHelpTopic("PT_MyPages");
        }
        HTMLAnchor myAnchor = HTMLConstructHelpers.GetHelpAnchor(this.m_asOwner);
        myAnchor.ClearInnerHTMLElements();
        myAnchor.AddInnerHTMLString(m_asOwner.GetString(1586, "ptmsgs_portalbrowsingmsgs"));
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.LOGIN_TEXT);
        linksTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.LOGIN_TEXT);
        myRow.AddInnerHTMLElement(myCell);
        myConstruct = ConstructFactory.GetConstruct(PTImageType.ICON_HELP);
        myImg = (HTMLImg) myConstruct.GetHTMLElement();
        myImg.SetAlt(m_asOwner.GetString(1586, "ptmsgs_portalbrowsingmsgs"));
        myCell.AddInnerHTMLElement(myImg);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.AddInnerHTMLElement(myAnchor);
        //	HELP TEXT
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.LOGIN_TEXT);
        linksTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.LOGIN_TEXT);
        myRow.AddInnerHTMLElement(myCell);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.AddInnerHTMLString(m_asOwner.GetString(1587, "ptmsgs_portalbrowsingmsgs"));
        //	EMPTY ROW
        myRow = new HTMLTableRow();
        linksTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.DIR_TEXT);
        myCell = new HTMLTableCell();
        myCell.SetHeight("10");
        myCell.SetStyleClass(PTStyleClass.DIR_TEXT);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell.SetAutoFit(true);
        myRow.AddInnerHTMLElement(myCell);
      }
      catch (HTMLException he)
      {
        log.Error("he: " + he);
      }
      catch (Exception ex)
      {
        log.Error("ex: " + ex);
      }
      return myTable;
    }
    
    /// <summary>
    /// This method returns the HTMLScript that encompasses the Javascript on the page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    /// <returns>HTMLScript</returns>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#Init(IModel,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asmModel = (CreateAccountModel) model;
      m_asOwner = parent;
    }
  }
}