using System;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.browsing.myportal
{
  /// <author>michaeld</author>
  public interface IMyPortalModelHelper
  {
    
    /// <summary>
    /// Returns the preference name for collapsed gadgets.
    /// </summary>
    /// <returns>String strCollapsedPortletsPrefName</returns>
    String GetCollapsedPortletsPrefName();
    
    /// <summary>
    /// Get the pages in the community.
    /// </summary>
    /// <param name="nCommunityID">nCommunityID</param>
    /// <returns>IPTQueryResult ptqrCommunityPages</returns>
    IPTQueryResult GetCommunityPages(int nCommunityID);
    
    /// <summary>
    /// Returns the portlets without title bars.
    /// </summary>
    /// <param name="nCOmmunityID">nCommunityID</param>
    /// <returns>Object[][] aoPortletHasNoTitleBar</returns>
    Object[][] GetPortletHasNoTitleBar(int nCommunityID);
    
    /// <summary>
    /// Get whether the current page is a community page.
    /// </summary>
    /// <returns>boolean bIsCommunityPage</returns>
    bool GetIsCommunityPage();
    
    /// <summary>
    /// Initializes the MyPortalModelHelper.
    /// </summary>
    /// <param name="ptSession">session</param>
    void Init(IPTSession ptSession, AActivitySpace parent);
    
    /// <summary>
    /// Returns IPTMyPortal for the current page.
    /// </summary>
    /// <param name="nCommunityID">nCommunityID</param>
    /// <param name="nPageID">nPageID</param>
    /// <returns>IPTMyPortal</returns>
    IPTPageInfo OpenPage(int nCommunityID, int nPageID);
    
    /// <summary>
    /// Returns the Community Name if this is a Community.
    /// </summary>
    /// <param name="nCommunityID"></param>
    /// <returns>String</returns>
    /// <deprecated>Use NavigationModel.GetCurCommunityName instead.</deprecated>
    String GetCommunityName(int nCommunityID);
  }
}