using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.intrinsicportlets;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
namespace com.plumtree.portalpages.browsing.myportal
{
  /// <author>josephc</author>
  public class IntrinsicPortletsRepostControl : RepostControl
  {
    
    /// <summary>
    /// Class name for the control 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "IntrinsicPortletsRepostControl";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new IntrinsicPortletsRepostControl();
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.RepostControl#PerformAction(int)"></seealso>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      // Aggregate all of the intrinsic portlet controls. Now iterate through intrinsic
      // portlet controls and call PerformRepostAction for each.
      IXPEnumerator enumControls = m_asOwner.GetControlsEnumerator();
      while (enumControls.MoveNext())
      {
        IControl currentControl = (IControl) enumControls.GetCurrent();
        if (currentControl is IntrinsicPortletControl)
        {
          IntrinsicPortletControl iPortletControl = (IntrinsicPortletControl) currentControl;
          iPortletControl.PerformRepostAction(_nAction, m_htFormData);
          // mbs- do a quick check for a redirect
          Redirect r = iPortletControl.CheckActionSecurityAndExecute(m_htFormData);
          if (null != r)
          {
            SetRedirect(r);
          }
        }
      }
    }
  }
}