using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.myportal
{
  /// <version>$Revision$</version>
  /// <author>RobZ</author>
  public class MyPortalFooterView : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.myportal.MyPortalFooterView");
    public const String m_ObjectName = "MyPortalFooterView";
    protected AActivitySpace m_asOwner;
    protected IMyPortalModelRO m_model;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new MyPortalFooterView();
    }
    
    /// <summary>
    /// This method returns the HTMLElement that encompasses the output of the
    /// Section.
    /// </summary>
    /// <returns></returns>
    public virtual HTMLElement Display()
    {
      // Temp thing
      // boolean bValidSession = true; not used -- JAO
      HTMLElementCollection result = new HTMLElementCollection();
      // HTMLTable table              = new HTMLTable(); JAO
      //        try
      //        {
      //            result.AddInnerHTMLElement(table);
      //
      //            // Community actions
      //            // Dont display if we are editing a default profile
      //            XPArrayList list = m_model.GetMyPortalActions();
      //
      //            if (m_model.GetIsCommunityPage())
      //            {
      //                GenerateFooterActions(table, list, _ui_MembershipOptions);
      //            }
      //            else
      //            {
      //                GenerateFooterActions(table, list, _ui_PageOptions);
      //            }
      //        }
      //        catch (HTMLException he)
      //        {
      //            he.printStackTrace();
      //        }
      return result;
    }
    
    /// <summary>
    /// This method returns the HTMLScript that encompasses the Javascript on
    /// the page.
    /// </summary>
    /// <returns>HTMLScript</returns>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <summary>
    /// Return the name of the Section.
    /// </summary>
    /// <returns></returns>
    public virtual String GetName()
    {
      return m_ObjectName;
    }
    
    /// <summary>
    /// This method initializes the Section with the read only model interface it
    /// is supposed to draw it's data from as well as it's parent ActivitySpace
    /// (necessary to create URLS).
    /// </summary>
    /// <param name="model"></param>
    /// <param name="parent"></param>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_model = (IMyPortalModelRO) model;
      m_asOwner = parent;
    }
    
    /// <param name="table"></param>
    /// <param name="list"></param>
    /// <param name="title"></param>
    /// <throws>HTMLException</throws>
    protected virtual void GenerateFooterActions(HTMLTable table, XPArrayList list,
     String title)
    {
      HTMLTableRow row = new HTMLTableRow();
      HTMLTableCell cell = new HTMLTableCell();
      cell.SetVAlign("MIDDLE");
      cell.SetAlign("LEFT");
      table.AddInnerHTMLElement(row);
      row.AddInnerHTMLElement(cell);
      cell.AddInnerHTMLElement(new HTMLAnchor("options"));
      cell.AddInnerHTMLString(title);
      cell.SetStyleClass(PTStyleClass.ACTIONBAR_BAN_TEXT);
      row = new HTMLTableRow();
      cell = new HTMLTableCell();
      cell.SetStyleClass(PTStyleClass.ACTIONBAR_TEXT);
      table.AddInnerHTMLElement(row);
      row.AddInnerHTMLElement(cell);
      for (int i = 0;i < list.GetSize();i++)
      {
        if (0 != i)
        {
          cell.AddInnerHTMLString("&nbsp; | &nbsp;");
        }
        ASURLContainer urlCont = null;
        try
        {
          urlCont = (ASURLContainer) list.GetElement(i);
        }
        catch (Exception e)
        {
          log.Error(e, "Error in MyPortalFooterView::GenerateFooterActions: ");
          }
        cell.AddInnerHTMLElement(ASURL.CreateFromURLContainerNew(urlCont).GetURLAsHTMLElement());
        }
    }
  }
}