using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.browsing.myportal.communities;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.myportal
{
  /// <author>RobZ</author>
  public class MyPortalHeaderView : IView
  {
    
    /// <summary>
    /// Object name; not to be localized 
    /// </summary>
    public const String ObjectName = "MyPortalHeaderView";
    // Localizable lable strings used in 508 mode
    protected AActivitySpace m_asOwner;
    protected IMyPortalModelRO m_model;
    protected bool m_bCommunityPage = true;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new MyPortalHeaderView();
    }
    
    /// <summary>
    /// This method returns the HTMLElement that encompasses the output of the
    /// Section.
    /// </summary>
    /// <returns></returns>
    public virtual HTMLElement Display()
    {
      HTMLTable table = null;
      HTMLTableRow row = null;
      HTMLTableCell cell = null;
      IPTQueryResult qrPages = null;
      if (m_model.GetIsCommunityPage())
      {
        qrPages = m_model.GetCommunityPages();
      }
      try
      {
        // Also check what type of navigation currently used		
        if (null != qrPages)
        {
          table = new HTMLTable();
          table.SetSummary(m_asOwner.GetString(1269, "ptmsgs_portalbrowsingmsgs"));
          row = new HTMLTableRow();
          table.AddInnerHTMLElement(row);
          cell = new HTMLTableCell();
          cell.SetWidth("100%");
          cell.SetAlign("LEFT");
          //				cell.AddInnerHTMLString("adf");
          row.AddInnerHTMLElement(cell);
          row = new HTMLTableRow();
          table.AddInnerHTMLElement(row);
          // Temp code
          cell = new HTMLTableCell();
          cell.SetWidth("100%");
          cell.SetAlign("CENTER");
          //			cell.SetStyleClass("body");
          for (int i = 0;i < qrPages.RowCount();i++)
          {
            String pageName = qrPages.ItemAsString(i, PT_PROPIDS.PT_PROPID_NAME);
            int pageID = qrPages.ItemAsInt(i, PT_PROPIDS.PT_PROPID_OBJECTID);
            ASURL asURL = new ASURL(m_asOwner);
            asURL.SetLinkCreateNewSpace(CommunityPageAS.STR_MVC_CLASS_NAME,
             m_asOwner);
            asURL.SetControl(SetCommunityControl.STR_MVC_CLASS_NAME);
            asURL.AddControlArgument(SetCommunityControl.STR_COMMUNITY_ID,
             XPConvert.ToString(m_model.GetCommunityID()));
            asURL.AddControlArgument(SetCommunityControl.STR_PAGE_ID, XPConvert.ToString(pageID));
            asURL.AddInnerHTMLString(pageName);
            if (0 != i)
            {
              cell.AddInnerHTMLString("&nbsp;|&nbsp;");
            }
            cell.AddInnerHTMLElement(asURL.GetURLAsHTMLElement());
            cell.SetStyleClass(PTStyleClass.BREADCRUMB_TEXT);
          }
          //cell.AddInnerHTMLString("blalba &nbsp;|&nbsp; adfafd &nbsp;|&nbsp; asdfaf &nbsp;|&nbsp; adfasf &nbsp;|&nbsp;a dafasdfasf &nbsp;|&nbsp;");
          row.AddInnerHTMLElement(cell);
        }
      }
      catch (Exception e)
      {
        // @TODO: Fix this shiat
        table = new HTMLTable();
      }
      return table;
    }
    
    /// <summary>
    /// This method returns the HTMLScript that encompasses the Javascript on
    /// the page.
    /// </summary>
    /// <returns>HTMLScript</returns>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <summary>
    /// Return the name of the Section.
    /// </summary>
    /// <returns></returns>
    public virtual String GetName()
    {
      return ObjectName;
    }
    
    /// <summary>
    /// This method initializes the Section with the model it is supposed to draw
    /// it's data from as well as it's parent ActivitySpace (necessary to
    /// create URLS).
    /// </summary>
    /// <param name="model"></param>
    /// <param name="parent"></param>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_model = (IMyPortalModelRO) model;
      m_asOwner = parent;
    }
  }
}