using System;
namespace com.plumtree.portalpages.browsing.myportal
{
  /// <author>michaeld</author>
  public class PortletColumnConstants
  {
    public static readonly PortletColumnConstants FREE_FORM = new PortletColumnConstants(-1);
    public static readonly PortletColumnConstants NARROW_ONE = new PortletColumnConstants(0);
    public static readonly PortletColumnConstants WIDE_ONE = new PortletColumnConstants(1);
    public static readonly PortletColumnConstants NARROW_TWO = new PortletColumnConstants(2);
    
    /// <summary>
    /// SKIP is used for headers and footers, so they don't get displayed in any column. 
    /// </summary>
    public static readonly PortletColumnConstants SKIP = new PortletColumnConstants(3);
    private int m_nPortletColumn;
    
    /// <summary>
    /// Creates a new PortletColumnConstants object.
    /// </summary>
    /// <param name="nPortletColumn"></param>
    private PortletColumnConstants(int nPortletColumn)
    {
      m_nPortletColumn = nPortletColumn;
    }
    
    /// <returns></returns>
    public virtual int ToInt()
    {
      return m_nPortletColumn;
    }
  }
}