using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.myportal.communities
{
  /// <summary>
  /// File: CommunityInvitationView_D.java
  /// -----------------------------
  /// </summary>
  /// <author>NaveenP/DustinA</author>
  public class CommunityInvitationView_D : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.myportal.communities.CommunityInvitationView_D");
    public const String STR_MVC_CLASS_NAME = "CommunityInvitation_D";
    
    /// <summary>
    /// Activity Space 
    /// </summary>
    private AActivitySpace m_asOwner;
    
    /// <summary>
    /// model 
    /// </summary>
    private PreviewCommunityBarModel m_asModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new CommunityInvitationView_D();
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#display()"></seealso>
    public virtual HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable mainTable;
      HTMLTableRow mainRow;
      HTMLTableCell mainCell;
      HTMLH1 headerH1;
      HTMLH2 headerH2;
      try
      {
        HTMLComment myComment = new HTMLComment("Begin: Display CommunityInvitationView_D");
        result.AddInnerHTMLElement(myComment);
        HTMLTable headerTable = new HTMLTable();
        result.AddInnerHTMLElement(headerTable);
        headerTable.SetStyleClass(PTStyleClass.BAN_HEADER_BG);
        headerTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        headerTable.SetHeight("52");
        HTMLTableRow headerRow = new HTMLTableRow();
        headerTable.AddInnerHTMLElement(headerRow);
        HTMLTableCell headerCell = new HTMLTableCell();
        headerRow.AddInnerHTMLElement(headerCell);
        headerCell.SetVAlign(CommonHTMLStrings.CENTER);
        headerH1 = new HTMLH1();
        headerCell.AddInnerHTMLElement(headerH1);
        headerH1.AddInnerHTMLString(m_asOwner.GetString(1252, "ptmsgs_portalbrowsingmsgs"));
        headerH1.SetStyleClass(PTStyleClass.BAN_HEADER);
        headerCell.AddInnerHTMLElement(new HTMLBr());
        headerH2 = new HTMLH2();
        headerCell.AddInnerHTMLElement(headerH2);
        headerH2.AddInnerHTMLString(m_asOwner.GetString(1250, "ptmsgs_portalbrowsingmsgs"));
        headerH2.SetStyleClass(PTStyleClass.BAN_SUBHEADER);
        mainTable = new HTMLTable();
        result.AddInnerHTMLElement(mainTable);
        mainTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        mainRow = new HTMLTableRow();
        mainTable.AddInnerHTMLElement(mainRow);
        mainCell = new HTMLTableCell();
        mainRow.AddInnerHTMLElement(mainCell);
        mainCell.SetWidth("20");
        mainCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        mainCell = new HTMLTableCell();
        mainRow.AddInnerHTMLElement(mainCell);
        HTMLTable myInnerTable = new HTMLTable();
        mainCell.AddInnerHTMLElement(myInnerTable);
        myInnerTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        HTMLTableRow myInnerRow = new HTMLTableRow();
        myInnerTable.AddInnerHTMLElement(myInnerRow);
        HTMLTableCell myInnerCell = new HTMLTableCell();
        myInnerRow.AddInnerHTMLElement(myInnerCell);
        myInnerCell.SetHeight("10");
        myInnerCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myInnerRow = new HTMLTableRow();
        myInnerTable.AddInnerHTMLElement(myInnerRow);
        myInnerCell = new HTMLTableCell();
        myInnerRow.AddInnerHTMLElement(myInnerCell);
        myInnerCell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        myInnerCell.AddInnerHTMLString(XPResourceManager.FormatMessage(m_asOwner.GetString(1251,
         "ptmsgs_portalbrowsingmsgs"), XPHttpUtility.HtmlEncode(m_asModel.GetCommunityName())));
        myInnerRow = new HTMLTableRow();
        myInnerTable.AddInnerHTMLElement(myInnerRow);
        myInnerCell = new HTMLTableCell();
        myInnerRow.AddInnerHTMLElement(myInnerCell);
        if (!m_asModel.IsCommunityMember())
        {
          myInnerCell.SetStyleClass(PTStyleClass.CUSTOMAPP_TEXT);
          myInnerCell.AddInnerHTMLString(m_asOwner.GetString(1249, "ptmsgs_portalbrowsingmsgs"));
          } else
        {
          myInnerCell.SetStyleClass(PTStyleClass.ALERT_ERROR_TEXT);
          myInnerCell.AddInnerHTMLString(XPResourceManager.FormatMessage(m_asOwner.GetString(1638,
           "ptmsgs_portalbrowsingmsgs"), XPHttpUtility.HtmlEncode(m_asModel.GetCommunityName())));
          }
        myInnerRow = new HTMLTableRow();
        myInnerTable.AddInnerHTMLElement(myInnerRow);
        myInnerCell = new HTMLTableCell();
        myInnerRow.AddInnerHTMLElement(myInnerCell);
        myInnerCell.SetHeight("10");
        myInnerCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myComment = new HTMLComment("End: Display CommunityInvitationView_D");
        result.AddInnerHTMLElement(myComment);
      }
      catch (HTMLException he)
      {
        log.Error(he, "Error displaying CommunityInvitationView_D.");
      }
      return result;
    }
    
    /// <summary>
    /// Display JavaScript - this includes the static source file
    /// return HTMLScript
    /// </summary>
    public virtual HTMLScript DisplayJavascript()
    {
      HTMLScript script = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
      script.SetSrc(ConfigHelper.GetPortalImageServerJavaScriptURL(m_asOwner) + "opennewwindow.js");
      return script;
    }
    
    /// <summary>
    /// Display JavaScript - this includes the static source file
    /// return HTMLScript
    /// </summary>
    public virtual HTMLScript DisplayRedirectJavascript()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#Init(IModel,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asModel = (PreviewCommunityBarModel) model;
      m_asOwner = parent;
    }
  }
}