using System;
using com.plumtree.portalpages.browsing.myportal;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.portaluiinfrastructure.login;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.myportal.communities
{
  /// <author>MichaelD</author>
  public class CommunityPageAS : PlumtreeAS
  {
    public const String STR_MVC_CLASS_NAME = "CommunityPage";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new CommunityPageAS();
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Repost control for intrinsic portlets.
    /// </summary>
    /// <returns>Intrinsic portlets repost control name</returns>
    public override String GetRepostControlName()
    {
      return IntrinsicPortletsRepostControl.STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.AActivitySpace#GetStyleSheetLinks()"></seealso>
    public override HTMLElementCollection GetStyleSheetLinks()
    {
      String settingLanguage = (String) PTPersonalSettingsHelper.GetPersonalSettingValue(PersonalSettingNames.LANGUAGE,
       this);
      MyPortalModel myModel = (MyPortalModel) GetModel(MyPortalModel.STR_MVC_CLASS_NAME);
      CommunityMyPortalModelHelper myHelper = (CommunityMyPortalModelHelper) myModel.GetHelper();
      int nHeaderID = myHelper.GetHeaderID(myModel.GetCommunityID());
      String strStyleSheet = "";
      if (nHeaderID > 0)
      {
        strStyleSheet = myHelper.GetStyleSheet(myModel.GetCommunityID());
        }
      HTMLElementCollection pCollection = null;
      if (!("").Equals(strStyleSheet) && (strStyleSheet != null))
      {
        if (GetIsAccessStyleNonStandard())
        {
          strStyleSheet = PlumtreeHelpers.STYLE_PREFIX_508 + strStyleSheet;
          }
        PTStyleSheetLink ptStyleSheetLink = new PTStyleSheetLink(strStyleSheet,
         settingLanguage);
        pCollection = new HTMLElementCollection();
        try
        {
          pCollection.AddInnerHTMLElement(ptStyleSheetLink.GetLinkAsHTMLElement(ConfigHelper.GetStyleSheetsBaseURL(this)));
          }
        catch (HTMLException e)
        {
        }
        catch (Exception e)
        {
        }
      } else
      {
        // use the default subportal stylesheet
        pCollection = base.GetStyleSheetLinks();
      }
      return pCollection;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.AActivitySpace#Init()"></seealso>
    public override void Init()
    {
      base.Init();
      // CommunityPage DisplayPages
      PlumtreeDP myPortalDP = new MyPortalDP();
      RegisterPage(myPortalDP);
      RegisterPage(new MyPortalPartialPortletsDP());
      // CommunityPage Model
      RegisterModel(MyPortalModel.STR_MVC_CLASS_NAME);
      IModel myModel = GetModel(MyPortalModel.STR_MVC_CLASS_NAME);
      ((MyPortalModel) myModel).SetMyPortalModelHelper(new CommunityMyPortalModelHelper());
      // Model has to be initialized in Init method because it requires PTSession.
      // CommunityPage Views
      RegisterView(MyPortalContentView.STR_MVC_CLASS_NAME, myModel);
      // Join confirmation & error page
      RegisterView(CommunityInvitationJoinView.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(JoinCurCommunityControl.STR_MVC_CLASS_NAME, myModel);
      // Unsubscribe confirmation & error page
      RegisterView(CommunityUnsubscribeView.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(UnsubscribeCurCommunityControl.STR_MVC_CLASS_NAME, myModel);
      // Extended Navigation Section
      RegisterView(MyPortalHeaderView.ObjectName, myModel);
      RegisterView(MyPortalFooterView.m_ObjectName, myModel);
      // CommunityPage Controls
      RegisterControl(SetPageControl.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(SetCommunityControl.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(CollapsePortletControl.STR_MVC_CLASS_NAME, CollapsePortletControl.STR_EXPAND_CONTROL,
       myModel);
      RegisterControl(CollapsePortletControl.STR_MVC_CLASS_NAME, CollapsePortletControl.STR_COLLAPSE_CONTROL,
       myModel);
      RegisterControl(AddRemovePortletControl.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(ReorderPortletsControl.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(IntrinsicPortletsRepostControl.STR_MVC_CLASS_NAME, myModel);
      // Default fall-through control when control has been lost (error handling)
      RegisterControl(DefaultPageControl.STR_MVC_CLASS_NAME, "", myModel);
      this.SetHelpTopic("PT_MyCommunities");
    }
  }
}