using System;
namespace com.plumtree.portalpages.browsing.myportal.communities
{
  /// <author>robertz</author>
  public interface IJoinPreviewCommunityModel
  {
    
    /// <summary>
    /// Was the join succesful?
    /// </summary>
    /// <returns>boolean</returns>
    bool CommunityJoinFailed();
    
    /// <summary>
    /// Get the ID of the community to join
    /// </summary>
    /// <returns>int</returns>
    int GetCommunityID();
    
    /// <summary>
    /// Get the URL to the Community 
    /// </summary>
    /// <returns>String</returns>
    String GetCommunityURL();
    
    /// <summary>
    /// Get the URL to the default Community
    /// </summary>
    /// <returns>String</returns>
    String GetDefaultCommunityURL();
    
    /// <summary>
    /// Get the Name of the community
    /// </summary>
    /// <returns>String</returns>
    String GetCommunityName();
  }
}