using System;
namespace com.plumtree.portalpages.browsing.myportal.communities
{
  public interface IUnsubscribeCommunityModel
  {
    
    /// <summary>
    /// Was the unsubscribe succesful?
    /// </summary>
    /// <returns>boolean</returns>
    bool CommunityUnsubscribeFailed();
    
    /// <summary>
    /// Get the ID of the community to unsubscribe
    /// </summary>
    /// <returns>int</returns>
    int GetCommunityID();
    
    /// <summary>
    /// Get the URL to the Community 
    /// </summary>
    /// <returns>String</returns>
    String GetCommunityURL();
    
    /// <summary>
    /// Get the URL to the default Community
    /// </summary>
    /// <returns>String</returns>
    String GetDefaultCommunityURL();
    
    /// <summary>
    /// Get the Name of the community
    /// </summary>
    /// <returns>String</returns>
    String GetCommunityName();
  }
}