using System;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.browsing.myportal.communities
{
  /// <summary>
  /// File: PreviewCommunityAS.java
  /// -----------------------------
  /// </summary>
  /// <author>NaveenP</author>
  public class PreviewCommunityAS : PlumtreeAS
  {
    public const String STR_MVC_CLASS_NAME = "PreviewCommunity";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new PreviewCommunityAS();
    }
    
    /// <summary>
    /// Get Name
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.AActivitySpace#Init()"></seealso>
    public override void Init()
    {
      base.Init();
      SetTrackCurrentPage(true);
      // Community Preview DisplayPages
      RegisterPage(new PreviewCommunityDP());
      RegisterPage(new NoCommunityAccessDP());
      // Community Preview Models
      RegisterModel(PreviewCommunityModel.STR_MVC_CLASS_NAME);
      IModel myModel = GetModel(PreviewCommunityModel.STR_MVC_CLASS_NAME);
      RegisterView(NoCommunityAccessView.STR_MVC_CLASS_NAME, myModel);
      // Community Preview Controls
      RegisterControl(PreviewCommunityControl.STR_MVC_CLASS_NAME, myModel);
      }
  }
}