using System;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
namespace com.plumtree.portalpages.browsing.myportal.communities
{
  /// <summary>
  /// File: PreviewCommunityBarAS.java
  /// --------------------------------
  /// </summary>
  /// <author>NaveenP</author>
  public class PreviewCommunityBarAS : PlumtreeAS,IFormAS
  {
    public const String STR_MVC_CLASS_NAME = "PreviewCommunityBar";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new PreviewCommunityBarAS();
    }
    
    /// <summary>
    /// Get Name
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.IRepostAS#GetRepostControlName()"></seealso>
    public override String GetRepostControlName()
    {
      return JoinCommunityControl.STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.AActivitySpace#Init()"></seealso>
    public override void Init()
    {
      base.Init();
      SetTrackCurrentPage(true);
      // Community Preview DisplayPages
      RegisterPage(new PreviewCommunityBarDP());
      RegisterPage(new PreviewCommunityDescPopupDP());
      RegisterPage(new CommunityInvitationJoinDP());
      //		CommunityInvitationDP_D commInviteDP_D = new CommunityInvitationDP_D();
      //		commInviteDP_D.SetShowFormFooter(true);
      RegisterPage(new CommunityInvitationDP_D());
      // Community Preview Model
      RegisterModel(PreviewCommunityBarModel.STR_MVC_CLASS_NAME);
      IModel myModel = GetModel(PreviewCommunityBarModel.STR_MVC_CLASS_NAME);
      // Preview and Invitation Views
      RegisterView(PreviewCommunityView.STR_MVC_CLASS_NAME, myModel);
      RegisterView(PreviewCommunityDescPopupView.STR_MVC_CLASS_NAME, myModel);
      RegisterView(CommunityInvitationJoinView.STR_MVC_CLASS_NAME, myModel);
      RegisterView(CommunityInvitationView_D.STR_MVC_CLASS_NAME, myModel);
      // Community Preview Controls
      RegisterControl(PreviewCommunityBarControl.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(JoinCommunityControl.STR_MVC_CLASS_NAME, myModel);
    }
  }
}