using System;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.myportal.communities
{
  /// <author>NaveenP</author>
  public class PreviewCommunityBarDP : AFormDP
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.myportal.communities.PreviewCommunityBarDP");
    public const String STR_MVC_CLASS_NAME = "PreviewCommunityBar";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()"></seealso>
    public override String GetFormTitle()
    {
      return m_asOwner.GetString(1621, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.AformDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLTable tOuter = new HTMLTable();
      try
      {
        tOuter.SetCellPadding("0");
        tOuter.SetCellPadding("0");
        HTMLTableRow tRow = null;
        HTMLTableCell tCell = null;
        tOuter.SetWidth("100%");
        tOuter.SetBorder("0");
        tRow = new HTMLTableRow();
        tCell = new HTMLTableCell();
        tOuter.AddInnerHTMLElement(tRow);
        tRow.AddInnerHTMLElement(tCell);
        tRow.SetVAlign("TOP");
        tCell.SetVAlign("TOP");
        tCell.AddInnerHTMLElement(m_asOwner.GetView(PreviewCommunityView.STR_MVC_CLASS_NAME).Display());
        }
      catch (HTMLException he)
      {
        log.Error(he, he.Message);
      }
      return tOuter;
    }
    
    /// <returns></returns>
    /// <throws>HTMLException </throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      PreviewCommunityBarModel asModel = (PreviewCommunityBarModel) m_asOwner.GetModel(PreviewCommunityBarModel.STR_MVC_CLASS_NAME);
      HTMLScriptCollection scripts = new HTMLScriptCollection();
      if (asModel.IsCommunitySelectionPreviewPage() || asModel.IsCommunityInvitePage())
      {
        scripts.AddInnerHTMLElement(((PreviewCommunityView) m_asOwner.GetView(PreviewCommunityView.STR_MVC_CLASS_NAME)).JoinCommunityInPreviewPageScript());
        }
      return scripts;
    }
  }
}