using System;
using com.plumtree.portalpages.browsing.myportal;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.common;
namespace com.plumtree.portalpages.browsing.myportal.communities
{
  /// <summary>
  /// File: PreviewCommunityDP.java
  /// -----------------------------
  /// </summary>
  /// <author>NaveenP</author>
  public class PreviewCommunityDP : FrameSetDP
  {
    public const String STR_MVC_CLASS_NAME = "PreviewCommunity";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.dialogheader.FrameSetDialog#GetFrameSetTitle()"></seealso>
    public override String GetFrameSetTitle()
    {
      return m_asOwner.GetString(703, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.dialogheader.FrameSetDialog#GetFrameURLBody()"></seealso>
    public override ASURL GetFrameURLBody()
    {
      PreviewCommunityModel asModel = (PreviewCommunityModel) m_asOwner.GetModel(PreviewCommunityModel.STR_MVC_CLASS_NAME);
      ASURL url = new ASURL(m_asOwner);
      url.SetLinkCreateNewSpace(CommunityPageAS.STR_MVC_CLASS_NAME, m_asOwner);
      url.SetControl(SetCommunityControl.STR_MVC_CLASS_NAME);
      url.AddControlArgument(SetCommunityControl.STR_COMMUNITY_ID, asModel.GetCommunityID());
      url.AddControlArgument(SetCommunityControl.STR_PAGE_ID, 0);
      url.AddControlArgument(SetCommunityControl.PREVIEW);
      return url;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.dialogheader.FrameSetDialog#GetFrameURLTop()"></seealso>
    public override ASURL GetFrameURLTop()
    {
      PreviewCommunityModel asModel = (PreviewCommunityModel) m_asOwner.GetModel(PreviewCommunityModel.STR_MVC_CLASS_NAME);
      ASURL url = new ASURL(m_asOwner);
      url.SetLinkCreateNewSpace(PreviewCommunityBarAS.STR_MVC_CLASS_NAME,
       m_asOwner);
      url.SetControl(PreviewCommunityBarControl.STR_MVC_CLASS_NAME);
      url.AddControlArgument(PreviewCommunityBarControl.m_CommunityID, asModel.GetCommunityID());
      url.AddControlArgument(PreviewCommunityBarControl.m_PageID, -1 * asModel.GetCommunityID());
      url.AddControlArgument(PreviewCommunityBarControl.m_PreviewType, asModel.m_nPreviewStatus);
      url.AddControlArgument(PreviewCommunityBarControl.m_CommunityIndex,
       asModel.GetCommunityIndex());
      url.AddControlArgument(PreviewCommunityBarControl.m_CommunityChecked,
       asModel.IsCommunityChecked());
      url.AddControlArgument(PreviewCommunityBarControl.m_strJoinCommunityJavascriptOverride,
       asModel.GetJoinCommunityJavaScriptOverride());
      return url;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.FrameSetDP#GetFrameScrollBody()"></seealso>
    public override bool GetFrameScrollBody()
    {
      return true;
    }
  }
}