using System;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.browsing.myportal.communities
{
  /// <summary>
  /// File: PreviewCommunityDescPopupDP.java
  /// --------------------------------------
  /// Display page for the Community Description popup.
  /// </summary>
  /// <author>NaveenP/DustinA</author>
  public class PreviewCommunityDescPopupDP : IDisplayPage
  {
    public const String STR_MVC_CLASS_NAME = "PreviewCommunityDescPopup";
    private AActivitySpace m_asOwner;
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#display()"></seealso>
    public virtual void Display(IWebData pageData)
    {
      // TODOCR: DONH - Shouldn't there by a Display Page that wraps this view
      // and generates the HTMLPage?
      pageData.SetData(m_asOwner.GetView(PreviewCommunityDescPopupView.STR_MVC_CLASS_NAME).Display());
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.ui.framework.IDisplayPage#GetParent()"></seealso>
    public virtual AActivitySpace GetOwner()
    {
      return m_asOwner;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#Init(AActivitySpace)"></seealso>
    public virtual void Init(AActivitySpace parent)
    {
      m_asOwner = parent;
    }
  }
}