using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.myportal.editpage
{
  /// <author>michaeld</author>
  public class EditCommunityPageView : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.myportal.editpage.EditCommunityPageView");
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "EditCommunityPage";
    
    /// <summary>
    /// Javascript function: submitToParent 
    /// </summary>
    public const String JAVASCRIPT_SUBMIT_TO_PARENT = "submitToParent";
    
    /// <summary>
    /// Form Input: Page Template Selected 
    /// </summary>
    public const String HTMLINPUT_PAGETEMPLATE_SET = "in_hi_PTSet";
    
    /// <summary>
    /// Activity Space 
    /// </summary>
    private AActivitySpace m_asasParent;
    
    /// <summary>
    /// Model 
    /// </summary>
    private IEditMyPortalPageModelRO m_asmModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new EditCommunityPageView();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Display()"></seealso>
    public virtual HTMLElement Display()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    public virtual HTMLScript DisplayJavascript()
    {
      // Set up parent form space ID
      String strSpaceIDInput = m_asmModel.GetParentFormSpaceID();
      // Calculate approximate string builder size
      int nSize = 400;
      if ((strSpaceIDInput != null) && (!"".Equals(strSpaceIDInput)))
      {
        // Add space for setting the space ID on the parent page
        nSize+=20;
      }
      XPStringBuilder sb = new XPStringBuilder(nSize);
      // Select submit function (multi and single)
      // Different cases for a single radio/checkbox button vs. multiple
      // radio/checkbox buttons:
      // - single is just an object
      // - multiple is an array of objects
      //sb.Append( "function " ).Append(JAVASCRIPT_SUBMIT_TO_PARENT).Append("()\n" );
      //sb.Append( "{\n" );
      //sb.Append( "  return true;\n" );
      //sb.Append( "}\n" );
      //sb.Append( "\n" );
      // Onload method to set the Space ID
      if ((strSpaceIDInput != null) && (!"".Equals(strSpaceIDInput)))
      {
        // TODO: Should this only be called the first time the tree is displayed?
        sb.Append("window.opener.document.").Append(JSHelper.escapeJS(m_asmModel.GetParentFormName())).Append(".").Append(JSHelper.escapeJS(strSpaceIDInput)).Append(".value= ").Append(m_asasParent.GetSpaceID()).Append(";\n");
        sb.Append("\n");
      }
      HTMLScript result = new HTMLScript("text/javaScript");
      try
      {
        result.AddInnerHTMLString(sb.ToString());
      }
      catch (HTMLException he)
      {
        log.Error(he, "DisplayJavascript couldn\'t add javascript to the HTMLScript element.");
        }
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asmModel = (IEditMyPortalPageModelRO) model;
      m_asasParent = parent;
    }
  }
}