using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.portalpages.browsing.myportal;
using com.plumtree.portalpages.common.editpage;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.myportal.editpage
{
  /// <summary>
  /// File: EditMyPagePortletLayoutAS_D.java
  /// -------------------------------------
  /// </summary>
  /// <author>NaveenP</author>
  public class EditMyPagePortletLayoutAS_D : PTEditorAS
  {
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "EditMyPageGadgetLayout";
    
    /// <summary>
    /// Plug in Key: PageName 
    /// </summary>
    public const String strPageNamePlugInKey = "PageName";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new EditMyPagePortletLayoutAS_D();
    }
    public override String GetEditorTitle()
    {
      EditMyPagePortletLayoutModel_D myModel = (EditMyPagePortletLayoutModel_D) GetModel(EditMyPagePortletLayoutModel_D.STR_MVC_CLASS_NAME);
      return XPResourceManager.FormatMessage(GetString(1261, "ptmsgs_portalbrowsingmsgs"),
       myModel.GetPageName());
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(java.lang.String,java.lang.String,boolean)"></seealso>
    public override bool CheckBasicAccess(String strPage, String strControl,
     bool bSameSpace)
    {
      bool bAccess = base.CheckBasicAccess(strPage, strControl, bSameSpace);
      if ((null != strControl) && (strControl.Equals(SetPageControl.STR_MVC_CLASS_NAME)))
      {
        bAccess = true;
      }
      return bAccess;
    }
    
    /// <returns></returns>
    /// <throws>HTMLException </throws>
    public override HTMLScriptCollection DisplayCommonJavaScript()
    {
      return new HTMLScriptCollection();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    /* */
    
    /// <summary>
    /// Returns the class name of the Property Repost Control.
    /// </summary>
    /// <returns>String</returns>
    public override String GetRepostControlName()
    {
      return (EditMyPagePortletLayoutRepostControl_D.STR_MVC_CLASS_NAME);
      }
    
    /// <summary>
    /// Registers all the classes of the Property Activity Space.
    /// </summary>
    public override void Init()
    {
      m_strModelName = EditMyPagePortletLayoutModel_D.STR_MVC_CLASS_NAME;
      base.Init();
      SetTrackCurrentPage(true);
      //RegisterModel(EditMyPagePortletLayoutModel_D.STR_MVC_CLASS_NAME);
      IModel myModel = GetModel(EditMyPagePortletLayoutModel_D.STR_MVC_CLASS_NAME);
      RegisterModel(PageNamePlugInModel.STR_MVC_CLASS_NAME, strPageNamePlugInKey);
      // Register DisplayPages
      AFormDP myPage = new EditMyPagePortletLayoutDP_D();
      //myPage.SetShowFormFooter(true);
      RegisterPage(myPage);
      // Register Views
      RegisterView(EditMyPagePortletLayoutView_D.STR_MVC_CLASS_NAME, myModel);
      RegisterView(PageNameView.STR_MVC_CLASS_NAME, strPageNamePlugInKey,
       GetModel(strPageNamePlugInKey));
      // Register Controls
      RegisterControl(EditMyPagePortletLayoutRepostControl_D.STR_MVC_CLASS_NAME,
       myModel);
      RegisterControl(EditMyPagePortletLayoutSetPageControl_D.STR_MVC_CLASS_NAME,
       myModel);
      SetCurrentPage(GetPage(EditMyPagePortletLayoutView_D.STR_MVC_CLASS_NAME));
      this.SetHelpTopic("PT_MyPage_EditPage");
    }
  }
}