using System;
// Framework Imports
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.errordisplay;
using com.plumtree.uiinfrastructure.form;
namespace com.plumtree.portalpages.browsing.myportal.editpage
{
  /// <summary>
  /// File: EditMyPagePortletLayoutRepostControl_D.java
  /// ------------------------------------------------
  /// </summary>
  /// <author>NaveenP</author>
  public class EditMyPagePortletLayoutRepostControl_D : RepostControl
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.myportal.editpage.EditMyPagePortletLayoutRepostControl_D");
    public const String STR_MVC_CLASS_NAME = "EditMyPagePortletLayoutRepost";
    public const int POSTTOSELF_ACTION_UP = 10;
    public const int POSTTOSELF_ACTION_DOWN = 11;
    public const int POSTTOSELF_ACTION_DELETE = 12;
    protected EditMyPagePortletLayoutModel_D m_asModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new EditMyPagePortletLayoutRepostControl_D();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IControl#Init(IModel,AActivitySpace)"></seealso>
    public override void Init(IModel model, AActivitySpace space)
    {
      base.Init(model, space);
      m_asModel = (EditMyPagePortletLayoutModel_D) model;
    }
    
    /// <summary>
    /// Switch between the action modes and call
    /// the associated method for each action.
    /// </summary>
    /// <param name="int"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      bool bDo302Redirect = false;
      try
      {
        switch (_nAction){
        case POSTTOSELF_ACTION_UP:
        m_asModel.SetActionUp();
        m_asModel.DoAction();
        bDo302Redirect = true;
        break;
        case POSTTOSELF_ACTION_DOWN:
        m_asModel.SetActionDown();
        m_asModel.DoAction();
        bDo302Redirect = true;
        break;
        case POSTTOSELF_ACTION_DELETE:
        m_asModel.SetActionDelete();
        m_asModel.DoAction();
        bDo302Redirect = true;
        break;
        default:
        break;
        }
      }
      catch (Exception e)
      {
        log.Error(e, "Server Error");
        UIError myError = new UIError(UIErrorLevel.FRIENDLY, UIErrorScope.CURRENT_USER,
         null, e.Message, e.Message);
        UIErrorHandler.RaiseError(myError, m_asOwner.GetSubSession(), m_asOwner.GetApplication());
        }
      if (bDo302Redirect)
      {
        // Redirect to url with no action in it so that refreshes don't cause wierd behavior.
        Redirect myRedirect = new Redirect();
        myRedirect.SetLinkGetCachedSpace(m_asOwner);
        myRedirect.SetIsHTTPRedirect(true);
        base.SetRedirect(myRedirect);
      }
    }
  }
}