using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.errordisplay;
namespace com.plumtree.portalpages.browsing.myportal.editpage
{
  /// <summary>
  /// File: SetGroupControl.java
  /// --------------------------
  /// </summary>
  /// <author>NaveenP</author>
  public class EditMyPagePortletLayoutSetPageControl_D : IControl
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.myportal.editpage.EditMyPagePortletLayoutSetPageControl_D");
    public const String STR_MVC_CLASS_NAME = "EditMyPagePortletLayoutSetPage";
    public const String QS_PAGEID = "PageID";
    
    /// <summary>
    /// Activity Space 
    /// </summary>
    private AActivitySpace m_asOwner;
    
    /// <summary>
    /// model 
    /// </summary>
    private EditMyPagePortletLayoutModel_D m_asModel;
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IControl#Execute()"></seealso>
    public virtual Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      try
      {
        String[] sValues = (String[]) arguments.GetElement(QS_PAGEID);
        int nPageID = 0;
        if (sValues == null)
        {
          log.Info("could not find page ID in query string.");
          log.Error("Page ID not found in query string");
          throw new Exception("Page ID not found");
        }
        nPageID = XPConvert.ToInteger(sValues[0]);
        m_asModel.SetPageID(nPageID);
      }
      catch (Exception e)
      {
        log.Error(e, "Server Error");
        UIError myError = new UIError(UIErrorLevel.FRIENDLY, UIErrorScope.CURRENT_USER,
         null, e.Message, e.Message);
        UIErrorHandler.RaiseError(myError, m_asOwner.GetSubSession(), m_asOwner.GetApplication());
        }
      return null;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new EditMyPagePortletLayoutSetPageControl_D();
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IControl#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IControl#Init(IModel,AActivitySpace)"></seealso>
    public virtual void Init(IModel model, AActivitySpace space)
    {
      m_asModel = (EditMyPagePortletLayoutModel_D) model;
      m_asOwner = space;
    }
  }
}