using System;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.myportal.editpage
{
  /// <summary>
  /// File: EditMyPagePortletLayoutView_D.java
  /// ---------------------------------------
  /// </summary>
  /// <author>NaveenP</author>
  public class EditMyPagePortletLayoutView_D : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.myportal.editpage.EditMyPagePortletLayoutView_D");
    public const String STR_MVC_CLASS_NAME = "EditMyPagePortletLayout";
    public const String QS_INDEX = "Index";
    protected AActivitySpace m_asOwner;
    // Client-specific variables
    protected EditMyPagePortletLayoutModel_D m_asModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new EditMyPagePortletLayoutView_D();
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#display()"></seealso>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      EditMyPagePortletLayoutDP_D displayPage = (EditMyPagePortletLayoutDP_D) m_asOwner.GetPage(EditMyPagePortletLayoutDP_D.STR_MVC_CLASS_NAME);
      HTMLTable mainTable = null;
      HTMLTableRow mainRow;
      HTMLTableCell mainCell;
      ASURL asurl;
      try
      {
        result.AddInnerHTMLString("\n<!-- Begin: Display EditMyPagePortletLayoutView_D -->\n");
        mainTable = new HTMLTable();
        result.AddInnerHTMLElement(mainTable);
        mainTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        mainTable.SetCellSpacing(CommonHTMLStrings.ZERO);
        mainTable.SetCellPadding(CommonHTMLStrings.ZERO);
        mainTable.SetBorder(CommonHTMLStrings.ZERO);
        mainRow = new HTMLTableRow();
        mainTable.AddInnerHTMLElement(mainRow);
        mainRow.SetStyleClass(PTStyleClass.BAN_HEADER_BG);
        mainRow = new HTMLTableRow();
        mainTable.AddInnerHTMLElement(mainRow);
        mainCell = new HTMLTableCell();
        mainRow.AddInnerHTMLElement(mainCell);
        HTMLTable myInnerTable = new HTMLTable();
        mainCell.AddInnerHTMLElement(myInnerTable);
        myInnerTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        HTMLTableRow myInnerRow = new HTMLTableRow();
        myInnerTable.AddInnerHTMLElement(myInnerRow);
        HTMLTableCell myInnerCell = new HTMLTableCell();
        myInnerRow.AddInnerHTMLElement(myInnerCell);
        myInnerCell.SetHeight("10");
        myInnerCell.SetColSpan(CommonHTMLStrings.THREE);
        myInnerCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myInnerRow = new HTMLTableRow();
        myInnerTable.AddInnerHTMLElement(myInnerRow);
        myInnerRow.SetStyleClass(PTStyleClass.DIR_HEADER_BG);
        myInnerCell = new HTMLTableCell();
        myInnerRow.AddInnerHTMLElement(myInnerCell);
        myInnerCell.SetStyleClass(PTStyleClass.DIR_TEXT);
        myInnerCell.SetHeight("25");
        myInnerCell.SetColSpan(CommonHTMLStrings.THREE);
        HTMLSpan myInnerSpan = new HTMLSpan();
        myInnerCell.AddInnerHTMLElement(myInnerSpan);
        myInnerSpan.SetStyleClass(PTStyleClass.DIR_HEADER);
        myInnerSpan.AddInnerHTMLString(m_asOwner.GetString(1257, "ptmsgs_portalbrowsingmsgs"));
        HTMLAnchor myAnchor = new HTMLAnchor("PortletList");
        myInnerRow = new HTMLTableRow();
        myInnerTable.AddInnerHTMLElement(myInnerRow);
        myInnerRow.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);
        myInnerCell = new HTMLTableCell();
        myInnerRow.AddInnerHTMLElement(myInnerCell);
        myInnerCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myInnerCell.SetWidth("50%");
        myInnerCell.SetAlign(CommonHTMLStrings.CENTER);
        myInnerCell.AddInnerHTMLString(m_asOwner.GetString(1258, "ptmsgs_portalbrowsingmsgs"));
        myInnerCell = new HTMLTableCell();
        myInnerRow.AddInnerHTMLElement(myInnerCell);
        myInnerCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myInnerCell.SetWidth("50%");
        myInnerCell.SetColSpan(CommonHTMLStrings.TWO);
        myInnerCell.SetAlign(CommonHTMLStrings.CENTER);
        myInnerCell.AddInnerHTMLString(m_asOwner.GetString(1259, "ptmsgs_portalbrowsingmsgs"));
        int nPortletCount = m_asModel.GetPortletCount();
        int nMandPortletCount = m_asModel.GetMandatoryPortletCount();
        for (int i = 0;i < nPortletCount;i++)
        {
          myInnerRow = new HTMLTableRow();
          myInnerTable.AddInnerHTMLElement(myInnerRow);
          myInnerCell = new HTMLTableCell();
          myInnerRow.AddInnerHTMLElement(myInnerCell);
          myInnerCell.SetWidth("50%");
          myInnerCell.SetAlign(CommonHTMLStrings.LEFT);
          if ((i % 2) == 0)
          {
            myInnerCell.SetStyleClass(PTStyleClass.LIST_ITEM_ONE_BG);
          } else
          {
            myInnerCell.SetStyleClass(PTStyleClass.LIST_ITEM_TWO_BG);
          }
          myInnerSpan = new HTMLSpan();
          myInnerCell.AddInnerHTMLElement(myInnerSpan);
          myInnerSpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
          myInnerSpan.AddInnerHTMLEncodedString(m_asModel.GetPortletName(i));
          myInnerCell = new HTMLTableCell();
          myInnerRow.AddInnerHTMLElement(myInnerCell);
          myInnerCell.SetAlign(CommonHTMLStrings.LEFT);
          if (i < nMandPortletCount || nMandPortletCount + 1 >= nPortletCount)
          {
            myInnerCell.SetWidth("50%");
            myInnerCell.SetColSpan("2");
          } else
          {
            myInnerCell.SetWidth("25%");
          }
          if ((i % 2) == 0)
          {
            myInnerCell.SetStyleClass(PTStyleClass.LIST_ITEM_ONE_BG);
          } else
          {
            myInnerCell.SetStyleClass(PTStyleClass.LIST_ITEM_TWO_BG);
          }
          myInnerSpan = new HTMLSpan();
          myInnerCell.AddInnerHTMLElement(myInnerSpan);
          myInnerSpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
          if (i < nMandPortletCount)
          {
            myInnerSpan.AddInnerHTMLString(m_asOwner.GetString(1722, "ptmsgs_portalbrowsingmsgs"));
            }
          if (i > nMandPortletCount)
          {
            // Move Up
            asurl = displayPage.Get508RepostURL(EditMyPagePortletLayoutRepostControl_D.POSTTOSELF_ACTION_UP);
            asurl.AddControlArgument(EditMyPagePortletLayoutView_D.QS_INDEX,
             i);
            myAnchor = new HTMLAnchor(m_asOwner.GetString(1264, "ptmsgs_portalbrowsingmsgs"));
            myAnchor.SetHRef(asurl.GetURLAsString());
            myInnerSpan.AddInnerHTMLElement(myAnchor);
            myAnchor.AddInnerHTMLString(m_asOwner.GetString(1264, "ptmsgs_portalbrowsingmsgs"));
            }
          if ((i > nMandPortletCount) && (i < nPortletCount - 1))
          {
            myInnerSpan.AddInnerHTMLString(" | ");
          }
          if ((i >= nMandPortletCount) && (i < nPortletCount - 1))
          {
            // Move Down
            asurl = displayPage.Get508RepostURL(EditMyPagePortletLayoutRepostControl_D.POSTTOSELF_ACTION_DOWN);
            asurl.AddControlArgument(EditMyPagePortletLayoutView_D.QS_INDEX,
             i);
            myAnchor = new HTMLAnchor(m_asOwner.GetString(1263, "ptmsgs_portalbrowsingmsgs"));
            myAnchor.SetHRef(asurl.GetURLAsString());
            myInnerSpan.AddInnerHTMLElement(myAnchor);
            myAnchor.AddInnerHTMLString(m_asOwner.GetString(1263, "ptmsgs_portalbrowsingmsgs"));
            }
          if (i > nMandPortletCount - 1)
          {
            if (nMandPortletCount + 1 < nPortletCount)
            {
              // DCA - cell for deleting portlet
              myInnerCell = new HTMLTableCell();
              myInnerRow.AddInnerHTMLElement(myInnerCell);
              myInnerCell.SetWidth("25%");
              myInnerCell.SetAlign(CommonHTMLStrings.LEFT);
              if ((i % 2) == 0)
              {
                myInnerCell.SetStyleClass(PTStyleClass.LIST_ITEM_ONE_BG);
                } else
              {
                myInnerCell.SetStyleClass(PTStyleClass.LIST_ITEM_TWO_BG);
                }
              myInnerSpan = new HTMLSpan();
              myInnerCell.AddInnerHTMLElement(myInnerSpan);
              myInnerSpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
            }
            asurl = displayPage.Get508RepostURL(EditMyPagePortletLayoutRepostControl_D.POSTTOSELF_ACTION_DELETE);
            asurl.AddControlArgument(EditMyPagePortletLayoutView_D.QS_INDEX,
             i);
            myAnchor = new HTMLAnchor(m_asOwner.GetString(302, "ptmsgs_portalbrowsingmsgs"));
            myAnchor.SetHRef(asurl.GetURLAsString());
            myInnerSpan.AddInnerHTMLElement(myAnchor);
            myAnchor.AddInnerHTMLString(m_asOwner.GetString(302, "ptmsgs_portalbrowsingmsgs"));
            }
        }
        myInnerRow = new HTMLTableRow();
        myInnerTable.AddInnerHTMLElement(myInnerRow);
        myInnerCell = new HTMLTableCell();
        myInnerRow.AddInnerHTMLElement(myInnerCell);
        myInnerCell.SetHeight("10");
        myInnerCell.SetColSpan(CommonHTMLStrings.THREE);
        myInnerCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        //mainCell = new HTMLTableCell();
        //mainRow.AddInnerHTMLElement(mainCell);
        //mainCell.SetWidth("20");
        //mainCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        //mainRow = new HTMLTableRow();
        //mainTable.AddInnerHTMLElement(mainRow);
        //mainCell = new HTMLTableCell();
        //mainRow.AddInnerHTMLElement(mainCell);
        //mainCell.SetHeight("10");
        //mainCell.SetColSpan(CommonHTMLStrings.THREE);
        //mainCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        result.AddInnerHTMLString("\n<!-- End: Display EditMyPagePortletLayoutView_D -->\n");
        }
      catch (Exception e)
      {
        log.Error(e, "Server Error");
      }
      return result;
    }
    
    /// <summary>
    /// This method returns the HTMLScript that encompasses the Javascript on the page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    /// <returns>HTMLScript</returns>
    public override HTMLScript DisplayJavascript()
    {
      return new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#Init(IModel,AActivitySpace)"></seealso>
    public override void Init(IModelRO model, AActivitySpace parent)
    {
      m_asModel = (EditMyPagePortletLayoutModel_D) model;
      m_asOwner = parent;
    }
  }
}