using System;
using com.plumtree.portalpages.common.editpage;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.browsing.myportal.editpage
{
  /// <author>michaeld</author>
  public interface IEditMyPortalPageModelRO : IEditorModelRO
  {
    
    /// <summary>
    /// Get the page model of the page being edited.
    /// </summary>
    /// <returns>PageData</returns>
    PageData GetPageModel();
    
    /// <summary>
    /// Get the set page template for the page.
    /// </summary>
    /// <returns>int</returns>
    int GetPageTemplateSet();
    
    /// <summary>
    /// Get the name of the parent window's form.
    /// </summary>
    /// <returns>String</returns>
    String GetParentFormName();
    
    /// <summary>
    /// Get the string that is the parent form space ID.
    /// </summary>
    /// <returns>String</returns>
    String GetParentFormSpaceID();
    
    /// <summary>
    /// Get the string that is the parent form submit function.
    /// </summary>
    /// <returns>String</returns>
    String GetParentFormSubmitFunction();
  }
}