using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.myportal;
using com.plumtree.portaluiinfrastructure.ptlink;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.taskapi.portalui;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.browsing.myportal.mypages
{
  /// <author>michaeld</author>
  public class DeletePageControl : IControl
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.myportal.mypages.DeletePageControl");
    
    /// <summary>
    /// Class Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "DeletePage";
    
    /// <summary>
    /// Page ID 
    /// </summary>
    public const String STR_PAGE_ID = "PageID";
    
    /// <summary>
    /// Activity Space 
    /// </summary>
    private AActivitySpace m_asOwner;
    
    /// <summary>
    /// Model 
    /// </summary>
    private MyPortalModel m_asModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IControl#CheckActionSecurityAndExecute(XPHashtable)"></seealso>
    public virtual Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      String[] sValues = (String[]) arguments.GetElement(STR_PAGE_ID);
      if (sValues == null)
      {
        log.Error("could not find page ID in query string.");
        return null;
      }
      int nDeletePageID = XPConvert.ToInteger(sValues[0]);
      m_asModel.DeletePage(nDeletePageID);
      Redirect redirect = new Redirect();
      IPTURL pturl = TaskAPIUIMyPages.CreateMyPageCommonOpenerURL(m_asOwner,
       SetPageControl.N_HOME_PAGE_ID, "");
      redirect.SetLinkToExternalURL(pturl.GetFullURL());
      return redirect;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new DeletePageControl();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IControl#Init(IModel,AActivitySpace)"></seealso>
    public virtual void Init(IModel model, AActivitySpace space)
    {
      m_asModel = (MyPortalModel) model;
      m_asOwner = space;
    }
  }
}