using System;
using com.plumtree.portalpages.browsing.myportal;
using com.plumtree.portalpages.common.uiparts;
namespace com.plumtree.portalpages.browsing.myportal.mypages
{
  /// <author>MichaelD</author>
  public class MyPageAS : PlumtreeAS
  {
    public const String STR_MVC_CLASS_NAME = "MyPage";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new MyPageAS();
    }
    
    /// <returns></returns>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Repost control for intrinsic portlets.
    /// </summary>
    /// <returns>Intrinsic portlets repost control name</returns>
    public override String GetRepostControlName()
    {
      return IntrinsicPortletsRepostControl.STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.AActivitySpace#Init()"></seealso>
    public override void Init()
    {
      base.Init();
      // MyPage DisplayPages
      PlumtreeDP myPortalDP = new MyPortalDP();
      RegisterPage(myPortalDP);
      RegisterPage(new MyPortalPartialPortletsDP());
      // MyPage Model
      RegisterModel(MyPortalModel.STR_MVC_CLASS_NAME);
      MyPortalModel myModel = (MyPortalModel) GetModel(MyPortalModel.STR_MVC_CLASS_NAME);
      myModel.SetMyPortalModelHelper(new MyPageMyPortalModelHelper());
      // Model has to be initialized in Init method because it requires PTSession.
      // MyPage Views
      RegisterView(MyPortalContentView.STR_MVC_CLASS_NAME, myModel);
      // Extended Navigation Section
      RegisterView(MyPortalHeaderView.ObjectName, myModel);
      RegisterView(MyPortalFooterView.m_ObjectName, myModel);
      // MyPage Controls
      RegisterControl(SetPageControl.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(CollapsePortletControl.STR_MVC_CLASS_NAME, CollapsePortletControl.STR_EXPAND_CONTROL,
       myModel);
      RegisterControl(CollapsePortletControl.STR_MVC_CLASS_NAME, CollapsePortletControl.STR_COLLAPSE_CONTROL,
       myModel);
      RegisterControl(DeletePageControl.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(AddRemovePortletControl.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(ReorderPortletsControl.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(IntrinsicPortletsRepostControl.STR_MVC_CLASS_NAME, myModel);
      // Default fall-through control when control has been lost (error handling)
      RegisterControl(DefaultPageControl.STR_MVC_CLASS_NAME, "", myModel);
      this.SetHelpTopic("PT_MyPages");
    }
  }
}