using System;
using com.plumtree.portalpages.browsing.myportal;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.browsing.myportal.mypages
{
  /// <author>MichaelD</author>
  public class MyPageMyPortalModelHelper : IMyPortalModelHelper
  {
    
    /// <summary>
    /// My Pages Object 
    /// </summary>
    private IPTSessionInfo ptSessionInfo = null;
    
    /// <seealso cref="com.plumtree.xpshared.browsing.myportal.IMyPortalModelHelper#GetCollapsedPortletsPrefName()"></seealso>
    public virtual String GetCollapsedPortletsPrefName()
    {
      return "CollapsedGadgets";
    }
    
    /// <seealso cref="com.plumtree.xpshared.browsing.myportal.IMyPortalModelHelper#GetCommunityPages(int)"></seealso>
    public virtual IPTQueryResult GetCommunityPages(int nCommunityID)
    {
      return null;
    }
    
    /// <summary>
    /// Individual users cannot disable title bars; this is available only for communities.  So return null.
    /// </summary>
    /// <seealso cref="com.plumtree.xpshared.browsing.myportal.IMyPortalModelHelper#GetPortletHasNoTitleBar(int)"></seealso>
    public virtual Object[][] GetPortletHasNoTitleBar(int nCommunityID)
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.xpshared.browsing.myportal.IMyPortalModelHelper#GetIsCommunityPage()"></seealso>
    public virtual bool GetIsCommunityPage()
    {
      return false;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IModel#Init(AActivitySpace)"></seealso>
    public virtual void Init(IPTSession ptSession, AActivitySpace parent)
    {
      ptSessionInfo = ptSession.GetSessionInfo();
    }
    //////////////////////////////////////
    // Methods from IMyPortalModelHelper
    //////////////////////////////////////
    
    /// <seealso cref="com.plumtree.xpshared.browsing.myportal.IMyPortalModelHelper#OpenPage(int,int)"></seealso>
    public virtual IPTPageInfo OpenPage(int nCommunityID, int nPageID)
    {
      return ptSessionInfo.GetCurrentMyPage(nPageID);
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.IMyPortalModelHelper#GetCommunityName(int)"></seealso>
    public virtual String GetCommunityName(int nCommunityID)
    {
      return null;
    }
  }
}