using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.search;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.browsing.objectselection
{
  /// <author>
  /// NaveenP/DustinA To change this generated comment edit the template
  /// variable "typecomment": Window>Preferences>Java>Templates. To
  /// enable and disable the creation of type comments go to
  /// Window>Preferences>Java>Code Generation.
  /// </author>
  public class InvitationPopupControl : IControl
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.objectselection.InvitationPopupControl");
    public const String STR_MVC_CLASS_NAME = "InvitationPopup";
    public const String strInviteIndex = "ObjectInviteIndex";
    public const String strTemporaryInvitationName = "TemporaryInvitationName";
    public const String strTemporaryInvitationID = "TemporaryInvitationID";
    private AActivitySpace m_asOwner;
    private ObjectSelectionModel m_asModel;
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IControl#Execute()"></seealso>
    public virtual Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      String[] sValues = (String[]) arguments.GetElement(strInviteIndex);
      if (sValues != null)
      {
        int nInvitationIndex = XPConvert.ToInteger(sValues[0]);
        String strName;
        int nObjectID;
        if (m_asModel.GetDisplaySearch())
        {
          SearchResultModel searchModel = (SearchResultModel) m_asOwner.GetModel(SearchResultModel.STR_MVC_CLASS_NAME);
          strName = searchModel.GetResultName(nInvitationIndex);
          nObjectID = searchModel.GetResultObjectID(nInvitationIndex);
        } else
        {
          strName = (String) m_asModel.GetObjectFields(nInvitationIndex, PT_PROPIDS.PT_PROPID_NAME);
          nObjectID = XPConvert.ToInteger(m_asModel.GetObjectFields(nInvitationIndex,
           PT_PROPIDS.PT_PROPID_OBJECTID));
        }
        m_asModel.SetTemporaryInvitationName(strName);
        m_asModel.SetTemporaryInvitationID(nObjectID);
      } else
      {
        // if we're coming from the editor, then the editor set the name and ID for us
        String[] sName = (String[]) arguments.GetElement(strTemporaryInvitationName);
        String[] sID = (String[]) arguments.GetElement(strTemporaryInvitationID);
        if ((sName != null) && (sID != null))
        {
          m_asModel.SetTemporaryInvitationName(sName[0]);
          m_asModel.SetTemporaryInvitationID(XPConvert.ToInteger(sID[0]));
          } else
        {
          log.Error("could not find object id or name in query string for a request that came from an object editor.");
          }
      }
      return null;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new InvitationPopupControl();
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IControl#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IControl#Init(IModel,AActivitySpace)"></seealso>
    public virtual void Init(IModel model, AActivitySpace space)
    {
      m_asModel = (ObjectSelectionModel) model;
      m_asOwner = space;
    }
  }
}