using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.portalpages.common.folder;
using com.plumtree.portaluiinfrastructure.resultwrapper;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.objectselection
{
  /// <author>MichaelD</author>
  public class ObjSelBreadCrumbView : BreadcrumbView
  {
    
    /// <summary>
    /// object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "ObjSelBreadcrumb";
    
    /// <summary>
    /// model for object selection model specific calls 
    /// </summary>
    internal IObjectSelectionModelRO m_asObjSelModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new ObjSelBreadCrumbView();
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#getName()"></seealso>
    public override String GetName()
    {
      return ObjSelBreadCrumbView.STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// override this to provide our own links
    /// </summary>
    protected override PTBreadcrumbPath GetBreadcrumbPath()
    {
      PTBreadcrumbPath myCrumbs = new PTBreadcrumbPath();
      HTMLAnchor myAnchor;
      IASQueryResult qrPath = m_asObjSelModel.GetBreadCrumbPath();
      int nPathCount = qrPath.GetCount();
      for (int i = 0;i < nPathCount;i++)
      {
        int nFolderID = XPConvert.ToInteger(qrPath.GetFields(i, PT_PROPIDS.PT_PROPID_OBJECTID));
        String strFolderName = (String) qrPath.GetFields(i, PT_PROPIDS.PT_PROPID_NAME);
        String strEncodedFolderName = XPHttpUtility.HtmlEncode(strFolderName);
        if (i < (nPathCount - 1))
        {
          myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
          myAnchor.SetOnClick(JAVASCRIPT_OPEN_FOLDER + "(" + nFolderID + "); return false;");
          myAnchor.AddInnerHTMLString(strEncodedFolderName);
          myAnchor.SetTitle(strEncodedFolderName);
          myCrumbs.appendAnchorItem(myAnchor);
        } else
        {
          myCrumbs.appendTextItem(strEncodedFolderName);
        }
      }
      return myCrumbs;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(com.plumtree.uiinfrastructure.activityspace.IModelRO, com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
     */
     
    public override void Init(IModelRO model, AActivitySpace parent)
    {
      m_asObjSelModel = (IObjectSelectionModelRO) model;
      base.Init(model, parent);
    }
  }
}