using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.common;
namespace com.plumtree.portalpages.browsing.objectselection
{
  /// <summary>
  /// File: ObjSelFrameSetDP.java
  /// -------------------------------------
  /// </summary>
  /// <author>NaveenP</author>
  public class ObjSelFrameSetDP : FrameSetDP
  {
    public const String STR_MVC_CLASS_NAME = "SelectionFrameSet";
    
    /// <summary>
    /// Frame Set Title 
    /// </summary>
    private String m_strFrameSetTitle;
    
    /// <summary>
    /// Top Frame Display Page Name 
    /// </summary>
    private String m_strTopFrameDPName;
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Set Frame Scroll Top
    /// </summary>
    /// <returns>boolean true implies scrolling</returns>
    public override bool GetFrameScrollTop()
    {
      return true;
    }
    
    /// <summary>
    /// Set Frame Scroll Body
    /// </summary>
    /// <returns>boolean true implies scrolling</returns>
    public override bool GetFrameScrollBody()
    {
      return false;
    }
    
    /// <summary>
    /// Set FrameSet Attributes
    /// </summary>
    /// <returns>String</returns>
    public override String GetFrameSetAttributes()
    {
      return "85%,15%";
    }
    
    /// <returns></returns>
    public override String GetFrameSetTitle()
    {
      return m_strFrameSetTitle;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.dialogheader.FrameSetDialog#GetFrameURLBody()"></seealso>
    public override ASURL GetFrameURLBody()
    {
      ASURL url = new ASURL(m_asOwner);
      url.SetLinkGetCachedSpace(m_asOwner);
      url.SetDisplayPage(SelectedObjectsDP.STR_MVC_CLASS_NAME);
      url.SetControl(ObjSelFrameCheckAccessControl.STR_MVC_CLASS_NAME);
      return url;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.dialogheader.FrameSetDialog#GetFrameURLTop()"></seealso>
    public override ASURL GetFrameURLTop()
    {
      ASURL url = new ASURL(m_asOwner);
      url.SetLinkGetCachedSpace(m_asOwner);
      url.SetDisplayPage(m_strTopFrameDPName);
      url.SetControl(ObjSelFrameCheckAccessControl.STR_MVC_CLASS_NAME);
      return url;
    }
    
    /// <summary>
    /// Method SetupFrameSet.
    /// This display page will not print anything legible unless this function is called with valid parameters.
    /// </summary>
    /// <param name="_strFrameSetTitle"></param>
    /// <param name="_strTopFrameDPName"></param>
    public virtual void SetupFrameSet(String _strFrameSetTitle, String _strTopFrameDPName)
    {
      m_strFrameSetTitle = _strFrameSetTitle;
      m_strTopFrameDPName = _strTopFrameDPName;
    }
  }
}