using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.browsing.objectselection
{
  /// <summary>
  /// This control is used to perform actions on the object selection model
  /// in cases where you don't want to repost the entire form (i.e. AJAX, etc...)
  /// </summary>
  public class ObjectSelectionActionControl : IControl
  {
    public const String STR_MVC_CLASS_NAME = "ObjectSelectAction";
    
    /// <summary>
    /// Post to self to switch to search mode. 
    /// </summary>
    public const String SEARCH_MODE = "displaysearch";
    
    /// <summary>
    /// Post to self to change pagination displayed item. 
    /// </summary>
    public const String FIRST_ITEM_TO_DISPLAY = "firstitem";
    protected IObjectSelectionModel m_model;
    public virtual Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      if (arguments.ContainsKey(SEARCH_MODE))
      {
        String[] data = (String[]) arguments.GetElement(SEARCH_MODE);
        if ((0 != data.Length) && (null != data[0]))
        {
          bool bDisplaySearch = XPConvert.ToBoolean(data[0]);
          m_model.SetDisplaySearch(bDisplaySearch);
        }
      }
      if (arguments.ContainsKey(FIRST_ITEM_TO_DISPLAY))
      {
        String[] data = (String[]) arguments.GetElement(FIRST_ITEM_TO_DISPLAY);
        if ((0 != data.Length) && (null != data[0]))
        {
          int nFirstItemToDisplay = XPConvert.ToInteger(data[0]);
          m_model.SetFirstDisplayableItem(nFirstItemToDisplay);
        }
      }
      return null;
    }
    public virtual void Init(IModel model, AActivitySpace space)
    {
      m_model = (ObjectSelectionModel) model;
    }
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    public virtual Object Create()
    {
      return new ObjectSelectionActionControl();
    }
  }
}