using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.constants;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.objectselection
{
  /// <author>michaeld</author>
  public class SelectedObjectsDP : IDisplayPage
  {
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "SelectionBottomFrame";
    
    /// <summary>
    /// AActivitySpace 
    /// </summary>
    protected AActivitySpace m_asOwner;
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Display(com.plumtree.uiinfrastructure.activityspace.IWebData)
     */
     
    public virtual void Display(IWebData pageData)
    {
      bool bNoJavascript = (GetOwner().GetAccessStyle() != AccessStyles.STANDARD);
      HTMLPage myPage = new HTMLPage();
      // Set the HTMLPage as the data to be sent to the browser.
      pageData.SetData(myPage);
      if (bNoJavascript)
      {
        myPage.SetDo508Checking(true);
      }
      HTMLHead myHead = new HTMLHead();
      myPage.SetHead(myHead);
      HTMLTitle myTitle = new HTMLTitle(m_asOwner.GetString(1275, "ptmsgs_portalbrowsingmsgs"));
      HTMLBody myBody = new HTMLBody();
      myPage.SetBody(myBody);
      myBody.SetMarginHeight("0");
      myBody.SetMarginWidth("0");
      myBody.SetLeftMargin("0");
      myBody.SetTopMargin("0");
      myBody.SetStyleClass(PTStyleClass.DIALOGUE_GRAY_BG);
      myHead.AddInnerHTMLElement(myTitle);
      myHead.AddInnerHTMLElement(GetOwner().GetStyleSheetLinks());
      myHead.AddInnerHTMLElement(m_asOwner.GetView(SelectedObjectsView.STR_MVC_CLASS_NAME).DisplayJavascript());
      myBody.AddInnerHTMLElement(m_asOwner.GetView(SelectedObjectsView.STR_MVC_CLASS_NAME).Display());
      m_asOwner.SetCurrentPage(m_asOwner.GetPage(ObjSelFrameSetDP.STR_MVC_CLASS_NAME));
      }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#GetOwner()
     */
     
    public virtual AActivitySpace GetOwner()
    {
      return m_asOwner;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Init(com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
     */
     
    public virtual void Init(AActivitySpace _asOwner)
    {
      m_asOwner = _asOwner;
    }
  }
}