using System;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.browsing.objectselection.communities
{
  /// <summary>
  /// File: CommunityInvitationPopupDP.java
  /// -------------------------------------
  /// Display page for the Invitation Popup on
  /// the gadget selection page (when clicking
  /// "Send to Others.")
  /// </summary>
  /// <author>NaveenP/DustinA</author>
  public class CommunityInvitationPopupDP : IDisplayPage
  {
    public const String STR_MVC_CLASS_NAME = "CommunityInvitationPopup";
    private AActivitySpace m_asOwner;
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#display()"></seealso>
    public virtual void Display(IWebData pageData)
    {
      pageData.SetData(m_asOwner.GetView(CommunityInvitationPopupView.STR_MVC_CLASS_NAME).Display());
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.ui.framework.IDisplayPage#GetParent()"></seealso>
    public virtual AActivitySpace GetOwner()
    {
      return m_asOwner;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#Init(AActivitySpace)"></seealso>
    public virtual void Init(AActivitySpace parent)
    {
      m_asOwner = parent;
    }
  }
}