using System;
using com.plumtree.portalpages.browsing.objectselection;
using com.plumtree.portalpages.common.folder;
using com.plumtree.portalpages.common.objects;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.objectselection.communities
{
  /// <author>MichaelD</author>
  public class CommunitySelectionDP_D : EditorDP
  {
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "CommunitySel_D";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#DisplayHTMLBeforeForm()"></seealso>
    public override HTMLElementCollection DisplayHTMLBeforeForm()
    {
      HTMLElementCollection searchview = base.DisplayHTMLBeforeForm();
      // Add a "search for gadgets" form
      if (searchview == null)
      {
        searchview = new HTMLElementCollection();
      }
      HTMLTable myTable = new HTMLTable();
      searchview.AddInnerHTMLElement(myTable);
      myTable.SetBorder(CommonHTMLStrings.ZERO);
      myTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
      myTable.SetCellPadding(CommonHTMLStrings.ZERO);
      myTable.SetCellSpacing(CommonHTMLStrings.ZERO);
      HTMLTableRow myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      HTMLTableCell myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetAutoFit(true);
      myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetWidth("15");
      myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.AddInnerHTMLElement(m_asOwner.GetView(ObjSelSearchFormView.STR_MVC_CLASS_NAME).Display());
      if (((ObjectSelectionModel) m_asOwner.GetModel(ObjectSelectionModel.STR_MVC_CLASS_NAME)).GetDisplaySearch())
      {
        // View by Subfolder and Header
        myCell.AddInnerHTMLElement(m_asOwner.GetView(ObjSelSearchHeaderView.STR_MVC_CLASS_NAME).Display());
        // Instructional text
        myCell.AddInnerHTMLElement(HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1783,
         "ptmsgs_portalbrowsingmsgs"), this.m_asOwner));
        // Spacer table
        myCell.AddInnerHTMLElement(EditorView.GetShortSpacerTable());
        // Search Summary and Search Results
        myCell.AddInnerHTMLElement(m_asOwner.GetView(ObjSelSearch508BodyView.STR_MVC_CLASS_NAME).Display());
        // Selected Objects
        myCell.AddInnerHTMLElement(m_asOwner.GetView(SelectedObjectsView.STR_MVC_CLASS_NAME).Display());
        myCell.AddInnerHTMLElement(m_asOwner.GetView(ObjectSelectionView.STR_MVC_CLASS_NAME).Display());
        }
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetWidth("15");
      myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      return searchview;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.editor.EditorDP#GetLeftNavString()"></seealso>
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(691, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      if (!((ObjectSelectionModel) m_asOwner.GetModel(ObjectSelectionModel.STR_MVC_CLASS_NAME)).GetDisplaySearch())
      {
        return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1783,
         "ptmsgs_portalbrowsingmsgs"), this.m_asOwner);
      }
      return null;
    }
    
    /// <summary>
    /// Returns the HTML for that Page.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException </throws>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLElementCollection views = new HTMLElementCollection();
      // Insert super class HTML
      result.AddInnerHTMLElement(base.PageDisplay());
      ObjectSelectionModel model = ((ObjectSelectionModel) m_asOwner.GetModel(ObjectSelectionModel.STR_MVC_CLASS_NAME));
      views.AddInnerHTMLElement(EditorView.GetShortSpacerTable());
      if (!model.GetDisplaySearch())
      {
        views.AddInnerHTMLElement(m_asOwner.GetView(FolderView.STR_MVC_CLASS_NAME).Display());
        views.AddInnerHTMLElement(EditorView.GetSpacerTable());
        if (1 != model.GetCurrentFolderID())
        {
          views.AddInnerHTMLElement(m_asOwner.GetView(ObjectView.STR_MVC_CLASS_NAME).Display());
          }
        views.AddInnerHTMLElement(EditorView.GetSpacerTable());
        views.AddInnerHTMLElement(m_asOwner.GetView(SelectedObjectsView.STR_MVC_CLASS_NAME).Display());
        views.AddInnerHTMLElement(m_asOwner.GetView(ObjectSelectionView.STR_MVC_CLASS_NAME).Display());
        result.AddInnerHTMLElement(CreateContentTable(views, null));
      }
      model = null;
      return result;
    }
  }
}