using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.myportal.communities;
using com.plumtree.portalpages.browsing.objectselection;
using com.plumtree.portalpages.common.objects;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.activityspace.utils;
using com.plumtree.uiinfrastructure.common;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.uiinfrastructure.htmlconstructs;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
//Put explicit import for Interpreter (to avoid ambiguity of using the deprecated class)
using Interpreter=com.plumtree.uiinfrastructure.interpreter.Interpreter;
namespace com.plumtree.portalpages.browsing.objectselection.communities
{
  /// <author>michaeld</author>
  public class CommunitySelectionViewHelper : IObjectViewHelper
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.objectselection.communities.CommunitySelectionViewHelper");
    
    /// <summary>
    /// HTML Input Checkbox 
    /// </summary>
    public const String HTMLINPUT_SELECTION_OBJECT = "in_cb_Object";
    
    /// <summary>
    /// Javascript Function: openInvite 
    /// </summary>
    public const String JAVASCRIPT_OPEN_INVITE = "openInvite";
    
    /// <summary>
    /// Javascript Function: previewGadget 
    /// </summary>
    public const String JAVASCRIPT_PREVIEW_COMMUNITY = "previewCommunity";
    
    /// <summary>
    /// subspace key for preview community 
    /// </summary>
    public const String PREVIEW_COMMUNITY_SUBSPACE = "PreviewCommunitySubspace";
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#AddObjectViewHTML()"></seealso>
    public virtual HTMLElement AddObjectViewHTML(IObjectModelRO model)
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#GetThereAreNoItemsString(AActivitySpace)"></seealso>
    public virtual String GetThereAreNoItemsString(AActivitySpace asOwner)
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#Display508Object(int,HTMLTable,IObjectModelRO,AActivitySpace)"></seealso>
    public virtual void Display508Object(int nObjectIndex, HTMLTable tableObjects,
     IObjectModelRO model, AActivitySpace parent)
    {
      HTMLTableRow row;
      HTMLTableCell cell;
      HTMLSpan span;
      ASURL myAsurl;
      HTMLBr br = new HTMLBr();
      int iObjectID = XPConvert.ToInteger(model.GetObjectFields(nObjectIndex,
       PT_PROPIDS.PT_PROPID_OBJECTID));
      String strObjectName = (String) model.GetObjectFields(nObjectIndex,
       PT_PROPIDS.PT_PROPID_NAME);
      Object oDescription = model.GetObjectFields(nObjectIndex, PT_PROPIDS.PT_PROPID_DESCRIPTION);
      try
      {
        row = new HTMLTableRow();
        tableObjects.AddInnerHTMLElement(row);
        cell = new HTMLTableCell();
        row.AddInnerHTMLElement(cell);
        cell.SetVAlign(CommonHTMLStrings.MIDDLE);
        cell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        cell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        cell = new HTMLTableCell();
        row.AddInnerHTMLElement(cell);
        cell.SetVAlign(CommonHTMLStrings.MIDDLE);
        cell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        cell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        span = new HTMLSpan();
        cell.AddInnerHTMLElement(span);
        span.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
        span.AddInnerHTMLEncodedString(strObjectName);
        cell.AddInnerHTMLElement(br);
        if (null != oDescription)
        {
          if (!"".Equals(oDescription))
          {
            cell.AddInnerHTMLEncodedString((String) oDescription);
            cell.AddInnerHTMLElement(br);
          }
        }
        if (model.GetIsObjectSelected(iObjectID))
        {
          if (model.DoNotShowObject(nObjectIndex))
          {
            cell.AddInnerHTMLString(parent.GetString(1719, "ptmsgs_portalbrowsingmsgs"));
            } else
          {
            myAsurl = ((AFormDP) parent.GetCurrentPage()).Get508RepostURL(ObjectSelectionRepostControl.POSTTOSELF_508_ACTION_REMOVEOBJECT);
            myAsurl.AddControlArgument(CommunitySelectionViewHelper.HTMLINPUT_SELECTION_OBJECT,
             iObjectID);
            myAsurl.AddInnerHTMLString(XPResourceManager.FormatMessage(parent.GetString(1271,
             "ptmsgs_portalbrowsingmsgs"), XPHttpUtility.HtmlEncode(strObjectName)));
            cell.AddInnerHTMLElement(myAsurl.GetURLAsHTMLElement());
          }
        } else
        {
          myAsurl = ((AFormDP) parent.GetCurrentPage()).Get508RepostURL(ObjectSelectionRepostControl.POSTTOSELF_508_ACTION_ADDOBJECT);
          myAsurl.AddControlArgument(CommunitySelectionViewHelper.HTMLINPUT_SELECTION_OBJECT,
           iObjectID);
          myAsurl.AddInnerHTMLString(XPResourceManager.FormatMessage(parent.GetString(1270,
           "ptmsgs_portalbrowsingmsgs"), XPHttpUtility.HtmlEncode(strObjectName)));
          cell.AddInnerHTMLElement(myAsurl.GetURLAsHTMLElement());
        }
        row = new HTMLTableRow();
        tableObjects.AddInnerHTMLElement(row);
        cell = new HTMLTableCell();
        row.AddInnerHTMLElement(cell);
        cell.SetColSpan("2");
        cell.SetAlign(CommonHTMLStrings.CENTER);
        cell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        cell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      }
      catch (HTMLException e)
      {
        log.Error(e, "Community " + iObjectID + " failed to display.");
      }
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#DisplayJavascriptCollection(AActivitySpace)"></seealso>
    public virtual HTMLScriptCollection DisplayJavascriptCollection(AActivitySpace asOwner,
     IObjectModelRO model)
    {
      HTMLScriptCollection collection = new HTMLScriptCollection();
      ASURL asurl;
      XPStringBuilder sb;
      HTMLScript script = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
      try
      {
        collection.AddInnerHTMLElement(script);
        String strPathToJSFiles = ConfigHelper.GetPortalImageServerJavaScriptURL(asOwner);
        script.SetSrc(strPathToJSFiles + "/opennewwindow.js");
      }
      catch (HTMLException he)
      {
        log.Error(he, "DisplayJavascriptCollection: Failed to add opennewwindow.js to javascript collection. " + he.Message);
        }
      script = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
      try
      {
        collection.AddInnerHTMLElement(script);
      }
      catch (HTMLException he)
      {
        log.Error(he, "DisplayJavascriptCollection: Failed to add script to collection. " + he.Message);
        }
      asurl = new ASURL(asOwner);
      asurl.SetLinkGetCachedSpace(asOwner);
      asurl.SetControl(InvitationPopupControl.STR_MVC_CLASS_NAME);
      asurl.SetDisplayPage(CommunityInvitationPopupDP.STR_MVC_CLASS_NAME);
      try
      {
        sb = new XPStringBuilder(200);
        String strJSUtilVersionPrefix = ConfigHelper.GetJSIncluderVersionPrefix(ConfigHelper.JSCOMPONENT_JSUTIL);
        sb.Append("\n").Append("function ").Append(JAVASCRIPT_OPEN_INVITE).Append("(communityIndex)\n").Append("{\n").Append("\t\t" + strJSUtilVersionPrefix + "PTWindowUtil.openWindow(\'").Append(asurl.GetURLAsString()).Append("&").Append(InvitationPopupControl.strInviteIndex).Append("=\' + communityIndex").Append(", \'SendToOthers\', \'250\',\'600\');").Append("}\n");
        script.AddInnerHTMLString(sb.ToString());
      }
      catch (HTMLException he)
      {
        log.Error(he, "DisplayJavascriptCollection: Failed to add javascript function " + JAVASCRIPT_OPEN_INVITE + " to javscript collection. " + he.Message);
        }
      asurl = new ASURL(asOwner);
      asurl.SetSubSpaceKey(PREVIEW_COMMUNITY_SUBSPACE);
      asurl.SetLinkCreateNewSpace(PreviewCommunityAS.STR_MVC_CLASS_NAME, asOwner);
      asurl.SetControl(PreviewCommunityControl.STR_MVC_CLASS_NAME);
      asurl.AddControlArgument(PreviewCommunityControl.m_PreviewType, XPConvert.ToString(PreviewCommunityBarModel.SELECTIONPREVIEWHEADER));
      try
      {
        sb = new XPStringBuilder(200);
        sb.Append("\n").Append("function ").Append(JAVASCRIPT_PREVIEW_COMMUNITY).Append("(communityID, communityIndex)\n").Append("{\n").Append("\t\tvar checkBoxes = document." + AFormDP.HTMLFORM_NAME + "." + HTMLINPUT_SELECTION_OBJECT + ";\n").Append("\t\tvar checked = \'" + XPConvert.ToString(false) + "\';\n");
        sb.Append("\t\tif (checkBoxes && checkBoxes.length) {\n");
        sb.Append("\t\t\tfor(var i = 0; i < checkBoxes.length; i++) {\n");
        sb.Append("\t\t\t\tif(checkBoxes[i].checked && checkBoxes[i].value == communityIndex){\n");
        sb.Append("\t\t\t\t\tchecked = \'" + XPConvert.ToString(true) + "\';\n");
        sb.Append("\t\t\t\t\tbreak;\n");
        sb.Append("\t\t\t\t}\n");
        sb.Append("\t\t\t}\n");
        sb.Append("\t\t} else if (checkBoxes.checked) {\n").Append("\t\t\tchecked = \'" + XPConvert.ToString(true) + "\';\n").Append("\t\t}\n");
        sb.Append("\t\tOpenLargePreviewWindow(\'").Append(asurl.GetURLAsString()).Append("&").Append(PreviewCommunityControl.m_CommunityID).Append("=\' + communityID").Append(" + \'&").Append(PreviewCommunityControl.m_CommunityIndex).Append("=\' + communityIndex").Append(" + \'&").Append(PreviewCommunityControl.m_CommunityChecked).Append("=\' + checked);\n").Append("}\n");
        script.AddInnerHTMLString(sb.ToString());
      }
      catch (HTMLException he)
      {
        log.Error(he, "DisplayJavascriptCollection: Failed to add javascript function " + JAVASCRIPT_PREVIEW_COMMUNITY + " to javscript collection. ");
        }
      try
      {
        // DCA - javascript function to update the bottom frame
        sb = new XPStringBuilder(200);
        sb.Append("\n").Append("function ").Append(SelectedObjectsView.JAVASCRIPT_ADD_SELECTED).Append("(checkbox)\n").Append("{\n");
        sb.Append("\tparent.").Append(FrameSetDP.BODY_FRAME).Append(".").Append(SelectedObjectsView.JAVASCRIPT_ADD_SELECTED).Append("(document.").Append(AFormDP.HTMLFORM_NAME).Append("[\'").Append(ObjectSelectionModel.HTMLINPUT_HIDDEN_ID).Append("\' +checkbox.value].value, 0, document.").Append(AFormDP.HTMLFORM_NAME).Append("[\'").Append(ObjectSelectionModel.HTMLINPUT_HIDDEN_NAME).Append("\' +checkbox.value].value, checkbox.checked);\n");
        sb.Append("}\n");
        script.AddInnerHTMLString(sb.ToString());
      }
      catch (HTMLException he)
      {
        log.Error(he, "DisplayJavascriptCollection: Failed to add javascript function " + SelectedObjectsView.JAVASCRIPT_ADD_SELECTED + " to javscript collection. " + he.Message);
        }
      return collection;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#DisplayObject(int,HTMLTable,IObjectModelRO)"></seealso>
    public virtual void DisplayObject(int nObjectIndex, int nRowIndex, HTMLTable tableObjects,
     IObjectModelRO model, AActivitySpace asOwner)
    {
      HTMLBr br = new HTMLBr();
      HTMLTableRow row = null;
      HTMLTableCell cell = null;
      int iObjectID = XPConvert.ToInteger(model.GetObjectFields(nObjectIndex,
       PT_PROPIDS.PT_PROPID_OBJECTID));
      String strObjectName = (String) model.GetObjectFields(nObjectIndex,
       PT_PROPIDS.PT_PROPID_NAME);
      try
      {
        row = new HTMLTableRow();
        tableObjects.AddInnerHTMLElement(row);
        if ((nRowIndex % 2) != 0)
        {
          row.SetStyleClass(PTStyleClass.LIST_ITEM_ONE_BG);
        } else
        {
          row.SetStyleClass(PTStyleClass.LIST_ITEM_TWO_BG);
        }
        // Input selector for object
        cell = new HTMLTableCell();
        row.AddInnerHTMLElement(cell);
        cell.SetHeight("20");
        cell.SetVAlign(CommonHTMLStrings.TOP);
        cell.SetAlign(CommonHTMLStrings.CENTER);
        HTMLInput inputSelector = new HTMLInput(HTMLInputTypes.CHECKBOX, HTMLINPUT_SELECTION_OBJECT,
         XPResourceManager.FormatMessage(asOwner.GetString(700, "ptmsgs_portalbrowsingmsgs"),
         XPHttpUtility.HtmlEncode(strObjectName)));
        inputSelector.SetValue(XPConvert.ToString(nObjectIndex));
        // DCA - onclick for updating the bottom frame
        inputSelector.SetOnClick(SelectedObjectsView.JAVASCRIPT_ADD_SELECTED + "(this); return true;");
        if (model.GetIsObjectSelected(iObjectID))
        {
          inputSelector.SetChecked(true);
        }
        if (model.DoNotShowObject(nObjectIndex))
        {
          inputSelector.SetDisabled(true);
        }
        BrowserType browser = (BrowserType) asOwner.GetSubSession().GetAttribute(Interpreter.BROWSERTYPE);
        if (browser.IsNetscape4() && (model.DoNotShowObject(nObjectIndex)))
        {
          cell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        } else
        {
          cell.AddInnerHTMLElement(inputSelector);
        }
        // Object Image
        cell = new HTMLTableCell();
        row.AddInnerHTMLElement(cell);
        cell.SetWidth("23");
        cell.SetVAlign(CommonHTMLStrings.TOP);
        cell.SetAlign(CommonHTMLStrings.CENTER);
        HTMLImg img = null;
        try
        {
          PTConstruct myConstruct = UIConstructFactory.GetConstruct(PTImageType.ICON_COMMUNITY);
          img = (HTMLImg) myConstruct.GetHTMLElement();
          img.SetAlt(asOwner.GetString(701, "ptmsgs_portalbrowsingmsgs"));
          }
        catch (Exception e)
        {
          log.Error(e, "Display Object: Failed to create image.");
        }
        cell.AddInnerHTMLElement(img);
        // Object Name
        cell = new HTMLTableCell();
        row.AddInnerHTMLElement(cell);
        cell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        cell.SetStyleClass(PTStyleClass.LIST_TEXT);
        HTMLSpan mySpan = new HTMLSpan();
        cell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.LIST_SUBTITLE);
        HTMLAnchor previewCommAnchor = ConstructStaticHelpers.GetJavascriptAnchor(XPHttpUtility.HtmlEncode(strObjectName),
         JAVASCRIPT_PREVIEW_COMMUNITY + "(\'" + iObjectID + "\',\'" + nObjectIndex + "\')");
        mySpan.AddInnerHTMLElement(previewCommAnchor);
        previewCommAnchor.SetTitle(asOwner.GetString(703, "ptmsgs_portalbrowsingmsgs"));
        Object oDescription = model.GetObjectFields(nObjectIndex, PT_PROPIDS.PT_PROPID_DESCRIPTION);
        if (null != oDescription)
        {
          if (!"".Equals(oDescription))
          {
            cell.AddInnerHTMLElement(br);
            // Object Description
            cell.AddInnerHTMLEncodedString((String) oDescription);
          }
        }
        // Hidden Inputs with Portlet information
        HTMLInput inputHidden = new HTMLInput(HTMLInputTypes.HIDDEN, ObjectSelectionModel.HTMLINPUT_HIDDEN_ID + nObjectIndex,
         "");
        inputHidden.SetValue(XPConvert.ToString(iObjectID));
        cell.AddInnerHTMLElement(inputHidden);
        inputHidden = new HTMLInput(HTMLInputTypes.HIDDEN, ObjectSelectionModel.HTMLINPUT_HIDDEN_NAME + nObjectIndex,
         "");
        inputHidden.SetValue(XPHttpUtility.HtmlEncode(strObjectName));
        cell.AddInnerHTMLElement(inputHidden);
        // Send to Others Link
        cell = new HTMLTableCell();
        row.AddInnerHTMLElement(cell);
        cell.SetAlign(CommonHTMLStrings.CENTER);
        cell.SetVAlign(CommonHTMLStrings.MIDDLE);
        cell.SetNoWrap(true);
        cell.SetStyleClass(PTStyleClass.LIST_TEXT);
        // just using asurl to build the url - will soon pass it into an HTMLAnchor
        HTMLAnchor sendToOthersAnchor = ConstructStaticHelpers.GetJavascriptAnchor("",
         JAVASCRIPT_OPEN_INVITE + "(\'" + nObjectIndex + "\')");
        cell.AddInnerHTMLElement(sendToOthersAnchor);
        sendToOthersAnchor.SetTitle(asOwner.GetString(702, "ptmsgs_portalbrowsingmsgs"));
        PTConstruct mySendConstruct = UIConstructFactory.GetConstruct(PTImageType.ACTION_SEND);
        HTMLImg myImg = (HTMLImg) mySendConstruct.GetHTMLElement();
        myImg.SetAlt(asOwner.GetString(702, "ptmsgs_portalbrowsingmsgs"));
        sendToOthersAnchor.AddInnerHTMLElement(myImg);
      }
      catch (HTMLException e)
      {
        log.Error(e, "Community " + iObjectID + " failed to display.");
      }
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#SetExpandButton(HTMLAnchor,IObjectModelRO)"></seealso>
    public virtual void SetExpandAnchor(HTMLAnchor anchor, IObjectModelRO model)
    {
    }
  }
}