using System;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.objectselection;
using com.plumtree.portalpages.browsing.objectselection.portlets;
using com.plumtree.portalpages.browsing.portletpreview;
using com.plumtree.portalpages.common.folder;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.search;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.common;
namespace com.plumtree.portalpages.browsing.objectselection.flyout
{
  /// <author>duang</author>
  public class FlyoutPortletSelectionAS : PTEditorAS
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.objectselection.flyout.FlyoutPortletSelectionAS");
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "FlyoutPortletSelection";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new FlyoutPortletSelectionAS();
    }
    
    /// <summary>
    /// Sets the Editor title.
    /// </summary>
    /// <returns></returns>
    public override String GetEditorTitle()
    {
      // DCA - not needed
      return "";
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the class name of the Property Repost Control.
    /// </summary>
    /// <returns>String</returns>
    public override String GetRepostControlName()
    {
      return (ObjectSelectionRepostControl.STR_MVC_CLASS_NAME);
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#Init(IPTSession)"></seealso>
    public override void Init()
    {
      log.Info("Initializing Portlet Selection Activity Space");
      // Portlet Selection Model
      m_strModelName = ObjectSelectionModel.STR_MVC_CLASS_NAME;
      base.Init();
      // Call IntegratedSearchAS.RegisterSearchClasses to register search stuff.
      IntegratedSearchAS.RegisterSearchClasses(this);
      ObjectSelectionModel myModel = (ObjectSelectionModel) GetModel(ObjectSelectionModel.STR_MVC_CLASS_NAME);
      myModel.SetSelectionModelHelper(new PortletSelectionModelHelper(this));
      // Model has to be initialized in Init method because it requires PTSession.
      log.Info("Registered models");
      // Portlet Selection DisplayPages
      RegisterPage(new FlyoutPortletSelectionDP());
      RegisterPage(new PortletInvitationPopupDP());
      log.Info("Registered pages");
      // Portlet Selection Controls
      RegisterControl(OpenSubFolderControl.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(SetStartItemControl.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(SetLastItemControl.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(ObjectSelectionRepostControl.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(InvitationPopupControl.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(PassthruControl.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(ObjectSelectionActionControl.STR_MVC_CLASS_NAME, myModel);
      log.Info("Registered controls");
      // Portlet Preview/Invitation Views
      RegisterView(PortletInvitationPopupView.STR_MVC_CLASS_NAME, myModel);
      // Set default page
      SetCurrentPage(GetPage(FlyoutPortletSelectionDP.STR_MVC_CLASS_NAME));
      }
  }
}
// TODO figure this out this.SetHelpTopic( "PT_AddPortlets" );
