using System;
using com.plumtree.portalpages.browsing.objectselection;
namespace com.plumtree.portalpages.browsing.objectselection.portlets
{
  /// <summary>
  /// This model is used to enable simple mode - no adding or preview of portlets.
  /// </summary>
  /// <author>dhayler</author>
  public class PortletInBundleObjectSelectionModel : ObjectSelectionModel
  {
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "PortletInBundleObjectSelection";
    protected bool m_bSimpleMode = false;
    public PortletInBundleObjectSelectionModel() : base()
    {
    }
    // TODO: These two methods should really be in model interfaces.
    
    /// <summary>
    /// Set whether we're in simple mode or not.
    /// </summary>
    /// <param name="_bSimple">whether we're in simple mode or not.</param>
    public virtual void SetSimpleMode(bool _bSimple)
    {
      m_bSimpleMode = _bSimple;
    }
    
    /// <returns>whether we're in simple mode or not.</returns>
    public virtual bool GetSimpleMode()
    {
      return m_bSimpleMode;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.editor.EditorModel#GetIsEditorReadOnly()"></seealso>
    public override bool GetIsEditorReadOnly()
    {
      if (GetSimpleMode())
      {
        // Simple submit mode only needs a done button.
        return true;
      }
      return base.GetIsEditorReadOnly();
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IModelRO#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new PortletInBundleObjectSelectionModel();
    }
  }
}