using System;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.objectselection;
using com.plumtree.portalpages.browsing.portletpreview;
using com.plumtree.portalpages.common.objects;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.browsing.objectselection.portlets
{
  /// <author>michaeld</author>
  public class PortletInBundleSelectionAS : PTEditorAS,IObjectSelectionAS
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.objectselection.portlets.PortletInBundleSelectionAS");
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "PortletInBundleSelection";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new PortletInBundleSelectionAS();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.editor.EditorAS#GetEditorTitle()"></seealso>
    public override String GetEditorTitle()
    {
      return GetString(734, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.objectselection.IObjectSelectionAS#GetObjectBannerText()"></seealso>
    public virtual String GetObjectBannerText()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.objectselection.IObjectSelectionAS#GetObjectBannerTitle()"></seealso>
    public virtual String GetObjectBannerTitle()
    {
      return null;
    }
    
    /// <summary>
    /// Returns the class name of the Property Repost Control.
    /// </summary>
    /// <returns>String</returns>
    public override String GetRepostControlName()
    {
      return (ObjectSelectionRepostControl.STR_MVC_CLASS_NAME);
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.objectselection.IObjectSelectionAS#GetResultsPageName()"></seealso>
    public virtual String GetResultsPageName()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.objectselection.IObjectSelectionAS#GetSearchPrompt()"></seealso>
    public virtual String GetSearchPrompt()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#Init(IPTSession)"></seealso>
    public override void Init()
    {
      log.Info("Initializing Portlet in Bundle Object Selection Activity Space");
      // Portlet in Bundle Object Selection Model
      m_strModelName = ObjectSelectionModel.STR_MVC_CLASS_NAME;
      // This allows us to register the bundle model under the name of the object selection model.
      m_strModelMVCName = PortletInBundleObjectSelectionModel.STR_MVC_CLASS_NAME;
      base.Init();
      ObjectSelectionModel myModel = (ObjectSelectionModel) GetModel(m_strModelName);
      myModel.SetSelectionModelHelper(new PortletInBundleSelectionModelHelper(this));
      // Model has to be initialized in Init method because it requires PTSession.
      log.Info("Registered model");
      // Portlet Selection DisplayPages
      RegisterPage(new PortletInBundleSelectionDP());
      // Register MVC for invitation popup
      RegisterPage(new PortletInvitationPopupDP());
      log.Info("Registered page");
      // Portlet Selection Views
      RegisterView(ObjectView.STR_MVC_CLASS_NAME, myModel);
      RegisterView(ObjectSelectionView.STR_MVC_CLASS_NAME, myModel);
      // Register MVC for invitation popup
      RegisterView(PortletInvitationPopupView.STR_MVC_CLASS_NAME, myModel);
      log.Info("Registered views");
      // Set view helper on object view
      ((ObjectView) GetView(ObjectView.STR_MVC_CLASS_NAME)).SetObjectViewHelper(new PortletSelectionViewHelper());
      // Reregister our custom editor start control so that it is used instead of the default one.
      UnRegisterControl(EditorStartControl.STR_MVC_CLASS_NAME);
      RegisterControl(PortletInBundleSelectionEditorStartControl.STR_MVC_CLASS_NAME,
       EditorStartControl.STR_MVC_CLASS_NAME, myModel);
      // Register MVC for invitation popup
      RegisterControl(InvitationPopupControl.STR_MVC_CLASS_NAME, myModel);
      // Portlet Selection Controls
      RegisterControl(ObjectSelectionRepostControl.STR_MVC_CLASS_NAME, myModel);
      log.Info("Registered controls");
      // Set default page
      SetCurrentPage(PortletInBundleSelectionDP.STR_MVC_CLASS_NAME);
      this.SetHelpTopic("PT_AddPortlets");
    }
  }
}