using System;
using com.plumtree.portalpages.browsing.objectselection;
using com.plumtree.portalpages.common.objects;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.objectselection.portlets
{
  /// <author>michaeld</author>
  public class PortletInBundleSelectionDP : EditorDP
  {
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "PortletInBundleSelection";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.editor.EditorDP#GetLeftNavString()"></seealso>
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(735, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for that Page.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException </throws>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // Insert super class HTML
      result.AddInnerHTMLElement(base.PageDisplay());
      HTMLElementCollection views = new HTMLElementCollection();
      views.AddInnerHTMLElement(m_asOwner.GetView(ObjectView.STR_MVC_CLASS_NAME).Display());
      result.AddInnerHTMLElement(CreateContentTable(views, m_asOwner.GetString(735,
       "ptmsgs_portalbrowsingmsgs")));
      return result;
    }
    
    /// <returns></returns>
    /// <throws>HTMLException </throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection scripts = new HTMLScriptCollection();
      HTMLScript myScript = m_asOwner.GetView(ObjectView.STR_MVC_CLASS_NAME).DisplayJavascript();
      if (null != myScript)
      {
        scripts.AddInnerHTMLElement(myScript);
      }
      HTMLScriptCollection myScriptCollection = ((ObjectView) m_asOwner.GetView(ObjectView.STR_MVC_CLASS_NAME)).DisplayJavascriptCollection();
      if (null != myScriptCollection)
      {
        scripts.AddInnerHTMLElement(myScriptCollection);
      }
      myScript = m_asOwner.GetView(ObjectSelectionView.STR_MVC_CLASS_NAME).DisplayJavascript();
      if (null != myScript)
      {
        scripts.AddInnerHTMLElement(myScript);
      }
      return scripts;
    }
  }
}