using System;
using com.plumtree.portalpages.browsing.objectselection;
using com.plumtree.portalpages.common.folder;
using com.plumtree.portalpages.common.objects;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.constants;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.objectselection.portlets
{
  /// <author>MichaelD</author>
  public class PortletSelectionDP_D : EditorDP
  {
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "PortletSel_D";
    
    /// <summary>
    /// Object Section Index: gadgets 
    /// </summary>
    public const int GADGET_INDEX = 0;
    
    /// <summary>
    /// Object Section Index: bundles 
    /// </summary>
    public const int BUNDLE_INDEX = 1;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#DisplayHTMLBeforeForm()"></seealso>
    public override HTMLElementCollection DisplayHTMLBeforeForm()
    {
      HTMLElementCollection searchview = base.DisplayHTMLBeforeForm();
      // Add a "search for gadgets" form
      if (searchview == null)
      {
        searchview = new HTMLElementCollection();
      }
      // Construct table to contain the page.
      HTMLTable myTable = new HTMLTable();
      searchview.AddInnerHTMLElement(myTable);
      myTable.SetBorder(CommonHTMLStrings.ZERO);
      myTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
      myTable.SetCellPadding(CommonHTMLStrings.ZERO);
      myTable.SetCellSpacing(CommonHTMLStrings.ZERO);
      HTMLTableRow myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      HTMLTableCell myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetAutoFit(true);
      myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetWidth("15");
      myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      // Search Form
      myCell.AddInnerHTMLElement(m_asOwner.GetView(ObjSelSearchFormView.STR_MVC_CLASS_NAME).Display());
      ObjectSelectionModel model = ((ObjectSelectionModel) m_asOwner.GetModel(ObjectSelectionModel.STR_MVC_CLASS_NAME));
      model.SetObjectViewIndex(GADGET_INDEX);
      if (model.GetDisplaySearch())
      {
        // View by Subfolder and Header
        myCell.AddInnerHTMLElement(m_asOwner.GetView(ObjSelSearchHeaderView.STR_MVC_CLASS_NAME).Display());
        // Instructional text
        if (AccessStyles.LOW_BANDWIDTH == m_asOwner.GetAccessStyle())
        {
          myCell.AddInnerHTMLElement(HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1784,
           "ptmsgs_portalbrowsingmsgs"), this.m_asOwner));
        } else
        {
          myCell.AddInnerHTMLElement(HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1884,
           "ptmsgs_portalbrowsingmsgs"), this.m_asOwner));
        }
        // Spacer table
        myCell.AddInnerHTMLElement(EditorView.GetShortSpacerTable());
        // Search Summary and Search Results
        myCell.AddInnerHTMLElement(m_asOwner.GetView(ObjSelSearch508BodyView.STR_MVC_CLASS_NAME).Display());
        myCell.AddInnerHTMLElement(((ObjectView) m_asOwner.GetView(PortletSelectionEditorAS.BUNDLE_VIEW)).GetObjectViewHelper().AddObjectViewHTML(model));
        // Selected Objects
        myCell.AddInnerHTMLElement(m_asOwner.GetView(SelectedObjectsView.STR_MVC_CLASS_NAME).Display());
        myCell.AddInnerHTMLElement(m_asOwner.GetView(ObjectSelectionView.STR_MVC_CLASS_NAME).Display());
        }
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetWidth("15");
      myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      return searchview;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.editor.EditorDP#GetLeftNavString()"></seealso>
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(713, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      if (!((ObjectSelectionModel) m_asOwner.GetModel(ObjectSelectionModel.STR_MVC_CLASS_NAME)).GetDisplaySearch())
      {
        if (AccessStyles.LOW_BANDWIDTH == m_asOwner.GetAccessStyle())
        {
          return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1784,
           "ptmsgs_portalbrowsingmsgs"), this.m_asOwner);
        } else
        {
          return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1884,
           "ptmsgs_portalbrowsingmsgs"), this.m_asOwner);
        }
      }
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for that Page.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException </throws>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLElementCollection views = new HTMLElementCollection();
      // Insert super class HTML
      result.AddInnerHTMLElement(base.PageDisplay());
      ObjectSelectionModel model = ((ObjectSelectionModel) m_asOwner.GetModel(ObjectSelectionModel.STR_MVC_CLASS_NAME));
      views.AddInnerHTMLElement(EditorView.GetShortSpacerTable());
      if (!model.GetDisplaySearch())
      {
        if (model.IsCommunityPage())
        {
          if (1 >= model.GetCurrentFolderID())
          {
            // JHQ: Don't display on the userprofile community
            if (model.GetSelectorCommunityFolderID() != PT_INTRINSICS.PT_ADMIN_FOLDER_PROFILECOMMUNITY)
            {
              views.AddInnerHTMLElement(m_asOwner.GetView(MyCustomPortletsView.STR_MVC_CLASS_NAME).Display());
              }
          } else
          if (model.GetSelectorCommunityFolderID() == model.GetCurrentFolderID())
          {
            views.AddInnerHTMLElement(m_asOwner.GetView(CreatePortletActionBarView_D.STR_MVC_CLASS_NAME).Display());
            }
        }
        if (model.GetSelectorCommunityFolderID() != model.GetCurrentFolderID())
        {
          views.AddInnerHTMLElement(m_asOwner.GetView(FolderView.STR_MVC_CLASS_NAME).Display());
          views.AddInnerHTMLElement(EditorView.GetSpacerTable());
        }
        if (1 != model.GetCurrentFolderID())
        {
          if (model.GetSelectorCommunityFolderID() != model.GetCurrentFolderID())
          {
            model.SetObjectViewIndex(BUNDLE_INDEX);
            views.AddInnerHTMLElement(m_asOwner.GetView(PortletSelectionEditorAS.BUNDLE_VIEW).Display());
            views.AddInnerHTMLElement(EditorView.GetSpacerTable());
          }
          model.SetObjectViewIndex(GADGET_INDEX);
          views.AddInnerHTMLElement(m_asOwner.GetView(PortletSelectionEditorAS.GADGET_VIEW).Display());
          }
        views.AddInnerHTMLElement(EditorView.GetSpacerTable());
        views.AddInnerHTMLElement(m_asOwner.GetView(SelectedObjectsView.STR_MVC_CLASS_NAME).Display());
        views.AddInnerHTMLElement(m_asOwner.GetView(ObjectSelectionView.STR_MVC_CLASS_NAME).Display());
        result.AddInnerHTMLElement(CreateContentTable(views, null));
      }
      model = null;
      return result;
    }
  }
}