using System;
using com.plumtree.portalpages.browsing.settings;
namespace com.plumtree.portalpages.browsing.portalsettings
{
  /// <version>5.0</version>
  /// <author>SudhaSathiaseelan</author>
  public interface IPortalSettings : ISettings
  {
    
    /// <summary>
    /// Return the description under the link
    /// </summary>
    /// <param name="String">the language ID</param>
    /// <returns>String the link description</returns>
    String GetDescription(String _strLangID);
    
    /// <summary>
    /// Return the file location of the image
    /// </summary>
    /// <returns>String the image location</returns>
    String GetImageLocation();
    
    /// <summary>
    /// Return whether or not to display this setting
    /// </summary>
    /// <param name="Object">the current user's session object</param>
    /// <returns>boolean true implies display this setting.</returns>
    bool GetDisplaySetting(Object session);
    
    /// <summary>
    /// Return activity right restriction - this should be moved to ISettings,
    /// as both Portal Settings and Plumtree Utilities require this method
    /// </summary>
    /// <returns>int the activity right restriction</returns>
    int GetActivityRightRestriction();
  }
}