using System;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.browsing.portalsettings
{
  /// <author>$author$</author>
  public class PortalSettingsAS : PlumtreeAS
  {
    public const String STR_MVC_CLASS_NAME = "PortalSettings";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new PortalSettingsAS();
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.AActivitySpace#Init()"></seealso>
    public override void Init()
    {
      base.Init();
      // Portal Settings Display Page
      PortalSettingsDP myPage = new PortalSettingsDP();
      RegisterPage(myPage);
      // Portal Settings Model
      RegisterModel(PortalSettingsModel.STR_MVC_CLASS_NAME);
      IModel myModel = GetModel(PortalSettingsModel.STR_MVC_CLASS_NAME);
      // Portal Settings Control
      RegisterControl(PortalSettingsControl.STR_MVC_CLASS_NAME, myModel);
      // Portal Settings Views
      RegisterView(PortalSettingsView.STR_MVC_CLASS_NAME, myModel);
      this.SetHelpTopic("PT_MyAccount");
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(String,String,boolean)"></seealso>
    public override bool CheckBasicAccess(String strPage, String strControl,
     bool bSameSpace)
    {
      // DCA - call super's to check for change in navigational scheme
      base.CheckBasicAccess(strPage, strControl, bSameSpace);
      // make sure this is not the guest user
      bool isGuest = PlumtreeHelpers.IsGuestSession(this);
      if (isGuest && !PlumtreeHelpers.IsEditingDefaultProfile(this))
      {
        return false;
      }
      return true;
    }
  }
}