using System;
using OpenLogService=com.plumtree.openlog.OpenLogService;
using OpenLogger=com.plumtree.openlog.OpenLogger;
using com.plumtree.portalpages.common.uiparts;
using Layouts=com.plumtree.portaluiinfrastructure.layout.Layouts;
using PTDebugHelpers=com.plumtree.portaluiinfrastructure.statichelpers.PTDebugHelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.portalsettings
{
  /// <author>$author$</author>
  public class PortalSettingsDP : PlumtreeDP
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.portalsettings.PortalSettingsDP");
    public const String STR_MVC_CLASS_NAME = "PortalSettings";
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetSubtitleForBanner()"></seealso>
    public override String GetSubtitleForBanner()
    {
      return "";
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetTitleForBanner()"></seealso>
    public override String GetTitleForBanner()
    {
      return m_asOwner.GetString(747, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <returns></returns>
    /// <throws>HTMLException </throws>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection myCollection = new HTMLElementCollection();
      try
      {
        HTMLElement element = DisplayLayout(Layouts.MYACCOUNT_PAGE);
        if (null != element)
        {
          return element;
        }
        myCollection.AddInnerHTMLElement(m_asOwner.GetView(PortalSettingsView.STR_MVC_CLASS_NAME).Display());
        }
      catch (HTMLException he)
      {
        log.Error("he: " + he);
      }
      return myCollection;
    }
  }
}