using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.portalsettings.displayoptions
{
  /// <author>sample</author>
  /// <author>Julie Fournier</author>
  public class AccessibilityView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.portalsettings.displayoptions.AccessibilityView");
    public const String STR_MVC_CLASS_NAME = "Accessibilty";
    public const String HTMLRADIO_PORTALSTYLE = "in_ra_PortalStyle";
    
    /// <returns></returns>
    public override Object Create()
    {
      return new AccessibilityView();
    }
    
    /// <returns></returns>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLB myBold;
      HTMLInput myInput;
      try
      {
        result.AddInnerHTMLString("\n");
        HTMLComment myComment = new HTMLComment("Begin: Display DisplayOptView MainView");
        result.AddInnerHTMLElement(myComment);
        result.AddInnerHTMLString("\n");
        result.AddInnerHTMLElement(base.GetHeaderView(m_asOwner.GetString(1283,
         "ptmsgs_portalbrowsingmsgs")));
        myTable = new HTMLTable();
        result.AddInnerHTMLElement(myTable);
        myTable.SetWidth("100%");
        myTable.SetBorder("0");
        myTable.SetCellPadding("5");
        myTable.SetCellSpacing("0");
        myTable.SetSummary(m_asOwner.GetString(1607, "ptmsgs_portalbrowsingmsgs"));
        // Option 1 - standard
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.SetVAlign(CommonHTMLStrings.TOP);
        myInput = new HTMLInput(HTMLInputTypes.RADIO, HTMLRADIO_PORTALSTYLE,
         "");
        myInput.SetValue("3");
        myInput.SetChecked(((IDisplayOptModelRO) m_model).IsViewChecked("3"));
        myCell.AddInnerHTMLElement(myInput);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myBold = new HTMLB();
        myBold.AddInnerHTMLString(m_asOwner.GetString(994, "ptmsgs_portalbrowsingmsgs"));
        myCell.AddInnerHTMLElement(myBold);
        myCell.AddInnerHTMLElement(new HTMLBr());
        myCell.AddInnerHTMLString(m_asOwner.GetString(1279, "ptmsgs_portalbrowsingmsgs"));
        // Option 2 - 508
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.SetVAlign(CommonHTMLStrings.TOP);
        myInput = new HTMLInput(HTMLInputTypes.RADIO, HTMLRADIO_PORTALSTYLE,
         "");
        myInput.SetValue("1");
        myInput.SetChecked(((IDisplayOptModelRO) m_model).IsViewChecked("1"));
        myCell.AddInnerHTMLElement(myInput);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myBold = new HTMLB();
        myBold.AddInnerHTMLString(m_asOwner.GetString(1281, "ptmsgs_portalbrowsingmsgs"));
        myCell.AddInnerHTMLElement(myBold);
        myCell.AddInnerHTMLElement(new HTMLBr());
        myCell.AddInnerHTMLString(m_asOwner.GetString(1280, "ptmsgs_portalbrowsingmsgs"));
        // Option 3 - low bandwidth
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.SetVAlign(CommonHTMLStrings.TOP);
        myInput = new HTMLInput(HTMLInputTypes.RADIO, HTMLRADIO_PORTALSTYLE,
         "");
        myInput.SetValue("2");
        myInput.SetChecked(((IDisplayOptModelRO) m_model).IsViewChecked("2"));
        myCell.AddInnerHTMLElement(myInput);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myBold = new HTMLB();
        myBold.AddInnerHTMLString(m_asOwner.GetString(993, "ptmsgs_portalbrowsingmsgs"));
        myCell.AddInnerHTMLElement(myBold);
        myCell.AddInnerHTMLElement(new HTMLBr());
        myCell.AddInnerHTMLString(m_asOwner.GetString(1282, "ptmsgs_portalbrowsingmsgs"));
        }
      catch (HTMLException he)
      {
        log.Error(he, STR_MVC_CLASS_NAME + "::AccessibilityView::Display The following error occured when trying to display the HTML: " + he.Message);
        throw new XPException(m_asOwner.GetString(995, "ptmsgs_portalbrowsingmsgs"),
         he);
      }
      return result;
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}
// Strings to localize.
