using System;
using com.plumtree.openlog;
using com.plumtree.portalpages.common.constants;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.tips;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.portalsettings.displayoptions
{
  /// <author>StephenC</author>
  public class DisplayOptAS : PTEditorAS
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.portalsettings.displayoptions.DisplayOptAS");
    public const String STR_MVC_CLASS_NAME = "DisplayOpt";
    private const String sClassName = "com.plumtree.portalpages.browsing.portalsettings.displayoptions.DisplayOptAS";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new DisplayOptAS();
    }
    
    /// <returns></returns>
    public override String GetEditorTitle()
    {
      return (GetString(996, "ptmsgs_portalbrowsingmsgs"));
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the class name of the Property Repost Control.
    /// </summary>
    /// <returns>String</returns>
    public override String GetRepostControlName()
    {
      return (DisplayOptRepostControl.STR_MVC_CLASS_NAME);
    }
    public override void Init()
    {
      m_strModelName = DisplayOptModel.STR_MVC_CLASS_NAME;
      // Warning: m_strModelName must be initialized before super.Init() is called.
      base.Init();
      IModel myModel = GetModel(m_strModelName);
      RegisterPage(new MainDP());
      RegisterView(DisplayOptView.STR_MVC_CLASS_NAME, myModel);
      RegisterView(AccessibilityView.STR_MVC_CLASS_NAME, myModel);
      RegisterView(GreetingView.STR_MVC_CLASS_NAME, myModel);
      RegisterView(TimeoutView.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(DisplayOptRepostControl.STR_MVC_CLASS_NAME, myModel);
      SetCurrentPage(MainDP.STR_MVC_CLASS_NAME);
      // Set left nav menu
      // BEGIN Sub menu "General Settings"
      int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(997, "ptmsgs_portalbrowsingmsgs"));
      m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, MainDP.STR_MVC_CLASS_NAME);
      IPTServerConfigSettings config = (IPTServerConfigSettings) ((IPTSession) GetUserSession()).OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
       false);
      // Only show advanced settings page if debuggin mode is enabled
      if (config.GetSettingAsInt(PT_SERVER_CONFIG_SETTINGNAME.PT_SETTINGNAME_ENABLE_DEBUG_SUBPORTAL_RULES_MODE) == 1)
      {
        RegisterPage(new AdvancedSettingsDP());
        RegisterView(RulesDebugModeView.STR_MVC_CLASS_NAME, myModel);
        m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, AdvancedSettingsDP.STR_MVC_CLASS_NAME);
        }
      // END Sub menu "General Settings"		
      //	TIPS
      TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);
      if (tm != null)
      {
        try
        {
          tm.SetGeneratingClass(sClassName);
          int iTitleId = 99;
          int iTipId = 100;
          int iSecondaryTipId = 101;
          tm.SetTipTitle(this.GetString(iTitleId, ResourceConstants.TIPS));
          HTMLGenericElement e = new HTMLGenericElement(this.GetString(iTipId,
           ResourceConstants.TIPS));
          tm.SetTip(e);
          String sSecondary = this.GetString(iSecondaryTipId, ResourceConstants.TIPS);
          if (!("none_do_not_translate".Equals(sSecondary)))
          {
            e = new HTMLGenericElement(sSecondary);
            tm.SetSecondarTip(e);
          }
        }
        catch (Exception ex)
        {
          log.Error(ex, "Couldn\'t generate tip.");
        }
      }
    }
    //	Got the tips model
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(String,String,boolean)"></seealso>
    public override bool CheckBasicAccess(String strPage, String strControl,
     bool bSameSpace)
    {
      // make sure this is not the guest user
      bool isGuest = PlumtreeHelpers.IsGuestSession(this);
      if (isGuest && !PlumtreeHelpers.IsEditingDefaultProfile(this))
      {
        return false;
      }
      return true;
    }
  }
}