using System;
// Framework Imports
using com.plumtree.openfoundation.web;
using com.plumtree.portaluiinfrastructure.login;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.browsing.portalsettings.displayoptions
{
  /// <author>mike</author>
  public class DisplayOptRepostControl : EditorRepostControl,IHTTPControl
  {
    public const String STR_MVC_CLASS_NAME = "DisplayOptRepostControl";
    public const int POSTTOSELF_ACTION_RELOAD = 10;
    
    /// <summary>
    /// This need to be nulled out after execution 
    /// </summary>
    private IWebData m_WebData = null;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new DisplayOptRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <param name="r"></param>
    public virtual void SetHTTPItems(IXPRequest r, IWebData webdata)
    {
      m_WebData = webdata;
    }
    
    /// <summary>
    /// Switch between the action modes and call
    /// the associated method for each action.
    /// </summary>
    /// <param name="int"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      switch (_nAction){
      case EditorRepostControl.POSTTOSELF_ACTION_FINISH:
      int iExpMinutes = 500;
      int iExpSeconds = iExpMinutes * 60;
      String sAccessStyle = ((IDisplayOptModelRO) this.m_model).GetAccessibilityStyle();
      //	When an user sets the access style, a cookie is
      //	saved, causing the login page to use the access
      //	style requested.
      XPCookie cookie = new XPCookie(PTPersonalSettingsHelper.ACCESS_STYLE_COOKIE_NAME,
       sAccessStyle);
      cookie.SetPath("");
      cookie.SetExpireTime(iExpSeconds);
      m_WebData.AddCookie(cookie);
      break;
      case POSTTOSELF_ACTION_RELOAD:
      ((DisplayOptModel) m_model).LoadSettings();
      break;
      }
      // null this  out so we don't leak it.
      m_WebData = null;
    }
  }
}