using System;
// Framework Imports
using com.plumtree.openlog;
using com.plumtree.portalpages.common.constants;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.tips;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.portalsettings.localesettings
{
  /// <author>Original Author Unknown</author>
  /// <author>DavidP tweaks for timeout</author>
  public class LocaleSettingsEditorAS : PTEditorAS
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.portalsettings.localesettings.LocaleSettingsEditorAS");
    private const String sClassName = "com.plumtree.portalpages.browsing.portalsettings.localesettings.LocaleSettingsEditorAS";
    public const String STR_MVC_CLASS_NAME = "LocaleSettings";
    public const String strStorageSelectPTObject = "SelectUserPTObject";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new LocaleSettingsEditorAS();
    }
    
    /// <summary>
    /// Returns the class name of the Editor Repost Control.
    /// </summary>
    /// <returns>String</returns>
    public override String GetRepostControlName()
    {
      return (LocaleSettingsRepostControl.STR_MVC_CLASS_NAME);
    }
    
    /// <summary>
    /// Sets the Editor title.
    /// </summary>
    public override String GetEditorTitle()
    {
      if (EditorStartControl.EDITOR_START_FLAG_CREATE == ((EditorModel) GetModel(m_strModelName)).GetEditorType())
      {
        return (GetString(1499, "ptmsgs_portalbrowsingmsgs"));
      } else
      {
        return (GetString(1499, "ptmsgs_portalbrowsingmsgs"));
      }
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Registers all the classes for this Activity Space.
    /// </summary>
    public override void Init()
    {
      m_strModelName = LocaleSettingsModel.STR_MVC_CLASS_NAME;
      base.Init();
      IModel myModel = GetModel(m_strModelName);
      // Register DisplayPages
      //RegisterPage(new MainDP());
      LocaleSettingsDP localeDP = new LocaleSettingsDP();
      RegisterPage(localeDP);
      // Register Views
      RegisterView(LocaleSettingsView.STR_MVC_CLASS_NAME, myModel);
      // Register Control
      RegisterControl(LocaleSettingsRepostControl.STR_MVC_CLASS_NAME, myModel);
      // Default page
      SetCurrentPage(LocaleSettingsDP.STR_MVC_CLASS_NAME);
      // Main DP
      //mainDP.AddToValidationFunction("CheckMinLength"
      //Sets left nav menu
      int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(1032, "ptmsgs_portalbrowsingmsgs"));
      m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, LocaleSettingsDP.STR_MVC_CLASS_NAME);
      //m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, LocNamesDP.STR_MVC_CLASS_NAME);
      //int nMenuTwoID = m_mEditorMenu.StartNewSubMenu(_ui_LeftNavTitleMain);
      //m_mEditorMenu.AddLinkToSubMenu(nMenuTwoID, DevicesDP.STR_MVC_CLASS_NAME);
      //	TIPS
      TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);
      if (tm != null)
      {
        try
        {
          tm.SetGeneratingClass(sClassName);
          int iTitleId = 120;
          int iTipId = 121;
          int iSecondaryTipId = 122;
          tm.SetTipTitle(this.GetString(iTitleId, ResourceConstants.TIPS));
          HTMLGenericElement e = new HTMLGenericElement(this.GetString(iTipId,
           ResourceConstants.TIPS));
          tm.SetTip(e);
          String sSecondary = this.GetString(iSecondaryTipId, ResourceConstants.TIPS);
          if (!("none_do_not_translate".Equals(sSecondary)))
          {
            e = new HTMLGenericElement(sSecondary);
            tm.SetSecondarTip(e);
          }
        }
        catch (Exception ex)
        {
          log.Error(ex, "Couldn\'t generate tip.");
        }
      }
    }
    //	Got the tips model
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(String,String,boolean)"></seealso>
    public override bool CheckBasicAccess(String strPage, String strControl,
     bool bSameSpace)
    {
      // make sure this is not the guest user, unless we are editing the default
      // profile.
      bool isGuest = PlumtreeHelpers.IsGuestSession(this);
      if (isGuest && (!PlumtreeHelpers.IsEditingDefaultProfile(this)))
      {
        return false;
      }
      return true;
    }
  }
}