using System;
using com.plumtree.openfoundation.web;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.browsing.portalsettings.localesettings
{
  /// <summary>
  /// The only reason why we need this class is to get the WebData object.
  /// Note that this editor doesn't have any other repost actions 
  /// than EditorRepostControl and we don't implement the PerformAction method.
  /// </summary>
  /// <author>JulieF</author>
  public class LocaleSettingsRepostControl : EditorRepostControl,IHTTPControl
  {
    
    /// <summary>
    /// Class name for the activity space 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "LocaleSettingsRepost";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new LocaleSettingsRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Inits this Control with the HTTP Request and the Web Data object.
    /// </summary>
    /// <param name="_xpRequest"></param>
    /// <param name="_webdata"></param>
    public virtual void SetHTTPItems(IXPRequest _xpRequest, IWebData _webdata)
    {
      ((LocaleSettingsModel) m_model).SetWebData(_webdata);
    }
  }
}