using System;
// Framework Imports
using com.plumtree.openfoundation.internationalization;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.application.varpacks;
using com.plumtree.portaluiinfrastructure.login;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.web;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.portalsettings.localesettings
{
  public class LocaleSettingsView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.portalsettings.localesettings.LocaleSettingsView");
    public const String STR_MVC_CLASS_NAME = "LocaleViewTest";
    public const String HTMLINPUT_LANG = "in_se_Lang";
    public const String HTMLINPUT_TZ = "in_se_TZ";
    
    /// <returns></returns>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTableCell myCell;
      HTMLTableRow myRow;
      try
      {
        result.AddInnerHTMLElement(base.GetHeaderView(m_asOwner.GetString(1463,
         "ptmsgs_portalbrowsingmsgs")));
        HTMLTable myTable = new HTMLTable();
        result.AddInnerHTMLElement(myTable);
        myTable.SetBorder("1");
        myTable.SetWidth("100%");
        myTable.SetBorder("0");
        myTable.SetCellPadding("5");
        myTable.SetCellSpacing("0");
        myTable.SetSummary(m_asOwner.GetString(1612, "ptmsgs_portalbrowsingmsgs"));
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
        myCell.SetNoWrap(true);
        myCell.AddInnerHTMLString(m_asOwner.GetString(1465, "ptmsgs_portalbrowsingmsgs"));
        myCell.SetWidth("20%");
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        String strSelectedTZ = ((ILocaleSettingsModelRO) m_model).GetTimeZoneSetting();
        myCell.AddInnerHTMLElement(GetTimeZoneDropdown(m_asOwner, strSelectedTZ));
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
        myCell.SetNoWrap(true);
        myCell.AddInnerHTMLString(m_asOwner.GetString(1466, "ptmsgs_portalbrowsingmsgs"));
        myCell.SetWidth("20%");
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        String strSelected = ((ILocaleSettingsModelRO) m_model).GetLocaleSetting();
        myCell.AddInnerHTMLElement(GetLocalesDropdown(m_asOwner, strSelected));
        }
      catch (Exception e)
      {
        log.Error(e, "LocaleSettingsView::Display An error occured when trying to display the HTML.");
        throw new XPException(m_asOwner.GetString(1464, "ptmsgs_portalbrowsingmsgs"),
         e);
      }
      return result;
    }
    
    /// <summary>
    /// Returns a dropdown for the Locales.
    /// </summary>
    /// <param name="rm">
    /// The resource manager can be retrieved from the editor's activity space owner -
    /// XPResourceManager rm =         m_asOwner.GetResourceManager();
    /// </param>
    /// <param name="__strSelectedLocale">
    /// The setting returned from the server as the previously selected locale.  Use
    /// the LoginHelper to get the setting :-
    /// (String) LoginHelper.GetPersonalSettingValue(PersonalSettingNames.LOCALE, sessionManager, ptSession);
    /// </param>
    /// <returns>An HTMLSelect that is the dropdown for timezones.</returns>
    /// <throws>HTMLException</throws>
    public static HTMLSelect GetLocalesDropdown(AActivitySpace asOwner, String _strSelectedLocale)
    {
      HTMLSelect mySelect = new HTMLSelect(HTMLINPUT_LANG, "");
      mySelect.SetStyleClass(PTStyleClass.FORM_PULLDOWN_TEXT);
      XPResourceManager rm = asOwner.GetResourceManager();
      //String[] supportedLangs = rm.GetSupportedLanguages();
      String strLang = (String) PTPersonalSettingsHelper.GetPersonalSettingValue(PersonalSettingsHelper.LANGUAGE,
       asOwner);
      String[] supportedLocales = rm.GetSupportedLocales(strLang);
      HTMLOption myOption;
      // Add "Use Browser Settings" locale setting as first option
      myOption = new HTMLOption(PTPersonalSettingsHelper.LOCALE_USE_BROWSER_SETTING);
      mySelect.AddInnerHTMLElement(myOption);
      myOption.AddInnerHTMLString(asOwner.GetString(1747, "ptmsgs_portalbrowsingmsgs"));
      myOption.SetValue(PTPersonalSettingsHelper.LOCALE_USE_BROWSER_SETTING);
      if (_strSelectedLocale.Equals(PTPersonalSettingsHelper.LOCALE_USE_BROWSER_SETTING))
      {
        myOption.SetSelected(true);
      }
      // Add "Use Default Setting" locale setting as next option
      myOption = new HTMLOption(PTPersonalSettingsHelper.LOCALE_USE_DEFAULT_SETTING);
      mySelect.AddInnerHTMLElement(myOption);
      myOption.AddInnerHTMLString(asOwner.GetString(1889, "ptmsgs_portalbrowsingmsgs"));
      myOption.SetValue(PTPersonalSettingsHelper.LOCALE_USE_DEFAULT_SETTING);
      // The constant just contains the empty string, so we treat an unset
      // or empty setting as "use default"
      // This is actually just the empty string
      if (_strSelectedLocale.Equals(PTPersonalSettingsHelper.LOCALE_USE_DEFAULT_SETTING))
      {
        myOption.SetSelected(true);
      }
      // Add sorted list of locales
      HTMLElementCollection colSortedOptions = new HTMLElementCollection();
      mySelect.AddInnerHTMLElement(colSortedOptions);
      String strLocale;
      for (int j = 0;j < supportedLocales.Length;j++)
      {
        String strLocaleID = supportedLocales[j];
        // The list of supported locales actually includes languages and
        // locales.  Ignore those entries that are not locales.
        //
        if (XPStringUtility.IndexOf(strLocaleID, "-") != -1)
        {
          strLocale = rm.GetDisplayLocaleFromLocaleID(strLocaleID, strLang);
          myOption = new HTMLOption(strLocale);
          colSortedOptions.AddInnerHTMLElement(myOption);
          if (_strSelectedLocale.Equals(strLocaleID))
          {
            myOption.SetSelected(true);
          }
          myOption.AddInnerHTMLString(strLocale);
          myOption.SetValue(strLocaleID);
        }
      }
      return mySelect;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns a dropdown for the Timezones.
    /// </summary>
    /// <param name="rm">
    /// The resource manager can be retrieved from the editor's activity space owner -
    /// XPResourceManager rm =         m_asOwner.GetResourceManager();
    /// </param>
    /// <param name="_strSelectedTZ">
    /// The setting returned from the server as the previously selected time zone.  Use
    /// the LoginHelper to get the setting :-
    /// (String) LoginHelper.GetPersonalSettingValue(PersonalSettingNames.TIMEZONE, sessionManager, ptSession);
    /// </param>
    /// <returns>An HTMLSelect that is the dropdown for timezones.</returns>
    /// <throws>HTMLException</throws>
    public static HTMLSelect GetTimeZoneDropdown(AActivitySpace asOwner, String _strSelectedTZ)
    {
      HTMLSelect mySelect = new HTMLSelect(HTMLINPUT_TZ, "");
      mySelect.SetStyleClass(PTStyleClass.FORM_PULLDOWN_TEXT);
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      PTTimeZoneVarPack vpPTTimeZone = (PTTimeZoneVarPack) application.GetVarPackManager().GetVariablePackage(PTTimeZoneVarPack.VARPACK_ID);
      String strLang = (String) PTPersonalSettingsHelper.GetPersonalSettingValue(PersonalSettingsHelper.LANGUAGE,
       asOwner);
      XPResourceManager rm = asOwner.GetResourceManager();
      HTMLOption myOption;
      for (int i = 0;i < vpPTTimeZone.GetVarPackLength();i++)
      {
        String strTimeZone = rm.GetString(i, "TIMEZONEMsgs", strLang);
        String strTimeZoneID = (String) vpPTTimeZone.GetVarPackValue(XPConvert.ToString(i));
        myOption = new HTMLOption(strTimeZoneID);
        mySelect.AddInnerHTMLElement(myOption);
        if (_strSelectedTZ.Equals(strTimeZoneID))
        {
          myOption.SetSelected(true);
        }
        myOption.AddInnerHTMLString(strTimeZone);
      }
      return mySelect;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new LocaleSettingsView();
    }
  }
}