using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using Interpreter=com.plumtree.uiinfrastructure.interpreter.Interpreter;
namespace com.plumtree.portalpages.browsing.portalsettings.password
{
  /// <summary>
  /// This control simply marks the user as a guest and redirects to the change
  /// password editor.
  /// </summary>
  public class ExpiredPasswordMarkAsGuestControl : IControl
  {
    
    /// <summary>
    /// MVC object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "ExpiredPasswordMarkAsGuest";
    protected AActivitySpace m_asOwner;
    public virtual Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      // We are supposed to mark this user as a guest and redirect to the editor.
      // This needs to happen in a separate request so that it will be set on the
      // new user subsession instead of the old one (and therefore lost).
      m_asOwner.GetSubSession().SetAttribute(Interpreter.USERSESSIONVALID,
       false);
      Redirect rReturn = new Redirect();
      // Create a new space so the editor is initialized for the new user.
      rReturn.SetLinkCreateNewSpace(PasswordAS.STR_MVC_CLASS_NAME, m_asOwner);
      rReturn.SetControl(EditorStartControl.STR_MVC_CLASS_NAME);
      rReturn.AddControlArgument(EditorStartControl.QS_EDITOR_TYPE, EditorStartControl.EDITOR_START_FLAG_MISC);
      rReturn.AddControlArgument(PasswordModel.PASSWORD_EXPIRED, true);
      return rReturn;
    }
    public virtual void Init(IModel _model, AActivitySpace _space)
    {
      m_asOwner = _space;
    }
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    public virtual Object Create()
    {
      return new ExpiredPasswordMarkAsGuestControl();
    }
  }
}