using System;
namespace com.plumtree.portalpages.browsing.portalsettings.search
{
  /// <summary>
  /// This class is used to hold the name and query string for a saved search.
  /// </summary>
  /// <author>
  /// Matt Fryer
  /// Created on Sept 2, 2003
  /// </author>
  public class SavedSearchData
  {
    private String _name;
    private String _query;
    
    /// <summary>
    /// Construct a SavedSearchData instance
    /// </summary>
    /// <param name="name">Name to save the search under</param>
    /// <param name="url">Url to reconstruct the search</param>
    public SavedSearchData(String name, String query)
    {
      _name = name;
      _query = query;
    }
    
    /// <returns>name of the saved search</returns>
    public virtual String GetName()
    {
      return _name;
    }
    
    /// <returns>query string for the url of the saved search</returns>
    public virtual String GetURLQueryString()
    {
      return _query;
    }
    
    /// <param name="url">The query string for the url for this saved search.</param>
    public virtual void SetURLQueryString(String query)
    {
      _query = query;
    }
    
    /// <param name="name">The name for this saved search.</param>
    public virtual void SetName(String name)
    {
      _name = name;
    }
  }
}