using System;
using com.plumtree.openlog;
using com.plumtree.portalpages.common.constants;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.tips;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.portalsettings.search
{
  /// <author>CraigS, based on JulieF template</author>
  public class SearchSettingsAS : PTEditorAS
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.portalsettings.search.SearchSettingsAS");
    public const String STR_MVC_CLASS_NAME = "SearchSettings";
    private const String sClassName = "com.plumtree.portalpages.browsing.portalsettings.search.SearchSettingsAS";
    
    /// <returns></returns>
    public override Object Create()
    {
      return new SearchSettingsAS();
    }
    
    /// <returns></returns>
    public override String GetEditorTitle()
    {
      return GetString(1031, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    public override void Init()
    {
      m_strModelName = SearchSettingsModel.STR_MVC_CLASS_NAME;
      base.Init();
      IModel myModel = GetModel(m_strModelName);
      RegisterPage(new SearchSettingsDP());
      RegisterView(SearchSettingsView.STR_MVC_CLASS_NAME, myModel);
      SetCurrentPage(SearchSettingsDP.STR_MVC_CLASS_NAME);
      int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(1032, "ptmsgs_portalbrowsingmsgs"));
      m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, SearchSettingsDP.STR_MVC_CLASS_NAME);
      this.SetHelpTopic("PT_SearchPreferences_MainSettings");
      //	TIPS
      TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);
      if (tm != null)
      {
        try
        {
          tm.SetGeneratingClass(sClassName);
          int iTitleId = 129;
          int iTipId = 130;
          int iSecondaryTipId = 131;
          tm.SetTipTitle(this.GetString(iTitleId, ResourceConstants.TIPS));
          HTMLGenericElement e = new HTMLGenericElement(this.GetString(iTipId,
           ResourceConstants.TIPS));
          tm.SetTip(e);
          String sSecondary = this.GetString(iSecondaryTipId, ResourceConstants.TIPS);
          if (!("none_do_not_translate".Equals(sSecondary)))
          {
            e = new HTMLGenericElement(sSecondary);
            tm.SetSecondarTip(e);
          }
        }
        catch (Exception ex)
        {
          log.Error(ex, "Couldn\'t generate tip.");
        }
      }
    }
    //	Got the tips model
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(String,String,boolean)"></seealso>
    public override bool CheckBasicAccess(String strPage, String strControl,
     bool bSameSpace)
    {
      // make sure this is not the guest user
      bool isGuest = PlumtreeHelpers.IsGuestSession(this);
      if (isGuest && !PlumtreeHelpers.IsEditingDefaultProfile(this))
      {
        return false;
      }
      return true;
    }
  }
}