using System;
using com.plumtree.uiinfrastructure.constants;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.portalsettings.search
{
  /// <author>CraigS, based on JulieF template</author>
  public class SearchSettingsDP : EditorDP
  {
    public const String STR_MVC_CLASS_NAME = "SearchSettings";
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,
    /// linking to that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return (m_asOwner.GetString(1033, "ptmsgs_portalbrowsingmsgs"));
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    /// <throws>HTMLException </throws>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      result.AddInnerHTMLElement(base.PageDisplay());
      HTMLElementCollection views = new HTMLElementCollection();
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(SearchSettingsView.STR_MVC_CLASS_NAME)).Display());
      result.AddInnerHTMLElement(CreateLeftNavBar(views));
      return result;
    }
    
    /// <returns></returns>
    /// <throws>HTMLException </throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = null;
      if (m_asOwner.GetAccessStyle() == AccessStyles.STANDARD)
      {
        myScripts = base.DisplayJavaScriptFromChild();
        myScripts.AddInnerHTMLElement(m_asOwner.GetView(SearchSettingsView.STR_MVC_CLASS_NAME).DisplayJavascript());
        }
      return myScripts;
    }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1450, "ptmsgs_portalbrowsingmsgs"),
       this.m_asOwner);
    }
  }
}