using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.portalpages.browsing.editors.userprofile;
using com.plumtree.portalpages.browsing.portalsettings;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.web;
namespace com.plumtree.portalpages.browsing.portalsettings.settings
{
  /// <version>$Revision$</version>
  /// <author>$author$</author>
  public class EditUserProfileSetting : IPortalSettings
  {
    private bool m_bIsViewable = true;
    
    /// <summary>
    /// Creates a new UserPortalSettings object.
    /// </summary>
    public EditUserProfileSetting()
    {
    }
    
    /// <returns></returns>
    public virtual String GetASControlName()
    {
      return EditorStartControl.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASDPName()
    {
      return null;
    }
    
    /// <returns></returns>
    public virtual String GetASName()
    {
      return UserProfileEditorAS.STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String GetASQueryString()
    {
      String strQuery = "&" + EditorStartControl.QS_EDITOR_TYPE + "=10";
      return strQuery;
    }
    
    /// <param name="_strLangID"></param>
    /// <returns></returns>
    public virtual String GetDescription(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      return rm.GetString(1733, "ptmsgs_portalbrowsingmsgs", _strLangID);
      }
    
    /// <returns></returns>
    public virtual String GetImageLocation()
    {
      return null;
    }
    
    /// <param name="_strLangID"></param>
    /// <returns></returns>
    public virtual String GetLinkText(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      return rm.GetString(1302, "ptmsgs_portalbrowsingmsgs", _strLangID);
      }
    
    /// <returns></returns>
    public virtual bool IsStandardPortalOption()
    {
      return true;
    }
    
    /// <returns></returns>
    public virtual bool IsViewable()
    {
      return m_bIsViewable;
    }
    
    /// <param name="bIsViewable"></param>
    public virtual void SetViewable(bool bIsViewable)
    {
      m_bIsViewable = bIsViewable;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.portalsettings.IPortalSettings#GetDisplaySetting()"></seealso>
    public virtual bool GetDisplaySetting(Object session)
    {
      return true;
    }
    public virtual int GetActivityRightRestriction()
    {
      return PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_EDIT_OWN_PROFILE;
    }
  }
}