using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.portalpages.browsing.portalsettings;
using com.plumtree.portalpages.browsing.portalsettings.passwordmanager;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.web;
namespace com.plumtree.portalpages.browsing.portalsettings.settings
{
  /// <author>
  /// JenniferSu
  /// This describes a link to the Password Manager space.
  /// </author>
  public class PasswordManagerPortalSetting : IPortalSettings
  {
    
    /// <seealso cref="com.plumtree.portalpages.browsing.portalsettings.IPortalSettings#GetDescription(String)"></seealso>
    public virtual String GetDescription(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      return rm.GetString(1834, "ptmsgs_portalbrowsingmsgs", _strLangID);
      }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.portalsettings.IPortalSettings#GetImageLocation()"></seealso>
    public virtual String GetImageLocation()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.portalsettings.IPortalSettings#GetDisplaySetting(Object)"></seealso>
    public virtual bool GetDisplaySetting(Object session)
    {
      return true;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#GetASControlName()"></seealso>
    public virtual String GetASControlName()
    {
      return EditorStartControl.STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#GetASDPName()"></seealso>
    public virtual String GetASDPName()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#GetASName()"></seealso>
    public virtual String GetASName()
    {
      return PasswordManagerAS.STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#GetASQueryString()"></seealso>
    public virtual String GetASQueryString()
    {
      return LinkConstants.AMPERSAND + EditorStartControl.QS_EDITOR_TYPE + LinkConstants.EQUALS + EditorStartControl.EDITOR_START_FLAG_MISC;
      }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#GetLinkText(String)"></seealso>
    public virtual String GetLinkText(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      return rm.GetString(1835, "ptmsgs_portalbrowsingmsgs", _strLangID);
      }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#IsStandardPortalOption()"></seealso>
    public virtual bool IsStandardPortalOption()
    {
      return true;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.settings.ISettings#IsViewable()"></seealso>
    public virtual bool IsViewable()
    {
      return true;
    }
    public virtual int GetActivityRightRestriction()
    {
      return PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_NONE;
    }
  }
}