using System;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.portletpreview
{
  /// <summary>
  /// File: PortletInvitationPopupDP.java
  /// ----------------------------------
  /// Display Page for the Portlet Invitation Popup
  /// that appears from the "Send To Others" link in the Portlet
  /// Selection Page.
  /// </summary>
  /// <author>NaveenP/DustinA</author>
  public class InvitationOpenerRedirectDP : IDisplayPage
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.portletpreview.InvitationOpenerRedirectDP");
    public const String STR_MVC_CLASS_NAME = "InvitationOpenerRedirect";
    
    /// <summary>
    /// Activity Space 
    /// </summary>
    private AActivitySpace m_asOwner;
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#display()"></seealso>
    public virtual void Display(IWebData pageData)
    {
      ASURL asurl = new ASURL(m_asOwner);
      asurl.SetLinkGetCachedSpace(m_asOwner);
      asurl.SetDisplayPage(PortletInvitationJoinDP.STR_MVC_CLASS_NAME);
      HTMLPage page = new HTMLPage();
      HTMLHead head = new HTMLHead();
      HTMLScript script = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
      try
      {
        script.AddInnerHTMLString("window.opener.location=\'" + asurl.GetURLAsString() + "\';\n");
        script.AddInnerHTMLString("self.close();\n");
        head.AddInnerHTMLElement(script);
        page.SetHead(head);
      }
      catch (HTMLException he)
      {
        log.Error(he, he.Message);
      }
      pageData.SetData(page);
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.ui.framework.IDisplayPage#GetParent()"></seealso>
    public virtual AActivitySpace GetOwner()
    {
      return m_asOwner;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#Init(AActivitySpace)"></seealso>
    public virtual void Init(AActivitySpace parent)
    {
      m_asOwner = parent;
    }
  }
}