using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.constants;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.portletpreview
{
  /// <summary>
  /// File: InvitePortletJSDP.java
  /// ---------------------------
  /// Display Page for the Portlet Invitation JavaScript.
  /// This is a blank page that simply pops up the Portlet
  /// Invitation.
  /// </summary>
  /// <author>NaveenP/DustinA</author>
  public class InvitePortletJSDP : AFormDP
  {
    public const String STR_MVC_CLASS_NAME = "InviteGadgetJS";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#GetFormPageType()"></seealso>
    public override FormPageTypes GetFormPageType()
    {
      if (GetOwner().GetAccessStyle() != AccessStyles.STANDARD)
      {
        return FormPageTypes.NORMAL_PAGE;
      }
      // default implementation
      return FormPageTypes.NO_BUTTONS;
    }
    
    /// <returns></returns>
    public override String GetFormTitle()
    {
      return "";
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.ui.framework.IDisplayPage#GetParent()"></seealso>
    public override AActivitySpace GetOwner()
    {
      return m_asOwner;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetSubtitleForBanner()"></seealso>
    public virtual String GetSubtitleForBanner()
    {
      return "";
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetTitleForBanner()"></seealso>
    public virtual String GetTitleForBanner()
    {
      return "";
    }
    /*public void Init(AActivitySpace parent)
     {
     m_asOwner = parent;
     }*/
     
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      result.AddInnerHTMLElement(m_asOwner.GetView(InvitePortletJSView.STR_MVC_CLASS_NAME).Display());
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#DisplayJavaScriptFromChild()"></seealso>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection scripts = new HTMLScriptCollection();
      scripts.AddInnerHTMLElement(m_asOwner.GetView(InvitePortletJSView.STR_MVC_CLASS_NAME).DisplayJavascript());
      scripts.AddInnerHTMLElement(((InvitePortletJSView) m_asOwner.GetView(InvitePortletJSView.STR_MVC_CLASS_NAME)).DisplayRedirectJavascript());
      return scripts;
    }
  }
}