using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.resultwrapper;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.errordisplay;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.portletpreview
{
  /// <summary>
  /// File: InvitePortletJSView.java
  /// -----------------------------
  /// Section for Portlet Invitation JavaScript.  This is a blank page
  /// that simply popups up the Portlet Invitation.
  /// </summary>
  /// <author>NaveenP/DustinA</author>
  public class InvitePortletJSView_D : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.portletpreview.InvitePortletJSView_D");
    public const String STR_MVC_CLASS_NAME = "InvitePortletJS_D";
    
    /// <summary>
    /// Activity Space 
    /// </summary>
    private AActivitySpace m_asOwner;
    
    /// <summary>
    /// model 
    /// </summary>
    private IPreviewPortletModelRO m_asModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new InvitePortletJSView_D();
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#display()"></seealso>
    public virtual HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      //InvitePortletJSDP displayPage = (InvitePortletJSDP) m_asOwner.GetPage(InvitePortletJSDP.STR_MVC_CLASS_NAME);
      HTMLTable mainTable;
      HTMLTableRow mainRow;
      HTMLTableCell mainCell;
      HTMLH1 headerH1;
      HTMLH2 headerH2;
      try
      {
        HTMLComment myComment = new HTMLComment("Begin: Display InvitePortletJSView_D");
        result.AddInnerHTMLElement(myComment);
        HTMLTable headerTable = new HTMLTable();
        result.AddInnerHTMLElement(headerTable);
        headerTable.SetStyleClass(PTStyleClass.BAN_HEADER_BG);
        headerTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        headerTable.SetHeight("52");
        HTMLTableRow headerRow = new HTMLTableRow();
        headerTable.AddInnerHTMLElement(headerRow);
        HTMLTableCell headerCell = new HTMLTableCell();
        headerRow.AddInnerHTMLElement(headerCell);
        headerCell.SetVAlign(CommonHTMLStrings.CENTER);
        headerH1 = new HTMLH1();
        headerCell.AddInnerHTMLElement(headerH1);
        headerH1.AddInnerHTMLString(m_asOwner.GetString(1313, "ptmsgs_portalbrowsingmsgs"));
        headerH1.SetStyleClass(PTStyleClass.BAN_HEADER);
        headerCell.AddInnerHTMLElement(new HTMLBr());
        headerH2 = new HTMLH2();
        headerCell.AddInnerHTMLElement(headerH2);
        headerH2.AddInnerHTMLString(m_asOwner.GetString(1637, "ptmsgs_portalbrowsingmsgs"));
        headerH2.SetStyleClass(PTStyleClass.BAN_SUBHEADER);
        if (m_asModel.IsErrorPage())
        {
          result.AddInnerHTMLElement(m_asOwner.GetView(ErrorView.STR_MVC_CLASS_NAME).Display());
          }
        mainTable = new HTMLTable();
        result.AddInnerHTMLElement(mainTable);
        mainTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        mainRow = new HTMLTableRow();
        mainTable.AddInnerHTMLElement(mainRow);
        mainCell = new HTMLTableCell();
        mainRow.AddInnerHTMLElement(mainCell);
        mainCell.SetWidth("20");
        mainCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        mainCell = new HTMLTableCell();
        mainRow.AddInnerHTMLElement(mainCell);
        HTMLTable myInnerTable = new HTMLTable();
        mainCell.AddInnerHTMLElement(myInnerTable);
        myInnerTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        HTMLTableRow myInnerRow = new HTMLTableRow();
        myInnerTable.AddInnerHTMLElement(myInnerRow);
        HTMLTableCell myInnerCell = new HTMLTableCell();
        myInnerRow.AddInnerHTMLElement(myInnerCell);
        myInnerCell.SetHeight("10");
        myInnerCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myInnerRow = new HTMLTableRow();
        myInnerTable.AddInnerHTMLElement(myInnerRow);
        myInnerCell = new HTMLTableCell();
        myInnerRow.AddInnerHTMLElement(myInnerCell);
        myInnerCell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        myInnerCell.AddInnerHTMLString(XPResourceManager.FormatMessage(m_asOwner.GetString(1312,
         "ptmsgs_portalbrowsingmsgs"), XPHttpUtility.HtmlEncode(m_asModel.GetPortletName())));
        myInnerRow = new HTMLTableRow();
        myInnerTable.AddInnerHTMLElement(myInnerRow);
        myInnerCell = new HTMLTableCell();
        myInnerRow.AddInnerHTMLElement(myInnerCell);
        myInnerCell.SetStyleClass(PTStyleClass.CUSTOMAPP_TEXT);
        myInnerCell.AddInnerHTMLString(m_asOwner.GetString(1310, "ptmsgs_portalbrowsingmsgs"));
        myInnerRow = new HTMLTableRow();
        myInnerTable.AddInnerHTMLElement(myInnerRow);
        myInnerCell = new HTMLTableCell();
        myInnerRow.AddInnerHTMLElement(myInnerCell);
        myInnerCell.SetHeight("20");
        myInnerCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myInnerRow = new HTMLTableRow();
        myInnerTable.AddInnerHTMLElement(myInnerRow);
        myInnerCell = new HTMLTableCell();
        myInnerRow.AddInnerHTMLElement(myInnerCell);
        myInnerCell.AddInnerHTMLString(m_asOwner.GetString(1309, "ptmsgs_portalbrowsingmsgs"));
        myInnerRow = new HTMLTableRow();
        myInnerTable.AddInnerHTMLElement(myInnerRow);
        myInnerCell = new HTMLTableCell();
        myInnerRow.AddInnerHTMLElement(myInnerCell);
        HTMLSelect pageMenu = new HTMLSelect("in_se_pageMenu", "pageMenu");
        IASQueryResult userPages = m_asModel.GetMyPages();
        String strPageName;
        int nPageID;
        for (int i = 0;i < userPages.GetCount();i++)
        {
          nPageID = XPConvert.ToInteger(userPages.GetFields(i, PT_PROPIDS.PT_PROPID_OBJECTID));
          strPageName = (String) userPages.GetFields(i, PT_PROPIDS.PT_PROPID_NAME);
          String optionValue = XPConvert.ToString(nPageID);
          HTMLOption option = new HTMLOption(optionValue);
          option.AddInnerHTMLEncodedString(strPageName);
          if (i == 0)
          {
            option.SetSelected(true);
          }
          pageMenu.AddInnerHTMLElement(option);
        }
        myInnerCell.AddInnerHTMLElement(pageMenu);
        myComment = new HTMLComment("End: Display InvitePortletJSView_D");
        result.AddInnerHTMLElement(myComment);
      }
      catch (HTMLException he)
      {
        log.Error(he, he.Message);
      }
      return result;
    }
    
    /// <summary>
    /// Display JavaScript - this includes the static source file
    /// return HTMLScript
    /// </summary>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <summary>
    /// Display JavaScript - this includes the static source file
    /// return HTMLScript
    /// </summary>
    public virtual HTMLScript DisplayRedirectJavascript()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#Init(IModel,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asModel = (IPreviewPortletModelRO) model;
      m_asOwner = parent;
    }
  }
}