using System;
using com.plumtree.openlog;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.portletpreview
{
  /// <summary>
  /// File: NoMyPageAccessView.java
  /// -------------------------------
  /// </summary>
  /// <author>NaveenP/DustinA</author>
  public class NoMyPageAccessView : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.portletpreview.NoMyPageAccessView");
    public const String STR_MVC_CLASS_NAME = "NoMyPageAccess";
    
    /// <summary>
    /// Activity Space 
    /// </summary>
    private AActivitySpace m_asOwner;
    
    /// <summary>
    /// model 
    /// </summary>
    private PreviewPortletModel m_asModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new NoMyPageAccessView();
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#display()"></seealso>
    public virtual HTMLElement Display()
    {
      NavigationModel navModel = (NavigationModel) m_asOwner.GetModel(NavigationModel.STR_MVC_CLASS_NAME);
      HTMLTable mainTable = new HTMLTable();
      HTMLTableRow mainRow;
      HTMLTableCell mainCell;
      HTMLAnchor anchor;
      ASURL defaultURL = navModel.GetDefaultSubportalURL();
      try
      {
        mainRow = new HTMLTableRow();
        mainTable.AddInnerHTMLElement(mainRow);
        mainCell = new HTMLTableCell();
        mainRow.AddInnerHTMLElement(mainCell);
        mainCell.SetStyleClass(PTStyleClass.ALERT_ERROR_TEXT);
        mainCell.AddInnerHTMLString(m_asOwner.GetString(1314, "ptmsgs_portalbrowsingmsgs"));
        mainCell = new HTMLTableCell();
        mainRow.AddInnerHTMLElement(mainCell);
        mainCell.SetStyleClass(PTStyleClass.DIALOGUE_TEXT);
        mainCell.AddInnerHTMLString(m_asOwner.GetString(1315, "ptmsgs_portalbrowsingmsgs"));
        anchor = new HTMLAnchor(m_asOwner.GetString(1316, "ptmsgs_portalbrowsingmsgs"));
        mainCell.AddInnerHTMLElement(anchor);
        anchor.SetHRef(defaultURL.GetURLAsString());
        anchor.AddInnerHTMLString(m_asOwner.GetString(1316, "ptmsgs_portalbrowsingmsgs"));
        }
      catch (HTMLException e)
      {
        log.Error(e, e.Message);
      }
      return mainTable;
    }
    
    /// <summary>
    /// Display JavaScript - this includes the static source file
    /// return HTMLScript
    /// </summary>
    public virtual HTMLScript DisplayJavascript()
    {
      HTMLScript script = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
      return script;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#Init(IModel,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asModel = (PreviewPortletModel) model;
      m_asOwner = parent;
    }
  }
}