using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.portletpreview
{
  /// <summary>
  /// File: PortletInvitationPopupDP.java
  /// ----------------------------------
  /// Display Page for the Portlet Invitation Popup
  /// that appears from the "Send To Others" link in the Portlet
  /// Selection Page.
  /// </summary>
  /// <author>NaveenP/DustinA</author>
  public class PortletInvitationPopupDP : IDisplayPage
  {
    public const String STR_MVC_CLASS_NAME = "GadgetInvitationPopup";
    
    /// <summary>
    /// Activity Space 
    /// </summary>
    private AActivitySpace m_asOwner;
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#display()"></seealso>
    public virtual void Display(IWebData pageData)
    {
      // TODOCR: DONH - Shouldn't there by a Display Page that wraps this view
      // and generates the HTMLPage?
      pageData.SetData((HTMLPage) m_asOwner.GetView(PortletInvitationPopupView.STR_MVC_CLASS_NAME).Display());
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.ui.framework.IDisplayPage#GetParent()"></seealso>
    public virtual AActivitySpace GetOwner()
    {
      return m_asOwner;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#Init(AActivitySpace)"></seealso>
    public virtual void Init(AActivitySpace parent)
    {
      m_asOwner = parent;
    }
  }
}