using System;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.myportal.communities;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.portletpreview
{
  /// <author>
  /// DustinA
  /// To change this generated comment edit the template variable "typecomment":
  /// Window>Preferences>Java>Templates.
  /// To enable and disable the creation of type comments go to
  /// Window>Preferences>Java>Code Generation.
  /// </author>
  public class PreviewPortletDescPopupView : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.portletpreview.PreviewPortletDescPopupView");
    public const String STR_MVC_CLASS_NAME = "PreviewPortletDescPopupView";
    
    /// <summary>
    /// Activity Space 
    /// </summary>
    private AActivitySpace m_asOwner;
    
    /// <summary>
    /// model 
    /// </summary>
    private IPreviewPortletModelRO m_asModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new PreviewPortletDescPopupView();
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#display()"></seealso>
    public virtual HTMLElement Display()
    {
      HTMLPage mainPage = null;
      try
      {
        //mainPage components
        mainPage = new HTMLPage();
        HTMLHead pageHead = new HTMLHead();
        HTMLTitle pageTitle = new HTMLTitle(m_asOwner.GetString(651, "ptmsgs_portalbrowsingmsgs"));
        pageHead.AddInnerHTMLElement(pageTitle);
        HTMLBody pageBody = new HTMLBody();
        pageBody.SetStyleClass(PTStyleClass.ALERT_DIALOG_BG);
        //mainTable components
        HTMLTable mainTable = new HTMLTable();
        HTMLTableRow mainRow1 = new HTMLTableRow();
        HTMLTableRow mainRow2 = new HTMLTableRow();
        HTMLTableRow mainRow3 = new HTMLTableRow();
        HTMLTableRow mainRow4 = new HTMLTableRow();
        HTMLTableCell mainRow1Cell = new HTMLTableCell();
        HTMLTableCell mainRow2Cell = new HTMLTableCell();
        HTMLTableCell mainRow3Cell = new HTMLTableCell();
        HTMLTableCell mainRow4Cell = new HTMLTableCell();
        //closeButton
        HTMLInput closeButton = new HTMLInput(1, "in_bu_close", m_asOwner.GetString(648,
         "ptmsgs_portalbrowsingmsgs"), m_asOwner.GetString(648, "ptmsgs_portalbrowsingmsgs"));
        closeButton.SetValue(m_asOwner.GetString(648, "ptmsgs_portalbrowsingmsgs"));
        closeButton.SetOnClick("self.close()");
        closeButton.SetStyleClass(PTStyleClass.FORM_EDITOR_BTN_TEXT);
        //Portlet Name and Description
        String strPortletName = m_asModel.GetPortletName();
        String strPortletDes = m_asModel.GetPortletDescription();
        //Specifying mainTable attributes
        //border="0" cellpadding="4" width="100%"
        mainTable.SetBorder("0");
        mainTable.SetCellPadding("4");
        mainTable.SetWidth("100%");
        //Setting up mainTable
        mainRow1Cell.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);
        mainRow1Cell.AddInnerHTMLString("<b>" + m_asOwner.GetString(1328,
         "ptmsgs_portalbrowsingmsgs") + "</b>" + XPHttpUtility.HtmlEncode(strPortletName));
        mainRow2Cell.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);
        mainRow2Cell.AddInnerHTMLString("<b>" + m_asOwner.GetString(1329,
         "ptmsgs_portalbrowsingmsgs") + "</b>" + XPHttpUtility.HtmlEncode(strPortletDes));
        mainRow3Cell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        mainRow4Cell.SetAlign("center");
        mainRow4Cell.AddInnerHTMLElement(closeButton);
        PreviewCommunityView.addRowCell(mainTable, mainRow1, mainRow1Cell);
        PreviewCommunityView.addRowCell(mainTable, mainRow2, mainRow2Cell);
        PreviewCommunityView.addRowCell(mainTable, mainRow3, mainRow3Cell);
        PreviewCommunityView.addRowCell(mainTable, mainRow4, mainRow4Cell);
        pageBody.AddInnerHTMLElement(mainTable);
        try
        {
          pageHead.AddInnerHTMLElement(m_asOwner.GetStyleSheetLinks());
        }
        catch (Exception e)
        {
          log.Error(e, e.Message);
        }
        mainPage.SetHead(pageHead);
        mainPage.SetBody(pageBody);
      }
      catch (HTMLException he)
      {
        log.Error(he, he.Message);
      }
      return mainPage;
    }
    
    /// <summary>
    /// Display JavaScript
    /// </summary>
    /// <returns>HTMLScript</returns>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#Init(IModel,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asModel = (IPreviewPortletModelRO) model;
      m_asOwner = parent;
    }
  }
}