using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.common.search;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.search.advanced
{
  /// <author>CraigS</author>
  public class ASFilterView : FilterView,IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.search.advanced.ASFilterView");
    public const String STR_MVC_CLASS_NAME = "ASFilter";
    protected AActivitySpace _parent = null;
    protected IAdvancedSearchModelRO _model = null;
    
    /// <returns></returns>
    public override Object Create()
    {
      return new ASFilterView();
    }
    
    /// <summary>
    /// Returns the HTML for the Section.
    /// </summary>
    /// <returns>HTMLElement</returns>
    public override HTMLElement Display()
    {
      try
      {
        return base.Display();
      }
      catch (Exception e)
      {
        log.Error(m_asOwner.GetString(775, "ptmsgs_portalbrowsingmsgs"));
        throw new XPException(m_asOwner.GetString(775, "ptmsgs_portalbrowsingmsgs"),
         e);
      }
    }
    
    /// <summary>
    /// This method returns the HTMLScript that encompasses the Javascript on the page.
    /// </summary>
    /// <returns>HTMLScript</returns>
    public override HTMLScript DisplayJavascript()
    {
      base.SetRepostAction(RepostControl.POSTTOSELF_ACTION_SIMPLEREPOST);
      return base.DisplayJavascript();
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <param name="model"></param>
    /// <param name="parent"></param>
    public override void Init(IModelRO model, AActivitySpace parent)
    {
      // Semi-hack: This class extends FilterView, which extends ObjEditorView,
      // but this space isn't an object editor, so a call to super.Init() would
      // fail.  Instead, initialize stuff here.
      _model = (IAdvancedSearchModelRO) model;
      m_model = _model;
      _parent = parent;
      // this will be intercepted in FilterView
      base.Init(model, parent);
      // No view title on AS page
      base.SetViewTitle(null);
      base.SetWidth(AdvancedSearchDP.TABLE_WIDTH);
      base.SetAllowSubclauses(false);
      base.SetUseJavascriptStatementButtons(false);
      //super.SetTextSearchAboveButtons();
      //super.SetUseCheckboxLayout();
      //super.SetErrorsNextToTextBoxes(true);
      base.SetTextboxLabel(new HTMLGenericElement(m_asOwner.GetString(777,
       "ptmsgs_portalbrowsingmsgs")));
      //"MATT TEST" + m_asOwner.GetString(778,
      base.SetPropertyLabel(null);
      //"ptmsgs_portalbrowsingmsgs"));
      base.SetAddConditionLabel(m_asOwner.GetString(739, "ptmsgs_portalcommonmsgs"));
      base.SetRemoveConditionLabel(m_asOwner.GetString(780, "ptmsgs_portalbrowsingmsgs"));
      }
    
    /// <summary>
    /// Overrides superclass method
    /// </summary>
    protected override bool GetDoValidation()
    {
      return _model.GetShowPotentialErrors();
    }
  }
}