using System;
using com.plumtree.portalpages.browsing.search.advanced;
using com.plumtree.portaluiinfrastructure.search;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.search.basic
{
  /// <author>MatthewF</author>
  public class BasicSearchButtonView : IView
  {
    public const String STR_MVC_CLASS_NAME = "BasicSearchButton";
    public const String HTMLINPUT_SEARCH_BUTTON = "in_bu_submitsearch";
    public const String HTMLINPUT_RESET_BUTTON = "in_bu_reset";
    protected AActivitySpace m_asOwner = null;
    protected SearchFormFactory _factory = null;
    
    /// <returns></returns>
    public virtual Object Create()
    {
      return new BasicSearchButtonView();
    }
    
    /// <summary>
    /// Returns the HTML for the Section.
    /// </summary>
    /// <returns>HTMLElement</returns>
    public virtual HTMLElement Display()
    {
      HTMLElement result = new HTMLElementCollection();
      ASURL url = AdvancedSearchDP.GetAdvancedSearchURL(m_asOwner);
      result.AddInnerHTMLElement(url.GetURLAsHTMLElement());
      result.AddInnerHTMLString("&nbsp;&nbsp;&nbsp;&nbsp;");
      HTMLInput button = new HTMLInput(HTMLInputTypes.BUTTON, HTMLINPUT_SEARCH_BUTTON,
       "");
      button.SetOnClick(_factory.GetAnchorOnClick());
      button.SetValue(m_asOwner.GetString(774, "ptmsgs_portalbrowsingmsgs"));
      button.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
      result.AddInnerHTMLElement(button);
      result.AddInnerHTMLString("&nbsp;");
      ASURL newAS = new ASURL(m_asOwner);
      newAS.SetLinkCreateNewSpace(BasicSearchAS.STR_MVC_CLASS_NAME, m_asOwner);
      String reset_url = newAS.GetURLAsString();
      // Make a reset button.
      button = new HTMLInput(HTMLInputTypes.BUTTON, HTMLINPUT_RESET_BUTTON,
       "");
      button.SetValue(m_asOwner.GetString(783, "ptmsgs_portalbrowsingmsgs"));
      button.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
      button.SetOnClick("window.location.href=\'" + reset_url + "\';");
      result.AddInnerHTMLElement(button);
      return result;
    }
    
    /// <summary>
    /// This method returns the HTMLScript that encompasses the Javascript on the page.
    /// </summary>
    /// <returns>HTMLScript</returns>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <returns></returns>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <param name="model"></param>
    /// <param name="parent"></param>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asOwner = parent;
    }
    public virtual void SetFactory(SearchFormFactory factory)
    {
      _factory = factory;
    }
  }
}