using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.browsing.search.network
{
  /// <author>JosephSi</author>
  public interface INetworkSearchModel : IModel
  {
    
    /// <summary>
    /// TMP A debugging method which will go away when the code is complete 
    /// </summary>
    void SetAlwaysDoLocalSearch(bool flag);
    
    /// <summary>
    /// reset searched source list to be empty
    /// </summary>
    void ClearSearchedSourceList();
    
    /// <summary>
    /// Call this to initialize a range of search results 
    /// </summary>
    void Prepare(String searchString, IXPList sourceIDs, int pageNum);
    void SetNumberResults(int num);
    int GetNumberResults();
    
    /// <summary>
    /// String entered into the box by the user
    /// </summary>
    void SetPageNum(int pageNum);
    //public void SetSearchString(String searchString); 
    
    /// <summary>
    /// set String indicating whether to present results collated
    /// or in parallel
    /// </summary>
    void SetViewMode(String viewMode);
    
    /// <summary>
    /// save the locations (object ids of fed portals) as a user preference
    /// so that they're automatically checked on the launch page next time
    /// </summary>
    void SaveLocationPreferences(String[] locationObjectIdStrings);
    
    /// <summary>
    /// Set a flag indicating whether we had to truncate the user's
    /// search string to NetworkSearchModel.MAX_SEARCHSTRING_LENGTH
    /// characters
    /// </summary>
    void SetSearchStringTruncated(bool flag);
  }
}