using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.search.network
{
  /// <author>JosephSi</author>
  public interface INetworkSearchModelRO : IModelRO
  {
    
    /// <param name="sourceId"></param>
    /// <returns></returns>
    bool isResultSetValid(int sourceId);
    
    /// <param name="sourceId"></param>
    /// <returns></returns>
    String GetFormattedError(int sourceId);
    
    /// <returns></returns>
    bool AreAllResultSetsValid();
    
    /// <param name="sourceId"></param>
    /// <param name="resultId"></param>
    /// <returns></returns>
    String GetDescriptionForResultFromSource(int sourceId, int resultId);
    
    /// <param name="sourceId"></param>
    /// <returns></returns>
    String GetErrorFromSource(int sourceId);
    
    /// <param name="sourceId"></param>
    /// <returns></returns>
    int GetFirstDisplayedResultFromSource(int sourceId);
    
    /// <returns></returns>
    int GetFirstDisplayedResultOverall();
    
    /// <param name="sourceId"></param>
    /// <param name="resultId"></param>
    /// <returns></returns>
    HTMLImg GetImageForResultFromSource(int sourceId, int resultId);
    
    /// <param name="sourceId"></param>
    /// <returns></returns>
    int GetNumDisplayedResultsFromSource(int sourceId);
    
    /// <returns></returns>
    int GetNumDisplayedResultsOverall();
    
    /// <param name="sourceId"></param>
    /// <returns></returns>
    int GetNumResultsFromSource(int sourceId);
    
    /// <returns></returns>
    int GetNumResultsOverall();
    
    /// <returns></returns>
    int GetNumSources();
    
    /// <returns></returns>
    int GetPageNum();
    
    /// <returns></returns>
    String GetSearchString();
    
    /// <summary>
    /// gets search string without html encoding (we need this
    /// to avoid double-encoding, since some of the HTMLElement
    /// classes do the encoding for you
    /// </summary>
    String GetUnencodedSearchString();
    
    /// <returns></returns>
    IXPList GetSearchedSources();
    
    /// <param name="index"></param>
    /// <returns></returns>
    int GetSourceID(int index);
    
    /// <param name="index"></param>
    /// <returns></returns>
    String GetSourceName(int index);
    
    /// <param name="sourceId"></param>
    /// <param name="resultId"></param>
    /// <returns></returns>
    String GetTitleForResultFromSource(int sourceId, int resultId);
    
    /// <param name="sourceId"></param>
    /// <param name="resultId"></param>
    /// <returns></returns>
    HTMLAnchor GetURLForResultFromSource(int sourceId, int resultId, bool popup);
    
    /// <returns></returns>
    String GetViewMode();
    
    /// <summary>
    /// check to see if the user has any stored preferences regarding
    /// which sources to check. Note: returns null if there are no such
    /// preferences
    /// </summary>
    XPHashtable GetLocationPreferencesForUser();
    
    /// <summary>
    /// A flag indicating whether we had to truncate the user's
    /// search string to NetworkSearchModel.MAX_SEARCHSTRING_LENGTH
    /// characters
    /// </summary>
    bool GetSearchStringTruncated();
    
    /// <summary>
    /// returns true if the fed portal's associated web service
    /// has been disabled
    /// </summary>
    bool IsDisabled(int objectID);
    
    /// <summary>
    /// certain errors lead to the generation of a link to 
    /// a config page where the problem can be fixed, in which
    /// case this returns the link. Otherwise, this method will
    /// return null
    /// </summary>
    HTMLElement GetErrorLinkFromSource(int sourceID);
    void SetNumberResults(int num);
    int GetNumberResults();
  }
}