using System;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.browsing.search.network
{
  /// <author>JosephSi</author>
  public class NetworkSearchAS : PlumtreeAS
  {
    public const String STR_MVC_CLASS_NAME = "NetworkSearch";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new NetworkSearchAS();
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.AActivitySpace#Init()"></seealso>
    public override void Init()
    {
      base.Init();
      //  Turn on automatic tracking of current page (off by default).
      SetTrackCurrentPage(true);
      RegisterPage(new NetworkSearchLaunchDP());
      RegisterPage(new NetworkSearchLaunchDP_D());
      RegisterPage(new NetworkSearchResultsDP());
      RegisterPage(new NetworkSearchResultsDP_D());
      RegisterModel(NetworkSearchModel.STR_MVC_CLASS_NAME);
      IModel myModel = GetModel(NetworkSearchModel.STR_MVC_CLASS_NAME);
      RegisterControl(NetworkSearchControl.STR_MVC_CLASS_NAME, myModel);
      RegisterView(NetworkSearchLaunchView.STR_MVC_CLASS_NAME, myModel);
      RegisterView(NetworkSearchLaunchView_D.STR_MVC_CLASS_NAME, myModel);
      RegisterView(NetworkSearchResultsView.STR_MVC_CLASS_NAME, myModel);
      RegisterView(NetworkSearchResultsView_D.STR_MVC_CLASS_NAME, myModel);
      this.SetHelpTopic("PT_FederatedSearch");
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage()"></seealso>
    /// <param name="IDisplayPage">the current Display Page</param>
    public override void SetCurrentPage(IDisplayPage page)
    {
      base.SetCurrentPage(page);
      String sPageName = page.GetName();
      if ((NetworkSearchResultsDP.STR_MVC_CLASS_NAME.Equals(sPageName)) || (NetworkSearchResultsDP_D.STR_MVC_CLASS_NAME.Equals(sPageName)))
      {
        this.SetHelpTopic("PT_FederatedSearchResults");
      } else
      {
        this.SetHelpTopic("PT_FederatedSearch");
      }
    }
  }
}