using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.search.network
{
  /// <author>
  /// JosephSi
  /// Displays the page where network searches can be set up and run.
  /// Shows a checkbox of possible sources to be searches on the left,
  /// and a text input box to enter the search on the right
  /// </author>
  public class NetworkSearchLaunchView_D : IView
  {
    public const String STR_MVC_CLASS_NAME = "NetworkSearchLaunch_D";
    private AActivitySpace m_asOwner;
    private INetworkSearchModelRO m_asmModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new NetworkSearchLaunchView_D();
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IView#Display()"></seealso>
    public virtual HTMLElement Display()
    {
      try
      {
        // the whole page is one big form
        HTMLForm form1 = new HTMLForm("networksearch");
        form1.SetMethod("get");
        form1.SetAction(ConfigHelper.GetApplicationBaseURLToAS(m_asOwner.GetCurrentNormalizedBaseURL(),
         m_asOwner.GetName(), m_asOwner.IsSubSpace()));
        form1.SetID("networksearch");
        form1.SetName("networksearch");
        // set the space and control 
        HTMLInput input = new HTMLInput(HTMLInputTypes.HIDDEN, "in_hi_space",
         "in_hi_space_id");
        input.SetValue(NetworkSearchAS.STR_MVC_CLASS_NAME);
        form1.AddInnerHTMLElement(input);
        input = new HTMLInput(HTMLInputTypes.HIDDEN, "in_hi_control", "in_hi_control_id");
        input.SetValue(NetworkSearchControl.STR_MVC_CLASS_NAME);
        form1.AddInnerHTMLElement(input);
        // just a simple input to make clear to the control
        // that this is a request for results
        input = new HTMLInput(HTMLInputTypes.HIDDEN, NetworkSearchControl.RESULTS_DATA,
         NetworkSearchControl.RESULTS_DATA);
        input.SetValue(XPConvert.ToString(true));
        form1.AddInnerHTMLElement(input);
        HTMLTable overallTable = new HTMLTable();
        overallTable.SetWidth("100%");
        overallTable.SetCellSpacing("0");
        overallTable.SetCellPadding("2");
        overallTable.SetBorder("0");
        form1.AddInnerHTMLElement(overallTable);
        HTMLTableRow topTableRow = new HTMLTableRow();
        HTMLTable topTable = new HTMLTable();
        topTable.SetWidth("100%");
        HTMLTableCell cell = new HTMLTableCell();
        cell.SetWidth("100%");
        cell.AddInnerHTMLElement(topTable);
        topTableRow.AddInnerHTMLElement(cell);
        overallTable.AddInnerHTMLElement(topTableRow);
        // row of instructions and search button
        HTMLTableRow row = new HTMLTableRow();
        row.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BG);
        topTable.AddInnerHTMLElement(row);
        cell = new HTMLTableCell();
        cell.SetStyleClass(PTStyleClass.LIST_TEXT);
        row.AddInnerHTMLElement(cell);
        cell.SetColSpan("3");
        cell.AddInnerHTMLString(m_asOwner.GetString(790, "ptmsgs_portalbrowsingmsgs"));
        cell = new HTMLTableCell();
        row.AddInnerHTMLElement(cell);
        cell.SetAlign("right");
        HTMLTableRow criteriaTableRow = new HTMLTableRow();
        HTMLTable criteriaTable = new HTMLTable();
        criteriaTable.SetWidth("100%");
        cell = new HTMLTableCell();
        cell.SetWidth("100%");
        cell.AddInnerHTMLElement(criteriaTable);
        criteriaTableRow.AddInnerHTMLElement(cell);
        overallTable.AddInnerHTMLElement(criteriaTableRow);
        HTMLTableRow headerRow = new HTMLTableRow();
        criteriaTable.AddInnerHTMLElement(headerRow);
        headerRow.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BG);
        cell = new HTMLTableCell();
        cell.SetStyleClass(PTStyleClass.LIST_TEXT);
        cell.SetWidth("100%");
        cell.SetColSpan("2");
        headerRow.AddInnerHTMLElement(cell);
        HTMLB bold = new HTMLB();
        cell.AddInnerHTMLElement(bold);
        bold.AddInnerHTMLString(m_asOwner.GetString(1360, "ptmsgs_portalbrowsingmsgs"));
        cell.SetHeight("30");
        HTMLTableRow searchBoxRow = new HTMLTableRow();
        searchBoxRow.SetStyleClass(PTStyleClass.LIST_ITEM_ONE_BG);
        criteriaTable.AddInnerHTMLElement(searchBoxRow);
        cell = new HTMLTableCell();
        cell.SetStyleClass(PTStyleClass.LIST_TEXT);
        cell.SetWidth("100%");
        cell.AddInnerHTMLString(m_asOwner.GetString(1361, "ptmsgs_portalbrowsingmsgs"));
        cell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        cell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        searchBoxRow.AddInnerHTMLElement(cell);
        input = new HTMLInput(HTMLInputTypes.TEXT, NetworkSearchControl.SEARCHSTRING_DATA,
         "myID");
        input.SetSize(50);
        // "Search for text:"
        input.SetAlt(m_asOwner.GetString(1361, "ptmsgs_portalbrowsingmsgs"));
        // "Search for text:"
        input.SetTitle(m_asOwner.GetString(1361, "ptmsgs_portalbrowsingmsgs"));
        cell.AddInnerHTMLElement(input);
        cell = new HTMLTableCell();
        cell.SetStyleClass(PTStyleClass.LIST_TEXT);
        cell.SetAlign("right");
        searchBoxRow.AddInnerHTMLElement(cell);
        HTMLInput searchButton = new HTMLInput(HTMLInputTypes.SUBMIT, "in_su_b1",
         "in_su_b1");
        cell.AddInnerHTMLElement(searchButton);
        searchButton.SetValue(m_asOwner.GetString(788, "ptmsgs_portalbrowsingmsgs"));
        searchButton.SetAlt(m_asOwner.GetString(43, "ptmsgs_portal508quickkeymsgs"));
        searchButton.SetAccessKey(m_asOwner.GetString(45, "ptmsgs_portal508quickkeymsgs"));
        searchButton.SetTitle(m_asOwner.GetString(788, "ptmsgs_portalbrowsingmsgs"));
        searchButton.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
        HTMLTable choicesTable = new HTMLTable();
        form1.AddInnerHTMLElement(choicesTable);
        choicesTable.SetWidth("100%");
        choicesTable.SetCellSpacing("0");
        choicesTable.SetCellPadding("2");
        choicesTable.SetBorder("0");
        // title row ( "Search Locations" )
        row = new HTMLTableRow();
        row.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BG);
        choicesTable.AddInnerHTMLElement(row);
        cell = new HTMLTableCell();
        cell.SetHeight("30");
        row.AddInnerHTMLElement(cell);
        cell.SetStyleClass(PTStyleClass.LIST_TEXT);
        HTMLB b = new HTMLB();
        cell.AddInnerHTMLElement(b);
        b.AddInnerHTMLString(m_asOwner.GetString(793, "ptmsgs_portalbrowsingmsgs"));
        // add checkbox option for the portal itself
        row = new HTMLTableRow();
        choicesTable.AddInnerHTMLElement(row);
        row.SetStyleClass(PTStyleClass.LIST_ITEM_TWO_BG);
        cell = new HTMLTableCell();
        cell.SetStyleClass(PTStyleClass.LIST_TEXT);
        row.AddInnerHTMLElement(cell);
        // see if the user has stored any preferences for
        // which locations to search. If so, we'll 
        // automatically check those boxes
        XPHashtable preferredSourceHash = m_asmModel.GetLocationPreferencesForUser();
        bool prefsExist = (preferredSourceHash != null);
        HTMLInput checkedInput = new HTMLInput(HTMLInputTypes.CHECKBOX, NetworkSearchControl.SOURCE_DATA,
         "idneg1");
        checkedInput.SetValue(XPConvert.ToString(NetworkSearchModel.THISPORTAL_ID));
        checkedInput.SetTitle(m_asOwner.GetString(794, "ptmsgs_portalbrowsingmsgs"));
        checkedInput.SetAlt(m_asOwner.GetString(794, "ptmsgs_portalbrowsingmsgs"));
        if (prefsExist && preferredSourceHash.ContainsKey(NetworkSearchModel.THISPORTAL_ID))
        {
          checkedInput.SetChecked(true);
        }
        cell.AddInnerHTMLElement(checkedInput);
        cell.AddInnerHTMLString(m_asOwner.GetString(794, "ptmsgs_portalbrowsingmsgs"));
        // list all the sources that the user can search-
        // user picks sources via checkboxes
        for (int sourceIndex = 0;sourceIndex < m_asmModel.GetNumSources();
        sourceIndex++)
        {
          row = new HTMLTableRow();
          if (sourceIndex % 2 == 0)
          {
            row.SetStyleClass(PTStyleClass.LIST_ITEM_TWO_BG);
          } else
          {
            row.SetStyleClass(PTStyleClass.LIST_ITEM_ONE_BG);
          }
          choicesTable.AddInnerHTMLElement(row);
          cell = new HTMLTableCell();
          cell.SetStyleClass(PTStyleClass.LIST_TEXT);
          row.AddInnerHTMLElement(cell);
          checkedInput = new HTMLInput(HTMLInputTypes.CHECKBOX, NetworkSearchControl.SOURCE_DATA,
           "id" + sourceIndex);
          int sourceId = m_asmModel.GetSourceID(sourceIndex);
          if (prefsExist && preferredSourceHash.ContainsKey(sourceId))
          {
            checkedInput.SetChecked(true);
          }
          checkedInput.SetValue(XPConvert.ToString(sourceId));
          checkedInput.SetTitle(m_asmModel.GetSourceName(sourceId));
          checkedInput.SetAlt(m_asmModel.GetSourceName(sourceId));
          cell.AddInnerHTMLElement(checkedInput);
          cell.AddInnerHTMLString(m_asmModel.GetSourceName(sourceId));
        }
        // empty row to separate "save locations" checkbox
        // from other checkboxes
        row = new HTMLTableRow();
        choicesTable.AddInnerHTMLElement(row);
        cell = new HTMLTableCell();
        cell.AddInnerHTMLElement(new HTMLBr());
        row.AddInnerHTMLElement(cell);
        // "save locations" checkbox
        row = new HTMLTableRow();
        row.SetStyleClass(PTStyleClass.LIST_ITEM_TWO_BG);
        choicesTable.AddInnerHTMLElement(row);
        cell = new HTMLTableCell();
        cell.SetStyleClass(PTStyleClass.LIST_TEXT);
        cell.AddInnerHTMLString(m_asOwner.GetString(1359, "ptmsgs_portalbrowsingmsgs"));
        row.AddInnerHTMLElement(cell);
        checkedInput = new HTMLInput(HTMLInputTypes.CHECKBOX, NetworkSearchControl.SAVELOCATIONS_DATA,
         "idsaveLocations");
        checkedInput.SetTitle(m_asOwner.GetString(1359, "ptmsgs_portalbrowsingmsgs"));
        checkedInput.SetAlt(m_asOwner.GetString(1359, "ptmsgs_portalbrowsingmsgs"));
        checkedInput.SetValue(XPConvert.ToString(true));
        cell.AddInnerHTMLElement(checkedInput);
        return form1;
      }
      catch (Exception e)
      {
        return new HTMLGenericElement(e.Message);
      }
    }
    
    /// <summary>
    /// This method returns the HTMLScript that encompasses the Javascript on the page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    /// <returns>HTMLScript</returns>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IView#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asmModel = (INetworkSearchModelRO) model;
      m_asOwner = parent;
    }
  }
}