using System;
using com.plumtree.portaluiinfrastructure.search;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.search.results
{
  /// <author>
  /// CraigS
  /// This is a simplified alternative to OrganizationView.  It doesn't make much
  /// sense to have them on the same page.  We use OrganizationView on the standard
  /// page and DrilldownView on the 508/low-bandwidth page.
  /// </author>
  public class DrilldownView : SearchResultView
  {
    public const String STR_MVC_CLASS_NAME = "DrilldownView";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new DrilldownView();
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IView#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.search.SearchResultView#DisplaySearchView()"></seealso>
    public override HTMLElement DisplaySearchView()
    {
      return ReorganizationViewHelper.DisplaySimpleDrilldownView(_model, m_asOwner);
      }
  }
}