using System;
using com.plumtree.portaluiinfrastructure.search;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.search.results
{
  /// <author>CraigS</author>
  public class OrganizationView : SearchResultView
  {
    public const String STR_MVC_CLASS_NAME = "OrganizationView";
    public const String REORGANIZATION_FORM_NAME = "ReorganizeResults";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new OrganizationView();
    }
    
    /// <seealso cref="com.plumtree.portalpages.search.SearchResultView#DisplaySearchView()"></seealso>
    public override HTMLElement DisplaySearchView()
    {
      return ReorganizationViewHelper.DisplayReorganization(_model, m_asOwner);
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IView#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    public virtual void addTargetsToOrganizationForm(HTMLForm form)
    {
      addTargetsToOrganizationForm(form, true);
    }
    public virtual void addTargetsToOrganizationForm(HTMLForm form, bool addScript)
    {
      form.SetAction(ConfigHelper.GetApplicationBaseURLToAS(m_asOwner.GetCurrentNormalizedBaseURL(),
       m_asOwner.GetName(), m_asOwner.IsSubSpace()));
      // Set target as the same space
      HTMLInput targetSpace = new HTMLInput(HTMLInputTypes.HIDDEN, ASConstants.SPACENAME_INPUT,
       ASConstants.SPACENAME_INPUT, "");
      targetSpace.SetValue(m_asOwner.GetName());
      form.AddInnerHTMLElement(targetSpace);
      // Add our current space ID, so the framework doesn't create
      // another instance of the space
      HTMLInput targetSpID = new HTMLInput(HTMLInputTypes.HIDDEN, ASConstants.SPACEID_INPUT,
       ASConstants.SPACEID_INPUT, "");
      targetSpID.SetValue(m_asOwner.GetSpaceID());
      form.AddInnerHTMLElement(targetSpID);
      // Set target as ReorganizationControl
      HTMLInput targetControl = new HTMLInput(HTMLInputTypes.HIDDEN, ASConstants.CONTROL_INPUT,
       ASConstants.CONTROL_INPUT, "");
      targetControl.SetValue(ReorganizationControl.STR_MVC_CLASS_NAME);
      form.AddInnerHTMLElement(targetControl);
      // Add a hidden input for the current search depth
      HTMLInput depth = new HTMLInput(HTMLInputTypes.HIDDEN, SearchResultControl.KEY_DATA,
       SearchResultControl.KEY_DATA, "");
      depth.SetValue(_model.GetCurrentKey());
      form.AddInnerHTMLElement(depth);
      if (!is508() && addScript)
      {
        HTMLScript script = GetOrganizationFormScripts(form.GetName());
        form.AddInnerHTMLElement(script);
      }
    }
    public virtual HTMLScript GetOrganizationFormScripts(String formName)
    {
      HTMLScript script = new HTMLScript("text/javaScript");
      script.AddInnerHTMLString("function " + ReorganizationViewHelper.JAVASCRIPT_RESORT + "() { var searchForm = document." + formName + ";\n" + "searchForm.submit(); }");
      return script;
    }
  }
}