using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.search.results
{
  /// <author>CraigS</author>
  public class SaveSearchPopupDP : AFormDP
  {
    public const String STR_MVC_CLASS_NAME = "SaveSearchDP";
    
    /// <summary>
    /// NOTE: Display the whole page outside the mainform, since SaveSearchView
    /// defines a form of its own.  (I don't want to force it to use a repost
    /// control; it would be awkward to try to meld reposts with the search controls.
    /// </summary>
    public override HTMLElementCollection DisplayHTMLBeforeForm()
    {
      HTMLElementCollection c = new HTMLElementCollection();
      c.AddInnerHTMLElement(m_asOwner.GetView(SaveSearchView.STR_MVC_CLASS_NAME).Display());
      return c;
    }
    public override String GetFormTitle()
    {
      return m_asOwner.GetString(835, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <param name="parent"></param>
    public override void Init(AActivitySpace parent)
    {
      base.Init(parent);
    }
    
    /// <returns></returns>
    /// <throws>HTMLException </throws>
    public override HTMLElement PageDisplay()
    {
      // Just return something to keep the framework happy.
      return new HTMLBr();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#GetFormPageType()"></seealso>
    public override FormPageTypes GetFormPageType()
    {
      return FormPageTypes.NO_BUTTONS;
    }
  }
}