using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.search;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.browsing.search.results
{
  /// <author>
  /// MatthewF
  /// Control for switching between Edit and Browse modes.
  /// </author>
  public class SearchBrowseEditModeControl : IControl
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.search.results.SearchBrowseEditModeControl");
    public const String STR_MVC_CLASS_NAME = "BrowseEditMode";
    public const String EDIT_MODE_INPUT = "in_hi_browse_edit";
    public const String EDIT_VALUE = "edit";
    public const String BROWSE_VALUE = "browse";
    protected AActivitySpace _parent;
    protected ISearchResultModel _model;
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IControl#Execute()"></seealso>
    public virtual Redirect CheckActionSecurityAndExecute(XPHashtable args)
    {
      Redirect r = null;
      // Figure out where we were (i.e. the value of the key)
      // when the model was generated
      String[] values = (String[]) args.GetElement(EDIT_MODE_INPUT);
      String modekey;
      if (values != null)
      {
        modekey = values[0];
        if (EDIT_VALUE.Equals(modekey))
        {
          _model.SetPageMode(SearchPageModeHelper.EDIT_MODE);
        } else
        {
          _model.SetPageMode(SearchPageModeHelper.BROWSE_MODE);
        }
      }
      return r;
    }
    
    /// <summary>
    /// This method is used by the ASManager to return new instances of managed
    /// objects.
    /// </summary>
    /// <returns>A new instance of the managed class (i.e. return new Foo();)</returns>
    public virtual Object Create()
    {
      return new SearchBrowseEditModeControl();
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IControl#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IControl#Init(IModel,AActivitySpace)"></seealso>
    public virtual void Init(IModel model, AActivitySpace space)
    {
      _model = (ISearchResultModel) model;
      _parent = space;
    }
  }
}