using System;
using com.plumtree.portaluiinfrastructure.search;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.search.results
{
  /// <author>CraigS</author>
  public class SearchFooterView : SearchResultView
  {
    public const String STR_MVC_CLASS_NAME = "SearchFooterView";
    
    /// <returns></returns>
    public override Object Create()
    {
      return new SearchFooterView();
    }
    
    /// <seealso cref="com.plumtree.portalpages.search.SearchResultView#DisplaySearchView()"></seealso>
    public override HTMLElement DisplaySearchView()
    {
      // If few results were returned, don't display anything.
      if (_model.GetTotalItems() <= _model.GetItemsPerPage())
      {
        return null;
      }
      // For the standard portal:
      // Only display global pagination if there is a single group;
      // it's confusing to see both drilldown links and pagination
      // For 508: always show pagination, since the results are never shown
      // in grouping style.
      if ((!is508()) && (_model.GetNumResultGroups() > 1))
      {
        return null;
      }
      HTMLTable table = new HTMLTable();
      table.SetCellSpacing("0");
      table.SetCellPadding("3");
      table.SetWidth("100%");
      HTMLTableRow row = new HTMLTableRow();
      table.AddInnerHTMLElement(row);
      HTMLTableCell cell = new HTMLTableCell();
      row.AddInnerHTMLElement(cell);
      if (is508())
      {
        row.SetStyleClass(PTStyleClass.LIST_ITEM_TWO_BG);
        cell.SetAlign("left");
        cell.SetStyleClass(PTStyleClass.LIST_TEXT);
        cell.AddInnerHTMLElement(PaginationView.Display508StylePagination(_model,
         m_asOwner));
      } else
      {
        row.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
        cell.SetHeight("25");
        cell.SetVAlign("middle");
        cell.SetAlign("right");
        cell.SetStyleClass(PTStyleClass.OBJECTSEARCH_TEXT);
        cell.AddInnerHTMLElement(PaginationView.DisplayPagination(_model,
         m_asOwner));
      }
      return table;
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}