using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.portalpages.common.uiparts;
namespace com.plumtree.portalpages.browsing.search.results.assocobjects
{
  /// <summary>
  /// A small space containing just a popup that shows the set of objects associated
  /// with a particular Content Server item.  (Actually has very little to do with Content..
  /// just feed it an unsecured list of portlet IDs.)
  /// </summary>
  /// <author>CraigS</author>
  public class AssociatedObjectsAS : PlumtreeAS
  {
    public const String STR_MVC_CLASS_NAME = "SRAssociatedObjects";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new AssociatedObjectsAS();
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.AActivitySpace#Init()"></seealso>
    public override void Init()
    {
      base.Init();
      RegisterPage(new AssociatedObjectsPopupDP());
      RegisterModel(AssociatedObjectsModel.STR_MVC_CLASS_NAME);
      IModel model = GetModel(AssociatedObjectsModel.STR_MVC_CLASS_NAME);
      RegisterControl(AssociatedObjectsControl.STR_MVC_CLASS_NAME, model);
      RegisterView(AssociatedObjectsView.STR_MVC_CLASS_NAME, model);
    }
  }
}