using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.browsing.search.results.assocobjects
{
  /// <author>CraigS</author>
  public class AssociatedObjectsControl : IControl
  {
    public const String STR_MVC_CLASS_NAME = "SRAssociatedObjects";
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    public virtual Object Create()
    {
      return new AssociatedObjectsControl();
    }
    private AssociatedObjectsModel _model = null;
    private AActivitySpace m_asOwner = null;
    public virtual void Init(IModel model, AActivitySpace owner)
    {
      _model = (AssociatedObjectsModel) model;
      m_asOwner = owner;
    }
    public const String PORTLET_LIST_ARGNAME = "portletId";
    public const String ITEM_NAME_ARGNAME = "itemName";
    public virtual Redirect CheckActionSecurityAndExecute(XPHashtable args)
    {
      // Extract the list of associated portlets
      String[] values = (String[]) args.GetElement(PORTLET_LIST_ARGNAME);
      if ((null != values) && (values.Length > 0))
      {
        int[] portlets = new int[values.Length];
        for (int j = 0;j < values.Length;j++)
        {
          try
          {
            portlets[j] = XPConvert.ToInteger(values[j]);
          }
          catch (Exception e)
          {
            portlets[j] = 0;
          }
        }
        _model.SetPortletList(portlets);
      }
      // .. and the item name
      values = (String[]) args.GetElement(ITEM_NAME_ARGNAME);
      if ((null != values) && (values.Length > 0))
      {
        _model.SetItemName(values[0]);
      }
      // .. and display the page
      return null;
    }
  }
}