using System;
using com.plumtree.openfoundation.util;
using OpenLogService=com.plumtree.openlog.OpenLogService;
using OpenLogger=com.plumtree.openlog.OpenLogger;
using PTDebugHelpers=com.plumtree.portaluiinfrastructure.statichelpers.PTDebugHelpers;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.browsing.sessionprefs
{
  /// <author>$author$</author>
  public class SessionPrefsControl : IControl
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.sessionprefs.SessionPrefsControl");
    public const String STR_MVC_CLASS_NAME = "SessionPrefs";
    private const String strAction = "action";
    private const String strSetPrefs = "setprefs";
    private const String strGetPrefs = "getprefs";
    private const String strTrue = "true";
    private AActivitySpace m_asasParent;
    private ISessionPrefsModel m_asmModel;
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IControl#Execute()"></seealso>
    public virtual Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      String[] arrAction = (String[]) arguments.GetElement(strAction);
      if (null != arrAction && arrAction.Length == 1 && arrAction[0] != null)
      {
        if (XPStringUtility.CompareIgnoreCase(arrAction[0], strSetPrefs) == 0)
        {
          m_asmModel.SetSessionPrefs(arguments);
        } else
        if (XPStringUtility.CompareIgnoreCase(arrAction[0], strGetPrefs) == 0)
        {
          m_asmModel.GetSessionPrefs(arguments);
        }
      }
      return null;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new SessionPrefsControl();
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IControl#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IControl#Init(IModel,AActivitySpace)"></seealso>
    public virtual void Init(IModel model, AActivitySpace space)
    {
      m_asmModel = (ISessionPrefsModel) model;
      m_asasParent = space;
    }
  }
}