using System;
using XPEncoding=com.plumtree.openfoundation.util.XPEncoding;
using AActivitySpace=com.plumtree.uiinfrastructure.activityspace.AActivitySpace;
using IDisplayPage=com.plumtree.uiinfrastructure.activityspace.IDisplayPage;
using IWebData=com.plumtree.uiinfrastructure.activityspace.IWebData;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.sessionprefs
{
  /// <author>$author$</author>
  public class SessionPrefsDP : IDisplayPage
  {
    public const String STR_MVC_CLASS_NAME = "SessionPrefs";
    private AActivitySpace m_asOwner = null;
    private const String strContentTypeHeaderName = "Content-Type";
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    /// <throws>HTMLException </throws>
    public virtual HTMLElement PageDisplay()
    {
      return null;
    }
    
    /// <returns></returns>
    public virtual AActivitySpace GetOwner()
    {
      return m_asOwner;
    }
    
    /// <param name="parent"></param>
    public virtual void Init(AActivitySpace parent)
    {
      m_asOwner = parent;
    }
    
    /// <param name="webData"></param>
    public virtual void Display(IWebData webData)
    {
      ISessionPrefsModelRO spModel = (ISessionPrefsModelRO) m_asOwner.GetModel(SessionPrefsModel.STR_MVC_CLASS_NAME);
      String strDisplayData = spModel.GetDisplayString();
      String strContentType = spModel.GetContentType();
      webData.SetHeader(strContentTypeHeaderName, strContentType);
      webData.SetData(XPEncoding.GetBytes(strDisplayData, "UTF-8"));
    }
  }
}