using System;
namespace com.plumtree.portalpages.browsing.settings
{
  /// <version>5.0</version>
  /// <author>SudhaSathiaseelan</author>
  public interface ISettings
  {
    
    /// <summary>
    /// The name of the control to use 
    /// </summary>
    String GetASControlName();
    
    /// <summary>
    /// The name of the display page to view (null means default) 
    /// </summary>
    String GetASDPName();
    
    /// <summary>
    /// The name of the activity space to go to 
    /// </summary>
    String GetASName();
    
    /// <summary>
    /// the rest of the query string for the URL (starting with &...) 
    /// </summary>
    String GetASQueryString();
    
    /// <summary>
    /// Use public static Object GetPersonalSettingValue(String sSettingName, ISessionManager sessionManager, IPTSession ptSession) to get the language ID "en" *
    /// </summary>
    String GetLinkText(String _strLangID);
    
    /// <summary>
    /// Describes whether the setting comes with the standard portal 
    /// </summary>
    bool IsStandardPortalOption();
    
    /// <summary>
    /// Describes whether the setting is currently viewable 
    /// </summary>
    bool IsViewable();
  }
}
//Returns the HTMLElement
//public HTMLElement GetHTMLElement();
