using System;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.uiinfrastructure.form;
namespace com.plumtree.portalpages.browsing.sitemap.editweblink
{
  /// <summary>
  /// File: EditWebLinkAS.java
  /// ------------------------
  /// </summary>
  /// <author>NaveenP</author>
  public class EditWebLinkAS : PlumtreeAS
  {
    public const String STR_MVC_CLASS_NAME = "EditWebLink";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new EditWebLinkAS();
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IActivitySpace#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.IRepostAS#GetRepostControlName()"></seealso>
    public override String GetRepostControlName()
    {
      return RepostControl.STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IActivitySpace#Init()"></seealso>
    public override void Init()
    {
      base.Init();
      EditWebLinkDP editweblinkDP = new EditWebLinkDP();
      //		editweblinkDP.SetShowFormHeader(true);
      editweblinkDP.AddToValidationFunction(EditWebLinkView.VALIDATION_FUNCTION_NAME);
      RegisterPage(editweblinkDP);
      RegisterPage(new ClosePopUpDP());
      RegisterModel(EditWebLinkModel.STR_MVC_CLASS_NAME);
      EditWebLinkModel myModel = (EditWebLinkModel) GetModel(EditWebLinkModel.STR_MVC_CLASS_NAME);
      RegisterView(EditWebLinkView.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(RepostControl.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(SetLinkControl.STR_MVC_CLASS_NAME, myModel);
    }
  }
}