using System;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.sitemap.editweblink
{
  /// <summary>
  /// File: EditWebLinkDP.java
  /// ------------------------
  /// </summary>
  /// <author>NaveenP</author>
  public class EditWebLinkDP : AFormDP
  {
    public const String STR_MVC_CLASS_NAME = "EditWebLink";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#GetFormPageType()"></seealso>
    public override FormPageTypes GetFormPageType()
    {
      // default implementation
      return FormPageTypes.NORMAL_PAGE;
    }
    
    /// <summary>
    /// This is a helper method that all classes that inherit from AFormDP and
    /// want to have the Done and Cancel buttons displayed in the header for
    /// them need to implement.  The method should return the title add whatever
    /// HTML the child class wants to display to the body argument.  The parent
    /// class will then add that HTML to the HTMLPage after filling in the
    /// banner and navigation.
    /// Override this method to set the form title
    /// </summary>
    /// <returns>String the title for the form header (if used)</returns>
    public override String GetFormTitle()
    {
      return m_asOwner.GetString(876, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// helper display method for PlumtreeDP
    /// Fill in the body argument with HTML to display in the page.
    /// </summary>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      result.AddInnerHTMLElement(m_asOwner.GetView(EditWebLinkView.STR_MVC_CLASS_NAME).Display());
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#DisplayJavaScriptFromChild()"></seealso>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection scripts = new HTMLScriptCollection();
      scripts.AddInnerHTMLElement(m_asOwner.GetView(EditWebLinkView.STR_MVC_CLASS_NAME).DisplayJavascript());
      return scripts;
    }
  }
}