using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.sitemap.editweblink
{
  /// <summary>
  /// File: EditWebLinkView.java
  /// --------------------------
  /// </summary>
  /// <author>NaveenP</author>
  public class EditWebLinkView : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.sitemap.editweblink.EditWebLinkView");
    public const String STR_MVC_CLASS_NAME = "EditWebLink";
    // Logger
    // HTML Object names.
    public const String HTMLINPUT_LINKNAME = "in_tx_LinkName";
    public const String HTMLINPUT_LINKDESC = "in_tx_LinkDesc";
    public const String HTMLINPUT_LINKURL = "in_tx_LinkURL";
    public const String HTMLBUTTON_REPOST = "in_bu_add";
    public const String VALIDATION_FUNCTION_NAME = "IsValidWebLink";
    protected AActivitySpace m_asOwner;
    // Client-specific variables
    protected EditWebLinkModel m_asModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new EditWebLinkView();
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#display()"></seealso>
    public virtual HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable myTable = null;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLInput myInput;
      HTMLSpan mySpan;
      HTMLB myBold;
      try
      {
        HTMLComment myComment = new HTMLComment("Begin: Display EditWebLinkView");
        result.AddInnerHTMLElement(myComment);
        myTable = new HTMLTable();
        result.AddInnerHTMLElement(myTable);
        myTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        myTable.SetBorder(CommonHTMLStrings.ZERO);
        myTable.SetCellPadding("5");
        myTable.SetCellSpacing(CommonHTMLStrings.ZERO);
        // 1st Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        //myRow.SetStyleClass(PTStyleClass.OBJECT_ACTIONBAR_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myBold = new HTMLB();
        myBold.AddInnerHTMLString(m_asOwner.GetString(878, "ptmsgs_portalbrowsingmsgs"));
        mySpan.AddInnerHTMLElement(myBold);
        // 2nd Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_LINKNAME, "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
        myInput.SetValue(m_asModel.GetOriginalName());
        myInput.SetMaxLength(63);
        myInput.SetSize(35);
        // 1st Row end
        // Desc Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myBold = new HTMLB();
        myBold.AddInnerHTMLString(m_asOwner.GetString(879, "ptmsgs_portalbrowsingmsgs"));
        mySpan.AddInnerHTMLElement(myBold);
        // 2nd Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_LINKDESC, "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
        myInput.SetValue(m_asModel.GetOriginalDescription());
        myInput.SetMaxLength(255);
        myInput.SetSize(35);
        // Desc Row end
        // 3rd Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myBold = new HTMLB();
        myBold.AddInnerHTMLString(m_asOwner.GetString(880, "ptmsgs_portalbrowsingmsgs"));
        mySpan.AddInnerHTMLElement(myBold);
        // 4th Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_LINKURL, "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
        myInput.SetValue(m_asModel.GetOriginalURL());
        myInput.SetMaxLength(255);
        myInput.SetSize(50);
        // ***<input text>*** ends here
        // 2nd Row end
        myComment = new HTMLComment("End: Display EditWebLinkView");
        result.AddInnerHTMLElement(myComment);
      }
      catch (Exception e)
      {
        log.Error(e, e.Message);
      }
      return result;
    }
    
    /// <summary>
    /// This method returns the HTMLScript that encompasses the Javascript on the page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    /// <returns>HTMLScript</returns>
    public virtual HTMLScript DisplayJavascript()
    {
      HTMLScript script = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
      XPStringBuilder sb = new XPStringBuilder(300);
      String strJSUtilVersionPrefix = ConfigHelper.GetJSIncluderVersionPrefix(ConfigHelper.JSCOMPONENT_JSUTIL);
      try
      {
        sb.Append("\n" + "function " + VALIDATION_FUNCTION_NAME + "()\n");
        sb.Append("{\n");
        sb.Append(" \tif ( " + strJSUtilVersionPrefix + "PTStringUtil.isAllWhitespace(document." + EditWebLinkDP.HTMLFORM_NAME + ".in_tx_LinkName.value) )\n");
        sb.Append("\t\t{\n");
        sb.Append(" \t\talert(\'" + m_asOwner.GetString(885, "ptmsgs_portalbrowsingmsgs") + "\');\n");
        sb.Append(" \t\treturn false;\n");
        sb.Append("\t\t}\n");
        //sb.Append(" 	if ( PTStringUtil.isAllWhitespace(document." +
        //	EditWebLinkDP.HTMLFORM_NAME + ".in_tx_LinkDesc.value) )\n");
        //sb.Append("		{\n");
        //sb.Append(" 		alert('" +
        //	m_asOwner.GetString(886, "ptmsgs_portalbrowsingmsgs") +
        //	"');\n");
        //sb.Append(" 		return false;\n");
        //sb.Append("		}\n");
        sb.Append(" \tif ( !" + strJSUtilVersionPrefix + "PTStringUtil.isValidHTTPString(document." + EditWebLinkDP.HTMLFORM_NAME + ".in_tx_LinkURL.value) )\n");
        sb.Append("\t\t{\n");
        sb.Append(" \t\talert(\'" + m_asOwner.GetString(887, "ptmsgs_portalbrowsingmsgs") + "\');\n");
        sb.Append(" \t\treturn false;\n");
        sb.Append("\t\t}\n");
        sb.Append(" \treturn true;\n");
        sb.Append("}\n\n");
        script.AddInnerHTMLString(sb.ToString());
      }
      catch (HTMLException he)
      {
        log.Error(he, he.Message);
      }
      return script;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#Init(IModel,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asModel = (EditWebLinkModel) model;
      m_asOwner = parent;
    }
  }
}