using System;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.sitemap.sitemappage
{
  /// <summary>
  /// File: DisplayInPortletDP.java
  /// --------------------------------
  /// </summary>
  /// <author>NaveenP</author>
  public class DisplayInPortletDP : AFormDP
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.sitemap.sitemappage.DisplayInPortletDP");
    public const String STR_MVC_CLASS_NAME = "DisplayInPortlet";
    
    /// <summary>
    /// Model 
    /// </summary>
    private SiteMapModel m_asModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#GetFormPageType()"></seealso>
    public override FormPageTypes GetFormPageType()
    {
      return FormPageTypes.NORMAL_PAGE;
    }
    
    /// <returns></returns>
    public override String GetFormTitle()
    {
      return m_asOwner.GetString(929, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      m_asModel = (SiteMapModel) m_asOwner.GetModel(SiteMapModel.STR_MVC_CLASS_NAME);
      HTMLElementCollection result = new HTMLElementCollection();
      try
      {
        result.AddInnerHTMLElement(m_asOwner.GetView(DisplayInPortletView.STR_MVC_CLASS_NAME).Display());
        }
      catch (HTMLException he)
      {
        log.Error(he, "Error in DisplayInPortletDP::Display.");
      }
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#DisplayJavaScriptFromChild()"></seealso>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection scripts = new HTMLScriptCollection();
      scripts.AddInnerHTMLElement(m_asOwner.GetView(DisplayInPortletView.STR_MVC_CLASS_NAME).DisplayJavascript());
      return scripts;
    }
    
    /// <summary>
    /// This method is provided so that the repost control name can be overridden
    /// on a per DP basis.
    /// </summary>
    /// <returns>String the name of the repost control to use</returns>
    protected override String GetRepostControlName()
    {
      return DisplayInPortletControl.STR_MVC_CLASS_NAME;
    }
  }
}