using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.arraywrapper;
using com.plumtree.uiinfrastructure.htmlconstructs;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.sitemap.sitemappage
{
  /// <summary>
  /// File: CreateSiteMapFolderView.java
  /// ----------------------------------
  /// </summary>
  /// <author>NaveenP</author>
  public class DisplayInPortletView : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.sitemap.sitemappage.DisplayInPortletView");
    public const String STR_MVC_CLASS_NAME = "DisplayInPortlet";
    public const String HTMLHIDDEN_SORTINGPAGEINDEX = "in_hi_sortingpageindex";
    public const String HTMLCHECKBOX_SELECTION_PAGE = "in_cb_Page";
    public const String HTMLCHECKBOX_CHECKALL = "in_cb_Checkall";
    protected AActivitySpace m_asOwner;
    // Logger
    // Client-specific variables
    protected ISiteMapModelRO m_asModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new DisplayInPortletView();
    }
    
    /// <returns>HTMLElement</returns>
    /// <throws>XPException </throws>
    public virtual HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable myParentTable;
      HTMLTableRow myParentRow;
      HTMLTableCell myParentCell;
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      try
      {
        HTMLComment myComment = new HTMLComment("Begin: DisplayPortletPrefencesView");
        result.AddInnerHTMLElement(myComment);
        myParentTable = new HTMLTable();
        result.AddInnerHTMLElement(myParentTable);
        //Specifying the mainTable attributes
        myParentTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        myParentTable.SetBorder(CommonHTMLStrings.ZERO);
        myParentTable.SetCellSpacing("15");
        myParentTable.SetCellPadding(CommonHTMLStrings.ZERO);
        myParentRow = new HTMLTableRow();
        myParentTable.AddInnerHTMLElement(myParentRow);
        myParentCell = new HTMLTableCell();
        myParentRow.AddInnerHTMLElement(myParentCell);
        // two hidden input variables -- one for SortBy function, one for folder ID
        HTMLInput inputPageToSort = new HTMLInput(HTMLInputTypes.HIDDEN, HTMLHIDDEN_SORTINGPAGEINDEX,
         "");
        inputPageToSort.SetValue("-1");
        myParentCell.AddInnerHTMLElement(inputPageToSort);
        // this returns an XPArrayList containig info about the gadgets with prefs
        PTSortedArrayWrapper arrPages = m_asModel.GetCommunityPages();
        // Page name row
        //		myTable = GetPageNameTable(strPageName);
        //	myParentCell.AddInnerHTMLElement( myTable );
        // spacer row
        //	myTable = GetAfterPageNameSpacerTable();
        //	myParentCell.AddInnerHTMLElement( myTable );
        // "portlet name" and "display titlebar" table; has a header row then all the portlets
        myTable = new HTMLTable();
        myParentCell.AddInnerHTMLElement(myTable);
        myTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        myTable.SetBorder(CommonHTMLStrings.ZERO);
        myTable.SetCellSpacing("2");
        myTable.SetCellPadding(CommonHTMLStrings.ZERO);
        // a row for the first part of the instructions
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetColSpan(CommonHTMLStrings.TWO);
        HTMLSpan mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(939, "ptmsgs_portalbrowsingmsgs"));
        // a spacer row
        myRow = GetSpacerRow();
        myTable.AddInnerHTMLElement(myRow);
        // a row for the second part of the instructions
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetColSpan(CommonHTMLStrings.TWO);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(1633, "ptmsgs_portalbrowsingmsgs"));
        // a spacer row
        myRow = GetSpacerRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow = GetTitleRow(arrPages);
        myTable.AddInnerHTMLElement(myRow);
        for (int iCurrentPage = 0;iCurrentPage < arrPages.GetCount();iCurrentPage++)
        {
          int nPageID = XPConvert.ToInteger(arrPages.GetItem(iCurrentPage,
           PT_PROPIDS.PT_PROPID_OBJECTID));
          String strPageName = (String) arrPages.GetItem(iCurrentPage, PT_PROPIDS.PT_PROPID_NAME);
          myRow = new HTMLTableRow();
          myTable.AddInnerHTMLElement(myRow);
          myCell = GetHTMLForCheckBox(nPageID);
          if (null != myCell)
          {
            myRow.AddInnerHTMLElement(myCell);
          }
          if ((0 == iCurrentPage) || (((iCurrentPage + 1) / 2) == (iCurrentPage / 2)))
          {
            // it's even
            myRow.SetStyleClass(PTStyleClass.LIST_ITEM_TWO_BG);
          } else
          {
            // it's odd
            myRow.SetStyleClass(PTStyleClass.LIST_ITEM_ONE_BG);
          }
          // Get HTML for portlet name
          myCell = GetHTMLForPageName(strPageName);
          myRow.AddInnerHTMLElement(myCell);
        }
        myComment = new HTMLComment("End: DisplayPagePrefencesView");
        result.AddInnerHTMLElement(myComment);
      }
      catch (Exception e)
      {
        // ***CHANGE_HERE*** Replace PagePreferencesView with your class name
        //         and update the error messages (log and exception).
        log.Error(e, "PagePreferencesView::Display The following error occured when trying to display the HTML");
        throw new XPException(m_asOwner.GetString(933, "ptmsgs_portalbrowsingmsgs"),
         e);
      }
      return result;
    }
    
    /// <summary>
    /// Returns Java Script for goToPage function.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    /// <returns>HTMLScript</returns>
    public virtual HTMLScript DisplayJavascript()
    {
      HTMLScript myScript = null;
      myScript = new HTMLScript("text/javaScript");
      try
      {
        XPStringBuilder sb;
        sb = new XPStringBuilder(300);
        // JavaScript to sort by column
        sb.Append("function SortBy" + "(varCurrentPageIndex)\n");
        sb.Append("{\n");
        sb.Append("  document." + DisplayInPortletDP.HTMLFORM_NAME + "." + HTMLHIDDEN_SORTINGPAGEINDEX + ".value= varCurrentPageIndex;\n");
        sb.Append("  postToSelf(" + DisplayInPortletControl.POSTTOSELF_ACTION_SORT + ");\n");
        sb.Append("}\n");
        // JavaScript to check all the rows
        sb.Append("function CheckAll()\n");
        sb.Append("{ \n");
        sb.Append("  var frm = document." + DisplayInPortletDP.HTMLFORM_NAME + "; \n");
        sb.Append("  var len = frm.elements.length; \n");
        sb.Append("  var nValue = frm." + HTMLCHECKBOX_CHECKALL + ".checked; \n");
        sb.Append("  var i = 0; \n");
        sb.Append("  \n");
        sb.Append("  for(i=0 ; i<len ; i++) \n");
        sb.Append("  { \n");
        sb.Append("    if (frm.elements[i].name == \'" + HTMLCHECKBOX_SELECTION_PAGE + "\') \n");
        sb.Append("    { \n");
        sb.Append("       frm.elements[i].checked = nValue;\n");
        sb.Append("    } \n");
        sb.Append("  } \n");
        sb.Append("}\n");
        myScript.AddInnerHTMLString(sb.ToString());
      }
      catch (Exception e)
      {
        log.Error(e, "DisplayInPortletView::DisplayJavascript The following error occured when trying to display the JavaScript: " + e.Message);
        throw new XPException(m_asOwner.GetString(942, "ptmsgs_portalbrowsingmsgs"),
         e);
      }
      return myScript;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IView#Init(IModel,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asModel = (ISiteMapModelRO) model;
      m_asOwner = parent;
    }
    
    /// <summary>
    /// Returns the HTML for the checkbox for a page
    /// </summary>
    /// <param name="nPortletID"></param>
    /// <returns>HTMLTableCell</returns>
    /// <throws>HTMLException</throws>
    protected virtual HTMLTableCell GetHTMLForCheckBox(int nPageID)
    {
      HTMLTableCell myCell;
      HTMLInput myInput;
      myCell = new HTMLTableCell();
      myCell.SetWidth("20");
      myCell.SetHeight("20");
      myCell.SetAlign(CommonHTMLStrings.CENTER);
      myCell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
      myCell.SetNoWrap(true);
      // checkbox
      myInput = new HTMLInput(HTMLInputTypes.CHECKBOX, HTMLCHECKBOX_SELECTION_PAGE,
       XPResourceManager.FormatMessage(m_asOwner.GetString(940, "ptmsgs_portalbrowsingmsgs"),
       nPageID));
      myCell.AddInnerHTMLElement(myInput);
      myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
      myInput.SetValue(XPConvert.ToString(nPageID));
      myInput.SetChecked(false);
      return (myCell);
    }
    
    /// <summary>
    /// Returns the HTML for the cell containing the page name
    /// </summary>
    /// <param name="strPortletName"></param>
    /// <returns>HTMLTableCell</returns>
    /// <throws>HTMLException</throws>
    protected virtual HTMLTableCell GetHTMLForPageName(String strPageName)
    {
      HTMLTableCell myCell;
      myCell = new HTMLTableCell();
      myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
      myCell.SetHeight("20");
      myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
      myCell.SetNoWrap(true);
      myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      myCell.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strPageName));
      return (myCell);
    }
    
    /// <returns></returns>
    /// <throws>Exception </throws>
    protected virtual HTMLTable GetAfterPageNameSpacerTable()
    {
      HTMLTableCell innerCell;
      HTMLTableRow innerRow;
      HTMLTable myTable;
      PTConstruct myConstruct;
      HTMLImg myImage;
      myTable = new HTMLTable();
      myTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
      myTable.SetBorder(CommonHTMLStrings.ZERO);
      myTable.SetCellSpacing(CommonHTMLStrings.ZERO);
      myTable.SetCellPadding(CommonHTMLStrings.ZERO);
      innerRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(innerRow);
      innerCell = new HTMLTableCell();
      innerRow.AddInnerHTMLElement(innerCell);
      myConstruct = UIConstructFactory.GetConstruct(PTImageType.SPACER);
      myImage = (HTMLImg) myConstruct.GetHTMLElement();
      myImage.SetWidth("1");
      myImage.SetHeight("5");
      myImage.SetAlign(CommonHTMLStrings.ABSMIDDLE);
      myImage.SetBorder(CommonHTMLStrings.ZERO);
      myImage.SetAlt("");
      innerCell.AddInnerHTMLElement(myImage);
      return myTable;
    }
    
    /// <returns></returns>
    /// <throws>Exception </throws>
    protected virtual HTMLTable GetBeforePageNameSpacerTable()
    {
      HTMLTableCell innerCell;
      HTMLTableRow innerRow;
      HTMLTable myTable;
      PTConstruct myConstruct;
      HTMLImg myImage;
      myTable = new HTMLTable();
      myTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
      myTable.SetBorder(CommonHTMLStrings.ZERO);
      myTable.SetCellSpacing(CommonHTMLStrings.ZERO);
      myTable.SetCellPadding(CommonHTMLStrings.ZERO);
      innerRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(innerRow);
      innerCell = new HTMLTableCell();
      innerRow.AddInnerHTMLElement(innerCell);
      myConstruct = UIConstructFactory.GetConstruct(PTImageType.SPACER);
      myImage = (HTMLImg) myConstruct.GetHTMLElement();
      myImage.SetWidth("1");
      myImage.SetHeight("5");
      myImage.SetAlign(CommonHTMLStrings.ABSMIDDLE);
      myImage.SetBorder(CommonHTMLStrings.ZERO);
      myImage.SetAlt("");
      innerCell.AddInnerHTMLElement(myImage);
      return myTable;
    }
    
    /// <param name="strPageName"></param>
    /// <returns></returns>
    /// <throws>Exception </throws>
    protected virtual HTMLTable GetPageNameTable(String strPageName)
    {
      HTMLTableRow innerRow;
      HTMLTableCell innerCell;
      HTMLTable myTable;
      HTMLSpan mySpan;
      myTable = new HTMLTable();
      myTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
      myTable.SetBorder(CommonHTMLStrings.ZERO);
      myTable.SetCellSpacing(CommonHTMLStrings.ZERO);
      myTable.SetCellPadding(CommonHTMLStrings.ZERO);
      innerRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(innerRow);
      innerRow.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);
      innerCell = new HTMLTableCell();
      innerRow.AddInnerHTMLElement(innerCell);
      innerCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
      innerCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
      innerCell.SetHeight("20");
      innerCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      mySpan = new HTMLSpan();
      innerCell.AddInnerHTMLElement(mySpan);
      mySpan.SetStyleClass(PTStyleClass.OBJECT_HEADER);
      mySpan.AddInnerHTMLString(strPageName);
      return myTable;
    }
    
    /// <summary>
    /// Return a two-column spacer row.
    /// </summary>
    /// <returns>HTMLTableRow</returns>
    /// <throws>XPException </throws>
    protected virtual HTMLTableRow GetSpacerRow()
    {
      HTMLTableCell myCell;
      HTMLTableRow myRow;
      PTConstruct myConstruct;
      HTMLImg myImage;
      myRow = new HTMLTableRow();
      myRow.SetStyleClass(PTStyleClass.OBJECT_TEXT);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
      myCell.SetColSpan(CommonHTMLStrings.TWO);
      myConstruct = UIConstructFactory.GetConstruct(PTImageType.SPACER);
      myImage = (HTMLImg) myConstruct.GetHTMLElement();
      myImage.SetWidth("1");
      myImage.SetHeight("5");
      myImage.SetAlign(CommonHTMLStrings.ABSMIDDLE);
      myImage.SetBorder(CommonHTMLStrings.ZERO);
      myImage.SetAlt("");
      myCell.AddInnerHTMLElement(myImage);
      return myRow;
    }
    
    /// <param name="arrPages"></param>
    /// <returns></returns>
    /// <throws>Exception </throws>
    protected virtual HTMLTableRow GetTitleRow(PTSortedArrayWrapper arrPages)
    {
      HTMLTableCell myCell;
      HTMLTableRow myRow;
      /*        PTConstruct myConstruct;
       HTMLImg myImage;
       HTMLAnchor myAnchor;
       */
       
      HTMLInput myInput;
      // checkbox, page name
      myRow = new HTMLTableRow();
      myRow.SetStyleClass(PTStyleClass.LIST_SORT_HEADER_BG);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetWidth("20");
      myCell.SetHeight("20");
      myCell.SetAlign(CommonHTMLStrings.CENTER);
      myCell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
      myCell.SetNoWrap(true);
      // checkbox
      myInput = new HTMLInput(HTMLInputTypes.CHECKBOX, HTMLCHECKBOX_CHECKALL,
       m_asOwner.GetString(941, "ptmsgs_portalbrowsingmsgs"));
      myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
      myInput.SetChecked(false);
      // mj: removed 'JavaScript:' from function name
      String strOnClickJavascript = "CheckAll()";
      myInput.SetOnClick(strOnClickJavascript);
      myCell.AddInnerHTMLElement(myInput);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
      myCell.SetHeight("20");
      myCell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
      myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      myCell.AddInnerHTMLString(m_asOwner.GetString(935, "ptmsgs_portalbrowsingmsgs"));
      // bjf -- I think sorting is not appropriate for this page.  If it is, we can add it back in.  About half
      // of the code is in place, but it would need a little TLC to make it work properly.
      /*        myAnchor = new HTMLAnchor("Sort()");	// mj: removed 'Javascript:' from function name
       myCell.AddInnerHTMLElement(myAnchor);
       myAnchor.AddInnerHTMLString(m_asOwner.GetString(935, "ptmsgs_portalbrowsingmsgs"));
       
       int[][] arrSort = arrPages.GetSort();
       if (PTSortedArrayWrapper.PTSAW_SORT_ASCENDING == arrSort[0][1])
       {
       myConstruct = UIConstructFactory.GetConstruct(PTImageType.ICON_ARROW_DESCEND, true, this.m_asOwner);
       myImage = (HTMLImg)myConstruct.GetHTMLElement();
       myImage.SetAlt(m_asOwner.GetString(937, "ptmsgs_portalbrowsingmsgs"));
       myImage.SetAlign(CommonHTMLStrings.ABSMIDDLE);
       myAnchor.AddInnerHTMLElement(myImage);
       }
       else
       {
       myConstruct = UIConstructFactory.GetConstruct(PTImageType.ICON_ARROW_ASCEND, true, this.m_asOwner);
       myImage = (HTMLImg)myConstruct.GetHTMLElement();
       myImage.SetAlt(m_asOwner.GetString(936, "ptmsgs_portalbrowsingmsgs"));
       myImage.SetAlign(CommonHTMLStrings.ABSMIDDLE);
       myAnchor.AddInnerHTMLElement(myImage);
       }
       */
       
      return myRow;
    }
  }
}