using System;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.directory;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.sitemap.sitemappage
{
  /// <summary>
  /// File: MembersDP.java
  /// --------------------
  /// </summary>
  /// <author>NaveenP</author>
  public class MembersDP : PlumtreeDP
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.sitemap.sitemappage.MembersDP");
    public const String STR_MVC_CLASS_NAME = "Members";
    private SiteMapModel m_asModel;
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetSubtitleForBanner()"></seealso>
    public override String GetSubtitleForBanner()
    {
      return m_asOwner.GetString(1634, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetTitleForBanner()"></seealso>
    public override String GetTitleForBanner()
    {
      NavigationModel modelNavigation = (NavigationModel) m_asOwner.GetModel(NavigationModel.STR_MVC_CLASS_NAME);
      return modelNavigation.GetCurCommunityName();
    }
    
    /// <summary>
    /// helper display method for PlumtreeDP
    /// Fill in the body argument with HTML to display in the page.
    /// </summary>
    public override HTMLElement PageDisplay()
    {
      m_asOwner.SetHelpTopic("pt_communityknowledgedirectory_browsing");
      m_asModel = (SiteMapModel) m_asOwner.GetModel(SiteMapModel.STR_MVC_CLASS_NAME);
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable table = new HTMLTable();
      table.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
      table.SetBorder(CommonHTMLStrings.ZERO);
      table.SetCellSpacing("10");
      table.SetCellPadding(CommonHTMLStrings.ZERO);
      HTMLTableRow row = new HTMLTableRow();
      table.AddInnerHTMLElement(row);
      HTMLTableCell cell = new HTMLTableCell();
      row.AddInnerHTMLElement(cell);
      try
      {
        result.AddInnerHTMLElement(m_asOwner.GetView(MembersView.STR_MVC_CLASS_NAME).Display());
        result.AddInnerHTMLElement(DirConstants.CreateSpacerTable(15, 1));
        result.AddInnerHTMLElement(m_asOwner.GetView(SiteMapAS.s_strMembersObjectView).Display());
        cell.AddInnerHTMLElement(result);
      }
      catch (HTMLException he)
      {
        log.Error(he, "Error in MembersDP::Display.");
      }
      return table;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#DisplayJavaScriptFromChild()"></seealso>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection scripts = new HTMLScriptCollection();
      scripts.AddInnerHTMLElement(m_asOwner.GetView(SiteMapAS.s_strMembersObjectView).DisplayJavascript());
      return scripts;
    }
  }
}