using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.common.mediator;
using com.plumtree.portalpages.common.objects;
using com.plumtree.portaluiinfrastructure.compoundlist;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.htmlconstructs;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.sitemap.sitemappage
{
  /// <summary>
  /// File: SiteMapLinkViewHelper.java
  /// </summary>
  /// <author>NaveenP</author>
  public class MembersViewHelper : IObjectViewHelper
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.sitemap.sitemappage.MembersViewHelper");
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#AddObjectViewHTML()"></seealso>
    public virtual HTMLElement AddObjectViewHTML(IObjectModelRO model)
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#Display508Object(int,HTMLTable,IObjectModelRO,AActivitySpace)"></seealso>
    public virtual void Display508Object(int nObjectIndex, HTMLTable tableObjects,
     IObjectModelRO model, AActivitySpace parent)
    {
      DisplayObject(nObjectIndex, 0, tableObjects, model, parent);
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#DisplayJavascriptCollection(AActivitySpace)"></seealso>
    public virtual HTMLScriptCollection DisplayJavascriptCollection(AActivitySpace asOwner,
     IObjectModelRO model)
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#GetThereAreNoItemsString(AActivitySpace)"></seealso>
    public virtual String GetThereAreNoItemsString(AActivitySpace asOwner)
    {
      return asOwner.GetString(1557, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#DisplayObject(int,HTMLTable,IObjectModelRO)"></seealso>
    public virtual void DisplayObject(int nObjectIndex, int nRowIndex, HTMLTable tableObjects,
     IObjectModelRO model, AActivitySpace asOwner)
    {
      HTMLTableRow row = null;
      Object iObjectID = model.GetObjectFields(nObjectIndex, PT_PROPIDS.PT_PROPID_OBJECTID);
      if (iObjectID == null)
      {
        iObjectID = 0;
      }
      String strLinkName = (String) model.GetObjectFields(nObjectIndex, PT_PROPIDS.PT_PROPID_NAME);
      if (strLinkName == null)
      {
        strLinkName = asOwner.GetString(953, "ptmsgs_portalbrowsingmsgs");
        }
      // bjf -- use the ASCompoundList to get the URL to the user.  This code is meant
      // to process an entire list of links, but we can only process one item here, so the
      // code is a little complicated, but allows us to reuse the URL generation code.
      ASCompoundList cpList = new ASCompoundList();
      cpList.AddUserProfileURL(strLinkName, XPConvert.ToInteger(iObjectID));
      ICPListEntryIterator iterator = cpList;
      CListURLMediator mediator = new CListURLMediator(asOwner, iterator);
      mediator.SetLabelMaxLength(PT_SERVERCONSTANTS.PT_MAX_NAMELENGTH);
      mediator.Next();
      HTMLAnchor myAnchor = (HTMLAnchor) mediator.GetEntry();
      if (XPConvert.ToInteger(iObjectID) == 0)
      {
        myAnchor = new HTMLAnchor(asOwner.GetString(953, "ptmsgs_portalbrowsingmsgs"));
        myAnchor.SetHRef("#");
      } else
      {
        myAnchor = (HTMLAnchor) mediator.GetEntry();
      }
      try
      {
        // use list item construct
        UIListItem itemConstruct = new UIListItem(myAnchor, asOwner);
        itemConstruct.SetItemTypeImage(PTImageType.ICON_MEMBER, asOwner.GetString(1629,
         "ptmsgs_portalbrowsingmsgs"));
        row = new HTMLTableRow();
        if (0 == (nRowIndex % 2))
        {
          row.SetStyleClass(PTStyleClass.LIST_ITEM_TWO_BG);
        } else
        {
          row.SetStyleClass(PTStyleClass.LIST_ITEM_ONE_BG);
        }
        itemConstruct.AddItemCellsToRow(row);
        tableObjects.AddInnerHTMLElement(row);
      }
      catch (HTMLException he)
      {
        log.Error(he, he.Message);
      }
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#SetExpandButton(HTMLAnchor,IObjectModelRO)"></seealso>
    public virtual void SetExpandAnchor(HTMLAnchor anchor, IObjectModelRO model)
    {
    }
  }
}