using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portalpages.common.mediator;
using com.plumtree.portalpages.common.objects;
using com.plumtree.portaluiinfrastructure.compoundlist;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.htmlconstructs;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.sitemap.sitemappage
{
  /// <summary>
  /// File: SiteMapLinkViewHelper.java
  /// --------------------------------
  /// </summary>
  /// <author>NaveenP</author>
  public class SubCommunitiesViewHelper : IObjectViewHelper
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.sitemap.sitemappage.SubCommunitiesViewHelper");
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#AddObjectViewHTML()"></seealso>
    public virtual HTMLElement AddObjectViewHTML(IObjectModelRO model)
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#Display508Object(int,HTMLTable,IObjectModelRO,AActivitySpace)"></seealso>
    public virtual void Display508Object(int nObjectIndex, HTMLTable tableObjects,
     IObjectModelRO model, AActivitySpace parent)
    {
      DisplayObject(nObjectIndex, 0, tableObjects, model, parent);
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#DisplayJavascriptCollection(AActivitySpace)"></seealso>
    public virtual HTMLScriptCollection DisplayJavascriptCollection(AActivitySpace asOwner,
     IObjectModelRO model)
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#GetThereAreNoItemsString(AActivitySpace)"></seealso>
    public virtual String GetThereAreNoItemsString(AActivitySpace asOwner)
    {
      return asOwner.GetString(1558, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <param name="nObjectIndex"></param>
    /// <param name="tableObjects"></param>
    /// <param name="model"></param>
    /// <param name="asOwner"></param>
    public virtual void DisplayObject(int nObjectIndex, int nRowIndex, HTMLTable tableObjects,
     IObjectModelRO model, AActivitySpace asOwner)
    {
      HTMLTableRow row = null;
      int iObjectID = XPConvert.ToInteger(model.GetObjectFields(nObjectIndex,
       PT_PROPIDS.PT_PROPID_OBJECTID));
      String strLinkName = (String) model.GetObjectFields(nObjectIndex, PT_PROPIDS.PT_PROPID_NAME);
      String strLinkDesc = "";
      strLinkDesc = (String) model.GetObjectFields(nObjectIndex, PT_PROPIDS.PT_PROPID_DESCRIPTION);
      // bjf -- use the ASCompoundList to get the URL to the user.  This code is meant
      // to process an entire list of links, but we can only process one item here, so the
      // code is a little complicated, but allows us to reuse the URL generation code.
      ASCompoundList cpList = new ASCompoundList();
      cpList.AddCommPageURL(strLinkName, iObjectID, -iObjectID);
      ICPListEntryIterator iterator = cpList;
      CListURLMediator mediator = new CListURLMediator(asOwner, iterator);
      mediator.SetLabelMaxLength(PT_SERVERCONSTANTS.PT_MAX_NAMELENGTH);
      mediator.Next();
      HTMLAnchor myAnchor = (HTMLAnchor) mediator.GetEntry();
      try
      {
        // use list item construct
        UIListItem itemConstruct = new UIListItem(myAnchor, asOwner);
        itemConstruct.SetItemTypeImage(PTImageType.ICON_COMMUNITY, asOwner.GetString(1786,
         "ptmsgs_portalbrowsingmsgs"));
        itemConstruct.SetDescription(XPHttpUtility.HtmlEncode(strLinkDesc));
        row = new HTMLTableRow();
        if (0 == (nRowIndex % 2))
        {
          row.SetStyleClass(PTStyleClass.LIST_ITEM_TWO_BG);
        } else
        {
          row.SetStyleClass(PTStyleClass.LIST_ITEM_ONE_BG);
        }
        itemConstruct.AddItemCellsToRow(row);
        tableObjects.AddInnerHTMLElement(row);
      }
      catch (HTMLException he)
      {
        log.Error(he, he.Message);
      }
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.objects.IObjectViewHelper#SetExpandButton(HTMLAnchor,IObjectModelRO)"></seealso>
    public virtual void SetExpandAnchor(HTMLAnchor anchor, IObjectModelRO model)
    {
    }
  }
}