using System;
using com.plumtree.portalpages.common.uiparts;
namespace com.plumtree.portalpages.browsing.sso.ensemble
{
  /// <author>
  /// Ravi Tunuguntla
  /// AActivitySpaces contain the MVC setup for a set of Display Pages, as well
  /// as the Display Pages themselves.  All objects should come to their parent
  /// AActivitySpace for access to other objects, such as IModels, IViews, and
  /// user objects like IPTSession and UserPreferences.
  /// Activity spaces setup and manage the interaction between the different MVC
  /// objects and the IDisplayPage.  They initialize all of the objects, and can
  /// get and set data on the Models if necessary.  Activity Spaces are not subject
  /// to the strict data/logic/presentation separation that MVC components are.
  /// </author>
  public class EnsembleHandlerAS : PlumtreeAS
  {
    
    /// <summary>
    /// MVC object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "EnsembleSSO";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new EnsembleHandlerAS();
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.AActivitySpace#Init()"></seealso>
    public override void Init()
    {
      base.Init();
      // Ensemble SSO Control
      RegisterControl(EnsembleHandlerControl.STR_MVC_CLASS_NAME, "", null);
      }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.AActivitySpace#GetRepostControlName()"></seealso>
    public override String GetRepostControlName()
    {
      return EnsembleHandlerControl.STR_MVC_CLASS_NAME;
    }
  }
}