using System;
using com.plumtree.openfoundation.util;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.arraywrapper;
using com.plumtree.uiinfrastructure.expandablelist;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlconstructs;
namespace com.plumtree.portalpages.browsing.unsubscribe.communities
{
  /// <author>
  /// dustina
  /// To change this generated comment edit the template variable "typecomment":
  /// Window>Preferences>Java>Templates.
  /// To enable and disable the creation of type comments go to
  /// Window>Preferences>Java>Code Generation.
  /// </author>
  public class MyCommunitiesListModel : ExpListModel,IMyCommunitiesListModelRO
  {
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "MyCommunitiesListModel";
    public const int COMMLIST_COL_MAX = 3;
    public const int COMMLIST_COL_NAME = 0;
    public const int COMMLIST_COL_ID = 1;
    public const int COMMLIST_COL_MEMBERSHIPTYPE = 2;
    
    /// <summary>
    /// Default initial size for the sorted array.
    /// </summary>
    public const int COMMLIST_DEFAULT_INITIAL_SIZE = 50;
    private bool m_bDisplayAllMandatoryAlert = false;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new MyCommunitiesListModel();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Initalizes the list (PTGrowableSortedArrayWrapper)
    /// with a column mapping and an array of sort.
    /// The growable array will always be sorted by the 1st
    /// column ascending.
    /// </summary>
    /// <param name="_saData"></param>
    public override void InitializeSortedArray(PTGrowableSortedArrayWrapper _saData)
    {
      int[] arrColumns = new int[]{COMMLIST_COL_NAME, COMMLIST_COL_ID, COMMLIST_COL_MEMBERSHIPTYPE};
      // The growable array will always be sorted by the String column (the one displayed).
      int[][] arrSort = new int[1][];
      for (int j2c_index = 0;j2c_index < 1;j2c_index++)
      {
        arrSort[j2c_index] = new int[2];
      }
      arrSort[0][PTSortedArrayWrapper.PTSAW_SORT_ROW_PROPID] = COMMLIST_COL_NAME;
      arrSort[0][PTSortedArrayWrapper.PTSAW_SORT_ROW_DIRECTION] = PTSortedArrayWrapper.PTSAW_SORT_ASCENDING;
      _saData.Initialize(arrColumns, null, arrSort, true, COMMLIST_DEFAULT_INITIAL_SIZE);
      }
    
    /// <summary>
    /// Will be called each time the add action is performed.
    /// Should take care of adding the row(s) to the list.
    /// Use the GetItems() method to get the list.
    /// </summary>
    /// <param name="_htFormData">Form data</param>
    public override void AddRowsOnRepost(XPHashtable _htFormData)
    {
    }
    // DCA - not used
    
    /// <summary>
    /// Will be called each ime there is a repost to save
    /// the data on the list.
    /// Should contain the code to update the data on the
    /// row _nRowIndex.Use the SetItem method to update _saData and
    /// use _htFormData to retrieve the posted data.
    /// </summary>
    /// <param name="_saData"></param>
    /// <param name="_nRowIndex"></param>
    /// <param name="_htFormData"></param>
    /// <param name="_nListKey"></param>
    /// <returns>int</returns>
    protected override int SaveRow(PTGrowableSortedArrayWrapper _saData, int _nRowIndex,
     XPHashtable _htFormData)
    {
      return RepostControl.PAGE_STATUS_VALID;
    }
    
    /// <summary>
    /// Initializes the expandable list.
    /// </summary>
    /// <param name="_sSectionTitle">Main title.</param>
    /// <param name="_sSectionSubTitle">Sub title</param>
    /// <param name="_sAddLabel">Text to display next to the add icon.</param>
    /// <param name="_nListKey">
    /// In case you have multiple Expandable Lists on
    /// the same DP, they should have a different key (otherwise, just set it to 1).
    /// </param>
    public virtual void InitCommExpList(String _sSectionTitle, String _sSectionSubTitle,
     String _sUnsubscribeLabel)
    {
      Object[][] arrExpListColInfo = new Object[1][];
      for (int j2c_index = 0;j2c_index < 1;j2c_index++)
      {
        arrExpListColInfo[j2c_index] = new Object[5];
      }
      arrExpListColInfo[0][EXPLIST_COLUMN_ID] = COMMLIST_COL_NAME;
      arrExpListColInfo[0][EXPLIST_COLUMN_TITLE] = _sSectionSubTitle;
      arrExpListColInfo[0][EXPLIST_COLUMN_WIDTH] = "100%";
      arrExpListColInfo[0][EXPLIST_COLUMN_COLSPAN] = "1";
      arrExpListColInfo[0][EXPLIST_COLUMN_ENABLESORT] = false;
      InitializeExpandableList(_sSectionTitle, arrExpListColInfo, PTImageType.ACTION_DELETE,
       _sUnsubscribeLabel, 1);
      DisableAddButton();
      SetEmptyListMessages(m_asOwner.GetString(1544, "ptmsgs_portalbrowsingmsgs"),
       "");
    }
    
    /// <param name="_nRowIndex"></param>
    /// <returns></returns>
    public virtual bool IsFreeMembership(int _nRowIndex)
    {
      if (XPConvert.ToInteger(m_saData.GetItem(_nRowIndex, COMMLIST_COL_MEMBERSHIPTYPE)) == PT_COMMUNITY_MEMBERSHIPTYPE.PT_COMMUNITYMEMBER_FREE)
      {
        return true;
      } else
      {
        return false;
      }
    }
    
    /// <param name="_htFormData"></param>
    /// <returns></returns>
    public virtual void Unsubscribe(XPHashtable _htFormData, UnsubscribeCommunitiesModel _model)
    {
      int[] aRowsToUnsubscribe = null;
      try
      {
        aRowsToUnsubscribe = GetArrayOfObjToDelete(_htFormData);
      }
      catch (Exception e)
      {
        // DCA - no communities to unsubscribe... must be all mandatory communities. Just return.
        m_bDisplayAllMandatoryAlert = true;
        return;
      }
      for (int i = 0;i < aRowsToUnsubscribe.Length;i++)
      {
        _model.AddCommToDelete(m_saData.GetItem(aRowsToUnsubscribe[i], COMMLIST_COL_ID));
        }
      m_saData.RemoveRows(aRowsToUnsubscribe);
    }
    
    /// <returns></returns>
    public virtual void Unsubscribe508(int _nRowIndex, UnsubscribeCommunitiesModel _model)
    {
      _model.AddCommToDelete(m_saData.GetItem(_nRowIndex, COMMLIST_COL_ID));
      m_saData.RemoveRow(_nRowIndex);
    }
    
    /// <summary>
    /// Returns the m_bDisplayAllMandatoryAlert.
    /// </summary>
    /// <returns>boolean</returns>
    public virtual bool displayAllMandatoryAlert()
    {
      return m_bDisplayAllMandatoryAlert;
    }
  }
}