using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.arraywrapper;
using com.plumtree.uiinfrastructure.constants;
using com.plumtree.uiinfrastructure.errordisplay;
using com.plumtree.uiinfrastructure.expandablelist;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.uiinfrastructure.htmlconstructs;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.unsubscribe.communities
{
  /// <author>
  /// dustina
  /// To change this generated comment edit the template variable "typecomment":
  /// Window>Preferences>Java>Templates.
  /// To enable and disable the creation of type comments go to
  /// Window>Preferences>Java>Code Generation.
  /// </author>
  public class MyCommunitiesListView : ExpListView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.unsubscribe.communities.MyCommunitiesListView");
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "MyCommunitiesListView";
    public const String HTMLBUTTON_DONE = "in_bu_Done";
    public const String HTMLBUTTON_CANCEL = "in_bu_Cancel";
    internal UnsubscribeCommunitiesAS m_asOwner;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new MyCommunitiesListView();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Inits the Model with the IPTSession.
    /// </summary>
    /// <param name="parent"></param>
    public override void Init(IModelRO _model, AActivitySpace parent)
    {
      base.Init(_model, parent);
      m_asOwner = (UnsubscribeCommunitiesAS) parent;
      m_model = _model;
    }
    
    /// <summary>
    /// Returns the HTML for the Action bar.
    /// (The one with the add icons).
    /// copied from JulieF's ExpListView but got rid of the delete Action cause invitation
    /// instances can't be deleted.
    /// </summary>
    /// <returns>HTMLTable</returns>
    /// <throws>Exception</throws>
    protected override HTMLTable GetHTMLForActionBar()
    {
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      myTable = new HTMLTable();
      myTable.SetBorder("0");
      myTable.SetCellPadding("0");
      myTable.SetCellSpacing("0");
      // 1st Row begin (there is only one row)
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
      // Add icon cell
      myRow.AddInnerHTMLElement(GetHTMLForUnsubscribeAction());
      // Empty Cell
      myRow.AddInnerHTMLElement(GetHTMLForEmptyCellInActionBar());
      // Add Extra HTML to the action bar (like a "create" button)
      AddHTMLToActionBar(myRow);
      // Last Empty Cell
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetAutoFit(true);
      myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
      myCell.SetHeight("25");
      myCell.AddInnerHTMLString(SPACE);
      // 1st Row ends
      return myTable;
    }
    
    /// <summary>
    /// Returns the HTML for the unsubscribe cell in the action bar.
    /// </summary>
    /// <returns>HTMLTableCell</returns>
    /// <throws>Exception</throws>
    protected virtual HTMLTableCell GetHTMLForUnsubscribeAction()
    {
      HTMLTableCell myCell;
      PTConstruct myConstruct;
      HTMLImg myImage;
      HTMLAnchor myAnchor;
      HTMLSpan mySpan;
      myCell = new HTMLTableCell();
      myCell.SetHeight("25");
      myCell.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BTN);
      myCell.SetNoWrap(true);
      myCell.AddInnerHTMLString(SPACE);
      // Add icon
      myConstruct = UIConstructFactory.GetConstruct(((IExpListModelRO) m_model).GetAddIcon(),
       true, this.m_asOwner);
      myImage = (HTMLImg) myConstruct.GetHTMLElement();
      myImage.SetAlt("");
      myImage.SetAlign("absmiddle");
      myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
      if (0 != ((IExpListModelRO) m_model).GetReadOnlyItems().GetCount())
      {
        myAnchor.SetOnClick(((IExpListModelRO) m_model).GetUniqueString("DeleteRows") + "(); return false;");
        }
      myAnchor.AddInnerHTMLElement(myImage);
      mySpan = new HTMLSpan();
      myAnchor.AddInnerHTMLElement(mySpan);
      mySpan.SetStyleClass(PTStyleClass.ACTIONBAR_TEXT);
      // Add label
      mySpan.AddInnerHTMLString(((IExpListModelRO) m_model).GetAddLabel());
      mySpan.AddInnerHTMLString(SPACE);
      mySpan.AddInnerHTMLString(SPACE);
      myCell.AddInnerHTMLElement(myAnchor);
      myCell.AddInnerHTMLString(SPACE);
      return myCell;
    }
    
    /// <summary>
    /// Returns the HTML for the row _nRowIndex.
    /// </summary>
    /// <param name="_saData"></param>
    /// <param name="_nRowIndex"></param>
    /// <returns>HTMLTableCell</returns>
    /// <throws>Exception</throws>
    protected virtual HTMLTableCell GetHTMLForNameColumn(IPTGrowableSortedArrayWrapperRO _saData,
     int _nRowIndex)
    {
      HTMLTableCell myCell;
      myCell = new HTMLTableCell();
      myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
      myCell.SetHeight("30");
      myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
      myCell.SetNoWrap(true);
      myCell.AddInnerHTMLString(SPACE);
      // Object Name
      String sPTObjectName = (String) _saData.GetItem(_nRowIndex, MyCommunitiesListModel.COMMLIST_COL_NAME);
      if (m_asOwner.GetAccessStyle() == AccessStyles.STANDARD)
      {
        // row icon
        HTMLImg myImage;
        PTConstruct myConstruct;
        myConstruct = UIConstructFactory.GetConstruct(PTImageType.ICON_COMMUNITY,
         true, this.m_asOwner);
        myImage = (HTMLImg) myConstruct.GetHTMLElement();
        myImage.SetAlt(m_asOwner.GetString(701, "ptmsgs_portalbrowsingmsgs"));
        myImage.SetAlign(CommonHTMLStrings.ABSMIDDLE);
        myCell.AddInnerHTMLElement(myImage);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell.AddInnerHTMLString(SPACE);
        myCell.AddInnerHTMLEncodedString(sPTObjectName);
        if (!((IMyCommunitiesListModelRO) m_model).IsFreeMembership(_nRowIndex))
        {
          myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
          HTMLSpan mySpan = new HTMLSpan();
          myCell.AddInnerHTMLElement(mySpan);
          mySpan.SetStyleClass(PTStyleClass.LIST_NEW_TEXT);
          mySpan.AddInnerHTMLString(m_asOwner.GetString(1661, "ptmsgs_portalbrowsingmsgs"));
          }
      } else
      {
        myCell.AddInnerHTMLEncodedString(sPTObjectName);
        myCell.AddInnerHTMLElement(new HTMLBr());
        // DCA - only display unsubscribe link if user has free membership to community
        if (((IMyCommunitiesListModelRO) m_model).IsFreeMembership(_nRowIndex))
        {
          ASURL myAsurl = ((AFormDP) m_asOwner.GetCurrentPage()).Get508RepostURL(UnsubscribeCommunitiesRepostControl.POSTTOSELF_508_ACTION_DELETE);
          myAsurl.AddControlArgument(UnsubscribeCommunitiesRepostControl.ROW_TO_DELETE,
           _nRowIndex);
          myAsurl.AddInnerHTMLString(XPResourceManager.FormatMessage(m_asOwner.GetString(1271,
           "ptmsgs_portalbrowsingmsgs"), XPHttpUtility.HtmlEncode(sPTObjectName)));
          myCell.AddInnerHTMLElement(myAsurl.GetURLAsHTMLElement());
        }
      }
      return myCell;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListView#GetHTMLForCheckBox(int)"></seealso>
    protected override HTMLTableCell GetHTMLForCheckBox(int _nRowIndex)
    {
      if (m_asOwner.GetAccessStyle() == AccessStyles.STANDARD && ((IMyCommunitiesListModelRO) m_model).IsFreeMembership(_nRowIndex))
      {
        // DCA - only display checkbox if user has free membership to community
        return base.GetHTMLForCheckBox(_nRowIndex);
      } else
      {
        HTMLTableCell myCell = new HTMLTableCell();
        myCell.SetHeight("30");
        myCell.SetAlign(CommonHTMLStrings.CENTER);
        myCell.SetVAlign(CommonHTMLStrings.MIDDLE);
        myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        return (myCell);
      }
    }
    
    /// <summary>
    /// Returns the HTML for the row _nRowIndex.
    /// Each row contains just an icon and input text.
    /// </summary>
    /// <param name="_saData"></param>
    /// <param name="_nRowIndex"></param>
    /// <returns>HTMLElement</returns>
    /// <throws>Exception</throws>
    public override HTMLElement GetHTMLForRow(IPTGrowableSortedArrayWrapperRO _saData,
     int _nRowIndex)
    {
      HTMLElementCollection result = new HTMLElementCollection();
      result.AddInnerHTMLElement(GetHTMLForNameColumn(_saData, _nRowIndex));
      return result;
    }
    
    /// <returns></returns>
    public override HTMLElement Display()
    {
      HTMLElementCollection myResult = new HTMLElementCollection();
      try
      {
        myResult.AddInnerHTMLElement(base.Display());
        //	add the error display view.
        myResult.AddInnerHTMLElement(this.m_asOwner.GetView(ErrorView.STR_MVC_CLASS_NAME).Display());
        }
      catch (Exception e)
      {
        log.Error(e, "MyCommunitiesListView::Display The following error occured when trying to display the HTML: " + e.Message);
        throw new XPException(m_asOwner.GetString(1545, "ptmsgs_portalbrowsingmsgs"),
         e);
      }
      return myResult;
    }
    
    /// <summary>
    /// Returns Java Script for goToPage function.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    /// <returns>HTMLScript</returns>
    public override HTMLScript DisplayJavascript()
    {
      HTMLScript myScript = null;
      myScript = new HTMLScript("text/javaScript");
      try
      {
        XPStringBuilder sb;
        // JavaScript alert try to unsubscribe mandatory communities
        if (((IMyCommunitiesListModelRO) m_model).displayAllMandatoryAlert())
        {
          sb = new XPStringBuilder(100);
          sb.Append("alert(\'" + m_asOwner.GetString(2360, "ptmsgs_portaladminmsgs") + "\');");
          myScript.AddInnerHTMLString(sb.ToString());
        }
        sb = new XPStringBuilder(300);
        // JavaScript to sort by column	
        sb.Append("function " + ((IExpListModelRO) m_model).GetUniqueString("DeleteRows") + "()\n");
        sb.Append("{\n");
        sb.Append("  if(0 != " + ((IExpListModelRO) m_model).GetUniqueString("CountCheckedRows") + "()) \n");
        sb.Append("  {\n");
        sb.Append("    postToSelf(" + UnsubscribeCommunitiesRepostControl.POSTTOSELF_ACTION_DELETE + ");\n");
        sb.Append("  }\n");
        sb.Append("  else\n");
        sb.Append("  {\n");
        sb.Append("    alert(\'" + m_asOwner.GetString(60, "ptmsgs_infrastructure") + "\');\n");
        sb.Append("  }\n");
        sb.Append("}\n");
        myScript.AddInnerHTMLString(sb.ToString());
        sb = new XPStringBuilder(300);
        // JavaScript to return the number of checked rows.
        sb.Append("function " + ((IExpListModelRO) m_model).GetUniqueString("CountCheckedRows") + "()\n");
        sb.Append("{ \n");
        sb.Append("  var frm = document." + UnsubscribeCommunitiesDP.HTMLFORM_NAME + "; \n");
        sb.Append("  var len = frm.elements.length; \n");
        sb.Append("  var nValue = frm." + ((IExpListModelRO) m_model).GetUniqueString(HTMLCHECKBOX_CHECKALL) + ".checked; \n");
        sb.Append("  var i = 0; \n");
        sb.Append("  var nTotal = 0; \n");
        sb.Append("  \n");
        sb.Append("  for(i=0 ; i<len ; i++) \n");
        sb.Append("  { \n");
        sb.Append("    if (frm.elements[i].name == \'" + ((IExpListModelRO) m_model).GetUniqueString(HTMLCHECKBOX_DELROW) + "\') \n");
        sb.Append("    { \n");
        sb.Append("       if (frm.elements[i].checked) \n");
        sb.Append("       { \n");
        sb.Append("          nTotal++; \n");
        sb.Append("       } \n");
        sb.Append("    } \n");
        sb.Append("  } \n");
        sb.Append("  return (nTotal);\n");
        sb.Append("}\n");
        myScript.AddInnerHTMLString(sb.ToString());
        sb = new XPStringBuilder(300);
        // JavaScript to check all the rows
        sb.Append("function " + ((IExpListModelRO) m_model).GetUniqueString("CheckRows") + "()\n");
        sb.Append("{ \n");
        sb.Append("  var frm = document." + UnsubscribeCommunitiesDP.HTMLFORM_NAME + "; \n");
        sb.Append("  var len = frm.elements.length; \n");
        sb.Append("  var nValue = frm." + ((IExpListModelRO) m_model).GetUniqueString(HTMLCHECKBOX_CHECKALL) + ".checked; \n");
        sb.Append("  var i = 0; \n");
        sb.Append("  \n");
        sb.Append("  for(i=0 ; i<len ; i++) \n");
        sb.Append("  { \n");
        sb.Append("    if (frm.elements[i].name == \'" + ((IExpListModelRO) m_model).GetUniqueString(HTMLCHECKBOX_DELROW) + "\') \n");
        sb.Append("    { \n");
        sb.Append("       frm.elements[i].checked = nValue;\n");
        sb.Append("    } \n");
        sb.Append("  } \n");
        sb.Append("}\n");
        myScript.AddInnerHTMLString(sb.ToString());
        String sEmptyListAlert = ((IExpListModelRO) m_model).GetAlertMessageForEmptyList();
        if (null != sEmptyListAlert)
        {
          sb = new XPStringBuilder(300);
          // JavaScript to check if the list is not empty	
          // JF- Note that this method is not called anywhere in the framework. 
          // It has to be registered as a validation function inside the Editor
          sb.Append("function " + ((IExpListModelRO) m_model).GetUniqueString("CheckEmptyList") + "()\n");
          sb.Append("{\n");
          sb.Append("  \n");
          if (0 == ((IExpListModelRO) m_model).GetReadOnlyItems().GetCount())
          {
            sb.Append("  alert(\"" + sEmptyListAlert + "\"); \n");
            sb.Append("  return false;\n");
          } else
          {
            sb.Append("  return true;\n");
          }
          sb.Append("}\n");
          myScript.AddInnerHTMLString(sb.ToString());
        }
      }
      catch (Exception e)
      {
        log.Error(e, "ExpListView::DisplayJavascript The following error occured when trying to display the JavaScript: " + e.Message);
        throw new XPException(m_asOwner.GetString(53, "ptmsgs_infrastructure"),
         e);
      }
      return myScript;
    }
  }
}