using System;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.browsing.unsubscribe.communities
{
  /// <author>
  /// dustina
  /// To change this generated comment edit the template variable "typecomment":
  /// Window>Preferences>Java>Templates.
  /// To enable and disable the creation of type comments go to
  /// Window>Preferences>Java>Code Generation.
  /// </author>
  public class UnsubscribeCommunitiesAS : PTEditorAS
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.browsing.unsubscribe.communities.UnsubscribeCommunitiesAS");
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "UnsubscribeCommunities";
    
    /// <summary>
    /// Sets the Editor title.
    /// </summary>
    /// <returns></returns>
    public override String GetEditorTitle()
    {
      return GetString(1547, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new UnsubscribeCommunitiesAS();
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the class name of the Property Repost Control.
    /// </summary>
    /// <returns>String</returns>
    public override String GetRepostControlName()
    {
      return (UnsubscribeCommunitiesRepostControl.STR_MVC_CLASS_NAME);
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#Init(IPTSession)"></seealso>
    public override void Init()
    {
      log.Info("Initializing UnsubscribeCommunity Activity Space");
      m_strModelName = UnsubscribeCommunitiesModel.STR_MVC_CLASS_NAME;
      base.Init();
      RegisterModel(MyCommunitiesListModel.STR_MVC_CLASS_NAME);
      IModel myModel = GetModel(MyCommunitiesListModel.STR_MVC_CLASS_NAME);
      RegisterView(MyCommunitiesListView.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(ExpListControl.STR_MVC_CLASS_NAME, myModel);
      // Unsubscribe Communities DisplayPages
      RegisterPage(new UnsubscribeCommunitiesDP());
      SetCurrentPage(UnsubscribeCommunitiesDP.STR_MVC_CLASS_NAME);
      // Unsubscribe Communities Model
      myModel = GetModel(UnsubscribeCommunitiesModel.STR_MVC_CLASS_NAME);
      // Unsubscribe Communities Controls
      RegisterControl(UnsubscribeCommunitiesRepostControl.STR_MVC_CLASS_NAME,
       myModel);
      this.SetHelpTopic("PT_UnsubscribefromCommunities");
    }
  }
}