using System;
using com.plumtree.uiinfrastructure.constants;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.browsing.unsubscribe.communities
{
  /// <author>
  /// dustina
  /// To change this generated comment edit the template variable "typecomment":
  /// Window>Preferences>Java>Templates.
  /// To enable and disable the creation of type comments go to
  /// Window>Preferences>Java>Code Generation.
  /// </author>
  public class UnsubscribeCommunitiesDP : EditorDP
  {
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "UnsubscribeCommunities";
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.editor.EditorDP#GetLeftNavString()"></seealso>
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(1548, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <summary>
    /// This is a helper method that all classes that inherit from AFormDP and want to
    /// have the Done and Cancel buttons displayed in the header for them need to
    /// implement.  The method should return the title add whatever HTML the child
    /// class wants to display to the body argument.  The parent class will then add
    /// that HTML to the HTMLPage after filling in the banner and navigation.
    /// Override this method to set the form title
    /// </summary>
    /// <returns>String the title for the form header (if used)</returns>
    public override String GetFormTitle()
    {
      return m_asOwner.GetString(1548, "ptmsgs_portalbrowsingmsgs");
    }
    
    /// <summary>
    /// Returns the HTML for that Page.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException </throws>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLElementCollection views = new HTMLElementCollection();
      // Insert super class HTML
      result.AddInnerHTMLElement(base.PageDisplay());
      // Display My Communities list.
      views.AddInnerHTMLElement(m_asOwner.GetView(MyCommunitiesListView.STR_MVC_CLASS_NAME).Display());
      result.AddInnerHTMLElement(CreateContentTable(views, null));
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(MyCommunitiesListView.STR_MVC_CLASS_NAME).DisplayJavascript());
      return myScripts;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.editor.EditorDP#GetHTMLBelowSubHeader()
     */
     
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      if (AccessStyles.STANDARD == m_asOwner.GetAccessStyle())
      {
        return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1546,
         "ptmsgs_portalbrowsingmsgs"), this.m_asOwner);
      } else
      {
        return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1785,
         "ptmsgs_portalbrowsingmsgs"), this.m_asOwner);
      }
    }
  }
}