using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.browsing.unsubscribe.communities
{
  /// <author>
  /// dustina
  /// To change this generated comment edit the template variable "typecomment":
  /// Window>Preferences>Java>Templates.
  /// To enable and disable the creation of type comments go to
  /// Window>Preferences>Java>Code Generation.
  /// </author>
  public class UnsubscribeCommunitiesRepostControl : EditorRepostControl
  {
    public const String STR_MVC_CLASS_NAME = "UnsubscribeCommunitiesRepostControl";
    
    /// <summary>
    /// Will delete one or more items from the list. 
    /// </summary>
    public const int POSTTOSELF_ACTION_DELETE = 31;
    public const int POSTTOSELF_508_ACTION_DELETE = 32;
    public const String ROW_TO_DELETE = "deleteRow";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new UnsubscribeCommunitiesRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call
    /// the associated method for each action.
    /// </summary>
    /// <param name="_nAction"></param>
    protected override void PerformAction(int _nAction)
    {
      if (_nAction == POSTTOSELF_ACTION_DELETE || _nAction == POSTTOSELF_ACTION_FINISH)
      {
        ((MyCommunitiesListModel) m_asOwner.GetModel(MyCommunitiesListModel.STR_MVC_CLASS_NAME)).Unsubscribe(m_htFormData,
         (UnsubscribeCommunitiesModel) m_model);
      } else
      if (_nAction == POSTTOSELF_508_ACTION_DELETE)
      {
        String[] data = (String[]) m_htFormData.GetElement(ROW_TO_DELETE);
        if ((0 != data.Length) && (null != data[0]))
        {
          try
          {
            int nRowIndex = XPConvert.ToInteger(data[0]);
            ((MyCommunitiesListModel) m_asOwner.GetModel(MyCommunitiesListModel.STR_MVC_CLASS_NAME)).Unsubscribe508(nRowIndex,
             (UnsubscribeCommunitiesModel) m_model);
          }
          catch (Exception e)
          {
          }
        }
      }
      // DCA - nothing to do...
      base.PerformAction(_nAction);
    }
  }
}