using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.common;
namespace com.plumtree.portalpages.common.areyousure
{
  /// <author>adolfoc</author>
  public class AYSPopupDP : FrameSetDP
  {
    
    /// <summary>
    /// Class name for the activity space
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "AYSPopupDP";
    
    /// <summary>
    /// Parent AS.
    /// </summary>
    private AreYouSureAS m_asOwner;
    
    /// <summary>
    /// Associated read-only Model.
    /// </summary>
    private AreYouSureModel m_model;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new AYSPopupDP();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IDisplayPage#GetOwner()"></seealso>
    public override AActivitySpace GetOwner()
    {
      return m_asOwner;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public override void Init(AActivitySpace parent)
    {
      base.Init(parent);
      m_model = (AreYouSureModel) parent.GetModel(AreYouSureModel.STR_MVC_CLASS_NAME);
      m_asOwner = (AreYouSureAS) parent;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameScrollBody()"></seealso>
    public override bool GetFrameScrollBody()
    {
      return true;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameScrollBottom()"></seealso>
    public override bool GetFrameScrollBottom()
    {
      return false;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameScrollTop()"></seealso>
    public override bool GetFrameScrollTop()
    {
      return false;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameSetAttributes()"></seealso>
    public override String GetFrameSetAttributes()
    {
      return "10%,70%,20%";
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameSetTitle()"></seealso>
    public override String GetFrameSetTitle()
    {
      return m_asOwner.GetString(19, "ptmsgs_portalcommonmsgs");
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameURLBody()"></seealso>
    public override ASURL GetFrameURLBody()
    {
      ASURL result = new ASURL(m_asOwner);
      result.SetLinkGetCachedSpace(m_asOwner);
      result.SetDisplayPage(AYSPopupBodyFrameDP.STR_MVC_CLASS_NAME);
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameURLBottom()"></seealso>
    public override ASURL GetFrameURLBottom()
    {
      ASURL result = new ASURL(m_asOwner);
      result.SetLinkGetCachedSpace(m_asOwner);
      result.SetDisplayPage(AYSPopupBottomFrameDP.STR_MVC_CLASS_NAME);
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameURLTop()"></seealso>
    public override ASURL GetFrameURLTop()
    {
      ASURL result = new ASURL(m_asOwner);
      result.SetLinkGetCachedSpace(m_asOwner);
      result.SetDisplayPage(AYSPopupTopFrameDP.STR_MVC_CLASS_NAME);
      return result;
    }
  }
}