using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.common.areyousure
{
  /// <author>adolfoc</author>
  public class AreYouSureControl : IControl
  {
    public const String STR_MVC_CLASS_NAME = "AreYouSureControl";
    
    /// <summary>
    /// This is posted after the popup window pops - so that the parent knows to
    /// redirect.
    /// </summary>
    public const int POSTTOSELF_ACTION_REDIRECT_AFTER_OK = 27;
    public const String _QS_AYS_SESSION_KEY = "aysSessionKey";
    protected AActivitySpace m_asOwner = null;
    protected IModel m_model = null;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IControl#Execute(XPHashtable)"></seealso>
    public virtual Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      AreYouSureModel aysModel = (AreYouSureModel) m_model;
      if (arguments.ContainsKey(_QS_AYS_SESSION_KEY))
      {
        String[] data = (String[]) arguments.GetElement(_QS_AYS_SESSION_KEY);
        if ((0 != data.Length) && (null != data[0]))
        {
          aysModel.SetSessionKey((String) data[0]);
        }
      }
      return null;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new AreYouSureControl();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IControl#Init(IModel,AActivitySpace)"></seealso>
    public virtual void Init(IModel model, AActivitySpace space)
    {
      // Store these for use later.
      m_asOwner = space;
      m_model = model;
    }
  }
}