using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.common.areyousure
{
  /// <author>adolfoc</author>
  public class AreYouSureModel : IModel,IAYSModelRO
  {
    public const String STR_MVC_CLASS_NAME = "AreYouSure";
    private AActivitySpace m_asOwner = null;
    private XPArrayList m_xpalAYSMessages = null;
    public AreYouSureModel()
    {
      m_xpalAYSMessages = new XPArrayList();
    }
    
    /// <summary>
    /// Adds an AYSMessage to be displayed
    /// </summary>
    public virtual void AddMessage(AYSMessage aysIn)
    {
      m_xpalAYSMessages.Add(aysIn);
    }
    
    /// <summary>
    /// Adds an AYSMessage to be displayed (simple form)
    /// </summary>
    public virtual void AddMessage(String strMessage, int nMessageType)
    {
      m_xpalAYSMessages.Add(new AYSMessage(strMessage, nMessageType));
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IModel#CleanupTempData()"></seealso>
    public virtual void CleanupTempData()
    {
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IModel#CleanupAllData()"></seealso>
    public virtual void CleanupAllData()
    {
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new AreYouSureModel();
    }
    
    /// <summary>
    /// Returns the xpalAYSMessages.
    /// </summary>
    /// <returns>XPArrayList</returns>
    public virtual XPArrayList GetMessages()
    {
      return m_xpalAYSMessages;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IModel#Init(AActivitySpace)"></seealso>
    public virtual void Init(AActivitySpace parent)
    {
      m_asOwner = parent;
    }
    
    /// <summary>
    /// Gets an array of messages from the passed-in SessionKey.
    /// </summary>
    public virtual void SetSessionKey(String strSessionKey)
    {
      m_xpalAYSMessages = (XPArrayList) m_asOwner.GetSubSession().GetAttribute(strSessionKey);
      }
  }
}