using System;
using com.plumtree.portalpages.admin.objmgr;
using com.plumtree.portalpages.browsing.directory;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.common.createfolder
{
  /// <author>StephenC</author>
  public class CreateFolderDP : AFormDP
  {
    public const String STR_MVC_CLASS_NAME = "CreateFolderDP";
    public const String QS_PARENT_FOLDER = "parentFolder";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()"></seealso>
    public override String GetFormTitle()
    {
      return ((CreateFolderView) m_asOwner.GetView(CreateFolderView.STR_VIEW_STORAGE_NAME)).GetBannerTitle();
      }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Init(AActivitySpace)"></seealso>
    public override void Init(AActivitySpace parent)
    {
      base.Init(parent);
      // enable the status view for these repost values.
      SetStatusViewRepostValues(new int[]{ObjMgrRepostControl.POSTTOSELF_ACTION_CREATE_FOLDER,
       DirRepostControl.POSTTOSELF_ACTION_CREATEFOLDER});
      AddToValidationFunction(CreateFolderView.JAVASCRIPT_CREATEFOLDER);
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      return m_asOwner.GetView(CreateFolderView.STR_VIEW_STORAGE_NAME).Display();
      }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(CreateFolderView.STR_VIEW_STORAGE_NAME).DisplayJavascript());
      return myScripts;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#GetFormPageType()"></seealso>
    public override FormPageTypes GetFormPageType()
    {
      return FormPageTypes.SMALL_POPUP;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#GetCloseOnCancel()"></seealso>
    public override bool GetCloseOnCancel()
    {
      return true;
    }
  }
}