using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.common.createfolder
{
  /// <author>StephenC</author>
  public abstract class CreateFolderView : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_COMMON),
     "com.plumtree.portalpages.common.createfolder.CreateFolderView");
    public const String STR_VIEW_STORAGE_NAME = "CreateFolder";
    
    /// <summary>
    /// Logging stuff 
    /// </summary>
    public const String HTMLINPUT_FOLDERNAME = "in_tx_FolderName";
    public const String HTMLINPUT_FOLDERDESCRIPTION = "in_tx_FolderDescription";
    public const String HTMLBUTTON_EDITOR_FINISH = "in_bu_Done";
    public const String HTMLBUTTON_EDITOR_CANCEL = "in_bu_Cancel";
    public const String HTMLINPUT_CREATED = "in_hi_Created";
    public const String JAVASCRIPT_SUBMIT_BY_POST = "SubmitByPost";
    public const String JAVASCRIPT_CREATEFOLDER = "CheckAndCreateFolder";
    public const String JAVASCRIPT_VALIDATE_FOLDER_NAME = "validateFolderName";
    public const String JAVASCRIPT_DO_ON_LOAD = "doOnLoad";
    public const String HTMLFORM_CREATEFOLDER = "CreateFolderPopup";
    protected AActivitySpace m_asOwner;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Display()"></seealso>
    public virtual HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLSpan mySpan;
      HTMLInput myInput;
      try
      {
        HTMLTable myTable = new HTMLTable();
        myTable.SetBorder("0");
        myTable.SetWidth("100%");
        myTable.SetCellPadding("0");
        myTable.SetCellSpacing("10");
        result.AddInnerHTMLElement(myTable);
        // BEGIN Banner and Finish and Cancel buttons
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        // title
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        myCell.SetColSpan(CommonHTMLStrings.TWO);
        mySpan.SetStyleClass(PTStyleClass.ALERT_DIALOG_TITLE);
        mySpan.AddInnerHTMLString(GetBannerTitle());
        // BEGIN Title Instructions ROW
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        // title
        myCell = new HTMLTableCell();
        myCell.SetColSpan(CommonHTMLStrings.TWO);
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(1198, "ptmsgs_portalbrowsingmsgs"));
        // END TitleInstructions ROW
        // BEGIN Folder Name Row
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myCell.SetWidth("100");
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);
        myCell.AddInnerHTMLString(m_asOwner.GetString(99, "ptmsgs_portalbrowsingmsgs"));
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_FOLDERNAME,
         "Name");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetValue("");
        myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
        myInput.SetSize(40);
        myInput.SetMaxLength(63);
        myInput.SetOnKeyPress("return " + PlumtreeHelpers.STR_JS_FUNC_NAME_EXECUTE_VIA_ENTER + "(event);");
        // END Folder Name Row
        // BEGIN Folder Description Row
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);
        myCell.AddInnerHTMLString(m_asOwner.GetString(100, "ptmsgs_portalbrowsingmsgs"));
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_FOLDERDESCRIPTION,
         "Description");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetValue("");
        myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
        myInput.SetSize(40);
        myInput.SetMaxLength(255);
        myInput.SetOnKeyPress("return " + PlumtreeHelpers.STR_JS_FUNC_NAME_EXECUTE_VIA_ENTER + "(event);");
        // END Folder Description Row
        // hidden input with the tree space ID
        myInput = new HTMLInput(HTMLInputTypes.HIDDEN, HTMLINPUT_CREATED,
         "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetValue("0");
        HTMLScript myScript = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
        myScript.AddInnerHTMLString(JAVASCRIPT_DO_ON_LOAD + "();\n");
        result.AddInnerHTMLElement(myScript);
      }
      catch (HTMLException he)
      {
        log.Error(he, STR_VIEW_STORAGE_NAME + "::Display The following error occured when trying to display the HTML.");
        throw new XPException(m_asOwner.GetString(105, "ptmsgs_portalbrowsingmsgs"),
         he);
      }
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    public virtual HTMLScript DisplayJavascript()
    {
      HTMLScript myScript = PlumtreeHelpers.GetExecuteViaEnterJScript(JAVASCRIPT_CREATEFOLDER);
      try
      {
        // The JavaScript below checks if the Property Name is empty.
        XPStringBuilder sb = new XPStringBuilder(1400);
        sb.Append("function ").Append(JAVASCRIPT_VALIDATE_FOLDER_NAME).Append("(strString)");
        sb.Append("{\n");
        sb.Append("\tvar bResult = true; \n");
        sb.Append("\n");
        sb.Append("\tif (strString.length == 0) return true; \n");
        sb.Append("\n");
        sb.Append("\tif (-1 != strString.lastIndexOf(\"\\\\\") || -1 != strString.lastIndexOf(\"\\t\") || -1 != strString.lastIndexOf(\"\\n\")) \n");
        sb.Append("\t{ \n");
        sb.Append("\t\tbResult = false;\n");
        sb.Append("\t}\n");
        sb.Append("\treturn bResult;\n");
        sb.Append("}\n");
        sb.Append("function ").Append(JAVASCRIPT_CREATEFOLDER).Append("()\n");
        sb.Append("{\n");
        sb.Append("\tvar strCreatedFlag = document." + CreateFolderDP.HTMLFORM_NAME + "." + HTMLINPUT_CREATED + ".value;\n");
        sb.Append("\tif(\"1\" == strCreatedFlag) return false;\n");
        sb.Append("\tvar strName = document." + CreateFolderDP.HTMLFORM_NAME + "." + HTMLINPUT_FOLDERNAME + ".value;\n");
        sb.Append("\tif (\"\" == strName)\n");
        sb.Append("\t{\n");
        sb.Append("\t\talert(\"" + m_asOwner.GetString(103, "ptmsgs_portalbrowsingmsgs") + "\");\n");
        sb.Append("\t\treturn false;\n");
        sb.Append("\t}\n");
        sb.Append("\tif (false == ").Append(JAVASCRIPT_VALIDATE_FOLDER_NAME).Append("(strName))\n");
        sb.Append("\t{\n");
        sb.Append("\t\talert(\"" + m_asOwner.GetString(104, "ptmsgs_portalbrowsingmsgs") + "\");\n");
        sb.Append("\t\treturn false;\n");
        sb.Append("\t}\n");
        sb.Append("\t").Append(JAVASCRIPT_SUBMIT_BY_POST).Append("(").Append(GetCreateFolderRepostAction()).Append(");\n");
        // This must return false so it can be used as a validation function w/o reposting the form.
        sb.Append("\treturn false;\n");
        sb.Append("}\n");
        sb.Append("function ").Append(JAVASCRIPT_SUBMIT_BY_POST).Append("(varID)\n");
        sb.Append("{\n");
        sb.Append("\tdocument." + CreateFolderDP.HTMLFORM_NAME + "." + HTMLINPUT_CREATED + ".value = \"1\";\n");
        sb.Append("\tdocument." + CreateFolderDP.HTMLFORM_NAME + ".method=\'POST\';\n");
        sb.Append("\t").Append(AFormDP.JAVASCRIPT_SUBMIT_FORM).Append("(varID);\n");
        sb.Append("}\n");
        sb.Append("\n");
        sb.Append("function ").Append(JAVASCRIPT_DO_ON_LOAD).Append("()\n");
        sb.Append("{\n");
        sb.Append("\tdocument.").Append(AFormDP.HTMLFORM_NAME).Append(".").Append(HTMLINPUT_FOLDERNAME).Append(".focus();\n");
        sb.Append("}\n");
        myScript.AddInnerHTMLString(sb.ToString());
      }
      catch (HTMLException he)
      {
        log.Error(he, "FolderBannerView::DisplayJavascript The following error occured when trying to display the JavaScript.");
        throw new XPException(m_asOwner.GetString(106, "ptmsgs_portalbrowsingmsgs"),
         he);
      }
      return myScript;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public abstract String GetName();
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asOwner = parent;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public abstract Object Create();
    public abstract String GetBannerTitle();
    public abstract int GetCreateFolderRepostAction();
  }
}