using System;
// Framework Imports
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.common.dirprefs
{
  /// <author>StephenC</author>
  public class DirPrefsRepostControl : EditorRepostControl
  {
    public const String STR_MVC_CLASS_NAME = "DirPrefsRepostControl";
    public const int POSTTOSELF_ACTION_RELOAD = 10;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new DirPrefsRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call
    /// the associated method for each action.
    /// </summary>
    /// <param name="int"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      ((ExpListControl) m_asOwner.GetControl(DirPrefsAS.strBrowsingPropertiesPlugInKey)).PerformRepostAction(_nAction,
       m_htFormData);
      switch (_nAction){
      case POSTTOSELF_ACTION_RELOAD:
      ((DirPrefsModel) m_model).LoadSettings();
      break;
      }
    }
  }
}