using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.common.documentlanguage
{
  /// <summary>
  /// This Control contains the repost actions of the plug-in section.
  /// </summary>
  /// <author>StephenC</author>
  public class CardLanguagePlugInRepostControl : EditorHelperRepostControl
  {
    public const String STR_MVC_CLASS_NAME = "CardLanguagePlugIn";
    // JF- repost actions for that section
    public const int POSTTOSELF_ACTION_SHOW_POPULAR = 30;
    public const int POSTTOSELF_ACTION_SHOW_ALL = 31;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new CardLanguagePlugInRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Performs action on repost.
    /// </summary>
    /// <param name="_nAction"></param>
    /// <param name="_htFormData"></param>
    public override void PerformRepostAction(int _nAction, XPHashtable _htFormData)
    {
      switch (_nAction){
      case POSTTOSELF_ACTION_SHOW_POPULAR:
      ((CardLanguagePlugInModel) m_model).SetDisplayOnlyPopularLanguages(true);
      break;
      case POSTTOSELF_ACTION_SHOW_ALL:
      ((CardLanguagePlugInModel) m_model).SetDisplayOnlyPopularLanguages(false);
      break;
      }
    }
  }
}