using System;
using com.plumtree.uiinfrastructure.arraywrapper;
namespace com.plumtree.portalpages.common.editpage
{
  /// <author>michaeld</author>
  public class PageData
  {
    
    /// <summary>
    /// Portlets 
    /// </summary>
    public PTGrowableSortedArrayWrapper m_arrPortlets;
    
    /// <summary>
    /// Free Form Portlet 
    /// </summary>
    public PortletData m_gmFreeForm;
    
    /// <summary>
    /// Page Name 
    /// </summary>
    public String m_strPageName;
    
    /// <summary>
    /// Page Template From Community Template 
    /// </summary>
    public bool m_bFromCommTemp;
    
    /// <summary>
    /// Has Portlets been setup? 
    /// </summary>
    public bool m_bPortletsSetUp;
    
    /// <summary>
    /// Has Page Template changed since this model was setup? 
    /// </summary>
    public bool m_bPageTemplateChanged;
    
    /// <summary>
    /// Community ID 
    /// </summary>
    public int m_nCommunityID;
    
    /// <summary>
    /// Portlet Count 
    /// </summary>
    public int m_nPortletCount;
    
    /// <summary>
    /// Page ID 
    /// </summary>
    public int m_nPageID;
    
    /// <summary>
    /// Page Template ID 
    /// </summary>
    public int m_nPageTemplateID;
    
    /// <summary>
    /// Page Type 
    /// </summary>
    public int m_nPageType;
    
    /// <summary>
    /// Unique ID
    /// This is optional. Currently it is only used in the community editor to keep
    /// track of pages.
    /// </summary>
    public int m_nUniqueID;
    
    /// <summary>
    /// Creates a new PageData object.
    /// </summary>
    /// <param name="nPageType"></param>
    /// <param name="strPageName"></param>
    public PageData(int nPageType, String strPageName)
    {
      m_nPageType = nPageType;
      m_strPageName = strPageName;
      m_bPortletsSetUp = false;
      m_bPageTemplateChanged = false;
      m_nPageID = 0;
      m_nCommunityID = -1;
      m_nPageTemplateID = 0;
      m_bFromCommTemp = false;
    }
    
    /// <summary>
    /// Creates a new PageData object.
    /// </summary>
    /// <param name="nPageID"></param>
    /// <param name="nCommunityID"></param>
    /// <param name="nPageTemplateID"></param>
    /// <param name="bFromCommTemp"></param>
    /// <param name="nPageType"></param>
    /// <param name="strPageName"></param>
    public PageData(int nPageID, int nCommunityID, int nPageTemplateID, bool bFromCommTemp,
     int nPageType, String strPageName) : this(nPageTemplateID, bFromCommTemp,
     nPageType, strPageName)
    {
      m_nPageID = nPageID;
      m_nCommunityID = nCommunityID;
    }
    
    /// <summary>
    /// Creates a new PageData object.
    /// </summary>
    /// <param name="nPageTemplateID"></param>
    /// <param name="bFromCommTemp"></param>
    /// <param name="nPageType"></param>
    /// <param name="strPageName"></param>
    public PageData(int nPageTemplateID, bool bFromCommTemp, int nPageType,
     String strPageName) : this(nPageType, strPageName)
    {
      m_nPageTemplateID = nPageTemplateID;
      m_bFromCommTemp = bFromCommTemp;
    }
  }
}