using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portalpages.common.editpage
{
  /// <author>michaeld</author>
  public class PageLayoutControl : EditorHelperRepostControl
  {
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "PageLayout";
    
    /// <summary>
    /// Repost Action: Add Portlets submitted 
    /// </summary>
    public const int POSTTOSELF_ACTION_ADDGADGETS = 36;
    
    /// <summary>
    /// Repost Action: Add Free Form submitted 
    /// </summary>
    public const int POSTTOSELF_ACTION_ADDFREEFORM = 37;
    
    /// <summary>
    /// Repost Action: New Portlet 
    /// </summary>
    public const int POSTTOSELF_ACTION_NEW_GADGET = 38;
    
    /// <summary>
    /// Repost Action: Delete Portlet 
    /// </summary>
    public const int POSTTOSELF_ACTION_DELETEPORTLET = 39;
    
    /// <summary>
    /// Repost Action: Select Layout 
    /// </summary>
    public const int POSTTOSELF_ACTION_SELECTLAYOUT = 40;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new PageLayoutControl();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.editor.EditorHelperRepostControl#PerformRepostAction(int,XPHashtable)"></seealso>
    public override void PerformRepostAction(int _nAction, XPHashtable _htFormData)
    {
      switch (_nAction){
      case POSTTOSELF_ACTION_ADDGADGETS:
      ((PageLayoutPlugInModel) m_model).RepostAddPortlets();
      break;
      case POSTTOSELF_ACTION_NEW_GADGET:
      ((PageLayoutPlugInModel) m_model).RepostNewPortlet();
      break;
      case POSTTOSELF_ACTION_ADDFREEFORM:
      ((PageLayoutPlugInModel) m_model).RepostAddFreeForm();
      break;
      case POSTTOSELF_ACTION_DELETEPORTLET:
      ((PageLayoutPlugInModel) m_model).RepostDeletePortlet();
      break;
      case POSTTOSELF_ACTION_SELECTLAYOUT:
      break;
      }
    }
  }
}