using System;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.errordisplay;
namespace com.plumtree.portalpages.common.error
{
  /// <author>
  /// BenG
  /// This activity space is for displaying those error messages that require
  /// their own display page.
  /// </author>
  public class ErrorAS : PlumtreeAS
  {
    
    /// <summary>
    /// name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "ErrorAS";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new ErrorAS();
    }
    
    /// <summary>
    /// Get the name of this activity space.
    /// </summary>
    /// <returns>String name.</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.AActivitySpace#Init()"></seealso>
    public override void Init()
    {
      base.Init();
      RegisterPage(new ErrorDP());
      RegisterModel(SinglePageErrorModel.STR_MVC_CLASS_NAME);
      IModel myModel = GetModel(SinglePageErrorModel.STR_MVC_CLASS_NAME);
      RegisterControl(SinglePageErrorControl.STR_MVC_CLASS_NAME, myModel);
      RegisterView(SinglePageErrorView.STR_MVC_CLASS_NAME, myModel);
    }
  }
}