using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.common.folder
{
  /// <summary>
  /// This writes out one folder to the given table cell and returns a reference
  /// to the next folder in the query result to display.
  /// See com.plumtree.portalpages.common.folder.FolderViewHelper for implementation of
  /// the general case.
  /// </summary>
  /// <author>RupaP</author>
  public interface IFolderViewHelper
  {
    
    /// <summary>
    /// Displays one folder and any related items.
    /// </summary>
    /// <param name="nFolderIndex">the index of the subfolder to be displayed</param>
    /// <param name="tableCell">the table to add the folder view to</param>
    /// <param name="model">passes     the current state of the opened folder</param>
    /// <param name="space">current activity space</param>
    /// <returns>the next Folder Index to display.</returns>
    int DisplayFolder(int nFolderIndex, HTMLTableCell tableCell, IFolderModelRO model,
     AActivitySpace space);
    
    /// <summary>
    /// SetupAnchorToOpenFolder.
    /// Sets up the anchor to open the folder with the given id.
    /// </summary>
    /// <param name="_anchor"></param>
    /// <param name="_nFolderID"></param>
    void SetupAnchorToOpenFolder(HTMLAnchor _anchor, int _nFolderID, IFolderModelRO _model,
     AActivitySpace _space);
  }
}