using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.common.folder
{
  /// <author>Don Hayler</author>
  public class OpenSubFolderControl : IControl
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_COMMON),
     "com.plumtree.portalpages.common.folder.OpenSubFolderControl");
    public const String STR_MVC_CLASS_NAME = "OpenSubFolder";
    public const String m_SubFolderID = "subfolderID";
    protected int m_nSubFolderID = 0;
    private IFolderModel m_asModel;
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IControl#execute()"></seealso>
    public virtual Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      String[] sValues = (String[]) arguments.GetElement(m_SubFolderID);
      if (sValues == null)
      {
        log.Error("could not find folder ID in query string.");
        return null;
      }
      m_asModel.OpenSubFolder(XPConvert.ToInteger(sValues[0]));
      return null;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new OpenSubFolderControl();
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IControl#getName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IControl#init(IModel,AActivitySpace)"></seealso>
    public virtual void Init(IModel model, AActivitySpace space)
    {
      m_asModel = (IFolderModel) model;
    }
  }
}