using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.common.folder
{
  /// <author>RupaP</author>
  public class SetStartItemControl : IControl
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_COMMON),
     "com.plumtree.portalpages.common.folder.SetStartItemControl");
    public const String STR_MVC_CLASS_NAME = "SetStartItem";
    public const String m_strStartItem = "StartItem";
    private IFolderModel m_asModel;
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IControl#execute()"></seealso>
    public virtual Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      String[] sValues = (String[]) arguments.GetElement(m_strStartItem);
      if (sValues == null)
      {
        log.Error("could not find start item in query string.");
        return null;
      }
      m_asModel.SetFirstItemIndex(XPConvert.ToInteger(sValues[0]));
      //todo- should we redirect to a new page if this changes?
      return null;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new SetStartItemControl();
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IControl#getName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IControl#init(IModel,AActivitySpace)"></seealso>
    public virtual void Init(IModel model, AActivitySpace space)
    {
      m_asModel = (IFolderModel) model;
    }
  }
}