using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.portalpages.admin.editors.common.setjob;
using com.plumtree.portaluiinfrastructure.classtypedescriptors.classtypes;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.portaluiinfrastructure.expandablelist.selectptobject;
using com.plumtree.portaluiinfrastructure.opener;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.common.helpers
{
  /// <author>OlegS</author>
  public class CreatedHelper
  {
    
    /// <summary>
    /// Indentation offset for displaying indented HTML 
    /// </summary>
    public const int OFFSET_DEFAULT = 5;
    
    /// <summary>
    /// Default number of lines skipped in a line break 
    /// </summary>
    public const int BREAK_DEFAULT = 2;
    protected AActivitySpace m_asOwner;
    protected HTMLList m_myList;
    protected IObjEditorModelRO m_myModel;
    
    /// <summary>
    /// Creates a new CreatedHelper object.
    /// </summary>
    /// <param name="asOwner"></param>
    public CreatedHelper(AActivitySpace asOwner)
    {
      m_asOwner = asOwner;
    }
    
    /// <summary>
    /// Creates a new CreatedHelper object.
    /// </summary>
    /// <param name="asOwner"></param>
    /// <param name="myModel"></param>
    public CreatedHelper(AActivitySpace asOwner, IObjEditorModelRO myModel)
    {
      m_asOwner = asOwner;
      m_myModel = myModel;
    }
    
    /// <param name="myScript"></param>
    /// <throws>HTMLException </throws>
    public virtual void addJobJavascript(HTMLScript myScript)
    {
      if (m_myModel == null)
      {
        return;
      }
      XPStringBuilder sb;
      sb = new XPStringBuilder(200);
      sb.Append("function AddToExistingJob()\n");
      sb.Append("{\n");
      sb.Append("  window.close(); \n");
      sb.Append("  window.opener." + ObjEditorAS.JAVASCRIPT_OBJEDITOR_OPEN);
      sb.Append("(\'" + m_myModel.GetClassID() + "\',");
      sb.Append("\'" + m_myModel.GetObjectID() + "\',");
      // JF- We don't need the Folder ID in edit mode
      sb.Append("\'" + ObjEditorModel.EDITOR_FOLDERID_UNKNOWN + "\',");
      sb.Append("\'" + IPTOpenerConstants.OPENER_MODE_EDIT + "\',");
      sb.Append("\'" + m_asOwner.GetParentSpaceName() + "\',");
      sb.Append("\'" + m_asOwner.GetParentSpaceID() + "\',");
      sb.Append("\'" + ASConstants.PAGE + "=" + SetJobDP.STR_MVC_CLASS_NAME + "\'); \n");
      sb.Append("}\n");
      myScript.AddInnerHTMLString(sb.ToString());
      //		sb = new XPStringBuilder(200);
      //		sb.Append("function CreateNewJob()\n");
      //		sb.Append("{\n");
      //		sb.Append("  window.close(); \n");
      //		sb.Append("  window.opener." + ObjEditorAS.JAVASCRIPT_OBJEDITOR_OPEN);
      //		sb.Append("('" + PT_CLASSIDS.PT_JOB_ID + "',");
      //
      //		// JF- We don't the Object ID in create mode
      //		sb.Append("'" + ObjEditorModel.EDITOR_OBJECTID_UNKNOWN + "',");
      //		sb.Append("'" + m_myModel.GetObject().GetAdminFolderID() + "',");
      //		sb.Append("'" + IPTOpenerConstants.OPENER_MODE_CREATE + "',");
      //		sb.Append("'" + m_asOwner.GetParentSpaceName() + "',");
      //		sb.Append("'" + m_asOwner.GetParentSpaceID() + "'); \n");
      //		sb.Append("}\n");
      //
      //		myScript.AddInnerHTMLString(sb.ToString());
      sb = new XPStringBuilder(200);
      sb.Append("function CreateNewJob()\n");
      sb.Append("{\n");
      sb.Append("  window.close(); \n");
      sb.Append("  window.opener." + ObjEditorAS.JAVASCRIPT_OBJEDITOR_OPEN);
      sb.Append("(\'" + PT_CLASSIDS.PT_JOB_ID + "\',");
      // JF- We don't the Object ID in create mode
      sb.Append("\'" + ObjEditorModel.EDITOR_OBJECTID_UNKNOWN + "\',");
      sb.Append("\'" + m_myModel.GetObject().GetAdminFolderID() + "\',");
      sb.Append("\'" + IPTOpenerConstants.OPENER_MODE_CREATE + "\',");
      sb.Append("\'" + m_asOwner.GetParentSpaceName() + "\',");
      sb.Append("\'" + m_asOwner.GetParentSpaceID() + "\',");
      sb.Append("\'" + PTJobs.JOBOP_CLSID + "=" + m_myModel.GetClassID());
      sb.Append("&" + PTJobs.JOBOP_OBJID + "=" + m_myModel.GetObjectID() + "\');\n");
      sb.Append("}\n");
      myScript.AddInnerHTMLString(sb.ToString());
    }
    
    /// <param name="result"></param>
    /// <throws>HTMLException </throws>
    public virtual void beginList(HTMLElementCollection result)
    {
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      myRow = new HTMLTableRow();
      result.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetWidth("100%");
      myCell.SetColSpan("2");
      myCell.SetStyleClass(PTStyleClass.DIALOGUE_TEXT);
      m_myList = new HTMLList(HTMLListTypes.UNORDERED_LIST);
      myCell.AddInnerHTMLElement(m_myList);
    }
    
    /// <param name="result"></param>
    /// <throws>HTMLException </throws>
    public virtual void displayEmptyRow(HTMLElementCollection result)
    {
      displayEmptyRow(result, -1);
    }
    
    /// <param name="result"></param>
    /// <param name="breaks"></param>
    /// <throws>HTMLException </throws>
    public virtual void displayEmptyRow(HTMLElementCollection result, int breaks)
    {
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      if (breaks < 0)
      {
        breaks = BREAK_DEFAULT;
      }
      myRow = new HTMLTableRow();
      result.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetWidth("100%");
      myCell.SetColSpan("2");
      myCell.SetStyleClass(PTStyleClass.DIALOGUE_TEXT);
      myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      for (int i = 0;i < breaks;i++)
      {
        myCell.AddInnerHTMLString("<br>");
      }
    }
    
    /// <param name="result"></param>
    /// <param name="jobmodel"></param>
    /// <throws>HTMLException </throws>
    public virtual void displayJobList(HTMLElementCollection result, ISelectPTObjectModelRO jobmodel)
    {
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      myRow = new HTMLTableRow();
      result.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetWidth("100%");
      myCell.SetColSpan("2");
      myCell.SetStyleClass(PTStyleClass.DIALOGUE_TEXT);
      myCell.AddInnerHTMLElement(jobmodel.GetSelectedNamesAsHTML());
    }
    
    /// <param name="result"></param>
    /// <param name="ifhasjobs"></param>
    /// <param name="ifnojobs"></param>
    /// <throws>HTMLException </throws>
    public virtual void displayJobRows(HTMLElementCollection result, String ifhasjobs,
     String ifnojobs)
    {
      ISelectPTObjectModelRO jobmodel = null;
      try
      {
        jobmodel = (ISelectPTObjectModelRO) m_asOwner.GetModel(SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB);
        }
      catch (Exception e)
      {
      }
      if (jobmodel != null)
      {
        bool hasjobs = (jobmodel.GetReadOnlyItems().GetCount() > 0);
        if (hasjobs)
        {
          displayTextRow(result, ifhasjobs, null);
          displayJobList(result, jobmodel);
        } else
        {
          displayTextRow(result, ifnojobs, null);
          displayNoJobsAnchors(result);
        }
      }
    }
    
    /// <summary>
    /// This function displays the standard successfully created message, adding
    /// the object name and its parent folder path
    /// </summary>
    /// <author>JohnH</author>
    /// <param name="result">- The HTML being displayed on the page</param>
    /// <param name="strObjectType">- The type of object being created</param>
    /// <param name="strObjectName">- The name of the object that has been created</param>
    /// <param name="strParentPath">
    /// - The parent folder path for the object that has
    /// been created
    /// </param>
    public virtual void displaySuccessMessage(HTMLElementCollection result,
     String strObjectType, String strObjectName, String strParentPath)
    {
      this.displayEmptyRow(result);
      this.displayTextRow(result, XPResourceManager.FormatMessage(m_asOwner.GetString(635,
       "ptmsgs_portalcommonmsgs"), strObjectType), null);
      this.displayTextRow(result, -1, XPResourceManager.FormatMessage(m_asOwner.GetString(790,
       "ptmsgs_portalcommonmsgs"), strObjectType), GeneralHelpers.TruncateLongString(strObjectName,
       ObjEditorModel.OBJECT_NAME_TRUNCATE, false));
      this.displayTextRow(result, -1, m_asOwner.GetString(636, "ptmsgs_portalcommonmsgs"),
       strParentPath, -1);
    }
    
    /// <summary>
    /// This function adds a warning message to the HTMLElementCollection passed
    /// in if the everyone group has access to the object whose editor model is
    /// passed in.
    /// </summary>
    /// <author>JohnH</author>
    /// <param name="result">- The HTML being displayed</param>
    /// <param name="objectModel">- The model for the object being created</param>
    /// <param name="strObjectType">
    /// - The type of the object being created (e.g. Data
    /// Source)
    /// </param>
    public virtual void displayEveryoneWarning(HTMLElementCollection result,
     IModelRO objectModel, String strObjectType)
    {
      IPTServerContext mySC;
      mySC = (IPTServerContext) ((ObjEditorModel) objectModel).GetObject().GetInterfaces("IPTServerContext");
      if (PlumtreeHelpers.EveryoneHasAccess(mySC))
      {
        HTMLTableRow myRow = new HTMLTableRow();
        result.AddInnerHTMLElement(myRow);
        HTMLTableCell myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetWidth("100%");
        myCell.SetColSpan("2");
        myCell.SetStyleClass(PTStyleClass.ALERT_ERROR_TITLE);
        myCell.AddInnerHTMLString(m_asOwner.GetString(634, "ptmsgs_portalcommonmsgs"));
        this.displayTextRow(result, XPResourceManager.FormatMessage(m_asOwner.GetString(745,
         "ptmsgs_portalcommonmsgs"), strObjectType), null);
      }
    }
    
    /// <summary>
    /// Displays the string "Warning:", then a line break, then some text
    /// </summary>
    /// <author>JohnH</author>
    /// <param name="result">- The HTMLElementCollection being modified</param>
    /// <param name="strWarningText">- The warning text to display</param>
    public virtual void displayWarning(HTMLElementCollection result, String strWarningText)
    {
      HTMLTableRow myRow = new HTMLTableRow();
      result.AddInnerHTMLElement(myRow);
      HTMLTableCell myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetWidth("100%");
      myCell.SetColSpan("2");
      myCell.SetStyleClass(PTStyleClass.ALERT_ERROR_TITLE);
      myCell.AddInnerHTMLString(m_asOwner.GetString(634, "ptmsgs_portalcommonmsgs"));
      this.displayTextRow(result, strWarningText, null);
    }
    
    /// <summary>
    /// Displays an element in a list formatted as a label (no content)
    /// </summary>
    /// <param name="label"></param>
    /// <throws>HTMLException </throws>
    public virtual void displayListRow(String label)
    {
      displayListRow(label, null);
    }
    
    /// <summary>
    /// Displays an element in a list formatted as content (no label)
    /// </summary>
    /// <param name="content">The content to display</param>
    /// <throws>HTMLException </throws>
    public virtual void displayListRow(HTMLElement content)
    {
      displayListRow(null, content);
    }
    
    /// <summary>
    /// Displays a row in a list with optional label and content
    /// </summary>
    /// <param name="label"></param>
    /// <param name="content"></param>
    /// <throws>HTMLException </throws>
    public virtual void displayListRow(String label, HTMLElement content)
    {
      HTMLListItem myListItem = new HTMLListItem();
      m_myList.AddInnerHTMLElement(myListItem);
      if (label != null)
      {
        myListItem.AddInnerHTMLString(XPHttpUtility.HtmlEncode(label));
      }
      if (content != null)
      {
        myListItem.AddInnerHTMLElement(content);
      }
    }
    
    /// <summary>
    /// Displays the links for adding to an existing job and creating a new job
    /// </summary>
    /// <param name="result">- the HTMLElementCollection being modified</param>
    /// <throws>HTMLException</throws>
    public virtual void displayNoJobsAnchors(HTMLElementCollection result)
    {
      beginList(result);
      HTMLAnchor myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
      myAnchor.SetOnClick("AddToExistingJob(); return false;");
      myAnchor.AddInnerHTMLString(m_asOwner.GetString(532, "ptmsgs_portalcommonmsgs"));
      displayListRow(myAnchor);
      myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
      myAnchor.SetOnClick("CreateNewJob(); return false;");
      myAnchor.AddInnerHTMLString(m_asOwner.GetString(533, "ptmsgs_portalcommonmsgs"));
      displayListRow(myAnchor);
    }
    
    /// <summary>
    /// Displays an arbitrary anchor link as part of a list.  beginList must
    /// be called before this function
    /// </summary>
    /// <param name="result">- the HTMLElementCollection being modified</param>
    /// <param name="strText">- The text of the link to display</param>
    /// <param name="strOnClick">
    /// - The javascript function name (including
    /// arguments) to call in the OnClick event
    /// </param>
    /// <throws>HTMLException</throws>
    public virtual void displayListRowAnchor(HTMLElementCollection result,
     String strText, String strOnClick)
    {
      beginList(result);
      HTMLAnchor myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
      myAnchor.SetOnClick(strOnClick + "; return false;");
      myAnchor.AddInnerHTMLString(strText);
      displayListRow(myAnchor);
    }
    
    /// <summary>
    /// Displays a row of text containing a label and a value (e.g. Name: Oleg)
    /// </summary>
    /// <param name="result">The HTMLElementCollection being modified</param>
    /// <param name="label">The label</param>
    /// <param name="value">The value</param>
    /// <throws>HTMLException </throws>
    public virtual void displayTextRow(HTMLElementCollection result, String label,
     String value)
    {
      displayTextRow(result, 0, label, value, 0);
    }
    
    /// <summary>
    /// Displays a row of text containing a label and a value with an optional
    /// indentation offset
    /// </summary>
    /// <param name="result">The HTMLElementCollection being modified</param>
    /// <param name="offset">The offset (indent spaces)</param>
    /// <param name="label">The label</param>
    /// <param name="value">The value</param>
    /// <throws>HTMLException </throws>
    public virtual void displayTextRow(HTMLElementCollection result, int offset,
     String label, String value)
    {
      displayTextRow(result, offset, label, value, 0);
    }
    
    /// <summary>
    /// Displays a row of text containing a label and a value with optional line
    /// breaks
    /// </summary>
    /// <param name="result">The HTMLElementCollection being modified</param>
    /// <param name="label">The label</param>
    /// <param name="value">The value</param>
    /// <param name="breaks">The number of line breaks</param>
    /// <throws>HTMLException </throws>
    public virtual void displayTextRow(HTMLElementCollection result, String label,
     String value, int breaks)
    {
      displayTextRow(result, 0, label, value, breaks);
    }
    
    /// <param name="offset"># of left &nbsp;, <0 use default, 0 none, >0 use specified</param>
    /// <param name="label">1st non bold part of text, null OK</param>
    /// <param name="value">2nd bold part of text, null OK</param>
    /// <param name="breaks"># of trailing <br />, <0 use default, 0 none, >0 use specified</param>
    public virtual void displayTextRow(HTMLElementCollection result, int offset,
     String label, String value, int breaks)
    {
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLB myBold;
      if (offset < 0)
      {
        offset = OFFSET_DEFAULT;
      }
      if (breaks < 0)
      {
        breaks = BREAK_DEFAULT;
      }
      myRow = new HTMLTableRow();
      result.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetWidth("100%");
      myCell.SetColSpan("2");
      myCell.SetStyleClass(PTStyleClass.DIALOGUE_TEXT);
      for (int i = 0;i < offset;i++)
      {
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      }
      if (label != null)
      {
        myCell.AddInnerHTMLString(label + CommonHTMLStrings.SPACE);
      }
      if (value != null)
      {
        myBold = new HTMLB();
        myCell.AddInnerHTMLElement(myBold);
        myBold.AddInnerHTMLString(XPHttpUtility.HtmlEncode(value));
      }
      for (int i = 0;i < breaks;i++)
      {
        myCell.AddInnerHTMLString("<br>");
      }
    }
  }
}