using System;
using com.plumtree.openfoundation.util;
namespace com.plumtree.portalpages.common.helpers
{
  /// <author>OlegS</author>
  public class DateProperty : PropertyValidator
  {
    
    /// <summary>
    /// Creates a new DateProperty object.
    /// </summary>
    /// <param name="owner"></param>
    public DateProperty(PropertyValidatorOwner owner) : base(owner)
    {
    }
    
    /// <param name="val"></param>
    /// <returns></returns>
    public override int validate(PropertyValue val)
    {
      int result = base.validate(val);
      XPDateTime dummyXPDateTime = new XPDateTime();
      if (result == VALIDSOFAR)
      {
        if (!val.isClass(dummyXPDateTime.GetType()))
        // try to convert
        {
          val.changeTypeToDate();
        }
        if (!val.isClass(dummyXPDateTime.GetType()))
        {
          SetInvalid(val, m_asOwner.GetString(59, "ptmsgs_portalcommonmsgs"));
          result = INVALID;
        }
      }
      return result;
    }
  }
}