using System;
namespace com.plumtree.portalpages.common.helpers
{
  /// <author>OlegS</author>
  public class IntegerProperty : PropertyValidator
  {
    
    /// <summary>
    /// Creates a new IntegerProperty object.
    /// </summary>
    /// <param name="owner"></param>
    public IntegerProperty(PropertyValidatorOwner owner) : base(owner)
    {
    }
    
    /// <param name="val"></param>
    /// <returns></returns>
    public override int validate(PropertyValue val)
    {
      int result = base.validate(val);
      if (result == VALIDSOFAR)
      {
        if (!(val.m_value is int))
        // try to convert
        {
          val.changeTypeToInteger();
        }
        if (!(val.m_value is int))
        {
          SetInvalid(val, m_asOwner.GetString(57, "ptmsgs_portalcommonmsgs"));
          result = INVALID;
        }
      }
      return result;
    }
  }
}