using System;
namespace com.plumtree.portalpages.common.helpers
{
  /// <author>OlegS</author>
  public class IntegerPropertyWithRange : IntegerProperty
  {
    protected int m_max;
    protected int m_min;
    
    /// <summary>
    /// Creates a new IntegerPropertyWithRange object.
    /// </summary>
    /// <param name="owner"></param>
    /// <param name="min"></param>
    /// <param name="max"></param>
    public IntegerPropertyWithRange(PropertyValidatorOwner owner, int min,
     int max) : base(owner)
    {
      m_min = min;
      m_max = max;
    }
    
    /// <param name="val"></param>
    /// <returns></returns>
    public override int validate(PropertyValue val)
    {
      int result = base.validate(val);
      if (result == VALIDSOFAR)
      {
        int n = val.number();
        if ((n < m_min) || (n > m_max))
        {
          SetInvalid(val, m_asOwner.GetString(58, "ptmsgs_portalcommonmsgs") + " [" + m_min + "," + m_max + "]");
          result = INVALID;
        }
      }
      return result;
    }
  }
}