using System;
using com.plumtree.openfoundation.util;
namespace com.plumtree.portalpages.common.helpers
{
  /// <author>OlegS</author>
  public class PropertyBagSource : PropertySource
  {
    internal IXPPropertyBag m_ptBag;
    
    /// <summary>
    /// Creates a new PropertyBagSource object.
    /// </summary>
    /// <param name="ptBag"></param>
    public PropertyBagSource(IXPPropertyBag ptBag)
    {
      m_ptBag = ptBag;
    }
    
    /// <param name="id"></param>
    /// <returns></returns>
    public override Object Get(Object id)
    {
      return m_ptBag.ReadAsObject((String) id);
    }
    
    /// <param name="id"></param>
    /// <param name="value"></param>
    public override void Set(Object id, Object value)
    {
      if (Differ(value, Get(id)))
      {
        m_ptBag.Write((String) id, value);
      }
    }
  }
}