using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.common.helpers
{
  /// <author>OlegS</author>
  public abstract class PropertyValidator
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_COMMON),
     "com.plumtree.portalpages.common.helpers.PropertyValidator");
    public const int VALID = 1;
    public const int INVALID = -1;
    public const int VALIDSOFAR = 0;
    protected AActivitySpace m_asOwner;
    protected PropertyValidatorOwner m_owner;
    
    /// <summary>
    /// Creates a new PropertyValidator object.
    /// </summary>
    /// <param name="owner"></param>
    public PropertyValidator(PropertyValidatorOwner owner)
    {
      m_owner = owner;
      if (m_owner != null)
      {
        m_asOwner = m_owner.asOwner();
      }
    }
    
    /// <param name="val"></param>
    /// <param name="reason"></param>
    public virtual void SetInvalid(PropertyValue val, String reason)
    {
      if (m_asOwner == null)
      {
        // usually null at creation time
        m_asOwner = m_owner.asOwner();
      }
      XPStringBuilder sb = new XPStringBuilder(100);
      String valtext = val.text();
      if ((valtext == null) || (valtext.Length == 0))
      {
        valtext = m_asOwner.GetString(55, "ptmsgs_portalcommonmsgs");
      }
      String valname = val.name();
      sb.Append(valname);
      sb.Append((XPStringUtility.EndsWith(valname, ":")) ? " " : " = ");
      sb.Append(valtext).Append(" (").Append(reason).Append(")");
      log.Warn("PropertyValidator validation error - " + sb.ToString() + ".");
      XPStringBuilder esb = m_owner.GetErrorString();
      if (esb.GetLength() > 0)
      {
        esb.Append("; ");
      }
      esb.Append(sb.ToString());
    }
    
    /// <param name="val"></param>
    /// <returns></returns>
    public virtual int validate(PropertyValue val)
    {
      if (m_asOwner == null)
      {
        // usually null at creation time
        m_asOwner = m_owner.asOwner();
      }
      return VALIDSOFAR;
    }
  }
}