using System;
using com.plumtree.openfoundation.util;
using com.plumtree.server;
namespace com.plumtree.portalpages.common.helpers
{
  /// <author>OlegS</author>
  public class ServerConfigSettings : PropertySource
  {
    protected IPTServerConfigSettings m_ptSC;
    
    /// <summary>
    /// Creates a new ServerConfigSettings object.
    /// </summary>
    /// <param name="ptSC"></param>
    public ServerConfigSettings(IPTServerConfigSettings ptSC)
    {
      m_ptSC = ptSC;
    }
    
    /// <param name="id"></param>
    /// <returns></returns>
    public override Object Get(Object id)
    {
      return m_ptSC.GetSettingAsObject(XPConvert.ToInteger(id));
    }
    
    /// <param name="id"></param>
    /// <param name="value"></param>
    public override void Set(Object id, Object value)
    {
      if (Differ(value, Get(id)))
      {
        m_ptSC.SetSetting(XPConvert.ToInteger(id), value);
      }
    }
  }
}