/*
 * Created on Apr 12, 2003
 *
 * To change this generated comment go to
 * Window>Preferences>Java>Code Generation>Code Template
 */
 
using System;
using com.plumtree.openfoundation.internationalization;
using XPCalendar=com.plumtree.openfoundation.util.XPCalendar;
using XPConvert=com.plumtree.openfoundation.util.XPConvert;
using XPDateFormat=com.plumtree.openfoundation.util.XPDateFormat;
using XPDateTime=com.plumtree.openfoundation.util.XPDateTime;
using XPException=com.plumtree.openfoundation.util.XPException;
using XPStringBuilder=com.plumtree.openfoundation.util.XPStringBuilder;
using XPHttpUtility=com.plumtree.openfoundation.web.XPHttpUtility;
using OpenLogService=com.plumtree.openlog.OpenLogService;
using OpenLogger=com.plumtree.openlog.OpenLogger;
using IInvCodeListModelRO=com.plumtree.portalpages.admin.sendinvitation.IInvCodeListModelRO;
using PTPersonalSettingsHelper=com.plumtree.portaluiinfrastructure.login.PTPersonalSettingsHelper;
using ASQueryResultWrapper=com.plumtree.portaluiinfrastructure.resultwrapper.ASQueryResultWrapper;
using PTDebugHelpers=com.plumtree.portaluiinfrastructure.statichelpers.PTDebugHelpers;
using IPTScheduler=com.plumtree.server.IPTScheduler;
using PT_JOBSTATUS=com.plumtree.server.PT_JOBSTATUS;
using PT_PROPIDS=com.plumtree.server.PT_PROPIDS;
using AActivitySpace=com.plumtree.uiinfrastructure.activityspace.AActivitySpace;
using ASURL=com.plumtree.uiinfrastructure.activityspace.ASURL;
using IModelRO=com.plumtree.uiinfrastructure.activityspace.IModelRO;
using LinkConstants=com.plumtree.uiinfrastructure.activityspace.LinkConstants;
using UIErrorLevel=com.plumtree.uiinfrastructure.errordisplay.UIErrorLevel;
using RepostControl=com.plumtree.uiinfrastructure.form.RepostControl;
using UIConstructFactory=com.plumtree.uiinfrastructure.htmlconstructs.UIConstructFactory;
using ADatePickerComponent=com.plumtree.uiinfrastructure.pagecontrols.datepicker.ADatePickerComponent;
using PageMgr=com.plumtree.uiinfrastructure.pagecontrols.framework.PageMgr;
using JSDatePickerMgr=com.plumtree.uiinfrastructure.pagecontrols.jsdatepicker.JSDatePickerMgr;
using GeneralHelpers=com.plumtree.uiinfrastructure.statichelpers.GeneralHelpers;
using ConstructStaticHelpers=com.plumtree.xpshared.htmlconstructs.ConstructStaticHelpers;
using PTBannerType=com.plumtree.xpshared.htmlconstructs.PTBannerType;
using PTButtonType=com.plumtree.xpshared.htmlconstructs.PTButtonType;
using PTConstruct=com.plumtree.xpshared.htmlconstructs.PTConstruct;
using PTImageType=com.plumtree.xpshared.htmlconstructs.PTImageType;
using PTStyleClass=com.plumtree.xpshared.htmlconstructs.PTStyleClass;
using CommonHTMLStrings=com.plumtree.xpshared.htmlelements.CommonHTMLStrings;
using HTMLAnchor=com.plumtree.xpshared.htmlelements.HTMLAnchor;
using HTMLComment=com.plumtree.xpshared.htmlelements.HTMLComment;
using HTMLElement=com.plumtree.xpshared.htmlelements.HTMLElement;
using HTMLElementCollection=com.plumtree.xpshared.htmlelements.HTMLElementCollection;
using HTMLException=com.plumtree.xpshared.htmlelements.HTMLException;
using HTMLImg=com.plumtree.xpshared.htmlelements.HTMLImg;
using HTMLInput=com.plumtree.xpshared.htmlelements.HTMLInput;
using HTMLInputTypes=com.plumtree.xpshared.htmlelements.HTMLInputTypes;
using HTMLSpan=com.plumtree.xpshared.htmlelements.HTMLSpan;
using HTMLTable=com.plumtree.xpshared.htmlelements.HTMLTable;
using HTMLTableCell=com.plumtree.xpshared.htmlelements.HTMLTableCell;
using HTMLTableRow=com.plumtree.xpshared.htmlelements.HTMLTableRow;
namespace com.plumtree.portalpages.common.joblogs
{
  /// <summary>
  /// This helper class is used in all three contexts the job history is displayed: 
  /// The automation server editor, the Job editor, and the Job History portlet.
  /// </summary>
  /// <author>JohnH</author>
  public class HistoryViewHelper
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_COMMON),
     "com.plumtree.portalpages.common.joblogs.HistoryViewHelper");
    
    /// <summary>
    /// JH- The read-only model associated with this view 
    /// </summary>
    private IJobLogModelRO m_model;
    
    /// <summary>
    /// Member variable for the parent activity space 
    /// </summary>
    private AActivitySpace m_asOwner;
    
    /// <summary>
    /// The javascript submit form 
    /// </summary>
    private String m_strSubmitForm = "";
    
    /// <summary>
    /// Boolean to indicate if this view is being displayed in a portlet 
    /// </summary>
    private bool m_bPortletView = false;
    // HTML Object names.
    
    /// <summary>
    /// HTML button to execute filter action 
    /// </summary>
    public const String HTMLBUTTON_FILTER = "in_bu_filter";
    
    /// <summary>
    /// Delete job log button 
    /// </summary>
    public const String HTMLBUTTON_DELETE = "in_bu_Delete";
    //Hidden input for the current page of job history
    
    /// <summary>
    /// Hidden HTML input for the current page number 
    /// </summary>
    public const String HTMLHIDDEN_CURRENTPAGE = "in_hi_CurrentPage";
    
    /// <summary>
    /// Hidden HTML Input for the active job instance for log download 
    /// </summary>
    public const String HTMLHIDDEN_ACTIVEINSTANCE = "in_hi_ActiveInstance";
    
    /// <summary>
    /// Hidden HTML input for the last page number 
    /// </summary>
    public const String HTMLHIDDEN_LASTPAGE = "in_hi_LastPage";
    
    /// <summary>
    /// Checkbox for selecting jobs to abort.  The value of each instance of
    /// the control on the page will be the job ID 
    /// </summary>
    public const String HTMLCHECKBOX_JOBID = "in_cb_JobID";
    
    /// <summary>
    /// Hidden field for the instance ID of the job log 
    /// </summary>
    public const String HTMLHIDDEN_INSTANCEID = "in_hi_InstanceID";
    
    /// <summary>
    /// Checkbox in the header row.  Checking this causes all the others to be checked 
    /// </summary>
    public const String HTMLCHECKBOX_CHECKALL = "in_cb_CheckAll";
    //Javascript function name for popping up the job log
    
    /// <summary>
    /// The name for the javascript function that opens a detail pop-up 
    /// </summary>
    public const String JAVASCRIPT_SHOWLOG = "OpenJobDetailPopUp";
    
    /// <summary>
    /// The name for the javascript function for downloading log files 
    /// </summary>
    public const String JAVASCRIPT_DOWNLOADLOG = "DownloadLog";
    
    /// <summary>
    /// The name for the checkall javascript function 
    /// </summary>
    public const String JAVASCRIPT_CHECKALL = "CheckAllJobs";
    //Constant controlling the number of records displayed per page
    
    /// <summary>
    /// The number of lines to display on a page 
    /// </summary>
    public const int DETAILPAGESIZE = 15;
    
    /// <summary>
    /// JH- POPUP_CONTROL_ARG_ROWTOVIEW is a querystring argument we pass to the popup so
    /// that it knows what row it's viewing 
    /// </summary>
    public const String POPUP_CONTROL_ARG_ROWTOVIEW = "ndrow";
    
    /// <summary>
    /// Querystring argument for the job name 
    /// </summary>
    public const String POPUP_CONTROL_ARG_JOBNAME = "jobname";
    
    /// <summary>
    /// Querystring argument 
    /// </summary>
    public const String POPUP_CONTROL_ARG_RUNTIME = "runtime";
    
    /// <summary>
    /// Constructor for the HistoryViewHelper class.  This helper class is used in all three
    /// contexts the job history is displayed: The automation server editor, the Job editor,
    /// and the Job History portlet.
    /// </summary>
    /// <param name="model">- The IJobLogModelRO</param>
    /// <param name="parent">- The activity space this is being called from</param>
    /// <param name="bPortletView">- True if this view is being displayed in a portlet</param>
    /// <param name="strSubmitForm">- The javascript submit form function name</param>
    public HistoryViewHelper(IModelRO model, AActivitySpace parent, bool bPortletView,
     String strSubmitForm)
    {
      m_model = (IJobLogModelRO) model;
      m_asOwner = parent;
      m_bPortletView = bPortletView;
      m_strSubmitForm = strSubmitForm;
    }
    
    /// <summary>
    /// Returns the header for the View.
    /// </summary>
    /// <param name="_sHeaderTitle">Title you want to display in the header.</param>
    /// <returns>HTMLTable</returns>
    /// <throws>XPException</throws>
    public virtual HTMLElement GetHeaderView(String _sHeaderTitle)
    {
      PTConstruct myViewBanner = null;
      try
      {
        // JF- Get the construct for the View banner
        myViewBanner = UIConstructFactory.GetConstruct(PTBannerType.OBJECT,
         true, this.m_asOwner);
        myViewBanner.ReplaceNestedElementsWithHTMLString(PTBannerType.OBJECT.TITLE_ELEMENT_NAME,
         _sHeaderTitle);
        myViewBanner.ReplaceNestedElementsWithHTMLString(PTBannerType.OBJECT.SUBTITLE_ELEMENT_NAME,
         "");
      }
      catch (Exception e)
      {
        GeneralHelpers.SetUIError(m_asOwner, OpenLogService.GetComponent("Portal_Common"),
         "HistoryViewHelper::GetHeaderView", e, true, UIErrorLevel.SERIOUS,
         m_asOwner.GetString(47, "ptmsgs_portalcommonmsgs"));
      }
      return myViewBanner.GetHTMLElement();
    }
    
    /// <summary>
    /// This function returns the javascript that should be displayed with the Job History
    /// view
    /// </summary>
    /// <returns>HTMLScript</returns>
    public virtual String GetJavascript(String strFormName)
    {
      XPStringBuilder sb;
      // The URL to open as the pop-up
      ASURL myPopUp = new ASURL(m_asOwner);
      myPopUp.SetLinkGetSpaceIfCached(JobLogAS.STR_MVC_CLASS_NAME, m_asOwner);
      myPopUp.SetDisplayPage(JobLogDisplayDP.STR_MVC_CLASS_NAME);
      //JH- We want to pass the data to our repost control so that it can be stored
      myPopUp.SetControl(JobLogRepostControl.STR_MVC_CLASS_NAME);
      //JH- Set the repost action to our special "popup" action for this URL
      myPopUp.AddControlArgument(RepostControl.HTMLINPUT_POSTTOSELF, XPConvert.ToString(JobLogRepostControl.POSTTOSELF_ACTION_JOBDETAIL_POPUP));
      sb = new XPStringBuilder(200);
      try
      {
        // Open Pop Up function
        sb.Append("function " + JAVASCRIPT_SHOWLOG + "(intInstanceID, strJobName, strRunTime)\n");
        sb.Append("{\n");
        //JH- We have to build an URL that contains the querystring argument (which contains the
        //	row number we're viewing.)
        sb.Append("  openURL = \'").Append(myPopUp.GetURLAsString()).Append("&").Append(POPUP_CONTROL_ARG_ROWTOVIEW).Append("=\' + intInstanceID + \'&").Append(POPUP_CONTROL_ARG_JOBNAME).Append("=\' + strJobName + \'&").Append(POPUP_CONTROL_ARG_RUNTIME).Append("=\' + strRunTime;\n");
        //MBS- We want our pop-up to have a scroll bar, but simple in all
        // other respects, so we cannot use the common PTUtil.js functions
        sb.Append("\tvar isNN4 = (document.layers);\n");
        sb.Append("\tvar winWidth = 800;\n");
        sb.Append("\tvar winHeight = 600;\n");
        sb.Append("\tvar scrWidth = (isNN4) ? screen.width : screen.availWidth;\n");
        sb.Append("\tvar scrHeight = (isNN4) ? screen.height : screen.availHeight;\n");
        sb.Append("\tvar leftPosVal = parseInt(scrWidth/2) - parseInt(winWidth/2);\n");
        sb.Append("\tvar topPosVal = parseInt(scrHeight/2) - parseInt(winHeight/2);\n");
        sb.Append("\tvar leftPos = (isNN4) ? \'screenX=\' + leftPosVal : \'left=\' + leftPosVal;\n");
        sb.Append("\tvar topPos = (isNN4) ? \'screenY=\' + topPosVal : \'top=\' + topPosVal;\n");
        sb.Append("\tvar winProps = \'width=\' + winWidth + \',height=\' + winHeight + \',\' + leftPos + \',\' + topPos + \',resizable=1\';\n");
        sb.Append("\twinProps += \',status=0,toolbar=0,menubar=0,scrollbars=1,location=0\';\n");
        sb.Append("\tvar winOpenedWindow = window.open(openURL,\'JobLogWindow\',winProps);\n");
        sb.Append("\twinOpenedWindow.focus();\n");
        sb.Append("}\n\n");
        // JavaScript to check all the rows
        sb.Append("function " + JAVASCRIPT_CHECKALL + "()\n");
        sb.Append("{ \n");
        sb.Append("  var frm = document." + strFormName + "; \n");
        sb.Append("  var len = frm.elements.length; \n");
        sb.Append("  var nValue = frm." + HTMLCHECKBOX_CHECKALL + ".checked; \n");
        sb.Append("  var i = 0; \n");
        sb.Append("  \n");
        sb.Append("  for(i=0 ; i<len ; i++) \n");
        sb.Append("  { \n");
        sb.Append("    if (frm.elements[i].name == \'" + HTMLCHECKBOX_JOBID + "\') \n");
        sb.Append("    { \n");
        sb.Append("       if (frm.elements[i].disabled == false)\n");
        sb.Append("           frm.elements[i].checked = nValue;\n");
        sb.Append("    } \n");
        sb.Append("  } \n");
        sb.Append("}\n");
        sb.Append("function " + JAVASCRIPT_DOWNLOADLOG + "(intInstanceID)\n");
        sb.Append("{\n");
        sb.Append("  var frm = document." + strFormName + "; \n");
        sb.Append("  frm.elements[\'" + HTMLHIDDEN_ACTIVEINSTANCE + "\'].value = intInstanceID;\n");
        sb.Append("  " + m_strSubmitForm + "(" + JobLogRepostControl.POSTTOSELF_ACTION_DOWNLOAD + "); return false;\n");
        sb.Append("}\n");
      }
      catch (HTMLException e)
      {
        GeneralHelpers.SetUIError(m_asOwner, OpenLogService.GetComponent("Portal_Common"),
         "HistoryViewHelper::GetJavascript", e, false, UIErrorLevel.SERIOUS,
         e.Message);
      }
      return sb.ToString();
    }
    
    /// <summary>
    /// Displays the HTML for the action bar.  If the actionbar is to be displayed in a 
    /// portlet, only the abort action will be enabled and visible.
    /// </summary>
    public virtual HTMLTable AddActionBar()
    {
      HTMLTable result = new HTMLTable();
      PTConstruct myButtonConstruct;
      HTMLAnchor myAnchor;
      PTButtonType myBType;
      HTMLImg myImage;
      HTMLInput myInput;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      try
      {
        //   ABORT button
        myBType = PTButtonType.ABORT_JOB;
        myButtonConstruct = UIConstructFactory.GetConstruct(myBType, true,
         this.m_asOwner);
        myButtonConstruct.ReplaceNestedElementsWithHTMLString(myBType.TITLE_ELEMENT_NAME,
         m_asOwner.GetString(629, "ptmsgs_portalcommonmsgs"));
        myImage = (HTMLImg) myButtonConstruct.GetNestedElement(myBType.IMG_ELEMENT_NAME);
        myImage.SetAlt(m_asOwner.GetString(629, "ptmsgs_portalcommonmsgs"));
        myAnchor = (HTMLAnchor) myButtonConstruct.GetNestedElement(myBType.ANCHOR_ELEMENT_NAME);
        myAnchor.SetOnClick(m_strSubmitForm + "(" + JobLogRepostControl.POSTTOSELF_ACTION_ABORT + "); return false;");
        result.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        result.SetBorder(CommonHTMLStrings.ZERO);
        result.SetCellPadding(CommonHTMLStrings.ZERO);
        result.SetCellSpacing(CommonHTMLStrings.ZERO);
        //Add the row to the table
        myRow = new HTMLTableRow();
        result.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BG);
        //First cell - the abort button
        myCell = new HTMLTableCell();
        myCell.SetNoWrap(true);
        myCell.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BTN);
        myCell.SetHeight("25");
        myRow.AddInnerHTMLElement(myCell);
        myCell.AddInnerHTMLElement(myButtonConstruct.GetHTMLElement());
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        //Second cell - divider
        myCell = new HTMLTableCell();
        myCell.SetNoWrap(true);
        myCell.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_DIVIDER);
        myCell.SetHeight("25");
        myRow.AddInnerHTMLElement(myCell);
        //Add a divider space
        myImage = (HTMLImg) UIConstructFactory.GetConstruct(PTImageType.SPACER,
         true, this.m_asOwner).GetHTMLElement();
        myCell.AddInnerHTMLElement(myImage);
        if (!(m_bPortletView))
        {
          //Third cell - "View By Date" text and datepicker input , "to" text, and datepicker input
          myCell = new HTMLTableCell();
          myCell.SetNoWrap(true);
          myCell.SetStyleClass(PTStyleClass.ACTIONBAR_TEXT);
          myCell.SetHeight("25");
          myRow.AddInnerHTMLElement(myCell);
          myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
          myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
          myCell.AddInnerHTMLString(m_asOwner.GetString(88, "ptmsgs_portalcommonmsgs"));
          myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
          JSDatePickerMgr ptDatePickerMgr = ((IJobLogModelRO) m_model).GetDatePickerControlManager();
          myCell.AddInnerHTMLElement(ptDatePickerMgr.GetComponentHTML(JobLogModel.FILTER_FROM));
          //the To text
          myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
          myCell.AddInnerHTMLString(m_asOwner.GetString(89, "ptmsgs_portalcommonmsgs"));
          myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
          //Add the "to" date picker
          myCell.AddInnerHTMLElement(ptDatePickerMgr.GetComponentHTML(JobLogModel.FILTER_TO));
          //The Filter List button
          myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_FILTER,
           m_asOwner.GetString(90, "ptmsgs_portalcommonmsgs"));
          //myInput.SetValue(m_asOwner.GetString(90, "ptmsgs_portalcommonmsgs"));
          myInput.SetValue(">>");
          myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
          myInput.SetOnClick(m_strSubmitForm + "(" + JobLogRepostControl.POSTTOSELF_ACTION_SIMPLEREPOST + "); return false;");
          //Add the button
          myCell.AddInnerHTMLElement(myInput);
          myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
          //Fourth cell - divider
          myCell = new HTMLTableCell();
          myCell.SetNoWrap(true);
          myCell.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_DIVIDER);
          myCell.SetHeight("25");
          myRow.AddInnerHTMLElement(myCell);
          //Add a divider space
          myCell.AddInnerHTMLElement(myImage);
          int intJobID = ((IJobLogModelRO) m_model).GetJobID();
          // SCC - only display Delete buttons for the general job history view
          if (0 == intJobID)
          {
            //Fifth cell - Delete Older Than date picker and button
            myCell = new HTMLTableCell();
            myCell.SetNoWrap(true);
            myCell.SetStyleClass(PTStyleClass.ACTIONBAR_TEXT);
            myCell.SetHeight("25");
            myRow.AddInnerHTMLElement(myCell);
            myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
            myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
            //Now add the delete text and button
            myCell.AddInnerHTMLString(m_asOwner.GetString(86, "ptmsgs_portalcommonmsgs"));
            myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
            //The delete date picker
            myCell.AddInnerHTMLElement(ptDatePickerMgr.GetComponentHTML(JobLogModel.DELETE_THROUGH));
            //the delete button
            myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_DELETE,
             m_asOwner.GetString(87, "ptmsgs_portalcommonmsgs"));
            myInput.SetValue(">>");
            myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
            myInput.SetOnClick(m_strSubmitForm + "(" + JobLogRepostControl.POSTTOSELF_ACTION_DELETEHISTORY + "); return false;");
            myCell.AddInnerHTMLElement(myInput);
            myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
            //Sixth cell - divider
            myCell = new HTMLTableCell();
            myCell.SetNoWrap(true);
            myCell.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_DIVIDER);
            myCell.SetHeight("25");
            myRow.AddInnerHTMLElement(myCell);
            //Add a divider space
            myImage = (HTMLImg) UIConstructFactory.GetConstruct(PTImageType.SPACER,
             true, this.m_asOwner).GetHTMLElement();
            myCell.AddInnerHTMLElement(myImage);
          }
        }
        //Ninth cell - refresh
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BTN);
        myCell.SetHeight("25");
        myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
        PTConstruct myConstruct = UIConstructFactory.GetConstruct(PTImageType.ACTION_REFRESH,
         true, this.m_asOwner);
        myImage = (HTMLImg) myConstruct.GetHTMLElement();
        myImage.SetAlt(m_asOwner.GetString(667, "ptmsgs_portalcommonmsgs"));
        myImage.SetAlign(CommonHTMLStrings.ABSMIDDLE);
        myAnchor.AddInnerHTMLElement(myImage);
        myAnchor.SetOnClick(m_strSubmitForm + "(" + RepostControl.POSTTOSELF_ACTION_SIMPLEREPOST + "); return false;");
        myCell.AddInnerHTMLElement(myAnchor);
        myRow.AddInnerHTMLElement(myCell);
      }
      catch (Exception ex)
      {
        GeneralHelpers.SetUIError(m_asOwner, OpenLogService.GetComponent("Portal_Common"),
         "HistoryViewHelper::AddActionBar", ex, false, UIErrorLevel.SERIOUS,
         m_asOwner.GetString(668, "ptmsgs_portalcommonmsgs"));
      }
      return result;
    }
    
    /// <summary>
    /// This function returns the list of jobs in an ASQueryResultWrapper
    /// </summary>
    /// <returns>ASQueryResultWrapper</returns>
    public virtual ASQueryResultWrapper GetJobHistoryList()
    {
      ASQueryResultWrapper myQueryResult = null;
      try
      {
        int intJobID = ((IJobLogModelRO) m_model).GetJobID();
        IPTScheduler ptScheduler = ((IJobLogModelRO) m_model).GetPTSession().GetScheduler();
        JSDatePickerMgr myMgr = ((IJobLogModelRO) m_model).GetDatePickerControlManager();
        PageMgr myPageMgr = myMgr.GetPageMgr();
        ADatePickerComponent myDatePicker = (ADatePickerComponent) myMgr.GetComponent(JobLogModel.FILTER_FROM);
        XPLocale myUSLocale = new XPLocale("EN", "us");
        XPDateFormat myFormat = XPDateFormat.GetDateInstance(XPDateFormat.MEDIUM,
         myUSLocale, myPageMgr.GetTimeZone());
        XPDateTime xpFromDate;
        XPDateTime xpToDate;
        String mySelectedString = myDatePicker.GetSelectedDateAsString();
        if ((null != mySelectedString) && !(mySelectedString.Equals("")))
        {
          xpFromDate = myFormat.Parse(myDatePicker.GetSelectedDateAsString());
          } else
        {
          // Let this be the default date...
          XPCalendar xpCalendar = XPCalendar.GetInstance(1999, 1, 1, 1, 0,
           0);
          XPDateTime xpdtHistoryStart = xpCalendar.GetTime();
          xpFromDate = xpdtHistoryStart;
        }
        myDatePicker = (ADatePickerComponent) myMgr.GetComponent(JobLogModel.FILTER_TO);
        mySelectedString = myDatePicker.GetSelectedDateAsString();
        if ((null != mySelectedString) && !(mySelectedString.Equals("")))
        {
          // JHQ 012703 - bug 27370: in CL 103882 this code was changed
          // to use XPDateTime objects instead of PTDateTime.  In that
          // change the variable xpFromDate was used here instead of
          // xpToDate.  Just a typo.  TODO: xpToDate whould be declared
          // closer to this block of code versus where the From date is
          // declared.
          xpToDate = myFormat.Parse(myDatePicker.GetSelectedDateAsString());
          /* The DatePicker returns the date with the time set to midnight
           * which means that the query will not return any jobs run on
           * the "to" date.  Create a calendar here so that we can change
           * the hour to include the "to" date.
           */
           
          XPCalendar xpCalendar = XPCalendar.GetInstance();
          xpCalendar.SetTime(xpToDate);
          xpCalendar.Set(XPCalendar.HOUR, 11);
          xpCalendar.Set(XPCalendar.MINUTE, 59);
          xpCalendar.Set(XPCalendar.SECOND, 59);
          xpCalendar.Set(XPCalendar.AM_PM, XPCalendar.PM);
          xpToDate = xpCalendar.GetTime();
        } else
        {
          xpToDate = new XPDateTime();
        }
        //Query the job history
        if (intJobID >= 0)
        {
          myQueryResult = new ASQueryResultWrapper(ptScheduler.QueryJobHistory(xpFromDate,
           xpToDate, intJobID));
        }
      }
      catch (Exception e)
      {
        GeneralHelpers.SetUIError(m_asOwner, OpenLogService.GetComponent("Portal_Common"),
         "HistoryViewHelper::GetJobHistoryList", e, true, UIErrorLevel.SERIOUS,
         m_asOwner.GetString(62, "ptmsgs_portalcommonmsgs"));
      }
      return myQueryResult;
    }
    
    /// <summary>
    /// Returns the header row for the job list
    /// </summary>
    /// <returns>HTMLElement</returns>
    public virtual HTMLTableRow GetHeaderRow()
    {
      HTMLTableRow result = null;
      HTMLTableCell myCell;
      HTMLInput myInput;
      try
      {
        //1st row begin (Job history header row)
        result = new HTMLTableRow();
        result.SetStyleClass(PTStyleClass.LIST_SORT_HEADER_BG);
        //JobID checkbox
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        result.AddInnerHTMLElement(myCell);
        myInput = new HTMLInput(HTMLInputTypes.CHECKBOX, HTMLCHECKBOX_CHECKALL,
         m_asOwner.GetString(628, "ptmsgs_portalcommonmsgs"));
        myInput.SetAlign("center");
        myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
        //Set this to an invalid value so it can be ignored when/if it comes back as checked
        myInput.SetValue("-1");
        myInput.SetOnClick(JAVASCRIPT_CHECKALL + "(); return true;");
        myCell.AddInnerHTMLElement(myInput);
        //Name
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        result.AddInnerHTMLElement(myCell);
        myCell.AddInnerHTMLString(m_asOwner.GetString(67, "ptmsgs_portalcommonmsgs"));
        //Server		
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        result.AddInnerHTMLElement(myCell);
        myCell.AddInnerHTMLString(m_asOwner.GetString(68, "ptmsgs_portalcommonmsgs"));
        //Next Run Date
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        result.AddInnerHTMLElement(myCell);
        myCell.AddInnerHTMLString(m_asOwner.GetString(69, "ptmsgs_portalcommonmsgs"));
        //Start date
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        result.AddInnerHTMLElement(myCell);
        myCell.AddInnerHTMLString(m_asOwner.GetString(70, "ptmsgs_portalcommonmsgs"));
        //Finish date
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        result.AddInnerHTMLElement(myCell);
        myCell.AddInnerHTMLString(m_asOwner.GetString(71, "ptmsgs_portalcommonmsgs"));
        //Status
        myCell = new HTMLTableCell();
        myCell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
        result.AddInnerHTMLElement(myCell);
        myCell.AddInnerHTMLString(m_asOwner.GetString(72, "ptmsgs_portalcommonmsgs"));
        if (!(m_bPortletView))
        {
          //Download to file
          myCell = new HTMLTableCell();
          myCell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
          result.AddInnerHTMLElement(myCell);
          myCell.AddInnerHTMLString(m_asOwner.GetString(2181, "ptmsgs_portaladminmsgs"));
          }
      }
      catch (Exception e)
      {
        GeneralHelpers.SetUIError(m_asOwner, OpenLogService.GetComponent("Portal_Common"),
         "HistoryViewHelper::GetTableRows", e, true, UIErrorLevel.SERIOUS,
         e.Message);
      }
      return result;
    }
    
    /// <summary>
    /// Returns the HTML table that contains the list of jobs
    /// </summary>
    /// <param name="intNumResults">- The number of results that will be displayed</param>
    /// <returns>HTMLTable</returns>
    public virtual HTMLElement GetTableRows(int intNumResults, ASQueryResultWrapper myQueryResult)
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTableCell myCell;
      HTMLTableRow myRow;
      HTMLAnchor myAnchor;
      HTMLInput myInput;
      HTMLSpan mySpan;
      try
      {
        int intCurrentPage = ((IJobLogModelRO) m_model).GetCurrentPage();
        int intIndex = (intCurrentPage * DETAILPAGESIZE) - DETAILPAGESIZE;
        for (int i = intIndex;((i < intNumResults) && (i < (intIndex + DETAILPAGESIZE)));
        i++)
        {
          Object intJobID = myQueryResult.GetFields(i, PT_PROPIDS.PT_PROPID_JOBHISTORY_JOBID);
          myRow = new HTMLTableRow();
          result.AddInnerHTMLElement(myRow);
          //Alternate styles by row number
          if ((i % 2) == 1)
          {
            myRow.SetStyleClass(PTStyleClass.LIST_ITEM_ONE_BG);
          } else
          {
            myRow.SetStyleClass(PTStyleClass.LIST_ITEM_TWO_BG);
          }
          //Job ID checkbox
          myCell = new HTMLTableCell();
          myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
          myRow.AddInnerHTMLElement(myCell);
          myInput = new HTMLInput(HTMLInputTypes.CHECKBOX, HTMLCHECKBOX_JOBID,
           m_asOwner.GetString(628, "ptmsgs_portalcommonmsgs"));
          myInput.SetAlign("center");
          myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
          myCell.AddInnerHTMLElement(myInput);
          //Retrieve the job id and set the value of the checkbox
          if (null != intJobID)
          {
            myInput.SetValue(XPConvert.ToString(intJobID));
          } else
          {
            myInput.SetValue("-1");
          }
          //If the job isn't running, disable the checkbox
          switch (XPConvert.ToInteger(myQueryResult.GetFields(i, PT_PROPIDS.PT_PROPID_JOBHISTORY_JOBSTATUS))){
          case PT_JOBSTATUS.PT_JOBSTATUS_INPROCESS:
          case PT_JOBSTATUS.PT_JOBSTATUS_SAVINGCHECKPOINT:
          break;
          default:
          myInput.SetDisabled(true);
          break;
          }
          //Job Name
          myCell = new HTMLTableCell();
          myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
          myRow.AddInnerHTMLElement(myCell);
          int intInstanceID = XPConvert.ToInteger(myQueryResult.GetFields(i,
           PT_PROPIDS.PT_PROPID_JOBHISTORY_INSTANCEID));
          String strJobName = (String) myQueryResult.GetFields(i, PT_PROPIDS.PT_PROPID_JOBHISTORY_JOBNAME);
          XPDateTime dtRunTime = (XPDateTime) myQueryResult.GetFields(i, PT_PROPIDS.PT_PROPID_JOBHISTORY_RUNTIME);
          XPDateFormat xpdfFormat = XPDateFormat.GetDateTimeInstance(XPDateFormat.MEDIUM,
           XPDateFormat.MEDIUM, PTPersonalSettingsHelper.GetPersonalSettingValue_Locale(m_asOwner),
           PTPersonalSettingsHelper.GetPersonalSettingValue_TimeZone(m_asOwner));
          if (null == dtRunTime)
          {
            dtRunTime = new XPDateTime();
          }
          String strRunTime = xpdfFormat.Format(dtRunTime);
          myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
          myAnchor.SetOnClick(JAVASCRIPT_SHOWLOG + "(" + intInstanceID + ",\'" + XPHttpUtility.UrlEncode(strJobName,
           LinkConstants.UTF_8_ENCODING) + "\',\'" + XPHttpUtility.UrlEncode(strRunTime,
           LinkConstants.UTF_8_ENCODING) + "\'); return false;");
          myAnchor.AddInnerHTMLEncodedString(strJobName);
          myCell.AddInnerHTMLElement(myAnchor);
          //Add the instance ID hidden field here as well
          myInput = new HTMLInput(HTMLInputTypes.HIDDEN, HTMLHIDDEN_INSTANCEID,
           "");
          myInput.SetValue(XPConvert.ToString(intInstanceID));
          myCell.AddInnerHTMLElement(myInput);
          //Server
          myCell = AddFieldToCell(myQueryResult.GetFields(i, PT_PROPIDS.PT_PROPID_JOBHISTORY_SERVERNAME),
           m_asOwner.GetString(68, "ptmsgs_portalcommonmsgs"));
          myRow.AddInnerHTMLElement(myCell);
          //Next Run
          XPDateTime dtNextRun = (XPDateTime) myQueryResult.GetFields(i, PT_PROPIDS.PT_PROPID_JOBHISTORY_NEXTRUNTIME);
          String strNextRun;
          if (null != dtNextRun)
          {
            strNextRun = xpdfFormat.Format(dtNextRun);
          } else
          {
            strNextRun = "";
          }
          myCell = AddFieldToCell(strNextRun, m_asOwner.GetString(69, "ptmsgs_portalcommonmsgs"));
          myRow.AddInnerHTMLElement(myCell);
          //Start
          myCell = AddFieldToCell(strRunTime, m_asOwner.GetString(70, "ptmsgs_portalcommonmsgs"));
          myRow.AddInnerHTMLElement(myCell);
          //Finish
          XPDateTime dtFinish = (XPDateTime) myQueryResult.GetFields(i, PT_PROPIDS.PT_PROPID_JOBHISTORY_FINISHTIME);
          String strFinish;
          if (null != dtFinish)
          {
            strFinish = xpdfFormat.Format(dtFinish);
          } else
          {
            strFinish = "";
          }
          myCell = AddFieldToCell(strFinish, m_asOwner.GetString(71, "ptmsgs_portalcommonmsgs"));
          myRow.AddInnerHTMLElement(myCell);
          //Status
          myCell = new HTMLTableCell();
          myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
          myRow.AddInnerHTMLElement(myCell);
          int myStatus = XPConvert.ToInteger(myQueryResult.GetFields(i, PT_PROPIDS.PT_PROPID_JOBHISTORY_JOBSTATUS));
          if (myStatus == PT_JOBSTATUS.PT_JOBSTATUS_FAILED)
          {
            mySpan = new HTMLSpan();
            mySpan.SetStyleClass(PTStyleClass.ALERT_ERROR_TEXT);
            mySpan.AddInnerHTMLString(GetStatusString(myStatus));
            myCell.AddInnerHTMLElement(mySpan);
          } else
          {
            mySpan = new HTMLSpan();
            mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
            mySpan.AddInnerHTMLString(GetStatusString(myStatus));
            myCell.AddInnerHTMLElement(mySpan);
          }
          if (!(m_bPortletView))
          {
            //Download the file
            myCell = new HTMLTableCell();
            myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
            myRow.AddInnerHTMLElement(myCell);
            HTMLImg myImage = (HTMLImg) UIConstructFactory.GetConstruct(PTImageType.ACTION_SAVE).GetHTMLElement();
            myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
            myAnchor.SetOnClick(JAVASCRIPT_DOWNLOADLOG + "(" + intInstanceID + "); return false;");
            myAnchor.AddInnerHTMLElement(myImage);
            myCell.AddInnerHTMLElement(myAnchor);
          }
        }
      }
      catch (Exception e)
      {
        GeneralHelpers.SetUIError(m_asOwner, OpenLogService.GetComponent("Portal_Common"),
         "HistoryViewHelper::GetTableRows", e, true, UIErrorLevel.SERIOUS,
         e.Message);
      }
      return result;
    }
    
    /// <summary>
    /// Return the HTML for the Next and Previous pageination links displayed
    /// at the end of the job log list
    /// </summary>
    /// <param name="intNumPages">- The total number of pages to display</param>
    /// <param name="intCurPage">- The page currently displayed</param>
    /// <returns>HTMLTableRow</returns>
    public virtual HTMLTableRow GetPreviousNextLinks(int intNumPages, int intCurPage)
    {
      HTMLTableRow myRow = null;
      HTMLTableCell myCell;
      HTMLAnchor myAnchor;
      try
      {
        //1st row begin
        myRow = new HTMLTableRow();
        myRow.SetStyleClass(PTStyleClass.LIST_TEXT);
        myCell = new HTMLTableCell();
        myCell.SetColSpan("7");
        myCell.SetAlign("right");
        myRow.AddInnerHTMLElement(myCell);
        //Previous and Next HREF's
        if (0 != intNumPages)
        {
          bool bIsFirstPage = (intCurPage == 1);
          bool bIsLastPage = (intCurPage == intNumPages);
          if (!bIsFirstPage)
          {
            //Show the First page and Previous Page links
            //The First page link
            myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
            myAnchor.SetOnClick(m_strSubmitForm + "(" + JobLogRepostControl.POSTTOSELF_ACTION_FIRSTHISTORYPAGE + "); return false;");
            myAnchor.AddInnerHTMLString(m_asOwner.GetString(65, "ptmsgs_portalcommonmsgs"));
            myCell.AddInnerHTMLElement(myAnchor);
            myCell.AddInnerHTMLString(" | ");
            //The Previous page link
            myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
            myAnchor.SetOnClick(m_strSubmitForm + "(" + JobLogRepostControl.POSTTOSELF_ACTION_PREVIOUSHISTORYPAGE + "); return false;");
            myAnchor.AddInnerHTMLString(m_asOwner.GetString(63, "ptmsgs_portalcommonmsgs"));
            myCell.AddInnerHTMLElement(myAnchor);
          }
          if (!bIsLastPage)
          {
            if (!bIsFirstPage)
            {
              myCell.AddInnerHTMLString("  ||  ");
            }
            //Show the Next page and Last Page links
            //The Next page link
            myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
            myAnchor.SetOnClick(m_strSubmitForm + "(" + JobLogRepostControl.POSTTOSELF_ACTION_NEXTHISTORYPAGE + "); return false;");
            myAnchor.AddInnerHTMLString(m_asOwner.GetString(64, "ptmsgs_portalcommonmsgs"));
            myCell.AddInnerHTMLElement(myAnchor);
            myCell.AddInnerHTMLString(" | ");
            //The Last page link
            myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
            myAnchor.SetOnClick(m_strSubmitForm + "(" + JobLogRepostControl.POSTTOSELF_ACTION_LASTHISTORYPAGE + "); return false;");
            myAnchor.AddInnerHTMLString(m_asOwner.GetString(66, "ptmsgs_portalcommonmsgs"));
            myCell.AddInnerHTMLElement(myAnchor);
          }
        }
      }
      catch (Exception e)
      {
        GeneralHelpers.SetUIError(m_asOwner, OpenLogService.GetComponent("Portal_Common"),
         "HistoryViewHelper::GetPreviousNextLinks", e, true, UIErrorLevel.SERIOUS,
         e.Message);
      }
      return myRow;
    }
    
    /// <summary>
    /// Display the HTML for the list of jobs with links to their logs
    /// </summary>
    /// <returns>HTMLElement</returns>
    public virtual HTMLElement GetJobLogDetail()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable myTable;
      HTMLTableRow myRow;
      ASQueryResultWrapper myQueryResult = null;
      HTMLInput myInput;
      int intNumResults = 0;
      int intNumPages = 0;
      try
      {
        //Get the job history list
        myQueryResult = GetJobHistoryList();
        if (null != myQueryResult)
        {
          intNumResults = myQueryResult.GetCount();
          if (0 != (intNumResults % DETAILPAGESIZE))
          {
            intNumPages = (intNumResults / DETAILPAGESIZE) + 1;
          } else
          {
            intNumPages = intNumResults / DETAILPAGESIZE;
          }
        }
        int intCurPage = ((IJobLogModelRO) m_model).GetCurrentPage();
        HTMLComment myComment = new HTMLComment("Begin: Display HistoryDetailView");
        result.AddInnerHTMLElement(myComment);
        myInput = new HTMLInput(HTMLInputTypes.HIDDEN, HTMLHIDDEN_ACTIVEINSTANCE,
         "");
        result.AddInnerHTMLElement(myInput);
        myInput = new HTMLInput(HTMLInputTypes.HIDDEN, HTMLHIDDEN_CURRENTPAGE,
         "");
        myInput.SetValue(XPConvert.ToString(intCurPage));
        result.AddInnerHTMLElement(myInput);
        myInput = new HTMLInput(HTMLInputTypes.HIDDEN, HTMLHIDDEN_LASTPAGE,
         "");
        myInput.SetValue(XPConvert.ToString(intNumPages));
        result.AddInnerHTMLElement(myInput);
        //Start the job list table
        myTable = new HTMLTable();
        result.AddInnerHTMLElement(myTable);
        myTable.SetWidth("100%");
        myTable.SetBorder("0");
        myTable.SetCellPadding("5");
        myTable.SetCellSpacing("2");
        myTable.AddInnerHTMLElement(GetHeaderRow());
        //Retrieve the HTML for the job list and next/previous links
        if ((null != myQueryResult) && (0 != intNumResults))
        {
          myTable.AddInnerHTMLElement(GetTableRows(intNumResults, myQueryResult));
          if (0 != intNumPages)
          {
            myRow = GetPreviousNextLinks(intNumPages, intCurPage);
            myTable.AddInnerHTMLElement(myRow);
          }
        }
      }
      catch (Exception e)
      {
        GeneralHelpers.SetUIError(m_asOwner, OpenLogService.GetComponent("Portal_Common"),
         "HistoryViewHelper::GetJobLogDetail", e, true, UIErrorLevel.SERIOUS,
         m_asOwner.GetString(61, "ptmsgs_portalcommonmsgs"));
      }
      return result;
    }
    
    /// <summary>
    /// This helper function returns a cell with the appropriate style and
    /// queryresult field added.  It sets a blank string on the cell if the
    /// argument is null.
    /// </summary>
    /// <param name="objField"></param>
    /// <param name="strField"></param>
    /// <returns>HTMLTableCell</returns>
    public virtual HTMLTableCell AddFieldToCell(Object objField, String strField)
    {
      HTMLTableCell myCell = new HTMLTableCell();
      try
      {
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        if (null == objField)
        {
          myCell.AddInnerHTMLString("");
        } else
        {
          myCell.AddInnerHTMLString(XPConvert.ToString(objField));
        }
      }
      catch (Exception e)
      {
        XPStringBuilder sb = new XPStringBuilder(50);
        sb.Append(m_asOwner.GetString(534, "ptmsgs_portalcommonmsgs")).Append(strField);
        GeneralHelpers.SetUIError(m_asOwner, OpenLogService.GetComponent("Portal_Common"),
         "HistoryViewHelper::AddFieldToCell", e, true, UIErrorLevel.SERIOUS,
         sb.ToString());
      }
      return myCell;
    }
    
    /// <summary>
    /// This helper function translates PT_JOBSTATUS numbers into localized
    /// string values
    /// </summary>
    public virtual String GetStatusString(int intStatus)
    {
      switch (intStatus){
      case PT_JOBSTATUS.PT_JOBSTATUS_FAILED:
      return m_asOwner.GetString(76, "ptmsgs_portalcommonmsgs");
      goto case PT_JOBSTATUS.PT_JOBSTATUS_INPROCESS;
      case PT_JOBSTATUS.PT_JOBSTATUS_INPROCESS:
      return m_asOwner.GetString(77, "ptmsgs_portalcommonmsgs");
      goto case PT_JOBSTATUS.PT_JOBSTATUS_INTERRUPTED;
      case PT_JOBSTATUS.PT_JOBSTATUS_INTERRUPTED:
      return m_asOwner.GetString(78, "ptmsgs_portalcommonmsgs");
      goto case PT_JOBSTATUS.PT_JOBSTATUS_INVALID;
      case PT_JOBSTATUS.PT_JOBSTATUS_INVALID:
      return m_asOwner.GetString(79, "ptmsgs_portalcommonmsgs");
      goto case PT_JOBSTATUS.PT_JOBSTATUS_SAVINGCHECKPOINT;
      case PT_JOBSTATUS.PT_JOBSTATUS_SAVINGCHECKPOINT:
      return m_asOwner.GetString(80, "ptmsgs_portalcommonmsgs");
      goto case PT_JOBSTATUS.PT_JOBSTATUS_SUCCEEDED;
      case PT_JOBSTATUS.PT_JOBSTATUS_SUCCEEDED:
      return m_asOwner.GetString(81, "ptmsgs_portalcommonmsgs");
      goto case PT_JOBSTATUS.PT_JOBSTATUS_SUSPENDED;
      case PT_JOBSTATUS.PT_JOBSTATUS_SUSPENDED:
      return m_asOwner.GetString(82, "ptmsgs_portalcommonmsgs");
      goto case PT_JOBSTATUS.PT_JOBSTATUS_SUSPENDING;
      case PT_JOBSTATUS.PT_JOBSTATUS_SUSPENDING:
      return m_asOwner.GetString(83, "ptmsgs_portalcommonmsgs");
      goto case PT_JOBSTATUS.PT_JOBSTATUS_KILLREQUESTED;
      case PT_JOBSTATUS.PT_JOBSTATUS_KILLREQUESTED:
      return m_asOwner.GetString(633, "ptmsgs_portalcommonmsgs");
      goto default;
      default:
      return m_asOwner.GetString(84, "ptmsgs_portalcommonmsgs");
      break;
      }
    }
  }
}