using System;
// Framework Imports
using com.plumtree.uiinfrastructure.constants;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.common.joblogs
{
  /// <summary>
  /// This class extends EditorDP and displays the History page of the Job Editor.
  /// </summary>
  public class JobLogDisplayDP : AFormDP
  {
    
    /// <summary>
    /// The unique name for the class 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "JobLogDisplayDP";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()"></seealso>
    public override String GetFormTitle()
    {
      return m_asOwner.GetString(93, "ptmsgs_portalcommonmsgs");
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for the Job Log Display page.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException </throws>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      //Just ask the view to display itself
      result.AddInnerHTMLElement(m_asOwner.GetView(JobLogDisplayView.STR_MVC_CLASS_NAME).Display());
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(JobLogDisplayView.STR_MVC_CLASS_NAME).DisplayJavascript());
      return myScripts;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.form.AFormDP#GetUseJavascript()
     */
     
    public override bool GetUseJavascript()
    {
      if (AccessStyles.LOW_BANDWIDTH == m_asOwner.GetAccessStyle())
      {
        return true;
      } else
      {
        return base.GetUseJavascript();
      }
    }
  }
}