using System;
// Framework Imports
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.pagecontrols.jsdatetimepicker;
namespace com.plumtree.portalpages.common.linksettings
{
  /// <author>
  /// StephenC
  /// This interface is implemented by the Model.
  /// It contains all the read-only mothods of the Model
  /// accessed by the Views.
  /// </author>
  public interface ILinkSettingsPlugInModelRO
  {
    
    /// <returns></returns>
    int GetBrokenLinksDeleteUnits();
    
    /// <returns></returns>
    int GetBrokenLinksDeleteValue();
    
    /// <returns></returns>
    bool GetCheckLinkOnly();
    
    /// <returns></returns>
    XPDateTime GetDisplayExpirationDate();
    
    /// <returns></returns>
    int GetExpireAfterUnits();
    
    /// <returns></returns>
    int GetExpireAfterValue();
    
    /// <returns></returns>
    int GetRefreshUnits();
    
    /// <returns></returns>
    int GetRefreshValue();
    
    /// <returns></returns>
    bool IsCrawler();
    
    /// <returns></returns>
    bool IsExpirationDateNull();
    
    /// <returns></returns>
    bool IsMultiple();
    
    /// <returns></returns>
    JSDateTimePickerMgr GetDateTimePickerControlManager();
  }
}