using System;
using com.plumtree.openfoundation.util;
using com.plumtree.server;
namespace com.plumtree.portalpages.common.objects.sort
{
  /// <author>OlegS</author>
  public class PTObjectNameComparator : IXPComparer
  {
    protected IPTObjectNameGetter ptNameGetter = null;
    protected IPTSession ptSession = null;
    protected bool ascending = true;
    
    /// <summary>
    /// Creates a new PTObjectNameComparator object.
    /// </summary>
    /// <param name="g"></param>
    /// <param name="s"></param>
    /// <param name="a"></param>
    public PTObjectNameComparator(IPTObjectNameGetter g, IPTSession s, bool a)
    {
      ptNameGetter = g;
      ptSession = s;
      ascending = a;
    }
    
    /// <param name="o1"></param>
    /// <param name="o2"></param>
    /// <returns></returns>
    public virtual int Compare(Object o1, Object o2)
    {
      PTObjectIdNamePair p1 = (PTObjectIdNamePair) o1;
      PTObjectIdNamePair p2 = (PTObjectIdNamePair) o2;
      if (p1.id == p2.id)
      {
        return 0;
      }
      String name1 = (p1.name == null) ? ptNameGetter.GetName(p1.id, ptSession) : p1.name;
      String name2 = (p2.name == null) ? ptNameGetter.GetName(p2.id, ptSession) : p2.name;
      int result = ((name1 == null) || (name2 == null)) ? 0 : name1.CompareTo(name2);
      if (!ascending)
      {
        result = -result;
      }
      return result;
    }
    
    /// <param name="o1"></param>
    /// <param name="o2"></param>
    /// <returns></returns>
    public virtual int compare(Object o1, Object o2)
    {
      return Compare(o1, o2);
    }
  }
}