/*
 * Created on Mar 5, 2003
 *
 */
 
using System;
using com.plumtree.openfoundation.util;
namespace com.plumtree.portalpages.common.plugnav
{
  /// <summary>
  /// Useful helper class that forms a list of all possible 
  /// page types for pluggable navigation
  /// </summary>
  /// <author>DavidP</author>
  public class NavCategoryHelper
  {
    private XPArrayList navCategoryArray = null;
    public static readonly NavCategoryHelper INSTANCE = new NavCategoryHelper();
    
    /// <summary>
    /// Constructs helper class with accessors for array of page types.
    /// </summary>
    private NavCategoryHelper()
    {
      navCategoryArray = new XPArrayList();
      for (int i = 0;i < NavCategoryType.m_navCategoryTypes.Length;++i)
      {
        navCategoryArray.Add(NavCategoryType.m_navCategoryTypes[i]);
      }
    }
    
    /// <summary>
    /// Enumerates the possible page types available.
    /// </summary>
    /// <returns>IXPEnumerator</returns>
    public virtual IXPEnumerator GetCategoryTypes()
    {
      IXPEnumerator eKeys = null;
      if (navCategoryArray != null && navCategoryArray.GetSize() > 0)
      {
        eKeys = navCategoryArray.GetEnumerator();
      }
      return eKeys;
    }
    
    /// <summary>
    /// Enumerates the possible page types available.
    /// </summary>
    /// <returns>XPArrayList</returns>
    public virtual XPArrayList GetCategoryTypeArray()
    {
      return navCategoryArray;
    }
    
    /// <summary>
    /// Returns the number of page types.
    /// </summary>
    /// <returns>int</returns>
    public virtual int GetNumCategoryTypes()
    {
      if (navCategoryArray != null)
      {
        return navCategoryArray.GetSize();
      }
      return 0;
    }
  }
}