/*
 * Created on Mar 7, 2003
 */
 
using System;
namespace com.plumtree.portalpages.common.plugnav
{
  /// <summary>
  /// Navigation link category types.  These are *different* from NavPageType because they 
  /// represent groups of navigation links, and are independent of the "page type" actually 
  /// showing in the center of the page.  Example: Mandatory linkshave nothing to do with 
  /// the page you're on.
  /// </summary>
  /// <author>DavidP</author>
  public class NavCategoryType
  {
    private String m_className;
    // enumeration of navigation link category types
    // Administrator
    public static readonly NavCategoryType ADMIN = new NavCategoryType("ADMIN");
    // My Pages
    public static readonly NavCategoryType MYPAGE = new NavCategoryType("MYPAGE");
    // Community Pages
    public static readonly NavCategoryType COMMUNITY = new NavCategoryType("COMMUNITY");
    // Directory
    public static readonly NavCategoryType DIRECTORY = new NavCategoryType("DIRECTORY");
    // (name of mandatory links folder)
    public static readonly NavCategoryType MANDATORYLINK = new NavCategoryType("MANDATORYLINK");
    // Mandatory Communities
    public static readonly NavCategoryType MANDATORYTABS = new NavCategoryType("MANDATORYTABS");
    // My Communities
    public static readonly NavCategoryType MYCOMMUNITIES = new NavCategoryType("MYCOMMUNITIES");
    // My Home
    public static readonly NavCategoryType MYHOME = new NavCategoryType("MYHOME");
    // array of navigation link category types
    public static readonly NavCategoryType[] m_navCategoryTypes = {ADMIN,
     MYPAGE, COMMUNITY, DIRECTORY, MANDATORYLINK, MANDATORYTABS, MYCOMMUNITIES,
     MYHOME};
    
    /// <param name="className"></param>
    private NavCategoryType(String className)
    {
      m_className = className;
    }
    
    /// <seealso cref="java.lang.Object#toString()"></seealso>
    public override String ToString()
    {
      return m_className;
    }
    
    /// <summary>
    /// Hash ID
    /// </summary>
    /// <returns>int</returns>
    public virtual int GetID()
    {
      return m_className.GetHashCode();
    }
    
    /// <seealso cref="java.lang.Object#equals(Object)"></seealso>
    public sealed override bool Equals(Object o)
    {
      bool retval = false;
      try
      {
        retval = ((NavCategoryType) o).ToString().Equals(m_className);
      }
      catch (Exception e)
      {
      }
      return retval;
    }
  }
}