/*
 * Created on Mar 5, 2003
 *
 */
 
using System;
using com.plumtree.openfoundation.util;
namespace com.plumtree.portalpages.common.plugnav
{
  /// <summary>
  /// Useful helper class that forms a list of all possible 
  /// page types for pluggable navigation
  /// </summary>
  /// <author>DavidP</author>
  public class NavPageHelper
  {
    private XPArrayList navPageArray = null;
    public static readonly NavPageHelper INSTANCE = new NavPageHelper();
    
    /// <summary>
    /// Constructs helper class with accessors for array of page types.
    /// </summary>
    private NavPageHelper()
    {
      navPageArray = new XPArrayList();
      for (int i = 0;i < NavPageType.m_navPageTypes.Length;++i)
      {
        navPageArray.Add(NavPageType.m_navPageTypes[i]);
      }
    }
    
    /// <summary>
    /// Enumerates the possible page types available.
    /// </summary>
    /// <returns>IXPEnumerator</returns>
    public virtual IXPEnumerator GetPageTypes()
    {
      IXPEnumerator eKeys = null;
      if (navPageArray != null && navPageArray.GetSize() > 0)
      {
        eKeys = navPageArray.GetEnumerator();
      }
      return eKeys;
    }
    
    /// <summary>
    /// Enumerates the possible page types available.
    /// </summary>
    /// <returns>XPArrayList</returns>
    public virtual XPArrayList GetPageTypeArray()
    {
      return navPageArray;
    }
    
    /// <summary>
    /// Returns the number of page types.
    /// </summary>
    /// <returns>int</returns>
    public virtual int GetNumPageTypes()
    {
      if (navPageArray != null)
      {
        return navPageArray.GetSize();
      }
      return 0;
    }
  }
}