/*
 * Created on Mar 5, 2003
 *
 * To change this generated comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
 
using System;
namespace com.plumtree.portalpages.common.plugnav
{
  /// <summary>
  /// Navigation page type: Java typesafe enumerator class for page types in navigation.
  /// Not the same as NavCategoryType, which refers to organized named groups of links.
  /// This represent the core page you're on within navigation.  Example: Community page.
  /// </summary>
  /// <author>DavidP</author>
  public class NavPageType : Object
  {
    private String m_className;
    // enumeration of page types
    public static readonly NavPageType COMMUNITY = new NavPageType("COMMUNITY");
    public static readonly NavPageType DIRECTORY = new NavPageType("DIRECTORY");
    public static readonly NavPageType USERPROFILE = new NavPageType("USERPROFILE");
    public static readonly NavPageType LOGIN = new NavPageType("LOGIN");
    public static readonly NavPageType MYPAGE = new NavPageType("MYPAGE");
    public static readonly NavPageType COMMUNITYPREVIEW = new NavPageType("COMMUNITYPREVIEW");
    
    /// <summary>
    /// Unknown pagetype, the current page is not among one of the unsupported pagetypes.
    /// </summary>
    public static readonly NavPageType UNKNOWN = new NavPageType("UNKNOWN");
    // array of page types
    public static readonly NavPageType[] m_navPageTypes = {COMMUNITY, COMMUNITYPREVIEW,
     DIRECTORY, LOGIN, MYPAGE, USERPROFILE, UNKNOWN};
    
    /// <param name="navModel"></param>
    private NavPageType(String className)
    {
      m_className = className;
    }
    
    /// <seealso cref="java.lang.Object#toString()"></seealso>
    public override String ToString()
    {
      return m_className;
    }
    
    /// <summary>
    /// Get the Hash ID
    /// </summary>
    /// <returns>int</returns>
    public virtual int GetID()
    {
      return m_className.GetHashCode();
    }
    
    /// <seealso cref="java.lang.Object#equals(Object)"></seealso>
    public sealed override bool Equals(Object o)
    {
      bool retval = false;
      try
      {
        retval = ((NavPageType) o).ToString().Equals(m_className);
      }
      catch (Exception e)
      {
      }
      return retval;
    }
  }
}