using System;
using com.plumtree.portaluiinfrastructure.filter;
using com.plumtree.uiinfrastructure.pagecontrols.framework;
using com.plumtree.uiinfrastructure.pagecontrols.jsdatetimepicker;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.common.search
{
  /// <author>
  /// CraigS, based on MikeS
  /// Interface that both DynamicQueryTable and RepostQueryTable implement;
  /// allows them to be used interchangably
  /// </author>
  public interface IFilterQueryTable
  {
    
    /// <param name="bOperator"></param>
    void SetAllMustPass(bool bOperator);
    
    /// <param name="qc"></param>
    void SetBlankQueryCondition(QueryCondition qc);
    
    /// <param name="s"></param>
    void SetExtraRowBelowGroupHeader(String s);
    
    /// <param name="e"></param>
    void SetExtraRowBelowGroupHeader(HTMLElement e);
    void SetHideGroupHeaderRow(bool hide);
    
    /// <param name="label"></param>
    void SetLabel(String label);
    
    /// <param name="b"></param>
    void SetSuppressCheckbox(bool b);
    
    /// <param name="nRows"></param>
    void SetTableSize(int nRows);
    
    /// <param name="b"></param>
    void SetUseVerboseTerminology(bool b);
    
    /// <returns></returns>
    bool GetAllMustPass();
    
    /// <param name="iIndex"></param>
    /// <returns></returns>
    QueryCondition GetDefinedQueryCondition(int iIndex);
    
    /// <param name="result"></param>
    /// <param name="showErrorsNextToInputs"></param>
    void addTableToCollection(HTMLElementCollection result, bool showErrorsNextToInputs,
     JSDateTimePickerMgr jsDateTimePickerMgr, PageMgr _ptPageMgr);
    
    /// <param name="qc"></param>
    void loadDefinedQueryCondition(QueryCondition qc);
    
    /// <param name="iIndex"></param>
    void removeDefinedQueryCondition(int iIndex);
  }
}