using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.common.search
{
  /// <summary>
  /// This is based on MikeS/OlegS code
  /// </summary>
  /// <author>CraigS</author>
  public interface ITypeSelectorModelRO : IModelRO
  {
    
    /// <returns></returns>
    bool AreDetailedOptionsShown();
    
    /// <summary>
    /// Returns a collection of all selected types (as Strings)
    /// </summary>
    IXPCollection GetSelectedTypes();
    
    /// <summary>
    /// Returns true if the given type is selected
    /// </summary>
    bool IsTypeSelected(int type);
    
    /// <summary>
    /// Returns true if admin objects (CLASSID_ENDUSERCOUNT .. DETAILEDCOUNT-1) should be selectable
    /// </summary>
    bool ShouldDisplayAdminObjects();
    
    /// <summary>
    /// Returns true if the user can see an alternate view that lists abstractified
    /// types and applications instead of the longer list of detailed types
    /// </summary>
    bool ShowAbstractTypeView();
    int[] GetOrderedClassIds();
    bool ContentInstalled();
    bool CollabInstalled();
  }
}