using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.search;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.form;
namespace com.plumtree.portalpages.common.search
{
  /// <author>CraigS</author>
  public class SimpleSelectorModel : EditorHelperModel,ISimpleSelectorModelRO
  {
    public const String STR_MVC_CLASS_NAME = "SimpleSelector";
    private String _elementName;
    private String _promptText;
    private String _title;
    private String[] _possibleSelections;
    private int _currentSelection;
    
    /// <returns></returns>
    public override Object Create()
    {
      return new SimpleSelectorModel();
    }
    
    /// <returns></returns>
    public virtual int GetCurrentSelection()
    {
      return _currentSelection;
    }
    
    /// <returns></returns>
    public virtual String GetElementName()
    {
      return _elementName;
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public virtual String[] GetPossibleSelections()
    {
      return _possibleSelections;
    }
    
    /// <returns></returns>
    public virtual String GetPromptText()
    {
      return _promptText;
    }
    
    /// <returns></returns>
    public virtual String GetTitle()
    {
      return _title;
    }
    
    /// <param name="possibleSelections"></param>
    /// <param name="initialSelection"></param>
    /// <param name="title"></param>
    /// <param name="promptText"></param>
    /// <param name="elementName"></param>
    public virtual void InitializePlugIn(String[] possibleSelections, int initialSelection,
     String title, String promptText, String elementName)
    {
      _possibleSelections = possibleSelections;
      _currentSelection = initialSelection;
      _title = title;
      _promptText = promptText;
      _elementName = elementName;
    }
    
    /// <param name="formData"></param>
    /// <returns></returns>
    public override int SaveSection(XPHashtable formData)
    {
      String[] data = (String[]) formData.GetElement(_elementName);
      if ((null != data) && (data.Length > 0))
      {
        try
        {
          _currentSelection = XPConvert.ToInteger(data[0]);
        }
        catch (Exception e)
        {
          throw XPException.GetInstance(e);
        }
      }
      return RepostControl.PAGE_STATUS_VALID;
    }
    public virtual void SetSelectionFromFormData(XPHashtable formData)
    {
      if (_possibleSelections == null || _possibleSelections.Length == 0 || formData == null)
      {
        return;
      }
      String[] numRes = (String[]) formData.GetElement(StartSearchControl.REQUIRED_CONSTRAINT_PREFIX + SearchSettingCollection.PT_SEARCHSETTING_MAXRESULTS_S);
      if ((null != numRes) && (numRes.Length > 0))
      {
        try
        {
          for (int i = 0;i < _possibleSelections.Length;i++)
          {
            if (_possibleSelections[i].Equals(numRes[0]))
            {
              _currentSelection = i;
              return;
            }
          }
        }
        catch (Exception e)
        {
        }
      }
    }
  }
}