using System;
namespace com.plumtree.portalpages.common.uiparts
{
  /// <author>robertz</author>
  public class NavTypeConstants
  {
    // so as not to renumber navs
    
    /// <summary>
    /// IDs for Plumtree's intrinsic navigation schemas
    /// </summary>
    public const int NAVTYPE_ID_HORIZONTAL_DHTML_DROPDOWN = -1;
    public const int NAVTYPE_ID_HORIZONTAL_COMBOBOX_DROPDOWN = -2;
    public const int NAVTYPE_ID_VERTICAL_TABGROUPSLEFT = -3;
    public const int NAVTYPE_ID_VERTICAL_SIMPLELEFT = -4;
    public const int NAVTYPE_ID_NULL_MANDATORY_ONLY = -5;
    public const int NAVTYPE_ID_NULL = -6;
    public const int NAVTYPE_ID_HORIZONTAL_DHTML_DROPDOWN_JSPORTALMENU = -7;
    // 508 compliant nav
    public const int NAVTYPE_ID_ACCESSIBLE = -8;
    public const int NAVTYPE_ID_PORTLETNAV = -9;
    
    /// <summary>
    /// The navigation type used in the 508 portal
    /// </summary>
    public static readonly int NAVTYPE_ID_508COMPLIANT = NAVTYPE_ID_ACCESSIBLE;
    
    /// <summary>
    /// Default navigation schema to be used in the case of invalid schema
    /// being stored. Eg when subportal is set to use a custom schema that
    /// has been removed.
    /// </summary>
    public static readonly int NAV_TYPE_ID_DEFAULT = NAVTYPE_ID_HORIZONTAL_DHTML_DROPDOWN_JSPORTALMENU;
    
    /// <summary>
    /// Starting ID for custom navigation schemas. This is used by TestExtNav.
    /// New navigations should use a positive offset from this base ID.
    /// </summary>
    public const int NAV_TYPE_ID_BASE = 100;
  }
}