using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.condition;
using com.plumtree.uiinfrastructure.constants;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.uiinfrastructure.htmlconstructs;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.common.uiparts
{
  /// <author>dustina</author>
  public class RulesDebugMSGDP : AFormDP
  {
    public const String STR_MVC_CLASS_NAME = "RulesDebugMSGDP";
    public const String HTMLBUTTON_DONE = "in_bu_Done";
    
    /// <summary>
    /// This is a helper method that all classes that inherit from AFormDP and want to
    /// have the Done and Cancel buttons displayed in the header for them need to
    /// implement.  The method should return the title add whatever HTML the child
    /// class wants to display to the body argument.  The parent class will then add
    /// that HTML to the HTMLPage after filling in the banner and navigation.
    /// Override this method to set the form title
    /// </summary>
    /// <returns>String the title for the form header (if used)</returns>
    public override String GetFormTitle()
    {
      return m_asOwner.GetString(2968, "ptmsgs_portaladminmsgs");
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.uiparts.PlumtreeDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLImg myImage;
      HTMLInput myInput;
      HTMLH1 headerH1;
      PTConstruct myConstruct;
      HTMLElementCollection result = new HTMLElementCollection();
      String strDebugText = XPConvert.ToString(m_asOwner.GetSubSession().GetAttribute(ConditionTypeManager.RULES_DEBUG_MSG));
      HTMLComment myComment = new HTMLComment("Begin: Header main table");
      result.AddInnerHTMLElement(myComment);
      myTable = new HTMLTable();
      result.AddInnerHTMLElement(myTable);
      myTable.SetBorder("0");
      myTable.SetWidth("100%");
      myTable.SetCellPadding("0");
      myTable.SetCellSpacing("0");
      // 1st Row
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myRow.SetStyleClass(PTStyleClass.BAN_HEADER_BG);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetWidth("10");
      myConstruct = UIConstructFactory.GetConstruct(PTImageType.SPACER, true,
       this.m_asOwner);
      myImage = (HTMLImg) myConstruct.GetHTMLElement();
      myImage.SetAlt("");
      myImage.SetWidth("10");
      myImage.SetHeight("1");
      myImage.SetBorder("0");
      myCell.AddInnerHTMLElement(myImage);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetWidth("100%");
      myCell.SetHeight("30");
      myCell.SetStyleClass(PTStyleClass.BAN_TEXT);
      myCell.SetNoWrap(true);
      headerH1 = new HTMLH1();
      myCell.AddInnerHTMLElement(headerH1);
      headerH1.AddInnerHTMLString(m_asOwner.GetString(2968, "ptmsgs_portaladminmsgs"));
      headerH1.SetStyleClass(PTStyleClass.BAN_HEADER);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetWidth("300");
      myCell.SetAlign("right");
      myCell.SetStyleClass(PTStyleClass.BAN_TEXT);
      myComment = new HTMLComment("Begin: Header buttons table");
      myCell.AddInnerHTMLElement(myComment);
      // Begin Header buttons table
      HTMLTable mySubTable = new HTMLTable();
      myCell.AddInnerHTMLElement(mySubTable);
      mySubTable.SetBorder("0");
      mySubTable.SetCellPadding("5");
      mySubTable.SetCellSpacing("0");
      // button table 1st Row
      HTMLTableRow mySubRow = new HTMLTableRow();
      mySubTable.AddInnerHTMLElement(mySubRow);
      HTMLTableCell mySubCell = new HTMLTableCell();
      mySubRow.AddInnerHTMLElement(mySubCell);
      mySubCell.SetHeight("20");
      mySubCell.SetAlign("right");
      mySubCell.SetVAlign("middle");
      mySubCell.SetNoWrap(true);
      // Done button
      AccessStyles accessStyles = m_asOwner.GetAccessStyle();
      if (accessStyles == AccessStyles.STANDARD)
      {
        myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_DONE, "");
        myInput.SetValue(m_asOwner.GetString(1310, "ptmsgs_portaladminmsgs"));
        myInput.SetStyleClass(PTStyleClass.FORM_EDITOR_BTN_TEXT);
        myInput.SetOnClick("window.close();");
      } else
      {
        myInput = new HTMLInput(HTMLInputTypes.SUBMIT, RepostControl.HTMLSUBMIT_508_POSTTOSELF + RepostControl.POSTTOSELF_ACTION_CANCEL,
         "");
        myInput.SetValue(m_asOwner.GetString(1310, "ptmsgs_portaladminmsgs"));
        myInput.SetAlt(m_asOwner.GetString(1310, "ptmsgs_portaladminmsgs"));
        myInput.SetAccessKey(m_asOwner.GetString(26, "ptmsgs_portal508quickkeymsgs"));
        myInput.SetTitle(m_asOwner.GetString(28, "ptmsgs_portal508quickkeymsgs"));
        myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
      }
      mySubCell.AddInnerHTMLElement(myInput);
      mySubCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      mySubCell = new HTMLTableCell();
      mySubRow.AddInnerHTMLElement(mySubCell);
      mySubCell.SetWidth("1");
      myConstruct = UIConstructFactory.GetConstruct(PTImageType.SPACER, true,
       this.m_asOwner);
      myImage = (HTMLImg) myConstruct.GetHTMLElement();
      myImage.SetAlt("");
      myImage.SetWidth("1");
      myImage.SetHeight("1");
      myImage.SetBorder("0");
      mySubCell.AddInnerHTMLElement(myImage);
      // End Header buttons table
      myComment = new HTMLComment("End: Header buttons table");
      myCell.AddInnerHTMLElement(myComment);
      myComment = new HTMLComment("End: Header main table");
      myCell.AddInnerHTMLElement(myComment);
      myTable = new HTMLTable();
      result.AddInnerHTMLElement(myTable);
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetNoWrap(true);
      myCell.AddInnerHTMLString(strDebugText);
      return result;
    }
  }
}