using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
namespace com.plumtree.portalpages.common.uiparts
{
  /// <author>DustinA</author>
  public class RulesDebugMSGModel : IRepostModel
  {
    public const String STR_MVC_CLASS_NAME = "RulesDebugMSGModel";
    private AActivitySpace m_asOwner;
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.form.IRepostModel#Finish()
     */
     
    public virtual void Finish()
    {
    }
    // DCA - we don't need to do anything here
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.form.IRepostModel#GetRedirectAfterFinish()
     */
     
    public virtual Redirect GetRedirectAfterFinish()
    {
      Redirect result = new Redirect();
      // JF- If the parent space is already in the cache, we redirect to it.
      if (null != m_asOwner.GetParentSpace())
      {
        result.SetLinkGetCachedSpace(m_asOwner.GetParentSpace());
      } else
      // JF- If not, we redirect to a new one.
      {
        result.SetLinkCreateNewSpace(m_asOwner.GetParentSpaceName(), m_asOwner);
        }
      return (result);
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.form.IRepostModel#SavePage(java.lang.String, com.plumtree.openfoundation.util.XPHashtable)
     */
     
    public virtual int SavePage(String arg0, XPHashtable arg1)
    {
      return RepostControl.PAGE_STATUS_VALID;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IModel#CleanupTempData()
     */
     
    public virtual void CleanupTempData()
    {
    }
    // DCA - we don't need to do anything here
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IModel#CleanupAllData()
     */
     
    public virtual void CleanupAllData()
    {
    }
    // DCA - we don't need to do anything here
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IModel#Init(com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
     */
     
    public virtual void Init(AActivitySpace parent)
    {
      m_asOwner = parent;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
     */
     
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
     */
     
    public virtual Object Create()
    {
      return new RulesDebugMSGModel();
    }
  }
}