/*
 * Created on Mar 5, 2003
 */
 
using System;
using com.plumtree.portalpages.common.plugnav;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.portaluiinfrastructure.compoundlist;
namespace com.plumtree.portalpages.common.uiparts.navpagetype
{
  /// <summary>
  /// Delegates model methods only usable by community preview page.
  /// </summary>
  /// <author>DavidP</author>
  public class CommunityPreviewNavPage : NavigationPage,ICommunityPreviewNavPageRO
  {
    
    /// <summary>
    /// Unique String Name of category of object.  Critical for link blocking by pluggable nav.
    /// </summary>
    public override String GetName()
    {
      return NavPageType.COMMUNITYPREVIEW.ToString();
    }
    
    /// <summary>
    /// CommunityNavPage constructor.   
    /// </summary>
    /// <param name="model"></param>
    public CommunityPreviewNavPage(INavigationModelRO model) : base(model,
     NavPageType.COMMUNITYPREVIEW)
    {
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.plugnav.ICommunityPreviewNavPageRO#GetAccessibleCommunityID(int)"></seealso>
    public virtual int GetAccessibleCommunityID(int nSubPortalCommID)
    {
      return m_model.GetAccessibleCommunityID(nSubPortalCommID);
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.plugnav.ICommunityPreviewNavPageRO#GetCurCommunityID()"></seealso>
    public virtual int GetCurCommunityID()
    {
      return m_model.GetCurCommunityID();
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.plugnav.ICommunityPreviewNavPageRO#GetCurCommunityName()"></seealso>
    public virtual String GetCurCommunityName()
    {
      return m_model.GetCurCommunityName();
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.plugnav.ICommunityPreviewNavPageRO#GetCurRelCommunities()"></seealso>
    public virtual ICPListEntryIterator GetCurRelCommunities()
    {
      return m_model.GetCurRelCommunities();
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.plugnav.ICommunityPreviewNavPageRO#GetCurSubCommunities()"></seealso>
    public virtual ICPListEntryIterator GetCurSubCommunities()
    {
      return m_model.GetCurSubCommunities();
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.plugnav.ICommunityPreviewNavPageRO#GetDefaultCommunity()"></seealso>
    public virtual int GetDefaultCommunity()
    {
      return m_model.GetDefaultCommunity();
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.plugnav.ICommunityPreviewNavPageRO#GetMyCommunities(boolean)"></seealso>
    public virtual ICPListEntryIterator GetMyCommunities(bool bListActions)
    {
      return m_model.GetMyCommunities(bListActions);
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.plugnav.ICommunityPreviewNavPageRO#GetParentComm()"></seealso>
    public virtual ICPListEntryIterator GetParentComm()
    {
      return m_model.GetParentComm();
    }
    
    /// <seealso cref="com.plumtree.portalpages.common.plugnav.ICommunityPreviewNavPageRO#IsCurCommOwner()"></seealso>
    public virtual bool IsCurCommOwner()
    {
      return m_model.IsCurCommOwner();
    }
  }
}