using System;
using com.plumtree.uiinfrastructure.arraywrapper;
using com.plumtree.uiinfrastructure.expandablelist.growablelist;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.condition.conditiontypes
{
  /// <author>dustina</author>
  public class IPAddressListView : GrowableListView
  {
    
    /// <summary>
    /// Class name for the activity space 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "IPAddressListView";
    public const String HTMLINPUT_IPBOX_1 = "in_tx_IPBox1";
    public const String HTMLINPUT_IPBOX_2 = "in_tx_IPBox2";
    public const String HTMLINPUT_IPBOX_3 = "in_tx_IPBox3";
    public const String HTMLINPUT_IPBOX_4 = "in_tx_IPBox4";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new IPAddressListView();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for the row _nRowIndex.
    /// Each row contains just an icon and input text.
    /// </summary>
    /// <param name="_saData"></param>
    /// <param name="_nRowIndex"></param>
    /// <returns>HTMLElement</returns>
    public override HTMLElement GetHTMLForRow(IPTGrowableSortedArrayWrapperRO _saData,
     int _nRowIndex)
    {
      HTMLTableCell myCell;
      HTMLInput myInput;
      myCell = new HTMLTableCell();
      myCell.SetWidth("100%");
      myCell.SetHeight("30");
      myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
      myCell.SetNoWrap(true);
      myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      // row icon
      PTImageType imgRowIcon = ((IGrowableListModelRO) m_model).GetRowIcon();
      if (null != imgRowIcon)
      {
        myCell.AddInnerHTMLElement(GetHTMLForIcon(imgRowIcon));
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      }
      // input text
      myInput = new HTMLInput(HTMLInputTypes.TEXT, ((IGrowableListModelRO) m_model).GetUniqueString(HTMLINPUT_IPBOX_1) + _nRowIndex,
       "");
      myCell.AddInnerHTMLElement(myInput);
      myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
      myInput.SetValue((String) _saData.GetItem(_nRowIndex, IPAddressListModel.EXPLIST_IPBOX_1));
      myInput.SetMaxLength("3");
      myInput.SetSize("3");
      myCell.AddInnerHTMLString(" <b>.</b> ");
      myInput = new HTMLInput(HTMLInputTypes.TEXT, ((IGrowableListModelRO) m_model).GetUniqueString(HTMLINPUT_IPBOX_2) + _nRowIndex,
       "");
      myCell.AddInnerHTMLElement(myInput);
      myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
      myInput.SetValue((String) _saData.GetItem(_nRowIndex, IPAddressListModel.EXPLIST_IPBOX_2));
      myInput.SetMaxLength("3");
      myInput.SetSize("3");
      myCell.AddInnerHTMLString(" <b>.</b> ");
      myInput = new HTMLInput(HTMLInputTypes.TEXT, ((IGrowableListModelRO) m_model).GetUniqueString(HTMLINPUT_IPBOX_3) + _nRowIndex,
       "");
      myCell.AddInnerHTMLElement(myInput);
      myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
      myInput.SetValue((String) _saData.GetItem(_nRowIndex, IPAddressListModel.EXPLIST_IPBOX_3));
      myInput.SetMaxLength("3");
      myInput.SetSize("3");
      myCell.AddInnerHTMLString(" <b>.</b> ");
      myInput = new HTMLInput(HTMLInputTypes.TEXT, ((IGrowableListModelRO) m_model).GetUniqueString(HTMLINPUT_IPBOX_4) + _nRowIndex,
       "");
      myCell.AddInnerHTMLElement(myInput);
      myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
      myInput.SetValue((String) _saData.GetItem(_nRowIndex, IPAddressListModel.EXPLIST_IPBOX_4));
      myInput.SetMaxLength("3");
      myInput.SetSize("3");
      return myCell;
    }
  }
}