using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.portalpages.admin.ptutilities.settings;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.portaluiinfrastructure.classtypedescriptors;
using com.plumtree.portaluiinfrastructure.friendlyurl;
using com.plumtree.portaluiinfrastructure.helpers;
using com.plumtree.portaluiinfrastructure.opener;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.application;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.constants;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.web;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.debug.ui
{
  public class DebugLayoutDP : PlumtreeDP
  {
    public const String STR_MVC_CLASS_NAME = "DebugLayout";
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    public override String GetSubtitleForBanner()
    {
      return GetOwner().GetString(816, ResourceConstants.PORTALCOMMONMSGS);
      }
    public override String GetTitleForBanner()
    {
      return GetOwner().GetString(817, ResourceConstants.PORTALCOMMONMSGS);
      }
    public override HTMLElement PageDisplay()
    {
      HTMLTable psTable = new HTMLTable();
      psTable.SetAlign("left");
      psTable.SetCellPadding("5");
      psTable.SetCellSpacing("0");
      psTable.SetBorder("0");
      psTable.SetWidth("100%");
      HTMLTableRow headerRow = new HTMLTableRow();
      psTable.AddInnerHTMLElement(headerRow);
      HTMLTableCell headerCell = new HTMLTableCell();
      headerCell.SetAlign("left");
      headerCell.SetVAlign("top");
      headerRow.AddInnerHTMLElement(headerCell);
      headerRow.SetStyleClass(PTStyleClass.DIR_HEADER_BG);
      HTMLSpan headerSpan = new HTMLSpan();
      headerSpan.SetStyleClass(PTStyleClass.DIR_HEADER);
      headerSpan.AddInnerHTMLString(GetOwner().GetString(816, ResourceConstants.PORTALCOMMONMSGS));
      headerCell.AddInnerHTMLElement(headerSpan);
      HTMLTableRow tRow;
      HTMLTableCell tCell;
      String strURL = PTOpenerLinks.GetOpenerURLOpenObjID(PT_CLASSIDS.PT_ADMIN_FOLDER_ID,
       PT_INTRINSICS.PT_ADMIN_FOLDER_SUBPORTALOBJECTS, IPTOpenerConstants.OPENER_MODE_VIEW,
       GetOwner());
      tRow = new HTMLTableRow();
      psTable.AddInnerHTMLElement(tRow);
      tCell = new HTMLTableCell();
      tRow.AddInnerHTMLElement(tCell);
      tCell.SetStyleClass(PTStyleClass.MENU_TEXT);
      XPStringBuilder sb = new XPStringBuilder(300);
      sb.Append(GetOwner().GetString(805, ResourceConstants.PORTALCOMMONMSGS)).Append(" ").Append(GetOwner().GetString(807,
       ResourceConstants.PORTALCOMMONMSGS));
      sb.Append("\n<br/><br/>\n");
      sb.Append(GetOwner().GetString(806, ResourceConstants.PORTALCOMMONMSGS)).Append(" <a href=\'").Append(strURL).Append("\'>").Append(GetOwner().GetString(808,
       ResourceConstants.PORTALCOMMONMSGS)).Append("</a> ").Append(GetOwner().GetString(809,
       ResourceConstants.PORTALCOMMONMSGS));
      sb.Append("\n<br/>\n");
      sb.Append(GetOwner().GetString(810, ResourceConstants.PORTALCOMMONMSGS));
      tCell.AddInnerHTMLString(sb.ToString());
      tRow = new HTMLTableRow();
      psTable.AddInnerHTMLElement(tRow);
      tCell = new HTMLTableCell();
      tRow.AddInnerHTMLElement(tCell);
      tCell.SetStyleClass(PTStyleClass.MENU_TEXT);
      tCell.AddInnerHTMLString("&nbsp;");
      strURL = PTOpenerLinks.GetOpenerURLOpenObjID(PT_CLASSIDS.PT_GADGETCONTENTSERVER_ID,
       PT_INTRINSICS.PT_REMOTE_SERVER_IMAGESERVER, IPTOpenerConstants.OPENER_MODE_EDIT,
       GetOwner());
      String strSysHealthURL = null;
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      IFriendlyURLManager ptFriendlyURLMgr = (IFriendlyURLManager) application.GetCachingManager().GetEntry(AppWarmUp.KEY_CACHEMAN_CLASS_TYPE_MANAGER);
      String debugPortalKeyword = ptFriendlyURLMgr.LookupFriendlyURLKeyFromClassId(FriendlyURLConstants.DEBUG_PORTAL_CLASS_ID);
      if (null != debugPortalKeyword)
      {
        String baseURL = PTConfigService.getPTInstance().GetApplicationBaseURL(GetOwner().GetCurrentNormalizedBaseURL());
        baseURL = GeneralHelpers.Replace(baseURL, "?", "/");
        strSysHealthURL = baseURL + XPHttpUtility.UrlDecode(debugPortalKeyword,
         LinkConstants.UTF_8_ENCODING);
      } else
      {
        DiagnosticPageUtilities dp = new DiagnosticPageUtilities();
        ASURL myURL = new ASURL(m_asOwner);
        myURL.SetLinkCreateNewSpace(dp.GetASName(), m_asOwner);
        if (dp.GetASControlName() != null)
        {
          myURL.SetControl(dp.GetASControlName());
        }
        if (dp.GetASDPName() != null)
        {
          myURL.SetDisplayPage(dp.GetASDPName());
        }
        strSysHealthURL = myURL.GetURLAsString();
        if (dp.GetASQueryString() != null)
        {
          strSysHealthURL+=dp.GetASQueryString();
        }
      }
      tRow = new HTMLTableRow();
      psTable.AddInnerHTMLElement(tRow);
      tCell = new HTMLTableCell();
      tRow.AddInnerHTMLElement(tCell);
      tCell.SetStyleClass(PTStyleClass.MENU_TEXT);
      IPTSession ptSession = (IPTSession) GetOwner().GetUserSession();
      IPTGadgetContentServer ptImageServer = (IPTGadgetContentServer) ptSession.GetGadgetContentServers().Open(PT_INTRINSICS.PT_REMOTE_SERVER_IMAGESERVER,
       false);
      String strImageServerURL = ptImageServer.GetURL();
      sb = new XPStringBuilder(300);
      sb.Append(GetOwner().GetString(805, ResourceConstants.PORTALCOMMONMSGS)).Append(" ").Append(GetOwner().GetString(811,
       ResourceConstants.PORTALCOMMONMSGS));
      sb.Append("\n<br/><br/>\n");
      sb.Append(GetOwner().GetString(806, ResourceConstants.PORTALCOMMONMSGS)).Append(" <a href=\'").Append(strURL).Append("\'>").Append(GetOwner().GetString(812,
       ResourceConstants.PORTALCOMMONMSGS)).Append("</a> ").Append(XPResourceManager.FormatMessage(GetOwner().GetString(813,
       ResourceConstants.PORTALCOMMONMSGS), strImageServerURL));
      sb.Append("\n<br/>\n");
      sb.Append(GetOwner().GetString(818, ResourceConstants.PORTALCOMMONMSGS));
      sb.Append(" <a href=\'").Append(strSysHealthURL).Append("\'>").Append(GetOwner().GetString(819,
       ResourceConstants.PORTALCOMMONMSGS)).Append("</a> ");
      sb.Append(GetOwner().GetString(820, ResourceConstants.PORTALCOMMONMSGS));
      tCell.AddInnerHTMLString(sb.ToString());
      tRow = new HTMLTableRow();
      psTable.AddInnerHTMLElement(tRow);
      tCell = new HTMLTableCell();
      tRow.AddInnerHTMLElement(tCell);
      tCell.SetStyleClass(PTStyleClass.MENU_TEXT);
      tCell.AddInnerHTMLString("&nbsp;");
      tRow = new HTMLTableRow();
      psTable.AddInnerHTMLElement(tRow);
      tCell = new HTMLTableCell();
      tRow.AddInnerHTMLElement(tCell);
      tCell.SetStyleClass(PTStyleClass.MENU_TEXT);
      sb = new XPStringBuilder(300);
      sb.Append(GetOwner().GetString(805, ResourceConstants.PORTALCOMMONMSGS)).Append(" ").Append(GetOwner().GetString(814,
       ResourceConstants.PORTALCOMMONMSGS));
      sb.Append("\n<br/><br/>\n");
      sb.Append(GetOwner().GetString(806, ResourceConstants.PORTALCOMMONMSGS)).Append(" ").Append(GetOwner().GetString(815,
       ResourceConstants.PORTALCOMMONMSGS));
      tCell.AddInnerHTMLString(sb.ToString());
      return psTable;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IDisplayPage#display()"></seealso>
    public override void Display(IWebData pageData)
    {
      int nNavScheme = NavTypeConstants.NAVTYPE_ID_NULL;
      if (m_asOwner.GetAccessStyle() != AccessStyles.STANDARD)
      {
        nNavScheme = NavTypeConstants.NAVTYPE_ID_508COMPLIANT;
      }
      // make sure the navscheme we are going to use is the one that is registered
      RegisterNavScheme(nNavScheme);
      // END: Temp code for deciding navigation
      // Create an HTMLPage
      HTMLPage myPage = new HTMLPage();
      // Set the HTMLPage as the data to be sent to the browser.
      pageData.SetData(myPage);
      if (GetOwner().GetAccessStyle() == AccessStyles.SECTION_508)
      {
        myPage.SetDo508Checking(true);
      }
      // Important note - We MUST construct the body before constructing the head.
      // This is because intrinsic portlets are dynamically registered with the activity
      // space when the body is constructed.  If the portlet has any Javascript, then
      // it must be added to the head, but you don't know if there's any Javascript to
      // add until the body is generated. Of course the head should still be added to
      // the page before the body as usual. -jic
      // Create body
      HTMLBody myBody = DisplayBody(nNavScheme);
      // Create head
      HTMLHead myHead = DisplayHead(nNavScheme);
      // Add the head to the page
      myPage.SetHead(myHead);
      // Add the body to the page
      myPage.SetBody(myBody);
    }
  }
}