using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.devices.mypage.common;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.devices.choosepage.common
{
  /// <author>SudhaS</author>
  public class ChoosePageDevicesControl : IControl
  {
    public const String STR_MVC_CLASS_NAME = "ChoosePageDevices_Devices";
    public const String m_strPORTAL_SETTINGS_DATA = "ChoosePageDevices_Devices";
    private AActivitySpace m_asasParent;
    private IChoosePageDevicesModelRO m_asmModel;
    
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IControl#Execute()"></seealso>
    public virtual Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      ChoosePageDevicesModel myChoosePageDevicesModel = (ChoosePageDevicesModel) m_asasParent.GetModel(ChoosePageDevicesModel.STR_MVC_CLASS_NAME);
      //SS - The current display screen for a device
      String[] sValues = (String[]) arguments.GetElement(MyPageDevicesControl.STR_LIST_ID);
      int nListID = 0;
      if (sValues != null)
      {
        nListID = XPConvert.ToInteger(sValues[0]);
      }
      myChoosePageDevicesModel.SetListID(nListID);
      return null;
    }
    
    /// <seealso cref="com.plumtree.xpshared.infrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new ChoosePageDevicesControl();
    }
    
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IControl#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IControl#Init(IModel,AActivitySpace)"></seealso>
    public virtual void Init(IModel model, AActivitySpace space)
    {
      m_asmModel = (IChoosePageDevicesModelRO) model;
      m_asasParent = space;
    }
  }
}