using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.devices.choosepage.common;
using com.plumtree.portalpages.devices.logoff.common;
using com.plumtree.portalpages.devices.mypage.common;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.devices.choosepage.html32
{
  /// <author>SudhaS</author>
  public class ChoosePageDevicesView_HTML32 : IView
  {
    public const String STR_MVC_CLASS_NAME = "ChoosePageDevices_HTML32";
    private AActivitySpace m_asOwner;
    private IChoosePageDevicesModelRO m_asmModel;
    
    /// <returns></returns>
    public virtual Object Create()
    {
      return new ChoosePageDevicesView_HTML32();
    }
    
    /// <returns></returns>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IView#Display()"></seealso>
    public virtual HTMLElement Display()
    {
      HTMLTable myTable = new HTMLTable();
      HTMLTableRow myRow = new HTMLTableRow();
      HTMLTableCell myCell = new HTMLTableCell();
      myTable.AddInnerHTMLElement(myRow);
      myRow.AddInnerHTMLElement(myCell);
      myCell.AddInnerHTMLString(m_asOwner.GetString(1409, "ptmsgs_portalbrowsingmsgs"));
      //SS - A 2d array of all the pages of which a user is a member.  An array
      //of communities where each community has an array of pages
      Object[][] oPageMemberships = m_asmModel.GetPageMemberships();
      //SS - The total number of community pages to which a user belongs
      int nTotalPages = m_asmModel.GetNumTotalPages();
      //SS - The total number of screens that will be displayed on the device.
      //Only 5 links are displayed on each screen shot.
      int nPageCount = m_asmModel.GetNumPages(nTotalPages, ChoosePageDevicesModel.NUM_LINKS_PER_SCREEN);
      //SS - The current screen the user is viewing
      int nListID = m_asmModel.GetListID();
      //SS - The community and page which should be the start of the current display screen
      int nCommunityStart = m_asmModel.GetCommunityIDIndex();
      int nPageStart = m_asmModel.GetPageIDIndex();
      if (nListID >= nPageCount)
      {
        nListID = 0;
      }
      int nStart = nListID * ChoosePageDevicesModel.NUM_LINKS_PER_SCREEN;
      int nEnd = nStart + ChoosePageDevicesModel.NUM_LINKS_PER_SCREEN;
      if (nEnd > nTotalPages)
      {
        nEnd = nTotalPages;
      }
      int nCount = nStart;
      //SS - Loop through each community.
      for (int i = nCommunityStart;i < oPageMemberships.Length;i++)
      {
        //SS - Break if the end has been reached.  If not for the break,
        //the loop would continue even after the NUM_LINKS_PER_SCREEN has
        //been reached.
        if (nCount == nEnd)
        {
          break;
        }
        int nCommunityID = XPConvert.ToInteger(oPageMemberships[i][1]);
        //SS - The array of pages contains 2 arrays
        //1. An array of page ids
        //2. An array of page names 
        Object[] aPages = (Object[]) oPageMemberships[i][2];
        String strCommunityName = (String) oPageMemberships[i][0];
        int[] aPageIDs = (int[]) aPages[0];
        String[] aPageNames = (String[]) aPages[1];
        //SS - Loop through the pages in a community.
        for (int j = nPageStart;j < aPageNames.Length;j++)
        {
          //SS - Break if the end has been reached.  If not for the break,
          //the loop would continue even after the NUM_LINKS_PER_SCREEN has
          //been reached.
          if (nCount == nEnd)
          {
            break;
          }
          //SS - If we are in between the start and the end indeces
          if ((nStart <= nCount) && (nCount < nEnd))
          {
            //SS - If we are at the beginning of a screen or have started listing a new community
            if ((nStart == nCount) || (j == 0))
            {
              //SS - List the link for the community page
              myRow = new HTMLTableRow();
              myTable.AddInnerHTMLElement(myRow);
              myCell = new HTMLTableCell();
              myRow.AddInnerHTMLElement(myCell);
              myCell.AddInnerHTMLString(strCommunityName);
            }
            myRow = new HTMLTableRow();
            myTable.AddInnerHTMLElement(myRow);
            myCell = new HTMLTableCell();
            myRow.AddInnerHTMLElement(myCell);
            ASURL myURL = new ASURL(m_asOwner);
            myURL.SetLinkCreateNewSpace("MyPage", m_asOwner);
            myURL.SetControl(MyPageDevicesControl.STR_MVC_CLASS_NAME);
            myURL.AddControlArgument(MyPageDevicesControl.STR_PAGE_ID, XPConvert.ToInteger(aPageIDs[j]));
            myURL.AddControlArgument(MyPageDevicesControl.STR_COMMUNITY_ID,
             nCommunityID);
            myURL.AddControlArgument(MyPageDevicesControl.STR_PAGE_NAME, aPageNames[j]);
            HTMLAnchor anchor = new HTMLAnchor(myURL.GetURLAsString());
            anchor.AddInnerHTMLString(aPageNames[j]);
            myCell.AddInnerHTMLElement(anchor);
            nCount++;
          }
          //SS - If we are at the end of the screen and there are more pages to display
          if ((nCount == nEnd) && (nPageCount > 1))
          {
            //SS - Create the links for going backwards and forwards
            //They will only be displayed if necessary
            ASURL myNextURL = new ASURL(m_asOwner);
            myNextURL.SetLinkCreateNewSpace("ChoosePageDevices", m_asOwner);
            myNextURL.SetControl(ChoosePageDevicesModel.STR_MVC_CLASS_NAME);
            myNextURL.AddControlArgument(MyPageDevicesControl.STR_LIST_ID,
             m_asmModel.GetListID() + 1);
            ASURL myPrevURL = new ASURL(m_asOwner);
            myPrevURL.SetLinkCreateNewSpace("ChoosePageDevices", m_asOwner);
            myPrevURL.SetControl(ChoosePageDevicesModel.STR_MVC_CLASS_NAME);
            myPrevURL.AddControlArgument(MyPageDevicesControl.STR_LIST_ID,
             m_asmModel.GetListID() - 1);
            //SS - First screen shot
            if (nListID == 0)
            {
              myRow = new HTMLTableRow();
              myTable.AddInnerHTMLElement(myRow);
              myCell = new HTMLTableCell();
              myRow.AddInnerHTMLElement(myCell);
              HTMLAnchor anchor = new HTMLAnchor(myNextURL.GetURLAsString());
              anchor.AddInnerHTMLString(m_asOwner.GetString(1412, "ptmsgs_portalbrowsingmsgs"));
              myCell.AddInnerHTMLElement(anchor);
            } else
            //SS - Last screen shot
            if (nListID == (nPageCount - 1))
            {
              myRow = new HTMLTableRow();
              myTable.AddInnerHTMLElement(myRow);
              myCell = new HTMLTableCell();
              myRow.AddInnerHTMLElement(myCell);
              HTMLAnchor anchor = new HTMLAnchor(myPrevURL.GetURLAsString());
              anchor.AddInnerHTMLString(m_asOwner.GetString(1411, "ptmsgs_portalbrowsingmsgs"));
              myCell.AddInnerHTMLElement(anchor);
            } else
            //SS - Somewhere in the middle
            {
              myRow = new HTMLTableRow();
              myTable.AddInnerHTMLElement(myRow);
              myCell = new HTMLTableCell();
              myRow.AddInnerHTMLElement(myCell);
              HTMLAnchor anchor = new HTMLAnchor(myNextURL.GetURLAsString());
              anchor.AddInnerHTMLString(m_asOwner.GetString(1412, "ptmsgs_portalbrowsingmsgs"));
              myCell.AddInnerHTMLElement(anchor);
              myRow = new HTMLTableRow();
              myTable.AddInnerHTMLElement(myRow);
              myCell = new HTMLTableCell();
              myRow.AddInnerHTMLElement(myCell);
              anchor = new HTMLAnchor(myPrevURL.GetURLAsString());
              anchor.AddInnerHTMLString(m_asOwner.GetString(1411, "ptmsgs_portalbrowsingmsgs"));
              myCell.AddInnerHTMLElement(anchor);
            }
          }
        }
        if (nCount == nEnd)
        {
          break;
        }
        nPageStart = 0;
      }
      //SS - Display the logoff link
      ASURL myLogoffPage = new ASURL(m_asOwner);
      myLogoffPage.SetLinkCreateNewSpace("Logoff", m_asOwner);
      myLogoffPage.SetControl(LogoffDevicesControl.STR_MVC_CLASS_NAME);
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      HTMLAnchor myAnchor = new HTMLAnchor(myLogoffPage.GetURLAsString());
      myAnchor.AddInnerHTMLString(m_asOwner.GetString(1410, "ptmsgs_portalbrowsingmsgs"));
      myCell.AddInnerHTMLElement(myAnchor);
      return myTable;
    }
    
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IView#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// PortalSettings
    /// </summary>
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asmModel = (IChoosePageDevicesModelRO) model;
      m_asOwner = parent;
    }
  }
}