using System;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.resultwrapper;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.devices.login.common
{
  /// <author>SudhaS</author>
  public class LoginDevicesModel : ILoginDevicesModelRO,IModel
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_DEVICES),
     "com.plumtree.portalpages.devices.login.common.LoginDevicesModel");
    public const String STR_MVC_CLASS_NAME = "Login_Devices";
    private AActivitySpace m_asOwner;
    private Redirect m_Redirect = null;
    public virtual void CleanupTempData()
    {
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IModel#CleanupAllData()"></seealso>
    public virtual void CleanupAllData()
    {
    }
    
    /// <seealso cref="com.plumtree.xpshared.infrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new LoginDevicesModel();
    }
    
    /// <returns></returns>
    public virtual String[][] GetAuthSources()
    {
      //SS - Query the authsources and return an enumeration of the name,
      //prefix, and description
      IPTObjectManager omAuthSources = ((IPTSession) m_asOwner.GetUserSession()).GetAuthSources();
      PTObjectManagerQueryWrapper qrAuthSources = new PTObjectManagerQueryWrapper(omAuthSources);
      int fields = PT_PROPIDS.PT_PROPID_NAME | PT_PROPIDS.PT_PROPID_DESCRIPTION | PT_PROPIDS.PT_PROPID_AUTHSOURCE_PREFIXSTRING;
      qrAuthSources.Query(fields, -1, null, null);
      String[][] aAuthSources = new String[qrAuthSources.GetCount()][];
      for (int j2c_index = 0;j2c_index < qrAuthSources.GetCount();j2c_index++)
      {
        aAuthSources[j2c_index] = new String[3];
      }
      for (int i = 0;i < qrAuthSources.GetCount();i++)
      {
        aAuthSources[i][0] = (String) qrAuthSources.GetItem(i, PT_PROPIDS.PT_PROPID_NAME);
        aAuthSources[i][1] = (String) qrAuthSources.GetItem(i, PT_PROPIDS.PT_PROPID_AUTHSOURCE_PREFIXSTRING);
        aAuthSources[i][2] = (String) qrAuthSources.GetItem(i, PT_PROPIDS.PT_PROPID_DESCRIPTION);
        }
      return aAuthSources;
    }
    public virtual bool GetIsNumericLogin()
    {
      log.Debug("Obtaining from portal server");
      IPTSession ptSession = (IPTSession) m_asOwner.GetUserSession();
      if (ptSession.GetSettingsAsInt(PT_SESSION_SETTINGS.PT_SESSION_NUMERICAUTH) == 1)
      {
        return true;
      }
      return false;
    }
    public virtual void SetRedirect(Redirect _redirect)
    {
      m_Redirect = _redirect;
    }
    public virtual Redirect GetRedirect()
    {
      return m_Redirect;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <param name="_asOwner"></param>
    public virtual void Init(AActivitySpace _asOwner)
    {
      m_asOwner = _asOwner;
    }
  }
}