using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.devices.login.common;
using com.plumtree.portaluiinfrastructure.login;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.devices.login.html32
{
  /// <author>SudhaS</author>
  public class LoginDevicesView_HTML32 : IView
  {
    public const String STR_MVC_CLASS_NAME = "Login_HTML32";
    private AActivitySpace m_asOwner;
    private ILoginDevicesModelRO m_asmModel;
    
    /// <returns></returns>
    public virtual Object Create()
    {
      return new LoginDevicesView_HTML32();
    }
    
    /// <returns></returns>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IView#Display()"></seealso>
    public virtual HTMLElement Display()
    {
      HTMLTable myTable = new HTMLTable();
      myTable.SetWidth("100%");
      myTable.SetCellPadding("0");
      myTable.SetCellSpacing("0");
      myTable.SetAlign("center");
      HTMLForm myForm = new HTMLForm(STR_MVC_CLASS_NAME);
      myForm.AddInnerHTMLElement(myTable);
      ASURL myURL = new ASURL(m_asOwner);
      myForm.SetMethod("post");
      //SS - Create the login page
      myURL.SetLinkCreateNewSpace("Login", m_asOwner);
      myURL.SetControl(LoginDevicesControl.STR_MVC_CLASS_NAME);
      myURL.AddControlArgument(LoginDevicesControl.DO_LOGIN, true);
      myURL.AddControlArgument(LoginDevicesControl.DO_HTML32, true);
      myForm.SetAction(myURL.GetURLAsString());
      HTMLTableRow myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      HTMLTableCell myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      HTMLB myBold = new HTMLB();
      myCell.AddInnerHTMLElement(myBold);
      myBold.AddInnerHTMLString(m_asOwner.GetString(1413, "ptmsgs_portalbrowsingmsgs"));
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetColSpan("2");
      myCell.SetAlign("left");
      myCell.AddInnerHTMLString(m_asOwner.GetString(1414, "ptmsgs_portalbrowsingmsgs"));
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetColSpan("2");
      myCell.SetAlign("left");
      HTMLInput myInput = new HTMLInput(HTMLInputTypes.TEXT, LoginDevicesControl.HTML_INPUT_NAME,
       "This is an input");
      myCell.AddInnerHTMLElement(myInput);
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetColSpan("2");
      myCell.SetAlign("left");
      myCell.AddInnerHTMLString(m_asOwner.GetString(1415, "ptmsgs_portalbrowsingmsgs"));
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetColSpan("2");
      myCell.SetAlign("left");
      myInput = new HTMLInput(HTMLInputTypes.PASSWORD, LoginDevicesControl.HTML_INPUT_PASSWORD,
       "This is an input");
      myCell.AddInnerHTMLElement(myInput);
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetColSpan("2");
      myCell.SetAlign("left");
      myCell.AddInnerHTMLString(m_asOwner.GetString(1416, "ptmsgs_portalbrowsingmsgs"));
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetColSpan("2");
      myCell.SetAlign("left");
      HTMLSelect mySelect = new HTMLSelect(LoginDevicesControl.HTML_INPUT_AUTHSRC,
       LoginDevicesControl.HTML_INPUT_AUTHSRC);
      myCell.AddInnerHTMLElement(mySelect);
      String[][] aAuthSources = m_asmModel.GetAuthSources();
      //SS - List the authsources
      for (int i = 0;i < aAuthSources.Length;i++)
      {
        String strName = aAuthSources[i][0];
        String strPrefix = aAuthSources[i][1];
        String strDesc = aAuthSources[i][2];
        if (strPrefix == null)
        {
          strPrefix = "";
        }
        HTMLOption myOption = new HTMLOption(strPrefix);
        mySelect.AddInnerHTMLElement(myOption);
        //SS - If there is no description for the auth src, use the name
        if ((null == strDesc) || (XPStringUtility.CompareIgnoreCase("", strDesc) == 0))
        {
          myOption.AddInnerHTMLEncodedString(strName);
        } else
        {
          myOption.AddInnerHTMLEncodedString(strDesc);
        }
        //SS - If the prefix is listed in the config file as the default auth src,
        //set it as such
        if (XPStringUtility.CompareIgnoreCase("", strPrefix) != 0)
        {
          if (strPrefix.Equals(PTLoginHelper.GetDefaultPrefix()))
          {
            myOption.SetSelected(true);
          }
        } else
        //SS - If there is no default auth src listed in the config file,
        //default to the one with no prefix
        {
          if ((PTLoginHelper.GetDefaultPrefix() == null) || ((XPStringUtility.CompareIgnoreCase("",
           PTLoginHelper.GetDefaultPrefix()) == 0)))
          {
            myOption.SetSelected(true);
          }
        }
      }
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetColSpan("2");
      myCell.SetAlign("left");
      myInput = new HTMLInput(HTMLInputTypes.SUBMIT, LoginDevicesControl.HTML_INPUT_SUBMIT,
       "This is an input");
      myCell.AddInnerHTMLElement(myInput);
      myInput.SetValue(m_asOwner.GetString(1417, "ptmsgs_portalbrowsingmsgs"));
      return myForm;
    }
    
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IView#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// PortalSettings
    /// </summary>
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asmModel = (ILoginDevicesModelRO) model;
      m_asOwner = parent;
    }
  }
}