using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.devices.login.common;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.devices;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.devices.login.wml
{
  /// <author>SudhaS</author>
  public class LoginDevicesView_WML : IDevicesView
  {
    public const String STR_MVC_CLASS_NAME = "Login_WML";
    private AActivitySpace m_asOwner;
    private ILoginDevicesModelRO m_asmModel;
    
    /// <returns></returns>
    public virtual Object Create()
    {
      return new LoginDevicesView_WML();
    }
    
    /// <returns></returns>
    public virtual HTMLElement Display()
    {
      return null;
    }
    
    /// <returns></returns>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IView#Display()"></seealso>
    public virtual String DisplayString()
    {
      XPStringBuilder sb;
      sb = new XPStringBuilder();
      sb.Append("<template>\n");
      sb.Append("\t\t<do type=\"prev\"><noop/></do>\n");
      sb.Append("</template>\n");
      sb.Append("<card id=\"LoginMain\" title=\"Login\" newcontext=\"true\">\n");
      sb.Append("<p align=\"center\" mode=\"wrap\">\n");
      sb.Append("<b>" + m_asOwner.GetString(1418, "ptmsgs_portalbrowsingmsgs") + "</b><br/>\n");
      sb.Append("</p>");
      sb.Append("<p align=\"left\" mode=\"nowrap\">\n");
      //SS - Only allow numeric input
      if (m_asmModel.GetIsNumericLogin())
      {
        sb.Append("Login ID: <br/>\n");
        sb.Append("\t\t<input  name=\"" + LoginDevicesControl.HTML_INPUT_NAME + "\" format=\"*N\" value=\"\"/><br/>\n");
        sb.Append("PIN: <br/>\n");
        sb.Append("\t\t<input  name=\"" + LoginDevicesControl.HTML_INPUT_PASSWORD + "\" type=\"password\" format=\"*N\" value=\"\"/><br/>\n");
        } else
      {
        sb.Append("User Name: <br/>\n");
        sb.Append("\t\t<input  name=\"" + LoginDevicesControl.HTML_INPUT_NAME + "\" format=\"*N\" value=\"\"/><br/>\n");
        sb.Append("Password: <br/>\n");
        sb.Append("\t\t<input  name=\"" + LoginDevicesControl.HTML_INPUT_PASSWORD + "\" type=\"password\" format=\"*N\" value=\"\"/><br/>\n");
        sb.Append("\t\t<select name=\"" + LoginDevicesControl.HTML_INPUT_AUTHSRC + "\" id=\"login_authsrc\" value=\"\">\n");
        String[][] aAuthSources = m_asmModel.GetAuthSources();
        //SS - List the authsources
        for (int i = 0;i < aAuthSources.Length;i++)
        {
          String strName = aAuthSources[i][0];
          String strPrefix = aAuthSources[i][1];
          String strDesc = aAuthSources[i][2];
          if (strPrefix == null)
          {
            strPrefix = "";
          }
          //SS - If there is no description, use the name for the auth src dropdown
          if ((strDesc == null) || (XPStringUtility.CompareIgnoreCase("",
           strDesc) == 0))
          {
            sb.Append("\t\t\t<option value=\"" + strPrefix + "\" id=\"Select" + i + "\">" + strName + "</option>\n");
            } else
          {
            sb.Append("\t\t\t<option value=\"" + strPrefix + "\" id=\"Select" + i + "\">" + strDesc + "</option>\n");
            }
        }
        sb.Append("\t\t</select>\n");
      }
      //SS - Create the login link
      ASURL myURL = new ASURL(m_asOwner);
      myURL.SetXMLEncoding(true);
      myURL.SetLinkCreateNewSpace("Login", m_asOwner);
      myURL.SetControl(LoginDevicesControl.STR_MVC_CLASS_NAME);
      myURL.AddControlArgument(LoginDevicesControl.DO_LOGIN, true);
      sb.Append(" \t<anchor title=\"Submit\">Log In\n");
      sb.Append("\t\t\t\t<go method=\"post\" href=\"" + myURL.GetURLAsString() + "\">\n");
      sb.Append("\t\t\t\t\t<postfield name=\"" + LoginDevicesControl.HTML_INPUT_NAME + "\" value=\"$(" + LoginDevicesControl.HTML_INPUT_NAME + ")\"/>\n");
      sb.Append("\t\t\t\t\t<postfield name=\"" + LoginDevicesControl.HTML_INPUT_PASSWORD + "\" value=\"$(" + LoginDevicesControl.HTML_INPUT_PASSWORD + ")\"/>\n");
      sb.Append("\t\t\t\t\t<postfield name=\"" + LoginDevicesControl.HTML_INPUT_AUTHSRC + "\" value=\"$(" + LoginDevicesControl.HTML_INPUT_AUTHSRC + ")\"/>\n");
      sb.Append("\t\t\t\t\t<postfield name=\"" + LoginDevicesControl.DO_LOGIN + "\" value=\"$(" + LoginDevicesControl.DO_LOGIN + ")\"/>\n");
      sb.Append("\t\t\t\t\t<postfield name=\"RedirectURL\" value=\"" + myURL.GetURLAsString() + "\"/>\n");
      sb.Append("\t\t\t\t</go>\n");
      sb.Append("\t\t</anchor>\n");
      //sb.Append("<a href=\"" + myURL.GetURLAsString() + "\">XYZ</a>");
      //sb.Append("<a href=\"" + strLink + "\">Boolahboolahboolah</a>");
      sb.Append("</p>\n");
      sb.Append("</card>\n");
      return (sb.ToString());
    }
    
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IView#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// PortalSettings
    /// </summary>
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asmModel = (ILoginDevicesModelRO) model;
      m_asOwner = parent;
    }
  }
}