using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.devices.logoff.common;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.devices;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.devices.logoff.wml
{
  /// <author>SudhaS</author>
  public class LogoffDevicesView_WML : IDevicesView
  {
    public const String STR_MVC_CLASS_NAME = "Logoff_WML";
    public const String WMLINPUT_NAME = "Logoff_name";
    public const String WMLINPUT_PASSWORD = "Logoff_password";
    public const String WMLINPUT_AUTHSRC = "Logoff_authsrc";
    private AActivitySpace m_asOwner;
    private ILogoffDevicesModelRO m_asmModel;
    
    /// <returns></returns>
    public virtual Object Create()
    {
      return new LogoffDevicesView_WML();
    }
    
    /// <returns></returns>
    public virtual HTMLElement Display()
    {
      return null;
    }
    
    /// <returns></returns>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IView#Display()"></seealso>
    public virtual String DisplayString()
    {
      //SS - The logoff space creates a link to the login space
      XPStringBuilder sb;
      sb = new XPStringBuilder();
      ASURL myURL = new ASURL(m_asOwner);
      myURL.SetXMLEncoding(true);
      myURL.SetLinkCreateNewSpace("Login", m_asOwner);
      sb.Append("<card id=\"Logoff\" title=\"Logoff\" newcontext=\"true\">\n");
      sb.Append("<p align=\"center\" mode=\"wrap\">\n");
      sb.Append("<a href=\"" + myURL.GetURLAsString() + "\">" + m_asOwner.GetString(1421,
       "ptmsgs_portalbrowsingmsgs") + "</a>");
      sb.Append("</p>");
      sb.Append("</card>");
      return (sb.ToString());
    }
    
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IView#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// PortalSettings
    /// </summary>
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asmModel = (ILogoffDevicesModelRO) model;
      m_asOwner = parent;
    }
  }
}