using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.devices.mypage.common
{
  /// <author>SudhaS</author>
  public class MyPageDevicesControl : IControl
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_DEVICES),
     "com.plumtree.portalpages.devices.mypage.common.MyPageDevicesControl");
    public const String STR_MVC_CLASS_NAME = "MyPageDevices_Devices";
    //public static final String STR_MVC_CLASS_NAME = "MyPage_WML";
    public const String STR_PAGE_ID = "PageID";
    public const String STR_COMMUNITY_ID = "CommunityID";
    public const String STR_PAGE_NAME = "PageName";
    public const String STR_LIST_ID = "ListID";
    public const String m_strPORTAL_SETTINGS_DATA = "MyPage_WML";
    private AActivitySpace m_asasParent;
    private IMyPageDevicesModelRO m_asmModel;
    
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IControl#Execute()"></seealso>
    public virtual Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      MyPageDevicesModel myPageDevicesModel = (MyPageDevicesModel) m_asasParent.GetModel(MyPageDevicesModel.STR_MVC_CLASS_NAME);
      String[] sValues = (String[]) arguments.GetElement(STR_PAGE_ID);
      if (sValues == null)
      {
        log.Error("could not find page ID in query string.");
        return null;
      }
      int nPageID = XPConvert.ToInteger(sValues[0]);
      if (nPageID == 0)
      {
        IPTSession objSession = (IPTSession) m_asasParent.GetUserSession();
        int nUserID = objSession.GetSessionInfo().GetCurrentUserID();
        nPageID = -1 * nUserID;
      }
      myPageDevicesModel.SetPageID(nPageID);
      sValues = (String[]) arguments.GetElement(MyPageDevicesControl.STR_PAGE_NAME);
      if (sValues != null)
      {
        myPageDevicesModel.SetPageName(sValues[0]);
      }
      sValues = (String[]) arguments.GetElement(STR_PAGE_NAME);
      if (sValues != null)
      {
        myPageDevicesModel.SetPageName(sValues[0]);
      }
      sValues = (String[]) arguments.GetElement(STR_COMMUNITY_ID);
      if (sValues == null)
      {
        myPageDevicesModel.SetCommunityID(0);
        log.Info("could not find community ID in query string.");
      } else
      //return null;
      {
        int nCommunityID = XPConvert.ToInteger(sValues[0]);
        myPageDevicesModel.SetCommunityID(nCommunityID);
      }
      //SS - Create a link to the appropriate page
      ASURL myASURL = new ASURL(m_asasParent);
      myASURL.SetLinkGetCachedSpace(m_asasParent);
      myASURL.SetControl(STR_MVC_CLASS_NAME);
      myASURL.AddControlArgument(STR_PAGE_ID, nPageID);
      // we need to add ampersand at the end, so that PT-Return-URI + "#GID" will work.
      //		-- moose
      myPageDevicesModel.SetHostPageURI(myASURL.GetURLAsString() + LinkConstants.AMPERSAND);
      int nListID;
      sValues = (String[]) arguments.GetElement(STR_LIST_ID);
      if (sValues == null)
      {
        nListID = 0;
      } else
      {
        nListID = XPConvert.ToInteger(sValues[0]);
      }
      myPageDevicesModel.SetListID(nListID);
      return null;
    }
    
    /// <seealso cref="com.plumtree.xpshared.infrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new MyPageDevicesControl();
    }
    
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IControl#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IControl#Init(IModel,AActivitySpace)"></seealso>
    public virtual void Init(IModel model, AActivitySpace space)
    {
      m_asmModel = (IMyPageDevicesModelRO) model;
      m_asasParent = space;
    }
  }
}