using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.devices.choosepage.common;
using com.plumtree.portalpages.devices.logoff.common;
using com.plumtree.portalpages.devices.mypage.common;
using com.plumtree.portalpages.devices.mypage.wml;
using com.plumtree.portalpages.devices.portlet.common;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.devices.mypage.html32
{
  /// <author>SudhaS</author>
  public class MyPageDevicesView_HTML32 : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_DEVICES),
     "com.plumtree.portalpages.devices.mypage.html32.MyPageDevicesView_HTML32");
    public const String STR_MVC_CLASS_NAME = "MyPageDevices_HTML32";
    public const String STR_LIST_ID = "ListID";
    public const String STR_GADGET_ID = "PortletID";
    public const String STR_GADGET_INDEX = "PortletIndex";
    public const String STR_UNIQUEID_HTML32 = "http://www.plumtree.com/uis/pda";
    private AActivitySpace m_asOwner;
    private IMyPageDevicesModelRO m_asmModel;
    
    /// <returns></returns>
    public virtual Object Create()
    {
      return new MyPageDevicesView_HTML32();
    }
    
    /// <returns></returns>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IView#Display()"></seealso>
    public virtual HTMLElement Display()
    {
      //String strPageName = m_asmModel.GetPageName();
      m_asmModel.SetPortletContent(STR_UNIQUEID_HTML32);
      int nPortletCount = m_asmModel.GetPortletCount();
      String strPageName = m_asmModel.GetPageName();
      HTMLTable myTable = new HTMLTable();
      HTMLTableRow myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      HTMLAnchor myAnchor;
      HTMLTableCell myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.AddInnerHTMLString(strPageName);
      int nListID = m_asmModel.GetListID();
      int nNumPages = 0;
      if (nPortletCount > 0)
      {
        nNumPages = m_asmModel.GetNumPages(nPortletCount, ChoosePageDevicesModel.NUM_LINKS_PER_SCREEN);
        int nStart = nListID * ChoosePageDevicesModel.NUM_LINKS_PER_SCREEN;
        int nEnd = nStart + ChoosePageDevicesModel.NUM_LINKS_PER_SCREEN;
        if (nEnd > nPortletCount)
        {
          nEnd = nPortletCount;
        }
        for (int i = nStart;i < nEnd;i++)
        {
          // We do not use this content, but the method must be called
          // before GetPortletName() to initialize the data.
          m_asmModel.GetPortletContent(i);
          //String strPortletSummary = m_asmModel.GetPortletSummary(i);
          String strPortletSummary = m_asmModel.GetPortletSummary(i);
          String strPortletName = m_asmModel.GetPortletName(i);
          try
          {
            ASURL myPortletURL = m_asmModel.GetASURL("PortletDevices");
            //					myPortletURL.SetXMLEncoding(true);
            myPortletURL.SetControl(PortletDevicesControl.STR_MVC_CLASS_NAME);
            myPortletURL.AddControlArgument(MyPageDevicesView_WML.STR_GADGET_INDEX,
             i);
            myPortletURL.AddControlArgument(MyPageDevicesControl.STR_LIST_ID,
             m_asmModel.GetListID());
            myPortletURL.AddControlArgument(MyPageDevicesControl.STR_PAGE_NAME,
             strPageName);
            myRow = new HTMLTableRow();
            myTable.AddInnerHTMLElement(myRow);
            myCell = new HTMLTableCell();
            myRow.AddInnerHTMLElement(myCell);
            myAnchor = new HTMLAnchor(myPortletURL.GetURLAsString());
            myAnchor.AddInnerHTMLString(strPortletName + " " + strPortletSummary);
            myCell.AddInnerHTMLElement(myAnchor);
          }
          catch (XPException e)
          {
            log.Error(e, "Error in MyPageDevicesModel::Display: ");
          }
        }
        if (nNumPages > 1)
        {
          ASURL myMyPageNextURL = m_asmModel.GetASURL("MyPage");
          //myMyPageNextURL.SetXMLEncoding(true);
          myMyPageNextURL.SetControl(MyPageDevicesControl.STR_MVC_CLASS_NAME);
          myMyPageNextURL.AddControlArgument(MyPageDevicesControl.STR_LIST_ID,
           m_asmModel.GetListID() + 1);
          ASURL myMyPagePrevURL = m_asmModel.GetASURL("MyPage");
          //myMyPagePrevURL.SetXMLEncoding(true);
          myMyPagePrevURL.SetControl(MyPageDevicesControl.STR_MVC_CLASS_NAME);
          myMyPagePrevURL.AddControlArgument(MyPageDevicesControl.STR_LIST_ID,
           m_asmModel.GetListID() - 1);
          if (nListID == 0)
          {
            myRow = new HTMLTableRow();
            myTable.AddInnerHTMLElement(myRow);
            myCell = new HTMLTableCell();
            myRow.AddInnerHTMLElement(myCell);
            myAnchor = new HTMLAnchor(myMyPageNextURL.GetURLAsString());
            myAnchor.AddInnerHTMLString(m_asOwner.GetString(1412, "ptmsgs_portalbrowsingmsgs"));
            myCell.AddInnerHTMLElement(myAnchor);
          } else
          if (nListID == nNumPages - 1)
          {
            myRow = new HTMLTableRow();
            myTable.AddInnerHTMLElement(myRow);
            myCell = new HTMLTableCell();
            myRow.AddInnerHTMLElement(myCell);
            myAnchor = new HTMLAnchor(myMyPagePrevURL.GetURLAsString());
            myAnchor.AddInnerHTMLString(m_asOwner.GetString(1411, "ptmsgs_portalbrowsingmsgs"));
            myCell.AddInnerHTMLElement(myAnchor);
          } else
          {
            myRow = new HTMLTableRow();
            myTable.AddInnerHTMLElement(myRow);
            myCell = new HTMLTableCell();
            myRow.AddInnerHTMLElement(myCell);
            myAnchor = new HTMLAnchor(myMyPageNextURL.GetURLAsString());
            myAnchor.AddInnerHTMLString(m_asOwner.GetString(1412, "ptmsgs_portalbrowsingmsgs"));
            myCell.AddInnerHTMLElement(myAnchor);
            myRow = new HTMLTableRow();
            myTable.AddInnerHTMLElement(myRow);
            myCell = new HTMLTableCell();
            myRow.AddInnerHTMLElement(myCell);
            myAnchor = new HTMLAnchor(myMyPagePrevURL.GetURLAsString());
            myAnchor.AddInnerHTMLString(m_asOwner.GetString(1411, "ptmsgs_portalbrowsingmsgs"));
            myCell.AddInnerHTMLElement(myAnchor);
          }
        }
      } else
      {
        myCell.AddInnerHTMLElement(new HTMLBr());
        myCell.AddInnerHTMLString(m_asOwner.GetString(1427, "ptmsgs_portalbrowsingmsgs"));
        }
      ASURL myChoosePage = new ASURL(m_asOwner);
      myChoosePage.SetLinkCreateNewSpace("ChoosePageDevices", m_asOwner);
      myChoosePage.SetControl(ChoosePageDevicesControl.STR_MVC_CLASS_NAME);
      myChoosePage.AddControlArgument(MyPageDevicesControl.STR_PAGE_ID, 0);
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myAnchor = new HTMLAnchor(myChoosePage.GetURLAsString());
      myAnchor.AddInnerHTMLString(m_asOwner.GetString(1425, "ptmsgs_portalbrowsingmsgs"));
      myCell.AddInnerHTMLElement(myAnchor);
      ASURL myLogoffPage = new ASURL(m_asOwner);
      myLogoffPage.SetLinkCreateNewSpace("Logoff", m_asOwner);
      myLogoffPage.SetControl(LogoffDevicesControl.STR_MVC_CLASS_NAME);
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myAnchor = new HTMLAnchor(myLogoffPage.GetURLAsString());
      myAnchor.AddInnerHTMLString(m_asOwner.GetString(1426, "ptmsgs_portalbrowsingmsgs"));
      myCell.AddInnerHTMLElement(myAnchor);
      return (myTable);
    }
    
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IView#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// PortalSettings
    /// </summary>
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asmModel = (IMyPageDevicesModelRO) model;
      m_asOwner = parent;
    }
  }
}