using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.devices.choosepage.common;
using com.plumtree.portalpages.devices.logoff.common;
using com.plumtree.portalpages.devices.mypage.common;
using com.plumtree.portalpages.devices.portlet.common;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.devices;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.devices.mypage.wml
{
  /// <author>SudhaS</author>
  public class MyPageDevicesView_WML : IDevicesView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_DEVICES),
     "com.plumtree.portalpages.devices.mypage.wml.MyPageDevicesView_WML");
    public const String STR_MVC_CLASS_NAME = "MyPageDevices_WML";
    public const String STR_GADGET_ID = "PortletID";
    public const String STR_UNIQUEID_WML = "http://www.plumtree.com/uis/wml";
    public const String STR_GADGET_INDEX = "GadgetIndex";
    private AActivitySpace m_asOwner;
    private IMyPageDevicesModelRO m_asmModel;
    
    /// <returns></returns>
    public virtual Object Create()
    {
      return new MyPageDevicesView_WML();
    }
    
    /// <returns></returns>
    public virtual HTMLElement Display()
    {
      return null;
    }
    
    /// <returns></returns>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IView#Display()"></seealso>
    public virtual String DisplayString()
    {
      XPStringBuilder sb;
      sb = new XPStringBuilder();
      sb.Append("<template>\n");
      sb.Append("\t\t<do type=\"prev\"><noop/></do>\n");
      sb.Append("</template>\n");
      sb.Append("<card id=\"MyPage\" title=\"My Page or Community Page name\" newcontext=\"true\">\n");
      sb.Append("<onevent type=\"onenterforward\">\n");
      sb.Append("\t\t<refresh>\n");
      sb.Append("\t\t\t<setvar name=\"v1\" value=\"\"/>\n");
      sb.Append("\t\t\t<setvar name=\"v2\" value=\"\"/>\n");
      sb.Append("\t\t</refresh>\n");
      sb.Append("</onevent>\n");
      sb.Append("<p align=\"left\" mode=\"nowrap\">\n");
      String strPageName = m_asmModel.GetPageName();
      //SS - Display page name
      sb.Append("<b>" + strPageName + "</b><br/>");
      //SS - Set all content for all the portlets
      m_asmModel.SetPortletContent(STR_UNIQUEID_WML);
      int nPortletCount = m_asmModel.GetPortletCount();
      int nListID = m_asmModel.GetListID();
      int nNumPages = 0;
      if (nPortletCount > 0)
      {
        //SS - If there are multiple portlets, figure out how many screens there will be
        //based on the number of portlets to view per screen
        nNumPages = m_asmModel.GetNumPages(nPortletCount, ChoosePageDevicesModel.NUM_LINKS_PER_SCREEN);
        int nStart = nListID * ChoosePageDevicesModel.NUM_LINKS_PER_SCREEN;
        int nEnd = nStart + ChoosePageDevicesModel.NUM_LINKS_PER_SCREEN;
        if (nEnd > nPortletCount)
        {
          nEnd = nPortletCount;
        }
        for (int i = nStart;i < nEnd;i++)
        {
          // We do not use this content, but the method must be called
          // before GetPortletName() to initialize the data.
          m_asmModel.GetPortletContent(i);
          String strPortletSummary = m_asmModel.GetPortletSummary(i);
          String strPortletName = m_asmModel.GetPortletName(i);
          try
          {
            ASURL myPortletURL = m_asmModel.GetASURL("PortletDevices");
            myPortletURL.SetControl(PortletDevicesControl.STR_MVC_CLASS_NAME);
            myPortletURL.AddControlArgument(MyPageDevicesView_WML.STR_GADGET_INDEX,
             i);
            myPortletURL.AddControlArgument(MyPageDevicesControl.STR_LIST_ID,
             m_asmModel.GetListID());
            myPortletURL.AddControlArgument(MyPageDevicesControl.STR_PAGE_NAME,
             strPageName);
            sb.Append("<a href=\"" + myPortletURL.GetURLAsString() + "\">");
            sb.Append(m_asmModel.GetFixStringLength(strPortletName, 24, ""));
            if (strPortletSummary.Length > 0)
            {
              sb.Append(" - " + m_asmModel.GetFixStringLength(strPortletSummary,
               10, "") + "</a><br/>");
            } else
            {
              sb.Append("</a><br/>");
            }
          }
          catch (XPException e)
          {
            log.Error(e, "Error in MyPageDevicesModel::Display: ");
          }
        }
        if (nNumPages > 1)
        {
          ASURL myMyPageNextURL = m_asmModel.GetASURL("MyPage");
          myMyPageNextURL.SetControl(MyPageDevicesControl.STR_MVC_CLASS_NAME);
          myMyPageNextURL.AddControlArgument(MyPageDevicesControl.STR_LIST_ID,
           m_asmModel.GetListID() + 1);
          ASURL myMyPagePrevURL = m_asmModel.GetASURL("MyPage");
          myMyPagePrevURL.SetControl(MyPageDevicesControl.STR_MVC_CLASS_NAME);
          myMyPagePrevURL.AddControlArgument(MyPageDevicesControl.STR_LIST_ID,
           m_asmModel.GetListID() - 1);
          if (nListID == 0)
          {
            //Next
            sb.Append("&nbsp;&nbsp;<a href=\"" + myMyPageNextURL.GetURLAsString() + "\">" + m_asOwner.GetString(1429,
             "ptmsgs_portalbrowsingmsgs") + "</a><br/>");
          } else
          if (nListID == nNumPages - 1)
          {
            //Prev
            sb.Append("&nbsp;&nbsp;<a href=\"" + myMyPagePrevURL.GetURLAsString() + "\">" + m_asOwner.GetString(1428,
             "ptmsgs_portalbrowsingmsgs") + "</a><br/>");
          } else
          {
            //Next   				
            sb.Append("&nbsp;&nbsp;<a href=\"" + myMyPageNextURL.GetURLAsString() + "\">" + m_asOwner.GetString(1429,
             "ptmsgs_portalbrowsingmsgs") + "</a><br/>");
            //Prev
            sb.Append("&nbsp;&nbsp;<a href=\"" + myMyPagePrevURL.GetURLAsString() + "\">" + m_asOwner.GetString(1428,
             "ptmsgs_portalbrowsingmsgs") + "</a><br/>");
          }
        }
      } else
      {
        sb.Append("<b>" + m_asOwner.GetString(1432, "ptmsgs_portalbrowsingmsgs") + "</b><br/>");
        }
      ASURL myChoosePage = new ASURL(m_asOwner);
      myChoosePage.SetXMLEncoding(true);
      myChoosePage.SetLinkCreateNewSpace("ChoosePageDevices", m_asOwner);
      myChoosePage.SetControl(ChoosePageDevicesControl.STR_MVC_CLASS_NAME);
      myChoosePage.AddControlArgument(MyPageDevicesControl.STR_PAGE_ID, 0);
      sb.Append("<a href=\"" + myChoosePage.GetURLAsString() + "\">" + m_asOwner.GetString(1430,
       "ptmsgs_portalbrowsingmsgs") + "</a><br/>");
      ASURL myLogoffPage = new ASURL(m_asOwner);
      myLogoffPage.SetXMLEncoding(true);
      myLogoffPage.SetLinkCreateNewSpace("Logoff", m_asOwner);
      myLogoffPage.SetControl(LogoffDevicesControl.STR_MVC_CLASS_NAME);
      sb.Append("<a href=\"" + myLogoffPage.GetURLAsString() + "\">" + m_asOwner.GetString(1431,
       "ptmsgs_portalbrowsingmsgs") + "</a><br/>");
      sb.Append("\t</p>");
      sb.Append("</card>");
      return (sb.ToString());
    }
    
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IView#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// PortalSettings
    /// </summary>
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asmModel = (IMyPageDevicesModelRO) model;
      m_asOwner = parent;
    }
  }
}