using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.devices.portlet.common;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.devices;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.devices.portlet.wml
{
  /// <author>SudhaS</author>
  public class PortletDevicesView_WML : IDevicesView
  {
    public const String STR_MVC_CLASS_NAME = "PortletDevices_WML";
    public const String STR_UNIQUEID_WML = "http://www.plumtree.com/uis/wml";
    private AActivitySpace m_asOwner;
    private IPortletDevicesModelRO m_asmModel;
    
    /// <returns></returns>
    public virtual Object Create()
    {
      return new PortletDevicesView_WML();
    }
    
    /// <returns></returns>
    public virtual HTMLElement Display()
    {
      return null;
    }
    
    /// <returns></returns>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IView#Display()"></seealso>
    public virtual String DisplayString()
    {
      XPStringBuilder sb;
      sb = new XPStringBuilder();
      m_asmModel.SetPortletContent(STR_UNIQUEID_WML);
      String strPortletContent = m_asmModel.GetPortletContent();
      sb.Append(strPortletContent);
      return (sb.ToString());
    }
    
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IView#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// PortalSettings
    /// </summary>
    /// <seealso cref="com.plumtree.xpshared.portalinfrastructure.activityspace.IView#Init(IModelRO,AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_asmModel = (IPortletDevicesModelRO) model;
      m_asOwner = parent;
    }
  }
}