using System;
using com.plumtree.openlog;
using com.plumtree.portalpages.pei.util;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.pei
{
  /// <summary>
  /// This class handles validating new passwords for native users.
  /// This does not affect LDAP users or other users stored in external user stores.
  /// </summary>
  public class PTCreateAccountActions : ICreateAccountActions
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
     "com.plumtree.portalpages.pei.PTCreateAccountActions");
    public virtual void OnAfterAcceptInvite(AActivitySpace _asCurrentSpace,
     IPTSession _ptUserSession, String _strInviteCode)
    {
    }
    public virtual String OnBeforeCreateAccount(AActivitySpace _asCurrentSpace,
     IPTSession _ptUserSession, String _strUserName, String _strPassword)
    {
      PasswordValidator validator = new PasswordValidator();
      // This validates that the password follows the password strength rules.
      return validator.ValidatePassword(_strPassword, _strUserName, _asCurrentSpace,
       log);
    }
  }
}