using System;
using com.plumtree.analytics.openusage;
using com.plumtree.portalpages.browsing.myportal;
using com.plumtree.portalpages.browsing.myportal.communities;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.pei;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.pei
{
  public class ProfileViewActions : IPageActions
  {
    public virtual HTMLComment OnPageFinish(AActivitySpace _asCurrentSpace,
     Object _oUserSession, String _strServerName)
    {
      // DCA - check if page being viewed is a user profile page
      if (CommunityPageAS.STR_MVC_CLASS_NAME.Equals(_asCurrentSpace.GetName()))
      {
        MyPortalModel portalModel = (MyPortalModel) _asCurrentSpace.GetModel(MyPortalModel.STR_MVC_CLASS_NAME);
        if (null != portalModel && portalModel.m_bIsProfilePage && portalModel.GetProfileID() > 0)
        {
          // DCA - user viewing profile page, send event to analytics
          // DCA - the USER_VIEW type event is defined in analytics
          IManagedEvent userView = ASEventFactory.createManagedEvent("USER_VIEW",
           "http://www.bea.com/analytics/graffiti");
          int nCurrentUserId = ((IPTSession) _oUserSession).GetSessionInfo().GetCurrentUserID();
          userView.setParameter("USER_ID", nCurrentUserId);
          int nViewedUserId = portalModel.GetProfileID();
          userView.setParameter("VIEWED_USER_ID", nViewedUserId);
          userView.sendEvent();
        }
      }
      return null;
    }
    public virtual void OnPageStart(AActivitySpace _asCurrentSpace, Object _oUserSession,
     String _strServerName)
    {
    }
  }
}