using System;
using com.plumtree.portalpages.common.constants;
using com.plumtree.portaluiinfrastructure.editor;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.portlets.intrinsicpageletparamprefeditor
{
  /// <summary>
  /// Activityspace to edit community preference for portlets for ensemble pagelets 
  /// </summary>
  /// <author>rozhang</author>
  public class IntrinsicPrefsEditorForPageletParametersAS : PTEditorAS
  {
    public const String STR_MVC_CLASS_NAME = "IntrinsicPrefsEditorForPageletParameters";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.editor.EditorAS#Init()"></seealso>
    public override void Init()
    {
      m_strModelName = IntrinsicPrefsEditorForPageletParametersModel.STR_MVC_CLASS_NAME;
      // Warning: m_strModelName must be initialized before super.Init() is called.
      base.Init();
      IModel myModel = GetModel(IntrinsicPrefsEditorForPageletParametersModel.STR_MVC_CLASS_NAME);
      // Register DisplayPages
      IntrinsicPrefsEditorForPageletParametersDP dp = new IntrinsicPrefsEditorForPageletParametersDP();
      RegisterPage(dp);
      // Register Views
      RegisterView(IntrinsicPrefsEditorForPageletParametersView.STR_MVC_CLASS_NAME,
       myModel);
      // Set default page
      SetCurrentPage(IntrinsicPrefsEditorForPageletParametersDP.STR_MVC_CLASS_NAME);
      }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.editor.EditorAS#SetCurrentPage(com.plumtree.uiinfrastructure.activityspace.IDisplayPage)"></seealso>
    public override void SetCurrentPage(IDisplayPage page)
    {
      base.SetCurrentPage(page);
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.editor.EditorAS#GetEditorTitle()"></seealso>
    public override String GetEditorTitle()
    {
      // Portlet Community Preferences 
      return GetString(1990, ResourceConstants.PORTALBROWSINGMSGS);
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormAS#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AActivitySpace#Create()"></seealso>
    public override Object Create()
    {
      return new IntrinsicPrefsEditorForPageletParametersAS();
    }
  }
}