using System;
using com.plumtree.portaluiinfrastructure.intrinsicportlets;
using com.plumtree.server;
namespace com.plumtree.portalpages.portlets.jobhistory
{
  /// <summary>
  /// The read-only version of the Job History portlet model
  /// </summary>
  /// <author>JohnH</author>
  public interface IJobHistoryPortletModelRO : IIntrinsicPortletModelRO
  {
    
    /// <summary>
    /// Returns the portlet name
    /// </summary>
    /// <returns>String</returns>
    String GetPortletName();
    
    /// <summary>
    /// Returns the log page currently being displayed.
    /// </summary>
    /// <returns>int</returns>
    int GetCurrentLogPage();
    
    /// <summary>
    /// Returns CurrentPage setting.
    /// </summary>
    /// <returns>int</returns>
    int GetCurrentPage();
    
    /// <summary>
    /// Returns the jobID.
    /// </summary>
    /// <returns>int</returns>
    int GetJobID();
    
    /// <summary>
    /// Returns the jobName.
    /// </summary>
    /// <returns>String</returns>
    String GetJobName();
    
    /// <summary>
    /// Returns the Plumtree Session object.
    /// </summary>
    /// <returns>IPTSession</returns>
    IPTSession GetPTSession();
    
    /// <summary>
    /// Returns the job history row to display in the job log detail viewer.
    /// </summary>
    /// <returns>int</returns>
    int GetRowToDisplay();
    
    /// <summary>
    /// Returns the runTime.
    /// </summary>
    /// <returns>String</returns>
    String GetRunTime();
    
    /// <summary>
    /// Returns boolean indicating whether the last request was a log search.
    /// </summary>
    /// <returns>boolean</returns>
    bool IsSearchRequest();
    
    /// <summary>
    /// Returns the target string to be used for a log search.
    /// </summary>
    /// <returns>String</returns>
    String GetSearchString();
  }
}