using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portalpages.common.constants;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.portaluiinfrastructure.tree;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.uiinfrastructure.tree;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.portlets.savedsearch.prefs
{
  /// <author>mikes</author>
  public class SavedSearchPortletAdminPrefsView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_PORTLETS),
     "com.plumtree.portalpages.portlets.savedsearch.prefs.SavedSearchPortletAdminPrefsView");
    
    /// <summary>
    /// SavedSearchPortletPrefs 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "SavedSearchPortletAdminPrefs";
    public const String HTMLINPUT_SAVSRCHID = "in_hi_savedsearchid";
    public const String HTMLINPUT_SIMPLE = "in_ra_simple";
    public const String HTMLHIDDEN_TITLE = "in_hi_title";
    public const String HTMLHIDDEN_SAVSRCHSPACEID = "in_hi_savsrchspaceid";
    
    /// <summary>
    /// Hidden HTML for the tree repost action 
    /// </summary>
    public const String HTMLHIDDEN_TREEREPOST = "in_hi_SavSrchRepostAction";
    public const String JAVASCRIPT_SAVSRCHTREE = "SavSrchTree";
    public const String JAVASCRIPT_TREESUBMIT = "TreeSubmit";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SavedSearchPortletAdminPrefsView();
    }
    
    /// <summary>
    /// Returns the HTML for the Section.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>XPException </throws>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLInput myInput;
      HTMLSpan mySpan;
      try
      {
        DisplayHiddenInputs(result);
        HTMLComment myComment = new HTMLComment("Begin: Display SavedSearchPortletAdminPrefsView");
        result.AddInnerHTMLElement(myComment);
        // Break MVC rules just for testing
        ISavedSearchPortletPrefsModelRO iModel = (ISavedSearchPortletPrefsModelRO) m_model;
        mySpan = new HTMLSpan();
        mySpan.AddInnerHTMLString(m_asOwner.GetString(65, ResourceConstants.PORTLETSMSGS) + " " + XPHttpUtility.HtmlEncode(iModel.GetPortletName()));
        mySpan.SetStyleClass(PTStyleClass.LIST_SUBHEAD);
        result.AddInnerHTMLElement(mySpan);
        myTable = new HTMLTable();
        result.AddInnerHTMLElement(myTable);
        myTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        myTable.SetBorder(CommonHTMLStrings.ZERO);
        myTable.SetCellPadding(CommonHTMLStrings.FIVE);
        myTable.SetCellSpacing(CommonHTMLStrings.ZERO);
        // 1st Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.LIST_READ_TEXT);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(2176, "ptmsgs_portaladminmsgs"));
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
        myCell.AddInnerHTMLString(XPHttpUtility.HtmlEncode(((ISavedSearchPortletPrefsModelRO) m_model).GetSavSrchName()));
        PTConstruct myConstruct = ConstructFactory.GetConstruct(PTImageType.ICON_SAVED_SEARCH);
        HTMLImg myImg = (HTMLImg) myConstruct.GetHTMLElement();
        myImg.SetAlt(m_asOwner.GetString(2178, "ptmsgs_portaladminmsgs"));
        XPStringBuilder sb = new XPStringBuilder(200);
        // mj: removed 'Javascript:' from function name
        sb.Append("").Append(JAVASCRIPT_SAVSRCHTREE);
        sb.Append("(document.").Append(AFormDP.HTMLFORM_NAME).Append(".");
        sb.Append(HTMLHIDDEN_SAVSRCHSPACEID).Append(",");
        sb.Append(XPConvert.ToString(SavedSearchPortletPrefsRepostControl.POSTTOSELF_ACTION_CHANGESAVSRCHID));
        sb.Append(");");
        HTMLSpan mySpan2 = new HTMLSpan();
        mySpan2.AddInnerHTMLElement(myImg);
        mySpan2.SetOnClick(sb.ToString());
        myInput = new HTMLInput(HTMLInputTypes.HIDDEN, HTMLINPUT_SAVSRCHID,
         "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetValue(XPConvert.ToString(((ISavedSearchPortletPrefsModelRO) m_model).GetSavSrchID()));
        myCell = new HTMLTableCell();
        myCell.SetAlign(CommonHTMLStrings.RIGHT);
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myCell.AddInnerHTMLElement(mySpan2);
        /* we no longer use the presentation style. */
        //			myRow = new HTMLTableRow();
        //			myTable.AddInnerHTMLElement(myRow);
        //			myRow.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BG);
        //
        //			myCell = new HTMLTableCell();
        //			myRow.AddInnerHTMLElement(myCell);
        //			mySpan = new HTMLSpan();
        //			myCell.AddInnerHTMLElement(mySpan);
        //			myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
        //			mySpan.SetStyleClass(PTStyleClass.LIST_READ_TEXT);
        //
        //			mySpan.AddInnerHTMLString(m_asOwner.GetString(2177, "ptmsgs_portaladminmsgs"));
        //
        //			myCell = new HTMLTableCell();
        //			myCell.SetColSpan(CommonHTMLStrings.TWO);
        //			myCell.SetAlign(CommonHTMLStrings.RIGHT);
        //			myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
        //			myRow.AddInnerHTMLElement(myCell);
        //			myCell.SetNoWrap(true);
        //
        //			myInput = new HTMLInput(HTMLInputTypes.RADIO, HTMLINPUT_SIMPLE, "");
        //			myInput.SetValue(XPConvert.ToString(true));
        //
        //			boolean bSimple = XPConvert.ToBoolean(iModel.GetSimple());
        //			myInput.SetChecked(bSimple);
        //
        //			myCell.AddInnerHTMLString(m_asOwner.GetString(758, "ptmsgs_portaladminmsgs"));
        //			myCell.AddInnerHTMLElement(myInput);
        //
        //			HTMLInput myInput2 = new HTMLInput(HTMLInputTypes.RADIO, HTMLINPUT_SIMPLE, "");
        //			myInput2.SetValue(XPConvert.ToString(false));
        //			myInput2.SetChecked(!bSimple);
        //
        //			myCell.AddInnerHTMLString(m_asOwner.GetString(759, "ptmsgs_portaladminmsgs"));
        //			myCell.AddInnerHTMLElement(myInput2);
        myComment = new HTMLComment("End: Display SavedSearchPortletAdminPrefsView");
        result.AddInnerHTMLElement(myComment);
      }
      catch (Exception e)
      {
        log.Error(e, "SavedSearchPortletAdminPrefsView::Display An error occured when trying to display the HTML.");
        throw new XPException(m_asOwner.GetString(464, "ptmsgs_portalcommonmsgs"),
         e);
      }
      return result;
    }
    
    /// <summary>
    /// Display the hidden inputs
    /// </summary>
    /// <param name="result">The HTMLElementCollection being manipulated</param>
    /// <throws>HTMLException</throws>
    protected virtual void DisplayHiddenInputs(HTMLElementCollection result)
    {
      HTMLInput myInput;
      // Hidden input for the Space ID for the tree.  That way if you hit the folder
      // tree link twice, it will open the same tree both times.
      // olegs: cool but dangerous; if you restart server you get a blank tree window
      // due to null root pointer in TreeCompositeIterator.<init>
      // one for the document directory
      myInput = new HTMLInput(HTMLInputTypes.HIDDEN, HTMLHIDDEN_SAVSRCHSPACEID,
       "");
      result.AddInnerHTMLElement(myInput);
      String strSpaceID = ((ISavedSearchPortletPrefsModelRO) m_model).GetLastTreeSpaceId();
      myInput.SetValue((strSpaceID == null) ? "" : strSpaceID);
      // hidden input to hold repost action on tree submit
      myInput = new HTMLInput(HTMLInputTypes.HIDDEN, HTMLHIDDEN_TREEREPOST,
       "");
      result.AddInnerHTMLElement(myInput);
      myInput.SetValue("");
    }
    
    /// <summary>
    /// This method returns the HTMLScript that encompasses the Javascript on
    /// the page.
    /// </summary>
    /// <returns>HTMLScript</returns>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    public override HTMLScript DisplayJavascript()
    {
      HTMLScript myScript = new HTMLScript("text/javaScript");
      String strFormName = AFormDP.HTMLFORM_NAME;
      // The URL to open a new remote catalog folder tree
      ASURL SavSrchTree = new ASURL(m_asOwner);
      SavSrchTree.SetLinkCreateNewSpace(TreeAS.STR_MVC_CLASS_NAME, m_asOwner);
      SavSrchTree.SetSubSpaceKey(JAVASCRIPT_SAVSRCHTREE);
      SavSrchTree.SetControl(StartTreeControl.STR_MVC_CLASS_NAME);
      SavSrchTree.AddControlArgument(StartTreeControl.TITLE, m_asOwner.GetString(2175,
       "ptmsgs_portaladminmsgs"));
      SavSrchTree.AddControlArgument(StartTreeControl.ACTIONSUBTITLE, m_asOwner.GetString(802,
       "ptmsgs_portaladminmsgs"));
      SavSrchTree.AddControlArgument(StartTreeControl.CLASS_IDS_TO_DISPLAY,
       XPConvert.ToString(PT_CLASSIDS.PT_SAVEDSEARCH_ID));
      SavSrchTree.AddControlArgument(StartTreeControl.ROOT_ID, XPConvert.ToString(PT_INTRINSICS.PT_FOLDER_ROOTFOLDER));
      SavSrchTree.AddControlArgument(StartTreeControl.SHOW_ROOT, XPConvert.ToString(true));
      SavSrchTree.AddControlArgument(StartTreeControl.MULTI_SELECT, XPConvert.ToString(false));
      SavSrchTree.AddControlArgument(StartTreeControl.SELECT_MODE, XPConvert.ToString(TreeConstants.N_LEAFSELECT));
      SavSrchTree.AddControlArgument(StartTreeControl.SUBMIT_MODE, XPConvert.ToString(TreeConstants.N_SERVERSUBMIT));
      SavSrchTree.AddControlArgument(StartTreeControl.PARENT_FORM_NAME, strFormName);
      SavSrchTree.AddControlArgument(StartTreeControl.PARENT_FORM_SPACE_ID,
       HTMLHIDDEN_SAVSRCHSPACEID);
      SavSrchTree.AddControlArgument(StartTreeControl.PARENT_SUBMIT_CALL,
       JAVASCRIPT_TREESUBMIT);
      String strSavSrchSelect = SavSrchTree.GetURLAsString();
      ASURL oldSavSrchTree = new ASURL(m_asOwner);
      oldSavSrchTree.SetLinkCreateNewSpace(TreeAS.STR_MVC_CLASS_NAME, m_asOwner);
      oldSavSrchTree.IsSubSpace();
      String strOldSavSrch = oldSavSrchTree.GetURLAsString();
      // Open remote catalog folder tree function
      XPStringBuilder sb = new XPStringBuilder(200);
      sb.Append("function ").Append(JAVASCRIPT_SAVSRCHTREE).Append("(savsrchspaceid, repostaction)\n");
      sb.Append("{\n");
      sb.Append("  \tdocument.").Append(AFormDP.HTMLFORM_NAME).Append(".").Append(HTMLHIDDEN_TREEREPOST).Append(".value = repostaction;\n");
      sb.Append("  \tif (savsrchspaceid.value == \'\')\n");
      sb.Append("    \t\twindow.open(\'").Append(strSavSrchSelect).Append("\', \'_blank1\', \'").Append(TreeConstants.GetJavascriptTreeWindowAttributes()).Append("\');\n");
      sb.Append("  \telse\n");
      sb.Append("    \t\twindow.open(\'").Append(strOldSavSrch).Append("&").Append(ASConstants.SPACEID).Append("=\' + savsrchspaceid.value, \'_blank1\', \'").Append(TreeConstants.GetJavascriptTreeWindowAttributes()).Append("\');\n");
      sb.Append("}\n");
      myScript.AddInnerHTMLString(sb.ToString());
      // Submit function
      sb.SetLength(0);
      sb.Append("function ").Append(JAVASCRIPT_TREESUBMIT).Append("()\n");
      sb.Append("{\n");
      sb.Append("  ").Append(AFormDP.JAVASCRIPT_SUBMIT_FORM).Append("(document.").Append(AFormDP.HTMLFORM_NAME).Append(".").Append(HTMLHIDDEN_TREEREPOST).Append(".value);\n");
      sb.Append("}\n");
      myScript.AddInnerHTMLString(sb.ToString());
      return myScript;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}