using System;
using com.plumtree.portaluiinfrastructure.intrinsicportlets.prefs;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.portlets.savedsearch.prefs
{
  /// <summary>
  /// Display page for intrinsic portlet, which uses the the editor framework.
  /// </summary>
  /// <author>mikes</author>
  public class SavedSearchPortletPrefsDP : EditorDP
  {
    
    /// <summary>
    /// Class name for SavedSearchPortletPrefsDP 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "SavedSearchPortletPrefs";
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,  linking to
    /// that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(471, "ptmsgs_portalcommonmsgs");
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for that Page.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // Insert super class HTML
      result.AddInnerHTMLElement(base.PageDisplay());
      HTMLElementCollection views = new HTMLElementCollection();
      // Determine what kind of prefs we are modifying.
      ISavedSearchPortletPrefsModelRO iModel = (ISavedSearchPortletPrefsModelRO) m_asOwner.GetModel(SavedSearchPortletPrefsModel.STR_MVC_CLASS_NAME);
      if (IntrinsicPortletPrefsEditorModel.PREF_TYPE_ADMIN == iModel.GetPrefType())
      {
        // sq Admin Prefs
        views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(SavedSearchPortletAdminPrefsView.STR_MVC_CLASS_NAME)).Display());
        // display fields exp list
        views.AddInnerHTMLElement(EditorView.GetSpacerTable());
        views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(SavedSearchPortletPrefsEditorAS.STR_MVC_SELECT_DISPLAY_FIELDS)).Display());
        // parameteric fields exp list
        views.AddInnerHTMLElement(EditorView.GetSpacerTable());
        views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(SavedSearchPortletPrefsEditorAS.STR_MVC_SELECT_PARAMETRIC_FIELDS)).Display());
        }
      result.AddInnerHTMLElement(CreateLeftNavBar(views));
      /* *****************************************
       * EDITOR WITH NO HEADER AND NO LEFT NAV?
       *
       * Replace the code above with the 2 lines below:
       *
       * HTMLElementCollection result = new HTMLElementCollection();
       * result.AddInnerHTMLElement(((EditorView)m_asOwner.GetView(SavedSearchPortletPrefsView.STR_MVC_CLASS_NAME)).Display());
       *
       ******************************************
       */
       
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      ISavedSearchPortletPrefsModelRO iModel = (ISavedSearchPortletPrefsModelRO) m_asOwner.GetModel(SavedSearchPortletPrefsModel.STR_MVC_CLASS_NAME);
      // Determine what kind of prefs we are modifying.
      if (IntrinsicPortletPrefsEditorModel.PREF_TYPE_ADMIN == iModel.GetPrefType())
      {
        HTMLScript myScript = m_asOwner.GetView(SavedSearchPortletAdminPrefsView.STR_MVC_CLASS_NAME).DisplayJavascript();
        if (null != myScript)
        {
          myScripts.AddInnerHTMLElement(myScript);
        }
        myScripts.AddInnerHTMLElement(m_asOwner.GetView(SavedSearchPortletPrefsEditorAS.STR_MVC_SELECT_DISPLAY_FIELDS).DisplayJavascript());
        myScripts.AddInnerHTMLElement(m_asOwner.GetView(SavedSearchPortletPrefsEditorAS.STR_MVC_SELECT_PARAMETRIC_FIELDS).DisplayJavascript());
        }
      return myScripts;
    }
  }
}