using System;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.expandablelist;
namespace com.plumtree.portalpages.portlets.savedsearch.prefs
{
  /// <summary>
  /// EditorRepostControl for our intrinsic portlet, which uses the editor
  /// framework.
  /// </summary>
  /// <author>mikes</author>
  public class SavedSearchPortletPrefsRepostControl : EditorRepostControl
  {
    
    /// <summary>
    /// SavedSearchPortletPrefsRepost 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "SavedSearchPortletPrefsRepost";
    
    /// <summary>
    /// Add an admin folder 
    /// </summary>
    public const int POSTTOSELF_ACTION_CHANGESAVSRCHID = 10;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SavedSearchPortletPrefsRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call  the associated method for each
    /// action.
    /// </summary>
    /// <param name="_nAction"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      ((ExpListControl) m_asOwner.GetControl(SavedSearchPortletPrefsEditorAS.STR_MVC_SELECT_PARAMETRIC_FIELDS)).PerformRepostAction(_nAction,
       m_htFormData);
      ((ExpListControl) m_asOwner.GetControl(SavedSearchPortletPrefsEditorAS.STR_MVC_SELECT_DISPLAY_FIELDS)).PerformRepostAction(_nAction,
       m_htFormData);
      ((SavedSearchPortletPrefsModel) m_model).CheckDisplayFieldsInExpList();
      switch (_nAction){
      case POSTTOSELF_ACTION_CHANGESAVSRCHID:
      ((SavedSearchPortletPrefsModel) m_model).ChangeSavedSearchIDOnRepost();
      break;
      }
    }
  }
}