using System;
using com.plumtree.portalpages.browsing.search.results;
using com.plumtree.portaluiinfrastructure.intrinsicportlets;
using com.plumtree.server;
namespace com.plumtree.portalpages.portlets.search
{
  /// <author>CraigS</author>
  public class SearchPortletModel : IntrinsicPortletModel
  {
    public const String STR_MVC_CLASS_NAME = "SearchPortlet";
    
    /// <returns></returns>
    public override bool ControlExists()
    {
      return false;
    }
    
    /// <returns></returns>
    public override Object Create()
    {
      return new SearchPortletModel();
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public override Object GetNewTempData()
    {
      if (0 != m_nPageID)
      {
        return GetSettingValues(SETTINGSTYPE_PORTLET, (String[]) null);
      } else
      {
        // We're in preview mode
        return null;
      }
    }
    
    /// <returns></returns>
    public virtual Object[][] GetRecentSearches()
    {
      Object o = m_asOwner.GetSubSession().GetAttribute(BannerStartSearchControl.CACHED_RECENT_KEY);
      if ((null != o) && (o is RecentSearchHistory))
      {
        RecentSearchHistory hist = (RecentSearchHistory) o;
        // Check that this was cached by the same user
        IPTSession session = (IPTSession) m_asOwner.GetUserSession();
        IPTSessionInfo info = session.GetSessionInfo();
        if (info.GetCurrentUserID() == hist.userId)
        {
          return hist.recentSearches;
        }
      }
      return null;
    }
  }
}