using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.intrinsicportlets;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.portlets.sitemap
{
  /// <version>$Revision$</version>
  /// <author>josephc</author>
  public class SiteMapPortletControl : IntrinsicPortletControl
  {
    
    /// <summary>
    /// Class name for the control. For intrinsic portlets, the control must
    /// have the same class name as the model.
    /// </summary>
    public static readonly String STR_MVC_CLASS_NAME = SiteMapPortletModel.STR_MVC_CLASS_NAME;
    
    /// <param name="arguments"></param>
    /// <returns></returns>
    public override Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SiteMapPortletControl();
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <param name="_nAction"></param>
    /// <param name="_htFormData"></param>
    public override void PerformRepostAction(int _nAction, XPHashtable _htFormData)
    {
      SiteMapPortletModel myModel = (SiteMapPortletModel) m_model;
      String sDataKey = SiteMapPortletView.HTMLINPUT_VALUE + myModel.GetPortletID();
      String[] aDataValues = (String[]) _htFormData.GetElement(sDataKey);
      if ((null != aDataValues) && !(0 == aDataValues.Length))
      {
        myModel.SetData(aDataValues[0]);
      }
    }
  }
}