using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.sitemap.sitemappage;
using com.plumtree.portalpages.portlets.sitemap.prefs;
using com.plumtree.portaluiinfrastructure.compoundlist;
using com.plumtree.portaluiinfrastructure.intrinsicportlets;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
namespace com.plumtree.portalpages.portlets.sitemap
{
  /// <author>josephc</author>
  public class SiteMapPortletModel : IntrinsicPortletModel,ISiteMapPortletModelRO,
  IRepostModel
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_PORTLETS),
     "com.plumtree.portalpages.portlets.sitemap.SiteMapPortletModel");
    
    /// <summary>
    /// Class name for the model 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "SiteMapPortlet";
    private String m_strLinkOrder = "";
    private bool m_bShowDescriptions;
    private int m_nFolderID;
    private int m_nMaxNumLinksToDisplay = 10;
    private int m_nNumTotalLinks;
    
    /// <returns></returns>
    public override bool ControlExists()
    {
      return true;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SiteMapPortletModel();
    }
    
    /// <summary>
    /// Implement some code to execute when the user clicks on "Finish".
    /// </summary>
    public virtual void Finish()
    {
    }
    
    /// <returns></returns>
    public virtual int GetCommunityID()
    {
      if (PT_CLASSIDS.PT_COMMUNITY_ID == m_nContainerClassID)
      {
        return m_nContainerObjectID;
      }
      return 0;
    }
    
    /// <returns></returns>
    /// <throws>XPException </throws>
    public virtual String GetData()
    {
      try
      {
        /*
         IPTGadget ptPortlet = m_ptPortlet;
         
         IPTAdminSettings ptAdminSettings = (IPTAdminSettings) ptPortlet.GetInterfaces("IPTAdminSettings");
         
         Object[] aSettings = new Object[1];
         aSettings[0] = ADMINGADGETSETTING_FOLDERID;
         
         Object[][] arData = (Object[][]) ptAdminSettings.LookupAdminGadgetSettings(aSettings);
         String strData    = (String) arData[1][0];
         
         return strData;
         */
         
        return null;
      }
      catch (Exception e)
      {
        log.Error(e, "SiteMapPortletModel::GetData. " + m_asOwner.GetString(590,
         "ptmsgs_portalcommonmsgs"));
        throw new XPException(m_asOwner.GetString(590, "ptmsgs_portalcommonmsgs"),
         e);
      }
    }
    
    /// <returns></returns>
    public virtual int GetFolderID()
    {
      return m_nFolderID;
    }
    
    /// <returns></returns>
    public virtual String GetFolderName()
    {
      IPTSiteMapFolderInfo ptSiteMapFolderInfo = (IPTSiteMapFolderInfo) GetTempData();
      if ((ptSiteMapFolderInfo != null) && (0 != ptSiteMapFolderInfo.GetObjectID()))
      {
        String strName = ptSiteMapFolderInfo.GetName();
        if ("".Equals(strName) || (strName == null))
        {
          return m_asOwner.GetString(589, "ptmsgs_portalcommonmsgs");
        } else
        {
          return strName;
        }
      } else
      {
        return m_asOwner.GetString(589, "ptmsgs_portalcommonmsgs");
      }
    }
    
    /// <returns></returns>
    public virtual bool GetHasEditAccessToCommunity()
    {
      IPTCommunityManager ptOM = (IPTCommunityManager) m_ptSession.GetCommunities();
      IPTCommunityInfo ptCommunityInfo = ptOM.CachedOpenCommunityInfo(GetCommunityID(),
       false);
      bool bHasEditAccess = false;
      if ((ptCommunityInfo != null) && (0 != ptCommunityInfo.GetObjectID()))
      {
        bHasEditAccess = ptCommunityInfo.GetAccessLevel() >= PT_ACCESS_LEVELS.PT_ACCESS_LEVEL_EDIT;
        }
      return bHasEditAccess;
    }
    
    /// <returns></returns>
    public virtual bool GetHasEditAccessToFolder()
    {
      IPTSiteMapFolderInfo ptSiteMapFolderInfo = (IPTSiteMapFolderInfo) GetTempData();
      bool bHasEditAccess = false;
      if ((ptSiteMapFolderInfo != null) && (0 != ptSiteMapFolderInfo.GetObjectID()))
      {
        bHasEditAccess = ptSiteMapFolderInfo.GetAccessLevel() >= PT_ACCESS_LEVELS.PT_ACCESS_LEVEL_EDIT;
        }
      return bHasEditAccess;
    }
    
    /// <returns></returns>
    public virtual bool GetHasReadAccessToFolder()
    {
      IPTSiteMapFolderInfo ptSiteMapFolderInfo = (IPTSiteMapFolderInfo) GetTempData();
      bool bHasEditAccess = false;
      if ((ptSiteMapFolderInfo != null) && (0 != ptSiteMapFolderInfo.GetObjectID()))
      {
        bHasEditAccess = ptSiteMapFolderInfo.GetAccessLevel() >= PT_ACCESS_LEVELS.PT_ACCESS_LEVEL_READ;
        }
      return bHasEditAccess;
    }
    
    /// <returns></returns>
    public virtual ICPListEntryIterator GetLinks()
    {
      ASCompoundList cpList = new ASCompoundList();
      try
      {
        IPTSiteMapFolderInfo ptSiteMapFolderInfo = (IPTSiteMapFolderInfo) GetTempData();
        if ((ptSiteMapFolderInfo != null) && (0 != ptSiteMapFolderInfo.GetObjectID()))
        {
          m_nNumTotalLinks = SiteMapModel.CreateSortedLinks(ptSiteMapFolderInfo,
           cpList, m_strLinkOrder, m_asOwner);
        }
      }
      catch (Exception e)
      {
        log.Warn("Failed getting links for community links portlet.");
      }
      return cpList;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <returns></returns>
    public override Object GetNewTempData()
    {
      SetFolderID(0);
      Object[][] arSettings = GetSettingValues(SETTINGSTYPE_COMMUNITYPORTLET,
       (String[]) null);
      if (null != arSettings)
      {
        for (int i = 0;i < arSettings[0].Length;i++)
        {
          String strSettingName = (String) arSettings[0][i];
          if (strSettingName.Equals(SiteMapPortletPrefsModel.SETTING_NAME_FOLDERID))
          {
            SetFolderID(XPConvert.ToInteger(arSettings[1][i]));
          } else
          if (strSettingName.Equals(SiteMapPortletPrefsModel.SETTING_NAME_LINKORDER))
          {
            String strLinkOrder = (String) arSettings[1][i];
            SetLinkOrder(strLinkOrder);
          } else
          if (strSettingName.Equals(SiteMapPortletPrefsModel.SETTING_NAME_SHOWDESC))
          {
            SetShowDescriptions(XPConvert.ToInteger(arSettings[1][i]));
          } else
          if (strSettingName.Equals(SiteMapPortletPrefsModel.SETTING_NAME_NUMLINKS))
          {
            SetNumLinksToDisplay(XPConvert.ToInteger(arSettings[1][i]));
          }
        }
      }
      int nSiteMapFolder = GetFolderID();
      IPTSiteMapFolderManager ptOM = (IPTSiteMapFolderManager) m_ptSession.GetSiteMapFolders();
      IPTSiteMapFolderInfo ptSiteMapFolderInfo = ptOM.CachedOpenSiteMapFolderInfo(nSiteMapFolder);
      // DCA - check to make sure site map folder exists if nSiteMapFolder is non-zero
      try
      {
        if (0 != nSiteMapFolder)
        {
          ptSiteMapFolderInfo.GetAccessLevel();
        }
      }
      catch (Exception e)
      {
        // reset folderID to 0
        SetFolderID(0);
        ptSiteMapFolderInfo = ptOM.CachedOpenSiteMapFolderInfo(0);
      }
      return ptSiteMapFolderInfo;
    }
    
    /// <seealso cref="com.plumtree.portalpages.portlets.sitemap.ISiteMapPortletModelRO#GetNumLinksToDisplay()"></seealso>
    public virtual int GetNumLinksToDisplay()
    {
      return m_nMaxNumLinksToDisplay;
    }
    
    /// <returns></returns>
    public virtual String GetPrefsURL()
    {
      String strPrefsURL = GatewayHelpers.ConstructCommunityPrefsLink(m_asOwner,
       GetPortletID(), GetCommunityID(), m_nPageID, true);
      return strPrefsURL;
    }
    
    /// <summary>
    /// Returns the Redirect object  (this is were we need to go at the end of
    /// the Editor).
    /// </summary>
    /// <returns>Redirect</returns>
    public virtual Redirect GetRedirectAfterFinish()
    {
      return null;
    }
    
    /// <summary>
    /// Calls the right save function according to the page name passed in
    /// argument.
    /// </summary>
    /// <param name="_sPageName"></param>
    /// <param name="_htFormData"></param>
    /// <returns></returns>
    public virtual int SavePage(String _sPageName, XPHashtable _htFormData)
    {
      return RepostControl.PAGE_STATUS_VALID;
    }
    
    /// <param name="strData"></param>
    /// <throws>XPException </throws>
    public virtual void SetData(String strData)
    {
    }
    /*   try
     {
     //IPTGadget ptPortlet = GetPortlet(_nPortletID);
     IPTObjectManager ptOM = m_ptSession.GetGadgets();
     IPTGadget ptPortlet   = (IPTGadget) ptOM.Open(m_nPortletID, false);
     
     IPTAdminSettings ptAdminSettings = (IPTAdminSettings) ptPortlet.GetInterfaces("IPTAdminSettings");
     ptAdminSettings.AddAdminGadgetSetting(m_strAdminSettingKey, strData);
     
     IPTServerContext ptSC = (IPTServerContext) ptPortlet.GetInterfaces("IPTServerContext");
     ptSC.LockObject();
     ptSC.Store();
     ptSC.UnlockObject();
     }
     catch (Exception e)
     {
     if ( log.IsErrorEnabled() )
     {
     log.Error("SamplePortletModel::SetData. " + m_asOwner.GetString(591, "ptmsgs_portalcommonmsgs") + ":" + e.getMessage());
     }
     
     throw new XPException(m_asOwner.GetString(591, "ptmsgs_portalcommonmsgs"), e);
     }
     */
     
    
    /// <returns></returns>
    public virtual void SetFolderID(int nFolderID)
    {
      m_nFolderID = nFolderID;
    }
    
    /// <seealso cref="com.plumtree.portalpages.portlets.sitemap.ISiteMapPortletModelRO#ShowDescriptions()"></seealso>
    public virtual bool ShowDescriptions()
    {
      return m_bShowDescriptions;
    }
    
    /// <returns></returns>
    public virtual bool ShowMoreLink()
    {
      if (m_nFolderID == 0)
      {
        return false;
      }
      return (m_nMaxNumLinksToDisplay < m_nNumTotalLinks);
    }
    
    /// <param name="strLinkOrder"></param>
    private void SetLinkOrder(String strLinkOrder)
    {
      m_strLinkOrder = strLinkOrder;
    }
    
    /// <param name="intNumLinks"></param>
    private void SetNumLinksToDisplay(int intNumLinksToDisplay)
    {
      m_nMaxNumLinksToDisplay = intNumLinksToDisplay;
    }
    
    /// <param name="intShowDesc"></param>
    private void SetShowDescriptions(int intShowDesc)
    {
      m_bShowDescriptions = (1 == intShowDesc);
    }
  }
}