using System;
// Framework Imports
using com.plumtree.portalpages.browsing.editors.sitemap.sitemapfolderplugin;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.portlets.sitemap.prefs
{
  /// <summary>
  /// Display page for intrinsic portlet, which uses the the editor framework.
  /// </summary>
  /// <version>$Revision$</version>
  /// <author>josephc</author>
  public class SiteMapPortletPrefsDP : EditorDP
  {
    
    /// <summary>
    /// SiteMapPortletPrefs 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "SiteMapPortletPrefs";
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,  linking to
    /// that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(570, "ptmsgs_portalcommonmsgs");
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for that Page.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // Insert super class HTML
      result.AddInnerHTMLElement(base.PageDisplay());
      HTMLElementCollection views = new HTMLElementCollection();
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(SiteMapPortletPrefsView.STR_MVC_CLASS_NAME)).Display());
      if (m_asOwner.GetIsAccessStyleStandard())
      {
        views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(SiteMapPortletPrefsSortedLinksView.STR_MVC_CLASS_NAME)).Display());
        }
      result.AddInnerHTMLElement(CreateLeftNavBar(views));
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      //super.DisplayJavaScriptFromChild();
      HTMLScriptCollection myScripts = new HTMLScriptCollection();
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(SiteMapPortletPrefsView.STR_MVC_CLASS_NAME).DisplayJavascript());
      SiteMapPortletPrefsModel prefsModel = (SiteMapPortletPrefsModel) m_asOwner.GetModel(SiteMapPortletPrefsModel.STR_MVC_CLASS_NAME);
      if (prefsModel.GetFolderID() != 0)
      {
        myScripts.AddInnerHTMLElement(m_asOwner.GetView(SiteMapPortletPrefsSortedLinksView.STR_MVC_CLASS_NAME).DisplayJavascript());
        myScripts.AddInnerHTMLElement(m_asOwner.GetView(SiteMapFolderPlugInView.STR_MVC_CLASS_NAME).DisplayJavascript());
        // DCA - display javascript for delete action
        myScripts.AddInnerHTMLElement(((SiteMapFolderPlugInView) m_asOwner.GetView(SiteMapFolderPlugInView.STR_MVC_CLASS_NAME)).DisplayDeleteJavascript());
        }
      HTMLScript script = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
      script.SetSrc(ConfigHelper.GetPortalImageServerJavaScriptURL(m_asOwner) + "opennewwindow.js");
      myScripts.AddInnerHTMLElement(script);
      return myScripts;
    }
  }
}