using System;
// Framework Imports
using com.plumtree.portalpages.browsing.editors.sitemap.sitemapfolderplugin;
using com.plumtree.portaluiinfrastructure.application.varpacks;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.portlets.sitemap.prefs
{
  /// <summary>
  /// EditorRepostControl for our intrinsic portlet, which uses the editor
  /// framework.
  /// </summary>
  /// <version>$Revision$</version>
  /// <author>NaveenP</author>
  public class SiteMapPortletPrefsRepostControl : EditorRepostControl
  {
    
    /// <summary>
    /// SiteMapPortletPrefsRepost 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "SiteMapPortletPrefsRepost";
    public const int POSTTOSELF_ACTION_MISC = 50;
    public const int POSTTOSELF_ACTION_DONE_POPUP = 51;
    public const int POSTTOSELF_ACTION_OPEN_POPUP = 52;
    public const int POSTTOSELF_ACTION_SHOWDESC = 54;
    public const int POSTTOSELF_ACTION_ORDERALPHA = 55;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SiteMapPortletPrefsRepostControl();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Switch between the action modes and call  the associated method for each
    /// action.
    /// </summary>
    /// <param name="_nAction"></param>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      ((SiteMapFolderPlugInControl) m_asOwner.GetControl(SiteMapFolderPlugInControl.STR_MVC_CLASS_NAME)).PerformRepostAction(_nAction,
       m_htFormData);
      Redirect redirect;
      //***CHANGE_HERE*** if you don't have any repost action, delete the switch statement.
      switch (_nAction){
      //***CHANGE_HERE*** Create a new case for each of your action.
      case POSTTOSELF_ACTION_FINISH:
      if (m_asOwner.GetIsAccessStyleStandard())
      {
        ClosePopUpDP closeDP = (ClosePopUpDP) m_asOwner.GetPage(ClosePopUpDP.STR_MVC_CLASS_NAME);
        HTMLScript script = new HTMLScript("text/javaScript");
        try
        {
          if (PTConfigHelper.GetSecurityMode() != PTConfigVarPack.SECURITY_MODE_SSL_CRITICAL_AS_ONLY)
          {
            script.AddInnerHTMLString("window.opener.location.reload(true);");
            }
        }
        catch (HTMLException he)
        {
        }
        closeDP.SetScript(script);
        redirect = new Redirect();
        redirect.SetLinkGetCachedSpace(m_asOwner);
        redirect.SetDisplayPage(ClosePopUpDP.STR_MVC_CLASS_NAME);
        SetRedirect(redirect);
      }
      break;
      case POSTTOSELF_ACTION_MISC:
      ((SiteMapPortletPrefsModel) m_model).ActionOnRepost();
      break;
      case POSTTOSELF_ACTION_DONE_POPUP:
      //***CHANGE_HERE*** Put any code you want to execute on come back from pop-up.
      // JF- There is nothing special to do here for template 6.
      // The main form has been posted and all the values have been saved by savePage.
      // The main page will be redisplayed with the new values.
      // And the pop-up has been closed by the JavaScript.
      break;
      case POSTTOSELF_ACTION_OPEN_POPUP:
      // ***CHANGE_HERE*** Add some code you want to execute when the pop-up is loaded.
      // If you don't have anything special to do here, just delete this case.
      break;
      case POSTTOSELF_ACTION_SHOWDESC:
      break;
      case POSTTOSELF_ACTION_ORDERALPHA:
      break;
      case SiteMapFolderPlugInControl.POSTTOSELF_ACTION_SAVELINKS:
      ClosePopUpDP closeWebLinkDP = (ClosePopUpDP) m_asOwner.GetPage(ClosePopUpDP.STR_MVC_CLASS_NAME);
      HTMLScript scriptWebLink = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
      scriptWebLink.AddInnerHTMLString("window.opener.document." + AFormDP.HTMLFORM_NAME + ".submit();\n");
      closeWebLinkDP.SetScript(scriptWebLink);
      closeWebLinkDP.SetToClose(true);
      redirect = new Redirect();
      redirect.SetLinkGetCachedSpace(m_asOwner);
      redirect.SetDisplayPage(ClosePopUpDP.STR_MVC_CLASS_NAME);
      SetRedirect(redirect);
      break;
      }
      // You need to call the PerformRepostAction on the page list control
      ((SiteMapPortletPrefsSortedLinksControl) m_asOwner.GetControl(SiteMapPortletPrefsSortedLinksControl.STR_MVC_CLASS_NAME)).PerformRepostAction(_nAction,
       m_htFormData);
    }
  }
}
// ***CHANGE_HERE*** Note that you can also implement the method below 
//      if you need to execute any code when the user finishes the sub Editor.
/*
 protected void PerformFinishSubEditorAction()
 {
 
 }*/
 
