using System;
// Framework Imports
using com.plumtree.openfoundation.internationalization;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.editors.sitemap.sitemapfolderplugin;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.portlets.sitemap.prefs
{
  /// <author>NaveenP</author>
  public class SiteMapPortletPrefsView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_PORTLETS),
     "com.plumtree.portalpages.portlets.sitemap.prefs.SiteMapPortletPrefsView");
    
    /// <summary>
    /// SiteMapPortletPrefs 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "SiteMapPortletPrefs";
    public const String HTMLINPUT_FOLDERNAME = "in_tx_FolderName";
    public const String HTMLBUTTON_REPOST = "in_bu_repost";
    public const String HTMLBUTTON_OPENPOPUP = "in_bu_open";
    public const String HTMLBUTTON_SHOWDESC = "in_cb_description";
    public const String HTMLBUTTON_ALPHA = "in_cb_alpha";
    public const String HTMLINPUT_NUMLINKS = "in_tx_numlinks";
    public const String JSFUNCTION_VALIDNUMLINKS = "ValidateNumLinks";
    public const String JSFUNCTION_VALIDNAME = "ValidatePortletName";
    public const String JSFUNCTION_VALIDATE_AND_SUBMIT = "ValidateNewFolderNameAndSubmit";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new SiteMapPortletPrefsView();
    }
    
    /// <summary>
    /// Returns the HTML for the Section.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>XPException </throws>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLInput myInput;
      HTMLSpan mySpan;
      HTMLB myBold;
      try
      {
        // ***CHANGEHERE*** Write the HTML for your Section.
        // ***COMMENT_1*** The HTML below can be used as a reference 
        //       to write some HTMLElements.
        // ***COMMENT_2*** Also look at PropMainView and PropAdvView in template1
        //      for more HTML example.
        HTMLComment myComment = new HTMLComment("Begin: Display SiteMapPortletPrefsView");
        result.AddInnerHTMLElement(myComment);
        // Break MVC rules just for testing
        ISiteMapPortletPrefsModelRO iModel = (ISiteMapPortletPrefsModelRO) m_model;
        //result.AddInnerHTMLString(iModel.GetPortletName());
        myTable = new HTMLTable();
        result.AddInnerHTMLElement(myTable);
        myTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
        myTable.SetBorder(CommonHTMLStrings.ZERO);
        myTable.SetCellPadding(CommonHTMLStrings.FIVE);
        myTable.SetCellSpacing(CommonHTMLStrings.ZERO);
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetColSpan(CommonHTMLStrings.THREE);
        myCell.SetHeight("20");
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_HEADER);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(665, "ptmsgs_portalcommonmsgs"));
        // create folder row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.DIR_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetColSpan(CommonHTMLStrings.FOUR);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        if (iModel.GetSiteMapFolderIsNull())
        {
          mySpan.AddInnerHTMLString(m_asOwner.GetString(575, "ptmsgs_portalcommonmsgs"));
          } else
        {
          mySpan.AddInnerHTMLString(m_asOwner.GetString(576, "ptmsgs_portalcommonmsgs"));
          }
        myRow = GetHTMLForNameRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.DIR_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.SetColSpan(CommonHTMLStrings.THREE);
        myInput = new HTMLInput(HTMLInputTypes.CHECKBOX, HTMLBUTTON_SHOWDESC,
         m_asOwner.GetString(588, "ptmsgs_portalcommonmsgs"));
        myInput.SetChecked(iModel.ShowDescriptions());
        // mj: removed 'Javascript:' from function name
        myInput.SetOnClick("postToSelf(\'" + SiteMapPortletPrefsRepostControl.POSTTOSELF_ACTION_SHOWDESC + "\')");
        mySpan.AddInnerHTMLElement(myInput);
        myBold = new HTMLB();
        myBold.AddInnerHTMLString(m_asOwner.GetString(588, "ptmsgs_portalcommonmsgs"));
        mySpan.AddInnerHTMLElement(myBold);
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.DIR_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myCell.SetColSpan(CommonHTMLStrings.THREE);
        myInput = new HTMLInput(HTMLInputTypes.CHECKBOX, HTMLBUTTON_ALPHA,
         m_asOwner.GetString(577, "ptmsgs_portalcommonmsgs"));
        myInput.SetChecked(iModel.OrderAlpha());
        // mj: removed 'Javascript:' from function name
        myInput.SetOnClick("postToSelf(\'" + SiteMapPortletPrefsRepostControl.POSTTOSELF_ACTION_ORDERALPHA + "\')");
        mySpan.AddInnerHTMLElement(myInput);
        myBold = new HTMLB();
        myBold.AddInnerHTMLString(m_asOwner.GetString(577, "ptmsgs_portalcommonmsgs"));
        mySpan.AddInnerHTMLElement(myBold);
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myRow.SetStyleClass(PTStyleClass.DIR_CONTENT_BG);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
        myBold = new HTMLB();
        myBold.AddInnerHTMLString(m_asOwner.GetString(582, "ptmsgs_portalcommonmsgs"));
        mySpan.AddInnerHTMLElement(myBold);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_NUMLINKS, "");
        myCell.AddInnerHTMLElement(myInput);
        myCell.SetAlign(CommonHTMLStrings.LEFT);
        myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
        myInput.SetValue(XPConvert.ToString(iModel.GetNumLinksToDisplay()));
        myInput.SetSize(CommonHTMLStrings.TWO);
        myInput.SetMaxLength(CommonHTMLStrings.TWO);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetWidth("50%");
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetColSpan(CommonHTMLStrings.THREE);
        myCell.SetHeight("5");
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        myComment = new HTMLComment("End: Display SiteMapPortletPrefsView");
        result.AddInnerHTMLElement(myComment);
      }
      catch (Exception e)
      {
        // ***CHANGE_HERE*** Update the error messages (log and exception).
        log.Error(e, "SiteMapPortletPrefsView::Display An error occured when trying to display the HTML.");
        throw new XPException(m_asOwner.GetString(579, "ptmsgs_portalcommonmsgs"),
         e);
      }
      return result;
    }
    
    /// <summary>
    /// This method returns the HTMLScript that encompasses the Javascript on
    /// the page.
    /// </summary>
    /// <returns>HTMLScript</returns>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    public override HTMLScript DisplayJavascript()
    {
      int nNumCurrLinks = ((SiteMapPortletPrefsSortedLinksModel) m_asOwner.GetModel(SiteMapPortletPrefsSortedLinksModel.STR_MVC_CLASS_NAME)).GetCurrNumLinks();
      HTMLScript myScript = new HTMLScript("text/javaScript");
      XPStringBuilder sb = new XPStringBuilder(200);
      sb.Append("\n" + "function " + JSFUNCTION_VALIDNUMLINKS + "()\n");
      sb.Append("{\n");
      if (((ISiteMapPortletPrefsModelRO) m_model).GetFolderID() != 0)
      {
        String strJSUtilVersionPrefix = ConfigHelper.GetJSIncluderVersionPrefix(ConfigHelper.JSCOMPONENT_JSUTIL);
        sb.Append("\t\tvar txtBox = document." + AFormDP.HTMLFORM_NAME + "." + HTMLINPUT_NUMLINKS + ";\n");
        sb.Append("\t\tif(txtBox) {\n");
        sb.Append("\t\t\tif(txtBox.value == \'\' || !" + strJSUtilVersionPrefix + "PTNumberUtil.isPositiveInteger(txtBox.value) || (txtBox.value < 1 && " + nNumCurrLinks + " != 0)) {\n");
        sb.Append("\t\t\t\talert(\'" + XPResourceManager.FormatMessage(m_asOwner.GetString(581,
         "ptmsgs_portalcommonmsgs"), XPConvert.ToString(nNumCurrLinks)) + "\');\n");
        sb.Append("\t\t\t\ttxtBox.focus();\n");
        sb.Append("\t\t\t\treturn false;\n");
        sb.Append("\t\t\t}\n");
        sb.Append("\t\t}\n");
      }
      sb.Append("\t\treturn true;\n");
      sb.Append("}\n");
      sb.Append("\n" + "function " + JSFUNCTION_VALIDNAME + "()\n");
      sb.Append("{\n");
      sb.Append("\t\tvar txtBox = document." + AFormDP.HTMLFORM_NAME + "." + HTMLINPUT_FOLDERNAME + ";\n");
      sb.Append("\t\tif(txtBox) {\n");
      sb.Append("\t\t\tif(txtBox.value == \'\') {\n");
      sb.Append("\t\t\t\talert(\'" + m_asOwner.GetString(753, "ptmsgs_portalcommonmsgs") + "\');\n");
      sb.Append("\t\t\t\ttxtBox.focus();\n");
      sb.Append("\t\t\t\treturn false;\n");
      sb.Append("\t\t\t}\n");
      sb.Append("\t\t\tif (-1 != txtBox.value.lastIndexOf(\"\\\\\") || " + "-1 != txtBox.value.lastIndexOf(\"\\t\") || -1 != txtBox.value.lastIndexOf(\"\\n\")) {\n");
      sb.Append("\t\t\t\talert(\'" + m_asOwner.GetString(754, "ptmsgs_portalcommonmsgs") + "\');\n");
      sb.Append("\t\t\t\ttxtBox.focus();\n");
      sb.Append("\t\t\t\treturn false;\n");
      sb.Append("\t\t\t}\n");
      sb.Append("\t\t}\n");
      sb.Append("\t\treturn true;\n");
      sb.Append("}\n");
      try
      {
        myScript.AddInnerHTMLString(sb.ToString());
      }
      catch (Exception e)
      {
        log.Error(e, "Error Displaying Prefs JS.");
      }
      return myScript;
    }
    
    /// <summary>
    /// Returns the HTML for the sub header.
    /// </summary>
    /// <returns>HTMLTableRow</returns>
    /// <throws>Exception</throws>
    public virtual HTMLTableRow GetHTMLForNameRow()
    {
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLInput myInput;
      HTMLSpan mySpan;
      // Row 1 - Cell 1 - input box for the site map folder name
      SiteMapFolderPlugInModel plugInModel = (SiteMapFolderPlugInModel) m_asOwner.GetModel(SiteMapFolderPlugInModel.STR_MVC_CLASS_NAME);
      myRow = new HTMLTableRow();
      myRow.SetStyleClass(PTStyleClass.DIR_CONTENT_BG);
      myCell = new HTMLTableCell();
      myCell.SetNoWrap(true);
      myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
      myRow.AddInnerHTMLElement(myCell);
      mySpan = new HTMLSpan();
      mySpan.SetStyleClass(PTStyleClass.LIST_SUBTITLE);
      mySpan.AddInnerHTMLString(m_asOwner.GetString(787, "ptmsgs_portalcommonmsgs"));
      mySpan.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      myCell.AddInnerHTMLElement(mySpan);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_FOLDERNAME, m_asOwner.GetString(787,
       "ptmsgs_portalcommonmsgs"));
      myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
      myInput.SetSize("30");
      IPTObject objFolder = plugInModel.GetPTObject();
      if (objFolder != null)
      {
        //MES- NOTE:  This value should NOT be localized, since it will be stored as
        //	the primary name of the Site Map
        myInput.SetValue(objFolder.GetName());
      } else
      {
        myInput.SetValue(m_asOwner.GetString(683, "ptmsgs_portalcommonmsgs"));
        }
      myCell.SetAlign(CommonHTMLStrings.RIGHT);
      myCell.AddInnerHTMLElement(myInput);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetWidth("50%");
      myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      return myRow;
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}