using System;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.intrinsicportlets;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
namespace com.plumtree.portalpages.portlets.userprofile.communities
{
  /// <author>jennifersu</author>
  public class CommunitiesPortletModel : IntrinsicPortletModel,ICommunitiesPortletModelRO
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_PORTLETS),
     "com.plumtree.portalpages.portlets.userprofile.communities.CommunitiesPortletModel");
    
    /// <summary>
    /// Class name for the model 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "ManagedCommunitiesPortlet";
    public const int NO_PROFILE_USER = 0;
    /* (non-Javadoc)
     * @see com.plumtree.portaluiinfrastructure.intrinsicportlets.IntrinsicPortletModel#ControlExists()
     */
     
    public override bool ControlExists()
    {
      return false;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portaluiinfrastructure.intrinsicportlets.IntrinsicPortletModel#GetName()
     */
     
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.AClearModel#Create()
     */
     
    public override Object Create()
    {
      return new CommunitiesPortletModel();
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.AClearModel#GetNewTempData()
     */
     
    public override Object GetNewTempData()
    {
      return null;
    }
    
    /// <summary>
    /// This method determines what roles the user is a member of and obtains
    /// the approriate text to be displayed in the introspective portlet.
    /// </summary>
    /// <param name="searchResponse">the search results for the user</param>
    /// <param name="index">the current index in the search results</param>
    /// <param name="iCurrentUser">the current user id</param>
    /// <returns>string the display string for the cell</returns>
    public virtual String GetUserRoles(IPTQueryResult searchResponse, int index,
     int iCurrentUser)
    {
      //		int Objectid     = searchResponse.ItemAsInt(index,
      //			PT_PROPIDS.PT_PROPID_OBJECTID);
      int commAccess = searchResponse.ItemAsInt(index, PT_PROPIDS.PT_PROPID_ACCESSLEVEL);
      switch (commAccess){
      case PT_ACCESS_LEVELS.PT_ACCESS_LEVEL_ADMIN:
      return (m_asOwner.GetString(41, "ptmsgs_portletsmsgs"));
      goto case PT_ACCESS_LEVELS.PT_ACCESS_LEVEL_EDIT;
      case PT_ACCESS_LEVELS.PT_ACCESS_LEVEL_EDIT:
      return (m_asOwner.GetString(4, "ptmsgs_portletsmsgs"));
      goto default;
      default:
      return "";
      break;
      }
    }
    
    /// <summary>
    /// This method uses the Plumtree Profile API to
    /// </summary>
    /// <param name="ptSession">a valid plumtree session</param>
    /// <param name="profileUserID">
    /// the profile user id that will be used to search
    /// information on.
    /// </param>
    /// <returns>IPTSearchResponse</returns>
    public virtual IPTQueryResult GetSearchResults(int profileUserID)
    {
      //get the profile pages object manager
      // MJD - local variable not used: IPTObjectManager profilePagesObjMgr = ptSession.GetProfilePages();
      //log.Info("Retrieved the Plumtree portal session successfully.");
      IPTProfileManager pm = (IPTProfileManager) m_ptSession.OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_PROFILE_MANAGER,
       false);
      IPTQueryResult qr = pm.GetManagedCommunities(profileUserID);
      return qr;
    }
    public virtual int GetProfileID()
    {
      IPTUserInfo userInfo = m_ptSession.GetUserInfo();
      return userInfo.GetProfileUserID();
    }
    public virtual int GetCurrentUser()
    {
      IPTSessionInfo sessionInfo = m_ptSession.GetSessionInfo();
      return sessionInfo.GetCurrentUserID();
    }
    
    /// <seealso cref="com.plumtree.xpportlets.expatriate.ext.introspective.IProfilePortlet#getTitle()"></seealso>
    public virtual String GetTitle()
    {
      return "";
    }
    public virtual String GetPortletDescription()
    {
      return m_ptPortlet.GetDescription();
    }
  }
}