using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.portlets.userprofile.eoddisplay.prefs
{
  /// <author>JHQ</author>
  /// <author>
  /// jennifersu
  /// Pop up page that lists all the sections in the current page.  The
  /// sections can be managed from this pop: they can be deleted and/or moved
  /// up/down.  The constructor for this class overrides the mvc class name.  This
  /// page is used for mutiple sections on a given page.
  /// </author>
  public class EODPortletPrefsMoveCtgDP : EditorDP
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_PORTLETS),
     "com.plumtree.portalpages.portlets.userprofile.eoddisplay.prefs.EODPortletPrefsMoveCtgDP");
    
    /// <summary>
    /// object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "EODDisplayPrefsMoveCtg";
    
    /// <summary>
    /// html element names 
    /// </summary>
    public const String HTMLINPUT_POPUPSTRING = "in_tx_PopUpString";
    public const String HTMLBUTTON_DONE = "in_bu_done";
    public const String HTMLBUTTON_CANCEL = "in_bu_cancel";
    public EODPortletPrefsMoveCtgDP()
    {
    }
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,
    /// linking to that page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(998, "ptmsgs_portaladminmsgs");
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // action Row begin
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLInput myInput;
      myTable = new HTMLTable();
      result.AddInnerHTMLElement(myTable);
      myTable.SetWidth("100%");
      myTable.SetBorder("0");
      myTable.SetCellPadding("5");
      myTable.SetCellSpacing("0");
      myRow = new HTMLTableRow();
      myTable.AddInnerHTMLElement(myRow);
      myRow.SetStyleClass(PTStyleClass.DIALOGUE_BG);
      /* title */
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetAlign("left");
      myCell.SetStyleClass(PTStyleClass.ALERT_DIALOG_TITLE);
      myCell.AddInnerHTMLString(m_asOwner.GetString(998, "ptmsgs_portaladminmsgs"));
      /* actions */
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetAlign("right");
      // ***Done Action*** begins here
      myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_DONE, "");
      myCell.AddInnerHTMLElement(myInput);
      myInput.SetValue(m_asOwner.GetString(2, "ptmsgs_portalcommonmsgs"));
      myInput.SetStyleClass(PTStyleClass.FORM_EDITOR_BTN_TEXT);
      myInput.SetOnClick("OnDone(); return false;");
      // spacer
      myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      // ***Cancel Action*** begins here
      myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_CANCEL, "");
      myCell.AddInnerHTMLElement(myInput);
      myInput.SetValue(m_asOwner.GetString(1000, "ptmsgs_portaladminmsgs"));
      myInput.SetStyleClass(PTStyleClass.FORM_EDITOR_BTN_TEXT);
      // mj: removed 'Javascript:' from function name
      myInput.SetOnClick("window.close();");
      /* add view's display */
      EditorView view = (EditorView) m_asOwner.GetView(EODPortletPrefsEditorAS.strStorageProfileSectionList);
      result.AddInnerHTMLElement(view.Display());
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      myScripts.AddInnerHTMLElement(DisplayOnDoneJavascript());
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(EODPortletPrefsEditorAS.strStorageProfileSectionList).DisplayJavascript());
      return myScripts;
    }
    
    /// <summary>
    /// This method returns the HTMLScript that encompasses the Javascript on the page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    /// <returns>HTMLScript</returns>
    public virtual HTMLScript DisplayOnDoneJavascript()
    {
      HTMLScript myScript = new HTMLScript("text/javaScript");
      XPStringBuilder sb;
      try
      {
        // JF- OnDone JavaScript function
        sb = new XPStringBuilder(200);
        sb.Append("function OnDone()\n");
        sb.Append("{\n");
        // JF- Then we repost the main form
        sb.Append("   window.opener.").Append(AFormDP.JAVASCRIPT_SUBMIT_FORM).Append("(").Append(EODPortletPrefsRepostControl.POSTTOSELF_ACTION_MOVECTG_DONE).Append(");\n");
        // JF- Finally we close the pop-up window
        sb.Append("   window.close();\n");
        sb.Append("}\n");
        myScript.AddInnerHTMLString(sb.ToString());
      }
      catch (HTMLException he)
      {
        log.Error(he, STR_MVC_CLASS_NAME + "::DisplayOnDoneJavascript The following error occured when trying to display the JavaScript: " + he.GetMessage());
        }
      return myScript;
    }
  }
}