using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.portlets.userprofile.eoddisplay.prefs
{
  /// <author>JHQ</author>
  /// <author>
  /// jennifersu
  /// Pop up view where user enters name and description of new category.
  /// </author>
  public class EODPortletPrefsNewCtgView : EditorView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_PORTLETS),
     "com.plumtree.portalpages.portlets.userprofile.eoddisplay.prefs.EODPortletPrefsNewCtgView");
    
    /// <summary>
    /// object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "EODDisplayPrefsNewCtg";
    
    /// <summary>
    /// html input names 
    /// </summary>
    public const String HTMLINPUT_CTGNAME = "in_tx_CtgName";
    public const String HTMLINPUT_CTGDESC = "in_ta_CtgDesc";
    
    /// <summary>
    /// html button names 
    /// </summary>
    public const String HTMLBUTTON_DONE = "in_su_finish";
    public const String HTMLBUTTON_CANCEL = "in_bu_cancel";
    
    /// <summary>
    /// js validation constants 
    /// </summary>
    public const String VALIDATION_FUNC_NAME = "ValidateNamesAndDesc";
    public const String ONSUBMIT_JAVASCRIPT_NAME = "OnDone";
    public const int CLIENT_VALIDATION_MAX_NAME = 255;
    public const int CLIENT_VALIDATION_MAX_DESCRIPTION = 255;
    public const int STANDARD_INPUT_BOX_WIDTH = 50;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new EODPortletPrefsNewCtgView();
    }
    
    /// <summary>
    /// Returns the HTML for the Section.
    /// </summary>
    /// <returns>HTMLElement</returns>
    public override HTMLElement Display()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      HTMLBody myBody;
      HTMLTable myTable;
      HTMLTableRow myRow;
      HTMLTableCell myCell;
      HTMLInput myInput;
      HTMLTextArea myTextArea;
      HTMLSpan mySpan;
      try
      {
        result.AddInnerHTMLElement(new HTMLComment("Begin: Display PopUpView"));
        myBody = new HTMLBody();
        result.AddInnerHTMLElement(myBody);
        myBody.SetStyleClass(PTStyleClass.DIALOGUE_BG);
        myTable = new HTMLTable();
        myBody.AddInnerHTMLElement(myTable);
        myTable.SetWidth("100%");
        myTable.SetBorder("0");
        myTable.SetCellPadding("0");
        myTable.SetCellSpacing("10");
        // title row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        // title
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetAlign("left");
        myCell.SetColSpan("2");
        myCell.SetNoWrap(true);
        mySpan = new HTMLSpan();
        myCell.AddInnerHTMLElement(mySpan);
        mySpan.SetStyleClass(PTStyleClass.ALERT_DIALOG_TITLE);
        mySpan.AddInnerHTMLString(m_asOwner.GetString(1001, "ptmsgs_portaladminmsgs"));
        // category name Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        // name text
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myCell.SetAlign("left");
        myCell.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);
        myCell.AddInnerHTMLString(m_asOwner.GetString(1002, "ptmsgs_portaladminmsgs"));
        // input box
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myCell.SetAlign("left");
        myCell.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);
        myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_CTGNAME, "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
        myInput.SetMaxLength(CLIENT_VALIDATION_MAX_NAME);
        myInput.SetSize(STANDARD_INPUT_BOX_WIDTH);
        myInput.SetOnKeyPress("return " + PlumtreeHelpers.STR_JS_FUNC_NAME_EXECUTE_VIA_ENTER + "(event);");
        // category description Row begin
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        // description text
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myCell.SetAlign("left");
        myCell.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);
        myCell.AddInnerHTMLString(m_asOwner.GetString(1908, "ptmsgs_portaladminmsgs"));
        // text box
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetNoWrap(true);
        myCell.SetAlign("left");
        myCell.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);
        myTextArea = new HTMLTextArea(XPConvert.ToString(STANDARD_INPUT_BOX_WIDTH),
         "3");
        myCell.AddInnerHTMLElement(myTextArea);
        myTextArea.SetName(HTMLINPUT_CTGDESC);
        myTextArea.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
        myTextArea.SetOnKeyPress("return " + PlumtreeHelpers.STR_JS_FUNC_NAME_EXECUTE_VIA_ENTER + "(event);");
        // buttons row
        myRow = new HTMLTableRow();
        myTable.AddInnerHTMLElement(myRow);
        myCell = new HTMLTableCell();
        myRow.AddInnerHTMLElement(myCell);
        myCell.SetAlign("left");
        myCell.SetColSpan("2");
        // ***Done Action*** begins here
        myInput = new HTMLInput(HTMLInputTypes.SUBMIT, HTMLBUTTON_DONE, "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetValue(m_asOwner.GetString(1003, "ptmsgs_portaladminmsgs"));
        myInput.SetStyleClass(PTStyleClass.FORM_EDITOR_BTN_TEXT);
        myInput.SetOnClick(ONSUBMIT_JAVASCRIPT_NAME + "();");
        // spacer
        myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
        // ***Cancel Action*** begins here
        myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_CANCEL,
         "");
        myCell.AddInnerHTMLElement(myInput);
        myInput.SetValue(m_asOwner.GetString(1004, "ptmsgs_portaladminmsgs"));
        myInput.SetStyleClass(PTStyleClass.FORM_EDITOR_BTN_TEXT);
        myInput.SetOnClick("window.close();");
        HTMLComment myComment = new HTMLComment("End: Display EODPortletPrefsNewCtgView");
        result.AddInnerHTMLElement(myComment);
      }
      catch (Exception e)
      {
        // error description
        log.Error(e, "EODPortletPrefsNewCtgView::Display An error occured when trying to display the HTML.");
        throw new XPException(m_asOwner.GetString(1005, "ptmsgs_portaladminmsgs"),
         e);
      }
      return result;
    }
    
    /// <summary>
    /// This method returns the HTMLScript that encompasses the Javascript on the page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    /// <returns>HTMLScript</returns>
    public override HTMLScript DisplayJavascript()
    {
      HTMLScript myScript = PlumtreeHelpers.GetExecuteViaEnterJScript(ONSUBMIT_JAVASCRIPT_NAME);
      XPStringBuilder sb;
      try
      {
        // OnDone JavaScript function
        sb = new XPStringBuilder(200);
        sb.Append("function " + ONSUBMIT_JAVASCRIPT_NAME + "()\n");
        sb.Append("{\n");
        // validate
        sb.Append("  if (" + VALIDATION_FUNC_NAME + "())\n");
        sb.Append("  {\n");
        // set the value of the new category name
        sb.Append("  window.opener.document." + AFormDP.HTMLFORM_NAME + "." + EODPortletPrefsMainDP.HTMLHIDDEN_NEWCTG + ".value = document." + AFormDP.HTMLFORM_NAME + "." + HTMLINPUT_CTGNAME + ".value;\n");
        // set the value of the new category description
        sb.Append("  window.opener.document." + AFormDP.HTMLFORM_NAME + "." + EODPortletPrefsMainDP.HTMLHIDDEN_NEWCTGDESC + ".value = document." + AFormDP.HTMLFORM_NAME + "." + HTMLINPUT_CTGDESC + ".value;\n");
        // JF- Then we repost the main form
        sb.Append("   window.opener.").Append(AFormDP.JAVASCRIPT_SUBMIT_FORM).Append("(").Append(EODPortletPrefsRepostControl.POSTTOSELF_ACTION_NEWCTG_DONE).Append(");\n");
        // JF- Finally we close the pop-up window
        sb.Append("   window.close();\n");
        sb.Append("}\n");
        sb.Append("}\n");
        myScript.AddInnerHTMLString(sb.ToString());
        /* add validating javascript */
        myScript.AddInnerHTMLString(DisplayValidatingJS());
      }
      catch (HTMLException he)
      {
        log.Error(he, "EODPortletPrefsNewCtgView::DisplayJavascript An error occured when trying to display the JavaScript.");
        }
      return myScript;
    }
    
    /// <summary>
    /// This method returns the HTMLScript that encompasses the
    /// validating Javascript on the page.
    /// </summary>
    /// <returns>HTMLScript</returns>
    public virtual String DisplayValidatingJS()
    {
      XPStringBuilder sb = new XPStringBuilder(200);
      //MES- See note above about PostToSelf.            
      sb.Append("function ").Append(VALIDATION_FUNC_NAME).Append("()\n");
      sb.Append("{\n");
      //MES- Validate the name.  It must not be blank.
      sb.Append("\t\tsName = document.").Append(AFormDP.HTMLFORM_NAME).Append(".").Append(HTMLINPUT_CTGNAME).Append(".value;\n");
      //MES- Trim the name
      sb.Append("\t\tsTrimmedName = sName.replace(/^\\s+/g, \'\').replace(/\\s+$/g, \'\');\n");
      sb.Append("\t\tif (sTrimmedName.length <= 0)\n");
      sb.Append("\t\t{\n");
      sb.Append("\t\t\talert(\"").Append(m_asOwner.GetString(69, "ptmsgs_portalinfrastructure")).Append("\");\n");
      sb.Append("\t\t\treturn false;\n");
      sb.Append("\t\t}\n");
      //MES- If we changed the name, store the modified name
      sb.Append("\t\tif (sTrimmedName != sName)\n");
      sb.Append("\t\t{\n");
      sb.Append("\t\t\tdocument.").Append(AFormDP.HTMLFORM_NAME).Append(".").Append(HTMLINPUT_CTGNAME).Append(".value = sTrimmedName;\n");
      sb.Append("\t\t}\n");
      //MES- Validate the description- it can be blank but cannot be over 255 characters.
      sb.Append("\t\tsDesc = document.").Append(AFormDP.HTMLFORM_NAME).Append(".").Append(HTMLINPUT_CTGDESC).Append(".value;\n");
      sb.Append("\t\tif (sDesc.length > ").Append(CLIENT_VALIDATION_MAX_DESCRIPTION).Append(")\n");
      sb.Append("\t\t{\n");
      sb.Append("\t\t\talert(\"").Append(XPResourceManager.FormatMessage(m_asOwner.GetString(70,
       "ptmsgs_portalinfrastructure"), CLIENT_VALIDATION_MAX_DESCRIPTION + 1)).Append("\");\n");
      sb.Append("\t\t\treturn false;\n");
      sb.Append("\t\t}\n");
      sb.Append("\t\treturn true;\n");
      sb.Append("}\n");
      return sb.ToString();
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}