using System;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portalpages.portlets.userprofile.infrastructure
{
  /// <author>
  /// chrisb To change this generated comment edit the template variable
  /// "typecomment": Window>Preferences>Java>Templates. To enable and
  /// disable the creation of type comments go to
  /// Window>Preferences>Java>Code Generation.
  /// </author>
  public sealed class ProfileCell : IProfileCell
  {
    private HTMLAnchor m_anchor;
    private HTMLImg m_Img;
    private String m_mouseover;
    private String m_subtext;
    private String m_text;
    private bool m_isHTML;
    private bool m_isImg;
    
    /// <summary>
    /// Constructs a ReferenceProfileCell and sets the text, mouseover,  URI and
    /// isHTML properties.
    /// </summary>
    /// <param name="text">The text to display in this ProfileCell.</param>
    /// <param name="subtext">
    /// The text that will be displayed below the main text of
    /// the cell
    /// </param>
    /// <param name="mouseover">
    /// The description of this ProfileCell to display as a
    /// mouseover.
    /// </param>
    /// <param name="Anchor">action for the profile cell if the URI is set.</param>
    /// <param name="isHTML">Whether or not this ProfileCell contains markup.</param>
    public ProfileCell(String text, String subtext, String mouseover, HTMLAnchor Anchor,
     bool isHTML)
    {
      m_text = text;
      m_mouseover = mouseover;
      m_isHTML = isHTML;
      m_subtext = subtext;
      m_anchor = Anchor;
      m_isImg = false;
      m_Img = null;
    }
    
    /// <summary>
    /// Constructs a Profile Cell and sets it as an image.  This needs to be
    /// handled differently in order for the upper most HTMLElementCollection
    /// to be able to retrieve the image server URL.
    /// </summary>
    /// <param name="Image"></param>
    public ProfileCell(HTMLImg Image)
    {
      m_text = "";
      m_mouseover = "";
      m_isHTML = false;
      m_subtext = "";
      m_anchor = null;
      m_isImg = true;
      m_Img = Image;
    }
    
    /// <seealso cref="com.plumtree.xpportlets.expatriate.ext.introspective.ProfileItem#isHTML()"></seealso>
    public bool isHTML()
    {
      return m_isHTML;
    }
    
    /// <seealso cref="com.plumtree.portlets.introspective2.IProfileCell#isImg()"></seealso>
    public bool isImg()
    {
      return m_isImg;
    }
    
    /// <seealso cref="com.plumtree.portlets.introspective2.IProfileCell#GetOnClickAction()"></seealso>
    public HTMLAnchor GetHTMLAnchor()
    {
      return m_anchor;
    }
    
    /// <seealso cref="com.plumtree.portlets.introspective2.IProfileCell#GetImage()"></seealso>
    public HTMLImg GetImage()
    {
      return m_Img;
    }
    
    /// <seealso cref="com.plumtree.xpportlets.expatriate.ext.introspective.ProfileItem#getMouseOver()"></seealso>
    public String GetMouseOver()
    {
      return m_mouseover;
    }
    
    /// <returns></returns>
    public String GetSubText()
    {
      return m_subtext;
    }
    
    /// <seealso cref="com.plumtree.xpportlets.expatriate.ext.introspective.ProfileItem#getText()"></seealso>
    public String GetText()
    {
      return m_text;
    }
  }
}