using System;
using com.plumtree.openfoundation.util;
namespace com.plumtree.portalpages.portlets.userprofile.infrastructure
{
  /// <author>
  /// chrisb, dand      This    class should be extended by your
  /// introspective portlet if there is specific processing that should
  /// be done.
  /// </author>
  public sealed class ProfileRow : IProfileRow
  {
    private XPArrayList m_profileCells;
    
    /// <summary>
    /// Creates a new ProfileRow object.
    /// </summary>
    /// <param name="profileCells"></param>
    public ProfileRow(XPArrayList profileCells)
    {
      m_profileCells = profileCells;
    }
    
    /// <returns></returns>
    public int GetNumProfileCells()
    {
      return (m_profileCells.GetSize());
    }
    
    /// <returns></returns>
    public IXPEnumerator GetProfileCells()
    {
      return (m_profileCells.GetEnumerator());
    }
  }
}