using System;
using com.plumtree.openfoundation.internationalization;
namespace com.plumtree.portalpages.rest
{
  /// <summary>
  /// Abstract base class for the mechanics of REST errors.
  /// </summary>
  public abstract class ARESTErrors : IRESTError
  {
    protected int m_nCode;
    protected String m_strMessage;
    protected ARESTErrors(int _nCode, String _strMessage)
    {
      m_nCode = _nCode;
      m_strMessage = _strMessage;
      RESTErrors.AddRestError(this);
    }
    public virtual IRESTError ParameterizeRESTError(String param1)
    {
      m_strMessage = XPResourceManager.FormatMessage(m_strMessage, param1);
      return this;
    }
    public virtual IRESTError ParameterizeRESTError(String param1, String param2)
    {
      m_strMessage = XPResourceManager.FormatMessage(m_strMessage, param1,
       param2);
      return this;
    }
    public virtual IRESTError ParameterizedRESTError(String param1, String param2,
     String param3)
    {
      m_strMessage = XPResourceManager.FormatMessage(m_strMessage, param1,
       param2, param3);
      return this;
    }
    
    /// <seealso cref="com.plumtree.portalpages.rest.IRESTError.GetCode()"></seealso>
    public virtual int GetCode()
    {
      return m_nCode;
    }
    
    /// <seealso cref="com.plumtree.portalpages.rest.IRESTError.GetMessage()"></seealso>
    public virtual String GetMessage()
    {
      return m_strMessage;
    }
    protected virtual void SetMessage(String message)
    {
      m_strMessage = message;
    }
  }
}