using System;
namespace com.plumtree.portalpages.rest
{
  /// <summary>
  /// Abstract class for all REST models
  /// </summary>
  /// <author>rozhang</author>
  public class ARESTModel
  {
    
    /// <summary>
    /// Contains the current error object
    /// Usually set by a control and read by a displaypage
    /// </summary>
    protected IRESTError m_error = null;
    
    /// <summary>
    /// Set an error object for the current REST request
    /// Usually called by a REST control
    /// </summary>
    /// <param name="_error"></param>
    public virtual void SetError(IRESTError _error)
    {
      m_error = _error;
    }
    
    /// <summary>
    /// Gets an error object for the current REST request if one exists
    /// Usually called by a REST display page
    /// </summary>
    /// <returns></returns>
    public virtual IRESTError GetError()
    {
      return m_error;
    }
  }
}