using System;
namespace com.plumtree.portalpages.rest
{
  /// <summary>
  /// This class enumerates the common errors generated by the portal Rest APIs.
  /// 1000 - 1999 is reserved for common errors.
  /// </summary>
  public class CommonRestErrors : ARESTErrors,IRESTError
  {
    // TODO: how do we document this?  Do people just look it up in code, or do we make a page
    // for it manually?  Javadocs?  Plus we need to doc the whole REST API.
    public static readonly IRESTError GENERAL = new CommonRestErrors(1000,
     "Unable to process request.");
    public static readonly IRESTError NOT_LOGGED_IN = new CommonRestErrors(1010,
     "The current user does " + "not have access to this API.");
    public static readonly IRESTError NOT_POST = new CommonRestErrors(1020,
     "This API only supports POSTs.");
    public static readonly IRESTError NO_POST_CONTENT = new CommonRestErrors(1030,
     "No POST content found.");
    public static readonly IRESTError NO_JSON_POST_CONTENT = new CommonRestErrors(1031,
     "JSON data not found in POST content.");
    public static readonly ARESTErrors PARAM_SERVER_ERROR = new CommonRestErrors(1050,
     "Server Error encountered: {0}");
    
    /// <summary>
    /// Use these errors with GetParameterizedRESTError method *
    /// </summary>
    public static readonly ARESTErrors PARAM_MISSING_REQUESTARGUMENT = new CommonRestErrors(1200,
     "Missing required Request Argument: {0}");
    private CommonRestErrors(int _nCode, String _strMessage) : base(_nCode,
     _strMessage)
    {
    }
  }
}