using System;
namespace com.plumtree.portalpages.rest
{
  /// <summary>
  /// These constants describe the .
  /// This class contains constants for the Rest API JSON/XML error
  /// output format.  These can be used in both the JSON format and
  /// the XML format.
  /// Each constant is marked with input and/or output depending on
  /// whether it can be used as an input to the API, an output, or both.
  /// </summary>
  public class RESTErrorConstants
  {
    
    /// <summary>
    /// The name of the error object in the format (i.e. the object
    /// itself, not a member of the object).
    /// output
    /// </summary>
    public const String ERROR_FORMAT_NAME = "error";
    
    /// <summary>
    /// The key for the error text member.
    /// output
    /// </summary>
    public const String ERROR_TEXT = "text";
    
    /// <summary>
    /// The key for the error code member.
    /// output
    /// </summary>
    public const String ERROR_CODE = "code";
  }
}