using System;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.rest.ldap
{
  /// <author>rozhang</author>
  public class UserIdLookupAS : AActivitySpace
  {
    public const String STR_MVC_CLASS_NAME = "ldaplookup";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(java.lang.String,java.lang.String,boolean)"></seealso>
    public override bool CheckBasicAccess(String strPage, String strControl,
     bool sameSpace)
    {
      IPTSession ptSession = (IPTSession) this.GetUserSession();
      // don't give guest users access to this AS
      return !ptSession.GetSessionInfo().CheckCurrentUserIsGuest();
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.AActivitySpace#Init()"></seealso>
    public override void Init()
    {
      base.Init();
      RegisterModel(UserIdLookupModel.STR_MVC_CLASS_NAME);
      IModel model = GetModel(UserIdLookupModel.STR_MVC_CLASS_NAME);
      RegisterPage(new UserIdLookupDP());
      RegisterControl(UserIdLookupControl.STR_MVC_CLASS_NAME, model);
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AActivitySpace#Create()"></seealso>
    public override Object Create()
    {
      return new UserIdLookupAS();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AActivitySpace#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}