using System;
using com.plumtree.portalpages.rest;
namespace com.plumtree.portalpages.rest.user
{
  /// <summary>
  /// This interface describes the setter and action methods for the user REST API model.
  /// </summary>
  public interface IUserRestModel : IUserRestModelRO
  {
    
    /// <summary>
    /// Join the specified community.
    /// </summary>
    /// <param name="_nCommunityID">the community to join.</param>
    void JoinCommunity(int _nCommunityID);
    
    /// <summary>
    /// Leave the specified community.
    /// </summary>
    /// <param name="_nCommunityID">the community to leave.</param>
    void LeaveCommunity(int _nCommunityID);
    
    /// <summary>
    /// Sets an error for later display.
    /// </summary>
    /// <param name="_error">the current error.</param>
    void SetError(IRESTError _error);
  }
}