using System;
using com.plumtree.portalpages.rest;
namespace com.plumtree.portalpages.rest.user
{
  /// <summary>
  /// This interface describes the read only methods for the user REST API model.
  /// </summary>
  public interface IUserRestModelRO
  {
    
    /// <returns>the ID of the community that was joined. -1 if no community was joined.</returns>
    int GetJoinedCommunityID();
    
    /// <returns>the ID of the community that was left. -1 if no community was left.</returns>
    int GetLeftCommunityID();
    
    /// <returns>the error.  Null if there is no error.</returns>
    IRESTError GetError();
  }
}