using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.rest.user
{
  /// <summary>
  /// This space contains the MVC objects that handle processing the User REST API requests.
  /// </summary>
  public class UserRESTAS : AActivitySpace
  {
    public const String STR_MVC_CLASS_NAME = "UserREST";
    public override bool CheckBasicAccess(String strPage, String strControl,
     bool bSameSpace)
    {
      // No need to check security here.  The control will handle that.
      // We only need to make sure we're going to the control correctly,
      // or that this is a redirect from within the same space (i.e. from
      // the control).
      return (bSameSpace || (XPStringUtility.CompareIgnoreCase(UserRESTControl.STR_MVC_CLASS_NAME,
       strControl) == 0));
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.AActivitySpace#Init()"></seealso>
    public override void Init()
    {
      base.Init();
      RegisterModel(UserRESTModel.STR_MVC_CLASS_NAME);
      IModel model = GetModel(UserRESTModel.STR_MVC_CLASS_NAME);
      RegisterPage(new UserRESTDP());
      RegisterControl(UserRESTControl.STR_MVC_CLASS_NAME, model);
    }
    public override Object Create()
    {
      return new UserRESTAS();
    }
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}