using System;
using com.plumtree.portalpages.rest;
using com.plumtree.taskapi.portalui;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.rest.user
{
  /// <summary>
  /// This model manages the user REST API logic.
  /// </summary>
  public class UserRESTModel : ARESTModel,IModel,IUserRestModel
  {
    public const String STR_MVC_CLASS_NAME = "UserREST";
    protected AActivitySpace m_asOwner;
    protected int m_nJoinedCommunityID = -1;
    protected int m_nLeftCommunityID = -1;
    public virtual void Init(AActivitySpace parent)
    {
      m_asOwner = parent;
    }
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    public virtual Object Create()
    {
      return new UserRESTModel();
    }
    public virtual void CleanupAllData()
    {
      m_error = null;
    }
    public virtual void CleanupTempData()
    {
      m_error = null;
    }
    public virtual void JoinCommunity(int _nCommunityID)
    {
      ITaskAPIUICommunity task = TaskAPIUICommunityService.GetInstance();
      // NOTE: If this method returns false, it means we already joined
      // this community.
      task.JoinCommunity(m_asOwner, _nCommunityID);
      m_nJoinedCommunityID = _nCommunityID;
    }
    public virtual void LeaveCommunity(int _nCommunityID)
    {
      ITaskAPIUICommunity task = TaskAPIUICommunityService.GetInstance();
      // NOTE: If this method returns false, it means we were not part of
      // this community.
      task.LeaveCommunity(m_asOwner, _nCommunityID);
      m_nLeftCommunityID = _nCommunityID;
    }
    public virtual int GetJoinedCommunityID()
    {
      return m_nJoinedCommunityID;
    }
    public virtual int GetLeftCommunityID()
    {
      return m_nLeftCommunityID;
    }
  }
}