using System;
using com.plumtree.portalpages.rest;
namespace com.plumtree.portalpages.rest.user
{
  /// <summary>
  /// This class enumerates the common errors generated by the User Rest APIs.
  /// 2500 - 2999 is reserved for User errors.
  /// </summary>
  public class UserRestErrors : ARESTErrors,IRESTError
  {
    public static readonly IRESTError NO_JSON_USER_OBJECT = new UserRestErrors(2500,
     "User node not " + "in JSON document.");
    public static readonly IRESTError NO_JOIN_COMMUNITY_ID = new UserRestErrors(2510,
     "The API data did not include a valid community ID to join.");
    public static readonly IRESTError NO_LEAVE_COMMUNITY_ID = new UserRestErrors(2520,
     "The API data did not include a valid community ID to join.");
    public static readonly IRESTError INVALID_USER_ID = new UserRestErrors(2530,
     "The User REST API found an invalid user ID.  The API currently only supports [" + UserRESTControl.CURRENT_USER + "] as a value.");
    public static readonly IRESTError JOIN_COMMUNITY_ERROR = new UserRestErrors(2540,
     "Unable to join the specified community.  This community may no longer exist or be visible to this user.");
    public static readonly IRESTError LEAVE_COMMUNITY_ERROR = new UserRestErrors(2550,
     "Unable to leave the specified community.  This community may no longer exist or be visible to this user.");
    private UserRestErrors(int _nCode, String _strMessage) : base(_nCode,
     _strMessage)
    {
    }
  }
}