using System;
using com.plumtree.openfoundation.util;
namespace com.plumtree.portalpages.rest.utils
{
  /// <summary>
  /// This JSON parser handles simple objects only.
  /// It is very limited, and does not handle arrays, or non-string
  /// object types.  It also only handles escaped quotes and slashes.
  /// </summary>
  public interface IJSONParser
  {
    
    /// <summary>
    /// Parses the supplied JSON object.
    /// </summary>
    /// <param name="_strJSON">the JSON string to be parsed.</param>
    /// <throws>XPFormatException</throws>
    void ParseJSONObject(String _strJSON);
    
    /// <returns>the top-level JSON object name.</returns>
    String GetObjectName();
    
    /// <param name="_strName">The key for the JSON member to be returned.</param>
    /// <returns>the requested JSON member value.</returns>
    String GetMember(String _strName);
  }
}