/*
 * Created on Jan 28, 2005
 */
 
using System;
using com.plumtree.openfoundation.web;
namespace com.plumtree.taskapi.portalui
{
  /// <summary>
  /// Class description
  /// </summary>
  /// <author>robertz</author>
  public class TaskAPIUIHTTP
  {
    public const String ENCODING_UTF8 = "UTF-8";
    
    /// <summary>
    /// Returns a URL-encoded version of the input 
    /// string, or empty string if input is null. 
    /// </summary>
    /// <param name="strValue">a string of characters to encode for use i.</param>
    /// <param name="strEncoding">
    /// the encoding used to interpret the encoded bytes.  
    /// Use <c>ENCODING_UTF8</c>
    /// </param>
    /// <returns>an encoded version of the input, or empty string if null.</returns>
    public static String URLEncode(String strValue, String strEncoding)
    {
      return XPHttpUtility.UrlEncode(strValue, strEncoding);
    }
    
    /// <summary>
    /// Returns a decoded version of the input string, 
    /// assuming it was a valid URL encoding.
    /// </summary>
    /// <param name="strValue">the string to decode</param>
    /// <param name="strEncoding">the encoding used to interpret the encoded bytes</param>
    /// <returns>a decoded version of the input.</returns>
    /// <throws>XPNullPointerException if input null</throws>
    /// <throws>XPUnsupportedEncodingException if invalid ampersand escape found</throws>
    public static String URLDecode(String strValue, String strEncoding)
    {
      return XPHttpUtility.UrlDecode(strValue, strEncoding);
    }
  }
}