using System;
namespace com.plumtree.taskapi.portalui.util
{
  /// <summary>
  /// This class contains constants for the data keys
  /// for the submit simple data source HashTableDataObjects
  /// returned by the ITaskAPIUIDirectory methods for submit
  /// data sources.
  /// NOTE: Do not change these constants, as they are used
  /// in an external API in the SubmitDataSourceTag.
  /// </summary>
  public class SubmitDataSourceConstants
  {
    
    /// <summary>
    /// The name of the Data Source.
    /// </summary>
    public const String NAME = "name";
    
    /// <summary>
    /// The object ID of the data source.
    /// </summary>
    public const String ID = "id";
    
    /// <summary>
    /// The type of the data source, either "file" or "web".
    /// </summary>
    public const String TYPE = "type";
    
    /// <summary>
    /// The file value of the data source type.
    /// </summary>
    public const String TYPE_FILE = "file";
    
    /// <summary>
    /// The web value of the data source type.
    /// </summary>
    public const String TYPE_WEB = "web";
    
    /// <summary>
    /// The remote upload URL of the data source, if it has one.
    /// </summary>
    public const String URL = "url";
    
    /// <summary>
    /// The object ID of the web service associated with this data source.
    /// </summary>
    public const String WEB_SERVICE_ID = "wsid";
  }
}