using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.portaluiinfrastructure.condition;
namespace com.plumtree.portalpages.browsing.mock.condition
{
  public class MockXPLimitedRequest : XPLimitedRequest
  {
    private XPHashtable headers;
    public MockXPLimitedRequest(IXPRequest xpRealRequest) : base(xpRealRequest)
    {
      headers = new XPHashtable();
    }
    
    /// <summary>
    /// Returns the value of the given HTTP header 
    /// </summary>
    /// <param name="name">Name of the HTTP header. For e.g. HTTP_USER_AGENT</param>
    /// <returns>			The given HTTP header as a String, null if not found.</returns>
    /// <seealso cref="com.plumtree.openfoundation.web.IXPRequest#GetHeader(java.lang.String)"></seealso>
    public override String GetHeader(String name)
    {
      return (String) headers.GetElement(name);
    }
    public virtual void SetHeader(String name, String value)
    {
      headers.PutElement(name, value);
    }
  }
}