using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.browsing.myportal;
using com.plumtree.server;
using AActivitySpace=com.plumtree.uiinfrastructure.activityspace.AActivitySpace;
using ASURL=com.plumtree.uiinfrastructure.activityspace.ASURL;
namespace com.plumtree.portalpages.browsing.mock.myportal
{
  /// <author>btse</author>
  public class MockMyPortalModel : MyPortalModel,IMyPortalModelRO,IMyPortalModel
  {
    // TODO CR DLH: package should be com.plumtree.portalpages.mock.browsing.myportal
    protected String KEY_PORTLETNAME = "name";
    protected String KEY_PORTLETID = "objid";
    protected String KEY_PORTLETREGION = "region";
    protected String KEY_PAGE = "pageId";
    public int m_pageId = 0;
    public int m_commId = 0;
    // start object ids at 200
    public int m_idcounter = 200;
    public int m_nRegions = 1;
    public String m_strRawHeaders = "";
    private XPArrayList m_RecentlyAddedPortlets = new XPArrayList();
    private int m_nRecentlyRemovedPortlet = 0;
    public XPArrayList m_regions = new XPArrayList();
    public MockMyPortalModel(int regions)
    {
      m_nRegions = regions;
      // initialize regions list with list of portlets
      for (int i = 0;i < m_nRegions;i++)
      {
        m_regions.Add(new XPArrayList());
      }
    }
    public override int GetPortletCount()
    {
      int count = 0;
      for (int i = 0;i < m_regions.GetSize();i++)
      {
        count+=((XPArrayList) m_regions.GetElement(i)).GetSize();
      }
      return count;
    }
    
    /// <summary>
    /// Helper function to reset the portlet columns.
    /// </summary>
    /// <returns>XPHashtable</returns>
    public virtual void ResetPortletColumns()
    {
      m_regions.Clear();
      // initialize regions list with list of portlets
      for (int i = 0;i < m_nRegions;i++)
      {
        m_regions.Add(new XPArrayList());
      }
    }
    
    /// <summary>
    /// Internal hepler function to lookup the portlet object from main index
    /// Portlets are indexed by their order in a region and the region order so
    /// index = 0 starts with the first portlet in the first region. 
    /// </summary>
    /// <param name="index"></param>
    /// <returns>XPHashtable</returns>
    protected virtual XPHashtable GetPortletFromIndex(int index)
    {
      int totalCount = 0;
      for (int i = 0;i < m_regions.GetSize();i++)
      {
        int curCount = ((XPArrayList) m_regions.GetElement(i)).GetSize();
        // comparing size with index, so add 1 to index
        if ((totalCount + curCount) >= index + 1)
        {
          // we know the portlet is in the current region, calculate the index within the region
          int regionIndex = index - totalCount;
          XPHashtable portlet = (XPHashtable) ((XPArrayList) m_regions.GetElement(i)).GetElement(regionIndex);
          return portlet;
        }
        totalCount+=curCount;
      }
      throw new XPIllegalArgumentException("Invalid portlet index: " + index);
      }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetFirstPortletIndexInColumn(int)"></seealso>
    public override int GetFirstPortletIndexInColumn(int nPortletColumn)
    {
      XPArrayList arrPortletColumn = (XPArrayList) m_regions.GetElement(nPortletColumn);
      int nPortletID = -1;
      if (arrPortletColumn.GetSize() > 0)
      {
        XPHashtable portlet = (XPHashtable) arrPortletColumn.GetElement(0);
        int id = (int) portlet.GetElement(KEY_PORTLETID);
        nPortletID = id;
      }
      return nPortletID;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetLastPortletIndexInColumn(int)"></seealso>
    public override int GetLastPortletIndexInColumn(int nPortletColumn)
    {
      XPArrayList arrPortletColumn = (XPArrayList) m_regions.GetElement(nPortletColumn);
      int nPortletID = -1;
      if (arrPortletColumn.GetSize() > 0)
      {
        XPHashtable portlet = (XPHashtable) arrPortletColumn.GetElement(arrPortletColumn.GetSize() - 1);
        int id = (int) portlet.GetElement(KEY_PORTLETID);
        nPortletID = id;
      }
      return nPortletID;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletColumnFromIndex(int)"></seealso>
    public override int GetPortletColumnFromIndex(int nPortletIndex)
    {
      XPHashtable portlet = GetPortletFromIndex(nPortletIndex);
      int region = (int) portlet.GetElement(KEY_PORTLETREGION);
      return region;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletIDFromIndex(int)"></seealso>
    public override int GetPortletIDFromIndex(int nPortletIndex)
    {
      XPHashtable portlet = GetPortletFromIndex(nPortletIndex);
      int id = (int) portlet.GetElement(KEY_PORTLETID);
      return id;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletNameFromIndex(int)"></seealso>
    public override String GetPortletNameFromIndex(int nPortletIndex)
    {
      XPHashtable portlet = GetPortletFromIndex(nPortletIndex);
      String name = (String) portlet.GetElement(KEY_PORTLETNAME);
      return name;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#IsGuestSession(AActivitySpace)"></seealso>
    public static bool IsGuestSession(AActivitySpace owner)
    {
      // Assume non-guest user.
      return false;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModel#SetProfileID(int)
     */
     
    public override bool SetProfileID(int profileID)
    {
      return true;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.IMyPortalModel#SetPage(int)"></seealso>
    public override bool SetPage(int nPageID)
    {
      m_pageId = nPageID;
      return true;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetRecentlyAddedPortlets()"></seealso>
    public override XPArrayList GetRecentlyAddedPortlets()
    {
      return m_RecentlyAddedPortlets;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.IMyPortalModel#ResetRecentlyAddedPortlets()"></seealso>
    public override void ResetRecentlyAddedPortlets()
    {
      m_RecentlyAddedPortlets = new XPArrayList();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetRecentlyRemovedPortlet()"></seealso>
    public override int GetRecentlyRemovedPortlet()
    {
      return m_nRecentlyRemovedPortlet;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#ResetRecentlyRemovedPortlet()"></seealso>
    public override void ResetRecentlyRemovedPortlet()
    {
      m_nRecentlyRemovedPortlet = 0;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.IMyPortalModel#SetRawHeaders(String)"></seealso>
    public override void SetRawHeaders(String strRawHeaders)
    {
      m_strRawHeaders = strRawHeaders;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModel#AddSinglePortlet(int, int)
     */
     
    public override void AddSinglePortlet(int nPageID, int nPortletID)
    {
      // Check to see if gadget is already in the page
      int nPortletId;
      bool bIsInPage = false;
      for (int i = 0;i < ((XPArrayList) m_regions.GetElement(0)).GetSize();
      i++)
      {
        XPHashtable portlet = (XPHashtable) ((XPArrayList) m_regions.GetElement(0)).GetElement(i);
        nPortletId = (int) portlet.GetElement(KEY_PORTLETID);
        if (nPortletId == nPortletID)
        {
          bIsInPage = true;
          break;
        }
      }
      if (!bIsInPage)
      {
        // add the gadget to the first column in the page
        // regions are 0 based in list
        // TODO: Mock up PTPage/PTGadget so that we can differentiate
        // portlet alignment and add to the appropriate column?
        XPHashtable table = new XPHashtable();
        table.PutElement(KEY_PORTLETID, nPortletID);
        table.PutElement(KEY_PORTLETNAME, "portlet" + nPortletID);
        table.PutElement(KEY_PAGE, nPageID);
        table.PutElement(KEY_PORTLETREGION, 0);
        ((XPArrayList) m_regions.GetElement(0)).Add(table);
        m_RecentlyAddedPortlets.Add(nPortletID);
      }
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModel#RemoveSinglePortlet(int, int)
     */
     
    public override void RemoveSinglePortlet(int nPageID, int nPortletID)
    {
      // Check to see if portlet is already in the page
      int portletId;
      int index = -1;
      bool bIsInPage = false;
      for (int i = 0;i < ((XPArrayList) m_regions.GetElement(0)).GetSize();
      i++)
      {
        XPHashtable portlet = (XPHashtable) ((XPArrayList) m_regions.GetElement(0)).GetElement(i);
        portletId = (int) portlet.GetElement(KEY_PORTLETID);
        if (portletId == nPortletID)
        {
          bIsInPage = true;
          index = i;
          break;
        }
      }
      if (bIsInPage)
      {
        // TODO: Mock up PTPage to remove the portlet appropriately
        // rather than just from the first column in this array list?
        ((XPArrayList) m_regions.GetElement(0)).RemoveAt(index);
        m_nRecentlyRemovedPortlet = nPortletID;
      }
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModel#CollapsePortlet(int, int, int)
     */
     
    public override void CollapsePortlet(int communityID, int pageID, int portletToCollapse)
    {
    }
    // TODO Auto-generated method stub
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModel#ExpandPortlet(int, int, int)
     */
     
    public override void ExpandPortlet(int communityID, int pageID, int portletToExpand)
    {
    }
    // TODO Auto-generated method stub
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModel#ReassignPortlets(int[], int, int)
     */
     
    public override void ReassignPortlets(int[] arrPortletIDs, int column,
     int pageID)
    {
      // Simulate PTPage::AssignPortlets. This will remove the current portlets 
      // in the column first before adding the portlets in arrPortletIDs.
      // Remove the current portlets in the column first.
      while (0 < ((XPArrayList) m_regions.GetElement(column)).GetSize())
      {
        ((XPArrayList) m_regions.GetElement(column)).RemoveAt(0);
      }
      // add the list of portlets to the specified column in the page
      // regions are 0 based in list
      for (int j = 0;j < arrPortletIDs.Length;j++)
      {
        XPHashtable table = new XPHashtable();
        table.PutElement(KEY_PORTLETID, arrPortletIDs[j]);
        table.PutElement(KEY_PORTLETNAME, "portlet" + arrPortletIDs[j]);
        table.PutElement(KEY_PAGE, pageID);
        table.PutElement(KEY_PORTLETREGION, column);
        ((XPArrayList) m_regions.GetElement(column)).Add(table);
      }
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetCollapsedOrErrorContent(int)
     */
     
    public override Object[][] GetCollapsedOrErrorContent(int portletIndex)
    {
      // TODO Auto-generated method stub
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetCommunityID()
     */
     
    public override int GetCommunityID()
    {
      // TODO Auto-generated method stub
      return 0;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetCommunityName()
     */
     
    public override String GetCommunityName()
    {
      // TODO Auto-generated method stub
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetCommunityPages()
     */
     
    public override IPTQueryResult GetCommunityPages()
    {
      // TODO Auto-generated method stub
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetDisplayPortletHeaderDueToError(int)
     */
     
    public override bool GetDisplayPortletHeaderDueToError(int portletIndex)
    {
      // TODO Auto-generated method stub
      return false;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetHelper()
     */
     
    public override IMyPortalModelHelper GetHelper()
    {
      // TODO Auto-generated method stub
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetIDStringForPortlet(int)
     */
     
    public override String GetIDStringForPortlet(int portletIndex)
    {
      // TODO Auto-generated method stub
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetIsCommunityPage()
     */
     
    public override bool GetIsCommunityPage()
    {
      // TODO Auto-generated method stub
      return false;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPageASURL()
     */
     
    public override ASURL GetPageASURL()
    {
      // TODO Auto-generated method stub
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPageID()
     */
     
    public override int GetPageID()
    {
      // TODO Auto-generated method stub
      return 0;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPageName()
     */
     
    public override String GetPageName()
    {
      // TODO Auto-generated method stub
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPageType()
     */
     
    public override int GetPageType()
    {
      // TODO Auto-generated method stub
      return 0;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletAdminPrefsURL(int)
     */
     
    public override String GetPortletAdminPrefsURL(int portletIndex)
    {
      // TODO Auto-generated method stub
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletCollapseExpandURL(int, java.lang.String)
     */
     
    public override String GetPortletCollapseExpandURL(int portletIndex, String strControl)
    {
      // TODO Auto-generated method stub
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletCollapsed(int)
     */
     
    public override bool GetPortletCollapsed(int portletIndex)
    {
      // TODO Auto-generated method stub
      return false;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletCommunityPrefsURL(int)
     */
     
    public override String GetPortletCommunityPrefsURL(int portletIndex)
    {
      // TODO Auto-generated method stub
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletDisabledMessage(int)
     */
     
    public override String GetPortletDisabledMessage(int portletIndex)
    {
      // TODO Auto-generated method stub
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletEnabled(int)
     */
     
    public override bool GetPortletEnabled(int portletIndex)
    {
      // TODO Auto-generated method stub
      return false;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletHTMLTextFromIndex(int)
     */
     
    public override Object[][] GetPortletHTMLTextFromIndex(int gadgetIndex)
    {
      // TODO Auto-generated method stub
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletHasAdminPrefsURL(int)
     */
     
    public override bool GetPortletHasAdminPrefsURL(int portletIndex)
    {
      // TODO Auto-generated method stub
      return false;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletHasCollapseExpandURL(int)
     */
     
    public override bool GetPortletHasCollapseExpandURL(int portletIndex)
    {
      // TODO Auto-generated method stub
      return false;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletHasCommunityPrefsURL(int)
     */
     
    public override bool GetPortletHasCommunityPrefsURL(int portletIndex)
    {
      // TODO Auto-generated method stub
      return false;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletHasHelpURL(int)
     */
     
    public override bool GetPortletHasHelpURL(int portletIndex)
    {
      // TODO Auto-generated method stub
      return false;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletHasRefreshButton(int)
     */
     
    public override bool GetPortletHasRefreshButton(int portletIndex)
    {
      // TODO Auto-generated method stub
      return false;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletHasTitleBar(int)
     */
     
    public override bool GetPortletHasTitleBar(int portletIndex)
    {
      // TODO Auto-generated method stub
      return false;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletHasUserPrefsURL(int)
     */
     
    public override bool GetPortletHasUserPrefsURL(int portletIndex)
    {
      // TODO Auto-generated method stub
      return false;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletHelpURL(int)
     */
     
    public override String GetPortletHelpURL(int portletIndex)
    {
      // TODO Auto-generated method stub
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletIsMandatory(int)
     */
     
    public override bool GetPortletIsMandatory(int portletIndex)
    {
      // TODO Auto-generated method stub
      return false;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletLayoutId()
     */
     
    public override int GetPortletLayoutId()
    {
      // TODO Auto-generated method stub
      return 0;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletPrefButtonBoolean()
     */
     
    public override String GetPortletPrefButtonBoolean()
    {
      // TODO Auto-generated method stub
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletRemoveURL(int)
     */
     
    public override String GetPortletRemoveURL(int portletIndex)
    {
      // TODO Auto-generated method stub
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletSupports508(int)
     */
     
    public override bool GetPortletSupports508(int portletIndex)
    {
      // TODO Auto-generated method stub
      return false;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletSupportsPersonalization(int)
     */
     
    public override int GetPortletSupportsPersonalization(int portletIndex)
    {
      // TODO Auto-generated method stub
      return 0;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletUUID(int)
     */
     
    public override String GetPortletUUID(int portletIndex)
    {
      // TODO Auto-generated method stub
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetPortletUserPrefsURL(int)
     */
     
    public override String GetPortletUserPrefsURL(int portletIndex)
    {
      // TODO Auto-generated method stub
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#GetSession()
     */
     
    public override IPTSession GetSession()
    {
      // TODO Auto-generated method stub
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#QuerySinglePortletContent(int)
     */
     
    public virtual void QuerySinglePortletContent(int portletId)
    {
    }
    // TODO Auto-generated method stub
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#SetDisplayPortletHeaderDueToError(int, boolean)
     */
     
    public override void SetDisplayPortletHeaderDueToError(int portletIndex,
     bool displayHeader)
    {
    }
    // TODO Auto-generated method stub
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModelRO#UsesPortletLayout()
     */
     
    public override bool UsesPortletLayout()
    {
      // TODO Auto-generated method stub
      return false;
    }
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
     */
     
    public override String GetName()
    {
      // TODO Auto-generated method stub
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModel#SetCommunity(int, int)
     */
     
    public override bool SetCommunity(int communityID, int pageID)
    {
      // TODO Auto-generated method stub
      return false;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portalpages.browsing.myportal.IMyPortalModel#SetIsPreviewPage(boolean)
     */
     
    public override void SetIsPreviewPage(bool isPreviewPage)
    {
    }
  }
}
// TODO Auto-generated method stub
