using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.portlets.intrinsicpageletparamprefeditor;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portalpages.browsing.mock.prefs
{
  /// <author>rozhang</author>
  public class MockIntrinsicPrefsEditorForPageletParametersModel : IntrinsicPrefsEditorForPageletParametersModel
  {
    public IPTGadget m_mockPortlet = null;
    protected XPHashtable m_setttings = new XPHashtable();
    // hashtable of xparraylist, one for each settings type, with the elements
    protected XPHashtable m_typeTable = new XPHashtable();
    public MockIntrinsicPrefsEditorForPageletParametersModel()
    {
    }
    
    /// <summary>
    /// Only works as if arFilter is always null
    /// </summary>
    /// <seealso cref="com.plumtree.portaluiinfrastructure.intrinsicportlets.prefs.IntrinsicPortletPrefsEditorModel#GetSettingValues(int,java.lang.String[])"></seealso>
    public override Object[][] GetSettingValues(int nSettingType, String[] arFilter)
    {
      XPHashtable list = (XPHashtable) m_typeTable.GetElement(nSettingType);
      if (list == null)
      {
        list = new XPHashtable();
      }
      IXPEnumerator typeEnum = list.GetKeys();
      Object[][] arSettings = new Object[2][];
      for (int j2c_index = 0;j2c_index < 2;j2c_index++)
      {
        arSettings[j2c_index] = new Object[list.GetSize()];
      }
      int counter = 0;
      while (typeEnum.MoveNext())
      {
        String name = (String) typeEnum.GetCurrent();
        String value = (String) list.GetElement(name);
        arSettings[0][counter] = name;
        arSettings[1][counter] = value;
        counter++;
      }
      return arSettings;
    }
    public override Object GetSettingValue(int nSettingType, String strName)
    {
      return m_setttings.GetElement(ConstructHashKey(nSettingType, strName));
      }
    public override void RemoveSettingValue(int nSettingType, String strName)
    {
      XPHashtable list = (XPHashtable) m_typeTable.GetElement(nSettingType);
      if (list != null)
      {
        list.RemoveElement(strName);
      }
      m_setttings.RemoveElement(ConstructHashKey(nSettingType, strName));
      }
    public override void SetSettingValue(int nSettingType, String strName,
     Object oValue)
    {
      if (m_typeTable.ContainsKey(nSettingType))
      {
        ((XPHashtable) m_typeTable.GetElement(nSettingType)).PutElement(strName,
         oValue);
      } else
      {
        XPHashtable list = new XPHashtable();
        list.PutElement(strName, oValue);
        m_typeTable.PutElement(nSettingType, list);
      }
      m_setttings.PutElement(ConstructHashKey(nSettingType, strName), oValue);
      }
    protected override IPTGadget GetPortletFromSpace(AActivitySpace asParent)
    {
      return m_mockPortlet;
    }
    protected virtual void SetMockPortlet(IPTGadget mockPortlet)
    {
      m_mockPortlet = mockPortlet;
    }
    protected virtual String ConstructHashKey(int type, String name)
    {
      return name + type;
    }
  }
}