using System;
using XPHashtable=com.plumtree.openfoundation.util.XPHashtable;
using IAdvancedSearchModelRO=com.plumtree.portalpages.browsing.search.advanced.IAdvancedSearchModelRO;
using SearchPageModeHelper=com.plumtree.portalpages.browsing.search.results.SearchPageModeHelper;
using com.plumtree.portaluiinfrastructure.filter;
using com.plumtree.server;
using EditorModel=com.plumtree.uiinfrastructure.editor.EditorModel;
namespace com.plumtree.portalpages.browsing.mock.search.advanced
{
  public class MockAdvancedSearchModel : EditorModel,IAdvancedSearchModelRO
  {
    public const String STR_MVC_CLASS_NAME = "MockAdvancedSearchModel";
    public const String HTML_SELECT_NUMRESULTS = "in_se_numresults";
    // Passthru IFilterIteratorIO methods
    private FilterIterator _filterIterator;
    private IPTFilter _filter;
    private IPTSession _session;
    private bool _showErrorsOnPage;
    protected String _mode = SearchPageModeHelper.BROWSE_MODE;
    public override bool CheckEditorAccessAndStart(XPHashtable _htFormData)
    {
      _session = (IPTSession) m_asOwner.GetUserSession();
      // Create a temporary filter
      try
      {
        _filter = FilterForm.BuildFilterFromForm(m_asOwner, _htFormData, "");
        }
      catch (Exception e)
      {
      }
      if (_filter == null)
      {
        _filter = PortalObjectsFactory.CreateSearchFilter();
      }
      _filterIterator = new FilterIterator(_session, _filter, m_asOwner);
      // Don't show potential errors until the user first attempts to submit
      _showErrorsOnPage = false;
      return true;
    }
    public override Object Create()
    {
      return new MockAdvancedSearchModel();
    }
    public override void Finish()
    {
    }
    // nothing to do here
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    public override int SavePage(String pageName, XPHashtable formData)
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual String GetMode()
    {
      return _mode;
    }
    public virtual bool GetShowPotentialErrors()
    {
      return _showErrorsOnPage;
    }
    public virtual IFilterIteratorRO GetFilterIterator()
    {
      // TODO Auto-generated method stub
      return null;
    }
  }
}