using System;
using XPHashtable=com.plumtree.openfoundation.util.XPHashtable;
using PTSearchLocaleVarPack=com.plumtree.portaluiinfrastructure.application.varpacks.PTSearchLocaleVarPack;
using MockPTSearchLocaleVarPack=com.plumtree.portaluiinfrastructure.mock.application.varpacks.MockPTSearchLocaleVarPack;
using AppConstants=com.plumtree.uiinfrastructure.application.varpacks.AppConstants;
using EditorHelperModel=com.plumtree.uiinfrastructure.editor.EditorHelperModel;
using com.plumtree.uiinfrastructure.web;
namespace com.plumtree.portalpages.common.documentlanguage
{
  public class MockCardLanguagePlugInModel : EditorHelperModel,ICardLanguagePlugInModelRO
  {
    // This should never be needed.
    public const String ENGLISH_LOCALE_CODE = "en";
    public bool m_bIncludeAllLanguagesOption = false;
    private MockPTSearchLocaleVarPack m_vpPTSearchLocales;
    private String m_strCardLanguageCode = "";
    private String m_strDefaultLanguage = "";
    private String m_strInstructionLabel = "";
    private String m_strViewTitle = "";
    //	private boolean m_bDisplayPopularOnly = false;
    public const String STR_MVC_CLASS_NAME = "MockCardLanguagePlugIn";
    
    /// <summary>
    /// To initialize this plug-in you need to set the DP name
    /// and the default value of the plug-in setting.
    /// </summary>
    /// <param name="_sPlugInSetting"></param>
    public virtual void InitializePlugIn(String strCardLanguage, String strViewTitle,
     String strInstructionLabel, bool bIncludeAllLanguagesOption)
    {
      m_strDefaultLanguage = strCardLanguage;
      m_strViewTitle = strViewTitle;
      //		m_strDefaultLanguage = XPLocale.GetDefault().GetLanguage();
      m_bIncludeAllLanguagesOption = bIncludeAllLanguagesOption;
      m_strCardLanguageCode = m_strDefaultLanguage;
      m_strInstructionLabel = strInstructionLabel;
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      m_vpPTSearchLocales = (MockPTSearchLocaleVarPack) application.GetVarPackManager().GetVariablePackage(MockPTSearchLocaleVarPack.VARPACK_ID);
      }
    public override Object Create()
    {
      return new MockCardLanguagePlugInModel();
    }
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    public override int SaveSection(XPHashtable formData)
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual String[] GetAllLanguageCodes()
    {
      return m_vpPTSearchLocales.GetAllLanguageCodes();
    }
    public virtual String[] GetAllLanguageNames()
    {
      return m_vpPTSearchLocales.GetAllLanguageNames(m_strDefaultLanguage);
      }
    public virtual String GetCardLanguageCode()
    {
      return m_strCardLanguageCode;
    }
    public virtual bool GetDisplayOnlyPopularLanguages()
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual String GetInstructionLabel()
    {
      return m_strInstructionLabel;
    }
    public virtual String[] GetPopularLanguageCodes()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual String[] GetPopularLanguageNames()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual String GetViewTitle()
    {
      return m_strViewTitle;
    }
    public virtual bool IncludeAllLanguagesOption()
    {
      return m_bIncludeAllLanguagesOption;
    }
  }
}