using System;
using com.plumtree.openfoundation.util;
using IFolderEditorModelRO=com.plumtree.portalpages.browsing.editors.folder.IFolderEditorModelRO;
using IASQueryResult=com.plumtree.portaluiinfrastructure.resultwrapper.IASQueryResult;
using com.plumtree.server;
using EditorHelperModel=com.plumtree.uiinfrastructure.editor.EditorHelperModel;
using com.plumtree.uiinfrastructure.tree;
namespace com.plumtree.portalpages.common.search
{
  public class MockFolderSelectorModel : EditorHelperModel,IFolderSelectorModelRO,
  IFolderSelectorModel
  {
    public const String STR_MVC_CLASS_NAME = "MockFolderSelector";
    private String _lastAdmTreeSpaceId;
    private String _lastCatTreeSpaceId;
    private XPArrayList _admSelections;
    private XPArrayList _catSelections;
    private bool _includeSubfolders = true;
    private bool _multiSelectMode;
    public override Object Create()
    {
      return new MockFolderSelectorModel();
    }
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    public virtual void InitializePlugIn(bool multiSelectMode)
    {
      _catSelections = new XPArrayList();
      _admSelections = new XPArrayList();
      _lastCatTreeSpaceId = null;
      _lastAdmTreeSpaceId = null;
      _multiSelectMode = multiSelectMode;
    }
    public override int SaveSection(XPHashtable formData)
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual String GetFolderSelections(bool isAdmin)
    {
      XPArrayList folderList = (isAdmin ? _admSelections : _catSelections);
      String retval = "";
      for (int j = 0;j < folderList.GetSize();j++)
      {
        for (int k = 0;k < folderList.GetSize();k++)
        {
          TreeLeafNode node = (TreeLeafNode) folderList.GetElement(k);
          // Add classid,
          retval = commaAdd(retval, (isAdmin) ? "20" : "17");
          // Add objectid,
          retval = commaAdd(retval, XPConvert.ToString(node.m_nObjectID));
          }
      }
      return retval;
    }
    private String commaAdd(String initial, String addend)
    {
      if (initial != null && !initial.Equals(""))
      {
        return initial + "," + addend;
      } else
      {
        return addend;
      }
    }
    public virtual bool GetIncludeSubfolders()
    {
      return _includeSubfolders;
    }
    public virtual String GetLastTreeSpaceId(bool isAdmin)
    {
      if (_multiSelectMode)
      {
        // In multiselect mode, reuse the same tree
        if (isAdmin)
        {
          return _lastAdmTreeSpaceId;
        } else
        {
          return _lastCatTreeSpaceId;
        }
      } else
      {
        return null;
      }
    }
    public virtual bool GetMultiSelectMode()
    {
      return _multiSelectMode;
    }
    public virtual IXPCollection GetSelections(bool isAdmin)
    {
      if (isAdmin)
      {
        return _admSelections;
      } else
      {
        return _catSelections;
      }
    }
    public virtual void AddFoldersFromTreeSelections(bool adminListOrCatalogList,
     ITreeModel tree)
    {
    }
    // TODO Auto-generated method stub
    public virtual void DeleteFolders(bool adminListOrCatalogList, int[] folderIDs)
    {
    }
  }
}
// TODO Auto-generated method stub
