using System;
using com.plumtree.openfoundation.util;
using SearchObjectTypes=com.plumtree.portaluiinfrastructure.search.SearchObjectTypes;
using com.plumtree.server;
using EditorHelperModel=com.plumtree.uiinfrastructure.editor.EditorHelperModel;
namespace com.plumtree.portalpages.common.search
{
  public class MockTypeSelectorModel : EditorHelperModel,ITypeSelectorModelRO
  {
    public const String STR_MVC_CLASS_NAME = "MockTypeSelector";
    private XPArrayList _selectedTypes = null;
    private bool _showingDetailedOptions;
    private bool _showAbstractTypeView;
    protected bool isPathwaysEnabled = false;
    public override Object Create()
    {
      return new MockTypeSelectorModel();
    }
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    public virtual void InitializePlugIn(bool showAbstractTypeView, bool noTypesSelected)
    {
      _showAbstractTypeView = showAbstractTypeView;
      _showingDetailedOptions = !_showAbstractTypeView;
      // Preselect the end-user types
      _selectedTypes = new XPArrayList();
      if (noTypesSelected)
      {
        return;
      }
      _selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.CLASSID_00));
      _selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.CLASSID_01));
      _selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.CLASSID_02));
      // community pages
      _selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.CLASSID_25));
      _selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.CLASSID_03));
      _selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.CLASSID_04));
      _selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.CONTENT_APPLICATION_ON_DETAIL_PAGE));
      _selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.COLLAB_APPLICATION_ON_DETAIL_PAGE));
      if (_showAbstractTypeView)
      {
        _selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.DOCUMENT_ABSTRACTTYPE));
        _selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.FOLDER_ABSTRACTTYPE));
        _selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.OTHER_ABSTRACTTYPE));
        _selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.PORTAL_APPLICATION));
        _selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.CONTENT_APPLICATION));
        _selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.COLLAB_APPLICATION));
        }
    }
    public override int SaveSection(XPHashtable formData)
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual bool AreDetailedOptionsShown()
    {
      return _showingDetailedOptions;
    }
    public virtual bool CollabInstalled()
    {
      return false;
    }
    public virtual bool ContentInstalled()
    {
      return false;
    }
    public virtual int[] GetOrderedClassIds()
    {
      return SearchObjectTypes.GetOrderedSearchObjectTypes();
    }
    public virtual IXPCollection GetSelectedTypes()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual bool IsTypeSelected(int type)
    {
      return _selectedTypes.Contains(XPConvert.ToString(type));
    }
    public virtual bool ShouldDisplayAdminObjects()
    {
      return ((IPTSession) m_asOwner.GetUserSession()).GetSessionInfo().CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_ACCESS_ADMINISTRATION);
      }
    public virtual bool ShowAbstractTypeView()
    {
      return _showAbstractTypeView;
    }
  }
}