using System;
using junit.framework;
using xpunit.framework;
using com.plumtree.portalpages.test.admin;
using com.plumtree.portalpages.test.browsing.myportal;
using com.plumtree.portalpages.test.condition;
using com.plumtree.portalpages.test.pei;
using com.plumtree.portalpages.test.rest;
using com.plumtree.taskapi.test.portalui;
namespace com.plumtree.portalpages.test
{
  public class PortalPagesTestSuite
  {
    public const String SUITENAME = "Portal Pages Unit Tests";
    public static Test suite()
    {
      XpTestSuite suite = new XpTestSuite(SUITENAME);
      suite.addTest(ConditionTestSuite.suite());
      suite.addTest(RESTTestSuite.suite());
      suite.addTest(MyPortalTestSuite.suite());
      suite.addTest(PEITestSuite.suite());
      suite.addTest(AdminTestSuite.suite());
      suite.addTest(TaskAPITestSuite.suite());
      return suite;
    }
  }
}