package com.plumtree.portalpages.admin.approval.document;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.constants.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.tips.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 *
 * @version $Revision$
 * @author BenG
 */
public class DocumentApprovalAS extends PTEditorAS
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.approval.document.DocumentApprovalAS");


	public static final String STR_MVC_CLASS_NAME = "DocumentApproval";

	private static final String sClassName = "com.plumtree.portalpages.admin.approval.document.DocumentApprovalAS";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new DocumentApprovalAS();
	}

	/**
	 * Returns the Editor title.
	 *
	 * @return String
	 */
	public String GetEditorTitle()
	{
		return (GetString(0, ResourceConstants.PORTALADMINMSGS));
	}

	/**
	 *
	 *
	 * @return
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the class name of the Property Repost Control.
	 *
	 * @return String
	 */
	public String GetRepostControlName()
	{
		return (DocumentApprovalControl.STR_MVC_CLASS_NAME);
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(String, String, boolean)
	 */
	public boolean CheckBasicAccess(String strPage, String strControl,
		boolean bSameSpace)
	{
		if (!((IPTSession) GetUserSession()).GetSessionInfo()
			.CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_ACCESS_UTILITIES))
		{
			return false;
		}

		return super.CheckBasicAccess(strPage, strControl, bSameSpace);
	}

	/**
	 * Registers all the classes of the Property Activity Space.
	 *
	 */
	public void Init()
	{
		
			log.Debug("ENTERING Init()");
		

		// ***CHANGE_HERE*** Replace Misc2Model below with your Model.
		m_strModelName = DocumentApprovalModel.STR_MVC_CLASS_NAME;

		// Warning: m_strModelName must be initialized before super.Init() is called.
		super.Init();

		//Sets left nav menu
		// ***CHANGE_HERE*** Set the left nav menu using StartNewSubMenu and AddLinkToSubMenu.
		// ***COMMENT_1*** If you don't want any left nav menu just remove the lines below.
		// BEGIN Sub menu "General Settings"
		int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(1,
					ResourceConstants.PORTALADMINMSGS));

		IModel myModel = GetModel(DocumentApprovalModel.STR_MVC_CLASS_NAME);

		DocumentApprovalDP dpTemp;

		dpTemp = new DocumentApprovalDP();

		RegisterPage(dpTemp);

		m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, dpTemp.GetName());

		SetCurrentPage(dpTemp);

		// Register Views
		RegisterView(DocumentApprovalView.STR_MVC_CLASS_NAME, myModel);

		// Register Controls
		RegisterControl(DocumentApprovalControl.STR_MVC_CLASS_NAME, myModel);

		// END Sub menu "General Settings"
		//	TIPS
		TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);

		if (tm != null)
		{
			try
			{
				tm.SetGeneratingClass( sClassName );


				int iTitleId = 0;
				int iTipId = 1;
				int iSecondaryTipId = 2;

				tm.SetTipTitle( this.GetString( iTitleId, ResourceConstants.TIPS) );

				HTMLGenericElement e = new HTMLGenericElement( this.GetString( iTipId, ResourceConstants.TIPS) );

				tm.SetTip( e );

				String sSecondary = this.GetString( iSecondaryTipId, ResourceConstants.TIPS);

				if( !("none_do_not_translate".equals( sSecondary )) )
				{

					e = new HTMLGenericElement( sSecondary );

					tm.SetSecondarTip( e );
				}



			}
			catch (Exception ex)
			{
				
					log.Error(ex, "Couldn't generate tip.");
				
			}
		}
		 //	Got the tips model


		 this.SetHelpTopic( "PT_ApproveDocuments_DocumentsforApproval" );

	}
}

