package com.plumtree.portalpages.admin.approval.document;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.approval.*;
import com.plumtree.uiinfrastructure.tree.*;

public class DocumentApprovalControl extends ApprovalControl
{
	public static final String STR_MVC_CLASS_NAME   = "DocumentApprovalControl";
	
	public final static int POSTTOSELF_ACTION_FILTER_BY = 90;
	
	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new DocumentApprovalControl();
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IView#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
	
	protected void PerformAction(int arg)
	{
		super.PerformAction(arg);
		// this is the override method
		if (arg > 199) // card IDs begin at 200
		{
			if (m_asOwner.GetSubSpaceExists("CatFolderTree"))
			{
				ATreeAS asFolderTree   = (ATreeAS) m_asOwner.GetSubSpace(
						"CatFolderTree");
				ITreeModelRO myTree    = (ITreeModelRO) asFolderTree.GetModel(ATreeAS.TREEMODEL);
				XPArrayList mySelected = myTree.GetSelectedItems();
	
				int[] FolderIDs = new int[mySelected.GetSize()];
				for (int i = 0; i < mySelected.GetSize(); i++)
					FolderIDs[i] = ((TreeLeafNode) mySelected.GetElement(i)).m_nObjectID;
				DocumentApprovalModel model  = (DocumentApprovalModel)m_asOwner.GetModel(DocumentApprovalModel.STR_MVC_CLASS_NAME);
				model.ModifyCardFolders(arg, FolderIDs);
			}
		}
		else if (arg == POSTTOSELF_ACTION_FILTER_BY)
		{
			if (m_asOwner.GetSubSpaceExists("CrawlerTree"))
			{
				/* get the tree */
				ATreeAS asCrawlerTree   = (ATreeAS) 
					m_asOwner.GetSubSpace("CrawlerTree");
				ITreeModelRO myTree    = (ITreeModelRO) 
					asCrawlerTree.GetModel(ATreeAS.TREEMODEL);
					
				/* get the selected items */
				XPArrayList mySelected = myTree.GetSelectedItems();
	
				/* create array of selected ids */
				Object[] crawlerIDs = null;
				if (mySelected.GetSize() > 0)
				{
					crawlerIDs = new Object[mySelected.GetSize()];
					for (int i = 0; i < mySelected.GetSize(); i++)
						crawlerIDs[i] = new Integer(((TreeLeafNode) mySelected.GetElement(i)).m_nObjectID);
				}
				
				/* store it on the model */
				DocumentApprovalModel model  = (DocumentApprovalModel)
					m_asOwner.GetModel(DocumentApprovalModel.STR_MVC_CLASS_NAME);
				model.SetFilterByIDs(crawlerIDs);
				
				/* clear the cache so we can query with filter of selected ids */
				model.ClearCache();
			}
		}
		
		return;
	}

}
