package com.plumtree.portalpages.admin.editors.authsource;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.constants.*;
import com.plumtree.portalpages.common.helpers.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 *
 * @author OlegS
 */
public abstract class AuthSource3View extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.authsource.AuthSource3View");

	public static final String HTMLINPUT_AuthenticationAndSynchronizationChoice = "in_ra_AuthenticationAndSynchronizationChoice";

	public static final String HTMLINPUT_SynchronizationType = "in_ra_SynchronizationType";

	public static final String HTMLINPUT_BatchSize = "in_tx_BatchSize";

	public static final String HTMLINPUT_PARTNERS = "in_se_Partners";
	
	// aj: this is for the enable/disable cross AS memberships cbox
	public static final String HTMLINPUT_CrossAsMemberships = "in_cb_CrossAsMemberships";


	/**
	 *
	 *
	 * @return
	 * @throws XPException
	 */
	public HTMLElement Display()
	{
		try
		{
			HTMLElementCollection result = new HTMLElementCollection();

			result.AddInnerHTMLString("\n");

			HTMLComment myComment = new HTMLComment( "Begin: Display AuthSource3View");
			result.AddInnerHTMLElement( myComment );


			DisplayHiddenInputs(result);
			DisplayHeader1(result);
			DisplayBody1(result);
			new Spacer("15").display(result);

			int mode = model().supportSyncMode();

			if (mode == PT_AUTHSOURCE_SUPPORTSSYNCMODES.PT_AUTHSOURCESUPPORTSSYNCMODE_SYNCONLY)
			{
				DisplayHeader3(result);
				DisplayBody3(result);
				new Spacer("15").display(result);
				DisplayHeader2(result);
				DisplayBody2(result);
			}
			else if (mode == PT_AUTHSOURCE_SUPPORTSSYNCMODES.PT_AUTHSOURCESUPPORTSSYNCMODE_BOTH)
			{
				DisplayHeader2(result);
				DisplayBody2(result);
			}

			result.AddInnerHTMLString( "\n" );

			myComment = new HTMLComment( "Display AuthSource3View");
			result.AddInnerHTMLElement( myComment );

			return result;
		}
		catch (Exception e)
		{
			log.Error(e, XPResourceManager.FormatMessage(
					"AuthSource3View::Display The following error occured when trying to display the HTML: {0}",
					e.getMessage()));

			throw new XPException(m_asOwner.GetString(58,
					ResourceConstants.PORTALADMINMSGS), e);
		}
	}

	/**
	 *
	 *
	 * @param result
	 *
	 * @throws HTMLException
	 */
	protected void DisplayBody1(HTMLElementCollection result)
	{
		HTMLTable myTable;
		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLSpan mySpan;
		result.AddInnerHTMLString("\n");

		HTMLComment myComment = new HTMLComment( "Begin: DisplayBody1 AuthSource3View");
		result.AddInnerHTMLElement( myComment );


		myTable = new HTMLTable();
		result.AddInnerHTMLElement(myTable);
		myTable.SetWidth("100%");
		myTable.SetBorder("0");
		myTable.SetCellPadding("5");
		myTable.SetCellSpacing("0");
		myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		mySpan = new HTMLSpan();
		myCell.AddInnerHTMLElement(mySpan);
		myCell.SetWidth("150");
		myCell.SetVAlign("TOP");
		mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);

		mySpan.AddInnerHTMLString(m_asOwner.GetString(43,
				ResourceConstants.PORTALADMINMSGS));
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);

		int choice = model().supportSyncMode();

		DisplayRadioForBody1(myCell,
			PT_AUTHSOURCE_SUPPORTSSYNCMODES.PT_AUTHSOURCESUPPORTSSYNCMODE_BOTH,
			choice, m_asOwner.GetString(40, ResourceConstants.PORTALADMINMSGS), true);

		DisplayRadioForBody1(myCell,
			PT_AUTHSOURCE_SUPPORTSSYNCMODES.PT_AUTHSOURCESUPPORTSSYNCMODE_AUTHONLY,
			choice, m_asOwner.GetString(41, ResourceConstants.PORTALADMINMSGS), true);

		DisplayRadioForBody1(myCell,
			PT_AUTHSOURCE_SUPPORTSSYNCMODES.PT_AUTHSOURCESUPPORTSSYNCMODE_SYNCONLY,
			choice, m_asOwner.GetString(42, ResourceConstants.PORTALADMINMSGS), false);

		result.AddInnerHTMLString( "\n" );

		myComment = new HTMLComment( "End: DisplayBody1 AuthSource3View");

		result.AddInnerHTMLElement( myComment );

	}

	/**
	 *
	 *
	 * @param result
	 *
	 * @throws HTMLException
	 */
	protected void DisplayBody2(HTMLElementCollection result)
	{
		HTMLTable myTable;
		result.AddInnerHTMLString( "\n" );

		HTMLComment myComment = new HTMLComment( "Begin: DisplayBody2 AuthSource3View");
		result.AddInnerHTMLElement( myComment );



		myTable = new HTMLTable();
		result.AddInnerHTMLElement(myTable);
		myTable.SetWidth("100%");
		myTable.SetBorder("0");
		myTable.SetCellPadding("5");
		myTable.SetCellSpacing("0");

		HTMLTableRow myRow;
		HTMLTableCell myCell;
		myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
		myCell = new HTMLTableCell();
		myCell.SetColSpan("2");
		myRow.AddInnerHTMLElement(myCell);
		myCell.AddInnerHTMLString(m_asOwner.GetString(2636, ResourceConstants.PORTALADMINMSGS));

		int choice = model().syncType();

		DisplayRowForBody2(myTable, PT_SYNCTYPES.PT_SYNCTYPE_FULL, choice,
			m_asOwner.GetString(44, ResourceConstants.PORTALADMINMSGS),
			null, 
			m_asOwner.GetString(2637, ResourceConstants.PORTALADMINMSGS), 
			m_asOwner.GetString(2638, ResourceConstants.PORTALADMINMSGS));

		DisplayRowForBody2(myTable, PT_SYNCTYPES.PT_SYNCTYPE_PARTIAL, choice,
			m_asOwner.GetString(46, ResourceConstants.PORTALADMINMSGS),
			m_asOwner.GetString(2639, ResourceConstants.PORTALADMINMSGS), 
			m_asOwner.GetString(2641, ResourceConstants.PORTALADMINMSGS), 
			m_asOwner.GetString(2638, ResourceConstants.PORTALADMINMSGS));

		DisplayRowForBody2(myTable, PT_SYNCTYPES.PT_SYNCTYPE_PARTIALGROUPS,
			choice, m_asOwner.GetString(48, ResourceConstants.PORTALADMINMSGS),
			m_asOwner.GetString(2642, ResourceConstants.PORTALADMINMSGS), 
			m_asOwner.GetString(2637, ResourceConstants.PORTALADMINMSGS), 
			m_asOwner.GetString(2643, ResourceConstants.PORTALADMINMSGS));

		DisplayRowForBody2(myTable,
			PT_SYNCTYPES.PT_SYNCTYPE_PARTIALUSERSPARTIALGROUPS, choice,
			m_asOwner.GetString(51, ResourceConstants.PORTALADMINMSGS),
			m_asOwner.GetString(2644, ResourceConstants.PORTALADMINMSGS) + "<BR>" + "&nbsp;&nbsp;&nbsp;" + 
		m_asOwner.GetString(2645, ResourceConstants.PORTALADMINMSGS) + "<BR>" + "&nbsp;&nbsp;&nbsp;" + 
		m_asOwner.GetString(2646, ResourceConstants.PORTALADMINMSGS) + "<BR>" + "&nbsp;&nbsp;&nbsp;" + 
		m_asOwner.GetString(2647, ResourceConstants.PORTALADMINMSGS), 
			m_asOwner.GetString(2641, ResourceConstants.PORTALADMINMSGS), 
			m_asOwner.GetString(2643, ResourceConstants.PORTALADMINMSGS));

		DisplayRowForBody2(myTable, PT_SYNCTYPES.PT_SYNCTYPE_NONE, choice,
			m_asOwner.GetString(54, ResourceConstants.PORTALADMINMSGS),
			m_asOwner.GetString(55, ResourceConstants.PORTALADMINMSGS), 
			null, 
			null);
		
		DisplayLastRowForBody2(myTable);
		result.AddInnerHTMLString( "\n" );

		myComment = new HTMLComment( "End: DisplayBody2 AuthSource3View");

		result.AddInnerHTMLElement( myComment );
	}

	/**
	 *
	 *
	 * @param result
	 *
	 * @throws HTMLException
	 */
	protected void DisplayBody3(HTMLElementCollection result)
	{
		HTMLTable myTable;
		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLSpan mySpan;
		result.AddInnerHTMLString( "\n" );

		HTMLComment myComment = new HTMLComment( "Begin: DisplayBody3 AuthSource3View");
		result.AddInnerHTMLElement( myComment );

		myTable = new HTMLTable();
		result.AddInnerHTMLElement(myTable);
		myTable.SetWidth("100%");
		myTable.SetBorder("0");
		myTable.SetCellPadding("5");
		myTable.SetCellSpacing("0");

		myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);

		mySpan = new HTMLSpan();
		myCell.AddInnerHTMLElement(mySpan);
		mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
		mySpan.AddInnerHTMLString(m_asOwner.GetString(1709, ResourceConstants.PORTALADMINMSGS) + ":"+CommonHTMLStrings.SPACE+CommonHTMLStrings.SPACE);

		Object[][] partners = model().authPartners();
		HTMLSelect mySelect = new HTMLSelect(HTMLINPUT_PARTNERS, "");
		myCell.AddInnerHTMLElement(mySelect);
		mySelect.SetStyleClass(PTStyleClass.FORM_PULLDOWN_TEXT);

		int sel = model().selectedPartnerId();

		for (int i = -1; i < partners[0].length; i++)
		{
			int id			    = (i < 0) ? 0
										  : XPConvert.ToInteger(partners[0][i]);
			HTMLOption myOption = new HTMLOption(XPConvert.ToString(id));
			mySelect.AddInnerHTMLElement(myOption);
			myOption.AddInnerHTMLString((i < 0) ? m_asOwner.GetString(1708, ResourceConstants.PORTALADMINMSGS)
												: XPHttpUtility.HtmlEncode((String) partners[1][i]));

			if (id == sel)
			{
				myOption.SetSelected(true);
			}
		}
	}

	/**
	 *
	 *
	 * @param result
	 *
	 * @throws HTMLException
	 */
	protected void DisplayHeader1(HTMLElementCollection result)
	{
		result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(38,
					ResourceConstants.PORTALADMINMSGS)));
	}

	/**
	 *
	 *
	 * @param result
	 *
	 * @throws HTMLException
	 */
	protected void DisplayHeader2(HTMLElementCollection result)
	{
		result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(39,
					ResourceConstants.PORTALADMINMSGS)));
	}

	/**
	 *
	 *
	 * @param result
	 *
	 * @throws HTMLException
	 */
	protected void DisplayHeader3(HTMLElementCollection result)
	{
		result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(1709, ResourceConstants.PORTALADMINMSGS)));
	}

	/**
	 *
	 *
	 * @param result
	 *
	 * @throws HTMLException
	 */
	protected void DisplayHiddenInputs(HTMLElementCollection result)
	{
	}

	/**
	 * Prints the last part of the second body.  Specifically:
	 * <SPACER ROW>
	 * Cross AS Memberships setting
	 * <SPACER ROW>
	 * Batch Import setting
	 *
	 * @param myTable
	 *
	 * @throws HTMLException
	 */
	protected void DisplayLastRowForBody2(HTMLTable myTable)
	{
		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLSpan mySpan;
		HTMLInput myInput;

		/******** SPACER ROW *******/
		// aj: white row - spacer between sync types and
		//     the other synchronization settings
		myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		myRow.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BG);
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetColSpan("2");
		myCell.SetHeight("2");

		/******** CROSS AS MEMBERSHIPS ********/
		// aj: the row for the cross as memberships checkbox
		myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		
		// aj: the actual checkbox (col 1)
		myInput = new HTMLInput(HTMLInputTypes.CHECKBOX, HTMLINPUT_CrossAsMemberships, "", "");
		myCell.AddInnerHTMLElement(myInput);
		myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
		myInput.SetValue(CommonHTMLStrings.ONE);
		myInput.SetChecked(model().ImportCrossASMemberships());
		
		// aj: a message about the setting (col 2)
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		mySpan = new HTMLSpan();
		myCell.AddInnerHTMLElement(mySpan);
		mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);	
		mySpan.AddInnerHTMLString(m_asOwner.GetString(2878, ResourceConstants.PORTALADMINMSGS));
		
		/******** SPACER ROW *******/
		// aj: white row - spacer between sync types and
		//     the other synchronization settings
		myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		myRow.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BG);
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetColSpan("2");
		myCell.SetHeight("2");
		
		/******** BATCH SETTING SIZE ********/
		// aj: the row for the input batch size setting
		myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetColSpan("2");
		mySpan = new HTMLSpan();
		myCell.AddInnerHTMLElement(mySpan);
		mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);

		// aj: this input is for the batch size settings
		myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_BatchSize, "", "");
		myInput.SetSize(4);
		myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
		myInput.SetValue(XPConvert.ToString(model().bulkCopyNum()));
		String inputHTML=myInput.GetDisplayString();
		String label=m_asOwner.GetString(56, ResourceConstants.PORTALADMINMSGS); // _ui_ImportBatchesOfUsersAtATime;
		String labelAndInputHTML=XPResourceManager.FormatMessage(label,inputHTML);
		mySpan.AddInnerHTMLString(labelAndInputHTML);
	}

	/**
	 *
	 *
	 * @param myCell
	 * @param ivalue
	 * @param checked
	 * @param s
	 * @param needbreak
	 *
	 * @throws HTMLException
	 */
	protected void DisplayRadioForBody1(HTMLTableCell myCell, int ivalue, int iChecked,
		String s, boolean needbreak)
	{
		myCell.SetVAlign(CommonHTMLStrings.TOP);
		HTMLInput myInput = new HTMLInput(HTMLInputTypes.RADIO,
				HTMLINPUT_AuthenticationAndSynchronizationChoice,
				XPConvert.ToString(ivalue), "");
		myInput.SetValue(XPConvert.ToString(ivalue));
		myInput.SetChecked(iChecked == ivalue);
		myInput.SetOnClick(AFormDP.JAVASCRIPT_SUBMIT_FORM + "(" +
			AuthSourceRepostControl.makeAction(AuthSourceRepostControl.ACTION_SYNC_CHOICE_CHANGED,0) + "); return false;");
		myCell.AddInnerHTMLElement(myInput);

		HTMLSpan mySpan = new HTMLSpan();
		myCell.AddInnerHTMLElement(mySpan);
		mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
		mySpan.AddInnerHTMLString(s);

		if (needbreak)
		{
			myCell.AddInnerHTMLElement(new HTMLBr());
		}
	}

	/**
	 *
	 *
	 * @param myTable
	 * @param ivalue
	 * @param nChecked
	 * @param s1
	 * @param s2
	 *
	 * @throws HTMLException
	 */
	protected void DisplayRowForBody2(HTMLTable myTable, int ivalue, int nChecked,
		String subheader, String generalDesc, String userDesc, String groupDesc)
	{
		HTMLTableRow myRow;

		// radio button
		HTMLTableCell myCell;
		HTMLInput myInput;
		myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetVAlign(CommonHTMLStrings.TOP);
		myInput = new HTMLInput(HTMLInputTypes.RADIO,
				HTMLINPUT_SynchronizationType, XPConvert.ToString(ivalue), "");
		myInput.SetChecked(nChecked == ivalue);
		myCell.AddInnerHTMLElement(myInput);
		myInput.SetValue(XPConvert.ToString(ivalue));
//		DisplayTwoSpansForBody2(myRow, subheader, generalDesc);

		HTMLSpan mySpan;
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);

		// subheader
		mySpan = new HTMLSpan();
		myCell.AddInnerHTMLElement(mySpan);
		mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
		mySpan.AddInnerHTMLString(subheader);
		mySpan.AddInnerHTMLElement(new HTMLBr());

		mySpan = new HTMLSpan();
		myCell.AddInnerHTMLElement(mySpan);
		mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);

		// general description
		if (generalDesc != null)
		{
			mySpan.AddInnerHTMLString(generalDesc);
			mySpan.AddInnerHTMLElement(new HTMLBr());
			mySpan.AddInnerHTMLElement(new HTMLBr());
		}

		// user description
		if (userDesc != null)
		{
			mySpan.AddInnerHTMLString(m_asOwner.GetString(2640, ResourceConstants.PORTALADMINMSGS));
			mySpan.AddInnerHTMLElement(new HTMLBr());
			mySpan.AddInnerHTMLString("&nbsp;&nbsp;&nbsp;" + userDesc);
			mySpan.AddInnerHTMLElement(new HTMLBr());
		}

		// group description
		if (groupDesc != null)
		{
			mySpan.AddInnerHTMLString("&nbsp;&nbsp;&nbsp;" + groupDesc);
			mySpan.AddInnerHTMLElement(new HTMLBr());
		}

	}

	/**
	 *
	 *
	 * @param myRow
	 * @param s1
	 * @param s2
	 *
	 * @throws HTMLException
	 */
	protected void DisplayTwoSpansForBody2(HTMLTableRow myRow, String s1, String s2)
	{
		HTMLTableCell myCell;
		HTMLSpan mySpan;
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		mySpan = new HTMLSpan();
		myCell.AddInnerHTMLElement(mySpan);
		mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
		mySpan.AddInnerHTMLString(s1);
		mySpan.AddInnerHTMLElement(new HTMLBr());
		mySpan = new HTMLSpan();
		myCell.AddInnerHTMLElement(mySpan);
		mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
		mySpan.AddInnerHTMLString(s2);
	}

	/**
	 *
	 *
	 * @return
	 */
	protected IAuthSourceModelRO model()
	{
		return (IAuthSourceModelRO) m_model;
	}
}

