package com.plumtree.portalpages.admin.editors.authsource;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.editors.common.setjob.*;
import com.plumtree.portalpages.common.constants.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.editor.commonpages.localizednames.*;
import com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.expandablelist.*;
import com.plumtree.uiinfrastructure.tips.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 *
 * @author OlegS
 */
public abstract class AuthSourceEditorAS extends ObjEditorAS
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.authsource.AuthSourceEditorAS");

	public abstract String GetPageName2();
	public abstract String GetPageName3();
	public abstract String GetPageName4();
	public abstract String GetPageNameMain();
	public abstract String GetViewName2();
	public abstract String GetViewName3();
	public abstract String GetViewName4();
	public abstract String GetViewNameMain();

	/**
	 *
	 */
	public void Init()
	{
		super.Init();

		RegisterView(AuthSourceDependenciesView.STR_MVC_CLASS_NAME,
			GetModel(m_strModelName));

		// JYS: Re-Enable Users popup
		RegisterPage(new AuthSourceReenableUsersPopupDP());
		RegisterView(AuthSourceReenableUsersPopupView.STR_MVC_CLASS_NAME, GetModel(m_strModelName));
		RegisterPage(new AuthSourceReenableUsersConfirmPopupDP());
		RegisterView(AuthSourceReenableUsersConfirmPopupView.STR_MVC_CLASS_NAME, GetModel(m_strModelName));

		// Register plug-in sections
		RegisterPage(new SetJobDP());

		// Register classes for the set job and for the object owner
		RegisterModel(SetJobModel.STR_MVC_CLASS_NAME);
		RegisterControl(SetJobRepostControl.STR_MVC_CLASS_NAME,
			GetModel(SetJobModel.STR_MVC_CLASS_NAME));
		RegisterView(ObjectOwnerView.STR_MVC_CLASS_NAME,
			GetModel(SetJobModel.STR_MVC_CLASS_NAME));

		// Register classes for Job selector
		RegisterModel(SelectPTObjectModel.STR_MVC_CLASS_NAME,
			SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB);
		RegisterView(SelectPTObjectView.STR_MVC_CLASS_NAME,
			SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB,
			GetModel(SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB));
		RegisterControl(ExpListControl.STR_MVC_CLASS_NAME,
			SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB,
			GetModel(SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB));

		//	TIPS
		TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);

		if (tm != null)
		{
			try
			{



				int iTitleId = 12;
				int iTipId = 13;
				int iSecondaryTipId = 14;

				tm.SetTipTitle( this.GetString( iTitleId, ResourceConstants.TIPS) );

				HTMLGenericElement e = new HTMLGenericElement( this.GetString( iTipId, ResourceConstants.TIPS) );

				tm.SetTip( e );

				String sSecondary = this.GetString( iSecondaryTipId, ResourceConstants.TIPS);

				if( !("none_do_not_translate".equals( sSecondary )) )
				{

					e = new HTMLGenericElement( sSecondary );

					tm.SetSecondarTip( e );
				}



			}
			catch (Exception ex)
			{
				
					log.Error(ex, "Couldn't generate tip.");
				
			}
		}
		 //	Got the tips model
	}

	/**
	 *
	 *
	 * @return
	 */
	public abstract boolean WantTemplatesSection();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor#GetDependenciesViewName()
	 */
	public String GetDependenciesViewName()
	{
		return (AuthSourceDependenciesView.STR_MVC_CLASS_NAME);
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage()
	 *
	 * @param IDisplayPage the current Display Page
	 */
	public void SetCurrentPage(IDisplayPage page)
	{
		super.SetCurrentPage(page);

		String sPageName = page.GetName();

		if (SetJobDP.STR_MVC_CLASS_NAME.equals(sPageName))
		{
			SetHelpTopic("PT_SetJob");
		}
		else if(LocNamesDP.STR_MVC_CLASS_NAME.equals(sPageName))
		{
			SetHelpTopic("PT_AuthenticationSource_PropertiesandNames");
		}

	}
}

