package com.plumtree.portalpages.admin.editors.authsource;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.editors.authsource.plumtree.*;
import com.plumtree.portalpages.common.constants.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

public class AuthSourceSelectAuthPartnerView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.authsource.plumtree.AuthSourceSelectAuthPartnerView");

	public static final String STR_MVC_CLASS_NAME = "AuthSourceSelectAuthPartnerView";

	public static final String HTMLINPUT_PARTNERS = "in_se_Partners";
	
	/**
	 *
	 *
	 * @return
	 * @throws XPException
	 */
	public HTMLElement Display()
	{
		HTMLTable myTable;
		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLSpan mySpan;

		try
		{
			HTMLElementCollection result = new HTMLElementCollection();

			result.AddInnerHTMLString("\n");

			HTMLComment myComment = new HTMLComment( "Begin: " + STR_MVC_CLASS_NAME);
			result.AddInnerHTMLElement( myComment );

			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(1709, ResourceConstants.PORTALADMINMSGS)));

			myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("5");
			myTable.SetCellSpacing("0");

			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);

			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			mySpan.AddInnerHTMLString(m_asOwner.GetString(1709, ResourceConstants.PORTALADMINMSGS) + ":"+CommonHTMLStrings.SPACE+CommonHTMLStrings.SPACE);

			Object[][] partners = ((PlumtreeAuthSourceEditorModel)m_model).authPartners();
			HTMLSelect mySelect = new HTMLSelect(HTMLINPUT_PARTNERS, "");
			myCell.AddInnerHTMLElement(mySelect);
			mySelect.SetStyleClass(PTStyleClass.FORM_PULLDOWN_TEXT);

			int sel = ((PlumtreeAuthSourceEditorModel)m_model).selectedPartnerId();

			for (int i = -1; i < partners[0].length; i++)
			{
				int id			    = (i < 0) ? 0
											  : XPConvert.ToInteger(partners[0][i]);
				HTMLOption myOption = new HTMLOption(XPConvert.ToString(id));
				mySelect.AddInnerHTMLElement(myOption);
				myOption.AddInnerHTMLString((i < 0) ? m_asOwner.GetString(1708, ResourceConstants.PORTALADMINMSGS)
													: XPHttpUtility.HtmlEncode((String) partners[1][i]));

				if (id == sel)
				{
					myOption.SetSelected(true);
				}
			}

			result.AddInnerHTMLString( "\n" );

			myComment = new HTMLComment( "End: " + STR_MVC_CLASS_NAME);
			result.AddInnerHTMLElement( myComment );

			return result;
		}
		catch (Exception e)
		{
			log.Error(e, XPResourceManager.FormatMessage(
					STR_MVC_CLASS_NAME + "::Display The following error occured when trying to display the HTML: {0}",
					e.getMessage()));

			throw new XPException(m_asOwner.GetString(58,
					ResourceConstants.PORTALADMINMSGS), e);
		}
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.editor.EditorView#Create()
	 */
	public Object Create() {
		return new AuthSourceSelectAuthPartnerView();
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.editor.EditorView#GetName()
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}
}

