package com.plumtree.portalpages.admin.editors.bestbets;

import com.plumtree.openfoundation.util.XPHashtable;
import com.plumtree.portalpages.common.constants.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.search.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author CraigS, based on JulieF template
 */
public class BestBetEditorAS extends PTEditorAS
{
	public static final String STR_MVC_CLASS_NAME = "BestBetEditor";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new BestBetEditorAS();
	}

	/**
	 * Returns the Editor title.
	 * @return String
	 */
	public String GetEditorTitle()
	{
		return GetString(155, ResourceConstants.PORTALADMINMSGS);
	}

	/**
	 * Returns the Class name.
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}


	/**
	 * Returns the class name of the Property Repost Control.
	 * @return String
	 */
	public String GetRepostControlName()
	{
		return BestBetRepostControl.STR_MVC_CLASS_NAME;
	}

	/**
	 * Registers all the classes of the Property Activity Space.
	 */
	public void Init()
	{
		m_strModelName = BestBetModel.STR_MVC_CLASS_NAME;

		// Warning: m_strModelName must be initialized before super.Init() is called.
		super.Init();

		// Get search classes as well.
		IntegratedSearchAS.RegisterSearchClasses(this);

		IModel editorModel					 = GetModel(BestBetModel.STR_MVC_CLASS_NAME);
		IBaseSearchResultModelRO searchModel = (IBaseSearchResultModelRO) GetModel(SearchResultModel.STR_MVC_CLASS_NAME);

		// Register DisplayPages
		RegisterPage(new BestBetEditorDP());

		// Register Views
		RegisterView(BestBetEditorView.STR_MVC_CLASS_NAME, editorModel);
		RegisterView(SearchBoxView.STR_MVC_CLASS_NAME, searchModel);
		RegisterView(SearchResultsView.STR_MVC_CLASS_NAME, searchModel);

		// Register Controls
		RegisterControl(BestBetRepostControl.STR_MVC_CLASS_NAME, editorModel);

		// Set default page
		SetCurrentPage(BestBetEditorDP.STR_MVC_CLASS_NAME);

		// Sets left nav menu
		// Commented out: no left nav menu needed
		// int nMenuOneID = m_mEditorMenu.StartNewSubMenu(_ui_LeftNavTitleMain);
		// m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, Misc2DP.STR_MVC_CLASS_NAME);
	}

  /**
   * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage()
   *
   * @param IDisplayPage the current Display Page
   */
  public void SetCurrentPage(IDisplayPage page) {
    super.SetCurrentPage( page );
    this.SetHelpTopic( "PT_EditBestBet" );
  }
	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentFormData(com.plumtree.openfoundation.util.XPHashtable)
	 */
	public void SetCurrentFormData(XPHashtable _htFormData) {
		// TODO Auto-generated method stub
		//if(_htFormData.GetElement(""))
		super.SetCurrentFormData(_htFormData);
	}
}

