package com.plumtree.portalpages.admin.editors.bestbets;

import com.plumtree.portalpages.common.constants.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.errordisplay.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author CraigS, based on JulieF template
 */
public class BestBetEditorDP extends EditorDP
{

	public static final String STR_MVC_CLASS_NAME = "BestBetEditorDP";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return m_asOwner.GetString(160, ResourceConstants.PORTALADMINMSGS);
	}

	/**
	 * Returns the Class name.
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the page.
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()
	 * @return HTMLElement
	 * @throws HTMLException
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		// Add link to help
		result.AddInnerHTMLElement(HTMLConstructHelpers.GetSubHeader("", this.m_asOwner));

		// Add error view
		result.AddInnerHTMLElement(m_asOwner.GetView(
				ErrorView.STR_MVC_CLASS_NAME).Display());

		// Add editor view
		result.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
				BestBetEditorView.STR_MVC_CLASS_NAME)).Display());

		return result;
	}

	 /**
	 *
	 *
	 * @return
	 *
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();
		myScripts.AddInnerHTMLElement(
			m_asOwner
				.GetView(BestBetEditorView.STR_MVC_CLASS_NAME)
				.DisplayJavascript());
		myScripts.AddInnerHTMLElement(
			m_asOwner
				.GetView(SearchResultsView.STR_MVC_CLASS_NAME)
				.DisplayJavascript());
		return myScripts;
	}

}

