package com.plumtree.portalpages.admin.editors.bestbets;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.constants.*;
import com.plumtree.portaluiinfrastructure.search.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author CraigS
 */
public class SearchResultsView implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.bestbets.SearchResultsView");

	// Localizable strings



	protected static final String HTMLINPUT_CB_NULL = "in_cb_null";
	// HTML inputs

	public static final String HTMLINPUT_SELECT_BUTTON = "in_bu_selectitem";

	public static final String STR_MVC_CLASS_NAME = "SearchResultsView";
	protected AActivitySpace m_asOwner;
	protected IBestBetModelRO _bbModel;
	protected ISearchResultModelRO _searchModel;
	private static final String EMPTY = "";
	protected XPDateFormat _dateFormat = null;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SearchResultsView();
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		try
		{
			HTMLTable table;
			HTMLTableCell cell;
			HTMLTableRow row;
			HTMLElement spacer = SearchUIUtility.makeSpacer(this.m_asOwner, "10");
			result.AddInnerHTMLElement(spacer);

			table = new HTMLTable();
			result.AddInnerHTMLElement(table);
			table.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
			table.SetBorder(CommonHTMLStrings.ZERO);
			table.SetCellPadding(CommonHTMLStrings.ZERO);
			table.SetCellSpacing(CommonHTMLStrings.ZERO);
			row = new HTMLTableRow();
			table.AddInnerHTMLElement(row);
			row.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);
			cell = new HTMLTableCell();
			row.AddInnerHTMLElement(cell);
			cell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
			cell.SetHeight("20");
			cell.SetVAlign(CommonHTMLStrings.MIDDLE);
			HTMLSpan span = new HTMLSpan();
			span.SetStyleClass(PTStyleClass.OBJECT_HEADER);
			span.AddInnerHTMLString(m_asOwner.GetString(2406,ResourceConstants.PORTALADMINMSGS));

			cell.AddInnerHTMLElement(span);
			cell = new HTMLTableCell();
			cell.SetWidth("10");
			cell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
			row.AddInnerHTMLElement(cell);
			spacer = SearchUIUtility.makeSpacer(this.m_asOwner, "10");
			result.AddInnerHTMLElement(spacer);

			table = new HTMLTable();
			result.AddInnerHTMLElement(table);
			table.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
			table.SetBorder(CommonHTMLStrings.ZERO);
			table.SetCellPadding(CommonHTMLStrings.FIVE);
			table.SetCellSpacing(CommonHTMLStrings.ZERO);
			row = new HTMLTableRow();
			table.AddInnerHTMLElement(row);
			row.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
			cell = new HTMLTableCell();
			row.AddInnerHTMLElement(cell);
			cell.SetHeight("25");
			cell.SetStyleClass(PTStyleClass.OBJECTSEARCH_TEXT);

			if(_bbModel.GetNumTargets() < _bbModel.GetMaxTargets())
				cell.AddInnerHTMLString(m_asOwner.GetString(2407,ResourceConstants.PORTALADMINMSGS));
			else
			{
				HTMLB bold = new HTMLB();
				cell.AddInnerHTMLElement(bold);
				bold.AddInnerHTMLString(m_asOwner.GetString(169,ResourceConstants.PORTALADMINMSGS));
			}
			table = new HTMLTable();
			table.SetCellPadding(CommonHTMLStrings.TWO);
			table.SetCellSpacing(CommonHTMLStrings.TWO);
			table.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
			result.AddInnerHTMLElement(table);
			HTMLInput hiddenAddDel = new HTMLInput(HTMLInputTypes.HIDDEN,
											BestBetRepostControl.HIDDEN_ADD_DELETE,
											BestBetRepostControl.HIDDEN_ADD_DELETE, EMPTY);
			hiddenAddDel.SetValue(EMPTY);
			result.AddInnerHTMLElement(hiddenAddDel);

			// If there are results to display
			if (_searchModel.IsInitialized())
			{

				row = new HTMLTableRow();
				table.AddInnerHTMLElement(row);


				int numDisplayableResults = _searchModel.GetNumDisplayableItems();
				int totalResults		  = _searchModel.GetTotalItems();

				if (0 == totalResults)
				{
					row.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);
					cell = new HTMLTableCell();
					row.AddInnerHTMLElement(cell);
					cell.SetColSpan(CommonHTMLStrings.FOUR);
					cell.SetHeight("25");
					cell.SetStyleClass(PTStyleClass.OBJECT_HEADER);

					cell.AddInnerHTMLString(m_asOwner.GetString(174,ResourceConstants.PORTALADMINMSGS));
				}
				else
				{
				      row.SetStyleClass(PTStyleClass.LIST_SORT_HEADER_BG);
				      cell = new HTMLTableCell();
				      cell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
				      cell.SetAlign(CommonHTMLStrings.MIDDLE);
				      cell.SetHeight("20");
				      //_ui_Select
				      cell.AddInnerHTMLString(m_asOwner.GetString(2451,ResourceConstants.PORTALADMINMSGS));
				      row.AddInnerHTMLElement(cell);

				      cell = new HTMLTableCell();
				      cell.SetColSpan(CommonHTMLStrings.TWO);
				      cell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
				      //_ui_Name
				      cell.AddInnerHTMLString(m_asOwner.GetString(2453,ResourceConstants.PORTALADMINMSGS));
				      row.AddInnerHTMLElement(cell);

				      cell = new HTMLTableCell();
				      cell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
				      //_ui_LastModified
				      cell.AddInnerHTMLString(m_asOwner.GetString(2454,ResourceConstants.PORTALADMINMSGS));
				      row.AddInnerHTMLElement(cell);


				      /*

					cell.AddInnerHTMLString(m_asOwner.GetString(175,
							ResourceConstants.PORTALADMINMSGS));
					cell.AddInnerHTMLString(XPConvert.ToString(totalResults));
					*/
				}
				boolean disable = _bbModel.GetNumTargets() == _bbModel.GetMaxTargets();
				for (int j = 0; j < numDisplayableResults; j++)
				{
					// Create a row
					row = new HTMLTableRow();
					table.AddInnerHTMLElement(row);

					if (0 == (j % 2))
					{
						row.SetStyleClass(PTStyleClass.LIST_ITEM_TWO_BG);
					}
					else
					{
						row.SetStyleClass(PTStyleClass.LIST_ITEM_ONE_BG);
					}

					// Create cell for radio button
					cell = new HTMLTableCell();
					row.AddInnerHTMLElement(cell);
					cell.SetStyleClass(PTStyleClass.LIST_TEXT);
					cell.SetAlign(CommonHTMLStrings.CENTER);
					cell.SetVAlign(CommonHTMLStrings.TOP);
					int index = itemIsAlreadySelectedIndex(j);
					if (index == 0)
					{
						HTMLInput cb = new HTMLInput(HTMLInputTypes.CHECKBOX,
								BestBetRepostControl.HTMLINPUT_SELECTED_ITEM,
								BestBetRepostControl.HTMLINPUT_SELECTED_ITEM, EMPTY);
						cb.SetValue(XPConvert.ToString(j));	
						cb.SetOnClick("DoAddClicked('" + j + "'); return false;");
						cb.SetDisabled(disable);

						cell.AddInnerHTMLElement(cb);
					}
					else
					{
					    // Put a greyed-out checkbox in if this has already been chosen
					    HTMLInput cb = new HTMLInput(HTMLInputTypes.CHECKBOX,HTMLINPUT_CB_NULL,HTMLINPUT_CB_NULL,EMPTY);
						cb.SetChecked(true);
						cb.SetOnClick("DoRemoveClicked('" + index + "'); return false;");
						cell.AddInnerHTMLElement(cb);
					}

					// Create cell for type icon
					cell = new HTMLTableCell();
					row.AddInnerHTMLElement(cell);
					cell.SetStyleClass(PTStyleClass.LIST_TEXT);
					cell.SetAlign(CommonHTMLStrings.CENTER);
					cell.SetVAlign(CommonHTMLStrings.TOP);

					HTMLImg icon = (HTMLImg) _searchModel.GetResultIcon(j);
					icon.SetAlign(CommonHTMLStrings.ABSMIDDLE);
					icon.SetBorder(CommonHTMLStrings.ZERO);
					cell.AddInnerHTMLElement(icon);

					// Create cell for result name
					cell = new HTMLTableCell();
					cell.SetVAlign(CommonHTMLStrings.TOP);
					row.AddInnerHTMLElement(cell);
					cell.SetStyleClass(PTStyleClass.LIST_TEXT);

					// Add clickthrough URL to cell
					String resultName = XPHttpUtility.HtmlEncode(_searchModel.GetResultName(j));
					HTMLAnchor anchor = _searchModel.GetResultClickthroughURL(j, /* allowPopups= */ false);
					anchor.SetTarget("_blank");
					HTMLB bold = new HTMLB();
					anchor.AddInnerHTMLElement(bold);
					bold.AddInnerHTMLString(resultName);
					anchor.SetTitle(resultName);
					cell.AddInnerHTMLElement(anchor);

					String kwic = _searchModel.GetKWIC(j);

					if (null != kwic)
					{
						// Add line break
						cell.AddInnerHTMLElement(new HTMLBr());

						// Note that the Search server htmlencodes the KWIC for us
						cell.AddInnerHTMLString(kwic);
					}

					// Add path
					String path = _searchModel.GetResultPath(j);

					if (null != path)
					{
						// Add line break
						cell.AddInnerHTMLElement(new HTMLBr());
						//TODO: Figure out what CSS to use here
						cell.AddInnerHTMLString("<i>");
						cell.AddInnerHTMLString(XPHttpUtility.HtmlEncode(path));
						cell.AddInnerHTMLString("</i>");
					}
					cell = new HTMLTableCell();
					row.AddInnerHTMLElement(cell);
					cell.SetStyleClass(PTStyleClass.LIST_TEXT);
					cell.SetNoWrap(true);
					cell.SetVAlign(CommonHTMLStrings.TOP);

					cell.AddInnerHTMLString(GetDateFormat().Format(_searchModel.GetResultLastModified(j)));

				}

				if (0 < totalResults)
				{
					// Add row for "select" button and pagination
					row = new HTMLTableRow();
					table.AddInnerHTMLElement(row);
					row.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);

					cell = new HTMLTableCell();
					row.AddInnerHTMLElement(cell);
					cell.SetHeight("25");

					cell = new HTMLTableCell();
					row.AddInnerHTMLElement(cell);
					cell.SetColSpan(CommonHTMLStrings.THREE);
					cell.SetStyleClass(PTStyleClass.OBJECT_HEADER);
					cell.SetAlign(CommonHTMLStrings.RIGHT);
					cell.AddInnerHTMLElement(PaginationView.DisplayPagination(_searchModel, m_asOwner));
				}
			}
		}
		catch (HTMLException e)
		{
			
				log.Error(e, e.getMessage());
			

			throw XPException.GetInstance(e);
		}

		return result;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		HTMLScript script;

		XPStringBuilder sb = new XPStringBuilder(1000);
		script = new HTMLScript("text/javaScript");

		sb.Append("\nfunction DoAddClicked(varInputVal) {\n");
		sb.Append("    var fElem = document.mainform;\n");
		sb.Append("    var feLen = fElem.elements.length;\n");
		sb.Append("    for (var i = 0; i < feLen; i++) {\n");
		sb.Append("        if (fElem.elements[i].name == '" + BestBetRepostControl.HIDDEN_ADD_DELETE + "') {\n");
		sb.Append("            fElem.elements[i].value = varInputVal;\n");
		sb.Append("        }\n");
		sb.Append("    }\n");
		sb.Append("    postToSelf(" + BestBetRepostControl.POSTTOSELF_ACTION_ADDTARG + ");\n");
		sb.Append("}\n");

		sb.Append("\n\nfunction DoRemoveClicked(varInputVal) {\n");
		sb.Append("    var fElem = document.mainform;\n");
		sb.Append("    var feLen = fElem.elements.length;\n");
		sb.Append("    for (var i = 0; i < feLen; i++) {\n");
		sb.Append("        if (fElem.elements[i].name == '" + BestBetRepostControl.HIDDEN_ADD_DELETE + "') {\n");
		sb.Append("            fElem.elements[i].value = varInputVal;\n");
		sb.Append("        }\n");
		sb.Append("    }\n");
		sb.Append("    postToSelf(" + BestBetRepostControl.POSTTOSELF_ACTION_DELTARGS + ");\n");
		sb.Append("}\n");

		script.AddInnerHTMLString(sb.ToString());


		return script;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IView#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		_searchModel     = (ISearchResultModelRO) model;
		m_asOwner		 = parent;

		// Get the best-bet model as well
		_bbModel = (IBestBetModelRO) m_asOwner.GetModel(BestBetModel.STR_MVC_CLASS_NAME);
	}

	/**
	 *  Helper method to determine if an item has already been selected
	 */
	private int itemIsAlreadySelectedIndex(int itemIdx)
	{
		String id  = _searchModel.GetResultBestBetKey(itemIdx);
		String app = _searchModel.GetResultApp(itemIdx);

		int numTargets = _bbModel.GetNumTargets();

		for (int j = 1; j <= numTargets; j++)
		{
			if (id.equals(_bbModel.GetTargetId(j)) &&
					app.equals(_bbModel.GetTargetApp(j)))
			{
				return j;
			}
		}

		return 0;
	}

	protected XPDateFormat GetDateFormat()
	{
		if(_dateFormat == null)
		  _dateFormat = _searchModel.GetDateFormat(m_asOwner);
		return _dateFormat;
	}
}

