package com.plumtree.portalpages.admin.editors.common.setjob;


// Framework Imports
import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.expandablelist.*;

/**
 * This class handles the repost actions for the
 * Job Owner section.
 *
 * @author Julie Fournier
 */
public class SetJobRepostControl extends EditorHelperRepostControl
{
	/**
	 * Class name for the activity space */
	public static final String STR_MVC_CLASS_NAME = "SetJob";

	/**
	 * Will add one or more items to the list. */
	public static final int POSTTOSELF_ACTION_CHANGE_OWNER = 20;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SetJobRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Calls the method associated to the repost action.
	 * Editors using this framework need to call that method from
	 * the PerformRepostAction method of the main RepostControl.
	 *
	 * @param _nAction
	 * @param _htFormData
	 */
	public void PerformRepostAction(int _nAction, XPHashtable _htFormData)
	{
		switch (_nAction)
		{
		case POSTTOSELF_ACTION_CHANGE_OWNER:
			((SetJobModel) m_model).ChangeOwner();

			break;
		}

		((ExpListControl) m_asOwner.GetControl(SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB)).PerformRepostAction(_nAction,
			_htFormData);
	}
}

