package com.plumtree.portalpages.admin.editors.communitytemplate;


// Framework Imports
import com.plumtree.portalpages.common.constants.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 * @author michaeld
 */
public class CommunityTemplateMainDP extends EditorDP
{
	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "CommTempMain";

	/**
	 * Returns the String to display on the left navigation menu,  linking to
	 * that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return m_asOwner.GetString(198, ResourceConstants.PORTALADMINMSGS);
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the Community Template Page Templates page.
	 *
	 * @return HTMLElement
	 *
	 * @throws HTMLException
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		// Display the list.
		views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
				CommunityTemplateEditorAS.PLUGIN_SELECT_PAGE_TEMPLATE)).Display());

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	 * This is a helper method that all classes that inherit from PlumtreeDP need
	 * to implement.  The method should add whatever HTML the child class wants to
	 * use the DisplayJavaScript and add it to the head.
	 *
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#DisplayJavaScriptFromChild()
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection result = super.DisplayJavaScriptFromChild();

		// Display JavaScripts for the Select PTObject list.
		result.AddInnerHTMLElement(m_asOwner.GetView(
				CommunityTemplateEditorAS.PLUGIN_SELECT_PAGE_TEMPLATE)
			.DisplayJavascript());

		return result;
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader() {
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(1677, ResourceConstants.PORTALADMINMSGS),
			this.m_asOwner);
	}
}

