package com.plumtree.portalpages.admin.editors.communitytemplate;

import com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.*;
import com.plumtree.uiinfrastructure.arraywrapper.*;
import com.plumtree.uiinfrastructure.htmlconstructs.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author michaeld
 */
public class SelectPageTemplateView extends SelectPTObjectView
{
	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "SelectPageTemplate";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SelectPageTemplateView();
	}


	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectView#GetHTMLForNameColumn(IPTGrowableSortedArrayWrapperRO, int)
	 */
	protected HTMLTableCell GetHTMLForNameColumn(
		IPTGrowableSortedArrayWrapperRO _saData, int _nRowIndex)

	{
		if (0 == _nRowIndex)
		{
			HTMLTableCell myCell;

			myCell = new HTMLTableCell();
			myCell.SetWidth("100%");
			myCell.SetHeight("30");
			myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
			myCell.SetNoWrap(true);
			myCell.AddInnerHTMLString(SPACE);

			// row icon
			PTImageType imgRowIcon = ((ISelectPTObjectModelRO) m_model).GetDefaultRowIcon();

			if (null != imgRowIcon)
			{
				myCell.AddInnerHTMLElement(GetIcon(imgRowIcon));
			}

			// Object Name
			Object oPTObjectName = _saData.GetItem(_nRowIndex,
					SelectPTObjectModel.EXPLIST_COL_STRING);

			PTConstruct myConstruct     = UIConstructFactory.GetConstruct(PTImageType.SPACER);
			HTMLImg spacerImage		    = (HTMLImg) myConstruct.GetHTMLElement();
			spacerImage.SetAlt("---");
			spacerImage.SetWidth(CommonHTMLStrings.FIVE);
			spacerImage.SetBorder("0");
			myCell.AddInnerHTMLElement(spacerImage);

			myCell.AddInnerHTMLEncodedString(
					(String) oPTObjectName);

			myCell.AddInnerHTMLString(SPACE + "(" +
				m_asOwner.GetString(214, "ptmsgs_portaladminmsgs") + ")");

			return myCell;
		}
		else
		{
			return super.GetHTMLForNameColumn(_saData, _nRowIndex);
		}
	}
}

