package com.plumtree.portalpages.admin.editors.condition;


// Framework Imports
import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.condition.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;

/**
 *
 */
public class RuleEditorAS extends ObjEditorAS
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.condition.RuleEditorAS");

	public static final String STR_MVC_CLASS_NAME = "RuleEditorAS";

	private static final String sClassName = "com.plumtree.portalpages.admin.editors.condition.RuleEditorAS";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new RuleEditorAS();
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor#GetDependenciesViewName()
	 *
	 */
	public String GetDependenciesViewName()
	{
		return "";
	}

	/**
	 * Sets the Editor title.
	 *
	 */
	public String GetEditorTitle()
	{
		if (EditorStartControl.EDITOR_START_FLAG_CREATE == ((EditorModel) GetModel(
					m_strModelName)).GetEditorType())
		{
			return GetString(2851, "ptmsgs_portaladminmsgs");
		}
		else
		{
			return (XPResourceManager.FormatMessage(GetString(2869, "ptmsgs_portaladminmsgs"), GetObjectName()));
		}
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}


	/**
	 * Returns the class name of the Repost Control.
	 *
	 * @return String
	 */
	public String GetRepostControlName()
	{
		return (RuleEditorRepostControl.STR_MVC_CLASS_NAME);
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage()
	 *
	 * @param IDisplayPage the current Display Page
	 */
	public void SetCurrentPage(IDisplayPage page)
	{
	    super.SetCurrentPage( page );

	    String sPageName = page.GetName();

	    if( RuleEditorMainDP.STR_MVC_CLASS_NAME.equals( sPageName ))
	    {
	        this.SetHelpTopic( "PT_SubportalRulesManager_RulesEditor" );
	    }
	}


	/**
	 * Registers all the classes for this Activity Space.
	 */
	public void Init()
	{
		m_strModelName = RuleEditorModel.STR_MVC_CLASS_NAME;

		super.Init();

		IModel myModel = GetModel(m_strModelName);

		// Main DP
		RuleEditorMainDP ruleMainDP = new RuleEditorMainDP();

		// add validation function
		ruleMainDP.AddToValidationFunction("CheckSubportal");
		ruleMainDP.AddToValidationFunction("CheckName");

		// Register DisplayPages
		RegisterPage(ruleMainDP);

		// Register Views
		RegisterView(CreateRuleView.STR_MVC_CLASS_NAME, myModel);

		// Register Controls
		RegisterControl(RuleEditorRepostControl.STR_MVC_CLASS_NAME, myModel);

		// Default page
		SetCurrentPage(RuleEditorMainDP.STR_MVC_CLASS_NAME);

		// Register Condition Type Expandable Lists
		IXPEnumerator condTypes = ConditionTypeManager.GetInstance().GetArrayConditionTypes().GetEnumerator();
		while (condTypes.MoveNext()) {
			AConditionType current = (AConditionType) condTypes.GetCurrent();
			current.RegisterMyConditionsList(this);
		}
	}
}

