package com.plumtree.portalpages.admin.editors.condition;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.condition.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.expandablelist.*;

/**
 * Delete that class if you don't have any repost actions.
 */
public class RuleEditorRepostControl extends ObjEditorRepostControl
{

	public static final String STR_MVC_CLASS_NAME = "RuleEditorRepostControl";


	public final static int POSTTOSELF_ACTION_SELECTSUBPORTAL = 11;


	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new RuleEditorRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Switch between the action modes and call  the associated method for each
	 * action.
	 *
	 * @param _nAction
	 */
	protected void PerformAction(int _nAction)
	{
		super.PerformAction(_nAction);
		
		// Initialize Condition Type Expandable Lists
		IXPEnumerator condTypes = ConditionTypeManager.GetInstance().GetArrayConditionTypes().GetEnumerator();
		while (condTypes.MoveNext()) {
			AConditionType current = (AConditionType) condTypes.GetCurrent();
			ExpListControl condListControl = (ExpListControl) m_asOwner.GetControl(current.GetConditionTypeIdentifier());
			condListControl.PerformRepostAction(_nAction, m_htFormData);
		}
			 
		switch (_nAction)
		{
		case POSTTOSELF_ACTION_SELECTSUBPORTAL:
			((RuleEditorModel) m_model).SetSubportalActionOnRepost();
			break;
		}
	}
	
	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.ObjEditorRepostControl#DisableSavePopUp()
	 */
	protected boolean DisableSavePopUp()
	{
		return true;
	}
}

