package com.plumtree.portalpages.admin.editors.crawler;

// Plumtree Server
import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 * @author Oleg Sinitsin
 */
public class CrawlerTagView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.crawler.CrawlerTagView");

	/**
	 * Class name for the activity space */
	public static final String STR_MVC_CLASS_NAME = "CrCrawlerTag";



	public static final String HTMLTEXT_CRAWLERTAG="in_tx_CrawlerTag";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new CrawlerTagView();
	}

	/**
	 *
	 * @return
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTableCell myCell;
		HTMLTableRow myRow;
		HTMLInput myInput;
		HTMLSpan mySpan;

		try
		{
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(1797, "ptmsgs_portaladminmsgs")));

			HTMLTable myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("5");
			myTable.SetCellSpacing("0");

			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetWidth("150");
			myCell.SetVAlign("top");
			myCell.SetNoWrap(true);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);

			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1798, "ptmsgs_portaladminmsgs"));

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetWidth("100%");
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);

			myInput = new HTMLInput(HTMLInputTypes.TEXT,HTMLTEXT_CRAWLERTAG,"");
			myCell.AddInnerHTMLElement(myInput);
			myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
			myInput.SetSize(30);
			myInput.SetValue(((ICrawlerModelRO) m_model).GetCrawlerTag());
		}
		catch (Exception e)
		{
			
				log.Error(e, "CrawlerTagView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			
			throw new XPException(m_asOwner.GetString(1796, "ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}

