package com.plumtree.portalpages.admin.editors.crawler;

import com.plumtree.openfoundation.util.IXPPropertyBag;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.server.*;

/**
 * This interface is implemented by the Model.
 * It contains all the read-only mothods of the Model
 * accessed by the Views.
 *
 * @author Julie Fournier
 */
public interface ICrawlerModelRO extends IObjEditorModelRO
{
	/**
	 * @see com.plumtree.portalpages.admin.editors.crawler.CrawlerModel#GetCrawlerSettings()
	 *
	 */
	public int GetCrawlerSettings();

	/**
	 * @see com.plumtree.portalpages.admin.editors.crawler.CrawlerModel#GetDocMapSectionCount()
	 *
	 */
	public int GetDocMapSectionCount();

	/**
	 * @see com.plumtree.portalpages.admin.editors.crawler.CrawlerModel#GetImportOnlyNewLinks()
	 *
	 */
	public boolean GetImportOnlyNewLinks();

	/**
	 * @see com.plumtree.portalpages.admin.editors.crawler.CrawlerModel#GetSupportMirroring()
	 *
	 */
	public boolean GetSupportMirroring();

	/**
	 * @see com.plumtree.portalpages.admin.editors.crawler.CrawlerModel#GetTaxSettings()
	 *
	 */
	public int GetTaxSettings();
	
	/**
	 * @see com.plumtree.portalpages.admin.editors.crawler.CrawlerModel#GetUnmappedExternalDomains()
	 *
	 */
	public IPTQueryResult GetUnmappedExternalDomains();
	
	/**
	 * @see com.plumtree.portalpages.admin.editors.crawler.CrawlerModel#GetCrawlerTag()
	 *
	 */
	public String GetCrawlerTag();

	/**
	 * @see com.plumtree.portalpages.admin.editors.crawler.CrawlerModel#GetApplyExisting()
	 *
	 */
	public boolean GetApplyExisting();
	
	/**
	 * @see com.plumtree.portalpages.admin.editors.crawler.CrawlerModel#GetSupportsACLImport()
	 *
	 */
	public boolean GetSupportsACLImport();
	
	/**
	 * Get the runtime configuration property bag
     * @return- IXPProperty bag containing the runtime configuration values such
     *          as number of threads used for fetching, number of threads used for
     * 			inexing, etc. 
     */
	public IXPPropertyBag GetRuntimeConfiguration();
	
	
}

