package com.plumtree.portalpages.admin.editors.crawler;


// Framework Imports
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This DP displays the Views for the link settings page.
 *
 * @author Julie Fournier
 */
public class LinkSettingsDP extends EditorDP
{
	/**
	 * Class name for the activity space */
	public static final String STR_MVC_CLASS_NAME = "CrLinkSettings";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return (m_asOwner.GetString(267, "ptmsgs_portaladminmsgs"));
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
	
   /**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader()
	{
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(2468, "ptmsgs_portaladminmsgs"),
			this.m_asOwner);
	}

	/**
	 * Returns the HTML for the General Info page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 *
	 * @return HTMLElement
	 */
	public HTMLElement PageDisplay()

	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
				CrawlerEditorAS.STR_MVC_STORAGE_NAME_LINK_SETTINGS)).Display());

		CrawlerModel myModel = (CrawlerModel) m_asOwner.GetModel(m_asOwner.m_strModelName);
		if (EditorStartControl.EDITOR_START_FLAG_CREATE != myModel.GetEditorType())
		{
			views.AddInnerHTMLElement(EditorView.GetSpacerTable());
				
			views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
					ExistingCardsView.STR_MVC_CLASS_NAME)).Display());
		}
		
		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}
}

