package com.plumtree.portalpages.admin.editors.datasource;


// Framework Imports
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.tips.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 *
 */
public abstract class DSEditorAS extends ObjEditorAS
{
    private static OpenLogger log = OpenLogService.GetLogger(
    		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
    		"com.plumtree.portalpages.admin.editors.datasource.DSEditorAS");
    
	/** The unique identifer for the Web Service SelectPTObject plug in */
	public static final String STR_MVC_STORAGE_NAME_SELECT_PTOBJECT = "PTWebServiceList";

	public static final String strSelectWSModel = "SelectWSModel";

	/** Subspace key for the gateway subspace */
	public static final String WSTREE_SUBSPACE = "WSTreeSubSpace";

	/**
	 */
	public void Init()
	{
		super.Init();

		//	TIPS
		TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);

		if (tm != null)
		{
			try
			{


				int iTitleId = 21;
				int iTipId = 22;
				int iSecondaryTipId = 23;

				tm.SetTipTitle( this.GetString( iTitleId, "ptmsgs_tips") );

				HTMLGenericElement e = new HTMLGenericElement( this.GetString( iTipId, "ptmsgs_tips") );

				tm.SetTip( e );

				String sSecondary = this.GetString( iSecondaryTipId, "ptmsgs_tips");

				if( !("none_do_not_translate".equals( sSecondary )) )
				{

					e = new HTMLGenericElement( sSecondary );

					tm.SetSecondarTip( e );
				}



			}
			catch (Exception ex)
			{
			    log.Error(ex, "Couldn't generate tip.");
			}
		}
		 //	Got the tips model
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor#GetDependenciesViewName()
	 */
	public String GetDependenciesViewName()
	{
		return (DataSourceDependenciesView.STR_MVC_CLASS_NAME);
	}


	/**
	 * Registers all the classes for this Activity Space.
	 */
	public void RegisterCommonDSClasses(IModel _myModel)
	{
		// Register Common Views
		RegisterView(DSURLTypeView.STR_MVC_CLASS_NAME, _myModel);
		RegisterView(DataSourceDependenciesView.STR_MVC_CLASS_NAME, _myModel);

		RegisterModel(DataSourceSelectWebServiceModel.STR_MVC_CLASS_NAME, strSelectWSModel);
		DataSourceSelectWebServiceModel wsModel = (DataSourceSelectWebServiceModel)GetModel(strSelectWSModel);
		RegisterView(DataSourceSelectWebServiceView.STR_MVC_CLASS_NAME,
			wsModel);

//		//Register the model, view and control for the web service list
//		RegisterModel(SelectPTObjectModel.STR_MVC_CLASS_NAME,
//			STR_MVC_STORAGE_NAME_SELECT_PTOBJECT);
//
//		// Get back the Model we just registered because we need it to register the View and the Control
//		IModel mySelectPTObjectModel = GetModel(STR_MVC_STORAGE_NAME_SELECT_PTOBJECT);
//		RegisterView(SelectPTObjectView.STR_MVC_CLASS_NAME,
//			STR_MVC_STORAGE_NAME_SELECT_PTOBJECT, mySelectPTObjectModel);
//		RegisterControl(ExpListControl.STR_MVC_CLASS_NAME,
//			STR_MVC_STORAGE_NAME_SELECT_PTOBJECT, mySelectPTObjectModel);
	}
}

