package com.plumtree.portalpages.admin.editors.datasource;


// Framework Imports
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 *
 */
public abstract class DSMainDP extends EditorDP
{
	/**
	 * Returns HTML for common Datasource Views.
	 *
	 * @return HTMLElement
	 */
	public HTMLElement GetHTMLForCommonView()
	{
		HTMLElementCollection views = new HTMLElementCollection();

		views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
				DSURLTypeView.STR_MVC_CLASS_NAME)).Display());
				
		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		return views;
	}

	
	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return (m_asOwner.GetString(280, "ptmsgs_portaladminmsgs"));
	}
	
	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 *
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		/* JHQ 021104 - bug 28266: we need to display both the html (Display())
		 * and the JavaScript (DisplayJavascript()) for the view.
		 */
		myScripts.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
			DataSourceSelectWebServiceView.STR_MVC_CLASS_NAME)).
			DisplayJavascript());
//		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
//				DSEditorAS.STR_MVC_STORAGE_NAME_SELECT_PTOBJECT)
//			.DisplayJavascript());
//
		return myScripts;
	}

}

