package com.plumtree.portalpages.admin.editors.datasource;


// Framework Imports
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.errordisplay.*;

/**
 * Delete that class if you don't have any repost actions.
 */
public abstract class DSRepostControl extends ObjEditorRepostControl
{
	public static final String STR_MVC_CLASS_NAME = "DSRepostControl";
	
	/** Set the URL type */
	public final static int POSTTOSELF_ACTION_CHANGEURLTYPE   = 10;

	/** Set the WS */	
	public final static int POSTTOSELF_ACTION_WEB_SERVICE_CHOSEN = 11;
	
	/** Remove the WS */	
	public final static int POSTTOSELF_ACTION_WEBSERVICE_REMOVED = 12;


	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Switch between the action modes and call  the associated method for each
	 * action.
	 *
	 * @param _nAction
	 */
	protected void PerformAction(int _nAction)
	{
		super.PerformAction(_nAction);

//		((ExpListControl) m_asOwner.GetControl(DSEditorAS.STR_MVC_STORAGE_NAME_SELECT_PTOBJECT)).PerformRepostAction(_nAction,
//			m_htFormData);

		switch (_nAction)
		{
			case POSTTOSELF_ACTION_WEB_SERVICE_CHOSEN:
				// Save page is called before we get here - it may error that the package is not
				// up-to-date (or that the remote server's not selected). It shouldn't do that.
				UIErrorHandler.ClearErrors(m_asOwner.GetSubSession(), m_asOwner.GetApplication());
				break;
				
				
			case POSTTOSELF_ACTION_WEBSERVICE_REMOVED:
				((DataSourceSelectWebServiceModel) m_asOwner.
					GetModel(DSEditorAS.strSelectWSModel)).ClearWebService();
				break;
		}
	}
}

