package com.plumtree.portalpages.admin.editors.datasource;


// Framework Imports
import com.plumtree.openfoundation.util.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 *
 */
public class DSURLTypeView extends EditorView
{
	public static final String STR_MVC_CLASS_NAME = "DSURLType";

	// HTML Object names.
	public static final String HTMLRADIO_USEGATEWAY = "in_ra_DisplayPage";

	/**
	 * @see com.plumtree.xpshared.infrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new DSURLTypeView();
	}

	/**
	 *
	 * @return
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTableCell myCell;
		HTMLTableRow myRow;
		HTMLInput myInput;

		try
		{
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						285, "ptmsgs_portaladminmsgs")));

			HTMLTable myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("5");
			myTable.SetCellSpacing("0");

			//First Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			//First cell
			myCell = new HTMLTableCell();
			myCell.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
			myCell.SetVAlign("top");
			myRow.AddInnerHTMLElement(myCell);

			myCell.AddInnerHTMLString(m_asOwner.GetString(287,
					"ptmsgs_portaladminmsgs"));

			//Second cell
			myCell = new HTMLTableCell();
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myRow.AddInnerHTMLElement(myCell);

			int intDisplayPage = ((IDSModelRO) m_model).GetURLType();

			myInput = new HTMLInput(HTMLInputTypes.RADIO, HTMLRADIO_USEGATEWAY,
					m_asOwner.GetString(288, "ptmsgs_portaladminmsgs"));
			myInput.SetStyleClass(PTStyleClass.FORM_RADIO);
			myInput.SetValue(XPConvert.ToString(
					PT_URL_TYPES.PT_URL_TYPE_SIMPLE_FIELD_MAPPING));

			if (PT_URL_TYPES.PT_URL_TYPE_SIMPLE_FIELD_MAPPING == intDisplayPage)
			{
				myInput.SetChecked(true);
			}

			myInput.SetOnClick(AFormDP.JAVASCRIPT_SUBMIT_FORM + "(" + DSRepostControl.POSTTOSELF_ACTION_SIMPLEREPOST + ")");

			myCell.AddInnerHTMLElement(myInput);

			myCell.AddInnerHTMLString(m_asOwner.GetString(288,
					"ptmsgs_portaladminmsgs"));
			myCell.AddInnerHTMLElement(new HTMLBr());

			myInput = new HTMLInput(HTMLInputTypes.RADIO, HTMLRADIO_USEGATEWAY,
					m_asOwner.GetString(289, "ptmsgs_portaladminmsgs"));
			myInput.SetStyleClass(PTStyleClass.FORM_RADIO);
			myInput.SetValue(XPConvert.ToString(
					PT_URL_TYPES.PT_URL_TYPE_DATASOURCE_GENERATED));

			if (PT_URL_TYPES.PT_URL_TYPE_DATASOURCE_GENERATED == intDisplayPage)
			{
				myInput.SetChecked(true);
			}

			//myInput.SetOnClick(AFormDP.JAVASCRIPT_SUBMIT_FORM + "(" + DSRepostControl.POSTTOSELF_ACTION_CHANGEURLTYPE + ")");
			myInput.SetOnClick(AFormDP.JAVASCRIPT_SUBMIT_FORM + "(" + DSRepostControl.POSTTOSELF_ACTION_SIMPLEREPOST + ")");


			myCell.AddInnerHTMLElement(myInput);

			myCell.AddInnerHTMLString(m_asOwner.GetString(289,
					"ptmsgs_portaladminmsgs"));
		}
		catch (Exception e)
		{
			throw new XPException(m_asOwner.GetString(286,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}

