package com.plumtree.portalpages.admin.editors.datasource;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.editors.webservice.*;
import com.plumtree.portalpages.common.helpers.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.portaluiinfrastructure.tree.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.uiinfrastructure.tree.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author adolfoc
 *
 */
public class DataSourceSelectWebServiceView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.datasource.DataSourceSelectWebServiceView");

	public static final String STR_MVC_CLASS_NAME = "DataSourceSelectWebServiceView";


	/**
	 * Private String that is the function name for the repost javascript called
	 * when the tree control returns
	 */
	private static final String JSREPOST_WEBSERVICE_FUNC	   = "frmRepostWebServiceChosen";
	private static final String JSREPOST_WEBSERVICE_FUNC_INPUT = "frmSetDataWebServiceChosen";
	private static final String JSREPOST_WEBSERVICEREMOVE_FUNC = "frmRepostRemoteViewRemoved";


	// HTML Object names.
	public static final String HTMLHIDDEN_WEBSERVICE_SPACE    = "in_hi_WebServiceSpace";
	public static final String HTMLHIDDEN_WEBSERVICE_SELECTED = "in_hi_WebServiceSelected";
	public static final String HTMLBUTTON_WEBSERVICE_REMOVE = "in_bu_RemoveRemoteServer";


	static Spacer spacer15 = new Spacer("15");

	/**
	 * Our parent Activity space.
	 */
	private AActivitySpace m_asasParent;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new DataSourceSelectWebServiceView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTable myTable;
		HTMLTableCell myCell;
		HTMLTableRow myRow;

		try
		{
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						595, "ptmsgs_portaladminmsgs")));

			// Containing Table
			myTable = WSViewHelper.AddTable(result);

			IDataSourceSelectWebServiceModelRO mModel = (IDataSourceSelectWebServiceModelRO) super.m_model;

			////// Don't forget to HTMLEncode this stuff..... Important!
			String strWebServiceName = mModel.GetWebServiceName();
			boolean bValidWebService = true;
			
			String strRemoteServerPath = ((IDataSourceSelectWebServiceModelRO) m_model).GetWebServicePath();
			String strRemoteServerLabel;

			if (null == strRemoteServerPath)
			{
				strRemoteServerPath = "";
				strRemoteServerLabel = "";
			}
			else
			{
				strRemoteServerLabel = m_asOwner.GetString(599, "ptmsgs_portaladminmsgs");
			}


			// 1st row begins (Top Margin)
			myRow     = WSViewHelper.AddEmptyRow(myTable, CommonHTMLStrings.FIVE);

			// 1st row ends
			// 2nd Row - Path info.
			myRow = WSViewHelper.AddRow(myTable);

			//// Left Margin
			WSViewHelper.AddLeftMargin(myRow, 5);
			
			// Label
			myCell = WSViewHelper.AddLabelCell(myRow, CommonHTMLStrings.ONE,
				m_asOwner.GetString(600, "ptmsgs_portaladminmsgs"));

			
			// Name and button
			

			// Existing Web Service Name
			if ((null == strWebServiceName) ||
					(0 >= strWebServiceName.length()))
			{
				strWebServiceName = m_asOwner.GetString(597,
						"ptmsgs_portaladminmsgs");
				bValidWebService	    = false;
				myCell = WSViewHelper.AddSubLabelCell(myRow, CommonHTMLStrings.ONE, strWebServiceName);
			} 
			else if(("").equals(strRemoteServerPath))
			{
				myCell = WSViewHelper.AddSubLabelCell(myRow, CommonHTMLStrings.ONE, strWebServiceName);
			}
			else {
				// add web service opener link
				HTMLAnchor wsLink = (HTMLAnchor)WSViewHelper.MakeEditObjectLink(PT_CLASSIDS.PT_WEBSERVICE_ID, mModel.GetWebServiceID(), strWebServiceName, m_asOwner);
				myCell = WSViewHelper.AddCell(myRow, CommonHTMLStrings.ONE);
				HTMLSpan wsOpenerSpan = WSViewHelper.AddSpanToCell(myCell);
				wsOpenerSpan.AddInnerHTMLElement(wsLink);		
			}
			
			
			/* JHQ 021104 - bug 28266: Begin code that will set up the 
			 * browse button which will open the Tree Control popup listing
			 * avialable web services
			 */
			if(((IDataSourceSelectWebServiceModelRO) m_model).IsWebServiceChangeable())
			{
				HTMLSpan wsBrowserSpan = WSViewHelper.AddSpanToCell(myCell);
				wsBrowserSpan.AddInnerHTMLString(SPACE);
				
				////// Actual Tree Control
				// Hidden input for the Space ID for the tree.  That way if you hit the folder
				// tree link twice, it will open the same tree both times.
				String strWebServiceSpaceID = ((IDataSourceSelectWebServiceModelRO) m_model).GetData(HTMLHIDDEN_WEBSERVICE_SPACE);
	
				if (strWebServiceSpaceID.equals(DataSourceSelectWebServiceModel.DEFAULTDATA))
				{
					strWebServiceSpaceID = "";
				}
				myCell.AddInnerHTMLElement(WSViewHelper.MakeHiddenInput(HTMLHIDDEN_WEBSERVICE_SPACE, strWebServiceSpaceID));
				myCell.AddInnerHTMLElement(WSViewHelper.MakeHiddenInput(HTMLHIDDEN_WEBSERVICE_SELECTED, ((IDataSourceSelectWebServiceModelRO) m_model).GetData(HTMLHIDDEN_WEBSERVICE_SELECTED)));
	
				String strOnClick	    = JSREPOST_WEBSERVICE_FUNC_INPUT +
					"(document." + AFormDP.HTMLFORM_NAME + "." +
					HTMLHIDDEN_WEBSERVICE_SPACE + "); return false;";
				String strOnClickRemove = JSREPOST_WEBSERVICEREMOVE_FUNC +
					"(document." + AFormDP.HTMLFORM_NAME + "." +
					HTMLHIDDEN_WEBSERVICE_SPACE + "); return false;";
	
				wsBrowserSpan.AddInnerHTMLString(SPACE);
				wsBrowserSpan.AddInnerHTMLElement(WSViewHelper.MakeSimpleButton(
						m_asOwner.GetString(598, "ptmsgs_portaladminmsgs"),
						strOnClick));

				// Add a remove button if the remote server is non-null.
				if(((IDataSourceSelectWebServiceModelRO) m_model).IsWebServiceRemovable())
				{
					if (bValidWebService)
					{
						wsBrowserSpan.AddInnerHTMLString(SPACE);
	
						wsBrowserSpan.AddInnerHTMLElement(WSViewHelper.MakeSimpleButton(
								m_asOwner.GetString(1141, "ptmsgs_portaladminmsgs"),
								strOnClickRemove, HTMLBUTTON_WEBSERVICE_REMOVE));
					}
				}
	
				wsBrowserSpan.AddInnerHTMLElement(WSViewHelper.MakeHiddenInput(
					HTMLHIDDEN_WEBSERVICE_SELECTED, 
					((IDataSourceSelectWebServiceModelRO) m_model).
						GetData(HTMLHIDDEN_WEBSERVICE_SELECTED)));  
	
				/* JHQ 021104 - bug 28266: End Tree Control code */
			}

			//// Right Margin
			WSViewHelper.AddRightMargin(myRow, 5);

			// 2nd row ends			
			// 3rd Row - Path info.
			myRow = WSViewHelper.AddRow(myTable);

			//// Left Margin
			WSViewHelper.AddLeftMargin(myRow, 5);

			// Actual Path

			//// Label "Remote Server Path"
			WSViewHelper.AddLabelCell(myRow, CommonHTMLStrings.ONE, strRemoteServerLabel);

			WSViewHelper.AddSubLabelCell(myRow, CommonHTMLStrings.ONE, strRemoteServerPath);

			//// Right Margin
			WSViewHelper.AddRightMargin(myRow, 5);

			// Bottom Margin

			WSViewHelper.AddEmptyRow(myTable, CommonHTMLStrings.FIVE);
			
			spacer15.display(result);
		}
		catch (Exception e)
		{
			
				log.Error(e, "DataSourceSelectWebServiceView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(596,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * This method returns the HTMLScript that encompasses the Javascript on the page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 *
	 * @return HTMLScript
	 */
	public HTMLScript DisplayJavascript()
	{
		String strFormName = AFormDP.HTMLFORM_NAME;

		// The URL to open a new folder tree
		ASURL newTree = new ASURL(m_asOwner);
		newTree.SetLinkCreateNewSpace(TreeAS.STR_MVC_CLASS_NAME, m_asasParent);
		newTree.SetSubSpaceKey(DSEditorAS.WSTREE_SUBSPACE);
		newTree.SetControl(StartTreeControl.STR_MVC_CLASS_NAME);
		newTree.AddControlArgument(StartTreeControl.ROOT_ID, "1");
		newTree.AddControlArgument(StartTreeControl.MULTI_SELECT, XPConvert.ToString(false));
		newTree.AddControlArgument(StartTreeControl.SELECT_MODE,
			XPConvert.ToString(TreeConstants.N_LEAFSELECT));
		newTree.AddControlArgument(StartTreeControl.SUBMIT_MODE,
			XPConvert.ToString(TreeConstants.N_SERVERSUBMIT));
		newTree.AddControlArgument(StartTreeControl.PARENT_FORM_NAME,
			strFormName);
		newTree.AddControlArgument(StartTreeControl.PARENT_FORM_SPACE_ID,
			HTMLHIDDEN_WEBSERVICE_SPACE);
		newTree.AddControlArgument(StartTreeControl.PARENT_SUBMIT_CALL,
			JSREPOST_WEBSERVICE_FUNC);
		newTree.AddControlArgument(StartTreeControl.CLASS_IDS_TO_DISPLAY,
			XPConvert.ToString(PT_CLASSIDS.PT_WEBSERVICE_ID));
//		newTree.AddControlArgument(StartTreeControl.QUERY_FILTER,
//			XPConvert.ToString(PT_CLASSIDS.PT_WEBSERVICE_ID) + "," +
//			XPConvert.ToString(PT_PROPIDS.PT_PROPID_WEBSERVICE_PROVIDERCLSID) +
//			"," + XPConvert.ToString(WSModelHelper.WSTYPE_IGP) + "," +
//			XPConvert.ToString(WSModelHelper.WSTYPE_HTTPGP));
		newTree.AddControlArgument(StartTreeControl.ACTIONSUBTITLE,
			m_asOwner.GetString(2484, "ptmsgs_portaladminmsgs"));
		newTree.AddControlArgument(StartTreeControl.TITLE,
			m_asOwner.GetString(2484, "ptmsgs_portaladminmsgs"));

		// The url to open a previously opened folder tree
		// This needs to have the SpaceID added to it.
		ASURL oldTree = new ASURL(m_asOwner);
		oldTree.SetLinkCreateNewSpace(TreeAS.STR_MVC_CLASS_NAME, m_asasParent);
		oldTree.IsSubSpace();

		HTMLScript result  = new HTMLScript("text/javaScript");
		XPStringBuilder sb;

		try
		{
			// Test Server Side From Submit function
			sb = new XPStringBuilder(100);
			sb.Append("function ").Append(JSREPOST_WEBSERVICE_FUNC).Append("()\n");
			sb.Append("{\n");
			sb.Append("  postToSelf(")
			.Append(DSRepostControl.POSTTOSELF_ACTION_WEB_SERVICE_CHOSEN)
			.Append(");\n");
			sb.Append("}\n");
			result.AddInnerHTMLString(sb.ToString());

			// remove Submit function
			sb = new XPStringBuilder(100);
			sb.Append("function ").Append(JSREPOST_WEBSERVICEREMOVE_FUNC)
			.Append("()\n");
			sb.Append("{\n");
			sb.Append("  postToSelf(")
			.Append(DSRepostControl.POSTTOSELF_ACTION_WEBSERVICE_REMOVED)
			.Append(");\n");
			sb.Append("}\n");
			result.AddInnerHTMLString(sb.ToString());

			// Open folder tree function
			sb = new XPStringBuilder(200);
			sb.Append("function ").Append(JSREPOST_WEBSERVICE_FUNC_INPUT)
			.Append("(myInput)\n");
			sb.Append("{\n");
			sb.Append("  if (myInput.value == '') {\n");

			sb.Append("    window.open('").Append(newTree.GetURLAsString())
			.Append			
			("', '_blank1', '")
			.Append(TreeConstants.GetJavascriptTreeWindowAttributes()).Append("');\n");
			sb.Append("  } else {\n");
			sb.Append("    window.open('").Append(oldTree.GetURLAsString())
			.Append("&").Append(ASConstants.SPACEID).Append("=' + myInput.value")
			.Append(", '_blank1', '")
			.Append(TreeConstants.GetJavascriptTreeWindowAttributes()).Append("');\n");
			sb.Append("  }\n");
			sb.Append("}\n");
			result.AddInnerHTMLString(sb.ToString());
		}
		catch (HTMLException he)
		{
			
				log.Error(he, "DisplayJavascript couldn't add javascript to the HTMLScript element: " +
					he.getMessage());
			
		}

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		super.Init(model, parent);
		m_asasParent = parent;
	}
	
}

