/**
 * Created on Dec 30, 2002
 * by adolfoc
 */
package com.plumtree.portalpages.admin.editors.datasource;


/**
 * @author adolfoc
 *
 */
public interface IDataSourceSelectWebServiceModelRO
{
	/**
	 * @see com.plumtree.portalpagessample.form.ISampleFormModelRO#GetData(String)
	 */
	public String GetData(String name);

	/**
	 * Returns the name of the web service
	 *
	 * @return String
	 */
	public String GetWebServiceName();

	/**
	 * Returns the Plumtree Path to the web service
	 *
	 * @return String
	 */
	public String GetWebServicePath();

	/**
	 * Returns the object ID of the web service
	 *
	 * @return int
	 */
	public int GetWebServiceID();

	/**
	 * Returns whether or not the WebService should be changeable in the view.
	 *
	 * @return boolean
	 */
	public boolean IsWebServiceChangeable();
	
	/**
	 * Returns whether or not the WebService should be removable in the view.
	 *
	 * @return boolean
	 */
	public boolean IsWebServiceRemovable();
}

