package com.plumtree.portalpages.admin.editors.defaultprofile;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 * File: EditDefaultProfileAS.java
 * -------------------------------
 *
 * @author NaveenP
 */
public class EditDefaultProfileAS extends PlumtreeAS
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.defaultprofile.EditDefaultProfileAS");

	public static final String STR_MVC_CLASS_NAME = "EditDefaultProfile";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new EditDefaultProfileAS();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	public String GetRepostControlName()
	{
		return EditDefaultProfileRepostControl.STR_MVC_CLASS_NAME;
	}

	/**
	 * Registers all the classes of the Property Activity Space.
	 *
	 */
	public void Init()
	{
		super.Init();

		// Display Pages
		RegisterPage(new EditDefaultProfileDP());
		RegisterPage(new EditDefaultProfileTopDP());
		RegisterPage(new ClosePopUpDP());

		// Models
		RegisterModel(EditDefaultProfileModel.STR_MVC_CLASS_NAME);

		EditDefaultProfileModel myModel = (EditDefaultProfileModel) GetModel(EditDefaultProfileModel.STR_MVC_CLASS_NAME);

		// Views
		RegisterView(EditDefaultProfileTopView.STR_MVC_CLASS_NAME, myModel);

		// Controls
		RegisterControl(SetEditDefaultProfileControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(EditDefaultProfileRepostControl.STR_MVC_CLASS_NAME,
			myModel);
/*
		//	TIPS
		// We need to explicitly register the Tips Model, View, and Control
		// because PlumtreeAS doesn't do it for us.  Only EditorAS does it for
		// us.  This is commented out because the current display page has no
		// support for Tips.  We need to be able to view the tips before there
		// is any point in registering the model.
//		RegisterModel(TipsModel.STR_MVC_CLASS_NAME);

//		TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);

//		RegisterView(TipsView.STR_MVC_CLASS_NAME, tm);
//		RegisterControl(TipsControl.STR_MVC_CLASS_NAME, tm);

		// Use GetModelExists rather than GetModel, because GetModel throws
		// an exception if the model is not found.
		if (GetModelExists(TipsModel.STR_MVC_CLASS_NAME))
		{
			TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);

			try
			{


				int iTitleId = 24;
				int iTipId = 25;
				int iSecondaryTipId = 26;

				tm.SetTipTitle( this.GetString( iTitleId, "ptmsgs_tips") );

				HTMLGenericElement e = new HTMLGenericElement( this.GetString( iTipId, "ptmsgs_tips") );

				tm.SetTip( e );

				String sSecondary = this.GetString( iSecondaryTipId, "ptmsgs_tips");

				if( !("none_do_not_translate".equals( sSecondary )) )
				{

					e = new HTMLGenericElement( sSecondary );

					tm.SetSecondarTip( e );
				}


			}
			catch (Exception ex)
			{
				
					log.Error(ex, "Couldn't generate tip.");
				
			}
		}
		 //	Got the tips model
*/
	}
}

