package com.plumtree.portalpages.admin.editors.defaultprofile;

import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.common.*;

/**
 * File: EditDefaultProfileDP.java
 * -------------------------------
 *
 * @author NaveenP
 */
public class EditDefaultProfileDP extends FrameSetDP
{
	public static final String STR_MVC_CLASS_NAME = "EditDefaultProfile";

	/**
	 * @see com.plumtree.xpshared.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Set Frame Scroll Body
	 *
	 * @return boolean true implies scrolling
	 */
	public boolean GetFrameScrollBody()
	{
		return true;
	}

	/**
	 * Set FrameSet Attributes
	 *
	 * @return String
	 */
	public String GetFrameSetAttributes()
	{
		return "60px,50%";
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.dialogheader.FrameSetDialog#GetFrameSetTitle()
	 */
	public String GetFrameSetTitle()
	{
		return m_asOwner.GetString(328, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.dialogheader.FrameSetDialog#GetFrameURLBody()
	 */
	public ASURL GetFrameURLBody()
	{
		EditDefaultProfileModel asModel = (EditDefaultProfileModel) m_asOwner.GetModel(EditDefaultProfileModel.STR_MVC_CLASS_NAME);

		return asModel.GetDefaultURL();
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.dialogheader.FrameSetDialog#GetFrameURLTop()
	 */
	public ASURL GetFrameURLTop()
	{
		ASURL url = new ASURL(m_asOwner);

		url.SetLinkGetCachedSpace(m_asOwner);
		url.SetDisplayPage(EditDefaultProfileTopDP.STR_MVC_CLASS_NAME);

		return url;
	}
}

