package com.plumtree.portalpages.admin.editors.defaultprofile;

import com.plumtree.openfoundation.web.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 * File: EditDefaultProfileRepostControl.java
 * ------------------------------------------
 *
 * @author NaveenP
 */
public class EditDefaultProfileRepostControl extends RepostControl
	implements ILoginControl, IHTTPControl
{
	public static final String STR_MVC_CLASS_NAME = "EditDefaultProfile";

	/** Activity Space */
	private AActivitySpace m_asOwner;

	/** Model */
	private EditDefaultProfileModel m_asModel;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new EditDefaultProfileRepostControl();
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.ILoginControl#DoGetSession()
	 */
	public boolean DoGetSession()
	{
		// The interpreter should ask us for the session.
		return true;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IControl#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 *
	 * @see com.plumtree.portaluiinfrastructure.activityspace.ILoginControl#GetSession()
	 */
	public Object GetSession()
	{
		return m_asModel.GetSession();
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IControl#Init(IModel,
	 *      AActivitySpace)
	 */
	public void Init(IModel model, AActivitySpace space)
	{
		super.Init(model, space);

		m_asModel     = (EditDefaultProfileModel) model;
		m_asOwner     = space;
	}

	/**
	 *
	 * @see com.plumtree.portaluiinfrastructure.activityspace.ILoginControl#SetRedirectForUseAfterLogin(Redirect)
	 */
	public void SetRedirectForUseAfterLogin(Redirect r)
	{
	}

	/**
	 * 
	 *
	 * @param r 
	 * @param webdata
	 */
	public void SetHTTPItems(IXPRequest request, IWebData webdata)
	{
		m_asModel.SetHTTPItems(request, webdata);
	}

	/**
	 *
	 * @see com.plumtree.uiinfrastructure.form.RepostControl#PerformAction(int)
	 */
	protected void PerformAction(int _nAction)
	{
		int nAction;
		if(_nAction == POSTTOSELF_ACTION_UNDEFINED) {
			// need to check for undefined here because switching between 508
			// and standard returns undefined.
			nAction = POSTTOSELF_ACTION_FINISH;
		} else {
			nAction = _nAction;
		}

		super.PerformAction(nAction);
	}
}

