package com.plumtree.portalpages.admin.editors.doctype;


// Framework Imports
import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.editor.commonpages.localizednames.*;
import com.plumtree.portaluiinfrastructure.editor.commonpages.migrationhistory.*;
import com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.*;
import com.plumtree.portaluiinfrastructure.ptmulticolumnlist.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.tips.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 *
 */
public class DocTypeEditorAS extends ObjEditorAS
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.doctype.DocTypeEditorAS");

	/** The unique identifying name for this activity space */
	public static final String STR_MVC_CLASS_NAME = "DocTypeEditor";

	
	/** The unique identifying name for the multi-column list plug-in */
	public static final String STR_MVC_STORAGE_NAME_PLUG_IN = "DocTypeMultiColList";
	private static final String sClassName = "com.plumtree.portalpages.admin.editors.doctype.DocTypeEditorAS";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new DocTypeEditorAS();
	}

	/**
	 * Sets the Editor title.
	 *
	 */
	public String GetEditorTitle()
	{
		if (EditorStartControl.EDITOR_START_FLAG_CREATE == ((EditorModel) GetModel(
					m_strModelName)).GetEditorType())
		{
			return (GetString(290, "ptmsgs_portaladminmsgs"));
		}
		else
		{
			return (XPResourceManager.FormatMessage(GetString(2605, "ptmsgs_portaladminmsgs"), GetObjectName()));
		}
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor#GetDependenciesViewName()
	 */
	public String GetDependenciesViewName()
	{
		return (DocTypeDependenciesView.STR_MVC_CLASS_NAME);
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	
	/**
	 * Returns the class name of the Repost Control.
	 *
	 * @return String
	 */
	public String GetRepostControlName()
	{
		return (DocTypeRepostControl.STR_MVC_CLASS_NAME);
	}

	/**
	 * Registers all the classes for this Activity Space.
	 */
	public void Init()
	{
		m_strModelName = DocTypeModel.STR_MVC_CLASS_NAME;

		super.Init();

		//Get the model
		IModel myModel = GetModel(m_strModelName);

		//Register the PTMulticolumnlist for the property map
		//Register the model, view and control for the property map list
		RegisterModel(PTMultiColumnListModel.STR_MVC_CLASS_NAME,
			STR_MVC_STORAGE_NAME_PLUG_IN);

		// Get back the Model we just registered because we need it to register the Section and the Control
		IModel myMultiColumnListModel = GetModel(STR_MVC_STORAGE_NAME_PLUG_IN);
		RegisterView(PTMultiColumnListView.STR_MVC_CLASS_NAME,
			STR_MVC_STORAGE_NAME_PLUG_IN, myMultiColumnListModel);
		RegisterControl(PTMultiColumnListRepostControl.STR_MVC_CLASS_NAME,
			STR_MVC_STORAGE_NAME_PLUG_IN, myMultiColumnListModel);

		// Register DisplayPages
		RegisterPage(new MainDP());

		// Register Views
		RegisterView(GenInfoView.STR_MVC_CLASS_NAME, myModel);
		RegisterView(DocTypeDependenciesView.STR_MVC_CLASS_NAME, myModel);

		// Register Controls
		RegisterControl(DocTypeRepostControl.STR_MVC_CLASS_NAME, myModel);

		// Default page
		SetCurrentPage(MainDP.STR_MVC_CLASS_NAME);

		//Sets left nav menu
		int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(292,
					"ptmsgs_portaladminmsgs"));
		m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, MainDP.STR_MVC_CLASS_NAME);
		
		int nMenuTwoID = m_mEditorMenu.StartNewSubMenu(GetString(1803, "ptmsgs_portaladminmsgs"));

		//Properties and Names
		m_mEditorMenu.AddLinkToSubMenu(nMenuTwoID, LocNamesDP.STR_MVC_CLASS_NAME);
		//Security
		m_mEditorMenu.AddLinkToSubMenu(nMenuTwoID, ObjectSecurityDP.STR_MVC_CLASS_NAME);
		//Migration History
		m_mEditorMenu.AddLinkToSubMenu(nMenuTwoID, MigrationHistoryPluginDP.STR_MVC_CLASS_NAME);

		//	TIPS
		TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);

		if (tm != null)
		{
			try
			{
				
				tm.SetGeneratingClass( sClassName );


				int iTitleId = 27;
				int iTipId = 28;
				int iSecondaryTipId = 29;
								
				tm.SetTipTitle( this.GetString( iTitleId, "ptmsgs_tips") );

				HTMLGenericElement e = new HTMLGenericElement( this.GetString( iTipId, "ptmsgs_tips") );

				tm.SetTip( e );
				
				String sSecondary = this.GetString( iSecondaryTipId, "ptmsgs_tips");
				
				if( !("none_do_not_translate".equals( sSecondary )) )
				{
									
					e = new HTMLGenericElement( sSecondary );
				
					tm.SetSecondarTip( e );
				}
							

				
			}
			catch (Exception ex)
			{
				
					log.Error(ex, "Couldn't generate tip.");
				
			}
		}
		 //	Got the tips model
	}
	
	/**
	  * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage()
	  *
	  * @param IDisplayPage the current Display Page
	  */

	 public void SetCurrentPage(IDisplayPage page)
	 {
		 
		  super.SetCurrentPage( page );
		  String sPageName = page.GetName();
		  if(MainDP.STR_MVC_CLASS_NAME.equals( sPageName ))
		  {
				this.SetHelpTopic( "PT_DocumentType_MainSettings" );                           
		  }

		  

	 }
}

