package com.plumtree.portalpages.admin.editors.doctypemap;


// Framework Imports
import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.expandablelist.*;

/**
 * This class contains the additional repost actions.
 * The ones specific to the Document Type Map Editor (other than
 * "change page", "finish" and "cancel" actions).
 *
 * @author SudhaS
 */

// ***CHANGE_HERE*** Change the name of the class.
// ***COMMENT_1*** Delete the comments prefixed by CHANGE_HERE and COMMENT
//       when you are done.
public class GbDocTypeRepostControl extends EditorRepostControl
{
	// ***CHANGE_HERE*** Set the class name.
	// ***COMMENT_1*** All the Controls in Plumtree need to have a unique name.


	public static final String STR_MVC_CLASS_NAME = "GbDocTypeMapRepost";

	// ***CHANGE_HERE*** create a new constant for each repost action
	//       you have in the entire Editor.
	// ***COMMENT_1*** The repost action value should not be below 10
	// ***COMMENT_2*** If you are using any plug-in section, you need to make sure
	//       there is no conflict between your actions below and the plug-in actions.


	public final static int POSTTOSELF_ACTION_DTM		 = 10;


	public final static int POSTTOSELF_ACTION_DONE_POPUP = 11;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new GbDocTypeRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Switch between the action modes and call
	 * the associated method for each action.
	 *
	 * @param _nAction
	 */
	protected void PerformAction(int _nAction)
	{
		super.PerformAction(_nAction);

		IDisplayPage currDP = (IDisplayPage) m_asOwner.GetCurrentPage();

		if (!XPStringUtility.EqualsIgnoreCase(currDP.GetName(),"MigrationHistoryPlugin"))
		{
			int nCurrPageID = ((GbDocTypeMainDP) m_asOwner.GetCurrentPage()).GetGbDocTypeID();

			((ExpListControl) m_asOwner.GetControl(GbDocTypeEditorAS.strStorageGbDocTypeList +
				nCurrPageID)).PerformRepostAction(_nAction, m_htFormData);
		}

		//***CHANGE_HERE*** if you don't have any repost action, delete the switch statement.
		switch (_nAction)
		{
		//***CHANGE_HERE*** Create a new case for each of your action.
		case POSTTOSELF_ACTION_DTM:

			//***CHANGE_HERE*** For each action call the associated method in your model.
			((GbDocTypeModel) m_model).ActionOnRepost();

			break;
		}
	}
}

