package com.plumtree.portalpages.admin.editors.doctypemapextension;


// Framework Imports
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author SudhaS
 *
 */
public class GbDocTypeExtDP extends EditorDP
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.doctypemapextension.GbDocTypeExtDP");


	public static final String STR_MVC_CLASS_NAME = "GbDocTypeExtMain";



	public static final String HTMLHIDDEN_POPUP_NAME = "in_hi_PopUpName";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return (m_asOwner.GetString(336, "ptmsgs_portaladminmsgs"));
	}

	/***/
	/**
	 */
	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the General Info page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 *
	 * @return HTMLElement
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
				GbDocTypeExtView.STR_MVC_CLASS_NAME)).Display());

		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
				GbDocTypeExtEditorAS.strStorageGbDocTypeExtList)).Display());

		HTMLInput myInput = new HTMLInput(HTMLInputTypes.HIDDEN,
				HTMLHIDDEN_POPUP_NAME, "");
		result.AddInnerHTMLElement(myInput);

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	* Display the Javascripts for the Views.
	*
	* @return HTMLScriptCollection
	* @throws HTMLException
	*/
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		try
		{
			HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

			// ***CHANGE_HERE SELECTPTOBJECT*** Display JavaScripts for the Select PTObject list.
			//GbDocTypeExtListView temp = (GbDocTypeExtListView) m_asOwner.GetView(GbDocTypeExtEditorAS.strStorageGbDocTypeExtList);
			myScripts.AddInnerHTMLElement(m_asOwner.GetView(GbDocTypeExtEditorAS.strStorageGbDocTypeExtList).DisplayJavascript());

			myScripts.AddInnerHTMLElement(m_asOwner.GetView(GbDocTypeExtView.STR_MVC_CLASS_NAME).DisplayJavascript());

			return myScripts;

			//myScripts.AddInnerHTMLElement(m_asOwner.GetView(GeneralInfoView.STR_MVC_CLASS_NAME).DisplayJavascript());
		}
		catch (Exception e)
		{
			
				log.Error("GbDocTypeExtDP" + e);
			
		}

		return null;
	}
}

