package com.plumtree.portalpages.admin.editors.doctypemapextension;


// Framework Imports
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.expandablelist.*;

/**
 *
 * @author SudhaS
 */

public class GbDocTypeExtEditorAS extends ObjEditorAS
{

	public static final String STR_MVC_CLASS_NAME = "GbDocTypeExtEditor";


	public static final String strStorageGbDocTypeExtList = "GbDocTypeExtListStorage";


	public static final String strStorageGbDocTypePopUp = "GbDocTypePopUpStorage";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new GbDocTypeExtEditorAS();
	}

	/**
	 * Sets the Editor title.
	 * @return
	 */
	public String GetEditorTitle()
	{

		return (GetString(337, "ptmsgs_portaladminmsgs"));

	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}


	/**
	 * Returns the class name of the Repost Control.
	 *
	 * @return String
	 */
	public String GetRepostControlName()
	{
		return (GbDocTypeExtRepostControl.STR_MVC_CLASS_NAME);
	}

	/**
	 * Registers all the classes for this Activity Space.
	 */
	public void Init()
	{
		m_strModelName = GbDocTypeExtModel.STR_MVC_CLASS_NAME;

		super.Init();

		IModel myModel = GetModel(m_strModelName);

		// Register DisplayPages
		//RegisterPage(new MainDP());
		GbDocTypeExtDP mainDP = new GbDocTypeExtDP();
		RegisterPage(mainDP);

		mainDP.AddToValidationFunction("CheckBlankExtension");
		mainDP.AddToValidationFunction("VerifySelect");


		//RegisterPage(new GbDocTypeExtPopUpDP());
		// Register Views
		RegisterView(GbDocTypeExtView.STR_MVC_CLASS_NAME, myModel);

		//RegisterView(GbDocTypeExtPopUpView.STR_MVC_CLASS_NAME, myModel);
		// Register Controls
		RegisterControl(GbDocTypeExtRepostControl.STR_MVC_CLASS_NAME, myModel);

		// Default page
		SetCurrentPage(GbDocTypeExtDP.STR_MVC_CLASS_NAME);

		// Get back the Model we just registered because we need it to register the Section and the Control
		RegisterModel(GbDocTypeExtListModel.STR_MVC_CLASS_NAME,
			strStorageGbDocTypeExtList);

		IModel myGbDocTypeExtListModel = GetModel(strStorageGbDocTypeExtList);

		RegisterView(GbDocTypeExtListView.STR_MVC_CLASS_NAME,
			strStorageGbDocTypeExtList, myGbDocTypeExtListModel);

		RegisterControl(ExpListControl.STR_MVC_CLASS_NAME,
			strStorageGbDocTypeExtList, myGbDocTypeExtListModel);

		//Sets left nav menu
		int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(339,
					"ptmsgs_portaladminmsgs"));
		m_mEditorMenu.AddLinkToSubMenu(nMenuOneID,
			GbDocTypeExtDP.STR_MVC_CLASS_NAME);
	}

	/**
	  * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage()
	  *
	  * @param IDisplayPage the current Display Page
	  */

	 public void SetCurrentPage(IDisplayPage page)
	 {

		  super.SetCurrentPage( page );
		  String sPageName = page.GetName();
		  if(GbDocTypeExtDP.STR_MVC_CLASS_NAME.equals( sPageName ))
		  {
				this.SetHelpTopic( "PT_CreateExtension_MainSettings" );
		  }





	 }
}

