package com.plumtree.portalpages.admin.editors.doctypemapextension;


// Framework Imports
import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 * @author SudhaS
 *
 */
public class GbDocTypeExtView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.doctypemapextension.GbDocTypeExtView");


	public static final String STR_MVC_CLASS_NAME = "GbDocTypeExt";



	public static final String HTMLINPUT_CREATE_EXT = "in_tx_CreateExt";
	private static final String CREATE_EXT_SIZE = "45";


	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new GbDocTypeExtView();
	}

	/**
	 *
	 *
	 * @return
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTableCell myCell;
		HTMLTableRow myRow;
		HTMLInput myInput;

		try
		{
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						348, "ptmsgs_portaladminmsgs")));

			HTMLTable myTable = new HTMLTable();

			result.AddInnerHTMLElement(myTable);
			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("5");
			myTable.SetCellSpacing("0");

			myRow = new HTMLTableRow();
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
			myTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetWidth("15%");
			myRow.AddInnerHTMLElement(myCell);

			myCell.AddInnerHTMLString(m_asOwner.GetString(350,
					"ptmsgs_portaladminmsgs"));
			myCell.SetStyleClass(PTStyleClass.LIST_TEXT);

			myCell = new HTMLTableCell();
			myCell.SetStyleClass(PTStyleClass.LIST_TEXT);

			//myCell.SetColSpan("3");
			myRow.AddInnerHTMLElement(myCell);
			myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_CREATE_EXT,
					"This is an input");
			myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
			myInput.SetValue(((IGbDocTypeExtModelRO) m_model).GetExtName());
			myInput.SetSize(CREATE_EXT_SIZE);
			myCell.AddInnerHTMLElement(myInput);
		}
		catch (Exception e)
		{
			
				log.Error(e, "GbDocTypeExtView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(349,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 *
	 *
	 * @return
	 */
	public HTMLScript DisplayJavascript()
	{
		HTMLScript myScript;

		// ***CHANGE_HERE*** Write all the JavaScripts for that Section bellow.
		// ***COMMENT_1*** Note that you also need to call that method from the
		//       DP (see PropMainDP)
		// ***COMMENT_2*** Put all your JavaScripts bellow (validation or no) they
		//       will be printed out in the header.
		// ***COMMENT_3*** If that Section doesn't have any JavaScripts,
		//      you can delete the entire DisplayJavascript() method.
		// ***COMMENT_4*** If this is a client side validation, you should use
		//      the AddToValidationFunction in your AS class (see PropEditorAS).
		try
		{
			XPStringBuilder sb = new XPStringBuilder(300);
			myScript = new HTMLScript("text/javaScript");

			sb.Append("function CheckBlankExtension()\n");
			sb.Append("{\n");
			sb.Append("  if (document." + EditorDP.HTMLFORM_NAME + "." + HTMLINPUT_CREATE_EXT + ".value.length == 0)\n") ;
			sb.Append("  {\n");

			sb.Append("      alert(\"" + m_asOwner.GetString(1817, "ptmsgs_portaladminmsgs") + "\");\n");
			sb.Append("      return false;\n");
			sb.Append("  }\n");
			sb.Append("  return true;\n");
			sb.Append("}\n");

			myScript.AddInnerHTMLString(sb.ToString());
		}
		catch (Exception e)
		{
			
				log.Error(e, "LoginView::DisplayJavascript The following error occured when trying to display the JavaScript: " +
					e.getMessage());
			

			throw XPException.GetInstance(e);
		}

		return (myScript);
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}

