package com.plumtree.portalpages.admin.editors.externaloperations;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.editors.common.setjob.*;
import com.plumtree.portalpages.common.constants.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.editor.commonpages.localizednames.*;
import com.plumtree.portaluiinfrastructure.editor.commonpages.migrationhistory.*;
import com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.*;
import com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.expandablelist.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.uiinfrastructure.tips.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author OlegS
 */
public class ExternalOperationEditorAS extends ObjEditorAS
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.externaloperations.ExternalOperationEditorAS");


	public static final String STR_MVC_CLASS_NAME = "ExternalOperationEditor";

	private static final String sClassName = "com.plumtree.portalpages.admin.editors.externaloperations.ExternalOperationEditorAS";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new ExternalOperationEditorAS();
	}

	/**
	 *
	 *
	 * @return
	 */
	public String GetEditorTitle()
	{	
		if (EditorStartControl.EDITOR_START_FLAG_CREATE == ((EditorModel) GetModel(
							m_strModelName)).GetEditorType())
		{
			return (GetString(2606, "ptmsgs_portaladminmsgs"));
		}
		else
		{
			return (XPResourceManager.FormatMessage(GetString(2607, "ptmsgs_portaladminmsgs"), GetObjectName()));
		}
	}

	/**
	 *
	 *
	 * @return
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 *
	 *
	 * @return
	 */
	public String GetRepostControlName()
	{
		return (ExternalOperationEditorRepostControl.STR_MVC_CLASS_NAME);
	}

	/**
	 *
	 */
	public void Init()
	{
		m_strModelName = ExternalOperationEditorModel.STR_MVC_CLASS_NAME;
		super.Init();

		RegisterView(ExternalOperationDependenciesView.STR_MVC_CLASS_NAME,
			GetModel(m_strModelName));

		// Register plug-in sections
		RegisterPage(new SetJobDP());

		// Register classes for the set job and for the object owner
		RegisterModel(SetJobModel.STR_MVC_CLASS_NAME);
		RegisterControl(SetJobRepostControl.STR_MVC_CLASS_NAME,
			GetModel(SetJobModel.STR_MVC_CLASS_NAME));
		RegisterView(ObjectOwnerView.STR_MVC_CLASS_NAME,
			GetModel(SetJobModel.STR_MVC_CLASS_NAME));

		// Register classes for Job selector
		RegisterModel(SelectPTObjectModel.STR_MVC_CLASS_NAME,
			SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB);
		RegisterView(SelectPTObjectView.STR_MVC_CLASS_NAME,
			SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB,
			GetModel(SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB));
		RegisterControl(ExpListControl.STR_MVC_CLASS_NAME,
			SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB,
			GetModel(SetJobModel.STR_MVC_STORAGE_NAME_SELECT_JOB));

		// external operation stuff
		IModel myModel = GetModel(ExternalOperationEditorModel.STR_MVC_CLASS_NAME);
		AFormDP mainDP = new ExternalOperationEditorMainDP();
		RegisterPage(mainDP);
		RegisterView(ExternalOperationEditorMainView.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(ExternalOperationEditorRepostControl.STR_MVC_CLASS_NAME,
			myModel);
		SetCurrentPage(ExternalOperationEditorMainDP.STR_MVC_CLASS_NAME);

		// Set left nav menu
		int nMenuOneID=m_mEditorMenu.StartNewSubMenu(GetString(1823, "ptmsgs_portaladminmsgs"));

		m_mEditorMenu.AddLinkToSubMenu(nMenuOneID,
			ExternalOperationEditorMainDP.STR_MVC_CLASS_NAME);

		m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, SetJobDP.STR_MVC_CLASS_NAME);

		// BEGIN Sub menu "Additional Settings"

		int nMenuTwoID = m_mEditorMenu.StartNewSubMenu(GetString(1824, "ptmsgs_portaladminmsgs"));



		//Properties and Names
		m_mEditorMenu.AddLinkToSubMenu(nMenuTwoID, LocNamesDP.STR_MVC_CLASS_NAME);
		//Security
		m_mEditorMenu.AddLinkToSubMenu(nMenuTwoID, ObjectSecurityDP.STR_MVC_CLASS_NAME);
		//Migration History
		m_mEditorMenu.AddLinkToSubMenu(nMenuTwoID, MigrationHistoryPluginDP.STR_MVC_CLASS_NAME);

		// END Sub menu "Additional Settings"

		// for clisent-side validation
		// JHQ ExtOpRedesign: we no longer use the RunAsUser/RunAsUserPassword
//		mainDP.AddToValidationFunction("CheckPassword");



		//	TIPS
		TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);

		if (tm != null)
		{
			try
			{
				tm.SetGeneratingClass( sClassName );


				int iTitleId = 108;
				int iTipId = 109;
				int iSecondaryTipId = 110;

				tm.SetTipTitle( this.GetString( iTitleId, ResourceConstants.TIPS) );

				HTMLGenericElement e = new HTMLGenericElement( this.GetString( iTipId, ResourceConstants.TIPS) );

				tm.SetTip( e );

				String sSecondary = this.GetString( iSecondaryTipId, ResourceConstants.TIPS);

				if( !("none_do_not_translate".equals( sSecondary )) )
				{

					e = new HTMLGenericElement( sSecondary );

					tm.SetSecondarTip( e );
				}



			}
			catch (Exception ex)
			{
				
					log.Error(ex, "Couldn't generate tip.");
				
			}
		}
		 //	Got the tips model




	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor#GetDependenciesViewName()
	 */
	public String GetDependenciesViewName()
	{
		return (ExternalOperationDependenciesView.STR_MVC_CLASS_NAME);
	}

	/**
	* @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage()
	* @param IDisplayPage the current Display Page
	*/
	public void SetCurrentPage(IDisplayPage page)	{
		super.SetCurrentPage(page);
		String sPageName=page.GetName();
		if(SetJobDP.STR_MVC_CLASS_NAME.equals(sPageName))
			SetHelpTopic("PT_SetJob");
		else if(ExternalOperationEditorMainDP.STR_MVC_CLASS_NAME.equals(sPageName))
			SetHelpTopic("PT_ExternalOperation_MainSettings");
	}
}

