package com.plumtree.portalpages.admin.editors.externaloperations;

import com.plumtree.openfoundation.web.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author OlegS
 */
public class ExternalOperationEditorMainDP extends EditorDP
{

	public static final String STR_MVC_CLASS_NAME = "ExternalOperationEditorMain";

	public String GetLeftNavString()
	{
		return m_asOwner.GetString(356, "ptmsgs_portaladminmsgs");
	}

	/**
	 *
	 *
	 * @return
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 *
	 *
	 * @return
	 *
	 * @throws HTMLException
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();
		views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
				ExternalOperationEditorMainView.STR_MVC_CLASS_NAME)).Display());
		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	 *
	 *
	 * @return
	 *
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();
		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
				ExternalOperationEditorMainView.STR_MVC_CLASS_NAME)
			.DisplayJavascript());

		return myScripts;
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader() {
		String s = m_asOwner.GetString(2684, "ptmsgs_portaladminmsgs");//m_asOwner.GetString(1678, "ptmsgs_portaladminmsgs");
		s = XPHttpUtility.HtmlEncode(s);
		//fixing bug 21946 where {br} tags were not being replaced;  TODO This is really bad style and needs to be cleaned up.  
		//These strings need to be broken up and reformatted. -mgs
		s = GeneralHelpers.Replace(s,"{","<");
		s = GeneralHelpers.Replace(s,"}",">"); // there are {br} in the string which we want as <br>
		return HTMLConstructHelpers.GetSubHeader(
			s,
			this.m_asOwner);
	}
}

