package com.plumtree.portalpages.admin.editors.externaloperations;

import com.plumtree.uiinfrastructure.editor.*;

/**
 * JHQ 050604: External Operations have been re-architected to run script files instead of 
 * commands from the command line.  These scripts must reside in the automation server's
 * portal_home/scripts directory.  This directory can be secured as necessary.  Therefore,
 * we no longer use the RunAsUser/RunAsUserPassword.  Corresponding methods will be 
 * deprecated and should not be implemented.
 * @author OlegS
 */
public interface IExternalOperationEditorModelRO extends IEditorModelRO
{
	/**
	 *
	 *
	 * @return
	 */
	public String GetCommandLine();

	/**
	 *
	 *
	 * @return
	 * 
	 * @deprecated This method should not be implemented.
	 */
	public String GetPasswordToDisplay();

	/**
	 *
	 *
	 * @return
	 */
	public int GetTimeout();

	/**
	 *
	 *
	 * @return
	 * 
	 * @deprecated This method should not be implemented.
	 */
	public String GetUser();
}

