package com.plumtree.portalpages.admin.editors.filter;


// Framework Imports
import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.editor.commonpages.localizednames.*;
import com.plumtree.portaluiinfrastructure.editor.commonpages.migrationhistory.*;
import com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.tips.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author MikeS
 *
 */
public class FilterEditorAS extends ObjEditorAS
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.filter.FilterEditorAS");

	public static final String STR_MVC_CLASS_NAME = "FilterEditor";

	/**
	  * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	  */
	public Object Create()
	{
		return new FilterEditorAS();
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor#GetDependenciesViewName()
	 *
	 */
	public String GetDependenciesViewName()
	{
		return (FilterDependenciesView.STR_MVC_CLASS_NAME);
	}

	/**
	 * Sets the Editor title.
	 *
	 */
	public String GetEditorTitle()
	{
		if (EditorStartControl.EDITOR_START_FLAG_CREATE == ((EditorModel) GetModel(
					m_strModelName)).GetEditorType())
		{
			return (GetString(368, "ptmsgs_portaladminmsgs"));
		}
		else
		{
			return (XPResourceManager.FormatMessage(GetString(2608, "ptmsgs_portaladminmsgs"), GetObjectName()));
		}
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the class name of the Repost Control.
	 *
	 * @return String
	 */
	public String GetRepostControlName()
	{
		return (FilterRepostControl.STR_MVC_CLASS_NAME);
	}

	/**
	 * Registers all the classes for this Activity Space.
	 */
	public void Init()
	{
		m_strModelName = FilterModel.STR_MVC_CLASS_NAME;

		super.Init();

		IModel myModel = GetModel(m_strModelName);

		RegisterView(FilterDependenciesView.STR_MVC_CLASS_NAME, myModel);

		// Register DisplayPages
		RegisterPage(new MainDP());

		// Register Views
		RegisterView(SettingsView.STR_MVC_CLASS_NAME, myModel);
		
		RegisterView(TestFilterView.STR_MVC_CLASS_NAME, myModel);
		
		// Register Controls
		RegisterControl(FilterRepostControl.STR_MVC_CLASS_NAME, myModel);

		// Default page
		SetCurrentPage(MainDP.STR_MVC_CLASS_NAME);

		//Sets left nav menu
		int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(370,
					"ptmsgs_portaladminmsgs"));

		m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, MainDP.STR_MVC_CLASS_NAME);


		// BEGIN Sub menu "Standard Settings"
		int nMenuTwoID = m_mEditorMenu.StartNewSubMenu(GetString(1828, "ptmsgs_portaladminmsgs"));

		//Properties and Names
		m_mEditorMenu.AddLinkToSubMenu(nMenuTwoID, LocNamesDP.STR_MVC_CLASS_NAME);
		//Security
		m_mEditorMenu.AddLinkToSubMenu(nMenuTwoID, ObjectSecurityDP.STR_MVC_CLASS_NAME);
		//Migration History
		m_mEditorMenu.AddLinkToSubMenu(nMenuTwoID, MigrationHistoryPluginDP.STR_MVC_CLASS_NAME);

		// END Sub menu "Standard Settings"

		//	TIPS
		TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);

		if (tm != null)
		{
			try
			{


				int iTitleId = 33;
				int iTipId = 34;
				int iSecondaryTipId = 35;

				tm.SetTipTitle( this.GetString( iTitleId, "ptmsgs_tips") );

				HTMLGenericElement e = new HTMLGenericElement( this.GetString( iTipId, "ptmsgs_tips") );

				tm.SetTip( e );

				String sSecondary = this.GetString( iSecondaryTipId, "ptmsgs_tips");

				if( !("none_do_not_translate".equals( sSecondary )) )
				{

					e = new HTMLGenericElement( sSecondary );

					tm.SetSecondarTip( e );
				}



			}
			catch (Exception ex)
			{
				
					log.Error(ex, "Couldn't generate tip.");
				
			}
		}
		 //	Got the tips model
	}

  /**
   * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage()
   *
   * @param IDisplayPage the current Display Page
   */
  public void SetCurrentPage(IDisplayPage page) {

    super.SetCurrentPage( page );

    String sPageName = page.GetName();

    if (MainDP.STR_MVC_CLASS_NAME.equals(sPageName)) {
      this.SetHelpTopic( "PT_Filter_MainSettings" );
    }
  }
}

