package com.plumtree.portalpages.admin.editors.filter;


// Framework Imports
import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.search.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author MikeS
 *
 */
public class SettingsView extends FilterView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.filter.SettingsView");


	public static final String STR_MVC_CLASS_NAME = "FilSettings";
	
	public static final String TEST_FILTER_FXN_NAME = "testFilter";


	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SettingsView();
	}

	public boolean QueryContainsValidationProblemsOnRender()
	{
		HTMLElement throwaway = Display();
		throwaway.ClearInnerHTMLElements();
		return super.QueryContainsValidationProblemsOnRender();
	}
	
	public SettingsView()
	{
		super();
		SetAddTestButton();
		DoSetTestButtonScript();	
	}
	
	public HTMLElement Display()
	{	

		try
		{
			SetStatementCount(5);

			super.SetViewTitle(m_asOwner.GetString(378, "ptmsgs_portaladminmsgs"));

			return super.Display();
		}
		catch (Exception e)
		{
			
				log.Error(e, "SettingsView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(379,
					"ptmsgs_portaladminmsgs"), e);
		}
	}

	/**
	 *
	 *
	 * @return
	 */
	public HTMLScript DisplayJavascript()
	{
		super.SetRepostAction(FilterRepostControl.POSTTOSELF_ACTION_SIMPLEREPOST);

		return super.DisplayJavascript();
	}

	/**
	 *
	 *
	 * @return
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
	
	protected void DoSetTestButtonScript()
	{
		SetTestButtonOnClickScript(TEST_FILTER_FXN_NAME + "();");
		String val = "function " + TEST_FILTER_FXN_NAME + "() {\n";
		val += "    postToSelf(" + FilterRepostControl.POSTTOSELF_ACTION_TEST_FILTER + ");\n";
		val += "}\n";
		SetTestButtonScript(val);
	}
}

