package com.plumtree.portalpages.admin.editors.filter;


// Framework Imports
import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.search.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author MatthewF
 *
 */
public class TestFilterView implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.filter.TestFilterView");


	public static final String STR_MVC_CLASS_NAME = "TestFilterView";

	private FilterModel _model;
	private AActivitySpace m_asOwner;
	
	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new TestFilterView();
	}

	
	public HTMLElement Display()
	{
		try
		{
			HTMLElementCollection result = new HTMLElementCollection();

			FilterModel.FilterReport report = _model.GetTestFilterReport();
			if(report == null)
			{
				return result;

			}
			// Don't leave report generation on.
			_model.TurnOffFilterReport(); 
			
			HTMLTable table = new HTMLTable();
			result.AddInnerHTMLElement(table);
			
			table.SetWidth("100%");
			table.SetCellSpacing("0");
			table.SetCellPadding("0");
			table.SetBorder("0");
			HTMLTableRow row = new HTMLTableRow();
			table.AddInnerHTMLElement(row);
			row.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);
			HTMLTableCell cell = new HTMLTableCell();
			row.AddInnerHTMLElement(cell);
			cell.SetWidth("100%");
			cell.SetHeight("20");
			cell.SetVAlign("middle");
			cell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			HTMLSpan span = new HTMLSpan();
			cell.AddInnerHTMLElement(span);
			span.AddInnerHTMLString(m_asOwner.GetString(2667, "ptmsgs_portaladminmsgs"));
			span.SetStyleClass(PTStyleClass.OBJECT_HEADER);
			
			row = new HTMLTableRow();
			row.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
			table.AddInnerHTMLElement(row);
			cell = new HTMLTableCell();
			cell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			row.AddInnerHTMLElement(cell);
			String report_summary;
			if(! report.threwException)
			{
				report_summary = XPResourceManager.FormatMessage(m_asOwner.GetString(2601, "ptmsgs_portaladminmsgs"),XPConvert.ToString(report.numResults));
				if(report.numResults == 0)
					report_summary += m_asOwner.GetString(2602, "ptmsgs_portaladminmsgs");
				cell.AddInnerHTMLString(report_summary);
			}
			else
			{
				report_summary = m_asOwner.GetString(2603, "ptmsgs_portaladminmsgs");
				cell.AddInnerHTMLString(report_summary);
				HTMLB b = new HTMLB();
				b.AddInnerHTMLString(report.exceptionMessage);
				cell.AddInnerHTMLElement(b);
			}
				
			result.AddInnerHTMLElement(SearchUIUtility.makeSpacer(m_asOwner,"10"));
			
			return result;

		}
		catch (Exception e)
		{
			
				log.Error(e, "TestFilterView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			
		}
		return null;
	}

	/**
	 *
	 *
	 * @return
	 */
	public HTMLScript DisplayJavascript()
	{
		return null;
	}

	public void Init(IModelRO model, AActivitySpace space)
	{
		_model = (FilterModel)model;
		m_asOwner = space;
	}
	/**
	 *
	 *
	 * @return
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}

