package com.plumtree.portalpages.admin.editors.group;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;

import com.plumtree.portalpages.common.search.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This View is a hack of the SavSrchSettingView by MikeS.
 * 
 * @author AkashJ
 */
public class DynamicRulesView extends FilterView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.group.DynamicRulesView");

	/** The unique identifier for the class */
	public static final String STR_MVC_CLASS_NAME = "DynamicRules";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new DynamicRulesView();
	}

	/**
	 * Display for the HTML for this view
	 *
	 * @return HTMLElement
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		try
		{
			// aj: we need to suppress the search box, so tell FilterView (our parent) not
			//     to show it...
			super.SetShowSearchBox(false);
			super.SetViewTitle(m_asOwner.GetString(2713, "ptmsgs_portaladminmsgs"));
			result.AddInnerHTMLElement(super.Display());
		}
		catch (Exception e)
		{
			
				log.Error(e, "DynamicRulesView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(779,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}
	
	public HTMLScript DisplayJavascript()
	{
		HTMLScript script = null;

		try
		{
			super.SetRepostAction(GroupRepostControl.POSTTOSELF_ACTION_SIMPLEREPOST);
			script = super.DisplayJavascript();
		}
		catch (Exception e)
		{
			
				log.Error(e, "DynamicRulesView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(779,
					"ptmsgs_portaladminmsgs"), e);
		}

		return script;
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}


	/**
	 * Returns the read-only model
	 *
	 * @return IGroupModelRO
	 */
	protected IGroupModelRO GetModel()
	{
		return (IGroupModelRO) m_model;
	}

}

