package com.plumtree.portalpages.admin.editors.group;

// Framework Imports
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 *
 */
public class GroupActivityRightsDP extends EditorDP {
	/** Class Name */
	public static final String STR_MVC_CLASS_NAME = "GroupActivityRightsDP";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString() {
		return m_asOwner.GetString(397, "ptmsgs_portaladminmsgs");
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader()
	{
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(1664, "ptmsgs_portaladminmsgs"),
			this.m_asOwner);
	}

	
	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the General Info page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 *
	 * @return HTMLElement
	 */
	public HTMLElement PageDisplay() {
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		// Display Plug-In: Rights SelectList
		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(GroupEditorAS.strStorageSelectActivityRights))
				.Display());

		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		// Display Plug-In: Inherited Rights SelectList
		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(GroupEditorAS.strStorageSelectInheritedRights))
				.Display());

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		// Display JavaScripts for the Select List.
		myScripts.AddInnerHTMLElement(
			m_asOwner
				.GetView(GroupEditorAS.strStorageSelectActivityRights)
				.DisplayJavascript());

		return myScripts;
	}
}

