package com.plumtree.portalpages.admin.editors.group;

import com.plumtree.openlog.OpenLogService;
import com.plumtree.openlog.OpenLogger;
import com.plumtree.portalpages.common.constants.*;
import com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel;
import com.plumtree.portaluiinfrastructure.statichelpers.PTDebugHelpers;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.expandablelist.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

public class GroupDynamicMembersPreviewPopupDP extends AFormDP
{
	private static OpenLogger log = OpenLogService.GetLogger(
			OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
			"com.plumtree.portalpages.admin.editors.group.GroupDynamicMembersPreviewPopupDP");
	
	/**
	 * Class name for the activity space
	 */
	public static final String STR_MVC_CLASS_NAME = "GroupDynamicMembersPreviewPopup";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new GroupDynamicMembersPreviewPopupDP();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		super.Init(parent);
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()
	 */
	public String GetFormTitle() {
		return m_asOwner.GetString(3182, ResourceConstants.PORTALADMINMSGS);
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay() {
		// SE: logging
		log.FunctionBegin("GroupDynamicMembersPreviewPopupDP::PageDisplay");
		SelectPTObjectModel myMemberSelectPTObjectModel = (SelectPTObjectModel) this.GetOwner().GetModel(GroupEditorAS.strStorageDynMemberPreviewPopup);
		
		if (null != myMemberSelectPTObjectModel)
		{
			log.Debug("Current number of items in GroupEditorAS.strStorageDynMemberPreviewPopup: " + myMemberSelectPTObjectModel.GetItems().GetCount());
		}
		
		log.Debug("Space name: " + m_asOwner.GetName() + ", Space ID: " + m_asOwner.GetSpaceID() + ", Parent Space Name: " + m_asOwner.GetParentSpaceName() + ", Parent Space ID: " + m_asOwner.GetParentSpaceID());
		
		HTMLElementCollection result = new HTMLElementCollection();		
		result.AddInnerHTMLElement(ExpListView.GetHiddenInputsForPagination());
		
		// aj: add the preview list
		result.AddInnerHTMLElement(
				((EditorView) m_asOwner
					.GetView(GroupEditorAS.strStorageDynMemberPreviewPopup)).Display());
		
		// SE: logging
		log.FunctionEnd("GroupDynamicMembersPreviewPopupDP::PageDisplay");
		return result;
	}
	
	/**
	 * 
	 *
	 * @return 
	 *
	 * @throws HTMLException 
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection sc = new HTMLScriptCollection();
		return sc;
	}

}

