package com.plumtree.portalpages.admin.editors.invitation;


// Server Imports
import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.editors.defaultprofile.*;
import com.plumtree.portaluiinfrastructure.resultwrapper.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.portaluiinfrastructure.tree.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.uiinfrastructure.tree.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 *
 */
public class GenInfoView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.invitation.GenInfoView");


	public static final String STR_MVC_CLASS_NAME = "InvGenInfo";


	public static final String HTMLHIDDEN_INV_USERFOLDER  = "in_hi_UserFolder";


	public static final String HTMLBUTTON_EDITFOLDER	  = "in_bu_EditFolder";


	public static final String HTMLSELECT_INV_USERPROF    = "in_se_UserProf";


	public static final String HTMLBUTTON_EDITPROF		  = "in_bu_EditProf";


	public static final String HTMLHIDDEN_USERTREESPACEID = "in_hi_UserTreeSpaceID";


	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new GenInfoView();
	}

	/**
	 *
	 *
	 * @return
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTableCell myCell;
		HTMLTableRow myRow;
		HTMLSelect mySelect;
		HTMLOption myOption;
		HTMLInput myInput;
		HTMLSpan mySpan;

		try
		{
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						430, "ptmsgs_portaladminmsgs")));

			HTMLTable myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("5");
			myTable.SetCellSpacing("0");

			//Instruction Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetColSpan("3");
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);

			myCell.AddInnerHTMLString(m_asOwner.GetString(431,
					"ptmsgs_portaladminmsgs"));
			myCell.AddInnerHTMLElement(new HTMLBr());

			// Instruction Row end
			//Spacer Rows begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetColSpan("3");
			myCell.SetHeight("5");

			//Spacer Rows ends
			// User Folder Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.SetWidth("20%");
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(426,
					"ptmsgs_portaladminmsgs"));

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.SetWidth("20%");
			myCell.SetNoWrap(true);

			String strFolderName = ((IInvitationModelRO) m_model).GetUserFolderName();

			if (strFolderName != null)
			{
				myCell.AddInnerHTMLEncodedString(strFolderName);
			}
			else
			{
				myCell.AddInnerHTMLString(m_asOwner.GetString(1834, "ptmsgs_portaladminmsgs"));
			}

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.SetWidth("60%");
			myCell.SetNoWrap(true);

			// hidden input user Folder Name for validation
			myInput = new HTMLInput(HTMLInputTypes.HIDDEN,
					HTMLHIDDEN_INV_USERFOLDER, "");
			result.AddInnerHTMLElement(myInput);
			myInput.SetValue(strFolderName);

			// hidden input with the tree space ID
			myInput = new HTMLInput(HTMLInputTypes.HIDDEN,
					HTMLHIDDEN_USERTREESPACEID, "");
			result.AddInnerHTMLElement(myInput);

			String strUserServerSpaceID = ((IInvitationModelRO) m_model).GetUserTreeSpaceID();

			if (strUserServerSpaceID.equals("Default Data"))
			{
				myInput.SetValue("");
			}
			else
			{
				myInput.SetValue(strUserServerSpaceID);
			}

			myInput = new HTMLInput(HTMLInputTypes.BUTTON,
					HTMLBUTTON_EDITFOLDER, "");
			myCell.AddInnerHTMLElement(myInput);

			myInput.SetValue(m_asOwner.GetString(427, "ptmsgs_portaladminmsgs"));
			myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
			myInput.SetOnClick("openUserFolderTree(document." +	// mj: removed 'Javascript:' from function name
				AFormDP.HTMLFORM_NAME + "." + HTMLHIDDEN_USERTREESPACEID +
				");");

			// User Folder Row end

			// Profiles Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.SetWidth("20%");
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(428,
					"ptmsgs_portaladminmsgs"));

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.SetWidth("20%");
			myCell.SetNoWrap(true);

			// ***<select>*** begins here
			mySelect = new HTMLSelect(HTMLSELECT_INV_USERPROF,
					HTMLSELECT_INV_USERPROF);
			myCell.AddInnerHTMLElement(mySelect);
			mySelect.SetStyleClass(PTStyleClass.FORM_PULLDOWN_TEXT);

			IASQueryResult IASprofiles = ((IInvitationModelRO) m_model).GetProfiles();
			String strProfileName;
			int nProfileID;

			myOption = new HTMLOption("-1");
			mySelect.AddInnerHTMLElement(myOption);
					myOption.AddInnerHTMLEncodedString(m_asOwner.GetString(2182, "ptmsgs_portaladminmsgs"));	// No user image selected.

			for (int i = 0; i < IASprofiles.GetCount(); i++)
			{
				nProfileID		   = XPConvert.ToInteger(IASprofiles.GetFields(i,
						PT_PROPIDS.PT_PROPID_OBJECTID));

				IPTSession ptSession = ((IInvitationModelRO) m_model).GetPTSession();
				boolean bObjectIsAccessible = ptSession.GetUsers().IsObjectAccessible( nProfileID,
					ptSession.GetSessionInfo().GetCurrentUserID(), PT_ACCESS_LEVELS.PT_ACCESS_LEVEL_SELECT);

				if (bObjectIsAccessible) {
					strProfileName     = (String) IASprofiles.GetFields(i,
							PT_PROPIDS.PT_PROPID_NAME);

					String optionValue = XPConvert.ToString(nProfileID);
					myOption		   = new HTMLOption(optionValue);

					if (nProfileID == ((IInvitationModelRO) m_model).GetDefaultProfileID())
					{
						myOption.SetSelected(true);
					}

					mySelect.AddInnerHTMLElement(myOption);
					myOption.AddInnerHTMLEncodedString(strProfileName);
				}
			}

			// ***<select>*** ends here
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.SetWidth("60%");
			myCell.SetNoWrap(true);
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
			// DCA - commented out for now since there is no way to make editting profile layout work
			/*myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_EDITPROF,
					"");
			myCell.AddInnerHTMLElement(myInput);

			myInput.SetValue(m_asOwner.GetString(429, "ptmsgs_portaladminmsgs"));
			myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
			myInput.SetOnClick("EditProfile(); return false;");*/

			// Profiles Row end
		}
		catch (Exception e)
		{
			
				log.Error(e, "GenInfoView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(432,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * This method returns the HTMLScript that encompasses the Javascript on the page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 *
	 * @return HTMLScript
	 */
	public HTMLScript DisplayJavascript()
	{
		String strFormName = AFormDP.HTMLFORM_NAME;

		// The URL to open a new user Folder tree
		ASURL newUserFolderTree = new ASURL(m_asOwner);
		newUserFolderTree.SetLinkCreateNewSpace(TreeAS.STR_MVC_CLASS_NAME, m_asOwner);
		newUserFolderTree.SetSubSpaceKey("UserTree");
		newUserFolderTree.SetControl(StartTreeControl.STR_MVC_CLASS_NAME);
		newUserFolderTree.AddControlArgument(StartTreeControl.ROOT_ID, "1");
		newUserFolderTree.AddControlArgument(StartTreeControl.MULTI_SELECT,
			XPConvert.ToString(false));
		newUserFolderTree.AddControlArgument(StartTreeControl.SELECT_MODE,
			XPConvert.ToString(TreeConstants.N_COMPOSITESELECT));
		newUserFolderTree.AddControlArgument(StartTreeControl.SHOW_ROOT, XPConvert.ToString(false));
		newUserFolderTree.AddControlArgument(StartTreeControl.SUBMIT_MODE,
			XPConvert.ToString(TreeConstants.N_SERVERSUBMIT));
		newUserFolderTree.AddControlArgument(StartTreeControl.PARENT_FORM_NAME,
			strFormName);
		newUserFolderTree.AddControlArgument(StartTreeControl.PARENT_FORM_SPACE_ID,
			HTMLHIDDEN_USERTREESPACEID);
		newUserFolderTree.AddControlArgument(StartTreeControl.PARENT_SUBMIT_CALL,
			"userFolderSubmit");
		newUserFolderTree.AddControlArgument(StartTreeControl.TITLE,
			m_asOwner.GetString(1835, "ptmsgs_portaladminmsgs"));
		newUserFolderTree.AddControlArgument(StartTreeControl.ACTIONSUBTITLE,
			m_asOwner.GetString(1833, "ptmsgs_portaladminmsgs"));
		newUserFolderTree.AddControlArgument(StartTreeControl.ACCESS_LEVEL,
			((IInvitationModelRO) m_model).GetAccessEdit());
		newUserFolderTree.AddControlArgument(StartTreeControl.CLASS_IDS_TO_DISPLAY,
			XPConvert.ToString(PT_CLASSIDS.PT_USER_ID));

		// The url to open a previously opened server user tree
		// This needs to have the SpaceID added to it.
		ASURL oldUserFolderTree = new ASURL(m_asOwner);
		oldUserFolderTree.SetLinkCreateNewSpace(TreeAS.STR_MVC_CLASS_NAME, m_asOwner);
		oldUserFolderTree.IsSubSpace();

		HTMLScript myScript = new HTMLScript("text/javaScript");
		XPStringBuilder sb;

		try
		{
			// Open user tree function
			sb = new XPStringBuilder(200);
			sb.Append("function ").Append("openUserFolderTree").Append("(myInput)\n");
			sb.Append("{\n");
			sb.Append("  if (myInput.value == '') {\n");
			sb.Append("    window.open('")
			.Append(newUserFolderTree.GetURLAsString()).Append("', '_blank3', '")
			.Append(TreeConstants.GetJavascriptTreeWindowAttributes()).Append("');\n");
			sb.Append("  } else {\n");
			sb.Append("    window.open('")
			.Append(oldUserFolderTree.GetURLAsString()).Append("&")
			.Append(ASConstants.SPACEID).Append("=' + myInput.value").Append(", '_blank3', '")
			.Append(TreeConstants.GetJavascriptTreeWindowAttributes()).Append("');\n");
			sb.Append("  }\n");
			sb.Append("}\n");
			myScript.AddInnerHTMLString(sb.ToString());

			// Submit function
			sb = new XPStringBuilder(100);
			sb.Append("function userFolderSubmit()\n");
			sb.Append("{\n");
			sb.Append("  postToSelf(")
			.Append(InvitationRepostControl.POSTTOSELF_ACTION_FOLDER).Append(");\n");
			sb.Append("}\n");
			myScript.AddInnerHTMLString(sb.ToString());

			sb = new XPStringBuilder(100);
			sb.Append("function CheckFolder()\n");
			sb.Append("{\n");
			sb.Append("  if (document." + AFormDP.HTMLFORM_NAME + "." +
				HTMLHIDDEN_INV_USERFOLDER + ".value == '') { \n");

			sb.Append("		alert(\"" +
				m_asOwner.GetString(434, "ptmsgs_portaladminmsgs") + "\");\n");
			sb.Append("      return false;\n");
			sb.Append("  }\n");
			sb.Append("  return true;\n");
			sb.Append("}\n");
			myScript.AddInnerHTMLString(sb.ToString());

			sb = new XPStringBuilder(100);
			sb.Append("function CheckProfile()\n");
			sb.Append("{\n");
			sb.Append("  if (document." + AFormDP.HTMLFORM_NAME + "." +
				HTMLSELECT_INV_USERPROF + ".value == '-1') { \n");
			sb.Append("		alert(\"" +
				m_asOwner.GetString(2183, "ptmsgs_portaladminmsgs") + "\");\n");	// A user image has not been selected.
			sb.Append("      return false;\n");
			sb.Append("  }\n");
			sb.Append("  return true;\n");
			sb.Append("}\n");
			myScript.AddInnerHTMLString(sb.ToString());

			ASURL myURL   = ((IInvitationModelRO) m_model).GetASURLToSubEditor();
			myURL.SetControl(SetEditDefaultProfileControl.STR_MVC_CLASS_NAME);
			myURL.SetSubSpaceKey(InvitationModel.m_sProfileSubspaceKey);
			//myURL.AddControlArgument(EditorStartControl.QS_EDITOR_TYPE, EditorStartControl.EDITOR_START_FLAG_EDIT);
			myURL.AddControlArgument(EditorStartControl.QS_CLOSE_WINDOW_ON_DONE, true);

			sb = new XPStringBuilder(100);
			sb.Append("function EditProfile()\n");
			sb.Append("{\n");
			sb.Append("  if (!CheckProfile()) { \n");
			sb.Append("  return;\n");
			sb.Append("}\n");
			sb.Append("    var profileID = document." + AFormDP.HTMLFORM_NAME +
				"." + HTMLSELECT_INV_USERPROF + ".value;\n");
			sb.Append("    var profileURL = '" + myURL.GetURLAsString() + "&" +
				SetEditDefaultProfileControl.m_UserID + "=' + profileID;\n");
			sb.Append("   OpenSubEditor(profileURL);\n");
			sb.Append("}\n");
			myScript.AddInnerHTMLString(sb.ToString());

			sb = new XPStringBuilder(100);
			sb.Append("function OpenSubEditor(varSubSpaceURL)\n");
			sb.Append("{\n");
			sb.Append(
				"    window.open(varSubSpaceURL, 'PopUpEditMode', 'location=no,scrollbars=yes,height=600,width=800');\n");
			sb.Append("}\n");
			myScript.AddInnerHTMLString(sb.ToString());
		}
		catch (HTMLException e)
		{
			
				log.Error(e, "GenInfoView::DisplayJavascript The following error occured when trying to display the JavaScript: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(433,
					"ptmsgs_portaladminmsgs"), e);
		}

		return myScript;
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}

