package com.plumtree.portalpages.admin.editors.invitation;

import com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author DustinA
 */
public class GroupListView extends SelectPTObjectView
{
	
	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "GroupListView";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new GroupListView();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the space below the Action bar.
	 * (The one with the add and delete icons).
	 *
	 * @return HTMLTable
	 * @throws Exception
	 */
	protected HTMLTable GetHTMLBelowActionBar()
	{
		HTMLTableCell myCell;
		HTMLTableRow myRow;

		HTMLTable myTable = new HTMLTable();
		myTable.SetWidth("100%");
		myTable.SetBorder("0");
		myTable.SetCellPadding("5");
		myTable.SetCellSpacing("0");

		//Spacer Row begin
		myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetHeight("5");

		//Spacer Row ends
		//Instruction Row begin
		myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);

		myCell.AddInnerHTMLString(m_asOwner.GetString(435,
				"ptmsgs_portaladminmsgs"));
		myCell.AddInnerHTMLElement(new HTMLBr());

		// Instruction Row end
		//Spacer Row begin
		myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetHeight("5");

		//Spacer Row ends
		return myTable;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListView#GetHTMLForCheckBox(int)
	 */
	protected HTMLTableCell GetHTMLForCheckBox(int _nRowIndex)

	{
		// Page cannot be deleted. It is from the community template or it is the home page.
		if (((IGroupListModelRO) m_model).IsEveryoneGroup(_nRowIndex))
		{
			HTMLTableCell myCell = new HTMLTableCell();
			myCell.SetWidth("20");
			myCell.SetHeight("30");
			myCell.SetAlign("center");
			myCell.SetVAlign("middle");
			myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
			myCell.AddInnerHTMLString(SPACE);

			return (myCell);
		}
		else
		{
			return super.GetHTMLForCheckBox(_nRowIndex);
		}
	}
}

