package com.plumtree.portalpages.admin.editors.invitation;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.expandablelist.*;

/**
 * Delete that class if you don't have any repost actions.
 */
public class InvitationRepostControl extends ObjEditorRepostControl
{

	public static final String STR_MVC_CLASS_NAME = "InvitationRepost";


	public final static int POSTTOSELF_ACTION_FOLDER = 10;


	public final static int POSTTOSELF_ACTION_PROFILE = 11;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new InvitationRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Switch between the action modes and call  the associated method for each
	 * action.
	 *
	 * @param _nAction
	 */
	protected void PerformAction(int _nAction)
	{
		super.PerformAction(_nAction);

		((ExpListControl) m_asOwner.GetControl(InvitationEditorAS.strStorageSelectPTObject)).PerformRepostAction(_nAction,
			m_htFormData);

		switch (_nAction)
		{
		case POSTTOSELF_ACTION_FOLDER:
			((InvitationModel) m_model).SetUserFolderOnRepost();

			break;

		case POSTTOSELF_ACTION_PROFILE:

			String[] data = (String[]) m_htFormData.GetElement(GenInfoView.HTMLSELECT_INV_USERPROF);
			((InvitationModel) m_model).SetDefaultProfileID(XPConvert.ToInteger(
					data[0]));

			break;
		}
	}
}

