package com.plumtree.portalpages.admin.editors.invitation;


// Framework Imports
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 *
 */
public class MainDP extends EditorDP
{
	public static final String STR_MVC_CLASS_NAME = "InvMain";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return (m_asOwner.GetString(456, "ptmsgs_portaladminmsgs"));
	}


	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

  	/**
	 * Implement this method to add HTML below the sub header.
	 *
	 * @return HTMLElement
	 *
	 * @throws HTMLException
	 */
	protected HTMLElement GetHTMLBelowSubHeader() throws HTMLException {
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(2517, "ptmsgs_portaladminmsgs"),
			this.m_asOwner);
	}


	/**
	 * Returns the HTML for the General Info page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 *
	 * @return HTMLElement
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
				GenInfoView.STR_MVC_CLASS_NAME)).Display());

		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		//views.AddInnerHTMLElement(((EditorView)
		//	m_asOwner.GetView(GroupsView.STR_MVC_CLASS_NAME)).Display());
		// ***GroupList*** Display the list.
		views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
				InvitationEditorAS.strStorageSelectPTObject)).Display());

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();
		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
				GenInfoView.STR_MVC_CLASS_NAME).DisplayJavascript());
		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
				InvitationEditorAS.strStorageSelectPTObject)
			.DisplayJavascript());

		return myScripts;
	}
}

