package com.plumtree.portalpages.admin.editors.job;


// Framework Imports
import com.plumtree.portalpages.common.joblogs.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.errordisplay.*;
import com.plumtree.uiinfrastructure.expandablelist.*;

/**
 *
 * *** Delete that class if you don't have any repost actions.***
 *
 */
public class JobRepostControl extends ObjEditorRepostControl
{
	/** The unique identifier for the class */
	public static final String STR_MVC_CLASS_NAME = "JobRepost";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new JobRepostControl();
	}

	//Repost actions

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Switch between the action modes and call
	 * the associated method for each action.
	 *
	 * @param _nAction
	 */
	protected void PerformAction(int _nAction)
	{
		super.PerformAction(_nAction);		
		
		switch (_nAction)
		{
			// JHQ 010804: bug 26619 - if Finish action is triggered and caused
			// a PAGE_STATUS_INVALID, and this job was scheduled to be deleted 
			// after running; then we should just inform the user that this job
			// has been deleted and they need to cancel.
			case POSTTOSELF_ACTION_FINISH:
			
				// the pagestatus will be invalid if this job was to be deleted 
				// after completion.
				IPTJob myJob = (IPTJob) ((JobModel) m_model).GetObject();
				if (PAGE_STATUS_INVALID == m_nPageStatus && 
					myJob.GetDeleteWhenDone())
				{
					UIError myError = new UIError(UIErrorLevel.FRIENDLY,
						UIErrorScope.CURRENT_USER, 
						null,
						m_asOwner.GetString(2648, "ptmsgs_portaladminmsgs"),
						"Cannot save job " + ((JobModel) m_model).GetObjectID() + " because it was set to be deleted when done.");
								
					UIErrorHandler.RaiseError(
						myError, 
						m_asOwner.GetSubSession(),
						m_asOwner.GetApplication());
		
					return;
				}
		}

		if (!((JobModel) m_model).IsAddOperationDisabled())
		{
			// You need to call the PerformRepostAction on the select ptobject control
			((ExpListControl) m_asOwner.GetControl(JobEditorAS.m_strStorageSelectPTObject)).PerformRepostAction(_nAction,
				m_htFormData);
		}

		//Call the repost action on the JobLogRepostControl
		JobLogRepostControl myControl = (JobLogRepostControl) m_asOwner.GetControl(JobLogRepostControl.STR_MVC_CLASS_NAME);
		Redirect _redirect = myControl.CheckActionSecurityAndExecute(m_htFormData);
		//set the redirect
		if (_redirect != null){
			SetRedirect(_redirect);
		}
	}
	
	protected void PerformReadOnlyAction(int _nAction)
	{
		super.PerformReadOnlyAction(_nAction);
		
		SaveCurrentPage();
		
		//Call the repost action on the JobLogRepostControl
		JobLogRepostControl myControl = (JobLogRepostControl) m_asOwner.GetControl(JobLogRepostControl.STR_MVC_CLASS_NAME);
		myControl.MyPerformReadOnlyAction(_nAction,m_htFormData);
	}
}

