package com.plumtree.portalpages.admin.editors.lockbox;

// Framework Imports
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;

/**
 * 
 * @author jennifersu
 *
 */
public interface ILockboxEditorModelRO extends IEditorModelRO
{
	/**
	 * Get Row index of Lockbox in the main Lockbox list of
	 * Credential Vault Manager.
	 * @return
	 */
	public int GetRow();
	
	/**
	 * Returns true if the lockbox was just created.
	 * @return
	 */
	public boolean IsNewLockbox();
	
	/**
	 * Get property object ID of the lockbox's
	 * username property.
	 * @return
	 */
	public int GetUsernamePropID();

	/**
	 * Get property object ID of the lockbox's
	 * password property.
	 * @return
	 */	
	public int GetPasswordPropID();
	
	/**
	 * Get property object name of the lockbox's
	 * username property.
	 * @return
	 */	
	public String GetUsernamePropName();
	
	/**
	 * Get property object name of the lockbox's
	 * password property.
	 * @return
	 */	
	public String GetPasswordPropName();

	/**
	 * Get the property editor URL.
	 * @param _nPropertyID
	 * @return
	 */
	public ASURL GetEditPropertyURL(int _nPropertyID);
}

