package com.plumtree.portalpages.admin.editors.lockbox;


// Framework Imports
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.editor.commonpages.keywords.*;
import com.plumtree.portaluiinfrastructure.editor.commonpages.localizednames.*;
import com.plumtree.portaluiinfrastructure.editor.commonpages.migrationhistory.*;
import com.plumtree.portaluiinfrastructure.editor.commonpages.objectproperties.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.expandablelist.*;

public class LockboxEditorAS extends PTEditorAS
{
	
	public static final String STR_MVC_CLASS_NAME = "LockboxEditor";

	/**
	 * MJD- Storage name for Keywords classes
	 */
	public static final String STR_MVC_STORAGE_NAME_KEYWORDS = "ObjectKeywordsObjEditor";
	
	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new LockboxEditorAS();
	}

	/**
	 * Sets the Editor title.
	 *
	 */
	public String GetEditorTitle()
	{
		if (EditorStartControl.EDITOR_START_FLAG_CREATE == ((EditorModel) GetModel(
					m_strModelName)).GetEditorType())
		{
			return (GetString(2907, "ptmsgs_portaladminmsgs"));
		}
		else
		{
			return (GetString(2908, "ptmsgs_portaladminmsgs"));
		}
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	
	/**
	 * Returns the class name of the Repost Control.
	 *
	 * @return String
	 */
	public String GetRepostControlName()
	{
		return (LockboxEditorRepostControl.STR_MVC_CLASS_NAME);
	}

	/**
	 * Registers all the classes for this Activity Space.
	 */
	public void Init()
	{
		m_strModelName = LockboxEditorModel.STR_MVC_CLASS_NAME;

		super.Init();

		IModel myModel = GetModel(m_strModelName);

		// JF- Register the Repost Control
		RegisterControl(LockboxEditorRepostControl.STR_MVC_CLASS_NAME,
			myModel);

		RegisterModel(LocNamesModel.STR_MVC_CLASS_NAME);
		RegisterView(LocNamesView.STR_MVC_CLASS_NAME,
			GetModel(LocNamesModel.STR_MVC_CLASS_NAME));
		RegisterView(LocNamesPrimaryNameView.STR_MVC_CLASS_NAME,
			GetModel(LocNamesModel.STR_MVC_CLASS_NAME));
		RegisterView(LocNamesPopUpView.STR_MVC_CLASS_NAME,
			GetModel(LocNamesModel.STR_MVC_CLASS_NAME));
		RegisterControl(LocNamesRepostControl.STR_MVC_CLASS_NAME,
			GetModel(LocNamesModel.STR_MVC_CLASS_NAME));

		// Register Plug-In: Object Properties
		RegisterModel(ObjPropModel.STR_MVC_CLASS_NAME);
		RegisterView(ObjPropEditView.STR_MVC_CLASS_NAME,
			GetModel(ObjPropModel.STR_MVC_CLASS_NAME));
		RegisterControl(ExpListControl.STR_MVC_CLASS_NAME,
			GetModel(ObjPropModel.STR_MVC_CLASS_NAME));
			
		// Register Plug-In: Keywords
		RegisterModel(KeywordsModel.STR_MVC_CLASS_NAME,
			STR_MVC_STORAGE_NAME_KEYWORDS);
		RegisterView(KeywordsView.STR_MVC_CLASS_NAME,
			STR_MVC_STORAGE_NAME_KEYWORDS,
			GetModel(STR_MVC_STORAGE_NAME_KEYWORDS));
		RegisterControl(ExpListControl.STR_MVC_CLASS_NAME,
			STR_MVC_STORAGE_NAME_KEYWORDS,
			GetModel(STR_MVC_STORAGE_NAME_KEYWORDS));

		RegisterView(LockboxEditorPropertiesView.STR_MVC_CLASS_NAME,
			myModel);

		LockboxEditorLocNamesDP dpLocNames = new LockboxEditorLocNamesDP();
		dpLocNames.AddToValidationFunction(LocNamesPrimaryNameView.VALIDATION_FUNC_NAME);
		RegisterPage(dpLocNames);
		RegisterPage(new LocNamesPopUpDP());

		// Register Migration History Plugin
		RegisterModel(MigrationHistoryPluginModel.STR_MVC_CLASS_NAME);
		RegisterView(MigrationHistoryView.STR_MVC_CLASS_NAME,
			GetModel(MigrationHistoryPluginModel.STR_MVC_CLASS_NAME));
		RegisterPage(new MigrationHistoryPluginDP());

		SetCurrentPage(GetPage(LockboxEditorLocNamesDP.STR_MVC_CLASS_NAME));
		
		//Sets left nav menu
		int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(1905,
					"ptmsgs_portaladminmsgs"));
		m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, LockboxEditorLocNamesDP.STR_MVC_CLASS_NAME);
		m_mEditorMenu.AddLinkToSubMenu(nMenuOneID,
			MigrationHistoryPluginDP.STR_MVC_CLASS_NAME);
			
	}
	
	/**
	 * Set the help page for this editor. 
	 *
	 * @param page 
	 * 
	 * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage(com.plumtree.uiinfrastructure.activityspace.IDisplayPage)
	 */
	public void SetCurrentPage(IDisplayPage page)
	{
		super.SetCurrentPage(page);

		String sPageName = page.GetName();

		if( MigrationHistoryPluginDP.STR_MVC_CLASS_NAME.equals( sPageName ))
		{
			this.SetHelpTopic( "PT_MigrationHistoryandStatus" );			
		}
		else if( LockboxEditorLocNamesDP.STR_MVC_CLASS_NAME.equals( sPageName ))
		{
			this.SetHelpTopic( "PT_CredentialVaultManager_LockboxMainSettings" );			
		}

	}
}

