package com.plumtree.portalpages.admin.editors.page;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.constants.*;
import com.plumtree.portaluiinfrastructure.expandablelist.template.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.xpshared.htmlconstructs.*;

/**
 * @author michaeld
 */
public class PageTemplateListModel extends TemplateListModel
{
	private static OpenLogger log = OpenLogService.GetLogger(
			OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
			"com.plumtree.portalpages.admin.editors.page.PageTemplateListModel");

	/** Object Name */
	public final static String STR_MVC_CLASS_NAME = "PageTemplateList";

	public void InitializePageTemplateList(IPTSession _Session, int _nPageTemplateID, boolean bInheritPageTemplate, int _nListKey)
	{
		InitializeTemplateList(_Session, PT_CLASSIDS.PT_PAGETEMPLATE_ID, _nPageTemplateID, bInheritPageTemplate,
			m_asOwner.GetString(1816, ResourceConstants.PORTALBROWSINGMSGS), PTImageType.ICON_COMMUNITY_TEMPLATE, _nListKey);
		
		SetIsListReadOnly(true);
	}

	/**
	 * We don't all add rows for this list.
	 *
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#AddRowsOnRepost(XPHashtable)
	 */
	public void AddRowsOnRepost(XPHashtable _htFormData)
	{
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new PageTemplateListModel();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}
