package com.plumtree.portalpages.admin.editors.pagetemplate;

import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author michaeld
 */
public class DefaultPageNamePopUpDP extends AFormDP
{
	/** MES- The name of this object */
	public static final String STR_MVC_CLASS_NAME = "DefaultPageNamePopUp";

	/**
	 * Returns the String to display on the left navigation menu,  linking to
	 * that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		// MJD- This is not used here.
		return "";
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormPageType()
	 */
	public FormPageTypes GetFormPageType()
	{
		return FormPageTypes.NO_BUTTONS;
	}
	
	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()
	 */
	public String GetFormTitle()
	{
		//MES- Localized Default Page Name
		return m_asOwner.GetString(2727, "ptmsgs_portaladminmsgs");
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for that Page.
	 *
	 * @return HTMLElement
	 *
	 * @throws HTMLException
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()
	{
		//MES- Just ask the popup view to write itself
		HTMLElementCollection result = new HTMLElementCollection();
		result.AddInnerHTMLElement((m_asOwner.GetView(
			PageTemplateEditorAS.PLUGIN_DEFAULT_PAGE_NAME_POPUP_VIEW)).Display());

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 *
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		//MES- Ask the superclass if it's got anything.
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		//MES- And ask the popup view if it's got anything
		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
			PageTemplateEditorAS.PLUGIN_DEFAULT_PAGE_NAME_POPUP_VIEW).DisplayJavascript());

		return myScripts;
	}
}
