/**
 * Created on Oct 30, 2002
 *
 * To change this generated comment edit the template variable "filecomment":

 * To enable and disable the creation of file comments go to

 */
package com.plumtree.portalpages.admin.editors.portlet;

import com.plumtree.server.*;

/**
 * @author adolfoc
 * This interface must be implemented by any plugin model that wishes to receive
 * updates from the WebServiceModel. Each plugin model must also be registered with
 * the WebServiceModel using
 * WebServiceModel.RegisterWSSubModel(String strPluginModelStorageName).
 */
public interface IPSubModel
{
	/**
	 * Sub models are expected to store themselves to the ptWebService object passed in
	 * in InitWSModel during this call.
	 */
	public void DoTaskBeforePStore();

	/**
	 * Called when the Portlet editor mode is changed.
	 */
	public void DoTaskOnPModeUpdate(int nNewWSMode);

	/**
	 * Called when the Remote Server is changed. This is mostly used to update the base-url
	 * displayed before URL edit boxes.
	 */
	public void DoTaskOnWebServiceUpdate(IPTWebService ptWebService);

	/**
	 * Initializes the sub-model. Provides an opportunity for the submodel to
	 * load it's state from the WebService.
	 */
	public void InitPModel(IPTGadget ptPortlet);
}

