package com.plumtree.portalpages.admin.editors.portlet;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author adolfoc
 *
 */
public class MainDP extends PPluginDP {
	/** Class Name */
	public static final String STR_MVC_CLASS_NAME = "PortletMain";



	
	/**
	 * Returns the String to display on the left navigation menu,  linking to
	 * that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString() {
		return m_asOwner.GetString(606, "ptmsgs_portaladminmsgs");
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader()
	{
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(1673, "ptmsgs_portaladminmsgs"),
			this.m_asOwner);
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetOrderedViewList(int)
	 */
	public XPArrayList GetOrderedViewList(int nPMode) {
		XPArrayList xpPViews = new XPArrayList();

		switch (nPMode) {
			case PortletModel.PMODE_PRECREATE :
				break;
			case PortletModel.PMODE_CREATE_FROMTEMPLATE :
			case PortletModel.PMODE_CREATE :
			case PortletModel.PMODE_EDIT :
				xpPViews.Add(PortletEditorAS.Storage_SelectWebServiceView);
				xpPViews.Add(PortletEditorAS.Storage_PortletSettingsView);

				break;

			case -1: //PortletModel.PMODE_INVALID :
			default :
		}

		return xpPViews;
	}
	
	/* (non-Javadoc)
	 * @see com.plumtree.portalpages.admin.editors.portlet.PPluginDP#GetPluginHelpTopic()
	 */
	public String GetPluginHelpTopic() {
		IPortletModelRO mParentModel = (IPortletModelRO) m_asOwner.GetModel(PortletModel.STR_MVC_CLASS_NAME);
		if (mParentModel.IsTemplate())
		{
			return "PT_PortletTemplate_MainSettings";
		} else
		{
			return "PT_Portlet_MainSettings";
		}
	}

}

