package com.plumtree.portalpages.admin.editors.portlet;
import com.plumtree.openfoundation.util.*;

/**
 * @author adolfoc
 *
 */
public class PreCreateDP extends PPluginDP
{
	/** Class Name */
	public static final String STR_MVC_CLASS_NAME = "PortletPreCreate";
 

	
	/**
	 * Returns the String to display on the left navigation menu,  linking to
	 * that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return m_asOwner.GetString(1857, "ptmsgs_portaladminmsgs");
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetOrderedViewList(int)
	 */
	public XPArrayList GetOrderedViewList(int nPMode)
	{
		XPArrayList xpPViews = new XPArrayList();

		switch (nPMode)
		{
		case PortletModel.PMODE_PRECREATE:
			// AGC- This is the old pre-selection view. I've left this in so that
			// it is easy for future developers to switch to this view for debugging
			// purposes. The view is no longer used otherwise (rebuilt due to a UI
			// change).
			// xpPViews.Add(PortletEditorAS.Storage_PChooseSelectionView);
			
			//AGC- This is the new pre-selection view.
			xpPViews.Add(PortletEditorAS.Storage_PSelectTemplateView);
			break;

		case PortletModel.PMODE_CREATE_FROMTEMPLATE:
		case PortletModel.PMODE_CREATE:
		case PortletModel.PMODE_EDIT:
			break;

		case PortletModel.PMODE_INVALID:
		default:
	
		}

		return xpPViews;
	}
	
	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorDP#GetEditorHeaderViewName()
	 */
	protected String GetEditorHeaderViewName() {
		return PortletEditorHeaderView.STR_MVC_CLASS_NAME;
	}
	/* (non-Javadoc)
	 * @see com.plumtree.portalpages.admin.editors.portlet.PPluginDP#GetPluginHelpTopic()
	 */
	public String GetPluginHelpTopic() {		
		return "PT_Portlet_ChoosePorletTemplate";
	}

 }

