/**
 * Created on Nov 14, 2002
 * by adolfoc
 */
package com.plumtree.portalpages.admin.editors.portlet.plugins;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.editors.portlet.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.portaluiinfrastructure.tree.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.uiinfrastructure.tree.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author adolfoc
 */
public class PChooseSelectionView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.portlet.plugins.PChooseSelectionView");

	public static final String STR_MVC_CLASS_NAME = "PChooseSelectionView";

	
	/**
	 * Private String that is the function name for the repost javascript called
	 * when the tree control returns
	 */
	private static final String JSREPOST_PORTLETTEMPLATE_FUNC	    = "frmRepostPortletTempltChosen";
	private static final String JSREPOST_PORTLETTEMPLATE_FUNC_INPUT = "frmSetDataPortletTempltChosen";

	// HTML Object names.
	public static final String HTMLHIDDEN_PORTLETTEMPLATE_SPACE    = "in_hi_PTTreeSpace";
	public static final String HTMLHIDDEN_PORTLETTEMPLATE_SELECTED = "in_hi_PTTreeSelected";
	public static final String HTMLRADIO_PORTLET_CREATEFROM = "in_ra_PTCreateFrom";

	/**
	 * Our parent Activity space.
	 */
	private AActivitySpace m_asasParent;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new PChooseSelectionView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTable myTable;
		HTMLTableCell myCell;
		HTMLTableRow myRow;
		HTMLInput myInput;

		HTMLSpan mySpan;

		try
		{
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						562, "ptmsgs_portaladminmsgs")));

			// Containing Table
			myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("1");
			myTable.SetCellSpacing("0");
			myTable.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BG);

			// 1st row begins (Top Margin)
			myRow = PortletViewHelper.AddEmptyRow(myTable, "5");

			// 1st row ends
			// 2nd & 3rd rows
			// AGC- So here' a little twist, if this editor is called from a community editor (and thus, is passed a 
			// community ID) then we can't allow the user to create a gadget from scratch. So we must remove this radio
			// selection and only allow the user to select a template to create from. We check whether the community editor
			// called us by checking whether the communityID held by our parent model is non-zero.
			IPortletModelRO mParentModel = (IPortletModelRO) m_asOwner.GetModel(PortletModel.STR_MVC_CLASS_NAME);

			if (!mParentModel.IsForCommunity())
			{
				int nNextPMode = ((IPChooseModelRO) m_model).GetNextPMode();

				if ((PortletModel.PMODE_CREATE != nNextPMode) &&
						(PortletModel.PMODE_CREATE_FROMTEMPLATE != nNextPMode))
				{
					// AGC - This is a good default.
					nNextPMode = PortletModel.PMODE_CREATE;
				}

				AddRadioToTable(myTable,
					m_asOwner.GetString(566, "ptmsgs_portaladminmsgs"),
					XPConvert.ToString(PortletModel.PMODE_CREATE),
					XPConvert.ToString(nNextPMode));

				AddRadioToTable(myTable,
					m_asOwner.GetString(567, "ptmsgs_portaladminmsgs"),
					XPConvert.ToString(PortletModel.PMODE_CREATE_FROMTEMPLATE),
					XPConvert.ToString(nNextPMode));
			}
			else
			{
				// Because the radios are gone, we need to throw in a label - otherwise it's a little spare and
				// possibly confusing.
				myRow = PortletViewHelper.AddRow(myTable);

				//// Left Margin
				PortletViewHelper.AddEmptyCell(myRow, "1");
				PortletViewHelper.AddEmptyCell(myRow, "1");

				// Label
				myCell     = PortletViewHelper.AddCell(myRow, "2");
				mySpan     = PortletViewHelper.AddSpanToCell(myCell);

				mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(
						m_asOwner.GetString(568, "ptmsgs_portaladminmsgs")));

				//// Right Margin
				PortletViewHelper.AddEmptyCell(myRow, "1");
			}

			// 4th row begins
			myRow = PortletViewHelper.AddRow(myTable);

			//// Left Margin
			PortletViewHelper.AddEmptyCell(myRow, "1");
			PortletViewHelper.AddEmptyCell(myRow, "1");

			//// Label 
			myCell     = PortletViewHelper.AddCell(myRow, "1");
			mySpan     = PortletViewHelper.AddSpanToCell(myCell);
			myCell.SetAutoFit(true);

			mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(
					m_asOwner.GetString(569, "ptmsgs_portaladminmsgs")) +
				SPACE + SPACE);

			////// Don't forget to HTMLEncode this stuff..... Important!			
			String strPortletTemplateName = ((IPChooseModelRO) m_model).GetPortletTemplateName();

			if ((null == strPortletTemplateName) ||
					(0 >= strPortletTemplateName.length()))
			{
				strPortletTemplateName = m_asOwner.GetString(564,
						"ptmsgs_portaladminmsgs");
			}

			// AGC- only add the indent if we're showing the radio buttons.			
			if (!mParentModel.IsForCommunity())
			{
				mySpan.AddInnerHTMLString(SPACE + SPACE + SPACE + SPACE +
					XPHttpUtility.HtmlEncode(strPortletTemplateName) + SPACE +
					SPACE);
			}
			else
			{
				mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(
						strPortletTemplateName) + SPACE + SPACE);
			}

			////// Actual Tree Control
			// Hidden input for the Space ID for the tree.  That way if you hit the folder
			// tree link twice, it will open the same tree both times.
			myInput = new HTMLInput(HTMLInputTypes.HIDDEN,
					HTMLHIDDEN_PORTLETTEMPLATE_SPACE, "");
			mySpan.AddInnerHTMLElement(myInput);

			String strSpaceID = ((IPChooseModelRO) m_model).GetData(HTMLHIDDEN_PORTLETTEMPLATE_SPACE);

			if (strSpaceID.equals(PChooseModel.DEFAULTDATA))
			{
				myInput.SetValue("");
			}
			else
			{
				myInput.SetValue(strSpaceID);
			}

			String strOnClick = JSREPOST_PORTLETTEMPLATE_FUNC_INPUT +
				"(document." + AFormDP.HTMLFORM_NAME + "." +
				HTMLHIDDEN_PORTLETTEMPLATE_SPACE + "); return false;";

			mySpan.AddInnerHTMLElement(PortletViewHelper.MakeSimpleButton(
					m_asOwner.GetString(565, "ptmsgs_portaladminmsgs"),
					strOnClick));

			myInput = new HTMLInput(HTMLInputTypes.HIDDEN,
					HTMLHIDDEN_PORTLETTEMPLATE_SELECTED, "PortletTemplate");
			result.AddInnerHTMLElement(myInput);
			myInput.SetValue(((IPChooseModelRO) m_model).GetData(
					HTMLHIDDEN_PORTLETTEMPLATE_SELECTED));
			myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);

			mySpan.AddInnerHTMLElement(new HTMLBr());

			// Right Margin			
			PortletViewHelper.AddSpacerCell(myRow, "1");
			PortletViewHelper.AddEmptyCell(myRow, "1");

			// last row begins (bottom margin)
			PortletViewHelper.AddEmptyRow(myTable, "5");
		}
		catch (Exception e)
		{
			
				log.Error(e, "PChooseSelectionView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(563,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * This method returns the HTMLScript that encompasses the Javascript on the page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 *
	 * @return HTMLScript
	 */
	public HTMLScript DisplayJavascript()
	{
		String strFormName = AFormDP.HTMLFORM_NAME;

		// The URL to open a new remote folder tree
		ASURL newTree = new ASURL(m_asOwner);
		newTree.SetLinkCreateNewSpace(TreeAS.STR_MVC_CLASS_NAME, m_asasParent);
		newTree.SetSubSpaceKey(PortletEditorAS.PTTREE_SUBSPACE);
		newTree.SetControl(StartTreeControl.STR_MVC_CLASS_NAME);
		newTree.AddControlArgument(StartTreeControl.ROOT_ID, "1");
		newTree.AddControlArgument(StartTreeControl.MULTI_SELECT, XPConvert.ToString(false));
		newTree.AddControlArgument(StartTreeControl.SELECT_MODE,
			XPConvert.ToString(TreeConstants.N_LEAFSELECT));
		newTree.AddControlArgument(StartTreeControl.SUBMIT_MODE,
			XPConvert.ToString(TreeConstants.N_SERVERSUBMIT));
		newTree.AddControlArgument(StartTreeControl.PARENT_FORM_NAME,
			strFormName);
		newTree.AddControlArgument(StartTreeControl.PARENT_FORM_SPACE_ID,
			HTMLHIDDEN_PORTLETTEMPLATE_SPACE);
		newTree.AddControlArgument(StartTreeControl.PARENT_SUBMIT_CALL,
			JSREPOST_PORTLETTEMPLATE_FUNC);
		newTree.AddControlArgument(StartTreeControl.CLASS_IDS_TO_DISPLAY,
			XPConvert.ToString(PT_CLASSIDS.PT_GADGETTEMPLATE_ID));

		// The url to open a previously opened remote folder tree
		// This needs to have the SpaceID added to it.
		ASURL oldTree = new ASURL(m_asOwner);
		oldTree.SetLinkCreateNewSpace(TreeAS.STR_MVC_CLASS_NAME, m_asasParent);
		oldTree.IsSubSpace();

		HTMLScript result  = new HTMLScript("text/javaScript");
		XPStringBuilder sb;

		try
		{
			// Test Server Side From Submit function
			sb = new XPStringBuilder(100);
			sb.Append("function ").Append(JSREPOST_PORTLETTEMPLATE_FUNC).Append("()\n");
			sb.Append("{\n");
			sb.Append("  postToSelf(")
			.Append(RepostControl.POSTTOSELF_ACTION_SIMPLEREPOST).Append(");\n");
			sb.Append("}\n");
			result.AddInnerHTMLString(sb.ToString());

			// Open remote folder tree function
			sb = new XPStringBuilder(200);
			sb.Append("function ").Append(JSREPOST_PORTLETTEMPLATE_FUNC_INPUT)
			.Append("(myInput)\n");
			sb.Append("{\n");
			sb.Append("  if (myInput.value == '') {\n");
			sb.Append("    window.open('").Append(newTree.GetURLAsString())
			.Append("', '_blank1', '")
			.Append(TreeConstants.GetJavascriptTreeWindowAttributes()).Append("');\n");
			sb.Append("  } else {\n");
			sb.Append("    window.open('").Append(oldTree.GetURLAsString())
			.Append("&").Append(ASConstants.SPACEID).Append("=' + myInput.value")
			.Append(", '_blank1', '")
			.Append(TreeConstants.GetJavascriptTreeWindowAttributes()).Append("');\n");
			sb.Append("  }\n");
			sb.Append("}\n");

			result.AddInnerHTMLString(sb.ToString());
		}
		catch (HTMLException he)
		{
			
				log.Error(he, "DisplayJavascript couldn't add javascript to the HTMLScript element: " +
					he.getMessage());
			
		}

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		super.Init(model, parent);
		m_asasParent = parent;
	}

	// Helper Function
	private void AddRadioToTable(HTMLTable myTable, String strLabel,
		String strValue, String strCheckedValue)

	{
		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLSpan mySpan;
		HTMLInput myInput;

		myRow = PortletViewHelper.AddRow(myTable);

		//// Left Margin
		PortletViewHelper.AddEmptyCell(myRow, "1");

		// radio
		myCell = PortletViewHelper.AddCell(myRow, "3");
		myCell.SetNoWrap(false);
		mySpan     = PortletViewHelper.AddSpanToCell(myCell);

		myInput = new HTMLInput(HTMLInputTypes.RADIO,
				HTMLRADIO_PORTLET_CREATEFROM, "");
		myInput.SetStyleClass(PTStyleClass.FORM_RADIO);

		mySpan.AddInnerHTMLElement(myInput);
		myInput.SetValue(strValue);

		// text label
		mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strLabel));

		if (0 == strValue.compareTo(strCheckedValue))
		{
			myInput.SetChecked(true);
		}
		else
		{
			myInput.SetChecked(false);
		}

		//// Right Margin
		PortletViewHelper.AddEmptyCell(myRow, "1");
	}
}

