/**
 * Created on Nov 14, 2002
 * by adolfoc
 */
package com.plumtree.portalpages.admin.editors.portlet.plugins;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.editors.portlet.*;
import com.plumtree.portaluiinfrastructure.login.*;
import com.plumtree.portaluiinfrastructure.resultwrapper.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author adolfoc
 *
 */
public class PSelectTemplateView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.portlet.plugins.PSelectTemplateView");

	public static final String STR_MVC_CLASS_NAME = "PSelectTemplateView";
	
	


		
	/** The HTMLID for each template to be selected from */
	public static final String HTMLRADIO_PORTLET_CREATEFROM = "in_ra_PTCreateFrom";

	/** A simple boolean for doing row coloring. */
	protected boolean m_bRowColor = true;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new PSelectTemplateView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTable myTable;

		try
		{
			result.AddInnerHTMLElement(GetHeaderView(m_asOwner.GetString(1848, "ptmsgs_portaladminmsgs")));

			// Containing Table
			myTable = PortletViewHelper.AddListTable(result);

			int nResultCount = DisplayObjectList(myTable, ((IPSelectTemplateModelRO)m_model).GetAvailableTemplates());
			if (nResultCount <= 0)
			{
				PortletViewHelper.AddSimpleLabel(myTable, 5, m_asOwner.GetString(1849, "ptmsgs_portaladminmsgs"));
			}

		}
		catch (Exception e)
		{
			
				log.Error(e, "PChooseSelectionView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(563,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}


	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	
	/** Returns a collection of rows and what not that can be added to a table. */
	public int DisplayObjectList(HTMLTable parentTable,
		IASQueryResult ptQRtoDisplay)

	{
		String strLangID = (String) PTPersonalSettingsHelper.GetPersonalSettingValue(PersonalSettingsHelper.LANGUAGE, m_asOwner);
		
		HTMLTableRow myRow;
		HTMLTableCell myCell;

		int nMaxCount = ptQRtoDisplay.GetCount();
		int nNotShown = 0;


		for (int nRowIndex = 0; nRowIndex < nMaxCount; nRowIndex++)
		{
			int nAlignment = PortletViewHelper.GetQRValueAsInt(ptQRtoDisplay, nRowIndex, PT_PROPIDS.PT_PROPID_GADGET_ALIGNMENT);
			if (((nAlignment == PT_GADGET_ALIGNMENTS.PT_GADGETALIGN_HEADER || 
				 nAlignment == PT_GADGET_ALIGNMENTS.PT_GADGETALIGN_FOOTER) &&
				 !((IPSelectTemplateModelRO) m_model).GetShowHeaderAndFooter()) || 
				(nAlignment == PT_GADGET_ALIGNMENTS.PT_GADGETALIGN_FREEFORM && !((IPSelectTemplateModelRO) m_model).GetShowFreeForm()) ) 
			{
				nNotShown++;
			} 
			else 
			{
				
				myRow = PortletViewHelper.AddRow(parentTable);
	
				// Add Radio Button
				int nObjectID  = PortletViewHelper.GetQRValueAsInt(ptQRtoDisplay,
						nRowIndex, PT_PROPIDS.PT_PROPID_OBJECTID);
	
				boolean bSelected = (nObjectID == ((IPSelectTemplateModelRO)m_model).GetPortletTemplateID());
				
				myCell = PortletViewHelper.AddCell(myRow, CommonHTMLStrings.ONE);
				myCell.AddInnerHTMLElement(PortletViewHelper.MakeSimpleRadio("", HTMLRADIO_PORTLET_CREATEFROM, XPConvert.ToString(nObjectID), bSelected, ""));
				myCell.SetWidth("20");			
	
				PortletViewHelper.SetRowColor(myCell, m_bRowColor);
				
				// Icon
				String strProvCLSID = PortletViewHelper.GetQRValueAsString(ptQRtoDisplay,
						nRowIndex, PT_PROPIDS.PT_PROPID_GADGET_PROVIDERCLSID);
			
				myCell = PortletViewHelper.AddIconCell(myRow, CommonHTMLStrings.ONE,
						PT_CLASSIDS.PT_GADGETTEMPLATE_ID, strProvCLSID, strLangID);
	
				// Do the alternate color line thingy.
				PortletViewHelper.SetRowColor(myCell, m_bRowColor);
	
				// Name
	
				String strName = PortletViewHelper.GetQRValueAsString(ptQRtoDisplay,
						nRowIndex, PT_PROPIDS.PT_PROPID_NAME);
				String strDesc = PortletViewHelper.GetQRValueAsString(ptQRtoDisplay, nRowIndex, PT_PROPIDS.PT_PROPID_DESCRIPTION);
	
				myCell		   = PortletViewHelper.AddLabelCell(myRow, CommonHTMLStrings.THREE, strName);
				HTMLSpan mySpan = PortletViewHelper.AddSpanToCell(myCell);
				mySpan.AddInnerHTMLElement(new HTMLBr());
				mySpan.AddInnerHTMLEncodedString(strDesc);
	
	
				// Do the alternate color line thingy.
				PortletViewHelper.SetRowColor(myCell, m_bRowColor);
	
				m_bRowColor = !m_bRowColor;
			}
		}

		return nMaxCount - nNotShown;
	}
	
}

