package com.plumtree.portalpages.admin.editors.portletbundle;

//Server import
import com.plumtree.portalpages.common.helpers.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.*;
import com.plumtree.portaluiinfrastructure.opener.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.arraywrapper.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This Section contains the HTML for the dependencies page.
 *
 * @author 
 */
public class PortletBundleDependenciesView extends ObjDependenciesView
{
	//Member variables
	private CreatedHelper m_chHelper	  = null;


	/**
	 * Class name for the activity space
	 */
	public static final String STR_MVC_CLASS_NAME = "PortletBundleDependencies";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new PortletBundleDependenciesView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(com.plumtree.uiinfrastructure.activityspace.IModelRO, com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		super.Init(model, parent);
		m_chHelper = new CreatedHelper(parent, (PortletBundleModel) model);
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.ObjDependenciesView#GetHTMLForDependencies()
	 */
	protected HTMLElementCollection GetHTMLForDependencies()

	{
		HTMLElementCollection result = new HTMLElementCollection();

		//Display the standard success message
		m_chHelper.displaySuccessMessage(result, m_asOwner.GetString(2129, "ptmsgs_portaladminmsgs"), ((ObjEditorModel) m_model).GetObjectName(), ((ObjEditorModel) m_model).GetParentFolderPath());

		SelectPTObjectModel mySelectPTObjectModel = (SelectPTObjectModel) m_asOwner.GetModel(
						PortletBundleEditorAS.strStorageSelectPTObject);

		PTGrowableSortedArrayWrapper arrOperations = mySelectPTObjectModel.GetItems();

		//If there are no operations, warn the user and provide a link back to the job editor
		if ( (null == arrOperations) || (arrOperations.GetCount() == 0) )
		{
			m_chHelper.displayTextRow(result, m_asOwner.GetString(2131, "ptmsgs_portaladminmsgs"), null);

			m_chHelper.beginList(result);

			m_chHelper.displayListRow(PlumtreeHelpers.MakeCreateObjectLink(
					PT_CLASSIDS.PT_GADGETBUNDLE_ID, null,
					((PortletBundleModel)m_model).GetObjectID(), m_asOwner.GetString(2132, "ptmsgs_portaladminmsgs"), m_asOwner, IPTOpenerConstants.OPENER_MODE_EDIT, null, true));
		}
		else
		{
			//Text: This job will display the following portlets:
			m_chHelper.displayTextRow(result, m_asOwner.GetString(2130, "ptmsgs_portaladminmsgs"), null);
			//Start a list of portlets
			m_chHelper.beginList(result);

			for (int i=0; i < arrOperations.GetCount(); i++)
			{
				m_chHelper.displayListRow((String) arrOperations.GetItem(i, SelectPTObjectModel.EXPLIST_COL_STRING));
			}
		}

		//Display the standard warning if everyone has access to this object
		m_chHelper.displayEveryoneWarning(result, m_model, m_asOwner.GetString(2129, "ptmsgs_portaladminmsgs"));

		return result;
	}
}

