package com.plumtree.portalpages.admin.editors.profilesource;


// Framework Imports
import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 *
 */
public class ClearHistoryView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.profilesource.ClearHistoryView");

	/**
	 * Class name for the activity space */
	public static final String STR_MVC_CLASS_NAME = "ClearHistory";

	/**
	 */
	public static final String BUTTON_CLEAR = "in_bu_clearhistory";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new ClearHistoryView();
	}

	/**
	 *
	 * @return
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTableCell myCell;
		HTMLTableRow myRow;
		HTMLTable myTable;

		try
		{
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(1860, "ptmsgs_portaladminmsgs")));

			//result.AddInnerHTMLElement(super.GetShortSpacerTable());

			// mj: do the instructions table
			myTable = ProfileSourceHelper.ConstructInstructionsTable(m_asOwner.GetString(1861, "ptmsgs_portaladminmsgs"));
			result.AddInnerHTMLElement(myTable);
			result.AddInnerHTMLElement(EditorView.GetShortSpacerTable());

			// mj: construct the control
			myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("5");
			myTable.SetCellSpacing("0");

			//myTable.SetAlign("left");
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			// mj: cell for dropdown
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);

            HTMLInput myButton = new HTMLInput(HTMLInputTypes.BUTTON, BUTTON_CLEAR, "");

            myCell.AddInnerHTMLElement(myButton);
            myButton.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);

            myButton.SetValue(m_asOwner.GetString(1860, "ptmsgs_portaladminmsgs"));
            myButton.SetOnClick("postToSelf(" +
                ProfileSourceRepostControl.POSTTOSELF_ACTION_CLEAR_HISTORY +
                "); return false;");
		}
		catch (Exception e)
		{
			
				log.Error(e, "AuthPartnerView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(1862, "ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}

