package com.plumtree.portalpages.admin.editors.profilesource;


// Framework Imports
import com.plumtree.portaluiinfrastructure.editor.*;

/**
 *
 *
 */
public interface IProfileSourceModelRO extends IObjEditorModelRO
{
	/**
	 *
	 *
	 * @return
	 */
	public String[][] GetPartnerList();

	/**
	 *
	 *
	 * @return
	 */
	public Object[][] GetPartnerQueryFilter();

	/**
	 *
	 *
	 * @return
	 */
	public String GetProviderCLSID();

	/**
	 *
	 *
	 * @return
	 */
	public int GetSelectedPartner();

	/**
	 *
	 *
	 * @return
	 */
	public boolean IsPartnerSupported();

	/**
	 *
	 *
	 * @return
	 */
	public String GetPropertyMapInstructions();
	
	/**
	 * Returns the unique key (property ID) that will be sent to 
	 * the providers during a profile sync.  If the unique key
	 * returned is <0, It should be checked against the 
	 * PT_PROFILE_UNIQUE_KEYS enum.
	 * 
	 * @return the unique key prop id
	 */
	public int GetUniqueKey();
	
	/**
	 * If a real property is selected, return the name of the 
	 * property for easy viewing...
	 * 
	 * @return the name of the property...
	 */
	public String GetUniqueKeyPropertyName();
	
	/**
	 * Returns the unique key picker space ID.  This is used to
	 * track tree picker instances so that if you click the 
	 * button to pick a group twice, you get the same tree.
	 * 
	 * @return the unique key picker space id
	 */
	public String GetUniqueKeyPickerSpaceID();
	
	/**
	 * Returns a comma-delimited list of property IDs that
	 * are mapped to the user object.
	 */
	public String GetUserProperties();
}

