package com.plumtree.portalpages.admin.editors.profilesource;


// Framework Imports
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 *
 */
public class PropertyMapDP extends EditorDP
{
	public static final String STR_MVC_CLASS_NAME = "PropertyMap";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return (m_asOwner.GetString(649, "ptmsgs_portaladminmsgs"));
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader()  {
		IProfileSourceModelRO model = (IProfileSourceModelRO)
			m_asOwner.GetModel(m_asOwner.m_strModelName);
		return HTMLConstructHelpers.GetSubHeader(model.GetPropertyMapInstructions(), m_asOwner);
//		return HTMLConstructHelpers.GetSubHeader(
//			m_asOwner.GetString(2437, "ptmsgs_portaladminmsgs"),
//			this.m_asOwner);
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the General Info page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 *
	 * @return HTMLElement
	 */
	public HTMLElement PageDisplay()

	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
				ProfileSourceEditorAS.strPTMultiColumnList)).Display());

		//views.AddInnerHTMLElement(((EditorView)
		//	m_asOwner.GetView(PropertyMapView.STR_MVC_CLASS_NAME)).Display());
		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
				ProfileSourceEditorAS.strPTMultiColumnList).DisplayJavascript());

		return myScripts;
	}
}

