package com.plumtree.portalpages.admin.editors.propertymap;

import com.plumtree.uiinfrastructure.editor.*;

/**
 *
 *
 * @author OlegS
 */
public class PropertyMapEditorRepostControl extends EditorRepostControl
{

	public static final String STR_MVC_CLASS_NAME = "PropertyMapEditorRepost";


	public final static int ACTION_ADD = 10;


	public final static int ACTION_DEL = 11;


	public final static int ACTION_SORT = 12;


	public final static int ACTION_EDIT = 1000; // + property id

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new PropertyMapEditorRepostControl();
	}

	/**
	 *
	 *
	 * @return
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 *
	 *
	 * @param _nAction
	 */
	protected void PerformAction(int _nAction)
	{
		super.PerformAction(_nAction);

		PropertyMapEditorModel m = (PropertyMapEditorModel) m_model;

		switch (_nAction)
		{
		case POSTTOSELF_ACTION_FINISH:

			// we use DoTaskBeforeStore()
			break;

		case ACTION_ADD:
			m.OnAdd();

			break;

		case ACTION_DEL:
			m.OnDel();

			break;

		case ACTION_SORT:
			m.OnSort();

			break;

		default:

			if (_nAction >= 1000)
			{
				m.OnEdit(_nAction - 1000);
			}

			break;
		}
	}

	/**
	 *
	 */
	protected void SetRepostAction()
	{
		super.SetRepostAction();
		GetModel().m_nAction = m_nAction;
	}

	/**
	 *
	 *
	 * @return
	 */
	protected PropertyMapEditorModel GetModel()
	{
		return (PropertyMapEditorModel) m_model;
	}
}

