package com.plumtree.portalpages.admin.editors.remoteserver;

import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.resultwrapper.*;

/**
 * @author adolfoc
 */
public interface IRemoteServerModelRO extends IObjEditorModelRO
{
	/**
	 * Returns a QueryResult of all of the Associated Web Services
	 * @return IPTQueryResult
	 */
	public IASQueryResult GetAssocWebServices();

	/**
	 * Returns the strAuthTypeRadio.
	 * @return int
	 */
	public int GetAuthType();

	/**
	 * Returns the strBaseURL.
	 * @return String
	 */
	public String GetBaseURL();

	/**
	 * Returns the strLoginName.
	 * @return String
	 */
	public String GetLoginName();

	/**
	 * Returns the public key.
	 * @return String
	 */
	public String GetPublicKey();
}

