package com.plumtree.portalpages.admin.editors.remoteserver;


// Framework imports
import com.plumtree.portalpages.common.helpers.*;
import com.plumtree.portaluiinfrastructure.classtypedescriptors.classtypes.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This Section contains the HTML for the dependencies page.
 *
 * @author
 */
public class RemoteServerDependenciesView extends ObjDependenciesView
{
	/**
	 * Class name for the activity space
	 */
	public static final String STR_MVC_CLASS_NAME = "RemoteServerDependencies";

	public static final int OFFSET = -1; // <0 use default, 0 none, >0 use specified

	public static final int BREAK = -1; // <0 use default, 0 none, >0 use specified
	protected CreatedHelper m_chHelper	  = null;

	/** Function name for the javascript used to open Web services based on this remote server */
	public static final String JS_OPENWS = "OpenWebServiceDependency";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new RemoteServerDependenciesView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(com.plumtree.uiinfrastructure.activityspace.IModelRO, com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		super.Init(model, parent);
		m_chHelper = new CreatedHelper(parent, (RemoteServerModel) model);
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.ObjDependenciesView#GetHTMLForDependencies()
	 */
	protected HTMLElementCollection GetHTMLForDependencies()
	{

		HTMLElementCollection result = new HTMLElementCollection();

		m_chHelper.displayEmptyRow(result);
		m_chHelper.displayTextRow(result, m_asOwner.GetString(1871, "ptmsgs_portaladminmsgs"), null);
		m_chHelper.displayTextRow(result, OFFSET, m_asOwner.GetString(1870, "ptmsgs_portaladminmsgs"),
			((ObjEditorModel) m_model).GetObjectName());
		m_chHelper.displayTextRow(result, OFFSET, m_asOwner.GetString(1872, "ptmsgs_portaladminmsgs"),
			((ObjEditorModel) m_model).GetParentFolderPath(), BREAK);

		m_chHelper.displayEmptyRow(result);
		m_chHelper.displayTextRow(result, m_asOwner.GetString(1873, "ptmsgs_portaladminmsgs"), null);
		m_chHelper.beginList(result);


		String strArg = "&" + PTWebServices.QS_WS_REMOTE_SERVER + "=" + ((RemoteServerModel)m_model).GetObjectID();

		int nFolderID = ((ObjEditorModel) m_model).GetFolderID();
		m_chHelper.displayListRow(RSViewHelper.MakeCreateObjectLink(
				PT_CLASSIDS.PT_WEBSERVICE_ID, RSModelHelper.WSTYPE_AWS,
				nFolderID, m_asOwner.GetString(1874, "ptmsgs_portaladminmsgs"), m_asOwner, strArg, true));
		m_chHelper.displayListRow(RSViewHelper.MakeCreateObjectLink(
				PT_CLASSIDS.PT_WEBSERVICE_ID, RSModelHelper.WSTYPE_CWS,
				nFolderID, m_asOwner.GetString(1876, "ptmsgs_portaladminmsgs"), m_asOwner, strArg, true));
		m_chHelper.displayListRow(RSViewHelper.MakeCreateObjectLink(
				PT_CLASSIDS.PT_WEBSERVICE_ID, RSModelHelper.WSTYPE_HTTPGP,
				nFolderID, m_asOwner.GetString(1875, "ptmsgs_portaladminmsgs"), m_asOwner, strArg, true));
		m_chHelper.displayListRow(RSViewHelper.MakeCreateObjectLink(
				PT_CLASSIDS.PT_WEBSERVICE_ID, RSModelHelper.WSTYPE_SWS,
				nFolderID, m_asOwner.GetString(1877, "ptmsgs_portaladminmsgs"), m_asOwner, strArg, true));
		m_chHelper.displayListRow(RSViewHelper.MakeCreateObjectLink(
				PT_CLASSIDS.PT_WEBSERVICE_ID, RSModelHelper.WSTYPE_PWS,
				nFolderID, m_asOwner.GetString(1878, "ptmsgs_portaladminmsgs"), m_asOwner, strArg, true));

		m_chHelper.displayEmptyRow(result);

		//Display the standard warning if everyone has access to this object
		m_chHelper.displayEveryoneWarning(result, (RemoteServerModel) m_model, m_asOwner.GetString(2270, "ptmsgs_portaladminmsgs"));

		return result;
	}
}

