package com.plumtree.portalpages.admin.editors.savedsearch;


// Framework Imports
import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.filter.*;
import com.plumtree.portaluiinfrastructure.resultwrapper.*;
import com.plumtree.server.*;

/**
 * @author MikeS
 *
 * ???
 */
public interface ISavedSearchModelRO extends IObjEditorModelRO, IFilterIteratorContainerRO
{
	/**
	 *
	 *
	 * @return
	 */
	public boolean AreClassIDsShown();

	/**
	 *
	 *
	 * @return
	 */
	public IPTSearchResponse GenerateResponse();

	/**
	 *
	 *
	 * @return
	 */
	public XPArrayList GetAdmFolderIDs();

	/**
	 *
	 *
	 * @return
	 */
	public XPArrayList GetCatFolderIDs();

	/**
	 *
	 *
	 * @return
	 */
	public XPArrayList GetSelectedFolderIDs(int _type, boolean _accessible);

	/**
	 *
	 *
	 * @return
	 */
	public String GetLastAdmTreeSpaceId();

	/**
	 *
	 *
	 * @return
	 */
	public String GetLastCatTreeSpaceId();

	/**
	 *
	 *
	 * @return
	 */
	public int GetMaxResults();

	/**
	 *
	 *
	 * @return
	 * 
	 * @deprecated the portlet format & presentation style are now set via the portlet editor 
	 */
	public String GetPortletFormat();

	/**
	 *
	 *
	 * @return
	 */
	public IASQueryResult GetProperties();

	/**
	 *
	 *
	 * @return
	 */
	public String GetSelectedOrderProp();

	/**
	 *
	 *
	 * @return
	 */
	public boolean GetSortAscending();

	/**
	 *
	 *
	 * @return
	 */
	public boolean IsAscending();

	/**
	 *
	 *
	 * @param strClassid
	 *
	 * @return
	 */
	public boolean IsClassIDChecked(String strClassid);

	/**
	 *
	 *
	 * @return
	 */
	public boolean ShouldRegenerate();

	/**
	 *
	 *
	 * @return
	 */
	public boolean SubscriptionEnabled();
	
	/**
	 * 
	 * @return
	 */
	public boolean GetApplyRecursive();
	
	/**
	 * 
	 * @return
	 */
	public int[] GetDisplayFields();
	
	/**
	 *
	 *
	 * @return
	 */
	public Object[][] GetDisplayFieldsInfo();

	/**
	 * Returns a bitmask of the enabled repositories.
	 * 
	 * Possible Repositories:
	 * 	SavedSearchModel.REPOSITORY_KD
	 *  SavedSearchModel.REPOSITORY_ADMIN
	 *  SavedSearchModel.REPOSITORY_COLLAB
	 *  SavedSearchModel.REPOSITORY_CONTENT
	 * 
	 * @return bitmask of enabled repsitories.
	 */
	public int GetRepositories();

	/**
	 * Returns a bitmask of the enabled knowledge directory types.
	 * 
	 * Possible KD Types:
	 * 	SavedSearchModel.KDTYPES_FOLDERS
	 *  SavedSearchModel.KDTYPES_DOCUMENTS
	 * 
	 * @return bitmask of enabled knowledge directory types.
	 */
	public int GetKDTypes();
	
	public boolean IsCollabInstalled();
	
	public boolean IsContentInstalled();
}