package com.plumtree.portalpages.admin.editors.savedsearch;

import com.plumtree.portalpages.common.objects.sort.*;
import com.plumtree.server.*;

/**
 * @author RajaM
 *
 */
public class PTFolderObjectNameGetter implements IPTObjectNameGetter
{
	private int m_classid;

	/**
	 * Creates a new PTFolderObjectNameGetter object.
	 *
	 * @param classid
	 */
	public PTFolderObjectNameGetter(int classid)
	{
		m_classid = classid;
	}


	public String GetName(int id, IPTSession ptSession)
	{
		String[] strName = GetItem(id, ptSession);
		if (null != strName)
			return strName[0];
		else
			return null;
	}
	/**
	 *
	 *
	 * @param id
	 * @param ptSession
	 *
	 * @return
	 */
	public String[] GetItem(int id, IPTSession ptSession)
	{
		String[] strFolderInfo = new String[2];
		try
		{
			if (m_classid == PT_CLASSIDS.PT_CATALOGFOLDER_ID)
			{
				IPTFolder ptFolder;

				ptFolder = ptSession.GetCatalog().OpenFolder(id, false);
				if (null != ptFolder)
				{
					strFolderInfo[0] = ptFolder.GetLocalizedName();
					strFolderInfo[1] = ptFolder.GetPath();
					return strFolderInfo;
				}
				else
					return null;
			}
			else
			{
				IPTAdminFolder ptFolder = ptSession.GetAdminCatalog()
					.OpenAdminFolder(id, false);

				if (null != ptFolder)
				{
					strFolderInfo[0] = ptFolder.GetLocalizedName();
					strFolderInfo[1] = ptFolder.GetPath();
					return strFolderInfo;
				}
				else
					return null;
			}
		}
		catch(Exception e)
		{
			strFolderInfo[0] = "";
			strFolderInfo[1] = "";
			return strFolderInfo;
		}
	}
}

