package com.plumtree.portalpages.admin.editors.savedsearch;


// Framework Imports
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 * @author $author$
 */
public class ResultFormatDP extends EditorDP
{
	public static final String STR_MVC_CLASS_NAME = "ResultFormatDP";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return (m_asOwner.GetString(745, "ptmsgs_portaladminmsgs"));
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader(){
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(2438, "ptmsgs_portaladminmsgs"),
			this.m_asOwner);
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the General Info page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 *
	 * @return HTMLElement
	 */
	public HTMLElement PageDisplay()

	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
				ResultFormatView.STR_MVC_CLASS_NAME)).Display());
		
		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}
	
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.form.AFormDP#DisplayJavaScriptFromChild()
     */
    protected HTMLScriptCollection DisplayJavaScriptFromChild() 
    {
// TODO: jhq- inplace refresh
//        m_asOwner.SetIsInPlaceRefreshEnabled(true);
//        m_asOwner.SetIsInPlaceRefreshDisplayOn(true);

        HTMLScriptCollection scripts = super.DisplayJavaScriptFromChild();
        
        scripts.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
				ResultFormatView.STR_MVC_CLASS_NAME)).DisplayJavascript());
        
        return scripts;
    }
}

