package com.plumtree.portalpages.admin.editors.savedsearch;


// Framework Imports
import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.constants.*;
import com.plumtree.portalpages.common.search.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author MichaelS
 * 
 * This class used be named SavSrchSettingsView and contained code for displaying
 * filtering settings & folder constraints settings.  All the code for folder constraints
 * have been moved elsewhere as follows:
 * 
 * SavSrchMainDP - All common tree control code
 * SnapshotADConstraintsView - Display of Admin folders
 * SnapshotKDConstraintsView - Display of Knowledge Dir folders
 */
public class SavSrchFilterView extends FilterView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.savedsearch.SavSrchFilterView");

	/** The unique identifier for the class */
	public static final String STR_MVC_CLASS_NAME = "SavSrchFilter";

	/** Checkbox for move */
	public static final String HTMLCHECKBOX_MOVE	  = "in_cb_move";

	// member variables
	protected PTStyleClass m_styleListItem = null;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SavSrchFilterView();
	}

	/**
	 * Display for the HTML for this view
	 *
	 * @return HTMLElement
	 */
	public HTMLElement Display()
	{
		SetStatementCount(5);

		HTMLElementCollection result = new HTMLElementCollection();

		try
		{
			super.SetViewTitle(m_asOwner.GetString(777, "ptmsgs_portaladminmsgs"));
			result.AddInnerHTMLElement(super.Display());
		}
		catch (Exception e)
		{
			
			log.Error(e, "SavSrchFilterView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			
			throw new XPException(m_asOwner.GetString(2974, ResourceConstants.PORTALADMINMSGS), e);
		}

		return result;
	}

	/**
	 * Display the javascript for this view
	 *
	 * @return HTMLScript
	 */
	public HTMLScript DisplayJavascript()
	{
		super.SetRepostAction(SavedSearchRepostControl.POSTTOSELF_ACTION_SIMPLEREPOST);
		return super.DisplayJavascript();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}