package com.plumtree.portalpages.admin.editors.savedsearch;


// Framework Imports
import com.plumtree.portalpages.common.documentlanguage.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.expandablelist.*;

/**
* @author MikeS
 *
 */
public class SavedSearchRepostControl extends ObjEditorRepostControl
{
	/** The unique name for this class */
	public static final String STR_MVC_CLASS_NAME = "SavedSearchRepost";

	/** Add an admin folder */
	public final static int ACTION_ADDADMINFOLDER 		= 10;

	/** Delete an Admin folder */
	public final static int ACTION_DEL			  		= 11;

	/** Sort the folders */
	public final static int ACTION_SORT			  		= 12;

	/** Add a catalog folder */
	public final static int ACTION_ADDCATALOGFOLDER 	= 13;
	
	/** Add a catalog folder */
	public final static int ACTION_CREATE_PORTLET 		= 14;

	
	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SavedSearchRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Switch between the action modes and call
	 * the associated method for each action.
	 *
	 * @param _nAction
	 */
	protected void PerformAction(int _nAction)
	{
		super.PerformAction(_nAction);

		((CardLanguagePlugInRepostControl) m_asOwner.GetControl(SavedSearchEditorAS.strCardLanguagePlugInKey)).PerformRepostAction(_nAction,
			m_htFormData);

		((ExpListControl) m_asOwner.GetControl(SavedSearchEditorAS.STR_MVC_SELECT_COLLAB_PROJECT)).PerformRepostAction(_nAction, m_htFormData);
		((ExpListControl) m_asOwner.GetControl(SavedSearchEditorAS.STR_MVC_SELECT_DISPLAY_PROPS)).PerformRepostAction(_nAction, m_htFormData);
		((ExpListControl) m_asOwner.GetControl(SavedSearchEditorAS.STR_MVC_SELECT_CONTENT)).PerformRepostAction(_nAction, m_htFormData);
		((ExpListControl) m_asOwner.GetControl(SavedSearchEditorAS.STR_MVC_SELECT_PORTLETS)).PerformRepostAction(_nAction, m_htFormData);
		
		if (_nAction > 1000)
		{
			_nAction -= 1000;
		}

		switch (_nAction)
		{
		case SavedSearchRepostControl.POSTTOSELF_ACTION_GOTOPAGE:
		case SavedSearchRepostControl.POSTTOSELF_ACTION_FINISH:
		case CardLanguagePlugInRepostControl.POSTTOSELF_ACTION_SHOW_POPULAR:
		case CardLanguagePlugInRepostControl.POSTTOSELF_ACTION_SHOW_ALL:
		case SavedSearchRepostControl.POSTTOSELF_ACTION_SIMPLEREPOST:
			break;

		case ACTION_ADDADMINFOLDER:
			((SavedSearchModel) m_model).OnAdd(ACTION_ADDADMINFOLDER);

			break;

		case ACTION_ADDCATALOGFOLDER:
			((SavedSearchModel) m_model).OnAdd(ACTION_ADDCATALOGFOLDER);

			break;

		case ACTION_DEL:
			((SavedSearchModel) m_model).OnDel();

			break;

		case ACTION_SORT:
			((SavedSearchModel) m_model).OnSort();
			break;
			
		case ACTION_CREATE_PORTLET:
		    ((SavedSearchModel) m_model).OnCreatePortlet();
		    break;
		}
	}

	/**
	 * Set the repost action
	 */
	protected void SetRepostAction()
	{
		super.SetRepostAction();
		GetModel().m_nAction = m_nAction;
	}

	/**
	 *
	 *
	 * @return
	 */
	protected SavedSearchModel GetModel()
	{
		return (SavedSearchModel) m_model;
	}
}

