package com.plumtree.portalpages.admin.editors.subportal;

// Server import
import com.plumtree.portalpages.common.helpers.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This Section contains the HTML for the dependencies page.
 *
 * @author
 */
public class SubPortalDependenciesView extends ObjDependenciesView
{
	//Member variables
	private CreatedHelper m_chHelper	  = null;


	/**
	 * Class name for the activity space
	 */
	public static final String STR_MVC_CLASS_NAME = "SubPortalDependenciesView";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SubPortalDependenciesView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(com.plumtree.uiinfrastructure.activityspace.IModelRO, com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		super.Init(model, parent);
		m_chHelper = new CreatedHelper(parent, (SubPortalModel) model);
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.ObjDependenciesView#GetHTMLForDependencies()
	 */
	protected HTMLElementCollection GetHTMLForDependencies()

	{
		HTMLElementCollection result = new HTMLElementCollection();

		//Display the standard success message
		m_chHelper.displayEmptyRow(result);
//fixed string concatenation	m_chHelper.displayTextRow(result, m_asOwner.GetString(635, "ptmsgs_portalcommonmsgs") + m_asOwner.GetString(2275, "ptmsgs_portaladminmsgs"), null);
		m_chHelper.displayTextRow(result, m_asOwner.GetString(696, "ptmsgs_portalcommonmsgs"), null);
		m_chHelper.displayTextRow(result, -1, m_asOwner.GetString(2275, "ptmsgs_portaladminmsgs") + ":",
			((ObjEditorModel) m_model).GetObjectName());

		m_chHelper.displayTextRow(result, m_asOwner.GetString(2276, "ptmsgs_portaladminmsgs"), null);
		//Start a list of portlets
		m_chHelper.beginList(result);

		int intAccessType = ((ISubPortalModelRO) m_model).GetAccessType();

		if ((PT_SUBPORTAL_ACCESS_TYPES.PT_SUBPORTAL_MYPAGES_ACCESS & intAccessType) != 0)
		{
			m_chHelper.displayListRow(m_asOwner.GetString(2277, "ptmsgs_portaladminmsgs"));
		} 
		if ((PT_SUBPORTAL_ACCESS_TYPES.PT_SUBPORTAL_COMMUNITIES_ACCESS & intAccessType) != 0)
		{
			m_chHelper.displayListRow(m_asOwner.GetString(2278, "ptmsgs_portaladminmsgs"));
		}
		if ((PT_SUBPORTAL_ACCESS_TYPES.PT_SUBPORTAL_DIRECTORY_ACCESS & intAccessType) != 0)
		{
			m_chHelper.displayListRow(m_asOwner.GetString(2279, "ptmsgs_portaladminmsgs"));
		}
		
		int intDefaultAccess = ((ISubPortalModelRO) m_model).GetDefaultFirstPageType();
		String strDefaultAccess = "";
		
		if (PT_SUBPORTAL_ACCESS_TYPES.PT_SUBPORTAL_MYPAGES_ACCESS == intDefaultAccess)
		{
			strDefaultAccess = m_asOwner.GetString(2277, "ptmsgs_portaladminmsgs");
		} else if (PT_SUBPORTAL_ACCESS_TYPES.PT_SUBPORTAL_COMMUNITIES_ACCESS == intDefaultAccess)
		{
			strDefaultAccess = m_asOwner.GetString(2278, "ptmsgs_portaladminmsgs");
		} else if (PT_SUBPORTAL_ACCESS_TYPES.PT_SUBPORTAL_DIRECTORY_ACCESS == intDefaultAccess)
		{
			strDefaultAccess = m_asOwner.GetString(2279, "ptmsgs_portaladminmsgs");
		}
		
		m_chHelper.displayTextRow(result, m_asOwner.GetString(2280, "ptmsgs_portaladminmsgs") + strDefaultAccess, null);

		//Display the standard warning if everyone has access to this object
		m_chHelper.displayEveryoneWarning(result, (SubPortalModel) m_model, m_asOwner.GetString(2275, "ptmsgs_portaladminmsgs"));

		return result;
	}
}

