package com.plumtree.portalpages.admin.editors.user;


// Framework Imports
import com.plumtree.portaluiinfrastructure.editor.*;

/**
 *
 * @author SudhaS
 */

public interface IUserModelRO extends IObjEditorModelRO
{
	/**
	 *
	 *
	 * @return
	 */
	public boolean GetDisabled();

	/**
	 *
	 *
	 * @return
	 */
	public String GetLoginName();

	/**
	 *
	 *
	 * @return
	 */
	public String GetPassword();
	
	/**
	 *
	 *
	 * @return
	 */
	public String GetConfirmPassword();

	/**
	 *
	 *
	 * @return
	 */
	public boolean EditingInDefaultProfilesFolder();

	/**
	 * Returns true if the User Type of the user is guest.
	 *
	 * @return
	 */
	public boolean EditingGuestUser();

	/**
	 * Return true if the user is locked.
	 * 
	 * @return
	 */
	public boolean EditingLockedAccount();
	
	public String GetUserMobileName();

	public String GetUserMobilePsswrd();
	
	public boolean IsPlumtreeAuthSource();

	public boolean IsCurrentUserAdministrator();
	
	/**
	 * Returns whether the guest account type is editable.
	 * @return
	 */
	public boolean UserTypeEditable();
	
	/**
	 * Returns <code>true</code> if the user is tied
	 * to a remote authentication source.  Otherwise,
	 * <code>false</code> is returned.
	 * 
	 * @return boolean indicating remote status
	 */
	public boolean IsRemoteUser();

	/**
	 * Returns the user's auth user name - the name
	 * sent to a remote provider in order to authenticate
	 * the user.
	 * 
	 * @return String representing the authentication user name
	 */
	public String GetAuthUsername();
	
	/**
	 * Returns the user's auth unique name - the unique key
	 * sent by a remote provider to identify the user.
	 * 
	 * @return String representing the remote unique name
	 */
	public String GetUniqueUsername();
	
	/**
	 * Returns <code>true</code> if the password is supposed
	 * to be set to expired when this editor finishes.  Otherwise,
	 * <code>false</code> is returned.
	 * 
	 * @return boolean indicating whether or not the password should
	 * be set to expired
	 */
	public boolean GetExpirePassword();

	/**
	 * Returns <code>true</code> if the Expire Password feature
	 * is enabled for this editor.  Otherwise,
	 * <code>false</code> is returned.
	 * 
	 * @return boolean indicating whether or not the Expire Password
	 * feature is enabled
	 */
	public boolean GetExpirePasswordEnabled();
}