package com.plumtree.portalpages.admin.editors.user;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.constants.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 * @author SudhaS
 */
public class LoginView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.user.LoginView");

	public static final String STR_MVC_CLASS_NAME = "UsrLogin";


	public static final String HTMLINPUT_LOGIN_NAME						= "in_tx_CreateName";
	public static final String HTMLINPUT_PASSWORD_NAME					= "in_pw_CreateLogin";
	public static final String HTMLINPUT_CONFIRM_PASSWORD_NAME			= "in_pw_ConfirmLogin";
	public static final String HTMLINPUT_CHECKBOX_DISABLE_NAME			= "in_cb_Disable";
	public static final String HTMLINPUT_CHECKBOX_GUEST_NAME			= "in_cb_guest";
	public static final String HTMLINPUT_CHECKBOX_EXPIRE_PASSWORD_NAME	= "in_cb_OneTime";
	
	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new LoginView();
	}

	/**
	 *
	 *
	 * @return
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTable myTable;
		HTMLTableCell myCell;
		HTMLTableRow myRow;
		HTMLInput myInput;

		boolean bEditingDefaultProfileUser = ((IUserModelRO)m_model).EditingInDefaultProfilesFolder();
		boolean bIsPlumtreeAuthSource = ((IUserModelRO)m_model).IsPlumtreeAuthSource();
		boolean bEditingGuestUser = ((IUserModelRO)m_model).EditingGuestUser();
		boolean bIsCurrentUserAdministrator = ((IUserModelRO)m_model).IsCurrentUserAdministrator();
		boolean bEditingLockedAccount = ((IUserModelRO)m_model).EditingLockedAccount();

		try
		{
			if(bEditingDefaultProfileUser && bEditingLockedAccount)
			{
				myTable = new HTMLTable();
				result.AddInnerHTMLElement(myTable);
				myTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
				myTable.SetBorder(CommonHTMLStrings.ZERO);
				myTable.SetCellPadding(CommonHTMLStrings.ZERO);
				myTable.SetCellSpacing(CommonHTMLStrings.ZERO);

				myRow = new HTMLTableRow();
				myTable.AddInnerHTMLElement(myRow);

				myCell = new HTMLTableCell();
				myRow.AddInnerHTMLElement(myCell);
				myCell.SetStyleClass(PTStyleClass.ALERT_REQUIRED_TEXT);
				myCell.SetAlign(CommonHTMLStrings.CENTER);
				myCell.AddInnerHTMLString(m_asOwner.GetString(1904, ResourceConstants.PORTALADMINMSGS));
				myCell.AddInnerHTMLElement(new HTMLBr());
			}

			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						947, ResourceConstants.PORTALADMINMSGS)));

			myTable = new HTMLTable();

			result.AddInnerHTMLElement(myTable);
			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("5");
			myTable.SetCellSpacing("0");

			
			/** aj: username row  **/
			myRow = new HTMLTableRow();
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
			myTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetWidth("150");
			myRow.AddInnerHTMLElement(myCell);

			myCell.AddInnerHTMLString(m_asOwner.GetString(949,
					ResourceConstants.PORTALADMINMSGS));
			myCell.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
			
			HTMLSpan mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.ALERT_REQUIRED_TEXT);
			mySpan.AddInnerHTMLString("*");

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_LOGIN_NAME,
					"This is an input");
			myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
			myInput.SetValue(((IUserModelRO) m_model).GetLoginName());
			myCell.AddInnerHTMLElement(myInput);

			
			/** aj: password row  **/
			myRow = new HTMLTableRow();
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
			myTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetWidth("150");
			myRow.AddInnerHTMLElement(myCell);

			myCell.AddInnerHTMLString(m_asOwner.GetString(950,
					ResourceConstants.PORTALADMINMSGS));
			myCell.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
			
			if (!bIsCurrentUserAdministrator && !bEditingGuestUser)
			{
				mySpan = new HTMLSpan();
				myCell.AddInnerHTMLElement(mySpan);
				mySpan.SetStyleClass(PTStyleClass.ALERT_REQUIRED_TEXT);
				mySpan.AddInnerHTMLString("*");
			}

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myInput = new HTMLInput(HTMLInputTypes.PASSWORD,
					HTMLINPUT_PASSWORD_NAME, "This is an input");
			myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
			myInput.SetValue(((IUserModelRO) m_model).GetPassword());
			//myInput.SetOnChange("CheckNotAstericks();");
			if(bEditingDefaultProfileUser || !bIsPlumtreeAuthSource || bEditingGuestUser)
			{
				myInput.SetDisabled(true);
			}
			myCell.AddInnerHTMLElement(myInput);

			
			/** aj: confirm password row **/
			myRow = new HTMLTableRow();
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
			myTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetNoWrap(true);

			myCell.AddInnerHTMLString(m_asOwner.GetString(951,
					ResourceConstants.PORTALADMINMSGS));
			myCell.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
			myRow.AddInnerHTMLElement(myCell);
			
			if (!bIsCurrentUserAdministrator && !bEditingGuestUser)
			{
				mySpan = new HTMLSpan();
				myCell.AddInnerHTMLElement(mySpan);
				mySpan.SetStyleClass(PTStyleClass.ALERT_REQUIRED_TEXT);
				mySpan.AddInnerHTMLString("*");
			}
				
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myInput = new HTMLInput(HTMLInputTypes.PASSWORD,
					HTMLINPUT_CONFIRM_PASSWORD_NAME, "This is an input");
			myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
			myInput.SetValue(((IUserModelRO) m_model).GetConfirmPassword());
			if(bEditingDefaultProfileUser || !bIsPlumtreeAuthSource || bEditingGuestUser)
			{
				myInput.SetDisabled(true);
			}
			myCell.AddInnerHTMLElement(myInput);
			
			
			// aj: remote users will have two extra rows:
			//		a) unique name
			//		b) auth name
			if(((IUserModelRO)m_model).IsRemoteUser())
			{
				/** aj: remote user unique name row **/
				myRow = new HTMLTableRow();
				myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
				myTable.AddInnerHTMLElement(myRow);
				myCell = new HTMLTableCell();
				myCell.SetWidth("150");
				myCell.AddInnerHTMLString(m_asOwner.GetString(2917,
						ResourceConstants.PORTALADMINMSGS));
				myCell.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
				myRow.AddInnerHTMLElement(myCell);
					
				myCell = new HTMLTableCell();
				myRow.AddInnerHTMLElement(myCell);
				myCell.AddInnerHTMLString(((IUserModelRO)m_model).GetUniqueUsername());
				
				
				/** aj: remote user authentication name row **/
				myRow = new HTMLTableRow();
				myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
				myTable.AddInnerHTMLElement(myRow);
				myCell = new HTMLTableCell();
				myCell.SetWidth("150");
				myCell.AddInnerHTMLString(m_asOwner.GetString(2918,
						ResourceConstants.PORTALADMINMSGS));
				myCell.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
				myRow.AddInnerHTMLElement(myCell);
					
				myCell = new HTMLTableCell();
				myRow.AddInnerHTMLElement(myCell);
				myCell.AddInnerHTMLString(((IUserModelRO)m_model).GetAuthUsername());
			}
			
			/** aj: disable user row **/
			myRow = new HTMLTableRow();
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
			myTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetWidth("150");
			myRow.AddInnerHTMLElement(myCell);

			myCell.AddInnerHTMLString(m_asOwner.GetString(952,
					ResourceConstants.PORTALADMINMSGS));
			myCell.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myInput = new HTMLInput(HTMLInputTypes.CHECKBOX,
					HTMLINPUT_CHECKBOX_DISABLE_NAME, "This is an input");
			myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
			myInput.SetChecked(((IUserModelRO) m_model).GetDisabled());
			if(bEditingDefaultProfileUser || bEditingGuestUser)
			{
				myInput.SetDisabled(true);
			}
			myCell.AddInnerHTMLElement(myInput);

			// WilliamA - Add guest account checkbox
			myRow = new HTMLTableRow();
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
			myTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetWidth("150");
			myRow.AddInnerHTMLElement(myCell);

			myCell.AddInnerHTMLString(m_asOwner.GetString(2831,
					ResourceConstants.PORTALADMINMSGS));
			myCell.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myInput = new HTMLInput(HTMLInputTypes.CHECKBOX,
					HTMLINPUT_CHECKBOX_GUEST_NAME, "This is an input");
			myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
			myInput.SetChecked(bEditingGuestUser);
			if (!((IUserModelRO) m_model).UserTypeEditable())
			{
				myInput.SetDisabled(true);
			} else
			{
				myInput.SetOnClick("CheckGuestAccount()");
			}
			myCell.AddInnerHTMLElement(myInput);

			// DLH - Expire Password checkbox row
			myRow = new HTMLTableRow();
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
			myTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetWidth("150");
			myRow.AddInnerHTMLElement(myCell);

			myCell.AddInnerHTMLString(m_asOwner.GetString(3268, ResourceConstants.PORTALADMINMSGS));
			myCell.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myInput = new HTMLInput(HTMLInputTypes.CHECKBOX,
				HTMLINPUT_CHECKBOX_EXPIRE_PASSWORD_NAME, "This is an input");
			myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
			myInput.SetChecked(((IUserModelRO)m_model).GetExpirePassword());
			if (bEditingDefaultProfileUser || bEditingGuestUser ||
				!((IUserModelRO)m_model).GetExpirePasswordEnabled())
			{
				myInput.SetDisabled(true);
			}
			myCell.AddInnerHTMLElement(myInput);

			// Description row
			myCell.SetStyleClass(PTStyleClass.DIR_CONTENT_TEXT);

			myRow = new HTMLTableRow();
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
			myTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetColSpan("2");
			myRow.AddInnerHTMLElement(myCell);

			myCell.AddInnerHTMLString(m_asOwner.GetString(3269, ResourceConstants.PORTALADMINMSGS));
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);

			/*
			myRow = new HTMLTableRow();
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
			myTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetWidth("150");
			myRow.AddInnerHTMLElement(myCell);
			myCell.AddInnerHTMLString(m_asOwner.GetString(953, ResourceConstants.PORTALADMINMSGS));
			myCell.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			HTMLTextArea myTextArea = new HTMLTextArea("20", "5");
			myTextArea.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
			myCell.AddInnerHTMLElement(myTextArea);
			*/
		}
		catch (Exception e)
		{
			log.Error(e, "LoginView::Display The following error occured when trying to display the HTML.");

			throw new XPException(m_asOwner.GetString(948,
				ResourceConstants.PORTALADMINMSGS), e);
		}

		return result;
	}

	/**
	 *
	 *
	 * @return
	 */
	public HTMLScript DisplayJavascript()
	{
		HTMLScript myScript;

		try
		{
			XPStringBuilder sb = new XPStringBuilder(300);
			myScript = new HTMLScript("text/javaScript");


			sb.Append("function CheckNotAstericks()\n");
			sb.Append("{\n");
			sb.Append("	var i;\n");
			sb.Append("	var strIn;\n");
			sb.Append("	var astericks;\n");
			sb.Append(" astericks = true;\n");
			sb.Append("	strIn = document." + EditorDP.HTMLFORM_NAME +".").Append(HTMLINPUT_PASSWORD_NAME).Append(".value;\n");
			sb.Append("	for (i = 0; i < strIn.length; ++i)\n");
			sb.Append("	{\n");
			sb.Append("		if (strIn.charAt(i) != \"*\")\n");
			sb.Append(" 	{\n");
			sb.Append("			astericks = false;\n");
			sb.Append("		}\n");
			sb.Append("	}\n");
			sb.Append("	if (astericks) {\n");
			sb.Append("		alert(\"" + m_asOwner.GetString(169, ResourceConstants.PORTALADMINMSGS) + "\");\n");
			sb.Append("	}\n");
			sb.Append("}\n");

			// The JavaScript bellow checks if the Property Name is empty.
			sb.Append("function CheckNames()\n");
			sb.Append("{\n");

			//sb.Append("  if (document." + EditorDP.HTMLFORM_NAME + ".in_pw_CreateLogin.length != 0)");
			//sb.Append("  {\n" );
			sb.Append("  if (document." + EditorDP.HTMLFORM_NAME +
				".").Append(HTMLINPUT_PASSWORD_NAME).Append(".value != document." +
				EditorDP.HTMLFORM_NAME + ".").Append(HTMLINPUT_CONFIRM_PASSWORD_NAME).Append(".value)\n");
			sb.Append("  {\n");
			sb.Append("     alert(\"" + m_asOwner.GetString(2171, ResourceConstants.PORTALADMINMSGS) + "\");\n");
			sb.Append("     return false;\n");
			sb.Append("  }\n");

			//sb.Append("  }\n" );
			sb.Append("  return true;\n");
			sb.Append("}\n");

			sb.Append("function CheckMinLength()\n");
			sb.Append("{\n");
			sb.Append("  if ((document." +
				EditorDP.HTMLFORM_NAME +
				".").Append(HTMLINPUT_PASSWORD_NAME).Append(".value.length < 5) && (!document." +
				EditorDP.HTMLFORM_NAME +
				"." + HTMLINPUT_CHECKBOX_GUEST_NAME + ".checked))\n");
			sb.Append("  {\n");
			sb.Append(
				"      alert(\"" + m_asOwner.GetString(2172, ResourceConstants.PORTALADMINMSGS) + "\");\n");
			sb.Append("      return false;\n");
			sb.Append("  }\n");
			sb.Append("  return true;\n");
			sb.Append("}\n");

			sb.Append("function CheckMaxLength()\n");
			sb.Append("{\n");
			sb.Append("  if (document." +
				EditorDP.HTMLFORM_NAME +
				".").Append(HTMLINPUT_PASSWORD_NAME).Append(".value.length > 20)\n");
			sb.Append("  {\n");
			sb.Append(
				"      alert(\"" + m_asOwner.GetString(2427, ResourceConstants.PORTALADMINMSGS) + "\");\n");
			sb.Append("      return false;\n");
			sb.Append("  }\n");
			sb.Append("  return true;\n");
			sb.Append("}\n");

			String strJSUtilVersionPrefix = ConfigHelper.GetJSIncluderVersionPrefix(ConfigHelper.JSCOMPONENT_JSUTIL);
			
			sb.Append("function CheckNotWhitespace()\n");
			sb.Append("{\n");
			sb.Append("  if (("+strJSUtilVersionPrefix+"PTStringUtil.isAllWhitespace(document." +
				EditorDP.HTMLFORM_NAME +
				"." + HTMLINPUT_PASSWORD_NAME + ".value)) && (!document." +
				EditorDP.HTMLFORM_NAME +
				"." + HTMLINPUT_CHECKBOX_GUEST_NAME + ".checked))\n");
			sb.Append("  {\n");
			sb.Append(
				"      alert(\"" + m_asOwner.GetString(2173, ResourceConstants.PORTALADMINMSGS) + "\");\n");
			sb.Append("      return false;\n");
			sb.Append("  }\n");
			sb.Append("  return true;\n");
			sb.Append("}\n");

			sb.Append("function CheckUsernameNotWhitespace()\n");
			sb.Append("{\n");
			sb.Append("  if ("+strJSUtilVersionPrefix+"PTStringUtil.isAllWhitespace(document." +
				EditorDP.HTMLFORM_NAME +
				"." + HTMLINPUT_LOGIN_NAME + ".value))\n");
			sb.Append("  {\n");
			sb.Append(
				"      alert(\"" + m_asOwner.GetString(2377, ResourceConstants.PORTALADMINMSGS) + "\");\n");
			sb.Append("      return false;\n");
			sb.Append("  }\n");
			sb.Append("  return true;\n");
			sb.Append("}\n");


			sb.Append("function CheckMinUserNameLength()\n");
			sb.Append("{\n");
			sb.Append("  if (document." +
				EditorDP.HTMLFORM_NAME +
				"." + HTMLINPUT_LOGIN_NAME + ".value.length == 0)\n");
			sb.Append("  {\n");
			sb.Append(
				"      alert(\"" + m_asOwner.GetString(2174, ResourceConstants.PORTALADMINMSGS) + "\");\n");
			sb.Append("      return false;\n");
			sb.Append("  }\n");
			sb.Append("  return true;\n");
			sb.Append("}\n");

			sb.Append("function CheckGuestAccount()\n");
			sb.Append("{\n");
			sb.Append("  if (document." +
				EditorDP.HTMLFORM_NAME +
				"." + HTMLINPUT_CHECKBOX_GUEST_NAME + ".checked)\n");
			sb.Append("  {\n");
			sb.Append(
				"      document." + EditorDP.HTMLFORM_NAME + ".").Append(HTMLINPUT_PASSWORD_NAME).Append(".disabled=true;\n");
			sb.Append("      document." + EditorDP.HTMLFORM_NAME + "." + HTMLINPUT_CONFIRM_PASSWORD_NAME + ".disabled=true;\n");
			sb.Append("      document." + EditorDP.HTMLFORM_NAME + "." + HTMLINPUT_CHECKBOX_DISABLE_NAME + ".disabled=true;\n");			
			sb.Append("      document." + EditorDP.HTMLFORM_NAME + "." + HTMLINPUT_PASSWORD_NAME + ".value='';\n");
			sb.Append("      document." + EditorDP.HTMLFORM_NAME + "." + HTMLINPUT_CONFIRM_PASSWORD_NAME + ".value='';\n");
			sb.Append("      document." + EditorDP.HTMLFORM_NAME + "." + HTMLINPUT_CHECKBOX_DISABLE_NAME + ".checked=false;\n");
			sb.Append("  } else {\n");
			sb.Append("      document." + EditorDP.HTMLFORM_NAME + "." + HTMLINPUT_PASSWORD_NAME + ".disabled=false;\n");
			sb.Append("      document." + EditorDP.HTMLFORM_NAME + "." + HTMLINPUT_CONFIRM_PASSWORD_NAME + ".disabled=false;\n");
			sb.Append("      document." + EditorDP.HTMLFORM_NAME + "." + HTMLINPUT_CHECKBOX_DISABLE_NAME + ".disabled=false;\n");
			sb.Append("  }\n");
			sb.Append("}\n");
						
			sb.Append(" function EditUserProfile(varURL)");
			sb.Append(" {");
			sb.Append("    window.open(varURL,'PopUpEditUserProfile','location=no,menubar=no, scrollbars=yes, height=600,width=800');\n");
			sb.Append(" }");

			myScript.AddInnerHTMLString(sb.ToString());
		}
		catch (Exception e)
		{
			log.Error(e, "LoginView::DisplayJavascript The following error occured when trying to display the JavaScript.");

			throw XPException.GetInstance(e);
		}

		return (myScript);
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}