package com.plumtree.portalpages.admin.editors.user;

// Framework Imports
import com.plumtree.portalpages.browsing.myportal.*;
import com.plumtree.portalpages.browsing.myportal.communities.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.constants.AccessStyles;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.HTMLConstructHelpers;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 * @author SudhaS
 */

public class MainDP extends EditorDP {
	public static final String STR_MVC_CLASS_NAME = "UsrMain";

 	/* (non-Javadoc)
 	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Init(com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
 	 */
 	public void Init(AActivitySpace parent)
 	{
 		super.Init(parent);
 		
 		// expandable lists will do in place refresh.
 		//parent.SetIsInPlaceRefreshEnabled(true);
 	}
	
	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString() {
		return (m_asOwner.GetString(954, "ptmsgs_portaladminmsgs"));
	}


	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader()
	{
		//return HTMLConstructHelpers.GetSubHeader(
		//	m_asOwner.GetString(1665, "ptmsgs_portaladminmsgs"),
		//	this.m_asOwner);
		HTMLTable myTable = new HTMLTable();
		myTable.SetWidth("100%");
		myTable.SetStyleClass(PTStyleClass.DIR_CONTENT_BG);
		
		HTMLTableRow myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		
		HTMLTableCell myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		
		myCell.SetStyleClass(PTStyleClass.DIR_CONTENT_TEXT);
		

		myCell.AddInnerHTMLString(m_asOwner.GetString(1665, "ptmsgs_portaladminmsgs") + "  ");

		IUserModelRO _model = (IUserModelRO)m_asOwner.GetModel(UserModel.STR_MVC_CLASS_NAME);
		int userID = _model.GetObjectID();
		if (userID != -1)
		{		
			ASURL asURL	= new ASURL(m_asOwner);
			asURL.SetLinkCreateNewSpace(CommunityPageAS.STR_MVC_CLASS_NAME, m_asOwner);
			asURL.SetControl(SetCommunityControl.STR_MVC_CLASS_NAME);
		
			String strQuery = "&" + SetCommunityControl.STR_COMMUNITY_ID + "=2&" +
						SetCommunityControl.STR_PAGE_ID + "=0&" + SetCommunityControl.PROFILEID + "=" + userID;
		
			String strSettingURL = asURL.GetURLAsString() + strQuery;
		
			HTMLAnchor myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
			myAnchor.SetOnClick("EditUserProfile('" + strSettingURL + "'); return false;");
			myAnchor.AddInnerHTMLString(m_asOwner.GetString(2539, "ptmsgs_portaladminmsgs"));
		
			myCell.AddInnerHTMLElement(myAnchor);
		}

        HTMLTableCell helpCell = new HTMLTableCell();
        helpCell.SetStyleClass(PTStyleClass.DIR_CONTENT_TEXT);
        helpCell.SetAlign(CommonHTMLStrings.RIGHT);
        myRow.AddInnerHTMLElement(helpCell);
        
        HTMLAnchor help = HTMLConstructHelpers.GetHelpAnchor(m_asOwner);
        if (m_asOwner.GetAccessStyle() != AccessStyles.STANDARD) {
            help.SetAccessKey(m_asOwner.GetString(11, "ptmsgs_portal508quickkeymsgs"));
        }
        helpCell.AddInnerHTMLElement(help);
        return myTable;
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}
	
 	/* (non-Javadoc)
 	 * @see com.plumtree.uiinfrastructure.form.AFormDP#PartialContentDisplay()
 	 */
 	public HTMLElement PartialContentDisplay()
 	{
 		HTMLElementCollection result = new HTMLElementCollection();
 
 		result.AddInnerHTMLElement(((EditorView) m_asOwner
 			.GetView(UserEditorAS.strStorageSelectPTObject))
 			.Display());
 
 		return result;
 	}


	/**
	 * Returns the HTML for the General Info page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 *
	 * @return HTMLElement
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		views.AddInnerHTMLElement(
			((EditorView) m_asOwner.GetView(LoginView.STR_MVC_CLASS_NAME))
				.Display());

		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		// aj: display the static memberships RW view
		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(UserEditorAS.strStorageSelectPTObject))
				.Display());
		
		// aj: display the dynamic memberships RO view
		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(UserEditorAS.strDynamicMembershipSelectPTObject))
				.Display());

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	* Display the Javascripts for the Views.
	*
	* @return HTMLScriptCollection
	* @throws HTMLException
	*/
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		myScripts.AddInnerHTMLElement(
			m_asOwner
				.GetView(UserEditorAS.strStorageSelectPTObject)
				.DisplayJavascript());
		myScripts.AddInnerHTMLElement(
			m_asOwner
				.GetView(LoginView.STR_MVC_CLASS_NAME)
				.DisplayJavascript());

		return myScripts;
	}

}

