package com.plumtree.portalpages.admin.editors.userprofilemanager;

import com.plumtree.portalpages.admin.ptutilities.userinfopropmap.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.expandablelist.*;

/**
 * @author JHQ
 * @author jennifersu
 *
 * Controls repost actions via the usr profile manager.  It calls the following
 * repost controls: UsrProfCommRepostControl and UserInfoPropMapAS
 */
public class UsrProfMgrRepostControl extends EditorRepostControl
{
	/** object name */
	public static final String STR_MVC_CLASS_NAME = "UserProfileManagerRepost";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new UsrProfMgrRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Switch between the action modes and call
	 * the associated method for each action.
	 *
	 * @param _nAction
	 */
	protected void PerformAction(int _nAction)
	{
		// this will do performaction on the user profile community objects 
		super.PerformAction(_nAction);

		IDisplayPage page;

		// do action specific stuff
		page = m_asOwner.GetCurrentPage();

		// this will perform action on the user info property map objects
		if (_nAction != EditorRepostControl.POSTTOSELF_ACTION_FINISH)
		{
			if (page instanceof MainDP)
			{
				((ExpListControl) m_asOwner.GetControl(UserInfoPropMapAS.STR_MVC_STORAGE_NAME_PLUG_IN)).PerformRepostAction(_nAction, m_htFormData);
			}

			// this will perform action on the user prof community control
			else
			{
				UsrProfCommRepostControl commControl = (UsrProfCommRepostControl) m_asOwner.GetControl(UsrProfCommRepostControl.STR_MVC_CLASS_NAME);
				commControl.InitializeArguments(m_htFormData);
				commControl.PublicPerformAction(_nAction);
			}
		}
	}
}

