package com.plumtree.portalpages.admin.editors.webservice;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 *
 * @author adolfoc To change this generated comment edit the template variable
 *         "typecomment": Window>Preferences>Java>Templates. To enable and
 *         disable the creation of type comments go to
 *         Window>Preferences>Java>Code Generation.
 */
public class AdvSettingsDP extends WSPluginDP {
	/** Class Name */
	public static final String STR_MVC_CLASS_NAME = "AdvSettingsDP";

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetAllPossibleViews()
	 */
	public XPArrayList GetAllPossibleViews() {
		XPArrayList xpWSViews = new XPArrayList();

		xpWSViews.Add(WebServiceEditorAS.strStorage_AdvSettingsPluginView);
		xpWSViews.Add(WebServiceEditorAS.strStorage_ActSecurityPluginView);
		xpWSViews.Add(WebServiceEditorAS.strStorage_SOAPEncodingPluginView);
		xpWSViews.Add(WebServiceEditorAS.strStorage_XUIURLPluginView);

		return xpWSViews;
	}

	/**
	 * Alternate Browsing Devices
	 * @return 
	 */

	
	/**
	 * Returns the String to display on the left navigation menu,  linking to
	 * that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString() {
		return m_asOwner.GetString(1183, "ptmsgs_portaladminmsgs");
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader()
	{
		// Specify the additional settings for this Web Service.
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(3236, "ptmsgs_portaladminmsgs"),
			m_asOwner);
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetOrderedViewList(int)
	 */
	public XPArrayList GetOrderedViewList(int nWSMode) {
		XPArrayList xpWSViews = new XPArrayList();

		switch (nWSMode) {
			case WebServiceModel.WSMODE_PORTLET :
				xpWSViews.Add(
					WebServiceEditorAS.strStorage_AdvSettingsPluginView);
				xpWSViews.Add(
					WebServiceEditorAS.strStorage_ActSecurityPluginView);

				break;

			case WebServiceModel.WSMODE_PAGELET :
				xpWSViews.Add(
					WebServiceEditorAS.strStorage_AdvSettingsPluginView);

				break;

			case WebServiceModel.WSMODE_INTRINSIC_PORTLET :
				xpWSViews.Add(
					WebServiceEditorAS.strStorage_IntrinsicHelpSpacePluginView);
				xpWSViews.Add(
					WebServiceEditorAS.strStorage_IntrinsicProfilePluginView);
	
				break;

			case WebServiceModel.WSMODE_AWS :
			case WebServiceModel.WSMODE_PWS :
			case WebServiceModel.WSMODE_MWS :
				xpWSViews.Add(
					WebServiceEditorAS.strStorage_SOAPEncodingPluginView);
				xpWSViews.Add(WebServiceEditorAS.strStorage_XUIURLPluginView);

				break;

			case WebServiceModel.WSMODE_CWS :
				xpWSViews.Add(
					WebServiceEditorAS.strStorage_AdvSettingsPluginView);
				xpWSViews.Add(
					WebServiceEditorAS.strStorage_SOAPEncodingPluginView);
				xpWSViews.Add(
					WebServiceEditorAS.strStorage_ActSecurityPluginView);
				break;

			case WebServiceModel.WSMODE_SWS :
				xpWSViews.Add(
					WebServiceEditorAS.strStorage_AdvSettingsPluginView);
				xpWSViews.Add(
					WebServiceEditorAS.strStorage_SOAPEncodingPluginView);
				break;

			case WebServiceModel.WSMODE_NONE :
			default :
				}

		return xpWSViews;
	}

	/* (non-Javadoc)
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetPluginHelpTopic()
	 */
	public String GetPluginHelpTopic() {
		WebServiceModel mParentModel = (WebServiceModel) m_asOwner.GetModel(WebServiceModel.STR_MVC_CLASS_NAME);
		switch(mParentModel.GetWSMode())
		{
			case WebServiceModel.WSMODE_PORTLET :
				return "PT_WebService_Portlet_Remote_AdvancedSettings";
			case WebServiceModel.WSMODE_PAGELET :
				return "PT_WebService_Pagelet_AdvancedSettings";
			case WebServiceModel.WSMODE_AWS :
				return "PT_WebService_Authentication_AdvancedSettings";
			case WebServiceModel.WSMODE_PWS :
				return "PT_WebService_Profile_AdvancedSettings";
			case WebServiceModel.WSMODE_CWS :
				return "PT_WebService_Crawler_AdvancedSettings";
			case WebServiceModel.WSMODE_SWS :
				return "PT_WebService_Search_AdvancedSettings";
			case WebServiceModel.WSMODE_MWS :
				return "PT_WebService_Migration_AdvancedSettings";
			case WebServiceModel.WSMODE_INTRINSIC_PORTLET :
			case WebServiceModel.WSMODE_NONE :
			default :					
		}
		return null;
	}

}

