package com.plumtree.portalpages.admin.editors.webservice;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author JaneD
 *
 */
public class DebugDP extends WSPluginDP {

	/** Class Name */
	//  The name is arbitrary as long as it is reasonably unique.    
	public static final String STR_MVC_CLASS_NAME = "WebServiceDebugDP";

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetAllPossibleViews()
	 */
	public XPArrayList GetAllPossibleViews() {
		XPArrayList xpWSViews = new XPArrayList();

		xpWSViews.Add(WebServiceEditorAS.strStorage_DebugConfigPluginView);
		xpWSViews.Add(WebServiceEditorAS.strStorage_DebugUserPluginView);
		xpWSViews.Add(WebServiceEditorAS.strStorage_DebugPortletPluginView);

		return xpWSViews;
	}

	
	/**
	 * Returns the String to display on the left navigation menu,  linking to
	 * that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString() {
		return m_asOwner.GetString(2934, "ptmsgs_portaladminmsgs");
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader()
	{
		return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(2935, "ptmsgs_portaladminmsgs"), this.m_asOwner);
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetOrderedViewList(int)
	 */
	public XPArrayList GetOrderedViewList(int nWSMode) {
		XPArrayList xpWSViews = new XPArrayList();

		

		switch (nWSMode) {
			case WebServiceModel.WSMODE_PORTLET :
			case WebServiceModel.WSMODE_PAGELET :
				xpWSViews.Add(WebServiceEditorAS.strStorage_DebugConfigPluginView);
				xpWSViews.Add(WebServiceEditorAS.strStorage_DebugUserPluginView);
				xpWSViews.Add(WebServiceEditorAS.strStorage_DebugPortletPluginView);
				break;

			case WebServiceModel.WSMODE_AWS :
			case WebServiceModel.WSMODE_CWS :
			case WebServiceModel.WSMODE_SWS :
				xpWSViews.Add(WebServiceEditorAS.strStorage_DebugConfigPluginView);
				xpWSViews.Add(WebServiceEditorAS.strStorage_DebugUserPluginView);
				break;
			case WebServiceModel.WSMODE_PWS :
			case WebServiceModel.WSMODE_MWS :
				xpWSViews.Add(WebServiceEditorAS.strStorage_DebugConfigPluginView);				
				break;

			case WebServiceModel.WSMODE_INTRINSIC_PORTLET :
				break;
			
			case WebServiceModel.WSMODE_NONE :
			default :
				}

		return xpWSViews;
	}
	/* (non-Javadoc)
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetPluginHelpTopic()
	 */
	public String GetPluginHelpTopic() {
		WebServiceModel mParentModel = (WebServiceModel) m_asOwner.GetModel(WebServiceModel.STR_MVC_CLASS_NAME);
		
		switch (mParentModel.GetWSMode()) {
			case WebServiceModel.WSMODE_PORTLET :
			case WebServiceModel.WSMODE_PAGELET :
			case WebServiceModel.WSMODE_AWS :
			case WebServiceModel.WSMODE_CWS :
			case WebServiceModel.WSMODE_SWS :
			case WebServiceModel.WSMODE_PWS :
			case WebServiceModel.WSMODE_MWS :
				return "PT_WebService_DebugSettings";
			case WebServiceModel.WSMODE_INTRINSIC_PORTLET :
			case WebServiceModel.WSMODE_NONE :
			default :
				}

		return null;
	}

}

