/**
 * Created on Oct 30, 2002
 *
 * To change this generated comment edit the template variable "filecomment":

 * To enable and disable the creation of file comments go to

 */
package com.plumtree.portalpages.admin.editors.webservice;

import com.plumtree.server.*;

/**
 * @author adolfoc
 * This interface must be implemented by any plugin model that wishes to receive
 * updates from the WebServiceModel. Each plugin model must also be registered with
 * the WebServiceModel using
 * WebServiceModel.RegisterWSSubModel(String strPluginModelStorageName).
 */
public interface IWSSubModel
{
	/**
	 * Sub models are expected to store themselves to the ptWebService object passed in
	 * in InitWSModel during this call.
	 */
	public void DoTaskBeforeWSStore();

	/**
	 * Called when the Remote Server is changed. This is mostly used to update the base-url
	 * displayed before URL edit boxes.
	 */
	public void DoTaskOnRemoteServerUpdate(String strRemoteServerID,
		String strRemoteServerName, String strRemoteServerBaseURL);

	/**
	 * Called when the Web Service type is changed.
	 */
	public void DoTaskOnWSModeUpdate(int nNewWSMode);

	/**
	 * This returns the name of the client-side validation function that the model
	 * wants added to the page-level validation funtion. Models return null or "" if
	 * they don't have a validation function.
	 */
	public String GetValidationFunction();

	/**
	 * Initializes the sub-model. Provides an opportunity for the submodel to
	 * load it's state from the WebService.
	 */
	public void InitWSModel(IPTWebService ptWebService);
}

