package com.plumtree.portalpages.admin.editors.webservice;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.common.constants.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 * @author rozhang
 */
public class ParameterMappingDP extends WSPluginDP
{
	public static final String STR_MVC_CLASS_NAME = "ParameterMappingDP";

	/**
	 * 
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetAllPossibleViews()
	 */
	public XPArrayList GetAllPossibleViews()
	{
		XPArrayList xpWSViews = new XPArrayList();

		xpWSViews.Add(WebServiceEditorAS.strStorage_PageletParamMapPluginView);
		
		return xpWSViews;
	}

	/**
	 * 
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetOrderedViewList(int)
	 */
	public XPArrayList GetOrderedViewList(int mode)
	{
		XPArrayList xpWSViews = new XPArrayList();

		switch (mode) {
		
		case WebServiceModel.WSMODE_PAGELET:
			xpWSViews.Add(WebServiceEditorAS.strStorage_PageletParamMapPluginView);
			break;
		default:
			; // only used on pagelet webservices
		}
		return xpWSViews;
	}

	/**
	 * 
	 * @see com.plumtree.portalpages.admin.editors.webservice.WSPluginDP#GetPluginHelpTopic()
	 */
	public String GetPluginHelpTopic()
	{
		WebServiceModel mParentModel = (WebServiceModel) m_asOwner.GetModel(WebServiceModel.STR_MVC_CLASS_NAME);
		switch(mParentModel.GetWSMode())
		{
			case WebServiceModel.WSMODE_PAGELET :
				return "PT_WebService_Pagelet_ParameterMapping";
			case WebServiceModel.WSMODE_PORTLET :
			case WebServiceModel.WSMODE_AWS :
			case WebServiceModel.WSMODE_PWS :
			case WebServiceModel.WSMODE_CWS :
			case WebServiceModel.WSMODE_SWS :
			case WebServiceModel.WSMODE_MWS :
			case WebServiceModel.WSMODE_INTRINSIC_PORTLET :
			case WebServiceModel.WSMODE_NONE :
			default :					
		}
		return null;
	}
	
	/**
	 * Implement this method to add HTML below the sub header.
	 *
	 * @return HTMLElement
	 */
	protected HTMLElement GetHTMLBelowSubHeader()
	{
		return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(3271, ResourceConstants.PORTALADMINMSGS), this.m_asOwner);
	}

	/**
	 * 
	 * @see com.plumtree.uiinfrastructure.editor.EditorDP#GetLeftNavString()
	 */
	public String GetLeftNavString()
	{
		return m_asOwner.GetString(3270, ResourceConstants.PORTALADMINMSGS);
	}

	/**
	 * 
	 * @see com.plumtree.uiinfrastructure.editor.EditorDP#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

}
