package com.plumtree.portalpages.admin.editors.webservice;


// Framework imports
import com.plumtree.portalpages.common.helpers.*;
import com.plumtree.portaluiinfrastructure.classtypedescriptors.classtypes.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This Section contains the HTML for the dependencies page.
 *
 * @author 
 */
public class WSDependenciesView extends ObjDependenciesView
{

	/**
	 * Class name for the activity space
	 */
	public static final String STR_MVC_CLASS_NAME = "WSDependencies";

	
	public static final int OFFSET = -1; // <0 use default, 0 none, >0 use specified 

	
	public static final int BREAK = -1; // <0 use default, 0 none, >0 use specified
	private CreatedHelper m_chHelper	  = null;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new WSDependenciesView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(com.plumtree.uiinfrastructure.activityspace.IModelRO, com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		super.Init(model, parent);
		m_chHelper = new CreatedHelper(parent, (WebServiceModel) model);
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.ObjDependenciesView#GetHTMLForDependencies()
	 */
	protected HTMLElementCollection GetHTMLForDependencies()

	{
		HTMLElementCollection result = new HTMLElementCollection();

		m_chHelper.displayEmptyRow(result);
		m_chHelper.displayTextRow(result, m_asOwner.GetString(1942, "ptmsgs_portaladminmsgs"), null);
		m_chHelper.displayTextRow(result, OFFSET, m_asOwner.GetString(1941, "ptmsgs_portaladminmsgs"),
			((ObjEditorModel) m_model).GetObjectName());
		m_chHelper.displayTextRow(result, OFFSET, m_asOwner.GetString(1943, "ptmsgs_portaladminmsgs"),
			((ObjEditorModel) m_model).GetParentFolderPath(), BREAK);


		int nFolderID = ((ObjEditorModel) m_model).GetFolderID();


		String strArg = "&" + XUIHelperMethods.QS_XUI_WEBSERVICE_ID + "=" + ((WebServiceModel)m_model).GetObjectID();
		strArg += "&" + PTPortlets.PORTLET_EDITOR_QS_INT_CREATOR_CLASSID + "=" + PT_CLASSIDS.PT_WEBSERVICE_ID;
		strArg += "&" + PTPortlets.PORTLET_EDITOR_QS_INT_CREATOR_ID + "=" + ((WebServiceModel)m_model).GetObjectID();

		int nWSMode = ((WebServiceModel) m_model).GetWSMode(); 
		switch (nWSMode)
		{			
		case WebServiceModel.WSMODE_INTRINSIC_PORTLET:
			m_chHelper.displayEmptyRow(result);
			m_chHelper.displayTextRow(result, m_asOwner.GetString(1944, "ptmsgs_portaladminmsgs"), null);
			m_chHelper.beginList(result);
		
			if (((WebServiceModel) m_model).GetPTSession().GetSessionInfo().CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_CREATE_PORTLETS))
			{
				m_chHelper.displayListRow(WSViewHelper.MakeCreateObjectLink(
						PT_CLASSIDS.PT_GADGET_ID, WSModelHelper.WSTYPE_IGP,
						nFolderID, m_asOwner.GetString(1947, "ptmsgs_portaladminmsgs"), m_asOwner, strArg, true));
			}

			m_chHelper.displayListRow(WSViewHelper.MakeCreateObjectLink(
					PT_CLASSIDS.PT_GADGETTEMPLATE_ID, WSModelHelper.WSTYPE_IGP,
					nFolderID, m_asOwner.GetString(1949, "ptmsgs_portaladminmsgs"), m_asOwner, strArg, true));

			break;

		case WebServiceModel.WSMODE_AWS:
			if (((WebServiceModel) m_model).GetPTSession().GetSessionInfo().CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_CREATE_AUTHSOURCES))
			{
				m_chHelper.displayEmptyRow(result);
				m_chHelper.displayTextRow(result, m_asOwner.GetString(1944, "ptmsgs_portaladminmsgs"), null);
				m_chHelper.beginList(result);

				m_chHelper.displayListRow(WSViewHelper.MakeCreateObjectLink(
						PT_CLASSIDS.PT_AUTHSOURCE_ID, WSModelHelper.WSTYPE_AWS,
						nFolderID, m_asOwner.GetString(1945, "ptmsgs_portaladminmsgs"), m_asOwner, strArg, true));
			}

			break;

		case WebServiceModel.WSMODE_CWS:
			if (((WebServiceModel) m_model).GetPTSession().GetSessionInfo().CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_CREATE_CRAWLERS))
			{
				m_chHelper.displayEmptyRow(result);
				m_chHelper.displayTextRow(result, m_asOwner.GetString(1944, "ptmsgs_portaladminmsgs"), null);
				m_chHelper.beginList(result);

				m_chHelper.displayListRow(WSViewHelper.MakeCreateObjectLink(
						PT_CLASSIDS.PT_DATASOURCE_ID, WSModelHelper.WSTYPE_CWS,
						nFolderID, m_asOwner.GetString(1950, "ptmsgs_portaladminmsgs"), m_asOwner, strArg, true));
			}

			break;

		case WebServiceModel.WSMODE_PORTLET:
		case WebServiceModel.WSMODE_PAGELET:
			String strWSType = (nWSMode == WebServiceModel.WSMODE_PORTLET ? WSModelHelper.WSTYPE_HTTPGP : WSModelHelper.WSTYPE_HTTPPAGELET);
			m_chHelper.displayEmptyRow(result);
			m_chHelper.displayTextRow(result, m_asOwner.GetString(1944, "ptmsgs_portaladminmsgs"), null);
			m_chHelper.beginList(result);
			if (((WebServiceModel) m_model).GetPTSession().GetSessionInfo().CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_CREATE_PORTLETS))
			{
				m_chHelper.displayListRow(WSViewHelper.MakeCreateObjectLink(
						PT_CLASSIDS.PT_GADGET_ID, strWSType,
						nFolderID, m_asOwner.GetString(1946, "ptmsgs_portaladminmsgs"), m_asOwner, strArg, true));
			}
			m_chHelper.displayListRow(WSViewHelper.MakeCreateObjectLink(
					PT_CLASSIDS.PT_GADGETTEMPLATE_ID,
					strWSType, nFolderID,
					m_asOwner.GetString(1948, "ptmsgs_portaladminmsgs"), m_asOwner, strArg, true));

			break;

		case WebServiceModel.WSMODE_SWS:
			if (((WebServiceModel) m_model).GetPTSession().GetSessionInfo().CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_CREATE_NETWORKSEARCHES))
			{
				m_chHelper.displayEmptyRow(result);
				m_chHelper.displayTextRow(result, m_asOwner.GetString(1944, "ptmsgs_portaladminmsgs"), null);
				m_chHelper.beginList(result);

				m_chHelper.displayListRow(WSViewHelper.MakeCreateObjectLink(
						PT_CLASSIDS.PT_FEDERATEDPORTAL_ID,
						WSModelHelper.WSTYPE_SWS, nFolderID,
						m_asOwner.GetString(1951, "ptmsgs_portaladminmsgs"), m_asOwner, strArg, true));
			}

			break;

		case WebServiceModel.WSMODE_PWS:
			if (((WebServiceModel) m_model).GetPTSession().GetSessionInfo().CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_CREATE_PROFILESOURCES))
			{			
				m_chHelper.displayEmptyRow(result);
				m_chHelper.displayTextRow(result, m_asOwner.GetString(1944, "ptmsgs_portaladminmsgs"), null);
				m_chHelper.beginList(result);

				m_chHelper.displayListRow(WSViewHelper.MakeCreateObjectLink(
						// AGC- Yes, AWS -  not PWS
						PT_CLASSIDS.PT_PROFILESOURCE_ID, WSModelHelper.WSTYPE_AWS,
						nFolderID, m_asOwner.GetString(1952, "ptmsgs_portaladminmsgs"), m_asOwner, strArg, true));
			}

			break;
		}

		m_chHelper.displayEmptyRow(result);

		//Display the standard warning if everyone has access to this object
		m_chHelper.displayEveryoneWarning(result, (WebServiceModel) m_model, m_asOwner.GetString(2287, "ptmsgs_portaladminmsgs"));

		return result;
	}
	
	
}

