package com.plumtree.portalpages.admin.editors.webservice;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.portalpages.admin.editors.webservice.plugins.*;
import com.plumtree.portalpages.common.helpers.*;
import com.plumtree.portaluiinfrastructure.opener.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author adolfoc
 *
 */
public class WSViewHelper extends ViewHelper
{

	/**
	 * Returns a collection of HTMLElements that make a link to the object with
	 * the specified CLASSID and objectID. strLink will be the string used as
	 * the link string.
	 *
	 * @param ptSession
	 * @param nCLASSID
	 * @param nObjectID
	 * @param strLink
	 * @return HTMLElement
	 */
	public static HTMLElement MakeEditObjectLink(int nClassID, int nObjectID,
		String strLink, AActivitySpace asOwner)
		throws HTMLException
	{
		HTMLAnchor myAnchor = new HTMLAnchor("#");
		
        XPStringBuilder sbQSArgs = new XPStringBuilder(256);

		// TODO: This should use the GetOpenerURLObjID method

        // using the open ended opener method, thus need to supply QS args.
        HTTPHelpers.AppendQSArgument(sbQSArgs, IPTOpenerConstants.QS_OPEN, nClassID);
        HTTPHelpers.AppendQSArgument(sbQSArgs, IPTOpenerConstants.QS_OBJECTID, nObjectID);

        // indicate that this link should be opened as a subeditor.
		HTTPHelpers.AppendQSArgument(sbQSArgs, ASConstants.SUBSPACE, 
		    AssocObjectsPluginView.STR_MVC_CLASS_NAME + nClassID + nObjectID);

		// using the open ended get common opener url method.
		String strURL = PTOpenerLinks.GetOpenerURL(sbQSArgs.ToString(), 
		    IPTOpenerConstants.OPENER_MODE_EDIT, asOwner);

		myAnchor.SetHRef(strURL);
		myAnchor.SetTarget("_blank");
		myAnchor.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strLink));

		return myAnchor;
	}

}

