package com.plumtree.portalpages.admin.editors.webservice.credvaulttree;


import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.tree.*;

/**
 * This version of the tree allows for browsing and
 * selecting of objects with no hierarchical structure
 *
 * @author JosephS
 */
public class CredVaultStartTreeControl extends AStartTreeControl
{
	/** object name */
	public static final String STR_MVC_CLASS_NAME = "CredVaultStartTree";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#Execute()
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		Redirect result = super.CheckActionSecurityAndExecute(arguments);

		String[] sValues;

		// CredVault's to select
		sValues = (String[]) arguments.GetElement(CredVaultRefreshTreeControl.SELECTED_CREDVAULTS);

		if (sValues != null)
		{
			((CredVaultTreeModel)m_asModel).SetCredVaultsToSelect(CredVaultRefreshTreeControl.StringToCredVaults(sValues[0]));
		}
		
		// Now load the bugger.
		((CredVaultTreeModel) m_asModel).LoadCredVault();

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new CredVaultStartTreeControl();
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IControl#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}
