/**
 * Created on Oct 29, 2002
 *
 * To change this generated comment edit the template variable "filecomment":

 * To enable and disable the creation of file comments go to

 */
package com.plumtree.portalpages.admin.editors.webservice.plugins;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.editors.webservice.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author adolfoc
 */
public class AddSettingsPluginView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.webservice.plugins.AddSettingsPluginView");

	public static final String STR_MVC_CLASS_NAME = "AddSettingsPluginView";

	/** Localized String: Remote Server */

	/** Localized String: Unable to display the HTML for RemoteServerPluginView (Display). */

	/** Localized String: Web Service is: */

	/** Localized String: Enabled */

	/** Localized String: Disabled with message: */

	// HTML Object names.
	public static final String HTMLRADIO_ENABLED	   = "in_ra_Enabled";
	public static final String HTMLINPUT_DISABLED_TEXT = "in_ta_DisabledText";

	/**
	 * Our parent Activity space.
	 */
	private AActivitySpace m_asasParent;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new AddSettingsPluginView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTable myTable;
		HTMLTableRow myRow;

		try
		{
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						1025, "ptmsgs_portaladminmsgs")));

			myTable = WSViewHelper.AddTable(result);

			// Top Margin
			WSViewHelper.AddEmptyRow(myTable, "7");

			// Radio Category Label
			WSViewHelper.AddSimpleLabel(myTable, 7,
				m_asOwner.GetString(1027, "ptmsgs_portaladminmsgs"));

			// Enabled/Disabled Radio Selection.
			boolean bEnabled = (((IAddSettingsPluginModelRO) m_model).GetEnabled());
			WSViewHelper.AddSimpleRadio(myTable, -7,
				m_asOwner.GetString(1028, "ptmsgs_portaladminmsgs"),
				HTMLRADIO_ENABLED, "1", bEnabled);
			WSViewHelper.AddSimpleRadio(myTable, -7,
				m_asOwner.GetString(1029, "ptmsgs_portaladminmsgs"),
				HTMLRADIO_ENABLED, "0", !bEnabled);

			myRow = WSViewHelper.AddRow(myTable);
			WSViewHelper.AddLeftMargin(myRow, 7);
			WSViewHelper.AddTextAreaCell(myRow, CommonHTMLStrings.ONE,
				XPHttpUtility.HtmlDecode(XPHttpUtility.HtmlDecode(((IAddSettingsPluginModelRO) m_model).GetDisabledMessage())),
				HTMLINPUT_DISABLED_TEXT);
				
			WSViewHelper.AddIndentCell(myRow, CommonHTMLStrings.ONE);
			WSViewHelper.AddIndentCell(myRow, CommonHTMLStrings.ONE);
			WSViewHelper.AddIndentCell(myRow, CommonHTMLStrings.ONE);
			
			WSViewHelper.AddRightMargin(myRow, 7);

			// Bottom Margin
			WSViewHelper.AddEmptyRow(myTable, "7");
		}
		catch (HTMLException e)
		{
			
				log.Error(e, STR_MVC_CLASS_NAME +
					"::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(1026,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		HTMLScript result = new HTMLScript("text/javaScript");

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		super.Init(model, parent);
		m_asasParent = parent;
	}
}

