/**
 * Created on Oct 29, 2002
 *
 * To change this generated comment edit the template variable "filecomment":

 * To enable and disable the creation of file comments go to

 */
package com.plumtree.portalpages.admin.editors.webservice.plugins;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.admin.editors.webservice.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 * @author adolfoc
 */
public class ChooseWSTypePluginModel extends EditorHelperModel
	implements IChooseWSTypePluginModelRO, IWSSubModel
{
	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "ChooseWSTypePlugin";

	/**
	 * The following publics should be used by views to Get or Set
	 * enabled-ness.
	 */
	public static final int WS_ENABLED  = 1;
	public static final int WS_DISABLED = 0;

	/**
	 * The Web Service object being edited by our parent Web Service editor
	 */
	IPTWebService m_ptWebService = null;

	/** Logging object and booleans */
	/**
	 * Radio item value that contains the WebService type.
	 * The actual provider CLSID to be stored in the WebService object.
	 */
	private String m_strWebServiceID = "";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new ChooseWSTypePluginModel();
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskBeforeWSStore()
	 */
	public void DoTaskBeforeWSStore()
	{
		// Store ourselves
		// Don't ever store a WStype that is the DEBUG_ME type -- even if we were in
		// debug mode. Bad idea.
		m_ptWebService.SetProviderCLSID(m_strWebServiceID);
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskOnRemoteServerUpdate(String, String, String)
	 */
	public void DoTaskOnRemoteServerUpdate(String strRemoteServerID,
		String strRemoteServerName, String strRemoteServerBaseURL)
	{
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskOnWSModeUpdate(int)
	 */
	public void DoTaskOnWSModeUpdate(int nNewWSMode)
	{
		SetWSTypeFromMode(nNewWSMode);
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#GetValidationFunction()
	 */
	public String GetValidationFunction()
	{
		return null;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.plugins.IChooseWSTypePluginModelRO#GetWSMode()
	 */
	public int GetWSMode()
	{
		WebServiceModel mParent = (WebServiceModel) m_asOwner.GetModel(WebServiceModel.STR_MVC_CLASS_NAME);

		return mParent.GetEditorType();
	}

	/**
	 * Returns the m_strWebServiceID. The actual CLSID of the WebServiceType.
	 *
	 * @return int
	 */
	public String GetWSType()
	{
		return m_strWebServiceID;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#InitWSModel()
	 */
	public void InitWSModel(IPTWebService ptWebService)
	{
		m_ptWebService     = ptWebService;

		// Initialize ourselves
		m_strWebServiceID = XPStringUtility.ToUpperCase(m_ptWebService.GetProviderCLSID()).trim();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorHelperModel#SaveSection(XPHashtable)
	 */
	public int SaveSection(XPHashtable _htFormData)
	{
		String[] data;

		data = (String[]) _htFormData.GetElement(ChooseWSTypePluginView.HTMLRADIO_WSTYPE);

		if ((null != data) && !(0 == data.length))
		{
			SetWSType(data[0]);
		}

		// AGC- This view should never be open when we store. Since this view should
		// never be shown except for during developer testing, we don't need to post
		// an error either.
		return RepostControl.PAGE_STATUS_INVALID;
	}

	/**
	 * Sets the m_nWebServiceType. Value must be a WSMODE_* as defined
	 * in WebServiceModel.
	 *
	 * @param nWSType The Web Service Type to set
	 */
	public void SetWSType(String strWSType)
	{
		WebServiceModel mParent = (WebServiceModel) m_asOwner.GetModel(WebServiceModel.STR_MVC_CLASS_NAME);

		if ((null == strWSType) || (0 == strWSType.length()))
		{
			m_strWebServiceID = "";

			// Initialize our parent model to the appropriate mode.
			mParent.SetWSMode(WebServiceModel.WSMODE_NONE);

			return;
		}
		else
		{
			// AGC- we don't really need to set this - this value will
			// be immediately reset in DoTaskOnWSModeUpdate... but for
			// clarity and safety's sakes, we'll set it anyway.
			m_strWebServiceID = XPStringUtility.ToUpperCase(strWSType);
		}

		// Initialize our parent model to the appropriate mode.
		if (0 == m_strWebServiceID.compareTo(WSModelHelper.WSTYPE_HTTPGP))
		{
			mParent.SetWSMode(WebServiceModel.WSMODE_PORTLET);
		}
		else if (0 == m_strWebServiceID.compareTo(WSModelHelper.WSTYPE_IGP))
		{
			mParent.SetWSMode(WebServiceModel.WSMODE_INTRINSIC_PORTLET);
		}
		else if (0 == m_strWebServiceID.compareTo(WSModelHelper.WSTYPE_AWS))
		{
			mParent.SetWSMode(WebServiceModel.WSMODE_AWS);
		}
		else if (0 == m_strWebServiceID.compareTo(WSModelHelper.WSTYPE_PWS))
		{
			mParent.SetWSMode(WebServiceModel.WSMODE_PWS);
		}
		else if (0 == m_strWebServiceID.compareTo(WSModelHelper.WSTYPE_CWS))
		{
			mParent.SetWSMode(WebServiceModel.WSMODE_CWS);
		}
		else if (0 == m_strWebServiceID.compareTo(WSModelHelper.WSTYPE_SWS))
		{
			mParent.SetWSMode(WebServiceModel.WSMODE_SWS);
		}
		else if (0 == m_strWebServiceID.compareTo(WSModelHelper.WSTYPE_MWS))
		{
			mParent.SetWSMode(WebServiceModel.WSMODE_MWS);
		}
		else
		{
			mParent.SetWSMode(WebServiceModel.WSMODE_NONE);
		}
	}

	/**
	 * Set the WSType based on the new mode... This does not update the WebServiceModel.
	 */
	public void SetWSTypeFromMode(int nNewWSMode)
	{
		switch (nNewWSMode)
		{
		case WebServiceModel.WSMODE_PORTLET:
			m_strWebServiceID = WSModelHelper.WSTYPE_HTTPGP;

			break;

		case WebServiceModel.WSMODE_INTRINSIC_PORTLET:
			m_strWebServiceID = WSModelHelper.WSTYPE_IGP;

			break;

		case WebServiceModel.WSMODE_AWS:
			m_strWebServiceID = WSModelHelper.WSTYPE_AWS;

			break;

		case WebServiceModel.WSMODE_PWS:
			m_strWebServiceID = WSModelHelper.WSTYPE_PWS;

			break;

		case WebServiceModel.WSMODE_CWS:
			m_strWebServiceID = WSModelHelper.WSTYPE_CWS;

			break;

		case WebServiceModel.WSMODE_SWS:
			m_strWebServiceID = WSModelHelper.WSTYPE_SWS;

			break;

		case WebServiceModel.WSMODE_MWS:
			m_strWebServiceID = WSModelHelper.WSTYPE_MWS;

			break;

		case WebServiceModel.WSMODE_NONE:default:
			m_strWebServiceID = "";
		}
	}
}

