/**
 * Created on Oct 29, 2002
 *
 * To change this generated comment edit the template variable "filecomment":

 * To enable and disable the creation of file comments go to

 */
package com.plumtree.portalpages.admin.editors.webservice.plugins;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.editors.webservice.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author adolfoc
 */
public class ChooseWSTypePluginView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.webservice.plugins.ChooseWSTypePluginView");

	public static final String STR_MVC_CLASS_NAME = "ChooseWSTypePluginView";

	public static final String HTMLRADIO_WSTYPE = "in_ra_WebServiceID";


	// This string need not be localized - it will only be used for developer debugging.
	public final String _DebugLabel = "Show all possible settings (UI DEBUG MODE ONLY - This does not create a valid Web Service)";

	/**
	 * Our parent Activity space.
	 */
	private AActivitySpace m_asasParent;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new ChooseWSTypePluginView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTable myTable;
		HTMLTableCell myCell;
		HTMLTableRow myRow;

		HTMLSpan mySpan;

		try
		{
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						1063, "ptmsgs_portaladminmsgs")));

			myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("1");
			myTable.SetCellSpacing("0");
			myTable.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BG);

			// 1st row (Top Margin)
			WSViewHelper.AddEmptyRow(myTable, "4");

			// 2nd row 
			myRow = WSViewHelper.AddRow(myTable);

			//// Left Margin
			WSViewHelper.AddEmptyCell(myRow, "1");

			//// Label
			myCell = WSViewHelper.AddCell(myRow, "2");
			myCell.SetVAlign("top");
			mySpan = WSViewHelper.AddSpanToCell(myCell);

			mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(
					m_asOwner.GetString(1065, "ptmsgs_portaladminmsgs")));

			//// Right Margin
			WSViewHelper.AddEmptyCell(myRow, "1");

			// 3rd - Xth rows
			String strWSTypeChecked = (((IChooseWSTypePluginModelRO) m_model).GetWSType());

			AddRadioToTable(myTable,
				m_asOwner.GetString(1066, "ptmsgs_portaladminmsgs"),
				WSModelHelper.WSTYPE_HTTPGP, strWSTypeChecked);

			AddRadioToTable(myTable,
				m_asOwner.GetString(1067, "ptmsgs_portaladminmsgs"),
				WSModelHelper.WSTYPE_IGP, strWSTypeChecked);

			AddRadioToTable(myTable,
				m_asOwner.GetString(1068, "ptmsgs_portaladminmsgs"),
				WSModelHelper.WSTYPE_CWS, strWSTypeChecked);

			AddRadioToTable(myTable,
				m_asOwner.GetString(1069, "ptmsgs_portaladminmsgs"),
				WSModelHelper.WSTYPE_AWS, strWSTypeChecked);

			AddRadioToTable(myTable,
				m_asOwner.GetString(1071, "ptmsgs_portaladminmsgs"),
				WSModelHelper.WSTYPE_SWS, strWSTypeChecked);

			AddRadioToTable(myTable,
				m_asOwner.GetString(1070, "ptmsgs_portaladminmsgs"),
				WSModelHelper.WSTYPE_PWS, strWSTypeChecked);

			WSViewHelper.AddEmptyRow(myTable, "4");
		}
		catch (HTMLException e)
		{
			
				log.Error(e, STR_MVC_CLASS_NAME +
					"::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(1064,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		HTMLScript result = new HTMLScript("text/javaScript");

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		super.Init(model, parent);
		m_asasParent = parent;
	}

	// Helper Function
	private void AddRadioToTable(HTMLTable myTable, String strLabel,
		String strValue, String strCheckedValue)
	{
		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLSpan mySpan;
		HTMLInput myInput;

		myRow = WSViewHelper.AddRow(myTable);

		//// Left Margin
		WSViewHelper.AddEmptyCell(myRow, "1");

		// radio
		myCell     = WSViewHelper.AddCell(myRow, "1");
		mySpan     = WSViewHelper.AddSpanToCell(myCell);

		XPStringBuilder sb = new XPStringBuilder(100);
		sb.Append("  postToSelf(")
		.Append(WebServiceRepostControl.POSTTOSELF_ACTION_SIMPLEREPOST).Append(");");

		myInput = new HTMLInput(HTMLInputTypes.RADIO, HTMLRADIO_WSTYPE, "");
		myInput.SetStyleClass(PTStyleClass.FORM_RADIO);
		myInput.SetOnClick(sb.ToString());
		mySpan.AddInnerHTMLElement(myInput);
		myInput.SetValue(strValue);

		// text label
		myCell     = WSViewHelper.AddCell(myRow, "1");
		mySpan     = WSViewHelper.AddSpanToCell(myCell);
		myCell.SetNoWrap(false);

		mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(strLabel));

		if (0 == strValue.compareTo(strCheckedValue))
		{
			myInput.SetChecked(true);
		}
		else
		{
			myInput.SetChecked(false);
		}

		//// Right Margin
		WSViewHelper.AddEmptyCell(myRow, "1");
	}
}

