/**
 * Created on Oct 30, 2002
 *
 * To change this generated comment edit the template variable "filecomment":

 * To enable and disable the creation of file comments go to

 */
package com.plumtree.portalpages.admin.editors.webservice.plugins;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.admin.editors.webservice.*;
import com.plumtree.portaluiinfrastructure.classtypedescriptors.providerframework.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 * @author adolfoc
 *
 */
public class HelpURLPluginModel extends EditorHelperModel
	implements IHelpURLPluginModelRO, IWSSubModel
{
	
	public static final String STR_MVC_CLASS_NAME = "HelpURLPlugin";

	/**
	 * The Web Service object being edited by our parent Web Service editor
	 */
	IPTWebService m_ptWebService = null;

	/**
	 * We might get the Remote Server Base URL from
	 * our parent model if it is a WebService Model. It is stored here.
	 */
	private String m_strBaseURL = "";

	/**
	 * The location of the Help URL for this Web Service.
	 */
	private String m_strHelpURL = "";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new HelpURLPluginModel();
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskBeforeWSStore()
	 */
	public void DoTaskBeforeWSStore()
	{
		IXPPropertyBag ptProviderInfo = (IXPPropertyBag) m_ptWebService.GetProviderInfo();
		WSModelHelper.PBWrite(ptProviderInfo, AExtensibilityConstants.PTC_HTTPGADGET_HELPURL, m_strHelpURL);

		int nSupportsPersonalization = m_ptWebService.GetSupportsPersonalization();

		if ((null == m_strHelpURL) || (0 >= m_strHelpURL.trim().length()))
		{
			nSupportsPersonalization = nSupportsPersonalization &
				~PT_GADGETPERSONALIZATION_ROLES.PT_GADGETPERSONALIZATION_HELPPAGE;
		}
		else
		{
			nSupportsPersonalization = nSupportsPersonalization |
				PT_GADGETPERSONALIZATION_ROLES.PT_GADGETPERSONALIZATION_HELPPAGE;
		}

		m_ptWebService.SetSupportsPersonalization(nSupportsPersonalization);
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskOnRemoteServerUpdate(String, String, String)
	 */
	public void DoTaskOnRemoteServerUpdate(String strRemoteServerID,
		String strRemoteServerName, String strRemoteServerBaseURL)
	{
		//MES- CR: How's BaseURL used in this model?  It seems like it's just set and retrieved, but never
		//	stored to the object?
		// AGC- m_strBaseURL through GetBaseURL is used in the view for display purposes only.		
		m_strBaseURL = strRemoteServerBaseURL;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskOnWSModeUpdate(int)
	 */
	public void DoTaskOnWSModeUpdate(int nNewWSMode)
	{
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.plugins.IAdminPrefsPluginModelRO#GetBaseURL()
	 */
	public String GetBaseURL()
	{
		return m_strBaseURL;
	}

	/**
	 * The location of the Help URL for this Web Service.
	 * @returns String
	 */
	public String GetHelpURL()
	{
		return m_strHelpURL;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#GetValidationFunction()
	 */
	public String GetValidationFunction()
	{
		return null;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#InitWSModel()
	 */
	public void InitWSModel(IPTWebService ptWebService)
	{
		m_ptWebService = ptWebService;

		IXPPropertyBag ptProviderInfo = (IXPPropertyBag) m_ptWebService.GetProviderInfo();

		SetHelpURL(WSModelHelper.PBReadString(ptProviderInfo, AExtensibilityConstants.PTC_HTTPGADGET_HELPURL, m_strHelpURL));
	}

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorHelperModel#SaveSection(XPHashtable)
	 */
	public int SaveSection(XPHashtable _htFormData)
	{
		int nValid = RepostControl.PAGE_STATUS_VALID;
		
		SetHelpURL(WSModelHelper.GetFormElementString(_htFormData, HelpURLPluginView.HTMLINPUT_HELP_URL, m_strHelpURL));
		if (((null != m_strHelpURL) && (!m_strHelpURL.equals(""))) &&
			((null == m_strBaseURL) || (m_strBaseURL.length() <= 0)))
		{
			nValid = WSModelHelper.ValidateIsURLString(m_strHelpURL, m_asOwner, m_asOwner.GetString(2625, "ptmsgs_portaladminmsgs"), nValid);
		}

		return nValid;
	}

	/**
	 * The location of the Help URL for this Web Service.
	 */
	public void SetHelpURL(String strHelpURL)
	{
		m_strHelpURL = strHelpURL;
	}
}

