package com.plumtree.portalpages.admin.editors.webservice.plugins;

/**
 * @author akashj
 */
public interface IFormLoginPluginModelRO
{
	/**
	 * The URL to that identifies a login URL - this can be a pattern
	 * with '*' characters to do wildcard matches.
	 *
	 * @return the login URL as a String
	 */
	public String GetLoginURL();

	/**
	 * The URL that credentials should be POSTed to.
	 *
	 * @return the POST URL as a String
	 */
	public String GetPostURL();
	
	/**
	 * Returns a series of constants representing the
	 * type of credential to send.  The choices are:
	 * 	0 - none (relies on the form fields only)
	 *  1 - Portal Username/Password
	 *  2 - Lockbox Username/Password
	 * 
	 * @return the credential type as an int
	 */
	public int GetCredentialType();
	
	/**
	 * Returns the HTML field to send the username as
	 * to the POST URL.
	 * 
	 * @return the username field name as a String
	 */
	public String GetUsernameFieldName();
	
	/**
	 * Returns the HTML field to send the password as
	 * to the POST URL.
	 * 
	 * @return the password field name as a String
	 */
	public String GetPasswordFieldName();
}

