package com.plumtree.portalpages.admin.editors.webservice.plugins;


/**
 * This interface contains read-only methods for the intrinsic portlet web service preferences plugin.
 *
 * @author josephc
 */
public interface IIntrinsicUserPrefsPluginModelRO
{
	/**
	 * Gets the preference mode.
	 *
	 * @return Preference mode
	 */
	public int GetPrefMode();

	/**
	 * Gets the preference space value for the current type of preference.
	 *
	 * @return Preference space
	 */
	public String GetPrefsSpace();

	/**
	 * Gets the preference space value for portlet template admin preferences.
	 *
	 * @return Portlet template admin preference space
	 */
	public String GetTemplatePrefsSpace();
}

