package com.plumtree.portalpages.admin.editors.webservice.plugins;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.editors.webservice.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This plugin view is used to show intrinsic portlet help pages.
 *
 * @author josephc
 */
public class IntrinsicHelpSpacePluginView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.webservice.plugins.IntrinsicHelpSpacePluginView");

	/** Class name for IntrinsicHelpSpacePluginView */
	public static final String STR_MVC_CLASS_NAME = "IntrinsicHelpSpacePlugin";

	/** Logger for IntrinsicHelpSpacePluginView */
	/** Flag for debug logging */
	/** Flag for error logging */
	/** Flag for warning logging */
	/** Flag for info logging */
	/** Flag for fatal error logging */
	/** Input for intrinsic portlet help space */
	public static final String HTMLINPUT_HELP_SPACE = "in_tx_HelpSpace";

	/**
	 * Localized String: Unable to display the HTML for
	 * IntrinsicHelpSpacePluginView (Display).
	 */

	
	/** Our parent Activity space. */
	private AActivitySpace m_asasParent;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new IntrinsicHelpSpacePluginView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTable myTable;

		try
		{
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						1091, "ptmsgs_portaladminmsgs")));

			//TODO: OBSOLETE string 1103

			myTable = WSViewHelper.AddTable(result);

			// 1st row begins (Top Margin)
			WSViewHelper.AddEmptyRow(myTable, CommonHTMLStrings.FOUR);

			// 1st row ends
			// 2nd row begins
			String strDefault = ((IIntrinsicHelpSpacePluginModelRO) m_model).GetHelpURL();

			WSViewHelper.AddSimpleEditBox(myTable, 4,
				m_asOwner.GetString(1092, "ptmsgs_portaladminmsgs"), null,
				strDefault, HTMLINPUT_HELP_SPACE);
			
			//TODO: OBSOLETE string 1102
			
			// last row (spacer row)
			WSViewHelper.AddEmptyRow(myTable, CommonHTMLStrings.FOUR);
		}
		catch (HTMLException e)
		{
			
				log.Error(e, STR_MVC_CLASS_NAME +
					"::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(1101,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		HTMLScript result = new HTMLScript("text/javaScript");

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO,
	 *      AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		super.Init(model, parent);
		m_asasParent = parent;
	}
}

