/**
 * Created on Nov 26, 2002
 * by adolfoc
 */
package com.plumtree.portalpages.admin.editors.webservice.plugins;

import com.plumtree.portalpages.admin.editors.webservice.*;
import com.plumtree.uiinfrastructure.expandablelist.growablelist.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author adolfoc
 *
 */
public class PrefsListPluginView extends GrowableListView
{
	/**
	 * Class name for the activity space */
	public static final String STR_MVC_CLASS_NAME = "PrefsListView";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new PrefsListPluginView();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListView#GetHTMLBelowActionBar()
	 */
	protected HTMLTable GetHTMLBelowActionBar()
	{
		String strViewToGet = "";

		switch (((IPrefsListPluginModelRO) m_model).GetWSMode())
		{
		case WebServiceModel.WSMODE_AWS:
		case WebServiceModel.WSMODE_CWS:
		case WebServiceModel.WSMODE_SWS:
		case WebServiceModel.WSMODE_NONE:

			//AGC- Don't show the Prefs URL selection for any mode except Portlet!
			return null;

		case WebServiceModel.WSMODE_PORTLET:default:

			switch (((IPrefsListPluginModelRO) m_model).GetPrefMode())
			{
			case PrefsListPluginModel.PLPM_PREFMODE_USERPREFS:
				strViewToGet = WebServiceEditorAS.strStorage_UserPrefsPluginView;

				break;

			case PrefsListPluginModel.PLPM_PREFMODE_COMMUNITYPREFS:
				strViewToGet = WebServiceEditorAS.strStorage_CommunityPrefsPluginView;

				break;
				
			case PrefsListPluginModel.PLPM_PREFMODE_SESSIONPREFS:
				strViewToGet = WebServiceEditorAS.strStorage_SessionPrefsPluginView;

				break;

				
			}
		}

		return (((UserPrefsPluginView) m_asOwner.GetView(strViewToGet)).GetDisplayAsTable());
	}
}

