/**
 * Created on Oct 30, 2002
 *
 * To change this generated comment edit the template variable "filecomment":

 * To enable and disable the creation of file comments go to

 */
package com.plumtree.portalpages.admin.editors.webservice.plugins;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.admin.editors.webservice.*;
import com.plumtree.portaluiinfrastructure.classtypedescriptors.providerframework.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 * @author adolfoc
 *
 */
public class RemoteConfigPluginModel extends EditorHelperModel
	implements IRemoteConfigPluginModelRO, IWSSubModel
{
	
	public static final String STR_MVC_CLASS_NAME = "RemoteConfigPlugin";

	/**
	 * The Web Service object being edited by our parent Web Service editor
	 */
	IPTWebService m_ptWebService = null;

	/**
	 * We might get the Remote Server Base URL from
	 * our parent model if it is a WebService Model. It is stored here.
	 */
	private String m_strBaseURL = "";

	/**
	 * The location of the Configuration URLs for this Web Service.
	 */
	private String m_strRemoteConfigURLAdmin = "";

	/**
	 * The location of the Configuration URLs for this Web Service.
	 */
	private String m_strRemoteConfigURLUser = "";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new RemoteConfigPluginModel();
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskBeforeWSStore()
	 */
	public void DoTaskBeforeWSStore()
	{
		IXPPropertyBag ptProviderInfo = (IXPPropertyBag) m_ptWebService.GetProviderInfo();
		int nSupportsPersonalization  = m_ptWebService.GetSupportsPersonalization();

		WSModelHelper.PBWrite(ptProviderInfo, AExtensibilityConstants.PTC_HTTPGADGET_CONFIGURL_ADMIN, m_strRemoteConfigURLAdmin);

		if ((null == m_strRemoteConfigURLAdmin) ||
				(0 >= m_strRemoteConfigURLAdmin.trim().length()))
		{
			nSupportsPersonalization = nSupportsPersonalization &
				~PT_GADGETPERSONALIZATION_ROLES.PT_WEBSERVICEPERSONALIZATION_ADMIN;
		}
		else
		{
			nSupportsPersonalization = nSupportsPersonalization |
				PT_GADGETPERSONALIZATION_ROLES.PT_WEBSERVICEPERSONALIZATION_ADMIN;
		}

		WSModelHelper.PBWrite(ptProviderInfo, AExtensibilityConstants.PTC_HTTPGADGET_CONFIGURL_USER, m_strRemoteConfigURLUser);

		if ((null == m_strRemoteConfigURLUser) ||
				(0 >= m_strRemoteConfigURLUser.trim().length()))
		{
			nSupportsPersonalization = nSupportsPersonalization &
				~PT_GADGETPERSONALIZATION_ROLES.PT_WEBSERVICEPERSONALIZATION_PERSONAL;
		}
		else
		{
			nSupportsPersonalization = nSupportsPersonalization |
				PT_GADGETPERSONALIZATION_ROLES.PT_WEBSERVICEPERSONALIZATION_PERSONAL;
		}

		m_ptWebService.SetSupportsPersonalization(nSupportsPersonalization);
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskOnRemoteServerUpdate(String, String, String)
	 */
	public void DoTaskOnRemoteServerUpdate(String strRemoteServerID,
		String strRemoteServerName, String strRemoteServerBaseURL)
	{
		m_strBaseURL = strRemoteServerBaseURL;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskOnWSModeUpdate(int)
	 */
	public void DoTaskOnWSModeUpdate(int nNewWSMode)
	{
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.plugins.IAdminPrefsPluginModelRO#GetBaseURL()
	 */
	public String GetBaseURL()
	{
		return m_strBaseURL;
	}

	/**
	 * The location of the Configuration URL for this Web Service.
	 * @returns String
	 */
	public String GetConfigURLAdmin()
	{
		return m_strRemoteConfigURLAdmin;
	}

	/**
	 * The location of the Configuration URL for this Web Service.
	 * @returns String
	 */
	public String GetConfigURLUser()
	{
		return m_strRemoteConfigURLUser;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#GetValidationFunction()
	 */
	public String GetValidationFunction()
	{
		return null;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#InitWSModel()
	 */
	public void InitWSModel(IPTWebService ptWebService)
	{
		m_ptWebService = ptWebService;

		IXPPropertyBag ptProviderInfo = (IXPPropertyBag) m_ptWebService.GetProviderInfo();

		SetConfigURLAdmin(WSModelHelper.PBReadString(ptProviderInfo, AExtensibilityConstants.PTC_HTTPGADGET_CONFIGURL_ADMIN, m_strRemoteConfigURLAdmin));
		SetConfigURLUser(WSModelHelper.PBReadString(ptProviderInfo, AExtensibilityConstants.PTC_HTTPGADGET_CONFIGURL_USER, m_strRemoteConfigURLUser));
	}

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorHelperModel#SaveSection(XPHashtable)
	 */
	public int SaveSection(XPHashtable _htFormData)
	{
		int nValid = RepostControl.PAGE_STATUS_VALID;

		SetConfigURLAdmin(WSModelHelper.GetFormElementString(_htFormData, RemoteConfigPluginView.HTMLINPUT_CONFIGURL_ADMIN, m_strRemoteConfigURLAdmin));
		SetConfigURLUser(WSModelHelper.GetFormElementString(_htFormData, RemoteConfigPluginView.HTMLINPUT_CONFIGURL_USER, m_strRemoteConfigURLUser));

		if ((null != m_strRemoteConfigURLAdmin && !m_strRemoteConfigURLAdmin.equals("")) && (null == m_strBaseURL) || (m_strBaseURL.length() <= 0))
		{
			nValid = WSModelHelper.ValidateIsURLString(m_strRemoteConfigURLAdmin, m_asOwner, m_asOwner.GetString(2625, "ptmsgs_portaladminmsgs"), nValid);
		}

		if ((null != m_strRemoteConfigURLUser && !m_strRemoteConfigURLUser.equals("")) && (null == m_strBaseURL) || (m_strBaseURL.length() <= 0))
		{
			nValid = WSModelHelper.ValidateIsURLString(m_strRemoteConfigURLUser, m_asOwner, m_asOwner.GetString(2625, "ptmsgs_portaladminmsgs"), nValid);
		}

		return nValid;
	}

	/**
	 * The location of the Configuration URL for this Web Service.
	 */
	public void SetConfigURLAdmin(String strRemoteConfig)
	{
		m_strRemoteConfigURLAdmin = strRemoteConfig;
	}

	/**
	 * The location of the Configuration URL for this Web Service.
	 */
	public void SetConfigURLUser(String strRemoteConfig)
	{
		m_strRemoteConfigURLUser = strRemoteConfig;
	}
}

