package com.plumtree.portalpages.admin.editors.webservice.plugins;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.editors.webservice.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author adolfoc
 *
 */
public class RemoteConfigPluginView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.webservice.plugins.RemoteConfigPluginView");

	public static final String STR_MVC_CLASS_NAME = "RemoteConfigPluginView";

	public static final String HTMLINPUT_CONFIGURL_ADMIN     = "in_tx_RemoteConfigAdmin";
	public static final String HTMLINPUT_CONFIGURL_USER = "in_tx_RemoteConfigUser";

	/**
	 * Our parent Activity space.
	 */
	private AActivitySpace m_asasParent;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new RemoteConfigPluginView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTable myTable;

		try
		{
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						1128, "ptmsgs_portaladminmsgs")));

			myTable = WSViewHelper.AddTable(result);

			// 1st row begins (Top Margin)
			WSViewHelper.AddEmptyRow(myTable, "5");

			// 2nd row begins
			String strBaseURL = ((IRemoteConfigPluginModelRO) m_model).GetBaseURL();
			String strDefault = ((IRemoteConfigPluginModelRO) m_model).GetConfigURLAdmin();

			WSViewHelper.AddSimpleEditBox(myTable, 5,
				m_asOwner.GetString(1129, "ptmsgs_portaladminmsgs"),
				strBaseURL, strDefault, HTMLINPUT_CONFIGURL_ADMIN);

			WSViewHelper.AddEmptyRow(myTable, "5");

			strDefault = ((IRemoteConfigPluginModelRO) m_model).GetConfigURLUser();

			WSViewHelper.AddSimpleEditBox(myTable, 5,
				m_asOwner.GetString(1131, "ptmsgs_portaladminmsgs"),
				strBaseURL, strDefault, HTMLINPUT_CONFIGURL_USER);

			WSViewHelper.AddEmptyRow(myTable, "5");

		}
		catch (HTMLException e)
		{
			
				log.Error(e, STR_MVC_CLASS_NAME +
					"::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(1127,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		HTMLScript result = new HTMLScript("text/javaScript");

		return result;
	}

	/**
	* @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	*/
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		super.Init(model, parent);
		m_asasParent = parent;
	}
}

