/**
 * Created on Oct 29, 2002
 *
 * To change this generated comment edit the template variable "filecomment":

 * To enable and disable the creation of file comments go to

 */
package com.plumtree.portalpages.admin.editors.webservice.plugins;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.admin.editors.webservice.*;
import com.plumtree.portaluiinfrastructure.classtypedescriptors.providerframework.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 * @author adolfoc
 *
 */
public class SOAPEncodingPluginModel extends EditorHelperModel
	implements ISOAPEncodingPluginModelRO, IWSSubModel
{
	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "SOAPEncodingPlugin";

	/**
	 * The following publics should be used by views to Get or Set
	 * enabled-ness.
	 */
	public static final int SOAPENC_RPC			    = 1;

	
	public static final int SOAPENC_DOCUMENTLITERAL = 0;

	/**
	 * The Web Service object being edited by our parent Web Service editor
	 */
	IPTWebService m_ptWebService = null;

	/** Logging object and booleans */
	/** Radio item that chooses whether this WebService is enabled or not
	 * (AdditionalSettingsView)
	 */
	private int m_nEncodingRadio;

	public SOAPEncodingPluginModel()
	{
		super();
		m_nEncodingRadio = SOAPENC_RPC;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SOAPEncodingPluginModel();
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskBeforeWSStore()
	 */
	public void DoTaskBeforeWSStore()
	{
		IXPPropertyBag ptProviderInfo = (IXPPropertyBag) m_ptWebService.GetProviderInfo();
		
		WSModelHelper.PBWrite(ptProviderInfo, AExtensibilityConstants.PTC_HTTPSOAP_ENCODED, m_nEncodingRadio);
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskOnRemoteServerUpdate(String, String, String)
	 */
	public void DoTaskOnRemoteServerUpdate(String strRemoteServerID,
		String strRemoteServerName, String strRemoteServerBaseURL)
	{
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskOnWSModeUpdate(int)
	 */
	public void DoTaskOnWSModeUpdate(int nNewWSMode)
	{
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the m_nEncodingRadio.
	 *
	 * @return int
	 */
	public int GetSOAPEncoding()
	{
		return m_nEncodingRadio;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#GetValidationFunction()
	 */
	public String GetValidationFunction()
	{
		return null;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#InitWSModel()
	 */
	public void InitWSModel(IPTWebService ptWebService)
	{
		m_ptWebService = ptWebService;

		IXPPropertyBag ptProviderInfo = (IXPPropertyBag) ptWebService.GetProviderInfo();

		// Initialize ourselves
		SetEncoding(WSModelHelper.PBReadInt(ptProviderInfo, AExtensibilityConstants.PTC_HTTPSOAP_ENCODED, m_nEncodingRadio));
	}

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorHelperModel#SaveSection(XPHashtable)
	 */
	public int SaveSection(XPHashtable _htFormData)
	{
		
		SetEncoding(WSModelHelper.GetFormElementInt(_htFormData, SOAPEncodingPluginView.HTMLRADIO_SOAPENCODING, m_nEncodingRadio));
		return RepostControl.PAGE_STATUS_VALID;
	}

	/**
	 * Sets the m_nEncodingRadio. Value must be SOAPENC_RPC or SOAPENC_DOCUMENTLITERAL (will
	 * silently set value to SOAPENC_RPC if out of range.
	 *
	 * @param nEnabledRadio The nEnabledRadio to set
	 */
	public void SetEncoding(int nEncodingRadio)
	{
		if (SOAPENC_RPC == nEncodingRadio)
		{
			this.m_nEncodingRadio = SOAPENC_RPC;
		}
		else
		{
			this.m_nEncodingRadio = SOAPENC_DOCUMENTLITERAL;
		}
	}
}

