/**
 * Created on Oct 29, 2002
 *
 * To change this generated comment edit the template variable "filecomment":

 * To enable and disable the creation of file comments go to

 */
package com.plumtree.portalpages.admin.editors.webservice.plugins;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.editors.webservice.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author adolfoc
 *
 */
public class SOAPEncodingPluginView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.webservice.plugins.SOAPEncodingPluginView");

	public static final String STR_MVC_CLASS_NAME = "SOAPEncodingPluginView";

	public static final String HTMLRADIO_SOAPENCODING = "in_ra_SOAPEncoding";

	/**
	 * Our parent Activity space.
	 */
	private AActivitySpace m_asasParent;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SOAPEncodingPluginView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTable myTable;

		try
		{

			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						1147, "ptmsgs_portaladminmsgs")));

			myTable = WSViewHelper.AddTable(result);

			// first row (margin)
			WSViewHelper.AddEmptyRow(myTable, "5");
			
			int nEnabled = (((ISOAPEncodingPluginModelRO) m_model).GetSOAPEncoding());
			
			WSViewHelper.AddSimpleLabel(myTable, 5, m_asOwner.GetString(1149, "ptmsgs_portaladminmsgs"));
			WSViewHelper.AddSimpleRadio(myTable, 5,
				m_asOwner.GetString(1150, "ptmsgs_portaladminmsgs"),
				HTMLRADIO_SOAPENCODING,
				XPConvert.ToString(SOAPEncodingPluginModel.SOAPENC_RPC),
				(nEnabled == SOAPEncodingPluginModel.SOAPENC_RPC),
				null);

			WSViewHelper.AddSimpleRadio(myTable, 5,
				m_asOwner.GetString(1151, "ptmsgs_portaladminmsgs"),
				HTMLRADIO_SOAPENCODING,
				XPConvert.ToString(SOAPEncodingPluginModel.SOAPENC_DOCUMENTLITERAL),
				(nEnabled == SOAPEncodingPluginModel.SOAPENC_DOCUMENTLITERAL),
				null);
			

			// last row (margin)
			WSViewHelper.AddEmptyRow(myTable, "5");

			// 3rd row ends            
		}
		catch (HTMLException e)
		{
			
				log.Error(e, STR_MVC_CLASS_NAME +
					"::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(1148,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		HTMLScript result = new HTMLScript("text/javaScript");

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		super.Init(model, parent);
		m_asasParent = parent;
	}
}

