/**
 * Created on Oct 30, 2002
 *
 * To change this generated comment edit the template variable "filecomment":

 * To enable and disable the creation of file comments go to

 */
package com.plumtree.portalpages.admin.editors.webservice.plugins;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.editors.webservice.*;
import com.plumtree.portaluiinfrastructure.classtypedescriptors.providerframework.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 * @author adolfoc
 *
 */
public class UserInfoPluginModel extends EditorHelperModel
	implements IUserInfoPluginModelRO, IWSSubModel
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.webservice.plugins.UserInfoPluginModel");

	
	public static final String STR_MVC_CLASS_NAME = "UserInfoPlugin";

	/**
	 * The Web Service object being edited by our parent Web Service editor
	 */
	IPTWebService m_ptWebService = null;

	/**
	 * The array of the currently selected user infos.
	 */
	XPArrayList m_xpalUserInfo;

	public UserInfoPluginModel()
	{
		super();
		m_xpalUserInfo = new XPArrayList(0);
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new UserInfoPluginModel();
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskBeforeWSStore()
	 */
	public void DoTaskBeforeWSStore()
	{
		IXPPropertyBag ptProviderInfo = (IXPPropertyBag) m_ptWebService.GetProviderInfo();

		// In order to not overwrite the non-hard-coded values (since they're not
		// displayed in this view) we must pick them out of the property bag and
		// add them back in.
		XPArrayList xpalUserInfoListToStore = WSModelHelper.GetNonHardcodedUserInfo(ptProviderInfo);

		// Now, we add the new hard-coded values.
		// Turn this into an Object array so that we can store it.			
		for (int nIndex = 0; nIndex < m_xpalUserInfo.GetSize(); nIndex++)
		{
			xpalUserInfoListToStore.Add(m_xpalUserInfo.GetElement(nIndex));

			
				log.Debug("Adding UserInfo array value: " +
					XPConvert.ToString(xpalUserInfoListToStore.GetElement(nIndex)));
			
		}

		ptProviderInfo.Write(AExtensibilityConstants.PT_PROPBAG_HTTPGADGET_USERINFO,
			xpalUserInfoListToStore.ToArray());
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskOnRemoteServerUpdate(String, String, String)
	 */
	public void DoTaskOnRemoteServerUpdate(String strRemoteServerID,
		String strRemoteServerName, String strRemoteServerBaseURL)
	{
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskOnWSModeUpdate(int)
	 */
	public void DoTaskOnWSModeUpdate(int nNewWSMode)
	{
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#GetValidationFunction()
	 */
	public String GetValidationFunction()
	{
		return null;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#InitWSModel()
	 */
	public void InitWSModel(IPTWebService ptWebService)
	{
		m_ptWebService = ptWebService;

		// Get our state from the ptObject.
		IXPPropertyBag ptProviderInfo = (IXPPropertyBag) m_ptWebService.GetProviderInfo();

		// Get only the hard-coded stuff. The non-hard-coded stuff will be edited in
		// a different view.		
		m_xpalUserInfo = WSModelHelper.GetHardcodedUserInfo(ptProviderInfo);
	}

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorHelperModel#SaveSection(XPHashtable)
	 */
	public int SaveSection(XPHashtable _htFormData)
	{
		m_xpalUserInfo.Clear();
		
		// iterate through all the defined User Info constants -jas
		for (int index = 0; index < PlumtreeExtensibility.PT_USERINFO_ALL.length; index++)
		{
			AddRemoveUserInfo(PlumtreeExtensibility.PT_USERINFO_ALL[index], _htFormData);
		}

		return RepostControl.PAGE_STATUS_VALID;
	}

	/**
	 * Takes in a user info string and checks to see if it is currently selected.
	 */
	public boolean UserInfoChecked(String strUserInfo)
	{
		return m_xpalUserInfo.Contains(strUserInfo);
	}

	// Helper functions...
	private void AddRemoveUserInfo(String strUserInfo, XPHashtable _htFormData)
	{
		String[] data = (String[]) _htFormData.GetElement(UserInfoPluginView.HTTP_USERINFO + strUserInfo);

		try
		{
			if ((null == data) || (0 >= data.length))
			{
				m_xpalUserInfo.Remove(strUserInfo);
			}
			else
			{
				m_xpalUserInfo.Add(strUserInfo);
			}
		}
		catch (Exception e)
		{
			
				// In all likelihood, we're attempting to remove a value that isn't there...
				// big deal.
				log.Warn(e, "UserInfoPluginModel::SaveSection: Unknown error setting value. Continuing: " +
					e.getMessage());
			
		}
	}
}

