package com.plumtree.portalpages.admin.editors.webservice.plugins;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.editors.webservice.*;
import com.plumtree.portaluiinfrastructure.classtypedescriptors.providerframework.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author adolfoc
 */
public class UserInfoPluginView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.editors.webservice.plugins.UserInfoPluginView");

	public static final String STR_MVC_CLASS_NAME = "UserInfoPluginView";

	
	public static final String HTTP_USERINFO = "in_cb_";

	
	/**
	 * Our parent Activity space.
	 */
	private AActivitySpace m_asasParent;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new UserInfoPluginView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTable myTable;

		HTMLTableRow myRow;

		try
		{
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						1161, "ptmsgs_portaladminmsgs")));
			
			myTable = WSViewHelper.AddTable(result);

			// 1st row begins (Top Margin)
			WSViewHelper.AddEmptyRow(myTable, CommonHTMLStrings.FIVE);

			// 1st row ends
			// 2nd row begins
			myRow = WSViewHelper.AddRow(myTable);

			// Left Margin
			WSViewHelper.AddEmptyCell(myRow, CommonHTMLStrings.ONE);

			// Check Boxes
			DrawUserInfoCheckBox(myRow, 
				PlumtreeExtensibility.PT_USERINFO_FULLNAME,
				m_asOwner.GetString(1162, "ptmsgs_portaladminmsgs"));

			DrawUserInfoCheckBox(myRow, 
				PlumtreeExtensibility.PT_USERINFO_EMAIL,
				m_asOwner.GetString(1163, "ptmsgs_portaladminmsgs"));

			DrawUserInfoCheckBox(myRow, 
				PlumtreeExtensibility.PT_USERINFO_IMUSER,
				m_asOwner.GetString(3056, "ptmsgs_portaladminmsgs"));

			// Right Margin
			WSViewHelper.AddEmptyCell(myRow, CommonHTMLStrings.ONE);

			// 3rd row begins
			myRow = WSViewHelper.AddRow(myTable);

			// Left Margin
			WSViewHelper.AddEmptyCell(myRow, CommonHTMLStrings.ONE);

			// Check Boxes
			DrawUserInfoCheckBox(myRow, 
				PlumtreeExtensibility.PT_USERINFO_EMPLOYEEID,
				m_asOwner.GetString(1165, "ptmsgs_portaladminmsgs"));

			DrawUserInfoCheckBox(myRow,
				PlumtreeExtensibility.PT_USERINFO_DEPARTMENT,
				m_asOwner.GetString(1166, "ptmsgs_portaladminmsgs"));

			DrawUserInfoCheckBox(myRow,
				PlumtreeExtensibility.PT_USERINFO_TITLE,
				m_asOwner.GetString(1167, "ptmsgs_portaladminmsgs"));

			// Right Margin
			WSViewHelper.AddEmptyCell(myRow, CommonHTMLStrings.ONE);

			// 4th row begins
			myRow = WSViewHelper.AddRow(myTable);

			// Left Margin
			WSViewHelper.AddEmptyCell(myRow, CommonHTMLStrings.ONE);

			// Check Boxes
			DrawUserInfoCheckBox(myRow,
				PlumtreeExtensibility.PT_USERINFO_ZIPCODE,
				m_asOwner.GetString(1168, "ptmsgs_portaladminmsgs"));

			DrawUserInfoCheckBox(myRow,
				PlumtreeExtensibility.PT_USERINFO_MANAGER,
				m_asOwner.GetString(1169, "ptmsgs_portaladminmsgs"));

			DrawUserInfoCheckBox(myRow,
				PlumtreeExtensibility.PT_USERINFO_PHONE,
				m_asOwner.GetString(1164, "ptmsgs_portaladminmsgs"));

			// Right Margin
			WSViewHelper.AddEmptyCell(myRow, CommonHTMLStrings.ONE);

			// 5th row begins
			myRow = WSViewHelper.AddRow(myTable);

			// Left Margin
			WSViewHelper.AddEmptyCell(myRow, CommonHTMLStrings.ONE);

			// Check Boxes
			DrawUserInfoCheckBox(myRow,
				PlumtreeExtensibility.PT_USERINFO_ACCESSINGFROMINTRANET,
				m_asOwner.GetString(1170, "ptmsgs_portaladminmsgs"));

			// Check Boxes
			DrawUserInfoCheckBox(myRow,
				PlumtreeExtensibility.PT_USERINFO_HOSTPAGEQUERYSTRING,
				m_asOwner.GetString(3150, "ptmsgs_portaladminmsgs"));
			
			// Right Margin
			WSViewHelper.AddEmptyCell(myRow, CommonHTMLStrings.ONE);

			// add label -jas
			WSViewHelper.AddEmptyRow(myTable, CommonHTMLStrings.FIVE);
			myRow = WSViewHelper.AddRow(myTable);
			WSViewHelper.AddLeftMargin(myRow, 5);
			WSViewHelper.AddTextCell(myRow, CommonHTMLStrings.THREE, m_asOwner.GetString(3057, "ptmsgs_portaladminmsgs"));	
			WSViewHelper.AddRightMargin(myRow, 5);

			// 6th row begins
			myRow = WSViewHelper.AddRow(myTable);

			// Left Margin
			WSViewHelper.AddEmptyCell(myRow, CommonHTMLStrings.ONE);

			// Check Boxes
			DrawUserInfoCheckBox(myRow,
				PlumtreeExtensibility.PT_USERINFO_PROFILEUSERID,
				m_asOwner.GetString(3058, "ptmsgs_portaladminmsgs"));

			DrawUserInfoCheckBox(myRow,
				PlumtreeExtensibility.PT_USERINFO_PROFILEUSERNAME,
				m_asOwner.GetString(3059, "ptmsgs_portaladminmsgs"));

			DrawUserInfoCheckBox(myRow,
				PlumtreeExtensibility.PT_USERINFO_PROFILEDESCRIPTION,
				m_asOwner.GetString(3060, "ptmsgs_portaladminmsgs"));

			// Right Margin
			WSViewHelper.AddEmptyCell(myRow, CommonHTMLStrings.ONE);

			// 7th row begins
			myRow = WSViewHelper.AddRow(myTable);

			// Left Margin
			WSViewHelper.AddEmptyCell(myRow, CommonHTMLStrings.ONE);

			// Check Boxes
			DrawUserInfoCheckBox(myRow, 
				PlumtreeExtensibility.PT_USERINFO_PROFILELOGINNAME,
				m_asOwner.GetString(3061, "ptmsgs_portaladminmsgs"));

			DrawUserInfoCheckBox(myRow, 
				PlumtreeExtensibility.PT_USERINFO_PROFILEUNIQUENAME,
				m_asOwner.GetString(3062, "ptmsgs_portaladminmsgs"));

			DrawUserInfoCheckBox(myRow, 
				PlumtreeExtensibility.PT_USERINFO_PROFILEAUTHNAME,
				m_asOwner.GetString(3063, "ptmsgs_portaladminmsgs"));

			// Right Margin
			WSViewHelper.AddEmptyCell(myRow, CommonHTMLStrings.ONE);

			// Last row begins (Bottom Margin)
			WSViewHelper.AddEmptyRow(myTable, CommonHTMLStrings.FIVE);
		}
		catch (HTMLException e)
		{
			
				log.Error(e, STR_MVC_CLASS_NAME +
					"::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(1160,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		HTMLScript result = new HTMLScript("text/javaScript");

		return result;
	}

	/**
	* @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	*/
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		super.Init(model, parent);
		m_asasParent = parent;
	}

	// Helper Function:
	private void DrawUserInfoCheckBox(HTMLTableRow myRow, String strUserInfo, String strUI)

	{
		HTMLTableCell myCell;
		HTMLSpan mySpan;

		//// Input for User Info.
		myCell	    = WSViewHelper.AddCell(myRow, CommonHTMLStrings.ONE);
		mySpan	    = WSViewHelper.AddSpanToCell(myCell);
		mySpan.AddInnerHTMLElement(WSViewHelper.MakeSimpleCheckbox(strUI, HTTP_USERINFO + strUserInfo, strUserInfo,
			((IUserInfoPluginModelRO) m_model).UserInfoChecked(strUserInfo), null));
		
	}
}

