/**
 * Created on Oct 30, 2002
 *
 * To change this generated comment edit the template variable "filecomment":

 * To enable and disable the creation of file comments go to

 */
package com.plumtree.portalpages.admin.editors.webservice.plugins;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.admin.editors.webservice.*;
import com.plumtree.portaluiinfrastructure.classtypedescriptors.providerframework.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 * @author adolfoc
 *
 */
public class UserPrefsPluginModel extends EditorHelperModel
	implements IUserPrefsPluginModelRO, IWSSubModel
{
	
	public static final String STR_MVC_CLASS_NAME = "UserPrefsPlugin";

	/**
	 * These values specify whether this model is used to set community
	 * preferences or user preferences. The call to SetPrefMode can be used
	 * to set this when the model is initialized. GetPrefMode can be used to
	 * get which mode this model is in.
	 */
	public static final int UPPM_PREFMODE_USERPREFS		 = 0;

	
	public static final int UPPM_PREFMODE_COMMUNITYPREFS = 1;

	
	public static final int UPPM_PREFMODE_ADMINPREFS = 2;
	
	
	public static final int UPPM_PREFMODE_SESSIONPREFS = 3;

	/**
	 * The Web Service object being edited by our parent Web Service editor
	 */
	IPTWebService m_ptWebService = null;

	/**
	 * We might get the Remote Server Base URL from
	 * our parent model if it is a WebService Model. It is stored here.
	 */
	private String m_strBaseURL = "";

	/** Template URL to the User Prefs (WebServicePrefsView) */
	private String m_strTemplateUserPrefsURL = "";

	/** URL to the User Prefs (WebServicePrefsView) */
	private String m_strUserPrefsURL = "";
	private int m_nPrefMode			 = 0;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new UserPrefsPluginModel();
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskBeforeWSStore()
	 */
	public void DoTaskBeforeWSStore()
	{
		IXPPropertyBag ptProviderInfo = (IXPPropertyBag) m_ptWebService.GetProviderInfo();
		String strPrefsURL			  = GetPrefsURL();
		String strTemplatePrefsURL    = GetTemplatePrefsURL();
		int nSupportsPersonalization  = m_ptWebService.GetSupportsPersonalization();

		switch (m_nPrefMode)
		{
		case UPPM_PREFMODE_USERPREFS:
			WSModelHelper.PBWrite(ptProviderInfo, AExtensibilityConstants.PT_PROPBAG_HTTPGADGET_PREFSURL, strPrefsURL);

			if ((null == strPrefsURL) || (0 >= strPrefsURL.trim().length()))
			{
				nSupportsPersonalization = nSupportsPersonalization &
					~PT_GADGETPERSONALIZATION_ROLES.PT_GADGETPERSONALIZATION_ENDUSER;
			}
			else
			{
				nSupportsPersonalization = nSupportsPersonalization |
					PT_GADGETPERSONALIZATION_ROLES.PT_GADGETPERSONALIZATION_ENDUSER;
			}

			m_ptWebService.SetSupportsPersonalization(nSupportsPersonalization);

			break;

		case UPPM_PREFMODE_COMMUNITYPREFS:
			WSModelHelper.PBWrite(ptProviderInfo, AExtensibilityConstants.PT_PROPBAG_HTTPGADGET_COMMUNITYPREFSURL, strPrefsURL);

			if ((null == strPrefsURL) || (0 >= strPrefsURL.trim().length()))
			{
				nSupportsPersonalization = nSupportsPersonalization &
					~PT_GADGETPERSONALIZATION_ROLES.PT_GADGETPERSONALIZATION_COMMUNITYOWNER;
			}
			else
			{
				nSupportsPersonalization = nSupportsPersonalization |
					PT_GADGETPERSONALIZATION_ROLES.PT_GADGETPERSONALIZATION_COMMUNITYOWNER;
			}

			m_ptWebService.SetSupportsPersonalization(nSupportsPersonalization);

			break;

		case UPPM_PREFMODE_ADMINPREFS:
			WSModelHelper.PBWrite(ptProviderInfo, AExtensibilityConstants.PT_PROPBAG_HTTPGADGET_ADMINPREFSURL, strPrefsURL);		

			if ((null == strPrefsURL) || (0 >= strPrefsURL.trim().length()))
			{
				nSupportsPersonalization = nSupportsPersonalization &
					~PT_GADGETPERSONALIZATION_ROLES.PT_GADGETPERSONALIZATION_ADMINISTRATOR;
			}
			else
			{
				nSupportsPersonalization = nSupportsPersonalization |
					PT_GADGETPERSONALIZATION_ROLES.PT_GADGETPERSONALIZATION_ADMINISTRATOR;
			}

			WSModelHelper.PBWrite(ptProviderInfo, AExtensibilityConstants.PTC_HTTPGADGET_ADMINPREFSURL_TEMPLT, strTemplatePrefsURL);

			if ((null == strTemplatePrefsURL) ||
					(0 >= strTemplatePrefsURL.trim().length()))
			{
				nSupportsPersonalization = nSupportsPersonalization &
					~PT_GADGETPERSONALIZATION_ROLES.PT_GADGETPERSONALIZATION_ADMINTEMPLATE;
			}
			else
			{
				nSupportsPersonalization = nSupportsPersonalization |
					PT_GADGETPERSONALIZATION_ROLES.PT_GADGETPERSONALIZATION_ADMINTEMPLATE;
			}

			m_ptWebService.SetSupportsPersonalization(nSupportsPersonalization);

			break;
		}
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskOnRemoteServerUpdate(String, String, String)
	 */
	public void DoTaskOnRemoteServerUpdate(String strRemoteServerID,
		String strRemoteServerName, String strRemoteServerBaseURL)
	{
		m_strBaseURL = strRemoteServerBaseURL;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#DoTaskOnWSModeUpdate(int)
	 */
	public void DoTaskOnWSModeUpdate(int nNewWSMode)
	{
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.plugins.IAdminPrefsPluginModelRO#GetBaseURL()
	 */
	public String GetBaseURL()
	{
		return m_strBaseURL;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * This method checks whether this model is used to set community
	 * preferences or user preferences. SetPrefMode can be used
	 * to set this when the model is initialized. GetPrefMode can be used to
	 * get which mode this model is in.
	 */
	public int GetPrefMode()
	{
		return m_nPrefMode;
	}

	/**
	 * Returns the Admin Prefs URL
	 *
	 * @return String
	 */
	public String GetPrefsURL()
	{
		return m_strUserPrefsURL;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.plugins.IUserPrefsPluginModelRO#GetTemplatePrefsURL()
	 */
	public String GetTemplatePrefsURL()
	{
		return m_strTemplateUserPrefsURL;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#GetValidationFunction()
	 */
	public String GetValidationFunction()
	{
		return null;
	}

	/**
	 * @see com.plumtree.portalpages.admin.editors.webservice.IWSSubModel#InitWSModel()
	 */
	public void InitWSModel(IPTWebService ptWebService)
	{
		m_ptWebService = ptWebService;

		IXPPropertyBag ptProviderInfo = (IXPPropertyBag) ptWebService.GetProviderInfo();

		switch (m_nPrefMode)
		{
		case UPPM_PREFMODE_USERPREFS:
			SetPrefsURL(WSModelHelper.PBReadString(ptProviderInfo, AExtensibilityConstants.PT_PROPBAG_HTTPGADGET_PREFSURL, m_strUserPrefsURL));
			break;

		case UPPM_PREFMODE_COMMUNITYPREFS:
			SetPrefsURL(WSModelHelper.PBReadString(ptProviderInfo, AExtensibilityConstants.PT_PROPBAG_HTTPGADGET_COMMUNITYPREFSURL, m_strUserPrefsURL));
			break;

		case UPPM_PREFMODE_ADMINPREFS:
			SetPrefsURL(WSModelHelper.PBReadString(ptProviderInfo, AExtensibilityConstants.PT_PROPBAG_HTTPGADGET_ADMINPREFSURL, m_strUserPrefsURL));
			SetTemplatePrefsURL(WSModelHelper.PBReadString(ptProviderInfo, AExtensibilityConstants.PTC_HTTPGADGET_ADMINPREFSURL_TEMPLT, m_strTemplateUserPrefsURL));
			break;
		}
	}

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorHelperModel#SaveSection(XPHashtable)
	 */
	public int SaveSection(XPHashtable _htFormData)
	{
		int nValid = RepostControl.PAGE_STATUS_VALID;

		switch (m_nPrefMode)
		{
		case UPPM_PREFMODE_COMMUNITYPREFS:
			SetPrefsURL(WSModelHelper.GetFormElementString(_htFormData, UserPrefsPluginView.HTMLINPUT_COMMUNITY_PREFS_URL, m_strUserPrefsURL));
			if ((null != m_strUserPrefsURL && !m_strUserPrefsURL.equals("")) && (null == m_strBaseURL) || (m_strBaseURL.length() <= 0))
			{
				nValid = WSModelHelper.ValidateIsURLString(m_strUserPrefsURL, m_asOwner, m_asOwner.GetString(2625, "ptmsgs_portaladminmsgs"), nValid);
			}

			break;

		case UPPM_PREFMODE_ADMINPREFS:
			SetPrefsURL(WSModelHelper.GetFormElementString(_htFormData, UserPrefsPluginView.HTMLINPUT_ADMIN_PREFS_URL, m_strUserPrefsURL));
			SetTemplatePrefsURL(WSModelHelper.GetFormElementString(_htFormData, UserPrefsPluginView.HTMLINPUT_TEMPLT_ADMIN_PREFS_URL, m_strTemplateUserPrefsURL));
			if ((null != m_strUserPrefsURL && !m_strUserPrefsURL.equals("")) && (null == m_strBaseURL) || (m_strBaseURL.length() <= 0))
			{
				nValid = WSModelHelper.ValidateIsURLString(m_strUserPrefsURL, m_asOwner, m_asOwner.GetString(2625, "ptmsgs_portaladminmsgs"), nValid);
			}

			if ((null != m_strTemplateUserPrefsURL && !m_strTemplateUserPrefsURL.equals("")) && (null == m_strBaseURL) || (m_strBaseURL.length() <= 0))
			{
				nValid = WSModelHelper.ValidateIsURLString(m_strTemplateUserPrefsURL, m_asOwner, m_asOwner.GetString(2625, "ptmsgs_portaladminmsgs"), nValid);
			}

			break;

		case UPPM_PREFMODE_USERPREFS:
		default:
			SetPrefsURL(WSModelHelper.GetFormElementString(_htFormData, UserPrefsPluginView.HTMLINPUT_USER_PREFS_URL, m_strUserPrefsURL));
			if ((null != m_strUserPrefsURL && !m_strUserPrefsURL.equals("")) && (null == m_strBaseURL) || (m_strBaseURL.length() <= 0))
			{
				nValid = WSModelHelper.ValidateIsURLString(m_strUserPrefsURL, m_asOwner, m_asOwner.GetString(2625, "ptmsgs_portaladminmsgs"), nValid);
			}

			break;
		}

		return nValid;
	}

	/**
	 * This method specifies whether this model is used to set community
	 * preferences or user preferences. SetPrefMode can be used
	 * to set this when the model is initialized. GetPrefMode can be used to
	 * get which mode this model is in.
	 */
	public void SetPrefMode(int nPrefMode)
	{
		m_nPrefMode = nPrefMode;
	}

	/**
	 * Sets the Admin Prefs URL
	 *
	 * @param strAdminPrefsURL The Admin Prefs URL to set
	 */
	public void SetPrefsURL(String strPrefsURL)
	{
		this.m_strUserPrefsURL = strPrefsURL;
	}

	/**
	 * Sets the Template Admin Prefs URL
	 *
	 * @param strAdminPrefsURL The Admin Prefs URL to set
	 */
	public void SetTemplatePrefsURL(String strPrefsURL)
	{
		this.m_strTemplateUserPrefsURL = strPrefsURL;
	}
}

