package com.plumtree.portalpages.admin.editors.webservice.userinfotree;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.tree.*;

/**
 * This version of the tree allows for browsing and
 * selecting of objects with no hierarchical structure
 *
 * @author AdolfoC
 */
public class UserInfoStartTreeControl extends AStartTreeControl
{
	/** object name */
	public static final String STR_MVC_CLASS_NAME = "UserInfoStartTree";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#Execute()
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		Redirect result = super.CheckActionSecurityAndExecute(arguments);

		String[] sValues;

		// UserInfo's to select
		sValues = (String[]) arguments.GetElement(UserInfoRefreshTreeControl.SELECTED_USERINFOS);

		if (sValues != null)
		{
			((UserInfoTreeModel)m_asModel).SetUserInfosToSelect(UserInfoRefreshTreeControl.StringToUserInfos(sValues[0]));
		}
		
		// Now load the bugger.
		((UserInfoTreeModel) m_asModel).LoadUserInfo();

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new UserInfoStartTreeControl();
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IControl#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}

