package com.plumtree.portalpages.admin.editors.webservice.userinfotree;

import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.tree.*;

/**
 * This version of the tree allows for browsing and
 * selecting of objects with no hierarchical structure
 *
 * @author AdolfoC
 */
public class UserInfoTreeAS extends ATreeAS
{
	/** object name */
	public static final String STR_MVC_CLASS_NAME = "UserInfoTree";

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IPTActivitySpace#CheckBasicAccess(String, String, boolean)
	 */
	public boolean CheckBasicAccess(String strPage, String strControl,
		boolean bSameSpace)
	{
		return true;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new UserInfoTreeAS();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#Init()
	 */
	public void Init()
	{
		super.Init();

		RegisterModel(UserInfoTreeModel.STR_MVC_CLASS_NAME, TREEMODEL);

		IModel myModel = GetModel(TREEMODEL);

		RegisterView(TreeView.STR_MVC_CLASS_NAME, myModel);
		RegisterView(TreeBarView.STR_MVC_CLASS_NAME,
			TreeDP.TREE_BAR_STORAGE_NAME, myModel);

		RegisterControl(UserInfoStartTreeControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(UserInfoRefreshTreeControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(TreeRepostControl.STR_MVC_CLASS_NAME, myModel);
	}
}

