package com.plumtree.portalpages.admin.httpmemorydebugging;

import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.xpshared.htmlelements.*;


/**
 * This Display Page displays HTTPMemoryDebugView.
 * 
 * @author Julie Fournier
 */
public class HTTPMemoryDebugDP extends PlumtreeDP
{
	/** Class name for the activity space */
	public static final String STR_MVC_CLASS_NAME = "HTTPMemoryDebug";
	

	public String GetTitleForBanner()
	{
		return m_asOwner.GetString(1953, "ptmsgs_portaladminmsgs");	
	}
	
	public String GetSubtitleForBanner()
	{
		return "";	
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()
	{
		return m_asOwner.GetView(HTTPMemoryDebugView.STR_MVC_CLASS_NAME).Display();
	}
	
	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = new HTMLScriptCollection();

		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
				HTTPMemoryDebugView.STR_MVC_CLASS_NAME).DisplayJavascript());

		return myScripts;
	}
}

