package com.plumtree.portalpages.admin.objmgr;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.opener.*;

/**
 * @author dustina
 *
 */
public class AdminLoginTokenControl implements IControl  
{
	/** Name of this control */
	public static final String STR_MVC_CLASS_NAME = "AdminLoginTokenControl";

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#CheckActionSecurityAndExecute(com.plumtree.openfoundation.util.XPHashtable)
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		String adminURL = PTConfigHelper.GetFullAdminSiteURL() + "?" +
			IOpenerConstants.QS_OPEN + "=" + PT_CLASSIDS.PT_ADMIN_FOLDER_ID + "&" +
			IOpenerConstants.QS_OBJECTID + "=" + PT_INTRINSICS.PT_ADMIN_FOLDER_ROOTFOLDER + "&" +
			IOpenerConstants.QS_MODE + "=" + IOpenerConstants.OPENER_MODE_VIEW + "&" +
			ASConstants.CACHED + "=" + XPConvert.ToString(true);
		
		Redirect redirect = new Redirect();
		redirect.SetLinkToExternalURL(adminURL);
		return redirect;
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#Init(com.plumtree.uiinfrastructure.activityspace.IModel, com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
	 */
	public void Init(IModel model, AActivitySpace space) {
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create() {
		return new AdminLoginTokenControl();
	}
}