package com.plumtree.portalpages.admin.objmgr;

/**
 * @author Don Hayler
 */
public interface IObjMgrDeleteRO
{
	/**
	 * This method checks if any users or groups came from an auth source other
	 * than plumtree.  This assumes that any objects to check were set on the
	 * model earlier in the request (as they will be deleted between requests).
	 *
	 * @return true implies objects did come from an outside auth source
	 */
	public boolean CheckAuthSourceForDelete();

	/**
	 * This method checks whether or not the user is trying to delete any page templates.
	 *
	 * @return true implies page templates are being deleted
	 */
	public boolean CheckPageTemplatesForDelete();

	/**
	 * This method checks whether or not the user is trying to delete any folders.
	 *
	 * @return true implies folders are being deleted
	 */
	public void SetFoldersForDeleteCheck(boolean tf);
	
	/**
	 * This method is used to set the list of folder IDs (temporary)
	 * to be checked for delete.
	 *
	 * @param int[] of object class id / object id pairs.
	 */
	public void SetObjectsForDeleteCheck(int[] nObjectIDPairs);
	
	
	public boolean CheckFoldersForDelete();



}
