package com.plumtree.portalpages.admin.objmgr;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.portalpages.common.folder.*;
import com.plumtree.portaluiinfrastructure.resultwrapper.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author Don Hayler
 */
public class ObjMgrBreadCrumbView extends BreadcrumbView
{
	/** object name */
	public static final String STR_MVC_CLASS_NAME = "ObjMgrBreadcrumb";

	/** object manager model (for custom path code) */
	protected IObjMgrModelRO m_asObjMgrModel;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new ObjMgrBreadCrumbView();
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IView#getName()
	 */
	public String GetName()
	{
		return ObjMgrBreadCrumbView.STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IView#init(IModelRO, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_asObjMgrModel = (IObjMgrModelRO) model;
		super.Init(model, parent);
	}

	/**
	 * override this to provide our own links
	 */
	protected PTBreadcrumbPath GetBreadcrumbPath()

	{
		PTBreadcrumbPath myCrumbs = new PTBreadcrumbPath();

		HTMLAnchor myAnchor;

		IASQueryResult qrPath = m_asObjMgrModel.GetBreadCrumbPath();

		int nPathCount = qrPath.GetCount();

		for(int i=0; i<nPathCount; i++)
		{
			int nFolderID = XPConvert.ToInteger(qrPath.GetFields(i, PT_PROPIDS.PT_PROPID_OBJECTID));
			String strFolderName = (String) qrPath.GetFields(i, PT_PROPIDS.PT_PROPID_NAME);

			String strEncodedFolderName = XPHttpUtility.HtmlEncode(strFolderName);

			if(i < (nPathCount - 1))
			{
				myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
				myAnchor.SetOnClick(ObjMgrHeaderView.JAVASCRIPT_OPEN_FOLDER +
					"(" + nFolderID + "); return false;");
				myAnchor.AddInnerHTMLString(strEncodedFolderName);
				myAnchor.SetTitle(strEncodedFolderName);
				myCrumbs.appendAnchorItem(myAnchor);
			}
			else
			{
				myCrumbs.appendTextItem(strEncodedFolderName);
			}
		}

		return myCrumbs;

/*
		XPStringTokenizer stPath = new XPStringTokenizer(m_asModel.GetPath(),
				"\\");
		Object[] oIDs			 = m_asModel.GetParentFolderIDs();

		// In the case of the root folder, there will be two oIDs even though there
		// is only one folder in stPath.  Otherwise there will be an equal number of
		// IDs and folder names.		
		if (oIDs.length < stPath.GetTokenCount())
		{
			if (PTDebug.IsErrorTracingEnabled(Component.Portal_Admin))
			{
				PTDebug.Trace(Component.Portal_Admin, TraceType.Error,
					"There are more parent names (" + stPath.GetTokenCount() +
					"than ids (" + oIDs.length + ").");
			}

			return myCrumbs;
		}

		HTMLAnchor myAnchor;
		int i   = 0;
		int end = stPath.GetTokenCount();
		String strName;

		while (stPath.HasMoreTokens())
		{
			strName = stPath.GetNextToken();
			strName = GeneralHelpers.TruncateLongString(strName,
				ObjMgrAS.MAX_DISPLAYED_NAME_LENGTH, false);

			if (i < (end - 1))
			{
				myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
				myAnchor.SetOnClick(ObjMgrHeaderView.JAVASCRIPT_OPEN_FOLDER +
					"(" + oIDs[i++] + "); return false;");
				myAnchor.AddInnerHTMLEncodedString(strName);
				myCrumbs.appendAnchorItem(myAnchor);
			}
			else
			{
				myCrumbs.appendTextItem(XPHttpUtility.HtmlEncode(strName));

				// Probably not necessary -- should break out of loop after this.
				i++;
			}
		}

		return myCrumbs;
		*/
	}
}

