package com.plumtree.portalpages.admin.objmgr;

import com.plumtree.portalpages.admin.objsearch.*;
import com.plumtree.portalpages.common.folder.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;
/**
 * @author Don Hayler
 *
 */
public class ObjMgrSearchView implements IView
{
	/** object name */
	public static final String STR_MVC_CLASS_NAME = "ObjMgrSearchView";

	/** localized strings */
	protected AActivitySpace m_asOwner;
	protected IFolderModelRO m_asModel;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new ObjMgrSearchView();
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		// Just call AdminSearchForm.GetObjectSearchForm()
		// to do all the work..
		return AdminSearchForm.GetObjectSearchForm(m_asOwner,
			
		// Give the form a unique name

		/* name= */ AFormDP.HTMLFORM_NAME, 
		// When form is submitted, results appear on page SampleResultsDP of the current space

		/* targetSpace= */ AdminSearchAS.STR_MVC_CLASS_NAME, 
		/* targetSpaceID= */ null, // null means create a new space
		/* targetPage= */ AdminSearchDP.STR_MVC_CLASS_NAME,
		// Display a prompt

		/* prompt= */ m_asOwner.GetString(1982, "ptmsgs_portaladminmsgs"), 
		// Restrict to this folder

		/* currentAdminFolder= */ m_asModel.GetCurrentFolderID(), 
		// No object type restriction; type is selectable from a pulldown

		/* objectClassIDs= */ null, 
		// Not needed if you've implemented your own view of search results

		/* makeEditLinks= */ true,
		/* return complete form= */ false,
		/* overrideEnclosingForm */ true,
		/* additional elements */ AdminFollowupSearchView.GetAdvancedAdminSearchLink(m_asOwner),
		/* validate alert */ true);
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		// by default, return nothing
		return null;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IView#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_asModel     = (IFolderModelRO) model;
		m_asOwner     = parent;
	}
}

