package com.plumtree.portalpages.admin.objmgr.popups;

import com.plumtree.portalpages.admin.objmgr.*;
import com.plumtree.portalpages.common.createfolder.*;

/**
 * @author Don Hayler
 *
 * This view is for a simple pop-up to create an admin folder.
 */
public class ObjMgrCreateFolderView extends CreateFolderView
{
	/** name of this view */
	public static final String STR_MVC_CLASS_NAME = "ObjMgrCreateFolder";


	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new ObjMgrCreateFolderView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.common.createfolder.CreateFolderView#GetBannerTitle()
	 */
	public String GetBannerTitle() 
	{
		return m_asOwner.GetString(1977, "ptmsgs_portaladminmsgs");
	}

	/**
	 * @see com.plumtree.portalpages.common.createfolder.CreateFolderView#GetCreateFolderRepostAction()
	 */
	public int GetCreateFolderRepostAction() 
	{
		return ObjMgrRepostControl.POSTTOSELF_ACTION_CREATE_FOLDER;
	}
}

