package com.plumtree.portalpages.admin.objmgr.popups;

import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author Don Hayler
 *
 */
public class ObjMgrDeleteWarningsDP implements IDisplayPage //extends AFormDP
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.objmgr.popups.ObjMgrDeleteWarningsDP");

	/** object name */
	public static final String STR_MVC_CLASS_NAME = "ObjMgrDeleteWarnings";

	/** owner */
	protected AActivitySpace m_asOwner;


	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Display()
	 */
	public void Display(IWebData pageData)
	{
		HTMLPage myPage = new HTMLPage();

		// Set the HTMLPage as the data to be sent to the browser.
		pageData.SetData(myPage);

		HTMLHead myHead = new HTMLHead();
		myPage.SetHead(myHead);

		HTMLTitle myTitle = new HTMLTitle(m_asOwner.GetString(1211,
					"ptmsgs_portaladminmsgs"));

		HTMLBody myBody = new HTMLBody();
		myPage.SetBody(myBody);
		myBody.SetMarginHeight("0");
		myBody.SetMarginWidth("0");
		myBody.SetLeftMargin("0");
		myBody.SetTopMargin("0");

		try
		{
			// Set to dark background color
			myBody.SetStyleClass(PTStyleClass.ALERT_DIALOG_BG);

			myHead.AddInnerHTMLElement(myTitle);

			myHead.AddInnerHTMLElement(m_asOwner.GetStyleSheetLinks());
			myHead.AddInnerHTMLElement(DisplayJavascript());

			myBody.AddInnerHTMLElement(m_asOwner.GetView(
					ObjMgrDeleteWarningsView.STR_MVC_CLASS_NAME).Display());
		}
		catch (HTMLException he)
		{
			
				log.Error(he, "Display: The following HTML error occured when trying to display the HTML.");
			
		}
		catch (Exception e)
		{
			
				log.Error(e, "Display: The following error occured when trying to display the HTML.");
			
		}
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#GetOwner()
	 */
	public AActivitySpace GetOwner()
	{
		return m_asOwner;
	}

	////////////////
	// Class Methods
	////////////////

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Init(AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		m_asOwner = parent;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()

	{
		return m_asOwner.GetView(ObjMgrDeleteWarningsView.STR_MVC_CLASS_NAME)
		.Display();
	}

	/**
	 * Display the javascript from the view
	 */
	protected HTMLScript DisplayJavascript()

	{
		return m_asOwner.GetView(ObjMgrDeleteWarningsView.STR_MVC_CLASS_NAME)
		.DisplayJavascript();
	}
}

