package com.plumtree.portalpages.admin.ptutilities;

import com.plumtree.portalpages.browsing.settings.*;

/**
 * 
 *
 * @version 5.0
 * @author SudhaSathiaseelan
 * @author Mark Schaaf
 */
public interface IPlumtreeUtilities extends ISettings {
	/**
	 * Activity rights now restrict certain utility menu items;  this method allows access to the restricting
	 * activity right
	 * 
	 * The following table outlines the utility security menu access:
	 * Utility						Activity Right or Group Required for Access
	 * Activity Manager				Create Activities
	 * Approve Documents			Access Utilities
	 * Approve Objects for Migration	Administrators Group Only
	 * Audit Manager				Administrators Group Only
	 * Automation Server			Administrators Group Only
	 * Default Profiles				Create User
	 * Global ACL Sync Map			Administrators Group Only
	 * Global Document Property Map	Administrators Group Only
	 * Global Document Type Map		Administrators Group Only
	 * Global Object Properties Map	Administrators Group Only
	 * Knowledge Directory Preferences	Administrators Group Only
	 * Localization Manager			Administrators Group Only
	 * Object Migration Status		Access Utilities
	 * Portal Resources - Export	Administrators Group Only
	 * Portal Resources - Import	Administrators Group Only
	 * Portal Server Settings		Administrators Group Only
	 * Release Item Locks			Administrators Group Only
	 * Release User Locks			Administrators Group Only
	 * Search Server Manager		Administrators Group Only
	 * Smart Sort					Create Taxonomists
	 * Subportal Manager			Create Subportals
	 * Tag Libraries Manager		Administrators Group Only
	 * User Profile Manager			Edit User Info Map
	 * Custom						Read access to the Custom Utilities Web Service
	 * @return PT_ACTIVITY_RIGHTS value which restricts the access to this utility
	 */
	public int GetActivityRightRestriction();
}

