package com.plumtree.portalpages.admin.ptutilities.activitysecurity;

// Framework Imports
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This is class is used to print out together the Views for
 * the Sub Editors page of the Main Editor.
 *
 * @author SudhaS
 */

public class MainActivityRightsDP extends EditorDP {
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.ptutilities.activitysecurity.MainActivityRightsDP");


	
	public static final String STR_MVC_CLASS_NAME = "MainActivityRights";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString() {
		return (m_asOwner.GetString(1349, "ptmsgs_portaladminmsgs"));
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader()
	{
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(1646, "ptmsgs_portaladminmsgs"),
			this.m_asOwner);
	}

	
	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for that Page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()
	 *
	 * @return HTMLElement
	 * @throws HTMLException
	 */
	public HTMLElement PageDisplay() {
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		try {
			result.AddInnerHTMLElement(super.PageDisplay());

			HTMLElementCollection views = new HTMLElementCollection();

			views.AddInnerHTMLElement(
				((EditorView) m_asOwner
					.GetView(
						MainActivityRightsEditorAS
							.strStorageActivityRightsList))
					.Display());

			result.AddInnerHTMLElement(CreateLeftNavBar(views));
		} catch (HTMLException e) {
			
				log.Error(e, "MainActivityRightsDP::PageDisplay.");
			
		}

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		// ***CHANGE_HERE*** If that DP doesn't have any JavaScripts, 
		//      you can delete the entire DisplayJavaScriptFromChild() method.
		HTMLScriptCollection myScripts = null;

		myScripts = super.DisplayJavaScriptFromChild();

		// ***CHANGE_HERE*** Call the DisplayJavascript() method for all the Views having JavaScripts 
		//      displayed by that DP.
		myScripts.AddInnerHTMLElement(
			m_asOwner
				.GetView(
					MainActivityRightsEditorAS.strStorageActivityRightsList)
				.DisplayJavascript());

		return myScripts;
	}
}

