package com.plumtree.portalpages.admin.ptutilities.automationserver;

// Framework Imports
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This is class is used to print out together the Views for
 * the Sub Editors page of the Main Editor.
 *
 * @author SudhaS
 */

public class AutomationServerDP extends EditorDP {
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.ptutilities.automationserver.AutomationServerDP");


	
	public static final String STR_MVC_CLASS_NAME = "AutomationServer";

	
	
	public static final String HTMLHIDDEN_POPUP_NAME = "in_hi_PopUpName";

	
	public static final String HTMLHIDDEN_POPUP_NETADDR = "in_hi_PopUpNetAddr";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString() {
		return (m_asOwner.GetString(1434, "ptmsgs_portaladminmsgs"));
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader()
	{
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(1657, "ptmsgs_portaladminmsgs"),
			this.m_asOwner);
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for that Page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()
	 *
	 * @return HTMLElement
	 * @throws HTMLException
	 */
	public HTMLElement PageDisplay() {
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		try {
			result.AddInnerHTMLElement(super.PageDisplay());

			HTMLElementCollection views = new HTMLElementCollection();

			// ***CHANGE_HERE*** For each Section you want to display on that page, 
			//       copy the line below and replace MainView with your Section name.
			views.AddInnerHTMLElement(
				((EditorView) m_asOwner
					.GetView(
						AutomationServerEditorAS
							.strStorageAutomationServerList))
					.Display());

			result.AddInnerHTMLElement(CreateLeftNavBar(views));

			HTMLInput myInput =
				new HTMLInput(HTMLInputTypes.HIDDEN, HTMLHIDDEN_POPUP_NAME, "");
			result.AddInnerHTMLElement(myInput);
			myInput =
				new HTMLInput(
					HTMLInputTypes.HIDDEN,
					HTMLHIDDEN_POPUP_NETADDR,
					"");
			result.AddInnerHTMLElement(myInput);
		} catch (HTMLException e) {
			log.Error(e, "AutomationServerDP Error");
		}

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		// ***CHANGE_HERE*** If that DP doesn't have any JavaScripts, 
		//      you can delete the entire DisplayJavaScriptFromChild() method.
		HTMLScriptCollection myScripts = null;

		myScripts = super.DisplayJavaScriptFromChild();

		// ***CHANGE_HERE*** Call the DisplayJavascript() method for all the Views having JavaScripts 
		//      displayed by that DP.
		myScripts.AddInnerHTMLElement(
			m_asOwner
				.GetView(
					AutomationServerEditorAS.strStorageAutomationServerList)
				.DisplayJavascript());

		return myScripts;
	}
}

