package com.plumtree.portalpages.admin.ptutilities.automationserver;


// Framework Imports
import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This Section represents a section of the main page
 * of the Misc Editor.
 * This Section is printed out by Misc2DP.
 *
 * @author SudhaS
 */

// ***CHANGE_HERE*** Change the name of the class.
// ***COMMENT_1*** Delete the comments prefixed by CHANGE_HERE and COMMENT
//       when you are done.
public class AutomationServerPopUpView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.ptutilities.automationserver.AutomationServerPopUpView");

	// ***CHANGE_HERE*** Set the class name.
	// ***COMMENT_1*** All the Views in Plumtree need to have a unique name.

	
	public static final String STR_MVC_CLASS_NAME = "AutomationServerPopUp";

	// Strings to localize.
	// ***CHANGE_HERE*** List of the Strings that need to be localized.
	// ***COMMENT_1*** The names should all start with "_ui_".

	// HTML Object names.
	// ***CHANGE_HERE*** Declare some constans for each 
	//        HTML object you are using in the display method
	// ***COMMENT_1*** You should follow the HTMLElements naming standards:
	//       <select> starts with in_se
	//       <input button> starts with in_bu
	//       <input text> starts with in_tx
	//       <input checkbox> starts with in_cb
	//       <input radio> starts with in_ra
	//       <textarea> starts with in_ta
	public static final String HTMLINPUT_SERVERNAME = "in_tx_servername";

	
	public static final String HTMLINPUT_NETNAME = "in_tx_netname";

	
	public static final String HTMLBUTTON_DONE   = "in_bu_done";

	
	public static final String HTMLBUTTON_CANCEL = "in_bu_cancel";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new AutomationServerPopUpView();
	}

	/**
	 * Returns the HTML for the Section.
	 *
	 * @return HTMLElement
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		HTMLTable myTable;
		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLInput myInput;
		HTMLSpan mySpan;
		HTMLH1 headerH1;
		
		try
		{
			// ***CHANGEHERE*** Write the HTML for your Section.
			// ***COMMENT_1*** The HTML below can be used as a reference 
			//       to write some HTMLElements.
			// ***COMMENT_2*** Also look at PropMainView and PropAdvView in template1
			//      for more HTML example.
			HTMLComment myComment = new HTMLComment( "Begin: Display PopUpView");
			result.AddInnerHTMLElement(myComment);

			myTable = new HTMLTable();
			myTable.SetStyleClass(PTStyleClass.DIALOGUE_BG);
			result.AddInnerHTMLElement(myTable);
			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("0");
			myTable.SetCellSpacing("10");

			// 1st Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);

			headerH1 = new HTMLH1();
			myCell.AddInnerHTMLElement(headerH1);
			headerH1.AddInnerHTMLString(m_asOwner.GetString(1454,
					"ptmsgs_portaladminmsgs"));
			headerH1.SetStyleClass(PTStyleClass.BAN_HEADER);
			myCell.SetNoWrap(true);

			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);

			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);
			mySpan.AddInnerHTMLString(m_asOwner.GetString(1455,
					"ptmsgs_portaladminmsgs") + "<br>");
			myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_SERVERNAME,
					"");
			myCell.AddInnerHTMLElement(myInput);
			myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
			myInput.SetSize(60);

			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);

			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1456,
					"ptmsgs_portaladminmsgs") + "<br>");
			myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_NETNAME, "");
			myCell.AddInnerHTMLElement(myInput);
			myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
			myInput.SetSize(60);

			// 2nd Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			//myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetAlign(CommonHTMLStrings.CENTER);

			// ***EXAMPLE*** How to implement a repost action?
			// ***Done Action*** begins here
			myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_DONE, "");
			myCell.AddInnerHTMLElement(myInput);

			myInput.SetValue(m_asOwner.GetString(1451, "ptmsgs_portaladminmsgs"));
			myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
			myInput.SetOnClick("OnDone(); return false;");	// mj: removed 'Javascript:' from function name

			// ***Done Action*** ends here
			// ***Cancel Action*** begins here
			myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_CANCEL, "");
			myCell.AddInnerHTMLElement(myInput);

			myInput.SetValue(m_asOwner.GetString(1452, "ptmsgs_portaladminmsgs"));
			myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
			myInput.SetOnClick("window.close(); return false;");	// mj: removed 'Javascript:' from function name

			// ***Cancel Action*** ends here
			// 2nd Row end
			myComment = new HTMLComment( "End: Display PopUpView");
			result.AddInnerHTMLElement( myComment );
		}
		catch (Exception e)
		{
			// ***CHANGE_HERE*** Update the error messages (log and exception).
			
				log.Error(e, "PopUpView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(1453,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * This method returns the HTMLScript that encompasses the Javascript on the page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 *
	 * @return HTMLScript
	 */
	public HTMLScript DisplayJavascript()
	{
		HTMLScript myScript = new HTMLScript("text/javaScript");

		XPStringBuilder sb;

		try
		{
			// JF- OnDone JavaScript function
			sb = new XPStringBuilder(200);
			sb.Append("function OnDone()\n");
			sb.Append("{\n");

			// JF- First we set the value of "Setting 3" into a hidden input of the main form
			//sb.Append("  window.opener.document." + AFormDP.HTMLFORM_NAME 
			//	+ "." + Misc2View.HTMLHIDDEN_MISC2_SETTING3 + ".value = document." 
			//	+ AFormDP.HTMLFORM_NAME + "." + HTMLINPUT_POPUPSTRING + ".value;\n");
			// JF- Then we repost the main form
			sb.Append("  window.opener.document." + AFormDP.HTMLFORM_NAME +
				"." + AutomationServerDP.HTMLHIDDEN_POPUP_NAME +
				".value = document." + AFormDP.HTMLFORM_NAME + "." +
				HTMLINPUT_SERVERNAME + ".value;\n");
			sb.Append("  window.opener.document." + AFormDP.HTMLFORM_NAME +
				"." + AutomationServerDP.HTMLHIDDEN_POPUP_NETADDR +
				".value = document." + AFormDP.HTMLFORM_NAME + "." +
				HTMLINPUT_NETNAME + ".value;\n");
			sb.Append("   window.opener.").Append(AFormDP.JAVASCRIPT_SUBMIT_FORM)
			.Append("(")
			.Append(AutomationServerRepostControl.POSTTOSELF_ACTION_DONE_POPUP)
			.Append(");\n");

			// JF- Finally we close the pop-up window
			sb.Append("   window.close();\n");
			sb.Append("}\n");

			myScript.AddInnerHTMLString(sb.ToString());
		}
		catch (HTMLException he)
		{
			
				log.Error(he, "PopUpView::DisplayJavascript The following error occured when trying to display the JavaScript: " +
					he.getMessage());
			
		}

		return myScript;
	}

	// ***CHANGE_HERE*** Update the class name below.

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}

