package com.plumtree.portalpages.admin.ptutilities.condition;


// Framework Imports
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.expandablelist.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 *
 */
public class SubportalRulesManagerMainDP extends EditorDP
{
	public static final String STR_MVC_CLASS_NAME = "SubportalRulesManagerMainDP";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return m_asOwner.GetString(2850, "ptmsgs_portaladminmsgs");
	}


	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

  	/**
	 * Implement this method to add HTML below the sub header.
	 *
	 * @return HTMLElement
	 *
	 * @throws HTMLException
	 */
	protected HTMLElement GetHTMLBelowSubHeader() throws HTMLException {
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(2884, "ptmsgs_portaladminmsgs"),
			this.m_asOwner);
	}


	/**
	 * Returns the HTML for the General Info page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 *
	 * @return HTMLElement
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());
		result.AddInnerHTMLElement(ExpListView.GetHiddenInputsForPagination());

		HTMLElementCollection views = new HTMLElementCollection();
		views.AddInnerHTMLElement(m_asOwner.GetView(SubportalRulesManagerAS.SUBPORTAL_RULES_LIST).Display());
		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();
		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
				SubportalRulesManagerAS.SUBPORTAL_RULES_LIST).DisplayJavascript());
		myScripts.AddInnerHTMLElement(ExpListView.GetJavaScriptsForPagination(m_asOwner));

		return myScripts;
	}
}

