package com.plumtree.portalpages.admin.ptutilities.credentialvaultmanager;

// Framework Imports
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;


/**
 * 
 * @author jennifersu
 *
 */
public class CredentialVaultManagerMainDP extends EditorDP {
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.ptutilities.credentialvaultmanager.CredentialVaultManagerMainDP");
	
	public static final String STR_MVC_CLASS_NAME = "CredentialVaultManagerMainDP";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString() {
		// Main Settings
		return (m_asOwner.GetString(2902, "ptmsgs_portaladminmsgs"));
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader()
	{
		// Credential Vault Manager instructions
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(2901, "ptmsgs_portaladminmsgs"),
			this.m_asOwner);
	}

	
	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for that Page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()
	 *
	 * @return HTMLElement
	 * @throws HTMLException
	 */
	public HTMLElement PageDisplay() {
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		try {
			result.AddInnerHTMLElement(super.PageDisplay());

			HTMLElementCollection views = new HTMLElementCollection();

			views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(CredentialVaultManagerAS.strLockboxList)).Display());

			result.AddInnerHTMLElement(CreateLeftNavBar(views));
		} catch (HTMLException e) {
			
				log.Error(e, STR_MVC_CLASS_NAME + "::PageDisplay : " + e.GetMessage());
			
		}

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection myScripts = null;

		myScripts = super.DisplayJavaScriptFromChild();

		myScripts.AddInnerHTMLElement(m_asOwner.GetView(CredentialVaultManagerAS.strLockboxList).DisplayJavascript());

		return myScripts;
	}
}

