package com.plumtree.portalpages.admin.ptutilities.customactivity;

// Framework Imports
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 * @author SudhaS
 */


public class CustomActivityDP extends EditorDP {
	
	public static final String STR_MVC_CLASS_NAME = "CustomMain";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString() {
		return (m_asOwner.GetString(1458, "ptmsgs_portaladminmsgs"));
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader()
	{
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(1647, "ptmsgs_portaladminmsgs"),
			this.m_asOwner);
	}

	
	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the General Info page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 *
	 * @return HTMLElement
	 */
	public HTMLElement PageDisplay() {
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(GeneralInfoView.STR_MVC_CLASS_NAME))
				.Display());

		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(CustomActivityEditorAS.strStorageSelectPTObject))
				.Display());

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	* Display the Javascripts for the Views.
	*
	* @return HTMLScriptCollection
	* @throws HTMLException
	*/
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		// ***CHANGE_HERE SELECTPTOBJECT*** Display JavaScripts for the Select PTObject list.
		myScripts.AddInnerHTMLElement(
			m_asOwner
				.GetView(CustomActivityEditorAS.strStorageSelectPTObject)
				.DisplayJavascript());

		myScripts.AddInnerHTMLElement(
			m_asOwner
				.GetView(GeneralInfoView.STR_MVC_CLASS_NAME)
				.DisplayJavascript());

		return myScripts;
	}
}

