package com.plumtree.portalpages.admin.ptutilities.customactivity;


// Framework Imports
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.editor.commonpages.migrationhistory.*;
import com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.expandablelist.*;

/**
 *
 * @author SudhaS
 */


public class CustomActivityEditorAS extends PTEditorAS
{
	
	public static final String STR_MVC_CLASS_NAME = "CustomActivityEditor";

	
	public static final String strStorageSelectPTObject = "SelectUserPTObject";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new CustomActivityEditorAS();
	}

	/**
	 * Sets the Editor title.
	 *
	 */
	public String GetEditorTitle()
	{
		if (EditorStartControl.EDITOR_START_FLAG_CREATE == ((EditorModel) GetModel(
					m_strModelName)).GetEditorType())
		{
			return (GetString(1459, "ptmsgs_portaladminmsgs"));
		}
		else
		{
			return (GetString(1460, "ptmsgs_portaladminmsgs"));
		}
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	
	/**
	 * Returns the class name of the Repost Control.
	 *
	 * @return String
	 */
	public String GetRepostControlName()
	{
		return (CustomActivityRepostControl.STR_MVC_CLASS_NAME);
	}

	/**
	 * Registers all the classes for this Activity Space.
	 */
	public void Init()
	{
		m_strModelName = CustomActivityModel.STR_MVC_CLASS_NAME;

		super.Init();

		IModel myModel = GetModel(m_strModelName);

		// Get back the Model we just registered because we need it to register the Section and the Control
		RegisterModel(SelectPTObjectModel.STR_MVC_CLASS_NAME,
			strStorageSelectPTObject);

		IModel mySelectPTObjectModel = GetModel(strStorageSelectPTObject);
	
		RegisterView(CustomActivityListView.STR_MVC_CLASS_NAME,
			strStorageSelectPTObject, mySelectPTObjectModel);
		RegisterControl(ExpListControl.STR_MVC_CLASS_NAME,
			strStorageSelectPTObject, mySelectPTObjectModel);

		// Register DisplayPages
		//RegisterPage(new MainDP());
		CustomActivityDP mainDP = new CustomActivityDP();
		RegisterPage(mainDP);

		mainDP.AddToValidationFunction("CheckName");
		mainDP.AddToValidationFunction("CheckURI");

		// Register Views
		RegisterView(GeneralInfoView.STR_MVC_CLASS_NAME, myModel);

		// Register Controls
		RegisterControl(CustomActivityRepostControl.STR_MVC_CLASS_NAME, myModel);

		// Default page
		SetCurrentPage(CustomActivityDP.STR_MVC_CLASS_NAME);

		// Register Migration History Plugin
		RegisterModel(MigrationHistoryPluginModel.STR_MVC_CLASS_NAME);
		RegisterView(MigrationHistoryView.STR_MVC_CLASS_NAME,
			GetModel(MigrationHistoryPluginModel.STR_MVC_CLASS_NAME));
		RegisterPage(new MigrationHistoryPluginDP());

		//Sets left nav menu
		int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(1461,
					"ptmsgs_portaladminmsgs"));
		m_mEditorMenu.AddLinkToSubMenu(nMenuOneID,
			CustomActivityDP.STR_MVC_CLASS_NAME);
		m_mEditorMenu.AddLinkToSubMenu(nMenuOneID,
			MigrationHistoryPluginDP.STR_MVC_CLASS_NAME);
	}
	
	/**
	 * Set the help page for this editor. 
	 *
	 * @param page 
	 * 
	 * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage(com.plumtree.uiinfrastructure.activityspace.IDisplayPage)
	 */
	public void SetCurrentPage(IDisplayPage page)
	{
		super.SetCurrentPage(page);

		String sPageName = page.GetName();

		if (CustomActivityDP.STR_MVC_CLASS_NAME.equals(sPageName))
		{
			this.SetHelpTopic("PT_PortalActivity_MainSettings");
		}
	}
}

