package com.plumtree.portalpages.admin.ptutilities.customactivity;

import com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.*;
import com.plumtree.uiinfrastructure.arraywrapper.*;
import com.plumtree.uiinfrastructure.expandablelist.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author SudhaS
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class CustomActivityListView extends SelectPTObjectView {
	
	/**
	 * Class name for the activity space */
	public static final String STR_MVC_CLASS_NAME = "CustomActivityList";
	
	public Object Create()
	{
		return new CustomActivityListView();
	}
	
	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
	
	/**
	 * Returns the HTML for the Action bar.
	 * (The one with the add and delete icons).
	 *
	 * @return HTMLTable
	 * @throws Exception
	 */
	protected HTMLTable GetHTMLForActionBar()
	{
		HTMLTable myTable;
		HTMLTableRow myRow;
		HTMLTableCell myCell;

		myTable = new HTMLTable();
		myTable.SetBorder("0");
		myTable.SetCellPadding("0");
		myTable.SetCellSpacing("0");
		
		CustomActivityModel customActivityModel = (CustomActivityModel) m_asOwner.GetModel(CustomActivityModel.STR_MVC_CLASS_NAME);
		boolean bDelegateRight = customActivityModel.GetDelegateRight();
		

		// 1st Row begin (there is only one row)
		myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		myRow.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BG);
		
		// JF- Get the Object array from the Model.
		IPTGrowableSortedArrayWrapperRO saData = ((IExpListModelRO) m_model).GetReadOnlyItems();


		if (bDelegateRight) {
			// DCA - check if add button wants to be shown
			// JF- Don't display the add button if we have reached the max number
			if (!((IExpListModelRO) m_model).IsAddButtonDisabled() && (saData.GetCount() < ExpListModel.MAX_ROWS))
			{
				
				// Add icon cell
				myRow.AddInnerHTMLElement(GetHTMLForAddAction());
	
				// Empty Cell
				myRow.AddInnerHTMLElement(GetHTMLForEmptyCellInActionBar());
			}
	
			// Add Extra HTML to the action bar (like a "create" button)
			AddHTMLToActionBar(myRow);
	
			// Empty Cell
			myRow.AddInnerHTMLElement(GetHTMLForEmptyCellInActionBar());
	
			// JF- No need to display the delete icon, if the list is empty.
			if (0 != ((IExpListModelRO) m_model).GetReadOnlyItems().GetCount())
			{
				// Delete icon cell
				myRow.AddInnerHTMLElement(GetHTMLForDeleteAction());
			}
	
			// Last Empty Cell
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetWidth("100%");
			myCell.SetHeight("25");
			myCell.AddInnerHTMLString(SPACE);
		
		} else {
			//Add message to tell user that they do not have rights to create/delete an activity
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			//myCell.SetWidth("100%");
			myCell.SetHeight("25");
			myCell.AddInnerHTMLString(SPACE);
			
			myCell = new HTMLTableCell();
			myCell.SetWidth("100%");
			myCell.SetHeight("25");
			myRow.AddInnerHTMLElement(myCell);
			
			myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
			myCell.AddInnerHTMLString(m_asOwner.GetString(2369, "ptmsgs_portaladminmsgs"));
					
		}

		// 1st Row ends
		return myTable;
	}
	
	
}

