package com.plumtree.portalpages.admin.ptutilities.diagnostic;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 * This model handles security for the Diagnostic Page Editor.
 * 
 * @author DonH
 */
public class DiagnosticPageModel extends EditorModel
{
	public static final String STR_MVC_CLASS_NAME = "diagnostic";

	/**
	 * Inits the Model with the Activity Space.
	 *
	 * @param parent
	 */
	public void Init(AActivitySpace parent)
	{
		// Set to read only so we only get finish button
		m_bIsEditorReadOnly = true;

		super.Init(parent);
	}

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorModel#CheckEditorAccessAndStart(com.plumtree.openfoundation.util.XPHashtable)
	 */
	public boolean CheckEditorAccessAndStart(XPHashtable _htFormData)
	{
		if (!PlumtreeHelpers.CheckCurrentUserIsAdmin
			((IPTSession) m_asOwner.GetUserSession()))
		{
			return false;
		}

		if (!((IPTSession) m_asOwner.GetUserSession()).GetSessionInfo()
			.CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_ACCESS_UTILITIES))
		{
			return false;
		}

		return true;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.IRepostModel#Finish()
	 */
	public void Finish() {}

	/**
	 * @see com.plumtree.uiinfrastructure.form.IRepostModel#SavePage(java.lang.String, com.plumtree.openfoundation.util.XPHashtable)
	 */
	public int SavePage(String _sPageName, XPHashtable _htFormData)
	{
		return RepostControl.PAGE_STATUS_VALID;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new DiagnosticPageModel();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}