package com.plumtree.portalpages.admin.ptutilities.diagnostic;

import com.plumtree.uiinfrastructure.editor.*;

/**
 * This class handles common repost actions for the diagnostic page editor.
 * 
 * @author DonH
 */
public class DiagnosticPageRepostControl extends EditorRepostControl
{
	/** Object Name for AS */
	public static final String STR_MVC_CLASS_NAME = "DiagnosticPageRepost";

	/** Repost Action: Refresh test */
	public final static int POSTTOSELF_ACTION_REFRESH_TEST = 20;

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorRepostControl#PerformReadOnlyAction(int)
	 */
	protected void PerformReadOnlyAction(int _nAction)
	{
		super.PerformReadOnlyAction(_nAction);

		EditorHelperRepostControl pageHelperControl =
			((DiagnosticPageEditorAS) m_asOwner).GetPageHelperRepostControl();

		if (null != pageHelperControl)
		{
			pageHelperControl.PerformRepostAction(_nAction, m_htFormData);
		}

		if (_nAction == POSTTOSELF_ACTION_IN_PLACE_REFRESH)
		{
			// set a flag so that display pages will show in place 
			// content instead of normal content on the next pass.
			m_asOwner.SetIsInPlaceRefreshDisplayOn(true);
		}

		if (_nAction == POSTTOSELF_ACTION_REFRESH_TEST)
		{
			// Rerun the current test.
			((DiagnosticPageEditorAS) m_asOwner).RefreshCurrentTest();
		}
	}

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorRepostControl#PerformAction(int)
	 */
	protected void PerformAction(int _nAction)
	{
		super.PerformAction(_nAction);

		if (m_nAction == POSTTOSELF_ACTION_GOTOPAGE)
		{
			// Tells the model to (re)init the page, since
			// we are changing it.
			((DiagnosticPageEditorAS) m_asOwner).SetChangingPage();
		}
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new DiagnosticPageRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}