package com.plumtree.portalpages.admin.ptutilities.diagnostic.dynamicloads.pei;

import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This displays the list of currently loaded PEIs.
 * 
 * @author DonH
 */
public class PEIAS extends AActivitySpace
{
	/** Class name for the activity space */
	public static final String STR_MVC_CLASS_NAME = "PEI";

	/**
	 * Registers all the classes of the Activity Space.
	 *
	 */
	public void Init()
	{
		super.Init();

		// Main PEI Popup Page

		RegisterPage(new PEIPopupDP());

		RegisterView(PEIView.STR_MVC_CLASS_NAME, null);
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(java.lang.String, java.lang.String, boolean)
	 */
	public boolean CheckBasicAccess(
		String strPage,
		String strControl,
		boolean bSameSpace)
	{
		if (!PlumtreeHelpers.CheckCurrentUserIsAdmin
			((IPTSession) GetUserSession()))
		{
			return false;
		}

		// Check for right to access administration
		return ((IPTSession) GetUserSession()).GetSessionInfo()
			.CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_ACCESS_ADMINISTRATION);
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new PEIAS();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}