package com.plumtree.portalpages.admin.ptutilities.diagnostic.dynamicloads.pei;

import com.plumtree.portalpages.common.constants.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This page displays a list of the currently loaded PEIs.
 * 
 * @author DonH
 */
public class PEIPopupDP extends SimplePopUpDP
{
	public static final String STR_MVC_CLASS_NAME = "PEIPopUp";

	/**
	 * @see com.plumtree.uiinfrastructure.form.SimplePopUpDP#GetTitle()
	 */
	public String GetTitle()
	{
		// "Portal Event Interfaces (PEIs)"
		return m_asOwner.GetString(3084, ResourceConstants.PORTALADMINMSGS);
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.SimplePopUpDP#PageDisplay()
	 */
	protected HTMLElement PageDisplay()
	{
		return m_asOwner.GetView(PEIView.STR_MVC_CLASS_NAME).Display();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.SimplePopUpDP#DisplayJavaScriptFromChild()
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection result = new HTMLScriptCollection();

		result.AddInnerHTMLElement(m_asOwner.GetView(
			PEIView.STR_MVC_CLASS_NAME).DisplayJavascript());

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}