package com.plumtree.portalpages.admin.ptutilities.diagnostic.dynamicloads.varpacks;

import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 * This Activity Space displays the currently loaded VarPacks.
 * 
 * @author DonH
 */
public class VarPackAS extends AFormAS
{
	/** Class name for the activity space */
	public static final String STR_MVC_CLASS_NAME = "VarPack";

	/**
	 * Registers all the classes of the Activity Space.
	 *
	 */
	public void Init()
	{
		super.Init();

		// Main VarPack Popup Page

		RegisterPage(new VarPackPopupDP());

		RegisterView(VarPackView.STR_MVC_CLASS_NAME, null);

		// View VarPack Contents Popup Page

		RegisterPage(new VarPackContentDP());

		RegisterModel(VarPackModel.STR_MVC_CLASS_NAME);

		IModel model = GetModel(VarPackModel.STR_MVC_CLASS_NAME);

		RegisterView(VarPackContentView.STR_MVC_CLASS_NAME, model);
		RegisterControl(ViewVarPackControl.STR_MVC_CLASS_NAME, model);
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(java.lang.String, java.lang.String, boolean)
	 */
	public boolean CheckBasicAccess(
		String strPage,
		String strControl,
		boolean bSameSpace)
	{
		if (!PlumtreeHelpers.CheckCurrentUserIsAdmin
			((IPTSession) GetUserSession()))
		{
			return false;
		}

		// Check for right to access administration
		return ((IPTSession) GetUserSession()).GetSessionInfo()
			.CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_ACCESS_ADMINISTRATION);
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new VarPackAS();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}