package com.plumtree.portalpages.admin.ptutilities.diagnostic.dynamicloads.varpacks;

import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;


/**
 * This Display Page displays HTTPMemoryDebugVarPackContentView.
 * 
 * @author Julie Fournier
 */
public class VarPackContentDP extends AFormDP
{
	/** Class name for the activity space */
	public static final String STR_MVC_CLASS_NAME = "VarPackContent";

	public String GetFormTitle()
	{
		return m_asOwner.GetString(1954, "ptmsgs_portaladminmsgs");	
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()
	{
		return m_asOwner.GetView(VarPackContentView.STR_MVC_CLASS_NAME).Display();
	}
	
	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection myScripts = new HTMLScriptCollection();

		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
			VarPackContentView.STR_MVC_CLASS_NAME).DisplayJavascript());

		return myScripts;
	}
}