package com.plumtree.portalpages.admin.ptutilities.diagnostic.dynamicloads.varpacks;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This control processes which VarPack to display.
 * 
 * @author DonH
 */
public class ViewVarPackControl implements IControl
{
	public static final String STR_MVC_CLASS_NAME = "ViewVarPack";

	/** HTML Object: hidden input for var pack ID to view */
	public static final String HTMLHIDDEN_VIEW_VARPACK_ID = "in_hi_ViewVarPackID";

	protected IVarPackModelRO m_model = null;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#CheckActionSecurityAndExecute(com.plumtree.openfoundation.util.XPHashtable)
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		String[] data = (String[]) arguments.GetElement(HTMLHIDDEN_VIEW_VARPACK_ID);

		if ((null != data) && !(0 == data.length))
		{
			((VarPackModel) m_model).SetCurrentVarPackID(data[0]);
		}

		return null;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#Init(com.plumtree.uiinfrastructure.activityspace.IModel, com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
	 */
	public void Init(IModel model, AActivitySpace space)
	{
		m_model = (IVarPackModelRO) model;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new ViewVarPackControl();
	}
}