package com.plumtree.portalpages.admin.ptutilities.diagnostic.pages;

import com.plumtree.portalpages.admin.ptutilities.diagnostic.*;
import com.plumtree.portalpages.admin.ptutilities.diagnostic.dynamicloads.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;

/**
 * This page displays the portal dynamic (custom objects and PEIs). 
 * 
 * @author DonH
 */
public class DynamicLoadsPage implements IDiagnosticPage
{
	/**
	 * @see com.plumtree.portalpages.admin.ptutilities.diagnostic.IDiagnosticPage#GetDiagnosticPage()
	 */
	public EditorDP GetDiagnosticPage()
	{
		return new DynamicLoadsDP();
	}

	/**
	 * @see com.plumtree.portalpages.admin.ptutilities.diagnostic.IDiagnosticPage#GetHelperRepostControlName()
	 */
	public String GetHelperRepostControlName()
	{
		return null;
	}

	/**
	 * @see com.plumtree.portalpages.admin.ptutilities.diagnostic.IDiagnosticPage#Init(com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
	 */
	public void Init(AActivitySpace _asOwner)
	{
		_asOwner.RegisterView(DynamicLoadsView.STR_MVC_CLASS_NAME, null);
	}

	/**
	 * @see com.plumtree.portalpages.admin.ptutilities.diagnostic.IDiagnosticPage#RunDiagnosticTest(com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
	 */
	public void RunDiagnosticTest(AActivitySpace _asOwner)
	{
	}

	/**
	 * @see com.plumtree.portalpages.admin.ptutilities.diagnostic.IDiagnosticPage#GetHelpTopic()
	 */
	public String GetHelpTopic()
	{
		return "PT_Diagnostic_DynamicLoads";
	}

	/**
	 * @see com.plumtree.portalpages.admin.ptutilities.diagnostic.IDiagnosticPage#HasTip()
	 */
	public boolean HasTip()
	{
		// This diagnostic page does not have a tip.
		return false;
	}

	/**
	 * @see com.plumtree.portalpages.admin.ptutilities.diagnostic.IDiagnosticPage#GetTipTitleID()
	 */
	public int GetTipTitleID()
	{
		return 0;
	}

	/**
	 * @see com.plumtree.portalpages.admin.ptutilities.diagnostic.IDiagnosticPage#GetTipID()
	 */
	public int GetTipID()
	{
		return 0;
	}

	/**
	 * @see com.plumtree.portalpages.admin.ptutilities.diagnostic.IDiagnosticPage#GetSecondaryTipID()
	 */
	public int GetSecondaryTipID()
	{
		return 0;
	}
}