package com.plumtree.portalpages.admin.ptutilities.diagnostic.relatedservers.search;

import com.plumtree.portalpages.admin.serversettings.search.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This space shows a popup search server status page.
 * 
 * @author DonH
 */
public class SearchServerStatusAS extends AActivitySpace
{
	/** Class name for the activity space */
	public static final String STR_MVC_CLASS_NAME = "SearchStatus";

	/**
	 * Registers all the classes of the Activity Space.
	 *
	 */
	public void Init()
	{
		super.Init();

		// Main Search Status Popup Page

		RegisterPage(new SearchServerStatusPopupDP());

		RegisterModel(SearchServerSettingsEditorModel.STR_MVC_CLASS_NAME);

		SearchServerSettingsEditorModel model = (SearchServerSettingsEditorModel)
			GetModel(SearchServerSettingsEditorModel.STR_MVC_CLASS_NAME);

		// This normally gets called by the editor framework in
		// CheckEditorAccessAndStart(), but since we are using this
		// model outside of the editor framework, we need to call
		// this manually.
		model.InitializePropertyValues();

		RegisterView(SearchServerStatusView.STR_MVC_CLASS_NAME, model);
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(java.lang.String, java.lang.String, boolean)
	 */
	public boolean CheckBasicAccess(
		String strPage,
		String strControl,
		boolean bSameSpace)
	{
		if (!PlumtreeHelpers.CheckCurrentUserIsAdmin
			((IPTSession) GetUserSession()))
		{
			return false;
		}

		// Check for right to access administration
		return ((IPTSession) GetUserSession()).GetSessionInfo()
			.CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_ACCESS_ADMINISTRATION);
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SearchServerStatusAS();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}