package com.plumtree.portalpages.admin.ptutilities.diagnostic.relatedservers.search;

import com.plumtree.portalpages.common.constants.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This shows a popup search server status page.
 * 
 * @author DonH
 */
public class SearchServerStatusPopupDP extends SimplePopUpDP
{
	public static final String STR_MVC_CLASS_NAME = "SearchStatusPopUp";

	/**
	 * @see com.plumtree.uiinfrastructure.form.SimplePopUpDP#GetTitle()
	 */
	public String GetTitle()
	{
		// "Search Server Status"
		return m_asOwner.GetString(3099, ResourceConstants.PORTALADMINMSGS);
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.SimplePopUpDP#PageDisplay()
	 */
	protected HTMLElement PageDisplay()
	{
		return m_asOwner.GetView(SearchServerStatusView.STR_MVC_CLASS_NAME).Display();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.SimplePopUpDP#DisplayJavaScriptFromChild()
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection result = new HTMLScriptCollection();

		result.AddInnerHTMLElement(m_asOwner.GetView(
			SearchServerStatusView.STR_MVC_CLASS_NAME).DisplayJavascript());

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}
