package com.plumtree.portalpages.admin.ptutilities.diagnostic.relatedservers.search;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.serversettings.search.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This shows a search server status page.
 * 
 * @author DonH
 */
public class SearchServerStatusView implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.ptutilities.diagnostic.relatedservers.search.SearchServerStatusView");

	public static final String STR_MVC_CLASS_NAME = "SearchStatus";

	protected AActivitySpace m_asOwner;

	protected ISearchServerSettingsEditorModelRO m_model;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTable myTable;

		try
		{
			HTMLComment myComment = new HTMLComment( "Begin: Display SearchServerStatusView");
			result.AddInnerHTMLElement(myComment);
			
			myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("5");
			myTable.SetCellSpacing("0");

			SearchServerSettingsPopUpView.AddSearchServerStatusHTML(result, myTable, m_model, m_asOwner);
		}
		catch (Exception e)
		{
			log.Error(e, "SearchServerSettingsPopUpView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());

			throw new XPException(m_asOwner.GetString(174,
					"ptmsgs_portalcommonmsgs"), e);
		}

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		return null;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(com.plumtree.uiinfrastructure.activityspace.IModelRO, com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_model = (ISearchServerSettingsEditorModelRO) model;
		m_asOwner = parent;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SearchServerStatusView();
	}
}