package com.plumtree.portalpages.admin.ptutilities.diagnostic.remotehosts.hostservices;

import com.plumtree.portalpages.common.constants.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * Displays a list of all the portlet web services associated
 * with a given host machine.
 * 
 * @author DonH
 */
public class HostServicesPopupDP extends SimplePopUpDP
{
	/**  Name for the page */
	public static final String STR_MVC_CLASS_NAME = "HostServices";

	/**
	 * @see com.plumtree.uiinfrastructure.form.SimplePopUpDP#GetTitle()
	 */
	public String GetTitle()
	{
		// "Remote Host Portlet Web Services"
		return m_asOwner.GetString(3118, ResourceConstants.PORTALADMINMSGS);
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.SimplePopUpDP#PageDisplay()
	 */
	protected HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		result.AddInnerHTMLElement(m_asOwner.GetView(ContentCollabLinksView.STR_MVC_CLASS_NAME).Display());

		result.AddInnerHTMLElement(m_asOwner.GetView(HostServicesAS.STR_MVC_STORAGE_NAME_MULTI_COLUMN_LIST).Display());

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.SimplePopUpDP#DisplayJavaScriptFromChild()
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection result = new HTMLScriptCollection();

		result.AddInnerHTMLElement(m_asOwner.GetView(
			ContentCollabLinksView.STR_MVC_CLASS_NAME).DisplayJavascript());

		result.AddInnerHTMLElement(m_asOwner.GetView(
			HostServicesAS.STR_MVC_STORAGE_NAME_MULTI_COLUMN_LIST).DisplayJavascript());

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}