package com.plumtree.portalpages.admin.ptutilities.diagnostic.serverstatuslist;

import com.plumtree.portalpages.admin.ptutilities.diagnostic.*;
import com.plumtree.portalpages.common.constants.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.uiinfrastructure.htmlconstructs.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This view overrides the server status list and adds a refresh action.
 * 
 * @author DonH
 */
public class RefreshServerStatusListView extends ServerStatusListView
{
	/** Class name for the activity space */
	public static final String STR_MVC_CLASS_NAME = "RefreshServerStatusList";

	/**
	 * Empty method that sub classes can override to add
	 * actions to the action bar (like a create object action).
	 *
	 * @param _myRow Action bar row object.
	 */
	protected void AddHTMLToActionBar(HTMLTableRow _myRow)
	{
		HTMLTableCell myCell = new HTMLTableCell();
		myCell.SetHeight("25");
		myCell.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BTN);
		myCell.SetNoWrap(true);

		_myRow.AddInnerHTMLElement(myCell);

		// Create refresh test button
		PTConstruct myConstruct;
		HTMLImg myImage, myAddIcon;
		HTMLAnchor refreshAnchor;
		HTMLSpan mySpan;

		// Refresh icon
		myConstruct = UIConstructFactory.GetConstruct(PTImageType.ACTION_REFRESH,
			true, m_asOwner);
		myAddIcon = (HTMLImg) myConstruct.GetHTMLElement();
		// Refresh
		// "Refresh"
		myAddIcon.SetAlt(m_asOwner.GetString(3119, ResourceConstants.PORTALADMINMSGS));
		myAddIcon.SetAlign("absmiddle");

		refreshAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
		refreshAnchor.AddInnerHTMLString("&nbsp;");
		refreshAnchor.SetOnClick(AFormDP.JAVASCRIPT_SUBMIT_FORM + "(" +
			DiagnosticPageRepostControl.POSTTOSELF_ACTION_REFRESH_TEST +
			"); return false;");
		refreshAnchor.AddInnerHTMLElement(myAddIcon);
		mySpan = new HTMLSpan();
		refreshAnchor.AddInnerHTMLElement(mySpan);
		mySpan.SetStyleClass(PTStyleClass.ACTIONBAR_TEXT);

		// Add label - Refresh
		// "Refresh"
		mySpan.AddInnerHTMLString(m_asOwner.GetString(3119, ResourceConstants.PORTALADMINMSGS));
		mySpan.AddInnerHTMLString("&nbsp;");
		mySpan.AddInnerHTMLString("&nbsp;");

		myCell.AddInnerHTMLElement(refreshAnchor);
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new RefreshServerStatusListView();
	}
}