package com.plumtree.portalpages.admin.ptutilities.jobfolders;


// Framework Imports
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 * @author SudhaS
 * 
 */
public class JobFoldersDP extends EditorDP
{
	
	public static final String STR_MVC_CLASS_NAME = "JobFolders";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return (m_asOwner.GetString(1501, "ptmsgs_portaladminmsgs"));
	}

	
	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the General Info page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 *
	 * @return HTMLElement
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		//views.AddInnerHTMLElement(((EditorView)
		//	m_asOwner.GetView(GeneralInfoView.STR_MVC_CLASS_NAME)).Display());
		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
				JobFoldersListView.STR_MVC_CLASS_NAME)).Display());

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	* Display the Javascripts for the Views.
	*
	* @return HTMLScriptCollection
	* @throws HTMLException
	*/
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		// ***CHANGE_HERE SELECTPTOBJECT*** Display JavaScripts for the Select PTObject list.
		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
				JobFoldersListView.STR_MVC_CLASS_NAME).DisplayJavascript());

		//myScripts.AddInnerHTMLElement(m_asOwner.GetView(GeneralInfoView.STR_MVC_CLASS_NAME).DisplayJavascript());
		return myScripts;
	}
}

