package com.plumtree.portalpages.admin.ptutilities.jobfolders;


// Framework Imports
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.expandablelist.*;

/**
 *
 * @author SudhaS
 * 
 */
public class JobFoldersEditorAS extends PTEditorAS
{
	
	public static final String STR_MVC_CLASS_NAME = "JobFoldersEditor";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new JobFoldersEditorAS();
	}

	/**
	 * Sets the Editor title.
	 *
	 */
	public String GetEditorTitle()
	{
		if (EditorStartControl.EDITOR_START_FLAG_CREATE == ((EditorModel) GetModel(
					m_strModelName)).GetEditorType())
		{
			return (GetString(1502, "ptmsgs_portaladminmsgs"));
		}
		else
		{
			return (GetString(1503, "ptmsgs_portaladminmsgs"));
		}
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	//public static final String strStorageSelectPTObject = "SelectUserPTObject";
	
	/**
	 * Returns the class name of the Repost Control.
	 *
	 * @return String
	 */
	public String GetRepostControlName()
	{
		return (JobFoldersRepostControl.STR_MVC_CLASS_NAME);
	}

	/**
	 * Registers all the classes for this Activity Space.
	 */
	public void Init()
	{
		m_strModelName = JobFoldersModel.STR_MVC_CLASS_NAME;

		super.Init();

		IModel myModel = GetModel(m_strModelName);

		// Register DisplayPages
		//RegisterPage(new MainDP());
		JobFoldersDP mainDP = new JobFoldersDP();
		RegisterPage(mainDP);

		// Get back the Model we just registered because we need it to register the Section and the Control
		RegisterModel(JobFoldersListModel.STR_MVC_CLASS_NAME);

		IModel myJobFoldersModel = GetModel(JobFoldersListModel.STR_MVC_CLASS_NAME);
		RegisterView(JobFoldersListView.STR_MVC_CLASS_NAME, myJobFoldersModel);
		RegisterControl(ExpListControl.STR_MVC_CLASS_NAME,
			JobFoldersListModel.STR_MVC_CLASS_NAME, myJobFoldersModel);

		// Register Views
		//RegisterView(JobFoldersView.STR_MVC_CLASS_NAME, myModel);
		// Register Controls
		RegisterControl(JobFoldersRepostControl.STR_MVC_CLASS_NAME, myModel);

		// Default page
		SetCurrentPage(JobFoldersDP.STR_MVC_CLASS_NAME);

		//Sets left nav menu
		int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(1504,
					"ptmsgs_portaladminmsgs"));
		m_mEditorMenu.AddLinkToSubMenu(nMenuOneID,
			JobFoldersDP.STR_MVC_CLASS_NAME);
	}
	
	/**
	  * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage()
	  *
	  * @param IDisplayPage the current Display Page
	  */

	 public void SetCurrentPage(IDisplayPage page)
	 {
		 
		  super.SetCurrentPage( page );
		  String sPageName = page.GetName();
		  if(JobFoldersDP.STR_MVC_CLASS_NAME.equals( sPageName ))
		  {
				this.SetHelpTopic( "PT_RegisterAutomationServerFolders" );                           
		  }

		 

	 }
}

