package com.plumtree.portalpages.admin.ptutilities.jobfolders;


// Framework Imports
import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.*;
import com.plumtree.portaluiinfrastructure.opener.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.portaluiinfrastructure.tree.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.arraywrapper.*;
import com.plumtree.uiinfrastructure.expandablelist.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.uiinfrastructure.opener.*;
import com.plumtree.uiinfrastructure.tree.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This is the implementation of the Expandable List
 * framework for the Growable Array.
 * Is constains the HTML to display the Growable Array.
 * It gets the data to display from GrowableListModel.
 *
 * @author SudhaS
 */
public class JobFoldersListView extends SelectPTObjectView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.ptutilities.jobfolders.JobFoldersListView");

	/**
	 * Class name for the activity space */
	public static final String STR_MVC_CLASS_NAME = "JobFoldersList";

	/**
	 * Class name for the activity space */
	public static final String HTMLINPUT_ITEM		    = "in_tx_Item";

	
	public static final String HTMLHIDDEN_PROPEDITORKEY = "in_hi_PropEditorKey";
	

	/**
	 * 
	 *
	 * @return 
	 */
	public Object Create()
	{
		return new JobFoldersListView();
	}
	
	/**
	 * This method returns the HTMLScript that encompasses the Javascript on the page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 *
	 * @return HTMLScript
	 */
	public HTMLScript DisplayJavascript()
	{
		HTMLScript myScript = super.DisplayJavascript();

		// The URL to open a new tree
		ASURL myNewTree = new ASURL(m_asOwner);

		myNewTree.SetLinkCreateNewSpace(TreeAS.STR_MVC_CLASS_NAME, m_asOwner);

		myNewTree.SetSubSpaceKey(((ISelectPTObjectModelRO) m_model).GetUniqueString(
				SelectPTObjectModel.SUBSPACE_KEY_SELECTTREE));
		myNewTree.SetControl(StartTreeControl.STR_MVC_CLASS_NAME);
		myNewTree.AddControlArgument(StartTreeControl.ROOT_ID,
			XPConvert.ToString(PT_INTRINSICS.PT_ADMIN_FOLDER_ROOTFOLDER));
		myNewTree.AddControlArgument(StartTreeControl.MULTI_SELECT,
			((ISelectPTObjectModelRO) m_model).GetTreeMultiSelect());
		myNewTree.AddControlArgument(StartTreeControl.SELECT_MODE,
			XPConvert.ToString(((ISelectPTObjectModelRO) m_model).GetTreeLeafType()));
		myNewTree.AddControlArgument(StartTreeControl.SUBMIT_MODE,
			XPConvert.ToString(TreeConstants.N_SERVERSUBMIT));
		myNewTree.AddControlArgument(StartTreeControl.PARENT_FORM_NAME,
			AFormDP.HTMLFORM_NAME);
		myNewTree.AddControlArgument(StartTreeControl.PARENT_FORM_SPACE_ID,
			((ISelectPTObjectModelRO) m_model).GetUniqueString(
				HTMLINPUT_TREEASID));
		myNewTree.AddControlArgument(StartTreeControl.PARENT_SUBMIT_CALL,
			((ISelectPTObjectModelRO) m_model).GetUniqueString(
				"OnReturnFromTree"));
		myNewTree.AddControlArgument(StartTreeControl.CLASS_IDS_TO_DISPLAY,
			((ISelectPTObjectModelRO) m_model).GetObjectClassIDs());
		myNewTree.AddControlArgument(StartTreeControl.SELECTED_ITEMS,
			((ISelectPTObjectModelRO) m_model).GetSelectedItems());
		myNewTree.AddControlArgument(StartTreeControl.ACCESS_LEVEL,
			XPConvert.ToString(((ISelectPTObjectModelRO) m_model).GetAccessLevel()));

		if (null != ((ISelectPTObjectModelRO) m_model).GetTreeTitle())
		{
			myNewTree.AddControlArgument(StartTreeControl.TITLE,
				((ISelectPTObjectModelRO) m_model).GetTreeTitle());
		}

		if (null != ((ISelectPTObjectModelRO) m_model).GetTreeSubTitle())
		{
			myNewTree.AddControlArgument(StartTreeControl.ACTIONSUBTITLE,
				((ISelectPTObjectModelRO) m_model).GetTreeSubTitle());
		}
		
		if (null != ((ISelectPTObjectModelRO) m_model).GetDisplayObjects())
		{
			myNewTree.AddControlArgument(StartTreeControl.DISPLAYED_ITEMS,
				((ISelectPTObjectModelRO) m_model).GetDisplayObjects());
		}

		if (!("").equals(((ISelectPTObjectModelRO) m_model).GetHiddenObjects()))
		{
			myNewTree.AddControlArgument(StartTreeControl.HIDDEN_ITEMS,
				((ISelectPTObjectModelRO) m_model).GetHiddenObjects());
		}

		if (!("").equals(
					((ISelectPTObjectModelRO) m_model).GetTreeQueryFilter()))
		{
			myNewTree.AddControlArgument(StartTreeControl.QUERY_FILTER,
				((ISelectPTObjectModelRO) m_model).GetTreeQueryFilter());
		}

		if (0 < ((ISelectPTObjectModelRO) m_model).GetCommunityFolderID())
		{
			myNewTree.AddControlArgument(StartTreeControl.COMMUNITY_MODE,
				AObjectTreeModel.THISCOMMUNITY);
			myNewTree.AddControlArgument(StartTreeControl.COMMUNITY_FOLDER_ID,
				((ISelectPTObjectModelRO) m_model).GetCommunityFolderID());
		}

		// The url to open a previously opened server user tree
		// This needs to have the SpaceID added to it.
		ASURL myOldTree = new ASURL(m_asOwner);
		myOldTree.SetLinkCreateNewSpace(TreeAS.STR_MVC_CLASS_NAME, m_asOwner);
		myOldTree.SetControl(RefreshTreeControl.STR_MVC_CLASS_NAME);
		myOldTree.AddControlArgument(StartTreeControl.SELECTED_ITEMS,
			((ISelectPTObjectModelRO) m_model).GetSelectedItems());
		myOldTree.IsSubSpace();

		XPStringBuilder sb;

		try
		{
			// Open Tree function
			sb = new XPStringBuilder(200);
			sb.Append("function " +
				((ISelectPTObjectModelRO) m_model).GetUniqueString("OpenTree") +
				"(myInput)\n");
			sb.Append("{\n");
			sb.Append("  if (myInput.value == '') {\n");
			sb.Append("    window.open('").Append(myNewTree.GetURLAsString())
			.Append("', '_blank3', '")
			.Append(TreeConstants.GetJavascriptTreeWindowAttributes()).Append("');\n");
			sb.Append("  } else {\n");
			sb.Append("    window.open('").Append(myOldTree.GetURLAsString())
			.Append("&").Append(ASConstants.SPACEID).Append("=' + myInput.value")
			.Append(", '_blank3', '")
			.Append(TreeConstants.GetJavascriptTreeWindowAttributes()).Append("');\n");
			sb.Append("  }\n");
			sb.Append("}\n");

			myScript.AddInnerHTMLString(sb.ToString());

			// On return from Tree function
			sb = new XPStringBuilder(200);
			sb.Append(" function " +
				((ISelectPTObjectModelRO) m_model).GetUniqueString(
					"OnReturnFromTree") + "()");
			sb.Append(" {");
			sb.Append(" 	postToSelf('" +
				((ISelectPTObjectModelRO) m_model).GetUniqueInt(
					ExpListControl.POSTTOSELF_ACTION_ADD) + "');");
			sb.Append(" }");

			myScript.AddInnerHTMLString(sb.ToString());

			// Create new object
			sb = new XPStringBuilder(200);
			sb.Append(" function " +
				((ISelectPTObjectModelRO) m_model).GetUniqueString("CreateNew") +
				"(varURL)");
			sb.Append(" {");
			sb.Append(
				"    window.open(varURL,'PopUpCreateMode','location=no,menubar=no,scrollbars,height=600,width=800');\n");
			sb.Append(" }");
			
			sb.Append("function EditJob(varURL)\n");
			sb.Append("{\n");
			sb.Append(
				"    window.open(varURL,'PopUpEditMode','location=no,menubar=no,scrollbars=yes, resizable=yes, height=600,width=800');\n");
			sb.Append(" }\n");

			myScript.AddInnerHTMLString(sb.ToString());

			// Edit object
			sb = new XPStringBuilder(200);
			sb.Append(" function " +
				((ISelectPTObjectModelRO) m_model).GetUniqueString("EditObject") +
				"(varURL,varIndex)");
			sb.Append(" {");
			sb.Append(
				"    window.open(varURL,'PopUpEditMode' + varIndex,'location=no,menubar=no,scrollbars,height=600,width=800');\n");
			sb.Append(" }\n");
			
			sb.Append("function doOnLoad()\n");
			sb.Append("{\n");
			sb.Append("	window.focus();\n");
			sb.Append("}\n");

			myScript.AddInnerHTMLString(sb.ToString());
		}
		catch (HTMLException he)
		{
			
				log.Error(he, "SelectPTObjectView::DisplayJavascript The following error occured when trying to display the JavaScript: " +
					he.getMessage());
			
		}

		return myScript;
	}
	
	/**
	 * Returns the HTML for the View.
	 *
	 * @return HTMLElement
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTable myTable;
		HTMLTableRow myRow;

		try
		{
			HTMLComment myComment = new HTMLComment( "Begin: Display ExpListView");
			result.AddInnerHTMLElement(myComment);

			// Header
			myComment = new HTMLComment( "Begin: Display Section header");
			result.AddInnerHTMLElement(myComment);

			if (0 < ((IExpListModelRO) m_model).GetSectionTitle().length())
			{
				result.AddInnerHTMLElement(GetHeaderView(
						((IExpListModelRO) m_model).GetSectionTitle()));
			}

			myComment = new HTMLComment( "End: Display Section header");
			result.AddInnerHTMLElement(myComment);

			// Action Bar
			// JF- We don't display the action bar if the list is read only
			if (!((IExpListModelRO) m_model).GetIsListReadOnly())
			{
				HTMLTable myActionBar = GetHTMLForActionBar();

				// JF- The child class could also decide to not have an action bar by returning null
				if (null != myActionBar)
				{
					myComment = new HTMLComment( "Begin: Display Action Bar");
					result.AddInnerHTMLElement(myComment);
					
					result.AddInnerHTMLElement(myActionBar);
					myComment = new HTMLComment( "End: Display Action Bar");
					
					result.AddInnerHTMLElement(myComment);
				}
			}

			// Below Action Bar
			HTMLTable myBelowActionBar = GetHTMLBelowActionBar();

			// AGC- This adds a table between the action bar and the list.
			if (null != myBelowActionBar)
			{
				myComment = new HTMLComment( "Begin: Display Below Action Bar");
				result.AddInnerHTMLElement(myComment);
				
				result.AddInnerHTMLElement(myBelowActionBar);

				myComment = new HTMLComment( "End: Display Below Action Bar");
				result.AddInnerHTMLElement(myComment);
			}
		
			String sInstructions = ((IExpListModelRO) m_model).GetTableInstructions();
		
			if (null != sInstructions)
			{
				result.AddInnerHTMLElement(SelectPTObjectView.GetShortSpacerTable());
				result.AddInnerHTMLElement(GetHTMLForInstructions(sInstructions, false));
				result.AddInnerHTMLElement(SelectPTObjectView.GetShortSpacerTable());
			}
		
			// JF- Get the Object array from the Model.
			IPTGrowableSortedArrayWrapperRO saData = ((IExpListModelRO) m_model).GetReadOnlyItems();
		
			// JF- Display a warning if we have reached the max number.
			// JF- bug 17880
			/*if (saData.GetCount() >= ExpListModel.MAX_ROWS)
			{
				result.AddInnerHTMLElement(super.GetShortSpacerTable());
				result.AddInnerHTMLElement(GetHTMLForInstructions(m_asOwner.GetString(92, "ptmsgs_infrastructure"), true));
				result.AddInnerHTMLElement(super.GetShortSpacerTable());
			}*/
		

			// Main Table
			myComment = new HTMLComment( "Begin: Display ExpList Main Table");
			result.AddInnerHTMLElement(myComment);

			// Hidden input for the row index (used by MoveRow to know which row to move)
			HTMLInput myInput = new HTMLInput(HTMLInputTypes.HIDDEN,
					((IExpListModelRO) m_model).GetUniqueString(
						HTMLHIDDEN_ROWINDEX), "");
			result.AddInnerHTMLElement(myInput);

			// Hidden input for the move action (used by MoveRow to know which type of move this is)
			myInput = new HTMLInput(HTMLInputTypes.HIDDEN,
					((IExpListModelRO) m_model).GetUniqueString(
						HTMLHIDDEN_MOVEACTION), "");
			result.AddInnerHTMLElement(myInput);

			// Hidden input for the column ID (used on change sort to know which column to sort)
			myInput = new HTMLInput(HTMLInputTypes.HIDDEN,
					((IExpListModelRO) m_model).GetUniqueString(
						HTMLHIDDEN_COLUMNID), "");
			result.AddInnerHTMLElement(myInput);

			myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
			myTable.SetBorder(CommonHTMLStrings.ZERO);
			myTable.SetCellPadding(CommonHTMLStrings.ZERO);
			myTable.SetCellSpacing(CommonHTMLStrings.TWO);

			if (CheckListContainsVisibleRows(saData))
			{
				// 1st Row begin - sub Header
				myTable.AddInnerHTMLElement(GetHTMLForSubHeader());

				// 1st Row end - sub Header
				// JF- Loop through the list and display the rows.
				m_nLastVisibleRow = -1;

				for (int nRowIndex = 0; nRowIndex < saData.GetCount(); nRowIndex++)
				{
					if (CheckRowIsVisible(nRowIndex))
					{
						// Row nRowIndex - begin
						myRow = new HTMLTableRow();
						myTable.AddInnerHTMLElement(myRow);

						// JF- Set row background
						SetRowStyle(myRow, nRowIndex);

						if (!(((IExpListModelRO) m_model).GetIsListReadOnly() ||
								((IExpListModelRO) m_model).IsCheckBoxesDisabled()))
						{
							// Display delete checkbox
							myRow.AddInnerHTMLElement(GetHTMLForCheckBox(
									nRowIndex));
						}

						// Display rest of the row
						myRow.AddInnerHTMLElement(GetHTMLForRow(saData,
								nRowIndex));

						// Update last visible row
						m_nLastVisibleRow = nRowIndex;

						// Row nRowIndex - end
					}
				}
			
				HTMLTableRow myBottomRow = GetHTMLForBottomRow();
			
				if (null != myBottomRow)
				{
					myTable.AddInnerHTMLElement(myBottomRow);
				}
			
				// Below Main Table
				HTMLTable myBelowMainTable = GetHTMLBelowMainTable();

				if (null != myBelowMainTable)
				{
					result.AddInnerHTMLElement(new HTMLComment("Begin: Display Below Main Table"));
					result.AddInnerHTMLElement(myBelowMainTable);
					result.AddInnerHTMLElement(new HTMLComment("End: Display Below Main Table"));
				}
			}
			else
			{
				myTable.AddInnerHTMLElement(GetHTMLForEmptyList());
			}
			
			HTMLScript myScript = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
			myScript.AddInnerHTMLString("doOnLoad();\n");

			result.AddInnerHTMLElement(myScript);

			myComment = new HTMLComment( "End: Display ExpList Main Table");
			result.AddInnerHTMLElement(myComment);

			myComment = new HTMLComment( "End: Display ExpListView");
			result.AddInnerHTMLElement(myComment);
		}
		catch (Exception e)
		{
			
				log.Error(e, "ExpListView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(52,
					"ptmsgs_infrastructure"), e);
		}

		return result;
	}
	
	/**
	 * Iterate through list in order to determine whether there are any visible rows.
	 * 
	 * @param saData
	 * @return boolean
	 */
	private boolean CheckListContainsVisibleRows(IPTGrowableSortedArrayWrapperRO saData)
	{
		for (int nRowIndex = 0; nRowIndex < saData.GetCount(); nRowIndex++)
		{
			if (CheckRowIsVisible(nRowIndex))
			{
				return true;
			}
		}
		return false;
	}
	
	/**
	 * Helper method to return the HTML for the instruction table.
	 *
	 * @param _sIntructions
	 * 
	 * @return HTMLTable
	 * 
	 * @throws Exception
	 */
	private HTMLTable GetHTMLForInstructions(String _sIntructions, boolean _bIsWarning)
	{
		HTMLTable myTable;
		HTMLTableRow myRow;
		HTMLTableCell myCell;

		myTable = new HTMLTable();
		myTable.SetWidth("100%");
		myTable.SetBorder("0");
		myTable.SetCellPadding("5");
		myTable.SetCellSpacing("0");
		
		myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
		
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetWidth("100%");
	
		if (_bIsWarning)
		{
			myCell.SetStyleClass(PTStyleClass.ALERT_ERROR_SUBTITLE);
		} else {
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);	
		}
		myCell.AddInnerHTMLString(_sIntructions);
	
		return myTable;	
	}

	/**
	 * 
	 *
	 * @param _saData 
	 * @param _nRowIndex 
	 *
	 * @return 
	 *
	 * @throws Exception 
	 */
	public HTMLTableCell GetHTMLForJobTable(
		IPTGrowableSortedArrayWrapperRO _saData, int _nRowIndex)

	{
		int nFolderObjID				  = XPConvert.ToInteger(_saData.GetItem(_nRowIndex,
				JobFoldersListModel.EXPLIST_COL_OBJECTID));
		Object[][] oRowsToDisplay = ((IJobFoldersListModelRO) m_model).GetJobsByFolder(_nRowIndex,
		nFolderObjID);

		HTMLTableCell tableCell = new HTMLTableCell();

		HTMLTable myTable;
		HTMLTableRow myRow;
		HTMLTableCell myCell;

		myTable = new HTMLTable();
		tableCell.AddInnerHTMLElement(myTable);
		myTable.SetWidth("100%");
		myTable.SetBorder("0");
		myTable.SetCellPadding("0");
		myTable.SetCellSpacing("2");

		if (oRowsToDisplay.length != 0)
		{
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.LIST_SORT_HEADER_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
			myCell.SetWidth("50%");
			myCell.AddInnerHTMLString(m_asOwner.GetString(183, "ptmsgs_portaladminmsgs"));

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
			myCell.SetWidth("50%");
			myCell.AddInnerHTMLString(m_asOwner.GetString(1993, "ptmsgs_portaladminmsgs"));
			
			

			for (int i = 0; i < oRowsToDisplay.length; i++)
			{
				myRow = new HTMLTableRow();
				myTable.AddInnerHTMLElement(myRow);

				//myRow.SetStyleClass(PTStyleClass.LIST_SORT_HEADER_BG);
				
				int nJobObjID = XPConvert.ToInteger(oRowsToDisplay[i][JobFoldersListModel.JOBS_COL_ID]);

				String strEditJob = PTOpenerLinks.GetOpenerURLOpenObjID
					(PT_CLASSIDS.PT_JOB_ID, nJobObjID, IOpenerConstants.OPENER_MODE_EDIT, m_asOwner);

				// mj: replaced the following line with a blank constructur and SetOnClick()
				// HTMLAnchor myAnchor = new HTMLAnchor("EditJob('" + myURL.GetURLAsString() + "');");
				HTMLAnchor myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
				myAnchor.SetOnClick("EditJob('" + strEditJob + "'); return false;");
				myAnchor.AddInnerHTMLEncodedString((String) oRowsToDisplay[i][JobFoldersListModel.JOBS_COL_NAME]);
				
				myCell = new HTMLTableCell();
				myRow.AddInnerHTMLElement(myCell);
				myCell.AddInnerHTMLElement(myAnchor);
				myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
				myCell.SetWidth("50%");
				//myCell.AddInnerHTMLString((String) oRowsToDisplay[i][JobFoldersListModel.JOBS_COL_NAME]);


				myCell = new HTMLTableCell();
				myRow.AddInnerHTMLElement(myCell);
				myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
				myCell.SetWidth("50%");
				myCell.AddInnerHTMLString((String) oRowsToDisplay[i][JobFoldersListModel.JOBS_COL_NEXTRUN]);
			}
		}

		return tableCell;
	}
	
	
	/**
	 * This helper function translates PT_JOBSTATUS numbers into localized
	 * string values
	 */
	public String GetStatusString(int intStatus)
	{
		switch (intStatus)
		{
		case PT_JOBSTATUS.PT_JOBSTATUS_FAILED:

			return m_asOwner.GetString(76, "ptmsgs_portalcommonmsgs");

		case PT_JOBSTATUS.PT_JOBSTATUS_INPROCESS:

			return m_asOwner.GetString(77, "ptmsgs_portalcommonmsgs");

		case PT_JOBSTATUS.PT_JOBSTATUS_INTERRUPTED:

			return m_asOwner.GetString(78, "ptmsgs_portalcommonmsgs");

		case PT_JOBSTATUS.PT_JOBSTATUS_INVALID:

			return m_asOwner.GetString(79, "ptmsgs_portalcommonmsgs");

		case PT_JOBSTATUS.PT_JOBSTATUS_SAVINGCHECKPOINT:

			return m_asOwner.GetString(80, "ptmsgs_portalcommonmsgs");

		case PT_JOBSTATUS.PT_JOBSTATUS_SUCCEEDED:

			return m_asOwner.GetString(81, "ptmsgs_portalcommonmsgs");

		case PT_JOBSTATUS.PT_JOBSTATUS_SUSPENDED:

			return m_asOwner.GetString(82, "ptmsgs_portalcommonmsgs");

		case PT_JOBSTATUS.PT_JOBSTATUS_SUSPENDING:

			return m_asOwner.GetString(83, "ptmsgs_portalcommonmsgs");

		case PT_JOBSTATUS.PT_JOBSTATUS_KILLREQUESTED:

			return m_asOwner.GetString(633, "ptmsgs_portalcommonmsgs");

		default:

			return m_asOwner.GetString(84, "ptmsgs_portalcommonmsgs");
		}
	}

	/**
	 * Returns the HTML for the row _nRowIndex.
	 * Each row contains just an icon and input text.
	 *
	 * @param _saData
	 * @param _nRowIndex
	 *
	 * @return HTMLElement
	 * @throws Exception
	 */
	public HTMLElement GetHTMLForRow(IPTGrowableSortedArrayWrapperRO _saData,
		int _nRowIndex)
	{
		HTMLTableCell myTableCell = new HTMLTableCell();
		myTableCell.SetVAlign("top");

		HTMLTable myTable  = new HTMLTable();
		HTMLTableRow myRow = new HTMLTableRow();
		myTable.SetWidth("100%");
		myTable.SetBorder("0");
		myTable.SetCellPadding("7");
		myTable.SetCellSpacing("0");

		//HTMLTableCell myCell = new HTMLTableCell();
		myTableCell.AddInnerHTMLElement(myTable);

		myTable.AddInnerHTMLElement(myRow);

		//myRow.AddInnerHTMLElement(myCell);
		//HTMLElementCollection result = new HTMLElementCollection();
		myRow.AddInnerHTMLElement(GetHTMLForNameColumn(_saData, _nRowIndex));

		myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		myRow.AddInnerHTMLElement(GetHTMLForJobTable(_saData, _nRowIndex));

		if (((ISelectPTObjectModelRO) m_model).GetEnableMoveRowActions())
		{
			//	result.AddInnerHTMLElement(super.GetHTMLForMoveRowActions(_nRowIndex));
		}

		return myTableCell;

		//return(GetHTMLForJobTable(_saData, _nRowIndex));
	}
	
	
		/**
	 * Returns the HTML for the checkbox on row _nRowIndex.
	 *
	 * @param _nRowIndex
	 * @return HTMLTableCell
	 * @throws HTMLException
	 */
	protected HTMLTableCell GetHTMLForCheckBox(int _nRowIndex)

	{
		HTMLTableCell myTableCell = new HTMLTableCell();
		HTMLInput myInput;

				
		HTMLTable myTable = new HTMLTable();
		myTable.SetHeight("100%");
		myTable.SetWidth("100%");
		myTable.SetCellPadding("5");
		myTable.SetBorder("0");
		
		myTableCell.AddInnerHTMLElement(myTable);
		
		HTMLTableRow myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		
		
		

		HTMLTableCell myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		//myCell.SetWidth("20");
		//myCell.SetHeight("30");
		myCell.SetAlign("center");
		myCell.SetVAlign("top");
		myCell.SetStyleClass(PTStyleClass.LIST_TEXT);

		// checkbox
		myInput = new HTMLInput(HTMLInputTypes.CHECKBOX,
				((IExpListModelRO) m_model).GetUniqueString(HTMLCHECKBOX_DELROW),
				((IExpListModelRO) m_model).GetDeleteIconAlt());
		myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
		myInput.SetValue(XPConvert.ToString(_nRowIndex));
		myCell.AddInnerHTMLElement(myInput);

		return (myTableCell);
	}

	/***/
	/**
	 */
	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the row _nRowIndex.
	 *
	 * @param _saData
	 * @param _nRowIndex
	 *
	 * @return HTMLTableCell
	 * @throws Exception
	 */
	protected HTMLTableCell GetHTMLForNameColumn(
		IPTGrowableSortedArrayWrapperRO _saData, int _nRowIndex)

	{
		HTMLTableCell myCell;

		//HTMLAnchor myAnchor;		
		myCell = new HTMLTableCell();
		myCell.SetWidth("100%");
		myCell.SetHeight("30");
		myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
		myCell.SetNoWrap(true);
		myCell.SetColSpan("2");
		myCell.AddInnerHTMLString(SPACE);

		// row icon
		PTImageType imgRowIcon = ((IJobFoldersListModelRO) m_model).GetDefaultRowIcon();

		if (null != imgRowIcon)
		{
			myCell.AddInnerHTMLElement(GetIcon(imgRowIcon));
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
		}

		myCell.AddInnerHTMLString(SPACE);

		// Object Name
		String sPTObjectName = (String) _saData.GetItem(_nRowIndex,
				JobFoldersListModel.EXPLIST_COL_STRING);

		// since the object name is non-unique return the parent object name as well if it's available
		int nObjectID = XPConvert.ToInteger(_saData.GetItem(_nRowIndex, JobFoldersListModel.EXPLIST_COL_OBJECTID));		
		String parentFolderName = ((IJobFoldersListModelRO) m_model).GetAdminFolderName(nObjectID);
		String rv = "";
		if (null != parentFolderName) {
			rv = sPTObjectName + " (" + parentFolderName + ") ";
		} else {
			rv = sPTObjectName;
		}
		myCell.AddInnerHTMLString(XPHttpUtility.HtmlEncode(rv));
		return myCell;
	}
}

