package com.plumtree.portalpages.admin.ptutilities.migrationutility;

import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 * @author jennifersu
 *
 */
public class MigrationStatusPopupDP extends AFormDP
{
    private static final String META_REFRESH_PREFIX = "3;URL="; // Seconds until we redirect to ourself to check the status 

	/**
	 * Class name for the activity space
	 */
	public static final String STR_MVC_CLASS_NAME = "MigrationStatusPopupDP";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new MigrationStatusPopupDP();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		super.Init(parent);
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()
	 */
	public String GetFormTitle() {
		return m_asOwner.GetString(2752, "ptmsgs_portaladminmsgs");
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay() {
		return m_asOwner.GetView(MigrationStatusPopupView.STR_MVC_CLASS_NAME).Display();
		
	}

	/**
	 * Displays a meta refresh in the HEAD.
	 * Refreshes after 5 seconds.
	 */
	public HTMLElementCollection DisplayHTMLinHEAD()
	{
		HTMLElementCollection htmlHead = new HTMLElementCollection();

		// Construct URL to the status popup DP
		ASURL pollPage = new ASURL(m_asOwner);
		pollPage.SetLinkGetCachedSpace(m_asOwner);
		pollPage.SetDisplayPage(MigrationStatusPopupDP.STR_MVC_CLASS_NAME);
		pollPage.SetControl(((MigrationUtilityAS)m_asOwner).GetRepostControlName());
		pollPage.AddControlArgument(RepostControl.HTMLINPUT_POSTTOSELF, MigrationUtilityRepostControl.POSTTOSELF_ACTION_MIGRATION_POLL);

        HTMLMeta metaRefresh = new HTMLMeta(META_REFRESH_PREFIX + pollPage.GetURLAsString());
		metaRefresh.SetHTTPEquiv("refresh");
		htmlHead.AddInnerHTMLElement(metaRefresh);

		return htmlHead;
	}

	/**
	 * 
	 *
	 * @return 
	 *
	 * @throws HTMLException 
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection scripts = new HTMLScriptCollection();

		scripts.AddInnerHTMLElement(m_asOwner.GetView(MigrationStatusPopupView.STR_MVC_CLASS_NAME).DisplayJavascript());
		
		return scripts;
	}

    // mel: Fix for 45278, prevent migration status window from continually popping up
    public boolean GetWindowFocusEnabled()
    {
        return false;
    }
}

