package com.plumtree.portalpages.admin.ptutilities.migrationutility;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.ptutilities.migrationutility.exp.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author jennifersu
 */
public class MigrationUtilityExportAS extends MigrationUtilityAS
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.ptutilities.migrationutility.MigrationUtilityExportAS");

	public static final String STR_MVC_CLASS_NAME = "MigrationUtilityExport";

	private static final String sClassName = "com.plumtree.portalpages.admin.ptutilities.migrationutility.MigrationUtilityExportAS";
	
	/** Storage key for SelectForExport **/
	public static final String strStorageSelectForExport = "STOR_SelectForExport";
	
	public static final String SUBSPACEKEY_AYS = "EXPORT_SUBSPACEKEY_AYS";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new MigrationUtilityExportAS();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorAS#GetEditorTitle()
	 */
	public String GetEditorTitle()
	{
		return GetString(2773, "ptmsgs_portaladminmsgs");
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
	
	/**
	 * Set the Migration Mode in order to initialize AS correctly.
	 */
	public void Init()
	{
		m_intMode = MODE_EXPORT;
		super.Init();
	}
	
	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage()
	 *
	 * @param IDisplayPage the current Display Page
	 */
	public void SetCurrentPage(IDisplayPage page)
	{
		super.SetCurrentPage( page );
		
		String sPageName = page.GetName();

		if (sPageName.equals(MigrationAddExistingPackageDP.STR_MVC_CLASS_NAME))
		{
			SetHelpTopic("PT_MigrationExport_AddExistingPackage");
		}
		else if (sPageName.equals(MigrationExportMainDP.STR_MVC_CLASS_NAME))
		{
			SetHelpTopic("PT_MigrationExport_PackageSettings");
		}
		else if (sPageName.equals(MigrationExportPortalResourcesDP.STR_MVC_CLASS_NAME))
		{
			SetHelpTopic("PT_ExportPortalResources_ResourcestoExport");
		}

	}
}

