package com.plumtree.portalpages.admin.ptutilities.migrationutility;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.ptutilities.migrationutility.imp.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;



/**
 * @author jennifersu
 */
public class MigrationUtilityImportAS extends MigrationUtilityAS
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.ptutilities.migrationutility.MigrationUtilityImportAS");

	public static final String STR_MVC_CLASS_NAME = "MigrationUtilityImport";

	private static final String sClassName = "com.plumtree.portalpages.admin.ptutilities.migrationutility.MigrationUtilityImportAS";
	
	/** Storage key for SelectForImport **/
	public static final String strStorageSelectForImport = "STOR_SelectForImport";
	
	public static final String SUBSPACEKEY_AYS = "IMPORT_SUBSPACEKEY_AYS";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new MigrationUtilityImportAS();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorAS#GetEditorTitle()
	 */
	public String GetEditorTitle()
	{
		return GetString(2774, "ptmsgs_portaladminmsgs");
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
	
	/**
	 * Set the Migration Mode in order to initialize AS correctly.
	 */
	public void Init()
	{
		m_intMode = MODE_IMPORT;
		super.Init();
	}
	
	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage()
	 *
	 * @param IDisplayPage the current Display Page
	 */
	public void SetCurrentPage(IDisplayPage page)
	{
		super.SetCurrentPage( page );
		
		String sPageName = page.GetName();

		if (sPageName.equals(MigrationDependenciesDP.STR_MVC_CLASS_NAME))
		{
			SetHelpTopic("PT_MigrationImport_MissingDependencies");
		}
		else if (sPageName.equals(MigrationImportMainDP.STR_MVC_CLASS_NAME))
		{
			SetHelpTopic("PT_ImportPortalResources_ResourcePackageInformation");
		}
        else if (sPageName.equals(MigrationImportPortalResourcesDP.STR_MVC_CLASS_NAME))
        {
            SetHelpTopic("PT_ImportPortalResources_ResourcestoImport");
        }
	}
}

