package com.plumtree.portalpages.admin.ptutilities.migrationutility.exp;

import com.plumtree.portaluiinfrastructure.tree.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.tree.*;

/**
 * 
 * @author jennifersu
 *
 */
public class GlobalObjsTreeAS extends TreeAS
{
	/** object name */
	public static final String STR_MVC_CLASS_NAME = "GlobalObjsTree";

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IPTActivitySpace#CheckBasicAccess(String, String, boolean)
	 */
	public boolean CheckBasicAccess(String strPage, String strControl,
		boolean bSameSpace)
	{
		return true;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new GlobalObjsTreeAS();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#Init()
	 */
	public void Init()
	{
		super.Init();

		RegisterModel(GlobalObjsTreeModel.STR_MVC_CLASS_NAME, TREEMODEL);

		IModel myModel = GetModel(TREEMODEL);

		RegisterView(TreeView.STR_MVC_CLASS_NAME, myModel);
		RegisterView(TreeBarView.STR_MVC_CLASS_NAME,
			TreeDP.TREE_BAR_STORAGE_NAME, myModel);

		RegisterControl(GlobalObjsStartTreeControl.STR_MVC_CLASS_NAME,
			myModel);
		RegisterControl(TreeRepostControl.STR_MVC_CLASS_NAME, myModel);

		RegisterControl(RefreshTreeControl.STR_MVC_CLASS_NAME, myModel);
		
	}
}

