package com.plumtree.portalpages.admin.ptutilities.migrationutility.exp;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.ptutilities.migrationutility.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

public class MigrationExportPortalResourcesDP extends EditorDP
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.ptutilities.migrationutility.exp.MigrationExportPortalResourcesDP");

	
	public static final String STR_MVC_CLASS_NAME = "MigrationExportPortalResources";

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorDP#GetLeftNavString()
	 */
	public String GetLeftNavString()
	{
		return m_asOwner.GetString(2757, "ptmsgs_portaladminmsgs");
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader()

	{
	  return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(2758, "ptmsgs_portaladminmsgs"), 
	  	this.m_asOwner);
	}

	
	/**
	 * @see com.plumtree.xpshared.activityspace.IDisplayPage#Init(AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		super.Init(parent);
	}

	/**
	 * Helper display method for PlumtreeDP
	 * Fill in the body argument with HTML to display in the page.
	 *
	 * @return HTMLElement
	 * @throws HTMLException
	 */
	public HTMLElement PageDisplay()

	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(MigrationUtilityExportAS.strStorageSelectForExport))
				.Display());

        views.AddInnerHTMLElement(EditorView.GetSpacerTable());

        // Export settings below the resources tree
        views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
            ExportSettingsView.STR_MVC_CLASS_NAME)).Display());

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#DisplayJavaScriptFromChild()
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection result = super.DisplayJavaScriptFromChild();

		if (null == result)
		{
			result = new HTMLScriptCollection();
		}

		result.AddInnerHTMLElement(
			m_asOwner
				.GetView(MigrationUtilityExportAS.strStorageSelectForExport)
				.DisplayJavascript());

		return result;
	}
}

