package com.plumtree.portalpages.admin.ptutilities.migrationutility.exp;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.editors.objectdelivery.common.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author jennifersu
 *
 */
public class MigrationGeneralInfoView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.ptutilities.migrationutility.exp.MigrationGeneralInfoView");

	public static final String STR_MVC_CLASS_NAME = "MigrationGeneralInfoView";

	public static final String HTMLINPUT_PACKAGE_NAME = "in_tx_PackageName";
	public static final String HTMLINPUT_PACKAGE_DESCRIPTION = "in_ta_PackageDesc";
	public static final String HTMLINPUT_PUBLISHER_NAME = "in_tx_PublisherName";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new MigrationGeneralInfoView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTable myTable;

		HTMLTableRow myRow;
		try
		{
			IMigrationUtilityExportModelRO myModel = (IMigrationUtilityExportModelRO)m_model;
			
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						472, "ptmsgs_portalbrowsingmsgs")));

			myTable = ODViewHelper.AddTable(result);

			// 1st row begins (Top Margin)
			ODViewHelper.AddEmptyRow(myTable, "5");

			// 2nd row			
			ODViewHelper.AddSimpleEditBox(myTable, 5,
				m_asOwner.GetString(473, "ptmsgs_portalbrowsingmsgs"), "",
				myModel.GetPackageName(), HTMLINPUT_PACKAGE_NAME);

			// 3rd row 
			myRow = ODViewHelper.AddRow(myTable);

			// Left Margin
			ODViewHelper.AddLeftMargin(myRow, 5);

			// Label
			ODViewHelper.AddLabelCell(myRow, "2", m_asOwner.GetString(475, "ptmsgs_portalbrowsingmsgs"));

			// Right Margin
			ODViewHelper.AddRightMargin(myRow, 5);			

			// 4th row
			myRow = ODViewHelper.AddRow(myTable);

			// Left Margin
			ODViewHelper.AddLeftMargin(myRow, 5);

			// Text Input box
			ODViewHelper.AddTextAreaCell(myRow, "2", myModel.GetPackageDescription(), HTMLINPUT_PACKAGE_DESCRIPTION);

			// Right Margin
			ODViewHelper.AddRightMargin(myRow, 5);


			// 5th row
			ODViewHelper.AddSimpleEditBox(myTable, 5,
				m_asOwner.GetString(474, "ptmsgs_portalbrowsingmsgs"), "",
				myModel.GetPublisher(), HTMLINPUT_PUBLISHER_NAME);

			// last row begins (Bottom Margin)
			ODViewHelper.AddEmptyRow(myTable, "5");
		}
		catch (HTMLException e)
		{
			
				log.Error(e, STR_MVC_CLASS_NAME +
					"::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(476,
					"ptmsgs_portalbrowsingmsgs"), e);
		}

		return result;
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}

