package com.plumtree.portalpages.admin.ptutilities.migrationutility.exp;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.ptutilities.migrationutility.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.expandablelist.*;

/**
 * 
 * @author jennifersu
 *
 */
public class MigrationSelectForExportRepostControl extends ExpListControl
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.ptutilities.migrationutility.exp.MigrationSelectForExportRepostControl");

	public static final String STR_MVC_CLASS_NAME = "MigrationSelectForExportRepostControl";

	public final static int POSTTOSELF_ACTION_ADD_APPROVED = 15;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new MigrationSelectForExportRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Switch between the action modes and call
	 * the associated method for each action.
	 *
	 * @param int
	 */
	public void PerformRepostAction(int _nAction, XPHashtable _htFormData)
	{
		// Editor repost actions (Finish, Cancel, Change Page, etc.)
		super.PerformRepostAction(_nAction, _htFormData);
		
		// Migration repost actions
		switch (_nAction)
		{
			case POSTTOSELF_ACTION_ADD_APPROVED:
				MigrationSelectForExportModel listModel = (MigrationSelectForExportModel)m_asOwner.GetModel(MigrationUtilityExportAS.strStorageSelectForExport);
				listModel.AddAllApproved();
				break;
		}

	}
}

