package com.plumtree.portalpages.admin.ptutilities.migrationutility.imp;

import com.plumtree.server.*;

import com.plumtree.openfoundation.util.*;

/**
 * 
 * @author jennifersu
 *
 */
public class CPTMigrationDependency
{
	protected String m_strUUID;
	protected int m_nClassID;
	protected String m_strName;
	protected XPHashtable m_xphtResolvableObjects;

	/**
	 * Creates a new CPTMigrationDependency object.
	 *
	 * @param strUUID DOCUMENT ME!
	 * @param nClassID DOCUMENT ME!
	 * @param strName DOCUMENT ME!
	 */
	public CPTMigrationDependency(String strUUID, int nClassID, String strName)
	{
		m_strUUID               = strUUID;
		m_nClassID              = nClassID;
		m_strName               = strName;
		m_xphtResolvableObjects = new XPHashtable();
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @return DOCUMENT ME!
	 */
	public String GetUUID()
	{
		return m_strUUID;
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @return DOCUMENT ME!
	 */
	public int GetClassID()
	{
		return m_nClassID;
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @return DOCUMENT ME!
	 */
	public String GetName()
	{
		return m_strName;
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @param ptME DOCUMENT ME!
	 */
	public void AddResolvableObject(IPTMigrationElement ptME)
	{
		m_xphtResolvableObjects.PutElement(ptME.GetUUID(), ptME);
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @return DOCUMENT ME!
	 */
	public int GetResolvableObjectCount()
	{
		return m_xphtResolvableObjects.GetSize();
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @param nIndex DOCUMENT ME!
	 *
	 * @return DOCUMENT ME!
	 */
	public IPTMigrationElement GetResolvableObject(String _strUUID)
	{
		return (IPTMigrationElement) m_xphtResolvableObjects.GetElement(_strUUID);
	}
	
	/**
	 * Gets an XPHashtable of all resolvable objects
	 * that depend on this CPTMigrationDependency
	 * @return
	 */
	public XPHashtable GetAllResolvableObjects()
	{
		return m_xphtResolvableObjects;
	}
	
	/**
	 * Removes object with UUID
	 * from XPHashtable of resolvable
	 * objects.
	 * @param _strUUID
	 */
	public void RemoveResolvableObject(String _strUUID)
	{
		m_xphtResolvableObjects.RemoveElement(_strUUID);
	}
}