package com.plumtree.portalpages.admin.ptutilities.migrationutility.imp;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.expandablelist.*;
import com.plumtree.uiinfrastructure.tree.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 * @author jennifersu
 *
 */
public class MigrationDependencyListRepostControl extends ExpListControl
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.ptutilities.migrationutility.imp.MigrationDependencyListRepostControl");

	public static final String STR_MVC_CLASS_NAME = "MigrationDependencyListRepostControl";

	public final static int POSTTOSELF_ACTION_EDIT_DEPENDENCY = 15;

	public final static int POSTTOSELF_ACTION_OPEN_DEPENDENCY_TREE = 16;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new MigrationDependencyListRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Sets the editor to perform the tree popup.
	 */
	protected void PerformTreePopup(ASURL _treeURL)
	{
		try
		{
			// Set up the popup
			HTMLScript myScript = new HTMLScript("text/javaScript");
			XPStringBuilder sb;

			sb = new XPStringBuilder(200);
			sb.Append("window.open('")
			.Append(_treeURL.GetURLAsString())
			.Append("', '_DependencyTree', '")
			.Append(TreeConstants.GetJavascriptTreeWindowAttributes()).Append("');\n");

			myScript.AddInnerHTMLString(sb.ToString());
			((EditorDP) ((EditorAS) m_asOwner).GetCurrentPage()).AddScriptToHead(myScript);

		}
		catch (Exception e)
		{			
			log.Error(e, STR_MVC_CLASS_NAME + "::PerformTreePopup  Unknown error attempting to open Dependency Tree. e: " + e.getMessage());
		}
	}


	/**
	 * Switch between the action modes and call
	 * the associated method for each action.
	 *
	 * @param int
	 */
	public void PerformRepostAction(int _nAction, XPHashtable _htFormData)
	{
		// Editor repost actions (Finish, Cancel, Change Page, etc.)
		super.PerformRepostAction(_nAction, _htFormData);
		
		// Migration repost actions
		switch (_nAction)
		{
			case POSTTOSELF_ACTION_EDIT_DEPENDENCY:
				MigrationDependencyListModel listModel = (MigrationDependencyListModel)m_asOwner.GetModel(MigrationDependencyListModel.STR_MVC_CLASS_NAME);
				listModel.DoEditDependency(_htFormData);
				break;
				
			case POSTTOSELF_ACTION_OPEN_DEPENDENCY_TREE:
				ASURL treeURL = ((MigrationDependencyListModel) m_model).DoOpenDependencyTree(_htFormData);
				PerformTreePopup(treeURL);
				break;
		}

	}
}

