package com.plumtree.portalpages.admin.ptutilities.objectlockmanager;


// Framework Imports
import com.plumtree.uiinfrastructure.arraywrapper.*;
import com.plumtree.uiinfrastructure.editor.*;

/**
 * This interface is implemented by the Model.
 * It contains all the read-only mothods of the Model
 * accessed by the Views.
 *
 * @author Julie Fournier
 */
public interface IObjectLockManagerModelRO extends IEditorModelRO
{
	/**
	 * Returns the classID.
	 * @return int
	 */
	public int GetClassID();

	/**
	 * Returns the sortColumn.
	 * @return int
	 */
	public int GetSortColumn();

	/**
	 * Returns the sortDirection.
	 * @return int
	 */
	public int GetSortDirection();

	/**
	 * Returns whether we are just sorting the list of locked items, or whether
	 * we should retrieve new data from the database.
	 * @return boolean
	 */
	public boolean GetSortOnly();

	/**
	 * Returns the value of the member variable "m_arrLockedItems".
	 *
	 * @return PTSortedArrayWrapper
	 */
	public PTGrowableSortedArrayWrapper GetLockedItems(int intClassID);
	
	/**
	 * Returns the value of the growable array of locked items for the current
	 * classID in the hashtable.
	 *
	 * @return PTSortedArrayWrapper
	 */
	
	public PTGrowableSortedArrayWrapper GetLockedItemsFromHashtable(int _nClassID);
}

