package com.plumtree.portalpages.admin.ptutilities.objectlockmanager;


// Framework Imports
import com.plumtree.openfoundation.util.XPConvert;
import com.plumtree.portaluiinfrastructure.classtypedescriptors.IPTClassTypeDesc;
import com.plumtree.uiinfrastructure.statichelpers.PersonalSettingsHelper;

/**
 * This is class is used to print out together the Views for 
 * all class types for the object lock manager.
 *
 * @author Okan Alper
 */
public class LockManagerObjectDP extends MainDP {
    IPTClassTypeDesc m_classType = null; 
	
    public LockManagerObjectDP(IPTClassTypeDesc classType) {
        m_classType = classType;
    }
	/**
	 * Returns the classID for this subclass
	 * @see com.plumtree.portalpages.admin.ptutilities.objectlockmanager.MainDP#GetChildClassID()
	 */
	public int GetChildClassID()
	{
		return m_classType.GetClassID();
	}

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString() {
        ObjectLockManagerModel myModel = (ObjectLockManagerModel)(m_asOwner.GetModel(ObjectLockManagerModel.STR_MVC_CLASS_NAME));
        int lockedCount = myModel.GetLockedCount(m_classType.GetClassID());
		return m_classType.GetObjectLockManagerLocalizedName(
                       XPConvert.ToString(PersonalSettingsHelper.GetPersonalSettingValue(
                                            PersonalSettingsHelper.LANGUAGE, m_asOwner))) + 
                                            (lockedCount > 0 ? " (" + lockedCount + ")" : "");
	}
    
    /**
     * Returns the page title. This implementation displays the left nav string without the # of locked objs
     *
     * @return String
     */
    public String GetFormTitle() {
        return m_classType.GetObjectLockManagerLocalizedName(
                XPConvert.ToString(PersonalSettingsHelper.GetPersonalSettingValue(
                                     PersonalSettingsHelper.LANGUAGE, m_asOwner)));
    }


	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName() {
		return "ObjectLockManager" + m_classType.GetClassKey();
	}
}

