package com.plumtree.portalpages.admin.ptutilities.objectlockmanager;


// Framework Imports
import com.plumtree.uiinfrastructure.editor.*;

/**
 * This class contains the additional repost actions.
 * The ones specific to the Object Lock Manager (other than
 * "change page", "finish" and "cancel" actions).
 *
 * @author John Hogan
 */
public class ObjectLockManagerRepostControl extends EditorRepostControl
{
	/** Unique identifier for the class */
	public static final String STR_MVC_CLASS_NAME    = "ObjectLockManagerRepost";

	
	public final static int POSTTOSELF_ACTION_UNLOCK = 10;

	
	public final static int POSTTOSELF_ACTION_SORT = 20;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new ObjectLockManagerRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Switch between the action modes and call
	 * the associated method for each action.
	 *
	 * @param int
	 */
	protected void PerformAction(int _nAction)
	{
		super.PerformAction(_nAction);

		switch (_nAction)
		{
		case POSTTOSELF_ACTION_UNLOCK:
			((ObjectLockManagerModel) m_model).UnlockObjects();

			break;

		case POSTTOSELF_ACTION_SORT:
			((ObjectLockManagerModel) m_model).ChangeSort();

			break;
		}
	}
}

