package com.plumtree.portalpages.admin.ptutilities.settings;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.portalpages.admin.objmgr.*;
import com.plumtree.portalpages.admin.ptutilities.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.web.*;


/**
 * 
 *
 * @version 5.0
 * @author Sudha Sathiaseelan
 */
public class DefaultProfilesPlumtreeUtilities implements IPlumtreeUtilities
{
	
	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASControlName()
	{
		return ObjMgrSettingsControl.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASDPName()
	{
		return null;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASName()
	{
		return ObjMgrAS.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASQueryString()
	{
		String strFolderQuery = ObjMgrSettingsControl.FOLDER_ID + "=" +
			PT_INTRINSICS.PT_ADMIN_FOLDER_DEFAULTPROFILES;
		String strObjectQuery = ObjMgrSettingsControl.OBJECT_IDS + "=" +
			PT_CLASSIDS.PT_USER_ID;
		String strQuery		  = "&" + strFolderQuery + "&" + strObjectQuery;

		return strQuery;
	}

	//Return link text
	public String GetLinkText(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
		return (rm.GetString(2007, "ptmsgs_portaladminmsgs", _strLangID));
	}

	//Describes whether the setting comes with the standard portal
	public boolean IsStandardPortalOption()
	{
		return (true);
	}

	//Describes whether the setting is currently viewable
	public boolean IsViewable()
	{
		return (true);
	}

	/* (non-Javadoc)
	 * @see com.plumtree.portalpages.admin.ptutilities.IPlumtreeUtilities#GetActivityRightRestriction()
	 */
	public int GetActivityRightRestriction()
	{
		return PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_CREATE_USERS;	
	}
}

