package com.plumtree.portalpages.admin.ptutilities.settings;


/**
 * @author dand
 *
 * This class causes the Profile Layout Editor to show up in the
 * Plumtree Utilities menu.
 *
 */
import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.portalpages.admin.editors.userprofilemanager.*;
import com.plumtree.portalpages.admin.ptutilities.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.web.*;

/**
 * 
 *
 * @version $Revision$
 * @author $author$
 */
public class ProfileLayoutPlumtreeUtilities implements IPlumtreeUtilities
{
	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASControlName()
	{
		return EditorStartControl.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASDPName()
	{
		return null;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASName()
	{
		return UsrProfMgrEditorAS.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASQueryString()
	{
		String strQuery = "&" + EditorStartControl.QS_EDITOR_TYPE + "=10";

		return strQuery;
	}

	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#GetLinkText()
	 */
	public String GetLinkText(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance()
			.GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm     = (XPResourceManager) 
			application.GetCachingManager().GetEntry("ResourceManager");

		return rm.GetString(967, "ptmsgs_portaladminmsgs", _strLangID);
	}

	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#IsStandardPortalOption()
	 */
	public boolean IsStandardPortalOption()
	{
		return true;
	}

	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#IsViewable()
	 */
	public boolean IsViewable()
	{
		return true;
	}
	
	/* (non-Javadoc)
	 * @see com.plumtree.portalpages.admin.ptutilities.IPlumtreeUtilities#GetActivityRightRestriction()
	 */
	public int GetActivityRightRestriction()
	{
		return PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_EDIT_USERINFO_MAP;	
	}
}

