package com.plumtree.portalpages.admin.ptutilities.settings;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.portalpages.admin.ptutilities.*;
import com.plumtree.portalpages.browsing.editors.smartsort.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.web.*;

/**
 * @author OlegS
 */
public class SmartSortPlumtreeUtilities implements IPlumtreeUtilities
{

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASControlName()
	{
		return EditorStartControl.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASDPName()
	{
		return null;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASName()
	{
		return SmartSortEditorAS.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASQueryString()
	{
		String strQuery = "&" + EditorStartControl.QS_EDITOR_TYPE + "=" +
			EditorStartControl.EDITOR_START_FLAG_CREATE + "&" + "classID=42"+
			// supress the option to choose admin folder for taxonomist
			"&"+ObjEditorModel.EDITOR_QS_BOL_QS_FORCESAVEINFOLDER+"=true"+ 
			"&"+ObjEditorModel.EDITOR_QS_INT_QS_FOLDER_ID+"="+PT_INTRINSICS.PT_ADMIN_FOLDER_INTRINSICOPS;

		return strQuery;
	}

	//Return link text
	public String GetLinkText(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
		return (rm.GetString(2010, "ptmsgs_portaladminmsgs", _strLangID));
	}

	//Describes whether the setting comes with the standard portal
	public boolean IsStandardPortalOption()
	{
		return (true);
	}

	//Describes whether the setting is currently viewable
	public boolean IsViewable()
	{
		return (true);
	}
	
	/* (non-Javadoc)
	 * @see com.plumtree.portalpages.admin.ptutilities.IPlumtreeUtilities#GetActivityRightRestriction()
	 */
	public int GetActivityRightRestriction()
	{
		return PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_CREATE_TAXONOMISTS;	
	}
}

