package com.plumtree.portalpages.admin.ptutilities.settings;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.portalpages.admin.ptutilities.*;
import com.plumtree.portalpages.admin.ptutilities.userlockmanager.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.web.*;

/**
 * The user lock manager is used to remove locks on users that have been left in
 * place due to a system error or a security violation.
 *
 * @version 5.0
 * @author JohnH
 */
public class UserLockManagerPlumtreeUtilities implements IPlumtreeUtilities
{

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASControlName()
	{
		return EditorStartControl.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASDPName()
	{
		return null;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASName()
	{
		return UserLockManagerAS.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASQueryString()
	{
		String strQuery = "&" + EditorStartControl.QS_EDITOR_TYPE + "=" +
			EditorStartControl.EDITOR_START_FLAG_MISC;

		return strQuery;
	}

	//Return link text
	public String GetLinkText(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
		return (rm.GetString(2012, "ptmsgs_portaladminmsgs", _strLangID));
	}

	//Describes whether the setting comes with the standard portal
	public boolean IsStandardPortalOption()
	{
		return (true);
	}

	//Describes whether the setting is currently viewable
	public boolean IsViewable()
	{
		return (true);
	}
	
	/* (non-Javadoc)
	 * @see com.plumtree.portalpages.admin.ptutilities.IPlumtreeUtilities#GetActivityRightRestriction()
	 */
	public int GetActivityRightRestriction()
	{
		return PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_NONE;	
	}
}

