package com.plumtree.portalpages.admin.ptutilities.userinfopropmap;


// Framework Imports
import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.ptmulticolumnlist.*;
import com.plumtree.portaluiinfrastructure.tree.*;
import com.plumtree.uiinfrastructure.tree.*;


public class UserInfoPropMapListModel extends PTMultiColumnListModel
{
	/** The unique identifier for the class */
	public static final String STR_MVC_CLASS_NAME = "UserInfoPropMapListModel";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new UserInfoPropMapListModel();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Clear the list and add all the values selected from the tree, as well as
	 * values or defaults for the other columns in the control.
	 *
	 * @param _htFormData Form data
	 */
	public void AddRowsOnRepost(XPHashtable _htFormData)
	{
		if (m_bIncludePTSelect)
		{
			//Validate that the proposed position of the selected Plumtree
			//object is not greater than the number of other columns
			if (m_intPTObjectPosition > m_intNumColumns)
			{
				m_intPTObjectPosition = 0;
			}

			SaveTreeID(_htFormData);

			TreeAS asTree = (TreeAS) m_asOwner.GetSubSpace(GetUniqueString(
						SUBSPACE_KEY_SELECTTREE));

			if (null != asTree)
			{
				ITreeModelRO myTree    = (ITreeModelRO) asTree.GetModel(ATreeAS.TREEMODEL);
				XPArrayList mySelected = myTree.GetSelectedItems();
				Object[] oNewRow;
				int nClassID;

				//First, save the data so we can re-populate the non-tree items
				XPHashtable[] arrHashtables = new XPHashtable[m_intNumColumns +
					3];

				for (int i = 0; i < (m_intNumColumns + 3); i++)
				{
					arrHashtables[i] = new XPHashtable();
				}

				for (int i = 0; i < m_saData.GetCount(); i++)
				{
					for (int j = 1; j < (m_intNumColumns + 4); j++) //skip the index column
					{
						arrHashtables[j - 1].PutElement(m_saData.GetItem(i,
								EXPLIST_COL_STRING + m_intPTObjectPosition),
							m_saData.GetItem(i, j));
					}
				}

				// JF- We clear the array before we start adding the selected items from the tree.
				super.GetItems().ClearArray();

				for (int i = 0; i < mySelected.GetSize(); i++)
				{
					oNewRow										  = new Object[m_intNumColumns +
						4];
					oNewRow[EXPLIST_SORTEDARRAY_PROPID_INDEX]     = new Integer(m_nNextIndex);
					m_nNextIndex++;
					nClassID												  = ((TreeLeafNode) mySelected.GetElement(i)).m_nClassID;
					oNewRow[EXPLIST_COL_CLASSID + m_intPTObjectPosition]	  = new Integer(nClassID);
					oNewRow[EXPLIST_COL_OBJECTID + m_intPTObjectPosition]     = new Integer(((TreeLeafNode) mySelected.GetElement(
								i)).m_nObjectID);
					oNewRow[EXPLIST_COL_STRING + m_intPTObjectPosition]		  = ((TreeLeafNode) mySelected.GetElement(i)).GetName();

					//Add the other empty columns
					String strValue;
					int intColIndex;

					for (int j = 0; j < m_intNumColumns; j++)
					{
						if (j < m_intPTObjectPosition)
						{
							intColIndex = j + 1;
						}
						else
						{
							intColIndex = j + 4;
						}

						//TODO - get the right hashtable - only j when m_intPTObjectPosition is 1
						strValue = (String) arrHashtables[intColIndex - 1].GetElement(oNewRow[EXPLIST_COL_STRING +
								m_intPTObjectPosition]);

						if ((null == strValue) || strValue.equals(""))
						{
							// Default to the property name
							strValue = XPConvert.ToString(oNewRow[EXPLIST_COL_STRING + m_intPTObjectPosition]);
						}

						oNewRow[intColIndex] = strValue;
					}

					super.GetItems().AddRow(oNewRow);
				}
			}
		}
		else
		{
			String[][] arrDefault = new String[m_intNumColumns][1];

			for (int i = 0; i < m_intNumColumns; i++)
			{
				arrDefault[i][0] = m_arrDefaultValue[i];
			}

			AddRowsToList(arrDefault);
		}
	}
}
