package com.plumtree.portalpages.admin.sendinvitation;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.login.createaccount.*;
import com.plumtree.portaluiinfrastructure.application.varpacks.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author dustina
 *
 */
public class CodePopUpView implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.sendinvitation.CodePopUpView");


	public static final String STR_MVC_CLASS_NAME = "CodePopUpView";

	public static final String HTMLBUTTON_DONE = "in_bu_Done";
	protected AActivitySpace m_asOwner;
	protected IModelRO m_model;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new CodePopUpView();
	}

	/**
	 *
	 *
	 * @return
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTable myTable;
		HTMLTableCell myCell;
		HTMLTableRow myRow;
		HTMLTextArea myTextArea;
		HTMLInput myInput;

		try
		{
			myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetStyleClass(PTStyleClass.DIALOGUE_BG);
			myTable.SetWidth("460");
			myTable.SetHeight("220");
			myTable.SetBorder("0");
			myTable.SetCellPadding("5");
			myTable.SetCellSpacing("0");

			//Header Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.ALERT_DIALOG_TITLE);

			myCell.AddInnerHTMLString(m_asOwner.GetString(1272,
					"ptmsgs_portaladminmsgs"));
			myCell.AddInnerHTMLElement(new HTMLBr());

			// Header Row end
			//Instruction Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);

			myCell.AddInnerHTMLString(m_asOwner.GetString(1273,
					"ptmsgs_portaladminmsgs"));
			myCell.AddInnerHTMLElement(new HTMLBr());

			// Instruction Row end
			//Email Text Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetAlign(CommonHTMLStrings.CENTER);

			// ***<textarea>*** begins here
			myTextArea = new HTMLTextArea("60", "6");
			myTextArea.SetReadOnly(true);
			myCell.AddInnerHTMLElement(myTextArea);
			myTextArea.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);

			boolean bIsInviteURLSecure = (1 == PTConfigHelper.GetConfigVariableAsInt(PTConfigConstants.INVITATIONS_SECTION, PTConfigConstants.IS_INVITATION_URL_SECURE,
																					"value", m_asOwner));

			// The URL to open the pop-up
			ASURL myURL = new ASURL(m_asOwner);
			myURL.SetUseMainServerURL(true, bIsInviteURLSecure);
			myURL.SetLinkGetSpaceIfCached(CreateAccountAS.STR_MVC_CLASS_NAME,
				this.m_asOwner);
			myURL.SetControl(InterceptInvitationControl.STR_MVC_CLASS_NAME);
			myURL.AddControlArgument(InvCodesListView.CONTROLARGUMENT_INVCODE,
				((IInvCodeListModelRO) m_model).GetInvitationCode());

			myTextArea.AddInnerHTMLString(m_asOwner.GetString(1274,
					"ptmsgs_portaladminmsgs"));
			myTextArea.AddInnerHTMLString(myURL.GetURLAsString());

			// ***<textarea>*** ends here
			// Email Text Row end
			// Done Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);

			myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_DONE,
					m_asOwner.GetString(1270, "ptmsgs_portaladminmsgs"));
			myCell.AddInnerHTMLElement(myInput);
			myCell.SetAlign(CommonHTMLStrings.CENTER);

			myInput.SetValue(m_asOwner.GetString(1269, "ptmsgs_portaladminmsgs"));
			myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
			myInput.SetOnClick("window.close();");	// mj: removed 'Javascript:' from function name

			// Done Row end
		}
		catch (Exception e)
		{
			
				log.Error(e, "CodePopUpView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(1271,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * This method returns the HTMLScript that encompasses the Javascript on the page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 *
	 * @return HTMLScript
	 */
	public HTMLScript DisplayJavascript()
	{
		HTMLScript myScript = new HTMLScript("text/javaScript");

		return myScript;
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Inits the Section with the read-only Model and the Activity Space.
	 *
	 * @param model
	 * @param parent
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_model = model;

		try
		{
			m_asOwner = (SendInvitationAS) parent;
		}
		catch (Exception e)
		{
			
				log.Error(e, "NewLinkPopUpView::Init Unable to cast the Object " +
					parent +
					" to SendInvitationAS. The following exception occured: " +
					e.getMessage());
			

			// JF- No need to extract, this is an unexpected error.
			throw new XPException("Unable to cast the Object " + parent +
				" to SendInvitationAS.", e);
		}
	}
}

