package com.plumtree.portalpages.admin.sendinvitation;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author dustina
 *
 */
public class CreateInvCodeView implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.sendinvitation.CreateInvCodeView");


	public static final String STR_MVC_CLASS_NAME    = "CreateInvCodeView";


	public static final String JS_CLOSE_AFTER_CREATE = "CloseAfterCreate";


	public static final String JS_RELOAD_NEW_LINK_PAGE = "TryAgain";


	public static final String HTMLBUTTON_CLOSE = "in_bu_Close";
	protected AActivitySpace m_asOwner;

	protected IModelRO m_model;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new CreateInvCodeView();
	}

	/**
	 *
	 *
	 * @return
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTableCell myCell;
		HTMLTableRow myRow;
		HTMLInput myInput;

		try
		{
			HTMLTable myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);

			if (((ISendInvitationModelRO) m_model).GetCreateCodeStatus())
			{
				myTable.SetStyleClass(PTStyleClass.DIALOGUE_BG);
			}
			else
			{
				myTable.SetStyleClass(PTStyleClass.ALERT_DIALOG_BG);
			}

			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("5");
			myTable.SetCellSpacing("0");

			//Header Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.ALERT_DIALOG_TITLE);

			myCell.AddInnerHTMLString(m_asOwner.GetString(1277,
					"ptmsgs_portaladminmsgs"));
			myCell.AddInnerHTMLElement(new HTMLBr());

			// Header Row end
			//spacer Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.AddInnerHTMLElement(new HTMLBr());

			// spacer Row end
			// MessageRow begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);

			if (((ISendInvitationModelRO) m_model).GetCreateCodeStatus())
			{
				myCell.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);

				myCell.AddInnerHTMLString(m_asOwner.GetString(1279,
						"ptmsgs_portaladminmsgs"));
			}
			else
			{
				myCell.SetStyleClass(PTStyleClass.ALERT_ERROR_TEXT);
				myCell.AddInnerHTMLString(((ISendInvitationModelRO) m_model).GetCreateErrorMessage());
			}

			// Message Row end
			//spacer Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.AddInnerHTMLElement(new HTMLBr());

			// spacer Row end
			// Done and Cancel Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetAlign(CommonHTMLStrings.CENTER);

			myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_CLOSE,
					m_asOwner.GetString(1278, "ptmsgs_portaladminmsgs"));
			myCell.AddInnerHTMLElement(myInput);

			myInput.SetValue(m_asOwner.GetString(1275, "ptmsgs_portaladminmsgs"));
			myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);

			if (((ISendInvitationModelRO) m_model).GetCreateCodeStatus())
			{
				myInput.SetOnClick(JS_CLOSE_AFTER_CREATE +	// mj: removed 'Javascript:' from function name
					"();");
			}
			else
			{
				myInput.SetOnClick(JS_RELOAD_NEW_LINK_PAGE +	// mj: removed 'Javascript:' from function name
					"();");
			}

			// Done and Cancel Row end
			//spacer Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetHeight("150");

			// spacer Row end
		}
		catch (Exception e)
		{
			
				log.Error(e, "CreateInvCodeView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(1276,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * This method returns the HTMLScript that encompasses the Javascript on the page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 *
	 * @return HTMLScript
	 */
	public HTMLScript DisplayJavascript()
	{
		HTMLScript myScript = new HTMLScript("text/javaScript");

		XPStringBuilder sb;

		try
		{
			sb = new XPStringBuilder(200);
			sb.Append("function " + JS_CLOSE_AFTER_CREATE + "()\n");
			sb.Append("{\n");
			sb.Append("  window.opener.postToSelf(")
			.Append(SendInvitationRepostControl.POSTTOSELF_ACTION_SIMPLEREPOST)
			.Append(");\n");
			sb.Append("  window.close();\n");
			sb.Append("}\n");
			myScript.AddInnerHTMLString(sb.ToString());

			sb = new XPStringBuilder(200);
			sb.Append("function " + JS_RELOAD_NEW_LINK_PAGE + "()\n");
			sb.Append("{\n");
			sb.Append("  document." + AFormDP.HTMLFORM_NAME + "." +
				ASConstants.PAGE_INPUT + ".value = 'NewLinkPopUpDP';\n");
			sb.Append("  postToSelf(")
			.Append(SendInvitationRepostControl.POSTTOSELF_ACTION_SIMPLEREPOST).Append(");\n");
			sb.Append("}\n");
			myScript.AddInnerHTMLString(sb.ToString());
		}
		catch (HTMLException he)
		{
			
				log.Error(he, "CreateInvCodeDP::DisplayJavascript The following error occured when trying to display the JavaScript: " +
					he.getMessage());
			
		}

		return myScript;
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Inits the Section with the read-only Model and the Activity Space.
	 *
	 * @param model
	 * @param parent
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_model = model;

		try
		{
			m_asOwner = (SendInvitationAS) parent;
		}
		catch (Exception e)
		{
			
				log.Error(e, "CreateInvCodeView::Init Unable to cast the Object " +
					parent +
					" to SendInvitationAS. The following exception occured: " +
					e.getMessage());
			

			// JF- No need to extract, this is an unexpected error.
			throw new XPException("Unable to cast the Object " + parent +
				" to SendInvitationAS.", e);
		}
	}
}

