package com.plumtree.portalpages.admin.sendinvitation;

import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.uiinfrastructure.pagecontrols.jsdatepicker.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author dustina
 *
 */
public class NewLinkPopUpDP extends AFormDP
{
	
	public static final String STR_MVC_CLASS_NAME = "NewLinkPopUpDP";

	/**
	 * Displays some HTML after the body tag and before the form tag.
	 * For example this is used by pages using a DHTML calendar to display the div tag.
	 * The function is optional.  If it exists, it will be called by the framework, and
	 * the resulting HTMLElement will be added in the right place.
	 *
	 * @return HTMLElement
	 */
	public HTMLElementCollection DisplayHTMLBeforeForm()

	{
		IInvCodeListModelRO ptROModel = (IInvCodeListModelRO) m_asOwner.GetModel(InvCodesListModel.STR_MVC_CLASS_NAME);

		return ptROModel.GetDatePickerControlManager().GetPagePreFormContent();
	}

	/**
	 * Returns the HTML that is placed in the HEAD section of this HTML page.
	 *
	 * @return HTMLElement
	 */
	public HTMLElementCollection DisplayHTMLinHEAD()

	{
		HTMLElementCollection retVal = new HTMLElementCollection();

		IInvCodeListModelRO ptROModel = (IInvCodeListModelRO) m_asOwner.GetModel(InvCodesListModel.STR_MVC_CLASS_NAME);
		JSDatePickerMgr ptDatePickerMgr = ptROModel.GetDatePickerControlManager();
		retVal.AddInnerHTMLElement(ptDatePickerMgr.GetJSIncludes());
		
		//Get access to the PTDate.js file for formatting date strings

		retVal.AddInnerHTMLElement(ConfigHelper.GetJSIncluderJSComponentInclude(ConfigHelper.JSCOMPONENT_JSDATEPICKER, GetOwner()));
		return retVal;
	}

	/**
	 * This is a helper method that all classes that inherit from AFormDP and want to
	 * have the Done and Cancel buttons displayed in the header for them need to
	 * implement.  The method should return the title add whatever HTML the child
	 * class wants to display to the body argument.  The parent class will then add
	 * that HTML to the HTMLPage after filling in the banner and navigation.
	 *
	 * Override this method to set the form title
	 *
	 * @return String the title for the form header (if used)
	 */
	public String GetFormTitle()
	{
		return m_asOwner.GetString(1298, "ptmsgs_portaladminmsgs");
	}

	
	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()

	{
		HTMLElementCollection result = new HTMLElementCollection();

		result.AddInnerHTMLElement(m_asOwner.GetView(
				NewLinkPopUpView.STR_MVC_CLASS_NAME).Display());

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
				NewLinkPopUpView.STR_MVC_CLASS_NAME).DisplayJavascript());

		return myScripts;
	}
}

