package com.plumtree.portalpages.admin.sendinvitation;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.uiinfrastructure.pagecontrols.jsdatepicker.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author dustina
 *
 */
public class NewLinkPopUpView implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.sendinvitation.NewLinkPopUpView");


	public static final String STR_MVC_CLASS_NAME = "NewLinkPopUpView";


	public static final String HTMLBUTTON_DONE   = "in_bu_Done";


	public static final String HTMLBUTTON_CANCEL = "in_bu_Cancel";


	public static final String HTMLINPUT_NAME = "in_tx_Name";


	public static final String HTMLINPUT_NOI  = "in_tx_NumOfInv";


	public static final String JS_ON_DONE	    = "OnDone";


	public static final String JS_VALIDATE_NAME = "CheckName";


	public static final String JS_VALIDATE_NOI  = "CheckNumberOfInvite";


	public static final String JS_VALIDATE_DATE = "CheckExprDate";
	protected AActivitySpace m_asOwner;

	protected IModelRO m_model;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new NewLinkPopUpView();
	}

	/**
	 *
	 *
	 * @return
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTableCell myCell;
		HTMLTableRow myRow;
		HTMLInput myInput;
		HTMLSpan mySpan;

		try
		{
			HTMLTable myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetStyleClass(PTStyleClass.DIALOGUE_BG);
			myTable.SetWidth("535");
			myTable.SetHeight("270");
			myTable.SetBorder("0");
			myTable.SetCellPadding("5");
			myTable.SetCellSpacing("0");

			//Header Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetColSpan("2");
			myCell.SetStyleClass(PTStyleClass.ALERT_DIALOG_TITLE);

			myCell.AddInnerHTMLString(m_asOwner.GetString(1302,
					"ptmsgs_portaladminmsgs"));

			// Header Row end
			// Name Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);

			// ***EXAMPLE*** How to display a String?
			mySpan.AddInnerHTMLString(m_asOwner.GetString(1303,
					"ptmsgs_portaladminmsgs"));

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);

			// ***EXAMPLE*** How to display an input text?
			// ***<input text>*** begins here
			myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_NAME, "");
			myCell.AddInnerHTMLElement(myInput);
			myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);

			myInput.SetValue( ((IInvCodeListModelRO) m_model).GetInvitationCodeName() );
			myInput.SetSize(40);

			// ***<input text>*** ends here
			// Name Row end
			// Number of invitations Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);

			// ***EXAMPLE*** How to display a String?
			mySpan.AddInnerHTMLString(m_asOwner.GetString(1304,
					"ptmsgs_portaladminmsgs"));

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);

			// ***EXAMPLE*** How to display an input text?
			// ***<input text>*** begins here
			myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_NOI, "");
			myCell.AddInnerHTMLElement(myInput);
			myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
			myInput.SetValue( ((IInvCodeListModelRO) m_model).GetNumberOfInvitations() );
			myInput.SetSize(5);

			// ***<input text>*** ends here
			// Number of invitations Row end
			// Expiration Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);

			// ***EXAMPLE*** How to display a String?
			mySpan.AddInnerHTMLString(m_asOwner.GetString(1305,
					"ptmsgs_portaladminmsgs"));

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);

			JSDatePickerMgr ptDatePickerMgr = ((IInvCodeListModelRO) m_model).GetDatePickerControlManager();
	
			myCell.AddInnerHTMLElement(ptDatePickerMgr.GetComponentHTML("DP_One"));		
	
			HTMLScript datePickerScript = new HTMLScript("text/javaScript");
			datePickerScript.AddInnerHTMLString("varName_DP_One.disablePastDates = true;");
			datePickerScript.AddInnerHTMLString("varName_DP_One.disableToday = true;");
			datePickerScript.AddInnerHTMLString("varName_DP_One.minYearChoice = new Date().getFullYear();");
			myCell.AddInnerHTMLElement(datePickerScript);
			// Expiration Row end

			// Done and Cancel Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetColSpan("2");

			myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_DONE,
					m_asOwner.GetString(1306, "ptmsgs_portaladminmsgs"));
			myCell.AddInnerHTMLElement(myInput);

			myInput.SetValue(m_asOwner.GetString(1299, "ptmsgs_portaladminmsgs"));
			myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
			myInput.SetOnClick(JS_ON_DONE + "();");	// mj: removed 'Javascript:' from function name
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

			myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_CANCEL,
					m_asOwner.GetString(1307, "ptmsgs_portaladminmsgs"));
			myCell.AddInnerHTMLElement(myInput);

			myInput.SetValue(m_asOwner.GetString(1300, "ptmsgs_portaladminmsgs"));
			myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
			myInput.SetOnClick("window.close();");	// mj: removed 'Javascript:' from function name

			// Done and Cancel Row end
			//spacer Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetColSpan("2");
			myCell.SetHeight("100%");

			// spacer Row end
		}
		catch (Exception e)
		{
			
				log.Error(e, "NewLinkPopUpView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(1301,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * This method returns the HTMLScript that encompasses the Javascript on the page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 *
	 * @return HTMLScript
	 */
	public HTMLScript DisplayJavascript()
	{
		HTMLScript myScript = new HTMLScript("text/javaScript");

		XPStringBuilder sb;

		try
		{
			sb = new XPStringBuilder(200);
			sb.Append("function " + JS_ON_DONE + "()\n");
			sb.Append("{\n");
			sb.Append("  if ( " + JS_VALIDATE_NAME + "() && " +
				JS_VALIDATE_NOI + "() && " + JS_VALIDATE_DATE + "() ) { \n");
			sb.Append("  	document." + AFormDP.HTMLFORM_NAME + "." +
				ASConstants.PAGE_INPUT + ".value = 'CreateInvCodeDP';\n");
			sb.Append("  	postToSelf(")
			.Append(SendInvitationRepostControl.POSTTOSELF_ACTION_ADD).Append(");\n");
			sb.Append("  }\n");
			sb.Append("}\n");
			myScript.AddInnerHTMLString(sb.ToString());

			sb = new XPStringBuilder(200);
			sb.Append("function " + JS_VALIDATE_NAME + "()\n");
			sb.Append("{\n");
			sb.Append("  if (document." + AFormDP.HTMLFORM_NAME + "." +
				HTMLINPUT_NAME + ".value == '') { \n");
			sb.Append("		alert(\"" +
				m_asOwner.GetString(1290, "ptmsgs_portaladminmsgs") + "\");\n");
			sb.Append("      return false;\n");
			sb.Append("  }\n");
			sb.Append("  return true;\n");
			sb.Append("}\n");
			myScript.AddInnerHTMLString(sb.ToString());

			sb = new XPStringBuilder(200);
			sb.Append("function " + JS_VALIDATE_NOI + "()\n");
			sb.Append("{\n");
			sb.Append("	 var iTempNum = parseInt( document." +
				AFormDP.HTMLFORM_NAME + "." + HTMLINPUT_NOI + ".value );\n");
			sb.Append("  if ( isNaN(iTempNum) ) { \n");
			sb.Append("		alert(\"" +
				m_asOwner.GetString(1291, "ptmsgs_portaladminmsgs") + "\");\n");
			sb.Append("      return false;\n");
			sb.Append("  } else if (iTempNum < 1) {\n");
			sb.Append("		alert(\"" +
				m_asOwner.GetString(1292, "ptmsgs_portaladminmsgs") + "\");\n");
			sb.Append("      return false;\n");
			sb.Append("  }\n");
			sb.Append("  return true;\n");
			sb.Append("}\n");
			myScript.AddInnerHTMLString(sb.ToString());

			JSDatePicker ptJSDatePicker = (JSDatePicker) ((IInvCodeListModelRO) m_model).GetDatePickerControlManager().GetComponent("DP_One");

			//DCA - only need to check is input is blank, datepicker handles date formats
			sb = new XPStringBuilder(200);
			sb.Append("function " + JS_VALIDATE_DATE + "()\n");
			sb.Append("{\n");
			sb.Append("  if ( document." + AFormDP.HTMLFORM_NAME + "." +
				ptJSDatePicker.GetDateInputName() + ".value == '' ) { \n");
			sb.Append("		alert(\"" +
				m_asOwner.GetString(1294, "ptmsgs_portaladminmsgs") + "\");\n");
			sb.Append("      return false;\n");
			sb.Append("  }\n");
			sb.Append("  return true;\n");
			sb.Append("}\n");
			myScript.AddInnerHTMLString(sb.ToString());
		}
		catch (HTMLException he)
		{
			
				log.Error(he, "NewLinkPopUpView::DisplayJavascript The following error occured when trying to display the JavaScript: " +
					he.getMessage());
			
		}

		return myScript;
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Inits the Section with the read-only Model and the Activity Space.
	 *
	 * @param model
	 * @param parent
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_model = model;

		try
		{
			m_asOwner = (SendInvitationAS) parent;
		}
		catch (Exception e)
		{
			
				log.Error(e, "NewLinkPopUpView::Init Unable to cast the Object " +
					parent +
					" to SendInvitationAS. The following exception occured: " +
					e.getMessage());
			

			// JF- No need to extract, this is an unexpected error.
			throw new XPException("Unable to cast the Object " + parent +
				" to SendInvitationAS.", e);
		}
	}
}

