package com.plumtree.portalpages.admin.sendinvitation;

import com.plumtree.openfoundation.util.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 * @author DustinA
 *
 */
public class SendInvitationModel implements IRepostModel,
	ISendInvitationModelRO
{
	
	public static final String STR_MVC_CLASS_NAME = "SendInvitationModel";
	protected AActivitySpace m_asOwner;
	protected IPTSession m_Session;
	protected String m_sCreateErrorMessage;
	protected boolean m_bCreateStatus;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IModel#CleanupTempData()
	 */
	public void CleanupTempData()
	{
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IModel#CleanupAllData()
	 */
	public void CleanupAllData()
	{
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SendInvitationModel();
	}

	/**
	 * Implement some code to execute when the user clicks on "Finish".
	 *
	 */
	public void Finish()
	{
	}

	/**
	 * Returns the Create Code Statue.
	 *
	 * @return boolean
	 */
	public boolean GetCreateCodeStatus()
	{
		return m_bCreateStatus;
	}

	/**
	 * Returns the Create Error Message.
	 *
	 * @return String
	 */
	public String GetCreateErrorMessage()
	{
		return m_sCreateErrorMessage;
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the Redirect object
	 * (this is were we need to go at the end).
	 * This is going to the previous AS
	 *
	 * @return Redirect
	 */
	public Redirect GetRedirectAfterFinish()
	{
		Redirect result = new Redirect();

		// JF- If the parent space is already in the cache, we redirect to it.
		if (null != m_asOwner.GetParentSpace())
		{
			result.SetLinkGetCachedSpace(m_asOwner.GetParentSpace());
		}

		// JF- If not, we redirect to a new one.
		else
		{
			result.SetLinkCreateNewSpace(m_asOwner.GetParentSpaceName(), m_asOwner);
		}

		return (result);
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public XPDateTime GetTodaysDate()
	{
		return new XPDateTime();
	}

	/**
	 * Inits the Model with the IPTSession.
	 *
	 * @param parent
	 */
	public void Init(AActivitySpace parent)
	{
		m_asOwner     = parent;

		// JF- Get the Session object from the associated AS.
		m_Session = (IPTSession) m_asOwner.GetUserSession();
	}

	/**
	 * Calls the right save function according to the page name passed in argument.
	 *
	 * @param _sPageName
	 * @param _htFormData
	 * @return int Page status for server side validation
	 */
	public int SavePage(String _sPageName, XPHashtable _htFormData)
	{
		return ((InvCodesListModel) m_asOwner.GetModel(InvCodesListModel.STR_MVC_CLASS_NAME)).SaveSection(_htFormData);
	}

	/**
	 * Sets the Create Code Statue.
	 *
	 * @param _bStatus
	 */
	public void SetCreateCodeStatus(boolean _bStatus)
	{
		m_bCreateStatus = _bStatus;
	}

	/**
	 * Sets the Create Error Message.
	 *
	 * @param _sErrorMessage
	 */
	public void SetCreateErrorMessage(String _sErrorMessage)
	{
		m_sCreateErrorMessage = _sErrorMessage;
	}
}

