package com.plumtree.portalpages.admin.serversettings;

import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.web.*;

/**
 * @author SudhaS
 */
public class ServerSettingsModel implements IServerSettingsModel,
	IServerSettingsModelRO
{
	
	public static final String STR_MVC_CLASS_NAME = "ServerSettings";
	private AActivitySpace m_asasParent;
	private IPTSession m_ptSession;
	private String m_strData = "Portal Utilities";
	private Object[] settings;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IModel#CleanupTempData()
	 */
	public void CleanupTempData()
	{
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IModel#CleanupAllData()
	 */
	public void CleanupAllData()
	{
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new ServerSettingsModel();
	}

	/**
	 * Read Only methods from IServerSettingsModelRO
	 */
	/**
	 * @see com.plumtree.portalpagessample.ServerSettings.IServerSettingsModelRO#getString()
	 */
	public String GetData()
	{
		// Methods like this are where you return data to your Section to be displayed.
		return m_strData;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IModelRO#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public Object[] GetServerSettings()
	{
		return settings;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IModel#Init(IActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		m_asasParent     = parent;
		m_ptSession		 = (IPTSession) parent.GetUserSession();

		IApplication application = ApplicationManager.GetInstance()
			.GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		settings		 = (Object[]) application.GetCachingManager().GetEntry("DisplayServerSettings");
	}

	/**
	 * Write methods for Hello World Model from IServerSettingsModel
	 */
	/**
	 * Set method for Hello World data
	 */
	public void SetData(String value)
	{
		// Methods like this are how your Controls perform actions on your Models.
		m_strData = value;
	}
}

