package com.plumtree.portalpages.admin.serversettings.auditmanager;

import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 *
 * @version $Revision$
 * @author $author$
 */
public class AuditManagerDP extends EditorDP {
	
	public static final String STR_MVC_CLASS_NAME = "AuditManager";

	/**
	 * The date-picker needs to print some stuff before the form.
	 *
	 * @return HTMLElementCollection
	 */
	public HTMLElementCollection DisplayHTMLBeforeForm()
	{
		IAuditManagerModelRO ptROModel = (IAuditManagerModelRO) m_asOwner.GetModel(AuditManagerModel.STR_MVC_CLASS_NAME);
		return ptROModel.GetDatePickerControlManager(AuditManagerModel.N_DATE_PICKER_PAGE_TYPE_MESSAGES).GetPagePreFormContent();
	}

	/**
	 * Returns the HTML that is placed in the HEAD section of this HTML page.
	 *
	 * @return HTMLElement
	 */
	public HTMLElementCollection DisplayHTMLinHEAD()
	{
		IAuditManagerModelRO ptROModel = (IAuditManagerModelRO) m_asOwner.GetModel(AuditManagerModel.STR_MVC_CLASS_NAME);
		return ptROModel.GetDatePickerControlManager(AuditManagerModel.N_DATE_PICKER_PAGE_TYPE_MESSAGES).GetJSIncludes();
	}

	/**
	 * Returns the String to display on the left navigation menu,  linking to
	 * that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString() {
		// ***CHANGE_HERE*** Returns the String to display on the left navigation menu, 
		//       linking to that page.
		// ***COMMENT_1*** That String will also be printed out in the page header, so
		//     even if you don't use the left nav menu, it should still return something.
		return (m_asOwner.GetString(1613, "ptmsgs_portaladminmsgs"));
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader()
	{
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(1639, "ptmsgs_portaladminmsgs"),
			this.m_asOwner);
	}

	// Strings to localize.
	// ***CHANGE_HERE*** List of the Strings that need to be localized.
	// ***COMMENT_1*** The names should all start with "_ui_".

	/**
	 * Localized String: Expandable Lists
	 * @return 
	 */

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for that Page.
	 *
	 * @return HTMLElement
	 *
	 * @throws HTMLException
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		// ***CHANGE_HERE SELECTPTOBJECT*** Display the list.
		//views.AddInnerHTMLElement(((EditorView)
		//	m_asOwner.GetView(AuditManagerEditorAS.m_strStorageSelectPTObject)).Display());
		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(MessageTypesView.STR_MVC_CLASS_NAME))
				.Display());

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(ArchivingAgentView.STR_MVC_CLASS_NAME))
				.Display());

		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(MessageDeleteView.STR_MVC_CLASS_NAME))
				.Display());

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 *
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		// ***CHANGE_HERE GROWABLELIST*** Display JavaScripts for the Growable Array.
		//myScripts.AddInnerHTMLElement(m_asOwner.GetView(AuditManagerEditorAS.m_strStorageGrowableList).DisplayJavascript());
		// ***CHANGE_HERE SELECTPTOBJECT*** Display JavaScripts for the Select PTObject list.
		//myScripts.AddInnerHTMLElement(m_asOwner.GetView(AuditManagerEditorAS.m_strStorageSelectPTObject).DisplayJavascript());
		return myScripts;
	}
}

