package com.plumtree.portalpages.admin.serversettings.auditmanager;


// Framework Imports
import com.plumtree.uiinfrastructure.editor.*;

/**
 * This is the RepostControl class for the Audit manager. It handles the Repost
 * actions for that Editor.
 *
 * @author JohnH
 */

public class AuditManagerRepostControl extends EditorRepostControl
{
	/** The unique identifier for the class */
	public static final String STR_MVC_CLASS_NAME = "AuditManagerRepost";

	/** Post query result to previous page */
	public final static int POSTTOSELF_ACTION_PREVIOUS = 10;

	/** Post query result to next page */
	public final static int POSTTOSELF_ACTION_NEXT = 11;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new AuditManagerRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Switch between the action modes and call
	 * the associated method for each action.
	 *
	 * @param _nAction
	 */
	protected void PerformAction(int _nAction)
	{
		super.PerformAction(_nAction);

		switch (_nAction)
		{
		case POSTTOSELF_ACTION_PREVIOUS:

			((AuditManagerModel) m_model).RepostQueryResultPageOnPrevious();

			break;

		case POSTTOSELF_ACTION_NEXT:

			((AuditManagerModel) m_model).RepostQueryResultPageOnNext();

			break;
		}

	}
}

