package com.plumtree.portalpages.admin.serversettings.auditmanager;


// Plumtree Server
import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.login.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.arraywrapper.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This class implements the Audit Query Results view for the Audit Query
 * Central part of the Audit Manager
 * 
 * @author ErickS
 *
 */
public class AuditQueryResultView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.serversettings.auditmanager.AuditQueryResultView");

	/** The unique identifier for this class */
	public static final String STR_MVC_CLASS_NAME = "AuditQueryResultView";

	
	/** Previous button */
	public static final String HTMLBUTTON_PREVIOUS = "in_bu_previous";

	/** Next button */
	public static final String HTMLBUTTON_NEXT = "in_bu_next";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new AuditQueryResultView();
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTableCell myCell;
		HTMLTableRow myRow;
		HTMLSpan mySpan;
		HTMLInput myInput;

		try
		{
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						1371, "ptmsgs_portaladminmsgs")));

			HTMLTable myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetBorder("1");
			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("2");
			myTable.SetCellSpacing("2");

			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.LIST_SORT_HEADER_BG);

			// Item Type cell
			myCell = new HTMLTableCell();
			myCell.SetHeight("20");
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1374,
					"ptmsgs_portaladminmsgs"));

			// Item Name cell
			myCell = new HTMLTableCell();
			myCell.SetHeight("20");
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1375,
					"ptmsgs_portaladminmsgs"));

			// User Name cell
			myCell = new HTMLTableCell();
			myCell.SetHeight("20");
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1376,
					"ptmsgs_portaladminmsgs"));

			// Server Name cell
			myCell = new HTMLTableCell();
			myCell.SetHeight("20");
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1377,
					"ptmsgs_portaladminmsgs"));

			// Message Type cell
			myCell = new HTMLTableCell();
			myCell.SetHeight("20");
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1378,
					"ptmsgs_portaladminmsgs"));

			// Time cell
			myCell = new HTMLTableCell();
			myCell.SetHeight("20");
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1379,
					"ptmsgs_portaladminmsgs"));

			// Message cell
			myCell = new HTMLTableCell();
			myCell.SetHeight("20");
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1380,
					"ptmsgs_portaladminmsgs"));

			// Add the other rows
			HTMLElementCollection myRows = null;
			myRows = PrintRowsAsTable(((IAuditManagerModelRO) m_model).GetAuditMessages());

			if (null != myRows)
			{
				myTable.AddInnerHTMLElement(myRows);
			}

			// Now create a new table for the Previous and Next buttons
			myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetBorder("1");
			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("5");
			myTable.SetCellSpacing("0");

			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_TEXT);

			int intPrevMsgNum = ((IAuditManagerModelRO) m_model).GetSkipMessages() -
				((IAuditManagerModelRO) m_model).GetResultsPerPage();

			// Previous button
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetWidth("50%");
			myCell.SetAlign(CommonHTMLStrings.RIGHT);

			//myCell.SetColSpan("2");
			if (intPrevMsgNum >= 0)
			{
				// ***Repost Action*** begins here
				myInput = new HTMLInput(HTMLInputTypes.BUTTON,
						HTMLBUTTON_PREVIOUS,
						m_asOwner.GetString(1382, "ptmsgs_portaladminmsgs"));
				myCell.AddInnerHTMLElement(myInput);

				myInput.SetValue(m_asOwner.GetString(1381,
						"ptmsgs_portaladminmsgs"));
				myInput.SetStyleClass(PTStyleClass.FORM_EDITOR_BTN_TEXT);
				myInput.SetOnClick(AFormDP.JAVASCRIPT_SUBMIT_FORM + "(" +
					AuditManagerRepostControl.POSTTOSELF_ACTION_PREVIOUS +
					");");
				myInput.SetSize(20);

				// ***Repost Action*** ends here	
			}

			// Next button
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetWidth("50%");
			myCell.SetAlign(CommonHTMLStrings.LEFT);

			//myCell.SetColSpan("2");
			if (((IAuditManagerModelRO) m_model).GetQueryCount() >= (((IAuditManagerModelRO) m_model).GetResultsPerPage() +
					1))
			{
				// ***Repost Action*** begins here
				myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_NEXT,
						m_asOwner.GetString(1384, "ptmsgs_portaladminmsgs"));
				myCell.AddInnerHTMLElement(myInput);

				myInput.SetValue(m_asOwner.GetString(1383,
						"ptmsgs_portaladminmsgs"));
				myInput.SetStyleClass(PTStyleClass.FORM_EDITOR_BTN_TEXT);
				myInput.SetOnClick(AFormDP.JAVASCRIPT_SUBMIT_FORM + "(" +
					AuditManagerRepostControl.POSTTOSELF_ACTION_NEXT +
					");");
				myInput.SetSize(20);

				// ***Repost Action*** ends here
			}
		}
		catch (Exception e)
		{
			
				log.Error(e, "AuditQueryResultsView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(1372,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @param arrRows 
	 *
	 * @return 
	 */
	public HTMLElementCollection PrintRowsAsTable(PTSortedArrayWrapper arrRows)
	{
		HTMLElementCollection result = null;
		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLSpan mySpan;

		if (null != arrRows)
		{
			int intRowCount = arrRows.GetCount();

			if (0 != intRowCount)
			{
				result = new HTMLElementCollection();
			}

			try
			{
				for (int k = 0; k < intRowCount; k++)
				{
					//row begin
					myRow = new HTMLTableRow();
					result.AddInnerHTMLElement(myRow);

					if ((k % 2) == 1)
					{
						myRow.SetStyleClass(PTStyleClass.LIST_ITEM_ONE_BG);
					}
					else
					{
						myRow.SetStyleClass(PTStyleClass.LIST_ITEM_TWO_BG);
					}

					//Item Type cell
					myCell = new HTMLTableCell();
					myRow.AddInnerHTMLElement(myCell);
					myCell.SetHeight("20");
					myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
					mySpan = new HTMLSpan();
					mySpan.SetStyleClass(PTStyleClass.LIST_TEXT);
					mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(
							(String) arrRows.GetItem(k,
								PT_PROPIDS.PT_PROPID_AUDIT_CLASSNAME)));
					myCell.AddInnerHTMLElement(mySpan);

					//Item Name cell
					myCell = new HTMLTableCell();
					myRow.AddInnerHTMLElement(myCell);
					myCell.SetHeight("20");
					myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
					mySpan = new HTMLSpan();
					mySpan.SetStyleClass(PTStyleClass.LIST_TEXT);
					mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(
							(String) arrRows.GetItem(k,
								PT_PROPIDS.PT_PROPID_AUDIT_OBJECTNAME)));
					myCell.AddInnerHTMLElement(mySpan);

					//User Name cell
					myCell = new HTMLTableCell();
					myRow.AddInnerHTMLElement(myCell);
					myCell.SetHeight("20");
					myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
					mySpan = new HTMLSpan();
					mySpan.SetStyleClass(PTStyleClass.LIST_TEXT);
					mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(
							(String) arrRows.GetItem(k,
								PT_PROPIDS.PT_PROPID_AUDIT_USERNAME)));
					myCell.AddInnerHTMLElement(mySpan);

					//Server Name cell
					myCell = new HTMLTableCell();
					myRow.AddInnerHTMLElement(myCell);
					myCell.SetHeight("20");
					myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
					mySpan = new HTMLSpan();
					mySpan.SetStyleClass(PTStyleClass.LIST_TEXT);
					mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(
							(String) arrRows.GetItem(k,
								PT_PROPIDS.PT_PROPID_AUDIT_SERVERNAME)));
					myCell.AddInnerHTMLElement(mySpan);

					//Message Type cell
					myCell = new HTMLTableCell();
					myRow.AddInnerHTMLElement(myCell);
					myCell.SetHeight("20");
					myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
					mySpan = new HTMLSpan();
					mySpan.SetStyleClass(PTStyleClass.LIST_TEXT);

					int iMessageType = XPConvert.ToInteger(arrRows.GetItem(k,
							PT_PROPIDS.PT_PROPID_AUDIT_MSGTYPE));					
					mySpan.AddInnerHTMLString(((IAuditManagerModelRO) m_model).
						GetMessageTypeAsString(iMessageType));
					myCell.AddInnerHTMLElement(mySpan);

					//Time cell
					myCell = new HTMLTableCell();
					myRow.AddInnerHTMLElement(myCell);
					myCell.SetHeight("20");
					myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
					mySpan = new HTMLSpan();
					mySpan.SetStyleClass(PTStyleClass.LIST_TEXT);

					XPDateTime dtMessageTime = (XPDateTime) arrRows.GetItem(k,
							PT_PROPIDS.PT_PROPID_AUDIT_MSGTIME);
					XPDateFormat xpDateFormat =
							   PTPersonalSettingsHelper.GetPersonalDateTimeFormat(m_asOwner,
																				  /* portal server time */ false);
					mySpan.AddInnerHTMLString(xpDateFormat.Format(dtMessageTime));
					myCell.AddInnerHTMLElement(mySpan);

					//Message cell
					myCell = new HTMLTableCell();
					myRow.AddInnerHTMLElement(myCell);
					myCell.SetHeight("20");
					myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
					mySpan = new HTMLSpan();
					mySpan.SetStyleClass(PTStyleClass.LIST_TEXT);
					mySpan.AddInnerHTMLString(XPHttpUtility.HtmlEncode(
							(String) arrRows.GetItem(k,
								PT_PROPIDS.PT_PROPID_AUDIT_MSGCONTENT)));
					myCell.AddInnerHTMLElement(mySpan);

					//Row End						
				}
			}
			catch (Exception e)
			{
				
					log.Error(e, "AuditQueryResultView::PrintRowsAsTable The following error occured when trying to display the HTML: " +
						e.getMessage());
				

				throw new XPException(m_asOwner.GetString(1373,
						"ptmsgs_portaladminmsgs"), e);
			}
		}

		return result;
	}
}

