package com.plumtree.portalpages.admin.serversettings.auditmanager;


// Plumtree Server Imports
import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 *
 */
public class MessageTypesView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.serversettings.auditmanager.MessageTypesView");

	
	public static final String STR_MVC_CLASS_NAME = "MessageTypesView";

	// HTML Object names.
	// ***CHANGE_HERE*** Declare some constans for each 
	//        HTML object you are using in the display method
	// ***COMMENT_1*** You should follow the HTMLElements naming standards:
	//       <select> starts with in_se
	//       <input button> starts with in_bu
	//       <input text> starts with in_tx
	//       <input checkbox> starts with in_cb
	//       <input radio> starts with in_ra
	//       <textarea> starts with in_ta

	
	public static final String HTMLCHECKBOX_ITEM_CHANGE			 = "in_cb_ItemChange";

	
	public static final String HTMLCHECKBOX_ITEM_DELETION		 = "in_cb_ItemDeletion";

	
	public static final String HTMLCHECKBOX_LOCKED_ACCOUNT		 = "in_cb_LockedAccount";

	
	public static final String HTMLCHECKBOX_SECURITY_CHANGE		 = "in_cb_SecurityChange";

	
	public static final String HTMLCHECKBOX_USER_LOGIN			 = "in_cb_UserLogin";

	
	public static final String HTMLCHECKBOX_GLOBAL_SYSTEM_CHANGE = "in_cb_GlobalSystemChange";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new MessageTypesView();
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTableCell myCell;
		HTMLTableRow myRow;
		HTMLSpan mySpan;
		HTMLInput myInput;

		try
		{
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						1628, "ptmsgs_portaladminmsgs")));

			HTMLTable myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetBorder("1");
			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("5");
			myTable.SetCellSpacing("0");

			// Message Type start
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetWidth("30%");
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			myCell.SetVAlign("top");
			mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1630,
					"ptmsgs_portaladminmsgs"));

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);

			int iMessageTypeValue = ((IAuditManagerModelRO) m_model).GetMessageTypeValue();

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);

			myTable = new HTMLTable();
			myCell.AddInnerHTMLElement(myTable);

			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);

			// Item Change
			// ***<input checkbox>*** begins here
			myInput = new HTMLInput(HTMLInputTypes.CHECKBOX,
					HTMLCHECKBOX_ITEM_CHANGE, "");

			boolean bSetChecked = ((iMessageTypeValue &
				PT_AUDIT_TYPES.PT_AUDIT_OBJECT_CHANGE) == PT_AUDIT_TYPES.PT_AUDIT_OBJECT_CHANGE)
				? true : false;
			myInput.SetChecked(bSetChecked);
			myCell.AddInnerHTMLElement(myInput);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1631,
					"ptmsgs_portaladminmsgs"));

			// ***<input checkbox>*** ends here
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);

			// Security Change
			// ***<input checkbox>*** begins here
			myInput		    = new HTMLInput(HTMLInputTypes.CHECKBOX,
					HTMLCHECKBOX_SECURITY_CHANGE, "");
			bSetChecked     = ((iMessageTypeValue &
				PT_AUDIT_TYPES.PT_AUDIT_SECURITY_CHANGE) == PT_AUDIT_TYPES.PT_AUDIT_SECURITY_CHANGE)
				? true : false;
			myInput.SetChecked(bSetChecked);
			myCell.AddInnerHTMLElement(myInput);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1635,
					"ptmsgs_portaladminmsgs"));

			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);

			// Item Deletion
			// ***<input checkbox>*** begins here
			myInput		    = new HTMLInput(HTMLInputTypes.CHECKBOX,
					HTMLCHECKBOX_ITEM_DELETION, "");
			bSetChecked     = ((iMessageTypeValue &
				PT_AUDIT_TYPES.PT_AUDIT_OBJECT_DELETION) == PT_AUDIT_TYPES.PT_AUDIT_OBJECT_DELETION)
				? true : false;
			myInput.SetChecked(bSetChecked);
			myCell.AddInnerHTMLElement(myInput);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1632,
					"ptmsgs_portaladminmsgs"));

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);

			// User Login
			// ***<input checkbox>*** begins here
			myInput		    = new HTMLInput(HTMLInputTypes.CHECKBOX,
					HTMLCHECKBOX_USER_LOGIN, "");
			bSetChecked     = ((iMessageTypeValue &
				PT_AUDIT_TYPES.PT_AUDIT_LOGIN) == PT_AUDIT_TYPES.PT_AUDIT_LOGIN)
				? true : false;
			myInput.SetChecked(bSetChecked);
			myCell.AddInnerHTMLElement(myInput);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1633,
					"ptmsgs_portaladminmsgs"));

			// Start in a new row
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);

			// Locked Account
			// ***<input checkbox>*** begins here
			myInput		    = new HTMLInput(HTMLInputTypes.CHECKBOX,
					HTMLCHECKBOX_LOCKED_ACCOUNT, "");
			bSetChecked     = ((iMessageTypeValue &
				PT_AUDIT_TYPES.PT_AUDIT_LOCKED_ACCOUNT) == PT_AUDIT_TYPES.PT_AUDIT_LOCKED_ACCOUNT)
				? true : false;
			myInput.SetChecked(bSetChecked);
			myCell.AddInnerHTMLElement(myInput);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1634,
					"ptmsgs_portaladminmsgs"));

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);

			// Global System Change
			// ***<input checkbox>*** begins here
			myInput		    = new HTMLInput(HTMLInputTypes.CHECKBOX,
					HTMLCHECKBOX_GLOBAL_SYSTEM_CHANGE, "");
			bSetChecked     = ((iMessageTypeValue &
				PT_AUDIT_TYPES.PT_AUDIT_GLOBAL_CHANGE) == PT_AUDIT_TYPES.PT_AUDIT_GLOBAL_CHANGE)
				? true : false;
			myInput.SetChecked(bSetChecked);
			myCell.AddInnerHTMLElement(myInput);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1636,
					"ptmsgs_portaladminmsgs"));
		}
		catch (Exception e)
		{
			
				log.Error(e, "GroupsView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(1629,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}

