package com.plumtree.portalpages.admin.serversettings.auditmanager;


// Framework Imports
import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author ErickS
 *
 */
public class TimesDatesView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.serversettings.auditmanager.TimesDatesView");

	
	public static final String STR_MVC_CLASS_NAME = "TimesDatesView";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new TimesDatesView();
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTable myTable			 = new HTMLTable();

		HTMLTableCell myCell;
		HTMLTableRow myRow;
		HTMLSpan mySpan;

		try
		{
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						1427, "ptmsgs_portaladminmsgs")));
			result.AddInnerHTMLElement(myTable);
			myTable.SetBorder("1");
			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("5");
			myTable.SetCellSpacing("0");

			/* Time Interval row begin */
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			myCell.SetVAlign("TOP");
			mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1429,
					"ptmsgs_portaladminmsgs"));

			// Starting on cell begin
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);

			// create a new table
			myTable = new HTMLTable();
			myCell.AddInnerHTMLElement(myTable);

			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);

			// add the start label
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1430,
					"ptmsgs_portaladminmsgs"));

			// add the start date picker
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.AddInnerHTMLElement(((IAuditManagerModelRO) m_model).GetDatePickerControlManager(AuditManagerModel.N_DATE_PICKER_PAGE_TYPE_QUERY).GetComponentHTML(AuditManagerModel.STR_START_DATE_PICKER_UNIQUE_ID));			

			// Starting on cell end
			// Make a new row for Ending on stuff
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			// Ending on cell begin
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);

			// add the end label
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1431,
					"ptmsgs_portaladminmsgs"));

			// add the end date picker
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.AddInnerHTMLElement(((IAuditManagerModelRO) m_model).GetDatePickerControlManager(AuditManagerModel.N_DATE_PICKER_PAGE_TYPE_QUERY).GetComponentHTML(AuditManagerModel.STR_END_DATE_PICKER_UNIQUE_ID));
		}
		catch (Exception e)
		{
			
				log.Error(e, "TimesDatesView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(1428,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}

