package com.plumtree.portalpages.admin.serversettings.general;


// Framework Imports
import com.plumtree.uiinfrastructure.editor.*;

/**
 * 
 *
 * @author $author$
 */
public interface ISetServerSettingsModelRO extends IEditorModelRO
{
	/**
	 * 
	 *
	 * @return 
	 */
	public boolean GetAllowNumericAuthentication();

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean GetAutoAssignNumericID();


	/**
	 * 
	 *
	 * @return 
	 */
	public String GetDefaultLocale();

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetDefaultTimeZone();

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetDocumentDisplayURL();

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean GetEnableAccountLocking();

//	/**
//	 * 
//	 *
//	 * @return 
//	 */
//	public String GetIncomingSearchURL();


	/**
	 * 
	 *
	 * @return 
	 */
	public String GetSoapServerURL();

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetSharedFilesPath();


	/**
	 * 
	 *
	 * @return 
	 */
	public int GetMinutesToLockAccounts();

	/**
	 * 
	 *
	 * @return 
	 */
	public int GetMinutesToTrackFailedLogins();

	/**
	 * @return Whether or not there was an error on the MinutesToLockAccounts setting.
	 */
	public boolean HasMinutesToLockAccountsError();

	/**
	 * @return Whether or not there was an error on the MinutesToTrackFailedLogins setting.
	 */
	public boolean HasMinutesToTrackFailedLoginsError();

	/**
	 * 
	 *
	 * @return 
	 */
	public int GetNumberOfFailedLoginsAllowed();

	/**
	 * @return Whether or not there was an error on the NumberOfFailedLoginsAllowed setting.
	 */
	public boolean HasNumberOfFailedLoginsAllowedError();

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetPrimaryWebServerURL();

	/**
	 * 
	 *
	 * @return 
	 */
	public Object[] GetServerSettings();

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean GetAllowUserCreation();
	
	/**
	 * 
	 *
	 * @return 
	 */
	public boolean GetEnableSubportalRulesDebugMode();

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean GetEnablePortletErrorsDebugMode();

	/**
	 * @return The minimum password length.
	 */
	public int GetPasswordLength();

	/**
	 * @return whether or not there was an error in saving the minimum password length.
	 */
	public boolean HasPasswordLengthError();

	/**
	 * @return Whether or not numbers are required in the passwords.
	 */
	public boolean GetPasswordIncludeNumbers();

	/**
	 * @return Whether or not both upper and lower case letters are required in the passwords.
	 */
	public boolean GetPasswordIncludeCasing();

	/**
	 * @return Whether or not punctuation is required in the passwords.
	 */
	public boolean GetPasswordIncludePunctuation();

	/**
	 * @return Whether or not user IDs should be dissalowed in the passwords.
	 */
	public boolean GetPasswordNoUserIDs();

	/**
	 * @return The number of passwords to keep in history to check for reuse.
	 */
	public int GetPasswordReuseHistory();

	/**
	 * @return Whether or not there was an error in saving the number of passwords to keep in history to check for reuse.
	 */
	public boolean HasPasswordReuseHistoryError();

	/**
	 * @return The password expiration in days.
	 */
	public int GetPasswordExpiration();

	/**
	 * @return Whether or not there was an error in saving the password expiration in days.
	 */
	public boolean HasPasswordExpirationError();

	/**
	 * @return The password expiration warning in days.
	 */
	public int GetPasswordExpirationWarning();

	/**
	 * @return Whether or not there was an error in saving the password expiration warning in days.
	 */
	public boolean HasPasswordExpirationWarningError();
}