package com.plumtree.portalpages.admin.serversettings.general;


// Framework Imports
import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

// ***COMMENT_1*** Delete the comments prefixed by CHANGE_HERE and COMMENT
//       when you are done.
public class NumericAuthenticationView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.serversettings.general.NumericAuthenticationView");

	// ***COMMENT_1*** All the Views in Plumtree need to have a unique name.

	
	public static final String STR_MVC_CLASS_NAME = "NumericAuthenticationView";

	// HTML Object names.
	//        HTML object you are using in the display method
	// ***COMMENT_1*** You should follow the HTMLElements naming standards:
	//       <select> starts with in_se
	//       <input button> starts with in_bu
	//       <input text> starts with in_tx
	//       <input checkbox> starts with in_cb
	//       <input radio> starts with in_ra
	//       <textarea> starts with in_ta
	public static final String HTMLINPUT_PROP_NAME		  = "in_tx_Name";

	
	public static final String HTMLINPUT_PROP_DESCRIPTION = "in_ta_Description";

	
	public static final String HTMLBUTTON_REPOST = "in_bu_repost";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new NumericAuthenticationView();
	}

	/**
	 * Returns the HTML for the Section.
	 *
	 * @return HTMLElement
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		HTMLTable myTable;
		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLInput myInput;
		HTMLSpan mySpan;

		try
		{
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						1336, "ptmsgs_portaladminmsgs")));

			myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("5");
			myTable.SetCellSpacing("0");

			// 1st Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);
			myCell.SetWidth( "50%");
			
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1333,
					"ptmsgs_portaladminmsgs"));

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);
			myCell.SetAlign(CommonHTMLStrings.LEFT);
			myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);

			myInput = new HTMLInput(HTMLInputTypes.CHECKBOX_TYPE,
					SetServerSettingsRepostControl.PARAM_ALLOW_NUMERIC_LOGIN,
					SetServerSettingsRepostControl.PARAM_ALLOW_NUMERIC_LOGIN);

			if (((ISetServerSettingsModelRO) this.m_model).GetAllowNumericAuthentication())
			{
				myInput.SetChecked(true);
			}

			myCell.AddInnerHTMLElement(myInput);
			myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
			myInput.SetValue(XPConvert.ToString(true));

			// 1st Row end
			// 1st Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);

			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1334,
					"ptmsgs_portaladminmsgs"));

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);
			myCell.SetAlign(CommonHTMLStrings.LEFT);
			myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);

			myInput = new HTMLInput(HTMLInputTypes.CHECKBOX_TYPE,
					SetServerSettingsRepostControl.PARAM_AUTO_ASSIGN_IDS,
					SetServerSettingsRepostControl.PARAM_AUTO_ASSIGN_IDS);

			if (((ISetServerSettingsModelRO) this.m_model).GetAutoAssignNumericID())
			{
				myInput.SetChecked(true);
			}

			myCell.AddInnerHTMLElement(myInput);
			myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);

			myInput.SetValue(XPConvert.ToString(true));

			// 1st Row end
			HTMLComment myComment = new HTMLComment( "End: Display PropMainView");
			result.AddInnerHTMLElement(myComment);
		}
		catch (Exception e)
		{
			
				log.Error(e, "PropMainView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(1338,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	// ***CHANGE_HERE*** Update the class name below.

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}

