package com.plumtree.portalpages.admin.serversettings.general;

// Framework Imports
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This is class is used to print out together the Views for
 * the Advanced Settings page of the Property Editor.
 *
 * @author Julie Fournier
 */

// ***CHANGE_HERE*** Change the name of the class.
// ***COMMENT_1*** Delete the comments prefixed by CHANGE_HERE and COMMENT
//       when you are done.
public class PortalURLsDP extends EditorDP {
	// ***CHANGE_HERE*** Set the class name.
	// ***COMMENT_1*** All the DPs in your AS need to have a unique name.

	
	public static final String STR_MVC_CLASS_NAME = "PortalURLsDP";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString() {
		// ***CHANGE_HERE*** Returns the String to display on the left navigation menu, 
		//       linking to that page.
		return (m_asOwner.GetString(1340, "ptmsgs_portaladminmsgs"));
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader() {
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(1644, "ptmsgs_portaladminmsgs"),
			this.m_asOwner);
	}

	// Strings to localize.
	// ***CHANGE_HERE*** List of the Strings that need to be localized.
	// ***COMMENT_1*** The names should all start with "_ui_".

	/** Localized String: Property Type */

	// ***CHANGE_HERE*** If you want to customize the empty space on the left 
	//      and right sides of the content table, use the SetContentTableCellSpacing
	//      method as shown below. This is optional, the default value of the 
	//      framework is 15. If you set it to 0 the Views won't get indented.

	/*
	public PropAdvDP()
	{
	    super();
	    super.SetContentTableCellSpacing("0");
	}*/

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the Advanced Settings page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 *
	 * @return HTMLElement
	 * @throws HTMLException
	 */
	public HTMLElement PageDisplay() {
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		// ***CHANGE_HERE*** For each Section you want to display on that page, 
		//       copy the line below and change the name of the Section.
		views.AddInnerHTMLElement(
			((EditorView) m_asOwner.GetView(PortalURLsView.STR_MVC_CLASS_NAME))
				.Display());

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}
}

