package com.plumtree.portalpages.admin.serversettings.general;


// Plumtree Server Imports
import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 *
 * @author $author$
 */
public class PortalURLsView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.serversettings.general.PortalURLsView");

	// ***COMMENT_1*** All the Views in Plumtree need to have a unique name.

	
	public static final String STR_MVC_CLASS_NAME = "PortalURLsView";

	
	public static final String HTMLSELECT_PROP_TYPE = "in_se_PropType";

	
	public static final String HTMLBUTTON_REPOST   = "in_bu_repost";

	
	public static final String HTMLCHECKBOX_SAMPLE = "in_cb_sample";

	
	public static final String HTMLRADIO_SAMPLE = "in_ra_sample";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new PortalURLsView();
	}

	/**
	 * Returns the HTML for the Section.
	 *
	 * @return HTMLElement
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLInput myInput;
		HTMLSpan mySpan;

		try
		{
			
			
			
			//	PRIMARY WEB SERVER URL		
			
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						1341, "ptmsgs_portaladminmsgs")));

			HTMLTable myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("5");
			myTable.SetCellSpacing("0");

			// 1st Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);

			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1342,
					"ptmsgs_portaladminmsgs"));

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);
			myCell.SetAlign(CommonHTMLStrings.LEFT);
			myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);

			myInput = new HTMLInput(HTMLInputTypes.TEXT_TYPE,
					SetServerSettingsRepostControl.PARAM_PRIMARY_WEB_SERVER_URL,
					SetServerSettingsRepostControl.PARAM_PRIMARY_WEB_SERVER_URL);

			myInput.SetSize(50);
			myInput.SetValue(((ISetServerSettingsModelRO) this.m_model).GetPrimaryWebServerURL());

			myCell.AddInnerHTMLElement(myInput);
			myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);



			//	DISPLAY FILES URL


			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);

			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1343,
					"ptmsgs_portaladminmsgs"));

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);
			myCell.SetAlign(CommonHTMLStrings.LEFT);
			myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);

			myInput = new HTMLInput(HTMLInputTypes.TEXT_TYPE,
					SetServerSettingsRepostControl.PARAM_DISPLAY_FILES_URL,
					SetServerSettingsRepostControl.PARAM_DISPLAY_FILES_URL);

			myInput.SetSize(50);
			myInput.SetValue(((ISetServerSettingsModelRO) this.m_model).GetDocumentDisplayURL());

			myCell.AddInnerHTMLElement(myInput);
			myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);


//
//			//	FEDERATED SEARCH URL
//
//			myRow = new HTMLTableRow();
//			myTable.AddInnerHTMLElement(myRow);
//			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
//
//			myCell = new HTMLTableCell();
//			myRow.AddInnerHTMLElement(myCell);
//			myCell.SetNoWrap(true);
//
//			mySpan = new HTMLSpan();
//			myCell.AddInnerHTMLElement(mySpan);
//			mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);
//
//			mySpan.AddInnerHTMLString(m_asOwner.GetString(1344,
//					"ptmsgs_portaladminmsgs"));
//
//			myCell = new HTMLTableCell();
//			myRow.AddInnerHTMLElement(myCell);
//			myCell.SetNoWrap(true);
//			myCell.SetAlign(CommonHTMLStrings.LEFT);
//			myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
//
//			myInput = new HTMLInput(HTMLInputTypes.TEXT_TYPE,
//					SetServerSettingsRepostControl.PARAM_INCOMING_SEARCH_URL,
//					SetServerSettingsRepostControl.PARAM_INCOMING_SEARCH_URL);
//
//			myInput.SetSize(90);
//			myInput.SetValue(((ISetServerSettingsModelRO) this.m_model).GetIncomingSearchURL());
//			
//			
//			myCell.AddInnerHTMLElement(myInput);
//			myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
//
//




			//	SOAP SERVER URL

			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);

			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);


			
			mySpan.AddInnerHTMLString( this.m_asOwner.GetString( 2363, "ptmsgs_portaladminmsgs" ) );

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);
			myCell.SetAlign(CommonHTMLStrings.LEFT);
			myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);

			myInput = new HTMLInput(HTMLInputTypes.TEXT_TYPE,
					SetServerSettingsRepostControl.PARAM_SOAP_SERVER_URL,
					SetServerSettingsRepostControl.PARAM_SOAP_SERVER_URL);

			myInput.SetSize(50);
			myInput.SetValue(((ISetServerSettingsModelRO) this.m_model).GetSoapServerURL());
			
			
			myCell.AddInnerHTMLElement(myInput);
			myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);



			//	SHARED FILES URL

			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);

			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);


			
			mySpan.AddInnerHTMLString( this.m_asOwner.GetString( 2542, "ptmsgs_portaladminmsgs" ) );

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);
			myCell.SetAlign(CommonHTMLStrings.LEFT);
			myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);

			myInput = new HTMLInput(HTMLInputTypes.TEXT_TYPE,
					SetServerSettingsRepostControl.PARAM_SHARED_FILES_PATH,
					SetServerSettingsRepostControl.PARAM_SHARED_FILES_PATH);

			myInput.SetSize(50);
			myInput.SetValue(((ISetServerSettingsModelRO) this.m_model).GetSharedFilesPath());
			
			
			myCell.AddInnerHTMLElement(myInput);
			myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);





		}
		catch (Exception e)
		{
			
				log.Error(e, "PropAdvView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(1345,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}

