package com.plumtree.portalpages.admin.serversettings.general;

import com.plumtree.uiinfrastructure.editor.*;

/**
 * This class contains the additional repost actions.
 * The ones specific to the Server Settings Editor (other than
 * "change page", "finish" and "cancel" actions).
 *
 * @author Julie Fournier
 */
public class SetServerSettingsRepostControl extends EditorRepostControl
{	
	public static final String STR_MVC_CLASS_NAME = "SetServerSettingsRepostControl";

	
	public static final String PARAM_ALLOW_USER_CREATION		    = "in_cb_aucta";

	
	public static final String PARAM_ALLOW_NUMERIC_LOGIN		    = "in_cb_anli";

	
	public static final String PARAM_AUTO_ASSIGN_IDS			    = "in_cb_aaids";

	
	public static final String PARAM_ENABLE_ACCOUNT_LOCKING		    = "in_cb_eal";
	public static final String PARAM_MINUTES_TO_TRACK_FAILED_LOGINS = "in_tx_mttfl";
	public static final String PARAM_NUMBER_FAILURES_ALLOWED  = "in_tx_nfa";
	public static final String PARAM_MINUTES_TO_LOCK_ACCOUNTS = "in_tx_mtla";

	
	public static final String PARAM_DEFAULT_LOCALE   = "in_se_dl";
	public static final String PARAM_DEFAULT_TIMEZONE = "in_se_dtz";
	public static final String PARAM_DEFAULT_CHARSET = "in_se_dcs";

	
	public static final String PARAM_PRIMARY_WEB_SERVER_URL = "in_tx_pwsu";
	public static final String PARAM_DISPLAY_FILES_URL   = "in_tx_dfu";
	public static final String PARAM_INCOMING_SEARCH_URL = "in_tx_isu";
	public static final String PARAM_SOAP_SERVER_URL = "in_tx_ssu";

	public static final String PARAM_SHARED_FILES_PATH = "in_tx_sfp";
	
	public static final String PARAM_INVITE_CIPHER_KEY = "in_se_icky";
	
	public static final String PARAM_ENABLE_DEBUG_SUBPORTAL_RULES_MODE	= "in_cb_srdebugmode";
	public static final String PARAM_ENABLE_DEBUG_PORTLET_ERRORS_MODE   = "in_cb_pedebugmode";

	// These are the parameters for the password management section
	public static final String PARAM_PASSWORD_LENGTH = "in_tx_pw_length";
	public static final String PARAM_PASSWORD_INCLUDE_NUMBERS = "in_cb_pw_numbers";
	public static final String PARAM_PASSWORD_INCLUDE_CASING = "in_cb_pw_casing";
	public static final String PARAM_PASSWORD_INCLUDE_PUNCTUATION = "in_cb_pw_punctuation";
	public static final String PARAM_PASSWORD_NO_USER_IDS = "in_cb_pw_no_ids";
	public static final String PARAM_PASSWORD_REUSE_HISTORY = "in_tx_pw_reuse_history";
	public static final String PARAM_PASSWORD_EXPIRATION = "in_tx_pw_expiration";
	public static final String PARAM_PASSWORD_EXPIRATION_WARNING = "in_tx_pw_expiration_warning";

	public static final int POSTTOSELF_ACTION_UPDATE_KEY = 47;


	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SetServerSettingsRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Switch between the action modes and call
	 * the associated method for each action.
	 *
	 * @param _nAction
	 */
	protected void PerformAction(int _nAction)
	{
		switch(_nAction)
		{
			case POSTTOSELF_ACTION_UPDATE_KEY:
				((SetServerSettingsModel)m_model).UpdateLoginTokenKey();
				break;
			
			default:	
		
		}
		super.PerformAction(_nAction);
	}
}