package com.plumtree.portalpages.admin.serversettings.general;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.editors.webservice.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 *
 * @author DanaD
 */
public class UpdateLoginTokenKeyView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.serversettings.general.UpdateLoginTokenKeyView");


	
	public static final String STR_MVC_CLASS_NAME = "UpdateLoginTokenKeyView";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new UpdateLoginTokenKeyView();
	}
	

	/**
	 * Returns the HTML for the Section.
	 *
	 * @return HTMLElement
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		HTMLTable myTable;
		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLSpan mySpan;

		try
		{
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(2136, "ptmsgs_portaladminmsgs")));
			myTable = WSViewHelper.AddTable(result);
			myTable.SetCellPadding("5");
			myRow = WSViewHelper.AddRow(myTable);
			
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.SetVAlign(CommonHTMLStrings.TOP);
			myCell.SetColSpan(CommonHTMLStrings.FOUR);	
			myCell.SetHeight(CommonHTMLStrings.THREE);
			
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			mySpan.AddInnerHTMLString(m_asOwner.GetString(2964, "ptmsgs_portaladminmsgs"));
			
			myRow = WSViewHelper.AddRow(myTable);
			myCell = WSViewHelper.AddLabelCell(myRow, CommonHTMLStrings.ONE, m_asOwner.GetString(2135, "ptmsgs_portaladminmsgs"));
			myCell.SetWidth( "50%");
			myCell = WSViewHelper.AddCell(myRow, CommonHTMLStrings.ONE);
			
			// todo: add the invite crypto key here also
			
			String strOnClick = "postToSelf(" + XPConvert.ToString(SetServerSettingsRepostControl.POSTTOSELF_ACTION_UPDATE_KEY) + ")";
			
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement( myCell );
			myCell.SetWidth( "50%");
			myCell.AddInnerHTMLElement(WSViewHelper.MakeSimpleButton(m_asOwner.GetString(2134, "ptmsgs_portaladminmsgs"), strOnClick));
			WSViewHelper.AddSpacerCell(myRow, CommonHTMLStrings.ONE);
		}
		catch (Exception e)
		{
			// ***CHANGE_HERE*** Update the error messages (log and exception).
			
				log.Error(e, "UpdateLoginTokenKeyView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException("UpdateLoginTokenKeyView::Display The following error occured when trying to display the HTML: ", e);
		}

		return result;
	}

	// ***CHANGE_HERE*** Update the class name below.

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}

