package com.plumtree.portalpages.admin.serversettings.general;

import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 */
public class UserSettingsDP extends EditorDP
{
	public static final String STR_MVC_CLASS_NAME = "SetUserServerSettingsDP";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString() {
		return (m_asOwner.GetString(1348, "ptmsgs_portaladminmsgs"));
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader(){
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(2962, "ptmsgs_portaladminmsgs"),
			this.m_asOwner);
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the General Info page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 *
	 * @return HTMLElement
	 * @throws HTMLException
	 */
	public HTMLElement PageDisplay() {
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(NewUserCreationView.STR_MVC_CLASS_NAME))
				.Display());

		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(NumericAuthenticationView.STR_MVC_CLASS_NAME))
				.Display());

		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(AccountLockingView.STR_MVC_CLASS_NAME))
				.Display());

		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(PasswordRulesView.STR_MVC_CLASS_NAME))
				.Display());

		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		/* JHQ bug 25352: Doc Team says to remove this view because it is not
		 * accurate.  I will not delete the class, since we may change our mind
		 * in the future.  For now I'll just comment this out. */
//		 views.AddInnerHTMLElement(
//			((EditorView) m_asOwner
//				.GetView(DefaultLanguageSettingsView.STR_MVC_CLASS_NAME))
//				.Display());
//
//		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(UpdateLoginTokenKeyView.STR_MVC_CLASS_NAME))
				.Display());

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}
}