package com.plumtree.portalpages.admin.serversettings.globalaclsyncmap;


// Framework Imports
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.expandablelist.*;

/**
 * This class contains the additional repost actions.
 * The ones specific to the Misc Editor (other than
 * "change page", "finish" and "cancel" actions).
 *
 * @author JohnH
 */
public class GlobalACLSyncMapRepostControl extends EditorRepostControl
{
	
	public static final String STR_MVC_CLASS_NAME = "GlobalACLSyncMapRepost";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new GlobalACLSyncMapRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Switch between the action modes and call
	 * the associated method for each action.
	 *
	 * @param int
	 */
	protected void PerformAction(int _nAction)
	{
		super.PerformAction(_nAction);

		//Domain map
		((ExpListControl) m_asOwner.GetControl(GlobalACLSyncMapAS.STR_MVC_STORAGE_NAME_DOMAIN_PLUG_IN)).PerformRepostAction(_nAction,
			m_htFormData);

		//Group map
		((ExpListControl) m_asOwner.GetControl(GlobalACLSyncMapAS.STR_MVC_STORAGE_NAME_GROUP_PLUG_IN)).PerformRepostAction(_nAction,
			m_htFormData);

		switch (_nAction)
		{
		}
	}
}

