package com.plumtree.portalpages.admin.serversettings.objectpropertymap.plugin;

import com.plumtree.uiinfrastructure.expandablelist.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This interface is implemented by the Model. It contains all the read-only
 * mothods of the Model accessed by the Views.
 *
 * @author josephc
 */
public interface IObjPropMapPluginModelRO extends IExpListModelRO
{
	/**
	 * Returns the class icon
	 *
	 * @param _nRowIndex Row index
	 *
	 * @return Icon for class
	 */
	public HTMLImg GetClassIcon(int _nRowIndex);

	/**
	 * Returns array of property names and descriptions.
	 *
	 * @param _nRowIndex Row index
	 *
	 * @return Array of property names and descriptions
	 */
	public String[][] GetPropertyInfo(int _nRowIndex);

	/**
	 * Returns a String of Class IDs and Object IDs of the Objects  to select
	 * in the tree. E.g.: "propertyClassID,ObjID1,propertyClassID,objID2".  In
	 * our case, propertyClassID is the classID for properties.
	 *
	 * @param _nRowIndex Row index
	 *
	 * @return String
	 */
	public String GetSelectedItems(int _nRowIndex);
}

