package com.plumtree.portalpages.admin.serversettings.search;

import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.openfoundation.util.IXPList;
/**
 * @author MatthewF
 */
public interface ISearchServerTuningEditorModelRO extends IEditorModelRO
{
	/* Best bet related view elements */
	public boolean GetIsShowAllBestBets();
	public String GetBestBetSearchString();
	public int GetNumBestBetsAskedFor();
	public int GetNumBestBetsOnPage();
	public int GetBestBetStartCount();
	public boolean GetShowPreviousBestBet();
	public boolean GetShowNextBestBet();
	public int GetTotalBestBetCount();
	public int GetNumDeletedBestBets();
	public int GetNumAddedBestBets();
	public boolean CheckDuplicateBestBetQuery(String originalTrigger, String strTrigger, boolean bNewlyAdded);
	// This isn't a read only call!
	public void UpdateBestBetFromSubEditor(String originalTrigger, boolean bModifiedBBWasFromDB, String strTrigger, String setup, IXPList arrTargets /* IPTBestBetTarget */);
	public String GetBestBetTrigger(int i);
	public String GetBestBetSetupString(int i);
	// This used to be 3 calls to get id, target & name.
	public IXPList GetBestBetTargets(int i);
	public boolean HasBestBetBeenDeleted(int i);
	public boolean HasBestBetBeenNewlyAdded(int i);

	/* Alias related view elements */
	/**
	 * @return set of AliasElement objects defining terms of banner field alias.
	 */
	public Object[] GetCurrentAliasElements();
	
	/**
	 * Returns true if a sufficient number of terms (1) would be left after the delete.
	 * 
	 * @param number of terms to delete
	 * @return
	 */
	public boolean OkToDeleteThisManyAliasTerms(int number);
	
	/**
	 * Restore banner search field alias to default value.
	 */
	public void RestoreDefaultFieldAlias();
	
	/**
	 * @return true if thesaurus usage is on.
	 */
	public boolean GetThesaurusOn();
	
	/**
	 * Set thesaurus usage on if tf is true.
	 * 
	 * @param tf
	 */
	public void SetThesaurusOn(boolean tf);
	
	/**
	 * @return true if spell checking is on.
	 */
	public boolean GetSpellCheckOn();

	/**
	 * Set spell checking on if tf is true.
	 * 
	 * @param tf
	 */
	public void SetSpellCheckOn(boolean tf);

}

