package com.plumtree.portalpages.admin.serversettings.search;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.editor.*;

/**
 * @author OlegS
 */
public class SearchServerSettingsEditorRepostControl extends EditorRepostControl
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.admin.serversettings.search.SearchServerSettingsEditorRepostControl");

	
	public static final String STR_MVC_CLASS_NAME = "SearchServerSettingsEditorRepost";

	public final static int POSTTOSELF_ACTION_MISC		 = 10;
	
	public final static int POSTTOSELF_ACTION_IS_DEL_ROWS = 41; 

	public final static int POSTTOSELF_ACTION_IS_ADD_TYPE = 61;
	
	public final static int POSTTOSELF_ACTION_OPEN_POPUP = 71;
	
	// HTML object names.
	
	public static final String HTMLINPUT_ADD				  = "in_bu_add";
	
	public static final String HTMLINPUT_DELETE				  = "in_bu_delete";
	
	public static final String HTMLINPUT_SELECTED_ITEM		  = "in_cb_selected";
	
	public static final String HTMLINPUT_IS_SELECTED_ITEM     = "in_cb_is_selected";
	
	public static final String HTMLINPUT_HIDDEN_SELECTED_ITEM = "in_hi_selected";

	private static final String TRUE = "true";
	
	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SearchServerSettingsEditorRepostControl();
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @param _nAction 
	 */
	protected void PerformAction(int _nAction)
	{
		super.PerformAction(_nAction);

		switch (_nAction)
		{
    		case POSTTOSELF_ACTION_APPLY_CHANGES:
				((SearchServerSettingsEditorModel) m_model).DoApplyChanges();
     			break;

			case POSTTOSELF_ACTION_MISC:
				((SearchServerSettingsEditorModel) m_model).ActionOnRepost();
	
				break;
	
			case POSTTOSELF_ACTION_IS_ADD_TYPE:
				if(m_htFormData.ContainsKey(IndexingStatusPopUpView.CHECKBOX_ADD_ALL) && IsTrue((String[])m_htFormData.GetElement(IndexingStatusPopUpView.CHECKBOX_ADD_ALL)))
				{
					((SearchServerSettingsEditorModel) m_model).AddAllUnusedISTypes();
	
				}
				else if (m_htFormData.ContainsKey(IndexingStatusPopUpView.SELECT_NAME))
				{
					String[] item = (String[]) m_htFormData.GetElement(IndexingStatusPopUpView.SELECT_NAME);
		
					for (int j = 0; j < item.length; j++)
					{
						int itemId = -1;
		
						try
						{
							itemId = XPConvert.ToInteger(item[j]);
						}
						catch (Exception e)
						{
							throw XPException.GetInstance(e);
						}
		
						if (itemId >= 0)
						{
							
								log.Error("Got POSTTOSELF_ACTION_IS_ADD_TYPE : " +
									itemId);
							
	
							((SearchServerSettingsEditorModel) m_model).AddTypeToIndexingStatus(itemId);
						}
					}
				}
	
				break;
			case POSTTOSELF_ACTION_IS_DEL_ROWS:
				if (m_htFormData.ContainsKey(IndexingStatusView.CB_CHECK_ONE))
				{
					String[] item = (String[]) m_htFormData.GetElement(IndexingStatusView.CB_CHECK_ONE);
		
					for (int j = 0; j < item.length; j++)
					{
						int itemId = -1;
		
						try
						{
							itemId = XPConvert.ToInteger(item[j]);
						}
						catch (Exception e)
						{
							throw XPException.GetInstance(e);
						}
		
						if (itemId >= 0)
						{
							((SearchServerSettingsEditorModel) m_model).DeleteTypeFromIndexingStatus(itemId);
						}
					}
				}

				break;
			default:
				break;
		}
	}
	
	protected boolean IsTrue(String[] vals)
	{
		if(vals == null)
			return false;
		for(int i = 0; i < vals.length; i++)
		{
			if(TRUE.equals(vals[i]))
				return true;
		}
		return false;
	}
}

