package com.plumtree.portalpages.admin.serversettings.search;

import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author MatthewF
 */
public class ThesaurusSettingsDP extends EditorDP {
	
	public static final String STR_MVC_CLASS_NAME = "ThesaurusSettings";
	
	public String GetLeftNavString() {
		return m_asOwner.GetString(2558, "ptmsgs_portaladminmsgs");
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader()
	{
		return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(2575, "ptmsgs_portaladminmsgs"), this.m_asOwner);
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	public HTMLElement PageDisplay() {
		HTMLElementCollection result = new HTMLElementCollection();
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();
		views.AddInnerHTMLElement(
			((EditorView) (m_asOwner
				.GetView(ThesaurusSettingsView.STR_MVC_CLASS_NAME)))
				.Display());

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	 * 
	 *
	 * @return 
	 *
	 * @throws HTMLException 
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();
		myScripts.AddInnerHTMLElement(
			m_asOwner
				.GetView(ThesaurusSettingsView.STR_MVC_CLASS_NAME)
				.DisplayJavascript());

		return myScripts;
	}
}

