package com.plumtree.portalpages.admin.serversettings.settings;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.portalpages.admin.serversettings.*;
import com.plumtree.portalpages.admin.serversettings.auditmanager.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.web.*;

/**
 * @author ErickS
 *
 */
public class AuditManagerServerSetting implements IServerSettings
{
	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASControlName()
	{
		return EditorStartControl.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASDPName()
	{
		return null;
	}

	// Strings to localize.

	/**
	 * Return the name of the Editor framework activity space
	 * for this settings class.
	 */
	public String GetASName()
	{
		return AuditManagerEditorAS.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASQueryString()
	{
		return "&" + EditorStartControl.QS_EDITOR_TYPE + "=" +
		EditorStartControl.EDITOR_START_FLAG_MISC;
	}

	/**
	 * 
	 *
	 * @param _strLangID 
	 *
	 * @return 
	 */
	public String GetLinkText(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance()
			.GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm     = (XPResourceManager) application.GetCachingManager()
			.GetEntry("ResourceManager");

		return rm.GetString(1637, "ptmsgs_portaladminmsgs", _strLangID); //_ui_LinkText
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetLinkURL()
	{
		return null;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean IsStandardPortalOption()
	{
		return true;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean IsViewable()
	{
		return true;
	}
}

