package com.plumtree.portalpages.admin.serversettings.settings;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.portalpages.admin.editors.doctypemap.*;
import com.plumtree.portalpages.admin.serversettings.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.web.*;

/**
 * @author SudhaS
 *
 * This class causes the Localized Strings link to show up in the
 * Plumtree Utilities menu.
 *
 */
public class GbDocTypeMapServerSetting implements IServerSettings
{
	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASControlName()
	{
		return EditorStartControl.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASDPName()
	{
		//return GbDocTypeMainDP.STR_MVC_CLASS_NAME;
		return null;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASName()
	{
		return GbDocTypeEditorAS.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASQueryString()
	{
		String strControl  = "&" + EditorStartControl.QS_EDITOR_TYPE + "=" +
			EditorStartControl.EDITOR_START_FLAG_MISC;
		String strObjectID = "&globalObjectID=1";

		String strQuery = strControl + strObjectID;

		return strQuery;
	}

	//@todo add class name to Plumtree Utilities XML file

	
	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#GetLinkText()
	 */
	public String GetLinkText(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance()
			.GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm     = (XPResourceManager) application.GetCachingManager()
			.GetEntry("ResourceManager");

		return rm.GetString(1602, "ptmsgs_portaladminmsgs", _strLangID);
	}

	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#IsStandardPortalOption()
	 */
	public boolean IsStandardPortalOption()
	{
		return true;
	}

	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#IsViewable()
	 */
	public boolean IsViewable()
	{
		return true;
	}
}

