package com.plumtree.portalpages.admin.serversettings.settings;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.admin.editors.propertymap.*;
import com.plumtree.portalpages.admin.serversettings.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.web.*;


/**
 * 
 *
 * @version 5.0
 * @author MikeSample
 */
public class GbPropMapServerSetting implements IServerSettings
{

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASControlName()
	{
		return EditorStartControl.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASDPName()
	{
		return null;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASName()
	{
		return PropertyMapEditorAS.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASQueryString()
	{
		String strQuery = "&" + EditorStartControl.QS_EDITOR_TYPE + "=" +
			EditorStartControl.EDITOR_START_FLAG_MISC;
		strQuery += ("&globalObjectID=" +
		XPConvert.ToString(PT_GLOBALOBJECTS.PT_GLOBAL_PROPERTYMAP));

		return strQuery;
	}

	//Return link text
	public String GetLinkText(String _strLangID)
	{

		IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
		return (rm.GetString(2008, "ptmsgs_portaladminmsgs", _strLangID));
	}

	//Describes whether the setting comes with the standard portal
	public boolean IsStandardPortalOption()
	{
		return (true);
	}

	//Describes whether the setting is currently viewable
	public boolean IsViewable()
	{
		return (true);
	}

	//public HTMLElement GetHTMLElement();
}

