package com.plumtree.portalpages.admin.serversettings.settings;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.portalpages.admin.serversettings.*;
import com.plumtree.portalpages.admin.serversettings.general.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.web.*;

/**
 * 
 *
 * @version 5.0
 * @author SudhaSathiaseelan
 */
public class GeneralServerSetting implements IServerSettings
{
	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASControlName()
	{
		return EditorStartControl.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASDPName()
	{
		return UserSettingsDP.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASName()
	{
		return SetServerSettingsAS.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASQueryString()
	{
		return "&" + EditorStartControl.QS_EDITOR_TYPE + "=" +
		EditorStartControl.EDITOR_START_FLAG_MISC;
	}

	public String GetLinkText(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance()
			.GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm     = (XPResourceManager) application.GetCachingManager()
			.GetEntry("ResourceManager");

		return rm.GetString(1346, "ptmsgs_portaladminmsgs", _strLangID); //_ui_LinkText
	}
	
	//Describes whether the setting comes with the standard portal
	public boolean IsStandardPortalOption()
	{
		return (true);
	}

	//Describes whether the setting is currently viewable
	public boolean IsViewable()
	{
		return (true);
	}

	//Returns the HTMLElement
	//public HTMLElement GetHTMLElement();
}

