package com.plumtree.portalpages.admin.serversettings.settings;


import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.portalpages.admin.serversettings.*;
import com.plumtree.portalpages.admin.serversettings.globalaclsyncmap.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.web.*;

/**
 * The user lock manager is used to remove locks on users that have been left in
 * place due to a system error or a security violation.
 *
 * @version 5.0
 * @author JohnH
 */
public class GlobalACLSyncMapServerSetting implements IServerSettings
{
	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASControlName()
	{
		return EditorStartControl.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASDPName()
	{
		return null;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASName()
	{
		return GlobalACLSyncMapAS.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASQueryString()
	{
		String strQuery = "&" + EditorStartControl.QS_EDITOR_TYPE + "=" +
			EditorStartControl.EDITOR_START_FLAG_MISC;

		return strQuery;
	}

//Return link text
	public String GetLinkText(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
		return (rm.GetString(1547, "ptmsgs_portaladminmsgs", _strLangID));
	}

	//Describes whether the setting comes with the standard portal
	public boolean IsStandardPortalOption()
	{
		return (true);
	}

	//Describes whether the setting is currently viewable
	public boolean IsViewable()
	{
		return (true);
	}
}

