package com.plumtree.portalpages.admin.serversettings.settings;


import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.admin.serversettings.*;
import com.plumtree.portalpages.admin.serversettings.objectpropertymap.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.web.*;

/**
 * 
 *
 * @author josephc
 */
public class ObjPropMapServerSetting implements IServerSettings
{
	
	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASControlName()
	{
		return EditorStartControl.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASDPName()
	{
		return ObjPropMapDP.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASName()
	{
		return ObjPropMapEditorAS.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASQueryString()
	{
		XPStringBuilder sb = new XPStringBuilder(100);

		sb.Append("&").Append(EditorStartControl.QS_EDITOR_TYPE).Append("=")
		.Append(EditorStartControl.EDITOR_START_FLAG_MISC);

		return sb.ToString();
	}

	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#GetLinkText()
	 */
	public String GetLinkText(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance()
			.GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm     = (XPResourceManager) application.GetCachingManager()
			.GetEntry("ResourceManager");

		return rm.GetString(542, "ptmsgs_portaladminmsgs", _strLangID);
	}

	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#IsStandardPortalOption()
	 */
	public boolean IsStandardPortalOption()
	{
		return true;
	}

	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#IsViewable()
	 */
	public boolean IsViewable()
	{
		return true;
	}
}

