package com.plumtree.portalpages.admin.serversettings.settings;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.portalpages.admin.serversettings.*;
import com.plumtree.portalpages.admin.serversettings.search.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.web.*;

/**
 * 
 *
 * @author $author$
 */
public class SearchServerSetting implements IServerSettings
{
	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASControlName()
	{
		return "EditorStart";
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASDPName()
	{
		return null;
	}


	/**
	 * Return the name of the Editor framework activity space
	 * for this settings class. The static variable holding the
	 * string name is:<p>
	 * com.plumtree.portalpages.common.search.serversettings.SearchServerSettingsEditorAS.STR_MVC_CLASS_NAME
	 */
	public String GetASName()
	{
		return SearchServerSettingsEditorAS.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASQueryString()
	{
		return "&editorType=10";
	}

	/**
	 * 
	 *
	 * @param _strLangID 
	 *
	 * @return 
	 */
	public String GetLinkText(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance()
			.GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm     = (XPResourceManager) application.GetCachingManager()
			.GetEntry("ResourceManager");

		return rm.GetString(1638, "ptmsgs_portaladminmsgs", _strLangID); //_ui_LinkText
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetLinkURL()
	{
		return null;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean IsStandardPortalOption()
	{
		return true;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean IsViewable()
	{
		return true;
	}
}

