package com.plumtree.portalpages.admin.serversettings.settings;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.portalpages.admin.serversettings.*;
import com.plumtree.portalpages.common.constants.*;
import com.plumtree.portaluiinfrastructure.tags.manager.taglibmanager.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.web.*;

/**
 * Link to the Tag Library Manager page.
 * 
 * @author DonH
 */
public class TagLibManagerServerSetting implements IServerSettings
{
	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#GetASControlName()
	 */
	public String GetASControlName()
	{
		return EditorStartControl.STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#GetASDPName()
	 */
	public String GetASDPName()
	{
		return null;
	}

	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#GetASName()
	 */
	public String GetASName()
	{
		return TagLibManagerAS.STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#GetASQueryString()
	 */
	public String GetASQueryString()
	{
		return "&" + EditorStartControl.QS_EDITOR_TYPE + "=" +
			EditorStartControl.EDITOR_START_FLAG_MISC;
	}

	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#GetLinkText(java.lang.String)
	 */
	public String GetLinkText(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance()
			.GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm = (XPResourceManager) application.GetCachingManager()
			.GetEntry("ResourceManager");

		// Tag Library Manager
		return rm.GetString(771, ResourceConstants.PORTALCOMMONMSGS, _strLangID);
	}

	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#IsStandardPortalOption()
	 */
	public boolean IsStandardPortalOption()
	{
		return true;
	}

	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#IsViewable()
	 */
	public boolean IsViewable()
	{
		return true;
	}
}
