package com.plumtree.portalpages.ajax;

import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 * Activity Space for all AJAX-related calls
 *
 * @author MattC
 */
public class AjaxAS extends AFormAS
{
	
	public static final String STR_MVC_CLASS_NAME = "Ajax";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new AjaxAS();
	}

	/**
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(String, String, boolean)
	 * @return boolean
	 */
	public boolean CheckBasicAccess(String strPage, String strControl, boolean bSameSpace)
	{
		return true;
	}
	
	/**
	 * @see com.plumtree.xpshared.activityspace.AActivitySpace#Init()
	 */
	public void Init()
	{
		super.Init();

		RegisterModel(AjaxModel.STR_MVC_CLASS_NAME);

		RegisterPage(new AjaxDP());

		IModel myModel = GetModel(AjaxModel.STR_MVC_CLASS_NAME);

		RegisterView(AjaxView.STR_MVC_CLASS_NAME, myModel);

		RegisterControl(AjaxControl.STR_MVC_CLASS_NAME, myModel);
	}
}
