package com.plumtree.portalpages.ajax;

import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This model contains data for both the Browse and Edit Modes of the
 * Directory.
 *
 * @author StephenC
 */
public class AjaxModel implements IModel
{
	/** Activity space name */
	public static final String STR_MVC_CLASS_NAME = "Ajax";

	private AActivitySpace m_asOwner;
	private IPTSession m_ptSession;
	
	private int objectID=0;
	private int classID=0;
	private String oldName="";
	private String newName="";
	private int status=0;
	private String message="";
	
	public AjaxModel()
	{
		super();
	}

	public void Init(AActivitySpace parent)
	{
		m_asOwner     = parent;
		m_ptSession     = (IPTSession) m_asOwner.GetUserSession();
	}

	public void CleanupAllData()
	{
	
	}

	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	public Object Create()
	{
		return new AjaxModel();
	}

	public void CleanupTempData()
	{
		
	}

	/////////////////////////////////////////
	// Write methods for Model
	/////////////////////////////////////////

	public void setObjectId(int newObjectId)
	{
		objectID = newObjectId;
	}

	public void setClassId(int newClassId)
	{
		classID = newClassId;
	}

	public void setOldName(String newOldName)
	{
		oldName = newOldName;
	}

	public void setNewName(String newNewName)
	{
		newName = newNewName;
	}

	public void setMessage(String newMessage, int newStatus)
	{
		message = newMessage;
		status = newStatus;
	}
	
	/////////////////////////////////////////
	// Read methods for Model
	/////////////////////////////////////////
	public int getObjectId()
	{
		return objectID;
	}
	public int getClassId()
	{
		return classID;
	}
	public String getOldName()
	{
		return oldName;
	}
	public String getNewName()
	{
		return newName;
	}
	public int getStatus()
	{
		return status;
	}
	public String getMessage()
	{
		return message;
	}
}

