package com.plumtree.portalpages.browsing.directory.abodelete;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.directory.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author MikeSample
 *
 */
public class DirABOLinksView implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.directory.abodelete.DirABOLinksView");

	/** object name */
	public static final String STR_MVC_CLASS_NAME = "DirABOLinks";

	/** HTML Object names */
	public static final String HTMLBUTTON_CLOSE = "in_bu_Close";

	
	/** mvc objects */
	AActivitySpace m_asOwner;
	IDirModelRO m_asModel;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new DirABOLinksView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLElement result   = new HTMLElementCollection();
		HTMLSpan mySpan;
		HTMLTable myTable;
		HTMLInput myInput;
		HTMLTableRow myRow;
		HTMLTableCell myCell;

		try
		{
			// Links
			mySpan = new HTMLSpan();
			result.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);

			int[] nIDs = m_asModel.GetABOJobIDs();

			for (int i = 0; i < nIDs.length; i++)
			{
				if (nIDs[i] != -1)
				{
					mySpan.AddInnerHTMLString("Job ID: " + nIDs[i]);
				}
			}

			// Add buttons
			result.AddInnerHTMLElement(new HTMLComment(
					"Begin: Footer buttons table"));

			myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetBorder("0");
			myTable.SetWidth("100%");
			myTable.SetCellPadding("0");
			myTable.SetCellSpacing("10");

			// 1st Row
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);

			// Close button
			myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_CLOSE, "");
			myCell.AddInnerHTMLElement(myInput);

			myInput.SetValue(m_asOwner.GetString(17, "ptmsgs_portalbrowsingmsgs"));
			myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
			myInput.SetOnClick("window.close(); return false;");

			result.AddInnerHTMLElement(new HTMLComment(
					"End: Footer buttons table"));
		}
		catch (HTMLException he)
		{
			
				log.Error(he, "Unable to create warnings: " + he.getMessage());
			

			result = new HTMLGenericElement(m_asOwner.GetString(16,
						"ptmsgs_portalbrowsingmsgs"));
		}

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		return null;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_asOwner     = parent;
		m_asModel     = (IDirModelRO) model;
	}

	/** logger */
}

