package com.plumtree.portalpages.browsing.directory.abodelete;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.browsing.directory.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author MikeSample
 *
 */
public class DirCheckDeleteControl implements IControl
{
	/** object name */
	public static final String STR_MVC_CLASS_NAME = "DirCheckDelete";

	/** Control argument names */
	public static final String DELETEFOLDERS = "DeleteFolders";

	
	public static final String OBJECTIDPAIRS = "ObjectIDPairs";

	/** internal data */
	private AActivitySpace m_asOwner;
	private DirModel m_asModel;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#Execute()
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		Redirect result = new Redirect();
		result.SetLinkGetCachedSpace(m_asOwner);

		boolean bFolders = false;
		String[] sValues = (String[]) arguments.GetElement(DELETEFOLDERS);

		if (sValues != null)
		{
			bFolders = XPConvert.ToBoolean(sValues[0]);
		}

		m_asModel.SetFoldersForDeleteCheck(bFolders);

		result.SetDisplayPage(DirDeleteWarningsDP.STR_MVC_CLASS_NAME);

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new DirCheckDeleteControl();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#Init(IModel, AActivitySpace)
	 */
	public void Init(IModel model, AActivitySpace space)
	{
		m_asModel     = (DirModel) model;
		m_asOwner     = space;
	}

	/* */
}

