package com.plumtree.portalpages.browsing.directory.browse_D;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.directory.*;
import com.plumtree.portalpages.browsing.directory.edit.*;
import com.plumtree.portalpages.common.objects.*;
import com.plumtree.portaluiinfrastructure.application.varpacks.*;
import com.plumtree.portaluiinfrastructure.login.*;
import com.plumtree.portaluiinfrastructure.opener.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.htmlconstructs.*;
import com.plumtree.uiinfrastructure.web.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * Presents Documents through Database (Disability)
 *
 * @author StephenC
 */
public class BrowseDocViewHelper_D implements IObjectViewHelper
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.directory.browse_D.BrowseDocViewHelper_D");

	/** Localized String: Document Type:  */
private IDirModelRO m_dirModel;

	/**
	 * @see com.plumtree.portalpages.common.objects.IObjectViewHelper#AddObjectViewHTML()
	 */
	public HTMLElement AddObjectViewHTML(IObjectModelRO model)
	{
		return null;
	}

	/**
	 * @see com.plumtree.portalpages.common.objects.IObjectViewHelper#Display508Object(int, HTMLTable, IObjectModelRO, AActivitySpace)
	 */
	public void Display508Object(int nObjectIndex, HTMLTable tableObjects,
		IObjectModelRO model, AActivitySpace parent)
	{
		m_dirModel = (IDirModelRO) model;

		//Construct definitions
		HTMLTableRow row;

		try
		{
			// Get the document ID
			String strDocumentID = XPConvert.ToString(m_dirModel.GetObjectFields(
				nObjectIndex, PT_PROPIDS.PT_PROPID_OBJECTID));

			//Get the document name
			String strName = XPHttpUtility.HtmlEncode((String) m_dirModel.GetObjectFields(
				nObjectIndex, PT_PROPIDS.PT_PROPID_NAME));

			//Get the image uiid
			String strImageUIID = (String) m_dirModel.GetObjectFields(nObjectIndex,
				PT_PROPIDS.PT_PROPID_IMAGEUUID);

			// get the current language.					
			String strLangID = (String) PTPersonalSettingsHelper
				.GetPersonalSettingValue(PersonalSettingNames.LANGUAGE, parent);
			
			// get the tooltip string based on the UUID.  use the PTDocTypesVarPack.
			// default to the document name if the PTDocTypesVarPack does not have
			// the string for this UUID.
			String strImageToolTip = strName;			
			IApplication application = ApplicationManager.GetInstance()
				.GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
			if (null != application)
			{
				PTDocTypesVarPack varPack = (PTDocTypesVarPack) application.GetVarPackManager()
					.GetVariablePackage(PTDocTypesVarPack.VARPACK_ID);
				if (null != varPack)
				{
					strImageToolTip = varPack.GetLocalizedName(strImageUIID, strLangID);
                    if (strImageToolTip.equals("")) {
                        strImageToolTip = strName;  
                    }
				}
			}

			//Description
			String strDescType = m_dirModel.GetDocDescriptionType();
			String strDesc     = "";

			if (false == XPStringUtility.EqualsIgnoreCase(DirConstants.DIR_DOC_DESC_NONE,strDescType))
			{
				strDesc = (String) m_dirModel.GetObjectFields(
							nObjectIndex, (PT_PROPIDS.PT_PROPID_DESCRIPTION));

				if (null == strDesc)
				{
					strDesc = "";
				}

				// abbreviate the description if necessary
				if (true == XPStringUtility.EqualsIgnoreCase(DirConstants.DIR_DOC_DESC_ABBR,strDescType))
				{
					if (DirConstants.DESCRIPTION_ABBR_LENGTH < strDesc.length())
					{
						strDesc = strDesc.substring(0,
								DirConstants.DESCRIPTION_ABBR_LENGTH) + "...";
					}
				}

				// HTMLEncode
				strDesc = XPHttpUtility.HtmlEncode(strDesc);
			}

			// Open document URL
			String strURL = PTOpenerLinks.GetOpenerURLOpenObjID(
			    PT_CLASSIDS.PT_CATALOGCARD_ID,
				XPConvert.ToInteger(strDocumentID),
				IPTOpenerConstants.OPENER_MODE_VIEW,
				parent);
 

			// anchor for list item construct
			HTMLAnchor aPrimaryLink = new HTMLAnchor(strURL);
			aPrimaryLink.SetTitle(strName);

			// if we need to set the 508-compliant lang tag
			String itemLang = GetDocumentLangTag(nObjectIndex, m_dirModel, parent);
			HTMLSpan langSpan;
			if (null != itemLang) 
			{
			    langSpan = new HTMLSpan();
			    langSpan.SetLangLocal(itemLang);
			    langSpan.AddInnerHTMLString(strName);
			    
				aPrimaryLink.AddInnerHTMLElement(langSpan);
			}
			else
			{
				aPrimaryLink.AddInnerHTMLString(strName);
			}
			
			// since we can't have js to popup new window use _blank
			if(m_dirModel.GetUserPrefOpenDocInNewWindow())
			{
				aPrimaryLink.SetTarget("_blank");
			}
			
			// use list item construct
			UIListItem itemConstruct;
            itemConstruct = new UIListItem(aPrimaryLink, parent);
			itemConstruct.SetTitle(strName);
			itemConstruct.SetTitleStyleClass(PTStyleClass.LIST_SUBTITLE);

			if ((false == XPStringUtility.EqualsIgnoreCase(DirConstants.DIR_DOC_DESC_NONE,strDescType)) && (0 != strDesc.length()))
			{
			    // if we need to set the 508-compliant lang tag
				if (null != itemLang) 
				{
				    langSpan = new HTMLSpan();
				    langSpan.SetLangLocal(itemLang);
				    langSpan.AddInnerHTMLString(strDesc);
				    
					itemConstruct.SetDescription(langSpan.GetDisplayString());
				}
				else
				{
					itemConstruct.SetDescription(strDesc);
				}
			        
			}

			//Properties URL
			ASURL myURL = new ASURL(parent);
			myURL.SetLinkGetSpaceIfCached(DirAS.STR_MVC_CLASS_NAME, parent);
			myURL.SetControl(DirRepostControl.STR_MVC_CLASS_NAME);
			myURL.SetDisplayPage(DirCardPropertiesDP_D.STR_MVC_CLASS_NAME);
			myURL.AddControlArgument(DirConstants.QS_CARDID, strDocumentID);

			HTMLAnchor myAnchor = new HTMLAnchor(myURL.GetURLAsString());

			myAnchor.AddInnerHTMLString(parent.GetString(1794,
					"ptmsgs_portalbrowsingmsgs"));
			myAnchor.SetTitle(XPResourceManager.FormatMessage(
			        parent.GetString(1792, "ptmsgs_portalbrowsingmsgs"), strName));
			
			itemConstruct.SetPropertiesLink(myAnchor);

			// Image UIID
			HTMLImg myImg = PlumtreeHelpers.GetHTMLImage(strImageUIID, true);
			myImg.SetAlt(strImageToolTip);
			itemConstruct.SetItemTypeImage(myImg);

			// delete
			boolean canEditKD = m_dirModel.CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_EDIT_DOCUMENT_DIRECTORY);
			boolean canEditFolder = m_dirModel.HasAccessToEditFolder();
			if (canEditKD && canEditFolder)
			{
				myURL = new ASURL(parent);
				myURL.SetLinkGetSpaceIfCached(DirAS.STR_MVC_CLASS_NAME, parent);
				myURL.SetControl(DirRepostControl.STR_MVC_CLASS_NAME);
				myURL.AddControlArgument(EditDocViewHelper.QS_CHECKBOX,new String[]{strDocumentID});
				myURL.AddControlArgument(DirConstants.QS_508_DELETE,"true");
				
				itemConstruct.SetItemEditButton(
				        PTImageType.ACTION_DELETE,
				        parent.GetString(177,"ptmsgs_portalbrowsingmsgs"),
				        myURL.GetURLAsString());
			}
			
			// convert the construct to table
			try
			{
				row = new HTMLTableRow();

				row.SetStyleClass(((nObjectIndex % 2) == 1)
					? PTStyleClass.LIST_ITEM_ONE_BG
					: PTStyleClass.LIST_ITEM_TWO_BG);

				itemConstruct.AddItemCellsToRow(row);

				tableObjects.AddInnerHTMLElement(row);
			}
			catch (Exception e)
			{
				
					log.Error(e, "BrowseDocViewHelper_D::Display508Object. The following exception occured: " + e.getMessage());
				
			}
		}
		catch (Exception e)
		{
			
				log.Error(e, "BrowseDocViewHelper_D::Display508Object. The following exception occured: " + e.getMessage());
			
		}
	}

	/**
	 * @see com.plumtree.portalpages.common.objects.
	 * IObjectViewHelper#GetThereAreNoItemsString(AActivitySpace)
	 */
	public String GetThereAreNoItemsString(AActivitySpace asOwner)
	{
		return null;
	}

	/**
	 * @see com.plumtree.portalpages.common.objects.IObjectViewHelper#DisplayJavascriptCollection(AActivitySpace)
	 */
	public HTMLScriptCollection DisplayJavascriptCollection(
		AActivitySpace asOwner, IObjectModelRO model)
	{
		return null;
	}

	/**
	 * Displays the object at the given index in the query result. This must be
	 * overridden by all subclasses.
	 *
	 * @param nObjectIndex
	 * @param tableObjects
	 * @param model
	 */
	public void DisplayObject(int nObjectIndex, int nRowIndex, HTMLTable tableObjects,
		IObjectModelRO model, AActivitySpace asOwner)
	{
		m_dirModel = (IDirModelRO) model;

		//Construct definitions
		HTMLTableRow row;

		try
		{
			// Get the document ID
			String strDocumentID = XPConvert.ToString(m_dirModel.GetObjectFields(
						nObjectIndex, PT_PROPIDS.PT_PROPID_OBJECTID));

			//Get the document name
			String strName = XPHttpUtility.HtmlEncode((String) m_dirModel.GetObjectFields(
						nObjectIndex, PT_PROPIDS.PT_PROPID_NAME));

			//Get the image uiid
			String strImageUIID = (String) m_dirModel.GetObjectFields(nObjectIndex,
					PT_PROPIDS.PT_PROPID_IMAGEUUID);

			//Description
			String strDescType = m_dirModel.GetDocDescriptionType();
			String strDesc     = "";

			if (false == XPStringUtility.EqualsIgnoreCase(DirConstants.DIR_DOC_DESC_NONE,strDescType))
			{
				strDesc = XPHttpUtility.HtmlEncode((String) m_dirModel.GetObjectFields(
							nObjectIndex, (PT_PROPIDS.PT_PROPID_DESCRIPTION)));

				if (null == strDesc)
				{
					strDesc = "";
				}

				// abbreviate the description if necessary
				if (true == XPStringUtility.EqualsIgnoreCase(DirConstants.DIR_DOC_DESC_ABBR,strDescType))
				{
					if (DirConstants.DESCRIPTION_ABBR_LENGTH < strDesc.length())
					{
						strDesc = strDesc.substring(0,
								DirConstants.DESCRIPTION_ABBR_LENGTH) + "...";
					}
				}
			}

			// Open document URL
			String strURL = PTOpenerLinks.GetOpenerURLOpenObjID(
			    PT_CLASSIDS.PT_CATALOGCARD_ID,
				XPConvert.ToInteger(strDocumentID),
				IPTOpenerConstants.OPENER_MODE_VIEW,
				asOwner);

			// use list item construct
			UIListItem itemConstruct = new UIListItem(strName, strURL, asOwner);
			itemConstruct.SetTitleStyleClass(PTStyleClass.LIST_SUBTITLE);

			if ((false == XPStringUtility.EqualsIgnoreCase(DirConstants.DIR_DOC_DESC_NONE,strDescType)) && (0 != strDesc.length()))
			{
				itemConstruct.SetDescription(strDesc);
			}

			//Properties URL
			ASURL myURL = new ASURL(asOwner);
			myURL.SetLinkGetSpaceIfCached(DirAS.STR_MVC_CLASS_NAME, asOwner);
			myURL.SetControl(DirRepostControl.STR_MVC_CLASS_NAME);
			myURL.SetDisplayPage(DirCardPropertiesDP_D.STR_MVC_CLASS_NAME);
			myURL.AddControlArgument(DirConstants.QS_CARDID, strDocumentID);

			HTMLAnchor myAnchor = new HTMLAnchor(myURL.GetURLAsString());

			myAnchor.AddInnerHTMLString(asOwner.GetString(31,
					"ptmsgs_portalbrowsingmsgs"));
			myAnchor.SetTitle(asOwner.GetString(31, "ptmsgs_portalbrowsingmsgs"));
			itemConstruct.SetPropertiesLink(myAnchor);

			// Image UIID
			HTMLImg myImg = PlumtreeHelpers.GetHTMLImage(strImageUIID, true);
			itemConstruct.SetItemTypeImage(myImg);

			// convert the construct to table
			try
			{
				row = new HTMLTableRow();

				itemConstruct.AddItemCellsToRow(row);

				tableObjects.AddInnerHTMLElement(row);
			}
			catch (Exception e)
			{
				
					log.Error(e, "BrowseDocViewHelper_D::DisplayObject. The following exception occured: " + e.getMessage());
				
			}
		}
		catch (Exception e)
		{
			
				log.Error(e, "BrowseDocViewHelper_D::DisplayObject. The following exception occured: " + e.getMessage());
			
		}
	}
	
	// returns null if no document lang tag is need.
	private String GetDocumentLangTag(	int nObjectIndex, IDirModelRO model, 
	        						AActivitySpace asOwner)
	{
		// What's the user's default language?  We'll need this for tagging any strings
	    // that we think are in another language.
	    String sUserLang = (String) PTPersonalSettingsHelper.
	    	GetPersonalSettingValue(PersonalSettingNames.LANGUAGE, asOwner);

	    String sDocLang;
	    try 
	    {
	        sDocLang = (String) m_dirModel.GetObjectFields(nObjectIndex, PT_PROPIDS.PT_PROPID_CARD_CONTENTLANGUAGE);
	    }
	    catch (Exception e)
	    {
	        // if we can't get the lang don't use lang tag
	        return null;
	    }
	    
	    if ((null != sDocLang) && (0 == sDocLang.length())) 
        {
            // Ignore empty strings
            return null;
        }
	    
	    if (null != sDocLang)
        {
	        sDocLang = XPStringUtility.ToLowerCase(sDocLang);
            if (XPStringUtility.EqualsIgnoreCase(sDocLang, sUserLang)) 
            {
                // If the item is in the user's default language, 
                // don't bother marking it with special tags.
                return null;
            }
        }
	    
	    return sDocLang;
	}

	
	/**
	 * @see com.plumtree.portalpages.common.objects.IObjectViewHelper#SetExpandButton(HTMLAnchor, IObjectModelRO)
	 */
	public void SetExpandAnchor(HTMLAnchor anchor, IObjectModelRO model)
	{
	}
}

