package com.plumtree.portalpages.browsing.directory.browse_D;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.directory.*;
import com.plumtree.portaluiinfrastructure.opener.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author StephenC
 *
 * Show the Page Options for the Directory
 */
public class DirBrowseHeaderView_D implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.directory.browse_D.DirBrowseHeaderView_D");

	
	public static final String STR_MVC_CLASS_NAME = "DirBrowseHeader_D";

	private AActivitySpace m_asOwner;
	private IDirModelRO m_asModel;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new DirBrowseHeaderView_D();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLAnchor myAnchor;

		HTMLElementCollection result = new HTMLElementCollection();

		try
		{
			HTMLComment myComment = new HTMLComment( "Begin: Display DirBrowseHeaderView_D");
			result.AddInnerHTMLElement(myComment);

			HTMLTable mainTable = new HTMLTable();
			result.AddInnerHTMLElement(mainTable);
			mainTable.SetBorder("0");
			mainTable.SetWidth("100%");
			mainTable.SetCellPadding("0");
			mainTable.SetCellSpacing("0");
			mainTable.SetSummary(m_asOwner.GetString(1174, "ptmsgs_portalbrowsingmsgs"));


			if(false == m_asModel.InRootFolder())
			{
				// BEGIN Go Up 1 Level Row
				myRow = new HTMLTableRow();
				mainTable.AddInnerHTMLElement(myRow);

				myCell = new HTMLTableCell();
				myRow.AddInnerHTMLElement(myCell);
	
				int nParentFolderID = m_asModel.GetParentFolderID();
	
				String strURL = PTOpenerLinks.GetOpenerURLOpenObjID(PT_CLASSIDS.PT_CATALOGFOLDER_ID,
						nParentFolderID, IPTOpenerConstants.OPENER_MODE_VIEW, m_asOwner);
	
				HTMLImg myUpImg = (HTMLImg) PTImageType.ACTION_FOLDER_UP.GetHTMLElement();
				myUpImg.SetAlt(m_asOwner.GetString(169,
						  "ptmsgs_portalbrowsingmsgs"));
				HTMLImg myFolderImg = (HTMLImg) PTImageType.ICON_FOLDER.GetHTMLElement();
				myFolderImg.SetAlt(m_asOwner.GetString(169,
						  "ptmsgs_portalbrowsingmsgs"));
				
				myAnchor = new HTMLAnchor(strURL);
				myAnchor.AddInnerHTMLElement(myUpImg);
				myAnchor.AddInnerHTMLElement(myFolderImg);
				myCell.AddInnerHTMLElement(myAnchor);

				myAnchor			 = new HTMLAnchor(strURL);
	
				myAnchor.AddInnerHTMLString(m_asOwner.GetString(168,
						"ptmsgs_portalbrowsingmsgs"));
	
				myAnchor.SetTitle(m_asOwner.GetString(169,
						"ptmsgs_portalbrowsingmsgs"));
				myCell.SetStyleClass(PTStyleClass.OBJECT_HEADER);
				myCell.AddInnerHTMLElement(myAnchor);
				// END Go Back Row
			}
	
			myComment = new HTMLComment( "Display DirBrowseHeaderView_D");
			result.AddInnerHTMLElement(myComment);
		}
		catch (HTMLException he)
		{
			
				log.Error(he, STR_MVC_CLASS_NAME +
					"::MainView::Display The following error occured when trying to display the HTML: " +
					he.getMessage());
			

			throw new XPException(m_asOwner.GetString(44,
					"ptmsgs_portalbrowsingmsgs"), he);
		}

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		return null;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_asModel     = (IDirModelRO) model;
		m_asOwner     = parent;
	}
}

