package com.plumtree.portalpages.browsing.directory.browse_D;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author StephenC
 *
 */
public class DirRelatedResourcesMoreDP_D extends PlumtreeDP
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.directory.browse_D.DirRelatedResourcesMoreDP_D");

	
	public static final String STR_MVC_CLASS_NAME = "DirRelatedResourcesMoreDP_D";

	
	/**
	 * @see com.plumtree.xpshared.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetSubtitleForBanner()
	 */
	public String GetSubtitleForBanner()
	{
		return m_asOwner.GetString(58, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetTitleForBanner()
	 */
	public String GetTitleForBanner()
	{
		return m_asOwner.GetString(57, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IDisplayPage#Init(AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		super.Init(parent);
		SetAddMainForm(true);
	}

	/**
	 * helper display method for PlumtreeDP
	 *
	 * Fill in the body argument with HTML to display in the page.
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection wholePageGroup = new HTMLElementCollection();

		try
		{
			wholePageGroup.AddInnerHTMLElement(m_asOwner.GetView(
					DirRelatedResourcesMoreView_D.STR_MVC_CLASS_NAME).Display());
		}
		catch (HTMLException he)
		{
			
				log.Error(he, "Error in DirRelatedResourcesMoreDP_D::Display: " +
					he.getMessage());
			
		}

		return wholePageGroup;
	}
}

