package com.plumtree.portalpages.browsing.directory.documentsubmitsimple;


// Framework imports
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This is the DP for the dependencies page. It's the
 * last page of the save pop-up and has a confirmation
 * message and some links to create other objects that
 * depend on the one that was just created.
 *
 * @author StephenC
 */
public class DirCardSubmitDependenciesDP extends AFormDP
{
	/**
	 * Class name for the activity space
	 */
	public static final String STR_MVC_CLASS_NAME = "DirCardSubmitDependencies";

	
	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()
	 */
	public String GetFormTitle()
	{
		return m_asOwner.GetString(1199, "ptmsgs_portalbrowsingmsgs");
	}
	
	
	/**
	 * @see com.plumtree.xpshared.activityspace.IDisplayPage#Init(AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		super.Init(parent);

		parent.SetHelpTopic( "PT_Submit_SimpleDocument" );
	}

	

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()
	{
		return m_asOwner.GetView(DirCardSubmitDependenciesView.STR_MVC_CLASS_NAME)
		.Display();
	}
}

