package com.plumtree.portalpages.browsing.directory.documentsubmitsimple;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.directory.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 *
 * @author StephenC
 */
public class DirCardSubmitDoneView implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.directory.documentsubmitsimple.DirCardSubmitDoneView");

	
	public static final String STR_MVC_CLASS_NAME = "DirCardSubmitDoneView";

	// Hidden inputs so that the name/path can be programatically extracted
	// using JavaScript (I.E. for DHTML submit to KD portlet).
	public static final String HIDDEN_DOC_NAME = "in_hi_DocumentName";
	public static final String HIDDEN_DOC_PATH = "in_hi_DocumentPath";
	public static final String HIDDEN_DOC_PATH_ID = "in_hi_DocumentPathID";

	/** Localized String: Successfully Submitted */
//	public final String _ui_Successful = "Successfully Submitted";

	/** Localized String: You have successfully created a document. */
//	public final String _ui_Info = "You have successfully created a document.";

	/** Localized String: This document may require approval before being accessible through the portal. */
//	public final String _ui_Tip = "This document may require approval before being accessible through the portal.";

	/** Localized String: OK */
//	public final String _ui_DoneButtonLabel = "OK";

	/** Localized String: Unable to display the HTML for DirCardSubmitDoneView (Display). */
//  public final String _ui_DisplayHTMLError = "Unable to display the HTML for DirCardSubmitDoneView (Display).";

	/** Localized String: Submit More */
//	public final String _ui_SubmitMore = "Submit More";

	
	public static final String HTMLBUTTON_EDITOR_DONE = "in_bu_Done";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new DirCardSubmitDoneView();
	}

	AActivitySpace m_asOwner;
	IDirModelRO m_dirModel;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLInput myInput;
		HTMLH1 headerH1;
		
		HTMLTable mainTable = new HTMLTable();
		mainTable.SetBorder("0");
		mainTable.SetWidth("100%");
		mainTable.SetCellPadding("0");
		mainTable.SetCellSpacing("0");

		result.AddInnerHTMLElement(mainTable);

		try
		{
			HTMLTable sectionTable;
			HTMLTable innerTable;

			myRow = new HTMLTableRow();
			mainTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);

			sectionTable = new HTMLTable();
			sectionTable.SetBorder("0");
			sectionTable.SetWidth("100%");
			sectionTable.SetCellPadding("5");
			sectionTable.SetCellSpacing("0");
			myCell.AddInnerHTMLElement(sectionTable);

			// BEGIN Banner and OK button
			myRow = new HTMLTableRow();
			sectionTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.BAN_HEADER_BG);

			// title
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			
			headerH1 = new HTMLH1();
			myCell.AddInnerHTMLElement(headerH1);
			myCell.SetHeight("30");
			headerH1.AddInnerHTMLString(m_asOwner.GetString(84,
				"ptmsgs_portalbrowsingmsgs"));
			headerH1.SetStyleClass(PTStyleClass.BAN_HEADER);

			// Done Button
			myCell = new HTMLTableCell();
			myCell.SetAlign(CommonHTMLStrings.RIGHT);
			myRow.AddInnerHTMLElement(myCell);
			myInput = new HTMLInput(HTMLInputTypes.BUTTON,
					HTMLBUTTON_EDITOR_DONE, "");
			myCell.AddInnerHTMLElement(myInput);
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);


//			myInput.SetValue("  " + _ui_DoneButtonLabel + "  ");
			myInput.SetValue("  " + m_asOwner.GetString(1478, "ptmsgs_portalbrowsingmsgs") + "  ");
			myInput.SetStyleClass(PTStyleClass.FORM_EDITOR_BTN_TEXT);
			myInput.SetOnClick("window.opener.location.reload(); self.close();");	// mj: removed 'Javascript:' from function name
			// END Banner and OK button

			// Add extra spacer row
			mainTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(1, 5));

			myRow = new HTMLTableRow();
			mainTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);

			sectionTable = new HTMLTable();
			sectionTable.SetBorder("0");
			sectionTable.SetWidth("100%");
			sectionTable.SetCellPadding("0");
			sectionTable.SetCellSpacing("5");
			myCell.AddInnerHTMLElement(sectionTable);

			myRow = new HTMLTableRow();
			sectionTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);

			innerTable = new HTMLTable();
			innerTable.SetBorder("0");
			innerTable.SetWidth("100%");
			innerTable.SetCellPadding("2");
			innerTable.SetCellSpacing("2");
			myCell.AddInnerHTMLElement(innerTable);

			sectionTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(2, 5));

			// BEGIN Title Row
			myRow = new HTMLTableRow();
			innerTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetColSpan(CommonHTMLStrings.TWO);
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_HEADER);
//			myCell.AddInnerHTMLString(_ui_Successful);
			myCell.AddInnerHTMLString(m_asOwner.GetString(1475, "ptmsgs_portalbrowsingmsgs"));
			// END Title Row

			// BEGIN Message Row
			myRow = new HTMLTableRow();
			innerTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetColSpan(CommonHTMLStrings.TWO);
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
//			myCell.AddInnerHTMLString(_ui_Info);
			myCell.AddInnerHTMLString(m_asOwner.GetString(1476, "ptmsgs_portalbrowsingmsgs"));
			
			// END Message Row

			int nParentFolderID  = m_dirModel.GetCardSubmitFolder();
			int nSubmittedCardID = m_dirModel.GetCardID();

			// BEGIN Card Name Row
			String strCardName = m_dirModel.GetCardName(nSubmittedCardID);
			String strFittedAndEncodedCardName = DirConstants.BreakUpLongWordsInStringAndHTMLEncode(strCardName);

			myRow = new HTMLTableRow();
			innerTable.AddInnerHTMLElement(myRow);

			// empty cell
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetWidth("10");
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.AddInnerHTMLString(m_asOwner.GetString(1200, "ptmsgs_portalbrowsingmsgs"));
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
			myCell.AddInnerHTMLString(strFittedAndEncodedCardName);

			// Hidden input so that the name/path can be programatically extracted
			// using JavaScript (I.E. for DHTML submit to KD portlet).
			myInput = new HTMLInput(HTMLInputTypes.HIDDEN_TYPE, "");
			myInput.SetName(HIDDEN_DOC_NAME);
			myInput.SetValue(strFittedAndEncodedCardName);
			myCell.AddInnerHTMLElement(myInput);

			// END Card Name Row

			// BEGIN Card Path Row
			myRow = new HTMLTableRow();
			innerTable.AddInnerHTMLElement(myRow);
			
			// empty cell
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetWidth("10");
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

			String strFolderPath = XPHttpUtility.HtmlEncode(
				m_dirModel.GetFolderPath(nParentFolderID));

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.AddInnerHTMLString(m_asOwner.GetString(1201, "ptmsgs_portalbrowsingmsgs"));
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
			myCell.AddInnerHTMLString(strFolderPath);

			// Hidden input so that the name/path can be programatically extracted
			// using JavaScript (I.E. for DHTML submit to KD portlet).
			myInput = new HTMLInput(HTMLInputTypes.HIDDEN_TYPE, "");
			myInput.SetName(HIDDEN_DOC_PATH);
			myInput.SetValue(strFolderPath);
			myCell.AddInnerHTMLElement(myInput);

			myInput = new HTMLInput(HTMLInputTypes.HIDDEN_TYPE, "");
			myInput.SetName(HIDDEN_DOC_PATH_ID);
			myInput.SetValue(XPConvert.ToString(nParentFolderID));
			myCell.AddInnerHTMLElement(myInput);

			// END Card Path Row

			// BEGIN Message Row
			myRow = new HTMLTableRow();
			innerTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetColSpan(CommonHTMLStrings.TWO);
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
//			myCell.AddInnerHTMLString(_ui_Tip);
			myCell.AddInnerHTMLString(m_asOwner.GetString(1477, "ptmsgs_portalbrowsingmsgs"));;
			// END Message Row


			innerTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(1,10));

			// BEGIN Submit More Button Row
			myRow = new HTMLTableRow();
			innerTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetColSpan(CommonHTMLStrings.TWO);
			myRow.AddInnerHTMLElement(myCell);
			myInput = new HTMLInput(HTMLInputTypes.BUTTON,
					HTMLBUTTON_EDITOR_DONE, "");
			myCell.AddInnerHTMLElement(myInput);


//			myInput.SetValue("  " + _ui_SubmitMore + "  ");
			myInput.SetValue(m_asOwner.GetString(1483, "ptmsgs_portalbrowsingmsgs"));
			myInput.SetStyleClass(PTStyleClass.FORM_EDITOR_BTN_TEXT);
			myInput.SetOnClick(DirCardSubmitSimpleDP.JAVASCRIPT_SUBMIT_FORM + "(" +
				DirRepostControl.POSTTOSELF_ACTION_CARDSUBMITSIMPLE_SUBMITMORE +
			"); return false;");
			// END Submit More Button Row

			innerTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(1,40));
		}
		catch (HTMLException he)
		{
			log.Error(he, m_asOwner.GetString(1479, "ptmsgs_portalbrowsingmsgs"));

			throw new XPException(m_asOwner.GetString(1479, "ptmsgs_portalbrowsingmsgs"), he);
		}

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		return null;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO,
	 *      AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_asOwner     = parent;
		m_dirModel = (IDirModelRO) model;
	}
}