package com.plumtree.portalpages.browsing.directory.documentsubmitsimple;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.directory.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 *
 * @author StephenC
 */
public class DirCardSubmitUploadingView implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.directory.documentsubmitsimple.DirCardSubmitUploadingView");

	
	public static final String STR_MVC_CLASS_NAME = "DirCardSubmitUpload";

	/** Localized String: Uploading... */
//	public final String _ui_Uploading = "Uploading...";	//

	/**
	 * Localized String: Unable to display the HTML for DirCardSubmitUploadingView
	 * (Display).
	 */
//	public final String _ui_DisplayHTMLError = "Unable to display the HTML for DirCardSubmitUploadingView (Display).";

	
	public static final String HTMLFORM_SUBMITCARD = "SubmitCardUploading";

	AActivitySpace m_asOwner;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new DirCardSubmitUploadingView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLH1 headerH1;
		
		HTMLTable mainTable = new HTMLTable();
		mainTable.SetBorder("0");
		mainTable.SetWidth("100%");
		mainTable.SetCellPadding("0");
		mainTable.SetCellSpacing("0");

		result.AddInnerHTMLElement(mainTable);

		try
		{
			HTMLTable sectionTable;
			HTMLTable innerTable;

			myRow = new HTMLTableRow();
			mainTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);

			sectionTable = new HTMLTable();
			sectionTable.SetBorder("0");
			sectionTable.SetWidth("100%");
			sectionTable.SetCellPadding("5");
			sectionTable.SetCellSpacing("0");
			myCell.AddInnerHTMLElement(sectionTable);

			// BEGIN Banner and Finish and Cancel buttons
			myRow = new HTMLTableRow();
			sectionTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.BAN_HEADER_BG);

			// title
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			headerH1 = new HTMLH1();
			myCell.AddInnerHTMLElement(headerH1);
			myCell.SetHeight("30");
			headerH1.AddInnerHTMLString(m_asOwner.GetString(84,
				"ptmsgs_portalbrowsingmsgs"));
			headerH1.SetStyleClass(PTStyleClass.BAN_HEADER);

			// Add extra spacer row
			mainTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(1, 5));

			myRow = new HTMLTableRow();
			mainTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);

			sectionTable = new HTMLTable();
			sectionTable.SetBorder("0");
			sectionTable.SetWidth("100%");
			sectionTable.SetCellPadding("0");
			sectionTable.SetCellSpacing("5");
			myCell.AddInnerHTMLElement(sectionTable);

			myRow = new HTMLTableRow();
			sectionTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);

			innerTable = new HTMLTable();
			innerTable.SetBorder("0");
			innerTable.SetWidth("100%");
			innerTable.SetCellPadding("2");
			innerTable.SetCellSpacing("2");
			myCell.AddInnerHTMLElement(innerTable);

			sectionTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(2, 5));

			// BEGIN Animated GIF Row
			myRow = new HTMLTableRow();
			innerTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetAlign(CommonHTMLStrings.CENTER);

			HTMLImg mySendDocImg = (HTMLImg) PTImageType.ICON_PROGRESS.GetHTMLElement();
//			mySendDocImg.SetAlt(_ui_Uploading);
			mySendDocImg.SetAlt(m_asOwner.GetString(1473, "ptmsgs_portalbrowsingmsgs"));
			myCell.AddInnerHTMLElement(mySendDocImg);
			// END Animated GIF Row

			// BEGIN Message Row
			myRow = new HTMLTableRow();
			innerTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetAlign(CommonHTMLStrings.CENTER);
			
			myCell.SetStyleClass(PTStyleClass.OBJECT_HEADER);
//			myCell.AddInnerHTMLString(_ui_Uploading); 
			myCell.AddInnerHTMLString(m_asOwner.GetString(1473, "ptmsgs_portalbrowsingmsgs")); 
			// END Message Row
			
			innerTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(1,100));

			HTMLScript myScript = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
			myScript.AddInnerHTMLString(AFormDP.JAVASCRIPT_SUBMIT_FORM + "(" + DirRepostControl.POSTTOSELF_ACTION_CARDSUBMITSIMPLE_UPLOAD + ");\n");
			
			result.AddInnerHTMLElement(myScript);
		}
		catch (HTMLException he)
		{
			log.Error(he, m_asOwner.GetString(1474, "ptmsgs_portalbrowsingmsgs"));

			throw new XPException(m_asOwner.GetString(93,
				"ptmsgs_portalbrowsingmsgs"), he);
		}

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		return null;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO,
	 *      AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_asOwner     = parent;
	}
}