package com.plumtree.portalpages.browsing.directory.opendoc;

import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.errordisplay.*;

/**
 * 
 *
 * @author John Osborne
 */
public class OpenDocModel implements IOpenDocModel, IOpenDocModelRO
{
	
	public static final String STR_MVC_CLASS_NAME = "OpenDoc";

	
	private OpenDocAS m_asOwner;

	
	private String m_strDocURL = null;

	
	private int m_nDocID = -1;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IModel#CleanupTempData()
	 */
	public void CleanupTempData()
	{
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IModel#CleanupAllData()
	 */
	public void CleanupAllData()
	{
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new OpenDocModel();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 *
	 */
	public String GetOpenDocURL()
	{
		if (m_strDocURL == null)
		{
			try
			{
				m_strDocURL = ((IPTSession) m_asOwner.GetUserSession()).GetCatalog()
					.OpenCard(m_nDocID, false).GetDocumentURL();
			}
			catch (Exception e)
			{
				m_strDocURL = null;
				UIError myError = new UIError(UIErrorLevel.FRIENDLY,
					UIErrorScope.CURRENT_USER, null, m_asOwner.GetString(1685, "ptmsgs_portalbrowsingmsgs"),
					e.getMessage());
				UIErrorHandler.RaiseError(myError, m_asOwner.GetSubSession(),
					m_asOwner.GetApplication());
			}	
		}

		return m_strDocURL;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IModel#Init(AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		m_asOwner = (OpenDocAS) parent;
	}

	/**
	 * 
	 *
	 * @param _nDocID 
	 */
	public void SetDocumentID(int _nDocID)
	{
		m_nDocID = _nDocID;
		// DCA - doc Id is changing, clear out doc URL
		m_strDocURL = null;
	}
}

