package com.plumtree.portalpages.browsing.directory.properties;

import com.plumtree.portalpages.browsing.directory.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author StephenC
 */
public class DirCardPropertiesDP extends AFormDP
{
	
	public static final String STR_MVC_CLASS_NAME = "DirCardProperties";

	
	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()
	 */
	public String GetFormTitle()
	{
		return m_asOwner.GetString(114, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();
   
		// card properties view
		result.AddInnerHTMLElement(m_asOwner.GetView(DirCardPropertiesView.STR_MVC_CLASS_NAME).Display());

		// bestbets view
		result.AddInnerHTMLElement(m_asOwner.GetView(DirAS.STR_MVC_STORAGE_NAME_KEYWORDS).Display());

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
				DirCardPropertiesView.STR_MVC_CLASS_NAME).DisplayJavascript());

		// bestbets view
		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
		        DirAS.STR_MVC_STORAGE_NAME_KEYWORDS).DisplayJavascript());
		
		return myScripts;
	}

	/** logger */
}

