package com.plumtree.portalpages.browsing.directory.rest;

/**
 * This class contains constants for the KD Rest API.  These can
 * be used in both the JSON format and the XML format.
 * 
 * Each constant is marked with input and/or output depending on
 * whether it can be used as an input to the API, an output, or both.
 */
public class DirRESTConstants
{
	// These constants describe the JSON/XML input/output format.

	/**
	 * The name of the document object in the format (i.e. the object
	 * itself, not a member of the object).
	 * input/output
	 */
	public static final String DOCUMENT_FORMAT_NAME = "document";

	/**
	 * The key for the document name member.
	 * input/output
	 */
	public static final String DOCUMENT_NAME = "name";

	/**
	 * The key for the document description member.
	 * input
	 */
	public static final String DOCUMENT_DESCRIPTION = "description";

	/**
	 * The key for the document data source ID member.
	 * input
	 */
	public static final String DOCUMENT_DATA_SOURCE_ID = "datasourceid";

	/**
	 * The key for the document content url member.
	 * input
	 */
	public static final String DOCUMENT_CONTENT_URL = "contenturl";

	/**
	 * The key for the document type member.
	 * input
	 */
	public static final String DOCUMENT_TYPE = "type";

	/**
	 * The key for the document doc ID member.
	 * input
	 */
	public static final String DOCUMENT_DOC_ID = "docid";

	/**
	 * The key for the document server ID member.
	 * input
	 */
	public static final String DOCUMENT_SERVER_ID = "serverid";

	/**
	 * The key for the document object ID member.
	 * output
	 */
	public static final String DOCUMENT_OBJECT_ID = "objectid";

	/**
	 * The key for the document folder ID member.
	 * output
	 */
	public static final String DOCUMENT_FOLDER_ID = "folderid";

	/**
	 * The key for the document folder path member.
	 * output
	 */
	public static final String DOCUMENT_FOLDER_PATH = "folderpath";
}