package com.plumtree.portalpages.browsing.directory.rest;

import com.plumtree.portalpages.rest.*;

/**
 * This class enumerates the errors generated by the KD Rest API.
 * 
 * 2000 - 2499 is reserved for KD errors.
 */
public class DirRestErrors extends ARESTErrors implements IRESTError
{
	public static final IRESTError NO_JSON_DOCUMENT_OBJECT = new DirRestErrors(2000, "Document node not " +
		"in JSON document.");
	public static final IRESTError NO_FOLDER_ID = new DirRestErrors(2010, "The API URL did not contain " +
		"the folder ID.");
	public static final IRESTError NO_DATA_SOURCE_ID = new DirRestErrors(2020, "The API data did not include a valid data source ID.");
	public static final IRESTError NO_CONTENT_URL = new DirRestErrors(2030, "The API data did not include a valid content source URL.");

	private DirRestErrors(int _nCode, String _strMessage)
	{
		super(_nCode, _strMessage);
	}

	/**
	 * @see com.plumtree.portalpages.rest.IRESTError.GetCode()
	 */
	public int GetCode()
	{
		return m_nCode;
	}

	/**
	 * @see com.plumtree.portalpages.rest.IRESTError.GetMessage()
	 */
	public String GetMessage()
	{
		return m_strMessage;
	}
}