package com.plumtree.portalpages.browsing.editors.community;

import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.securitymatrix.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author MichaelD
 */
public class ABOCommPopupSelectView extends ABOPopupSelectView {
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.editors.community.ABOCommPopupSelectView");

	/** object class name */
	public static final String STR_MVC_CLASS_NAME = "ABOCommPopupSelectView";

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display() {
		HTMLElement result = new HTMLElementCollection();
		HTMLSpan mySpan;
		HTMLTable myTable;
		HTMLInput myInput;
		HTMLTableRow myRow;
		HTMLTableCell myCell;

		try
		{
			// create table
			myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetBorder("0");
			myTable.SetWidth("100%");
			myTable.SetStyleClass(PTStyleClass.DIALOGUE_BG);
			myTable.SetCellPadding("0");
			myTable.SetCellSpacing("10");

			// add title
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetColSpan("2");
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.ALERT_DIALOG_TITLE);
			mySpan.AddInnerHTMLString(m_asOwner.GetString(1712, "ptmsgs_portalbrowsingmsgs"));

			// add paragraph 1
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetColSpan("2");
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);
			mySpan.AddInnerHTMLString(m_asOwner.GetString(1713, "ptmsgs_portalbrowsingmsgs"));

			//add "Changes will be applied by a job and may not..."
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetColSpan("2");
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);
			mySpan.AddInnerHTMLString(m_asOwner.GetString(1714, "ptmsgs_portalbrowsingmsgs"));
			HTMLBr myBr = new HTMLBr();
			mySpan.AddInnerHTMLElement(myBr);
			mySpan.AddInnerHTMLElement(myBr);

			//add "Changes will be applied by a job and may not..."
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetColSpan("2");
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.ALERT_DIALOG_TEXT);
			HTMLB myBold = new HTMLB();
			mySpan.AddInnerHTMLElement(myBold);
			myBold.AddInnerHTMLString(m_asOwner.GetString(1715, "ptmsgs_portalbrowsingmsgs"));

			// add buttons - create table
			// add buttons - add new row
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetColSpan("2");
			myCell.SetAlign(CommonHTMLStrings.CENTER);
			myRow.AddInnerHTMLElement(myCell);

			// add buttons - add apply to all button (apply later)
			myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_APPLY, "");
			myCell.AddInnerHTMLElement(myInput);
			myInput.SetValue(m_asOwner.GetString(2547, "ptmsgs_portaladminmsgs"));
			myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
			myInput.SetOnClick(JAVASCRIPT_APPLY_ON_OPENER + "(true); return false;");

			// add spacer between buttons
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

			// add buttons - add apply to all button (apply later)
			myInput = new HTMLInput(HTMLInputTypes.BUTTON, HTMLBUTTON_APPLY, "");
			myCell.AddInnerHTMLElement(myInput);
			myInput.SetValue(m_asOwner.GetString(2628, "ptmsgs_portaladminmsgs"));
			myInput.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
			myInput.SetOnClick(JAVASCRIPT_APPLY_ON_OPENER + "(false); return false;");

			//add end row
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetColSpan("2");
			myCell.SetAlign(CommonHTMLStrings.CENTER);
			myCell.SetHeight("5");
			myRow.AddInnerHTMLElement(myCell);

		} catch (HTMLException he) {
			
				log.Error(he, "Unable to create warnings: " + he.getMessage());
			
		}

		return result;
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create() {
		return new ABOCommPopupSelectView();
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

}

