package com.plumtree.portalpages.browsing.editors.community;

// Framework imports
import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.browsing.objectselection.*;
import com.plumtree.portalpages.browsing.objectselection.communities.*;
import com.plumtree.portalpages.common.helpers.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This Section contains the HTML for the dependencies page.
 *
 * @author 
 */
public class CommunityDependenciesView extends ObjDependenciesView
{
	//Member variables
	private CreatedHelper m_chHelper	  = null;
	/** <0 use default, 0 none, >0 use specified */
	public static final int OFFSET = -1; // <0 use default, 0 none, >0 use specified

	/** <0 use default, 0 none, >0 use specified */
	public static final int BREAK = -1; // <0 use default, 0 none, >0 use specified

	
	/**
	 * Class name for the activity space
	 */
	public static final String STR_MVC_CLASS_NAME = "CommunityDependencies";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new CommunityDependenciesView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(com.plumtree.uiinfrastructure.activityspace.IModelRO, com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		super.Init(model, parent);
		m_chHelper = new CreatedHelper(parent, (CommunityEditorModel) model);
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.ObjDependenciesView#GetHTMLForDependencies()
	 */
	protected HTMLElementCollection GetHTMLForDependencies()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLAnchor myAnchor;

		// PAI - have to take the object name off the folder path because communities have their own admin folder,
		// so it looks like the community name is being shown in the path
		String strOriginalParentFolderPath = ((ObjEditorModel) m_model).GetParentFolderPath();
		String strObjectName = ((ObjEditorModel) m_model).GetObjectName();
		int nLengthOfRealFolderPath = strOriginalParentFolderPath.length() - strObjectName.length();
		String strNewParentFolderPath = strOriginalParentFolderPath.substring(0, nLengthOfRealFolderPath - 1); 

		//Display the standard success message		
		m_chHelper.displaySuccessMessage(result, m_asOwner.GetString(1468, "ptmsgs_portalbrowsingmsgs"), strObjectName, strNewParentFolderPath);
		
		//Generate a popup URL to invite people to this community
		ASURL asurl = new ASURL(m_asOwner);
		asurl.SetLinkCreateNewSpace(CommunitySelectionEditorAS.STR_MVC_CLASS_NAME, m_asOwner);
		asurl.SetControl(InvitationPopupControl.STR_MVC_CLASS_NAME);
		asurl.SetDisplayPage(CommunityInvitationPopupDP.STR_MVC_CLASS_NAME);
		asurl.AddControlArgument(InvitationPopupControl.strTemporaryInvitationID,
			XPConvert.ToString(((CommunityEditorModel) m_model).GetObjectID()));
		asurl.AddControlArgument(InvitationPopupControl.strTemporaryInvitationName,
			((CommunityEditorModel) m_model).GetObjectName());
		
		String strJSUtilVersionPrefix = ConfigHelper.GetJSIncluderVersionPrefix(ConfigHelper.JSCOMPONENT_JSUTIL);
		myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
		myAnchor.SetOnClick(strJSUtilVersionPrefix+"PTWindowUtil.openWindow('" +
						asurl.GetURLAsString() + "', 'SendToOthers', '250','600'); return false;");

		m_chHelper.beginList(result);

		HTMLSpan mySpan = new HTMLSpan();
		mySpan.AddInnerHTMLString(m_asOwner.GetString(1467, "ptmsgs_portalbrowsingmsgs"));

		myAnchor.AddInnerHTMLElement(mySpan);

		m_chHelper.displayListRow(myAnchor);

		//Display the standard warning if everyone has access to this object		
		m_chHelper.displayEveryoneWarning(result, m_model, m_asOwner.GetString(1468, "ptmsgs_portalbrowsingmsgs"));
		
		return result;
	}
}

