package com.plumtree.portalpages.browsing.editors.community;

import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

// Framework Imports

/**
 * This is class is used to print out together the Views for
 * the Expandable List page of the List Editor.
 *
 * @author Julie Fournier
 */
public class CommunityEditorCommGroupDP extends EditorDP {
	
	public static final String STR_MVC_CLASS_NAME = "CommunityGroup";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString() {
		// ***CHANGE_HERE*** Returns the String to display on the left navigation menu, 
		//       linking to that page.
		// ***COMMENT_1*** That String will also be printed out in the page header, so
		//     even if you don't use the left nav menu, it should still return something.
		return (m_asOwner.GetString(231, "ptmsgs_portalbrowsingmsgs"));
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader()
	{
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(1080, "ptmsgs_portalbrowsingmsgs"),
			this.m_asOwner);
	}

	// Strings to localize.
	// ***CHANGE_HERE*** List of the Strings that need to be localized.
	// ***COMMENT_1*** The names should all start with "_ui_".

	
	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for that Page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()
	 *
	 * @return HTMLElement
	 * @throws HTMLException
	 */
	public HTMLElement PageDisplay() {
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		// ***CHANGE_HERE SELECTPTOBJECT*** Display the list.
		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(CommunityEditorAS.PLUGIN_COMMUNITY_GROUP_LIST))
				.Display());

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		myScripts.AddInnerHTMLElement(
			m_asOwner
				.GetView(CommunityEditorAS.PLUGIN_COMMUNITY_GROUP_LIST)
				.DisplayJavascript());

		return myScripts;
	}
}

