package com.plumtree.portalpages.browsing.editors.community;

// Framework Imports
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 *
 * @author MichaelD
 */
public class CommunityEditorPortletPreferencesDP extends EditorDP {
	/** Object Name */
	public static final String STR_MVC_CLASS_NAME =
		"CommunityEditorPortletPreferences";

	/** Constructor for CommunityEditorPortletPreferencesDP */
	public CommunityEditorPortletPreferencesDP() {
		super();
		super.SetContentTableCellSpacing("0");
	}

	/**
	 * Returns the String to display on the left navigation menu,  linking to
	 * that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString() {
		return m_asOwner.GetString(233, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader() 
	{
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(1082, "ptmsgs_portalbrowsingmsgs"),
			this.m_asOwner);
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the General Info page.
	 *
	 * @return HTMLElement
	 *
	 * @throws HTMLException 
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 */
	public HTMLElement PageDisplay() {
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		// ***CHANGE_HERE*** For each Section you want to display on that page, 
		//       copy the line bellow and change the name of the Section.
		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(PortletPreferencesView.STR_MVC_CLASS_NAME))
				.Display());

		// ***CHANGE_HERE PLUG-IN ONLY*** (delete if you are not using a plug-in section)
		//      This is where you print out the plug-in view.
		//views.AddInnerHTMLElement(m_asOwner.GetView(SamplePlugInView.STR_MVC_CLASS_NAME).Display());
		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		// ***CHANGE_HERE*** If that DP doesn't have any JavaScripts, 
		//      you can delete the entire DisplayJavaScriptFromChild() method.
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		// ***CHANGE_HERE*** Call the DisplayJavascript() method for all the Views having JavaScripts 
		//      displayed by that DP.
		myScripts.AddInnerHTMLElement(
			m_asOwner
				.GetView(PortletPreferencesView.STR_MVC_CLASS_NAME)
				.DisplayJavascript());
				
		HTMLScript script = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);	
		script.SetSrc(ConfigHelper.GetPortalImageServerJavaScriptURL(m_asOwner) + "opennewwindow.js");
		myScripts.AddInnerHTMLElement(script);

		return myScripts;
	}
}

