package com.plumtree.portalpages.browsing.editors.community;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.constants.*;
import com.plumtree.portaluiinfrastructure.expandablelist.template.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.xpshared.htmlconstructs.*;

/**
 * @author michaeld
 */
public class CommunityTemplateSelectorModel extends TemplateListModel
{
	private static OpenLogger log = OpenLogService.GetLogger(
			OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
			"com.plumtree.portalpages.browsing.editors.community.CommunityTemplateSelectorModel");

	/** Object Name */
	public final static String STR_MVC_CLASS_NAME = "CommunityTemplateSelector";

	public void InitializeCommunityTemplateSelector(IPTSession _Session, int _nCommunityTemplateID, boolean bInheritCommunityTemplate, int _nListKey)
	{
		if (0 == _nCommunityTemplateID)
		{
			// template not selected yet
			SetAddLabel(m_asOwner.GetString(307, ResourceConstants.PORTALBROWSINGMSGS));
		}
		else
		{
			SetAddLabel(m_asOwner.GetString(1236, ResourceConstants.PORTALBROWSINGMSGS));
		}
		
		InitializeTemplateList(_Session, PT_CLASSIDS.PT_COMMUNITYTEMPLATE_ID, _nCommunityTemplateID, bInheritCommunityTemplate,
			m_asOwner.GetString(1817, ResourceConstants.PORTALBROWSINGMSGS), PTImageType.ICON_COMMUNITY_TEMPLATE, _nListKey);
	}

	/**
	 * Instead of adding rows on repost we are setting the community template which can add a few rows at once.
	 *
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListModel#AddRowsOnRepost(XPHashtable)
	 */
	public void AddRowsOnRepost(XPHashtable _htFormData)
	{
		super.AddRowsOnRepost(_htFormData);
		
		String strCommunityTemplateName = XPConvert.ToString(m_saData.GetItem(0, TemplateListModel.EXPLIST_COL_TEMPLATE_NAME));
		int nCommunityTemplateID = XPConvert.ToInteger(m_saData.GetItem(0, TemplateListModel.EXPLIST_COL_TEMPLATE_ID));

		if ( !("").equals(strCommunityTemplateName) )
		{
			// store the community.
			((CommunityEditorModel) m_asOwner.GetModel(CommunityEditorAS.STR_MVC_CLASS_NAME)).CommunityTempStore();

			if (0 != nCommunityTemplateID)
			{
				m_sAddLabel = m_asOwner.GetString(1236, "ptmsgs_portalbrowsingmsgs");
			}
		}
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new CommunityTemplateSelectorModel();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}
