package com.plumtree.portalpages.browsing.editors.community;

// Framework Imports
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 *
 * @author MichaelD
 */
public class HeaderAndFooterSelectorDP extends EditorDP {
	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "HeaderAndFooterSelector";

	/**
	 * Returns the String to display on the left navigation menu,  linking to
	 * that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return m_asOwner.GetString(223, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader() 
	{
		if ( CommunityEditorAS.STR_MVC_CLASS_NAME == m_asOwner.GetName() )
		{
			// if this is a community
			return HTMLConstructHelpers.GetSubHeader(
				m_asOwner.GetString(1078, "ptmsgs_portalbrowsingmsgs"),
				this.m_asOwner); 
		}	
		// if this is a community template
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(1445, "ptmsgs_portalbrowsingmsgs"),
			this.m_asOwner);
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the General Info page.
	 *
	 * @return HTMLElement
	 *
	 * @throws HTMLException 
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 */
	public HTMLElement PageDisplay() {
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(HeaderAndFooterSelectorView.STR_MVC_CLASS_NAME))
				.Display());

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	 * This is a helper method that all classes that inherit from PlumtreeDP need
	 * to implement.  The method should add whatever HTML the child class wants to
	 * use the DisplayJavaScript and add it to the head.
	 *
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#DisplayJavaScriptFromChild()
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection result = super.DisplayJavaScriptFromChild();

		// Display JavaScripts for the Banner Section list.
		result.AddInnerHTMLElement(
			m_asOwner
				.GetView(HeaderAndFooterSelectorView.STR_MVC_CLASS_NAME)
				.DisplayJavascript());

		return result;
	}
}

