/**
 * Created on Dec 16, 2002
 *
 * To change this generated comment edit the template variable "filecomment":

 * To enable and disable the creation of file comments go to

 */
package com.plumtree.portalpages.browsing.editors.community;


import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.editors.communitytemplate.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.portaluiinfrastructure.tree.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.uiinfrastructure.htmlconstructs.*;
import com.plumtree.uiinfrastructure.tree.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author robertz
 *
 */
public class HeaderAndFooterSelectorView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.editors.community.HeaderAndFooterSelectorView");

	
	public static final String STR_MVC_CLASS_NAME = "HeaderAndFooter";

	/** Subspace key for the gateway subspace */
	public static final String TREE_HEADER_SUBSPACE = "TreeHeaderSubSpace";

	/** Subspace key for the gateway subspace */
	public static final String TREE_FOOTER_SUBSPACE = "TreeFooterSubSpace";

	
	public final static String HTMLHIDDEN_HEADERSPACE_ID = "in_hi_headerSpaceID";

	
	public final static String HTMLHIDDEN_HEADER_SELECTED = "in_hi_headerSelected";

	
	public final static String HTMLHIDDEN_FOOTERSPACE_ID = "in_hi_footerSpaceID";

	
	public final static String HTMLHIDDEN_FOOTER_SELECTED = "in_hi_footerSelected";
	
	public final static String HTMLCHECKBOX_FORCE_SUBPORTAL = "in_cb_forceSubPortal";
	/**
	 * Private String that is the function name for the repost javascript called
	 * when the tree control returns
	 */
	private static final String JSREPOST_HEADER_FUNC	   = "frmRepostHeaderChosen";
	private static final String JSREPOST_HEADER_FUNC_INPUT = "frmSetHeaderChosen";
	private static final String JSREPOST_FOOTER_FUNC	   = "frmRepostFooterChosen";
	private static final String JSREPOST_FOOTER_FUNC_INPUT = "frmSetFooterChosen";
	private static final String JSREPORT_FORCESUBPORTAL_FUNC="forceSubPortalHeaderAndFooter";
	private static final String JSREPOST_USEDEFAULT_FUNC   = "useDefaultHeaderOrFooter";

	/**
	 *
	 * @param objName
	 * @param strLabel
	 * @param strSpaceIDInput
	 * @param strJSFunction
	 * @return HTMLTable
	 * @throws HTMLException
	 */
	public HTMLTable CreateSingleSelectObjectTable(String objName,
		boolean bHasCommunityPrefs, String strLabel, String strSpaceIDInput,
		String strJSFunction, int nPortletID, boolean bIsFooter)
	{
		HTMLTable myTable;
		HTMLTableCell myCell;
		HTMLTableRow myRow;
		HTMLInput myInput;

		HTMLSpan mySpan;

		// Containing Table
		myTable = new HTMLTable();

		myTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
		myTable.SetBorder("0");
		myTable.SetCellPadding("1");
		myTable.SetCellSpacing("0");
		myTable.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

		// 1st row begins (Top Margin)
		this.AddEmptyRowToTable(myTable, "3");
		// 1st row ends

		// 2nd row begins
		myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

		// 1st column
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
		myCell.SetWidth("25%");
		myCell.SetNoWrap(true);
		mySpan = new HTMLSpan();
		myCell.AddInnerHTMLElement(mySpan);
		mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);

		mySpan.AddInnerHTMLString(SPACE + strLabel + SPACE + SPACE);

		// 2nd column
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
		myCell.SetWidth("40%");
		myCell.SetAlign(CommonHTMLStrings.LEFT);

		int nCommID = ((IHeaderAndFooterModel) m_model).GetCommunityID();

		if ((nPortletID > 0) && (nCommID > 0) && bHasCommunityPrefs)
		{
			HTMLImg htmlImg = null;

			try
			{
				htmlImg = (HTMLImg) UIConstructFactory.GetConstruct(PTImageType.ACTION_EDIT,
						true, this.m_asOwner).GetHTMLElement();

				htmlImg.SetAlt(m_asOwner.GetString(303,
						"ptmsgs_portalbrowsingmsgs"));
				htmlImg.SetAlign(CommonHTMLStrings.ABSMIDDLE);
				htmlImg.SetBorder(CommonHTMLStrings.ZERO);
			}
			catch (Exception e)
			{
				// TODO CR DLH: Why do we ignore this?
			}

			// Link to the portlet editor.
			//			ASURL url = new ASURL(m_asOwner);
			//			url.SetSpaceCreateNew(PortMainPortletEditorAS.STR_MVC_CLASS_NAME, m_asOwner);
			//			url.SetControl(EditorStartControl.STR_MVC_CLASS_NAME);
			//			url.AddControlArgument(ObjEditorModel.EDITOR_QS_INT_QS_OBJECT_ID, nPortletID);
			//			url.AddControlArgument(ObjEditorModel.EDITOR_QS_INT_CLASS_ID, XPConvert.ToString(PT_CLASSIDS.PT_GADGET_ID));			
			//			url.AddControlArgument(EditorStartControl.QS_EDITOR_TYPE, EditorStartControl.EDITOR_START_FLAG_EDIT);
			String commPrefsURL = GatewayHelpers.ConstructCommunityPrefsLink(m_asOwner,
					nPortletID, nCommID, true);
			HTMLAnchor anchor   = new HTMLAnchor(commPrefsURL);

			anchor.AddInnerHTMLElement(htmlImg);
			anchor.AddInnerHTMLString(SPACE);
			anchor.AddInnerHTMLEncodedString(objName);

			// bjf -- set a target so the window will close itself properly.
			anchor.SetTarget("blank666");
			myCell.AddInnerHTMLElement(anchor);
			myCell.AddInnerHTMLString(SPACE + SPACE);
		}
		else
		{
			// Just a label, not a real portlet.
			myCell.AddInnerHTMLEncodedString(objName);
			myCell.AddInnerHTMLString(SPACE + SPACE);
		}

		// spacer cell
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
		myCell.SetWidth("10");
		myCell.SetNoWrap(true);
		myCell.AddInnerHTMLElement(new HTMLBr());

		////// Actual Tree Control
		// Hidden input for the Space ID for the tree.  That way if you hit the folder
		// tree link twice, it will open the same tree both times.
		// 3rd column
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
		myCell.SetWidth("10%");
		myCell.SetNoWrap(true);
		
		IHeaderAndFooterModel model = (IHeaderAndFooterModel) m_model;
		
		// bjf -- show the browse button only if we're not using the header or footer from the community template
		boolean bShowButton = false;
		if (bIsFooter)
		{
			if (m_asOwner.GetString(301, "ptmsgs_portalbrowsingmsgs").equals(strLabel) &&
				!((IHeaderAndFooterModel) m_model).UsingFooterFromCommunityTemplate())
					bShowButton = true;			
		}
		else // header
		{
			if (m_asOwner.GetString(300, "ptmsgs_portalbrowsingmsgs").equals(strLabel) &&
				!((IHeaderAndFooterModel) m_model).UsingHeaderFromCommunityTemplate())
					bShowButton = true;			
		}
		
		
		// form the button for diaply
		if ( nPortletID == CommunityTemplateModel.HEADERFOOTER_ID_FORCE_SUBPORTAL && model.IsTemplateSelector() )
		{
			// Dont show the browse button and say the header/footer is forced to use the subportal
			myCell.AddInnerHTMLString("(" + m_asOwner.GetString(1480, "ptmsgs_portalbrowsingmsgs") + ")");
		}
		// bjf -- show the browse button only if we're not using the header or footer from the community template
		// dap -- *or* if you have access to the community template, allowing you to make the set
		else if (bShowButton)
		{
			myInput = new HTMLInput(HTMLInputTypes.HIDDEN, strSpaceIDInput, "");
			myCell.AddInnerHTMLElement(myInput);

			String strTreeSpaceID = ((IHeaderAndFooterModel) m_model).GetData(strSpaceIDInput);

			
				log.Info(" TreeID for the " + strLabel + " name: " + strTreeSpaceID);
			

			if (strTreeSpaceID.equals(""))
			{
				myInput.SetValue("");
			}
			else
			{
				myInput.SetValue(strTreeSpaceID);
			}

			String strOnClick = strJSFunction + "(document." +	// mj: removed 'javascript:' from function name
				AFormDP.HTMLFORM_NAME + "." + strSpaceIDInput + ");";

			myCell.AddInnerHTMLElement(MakeSimpleButton(m_asOwner.GetString(
						299, "ptmsgs_portalbrowsingmsgs"), strOnClick));
		}
		else
		{
			myCell.AddInnerHTMLString("(" + m_asOwner.GetString(304, "ptmsgs_portalbrowsingmsgs") + ")");
		}

		myCell.AddInnerHTMLElement(new HTMLBr());

		// Delete button
		// 4th column
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
		myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
		myCell.SetAlign(CommonHTMLStrings.MIDDLE);

		// if they can pick one they can remove it also
		if (nPortletID > 0 && bShowButton) 
		{
			if (m_asOwner.GetString(300, "ptmsgs_portalbrowsingmsgs").equals(strLabel) &&
					!model.UsingHeaderFromCommunityTemplate())
			{
				myCell.AddInnerHTMLElement(MakeSimpleButton(m_asOwner.GetString(
							302, "ptmsgs_portalbrowsingmsgs"),
						JSREPOST_USEDEFAULT_FUNC + "(true)"));	// mj: removed 'javascript:' from function name

			}
			else if (m_asOwner.GetString(301, "ptmsgs_portalbrowsingmsgs")
					.equals(strLabel) &&
					!model.UsingFooterFromCommunityTemplate())
			{
				myCell.AddInnerHTMLElement(MakeSimpleButton(m_asOwner.GetString(
							302, "ptmsgs_portalbrowsingmsgs"),
						JSREPOST_USEDEFAULT_FUNC + "(false)"));	// mj: removed 'javascript:' from function name
			}
		}
		
		

		myCell.AddInnerHTMLElement(new HTMLBr());
		this.AddEmptyRowToTable(myTable, "3");

		return myTable;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		try
		{
			// Header view
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						294, "ptmsgs_portalbrowsingmsgs")));

			IHeaderAndFooterModel mModel = (IHeaderAndFooterModel) super.m_model;

			///// Don't forget to HTMLEncode this stuff..... Important!
			// Header view
			String objName					 = mModel.GetHeaderName();
			boolean bHeaderHasCommunityPrefs = false;

			if ((null == objName) || (0 >= objName.length()))
			{
				objName = m_asOwner.GetString(297, "ptmsgs_portalbrowsingmsgs");
			}
			else
			{
				bHeaderHasCommunityPrefs = mModel.GetHeaderHasCommunityPrefs();
			}

			int nHeaderID = mModel.GetHeaderID();

			result.AddInnerHTMLElement(
					CreateSingleSelectObjectTable(objName,
					bHeaderHasCommunityPrefs,
					m_asOwner.GetString(300, "ptmsgs_portalbrowsingmsgs"),
					HTMLHIDDEN_HEADERSPACE_ID, 
					JSREPOST_HEADER_FUNC_INPUT,
					nHeaderID,false));

			HTMLInput myInput = new HTMLInput(HTMLInputTypes.HIDDEN,
					HTMLHIDDEN_HEADER_SELECTED, "");
			result.AddInnerHTMLElement(myInput);
			myInput.SetValue(mModel.GetData(HTMLHIDDEN_HEADER_SELECTED));

			result.AddInnerHTMLElement(new HTMLBr());
			result.AddInnerHTMLElement(new HTMLBr());

			// Footer view
			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						295, "ptmsgs_portalbrowsingmsgs")));
			objName = mModel.GetFooterName();

			boolean bFooterHasCommunityPrefs = false;

			if ((null == objName) || (0 >= objName.length()))
			{
				objName = m_asOwner.GetString(298, "ptmsgs_portalbrowsingmsgs");
			}
			else
			{
				bFooterHasCommunityPrefs = mModel.GetFooterHasCommunityPrefs();
			}

			int nFooterID = mModel.GetFooterID();

			result.AddInnerHTMLElement(CreateSingleSelectObjectTable(objName,
					bFooterHasCommunityPrefs,
					m_asOwner.GetString(301, "ptmsgs_portalbrowsingmsgs"),
					HTMLHIDDEN_FOOTERSPACE_ID, JSREPOST_FOOTER_FUNC_INPUT,
					nFooterID,true));

			myInput = new HTMLInput(HTMLInputTypes.HIDDEN,
					HTMLHIDDEN_FOOTER_SELECTED, "");
			result.AddInnerHTMLElement(myInput);
			myInput.SetValue(((IHeaderAndFooterModel) m_model).GetData(
					HTMLHIDDEN_FOOTER_SELECTED));
					
				
			if ( ((IHeaderAndFooterModel)m_model).IsTemplateSelector() ) 
			{
				result.AddInnerHTMLElement(new HTMLBr());
				result.AddInnerHTMLElement(new HTMLBr());
				result.AddInnerHTMLElement(CreateForceSubPortalCheckBox());	
			}
			
		}
		catch (Exception e)
		{
			
				log.Error(e, "HeaderAndFooterSelectorView::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			
		}

		return result;
	}

	/**
	 * This method returns the HTMLScript that encompasses the Javascript on the page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 *
	 * @return HTMLScript
	 */
	public HTMLScript DisplayJavascript()
	{
		String strFormName = AFormDP.HTMLFORM_NAME;

		HTMLScript result = new HTMLScript("text/javaScript");

		try
		{
			// The URL to open a new folder tree
			ASURL headerTree = new ASURL(m_asOwner);
			headerTree.SetLinkCreateNewSpace(TreeAS.STR_MVC_CLASS_NAME, m_asOwner);
			headerTree.SetSubSpaceKey(HeaderAndFooterSelectorView.TREE_HEADER_SUBSPACE);
			headerTree.SetControl(StartTreeControl.STR_MVC_CLASS_NAME);
			headerTree.AddControlArgument(StartTreeControl.ROOT_ID, "1");
			headerTree.AddControlArgument(StartTreeControl.MULTI_SELECT, XPConvert.ToString(false));
			headerTree.AddControlArgument(StartTreeControl.SELECT_MODE,
				XPConvert.ToString(TreeConstants.N_LEAFSELECT));
			headerTree.AddControlArgument(StartTreeControl.SUBMIT_MODE,
				XPConvert.ToString(TreeConstants.N_SERVERSUBMIT));
			headerTree.AddControlArgument(StartTreeControl.PARENT_FORM_NAME,
				strFormName);
			headerTree.AddControlArgument(StartTreeControl.PARENT_FORM_SPACE_ID,
				HTMLHIDDEN_HEADERSPACE_ID);
			headerTree.AddControlArgument(StartTreeControl.PARENT_SUBMIT_CALL,
				JSREPOST_HEADER_FUNC);
			headerTree.AddControlArgument(StartTreeControl.CLASS_IDS_TO_DISPLAY,
				XPConvert.ToString(PT_CLASSIDS.PT_GADGET_ID));
			headerTree.AddControlArgument(StartTreeControl.TITLE,
				m_asOwner.GetString(1233, "ptmsgs_portalbrowsingmsgs"));
			headerTree.AddControlArgument(StartTreeControl.ACTIONSUBTITLE,
				m_asOwner.GetString(1231, "ptmsgs_portalbrowsingmsgs"));
			headerTree.AddControlArgument(StartTreeControl.QUERY_FILTER,
				XPConvert.ToString(PT_CLASSIDS.PT_GADGET_ID) + "," +
				XPConvert.ToString(PT_PROPIDS.PT_PROPID_GADGET_ALIGNMENT) + "," +
				XPConvert.ToString(PT_GADGET_ALIGNMENTS.PT_GADGETALIGN_HEADER));
			if ( 0 < ((IHeaderAndFooterModel)m_model).GetCommunityID() )
			{
				headerTree.AddControlArgument(StartTreeControl.COMMUNITY_MODE,
					AObjectTreeModel.THISCOMMUNITY);
				headerTree.AddControlArgument(StartTreeControl.COMMUNITY_FOLDER_ID,
					((IHeaderAndFooterModel)m_model).GetCommunityFolderID());
			}

			// The url to open a previously opened folder tree
			// This needs to have the SpaceID added to it.
			ASURL oldTree = new ASURL(m_asOwner);
			oldTree.SetLinkCreateNewSpace(TreeAS.STR_MVC_CLASS_NAME, m_asOwner);
			oldTree.IsSubSpace();

			// Test Server Side From Submit function
			XPStringBuilder sbHeader = new XPStringBuilder(300);
			sbHeader.Append("function ").Append(JSREPOST_HEADER_FUNC).Append("()\n");
			sbHeader.Append("{\n");
			sbHeader.Append("  postToSelf(")
			.Append(HeaderAndFooterRepostControl.POSTTOSELF_ACTION_SELECTHEADER)
			.Append(");\n");
			sbHeader.Append("}\n");

			// Open folder tree function
			sbHeader.Append("function ").Append(JSREPOST_HEADER_FUNC_INPUT)
			.Append("(myInput)\n");
			sbHeader.Append("{\n");
			sbHeader.Append("  if (myInput.value == '') {\n");
			sbHeader.Append("    window.open('")
			.Append(headerTree.GetURLAsString()).Append("', '_blank1', '")
			.Append(TreeConstants.GetJavascriptTreeWindowAttributes()).Append("');\n");
			sbHeader.Append("  } else {\n");
			sbHeader.Append("    window.open('").Append(oldTree.GetURLAsString())
			.Append("&").Append(ASConstants.SPACEID).Append("=' + myInput.value")
			.Append(", '_blank1', '")
			.Append(TreeConstants.GetJavascriptTreeWindowAttributes()).Append("');\n");
			sbHeader.Append("  }\n");
			sbHeader.Append("}\n");
			result.AddInnerHTMLString(sbHeader.ToString());

			ASURL footerTree = new ASURL(m_asOwner);
			footerTree.SetLinkCreateNewSpace(TreeAS.STR_MVC_CLASS_NAME, m_asOwner);
			footerTree.SetSubSpaceKey(HeaderAndFooterSelectorView.TREE_FOOTER_SUBSPACE);
			footerTree.SetControl(StartTreeControl.STR_MVC_CLASS_NAME);
			footerTree.AddControlArgument(StartTreeControl.ROOT_ID, "1");
			footerTree.AddControlArgument(StartTreeControl.MULTI_SELECT, XPConvert.ToString(false));
			footerTree.AddControlArgument(StartTreeControl.SELECT_MODE,
				XPConvert.ToString(TreeConstants.N_LEAFSELECT));
			footerTree.AddControlArgument(StartTreeControl.SUBMIT_MODE,
				XPConvert.ToString(TreeConstants.N_SERVERSUBMIT));
			footerTree.AddControlArgument(StartTreeControl.PARENT_FORM_NAME,
				strFormName);
			footerTree.AddControlArgument(StartTreeControl.PARENT_FORM_SPACE_ID,
				HTMLHIDDEN_FOOTERSPACE_ID);
			footerTree.AddControlArgument(StartTreeControl.PARENT_SUBMIT_CALL,
				JSREPOST_FOOTER_FUNC);
			footerTree.AddControlArgument(StartTreeControl.CLASS_IDS_TO_DISPLAY,
				XPConvert.ToString(PT_CLASSIDS.PT_GADGET_ID));
			footerTree.AddControlArgument(StartTreeControl.TITLE,
				m_asOwner.GetString(1232, "ptmsgs_portalbrowsingmsgs"));
			footerTree.AddControlArgument(StartTreeControl.ACTIONSUBTITLE,
				m_asOwner.GetString(1230, "ptmsgs_portalbrowsingmsgs"));
			footerTree.AddControlArgument(StartTreeControl.QUERY_FILTER,
				XPConvert.ToString(PT_CLASSIDS.PT_GADGET_ID) + "," +
				XPConvert.ToString(PT_PROPIDS.PT_PROPID_GADGET_ALIGNMENT) + "," +
				XPConvert.ToString(PT_GADGET_ALIGNMENTS.PT_GADGETALIGN_FOOTER));
			if ( 0 < ((IHeaderAndFooterModel)m_model).GetCommunityID() )
			{
				footerTree.AddControlArgument(StartTreeControl.COMMUNITY_MODE,
					AObjectTreeModel.THISCOMMUNITY);
				footerTree.AddControlArgument(StartTreeControl.COMMUNITY_FOLDER_ID,
					((IHeaderAndFooterModel)m_model).GetCommunityFolderID());
			}

			oldTree = new ASURL(m_asOwner);
			oldTree.SetLinkCreateNewSpace(TreeAS.STR_MVC_CLASS_NAME, m_asOwner);
			oldTree.IsSubSpace();

			// Test Server Side From Submit function
			XPStringBuilder sbFooter = new XPStringBuilder(300);
			sbFooter.Append("function ").Append(JSREPOST_FOOTER_FUNC).Append("()\n");
			sbFooter.Append("{\n");
			sbFooter.Append("  postToSelf(")
			.Append(HeaderAndFooterRepostControl.POSTTOSELF_ACTION_SELECTFOOTER)
			.Append(");\n");
			sbFooter.Append("}\n");

			// Open folder tree function
			sbFooter.Append("function ").Append(JSREPOST_FOOTER_FUNC_INPUT)
			.Append("(myInput)\n");
			sbFooter.Append("{\n");
			sbFooter.Append("  if (myInput.value == '') {\n");
			sbFooter.Append("    window.open('")
			.Append(footerTree.GetURLAsString()).Append("', '_blank2', '")
			.Append(TreeConstants.GetJavascriptTreeWindowAttributes()).Append("');\n");
			sbFooter.Append("  } else {\n");
			sbFooter.Append("    window.open('").Append(oldTree.GetURLAsString())
			.Append("&").Append(ASConstants.SPACEID).Append("=' + myInput.value")
			.Append(", '_blank2', '")
			.Append(TreeConstants.GetJavascriptTreeWindowAttributes()).Append("');\n");
			sbFooter.Append("  }\n");
			sbFooter.Append("}\n");
			result.AddInnerHTMLString(sbFooter.ToString());

			XPStringBuilder delete = new XPStringBuilder(100);
			delete.Append("function " + JSREPOST_USEDEFAULT_FUNC +
				"(bHeader)\n");
			delete.Append("{\n");
			delete.Append("if ( bHeader ) {\n");
			delete.Append("		postToSelf(" +
				HeaderAndFooterRepostControl.POSTTOSELF_ACTION_USEDEFAULTHEADER +
				");\n");
			delete.Append("	} else {\n");
			delete.Append(" 	postToSelf(" +
				HeaderAndFooterRepostControl.POSTTOSELF_ACTION_USEDEFAULTFOOTER +
				");\n");
			delete.Append("	}\n");
			delete.Append("}\n");
			result.AddInnerHTMLString(delete.ToString());
			
			String strOut =
			 "function "+JSREPORT_FORCESUBPORTAL_FUNC+"(bForce)\n"
			+"{\n"
			+"\t if ( bForce ) { \n"
			+"\t 	postToSelf("+HeaderAndFooterRepostControl.POSTTOSELF_ACTION_SETUSEFORCE_SUBPORTAL+");\n"
			+"\t }else {\n"
			+"\t 	postToSelf("+HeaderAndFooterRepostControl.POSTTOSELF_ACTION_DONOTFORCE_SUBPORTAL+");\n"
			+"} }"
			;
			result.AddInnerHTMLString(strOut);
		}
		catch (HTMLException he)
		{
			
				log.Error(he, "DisplayJavascript couldn't add javascript to the HTMLScript element: " +
					he.getMessage());
			
		}

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @param strText 
	 * @param strOnClick 
	 *
	 * @return 
	 */
	public static HTMLElement MakeSimpleButton(String strText, String strOnClick)
	{
		return MakeSimpleButton(strText, strText, PTStyleClass.OBJECT_TEXT,
			PTStyleClass.FORM_BTN_TEXT, strOnClick);
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new HeaderAndFooterSelectorView();
	}
	
//	private boolean IsSubPortalForced()
//	{
//		IHeaderAndFooterModel model = (IHeaderAndFooterModel)m_model;
//		return 	CommunityTemplateModel.HEADERFOOTER_ID_FORCE_SUBPORTAL == model.GetHeaderID() && 
//			 	CommunityTemplateModel.HEADERFOOTER_ID_FORCE_SUBPORTAL	== model.GetFooterID() ;
//			
//	}
	
	
	private HTMLTable CreateForceSubPortalCheckBox()	
	{
		HTMLTable table = null;
		try
		{
			IHeaderAndFooterModel model = (IHeaderAndFooterModel)m_model;

			table = new HTMLTable();
			table.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
			table.SetCellPadding(CommonHTMLStrings.ZERO);
			table.SetCellSpacing(CommonHTMLStrings.ZERO);
			table.SetBorder(CommonHTMLStrings.ZERO);

			HTMLTableRow row = new HTMLTableRow();
			table.AddInnerHTMLElement(row);
			row.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);

			HTMLTableCell cell = new HTMLTableCell();
			row.AddInnerHTMLElement(cell);
			cell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			cell.SetColSpan("2");
			cell.SetHeight("20");

			HTMLSpan span = new HTMLSpan();
			cell.AddInnerHTMLElement(span);
			span.SetStyleClass(PTStyleClass.OBJECT_HEADER);

			span.AddInnerHTMLString(m_asOwner.GetString(1500, "ptmsgs_portalbrowsingmsgs"));

			row = new HTMLTableRow();
			table.AddInnerHTMLElement(row);
			row.SetStyleClass(PTStyleClass.LIST_ITEM_ONE_BG);

			// Input selector for object
			cell = new HTMLTableCell();
			row.AddInnerHTMLElement(cell);
			cell.SetHeight("20");
			cell.SetWidth("20");
			cell.SetVAlign(CommonHTMLStrings.CENTER);

			HTMLInput inputSelector = new HTMLInput(HTMLInputTypes.CHECKBOX_TYPE, HTMLCHECKBOX_FORCE_SUBPORTAL,
					m_asOwner.GetString(1500, "ptmsgs_portalbrowsingmsgs"));
			cell.AddInnerHTMLElement(inputSelector);
			
			boolean bForced = model.GetHeaderID() == CommunityTemplateModel.HEADERFOOTER_ID_FORCE_SUBPORTAL;
			inputSelector.SetChecked( bForced );
			inputSelector.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
			inputSelector.SetValue(XPConvert.ToString(CommunityTemplateModel.HEADERFOOTER_ID_FORCE_SUBPORTAL));
			inputSelector.SetOnClick(JSREPORT_FORCESUBPORTAL_FUNC+"("+XPConvert.ToString(!bForced)+")");

			// Object Image
			cell = new HTMLTableCell();
			row.AddInnerHTMLElement(cell);
			cell.SetStyleClass(PTStyleClass.LIST_TEXT);
			cell.SetNoWrap(true);
			cell.SetHeight("20");
			cell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
			cell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

			HTMLImg img = null;

			try
			{
				PTConstruct myConstruct = UIConstructFactory.GetConstruct(PTImageType.ICON_SUB_PORTAL,
						true, this.m_asOwner);
				img = (HTMLImg) myConstruct.GetHTMLElement();

				img.SetAlt(m_asOwner.GetString(1500, "ptmsgs_portalbrowsingmsgs"));
				img.SetAlign(CommonHTMLStrings.ABSMIDDLE);
				img.SetHeight("20");
				img.SetWidth("18");
			}
			catch (Exception e)
			{
				
					log.Error(e, "Display Object: Failed to create image. " +
						e.getMessage());
				
			}

			cell.AddInnerHTMLElement(img);

			// Object Name
			//cell = new HTMLTableCell();
			//row.AddInnerHTMLElement(cell);
			cell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
			cell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

			cell.AddInnerHTMLString(m_asOwner.GetString(1500, "ptmsgs_portalbrowsingmsgs"));
		}
		catch (HTMLException he)
		{
			log.Error(he.getMessage());
		}
		return table;		
	}

	/**
	 * 
	 *
	 * @param sButtonName 
	 * @param sTitle 
	 * @param outterSpanStyle 
	 * @param titleSpanStyle 
	 * @param strOnClick 
	 *
	 * @return 
	 */
	private static HTMLElement MakeSimpleButton(String sButtonName,
		String sTitle, PTStyleClass outterSpanStyle,
		PTStyleClass titleSpanStyle, String strOnClick)
	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLSpan mySpan;
		HTMLInput myInput;

		try
		{
			mySpan = new HTMLSpan();
			result.AddInnerHTMLElement(mySpan);

			mySpan.SetPreComment("begin " + sButtonName + " button");
			mySpan.SetPostComment("end " + sButtonName + " button");

			mySpan.SetStyleClass(outterSpanStyle);

			myInput = new HTMLInput(HTMLInputTypes.BUTTON, "in_bu_NULL", "");

			mySpan.AddInnerHTMLElement(myInput);

			if (null != strOnClick)
			{
				myInput.SetOnClick(strOnClick);
			}

			if (sTitle != null)
			{
				myInput.SetValue(sTitle);

				if (titleSpanStyle != null)
				{
					myInput.SetStyleClass(titleSpanStyle);
				}
			}

			return result;
		}
		catch (HTMLException he)
		{
		}

		return null;
	}
}

