package com.plumtree.portalpages.browsing.editors.community;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.expandablelist.*;

/**
 * @author michaeld
 *
 */
public class PageListControl extends ExpListControl
{
	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "PageList";

	/** Repost Action: New Page */
	public final static int POSTTOSELF_ACTION_NEW_PAGE = 38;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new PageListControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Calls the method associated to the repost action.
	 * Editors using this framework need to call that method from
	 * the PerformRepostAction method of the main RepostControl.
	 *
	 * @param _nAction
	 * @param _htFormData
	 */
	public void PerformRepostAction(int _nAction, XPHashtable _htFormData)
	{
		super.PerformRepostAction(_nAction, _htFormData);

		switch (_nAction)
		{
		case POSTTOSELF_ACTION_NEW_PAGE:
			((PageListModel) m_model).RepostNewPage();

			break;

		}
	}
}

