package com.plumtree.portalpages.browsing.editors.dircommon.doctype;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.editor.*;

/**
 * This Control contains the repost actions of the plug-in section.
 *
 * @author StephenC
 */
public class DocTypePlugInRepostControl extends EditorHelperRepostControl
{
	
	public static final String STR_MVC_CLASS_NAME = "DocTypePlugIn";

	// JF- repost actions for that section

	/** Repost that occurs when the DocType is chosen via Tree Section */
	public final static int POSTTOSELF_ACTION_DOCTYPE_CHOSEN = 40;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new DocTypePlugInRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Performs action on repost.
	 *
	 * @param _nAction
	 * @param _htFormData
	 */
	public void PerformRepostAction(int _nAction, XPHashtable _htFormData)
	{
		switch (_nAction)
		{
		case POSTTOSELF_ACTION_DOCTYPE_CHOSEN:
			((DocTypePlugInModel) m_model).RefreshItemFromTree();

			break;
		}
	}
}

