package com.plumtree.portalpages.browsing.editors.directory.submit_D;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.directory.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.errordisplay.*;

/**
 * @author joseq
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class DirSubmitAS_D extends PTEditorAS
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.editors.directory.submit_D.DirSubmitAS_D");

	public static final String STR_MVC_CLASS_NAME = "DirSubmitAS_D";
	
	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new DirSubmitAS_D();
	}

	/**
	 * Returns the Editor title.
	 *
	 * @return String
	 */
	public String GetEditorTitle()
	{
		return GetString(1188, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.AActivitySpace#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the name of the repost control class.
	 *
	 * @see com.plumtree.xpshared.form.IRepostAS#GetRepostControlName()
	 *
	 * @return String
	 */
	public String GetRepostControlName()
	{
	    return DirRepostControl.STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.AActivitySpace#Init()
	 */
	public void Init()
	{
	    m_strModelName = DirSubmitModel_D.STR_MVC_CLASS_NAME;
	    super.Init();

	    // This activity space is only valid if the parent is the DirAS
	    // the DirModel does all the work.
		AActivitySpace parentAS = GetParentSpace();
		if (null==parentAS)
		{
		    UIError myError = new UIError(
		            UIErrorLevel.FRIENDLY,
					UIErrorScope.CURRENT_USER, 
					GetString(1801, "ptmsgs_portalbrowsingmsgs"), 
					"DirSubmitAS_D.Init - The parent AS is null.");
		    
			UIErrorHandler.RaiseError(myError, GetSubSession(), GetApplication());
			return;
		}

		IModel dirModel = parentAS.GetModel(DirModel.STR_MVC_CLASS_NAME);

		// Start a menu but hide it.
		int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(71, "ptmsgs_portalbrowsingmsgs"));
		m_mEditorMenu.HideSubMenu(true,nMenuOneID);

		// Directory Controls
		RegisterControl(DirRepostControl.STR_MVC_CLASS_NAME, dirModel);
		
		// 508 pages and views
		RegisterPage(new DirSubmitCardDP_D());
		RegisterPage(new DirDataSourceDP_D());
		RegisterPage(new DirSubmitDoneDP_D());
		RegisterView(DirSubmitDoneView_D.STR_MVC_CLASS_NAME, dirModel);
		RegisterView(DirSubmitCardView_D.STR_MVC_CLASS_NAME, dirModel);
		RegisterView(DirDataSourceView_D.STR_MVC_CLASS_NAME, dirModel);

		SetCurrentPage(DirDataSourceDP_D.STR_MVC_CLASS_NAME);
		
		this.SetHelpTopic("PT_Submit_SimpleDocument");
	}

	
	
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(java.lang.String, java.lang.String, boolean)
     */
    public boolean CheckBasicAccess(String strPage, String strControl, boolean bSameSpace) 
    {
        AActivitySpace myParentAS = GetParentSpace(); 
        if (null == myParentAS || !(myParentAS instanceof DirAS)) 
        {
			
				log.Error("DirSubmitAS_D.CheckBasicAccess - The parent editor must be DirAS.");
			

            return false;
        }

        return true;
    }
}

