package com.plumtree.portalpages.browsing.editors.directory.submit_D;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.directory.*;
import com.plumtree.portalpages.browsing.directory.documentsubmitsimple.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author StephenC
 *
 */
public class DirSubmitCardDP_D extends EditorDP
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.editors.directory.submit_D.DirSubmitCardDP_D");

	public static final String STR_MVC_CLASS_NAME = "DirSubmitCardDP_D";
	
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.editor.EditorDP#GetLeftNavString()
     */
    public String GetLeftNavString() 
    {
        return m_asOwner.GetString(1188, "ptmsgs_portalbrowsingmsgs");
    }
	
	/**
	 * @see com.plumtree.xpshared.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IDisplayPage#Init(AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		super.Init(parent);
		SetShow508FormFooter(false);
		parent.SetHelpTopic("PT_Submit_SimpleDocument");
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#DisplayForm()
	 */
	public HTMLForm DisplayForm() 
	{
		// if the datasource selected was the file upload ds, then we need to 
		// change the form's action to submit to the FU webservice
	    IDirModelRO myModel = (IDirModelRO) m_asOwner.GetParentSpace().GetModel(DirModel.STR_MVC_CLASS_NAME);//((DirSubmitModel_D) m_asOwner.GetModel(DirSubmitModel_D.STR_MVC_CLASS_NAME)).GetDirModel();
		int nDataSource = myModel.GetCardSubmitDataSource();

		if (myModel.SupportsUpload(nDataSource))
		{
			int webServiceID = ((DirModel)myModel).GetWebServiceID(nDataSource);

			// create a gateway prefix
			String gwUrl =
				GatewayHelpers.ConstructPrefPageLink(
					m_asOwner,
					webServiceID,
					0,
					0,
					0,
					PT_CLASSIDS.PT_WEBSERVICE_ID);

			// create an asurl for the return url 
			ASURL myCardSubmitURL = new ASURL(m_asOwner);
			myCardSubmitURL.SetLinkCreateNewSpace(DirSubmitAS_D.STR_MVC_CLASS_NAME, m_asOwner.GetParentSpace());
			myCardSubmitURL.SetControl(DirRepostControl.STR_MVC_CLASS_NAME);

			// the upload url is the gatewayed WS url with the returnURL as a QS parameter
			String sUploadUrl =
				gwUrl
					+ GatewayHelpers.CreateGatewayFriendlyURL(myModel.GetUploadWSURL(nDataSource)
					+ "?"
					+ DirCardSubmitSimpleView.HTMLINPUT_ReturnURL
					+ "="
					+ myCardSubmitURL.GetURLAsString());

			// set the form to be multipart; must do this before calling super.DispalyForm()
			// to get the form.
			((AFormDP) m_asOwner.
			        GetPage(DirSubmitCardDP_D.STR_MVC_CLASS_NAME)).
			        SetMultiPartEncoding(true);

			// set the action
			HTMLForm myForm = super.DisplayForm();
			myForm.SetAction(sUploadUrl);
			
			return myForm;
		}
		else
		{
			return super.DisplayForm();
		}
	}
	
	/**
	 * helper display method for PlumtreeDP
	 *
	 * Fill in the body argument with HTML to display in the page.
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection wholePageGroup = new HTMLElementCollection();

		try
		{
			wholePageGroup.AddInnerHTMLElement(m_asOwner.GetView(
					DirSubmitCardView_D.STR_MVC_CLASS_NAME).Display());
		}
		catch (HTMLException he)
		{
					
				log.Error(he, "Error in DirSubmitCardDP_D::Display: " + he.getMessage());
			
		}

		return wholePageGroup;
	}
}

