package com.plumtree.portalpages.browsing.editors.directory.submit_D;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.directory.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author StephenC
 */
public class DirSubmitCardView_D implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.editors.directory.submit_D.DirSubmitCardView_D");

	
	public static final String STR_MVC_CLASS_NAME = "DirSubmitCardView_D";

	
	public static final String HTMLINPUT_WWWCardURL  = "in_tx_CardURL"; 

	
	public static final String HTMLINPUT_FileCardURL = "in_fi_CardURL";

	private AActivitySpace m_asOwner;
	private IDirModelRO m_asModel;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new DirSubmitCardView_D();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLSpan mySpan;
		HTMLInput myInput;
		
		HTMLTable myTable = new HTMLTable();
		myTable.SetBorder("0");
		myTable.SetWidth("100%");
		myTable.SetCellPadding("1");
		myTable.SetCellSpacing("0");
		myTable.SetSummary(m_asOwner.GetString(1188, "ptmsgs_portalbrowsingmsgs"));

		HTMLElementCollection result = new HTMLElementCollection();

		try
		{
			HTMLComment myComment = new HTMLComment( "Begin: Display DirSubmitCardView_D");
			result.AddInnerHTMLElement(myComment);
			
			result.AddInnerHTMLElement(myTable);

			int nDefaultDataSource		    = m_asModel.GetCardSubmitDataSource();
			// TODO CR not used, commenting out.
			//String strDefaultDataSourceName = m_asModel.GetDataSourceName(nDefaultDataSource);

			boolean bIsWebDataSource = m_asModel.IsWebDataSource(nDefaultDataSource);
			String strURL			 = m_asModel.GetCardSubmitURL(bIsWebDataSource);

			
			// BEGIN Document Submit Step2 Title Row
			myRow = new HTMLTableRow();
			myRow.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT); 

			mySpan.AddInnerHTMLString(m_asOwner.GetString(1756, "ptmsgs_portalbrowsingmsgs"));
			
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
			// END Document Submit Step2 Title Row

			
			// BEGIN Instructions Title Row
			myRow = new HTMLTableRow();
			myRow.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT); 

			mySpan.AddInnerHTMLString(bIsWebDataSource
					? m_asOwner.GetString(1757, "ptmsgs_portalbrowsingmsgs")
					: m_asOwner.GetString(1758, "ptmsgs_portalbrowsingmsgs"));

			/* help */
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.SetAlign(CommonHTMLStrings.RIGHT);
			
			HTMLAnchor helpAnchor = HTMLConstructHelpers.GetHelpAnchor( m_asOwner );
			helpAnchor.SetAccessKey(m_asOwner.GetString(11, "ptmsgs_portal508quickkeymsgs"));
			myCell.AddInnerHTMLElement(helpAnchor);
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
			// END Document Submit Instructions Rows

			
			// BEGIN Path Example Row
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.LIST_ITALIC_TEXT);
			
			mySpan.AddInnerHTMLString(bIsWebDataSource
					? m_asOwner.GetString(79, "ptmsgs_portalbrowsingmsgs")
					: m_asOwner.GetString(78, "ptmsgs_portalbrowsingmsgs"));
			
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
			// END Path Example Row


			// Add extra spacer row
			myTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(3, 20));

			
			// BEGIN Input Box Title Row
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_BTN_TEXT); 
 
			myCell.AddInnerHTMLString(bIsWebDataSource
					? m_asOwner.GetString(1759, "ptmsgs_portalbrowsingmsgs")
					: m_asOwner.GetString(1760, "ptmsgs_portalbrowsingmsgs"));
			
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
			// END Input Box Title Row


			// BEGIN Path Input Box Row
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);

			if (bIsWebDataSource)
			{
				myInput = new HTMLInput(HTMLInputTypes.TEXT,
						HTMLINPUT_WWWCardURL,
						m_asOwner.GetString(76, "ptmsgs_portalbrowsingmsgs"));
			}
			else
			{
				myInput = new HTMLInput(HTMLInputTypes.FILE,
						HTMLINPUT_FileCardURL,
						m_asOwner.GetString(77, "ptmsgs_portalbrowsingmsgs"));
			}
			myCell.AddInnerHTMLElement(myInput);

			myInput.SetSize(50);
			myInput.SetValue(strURL);
			myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT); 
			myInput.SetMaxLength(1020);

			myInput.SetTitle(bIsWebDataSource
				? m_asOwner.GetString(76, "ptmsgs_portalbrowsingmsgs")
				: m_asOwner.GetString(77, "ptmsgs_portalbrowsingmsgs"));
			
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
			// END Path Input Box Row

			
			// Add extra spacer row
			myTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(3, 40));

			
			// BEGIN Previous, Finish, and Cancel buttons
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.BAN_HEADER_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetHeight("40");
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetHeight("40");
			myCell.SetAlign(CommonHTMLStrings.CENTER);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);

			// Previous button
			myInput = new HTMLInput(HTMLInputTypes.SUBMIT,
					RepostControl.HTMLSUBMIT_508_POSTTOSELF +
					DirRepostControl.POSTTOSELF_ACTION_CARDSUBMIT508_DATASOURCE, "");
			myCell.AddInnerHTMLElement(myInput);

			myInput.SetValue(m_asOwner.GetString(1140, "ptmsgs_portalbrowsingmsgs"));
			myInput.SetAccessKey(m_asOwner.GetString(36, "ptmsgs_portal508quickkeymsgs"));
			myInput.SetTitle(m_asOwner.GetString(37, "ptmsgs_portal508quickkeymsgs"));
			myInput.SetStyleClass(PTStyleClass.OBJECT_BTN_TEXT); 

			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

			// Finish button
			myInput = new HTMLInput(HTMLInputTypes.SUBMIT,
					RepostControl.HTMLSUBMIT_508_POSTTOSELF +
					DirRepostControl.POSTTOSELF_ACTION_CARDSUBMIT508_SUBMIT, "");
			myCell.AddInnerHTMLElement(myInput);

			myInput.SetValue(m_asOwner.GetString(81, "ptmsgs_portalbrowsingmsgs"));
			myInput.SetAccessKey(m_asOwner.GetString(26, "ptmsgs_portal508quickkeymsgs"));
			myInput.SetTitle(m_asOwner.GetString(28, "ptmsgs_portal508quickkeymsgs"));
			myInput.SetStyleClass(PTStyleClass.OBJECT_BTN_TEXT); 

			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

			// Cancel button
			myInput = new HTMLInput(HTMLInputTypes.SUBMIT,
					RepostControl.HTMLSUBMIT_508_POSTTOSELF +
					DirRepostControl.POSTTOSELF_ACTION_CARDSUBMIT508_CANCEL, "");
			myCell.AddInnerHTMLElement(myInput);

			myInput.SetValue(m_asOwner.GetString(82, "ptmsgs_portalbrowsingmsgs"));
			myInput.SetAccessKey(m_asOwner.GetString(27, "ptmsgs_portal508quickkeymsgs"));
			myInput.SetTitle(m_asOwner.GetString(29, "ptmsgs_portal508quickkeymsgs"));
			myInput.SetStyleClass(PTStyleClass.OBJECT_BTN_TEXT); 
			
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
			// END Previous, Finish, and Cancel buttons
			
			
			myComment = new HTMLComment( "End: Display DirSubmitCardView_D");
			result.AddInnerHTMLElement(myComment);
		}
		catch (HTMLException he)
		{
			
				log.Error(he, STR_MVC_CLASS_NAME +
					"::MainView::Display The following error occured when trying to display the HTML: " +
					he.getMessage());
			

			throw new XPException(m_asOwner.GetString(80,"ptmsgs_portalbrowsingmsgs"), he);
		}

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		return null;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_asModel     = (IDirModelRO) model;
		m_asOwner     = parent;
	}
}

