package com.plumtree.portalpages.browsing.editors.directory.submit_D;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.directory.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author StephenC
 */
public class DirSubmitDoneView_D implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.editors.directory.submit_D.DirSubmitDoneView_D");

	
	public static final String STR_MVC_CLASS_NAME = "DirSubmitDoneView_D";

	
	public static final String HTMLBUTTON_EDITOR_DONE = "in_bu_Done"; 

	private AActivitySpace m_asOwner;
	private IDirModelRO m_asModel;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new DirSubmitDoneView_D();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		HTMLTableRow myRow;
		HTMLTableCell myCell;
		// TODO CR not used, commenting out.
		//HTMLSpan mySpan;
		HTMLInput myInput;

		HTMLTable mainTable = new HTMLTable();
		mainTable.SetBorder("0");
		mainTable.SetWidth("100%");
		mainTable.SetCellPadding("0");
		mainTable.SetCellSpacing("0");

		result.AddInnerHTMLElement(mainTable);

		try
		{
			HTMLTable sectionTable;
			HTMLTable innerTable;

			myRow = new HTMLTableRow();
			mainTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);

			sectionTable = new HTMLTable();
			sectionTable.SetBorder("0");
			sectionTable.SetWidth("100%");
			sectionTable.SetCellPadding("5");
			sectionTable.SetCellSpacing("0");
			myCell.AddInnerHTMLElement(sectionTable);

			// Add extra spacer row
			mainTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(1, 5));

			myRow = new HTMLTableRow();
			mainTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);

			sectionTable = new HTMLTable();
			sectionTable.SetBorder("0");
			sectionTable.SetWidth("100%");
			sectionTable.SetCellPadding("0");
			sectionTable.SetCellSpacing("5");
			myCell.AddInnerHTMLElement(sectionTable);

			myRow = new HTMLTableRow();
			sectionTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);

			innerTable = new HTMLTable();
			innerTable.SetBorder("0");
			innerTable.SetWidth("100%");
			innerTable.SetCellPadding("2");
			innerTable.SetCellSpacing("2");
			myCell.AddInnerHTMLElement(innerTable);

			sectionTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(2, 5));

			// BEGIN Title Row
			myRow = new HTMLTableRow();
			innerTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetColSpan(CommonHTMLStrings.TWO);
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_HEADER);
			myCell.AddInnerHTMLString(m_asOwner.GetString(1795, "ptmsgs_portalbrowsingmsgs"));
			// END Title Row

			// BEGIN Message Row
			myRow = new HTMLTableRow();
			innerTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetColSpan(CommonHTMLStrings.TWO);
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.AddInnerHTMLString(m_asOwner.GetString(1476, "ptmsgs_portalbrowsingmsgs"));
			
			// END Message Row

			int nParentFolderID  = m_asModel.GetCurrentFolderID();
			int nSubmittedCardID = m_asModel.GetCardID();

			// BEGIN Card Name Row
			String strCardName = m_asModel.GetCardName(nSubmittedCardID);
			String strFittedAndEncodedCardName = DirConstants.BreakUpLongWordsInStringAndHTMLEncode(strCardName);

			myRow = new HTMLTableRow();
			innerTable.AddInnerHTMLElement(myRow);

			// empty cell
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetWidth("10");
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.AddInnerHTMLString(m_asOwner.GetString(1200, "ptmsgs_portalbrowsingmsgs"));
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
			myCell.AddInnerHTMLString(strFittedAndEncodedCardName);
			// END Card Name Row

			// BEGIN Card Path Row
			myRow = new HTMLTableRow();
			innerTable.AddInnerHTMLElement(myRow);
			
			// empty cell
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetWidth("10");
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.AddInnerHTMLString(m_asOwner.GetString(1201, "ptmsgs_portalbrowsingmsgs"));
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
			myCell.AddInnerHTMLEncodedString(m_asModel.GetFolderPath(nParentFolderID));
			// END Card Path Row

			// BEGIN Message Row
			myRow = new HTMLTableRow();
			innerTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myCell.SetColSpan(CommonHTMLStrings.TWO);
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.AddInnerHTMLString(m_asOwner.GetString(1477, "ptmsgs_portalbrowsingmsgs"));;
			// END Message Row


			// spacer row
			innerTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(1,10));

			
			// BEGIN Submit More & Finish Buttons Row
			myRow = new HTMLTableRow();
			innerTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.BAN_HEADER_BG);
			
			myCell = new HTMLTableCell();
			myCell.SetColSpan(CommonHTMLStrings.TWO);
			myCell.SetAlign(CommonHTMLStrings.CENTER);
			myCell.SetHeight("40");
			myRow.AddInnerHTMLElement(myCell);
			
			// submit more 
			myInput = new HTMLInput(HTMLInputTypes.SUBMIT,
					RepostControl.HTMLSUBMIT_508_POSTTOSELF +
					DirRepostControl.POSTTOSELF_ACTION_CARDSUBMIT508_DATASOURCE, "");
			
			myCell.AddInnerHTMLElement(myInput);
			
			myInput.SetValue(m_asOwner.GetString(1483, "ptmsgs_portalbrowsingmsgs"));
			myInput.SetAccessKey(m_asOwner.GetString(38, "ptmsgs_portal508quickkeymsgs"));
			myInput.SetTitle(m_asOwner.GetString(39, "ptmsgs_portal508quickkeymsgs"));
			myInput.SetStyleClass(PTStyleClass.OBJECT_BTN_TEXT);

			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

			// finish
			myInput = new HTMLInput(HTMLInputTypes.SUBMIT,
					RepostControl.HTMLSUBMIT_508_POSTTOSELF +
					DirRepostControl.POSTTOSELF_ACTION_CARDSUBMIT508_CANCEL, "");
			myCell.AddInnerHTMLElement(myInput);

			myInput.SetValue(m_asOwner.GetString(81, "ptmsgs_portalbrowsingmsgs"));
			myInput.SetAccessKey(m_asOwner.GetString(26, "ptmsgs_portal508quickkeymsgs"));
			myInput.SetTitle(m_asOwner.GetString(28, "ptmsgs_portal508quickkeymsgs"));
			myInput.SetStyleClass(PTStyleClass.OBJECT_BTN_TEXT); 

			// END Submit More & Finish Buttons Row

			// spacer row
			innerTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(1,10));

			innerTable.AddInnerHTMLElement(DirConstants.CreateSpacerRow(1,40));
		}
		catch (HTMLException he)
		{
			
				log.Error(he, m_asOwner.GetString(1479, "ptmsgs_portalbrowsingmsgs")
					+ he.getMessage());
			

			throw new XPException(m_asOwner.GetString(1479, "ptmsgs_portalbrowsingmsgs"), he);
		}

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		return null;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_asModel     = (IDirModelRO) model;
		m_asOwner     = parent;
	}
}

