package com.plumtree.portalpages.browsing.editors.directory.submit_D;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.directory.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;

/**
 * @author joseq
 *
 * This Model doesn't do anything.  It's a dummy model for DirSubmitAS_D,
 * the 508 Editor for submitting cards in the KD.  It's purpose is just 
 * so that the DIrSubmitAS_D has an Editor model to register and to check 
 * that the parent AS/Model is the DirAS.  All the real work is done in
 * DirModel. 
 */
public class DirSubmitModel_D extends EditorModel
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.editors.directory.submit_D.DirSubmitModel_D");

	public static final String STR_MVC_CLASS_NAME = "DirSubmitModel_D";
	
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IModel#Init(com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
     */
    public void Init(AActivitySpace parent) 
    {
        super.Init(parent);
    }
    
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
     */
    public Object Create() 
    {
		return new DirSubmitModel_D();
    }

    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
     */
    public String GetName() 
    {
		return STR_MVC_CLASS_NAME;
    }

    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.editor.EditorModel#CheckEditorAccessAndStart(com.plumtree.openfoundation.util.XPHashtable)
     */
    public boolean CheckEditorAccessAndStart(XPHashtable _htFormData) 
    {
        AActivitySpace myParentAS = m_asOwner.GetParentSpace(); 
        if (null == myParentAS || !(myParentAS instanceof DirAS)) 
        {
			
				log.Error("DirSubmitModel_D.CheckEditorAccessAndStart - The parent editor must be DirAS.");
			

            return false;
        }

        return true;
    }

    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.form.IRepostModel#Finish()
     */
    public void Finish() 
    {
    }

    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.form.IRepostModel#SavePage(java.lang.String, com.plumtree.openfoundation.util.XPHashtable)
     */
    public int SavePage(String _sPageName, XPHashtable _htFormData) 
    {
		return DirRepostControl.PAGE_STATUS_VALID;
    }
}
