package com.plumtree.portalpages.browsing.editors.editportletprefs;


// Framework Imports
import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.editors.community.*;
import com.plumtree.portalpages.common.constants.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.tips.*;
import com.plumtree.xpshared.htmlelements.*;



/**
 * 
 *
 * @version $Revision$
 * @author $author$
 */
public class EditPortletPrefsAS extends PTEditorAS
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.editors.editportletprefs.EditPortletPrefsAS");

	
	public static final String STR_MVC_CLASS_NAME = "EditGadgetPrefs";

	
	public final static String QS_PARAM_COMMUNITYID = "PortletsCommunityID";

	
	public final static String QS_PARAM_PAGEID = "PortletsPageID";

	private static final String sClassName = "com.plumtree.portalpages.browsing.editors.editportletprefs.EditPortletPrefsAS";


	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new EditPortletPrefsAS();
	}

	 public boolean CheckBasicAccess(String strPage, String strControl, boolean bSameSpace)
    {
        return true;
    }
	
	/**
	 * Returns the Editor title.
	 *
	 * @return String
	 */
	public String GetEditorTitle()
	{
		return (GetString(377, "ptmsgs_portalbrowsingmsgs"));
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the class name of the Property Repost Control.
	 *
	 * @return String
	 */
	public String GetRepostControlName()
	{
		// ***CHANGE_HERE*** Replace Misc2RepostControl below with your RepostControl.
		return (EditPortletPrefsRepostControl.STR_MVC_CLASS_NAME);
	}

	/**
	 * Registers all the classes of the Property Activity Space.
	 */
	public void Init()
	{
		// ***CHANGE_HERE*** Replace Misc2Model below with your Model.
		m_strModelName = EditPortletPrefsModel.STR_MVC_CLASS_NAME;

		// Warning: m_strModelName must be initialized before super.Init() is called.
		super.Init();

		IModel myModel = GetModel(EditPortletPrefsModel.STR_MVC_CLASS_NAME);

		RegisterModel(PageListModel.STR_MVC_CLASS_NAME);

		// Register DisplayPages
		RegisterPage(new EditPortletPrefsDP());

		// Register Views
		RegisterView(PortletPreferencesView.STR_MVC_CLASS_NAME, myModel);

		// Register Controls
		RegisterControl(EditPortletPrefsRepostControl.STR_MVC_CLASS_NAME,
			myModel);

		// Set default page
		// (It will be the page selected by default when the user starts the Editor).
		SetCurrentPage(EditPortletPrefsDP.STR_MVC_CLASS_NAME);

		// END Sub menu "General Settings"
		
		this.SetHelpTopic( "PT_EditPortletPreferences" );
		
		

		//	TIPS
		TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);

		if (tm != null)
		{
			try
			{
				tm.SetGeneratingClass( sClassName );
				
				
				int iTitleId = 123;
				int iTipId = 124;
				int iSecondaryTipId = 125;
								
				tm.SetTipTitle( this.GetString( iTitleId, ResourceConstants.TIPS) );

				HTMLGenericElement e = new HTMLGenericElement( this.GetString( iTipId, ResourceConstants.TIPS) );

				tm.SetTip( e );
				
				String sSecondary = this.GetString( iSecondaryTipId, ResourceConstants.TIPS);
				
				if( !("none_do_not_translate".equals( sSecondary )) )
				{
									
					e = new HTMLGenericElement( sSecondary );
				
					tm.SetSecondarTip( e );
				}

								
			}
			catch (Exception ex)
			{
				
					log.Error(ex, "Couldn't generate tip.");
				
			}
		}
		 //	Got the tips model
		 							
		
	}
}

