package com.plumtree.portalpages.browsing.editors.editportletprefs;

// Framework Imports
import com.plumtree.uiinfrastructure.editor.*;

/**
 * This class contains the additional repost actions.
 * The ones specific to the Misc Editor (other than
 * "change page", "finish" and "cancel" actions).
 *
 * @author MichaelD
 */

public class EditPortletPrefsRepostControl extends EditorRepostControl
{
	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "EditPortletPrefsRepost";

	
	public final static int POSTTOSELF_ACTION_CHANGEGADGETPREFSSORT = 13;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new EditPortletPrefsRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Switch between the action modes and call
	 * the associated method for each action.
	 *
	 * @param int
	 */
	protected void PerformAction(int _nAction)
	{
		super.PerformAction(_nAction);

		switch (_nAction)
		{
		case POSTTOSELF_ACTION_CHANGEGADGETPREFSSORT:
			((EditPortletPrefsModel) m_model).ReversePortletPrefsSort(m_htFormData);

			break;
		}
	}
}

