package com.plumtree.portalpages.browsing.editors.folder;

import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author joseq
 *
 * prints views for the popup asking if folder ACL changes should 
 * propagate to its children.
 */
public class FolderEditorACLPropagateDP extends EditorDP 
{
	public static final String STR_MVC_CLASS_NAME = "FolderEditorACLProp";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return (m_asOwner.GetString(1698, "ptmsgs_portalbrowsingmsgs"));
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the General Info page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 *
	 * @return HTMLElement
	 * @throws HTMLException
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		/* set the dialog body */
		HTMLBody myBody = new HTMLBody();
		result.AddInnerHTMLElement(myBody);
		myBody.SetStyleClass(PTStyleClass.DIALOGUE_BG);

		// Insert super class HTML
		result.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
			FolderEditorACLPropagateView.STR_MVC_CLASS_NAME)).Display());

		return result;
	}
}
