package com.plumtree.portalpages.browsing.editors.folder;


// Framework Imports
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author StephenC
 *
 * This is class is used to print out together the Views for
 * the Related Resources page of the Property Editor.
 */
public class FolderEditorAdvancedSettingsDP extends EditorDP
{
	
	public static final String STR_MVC_CLASS_NAME = "FolderEditorAdditionalSettings";
	private IFolderEditorModelRO m_asModel;



	/**
	 * @see com.plumtree.xpshared.activityspace.IDisplayPage#Init(AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		super.Init(parent);

		parent.SetHelpTopic( "PT_Folder_AdvancedSettings" );
		
	}
	
	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return (m_asOwner.GetString(381, "ptmsgs_portalbrowsingmsgs"));
	}

	
	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the Advanced Settings page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 *
	 * @return HTMLElement
	 * @throws HTMLException
	 */
	public HTMLElement PageDisplay()
	{
		m_asModel = (IFolderEditorModelRO) m_asOwner.GetModel(FolderEditorModel.STR_MVC_CLASS_NAME);

		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
				FolderEditorDataSourceView.STR_MVC_CLASS_NAME)).Display());

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	 * 
	 *
	 * @return 
	 *
	 * @throws HTMLException 
	 * @throws XPException 
	 */
	protected HTMLElement GetHTMLBelowSubHeader()

	{
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(382,
				"ptmsgs_portalbrowsingmsgs"),
			this.m_asOwner);
	}
}

