package com.plumtree.portalpages.browsing.editors.multipledocumentlinksettings;


// Framework Imports
import com.plumtree.portalpages.common.linksettings.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This class is used to register all the Model, Views, Display Pages,
 * and Controls created for the MultipleCardLinkSettings Editor.
 * This class can also be used to get any of those objects back with
 * the class name.
 *
 * @author StephenC
 */
public class MultipleCardLinkSettingsAS extends ObjEditorAS
{
	
	public static final String STR_MVC_CLASS_NAME = "MultipleCardLinkSettings";

	
	public static final String strLinkSettingsPlugInKey = "MultipleCardLinkSettingsPlugIn";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new MultipleCardLinkSettingsAS();
	}

	
	/**
	 * Returns the Editor title.
	 *
	 * @return String
	 */
	public String GetEditorTitle()
	{
		return (GetString(464, "ptmsgs_portalbrowsingmsgs"));
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Registers all the classes of the Property Activity Space.
	 *
	 */
	public void Init()
	{
		m_strModelName = MultipleCardLinkSettingsModel.STR_MVC_CLASS_NAME;

		// Warning: m_strModelName must be initialized before super.Init() is called.
		super.Init();

		// Register DisplayPages
		// Main DP
		MultipleCardLinkSettingsMainDP myMainDP = new MultipleCardLinkSettingsMainDP();
		myMainDP.AddToValidationFunction("CheckNumericLinkValues");
		RegisterPage(myMainDP);

		RegisterModel(LinkSettingsPlugInModel.STR_MVC_CLASS_NAME,
			strLinkSettingsPlugInKey);

		IModel myPlugInModel = GetModel(strLinkSettingsPlugInKey);
		RegisterView(LinkSettingsPlugInView.STR_MVC_CLASS_NAME,
			strLinkSettingsPlugInKey, myPlugInModel);

		SetCurrentPage(MultipleCardLinkSettingsMainDP.STR_MVC_CLASS_NAME);

		// This editor only has one page so we can set the help here
		this.SetHelpTopic( "PT_DocumentSettings" );                           

		//Sets left nav menu
		// BEGIN Sub menu "General Settings"
		int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(465,
					"ptmsgs_portalbrowsingmsgs"));
		m_mEditorMenu.AddLinkToSubMenu(nMenuOneID,
			MultipleCardLinkSettingsMainDP.STR_MVC_CLASS_NAME);

		// END Sub menu "General Settings"
	}
}

