package com.plumtree.portalpages.browsing.editors.sitemap;


// Framework Imports
import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.portalpages.browsing.editors.sitemap.sitemapfolderplugin.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.editor.commonpages.localizednames.*;
import com.plumtree.portaluiinfrastructure.editor.commonpages.migrationhistory.*;
import com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;

/**
 * File: SiteMapFolderEditorAS.java
 * --------------------------------
 *
 * @author NaveenP
 */
public class SiteMapFolderEditorAS extends ObjEditorAS
{
	/** Unique identifier for the class */
	public static final String STR_MVC_CLASS_NAME = "SiteMapFolderEditor";

	/** Unique identifier for sitemap folder links plug-in section */
	public static final String STR_MVC_SITEMAP_PLUGIN = "SiteMapFolderPlugIn";
	
	public int m_nMenuGeneralID;
	
	public int m_nMenuStandardID;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SiteMapFolderEditorAS();
	}

	public boolean CheckBasicAccess(String strPage, String strControl, boolean bSameSpace)
	{
		boolean bAccess = super.CheckBasicAccess(strPage, strControl, bSameSpace);

		if ((null != strControl) && (strControl.equals(SiteMapFolderCheckAccessControl.STR_MVC_CLASS_NAME)))
		{
			return true;
		}		

		return bAccess;	
	}

	/**
	 * Returns the Editor title.
	 *
	 * @return String
	 */
	public String GetEditorTitle()
	{
		SiteMapFolderModel iModel = (SiteMapFolderModel) GetModel(SiteMapFolderModel.STR_MVC_CLASS_NAME);

		if (EditorStartControl.EDITOR_START_FLAG_CREATE == ((EditorModel) GetModel(
					m_strModelName)).GetEditorType())
		{
			if (iModel.GetStartedInSiteMap())
			{

				return (GetString(537, "ptmsgs_portalbrowsingmsgs"));
			}
			else
			{

				return (GetString(535, "ptmsgs_portalbrowsingmsgs"));
			}
		}
		else
		{
			if (iModel.GetStartedInSiteMap())
			{

				return (XPResourceManager.FormatMessage(GetString(1708, "ptmsgs_portalbrowsingmsgs"), GetObjectName()));
			}
			else
			{

				return (XPResourceManager.FormatMessage(GetString(1707, "ptmsgs_portalbrowsingmsgs"), GetObjectName()));
			}
		}
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the class name of the Property Repost Control.
	 *
	 * @return String
	 */
	public String GetRepostControlName()
	{
		return (SiteMapFolderRepostControl.STR_MVC_CLASS_NAME);
	}

	/**
	 * Registers all the classes of the Property Activity Space.
	 *
	 */
	public void Init()
	{
		m_strModelName = SiteMapFolderModel.STR_MVC_CLASS_NAME;

		// Warning: m_strModelName must be initialized before super.Init() is called.
		super.Init();

		IModel myModel = GetModel(SiteMapFolderModel.STR_MVC_CLASS_NAME);

		SiteMapFolderEditLinksDP smEditDP = new SiteMapFolderEditLinksDP();

		RegisterPage(smEditDP);

		// Register Controls
		RegisterControl(SiteMapFolderRepostControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(SiteMapFolderCheckAccessControl.STR_MVC_CLASS_NAME, myModel);

		//Sitemap link plug-in
		RegisterModel(SiteMapFolderPlugInModel.STR_MVC_CLASS_NAME, STR_MVC_SITEMAP_PLUGIN);

		IModel mySiteMapPluginModel = GetModel(STR_MVC_SITEMAP_PLUGIN);
		RegisterView(SiteMapFolderPlugInView.STR_MVC_CLASS_NAME,
			STR_MVC_SITEMAP_PLUGIN, mySiteMapPluginModel);
		RegisterControl(SiteMapFolderPlugInControl.STR_MVC_CLASS_NAME,
			STR_MVC_SITEMAP_PLUGIN, mySiteMapPluginModel);

		// Set default page
		SetCurrentPage(SiteMapFolderEditLinksDP.STR_MVC_CLASS_NAME);

		//Sets left nav menu
		m_nMenuGeneralID = m_mEditorMenu.StartNewSubMenu(GetString(1866,
					"ptmsgs_portaladminmsgs"));
		m_mEditorMenu.AddLinkToSubMenu(m_nMenuGeneralID,
			SiteMapFolderEditLinksDP.STR_MVC_CLASS_NAME);

		// BEGIN Sub menu "Standard Settings"

		m_nMenuStandardID = m_mEditorMenu.StartNewSubMenu(GetString(1867, "ptmsgs_portaladminmsgs"));

		//Properties and Names
		m_mEditorMenu.AddLinkToSubMenu(m_nMenuStandardID, LocNamesDP.STR_MVC_CLASS_NAME);
		//Security
		m_mEditorMenu.AddLinkToSubMenu(m_nMenuStandardID, ObjectSecurityDP.STR_MVC_CLASS_NAME);
		//Migration History
		m_mEditorMenu.AddLinkToSubMenu(m_nMenuStandardID, MigrationHistoryPluginDP.STR_MVC_CLASS_NAME);

		// END Sub menu "Standard Settings"
	}
}

