package com.plumtree.portalpages.browsing.editors.sitemap;


// UI Imports
import com.plumtree.portalpages.browsing.editors.sitemap.sitemapfolderplugin.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.editor.*;

/**
 * File: SiteMapFolderRepostControl.java
 * -------------------------------------
 *
 * @author NaveenP
 */
public class SiteMapFolderRepostControl extends ObjEditorRepostControl
{
	/** Unique identifier for the class */
	public static final String STR_MVC_CLASS_NAME = "SiteMapFolderRepost";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SiteMapFolderRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * For the Object Editor we don't want to store the object yet.  We need to
	 * pop-up the save Object window so the user can select the folder, set
	 * the security and and set the name and description. Do do this we add a
	 * JavaScript to the current DP to open the pop-up window.
	 */
	public void PerformFinishAction()
	{
		if ((EditorStartControl.EDITOR_START_FLAG_CREATE == ((ObjEditorModel) m_model).GetEditorType()) &&
				!((SiteMapFolderModel) m_model).GetStartedInSiteMap())
		{
			OpenSavePopUp();
		}
		else
		{
			super.PerformFinishAction();
		}
	}

	/**
	 * Switch between the action modes and call
	 * the associated method for each action.
	 *
	 * @param _nAction
	 */
	protected void PerformAction(int _nAction)
	{
		super.PerformAction(_nAction);

		// You need to call the PerformRepostAction on the plug-in control
		((SiteMapFolderPlugInControl) m_asOwner.GetControl(SiteMapFolderEditorAS.STR_MVC_SITEMAP_PLUGIN)).PerformRepostAction(_nAction,
			m_htFormData);

		switch (_nAction)
		{
			case POSTTOSELF_ACTION_FINISH:
	
				if ((EditorStartControl.EDITOR_START_FLAG_CREATE == ((ObjEditorModel) m_model).GetEditorType()) &&
						!((SiteMapFolderModel) m_model).FolderHasParent())
				{
					super.OpenSavePopUp();
				}
	
				break;
	
			case POSTTOSELF_ACTION_CANCEL:
				((SiteMapFolderModel) m_model).DeleteFolderOnCancel();
	
				break;
		}
	}
	
	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.ObjEditorRepostControl#DisableSavePopUp()
	 */
	protected boolean DisableSavePopUp()
	{
		return true;
	}

}

