package com.plumtree.portalpages.browsing.editors.sitemap.sitemapfolderplugin;


// Framework Imports
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This class extends EditorDP and displays the Select Web Links page for the
 * Site Map folder plug-in.
 */
public class SiteMapCreateWebLinkDP extends AFormDP
{
	/** The unique identifier for the class */
	public static final String STR_MVC_CLASS_NAME = "SiteMapCreateWebLinkDP";

	public String GetFormTitle()
	{
		return (m_asOwner.GetString(1489, "ptmsgs_portalbrowsingmsgs"));	
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the Site Map Folder Create Links page.
	 *
	 * @return HTMLElement
	 * @throws HTMLException
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 */
	public HTMLElement PageDisplay()

	{
		HTMLElementCollection result = new HTMLElementCollection();

		//Just ask the view to display itself
		result.AddInnerHTMLElement((m_asOwner.GetView(
				SiteMapCreateWebLinkView.STR_MVC_CLASS_NAME)).Display());

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 *
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
			SiteMapCreateWebLinkView.STR_MVC_CLASS_NAME).DisplayJavascript());

		return myScripts;
	}
}

