package com.plumtree.portalpages.browsing.editors.smartsort;

import com.plumtree.portaluiinfrastructure.editor.*;
/* job is auto created
import com.plumtree.portalpages.admin.editors.common.setjob.*;
*/

/**
 * This class contains the additional repost actions.
 * The ones specific to the Smart Sort Editor (other than
 * "change page", "finish" and "cancel" actions).
 *
 * @author OlegS
 */
public class SmartSortEditorRepostControl extends ObjEditorRepostControl
{
	
	public static final String STR_MVC_CLASS_NAME = "SmartSortEditorRepost";

	
	public final static int ACTION_ADD  = 80; // +GROUP_SHIFT*group

	
	public final static int ACTION_DEL  = 81; // +GROUP_SHIFT*group

	
	public final static int ACTION_SORT = 82; // +GROUP_SHIFT*group
	
	public final static int GROUP_SHIFT = 1000; // +GROUP_SHIFT*group

	/**
	 * 
	 *
	 * @param action 
	 *
	 * @return 
	 */
	public static int GetActionGroup(int action)
	{
		return (action >= GROUP_SHIFT) ? SmartSortEditorModel.DESTINATION_FOLDER_GROUP
								: SmartSortEditorModel.SOURCE_FOLDER_GROUP;
	}
	
	public static int RemoveGroupFromAction(int action)
	{
		if (action >= GROUP_SHIFT)
		{
			action -= GROUP_SHIFT;
		}
			return action;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SmartSortEditorRepostControl();
	}

		public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/* job is auto created
	protected void PerformAction(int _nAction)
	{
		TraceHelper.Trace("PerformAction " + _nAction);
		super.PerformAction(_nAction);

		// for job plugin
		((SetJobRepostControl) m_asOwner.GetControl(SetJobRepostControl.STR_MVC_CLASS_NAME)).PerformRepostAction(_nAction,
			m_htFormData);
	}
	*/

	/**
	 * 
	 */
	protected void SetRepostAction()
	{
		super.SetRepostAction();
		GetModel().m_nAction = m_nAction; // copy to model for convenience
	}

	/**
	 * 
	 *
	 * @return 
	 */
	protected SmartSortEditorModel GetModel()
	{
		return (SmartSortEditorModel) m_model;
	}
}

