package com.plumtree.portalpages.browsing.editors.userprofile;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This is the General Profile Display Page that will be used to display all of
 * the sections for each of the Profile pages.   It will retrieve the title and
 * names from the different pages.
 *
 */
public class ProfilePageListDP_D extends EditorDP
{
	/** object name it is overridden below**/
	public static final String STR_MVC_CLASS_NAME = "ProfilePageList";

	/** object title - it is overridden below **/
	public String _ui_PageTitle = "";
	
	public XPArrayList m_alPortlets = null;

	public ProfilePageListDP_D(XPArrayList _alPortlets)
	{
		super();
		m_alPortlets = _alPortlets;
	}

	/**
	 * Returns the HTML that is placed in the HEAD section of this HTML page.
	 *
	 * @return HTMLElement
	 *
	 * @throws HTMLException 
	 */
	public HTMLElementCollection DisplayHTMLinHEAD()

	{
		HTMLElementCollection retVal = new HTMLElementCollection();

		return retVal;
	}

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		// If it hasn't been overridden and set by GeneralProfileDP() call, use default
		if (m_asOwner.GetString(1286, "ptmsgs_portalbrowsingmsgs").equals(""))
		{
			_ui_PageTitle = m_asOwner.GetString(576, "ptmsgs_portalbrowsingmsgs");
		}

		return m_asOwner.GetString(1286, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the Profile List page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 *
	 * @return HTMLElement
	 */
	public HTMLElement PageDisplay()

	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		// display the list view
		for (int i = 0; i < m_alPortlets.GetSize(); i++)
		{
			views.AddInnerHTMLElement(((ProfilePageListView_D) m_asOwner.GetView(
					ProfilePageListView_D.STR_MVC_CLASS_NAME)).Display(m_alPortlets.GetElement(i)));
		}
		// add a spacer table
		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	     * Display no Javascripts.  This page is only used in 508 mode.
	     *
	     * @return HTMLScriptCollection
	     * @throws HTMLException
	     */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		return myScripts;
	}
}

