package com.plumtree.portalpages.browsing.gateway;

import com.plumtree.portaluiinfrastructure.tags.displaytree.*;

/**
 * This class contains constants necessary for the Tag Engine integration. 
 */
public class TagConstants
{
	/**
	 * The name of the standard tag library.
	 */
	public static final String STANDARD_LIBRARY = "standard"; 

	/**
	 * The fully qualified name of the display mode tag. 
	 */
	public static final String DISPLAY_MODE_TAG_FULL_NAME = STANDARD_LIBRARY +
		TagDisplayElement.LIBRARY_SEPARATOR + "displaymode";

	/**
	 * The name of the hosted mode attribute in the display mode tag.
	 */
	public static final String DISPLAY_MODE_TAG_MODE_ATTRIBUTE = "mode";

	/**
	 * The display mode attribute to set the page to hosted mode.
	 */
	public static final String DISPLAY_MODE_ATTRIBUTE_HOSTED_VALUE = "Hosted";
}