package com.plumtree.portalpages.browsing.layoutselection;

import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.editor.*;

/**
 * 
 *
 * @author michaeld
 */
public interface ILayoutSelectionModelRO extends IEditorModelRO
{
	/**
	 * Get the count of columns to display on the select layout page.
	 *
	 * @return int nLayoutColumnCount
	 */
	public int GetLayoutColumnCount();

	/**
	 * @return whether the page has a content canvas portlet on it
	 */
	public boolean GetPageHasFreeFormPortlet();
	
	/**
	 * @return whether the page supports a content canvas section
	 */
	public boolean GetPageSupportsFreeFormSection();

	/**
	 * Get the name of the parent window's form.
	 *
	 * @return String
	 */
	public String GetParentFormName();

	/**
	 * Get the name of the form element for selected items.
	 *
	 * @return String
	 */
	public String GetParentFormSelectInput();

	/**
	 * Get the string that is the parent form space ID.
	 *
	 * @return String
	 */
	public String GetParentFormSpaceID();

	/**
	 * Get the string that is the parent form submit function.
	 *
	 * @return String
	 */
	public String GetParentFormSubmitFunction();

	/**
	 * Get the currently selected layout.
	 *
	 * @return nSelectedLayout
	 */
	public int GetSelectedLayout();
	
	/**
	 * 
	 * @return Available portlet page layouts
	 */
	public IPTQueryResult GetAdaptiveLayouts();
}

