package com.plumtree.portalpages.browsing.layoutselection;

import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 *
 * @author michaeld
 */
public class LayoutSelectionDP extends EditorDP
{
	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "LayoutSelection";

	/**
	 * Returns the String to display on the left navigation menu,  linking to
	 * that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return m_asOwner.GetString(627, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
		
	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader()
	{
		if (((ILayoutSelectionModelRO) m_asOwner.GetModel(
							LayoutSelectionModel.STR_MVC_CLASS_NAME)).GetPageSupportsFreeFormSection())
		{
	  		return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1077,
	  		"ptmsgs_portalbrowsingmsgs"), this.m_asOwner);
		}
		return HTMLConstructHelpers.GetSubHeader("", this.m_asOwner);
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()

	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
				LayoutSelectionView.STR_MVC_CLASS_NAME)).Display());

		result.AddInnerHTMLElement(CreateContentTable(views, null));

		return result;
	}

	/**
	 * 
	 *
	 * @return 
	 *
	 * @throws HTMLException 
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection scripts = new HTMLScriptCollection();
		scripts.AddInnerHTMLElement(m_asOwner.GetView(
				LayoutSelectionView.STR_MVC_CLASS_NAME).DisplayJavascript());

		return scripts;
	}
}

