package com.plumtree.portalpages.browsing.login;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.portaluiinfrastructure.layout.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author BenG
 */
public class LoginDP extends PlumtreeDP
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.login.LoginDP");

	public static final String STR_MVC_CLASS_NAME = "Login";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Init(AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		super.Init( parent );
		
		parent.SetHelpTopic( "PT_Login" );
		
	}


	/**
	 * @see com.plumtree.xpshared.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetSubtitleForBanner()
	 */
	public String GetSubtitleForBanner()
	{
		return "";
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetTitleForBanner()
	 */
	public String GetTitleForBanner()
	{
		return m_asOwner.GetString(630, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()
	{
		
			log.Debug("PageDisplay()");
		

		HTMLElementCollection myCollection = new HTMLElementCollection();

		try
		{
			HTMLElement element = DisplayLayout(Layouts.LOGIN_PAGE);
			if (null != element) {
				return element;
			}
			
			myCollection.AddInnerHTMLElement(m_asOwner.GetView(LoginView.STR_MVC_CLASS_NAME).Display());
		}
		catch (HTMLException he)
		{
			
				log.Error("he: " + he);
			
		}

		return myCollection;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#DisplayJavaScriptFromChild()
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection myScriptCollection = new HTMLScriptCollection();

		HTMLScript myScript = m_asOwner.GetView(LoginView.STR_MVC_CLASS_NAME).DisplayJavascript();

		if (myScript != null)
		{
			myScriptCollection.AddInnerHTMLElement(myScript);
		}

		return myScriptCollection;
	}
}

