package com.plumtree.portalpages.browsing.login.createaccount;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 *
 * @author BenG
 */
public class CreateAccountDP extends PlumtreeDP
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.login.createaccount.CreateAccountDP");

	public static final String STR_MVC_CLASS_NAME = "CreateAccountDP";
	
	/**
	 * @see com.plumtree.xpshared.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetSubtitleForBanner()
	 */
	public String GetSubtitleForBanner()
	{
		return "";
	}
	
	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetTitleForBanner()
	 */
	public String GetTitleForBanner()
	{
		return m_asOwner.GetString(0, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection myCollection = new HTMLElementCollection();

		try
		{
			myCollection.AddInnerHTMLElement(m_asOwner.GetView(
					CreateAccountView.STR_MVC_CLASS_NAME).Display());
		}
		catch (HTMLException he)
		{
			
				log.Error(he, "Error displaying page.");
			
		}

		return myCollection;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#DisplayJavaScriptFromChild()
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		try
		{
			myScripts.AddInnerHTMLElement(m_asOwner.GetView(
					CreateAccountView.STR_MVC_CLASS_NAME).DisplayJavascript());
		}
		catch (HTMLException he)
		{
			
				log.Error(he, "Error displaying javascript.");
			
		}

		return myScripts;
	}
}

