package com.plumtree.portalpages.browsing.login.createaccount;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.admin.sendinvitation.*;
import com.plumtree.portalpages.pei.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.web.*;

/**
 * Handles incoming invitation request
 *
 * @author BenG
 * @author DavidP
 */
public class InterceptInvitationControl implements IControl
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.login.createaccount.InterceptInvitationControl");

	/** object name */
	public static final String STR_MVC_CLASS_NAME = "InterceptInvitationControl";
	private AActivitySpace m_asOwner;

	/** MVC Objects */
	private CreateAccountModel m_asModel;

	/**
	 * @see com.plumtree.xpshared.activityspace.IControl#execute()
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		
			log.Debug("Execute()");
		

		Redirect myRedirect = null;

		String[] sValues = null;

		// Invite code
		sValues = (String[]) arguments.GetElement(InvCodesListView.CONTROLARGUMENT_INVCODE);

		if (sValues != null)
		{
			
				log.Debug("invite code: " + sValues[0]);
			

			m_asModel.SetInviteCode(sValues[0]);
		}
		
		// Get all the values from the CreateAccount that are being intercepted 
		// and re-use them on the redirect
		
		
		
		//PEI : OnAfterAcceptInvite
		//BrianH - This set of code will process through all of the available OnAfterAcceptInvite PEIs
		// and process the according functionality.
		Object[] oa;
		Object o;
		ICreateAccountActions iActions;
		IApplication application = m_asOwner.GetApplication();

		oa = (Object[]) application.GetCachingManager().GetEntry("CreateAccountActions");

		if (oa != null)
		{
			for (int x = 0; x < oa.length; x++)
			{
				o = oa[x];

				
					log.Debug("CheckActionSecurityAndExecute() - About to call OnAfterAcceptInvite on an: " + o);
				

				if(o != null)
				{
					iActions = (ICreateAccountActions) o;
					iActions.OnAfterAcceptInvite(m_asOwner, (IPTSession) m_asOwner.GetUserSession(), sValues[0]);
				 }
			}
		}
		//PEI : OnAfterAcceptInvite : END

		//	Now use the create account control.
		myRedirect = new Redirect();

		myRedirect.SetLinkGetSpaceIfCached(CreateAccountAS.STR_MVC_CLASS_NAME,
			this.m_asOwner);

		return myRedirect;
	}

	/////////////
	// IMVCObject
	/////////////

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new InterceptInvitationControl();
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IControl#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IControl#Init(IModelRW)
	 */
	public void Init(IModel model, AActivitySpace space)
	{
		m_asModel     = (CreateAccountModel) model;
		m_asOwner     = space;
	}
}

