package com.plumtree.portalpages.browsing.myportal;

import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * 
 *
 * @author michaeld
 */
public interface IMyPortalModelHelper
{
	/**
	 * Returns the preference name for collapsed gadgets.
	 *
	 * @return String strCollapsedPortletsPrefName
	 */
	public String GetCollapsedPortletsPrefName();

	/**
	 * Get the pages in the community.
	 *
	 * @param nCommunityID nCommunityID
	 *
	 * @return IPTQueryResult ptqrCommunityPages
	 */
	public IPTQueryResult GetCommunityPages(int nCommunityID);

	/**
	 * Returns the portlets without title bars.
	 *
	 * @param nCOmmunityID nCommunityID
	 * @return Object[][] aoPortletHasNoTitleBar
	 */
	public Object[][] GetPortletHasNoTitleBar(int nCommunityID);

	/**
	 * Get whether the current page is a community page.
	 *
	 * @return boolean bIsCommunityPage
	 */
	public boolean GetIsCommunityPage();

	/**
	 * Initializes the MyPortalModelHelper.
	 *
	 * @param ptSession session
	 */
	public void Init(IPTSession ptSession, AActivitySpace parent);

	/**
	 * Returns IPTMyPortal for the current page.
	 *
	 * @param nCommunityID nCommunityID
	 * @param nPageID nPageID
	 *
	 * @return IPTMyPortal
	 */
	public IPTPageInfo OpenPage(int nCommunityID, int nPageID);
	
	/**
	 * Returns the Community Name if this is a Community.
	 * 
	 * @param nCommunityID
	 * @return String
	 * @deprecated Use NavigationModel.GetCurCommunityName instead.
	 */
	public String GetCommunityName(int nCommunityID);
}

