package com.plumtree.portalpages.browsing.myportal;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.intrinsicportlets.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 * 
 *
 * @author josephc
 */
public class IntrinsicPortletsRepostControl extends RepostControl
{
	/** Class name for the control */
	public static final String STR_MVC_CLASS_NAME = "IntrinsicPortletsRepostControl";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new IntrinsicPortletsRepostControl();
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.RepostControl#PerformAction(int)
	 */
	protected void PerformAction(int _nAction)
	{
		super.PerformAction(_nAction);

		// Aggregate all of the intrinsic portlet controls. Now iterate through intrinsic
		// portlet controls and call PerformRepostAction for each.
		IXPEnumerator enumControls = m_asOwner.GetControlsEnumerator();

		while (enumControls.MoveNext())
		{
			IControl currentControl = (IControl) enumControls.GetCurrent();

			if (currentControl instanceof IntrinsicPortletControl)
			{
				IntrinsicPortletControl iPortletControl = (IntrinsicPortletControl) currentControl;
				iPortletControl.PerformRepostAction(_nAction, m_htFormData);
				// mbs- do a quick check for a redirect
				Redirect r = iPortletControl.CheckActionSecurityAndExecute(m_htFormData);
				if (null != r)
					SetRedirect(r);
			}
		}
	}
}

