package com.plumtree.portalpages.browsing.myportal;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 *
 * @version $Revision$
 * @author RobZ
 */
public class MyPortalFooterView implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.myportal.MyPortalFooterView");


	public static final String m_ObjectName = "MyPortalFooterView";


	protected AActivitySpace m_asOwner;


	protected IMyPortalModelRO m_model;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new MyPortalFooterView();
	}

	/**
	 * This method returns the HTMLElement that encompasses the output of the
	 * Section.
	 *
	 * @return
	 */
	public HTMLElement Display()
	{
		// Temp thing
		// boolean bValidSession = true; not used -- JAO
		HTMLElementCollection result = new HTMLElementCollection();

		// HTMLTable table              = new HTMLTable(); JAO
		//        try
		//        {
		//            result.AddInnerHTMLElement(table);
		//
		//            // Community actions
		//            // Dont display if we are editing a default profile
		//            XPArrayList list = m_model.GetMyPortalActions();
		//
		//            if (m_model.GetIsCommunityPage())
		//            {
		//                GenerateFooterActions(table, list, _ui_MembershipOptions);
		//            }
		//            else
		//            {
		//                GenerateFooterActions(table, list, _ui_PageOptions);
		//            }
		//        }
		//        catch (HTMLException he)
		//        {
		//            he.printStackTrace();
		//        }
		return result;
	}

	/**
	 * This method returns the HTMLScript that encompasses the Javascript on
	 * the page.
	 *
	 * @return HTMLScript
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		return null;
	}

	/**
	 * Return the name of the Section.
	 *
	 * @return
	 */
	public String GetName()
	{
		return m_ObjectName;
	}

	/**
	 * This method initializes the Section with the read only model interface it
	 * is supposed to draw it's data from as well as it's parent ActivitySpace
	 * (necessary to create URLS).
	 *
	 * @param model
	 * @param parent
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_model		  = (IMyPortalModelRO) model;
		m_asOwner     = parent;
	}

	/**
	 *
	 *
	 * @param table
	 * @param list
	 * @param title
	 *
	 * @throws HTMLException
	 */
	protected void GenerateFooterActions(HTMLTable table, XPArrayList list,
		String title)
	{
		HTMLTableRow row   = new HTMLTableRow();
		HTMLTableCell cell = new HTMLTableCell();

		cell.SetVAlign("MIDDLE");
		cell.SetAlign("LEFT");

		table.AddInnerHTMLElement(row);
		row.AddInnerHTMLElement(cell);

		cell.AddInnerHTMLElement(new HTMLAnchor("options"));
		cell.AddInnerHTMLString(title);
		cell.SetStyleClass(PTStyleClass.ACTIONBAR_BAN_TEXT);

		row		 = new HTMLTableRow();
		cell     = new HTMLTableCell();
		cell.SetStyleClass(PTStyleClass.ACTIONBAR_TEXT);
		table.AddInnerHTMLElement(row);
		row.AddInnerHTMLElement(cell);

		for (int i = 0; i < list.GetSize(); i++)
		{
			if (0 != i)
			{
				cell.AddInnerHTMLString("&nbsp; | &nbsp;");
			}

			ASURLContainer urlCont = null;

			try
			{
				urlCont = (ASURLContainer) list.GetElement(i);
			}
			catch (Exception e)
			{
				
					log.Error(e, "Error in MyPortalFooterView::GenerateFooterActions: ");
				
			}

			cell.AddInnerHTMLElement(ASURL.CreateFromURLContainerNew(urlCont)
				.GetURLAsHTMLElement());
		}
	}
}

