package com.plumtree.portalpages.browsing.myportal;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.browsing.myportal.communities.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 *
 * @author RobZ
 */
public class MyPortalHeaderView implements IView
{
	/** Object name; not to be localized */
	public static final String ObjectName = "MyPortalHeaderView";

	// Localizable lable strings used in 508 mode

	
	protected AActivitySpace m_asOwner;

	
	protected IMyPortalModelRO m_model;

	
	protected boolean m_bCommunityPage = true;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new MyPortalHeaderView();
	}

	/**
	 * This method returns the HTMLElement that encompasses the output of the
	 * Section.
	 *
	 * @return 
	 */
	public HTMLElement Display()
	{
		HTMLTable table		   = null;
		HTMLTableRow row	   = null;
		HTMLTableCell cell     = null;
		IPTQueryResult qrPages = null;

		if (m_model.GetIsCommunityPage())
		{
			qrPages = m_model.GetCommunityPages();
		}

		try
		{
			// Also check what type of navigation currently used		
			if (null != qrPages)
			{
				table = new HTMLTable();
				table.SetSummary(m_asOwner.GetString(1269, "ptmsgs_portalbrowsingmsgs"));

				row = new HTMLTableRow();
				table.AddInnerHTMLElement(row);
				cell = new HTMLTableCell();
				cell.SetWidth("100%");
				cell.SetAlign("LEFT");

				//				cell.AddInnerHTMLString("adf");
				row.AddInnerHTMLElement(cell);

				row = new HTMLTableRow();
				table.AddInnerHTMLElement(row);

				// Temp code
				cell = new HTMLTableCell();
				cell.SetWidth("100%");
				cell.SetAlign("CENTER");

				//			cell.SetStyleClass("body");
				for (int i = 0; i < qrPages.RowCount(); i++)
				{
					String pageName = qrPages.ItemAsString(i,
							PT_PROPIDS.PT_PROPID_NAME);
					int pageID	    = qrPages.ItemAsInt(i,
							PT_PROPIDS.PT_PROPID_OBJECTID);
					ASURL asURL     = new ASURL(m_asOwner);
					asURL.SetLinkCreateNewSpace(CommunityPageAS.STR_MVC_CLASS_NAME,
						m_asOwner);
					asURL.SetControl(SetCommunityControl.STR_MVC_CLASS_NAME);
					asURL.AddControlArgument(SetCommunityControl.STR_COMMUNITY_ID,
						XPConvert.ToString(m_model.GetCommunityID()));
					asURL.AddControlArgument(SetCommunityControl.STR_PAGE_ID,
						XPConvert.ToString(pageID));
					asURL.AddInnerHTMLString(pageName);

					if (0 != i)
					{
						cell.AddInnerHTMLString("&nbsp;|&nbsp;");
					}

					cell.AddInnerHTMLElement(asURL.GetURLAsHTMLElement());
					cell.SetStyleClass(PTStyleClass.BREADCRUMB_TEXT);
				}

				//cell.AddInnerHTMLString("blalba &nbsp;|&nbsp; adfafd &nbsp;|&nbsp; asdfaf &nbsp;|&nbsp; adfasf &nbsp;|&nbsp;a dafasdfasf &nbsp;|&nbsp;");
				row.AddInnerHTMLElement(cell);
			}
		}
		catch (Exception e)
		{
			// @TODO: Fix this shiat
			table = new HTMLTable();
		}

		return table;
	}

	/**
	 * This method returns the HTMLScript that encompasses the Javascript on
	 * the page.
	 *
	 * @return HTMLScript
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		return null;
	}

	/**
	 * Return the name of the Section.
	 *
	 * @return 
	 */
	public String GetName()
	{
		return ObjectName;
	}

	/**
	 * This method initializes the Section with the model it is supposed to draw
	 * it's data from as well as it's parent ActivitySpace (necessary to
	 * create URLS).
	 *
	 * @param model 
	 * @param parent 
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_model		  = (IMyPortalModelRO) model;
		m_asOwner     = parent;
	}
}

