package com.plumtree.portalpages.browsing.myportal.communities;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * File: CommunityInvitationJoinDP.java
 * ------------------------------------
 * Display page for joining a community via an Invitation.
 *
 * @author NaveenP/DustinA
 */
public class CommunityInvitationJoinDP extends PlumtreeDP
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.myportal.communities.CommunityInvitationJoinDP");

	
	public static final String STR_MVC_CLASS_NAME = "CommunityInvitationJoin";

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetSubtitleForBanner()
	 */
	public String GetSubtitleForBanner()
	{
		return "";
	}

	
	/** Logging */
	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetTitleForBanner()
	 */
	public String GetTitleForBanner()
	{
		return m_asOwner.GetString(641, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#PageDisplay(HTMLTableRow)
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		try
		{
			result.AddInnerHTMLElement(m_asOwner.GetView(
					CommunityInvitationJoinView.STR_MVC_CLASS_NAME).Display());
		}
		catch (HTMLException he)
		{
			log.Error(he, "Error displaying CommunityInvitationJoinView.");
		}

		return result;
	}
}

