package com.plumtree.portalpages.browsing.myportal.communities;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * Display page for unsubscribing a community via UnsubscribeCurCommunityControl.
 * 
 * @author btse
 *
 */
public class CommunityUnsubscribeDP extends PlumtreeDP
{
	private static OpenLogger log = OpenLogService.GetLogger(
			OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
			"com.plumtree.portalpages.browsing.myportal.communities.CommunityUnsubscribeDP");

		
	public static final String STR_MVC_CLASS_NAME = "CommunityUnsubscribe";

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetSubtitleForBanner()
	 */
	public String GetSubtitleForBanner()
	{
		return "";
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetTitleForBanner()
	 */
	public String GetTitleForBanner()
	{
		return m_asOwner.GetString(1920, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#PageDisplay(HTMLTableRow)
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		try
		{
			result.AddInnerHTMLElement(m_asOwner.GetView(
					CommunityUnsubscribeView.STR_MVC_CLASS_NAME).Display());
		}
		catch (HTMLException he)
		{
			log.Error(he, "Error displaying CommunityUnsubscribeView.");
		}

		return result;
	}
}
