package com.plumtree.portalpages.browsing.myportal.communities;

import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * File: PreviewCommunityAS.java
 * -----------------------------
 *
 *
 * @author NaveenP
 */
public class PreviewCommunityAS extends PlumtreeAS
{
	
	public static final String STR_MVC_CLASS_NAME = "PreviewCommunity";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new PreviewCommunityAS();
	}

	/**
	 * Get Name
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.AActivitySpace#Init()
	 */
	public void Init()
	{
		super.Init();

		SetTrackCurrentPage(true);

		// Community Preview DisplayPages
		RegisterPage(new PreviewCommunityDP());
		RegisterPage(new NoCommunityAccessDP());

		// Community Preview Models
		RegisterModel(PreviewCommunityModel.STR_MVC_CLASS_NAME);

		IModel myModel = GetModel(PreviewCommunityModel.STR_MVC_CLASS_NAME);

		RegisterView(NoCommunityAccessView.STR_MVC_CLASS_NAME, myModel);

		// Community Preview Controls
		RegisterControl(PreviewCommunityControl.STR_MVC_CLASS_NAME, myModel);
	}
}

