package com.plumtree.portalpages.browsing.myportal.communities;

import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 * File: PreviewCommunityBarAS.java
 * --------------------------------
 *
 *
 * @author NaveenP
 */
public class PreviewCommunityBarAS extends PlumtreeAS implements IFormAS
{
	
	public static final String STR_MVC_CLASS_NAME = "PreviewCommunityBar";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new PreviewCommunityBarAS();
	}

	/**
	 * Get Name
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.IRepostAS#GetRepostControlName()
	 */
	public String GetRepostControlName()
	{
		return JoinCommunityControl.STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.AActivitySpace#Init()
	 */
	public void Init()
	{
		super.Init();

		SetTrackCurrentPage(true);

		// Community Preview DisplayPages
		RegisterPage(new PreviewCommunityBarDP());
		RegisterPage(new PreviewCommunityDescPopupDP());
		RegisterPage(new CommunityInvitationJoinDP());

//		CommunityInvitationDP_D commInviteDP_D = new CommunityInvitationDP_D();
//		commInviteDP_D.SetShowFormFooter(true);
		RegisterPage(new CommunityInvitationDP_D());

		// Community Preview Model
		RegisterModel(PreviewCommunityBarModel.STR_MVC_CLASS_NAME);

		IModel myModel = GetModel(PreviewCommunityBarModel.STR_MVC_CLASS_NAME);

		// Preview and Invitation Views
		RegisterView(PreviewCommunityView.STR_MVC_CLASS_NAME, myModel);
		RegisterView(PreviewCommunityDescPopupView.STR_MVC_CLASS_NAME, myModel);
		RegisterView(CommunityInvitationJoinView.STR_MVC_CLASS_NAME, myModel);
		RegisterView(CommunityInvitationView_D.STR_MVC_CLASS_NAME, myModel);

		// Community Preview Controls
		RegisterControl(PreviewCommunityBarControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(JoinCommunityControl.STR_MVC_CLASS_NAME, myModel);
	}
}

