package com.plumtree.portalpages.browsing.myportal.communities;

import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 *
 * @author NaveenP
 */
public class PreviewCommunityBarDP extends AFormDP
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.myportal.communities.PreviewCommunityBarDP");

	
	public static final String STR_MVC_CLASS_NAME = "PreviewCommunityBar";

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()
	 */
	public String GetFormTitle()
	{
		return m_asOwner.GetString(1621, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.AformDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()
	{
		HTMLTable tOuter = new HTMLTable();

		try
		{
			tOuter.SetCellPadding("0");
			tOuter.SetCellPadding("0");

			HTMLTableRow tRow   = null;
			HTMLTableCell tCell = null;

			tOuter.SetWidth("100%");
			tOuter.SetBorder("0");

			tRow	  = new HTMLTableRow();
			tCell     = new HTMLTableCell();
			tOuter.AddInnerHTMLElement(tRow);

			tRow.AddInnerHTMLElement(tCell);
			tRow.SetVAlign("TOP");
			tCell.SetVAlign("TOP");
			tCell.AddInnerHTMLElement(m_asOwner.GetView(
					PreviewCommunityView.STR_MVC_CLASS_NAME).Display());
		}
		catch (HTMLException he)
		{
			log.Error(he, he.getMessage());
		}

		return tOuter;
	}

	/**
	 * 
	 *
	 * @return 
	 *
	 * @throws HTMLException 
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		PreviewCommunityBarModel asModel = (PreviewCommunityBarModel) m_asOwner.GetModel(PreviewCommunityBarModel.STR_MVC_CLASS_NAME);

		HTMLScriptCollection scripts = new HTMLScriptCollection();

		if (asModel.IsCommunitySelectionPreviewPage() ||
				asModel.IsCommunityInvitePage())
		{
			scripts.AddInnerHTMLElement(((PreviewCommunityView) m_asOwner.GetView(
					PreviewCommunityView.STR_MVC_CLASS_NAME)).JoinCommunityInPreviewPageScript());
		}

		return scripts;
	}
}

