package com.plumtree.portalpages.browsing.myportal.communities;

import com.plumtree.portalpages.browsing.myportal.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.common.*;

/**
 * File: PreviewCommunityDP.java
 * -----------------------------
 *
 *
 * @author NaveenP
 */
public class PreviewCommunityDP extends FrameSetDP
{
	
	public static final String STR_MVC_CLASS_NAME = "PreviewCommunity";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.dialogheader.FrameSetDialog#GetFrameSetTitle()
	 */
	public String GetFrameSetTitle()
	{
		return m_asOwner.GetString(703, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.dialogheader.FrameSetDialog#GetFrameURLBody()
	 */
	public ASURL GetFrameURLBody()
	{
		PreviewCommunityModel asModel = (PreviewCommunityModel) m_asOwner.GetModel(PreviewCommunityModel.STR_MVC_CLASS_NAME);

		ASURL url = new ASURL(m_asOwner);
		url.SetLinkCreateNewSpace(CommunityPageAS.STR_MVC_CLASS_NAME, m_asOwner);
		url.SetControl(SetCommunityControl.STR_MVC_CLASS_NAME);
		url.AddControlArgument(SetCommunityControl.STR_COMMUNITY_ID,
			asModel.GetCommunityID());
		url.AddControlArgument(SetCommunityControl.STR_PAGE_ID,
			0);
		url.AddControlArgument(SetCommunityControl.PREVIEW);

		return url;
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.dialogheader.FrameSetDialog#GetFrameURLTop()
	 */
	public ASURL GetFrameURLTop()
	{
		PreviewCommunityModel asModel = (PreviewCommunityModel) m_asOwner.GetModel(PreviewCommunityModel.STR_MVC_CLASS_NAME);

		ASURL url = new ASURL(m_asOwner);
		url.SetLinkCreateNewSpace(PreviewCommunityBarAS.STR_MVC_CLASS_NAME,
			m_asOwner);
		url.SetControl(PreviewCommunityBarControl.STR_MVC_CLASS_NAME);
		url.AddControlArgument(PreviewCommunityBarControl.m_CommunityID,
			asModel.GetCommunityID());
		url.AddControlArgument(PreviewCommunityBarControl.m_PageID,
			-1 * asModel.GetCommunityID());
		url.AddControlArgument(PreviewCommunityBarControl.m_PreviewType,
			asModel.m_nPreviewStatus);
		url.AddControlArgument(PreviewCommunityBarControl.m_CommunityIndex,
			asModel.GetCommunityIndex());
		url.AddControlArgument(PreviewCommunityBarControl.m_CommunityChecked,
			asModel.IsCommunityChecked());		
		url.AddControlArgument(PreviewCommunityBarControl.m_strJoinCommunityJavascriptOverride,
				asModel.GetJoinCommunityJavaScriptOverride());
		
		return url;
	}
	
	/**
	 * 
	 * @see com.plumtree.uiinfrastructure.activityspace.FrameSetDP#GetFrameScrollBody()
	 */
	public boolean GetFrameScrollBody()
	{
		return true;	
	}
}

