package com.plumtree.portalpages.browsing.myportal.communities;

import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * File: PreviewCommunityDescPopupDP.java
 * --------------------------------------
 * Display page for the Community Description popup.
 *
 * @author NaveenP/DustinA
 */
public class PreviewCommunityDescPopupDP implements IDisplayPage
{
	
	public static final String STR_MVC_CLASS_NAME = "PreviewCommunityDescPopup";
	private AActivitySpace m_asOwner;

	/**
	 * @see com.plumtree.xpshared.activityspace.IDisplayPage#display()
	 */
	public void Display(IWebData pageData)
	{
		// TODOCR: DONH - Shouldn't there by a Display Page that wraps this view
		// and generates the HTMLPage?
		pageData.SetData(m_asOwner.GetView(PreviewCommunityDescPopupView.STR_MVC_CLASS_NAME).Display());
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.ui.framework.IDisplayPage#GetParent()
	 */
	public AActivitySpace GetOwner()
	{
		return m_asOwner;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IDisplayPage#Init(AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		m_asOwner = parent;
	}
}

