package com.plumtree.portalpages.browsing.myportal.editpage;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author michaeld
 */
public class EditCommunityPageView implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.myportal.editpage.EditCommunityPageView");

	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "EditCommunityPage";

	
	
	/** Javascript function: submitToParent */
	public static final String JAVASCRIPT_SUBMIT_TO_PARENT = "submitToParent";

	/** Form Input: Page Template Selected */
	public static final String HTMLINPUT_PAGETEMPLATE_SET = "in_hi_PTSet";

	/** Activity Space */
	private AActivitySpace m_asasParent;

	/** Model */
	private IEditMyPortalPageModelRO m_asmModel;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new EditCommunityPageView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		return null;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		// Set up parent form space ID
		String strSpaceIDInput = m_asmModel.GetParentFormSpaceID();

		// Calculate approximate string builder size
		int nSize = 400;

		if ((strSpaceIDInput != null) && (!"".equals(strSpaceIDInput)))
		{
			// Add space for setting the space ID on the parent page
			nSize += 20;
		}

		XPStringBuilder sb = new XPStringBuilder(nSize);

		// Select submit function (multi and single)
		// Different cases for a single radio/checkbox button vs. multiple
		// radio/checkbox buttons:
		// - single is just an object
		// - multiple is an array of objects
		//sb.Append( "function " ).Append(JAVASCRIPT_SUBMIT_TO_PARENT).Append("()\n" );
		//sb.Append( "{\n" );
		//sb.Append( "  return true;\n" );
		//sb.Append( "}\n" );
		//sb.Append( "\n" );
		// Onload method to set the Space ID
		if ((strSpaceIDInput != null) && (!"".equals(strSpaceIDInput)))
		{
			// TODO: Should this only be called the first time the tree is displayed?
			sb.Append("window.opener.document.").Append(JSHelper.escapeJS(m_asmModel.GetParentFormName()))
			.Append(".").Append(JSHelper.escapeJS(strSpaceIDInput)).Append(".value= ")
			.Append(m_asasParent.GetSpaceID()).Append(";\n");
			sb.Append("\n");
		}

		HTMLScript result = new HTMLScript("text/javaScript");

		try
		{
			result.AddInnerHTMLString(sb.ToString());
		}
		catch (HTMLException he)
		{
			log.Error(he, "DisplayJavascript couldn't add javascript to the HTMLScript element.");
		}

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_asmModel		 = (IEditMyPortalPageModelRO) model;
		m_asasParent     = parent;
	}
}

