package com.plumtree.portalpages.browsing.myportal.editpage;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.portalpages.browsing.myportal.*;
import com.plumtree.portalpages.common.editpage.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * File: EditMyPagePortletLayoutAS_D.java
 * -------------------------------------
 *
 * @author NaveenP
 */
public class EditMyPagePortletLayoutAS_D extends PTEditorAS
{
	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "EditMyPageGadgetLayout";
	
	/** Plug in Key: PageName */
	public static final String strPageNamePlugInKey = "PageName";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new EditMyPagePortletLayoutAS_D();
	}

	public String GetEditorTitle()
	{
		EditMyPagePortletLayoutModel_D myModel = (EditMyPagePortletLayoutModel_D) GetModel(EditMyPagePortletLayoutModel_D.STR_MVC_CLASS_NAME);
		
		return XPResourceManager.FormatMessage(
					GetString(1261, "ptmsgs_portalbrowsingmsgs"),
					myModel.GetPageName());
	}
	
	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(java.lang.String, java.lang.String, boolean)
	 */
	public boolean CheckBasicAccess(String strPage, String strControl, boolean bSameSpace)
	{
		boolean bAccess = super.CheckBasicAccess(strPage, strControl, bSameSpace);

		if ((null != strControl) && (strControl.equals(SetPageControl.STR_MVC_CLASS_NAME)))
		{
			bAccess = true;
		}

		return bAccess;
	}

	/**
	 * 
	 *
	 * @return 
	 *
	 * @throws HTMLException 
	 */
	public HTMLScriptCollection DisplayCommonJavaScript()
		throws HTMLException
	{
		return new HTMLScriptCollection();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/* */

	/**
	 * Returns the class name of the Property Repost Control.
	 *
	 * @return String
	 */
	public String GetRepostControlName()
	{
		return (EditMyPagePortletLayoutRepostControl_D.STR_MVC_CLASS_NAME);
	}

	/**
	 * Registers all the classes of the Property Activity Space.
	 *
	 */
	public void Init()
	{
		m_strModelName = EditMyPagePortletLayoutModel_D.STR_MVC_CLASS_NAME;
		
		super.Init();
		
		SetTrackCurrentPage(true);
		//RegisterModel(EditMyPagePortletLayoutModel_D.STR_MVC_CLASS_NAME);

		IModel myModel = GetModel(EditMyPagePortletLayoutModel_D.STR_MVC_CLASS_NAME);
	
		RegisterModel(PageNamePlugInModel.STR_MVC_CLASS_NAME, strPageNamePlugInKey);

		// Register DisplayPages
		AFormDP myPage = new EditMyPagePortletLayoutDP_D();
		//myPage.SetShowFormFooter(true);
		RegisterPage(myPage);

		// Register Views
		RegisterView(EditMyPagePortletLayoutView_D.STR_MVC_CLASS_NAME, myModel);
		RegisterView(PageNameView.STR_MVC_CLASS_NAME, strPageNamePlugInKey,
			GetModel(strPageNamePlugInKey));

		// Register Controls
		RegisterControl(EditMyPagePortletLayoutRepostControl_D.STR_MVC_CLASS_NAME,
			myModel);
		RegisterControl(EditMyPagePortletLayoutSetPageControl_D.STR_MVC_CLASS_NAME,
			myModel);
			
		SetCurrentPage(GetPage(EditMyPagePortletLayoutView_D.STR_MVC_CLASS_NAME));	
			
		this.SetHelpTopic( "PT_MyPage_EditPage" );
	}
}

