package com.plumtree.portalpages.browsing.myportal.editpage;


// Framework Imports
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.errordisplay.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 * File: EditMyPagePortletLayoutRepostControl_D.java
 * ------------------------------------------------
 *
 * @author NaveenP
 */
public class EditMyPagePortletLayoutRepostControl_D extends RepostControl
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.myportal.editpage.EditMyPagePortletLayoutRepostControl_D");

	
	public static final String STR_MVC_CLASS_NAME = "EditMyPagePortletLayoutRepost";

	
	public final static int POSTTOSELF_ACTION_UP   = 10;

	
	public final static int POSTTOSELF_ACTION_DOWN = 11;
	
	
	public final static int POSTTOSELF_ACTION_DELETE = 12;
	protected EditMyPagePortletLayoutModel_D m_asModel;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new EditMyPagePortletLayoutRepostControl_D();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#Init(IModel, AActivitySpace)
	 */
	public void Init(IModel model, AActivitySpace space)
	{
		super.Init(model, space);

		m_asModel = (EditMyPagePortletLayoutModel_D) model;
	}

	/**
	 * Switch between the action modes and call
	 * the associated method for each action.
	 *
	 * @param int
	 */
	protected void PerformAction(int _nAction)
	{
		super.PerformAction(_nAction);
	
		boolean bDo302Redirect = false;

		try
		{
			switch (_nAction)
			{
			case POSTTOSELF_ACTION_UP:
				m_asModel.SetActionUp();
				m_asModel.DoAction();
				bDo302Redirect = true;

				break;

			case POSTTOSELF_ACTION_DOWN:
				m_asModel.SetActionDown();
				m_asModel.DoAction();
				bDo302Redirect = true;

				break;
				
			case POSTTOSELF_ACTION_DELETE:
				m_asModel.SetActionDelete();
				m_asModel.DoAction();
				bDo302Redirect = true;

				break;

			default:}
		}
		catch (Exception e)
		{
			log.Error(e, "Server Error");

			UIError myError = new UIError(UIErrorLevel.FRIENDLY,
					UIErrorScope.CURRENT_USER, null, e.getMessage(),
					e.getMessage());
			UIErrorHandler.RaiseError(myError, m_asOwner.GetSubSession(),
				m_asOwner.GetApplication());
		}

		if (bDo302Redirect)
		{
			// Redirect to url with no action in it so that refreshes don't cause wierd behavior.
			Redirect myRedirect = new Redirect();
			myRedirect.SetLinkGetCachedSpace(m_asOwner);
			myRedirect.SetIsHTTPRedirect(true);
			super.SetRedirect(myRedirect);
		}
	}
}

