package com.plumtree.portalpages.browsing.myportal.editpage;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.errordisplay.*;

/**
 * File: SetGroupControl.java
 * --------------------------
 *
 * @author NaveenP
 */
public class EditMyPagePortletLayoutSetPageControl_D implements IControl
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.myportal.editpage.EditMyPagePortletLayoutSetPageControl_D");

	
	public static final String STR_MVC_CLASS_NAME = "EditMyPagePortletLayoutSetPage";

	
	public static final String QS_PAGEID = "PageID";

	/** Activity Space */
	private AActivitySpace m_asOwner;

	/** model */
	private EditMyPagePortletLayoutModel_D m_asModel;

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IControl#Execute()
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		try
		{
			String[] sValues = (String[]) arguments.GetElement(QS_PAGEID);
			int nPageID		 = 0;

			if (sValues == null)
			{
				
					log.Info("could not find page ID in query string.");
				

				log.Error("Page ID not found in query string");
				throw new Exception("Page ID not found");
			}

			nPageID = XPConvert.ToInteger(sValues[0]);
			m_asModel.SetPageID(nPageID);
		}
		catch (Exception e)
		{
			log.Error(e, "Server Error");

			UIError myError = new UIError(UIErrorLevel.FRIENDLY,
					UIErrorScope.CURRENT_USER, null, e.getMessage(),
					e.getMessage());
			UIErrorHandler.RaiseError(myError, m_asOwner.GetSubSession(),
				m_asOwner.GetApplication());
		}

		return null;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new EditMyPagePortletLayoutSetPageControl_D();
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IControl#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IControl#Init(IModel,
	 *      AActivitySpace)
	 */
	public void Init(IModel model, AActivitySpace space)
	{
		m_asModel     = (EditMyPagePortletLayoutModel_D) model;
		m_asOwner     = space;
	}
}

