package com.plumtree.portalpages.browsing.myportal.editpage;

import com.plumtree.portalpages.common.editpage.*;
import com.plumtree.uiinfrastructure.editor.*;

/**
 * @author michaeld
 */
public interface IEditMyPortalPageModelRO extends IEditorModelRO
{
	/**
	 * Get the page model of the page being edited.
	 *
	 * @return PageData
	 */
	public PageData GetPageModel();

	/**
	 * Get the set page template for the page.
	 *
	 * @return int
	 */
	public int GetPageTemplateSet();

	/**
	 * Get the name of the parent window's form.
	 *
	 * @return String
	 */
	public String GetParentFormName();

	/**
	 * Get the string that is the parent form space ID.
	 *
	 * @return String
	 */
	public String GetParentFormSpaceID();

	/**
	 * Get the string that is the parent form submit function.
	 *
	 * @return String
	 */
	public String GetParentFormSubmitFunction();
}

