package com.plumtree.portalpages.browsing.myportal.mypages;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.myportal.*;
import com.plumtree.portaluiinfrastructure.ptlink.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.taskapi.portalui.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author michaeld
 *
 */
public class DeletePageControl implements IControl
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.myportal.mypages.DeletePageControl");

	/** Class Name */
	public static final String STR_MVC_CLASS_NAME = "DeletePage";

	/** Page ID */
	public static final String STR_PAGE_ID = "PageID";

	/** Activity Space */
	private AActivitySpace m_asOwner;

	/** Model */
	private MyPortalModel m_asModel;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#CheckActionSecurityAndExecute(XPHashtable)
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		String[] sValues = (String[]) arguments.GetElement(STR_PAGE_ID);

		if (sValues == null)
		{
			
				log.Error("could not find page ID in query string.");
			

			return null;
		}

		int nDeletePageID = XPConvert.ToInteger(sValues[0]);

		m_asModel.DeletePage(nDeletePageID);

		Redirect redirect = new Redirect();
		IPTURL pturl = TaskAPIUIMyPages.CreateMyPageCommonOpenerURL(m_asOwner, SetPageControl.N_HOME_PAGE_ID, "");
		redirect.SetLinkToExternalURL(pturl.GetFullURL());	

		return redirect;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new DeletePageControl();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#Init(IModel, AActivitySpace)
	 */
	public void Init(IModel model, AActivitySpace space)
	{
		m_asModel     = (MyPortalModel) model;
		m_asOwner     = space;
	}
}

