package com.plumtree.portalpages.browsing.myportal.mypages;

import com.plumtree.portalpages.browsing.myportal.*;
import com.plumtree.portalpages.common.uiparts.*;

/**
 * 
 *
 * @author MichaelD
 */
public class MyPageAS extends PlumtreeAS
{
	
	public static final String STR_MVC_CLASS_NAME = "MyPage";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new MyPageAS();
	}

	/**
	 * 
	 *
	 * @return 
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Repost control for intrinsic portlets.
	 *
	 * @return Intrinsic portlets repost control name
	 */
	public String GetRepostControlName()
	{
		return IntrinsicPortletsRepostControl.STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.AActivitySpace#Init()
	 */
	public void Init()
	{
		super.Init();

		// MyPage DisplayPages
		PlumtreeDP myPortalDP = new MyPortalDP();
		RegisterPage(myPortalDP);
		RegisterPage(new MyPortalPartialPortletsDP());

		// MyPage Model
		RegisterModel(MyPortalModel.STR_MVC_CLASS_NAME);

		MyPortalModel myModel = (MyPortalModel) GetModel(MyPortalModel.STR_MVC_CLASS_NAME);
		myModel.SetMyPortalModelHelper(new MyPageMyPortalModelHelper());

		// Model has to be initialized in Init method because it requires PTSession.
		// MyPage Views
		RegisterView(MyPortalContentView.STR_MVC_CLASS_NAME, myModel);

		// Extended Navigation Section
		RegisterView(MyPortalHeaderView.ObjectName, myModel);
		RegisterView(MyPortalFooterView.m_ObjectName, myModel);

		// MyPage Controls
		RegisterControl(SetPageControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(CollapsePortletControl.STR_MVC_CLASS_NAME, CollapsePortletControl.STR_EXPAND_CONTROL, myModel);
		RegisterControl(CollapsePortletControl.STR_MVC_CLASS_NAME, CollapsePortletControl.STR_COLLAPSE_CONTROL, myModel);
		RegisterControl(DeletePageControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(AddRemovePortletControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(ReorderPortletsControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(IntrinsicPortletsRepostControl.STR_MVC_CLASS_NAME,
			myModel);
			
		// Default fall-through control when control has been lost (error handling)
		RegisterControl(DefaultPageControl.STR_MVC_CLASS_NAME, "", myModel);
		
		this.SetHelpTopic( "PT_MyPages" );
		
	}
}

