package com.plumtree.portalpages.browsing.objectselection;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.portalpages.common.folder.*;
import com.plumtree.portaluiinfrastructure.resultwrapper.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author MichaelD
 */
public class ObjSelBreadCrumbView extends BreadcrumbView
{
	/** object name */
	public static final String STR_MVC_CLASS_NAME = "ObjSelBreadcrumb";
	
	/** model for object selection model specific calls */
	IObjectSelectionModelRO m_asObjSelModel;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new ObjSelBreadCrumbView();
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IView#getName()
	 */
	public String GetName()
	{
		return ObjSelBreadCrumbView.STR_MVC_CLASS_NAME;
	}

	/**
	 * override this to provide our own links
	 */
	protected PTBreadcrumbPath GetBreadcrumbPath()

	{
		PTBreadcrumbPath myCrumbs = new PTBreadcrumbPath();

		HTMLAnchor myAnchor;

		IASQueryResult qrPath = m_asObjSelModel.GetBreadCrumbPath();

		int nPathCount = qrPath.GetCount();

		for(int i=0; i<nPathCount; i++)
		{
			int nFolderID = XPConvert.ToInteger(qrPath.GetFields(i, PT_PROPIDS.PT_PROPID_OBJECTID));
			String strFolderName = (String) qrPath.GetFields(i, PT_PROPIDS.PT_PROPID_NAME);

			String strEncodedFolderName = XPHttpUtility.HtmlEncode(strFolderName);

			if(i < (nPathCount - 1))
			{
				myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
				myAnchor.SetOnClick(JAVASCRIPT_OPEN_FOLDER +
					"(" + nFolderID + "); return false;");
				myAnchor.AddInnerHTMLString(strEncodedFolderName);
				myAnchor.SetTitle(strEncodedFolderName);
				myCrumbs.appendAnchorItem(myAnchor);
			}
			else
			{
				myCrumbs.appendTextItem(strEncodedFolderName);
			}
		}

		return myCrumbs;
	}
	
	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(com.plumtree.uiinfrastructure.activityspace.IModelRO, com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_asObjSelModel = (IObjectSelectionModelRO)model;
		super.Init(model, parent);
	}

}

