package com.plumtree.portalpages.browsing.objectselection;

import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.common.*;

/**
 * File: ObjSelFrameSetDP.java
 * -------------------------------------
 *
 * @author NaveenP
 */
public class ObjSelFrameSetDP extends FrameSetDP
{
	
	public static final String STR_MVC_CLASS_NAME = "SelectionFrameSet";
	
	/** Frame Set Title */
	private String m_strFrameSetTitle;
	
	/** Top Frame Display Page Name */
	private String m_strTopFrameDPName;
	
	/**
	 * @see com.plumtree.xpshared.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
	
	/**
	 * Set Frame Scroll Top
	 *
	 * @return boolean true implies scrolling
	 */
	public boolean GetFrameScrollTop()
	{
		return true;
	}
		
	/**
	 * Set Frame Scroll Body
	 *
	 * @return boolean true implies scrolling
	 */
	public boolean GetFrameScrollBody()
	{
		return false;
	}

	/**
	 * Set FrameSet Attributes
	 *
	 * @return String
	 */
	public String GetFrameSetAttributes()
	{
		return "85%,15%";
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetFrameSetTitle()
	{
		return m_strFrameSetTitle;
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.dialogheader.FrameSetDialog#GetFrameURLBody()
	 */
	public ASURL GetFrameURLBody()
	{				
		ASURL url = new ASURL(m_asOwner);

		url.SetLinkGetCachedSpace(m_asOwner);
		url.SetDisplayPage(SelectedObjectsDP.STR_MVC_CLASS_NAME);
		url.SetControl(ObjSelFrameCheckAccessControl.STR_MVC_CLASS_NAME);

		return url;
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.dialogheader.FrameSetDialog#GetFrameURLTop()
	 */
	public ASURL GetFrameURLTop()
	{
		ASURL url = new ASURL(m_asOwner);

		url.SetLinkGetCachedSpace(m_asOwner);
		url.SetDisplayPage(m_strTopFrameDPName);
		url.SetControl(ObjSelFrameCheckAccessControl.STR_MVC_CLASS_NAME);

		return url;
	}
	
	/**
	 * Method SetupFrameSet.
	 * This display page will not print anything legible unless this function is called with valid parameters.
	 * 
	 * @param _strFrameSetTitle
	 * @param _strTopFrameDPName
	 */
	public void SetupFrameSet(String _strFrameSetTitle, String _strTopFrameDPName)
	{
		m_strFrameSetTitle = _strFrameSetTitle;
		m_strTopFrameDPName = _strTopFrameDPName;
	}
}

