package com.plumtree.portalpages.browsing.objectselection;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This control is used to perform actions on the object selection model
 * in cases where you don't want to repost the entire form (i.e. AJAX, etc...)
 */
public class ObjectSelectionActionControl implements IControl
{
	public static final String STR_MVC_CLASS_NAME = "ObjectSelectAction";

	/** Post to self to switch to search mode. */
	public final static String SEARCH_MODE = "displaysearch";

	/** Post to self to change pagination displayed item. */
	public final static String FIRST_ITEM_TO_DISPLAY = "firstitem";

	protected IObjectSelectionModel m_model;

	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		if (arguments.ContainsKey(SEARCH_MODE))
		{
			String[] data = (String[]) arguments.GetElement(SEARCH_MODE);

			if ((0 != data.length) && (null != data[0]))
			{
				boolean bDisplaySearch = XPConvert.ToBoolean(data[0]);
				m_model.SetDisplaySearch(bDisplaySearch);
			}
		}

		if (arguments.ContainsKey(FIRST_ITEM_TO_DISPLAY))
		{
			String[] data = (String[]) arguments.GetElement(FIRST_ITEM_TO_DISPLAY);

			if ((0 != data.length) && (null != data[0]))
			{
				int nFirstItemToDisplay = XPConvert.ToInteger(data[0]);
				m_model.SetFirstDisplayableItem(nFirstItemToDisplay);
			}
		}

		return null;
	}

	public void Init(IModel model, AActivitySpace space)
	{
		m_model = (ObjectSelectionModel) model;
	}

	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	public Object Create()
	{
		return new ObjectSelectionActionControl();
	}
}