package com.plumtree.portalpages.browsing.objectselection;

import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.constants.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 *
 * @author michaeld
 */
public class SelectedObjectsDP implements IDisplayPage
{
	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "SelectionBottomFrame";
	
	/** AActivitySpace */
	protected AActivitySpace m_asOwner;
	
	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Display(com.plumtree.uiinfrastructure.activityspace.IWebData)
	 */
	public void Display(IWebData pageData)
	{
		boolean bNoJavascript = (GetOwner().GetAccessStyle() != AccessStyles.STANDARD);

		HTMLPage myPage = new HTMLPage();

		// Set the HTMLPage as the data to be sent to the browser.
		pageData.SetData(myPage);

		if (bNoJavascript)
		{
			myPage.SetDo508Checking(true);
		}

		HTMLHead myHead = new HTMLHead();
		myPage.SetHead(myHead);

		HTMLTitle myTitle = new HTMLTitle(m_asOwner.GetString(1275, "ptmsgs_portalbrowsingmsgs"));

		HTMLBody myBody = new HTMLBody();
		myPage.SetBody(myBody);
		myBody.SetMarginHeight("0");
		myBody.SetMarginWidth("0");
		myBody.SetLeftMargin("0");
		myBody.SetTopMargin("0");
		myBody.SetStyleClass(PTStyleClass.DIALOGUE_GRAY_BG);

		myHead.AddInnerHTMLElement(myTitle);

		myHead.AddInnerHTMLElement(GetOwner().GetStyleSheetLinks());

		myHead.AddInnerHTMLElement(m_asOwner.GetView(SelectedObjectsView.STR_MVC_CLASS_NAME).DisplayJavascript());

		myBody.AddInnerHTMLElement(m_asOwner.GetView(SelectedObjectsView.STR_MVC_CLASS_NAME).Display());

		m_asOwner.SetCurrentPage(m_asOwner.GetPage(ObjSelFrameSetDP.STR_MVC_CLASS_NAME));
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#GetOwner()
	 */
	public AActivitySpace GetOwner()
	{
		return m_asOwner;
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Init(com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
	 */
	public void Init(AActivitySpace _asOwner)
	{
		m_asOwner = _asOwner;
	}
}

