package com.plumtree.portalpages.browsing.objectselection.communities;

import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * File: CommunityInvitationPopupDP.java
 * -------------------------------------
 * Display page for the Invitation Popup on
 * the gadget selection page (when clicking
 * "Send to Others.")
 *
 * @author NaveenP/DustinA
 */
public class CommunityInvitationPopupDP implements IDisplayPage
{
	
	public static final String STR_MVC_CLASS_NAME = "CommunityInvitationPopup";
	private AActivitySpace m_asOwner;

	/**
	 * @see com.plumtree.xpshared.activityspace.IDisplayPage#display()
	 */
	public void Display(IWebData pageData)
	{
		pageData.SetData(m_asOwner.GetView(CommunityInvitationPopupView.STR_MVC_CLASS_NAME).Display());
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.ui.framework.IDisplayPage#GetParent()
	 */
	public AActivitySpace GetOwner()
	{
		return m_asOwner;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IDisplayPage#Init(AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		m_asOwner = parent;
	}
}

