package com.plumtree.portalpages.browsing.objectselection.flyout;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.objectselection.*;
import com.plumtree.portalpages.browsing.objectselection.communities.*;
import com.plumtree.portalpages.common.folder.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.search.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.common.*;

/**
 * @author Bobby Tse
 *
 */
public class FlyoutCommunitySelectionAS extends PTEditorAS 
{
	private static OpenLogger log = OpenLogService.GetLogger(
			OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
			"com.plumtree.portalpages.browsing.objectselection.flyout.FlyoutCommunitySelectionAS");

	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "FlyoutCommunitySelection";
	
	public FlyoutCommunitySelectionAS() {
		// TODO Auto-generated constructor stub
	}

	/**
	 * Sets the Editor title.
	 *
	 * @return 
	 */
	public String GetEditorTitle() {
		// DCA - not needed
		return "";
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#GetName()
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}
	
	/**
	 * Returns the class name of the Property Repost Control.
	 *
	 * @return String
	 */
	public String GetRepostControlName()
	{
		return (ObjectSelectionRepostControl.STR_MVC_CLASS_NAME);
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create() {
		return new FlyoutCommunitySelectionAS();
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#Init(IPTSession)
	 */
	public void Init()
	{
		log.Info("Initializing Flyout Community Selection Activity Space");

		// Community Selection Model
		m_strModelName = ObjectSelectionModel.STR_MVC_CLASS_NAME;

		super.Init();

		// Call IntegratedSearchAS.RegisterSearchClasses to register search stuff.
		IntegratedSearchAS.RegisterSearchClasses(this);

		ObjectSelectionModel myModel = (ObjectSelectionModel) GetModel(ObjectSelectionModel.STR_MVC_CLASS_NAME);
		myModel.SetSelectionModelHelper(new CommunitySelectionModelHelper(this));

		// Model has to be initialized in Init method because it requires PTSession.
		log.Info("Registered model");

		// Community Selection DisplayPages
		RegisterPage(new FlyoutCommunitySelectionDP());
		CommunityInvitationPopupDP CommInvitationPopup = new CommunityInvitationPopupDP();
		CommInvitationPopup.Init(this);
		RegisterPage(CommInvitationPopup);
		log.Info("Registered pages");

		// Community Preview/Invitation Views
		RegisterView(CommunityInvitationPopupView.STR_MVC_CLASS_NAME, myModel);
		log.Info("Registered views");

		// Community Selection Controls
		RegisterControl(OpenSubFolderControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(SetStartItemControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(SetLastItemControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(ObjectSelectionRepostControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(InvitationPopupControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(PassthruControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(ObjectSelectionActionControl.STR_MVC_CLASS_NAME, myModel);
		log.Info("Registered controls");
		
		// Set default page
		SetCurrentPage(GetPage(FlyoutCommunitySelectionDP.STR_MVC_CLASS_NAME));

		// TODO figure this out this.SetHelpTopic( "PT_ChooseCommunities" );
	}
}
