package com.plumtree.portalpages.browsing.objectselection.flyout;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.objectselection.*;
import com.plumtree.portalpages.browsing.objectselection.portlets.*;
import com.plumtree.portalpages.browsing.portletpreview.*;
import com.plumtree.portalpages.common.folder.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.search.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.common.*;

/**
 * 
 *
 * @author duang
 */
public class FlyoutPortletSelectionAS extends PTEditorAS
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.objectselection.flyout.FlyoutPortletSelectionAS");

	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "FlyoutPortletSelection";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new FlyoutPortletSelectionAS();
	}

	/**
	 * Sets the Editor title.
	 *
	 * @return 
	 */
	public String GetEditorTitle()
	{
		// DCA - not needed
		return "";
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the class name of the Property Repost Control.
	 *
	 * @return String
	 */
	public String GetRepostControlName()
	{
		return (ObjectSelectionRepostControl.STR_MVC_CLASS_NAME);
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#Init(IPTSession)
	 */
	public void Init()
	{
		log.Info("Initializing Portlet Selection Activity Space");

		// Portlet Selection Model
		m_strModelName = ObjectSelectionModel.STR_MVC_CLASS_NAME;

		super.Init();

		// Call IntegratedSearchAS.RegisterSearchClasses to register search stuff.
		IntegratedSearchAS.RegisterSearchClasses(this);

		ObjectSelectionModel myModel = (ObjectSelectionModel) GetModel(ObjectSelectionModel.STR_MVC_CLASS_NAME);
		myModel.SetSelectionModelHelper(new PortletSelectionModelHelper(this));

		// Model has to be initialized in Init method because it requires PTSession.
		log.Info("Registered models");

		// Portlet Selection DisplayPages
		RegisterPage(new FlyoutPortletSelectionDP());

		RegisterPage(new PortletInvitationPopupDP());

		log.Info("Registered pages");

		// Portlet Selection Controls
		RegisterControl(OpenSubFolderControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(SetStartItemControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(SetLastItemControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(ObjectSelectionRepostControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(InvitationPopupControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(PassthruControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(ObjectSelectionActionControl.STR_MVC_CLASS_NAME, myModel);
		log.Info("Registered controls");

		// Portlet Preview/Invitation Views
		RegisterView(PortletInvitationPopupView.STR_MVC_CLASS_NAME, myModel);

		// Set default page
		SetCurrentPage(GetPage(FlyoutPortletSelectionDP.STR_MVC_CLASS_NAME));

		// TODO figure this out this.SetHelpTopic( "PT_AddPortlets" );
	}
}

