package com.plumtree.portalpages.browsing.objectselection.portlets;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.objectselection.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.uiinfrastructure.htmlconstructs.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author naveenp
 * 
 * This view doesn't have the create portlet button
 * because we don't provide that in 508.  It is named
 * as such because it is a replacement for the standard
 * access view CreatePortletActionBar.java/cs.
 */
public class CreatePortletActionBarView_D implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.objectselection.portlets.CreatePortletActionBarView_D");


	public static final String STR_MVC_CLASS_NAME = "CreatePortletActionBarView_D";

	/** Subspace Key for Creating a portlet */
	public static final String SUBSPACE_NAME_CREATEPORTLET = "CreatePortlet";
	protected AActivitySpace m_asOwner;
	protected IModelRO m_model;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new CreatePortletActionBarView_D();
	}

	/**
	 * Returns the HTML for the Section.
	 *
	 * @return HTMLElement
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		try
		{
			PTConstruct construct = UIConstructFactory.GetConstruct( PTBannerType.FOLDER, true, this.m_asOwner );
			construct.ReplaceNestedElementsWithHTMLString( PTBannerType.FOLDER.GetElementName(PTBannerType.ELEMENT_NAME_ID_TITLE),
				m_asOwner.GetString(733, "ptmsgs_portalbrowsingmsgs") );

			PTConstruct myButtonConstruct = UIConstructFactory.GetConstruct( PTButtonType.GO_UP, true, this.m_asOwner );
			myButtonConstruct.ReplaceNestedElementsWithHTMLString( PTButtonType.GO_UP.GetElementName(PTButtonType.ELEMENT_NAME_ID_TITLE),
				m_asOwner.GetString(1564, "ptmsgs_portalbrowsingmsgs") );
			ConstructFactory.SetAltOnButtonImages(myButtonConstruct, m_asOwner.GetString(1564, "ptmsgs_portalbrowsingmsgs"));
			ConstructFactory.SetTitleOnButtonImages(myButtonConstruct, m_asOwner.GetString(1564, "ptmsgs_portalbrowsingmsgs"));
			HTMLAnchor myAnchor = (HTMLAnchor) myButtonConstruct.GetNestedElement( PTButtonType.GO_UP.GetElementName(
				PTButtonType.ELEMENT_NAME_ID_ANCHOR) );
			
			ASURL myAsurl = ((AFormDP) m_asOwner.GetCurrentPage()).Get508RepostURL(ObjectSelectionRepostControl.POSTTOSELF_ACTION_OPENFOLDER);
			myAsurl.AddControlArgument(ObjSelFolderViewHelper.HTMLINPUT_OPENFOLDERID, PT_INTRINSICS.PT_ADMIN_FOLDER_ROOTFOLDER);
			
			myAnchor.SetHRef( myAsurl.GetURLAsString() );
			myAnchor.SetTitle(m_asOwner.GetString(1564, "ptmsgs_portalbrowsingmsgs"));

			construct.AddElementToNestedElement(
				PTBannerType.FOLDER.GetElementName(PTBannerType.ELEMENT_NAME_ID_EXTENDABLE_CELL),
				myButtonConstruct.GetHTMLElement() );

			result.AddInnerHTMLElement(construct.GetHTMLElement());

			result.AddInnerHTMLElement(EditorView.GetShortSpacerTable());
		}
		catch (Exception e)
		{
			
				log.Error(e, "CreatePortletActionBarView_D::Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(" ", e);
		}

		return result;
	}

	/**
	 * This method returns the HTMLScript that encompasses the Javascript on the page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 *
	 * @return HTMLScript
	 */
	public HTMLScript DisplayJavascript()
	{
		return null;
	}

	/***/
	/**
	 */
	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Inits the Section with the read-only Model and the Activity Space.
	 *
	 * @param model
	 * @param parent
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_model = model;

		try
		{
			m_asOwner = parent;
		}
		catch (Exception e)
		{
			
				log.Error(e, "CreatePortletActionBarView_D::Init Unable to cast the Object " +
					parent +
					" to AActivitySpace. The following exception occured: " +
					e.getMessage());
			

			// JF- No need to extract, this is an unexpected error.
			throw new XPException("Unable to cast the Object " + parent +
				" to AActivitySpace.", e);
		}
	}
}

