package com.plumtree.portalpages.browsing.objectselection.portlets;

import com.plumtree.portalpages.browsing.objectselection.*;

/**
 * This model is used to enable simple mode - no adding or preview of portlets.
 * 
 * @author dhayler
 */
public class PortletInBundleObjectSelectionModel extends ObjectSelectionModel
{
	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "PortletInBundleObjectSelection";

	protected boolean m_bSimpleMode = false;

	public PortletInBundleObjectSelectionModel()
	{
		super();
	}

	// TODO: These two methods should really be in model interfaces.

	/**
	 * Set whether we're in simple mode or not.
	 * @param _bSimple whether we're in simple mode or not.
	 */
	public void SetSimpleMode(boolean _bSimple)
	{
		m_bSimpleMode = _bSimple;
	}

	/**
	 * @return whether we're in simple mode or not.
	 */
	public boolean GetSimpleMode()
	{
		return m_bSimpleMode;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorModel#GetIsEditorReadOnly()
	 *
	 */
	public boolean GetIsEditorReadOnly()
	{
		if (GetSimpleMode())
		{
			// Simple submit mode only needs a done button.
			return true;
		}

		return super.GetIsEditorReadOnly();
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IModelRO#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new PortletInBundleObjectSelectionModel();
	}
}