package com.plumtree.portalpages.browsing.objectselection.portlets;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.objectselection.*;
import com.plumtree.portalpages.browsing.portletpreview.*;
import com.plumtree.portalpages.common.objects.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.editor.*;

/**
 * @author michaeld
 */
public class PortletInBundleSelectionAS extends PTEditorAS
	implements IObjectSelectionAS
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.objectselection.portlets.PortletInBundleSelectionAS");

	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "PortletInBundleSelection";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new PortletInBundleSelectionAS();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorAS#GetEditorTitle()
	 */
	public String GetEditorTitle()
	{
		return GetString(734, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.browsing.objectselection.IObjectSelectionAS#GetObjectBannerText()
	 */
	public String GetObjectBannerText()
	{
		return null;
	}

	/**
	 * @see com.plumtree.portalpages.browsing.objectselection.IObjectSelectionAS#GetObjectBannerTitle()
	 */
	public String GetObjectBannerTitle()
	{
		return null;
	}

	/**
	 * Returns the class name of the Property Repost Control.
	 *
	 * @return String
	 */
	public String GetRepostControlName()
	{
		return (ObjectSelectionRepostControl.STR_MVC_CLASS_NAME);
	}

	/**
	 * @see com.plumtree.portalpages.browsing.objectselection.IObjectSelectionAS#GetResultsPageName()
	 */
	public String GetResultsPageName()
	{
		return null;
	}

	/**
	 * @see com.plumtree.portalpages.browsing.objectselection.IObjectSelectionAS#GetSearchPrompt()
	 */
	public String GetSearchPrompt()
	{
		return null;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#Init(IPTSession)
	 */
	public void Init()
	{
		log.Info("Initializing Portlet in Bundle Object Selection Activity Space");

		// Portlet in Bundle Object Selection Model
		m_strModelName = ObjectSelectionModel.STR_MVC_CLASS_NAME;
		// This allows us to register the bundle model under the name of the object selection model.
		m_strModelMVCName = PortletInBundleObjectSelectionModel.STR_MVC_CLASS_NAME;

		super.Init();

		ObjectSelectionModel myModel = (ObjectSelectionModel) GetModel(m_strModelName);
		myModel.SetSelectionModelHelper(new PortletInBundleSelectionModelHelper(this));

		// Model has to be initialized in Init method because it requires PTSession.
		log.Info("Registered model");

		// Portlet Selection DisplayPages
		RegisterPage(new PortletInBundleSelectionDP());

		// Register MVC for invitation popup
		RegisterPage(new PortletInvitationPopupDP());
		log.Info("Registered page");

		// Portlet Selection Views
		RegisterView(ObjectView.STR_MVC_CLASS_NAME, myModel);
		RegisterView(ObjectSelectionView.STR_MVC_CLASS_NAME, myModel);

		// Register MVC for invitation popup
		RegisterView(PortletInvitationPopupView.STR_MVC_CLASS_NAME, myModel);
		log.Info("Registered views");

		// Set view helper on object view
		((ObjectView) GetView(ObjectView.STR_MVC_CLASS_NAME)).SetObjectViewHelper(new PortletSelectionViewHelper());

		// Reregister our custom editor start control so that it is used instead of the default one.
		UnRegisterControl(EditorStartControl.STR_MVC_CLASS_NAME);
		RegisterControl(PortletInBundleSelectionEditorStartControl.STR_MVC_CLASS_NAME, EditorStartControl.STR_MVC_CLASS_NAME, myModel);

		// Register MVC for invitation popup
		RegisterControl(InvitationPopupControl.STR_MVC_CLASS_NAME, myModel);

		// Portlet Selection Controls
		RegisterControl(ObjectSelectionRepostControl.STR_MVC_CLASS_NAME, myModel);
		log.Info("Registered controls");

		// Set default page
		SetCurrentPage(PortletInBundleSelectionDP.STR_MVC_CLASS_NAME);

		this.SetHelpTopic( "PT_AddPortlets" );
		
	}
}