package com.plumtree.portalpages.browsing.objectselection.portlets;

import com.plumtree.portalpages.browsing.objectselection.*;
import com.plumtree.portalpages.common.objects.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author michaeld
 */
public class PortletInBundleSelectionDP extends EditorDP
{
	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "PortletInBundleSelection";

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorDP#GetLeftNavString()
	 */
	public String GetLeftNavString()
	{
		return m_asOwner.GetString(735, "ptmsgs_portalbrowsingmsgs");
	}

	
	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for that Page.
	 *
	 * @return HTMLElement
	 *
	 * @throws HTMLException 
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()

	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		views.AddInnerHTMLElement(m_asOwner.GetView(
				ObjectView.STR_MVC_CLASS_NAME).Display());

		result.AddInnerHTMLElement(CreateContentTable(views,
				m_asOwner.GetString(735, "ptmsgs_portalbrowsingmsgs")));

		return result;
	}

	/**
	 * 
	 *
	 * @return 
	 *
	 * @throws HTMLException 
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection scripts = new HTMLScriptCollection();
		HTMLScript myScript			 = m_asOwner.GetView(ObjectView.STR_MVC_CLASS_NAME)
			.DisplayJavascript();

		if (null != myScript)
		{
			scripts.AddInnerHTMLElement(myScript);
		}

		HTMLScriptCollection myScriptCollection = ((ObjectView) m_asOwner.GetView(ObjectView.STR_MVC_CLASS_NAME)).DisplayJavascriptCollection();

		if (null != myScriptCollection)
		{
			scripts.AddInnerHTMLElement(myScriptCollection);
		}

		myScript = m_asOwner.GetView(ObjectSelectionView.STR_MVC_CLASS_NAME)
			.DisplayJavascript();

		if (null != myScript)
		{
			scripts.AddInnerHTMLElement(myScript);
		}

		return scripts;
	}
}

