package com.plumtree.portalpages.browsing.objectselection.portlets;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;

/**
 * This control is used to enable simple mode - no adding or preview of portlets.
 * 
 * @author dhayler
 */
public class PortletInBundleSelectionEditorStartControl extends EditorStartControl
{
	/** Object Name for AS */
	public static final String STR_MVC_CLASS_NAME = "PortletInBundleEditorStart";

	/**
	 * Whether or not to use simple mode (i.e. true, false).  The default is false.
	 * Simple mode removes the checkboxes and Finish button.
	 */
	public static final String SIMPLE_MODE = "SimpleMode";

	/**
	 * This code is called by the AS Servlet each time there is an Editor is started.
	 * It calls the startEditor method in the Model if a valid Editor Type was in the QS.
	 *
	 * If the Redirect object returned is not null,
	 *  the Servlet will the page specified by the Redirect.
	 *
	 * If the Redirect is null, the Servlet will get the current page
	 * from the AS and display it.
	 *
	 * @return Redirect
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		// This needs to happen before the super call, since that accesses
		// the model as well.
		String[] data = (String[]) arguments.GetElement(SIMPLE_MODE);

		if ((null != data) && (0 != data.length) && (!"".equals(data[0])))
		{
			((PortletInBundleObjectSelectionModel)m_model).SetSimpleMode(XPConvert.ToBoolean(data[0]));
		}

		Redirect result = super.CheckActionSecurityAndExecute(arguments);

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new PortletInBundleSelectionEditorStartControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}