package com.plumtree.portalpages.browsing.objectselection.portlets;

import com.plumtree.portalpages.browsing.objectselection.*;
import com.plumtree.portalpages.common.folder.*;
import com.plumtree.portalpages.common.objects.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.constants.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author MichaelD
 */
public class PortletSelectionDP_D extends EditorDP
{
	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "PortletSel_D";

	/** Object Section Index: gadgets */
	public static final int GADGET_INDEX = 0;

	/** Object Section Index: bundles */
	public static final int BUNDLE_INDEX = 1;
	
	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#DisplayHTMLBeforeForm()
	 */
	public HTMLElementCollection DisplayHTMLBeforeForm()

	{
		HTMLElementCollection searchview = super.DisplayHTMLBeforeForm();

		// Add a "search for gadgets" form
		if (searchview == null)
		{
			searchview = new HTMLElementCollection();
		}
		
		// Construct table to contain the page.
		HTMLTable myTable = new HTMLTable();
		searchview.AddInnerHTMLElement(myTable);
		myTable.SetBorder(CommonHTMLStrings.ZERO);
		myTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
		myTable.SetCellPadding(CommonHTMLStrings.ZERO);
		myTable.SetCellSpacing(CommonHTMLStrings.ZERO);
		HTMLTableRow myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		HTMLTableCell myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetAutoFit(true);
		myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
		myRow = new HTMLTableRow();
		myTable.AddInnerHTMLElement(myRow);
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetWidth("15");
		myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);

		// Search Form
		myCell.AddInnerHTMLElement(m_asOwner.GetView(
				ObjSelSearchFormView.STR_MVC_CLASS_NAME).Display());
				
		ObjectSelectionModel model = ((ObjectSelectionModel) m_asOwner.GetModel(ObjectSelectionModel.STR_MVC_CLASS_NAME));
		model.SetObjectViewIndex(GADGET_INDEX);

		if (model.GetDisplaySearch())
		{
			// View by Subfolder and Header
			myCell.AddInnerHTMLElement(m_asOwner.GetView(ObjSelSearchHeaderView.STR_MVC_CLASS_NAME).Display());
			
			// Instructional text
			if (AccessStyles.LOW_BANDWIDTH == m_asOwner.GetAccessStyle())
			{
				myCell.AddInnerHTMLElement(HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1784,
					"ptmsgs_portalbrowsingmsgs"), this.m_asOwner));
			}
			else
			{
				myCell.AddInnerHTMLElement(HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1884,
					"ptmsgs_portalbrowsingmsgs"), this.m_asOwner));
			}
			// Spacer table
			myCell.AddInnerHTMLElement(EditorView.GetShortSpacerTable());
			// Search Summary and Search Results
			myCell.AddInnerHTMLElement(m_asOwner.GetView(
					ObjSelSearch508BodyView.STR_MVC_CLASS_NAME).Display());

			myCell.AddInnerHTMLElement(((ObjectView)m_asOwner.GetView(PortletSelectionEditorAS.BUNDLE_VIEW)).GetObjectViewHelper().AddObjectViewHTML(model));

			// Selected Objects
			myCell.AddInnerHTMLElement(m_asOwner.GetView(
					SelectedObjectsView.STR_MVC_CLASS_NAME).Display());

			myCell.AddInnerHTMLElement(m_asOwner.GetView(
					ObjectSelectionView.STR_MVC_CLASS_NAME).Display());
		}
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetWidth("15");
		myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

		return searchview;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorDP#GetLeftNavString()
	 */
	public String GetLeftNavString()
	{
		return m_asOwner.GetString(713, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader()

	{
		if (!((ObjectSelectionModel) m_asOwner.GetModel(ObjectSelectionModel.STR_MVC_CLASS_NAME)).GetDisplaySearch())
		{
			if (AccessStyles.LOW_BANDWIDTH == m_asOwner.GetAccessStyle())
			{
				return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1784,
							"ptmsgs_portalbrowsingmsgs"), this.m_asOwner);
			}
			else
			{
				return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1884,
							"ptmsgs_portalbrowsingmsgs"), this.m_asOwner);
			}
		}
		return null;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for that Page.
	 *
	 * @return HTMLElement
	 *
	 * @throws HTMLException 
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()

	{
		HTMLElementCollection result = new HTMLElementCollection();
		HTMLElementCollection views  = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		ObjectSelectionModel model = ((ObjectSelectionModel) m_asOwner.GetModel(ObjectSelectionModel.STR_MVC_CLASS_NAME));

		views.AddInnerHTMLElement(EditorView.GetShortSpacerTable());
		
		if (!model.GetDisplaySearch())
		{
			if (model.IsCommunityPage())
			{
				if (1 >= model.GetCurrentFolderID())
				{
					// JHQ: Don't display on the userprofile community
					if (model.GetSelectorCommunityFolderID() != PT_INTRINSICS.PT_ADMIN_FOLDER_PROFILECOMMUNITY)
					{
						views.AddInnerHTMLElement(m_asOwner.GetView(
							MyCustomPortletsView.STR_MVC_CLASS_NAME).Display());
					}
				}
				else if (model.GetSelectorCommunityFolderID() == model.GetCurrentFolderID())
				{
					views.AddInnerHTMLElement(m_asOwner.GetView(
							CreatePortletActionBarView_D.STR_MVC_CLASS_NAME)
						.Display());
				}
			}

			if (model.GetSelectorCommunityFolderID() != model.GetCurrentFolderID())
			{
				views.AddInnerHTMLElement(m_asOwner.GetView(
						FolderView.STR_MVC_CLASS_NAME).Display());
				views.AddInnerHTMLElement(EditorView.GetSpacerTable());
			}

			if (1 != model.GetCurrentFolderID())
			{
				if (model.GetSelectorCommunityFolderID() != model.GetCurrentFolderID())
				{
					model.SetObjectViewIndex(BUNDLE_INDEX);
					views.AddInnerHTMLElement(m_asOwner.GetView(
							PortletSelectionEditorAS.BUNDLE_VIEW).Display());
					views.AddInnerHTMLElement(EditorView.GetSpacerTable());
				}
				model.SetObjectViewIndex(GADGET_INDEX);
				views.AddInnerHTMLElement(m_asOwner.GetView(
						PortletSelectionEditorAS.GADGET_VIEW).Display());
			}

			views.AddInnerHTMLElement(EditorView.GetSpacerTable());

			views.AddInnerHTMLElement(m_asOwner.GetView(
					SelectedObjectsView.STR_MVC_CLASS_NAME).Display());

			views.AddInnerHTMLElement(m_asOwner.GetView(
					ObjectSelectionView.STR_MVC_CLASS_NAME).Display());

			result.AddInnerHTMLElement(CreateContentTable(views,
					null));
		}

		model = null;

		return result;
	}
}

