package com.plumtree.portalpages.browsing.portalsettings;

import com.plumtree.portalpages.browsing.settings.*;

/**
 * 
 *
 * @version 5.0
 * @author SudhaSathiaseelan
 */
public interface IPortalSettings extends ISettings
{
	/**
	 * Return the description under the link
	 * 
	 * @param String the language ID
	 * 
	 * @return String the link description
	 */
	public String GetDescription(String _strLangID);

	/**
	 * Return the file location of the image
	 * 
	 * @return String the image location
	 */
	public String GetImageLocation();

	/**
	 * Return whether or not to display this setting
	 * 
	 * @param Object the current user's session object
	 * 
	 * @return boolean true implies display this setting.
	 */
	public boolean GetDisplaySetting(Object session);
	
	/**
	 * Return activity right restriction - this should be moved to ISettings,
	 * as both Portal Settings and Plumtree Utilities require this method
	 * 
	 * @return int the activity right restriction
	 * 
	 */
	public int GetActivityRightRestriction();
}

