package com.plumtree.portalpages.browsing.portalsettings;

import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * 
 *
 * @author $author$
 */
public class PortalSettingsAS extends PlumtreeAS
{
	
	public static final String STR_MVC_CLASS_NAME = "PortalSettings";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new PortalSettingsAS();
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.AActivitySpace#Init()
	 */
	public void Init()
	{
		super.Init();

		// Portal Settings Display Page
		PortalSettingsDP myPage = new PortalSettingsDP();
		RegisterPage(myPage);

		// Portal Settings Model
		RegisterModel(PortalSettingsModel.STR_MVC_CLASS_NAME);

		IModel myModel = GetModel(PortalSettingsModel.STR_MVC_CLASS_NAME);

		// Portal Settings Control
		RegisterControl(PortalSettingsControl.STR_MVC_CLASS_NAME, myModel);

		// Portal Settings Views
		RegisterView(PortalSettingsView.STR_MVC_CLASS_NAME, myModel);
		
		this.SetHelpTopic( "PT_MyAccount" );
				
	}
	
	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(String, String, boolean)
	 */
	public boolean CheckBasicAccess(String strPage, String strControl, boolean bSameSpace)
	{
		// DCA - call super's to check for change in navigational scheme
		super.CheckBasicAccess(strPage, strControl, bSameSpace);
		// make sure this is not the guest user
		boolean isGuest = PlumtreeHelpers.IsGuestSession(this);
		
		if ( isGuest && !PlumtreeHelpers.IsEditingDefaultProfile(this) )
			return false;
		
		return true;
	}	
}

