package com.plumtree.portalpages.browsing.portalsettings;

import com.plumtree.openlog.OpenLogService;
import com.plumtree.openlog.OpenLogger;
import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.portaluiinfrastructure.layout.Layouts;
import com.plumtree.portaluiinfrastructure.statichelpers.PTDebugHelpers;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 *
 * @author $author$
 */
public class PortalSettingsDP extends PlumtreeDP
{
	
	private static OpenLogger log = OpenLogService.GetLogger(
			OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
			"com.plumtree.portalpages.browsing.portalsettings.PortalSettingsDP");
	
	public static final String STR_MVC_CLASS_NAME = "PortalSettings";

	
	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetSubtitleForBanner()
	 */
	public String GetSubtitleForBanner()
	{
		return "";
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetTitleForBanner()
	 */
	public String GetTitleForBanner()
	{
		return m_asOwner.GetString(747, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * 
	 *
	 * @return 
	 *
	 * @throws HTMLException 
	 */
	public HTMLElement PageDisplay()
	{	
		HTMLElementCollection myCollection = new HTMLElementCollection();
		try
		{
			HTMLElement element = DisplayLayout(Layouts.MYACCOUNT_PAGE);
			if (null != element) {
					return element;
			}
				myCollection.AddInnerHTMLElement(m_asOwner
						.GetView(PortalSettingsView.STR_MVC_CLASS_NAME).Display());
			
			
		} catch (HTMLException he)	{			
			log.Error("he: " + he);		
		}
		return myCollection;		
	}
}

