package com.plumtree.portalpages.browsing.portalsettings.displayoptions;

// Framework Imports
import com.plumtree.openfoundation.web.*;
import com.plumtree.portaluiinfrastructure.login.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;

/**
 * @author mike
 */
public class DisplayOptRepostControl extends EditorRepostControl
	implements IHTTPControl
{
	
	public static final String STR_MVC_CLASS_NAME = "DisplayOptRepostControl";

	
	public final static int POSTTOSELF_ACTION_RELOAD = 10;

	/** This need to be nulled out after execution */
	private IWebData m_WebData = null;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new DisplayOptRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @param r 
	 */
	public void SetHTTPItems(IXPRequest r, IWebData webdata)
	{
		m_WebData     = webdata;
	}

	/**
	 * Switch between the action modes and call
	 * the associated method for each action.
	 *
	 * @param int
	 */
	protected void PerformAction(int _nAction)
	{
		super.PerformAction(_nAction);

		switch (_nAction)
		{
		case EditorRepostControl.POSTTOSELF_ACTION_FINISH:

			int iExpMinutes = 500;
			int iExpSeconds = iExpMinutes * 60;

			String sAccessStyle = ((IDisplayOptModelRO) this.m_model).GetAccessibilityStyle();

			//	When an user sets the access style, a cookie is
			//	saved, causing the login page to use the access
			//	style requested.
			XPCookie cookie = new XPCookie(PTPersonalSettingsHelper.ACCESS_STYLE_COOKIE_NAME,
					sAccessStyle);

			cookie.SetPath("");

			cookie.SetExpireTime(iExpSeconds);

			m_WebData.AddCookie(cookie);

			break;

		case POSTTOSELF_ACTION_RELOAD:
			((DisplayOptModel) m_model).LoadSettings();

			break;
		}

		// null this  out so we don't leak it.
		m_WebData = null;
	}
}

