package com.plumtree.portalpages.browsing.portalsettings.displayoptions;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author mike
 * @author Julie Fournier
 */
public class DisplayOptView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.portalsettings.displayoptions.DisplayOptView");

	
	public static final String STR_MVC_CLASS_NAME = "DisplayOpt";

	// HTML Object names.

	
	public static final String HTMLRADIO_OPENDOC = "in_ra_OpenWin";

	
	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new DisplayOptView();
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		HTMLTable myTable;
		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLInput myInput;

		try
		{
			HTMLComment myComment = new HTMLComment( "Begin: Display DisplayOptView MainView");
			result.AddInnerHTMLElement(myComment);

			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						1001, "ptmsgs_portalbrowsingmsgs")));

			myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("5");
			myTable.SetCellSpacing("0");
			myTable.SetTitle(m_asOwner.GetString( 1606, "ptmsgs_portalbrowsingmsgs"));

			// Option 1 - new window
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetWidth("15");
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);

			myInput = new HTMLInput(HTMLInputTypes.RADIO, HTMLRADIO_OPENDOC, "");
			myInput.SetValue("1");
			myInput.SetChecked(((IDisplayOptModelRO) m_model).ShouldOpenNewWindow());
			myCell.AddInnerHTMLElement(myInput);

			myCell = new HTMLTableCell();
			myCell.SetAlign(CommonHTMLStrings.LEFT);
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.AddInnerHTMLString(m_asOwner.GetString(1284, "ptmsgs_portalbrowsingmsgs"));

			// Option 2 - same window
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetWidth("15");
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);

			myInput = new HTMLInput(HTMLInputTypes.RADIO, HTMLRADIO_OPENDOC, "");
			myInput.SetValue("0");
			myInput.SetChecked(!((IDisplayOptModelRO) m_model).ShouldOpenNewWindow());
			myCell.AddInnerHTMLElement(myInput);

			myCell = new HTMLTableCell();
			myCell.SetAlign(CommonHTMLStrings.LEFT);
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.AddInnerHTMLString(m_asOwner.GetString(1285, "ptmsgs_portalbrowsingmsgs"));

			myComment = new HTMLComment( "End: Display DisplayOptView");
			result.AddInnerHTMLElement(myComment);
				
		}
		catch (HTMLException he)
		{
			
				log.Error(he, STR_MVC_CLASS_NAME +
					"::MainView::Display The following error occured when trying to display the HTML: " +
					he.getMessage());
			

			throw new XPException(m_asOwner.GetString(1003,
					"ptmsgs_portalbrowsingmsgs"), he);
		}

		return result;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

}

