package com.plumtree.portalpages.browsing.portalsettings.displayoptions;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author sample
 */
public class GreetingView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.portalsettings.displayoptions.GreetingView");

	
	public static final String STR_MVC_CLASS_NAME = "Greeting";

	
	
	public static final String HTMLINPUT_GREETING = "in_tx_greeting";

	/**
	 * 
	 *
	 * @return 
	 */
	public Object Create()
	{
		return new GreetingView();
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		HTMLTable myTable;
		HTMLTableRow myRow;
		HTMLTableCell myCell;

		try
		{
			HTMLComment myComment = new HTMLComment( "Begin: Display GreetingView");
			result.AddInnerHTMLElement(myComment);

			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(
						1005, "ptmsgs_portalbrowsingmsgs")));

			myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("5");
			myTable.SetCellSpacing("0");
			myTable.SetSummary(m_asOwner.GetString( 1608, "ptmsgs_portalbrowsingmsgs"));

			// BEGIN Folder Description Type Label ROW
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.LIST_ITEM_ONE_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);

			myCell.AddInnerHTMLString(m_asOwner.GetString(1006,
					"ptmsgs_portalbrowsingmsgs"));

			HTMLTableCell greetCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(greetCell);

			HTMLInput myInput = new HTMLInput(HTMLInputTypes.TEXT,
					HTMLINPUT_GREETING, "");
			greetCell.AddInnerHTMLElement(myInput);
			myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
			myInput.SetValue(((IDisplayOptModelRO) m_model).GetGreeting());
			myInput.SetMaxLength(40);
			myInput.SetSize(40);
		}
		catch (HTMLException he)
		{
			
				log.Error(he, STR_MVC_CLASS_NAME +
					"::MainView::Display The following error occured when trying to display the HTML: " +
					he.getMessage());
			

			throw new XPException(m_asOwner.GetString(1018,
					"ptmsgs_portalbrowsingmsgs"), he);
		}

		return result;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

}

