package com.plumtree.portalpages.browsing.portalsettings.displayoptions;


// Framework Imports
import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 *
 * @author $author$
 */
public class RulesDebugModeView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.browsing.portalsettings.displayoptions.RulesDebugModeView");
	
	public static final String STR_MVC_CLASS_NAME = "RulesDebugModeView";
	
	public static final String HTMLINPUT_ENABLE_DEBUG_MODE = "in_cb_debugmode";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new RulesDebugModeView();
	}

	/**
	 * Returns the HTML for the Section.
	 *
	 * @return HTMLElement
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		HTMLTable myTable;
		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLInput myInput;
		HTMLSpan mySpan;

		try
		{
			HTMLComment myComment = new HTMLComment( "Begin: Display RulesDebugModeView");
			result.AddInnerHTMLElement(myComment);

			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(2960, "ptmsgs_portaladminmsgs")));

			myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("5");
			myTable.SetCellSpacing("0");

			// 1st Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);
			
			myCell.SetWidth( "50%");

			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.OBJECT_SUBTITLE);

			mySpan.AddInnerHTMLString(m_asOwner.GetString(2961, "ptmsgs_portaladminmsgs"));

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);
			myCell.SetAlign(CommonHTMLStrings.LEFT);
			myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);

			myInput = new HTMLInput(HTMLInputTypes.CHECKBOX_TYPE,
					HTMLINPUT_ENABLE_DEBUG_MODE,
					HTMLINPUT_ENABLE_DEBUG_MODE);

			if (((IDisplayOptModelRO) m_model).GetRulesDebugMode())
			{
				myInput.SetChecked(true);
			}

			myCell.AddInnerHTMLElement(myInput);
			myInput.SetStyleClass(PTStyleClass.FORM_CHECKBOX_TEXT);
			myInput.SetValue(XPConvert.ToString(true));

			// 1st Row end
			myComment = new HTMLComment( "End: Display RulesDebugModeView");
			result.AddInnerHTMLElement(myComment);
		}
		catch (Exception e)
		{
			// ***CHANGE_HERE*** Update the error messages (log and exception).
			log.Error(e, "RulesDebugModeView::Display The following error occured when trying to display the HTML: " +
				e.getMessage());

			throw new XPException(m_asOwner.GetString(1328,
					"ptmsgs_portaladminmsgs"), e);
		}

		return result;
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}

