package com.plumtree.portalpages.browsing.portalsettings.displayoptions;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author sample
 */
public class TimeoutView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.portalsettings.displayoptions.TimeoutView");

	public static final String STR_MVC_CLASS_NAME = "Timeout";

	private static final String[][] _aui_refreshrates = new String[10][2];

	private static final String[] timeouts = new String[9];

	public static final String HTMLSELECT_REFRESH = "in_se_refresh";

//	public static boolean bDropDownBuilt = false;

	public static final String HTMLRADIO_ADMIN   = "in_ra_adminchoice";

	public static final String HTMLSELECT_TIMEOUT = "in_se_timeout";

	/**
	 * 
	 *
	 * @return 
	 */
	public Object Create()
	{
		return new TimeoutView();
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public HTMLElement Display()
	{
		// SCC: removing caching of refresh rates.  If you switch users with different locales, you want a fresh list
//		if (!bDropDownBuilt)
		{
			_aui_refreshrates[0][0]     = m_asOwner.GetString(1008,
					"ptmsgs_portalbrowsingmsgs");
			_aui_refreshrates[0][1]     = "0";
	
	
			_aui_refreshrates[1][0]     = m_asOwner.GetString(1009,
					"ptmsgs_portalbrowsingmsgs");
			_aui_refreshrates[1][1]     = "10";
	
	
			_aui_refreshrates[2][0]     = m_asOwner.GetString(1010,
					"ptmsgs_portalbrowsingmsgs");
			_aui_refreshrates[2][1]     = "15";
	
	
			_aui_refreshrates[3][0]     = m_asOwner.GetString(1011,
					"ptmsgs_portalbrowsingmsgs");
			_aui_refreshrates[3][1]     = "20";
	
	
			_aui_refreshrates[4][0]     = m_asOwner.GetString(1012,
					"ptmsgs_portalbrowsingmsgs");
			_aui_refreshrates[4][1]     = "25";
	
	
			_aui_refreshrates[5][0]     = m_asOwner.GetString(1013,
					"ptmsgs_portalbrowsingmsgs");
			_aui_refreshrates[5][1]     = "30";
	
	
			_aui_refreshrates[6][0]     = m_asOwner.GetString(1014,
					"ptmsgs_portalbrowsingmsgs");
			_aui_refreshrates[6][1]     = "45";
	
	
			_aui_refreshrates[7][0]     = m_asOwner.GetString(1015,
					"ptmsgs_portalbrowsingmsgs");
			_aui_refreshrates[7][1]     = "60";
	
	
			_aui_refreshrates[8][0]     = m_asOwner.GetString(1016,
					"ptmsgs_portalbrowsingmsgs");
			_aui_refreshrates[8][1]     = "120";
	
	
			_aui_refreshrates[9][0]     = m_asOwner.GetString(1017,
					"ptmsgs_portalbrowsingmsgs");
			_aui_refreshrates[9][1]     = "240";
			
			timeouts[0] = "3";
			timeouts[1] = "5";
			timeouts[2] = "8";
			timeouts[3] = "10";
			timeouts[4] = "15";
			timeouts[5] = "20";
			timeouts[6] = "30";
			timeouts[7] = "45";
			timeouts[8] = "60";
	
//			bDropDownBuilt			    = true;
		}

		HTMLElementCollection result = new HTMLElementCollection();
		HTMLTable myTable;
		HTMLTableRow myRow;
		HTMLTableCell myCell;

		try
		{
			HTMLComment myComment = new HTMLComment( "Begin: Display TimeoutView");
			result.AddInnerHTMLElement(myComment);

			result.AddInnerHTMLElement(super.GetHeaderView(m_asOwner.GetString(1288, "ptmsgs_portalbrowsingmsgs")));
			myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetWidth("100%");
			myTable.SetBorder("0");
			myTable.SetCellPadding("5");
			myTable.SetCellSpacing("0");
			myTable.SetSummary(m_asOwner.GetString( 1609, "ptmsgs_portalbrowsingmsgs"));

			HTMLTableRow updateRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(updateRow);
			updateRow.SetStyleClass(PTStyleClass.LIST_ITEM_ONE_BG);

			HTMLTableCell cell = new HTMLTableCell();
			updateRow.AddInnerHTMLElement(cell);
			cell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);


			cell.AddInnerHTMLString(m_asOwner.GetString(1007,
					"ptmsgs_portalbrowsingmsgs"));

			HTMLSelect myRefresh = new HTMLSelect(HTMLSELECT_REFRESH, "");
			myRefresh.SetStyleClass(PTStyleClass.FORM_PULLDOWN_TEXT);

			for (int i = 0; i < _aui_refreshrates.length; i++)
			{
				HTMLOption myOption = new HTMLOption(_aui_refreshrates[i][1]);

				if (((IDisplayOptModelRO) m_model).IsRefreshRate(
							_aui_refreshrates[i][1]))
				{
					myOption.SetSelected(true);
				}

				myOption.AddInnerHTMLString(_aui_refreshrates[i][0]);
				myRefresh.AddInnerHTMLElement(myOption);
			}

			HTMLTableCell selcell = new HTMLTableCell();
			updateRow.AddInnerHTMLElement(selcell);
			selcell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
			selcell.AddInnerHTMLElement(myRefresh);

			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.LIST_ITEM_ONE_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);


			myCell.AddInnerHTMLString(m_asOwner.GetString(1021,
					"ptmsgs_portalbrowsingmsgs"));

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetStyleClass(PTStyleClass.LIST_TEXT);

			HTMLInput adminRB = new HTMLInput(HTMLInputTypes.RADIO,
					HTMLRADIO_ADMIN, "");
			adminRB.SetValue("admin");
			adminRB.SetChecked(-1 == ((IDisplayOptModelRO) m_model).GetTimeout());
			myCell.AddInnerHTMLElement(adminRB);


			myCell.AddInnerHTMLString(m_asOwner.GetString(1022,
					"ptmsgs_portalbrowsingmsgs") + "<br>");

			HTMLInput myRB = new HTMLInput(HTMLInputTypes.RADIO,
					HTMLRADIO_ADMIN, "");
			myRB.SetValue("mine");
			myRB.SetChecked(-1 != ((IDisplayOptModelRO) m_model).GetTimeout());
			myCell.AddInnerHTMLElement(myRB);


		HTMLSelect mySelect = new HTMLSelect(HTMLSELECT_TIMEOUT, "");
		mySelect.SetStyleClass(PTStyleClass.FORM_PULLDOWN_TEXT);

		for (int i = 0; i < timeouts.length ; i++)
		{
			HTMLOption option = new HTMLOption(timeouts[i]);
			option.SetValue(timeouts[i]);
			option.AddInnerHTMLString(timeouts[i]);

			String value = (-1 != ((IDisplayOptModelRO) m_model).GetTimeout())
				? XPConvert.ToString(((IDisplayOptModelRO) m_model).GetTimeout()) : "";
			if (value.equals(timeouts[i]))
				option.SetSelected(true);
								
			mySelect.AddInnerHTMLElement(option);
		}
		
		myCell.AddInnerHTMLElement(mySelect);
/*
			HTMLInput myInput = new HTMLInput(HTMLInputTypes.,
					HTMLINPUT_TIMEOUT, "");
			myCell.AddInnerHTMLElement(myInput);
			myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);

			String value = (-1 != ((IDisplayOptModelRO) m_model).GetTimeout())
				? XPConvert.ToString(((IDisplayOptModelRO) m_model).GetTimeout()) : "";
			myInput.SetValue(value);
			myInput.SetMaxLength(5);
			myInput.SetSize(5);
*/

			myCell.AddInnerHTMLString(m_asOwner.GetString(1023,
					"ptmsgs_portalbrowsingmsgs"));
		}
		catch (HTMLException he)
		{
			log.Error(he, STR_MVC_CLASS_NAME +
				"::MainView::Display The following error occured when trying to display the HTML.");

			throw new XPException(m_asOwner.GetString(1024,
					"ptmsgs_portalbrowsingmsgs"), he);
		}

		return result;
	}

	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}