package com.plumtree.portalpages.browsing.portalsettings.localesettings;


// Framework Imports
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.constants.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *
 *
 */
public class LocaleSettingsDP extends EditorDP
{
	
	public static final String STR_MVC_CLASS_NAME = "LocaleMain";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return (m_asOwner.GetString(1025, "ptmsgs_portalbrowsingmsgs"));
	}

	
	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the General Info page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 *
	 * @return HTMLElement
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
				LocaleSettingsView.STR_MVC_CLASS_NAME)).Display());

		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		//views.AddInnerHTMLElement(((EditorView)
		//	m_asOwner.GetView(GroupsView.STR_MVC_CLASS_NAME)).Display());
		//views.AddInnerHTMLElement(((EditorView)
		//	m_asOwner.GetView(UserEditorAS.m_strStorageSelectPTObject)).Display());
		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	* Display the Javascripts for the Views.
	*
	* @return HTMLScriptCollection
	* @throws HTMLException
	*/
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = null;
		if (m_asOwner.GetAccessStyle() == AccessStyles.STANDARD)
		{
			myScripts = super.DisplayJavaScriptFromChild();
		}

		// ***CHANGE_HERE SELECTPTOBJECT*** Display JavaScripts for the Select PTObject list.
		//myScripts.AddInnerHTMLElement(m_asOwner.GetView(UserEditorAS.m_strStorageSelectPTObject).DisplayJavascript());
		//myScripts.AddInnerHTMLElement(m_asOwner.GetView(LoginView.STR_MVC_CLASS_NAME).DisplayJavascript());
		return myScripts;
	}
	

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Init(AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		super.Init( parent );
		
		parent.SetHelpTopic( "PT_LocaleSettings_MainSettings" );	
	}

	
	

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader() {
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(1451, "ptmsgs_portalbrowsingmsgs"),
			this.m_asOwner);
	}
}

