package com.plumtree.portalpages.browsing.portalsettings.localesettings;


// Framework Imports
import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.constants.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.tips.*;
import com.plumtree.xpshared.htmlelements.*;


/**
 *
 * @author Original Author Unknown
 * @author DavidP tweaks for timeout
 */
public class LocaleSettingsEditorAS extends PTEditorAS
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.portalsettings.localesettings.LocaleSettingsEditorAS");

	
	private static final String sClassName = "com.plumtree.portalpages.browsing.portalsettings.localesettings.LocaleSettingsEditorAS";
	
	
	public static final String STR_MVC_CLASS_NAME = "LocaleSettings";

	
	public static final String strStorageSelectPTObject = "SelectUserPTObject";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new LocaleSettingsEditorAS();
	}
	
	/**
	 * Returns the class name of the Editor Repost Control.
	 *
	 * @return String
	 */
	public String GetRepostControlName()
	{
		return (LocaleSettingsRepostControl.STR_MVC_CLASS_NAME);
	}

	/**
	 * Sets the Editor title.
	 *
	 */
	public String GetEditorTitle()
	{
		if (EditorStartControl.EDITOR_START_FLAG_CREATE == ((EditorModel) GetModel(
					m_strModelName)).GetEditorType())
		{
			return (GetString(1499, "ptmsgs_portalbrowsingmsgs"));
		}
		else
		{
			return (GetString(1499, "ptmsgs_portalbrowsingmsgs"));
		}
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	
	/**
	 * Registers all the classes for this Activity Space.
	 */
	public void Init()
	{
		m_strModelName = LocaleSettingsModel.STR_MVC_CLASS_NAME;

		super.Init();

		IModel myModel = GetModel(m_strModelName);

		// Register DisplayPages
		//RegisterPage(new MainDP());
		LocaleSettingsDP localeDP = new LocaleSettingsDP();
		RegisterPage(localeDP);

		// Register Views
		RegisterView(LocaleSettingsView.STR_MVC_CLASS_NAME, myModel);
		
		// Register Control
		RegisterControl(LocaleSettingsRepostControl.STR_MVC_CLASS_NAME, myModel);

		// Default page
		SetCurrentPage(LocaleSettingsDP.STR_MVC_CLASS_NAME);

		// Main DP
		//mainDP.AddToValidationFunction("CheckMinLength"
		//Sets left nav menu
		int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(1032,
					"ptmsgs_portalbrowsingmsgs"));
		m_mEditorMenu.AddLinkToSubMenu(nMenuOneID,
			LocaleSettingsDP.STR_MVC_CLASS_NAME);

		//m_mEditorMenu.AddLinkToSubMenu(nMenuOneID, LocNamesDP.STR_MVC_CLASS_NAME);
		//int nMenuTwoID = m_mEditorMenu.StartNewSubMenu(_ui_LeftNavTitleMain);
		//m_mEditorMenu.AddLinkToSubMenu(nMenuTwoID, DevicesDP.STR_MVC_CLASS_NAME);
		

		//	TIPS
		TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);

		if (tm != null)
		{
			try
			{
				tm.SetGeneratingClass( sClassName );
				
				
				int iTitleId = 120;
				int iTipId = 121;
				int iSecondaryTipId = 122;
								
				tm.SetTipTitle( this.GetString( iTitleId, ResourceConstants.TIPS) );

				HTMLGenericElement e = new HTMLGenericElement( this.GetString( iTipId, ResourceConstants.TIPS) );

				tm.SetTip( e );
				
				String sSecondary = this.GetString( iSecondaryTipId, ResourceConstants.TIPS);
				
				if( !("none_do_not_translate".equals( sSecondary )) )
				{
									
					e = new HTMLGenericElement( sSecondary );
				
					tm.SetSecondarTip( e );
				}

								

			}
			catch (Exception ex)
			{
				
					log.Error(ex, "Couldn't generate tip.");
				
			}
		}
		 //	Got the tips model
		 
		 				
				
		
		
	}
	
	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(String, String, boolean)
	 */
	public boolean CheckBasicAccess(String strPage, String strControl, boolean bSameSpace)
	{
		// make sure this is not the guest user, unless we are editing the default
		// profile.
		boolean isGuest = PlumtreeHelpers.IsGuestSession(this);
		if (isGuest &&
			(!PlumtreeHelpers.IsEditingDefaultProfile(this)))
		{
			return false;
		}
		
		return true;
	}	
}

