package com.plumtree.portalpages.browsing.portalsettings.localesettings;

import com.plumtree.openfoundation.web.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;

/**
 * The only reason why we need this class is to get the WebData object.
 * 
 * Note that this editor doesn't have any other repost actions 
 * than EditorRepostControl and we don't implement the PerformAction method.
 * 
 * @author JulieF
 */
public class LocaleSettingsRepostControl extends EditorRepostControl
	implements IHTTPControl
{
	
	/** Class name for the activity space */
	public static final String STR_MVC_CLASS_NAME = "LocaleSettingsRepost";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new LocaleSettingsRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Inits this Control with the HTTP Request and the Web Data object.
	 *
	 * @param _xpRequest
	 * @param _webdata
	 */
	public void SetHTTPItems(IXPRequest _xpRequest, IWebData _webdata)
	{
		((LocaleSettingsModel) m_model).SetWebData(_webdata);		
	}
}

