package com.plumtree.portalpages.browsing.portalsettings.search;

/**
 * This class is used to hold the name and query string for a saved search.
 * 
 * @author Matt Fryer
 * Created on Sept 2, 2003
 */
public class SavedSearchData
{
	private String _name;
	
	private String _query;
	
	/**
	 * Construct a SavedSearchData instance
	 * 
	 * @param name Name to save the search under
	 * @param url Url to reconstruct the search
	 */
	public SavedSearchData(String name, String query)
	{
		_name = name;
		_query = query;
	}
	
	/**
	 * @return name of the saved search
	 */
	public String GetName() { return _name; }
	
	/**
	 * @return query string for the url of the saved search
	 */
	public String GetURLQueryString() { return _query; }
	
	/**
	 * @param url The query string for the url for this saved search.
	 */
	public void SetURLQueryString(String query) { _query = query; }
	
	/**
	 * @param name The name for this saved search.
	 */
	public void SetName(String name) { _name = name; }
	
	
}

