package com.plumtree.portalpages.browsing.portalsettings.search;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.constants.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.tips.*;
import com.plumtree.xpshared.htmlelements.*;


/**
 * @author CraigS, based on JulieF template
 */
public class SearchSettingsAS extends PTEditorAS
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.portalsettings.search.SearchSettingsAS");

	
	public static final String STR_MVC_CLASS_NAME = "SearchSettings";

	private static final String sClassName = "com.plumtree.portalpages.browsing.portalsettings.search.SearchSettingsAS";

	/**
	 * 
	 *
	 * @return 
	 */
	public Object Create()
	{
		return new SearchSettingsAS();
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetEditorTitle()
	{
		return GetString(1031, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	
	/**
	 * 
	 */
	public void Init()
	{
		m_strModelName = SearchSettingsModel.STR_MVC_CLASS_NAME;
		super.Init();

		IModel myModel = GetModel(m_strModelName);

		RegisterPage(new SearchSettingsDP());

		RegisterView(SearchSettingsView.STR_MVC_CLASS_NAME, myModel);

		SetCurrentPage(SearchSettingsDP.STR_MVC_CLASS_NAME);

		int nMenuOneID = m_mEditorMenu.StartNewSubMenu(GetString(1032,
					"ptmsgs_portalbrowsingmsgs"));
		m_mEditorMenu.AddLinkToSubMenu(nMenuOneID,
			SearchSettingsDP.STR_MVC_CLASS_NAME);
			
		this.SetHelpTopic( "PT_SearchPreferences_MainSettings" );
		
		

		//	TIPS
		TipsModel tm = (TipsModel) GetModel(TipsModel.STR_MVC_CLASS_NAME);

		if (tm != null)
		{
			try
			{
				tm.SetGeneratingClass( sClassName );
				
				
				int iTitleId = 129;
				int iTipId = 130;
				int iSecondaryTipId = 131;
								
				tm.SetTipTitle( this.GetString( iTitleId, ResourceConstants.TIPS) );

				HTMLGenericElement e = new HTMLGenericElement( this.GetString( iTipId, ResourceConstants.TIPS) );

				tm.SetTip( e );
				
				String sSecondary = this.GetString( iSecondaryTipId, ResourceConstants.TIPS);
				
				if( !("none_do_not_translate".equals( sSecondary )) )
				{
									
					e = new HTMLGenericElement( sSecondary );
				
					tm.SetSecondarTip( e );
				}

								

			}
			catch (Exception ex)
			{
				
					log.Error(ex, "Couldn't generate tip.");
				
			}
		}
		 //	Got the tips model
		 
		 						
		
		
	}
	
	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(String, String, boolean)
	 */
	public boolean CheckBasicAccess(String strPage, String strControl, boolean bSameSpace)
	{
		// make sure this is not the guest user
		boolean isGuest = PlumtreeHelpers.IsGuestSession(this);
		if (isGuest  && !PlumtreeHelpers.IsEditingDefaultProfile(this))
		{
			return false;
		}
		
		return true;
	}	
}

