package com.plumtree.portalpages.browsing.portalsettings.search;

import com.plumtree.uiinfrastructure.constants.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author CraigS, based on JulieF template
 */
public class SearchSettingsDP extends EditorDP
{
	
	public static final String STR_MVC_CLASS_NAME = "SearchSettings";

	
	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return (m_asOwner.GetString(1033, "ptmsgs_portalbrowsingmsgs"));
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 *
	 * @throws HTMLException 
	 */
	public HTMLElement PageDisplay()

	{
		HTMLElementCollection result = new HTMLElementCollection();

		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();
		views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
				SearchSettingsView.STR_MVC_CLASS_NAME)).Display());

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	 * 
	 *
	 * @return 
	 *
	 * @throws HTMLException 
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = null;
		if (m_asOwner.GetAccessStyle() == AccessStyles.STANDARD)
		{
			myScripts = super.DisplayJavaScriptFromChild();
			myScripts.AddInnerHTMLElement(m_asOwner.GetView(
				SearchSettingsView.STR_MVC_CLASS_NAME).DisplayJavascript());
		}

		return myScripts;
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader()  {
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(1450, "ptmsgs_portalbrowsingmsgs"),
			this.m_asOwner);
	}
}

