package com.plumtree.portalpages.browsing.portalsettings.settings;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.portalpages.browsing.editors.userprofile.*;
import com.plumtree.portalpages.browsing.portalsettings.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.web.*;



/**
 * 
 *
 * @version $Revision$
 * @author $author$
 */
public class EditUserProfileSetting implements IPortalSettings
{
	private boolean m_bIsViewable     = true;

	/**
	 * Creates a new UserPortalSettings object.
	 */
	public EditUserProfileSetting()
	{
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASControlName()
	{
		return EditorStartControl.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASDPName()
	{
		return null;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASName()
	{
		return UserProfileEditorAS.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASQueryString()
	{
		String strQuery = "&" + EditorStartControl.QS_EDITOR_TYPE + "=10";

		return strQuery;
	}

	/**
	 * 
	 *
	 * @param _strLangID 
	 *
	 * @return 
	 */
	public String GetDescription(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
		return rm.GetString(1733, "ptmsgs_portalbrowsingmsgs", _strLangID);
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetImageLocation()
	{
		return null;
	}

	/**
	 * 
	 *
	 * @param _strLangID 
	 *
	 * @return 
	 */
	public String GetLinkText(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
		return rm.GetString(1302, "ptmsgs_portalbrowsingmsgs", _strLangID);
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean IsStandardPortalOption()
	{
		return true;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean IsViewable()
	{
		return m_bIsViewable;
	}

	/**
	 * 
	 *
	 * @param bIsViewable 
	 */
	public void SetViewable(boolean bIsViewable)
	{
		m_bIsViewable = bIsViewable;
	}

	/**
	 * @see com.plumtree.portalpages.browsing.portalsettings.IPortalSettings#GetDisplaySetting()
	 */
	public boolean GetDisplaySetting(Object session)
	{
		return true;
	}
	
	public int GetActivityRightRestriction()
	{
		return PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_EDIT_OWN_PROFILE;
	}
}

