package com.plumtree.portalpages.browsing.portalsettings.settings;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.portalpages.browsing.portalsettings.*;
import com.plumtree.portalpages.browsing.portalsettings.localesettings.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.web.*;

/**
 * 
 *
 */
public class LocalePortalSetting implements IPortalSettings
{
	private boolean m_bIsViewable		    = true;

	/**
	 * Creates a new LocalePortalSetting object.
	 */
	public LocalePortalSetting()
	{
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASControlName()
	{
		return EditorStartControl.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASDPName()
	{
		return null;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASName()
	{
		return LocaleSettingsEditorAS.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASQueryString()
	{
		return LinkConstants.AMPERSAND + EditorStartControl.QS_EDITOR_TYPE + LinkConstants.EQUALS + EditorStartControl.EDITOR_START_FLAG_MISC;
	}

	/**
	 * 
	 *
	 * @param _strLangID 
	 *
	 * @return 
	 */
	public String GetDescription(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
		return rm.GetString(1303, "ptmsgs_portalbrowsingmsgs", _strLangID);
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetImageLocation()
	{
		return null;
	}

	/**
	 * 
	 *
	 * @param _strLangID 
	 *
	 * @return 
	 */
	public String GetLinkText(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
		return rm.GetString(1304, "ptmsgs_portalbrowsingmsgs", _strLangID);
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean IsStandardPortalOption()
	{
		return true;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean IsViewable()
	{
		return m_bIsViewable;
	}

	/**
	 * 
	 *
	 * @param bIsViewable 
	 */
	public void SetViewable(boolean bIsViewable)
	{
		m_bIsViewable = bIsViewable;
	}

	//Returns the HTMLElement
	//public HTMLElement GetHTMLElement(); 

	/**
	 * @see com.plumtree.portalpages.browsing.portalsettings.IPortalSettings#GetDisplaySetting()
	 */
	public boolean GetDisplaySetting(Object session)
	{
		return true;
	}
	
	public int GetActivityRightRestriction()
	{
		return PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_NONE;
	}
}

