package com.plumtree.portalpages.browsing.portalsettings.settings;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.portalpages.browsing.portalsettings.*;
import com.plumtree.portalpages.browsing.portalsettings.passwordmanager.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.web.*;

/**
 * @author JenniferSu
 *
 * This describes a link to the Password Manager space.
 */
public class PasswordManagerPortalSetting implements IPortalSettings
{

	/**
	 * @see com.plumtree.portalpages.browsing.portalsettings.IPortalSettings#GetDescription(String)
	 */
	public String GetDescription(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
		return rm.GetString(1834, "ptmsgs_portalbrowsingmsgs", _strLangID);
	}

	/**
	 * @see com.plumtree.portalpages.browsing.portalsettings.IPortalSettings#GetImageLocation()
	 */
	public String GetImageLocation()
	{
		return null;
	}

	/**
	 * @see com.plumtree.portalpages.browsing.portalsettings.IPortalSettings#GetDisplaySetting(Object)
	 */
	public boolean GetDisplaySetting(Object session)
	{

		return true;
	}
	
	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#GetASControlName()
	 */
	public String GetASControlName()
	{
		return EditorStartControl.STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#GetASDPName()
	 */
	public String GetASDPName()
	{
		return null;
	}

	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#GetASName()
	 */
	public String GetASName()
	{
		return PasswordManagerAS.STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#GetASQueryString()
	 */
	public String GetASQueryString()
	{
		return LinkConstants.AMPERSAND + EditorStartControl.QS_EDITOR_TYPE + LinkConstants.EQUALS + EditorStartControl.EDITOR_START_FLAG_MISC;
	}

	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#GetLinkText(String)
	 */
	public String GetLinkText(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
		return rm.GetString(1835, "ptmsgs_portalbrowsingmsgs", _strLangID);
	}

	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#IsStandardPortalOption()
	 */
	public boolean IsStandardPortalOption()
	{
		return true;
	}

	/**
	 * @see com.plumtree.portalpages.browsing.settings.ISettings#IsViewable()
	 */
	public boolean IsViewable()
	{
		return true;
	}
	
	public int GetActivityRightRestriction()
	{
		return PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_NONE;
	}
}

