package com.plumtree.portalpages.browsing.portalsettings.settings;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.portalpages.browsing.portalsettings.*;
import com.plumtree.portalpages.browsing.portalsettings.search.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.web.*;

/**
 *
 */
public class SearchPortalSetting implements IPortalSettings
{
	private boolean m_bIsViewable = true;

	/**
	 * Creates a new SearchPortalSetting object.
	 */
	public SearchPortalSetting()
	{
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASControlName()
	{
		return EditorStartControl.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASDPName()
	{
		return null;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASName()
	{
		return SearchSettingsAS.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASQueryString()
	{
		return "&editorType=10";
	}


	public String GetDescription(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance()
			.GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm = (XPResourceManager) application.GetCachingManager()
			.GetEntry("ResourceManager");

		return rm.GetString(1065, "ptmsgs_portalbrowsingmsgs", _strLangID);
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetImageLocation()
	{
		return null;
	}



	public String GetLinkText(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance()
			.GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm = (XPResourceManager) application.GetCachingManager()
			.GetEntry("ResourceManager");

		return rm.GetString(1064, "ptmsgs_portalbrowsingmsgs", _strLangID);

		//_ui_LinkText
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean IsStandardPortalOption()
	{
		return true;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean IsViewable()
	{
		return m_bIsViewable;
	}

	/**
	 * 
	 *
	 * @param bIsViewable 
	 */
	public void SetViewable(boolean bIsViewable)
	{
		m_bIsViewable = bIsViewable;
	}

	/**
	 * @see com.plumtree.portalpages.browsing.portalsettings.IPortalSettings#GetDisplaySetting()
	 */
	public boolean GetDisplaySetting(Object session)
	{
		return true;
	}
	
	public int GetActivityRightRestriction()
	{
		return PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_NONE;
	}
}

