package com.plumtree.portalpages.browsing.portalsettings.settings;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.portalpages.browsing.myportal.*;
import com.plumtree.portalpages.browsing.myportal.communities.*;
import com.plumtree.portalpages.browsing.portalsettings.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.web.*;


/**
 * 
 *
 * @author NaveenP
 */
public class ViewUserProfileSetting implements IPortalSettings
{


	// TODO: localize


	
	private boolean m_bIsViewable = true;

	/**
	 * Creates a new UserPortalSettings object.
	 */
	public ViewUserProfileSetting()
	{
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASControlName()
	{
		return SetCommunityControl.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASDPName()
	{
		return null;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASName()
	{
		return CommunityPageAS.STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetASQueryString()
	{
		String strQuery = "&" + SetCommunityControl.STR_COMMUNITY_ID + "=2&" +
			SetCommunityControl.STR_PAGE_ID + "=0";

		return strQuery;
	}

	/**
	 * 
	 *
	 * @param _strLangID 
	 *
	 * @return 
	 */
	public String GetDescription(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");

		return rm.GetString(1307, "ptmsgs_portalbrowsingmsgs", _strLangID);
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetImageLocation()
	{
		return null;
	}

	/**
	 * 
	 *
	 * @param _strLangID 
	 *
	 * @return 
	 */
	public String GetLinkText(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");

		return rm.GetString(1308, "ptmsgs_portalbrowsingmsgs", _strLangID);
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean IsStandardPortalOption()
	{
		return true;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean IsViewable()
	{
		return m_bIsViewable;
	}

	/**
	 * 
	 *
	 * @param bIsViewable 
	 */
	public void SetViewable(boolean bIsViewable)
	{
		m_bIsViewable = bIsViewable;
	}

	/**
	 * @see com.plumtree.portalpages.browsing.portalsettings.IPortalSettings#GetDisplaySetting()
	 */
	public boolean GetDisplaySetting(Object session)
	{
		return true;
	}
	
	public int GetActivityRightRestriction()
	{
		return PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_NONE;
	}
}

