package com.plumtree.portalpages.browsing.portletpreview;

import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.constants.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * File: InvitePortletJSDP.java
 * ---------------------------
 * Display Page for the Portlet Invitation JavaScript.
 * This is a blank page that simply pops up the Portlet
 * Invitation.
 *
 * @author NaveenP/DustinA
 */
public class InvitePortletJSDP extends AFormDP
{
	
	public static final String STR_MVC_CLASS_NAME = "InviteGadgetJS";

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormPageType()
	 */
	public FormPageTypes GetFormPageType()
	{
		if (GetOwner().GetAccessStyle() != AccessStyles.STANDARD)
		{
			return FormPageTypes.NORMAL_PAGE;
		}

		// default implementation
		return FormPageTypes.NO_BUTTONS;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetFormTitle()
	{
		return "";
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.ui.framework.IDisplayPage#GetParent()
	 */
	public AActivitySpace GetOwner()
	{
		return m_asOwner;
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetSubtitleForBanner()
	 */
	public String GetSubtitleForBanner()
	{
		return "";
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetTitleForBanner()
	 */
	public String GetTitleForBanner()
	{
		return "";
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IDisplayPage#Init(AActivitySpace)
	 */

	/*public void Init(AActivitySpace parent)
	{
	    m_asOwner = parent;
	}*/

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		
		result.AddInnerHTMLElement(m_asOwner.GetView(InvitePortletJSView.STR_MVC_CLASS_NAME)
		.Display());
		
		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#DisplayJavaScriptFromChild()
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection scripts = new HTMLScriptCollection();

		scripts.AddInnerHTMLElement(m_asOwner.GetView(
				InvitePortletJSView.STR_MVC_CLASS_NAME).DisplayJavascript());
		scripts.AddInnerHTMLElement(((InvitePortletJSView) m_asOwner.GetView(
				InvitePortletJSView.STR_MVC_CLASS_NAME)).DisplayRedirectJavascript());

		return scripts;
	}
}

