package com.plumtree.portalpages.browsing.portletpreview;

import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * File: PortletInvitationJoinDP.java
 * ------------------------------------
 * Display page for adding a gadget via an Invitation.
 *
 * @author NaveenP/DustinA
 */
public class PortletInvitationJoinDP extends AFormDP
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.portletpreview.PortletInvitationJoinDP");

	
	public static final String STR_MVC_CLASS_NAME = "PortletInvitationJoin";

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()
	 */
	public String GetFormTitle()
	{
		return m_asOwner.GetString(586, "ptmsgs_portalbrowsingmsgs");
	}

	
	/** Logging */
	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetSubtitleForBanner()
	 */
	public String GetSubtitleForBanner()
	{
		return "";
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#PageDisplay(HTMLTableRow)
	 */
	public HTMLElement PageDisplay()

	{
		HTMLElementCollection result = new HTMLElementCollection();

		try
		{
			result.AddInnerHTMLElement(m_asOwner.GetView(
					PortletInvitationJoinView.STR_MVC_CLASS_NAME).Display());
		}
		catch (HTMLException he)
		{
			log.Error(he, he.getMessage());
		}

		return result;
	}
}

