package com.plumtree.portalpages.browsing.portletpreview;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * Displays a list of URLs to communities that contain the portlet being
 * previewed.
 * 
 * @author DavidP
 */
public class PreviewCommPortletListDP extends AFormDP 
{
	
	public static final String STR_MVC_CLASS_NAME = "PreviewCommPortletList";
	

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()
	 */
	public String GetFormTitle()
	{
		return m_asOwner.GetString(1318, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Init(AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		super.Init(parent);
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IDisplayPage#display()
	 */
	public HTMLElement PageDisplay()

	{
		return m_asOwner.GetView(PreviewCommPortletListView.STR_MVC_CLASS_NAME).Display();
	}

	/**
	 * Display Java Script From Child
	 *
	 * @return HTMLScriptCollection
	 *
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection scripts = new HTMLScriptCollection();
		scripts.AddInnerHTMLElement(m_asOwner.GetView(
			PreviewCommPortletListView.STR_MVC_CLASS_NAME).DisplayJavascript());
			
		HTMLScript script = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
		script.SetSrc(ConfigHelper.GetPortalImageServerJavaScriptURL(m_asOwner) + "opennewwindow.js");
		scripts.AddInnerHTMLElement(script);

		return scripts;
	}

}

