package com.plumtree.portalpages.browsing.search.advanced;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.search.basic.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author CraigS
 */
public class ASButtonView implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.search.advanced.ASButtonView");

	
	public static final String STR_MVC_CLASS_NAME = "ASButton";

	// Strings to localize.
	// HTML inputs

	
	public static final String HTMLINPUT_SEARCH_BUTTON = "in_bu_submitsearch";
	protected AActivitySpace m_asOwner	    = null;
	protected IAdvancedSearchModelRO _model = null;

	/**
	 * 
	 *
	 * @return 
	 */
	public Object Create()
	{
		return new ASButtonView();
	}

	/**
	 * Creates the search button in the advanced search settings page and returns the HTML for the Section
	 * @return HTMLElement
	 */
	public HTMLElement Display()
	{
		HTMLElement result = new HTMLElementCollection();

		//Ravi Tunuguntla - Removed Basic Search Link from Advanced Search Page
		// This is fix for Bug # 
//		ASURL url = BasicSearchView.GetBasicSearchURL(m_asOwner);
//		result.AddInnerHTMLElement(url.GetURLAsHTMLElement());
		result.AddInnerHTMLString("&nbsp;&nbsp;&nbsp;&nbsp;");
		
		try
		{
			HTMLInput button = new HTMLInput(HTMLInputTypes.BUTTON,
					HTMLINPUT_SEARCH_BUTTON, "");
			button.SetOnClick("postToSelf(" +
				AdvancedSearchRepostControl.SEARCH_ACTION + ");");

			button.SetValue(m_asOwner.GetString(774, "ptmsgs_portalbrowsingmsgs"));
			button.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
			result.AddInnerHTMLElement(button);
		}
		catch (Exception e)
		{
			
				log.Error(m_asOwner.GetString(773, "ptmsgs_portalbrowsingmsgs"));
			

			throw new XPException(m_asOwner.GetString(773,
					"ptmsgs_portalbrowsingmsgs"), e);
		}

		return result;
	}

	/**
	 * This method returns the HTMLScript that encompasses the Javascript on the page.
	 * @return HTMLScript
	 */
	public HTMLScript DisplayJavascript()
	{
		return null;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @param model 
	 * @param parent 
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		_model		  = (IAdvancedSearchModelRO) model;
		m_asOwner     = parent;
	}
}

