package com.plumtree.portalpages.browsing.search.advanced;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.search.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author CraigS
 */
public class ASFilterView extends FilterView implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.search.advanced.ASFilterView");

	
	public static final String STR_MVC_CLASS_NAME = "ASFilter";
	protected AActivitySpace _parent = null;

	protected IAdvancedSearchModelRO _model = null;

	/**
	 * 
	 *
	 * @return 
	 */
	public Object Create()
	{
		return new ASFilterView();
	}

	/**
	 * Returns the HTML for the Section.
	 * @return HTMLElement
	 */
	public HTMLElement Display()
	{
		try
		{
			return super.Display();
		}
		catch (Exception e)
		{
			
				log.Error(m_asOwner.GetString(775, "ptmsgs_portalbrowsingmsgs"));
			

			throw new XPException(m_asOwner.GetString(775,
					"ptmsgs_portalbrowsingmsgs"), e);
		}
	}

	/**
	 * This method returns the HTMLScript that encompasses the Javascript on the page.
	 * @return HTMLScript
	 */
	public HTMLScript DisplayJavascript()
	{
		super.SetRepostAction(RepostControl.POSTTOSELF_ACTION_SIMPLEREPOST);

		return super.DisplayJavascript();
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @param model 
	 * @param parent 
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		// Semi-hack: This class extends FilterView, which extends ObjEditorView,
		// but this space isn't an object editor, so a call to super.Init() would
		// fail.  Instead, initialize stuff here.
		_model	    = (IAdvancedSearchModelRO) model;
		m_model     = _model;
		_parent     = parent;

		super.Init(model, parent); // this will be intercepted in FilterView

		// No view title on AS page
		super.SetViewTitle(null);

		super.SetWidth(AdvancedSearchDP.TABLE_WIDTH);
		super.SetAllowSubclauses(false);
		super.SetUseJavascriptStatementButtons(false);
		//super.SetTextSearchAboveButtons();
		//super.SetUseCheckboxLayout();
		//super.SetErrorsNextToTextBoxes(true);

		super.SetTextboxLabel(new HTMLGenericElement(m_asOwner.GetString(777,
					"ptmsgs_portalbrowsingmsgs")));

		super.SetPropertyLabel(null); //"MATT TEST" + m_asOwner.GetString(778,
				//"ptmsgs_portalbrowsingmsgs"));

		super.SetAddConditionLabel(m_asOwner.GetString(739,
				"ptmsgs_portalcommonmsgs"));

		super.SetRemoveConditionLabel(m_asOwner.GetString(780,
				"ptmsgs_portalbrowsingmsgs"));
	}

	/**
	 *  Overrides superclass method
	 */
	protected boolean GetDoValidation()
	{
		return _model.GetShowPotentialErrors();
	}
}

