package com.plumtree.portalpages.browsing.search.advanced;

import com.plumtree.portaluiinfrastructure.filter.*;
import com.plumtree.uiinfrastructure.editor.*;

/**
 * @author CraigS
 */
public interface IAdvancedSearchModelRO extends IEditorModelRO, IFilterIteratorContainerRO
{
	/**
	 *  Whether to flag items that will cause errors if the search is submitted.
	 *  It's nice to not do this at first, so the user can assemble a search without
	 *  being constantly pestered, then we turn on validation once the user first
	 *  attempts to submit the search.
	 */
	public boolean GetShowPotentialErrors();
	
	/*
	 * This is one of the modes defined in SearchPageModeHelper. There
	 * are not setter methods, currently, since the mode is just being passed through.
	 */
	public String GetMode();
}

