package com.plumtree.portalpages.browsing.search.basic;

import com.plumtree.portalpages.browsing.search.advanced.*;
import com.plumtree.portaluiinfrastructure.search.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author MatthewF
 */
public class BasicSearchButtonView implements IView
{
	
	public static final String STR_MVC_CLASS_NAME = "BasicSearchButton";
	
	public static final String HTMLINPUT_SEARCH_BUTTON = "in_bu_submitsearch";
	
	public static final String HTMLINPUT_RESET_BUTTON = "in_bu_reset";
	
	protected AActivitySpace m_asOwner	    = null;
	
	protected SearchFormFactory _factory = null;

	/**
	 * 
	 *
	 * @return 
	 */
	public Object Create()
	{
		return new BasicSearchButtonView();
	}

	/**
	 * Returns the HTML for the Section.
	 * @return HTMLElement
	 */
	public HTMLElement Display()
	{
		HTMLElement result = new HTMLElementCollection();

		ASURL url = AdvancedSearchDP.GetAdvancedSearchURL(m_asOwner);
		result.AddInnerHTMLElement(url.GetURLAsHTMLElement());
		result.AddInnerHTMLString("&nbsp;&nbsp;&nbsp;&nbsp;");
		
		HTMLInput button = new HTMLInput(HTMLInputTypes.BUTTON,
				HTMLINPUT_SEARCH_BUTTON, "");
		button.SetOnClick(_factory.GetAnchorOnClick());

		button.SetValue(m_asOwner.GetString(774, "ptmsgs_portalbrowsingmsgs"));
		button.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
		result.AddInnerHTMLElement(button);
		
		result.AddInnerHTMLString("&nbsp;");
		
		ASURL newAS = new ASURL(m_asOwner);
		newAS.SetLinkCreateNewSpace(BasicSearchAS.STR_MVC_CLASS_NAME,
			m_asOwner);

		String reset_url = newAS.GetURLAsString();

		// Make a reset button.
		button = new HTMLInput(HTMLInputTypes.BUTTON,
				HTMLINPUT_RESET_BUTTON, "");

		button.SetValue(m_asOwner.GetString(783, "ptmsgs_portalbrowsingmsgs"));
		button.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
		button.SetOnClick("window.location.href='" + reset_url + "';");

		result.AddInnerHTMLElement(button);

		return result;
	}

	/**
	 * This method returns the HTMLScript that encompasses the Javascript on the page.
	 * @return HTMLScript
	 */
	public HTMLScript DisplayJavascript()
	{
		return null;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @param model 
	 * @param parent 
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_asOwner     = parent;
	}
	
	public void SetFactory(SearchFormFactory factory)
	{
		_factory = factory;
	}
}

