package com.plumtree.portalpages.browsing.search.network;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author JosephSi
 *
 */
public interface INetworkSearchModel extends IModel
{
	/** TMP A debugging method which will go away when the code is complete */
	public void SetAlwaysDoLocalSearch(boolean flag);

	/**
	 * reset searched source list to be empty
	 **/
	public void ClearSearchedSourceList();

	/** Call this to initialize a range of search results */
	public void Prepare(String searchString, IXPList sourceIDs, int pageNum);

	public void SetNumberResults(int num);
	public int GetNumberResults();
	/**
	 * String entered into the box by the user
	 **/

	//public void SetSearchString(String searchString); 
	public void SetPageNum(int pageNum);

	/**
	 * set String indicating whether to present results collated
	 * or in parallel
	 **/
	public void SetViewMode(String viewMode);

    /**
     * save the locations (object ids of fed portals) as a user preference
     * so that they're automatically checked on the launch page next time
     **/
    public void SaveLocationPreferences(String[] locationObjectIdStrings);
    
    /**
     * Set a flag indicating whether we had to truncate the user's
     * search string to NetworkSearchModel.MAX_SEARCHSTRING_LENGTH
     * characters
     **/
    public void SetSearchStringTruncated(boolean flag); 
}

