package com.plumtree.portalpages.browsing.search.network;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 *
 * @author JosephSi
 */
public interface INetworkSearchModelRO extends IModelRO
{
	/**
	 * 
	 *
	 * @param sourceId 
	 *
	 * @return 
	 */
	public boolean isResultSetValid(int sourceId);

	/**
	 * 
	 *
	 * @param sourceId 
	 *
	 * @return 
	 */
	public String GetFormattedError(int sourceId);
	
	/**
	 * 
	 *
	 * @return 
	 */
	public boolean AreAllResultSetsValid();

	/**
	 * 
	 *
	 * @param sourceId 
	 * @param resultId 
	 *
	 * @return 
	 */
	public String GetDescriptionForResultFromSource(int sourceId, int resultId);

	/**
	 * 
	 *
	 * @param sourceId 
	 *
	 * @return 
	 */
	public String GetErrorFromSource(int sourceId);

	/**
	 * 
	 *
	 * @param sourceId 
	 *
	 * @return 
	 */
	public int GetFirstDisplayedResultFromSource(int sourceId);

	/**
	 * 
	 *
	 * @return 
	 */
	public int GetFirstDisplayedResultOverall();

	/**
	 * 
	 *
	 * @param sourceId 
	 * @param resultId 
	 *
	 * @return 
	 */
	public HTMLImg GetImageForResultFromSource(int sourceId, int resultId);

	/**
	 * 
	 *
	 * @param sourceId 
	 *
	 * @return 
	 */
	public int GetNumDisplayedResultsFromSource(int sourceId);

	/**
	 * 
	 *
	 * @return 
	 */
	public int GetNumDisplayedResultsOverall();

	/**
	 * 
	 *
	 * @param sourceId 
	 *
	 * @return 
	 */
	public int GetNumResultsFromSource(int sourceId);

	/**
	 * 
	 *
	 * @return 
	 */
	public int GetNumResultsOverall();

	/**
	 * 
	 *
	 * @return 
	 */
	public int GetNumSources();

	/**
	 * 
	 *
	 * @return 
	 */
	public int GetPageNum();
	
	/**
	 * 
	 *
	 * @return 
	 */
	public String GetSearchString();

    /**
     * gets search string without html encoding (we need this
     * to avoid double-encoding, since some of the HTMLElement
     * classes do the encoding for you
     **/
    public String GetUnencodedSearchString(); 

	/**
	 * 
	 *
	 * @return 
	 */
	public IXPList GetSearchedSources();

	/**
	 * 
	 *
	 * @param index 
	 *
	 * @return 
	 */
	public int GetSourceID(int index);

	/**
	 * 
	 *
	 * @param index 
	 *
	 * @return 
	 */
	public String GetSourceName(int index);

	/**
	 * 
	 *
	 * @param sourceId 
	 * @param resultId 
	 *
	 * @return 
	 */
	public String GetTitleForResultFromSource(int sourceId, int resultId);

	/**
	 * 
	 *
	 * @param sourceId 
	 * @param resultId 
	 *
	 * @return 
	 */
	public HTMLAnchor GetURLForResultFromSource(int sourceId, int resultId, boolean popup);

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetViewMode();

    /**
     * check to see if the user has any stored preferences regarding
     * which sources to check. Note: returns null if there are no such
     * preferences
     **/
    public XPHashtable GetLocationPreferencesForUser();
    
    /**
     * A flag indicating whether we had to truncate the user's
     * search string to NetworkSearchModel.MAX_SEARCHSTRING_LENGTH
     * characters
     **/

    public boolean GetSearchStringTruncated(); 

    /**
     * returns true if the fed portal's associated web service
     * has been disabled
     **/
    public boolean IsDisabled(int objectID);
    
    /**
     * certain errors lead to the generation of a link to 
     * a config page where the problem can be fixed, in which
     * case this returns the link. Otherwise, this method will
     * return null
     **/
    public HTMLElement GetErrorLinkFromSource(int sourceID);
    
	public void SetNumberResults(int num);
	public int GetNumberResults();

}

