package com.plumtree.portalpages.browsing.search.network;

import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author JosephSi
 *
 */
public class NetworkSearchAS extends PlumtreeAS
{
	
	public static final String STR_MVC_CLASS_NAME = "NetworkSearch";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new NetworkSearchAS();
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.AActivitySpace#Init()
	 */
	public void Init()
	{
		super.Init();

		//  Turn on automatic tracking of current page (off by default).
		SetTrackCurrentPage(true);
		
		RegisterPage(new NetworkSearchLaunchDP());
		RegisterPage(new NetworkSearchLaunchDP_D());
		RegisterPage(new NetworkSearchResultsDP());
		RegisterPage(new NetworkSearchResultsDP_D());

		RegisterModel(NetworkSearchModel.STR_MVC_CLASS_NAME);

		IModel myModel = GetModel(NetworkSearchModel.STR_MVC_CLASS_NAME);

		RegisterControl(NetworkSearchControl.STR_MVC_CLASS_NAME, myModel);

		RegisterView(NetworkSearchLaunchView.STR_MVC_CLASS_NAME, myModel);
		RegisterView(NetworkSearchLaunchView_D.STR_MVC_CLASS_NAME, myModel);
		RegisterView(NetworkSearchResultsView.STR_MVC_CLASS_NAME, myModel);
		RegisterView(NetworkSearchResultsView_D.STR_MVC_CLASS_NAME, myModel);
		
		this.SetHelpTopic("PT_FederatedSearch");
		
	}
	/**
	  * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#SetCurrentPage()
	  *
	  * @param IDisplayPage the current Display Page
	  */
	 public void SetCurrentPage(IDisplayPage page)
	 {
		  super.SetCurrentPage( page );             
		  String sPageName = page.GetName();

		  if( (NetworkSearchResultsDP.STR_MVC_CLASS_NAME.equals( sPageName )) ||
		      (NetworkSearchResultsDP_D.STR_MVC_CLASS_NAME.equals( sPageName )) )
		  {
					this.SetHelpTopic( "PT_FederatedSearchResults" );                           
		  }
		  else
		  {
					this.SetHelpTopic( "PT_FederatedSearch" );
		  }
	 }
}

