package com.plumtree.portalpages.browsing.search.network;

import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlelements.*;


/**
 * @author JosephSi
 *
 */
public class NetworkSearchLaunchDP extends PlumtreeDP
{
	
	public static final String STR_MVC_CLASS_NAME = "NetworkSearchLaunch";

	
	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetSubtitleForBanner()
	 */
	public String GetSubtitleForBanner()
	{
		return "";
	}



	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Init(AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		super.Init( parent );
		
		parent.SetHelpTopic("PT_FederatedSearch");
		
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetTitleForBanner()
	 */
	public String GetTitleForBanner()
	{
		return m_asOwner.GetString(786, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()

	{
		return m_asOwner.GetView(NetworkSearchLaunchView.STR_MVC_CLASS_NAME)
		.Display();
	}

	/**
	 * 
	 *
	 * @return 
	 *
	 * @throws HTMLException 
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();
		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
				NetworkSearchLaunchView.STR_MVC_CLASS_NAME).DisplayJavascript());

		return myScripts;
	}
}

