package com.plumtree.portalpages.browsing.search.network;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;


/**
 * @author JosephSi
 *
 * Displays the page where network searches can be set up and run.
 * Shows a checkbox of possible sources to be searches on the left,
 * and a text input box to enter the search on the right
 */
public class NetworkSearchLaunchView implements IView
{
	
	public static final String STR_MVC_CLASS_NAME = "NetworkSearchLaunch";
	private AActivitySpace m_asOwner;
	private INetworkSearchModelRO m_asmModel;
    public static final String widthOfLocationCells="97%";
	public static final String IN_CB_CHECKALL1 = "in_cb_CheckAll1";
	protected XPStringBuilder checkboxJSBuffer = new XPStringBuilder();
    
	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new NetworkSearchLaunchView();
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		try
		{
			HTMLElement result = new HTMLElementCollection();

			// the whole page is one big form
			HTMLForm form1 = new HTMLForm("networksearch");
			result.AddInnerHTMLElement(form1);
			form1.SetMethod("get");
			form1.SetAction(ConfigHelper.GetApplicationBaseURLToAS(m_asOwner.GetCurrentNormalizedBaseURL(), 
				m_asOwner.GetName(), m_asOwner.IsSubSpace()));
			form1.SetID("networksearch");
			form1.SetName("networksearch"); 
			form1.SetOnSubmit("return DoSearch();"); 
			// set the space and control 
			HTMLInput input = new HTMLInput(HTMLInputTypes.HIDDEN,
					"in_hi_space", "in_hi_space_id");
			input.SetValue(NetworkSearchAS.STR_MVC_CLASS_NAME);
			form1.AddInnerHTMLElement(input);

			input = new HTMLInput(HTMLInputTypes.HIDDEN, "in_hi_control",
					"in_hi_control_id");
			input.SetValue(NetworkSearchControl.STR_MVC_CLASS_NAME);
			form1.AddInnerHTMLElement(input);

			// just a simple input to make clear to the control
			// that this is a request for results
			input = new HTMLInput(HTMLInputTypes.HIDDEN,
					NetworkSearchControl.RESULTS_DATA,
					NetworkSearchControl.RESULTS_DATA);
			input.SetValue(XPConvert.ToString(true));
			form1.AddInnerHTMLElement(input);

			HTMLTable overallTable=new HTMLTable();
			overallTable.SetWidth("100%");
			overallTable.SetCellSpacing("0");
			overallTable.SetCellPadding("0");
			overallTable.SetBorder("0");
			form1.AddInnerHTMLElement(overallTable); 

			HTMLTableRow topTableRow=new HTMLTableRow();
			HTMLTable topTable = new HTMLTable();
			topTable.SetWidth("100%"); 
		        HTMLTableCell cell=new HTMLTableCell();
			cell.SetWidth("100%"); 
			cell.AddInnerHTMLElement(topTable); 
			topTableRow.AddInnerHTMLElement(cell); 
			overallTable.AddInnerHTMLElement(topTableRow);
				
	       
			// row of instructions and search button
			HTMLTableRow row = new HTMLTableRow();
			topTable.AddInnerHTMLElement(row);

			cell = new HTMLTableCell();
			row.AddInnerHTMLElement(cell);
			row.SetStyleClass(PTStyleClass.DIR_HEADER_BG); 
			cell.SetWidth("100%");
			HTMLTable innerTable= new HTMLTable();
			innerTable.SetWidth("100%"); 
			HTMLTableRow innerTableRow=new HTMLTableRow();
			innerTable.AddInnerHTMLElement(innerTableRow); 
			cell.AddInnerHTMLElement(innerTable);
			
			
			//cell.SetStyleClass(PTStyleClass.DIR_HEADER_BG); 
 
			cell = new HTMLTableCell();
			cell.SetStyleClass(PTStyleClass.DIR_HEADER); 
			innerTableRow.AddInnerHTMLElement(cell); 
			HTMLB bold = new HTMLB();
			cell.AddInnerHTMLElement(bold);
			bold.AddInnerHTMLString(m_asOwner.GetString(1355, "ptmsgs_portalbrowsingmsgs"));
		

			cell=new HTMLTableCell();
			innerTableRow.AddInnerHTMLElement(cell);
			cell.SetAlign("right");
			
			HTMLInput searchButton=new HTMLInput(HTMLInputTypes.SUBMIT,"in_su_b1","in_su_b1");
			cell.AddInnerHTMLElement(searchButton);
			cell.SetStyleClass(PTStyleClass.DIR_HEADER); 
			searchButton.SetValue(m_asOwner.GetString(1528, "ptmsgs_portalbrowsingmsgs")); 
			searchButton.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
			//			searchButton.SetOnClick("DoSearch();"); 

			cell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
			HTMLInput clearButton = new HTMLInput(HTMLInputTypes.BUTTON, "in_bu_clear", "in_bu_clear");
			cell.AddInnerHTMLElement(clearButton);
			cell.SetStyleClass(PTStyleClass.DIR_HEADER); 
			clearButton.SetValue(m_asOwner.GetString(1665, "ptmsgs_portalbrowsingmsgs")); 
			clearButton.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
			clearButton.SetOnClick("DoClearAll();"); 


			HTMLTableRow instructionsTableRow = new HTMLTableRow(); 
			HTMLTable spacerTable = new HTMLTable();
			spacerTable.SetWidth("100%"); 
			HTMLTableRow spacerRow = new HTMLTableRow();
			spacerTable.AddInnerHTMLElement(spacerRow);
			HTMLTableCell spacerCell = new HTMLTableCell();
			spacerRow.AddInnerHTMLElement(spacerCell);
			
			HTMLTable instructionsTable = new HTMLTable();
			instructionsTable.SetWidth("100%"); 
			spacerCell.AddInnerHTMLElement(instructionsTable);
			cell = new HTMLTableCell();
			cell.SetWidth("100%"); 
			//cell.AddInnerHTMLElement(instructionsTable); 
			instructionsTableRow.AddInnerHTMLElement(cell); 
			cell.AddInnerHTMLElement(spacerTable);
			overallTable.AddInnerHTMLElement(instructionsTableRow); 

			HTMLTableRow headerRow = new HTMLTableRow();
			instructionsTable.AddInnerHTMLElement(headerRow);

			cell = new HTMLTableCell();
			cell.SetStyleClass(PTStyleClass.DIR_CONTENT_BG);
			cell.SetWidth("100%");
			cell.SetColSpan("2");
			cell.SetNoWrap(true); 

			HTMLSpan span = new HTMLSpan();
			span.SetStyleClass(PTStyleClass.OBJECTSEARCH_TEXT);
			span.AddInnerHTMLString(m_asOwner.GetString(790,
								    "ptmsgs_portalbrowsingmsgs"));
			cell.AddInnerHTMLElement(span);
			headerRow.AddInnerHTMLElement(cell);
	
			cell.SetHeight("25"); 
			HTMLTableRow searchBoxRow = new HTMLTableRow();
			searchBoxRow.SetStyleClass(PTStyleClass.DIR_CONTENT_BG);
			instructionsTable.AddInnerHTMLElement(searchBoxRow);
			instructionsTable.SetStyleClass(PTStyleClass.DIR_CONTENT_BG);

			cell = new HTMLTableCell();
			cell.SetNoWrap(true);
			cell.SetHeight("25");
			cell.SetWidth("60%");
			span = new HTMLSpan();
			span.SetStyleClass(PTStyleClass.OBJECTSEARCH_HEADER);
			span.AddInnerHTMLString(m_asOwner.GetString(1356, "ptmsgs_portalbrowsingmsgs"));
			span.AddInnerHTMLString(CommonHTMLStrings.SPACE); 
			span.AddInnerHTMLString(CommonHTMLStrings.SPACE); 
			cell.AddInnerHTMLElement(span);

			searchBoxRow.AddInnerHTMLElement(cell);
			input = new HTMLInput(HTMLInputTypes.TEXT,
					NetworkSearchControl.SEARCHSTRING_DATA, "myID");
			input.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
			input.SetSize(50);
			//			input.SetOnKeyDown("IsCR;");
			cell.AddInnerHTMLElement(input);
			
			cell = new HTMLTableCell();
			cell.SetNoWrap(true);
			cell.SetHeight("25");
			cell.SetWidth("40%");
			span = new HTMLSpan();
			span.SetStyleClass(PTStyleClass.OBJECTSEARCH_HEADER);
			span.AddInnerHTMLString(m_asOwner.GetString(1686, "ptmsgs_portalbrowsingmsgs"));
			span.AddInnerHTMLString(CommonHTMLStrings.SPACE); 
			span.AddInnerHTMLString(CommonHTMLStrings.SPACE); 
			cell.AddInnerHTMLElement(span);
			searchBoxRow.AddInnerHTMLElement(cell);
			
			HTMLSelect s = new HTMLSelect(NetworkSearchControl.IN_SE_NUMRESULTS, NetworkSearchControl.IN_SE_NUMRESULTS);
			s.SetStyleClass(PTStyleClass.FORM_PULLDOWN_TEXT);
			cell.AddInnerHTMLElement(s);
					// Load number results from prefs.
			((NetworkSearchModel)m_asmModel).LoadNumberResults();
			
			int numResults = m_asmModel.GetNumberResults();
			
			HTMLOption option = new HTMLOption("5");
			option.AddInnerHTMLString("5");
			option.SetSelected((numResults == 5));
			s.AddInnerHTMLElement(option);
			option = new HTMLOption("10");
			option.AddInnerHTMLString("10");
			option.SetSelected((numResults == 10));
			s.AddInnerHTMLElement(option);
			option = new HTMLOption("15");
			option.AddInnerHTMLString("15");
			option.SetSelected((numResults == 15));
			s.AddInnerHTMLElement(option);
			option = new HTMLOption("25");
			option.AddInnerHTMLString("25");
			option.SetSelected((numResults == 25));
			s.AddInnerHTMLElement(option);
			option = new HTMLOption("50");
			option.AddInnerHTMLString("50");
			option.SetSelected((numResults == 50));
			s.AddInnerHTMLElement(option);

			HTMLTable choicesHeaderTable = new HTMLTable();
			//form1.AddInnerHTMLElement(choicesHeaderTable); 
			HTMLTableRow aTableRow = new HTMLTableRow();
			overallTable.AddInnerHTMLElement(aTableRow);
			HTMLTable aTable = new HTMLTable();
			aTable.SetWidth("100%");
			aTable.SetCellPadding("0");
			HTMLTableCell aTableCell = new HTMLTableCell();
			aTableRow.AddInnerHTMLElement(aTableCell); 
			aTableCell.AddInnerHTMLElement(aTable);
			aTableRow = new HTMLTableRow();
			aTable.AddInnerHTMLElement(aTableRow);
			aTableCell = new HTMLTableCell();
			aTableRow.AddInnerHTMLElement(aTableCell);
			aTableCell.AddInnerHTMLElement(choicesHeaderTable);
		 
			choicesHeaderTable.SetWidth("100%");
			choicesHeaderTable.SetCellSpacing("2");
			choicesHeaderTable.SetCellPadding("2");
			choicesHeaderTable.SetBorder("0");

			// title row ( "Search Locations" )
			row = new HTMLTableRow();
			choicesHeaderTable.AddInnerHTMLElement(row);
			cell = new HTMLTableCell();
			cell.SetColSpan("2"); 
			cell.SetHeight("25"); 
			row.AddInnerHTMLElement(cell);
			cell.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);
 
			span = new HTMLSpan();
			span.SetStyleClass(PTStyleClass.OBJECTSEARCH_HEADER);
			span.AddInnerHTMLString(m_asOwner.GetString(793,
					"ptmsgs_portalbrowsingmsgs"));

			cell.AddInnerHTMLElement(span);
			// "save locations" checkbox
			row=new HTMLTableRow();
			row.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_BG); 
			choicesHeaderTable.AddInnerHTMLElement(row); 
			cell=new HTMLTableCell();
			cell.SetHeight("25");
			cell.SetWidth("100%");
			cell.SetColSpan("2");
			cell.SetVAlign("center");
			cell.SetAlign("left");
			cell.SetNoWrap(true);
		
			row.AddInnerHTMLElement(cell); 
			HTMLInput prefsInput = 
			    new HTMLInput(HTMLInputTypes.CHECKBOX,
					  NetworkSearchControl.SAVELOCATIONS_DATA, "idsaveLocations");
			prefsInput.SetValue(XPConvert.ToString(true));
			cell.AddInnerHTMLElement(prefsInput);
			/*cell=new HTMLTableCell();
			cell.SetWidth(widthOfLocationCells); 
			cell.SetHeight("25");
			cell.SetStyleClass(PTStyleClass.ACTIONBAR_TEXT); 
			row.AddInnerHTMLElement(cell); 
			*/
			cell.AddInnerHTMLString("&nbsp;");
			cell.AddInnerHTMLString(m_asOwner.GetString(1354, "ptmsgs_portalbrowsingmsgs"));
			
			// add header row, with checkbox that checks 
			// everything
			row= new HTMLTableRow();
			choicesHeaderTable.AddInnerHTMLElement(row); // was choicesTable
			row.SetStyleClass(PTStyleClass.LIST_SORT_HEADER_BG);
			cell=new HTMLTableCell();
			cell.SetHeight("25");
			cell.SetWidth("25");
			cell.SetVAlign("center");
			cell.SetAlign("middle");

			row.AddInnerHTMLElement(cell);
			HTMLInput checkedAllInput = 
			    new HTMLInput(HTMLInputTypes.CHECKBOX,
					  // this input doesn't actually 
					  // achieve anything when the form
					  // gets submitted- it exists solely
					  // for the sake of checking and 
					  // unchecking all the others
					  // simultaneously
					  IN_CB_CHECKALL1, 
					  "checkall");
			cell.AddInnerHTMLElement(checkedAllInput); 
			checkedAllInput.SetValue("bar"); 
			checkedAllInput.SetOnClick("CheckRows1();");
			checkboxJSBuffer.SetLength(0);	// Clear out the js buffer.
			AppendCheckBoxConditional(checkboxJSBuffer, IN_CB_CHECKALL1, "bar", false);

			cell=new HTMLTableCell();
			cell.SetHeight("25");
			row.AddInnerHTMLElement(cell);
		      
			cell.SetWidth(widthOfLocationCells); 
			cell.SetStyleClass(PTStyleClass.LIST_SORT_HEADER);
			cell.AddInnerHTMLString("&nbsp;");
			cell.AddInnerHTMLString(m_asOwner.GetString(1529, "ptmsgs_portalbrowsingmsgs")); 	


			// add checkbox option for the portal itself
			row = new HTMLTableRow();
			row.SetStyleClass(PTStyleClass.LIST_ITEM_TWO_BG); 
			choicesHeaderTable.AddInnerHTMLElement(row); // was choicesTable
			cell = new HTMLTableCell();
			cell.SetHeight("25");
			cell.SetWidth("25");
			cell.SetVAlign("center");
			cell.SetAlign("middle");

			row.AddInnerHTMLElement(cell);
			// see if the user has stored any preferences for
			// which locations to search. If so, we'll 
			// automatically check those boxes
			XPHashtable preferredSourceHash =
			    m_asmModel.GetLocationPreferencesForUser(); 
			boolean prefsExist=(preferredSourceHash != null); 

			HTMLInput checkedInput = 
			    new HTMLInput(HTMLInputTypes.CHECKBOX,
					  NetworkSearchControl.SOURCE_DATA, 
					  "idneg1");
			checkedInput.SetValue(XPConvert.ToString(
					NetworkSearchModel.THISPORTAL_ID));
			boolean prefsValueUsed = false;
			if (prefsExist && 
			    preferredSourceHash.ContainsKey(new Integer(NetworkSearchModel.THISPORTAL_ID))) 
		   {
		   		prefsValueUsed = true;
			    checkedInput.SetChecked(true);
			    AppendCheckBoxConditional(checkboxJSBuffer, NetworkSearchControl.SOURCE_DATA, XPConvert.ToString(NetworkSearchModel.THISPORTAL_ID), true);
			}
			else
				AppendCheckBoxConditional(checkboxJSBuffer, NetworkSearchControl.SOURCE_DATA, XPConvert.ToString(NetworkSearchModel.THISPORTAL_ID), false);

			cell.SetStyleClass(PTStyleClass.LIST_TEXT); 
			cell.AddInnerHTMLElement(checkedInput);

			cell=new HTMLTableCell();
			row.AddInnerHTMLElement(cell);
			cell.SetHeight("25");
			cell.SetWidth(widthOfLocationCells); 
			cell.SetStyleClass(PTStyleClass.LIST_TEXT); 
			cell.AddInnerHTMLString("&nbsp;");
			cell.AddInnerHTMLString(m_asOwner.GetString(794,
					"ptmsgs_portalbrowsingmsgs"));

 		
			// list all the sources that the user can search-
			// user picks sources via checkboxes
			// disabled ones are not displayed
	
			for (int sourceIndex = 0; sourceIndex < m_asmModel.GetNumSources();
					sourceIndex++)
			{      
				int sourceId=m_asmModel.GetSourceID(sourceIndex); 
				if (!m_asmModel.IsDisabled(sourceId)) { 
			    
				    row = new HTMLTableRow();
	
				    if (sourceIndex%2==0) 
				    {
						row.SetStyleClass(PTStyleClass.LIST_ITEM_ONE_BG);
				    }
				    else 
				    {
						row.SetStyleClass(PTStyleClass.LIST_ITEM_TWO_BG); 
				    }
				    choicesHeaderTable.AddInnerHTMLElement(row); // was choicesTable
				    cell = new HTMLTableCell();
					cell.SetHeight("25");
					cell.SetWidth("25");
					cell.SetVAlign("center");
					cell.SetAlign("middle");

				    row.AddInnerHTMLElement(cell);
				   
				    
				    checkedInput = new HTMLInput(HTMLInputTypes.CHECKBOX,
								 NetworkSearchControl.SOURCE_DATA, 
								 "id" + sourceIndex);
			
				
				    if (prefsExist && preferredSourceHash.ContainsKey(new Integer(sourceId))) 
					{
						checkedInput.SetChecked(true);
						prefsValueUsed = true;
						AppendCheckBoxConditional(checkboxJSBuffer, NetworkSearchControl.SOURCE_DATA, XPConvert.ToString(sourceId), true);
				    }
				    else
						AppendCheckBoxConditional(checkboxJSBuffer, NetworkSearchControl.SOURCE_DATA, XPConvert.ToString(sourceId), false);
				    
				    checkedInput.SetValue(XPConvert.ToString(sourceId));
				    cell.AddInnerHTMLElement(checkedInput);
			
 
				    cell=new HTMLTableCell();
				    row.AddInnerHTMLElement(cell);
					cell.SetHeight("25");
				    cell.SetWidth(widthOfLocationCells); 
				    cell.SetStyleClass(PTStyleClass.LIST_TEXT);
					cell.AddInnerHTMLString("&nbsp;");
				    cell.AddInnerHTMLString(m_asmModel.GetSourceName(sourceId));
				}
			}
			if(prefsValueUsed)
			{
				prefsInput.SetChecked(true);
				AppendCheckBoxConditional(checkboxJSBuffer, NetworkSearchControl.SAVELOCATIONS_DATA, "true", true);
			}
			else
				AppendCheckBoxConditional(checkboxJSBuffer, NetworkSearchControl.SAVELOCATIONS_DATA, "true", false);
			
			// empty row to separate "save locations" checkbox
			// from other checkboxes
			row = new HTMLTableRow();
			choicesHeaderTable.AddInnerHTMLElement(row); // was choicesTable
			cell = new HTMLTableCell();
			cell.AddInnerHTMLElement(new HTMLBr()); 
			row.AddInnerHTMLElement(cell);
 
			return result;
		}
		catch (Exception e)
		{
			return new HTMLGenericElement(e.getMessage());
		}
	}
 
	/**
	 * This method returns the HTMLScript that encompasses the Javascript on the page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 *
	 * @return HTMLScript
	 */
	public HTMLScript DisplayJavascript()
	{
		try
		{
			XPStringBuilder sb = new XPStringBuilder("");

			sb.Append("\n function DoSearch() {\n");
			sb.Append("\n");
			sb.Append("    var inputBoxValue = document.forms['networksearch'].in_tx_query.value;\n");
			// If I have time, I'll figure out how to use this
			// utility
			//	sb.Append("    if (PTStringUtil.isAllWhitespace(inputBoxValue))\n"); 
   
			sb.Append("     if (inputBoxValue=='')\n"); 
            sb.Append("      {\n"); 
			sb.Append("      alert('");
			sb.Append(m_asOwner.GetString(1357, "ptmsgs_portalbrowsingmsgs"));
			sb.Append("');\n"); 
            sb.Append("        return false;\n");
            sb.Append("}\n"); 
			sb.Append("\n"); 
			sb.Append("var checkboxes = document.forms['networksearch']." + NetworkSearchControl.SOURCE_DATA + ";\n");
		
			sb.Append(" if (checkboxes.checked) {\n"); 
            sb.Append("  return true;\n");
			sb.Append(" }\n"); 
            sb.Append("else\n"); 
            sb.Append("{\n"); 
			sb.Append(" for (var i = 0; i < checkboxes.length; i++)\n"); 
            sb.Append(" {\n");
            sb.Append("   if (checkboxes[i].checked) {\n");
			sb.Append("        return true;\n");
		    sb.Append("    }\n"); 
		    sb.Append("  }\n"); 
		    sb.Append(" }\n"); 
			sb.Append("      alert('");
			sb.Append(m_asOwner.GetString(1862, "ptmsgs_portalbrowsingmsgs"));
			sb.Append("');\n");  
            sb.Append(" return false;\n"); 
            sb.Append("}\n"); 
 
			sb.Append("function CheckRows1()\n");
			sb.Append("{\n"); 
			sb.Append("   var frm = document.networksearch;\n");
			sb.Append("   var len = frm.elements.length;\n");  
			sb.Append("   var nValue = frm." + IN_CB_CHECKALL1 + ".checked;\n");  
			sb.Append("   var i = 0;\n");  
			sb.Append("\n"); 
			sb.Append("   for(i=0 ; i<len ; i++)\n"); 
			sb.Append("   {\n");  
			sb.Append("       if (frm.elements[i].name == '");
			sb.Append(NetworkSearchControl.SOURCE_DATA);
			sb.Append("')\n"); 
			sb.Append("         {\n");  
			sb.Append("           frm.elements[i].checked = nValue;\n"); 
			sb.Append("         }\n");  
			sb.Append("   }\n");  
			sb.Append("}\n"); 
			
		
			sb.Append("function DoClearAll()\n");
			sb.Append("{\n"); 
			sb.Append("   var frm = document.networksearch;\n");
			sb.Append("   var len = frm.elements.length;\n");  
			sb.Append("   var i = 0;\n");  
			sb.Append("\n"); 
			sb.Append("   for(i=0 ; i<len ; i++)\n"); 
			sb.Append("   {\n"); 
			sb.Append("    if (frm.elements[i].name == '" + NetworkSearchControl.SEARCHSTRING_DATA + "') {\n");
			sb.Append("        frm.elements[i].value = '';\n");
			sb.Append("    }\n");
			sb.Append(checkboxJSBuffer.ToString());
			sb.Append("   }\n");  
			sb.Append("}\n"); 
			
			HTMLScript script = new HTMLScript("text/javaScript");
			script.AddInnerHTMLString(sb.ToString());

			return script;
		}
		catch (Exception e)
		    {
			throw XPException.GetInstance(e);
		    }
	}
    /*
     * For the DoClearAll() javascript function. This appends an if statement to the loop that sets or clears
     * the checked flag of a particular checkbox.
     */
	protected void AppendCheckBoxConditional(XPStringBuilder builder, String CheckboxName, String CheckboxValue, boolean onoff)
	{
		builder.Append("    if (frm.elements[i].name == '" + CheckboxName + "' && \n");
		builder.Append("    		frm.elements[i].value == '" + CheckboxValue + "') {\n");
		builder.Append("        frm.elements[i].checked = "  + XPConvert.ToString(onoff) + ";\n");
		builder.Append("     }\n");
	}
	
	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IView#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_asmModel     = (INetworkSearchModelRO) model;
		m_asOwner	   = parent;
	}
}

