package com.plumtree.portalpages.browsing.search.results;

import com.plumtree.portaluiinfrastructure.search.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author CraigS
 *
 *  This is a simplified alternative to OrganizationView.  It doesn't make much
 *  sense to have them on the same page.  We use OrganizationView on the standard
 *  page and DrilldownView on the 508/low-bandwidth page.
 */
public class DrilldownView extends SearchResultView
{
  public static final String STR_MVC_CLASS_NAME = "DrilldownView";

  /**
   * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
   */
  public Object Create()
  {
    return new DrilldownView();
  }

  /**
   * @see com.plumtree.portaluiinfrastructure.activityspace.IView#GetName()
   */
  public String GetName()
  {
    return STR_MVC_CLASS_NAME;
  }

  /**
   * @see com.plumtree.portalpages.search.SearchResultView#DisplaySearchView()
   */
  public HTMLElement DisplaySearchView()
  {
    return ReorganizationViewHelper.DisplaySimpleDrilldownView(_model, m_asOwner);
  }
}
