package com.plumtree.portalpages.browsing.search.results;

import com.plumtree.portaluiinfrastructure.search.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author CraigS
 *
 */
public class OrganizationView extends SearchResultView
{
  public static final String STR_MVC_CLASS_NAME = "OrganizationView";
  public static final String REORGANIZATION_FORM_NAME = "ReorganizeResults";
  

  /**
   * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
   */
  public Object Create()
  {
    return new OrganizationView();
  }

  /**
   * @see com.plumtree.portalpages.search.SearchResultView#DisplaySearchView()
   */
  public HTMLElement DisplaySearchView()

  {
    return ReorganizationViewHelper.DisplayReorganization(_model, m_asOwner);
  }

  /**
   * @see com.plumtree.portaluiinfrastructure.activityspace.IView#GetName()
   */
  public String GetName()
  {
    return STR_MVC_CLASS_NAME;
  }

  public void addTargetsToOrganizationForm(HTMLForm form)
  {
	  addTargetsToOrganizationForm(form, true);
  }
  
  public void addTargetsToOrganizationForm(HTMLForm form, boolean addScript)
  {
    form.SetAction(ConfigHelper.GetApplicationBaseURLToAS(m_asOwner.GetCurrentNormalizedBaseURL(), 
		m_asOwner.GetName(), m_asOwner.IsSubSpace()));

    // Set target as the same space
    HTMLInput targetSpace = new HTMLInput(HTMLInputTypes.HIDDEN,
        ASConstants.SPACENAME_INPUT, ASConstants.SPACENAME_INPUT, "");
    targetSpace.SetValue(m_asOwner.GetName());
    form.AddInnerHTMLElement(targetSpace);

    // Add our current space ID, so the framework doesn't create
    // another instance of the space
    HTMLInput targetSpID = new HTMLInput(HTMLInputTypes.HIDDEN,
        ASConstants.SPACEID_INPUT, ASConstants.SPACEID_INPUT, "");
    targetSpID.SetValue(m_asOwner.GetSpaceID());
    form.AddInnerHTMLElement(targetSpID);

    // Set target as ReorganizationControl
    HTMLInput targetControl = new HTMLInput(HTMLInputTypes.HIDDEN,
        ASConstants.CONTROL_INPUT, ASConstants.CONTROL_INPUT, "");
    targetControl.SetValue(ReorganizationControl.STR_MVC_CLASS_NAME);
    form.AddInnerHTMLElement(targetControl);
	
    // Add a hidden input for the current search depth
    HTMLInput depth = new HTMLInput(HTMLInputTypes.HIDDEN,
        SearchResultControl.KEY_DATA, SearchResultControl.KEY_DATA, "");
    depth.SetValue(_model.GetCurrentKey());
    form.AddInnerHTMLElement(depth);

    if (!is508() && addScript)
    {
    	HTMLScript script = GetOrganizationFormScripts(form.GetName());
    	form.AddInnerHTMLElement(script);
    }
  }
  
  public HTMLScript GetOrganizationFormScripts(String formName) {
	  HTMLScript script = new HTMLScript("text/javaScript");
      script.AddInnerHTMLString(
        "function " + ReorganizationViewHelper.JAVASCRIPT_RESORT +
        "() { var searchForm = document." + formName + ";\n" +
		"searchForm.submit(); }");
      return script;
  }
}

