package com.plumtree.portalpages.browsing.search.results;

import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author CraigS
 */
public class SaveSearch508DP extends AFormDP
{
	public static final String STR_MVC_CLASS_NAME = "SaveSearch508DP";

	/**
	 * @return name of this page
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 *  NOTE: Display the whole page outside the mainform, since SaveSearchView
	 *  defines a form of its own.  (I don't want to force it to use a repost
	 *  control; it would be awkward to try to meld reposts with the search controls.
	 */
	public HTMLElementCollection DisplayHTMLBeforeForm()

	{
		HTMLElementCollection c = new HTMLElementCollection();
		c.AddInnerHTMLElement(m_asOwner.GetView(SaveSearch508View.STR_MVC_CLASS_NAME).Display());

		return c;
	}


	public String GetFormTitle()
	{
		return m_asOwner.GetString(835, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * @return HTML for the page
	 * @throws HTMLException 
	 */
	public HTMLElement PageDisplay()
	{
		// Just return something to keep the framework happy.
		return new HTMLBr();
	}
	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormPageType()
	 */
	public FormPageTypes GetFormPageType()
	{
		return FormPageTypes.NO_BUTTONS;
	}
}
