package com.plumtree.portalpages.browsing.search.results;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.search.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author MatthewF
 *
 *  Control for switching between Edit and Browse modes.
 */
public class SearchBrowseEditModeControl implements IControl
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.search.results.SearchBrowseEditModeControl");

	public static final String STR_MVC_CLASS_NAME = "BrowseEditMode";
	
	public static final String EDIT_MODE_INPUT = "in_hi_browse_edit";
	
	public static final String EDIT_VALUE = "edit";

	public static final String BROWSE_VALUE = "browse";
	
	protected AActivitySpace _parent;

	protected ISearchResultModel _model;

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IControl#Execute()
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable args)
	{
		Redirect r = null;

		// Figure out where we were (i.e. the value of the key)
		// when the model was generated
		String[] values = (String[]) args.GetElement(EDIT_MODE_INPUT);
		String modekey;
		if (values != null)
		{
			modekey = values[0];
			if (EDIT_VALUE.equals(modekey))
			{
			    _model.SetPageMode(SearchPageModeHelper.EDIT_MODE);
			}
			else
			{
			    _model.SetPageMode(SearchPageModeHelper.BROWSE_MODE);
			}
		}
		return r;
	}

	/**
	  * This method is used by the ASManager to return new instances of managed
	  * objects.
	  *
	  * @return A new instance of the managed class (i.e. return new Foo();)
	  */
	public Object Create()
	{
		return new SearchBrowseEditModeControl();
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IControl#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IControl#Init(IModel, AActivitySpace)
	 */
	public void Init(IModel model, AActivitySpace space)
	{
		_model	    = (ISearchResultModel) model;
		_parent     = space;
	}
}

