package com.plumtree.portalpages.browsing.search.results;

import com.plumtree.portaluiinfrastructure.search.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author CraigS
 */
public class SearchFooterView extends SearchResultView
{
	
	public static final String STR_MVC_CLASS_NAME = "SearchFooterView";

	/**
	 * 
	 *
	 * @return 
	 */
	public Object Create()
	{
		return new SearchFooterView();
	}

	/**
	 * @see com.plumtree.portalpages.search.SearchResultView#DisplaySearchView()
	 */
	public HTMLElement DisplaySearchView()

	{
		// If few results were returned, don't display anything.
		if (_model.GetTotalItems() <= _model.GetItemsPerPage())
		{
			return null;
		}

                // For the standard portal:
		// Only display global pagination if there is a single group;
		// it's confusing to see both drilldown links and pagination
                // For 508: always show pagination, since the results are never shown
                // in grouping style.
		if ((! is508()) && (_model.GetNumResultGroups() > 1))
		{
			return null;
		}

		HTMLTable table = new HTMLTable();

		table.SetCellSpacing("0");
		table.SetCellPadding("3");
		table.SetWidth("100%");

		HTMLTableRow row = new HTMLTableRow();
		table.AddInnerHTMLElement(row);

		HTMLTableCell cell = new HTMLTableCell();
		row.AddInnerHTMLElement(cell);
                if (is508()) {
                  row.SetStyleClass(PTStyleClass.LIST_ITEM_TWO_BG);
                  cell.SetAlign("left");
                  cell.SetStyleClass(PTStyleClass.LIST_TEXT);

                  cell.AddInnerHTMLElement(PaginationView.Display508StylePagination(_model, m_asOwner));
                } else {
                  row.SetStyleClass(PTStyleClass.OBJECT_CONTENT_BG);
                  cell.SetHeight("25");
                  cell.SetVAlign("middle");
                  cell.SetAlign("right");
                  cell.SetStyleClass(PTStyleClass.OBJECTSEARCH_TEXT);

                  cell.AddInnerHTMLElement(PaginationView.DisplayPagination(_model, m_asOwner));
                }

		return table;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}

