package com.plumtree.portalpages.browsing.search.results.assocobjects;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 *  @author CraigS
 */
public class AssociatedObjectsControl implements IControl
{
  public static final String STR_MVC_CLASS_NAME = "SRAssociatedObjects";

  public String GetName()
  {
    return STR_MVC_CLASS_NAME;
  }

  public Object Create()
  {
    return new AssociatedObjectsControl();
  }

  private AssociatedObjectsModel _model = null;
  private AActivitySpace m_asOwner = null;

  public void Init(IModel model, AActivitySpace owner)
  {
    _model = (AssociatedObjectsModel) model;
    m_asOwner = owner;
  }

  public static final String PORTLET_LIST_ARGNAME = "portletId";
  public static final String ITEM_NAME_ARGNAME = "itemName";

  public Redirect CheckActionSecurityAndExecute(XPHashtable args)
  {
    // Extract the list of associated portlets
    String[] values = (String[]) args.GetElement(PORTLET_LIST_ARGNAME);
    if ((null != values) && (values.length > 0)) {

      int[] portlets = new int[values.length];

      for (int j = 0; j < values.length; j++) {
        try {
          portlets[j] = XPConvert.ToInteger(values[j]);
        } catch (Exception e) {
          portlets[j] = 0;
        }
      }

      _model.SetPortletList(portlets);
    }

    // .. and the item name
    values = (String[]) args.GetElement(ITEM_NAME_ARGNAME);
    if ((null != values) && (values.length > 0)) {
      _model.SetItemName(values[0]);
    }

    // .. and display the page
    return null;
  }
}
