package com.plumtree.portalpages.browsing.sessionprefs;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.OpenLogService;
import com.plumtree.openlog.OpenLogger;
import com.plumtree.portaluiinfrastructure.statichelpers.PTDebugHelpers;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * 
 *
 * @author $author$
 */
public class SessionPrefsControl implements IControl
{
	
	private static OpenLogger log = OpenLogService.GetLogger(
			OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
			"com.plumtree.portalpages.browsing.sessionprefs.SessionPrefsControl");
	
	public static final String STR_MVC_CLASS_NAME = "SessionPrefs";
	private static final String strAction = "action";
	private static final String strSetPrefs = "setprefs";
	private static final String strGetPrefs = "getprefs";
	private static final String strTrue = "true";


	private AActivitySpace m_asasParent;
	private ISessionPrefsModel m_asmModel;

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IControl#Execute()
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		String[] arrAction = (String[]) arguments.GetElement(strAction);
		if (null != arrAction && arrAction.length == 1 && arrAction[0] != null)
		{
			if (arrAction[0].compareToIgnoreCase(strSetPrefs) == 0)
			{
				m_asmModel.SetSessionPrefs(arguments);
			}
			else if (arrAction[0].compareToIgnoreCase(strGetPrefs) == 0)
			{
				m_asmModel.GetSessionPrefs(arguments);
			}
		}
		return null;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SessionPrefsControl();
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IControl#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IControl#Init(IModel, AActivitySpace)
	 */
	public void Init(IModel model, AActivitySpace space)
	{
		m_asmModel		 = (ISessionPrefsModel) model;
		m_asasParent     = space;
	}
}

