package com.plumtree.portalpages.browsing.sitemap.editweblink;

import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * File: EditWebLinkDP.java
 * ------------------------
 *
 * @author NaveenP
 */
public class EditWebLinkDP extends AFormDP
{
	
	public static final String STR_MVC_CLASS_NAME = "EditWebLink";

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormPageType()
	 */
	public FormPageTypes GetFormPageType()
	{
		// default implementation
		return FormPageTypes.NORMAL_PAGE;
	}

	/**
	  * This is a helper method that all classes that inherit from AFormDP and
	  * want to have the Done and Cancel buttons displayed in the header for
	  * them need to implement.  The method should return the title add whatever
	  * HTML the child class wants to display to the body argument.  The parent
	  * class will then add that HTML to the HTMLPage after filling in the
	  * banner and navigation.
	  *Override this method to set the form title
	  *
	  * @return String the title for the form header (if used)
	  */
	public String GetFormTitle()
	{
		return m_asOwner.GetString(876, "ptmsgs_portalbrowsingmsgs");
	}

	
	/**
	 * @see com.plumtree.xpshared.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * helper display method for PlumtreeDP
	 *
	 * Fill in the body argument with HTML to display in the page.
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		result.AddInnerHTMLElement(m_asOwner.GetView(
				EditWebLinkView.STR_MVC_CLASS_NAME).Display());

		return result;
	}

	/**
	 *
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#DisplayJavaScriptFromChild()
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection scripts = new HTMLScriptCollection();

		scripts.AddInnerHTMLElement(m_asOwner.GetView(
				EditWebLinkView.STR_MVC_CLASS_NAME).DisplayJavascript());

		return scripts;
	}
}

