package com.plumtree.portalpages.browsing.sitemap.editweblink;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * File: EditWebLinkView.java
 * --------------------------
 *
 *
 * @author NaveenP
 */
public class EditWebLinkView implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.sitemap.editweblink.EditWebLinkView");

	
	public static final String STR_MVC_CLASS_NAME = "EditWebLink";

	// Logger

	// HTML Object names.
	public static final String HTMLINPUT_LINKNAME = "in_tx_LinkName";

	
	public static final String HTMLINPUT_LINKDESC = "in_tx_LinkDesc";

	
	public static final String HTMLINPUT_LINKURL = "in_tx_LinkURL";

	
	public static final String HTMLBUTTON_REPOST = "in_bu_add";

	
	public static final String VALIDATION_FUNCTION_NAME = "IsValidWebLink";
	protected AActivitySpace m_asOwner;

	// Client-specific variables
	protected EditWebLinkModel m_asModel;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new EditWebLinkView();
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IView#display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		HTMLTable myTable    = null;
		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLInput myInput;
		HTMLSpan mySpan;
		HTMLB myBold;

		try
		{
			HTMLComment myComment = new HTMLComment( "Begin: Display EditWebLinkView");
			result.AddInnerHTMLElement(myComment);

			myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
			myTable.SetBorder(CommonHTMLStrings.ZERO);
			myTable.SetCellPadding("5");
			myTable.SetCellSpacing(CommonHTMLStrings.ZERO);

			// 1st Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			//myRow.SetStyleClass(PTStyleClass.OBJECT_ACTIONBAR_BG);
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myBold = new HTMLB();

			myBold.AddInnerHTMLString(m_asOwner.GetString(878,
					"ptmsgs_portalbrowsingmsgs"));
			mySpan.AddInnerHTMLElement(myBold);

			// 2nd Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);

			myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_LINKNAME, "");
			myCell.AddInnerHTMLElement(myInput);
			myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
			myInput.SetValue(m_asModel.GetOriginalName());

			myInput.SetMaxLength(63);
			myInput.SetSize(35);

			// 1st Row end
			// Desc Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myBold = new HTMLB();

			myBold.AddInnerHTMLString(m_asOwner.GetString(879,
					"ptmsgs_portalbrowsingmsgs"));
			mySpan.AddInnerHTMLElement(myBold);

			// 2nd Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);

			myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_LINKDESC, "");
			myCell.AddInnerHTMLElement(myInput);
			myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
			myInput.SetValue(m_asModel.GetOriginalDescription());

			myInput.SetMaxLength(255);
			myInput.SetSize(35);

			// Desc Row end
			// 3rd Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myBold = new HTMLB();

			myBold.AddInnerHTMLString(m_asOwner.GetString(880,
					"ptmsgs_portalbrowsingmsgs"));
			mySpan.AddInnerHTMLElement(myBold);

			// 4th Row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetNoWrap(true);

			myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_LINKURL, "");
			myCell.AddInnerHTMLElement(myInput);
			myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
			myInput.SetValue(m_asModel.GetOriginalURL());
			myInput.SetMaxLength(255);
			myInput.SetSize(50);

			// ***<input text>*** ends here
			// 2nd Row end
			myComment = new HTMLComment( "End: Display EditWebLinkView");
			result.AddInnerHTMLElement(myComment);
		}
		catch (Exception e)
		{
			log.Error(e, e.getMessage());
		}

		return result;
	}

	/**
	 * This method returns the HTMLScript that encompasses the Javascript on the page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 *
	 * @return HTMLScript
	 */
	public HTMLScript DisplayJavascript()
	{
		HTMLScript script  = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
		XPStringBuilder sb = new XPStringBuilder(300);

		String strJSUtilVersionPrefix = ConfigHelper.GetJSIncluderVersionPrefix(ConfigHelper.JSCOMPONENT_JSUTIL);
		
		try
		{
			sb.Append("\n" + "function " + VALIDATION_FUNCTION_NAME + "()\n");
			sb.Append("{\n");
			sb.Append(" 	if ( "+strJSUtilVersionPrefix+"PTStringUtil.isAllWhitespace(document." +
				EditWebLinkDP.HTMLFORM_NAME + ".in_tx_LinkName.value) )\n");
			sb.Append("		{\n");

			sb.Append(" 		alert('" +
				m_asOwner.GetString(885, "ptmsgs_portalbrowsingmsgs") +
				"');\n");
			sb.Append(" 		return false;\n");
			sb.Append("		}\n");
			//sb.Append(" 	if ( PTStringUtil.isAllWhitespace(document." +
			//	EditWebLinkDP.HTMLFORM_NAME + ".in_tx_LinkDesc.value) )\n");
			//sb.Append("		{\n");

			//sb.Append(" 		alert('" +
			//	m_asOwner.GetString(886, "ptmsgs_portalbrowsingmsgs") +
			//	"');\n");
			//sb.Append(" 		return false;\n");
			//sb.Append("		}\n");
			sb.Append(" 	if ( !"+strJSUtilVersionPrefix+"PTStringUtil.isValidHTTPString(document." +
				EditWebLinkDP.HTMLFORM_NAME + ".in_tx_LinkURL.value) )\n");
			sb.Append("		{\n");

			sb.Append(" 		alert('" +
				m_asOwner.GetString(887, "ptmsgs_portalbrowsingmsgs") +
				"');\n");
			sb.Append(" 		return false;\n");
			sb.Append("		}\n");
			sb.Append(" 	return true;\n");
			sb.Append("}\n\n");

			script.AddInnerHTMLString(sb.ToString());
		}
		catch (HTMLException he)
		{
			log.Error(he, he.getMessage());
		}

		return script;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IView#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IView#Init(IModel, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_asModel     = (EditWebLinkModel) model;
		m_asOwner     = parent;
	}
}

