package com.plumtree.portalpages.browsing.sitemap.sitemappage;

import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * File: DisplayInPortletDP.java
 * --------------------------------
 *
 * @author NaveenP
 */
public class DisplayInPortletDP extends AFormDP
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.sitemap.sitemappage.DisplayInPortletDP");

	
	public static final String STR_MVC_CLASS_NAME = "DisplayInPortlet";

	/** Model */
	private SiteMapModel m_asModel;

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormPageType()
	 */
	public FormPageTypes GetFormPageType()
	{
		return FormPageTypes.NORMAL_PAGE;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetFormTitle()
	{
		return m_asOwner.GetString(929, "ptmsgs_portalbrowsingmsgs");
	}

	
	/**
	 * @see com.plumtree.xpshared.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 *
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()
	{
		m_asModel = (SiteMapModel) m_asOwner.GetModel(SiteMapModel.STR_MVC_CLASS_NAME);

		HTMLElementCollection result = new HTMLElementCollection();

		try
		{
			result.AddInnerHTMLElement(m_asOwner.GetView(
					DisplayInPortletView.STR_MVC_CLASS_NAME).Display());
		}
		catch (HTMLException he)
		{
			log.Error(he, "Error in DisplayInPortletDP::Display.");
		}

		return result;
	}

	/**
	 *
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#DisplayJavaScriptFromChild()
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection scripts = new HTMLScriptCollection();

		scripts.AddInnerHTMLElement(m_asOwner.GetView(
				DisplayInPortletView.STR_MVC_CLASS_NAME).DisplayJavascript());

		return scripts;
	}

	/**
	 * This method is provided so that the repost control name can be overridden
	 * on a per DP basis.
	 *
	 * @return String the name of the repost control to use
	 */
	protected String GetRepostControlName()
	{
		return DisplayInPortletControl.STR_MVC_CLASS_NAME;
	}
}

