package com.plumtree.portalpages.browsing.sitemap.sitemappage;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.mediator.*;
import com.plumtree.portalpages.common.objects.*;
import com.plumtree.portaluiinfrastructure.compoundlist.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.htmlconstructs.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * File: SiteMapLinkViewHelper.java
 *
 * @author NaveenP
 */
public class MembersViewHelper implements IObjectViewHelper
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.sitemap.sitemappage.MembersViewHelper");

	/**
	 * @see com.plumtree.portalpages.common.objects.IObjectViewHelper#AddObjectViewHTML()
	 */
	public HTMLElement AddObjectViewHTML(IObjectModelRO model)
	{
		return null;
	}

	/**
	 * @see com.plumtree.portalpages.common.objects.IObjectViewHelper#Display508Object(int, HTMLTable, IObjectModelRO, AActivitySpace)
	 */
	public void Display508Object(int nObjectIndex, HTMLTable tableObjects,
		IObjectModelRO model, AActivitySpace parent)
	{
		DisplayObject(nObjectIndex, 0, tableObjects, model, parent);
	}

	/**
	 * @see com.plumtree.portalpages.common.objects.IObjectViewHelper#DisplayJavascriptCollection(AActivitySpace)
	 */
	public HTMLScriptCollection DisplayJavascriptCollection(
		AActivitySpace asOwner, IObjectModelRO model)
	{
		return null;
	}

	/**
	 * @see com.plumtree.portalpages.common.objects.
	 * IObjectViewHelper#GetThereAreNoItemsString(AActivitySpace)
	 */
	public String GetThereAreNoItemsString(AActivitySpace asOwner)
	{
		return asOwner.GetString(1557, "ptmsgs_portalbrowsingmsgs");
	}
	/**
	 * @see com.plumtree.portalpages.common.objects.IObjectViewHelper#DisplayObject(int,
	 *      HTMLTable, IObjectModelRO)
	 */
	public void DisplayObject(int nObjectIndex, int nRowIndex, HTMLTable tableObjects,
		IObjectModelRO model, AActivitySpace asOwner)
	{
		HTMLTableRow row = null;

		Object iObjectID = model.GetObjectFields(nObjectIndex,
				PT_PROPIDS.PT_PROPID_OBJECTID);

		if (iObjectID == null)
		{
			iObjectID = new Integer(0);
		}

		String strLinkName = (String) model.GetObjectFields(nObjectIndex,
				PT_PROPIDS.PT_PROPID_NAME);

		if (strLinkName == null)
		{
			strLinkName = asOwner.GetString(953, "ptmsgs_portalbrowsingmsgs");
		}

		// bjf -- use the ASCompoundList to get the URL to the user.  This code is meant
		// to process an entire list of links, but we can only process one item here, so the
		// code is a little complicated, but allows us to reuse the URL generation code.
		ASCompoundList cpList = new ASCompoundList();
		cpList.AddUserProfileURL(strLinkName, XPConvert.ToInteger(iObjectID));

		ICPListEntryIterator iterator = cpList;
		CListURLMediator mediator     = new CListURLMediator(asOwner, iterator);
		mediator.SetLabelMaxLength(PT_SERVERCONSTANTS.PT_MAX_NAMELENGTH);
		mediator.Next();

		HTMLAnchor myAnchor = (HTMLAnchor) mediator.GetEntry();

		if (XPConvert.ToInteger(iObjectID) == 0)
		{
			myAnchor = new HTMLAnchor(asOwner.GetString(953,
						"ptmsgs_portalbrowsingmsgs"));
			myAnchor.SetHRef("#");
		}
		else
		{
			myAnchor = (HTMLAnchor) mediator.GetEntry();
		}
		
		try
		{
			// use list item construct
			UIListItem itemConstruct = new UIListItem(myAnchor, asOwner );

			itemConstruct.SetItemTypeImage(PTImageType.ICON_MEMBER,
				asOwner.GetString(1629, "ptmsgs_portalbrowsingmsgs"));
			
			row = new HTMLTableRow();

			if (0 == (nRowIndex % 2))
			{
				row.SetStyleClass(PTStyleClass.LIST_ITEM_TWO_BG);
			}
			else
			{
				row.SetStyleClass(PTStyleClass.LIST_ITEM_ONE_BG);
			}

			itemConstruct.AddItemCellsToRow(row);
			tableObjects.AddInnerHTMLElement(row);
		}
		catch (HTMLException he)
		{
			log.Error(he, he.getMessage());
		}
	}

	
	/**
	 * @see com.plumtree.portalpages.common.objects.IObjectViewHelper#SetExpandButton(HTMLAnchor, IObjectModelRO)
	 */
	public void SetExpandAnchor(HTMLAnchor anchor, IObjectModelRO model)
	{
	}
}

