package com.plumtree.portalpages.browsing.sitemap.sitemappage;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.editors.sitemap.*;
import com.plumtree.portalpages.browsing.editors.sitemap.sitemapfolderplugin.*;
import com.plumtree.portalpages.common.createfolder.*;
import com.plumtree.portaluiinfrastructure.editor.commonpages.localizednames.*;
import com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.portaluiinfrastructure.tree.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.constants.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.uiinfrastructure.htmlconstructs.*;
import com.plumtree.uiinfrastructure.tree.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * File SiteMapBannerView.java
 * ---------------------------
 *
 * @author NaveenP
 */
public class SiteMapBannerView implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.sitemap.sitemappage.SiteMapBannerView");


	public static final String STR_MVC_CLASS_NAME = "SiteMapBanner";

	/** Localized String: Go Up */



	/** Localized String: Create Folder*/



	/** Localized String: Submit */



	/** Localized String: Delete */



	/** Localized String: Delete Link */



	/** Localized String: Edit */



	/** Localized String: Browse */



	/** Localized String: Edit Folder */



	/** Localized String: Move */



	/** Localized String: Community Knowledge Directory */



	/** Localized String: Select a folder */



	/** Localized String: You must check folders and/or links to do this action. */



	/** Localized String: You must check exactly one folder to do this action. */



	/** Localized String: You must open a folder aside from Members or Subcommunities to submit links.*/


	/** Javascript function names - do not need to localize **/
	private static final String JAVASCRIPT_SERVER_IPTTREE = "openServerIPTTree";

	/** Javascript function names - do not need to localize **/
	public static final String SERVER_SUBMIT = "PostFolderTree";

	/** Javascript keys - do not need to localize **/
	public static final String SITEMAPFOLDERTREE = "SiteMapFolderTree";
	protected AActivitySpace m_asOwner;

	// Logger
	// Client-specific variables
	protected ISiteMapModelRO m_asModel;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SiteMapBannerView();
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IView#display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		ASURL asurl;
		HTMLAnchor anchor;
		ElementName elementName;

		try
		{
			// Hidden input for the Space ID for the tree.  That way if you hit the IPT
			// tree link twice, it will open the same tree both times.
			HTMLInput myInput = new HTMLInput(HTMLInputTypes.HIDDEN,
					"in_hi_IPTServerSpaceID", "");
			result.AddInnerHTMLElement(myInput);
			myInput.SetValue("");

			PTConstruct myConstruct = UIConstructFactory.GetConstruct(PTBannerType.FOLDER,
					true, this.m_asOwner);

			ElementName eNameBanner = PTBannerType.FOLDER.GetElementName(PTBannerType.ELEMENT_NAME_ID_TITLE);
			myConstruct.ReplaceNestedElementsWithHTMLEncodedString(eNameBanner,
				XPResourceManager.FormatMessage(m_asOwner.GetString(181,
					"ptmsgs_portalbrowsingmsgs"), "\"" + m_asModel.GetCurrentFolderName() +
					"\" "));

			//	Get a button construct
			PTConstruct myButtonConstruct;

			if (m_asModel.IsEditMode() && !m_asModel.InRootFolder())
			{
				//DisplayInPortlet
				ASURL displayInPorletURL = new ASURL(m_asOwner);
				displayInPorletURL.SetLinkCreateNewSpace(SiteMapAS.STR_MVC_CLASS_NAME,
					m_asOwner);
				displayInPorletURL.SetDisplayPage(DisplayInPortletDP.STR_MVC_CLASS_NAME);
				displayInPorletURL.SetControl(DisplayInPortletControl.STR_MVC_CLASS_NAME);
				displayInPorletURL.AddControlArgument(DisplayInPortletControl.QS_PAGEISLOADING,
					1);
				displayInPorletURL.AddControlArgument(DisplayInPortletControl.QS_COMMUNITYID,
					m_asModel.GetCommunityID());
				displayInPorletURL.AddControlArgument(DisplayInPortletControl.QS_FOLDERID,
					m_asModel.GetCurrentFolderID());

				myButtonConstruct     = UIConstructFactory.GetConstruct(PTButtonType.CONTENT_SNAPSHOT_HEADER,
						true, this.m_asOwner);
				elementName			  = PTButtonType.CONTENT_SNAPSHOT_HEADER.GetElementName(PTButtonType.ELEMENT_NAME_ID_TITLE);
				myButtonConstruct.ReplaceNestedElementsWithHTMLString(elementName,
					m_asOwner.GetString(1860, "ptmsgs_portalbrowsingmsgs"));
				ConstructFactory.SetAltOnButtonImages(myButtonConstruct, m_asOwner.GetString(1860,
					"ptmsgs_portalbrowsingmsgs"));
				ConstructFactory.SetTitleOnButtonImages(myButtonConstruct, m_asOwner.GetString(1860,
					"ptmsgs_portalbrowsingmsgs"));

				anchor				  = (HTMLAnchor) myButtonConstruct.GetNestedElement(PTButtonType.CONTENT_SNAPSHOT_HEADER.GetElementName(
							PTButtonType.ELEMENT_NAME_ID_ANCHOR));
				anchor.SetOnClick("OpenLargePreviewWindow('" + displayInPorletURL.GetURLAsString() + "');return false;");	// mj: removed 'JavaScript:' from function name
				myConstruct.AddElementToNestedElement(PTBannerType.FOLDER.GetElementName(
					PTBannerType.ELEMENT_NAME_ID_EXTENDABLE_CELL),
					myButtonConstruct.GetHTMLElement());
			}

			if(m_asModel.IsEditMode())
			{
				//Edit This Folder
				ASURL editNameURL = new ASURL(m_asOwner);
				editNameURL.SetLinkCreateNewSpace(SiteMapFolderEditorAS.STR_MVC_CLASS_NAME,
					m_asOwner);
				editNameURL.SetDisplayPage(LocNamesDP.STR_MVC_CLASS_NAME);
				editNameURL.SetControl(EditorStartControl.STR_MVC_CLASS_NAME);
				editNameURL.AddControlArgument(EditorStartControl.QS_EDITOR_TYPE,
					EditorStartControl.EDITOR_START_FLAG_EDIT);
				editNameURL.AddControlArgument(SiteMapFolderModel.EDITOR_QS_INT_CLASS_ID,
					PT_CLASSIDS.PT_SITEMAPFOLDER_ID);
				editNameURL.AddControlArgument(SiteMapFolderModel.QS_NAMEORSECURITY,
					SiteMapFolderModel.EDIT_TYPE_NAME_DESC);
				editNameURL.AddControlArgument(SiteMapFolderModel.QS_STARTEDINSITEMAP,
					1);
				editNameURL.AddControlArgument(SiteMapFolderModel.EDITOR_QS_INT_QS_OBJECT_ID,
					m_asModel.GetCurrentFolderID());

				myButtonConstruct     = UIConstructFactory.GetConstruct(PTButtonType.EDIT_FOLDER_DIR_ACTIONBAR,
						true, this.m_asOwner);
				elementName			  = PTButtonType.EDIT_DIR_ACTIONBAR.GetElementName(PTButtonType.ELEMENT_NAME_ID_TITLE);

				ConstructFactory.SetAltOnButtonImages(myButtonConstruct, m_asOwner.GetString(965,
					"ptmsgs_portalbrowsingmsgs"));
				ConstructFactory.SetTitleOnButtonImages(myButtonConstruct, m_asOwner.GetString(965,
					"ptmsgs_portalbrowsingmsgs"));
				anchor = (HTMLAnchor) myButtonConstruct.GetNestedElement(PTButtonType.EDIT_FOLDER_DIR_ACTIONBAR.GetElementName(
							PTButtonType.ELEMENT_NAME_ID_ANCHOR));
				anchor.SetOnClick("OpenLargePreviewWindow('" + editNameURL.GetURLAsString() + "');return false;");	// mj: removed 'JavaScript:' from function name
				myConstruct.AddElementToNestedElement(PTBannerType.FOLDER.GetElementName(
						PTBannerType.ELEMENT_NAME_ID_EXTENDABLE_CELL),
					myButtonConstruct.GetHTMLElement());
			}

			if (m_asModel.GetCurrentFolderLevel() > 1)
			{
				//Go up button
				myButtonConstruct     = UIConstructFactory.GetConstruct(PTButtonType.GO_UP,
						true, this.m_asOwner);
				elementName			  = PTButtonType.GO_UP.GetElementName(PTButtonType.ELEMENT_NAME_ID_TITLE);

				myButtonConstruct.ReplaceNestedElementsWithHTMLString(elementName,
				 	CommonHTMLStrings.SPACE + m_asOwner.GetString(957, "ptmsgs_portalbrowsingmsgs"));
				ConstructFactory.SetAltOnButtonImages(myButtonConstruct, m_asOwner.GetString(957,
					"ptmsgs_portalbrowsingmsgs"));
				ConstructFactory.SetTitleOnButtonImages(myButtonConstruct, m_asOwner.GetString(957,
					"ptmsgs_portalbrowsingmsgs"));
				asurl = new ASURL(m_asOwner);
				asurl.SetLinkGetCachedSpace(m_asOwner);
				asurl.SetControl(SetSiteMapControl.STR_MVC_CLASS_NAME);

				int parentID = m_asModel.GetParentFolderID();
				asurl.AddControlArgument(SetSiteMapControl.m_CommunityID,
					m_asModel.GetCommunityID());
				asurl.AddControlArgument(SetSiteMapControl.m_FolderID, parentID);
				asurl.AddControlArgument(SetSiteMapControl.m_Mode,
					m_asModel.GetMode());
				anchor = (HTMLAnchor) myButtonConstruct.GetNestedElement(PTButtonType.GO_UP.GetElementName(
							PTButtonType.ELEMENT_NAME_ID_ANCHOR));

				if (parentID != m_asModel.GetCurrentFolderID())
				{
					anchor.SetHRef(asurl.GetURLAsString());
				}
				else
				{
					anchor.SetDisabled(true);
				}

				myButtonConstruct.ReplaceNestedElementsWithHTMLString(elementName,
					m_asOwner.GetString(957, "ptmsgs_portalbrowsingmsgs"));
				myConstruct.AddElementToNestedElement(PTBannerType.FOLDER.GetElementName(
					PTBannerType.ELEMENT_NAME_ID_EXTENDABLE_CELL),
					myButtonConstruct.GetHTMLElement());
			}

			if(m_asModel.IsEditMode())
			{
				//Browse button
				myButtonConstruct     = UIConstructFactory.GetConstruct(PTButtonType.BROWSE_HEADER,
						true, this.m_asOwner);
				elementName			  = PTButtonType.BROWSE_HEADER.GetElementName(PTButtonType.ELEMENT_NAME_ID_TITLE);

				myButtonConstruct.ReplaceNestedElementsWithHTMLString(elementName,
					m_asOwner.GetString(963, "ptmsgs_portalbrowsingmsgs"));
				ConstructFactory.SetAltOnButtonImages(myButtonConstruct, m_asOwner.GetString(963,
					"ptmsgs_portalbrowsingmsgs"));
				ConstructFactory.SetTitleOnButtonImages(myButtonConstruct, m_asOwner.GetString(963,
					"ptmsgs_portalbrowsingmsgs"));
				asurl = new ASURL(m_asOwner);
				asurl.SetLinkGetCachedSpace(m_asOwner);
				asurl.SetControl(SetSiteMapControl.STR_MVC_CLASS_NAME);
				asurl.AddControlArgument(SetSiteMapControl.m_CommunityID,
					m_asModel.GetCommunityID());
				asurl.AddControlArgument(SetSiteMapControl.m_FolderID,
					m_asModel.GetCurrentFolderID());
				asurl.AddControlArgument(SetSiteMapControl.m_Mode,
					SetSiteMapControl.BROWSE);
				anchor = (HTMLAnchor) myButtonConstruct.GetNestedElement(PTButtonType.BROWSE_HEADER.GetElementName(
							PTButtonType.ELEMENT_NAME_ID_ANCHOR));

				if (m_asModel.IsBrowseMode())
				{
					anchor.SetDisabled(true);
				}
				else
				{
					anchor.SetHRef(asurl.GetURLAsString());
				}

				myConstruct.AddElementToNestedElement(PTBannerType.FOLDER.GetElementName(
						PTBannerType.ELEMENT_NAME_ID_EXTENDABLE_CELL),
					myButtonConstruct.GetHTMLElement());
			}
			else if (m_asModel.IsBrowseMode() &&
					m_asModel.GetHasEditAccessToFolder() &&
					(m_asOwner.GetAccessStyle() == AccessStyles.STANDARD) &&
					!m_asModel.IsPreviewPage())
			{
				//Edit button
				myButtonConstruct     = UIConstructFactory.GetConstruct(PTButtonType.EDIT_HEADER,
						true, this.m_asOwner);
				elementName			  = PTButtonType.EDIT_HEADER.GetElementName(PTButtonType.ELEMENT_NAME_ID_TITLE);
				myButtonConstruct.ReplaceNestedElementsWithHTMLString(elementName,
					m_asOwner.GetString(962, "ptmsgs_portalbrowsingmsgs"));
				ConstructFactory.SetAltOnButtonImages(myButtonConstruct, m_asOwner.GetString(962,
					"ptmsgs_portalbrowsingmsgs"));
				ConstructFactory.SetTitleOnButtonImages(myButtonConstruct, m_asOwner.GetString(962,
					"ptmsgs_portalbrowsingmsgs"));
				asurl = new ASURL(m_asOwner);
				asurl.SetLinkGetCachedSpace(m_asOwner);
				asurl.SetControl(SetSiteMapControl.STR_MVC_CLASS_NAME);
				asurl.AddControlArgument(SetSiteMapControl.m_CommunityID,
					m_asModel.GetCommunityID());
				asurl.AddControlArgument(SetSiteMapControl.m_FolderID,
					m_asModel.GetCurrentFolderID());
				asurl.AddControlArgument(SetSiteMapControl.m_Mode,
					SetSiteMapControl.EDIT);
				anchor = (HTMLAnchor) myButtonConstruct.GetNestedElement(PTButtonType.EDIT_HEADER.GetElementName(
							PTButtonType.ELEMENT_NAME_ID_ANCHOR));

				if (m_asModel.IsEditMode())
				{
					anchor.SetDisabled(true);
				}
				else
				{
					anchor.SetHRef(asurl.GetURLAsString());
				}

				myConstruct.AddElementToNestedElement(PTBannerType.FOLDER.GetElementName(
					PTBannerType.ELEMENT_NAME_ID_EXTENDABLE_CELL),
					myButtonConstruct.GetHTMLElement());
			}

			result.AddInnerHTMLElement(myConstruct.GetHTMLElement());
		}
		catch (Exception e)
		{
			log.Error(e, "SiteMapBannerView::Display. An exception occured.");
		}

		if (m_asModel.IsEditMode())
		{
			try
			{
				PTConstruct myConstruct = UIConstructFactory.GetConstruct(PTBannerType.DIRECTORY_ACTION_BAR,
						true, m_asOwner);

				//	Get a button construct
				PTConstruct myButtonConstruct;

				//Create button
				myButtonConstruct     = UIConstructFactory.GetConstruct(PTButtonType.CREATE_FOLDER_DIR_ACTIONBAR,
						true, this.m_asOwner);
				elementName			  = PTButtonType.CREATE_FOLDER_DIR_ACTIONBAR.GetElementName(PTButtonType.ELEMENT_NAME_ID_TITLE);

				ConstructFactory.SetAltOnButtonImages(myButtonConstruct, m_asOwner.GetString(958,
					"ptmsgs_portalbrowsingmsgs"));
				ConstructFactory.SetTitleOnButtonImages(myButtonConstruct, m_asOwner.GetString(958,
					"ptmsgs_portalbrowsingmsgs"));

				asurl = new ASURL(m_asOwner);
				asurl.SetLinkGetCachedSpace(m_asOwner);
				asurl.SetDisplayPage(CreateFolderDP.STR_MVC_CLASS_NAME);
				asurl.SetControl(SiteMapRepostControl.STR_MVC_CLASS_NAME);
				asurl.AddControlArgument(RepostControl.HTMLINPUT_POSTTOSELF, SiteMapRepostControl.POSTTOSELF_ACTION_OPEN_CREATE_FOLDER);

				anchor = (HTMLAnchor) myButtonConstruct.GetNestedElement(PTButtonType.CREATE_FOLDER_DIR_ACTIONBAR.GetElementName(
							PTButtonType.ELEMENT_NAME_ID_ANCHOR));
				anchor.SetOnClick("window.open('" + asurl.GetURLAsString()
					+ "', '_blank1', 'location=no,menubar=no,height=180,width=400'); return false;");
				myConstruct.AddElementToNestedElement(PTBannerType.DIRECTORY_ACTION_BAR.GetElementName(
						PTBannerType.ELEMENT_NAME_ID_EXTENDABLE_CELL),
					myButtonConstruct.GetHTMLElement());

				//Move
				myButtonConstruct     = UIConstructFactory.GetConstruct(PTButtonType.MOVE_DIR_ACTIONBAR,
						true, this.m_asOwner);
				elementName			  = PTButtonType.MOVE_DIR_ACTIONBAR.GetElementName(PTButtonType.ELEMENT_NAME_ID_TITLE);

				ConstructFactory.SetAltOnButtonImages(myButtonConstruct, m_asOwner.GetString(966,
					"ptmsgs_portalbrowsingmsgs"));
				ConstructFactory.SetTitleOnButtonImages(myButtonConstruct, m_asOwner.GetString(966,
					"ptmsgs_portalbrowsingmsgs"));
				anchor = (HTMLAnchor) myButtonConstruct.GetNestedElement(PTButtonType.MOVE_DIR_ACTIONBAR.GetElementName(
							PTButtonType.ELEMENT_NAME_ID_ANCHOR));
				anchor.SetOnClick("IsAnythingChecked(true);return false;");	// mj: removed 'Javascript:' from function name
				myConstruct.AddElementToNestedElement(PTBannerType.DIRECTORY_ACTION_BAR.GetElementName(
						PTBannerType.ELEMENT_NAME_ID_EXTENDABLE_CELL),
					myButtonConstruct.GetHTMLElement());

				//Delete button
				myButtonConstruct     = UIConstructFactory.GetConstruct(PTButtonType.DELETE_DIR_ACTIONBAR,
						true, this.m_asOwner);
				elementName			  = PTButtonType.DELETE_DIR_ACTIONBAR.GetElementName(PTButtonType.ELEMENT_NAME_ID_TITLE);

				ConstructFactory.SetAltOnButtonImages(myButtonConstruct, m_asOwner.GetString(960,
					"ptmsgs_portalbrowsingmsgs"));
				ConstructFactory.SetTitleOnButtonImages(myButtonConstruct, m_asOwner.GetString(960,
					"ptmsgs_portalbrowsingmsgs"));
				anchor = (HTMLAnchor) myButtonConstruct.GetNestedElement(PTButtonType.DELETE_DIR_ACTIONBAR.GetElementName(
							PTButtonType.ELEMENT_NAME_ID_ANCHOR));
				anchor.SetOnClick("IsAnythingChecked(false);return false;");	// mj: removed 'JavaScript:' from function name
				myConstruct.AddElementToNestedElement(PTBannerType.DIRECTORY_ACTION_BAR.GetElementName(
						PTBannerType.ELEMENT_NAME_ID_EXTENDABLE_CELL),
					myButtonConstruct.GetHTMLElement());

				if(!m_asModel.InRootFolder() && !m_asModel.IsPreviewPage())
				{
					SiteMapFolderPlugInView plugInView = (SiteMapFolderPlugInView)
						m_asOwner.GetView(SiteMapFolderPlugInView.STR_MVC_CLASS_NAME);

					myConstruct.AddElementToNestedElement(PTBannerType.DIRECTORY_ACTION_BAR.GetElementName(
							PTBannerType.ELEMENT_NAME_ID_EXTENDABLE_CELL_2),
						plugInView.GetHTMLForActionBar(0));
				}

				result.AddInnerHTMLElement(myConstruct.GetHTMLElement());

			}
			catch (Exception e)
			{
				log.Error(e, "SiteMapBannerView::Display.");
			}
		}

		return result;
	}

	/**
	 * This method returns the HTMLScript that encompasses the Javascript on the page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 *
	 * @return HTMLScript
	 */
	public HTMLScript DisplayJavascript()
	{
		HTMLScript script = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);

		XPStringBuilder sb;
		ASURL asurl;

		try
		{
			asurl = new ASURL(m_asOwner);
			asurl.SetLinkCreateNewSpace(ServerTreeAS.STR_MVC_CLASS_NAME, m_asOwner);
			asurl.SetSubSpaceKey(SITEMAPFOLDERTREE);
			asurl.SetControl(ServerStartTreeControl.STR_MVC_CLASS_NAME);
			asurl.AddControlArgument(ServerStartTreeControl.INTERFACE_TYPE,
				ServerTreeModel.s_nSITEMAP_TREE);
			asurl.AddControlArgument(ServerStartTreeControl.INIT_DATA,
				m_asModel.GetSiteMapRootID());
			asurl.AddControlArgument(AStartTreeControl.MULTI_SELECT, XPConvert.ToString(false));
			asurl.AddControlArgument(AStartTreeControl.SELECT_MODE,
				TreeConstants.N_COMPOSITESELECT);
			asurl.AddControlArgument(AStartTreeControl.PARENT_SUBMIT_CALL,
				SERVER_SUBMIT);

			asurl.AddControlArgument(AStartTreeControl.TITLE,
				m_asOwner.GetString(967, "ptmsgs_portalbrowsingmsgs"));

			asurl.AddControlArgument(AStartTreeControl.ACTIONSUBTITLE,
				m_asOwner.GetString(968, "ptmsgs_portalbrowsingmsgs"));
			//asurl.AddControlArgument(AStartTreeControl.HIDDEN_ITEMS,
			//	m_asModel.GetCurrentFolderID());
			asurl.AddControlArgument(AStartTreeControl.SHOW_ROOT);

			// Submit function
			sb = new XPStringBuilder(100);
			sb.Append("function " + SERVER_SUBMIT + "()\n");
			sb.Append("{\n");
			sb.Append("  postToSelf(")
			.Append(SiteMapRepostControl.POSTTOSELF_ACTION_MOVE).Append(");\n");
			sb.Append("}\n");
			script.AddInnerHTMLString(sb.ToString());

			// Open server user tree function
			sb = new XPStringBuilder(200);
			sb.Append("function ").Append(JAVASCRIPT_SERVER_IPTTREE).Append("(strShowRoot, checkedFolders)\n");
			sb.Append("{\n");

			sb.Append("    window.open('").Append(asurl.GetURLAsString())
			.Append("' + strShowRoot + '&").Append(AStartTreeControl.HIDDEN_ITEMS).Append("=' + checkedFolders, '_blank3', '")
			.Append(TreeConstants.GetJavascriptTreeWindowAttributes()).Append("');\n");
			sb.Append("}\n");
			script.AddInnerHTMLString(sb.ToString());

			sb = new XPStringBuilder(400);
			sb.Append("\n" + "function GetCheckedFolder()\n");
			sb.Append("{\n");
			sb.Append(" varBoxes = document.mainform." +
				SiteMapFolderViewHelper.HTMLINPUT_SELECTION_FOLDER + ";\n");
			sb.Append("	varCount = 0;\n");
			sb.Append("	varSelectedFolder = 0;\n");
			sb.Append(" if ((varBoxes) && (varBoxes.length)) {\n");
			sb.Append("	  for ( var i = 0; i < varBoxes.length; i++ ) {\n");
			sb.Append("	    if ( varBoxes[i].checked == true ) {\n");
			sb.Append("		  varCount++;\n");
			sb.Append("		  if(varCount > 1) { \n");
			sb.Append("		    break; \n");
			sb.Append("		  } \n");
			sb.Append("		  varSelectedFolder = varBoxes[i].value;\n");
			sb.Append("	    }\n");
			sb.Append("	  }\n");
			sb.Append(
				" } else if ((varBoxes) && (varBoxes.checked == true)) {\n");
			sb.Append("	  varCount++;\n");
			sb.Append("	  varSelectedFolder = varBoxes.value;\n");
			sb.Append(" }\n");
			sb.Append(" if (varCount == 1) {\n");
			sb.Append("	  return varSelectedFolder;\n");
			sb.Append(" } else {\n");

			sb.Append("   alert('" +
				m_asOwner.GetString(970, "ptmsgs_portalbrowsingmsgs") +
				"');\n");
			sb.Append("   return 0;\n");
			sb.Append(" } \n");
			sb.Append("}\n\n");
			script.AddInnerHTMLString(sb.ToString());

			ASURL securityURL = new ASURL(m_asOwner);
			securityURL.SetLinkCreateNewSpace(SiteMapFolderEditorAS.STR_MVC_CLASS_NAME,
				m_asOwner);
			securityURL.SetDisplayPage(ObjectSecurityDP.STR_MVC_CLASS_NAME);
			securityURL.SetControl(EditorStartControl.STR_MVC_CLASS_NAME);
			securityURL.AddControlArgument(EditorStartControl.QS_EDITOR_TYPE,
				EditorStartControl.EDITOR_START_FLAG_EDIT);
			securityURL.AddControlArgument(SiteMapFolderModel.EDITOR_QS_INT_CLASS_ID,
				PT_CLASSIDS.PT_SITEMAPFOLDER_ID);
			securityURL.AddControlArgument(SiteMapFolderModel.QS_NAMEORSECURITY,
				SiteMapFolderModel.EDIT_TYPE_SECURITY);
			securityURL.AddControlArgument(SiteMapFolderModel.QS_STARTEDINSITEMAP,
				1);
			securityURL.AddControlArgument(SiteMapFolderModel.EDITOR_QS_INT_QS_OBJECT_ID);

			sb = new XPStringBuilder(300);
			sb.Append("\n" + "function DoFolderAction(nAction)\n");
			sb.Append("{\n");
			sb.Append("	 var nFolderID = GetCheckedFolder();\n");
			sb.Append("  if(nFolderID != 0) {\n");
			sb.Append("  	switch(nAction) \n");
			sb.Append(" 	{\n");
			sb.Append("  	  case 2:\n");
			sb.Append("  		OpenLargePreviewWindow('" +
				securityURL.GetURLAsString() + "' + nFolderID);\n");
			sb.Append("  		break;\n");
			sb.Append("  	  default:\n");
			sb.Append("  		break;\n");
			sb.Append("  	}\n");
			sb.Append("  	}\n");
			sb.Append("}\n\n");
			script.AddInnerHTMLString(sb.ToString());

			sb = new XPStringBuilder(300);
			sb.Append("\n" + "function IsAnythingChecked(bMove)\n");
			sb.Append("{\n");
			sb.Append(
				"  varFolderChecked = IsSomethingChecked(document.mainform." +
				SiteMapFolderViewHelper.HTMLINPUT_SELECTION_FOLDER + ");\n");
			sb.Append(
				"  varLinkChecked = IsSomethingChecked(document.mainform." +
				SiteMapLinkViewHelper.HTMLINPUT_SELECTION_OBJECT + ");\n");
			sb.Append("  if(varFolderChecked != '' || varLinkChecked != '')\n");
			sb.Append("	 {\n");
			sb.Append("		if(bMove) {\n");
			sb.Append("			if(varLinkChecked) {\n");
			sb.Append("				" + JAVASCRIPT_SERVER_IPTTREE + "('false', varFolderChecked);\n");
			sb.Append("			} else {\n");
			sb.Append("				" + JAVASCRIPT_SERVER_IPTTREE + "('true', varFolderChecked);\n");
			sb.Append("			}\n");
			sb.Append("		} else {\n");
			sb.Append("			postToSelf('" +
				SiteMapRepostControl.POSTTOSELF_ACTION_DELETE + "');\n");
			sb.Append("		}\n");
			sb.Append("   } else {\n");


			sb.Append("	alert('" +
				m_asOwner.GetString(969, "ptmsgs_portalbrowsingmsgs") +
				"');\n");
			sb.Append("   }\n");
			sb.Append("}\n\n");
			script.AddInnerHTMLString(sb.ToString());

			sb = new XPStringBuilder(300);
			sb.Append("function IsSomethingChecked(varMultiButton)\n");
			sb.Append("{\n");
			sb.Append("	var arrCheckedItems = '';");
			sb.Append(" if ((varMultiButton) && (varMultiButton.length)) {\n");
			sb.Append(
				"	  for ( var i = 0; i < varMultiButton.length; i++ ) {\n");
			sb.Append("	    if ( varMultiButton[i].checked == true ) {\n");
			sb.Append("		  arrCheckedItems += varMultiButton[i].value + ';';\n");
			sb.Append("	    }\n");
			sb.Append("	  }\n");
			sb.Append("	  return arrCheckedItems;\n");
			sb.Append(
				" } else if ((varMultiButton) && (varMultiButton.checked == true)) {\n");
			sb.Append("	  return varMultiButton.value;\n");
			sb.Append(" }\n");
			sb.Append(" return '';\n");
			sb.Append("}\n\n");
			script.AddInnerHTMLString(sb.ToString());
		}
		catch (HTMLException he)
		{
			
				log.Error(he, "DisplayJavascript couldn't add javascript to the HTMLScript element: " +
					he.getMessage());
			
		}

		return script;
	}

	/**
	 * Helper method for empty cell between actions
	 * in the action bar.
	 *
	 * @return HTMLTableCell
	 * @throws Exception
	 */
	protected HTMLSpan GetHTMLForEmptyCellInActionBar()

	{
		HTMLSpan mySpan;
		PTConstruct myConstruct;
		HTMLImg myImage;

		mySpan = new HTMLSpan();
		mySpan.SetStyleClass(PTStyleClass.ACTIONBAR_OBJECT_DIVIDER);
		myConstruct     = UIConstructFactory.GetConstruct(PTImageType.SPACER,
				true, m_asOwner);
		myImage		    = (HTMLImg) myConstruct.GetHTMLElement();
		myImage.SetAlt("");
		myImage.SetWidth(CommonHTMLStrings.ONE);
		myImage.SetHeight(CommonHTMLStrings.ONE);
		myImage.SetBorder(CommonHTMLStrings.ZERO);
		mySpan.AddInnerHTMLElement(myImage);
		mySpan.AddInnerHTMLElement(myConstruct.GetHTMLElement());

		return mySpan;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IView#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IView#Init(IModel, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_asModel     = (ISiteMapModelRO) model;
		m_asOwner     = parent;
	}
}

