package com.plumtree.portalpages.browsing.sitemap.sitemappage;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * File: SubCommunitiesDP.java
 * ---------------------------
 *
 * @author NaveenP
 */
public class SubCommunitiesDP extends PlumtreeDP
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.sitemap.sitemappage.SubCommunitiesDP");

	
	public static final String STR_MVC_CLASS_NAME = "SubCommunities";

	private SiteMapModel m_asModel;

	/**
	 * @see com.plumtree.xpshared.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetSubtitleForBanner()
	 */
	public String GetSubtitleForBanner()
	{
		return m_asOwner.GetString(986, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * @see com.plumtree.portalpages.common.uiparts.PlumtreeDP#GetTitleForBanner()
	 */
	public String GetTitleForBanner()
	{
		NavigationModel modelNavigation = (NavigationModel) m_asOwner.GetModel(NavigationModel.STR_MVC_CLASS_NAME);

		return modelNavigation.GetCurCommunityName();
	}

	/**
	 * helper display method for PlumtreeDP
	 *
	 * Fill in the body argument with HTML to display in the page.
	 */
	public HTMLElement PageDisplay()

	{
		m_asOwner.SetHelpTopic( "pt_communityknowledgedirectory_browsing" );
		
		m_asModel = (SiteMapModel) m_asOwner.GetModel(SiteMapModel.STR_MVC_CLASS_NAME);

		HTMLElementCollection result = new HTMLElementCollection();
		
		HTMLTable table = new HTMLTable();
		table.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
		table.SetBorder(CommonHTMLStrings.ZERO);
		table.SetCellSpacing("10");
		table.SetCellPadding(CommonHTMLStrings.ZERO);

		HTMLTableRow row = new HTMLTableRow();
		table.AddInnerHTMLElement(row);
		HTMLTableCell cell = new HTMLTableCell();
		row.AddInnerHTMLElement(cell);

		try
		{
			result.AddInnerHTMLElement(m_asOwner.GetView(
					SubCommunitiesView.STR_MVC_CLASS_NAME).Display());

			result.AddInnerHTMLElement(m_asOwner.GetView(
					SiteMapAS.s_strSubCommunitiesObjectView).Display());
					
			cell.AddInnerHTMLElement(result);
		}
		catch (HTMLException he)
		{
			log.Error(he, "Error in SubCommunitiesDP::Display.");
		}

		return table;
	}

	/**
	 * 
	 *
	 * @return 
	 *
	 * @throws HTMLException 
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection scripts = new HTMLScriptCollection();

		//scripts.AddInnerHTMLElement(m_asOwner.GetView(SiteMapBannerView.STR_MVC_CLASS_NAME).DisplayJavascript());
		return scripts;
	}
}

