package com.plumtree.portalpages.browsing.sso.ensemble;

import com.plumtree.portalpages.common.uiparts.*;


/**
 * @author Ravi Tunuguntla
 *
 * AActivitySpaces contain the MVC setup for a set of Display Pages, as well
 * as the Display Pages themselves.  All objects should come to their parent
 * AActivitySpace for access to other objects, such as IModels, IViews, and
 * user objects like IPTSession and UserPreferences.
 *
 * Activity spaces setup and manage the interaction between the different MVC
 * objects and the IDisplayPage.  They initialize all of the objects, and can
 * get and set data on the Models if necessary.  Activity Spaces are not subject
 * to the strict data/logic/presentation separation that MVC components are.
 */
public class EnsembleHandlerAS extends PlumtreeAS
{
	/** MVC object name */
	public static final String STR_MVC_CLASS_NAME = "EnsembleSSO";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new EnsembleHandlerAS();
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.AActivitySpace#Init()
	 */
	public void Init()
	{
		super.Init();

		
		// Ensemble SSO Control
		
		RegisterControl(EnsembleHandlerControl.STR_MVC_CLASS_NAME,"", null);
		
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.AActivitySpace#GetRepostControlName()
	 */	
	public String GetRepostControlName()
   {

     return EnsembleHandlerControl.STR_MVC_CLASS_NAME;

   } 
}
