package com.plumtree.portalpages.browsing.unsubscribe.communities;

import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.expandablelist.*;

/**
 * @author dustina
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class UnsubscribeCommunitiesAS extends PTEditorAS
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.browsing.unsubscribe.communities.UnsubscribeCommunitiesAS");

	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "UnsubscribeCommunities";
	
	
	/**
	 * Sets the Editor title.
	 *
	 * @return 
	 */
	public String GetEditorTitle()
	{
		return GetString(1547, "ptmsgs_portalbrowsingmsgs");
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new UnsubscribeCommunitiesAS();
	}
	
	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
	
	/**
	 * Returns the class name of the Property Repost Control.
	 *
	 * @return String
	 */
	public String GetRepostControlName()
	{
		return (UnsubscribeCommunitiesRepostControl.STR_MVC_CLASS_NAME);
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#Init(IPTSession)
	 */
	public void Init()
	{
		log.Info("Initializing UnsubscribeCommunity Activity Space");

		m_strModelName = UnsubscribeCommunitiesModel.STR_MVC_CLASS_NAME;
		
		super.Init();
		
		RegisterModel(MyCommunitiesListModel.STR_MVC_CLASS_NAME);
		IModel myModel = GetModel(MyCommunitiesListModel.STR_MVC_CLASS_NAME);
		
		RegisterView(MyCommunitiesListView.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(ExpListControl.STR_MVC_CLASS_NAME, myModel);
			
		// Unsubscribe Communities DisplayPages
		RegisterPage(new UnsubscribeCommunitiesDP());
		SetCurrentPage(UnsubscribeCommunitiesDP.STR_MVC_CLASS_NAME);
		
		// Unsubscribe Communities Model
		myModel = GetModel(UnsubscribeCommunitiesModel.STR_MVC_CLASS_NAME);
		
		// Unsubscribe Communities Controls
		RegisterControl(UnsubscribeCommunitiesRepostControl.STR_MVC_CLASS_NAME, myModel);


		this.SetHelpTopic( "PT_UnsubscribefromCommunities" );
		
	}

}

