package com.plumtree.portalpages.browsing.unsubscribe.communities;

import com.plumtree.uiinfrastructure.constants.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author dustina
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class UnsubscribeCommunitiesDP extends EditorDP {
	
	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "UnsubscribeCommunities";

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
	
	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorDP#GetLeftNavString()
	 */
	public String GetLeftNavString()
	{
		return m_asOwner.GetString(1548, "ptmsgs_portalbrowsingmsgs");
	}
	
	/**
	 * This is a helper method that all classes that inherit from AFormDP and want to
	 * have the Done and Cancel buttons displayed in the header for them need to
	 * implement.  The method should return the title add whatever HTML the child
	 * class wants to display to the body argument.  The parent class will then add
	 * that HTML to the HTMLPage after filling in the banner and navigation.
	 *
	 * Override this method to set the form title
	 *
	 * @return String the title for the form header (if used)
	 */
	public String GetFormTitle()
	{
		return m_asOwner.GetString(1548, "ptmsgs_portalbrowsingmsgs");
	}
	
	/**
	 * Returns the HTML for that Page.
	 *
	 * @return HTMLElement
	 *
	 * @throws HTMLException 
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay() 
	{
		HTMLElementCollection result = new HTMLElementCollection();
		
		HTMLElementCollection views = new HTMLElementCollection();

		
		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());
		
		// Display My Communities list.
		views.AddInnerHTMLElement(m_asOwner.GetView(MyCommunitiesListView.STR_MVC_CLASS_NAME).Display());
		
		result.AddInnerHTMLElement(CreateContentTable(views, null));
		
		return result;
	}
	
	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();
		myScripts.AddInnerHTMLElement(m_asOwner.GetView(MyCommunitiesListView.STR_MVC_CLASS_NAME).DisplayJavascript());

		return myScripts;
	}
	
	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.editor.EditorDP#GetHTMLBelowSubHeader()
	 */
	protected HTMLElement GetHTMLBelowSubHeader() 
	{
		if (AccessStyles.STANDARD == m_asOwner.GetAccessStyle())
		{
			return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1546, "ptmsgs_portalbrowsingmsgs"), this.m_asOwner);
		}
		else
		{
			return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(1785, "ptmsgs_portalbrowsingmsgs"), this.m_asOwner);
		}
	}
}

