package com.plumtree.portalpages.browsing.unsubscribe.communities;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.editor.*;

/**
 * @author dustina
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class UnsubscribeCommunitiesRepostControl extends EditorRepostControl
{
	public static final String STR_MVC_CLASS_NAME = "UnsubscribeCommunitiesRepostControl";
	
	/** Will delete one or more items from the list. */
	public static final int POSTTOSELF_ACTION_DELETE = 31;
	public static final int POSTTOSELF_508_ACTION_DELETE = 32;
	
	public static final String ROW_TO_DELETE = "deleteRow";
	
	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new UnsubscribeCommunitiesRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
	
	/**
	 * Switch between the action modes and call
	 * the associated method for each action.
	 *
	 * @param _nAction
	 */
	protected void PerformAction(int _nAction)
	{
		if (_nAction == POSTTOSELF_ACTION_DELETE || _nAction == POSTTOSELF_ACTION_FINISH)
		{
			((MyCommunitiesListModel) m_asOwner.GetModel(MyCommunitiesListModel.STR_MVC_CLASS_NAME)).
				Unsubscribe(m_htFormData, (UnsubscribeCommunitiesModel) m_model);

		} 
		else if (_nAction == POSTTOSELF_508_ACTION_DELETE)
		{
			String[] data = (String[]) m_htFormData.GetElement(ROW_TO_DELETE);

			if ((0 != data.length) && (null != data[0]))
			{
				try
				{
					int nRowIndex = XPConvert.ToInteger(data[0]);
					
					((MyCommunitiesListModel) m_asOwner.GetModel(MyCommunitiesListModel.STR_MVC_CLASS_NAME)).
					Unsubscribe508(nRowIndex, (UnsubscribeCommunitiesModel) m_model);
					
				}
				catch (Exception e)
				{
					// DCA - nothing to do...
				}
			}
		}
		
		super.PerformAction(_nAction);
	}
	
}

