/**
 * Created on Dec 23, 2002
 * by adolfoc
 */
package com.plumtree.portalpages.common.areyousure;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author adolfoc
 *
 */
public class AYSBottomView implements IView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_COMMON),
		"com.plumtree.portalpages.common.areyousure.AYSBottomView");

	/**
	 * Class name for the activity space
	 */
	public static final String STR_MVC_CLASS_NAME = "AYSBottomView";

	/**
	 * Parent AS.
	 */
	private AreYouSureAS m_asOwner;

	/**
	 * Associated read-only Model.
	 */
	private IAYSModelRO m_model;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new AYSBottomView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Display()
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result  = new HTMLElementCollection();
		HTMLTable myMainTable;
		HTMLTableRow myMainTableRow;
		HTMLTableCell myMainTableCell;
		HTMLSpan mySpan;

		try
		{
			// Main table
			myMainTable = new HTMLTable();
			result.AddInnerHTMLElement(myMainTable);
			myMainTable.SetWidth("100%");
			myMainTable.SetHeight("100%");
			myMainTable.SetBorder("0");
			myMainTable.SetCellPadding("0");
			myMainTable.SetCellSpacing("0");

			// Main table = row 1
			myMainTableRow = new HTMLTableRow();
			myMainTable.AddInnerHTMLElement(myMainTableRow);

			myMainTableCell = new HTMLTableCell();
			myMainTableRow.AddInnerHTMLElement(myMainTableCell);
			myMainTableCell.SetHeight("60");
			myMainTableCell.SetWidth("100%");
			myMainTableCell.SetStyleClass(PTStyleClass.DIALOGUE_BG);

			mySpan = new HTMLSpan();
			myMainTableCell.AddInnerHTMLElement(mySpan);
			mySpan.AddInnerHTMLString(CommonHTMLStrings.SPACE);
		}
		catch (Exception e)
		{
			
				log.Error(e, "Display The following error occured when trying to display the HTML: " +
					e.getMessage());
			

			throw new XPException(m_asOwner.GetString(3,
					"ptmsgs_portalcommonmsgs"), e);
		}

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		HTMLScript myScript = new HTMLScript("text/javaScript");

		return myScript;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/***/
	/**
	 */
	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_model		  = (IAYSModelRO) model;
		m_asOwner     = (AreYouSureAS) parent;
	}
}

