/**
 * Created on Dec 23, 2002
 * by adolfoc
 */
package com.plumtree.portalpages.common.areyousure;


/**
 * @author adolfoc
 *
 * This simple class encapsulates a single message to be rendered in the AYSMessageView.
 */
public class AYSMessage
{
	/**
	 * Top level messages are printed with now title or descriptive text.
	 * Actions are marked as actions that will occur when the OK button is clicked.
	 * Warnings are warnings displayed to the user.
	 * Recommendations are marked as suggested actions for the user to take after clicking OK.
	 * Errors are errors displayed to the user.
	 */
	public static final int AYSTYPE_TOPLEVEL	   = 0;
	public static final int AYSTYPE_ACTION		   = 1;
	public static final int AYSTYPE_WARNING		   = 2;
	public static final int AYSTYPE_RECOMMENDATION = 3;
	public static final int AYSTYPE_ERROR 		   = 4;

	/**
	 * The actual message text you would like to print. This should be localized for display.
	 */
	public String m_strMessage = "";

	/**
	 * Whether or not this message should be HTMLEncoded when displayed.
	 */
	public boolean m_bHTMLEncode = true;

	/**
	 * The message type for this message.
	 */
	public int m_nMessageType = 0;

	/**
	 * Creates a new AYSMessage object.
	 *
	 * @param strMessage 
	 * @param nMessageType 
	 */
	public AYSMessage(String strMessage, int nMessageType)
	{
		m_strMessage	   = strMessage;
		m_nMessageType     = nMessageType;
	}

	/**
	 * Creates a new AYSMessage object.
	 *
	 * @param strMessage 
	 * @param nMessageType 
	 * @param bHTMLEncode 
	 */
	public AYSMessage(String strMessage, int nMessageType, boolean bHTMLEncode)
	{
		m_strMessage	   = strMessage;
		m_nMessageType     = nMessageType;
	}
}

