/**
 * Created on Dec 17, 2002
 * by adolfoc
 */
package com.plumtree.portalpages.common.areyousure;

import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author adolfoc
 *
 */
public class AYSPopupBodyFrameDP extends AFormDP
{
	/**
	 * Class name for the activity space
	 */
	public static final String STR_MVC_CLASS_NAME = "AYSPopupBodyFrameDP";	

	/***/
	/**
	 */

	
	/** HTML Object name: close button */
	public static final String HTMLBUTTON_CLOSE = "in_bu_Close";

	/**
	 * Parent AS.
	 */
	private AreYouSureAS m_asOwner;

	/**
	 * Associated read-only Model.
	 */
	private AreYouSureModel m_model;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new AYSPopupBodyFrameDP();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()
	 */
	public String GetFormTitle()
	{		
		return m_asOwner.GetString(715,"ptmsgs_portalcommonmsgs");
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#GetOwner()
	 */
	public AActivitySpace GetOwner()
	{
		return m_asOwner;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		super.Init(parent);
		m_model		  = (AreYouSureModel) parent.GetModel(AreYouSureModel.STR_MVC_CLASS_NAME);
		m_asOwner     = (AreYouSureAS) parent;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		result.AddInnerHTMLElement(((AYSMessageView) m_asOwner.GetView(
				AYSMessageView.STR_MVC_CLASS_NAME)).Display());

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#DisplayJavaScriptFromChild()
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection result = super.DisplayJavaScriptFromChild();

		if (null == result)
		{
			result = new HTMLScriptCollection();
		}

		result.AddInnerHTMLElement(m_asOwner.GetView(
				AYSMessageView.STR_MVC_CLASS_NAME).DisplayJavascript());

		return result;
	}
}

