/**
 * Created on Dec 17, 2002
 * by adolfoc
 */
package com.plumtree.portalpages.common.areyousure;

import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.common.*;

/**
 * @author adolfoc
 *
 */
public class AYSPopupDP extends FrameSetDP
{
	/**
	 * Class name for the activity space
	 */
	public static final String STR_MVC_CLASS_NAME = "AYSPopupDP";

	/**
	 * Parent AS.
	 */
	private AreYouSureAS m_asOwner;

	/**
	 * Associated read-only Model.
	 */
	private AreYouSureModel m_model;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new AYSPopupDP();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#GetOwner()
	 */
	public AActivitySpace GetOwner()
	{
		return m_asOwner;
	}

	/***/
	/**
	 */

	
	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		super.Init(parent);
		m_model		  = (AreYouSureModel) parent.GetModel(AreYouSureModel.STR_MVC_CLASS_NAME);
		m_asOwner     = (AreYouSureAS) parent;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameScrollBody()
	 */
	public boolean GetFrameScrollBody()
	{
		return true;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameScrollBottom()
	 */
	public boolean GetFrameScrollBottom()
	{
		return false;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameScrollTop()
	 */
	public boolean GetFrameScrollTop()
	{
		return false;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameSetAttributes()
	 */
	public String GetFrameSetAttributes()
	{
		return "10%,70%,20%";
	}

	/**
	 * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameSetTitle()
	 */
	public String GetFrameSetTitle()
	{
		return m_asOwner.GetString(19, "ptmsgs_portalcommonmsgs");
	}

	/**
	 * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameURLBody()
	 */
	public ASURL GetFrameURLBody()
	{
		ASURL result = new ASURL(m_asOwner);
		result.SetLinkGetCachedSpace(m_asOwner);
		result.SetDisplayPage(AYSPopupBodyFrameDP.STR_MVC_CLASS_NAME);

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameURLBottom()
	 */
	public ASURL GetFrameURLBottom()
	{
		ASURL result = new ASURL(m_asOwner);
		result.SetLinkGetCachedSpace(m_asOwner);
		result.SetDisplayPage(AYSPopupBottomFrameDP.STR_MVC_CLASS_NAME);

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameURLTop()
	 */
	public ASURL GetFrameURLTop()
	{
		ASURL result = new ASURL(m_asOwner);
		result.SetLinkGetCachedSpace(m_asOwner);
		result.SetDisplayPage(AYSPopupTopFrameDP.STR_MVC_CLASS_NAME);

		return result;
	}
}

