/**
 * Created on Dec 16, 2002
 * by adolfoc
 */
package com.plumtree.portalpages.common.areyousure;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author adolfoc
 *
 */
public class AreYouSureControl implements IControl
{
	
	public static final String STR_MVC_CLASS_NAME = "AreYouSureControl";

	/**
	 * This is posted after the popup window pops - so that the parent knows to
	 * redirect.
	 */
	public static final int POSTTOSELF_ACTION_REDIRECT_AFTER_OK = 27;

	/**
	 *
	 */
	public static final String _QS_AYS_SESSION_KEY = "aysSessionKey";
	protected AActivitySpace m_asOwner			   = null;
	protected IModel m_model					   = null;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#Execute(XPHashtable)
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		AreYouSureModel aysModel = (AreYouSureModel) m_model;

		if (arguments.ContainsKey(_QS_AYS_SESSION_KEY))
		{
			String[] data = (String[]) arguments.GetElement(_QS_AYS_SESSION_KEY);

			if ((0 != data.length) && (null != data[0]))
			{
				aysModel.SetSessionKey((String) data[0]);
			}
		}

		return null;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new AreYouSureControl();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#Init(IModel, AActivitySpace)
	 */
	public void Init(IModel model, AActivitySpace space)
	{
		// Store these for use later.
		m_asOwner     = space;
		m_model		  = model;
	}
}

