/**
 * Created on Dec 16, 2002
 * by adolfoc
 */
package com.plumtree.portalpages.common.areyousure;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author adolfoc
 *
 */
public class AreYouSureModel implements IModel, IAYSModelRO
{
	
	public static final String STR_MVC_CLASS_NAME = "AreYouSure";
	private AActivitySpace m_asOwner		  = null;
	private XPArrayList m_xpalAYSMessages = null;

	public AreYouSureModel()
	{
		m_xpalAYSMessages = new XPArrayList();	
	}

	/**
	 * Adds an AYSMessage to be displayed
	 */
	public void AddMessage(AYSMessage aysIn)
	{
		m_xpalAYSMessages.Add(aysIn);
	}

	/**
	 * Adds an AYSMessage to be displayed (simple form)
	 */
	public void AddMessage(String strMessage, int nMessageType)
	{
		m_xpalAYSMessages.Add(new AYSMessage(strMessage, nMessageType));
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IModel#CleanupTempData()
	 */
	public void CleanupTempData()
	{
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IModel#CleanupAllData()
	 */
	public void CleanupAllData()
	{
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new AreYouSureModel();
	}

	/**
	 * Returns the xpalAYSMessages.
	 * @return XPArrayList
	 */
	public XPArrayList GetMessages()
	{
		return m_xpalAYSMessages;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IModel#Init(AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		m_asOwner = parent;
	}

	/**
	 * Gets an array of messages from the passed-in SessionKey.
	 */
	public void SetSessionKey(String strSessionKey)
	{
		m_xpalAYSMessages = (XPArrayList) m_asOwner.GetSubSession()
			.GetAttribute(strSessionKey);
	}
}

