package com.plumtree.portalpages.common.createfolder;

import com.plumtree.portalpages.admin.objmgr.*;
import com.plumtree.portalpages.browsing.directory.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 *
 * @author StephenC
 */
public class CreateFolderDP extends AFormDP
{
	
	public static final String STR_MVC_CLASS_NAME = "CreateFolderDP";

	
	public static final String QS_PARENT_FOLDER    = "parentFolder";

	
	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()
	 */
	public String GetFormTitle()
	{
		return ((CreateFolderView) m_asOwner.GetView(CreateFolderView.STR_VIEW_STORAGE_NAME)).GetBannerTitle();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Init(AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		super.Init(parent);
		
		// enable the status view for these repost values.
		SetStatusViewRepostValues(new int[] {
			ObjMgrRepostControl.POSTTOSELF_ACTION_CREATE_FOLDER,
			DirRepostControl.POSTTOSELF_ACTION_CREATEFOLDER
			});
		
		AddToValidationFunction(CreateFolderView.JAVASCRIPT_CREATEFOLDER);
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()
	{
		return m_asOwner.GetView(CreateFolderView.STR_VIEW_STORAGE_NAME)
			.Display();
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 *
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
				CreateFolderView.STR_VIEW_STORAGE_NAME).DisplayJavascript());

		return myScripts;
	}
	
	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormPageType()
	 */
	public FormPageTypes GetFormPageType()
	{
		return FormPageTypes.SMALL_POPUP;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetCloseOnCancel()
	 */
	public boolean GetCloseOnCancel()
	{
		return true;
	}
}

