package com.plumtree.portalpages.common.dirprefs;

import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author StephenC
 */
public class DirPrefsDP extends EditorDP
{
	
	public static final String STR_MVC_CLASS_NAME = "DirPrefs";

	public String GetLeftNavString()
	{
		return(m_asOwner.GetString(501, "ptmsgs_portalcommonmsgs"));
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader() 
	{
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(1454, "ptmsgs_portalbrowsingmsgs"),
			this.m_asOwner);
	}

	/**
	 * 
	 *
	 * @return 
	 *
	 * @throws HTMLException 
	 */
	public HTMLElement PageDisplay()

	{
		HTMLElementCollection result = new HTMLElementCollection();
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();
		views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
				DirPrefsView.STR_MVC_CLASS_NAME)).Display());

		views.AddInnerHTMLElement(EditorView.GetSpacerTable());

		views.AddInnerHTMLElement(m_asOwner.GetView(
				DirPrefsAS.strBrowsingPropertiesPlugInKey).Display());

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}


	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
				DirPrefsAS.strBrowsingPropertiesPlugInKey).DisplayJavascript());

		return myScripts;
	}
}

