package com.plumtree.portalpages.common.documentlanguage;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.editor.*;

/**
 * This Control contains the repost actions of the plug-in section.
 *
 * @author StephenC
 */
public class CardLanguagePlugInRepostControl extends EditorHelperRepostControl
{
	
	public static final String STR_MVC_CLASS_NAME = "CardLanguagePlugIn";

	// JF- repost actions for that section

	
	public final static int POSTTOSELF_ACTION_SHOW_POPULAR = 30;

	
	public final static int POSTTOSELF_ACTION_SHOW_ALL = 31;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new CardLanguagePlugInRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Performs action on repost.
	 *
	 * @param _nAction
	 * @param _htFormData
	 */
	public void PerformRepostAction(int _nAction, XPHashtable _htFormData)
	{
		switch (_nAction)
		{
		case POSTTOSELF_ACTION_SHOW_POPULAR:
			((CardLanguagePlugInModel) m_model).SetDisplayOnlyPopularLanguages(true);

			break;

		case POSTTOSELF_ACTION_SHOW_ALL:
			((CardLanguagePlugInModel) m_model).SetDisplayOnlyPopularLanguages(false);

			break;
		}
	}
}

