package com.plumtree.portalpages.common.editpage;

import com.plumtree.uiinfrastructure.arraywrapper.*;

/**
 * @author michaeld
 *
 */
public class PageData
{
	/** Portlets */
	public PTGrowableSortedArrayWrapper m_arrPortlets;

	/** Free Form Portlet */
	public PortletData m_gmFreeForm;

	/** Page Name */
	public String m_strPageName;

	/** Page Template From Community Template */
	public boolean m_bFromCommTemp;

	/** Has Portlets been setup? */
	public boolean m_bPortletsSetUp;
	
	/** Has Page Template changed since this model was setup? */
	public boolean m_bPageTemplateChanged;

	/** Community ID */
	public int m_nCommunityID;

	/** Portlet Count */
	public int m_nPortletCount;

	/** Page ID */
	public int m_nPageID;

	/** Page Template ID */
	public int m_nPageTemplateID;

	/** Page Type */
	public int m_nPageType;

	/**
	 * Unique ID
	 * This is optional. Currently it is only used in the community editor to keep
	 * track of pages.
	 */
	public int m_nUniqueID;

	/**
	 * Creates a new PageData object.
	 *
	 * @param nPageType 
	 * @param strPageName 
	 */
	public PageData(int nPageType, String strPageName)
	{
		m_nPageType			 = nPageType;
		m_strPageName		 = strPageName;
		m_bPortletsSetUp     = false;
		m_bPageTemplateChanged = false;

		m_nPageID			  = 0;
		m_nCommunityID		  = -1;
		m_nPageTemplateID     = 0;
		m_bFromCommTemp		  = false;
	}

	/**
	 * Creates a new PageData object.
	 *
	 * @param nPageID 
	 * @param nCommunityID 
	 * @param nPageTemplateID 
	 * @param bFromCommTemp 
	 * @param nPageType 
	 * @param strPageName 
	 */
	public PageData(int nPageID, int nCommunityID, int nPageTemplateID,
		boolean bFromCommTemp, int nPageType, String strPageName)
	{
		this(nPageTemplateID, bFromCommTemp, nPageType, strPageName);

		m_nPageID		   = nPageID;
		m_nCommunityID     = nCommunityID;
	}

	/**
	 * Creates a new PageData object.
	 *
	 * @param nPageTemplateID 
	 * @param bFromCommTemp 
	 * @param nPageType 
	 * @param strPageName 
	 */
	public PageData(int nPageTemplateID, boolean bFromCommTemp, int nPageType,
		String strPageName)
	{
		this(nPageType, strPageName);

		m_nPageTemplateID     = nPageTemplateID;
		m_bFromCommTemp		  = bFromCommTemp;
	}
}

