package com.plumtree.portalpages.common.editpage;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.editor.*;

/**
 * @author michaeld
 */
public class PageLayoutControl extends EditorHelperRepostControl
{
	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "PageLayout";

	/** Repost Action: Add Portlets submitted */
	public final static int POSTTOSELF_ACTION_ADDGADGETS = 36;

	/** Repost Action: Add Free Form submitted */
	public final static int POSTTOSELF_ACTION_ADDFREEFORM = 37;

	/** Repost Action: New Portlet */
	public final static int POSTTOSELF_ACTION_NEW_GADGET = 38;

	/** Repost Action: Delete Portlet */
	public final static int POSTTOSELF_ACTION_DELETEPORTLET = 39;
	
	/** Repost Action: Select Layout */
	public final static int POSTTOSELF_ACTION_SELECTLAYOUT = 40;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new PageLayoutControl();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.editor.EditorHelperRepostControl#PerformRepostAction(int, XPHashtable)
	 */
	public void PerformRepostAction(int _nAction, XPHashtable _htFormData)
	{
		switch (_nAction)
		{
		case POSTTOSELF_ACTION_ADDGADGETS:
			((PageLayoutPlugInModel) m_model).RepostAddPortlets();

			break;

		case POSTTOSELF_ACTION_NEW_GADGET:
			((PageLayoutPlugInModel) m_model).RepostNewPortlet();

			break;

		case POSTTOSELF_ACTION_ADDFREEFORM:
			((PageLayoutPlugInModel) m_model).RepostAddFreeForm();

			break;

		case POSTTOSELF_ACTION_DELETEPORTLET:
			((PageLayoutPlugInModel) m_model).RepostDeletePortlet();

			break;
			
		case POSTTOSELF_ACTION_SELECTLAYOUT:
			
			break;
		}
	}
}

