package com.plumtree.portalpages.common.error;

import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.errordisplay.*;

/**
 * @author BenG
 * 
 * This activity space is for displaying those error messages that require
 * their own display page.
 */
public class ErrorAS extends PlumtreeAS
{
	/** name */
	public static final String STR_MVC_CLASS_NAME = "ErrorAS";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new ErrorAS();
	}

	/**
	 * Get the name of this activity space.
	 *
	 * @return String name.
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.AActivitySpace#Init()
	 */
	public void Init()
	{
		super.Init();

		RegisterPage(new ErrorDP());

		RegisterModel(SinglePageErrorModel.STR_MVC_CLASS_NAME);

		IModel myModel = GetModel(SinglePageErrorModel.STR_MVC_CLASS_NAME);

		RegisterControl(SinglePageErrorControl.STR_MVC_CLASS_NAME, myModel);

		RegisterView(SinglePageErrorView.STR_MVC_CLASS_NAME, myModel);
	}
}

