package com.plumtree.portalpages.common.folder;

import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This writes out one folder to the given table cell and returns a reference
 * to the next folder in the query result to display.
 *
 * See com.plumtree.portalpages.common.folder.FolderViewHelper for implementation of
 * the general case.
 *
 * @author RupaP
 */
public interface IFolderViewHelper
{
	/**
	 * Displays one folder and any related items.
	 *
	 * @param nFolderIndex     the index of the subfolder to be displayed
	 * @param tableCell     the table to add the folder view to
	 * @param model passes     the current state of the opened folder
	 * @param space     current activity space
	 *
	 * @return the next Folder Index to display.
	 */
	public int DisplayFolder(int nFolderIndex, HTMLTableCell tableCell,
		IFolderModelRO model, AActivitySpace space);
		
	/**
	 * SetupAnchorToOpenFolder.
	 * Sets up the anchor to open the folder with the given id.
	 * 
	 * @param _anchor
	 * @param _nFolderID
	 */
	public void SetupAnchorToOpenFolder(HTMLAnchor _anchor, int _nFolderID,
		IFolderModelRO _model, AActivitySpace _space);
}

