package com.plumtree.portalpages.common.folder;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author Don Hayler
 *
 */
public class OpenSubFolderControl implements IControl
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_COMMON),
		"com.plumtree.portalpages.common.folder.OpenSubFolderControl");

	
	public static final String STR_MVC_CLASS_NAME = "OpenSubFolder";

	
	public static final String m_SubFolderID = "subfolderID";
	protected int m_nSubFolderID   = 0;
	private IFolderModel m_asModel;

	/**
	 * @see com.plumtree.xpshared.activityspace.IControl#execute()
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		String[] sValues = (String[]) arguments.GetElement(m_SubFolderID);

		if (sValues == null)
		{
			
				log.Error("could not find folder ID in query string.");
			

			return null;
		}

		m_asModel.OpenSubFolder(XPConvert.ToInteger(sValues[0]));

		return null;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new OpenSubFolderControl();
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IControl#getName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IControl#init(IModel, AActivitySpace)
	 */
	public void Init(IModel model, AActivitySpace space)
	{
		m_asModel = (IFolderModel) model;
	}
}

