package com.plumtree.portalpages.common.folder;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author RupaP
 *
 */
public class SetStartItemControl implements IControl
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_COMMON),
		"com.plumtree.portalpages.common.folder.SetStartItemControl");

	
	public static final String STR_MVC_CLASS_NAME = "SetStartItem";

	
	public static final String m_strStartItem = "StartItem";
	private IFolderModel m_asModel;

	/**
	 * @see com.plumtree.xpshared.activityspace.IControl#execute()
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		String[] sValues = (String[]) arguments.GetElement(m_strStartItem);

		if (sValues == null)
		{
			
				log.Error("could not find start item in query string.");
			

			return null;
		}

		m_asModel.SetFirstItemIndex(XPConvert.ToInteger(sValues[0]));

		//todo- should we redirect to a new page if this changes?
		return null;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SetStartItemControl();
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IControl#getName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IControl#init(IModel, AActivitySpace)
	 */
	public void Init(IModel model, AActivitySpace space)
	{
		m_asModel = (IFolderModel) model;
	}
}

