package com.plumtree.portalpages.common.helpers;


/**
 * @author OlegS
 */
public class IntegerPropertyWithRange extends IntegerProperty
{
	protected int m_max;
	protected int m_min;

	/**
	 * Creates a new IntegerPropertyWithRange object.
	 *
	 * @param owner 
	 * @param min 
	 * @param max 
	 */
	public IntegerPropertyWithRange(PropertyValidatorOwner owner, int min,
		int max)
	{
		super(owner);
		m_min     = min;
		m_max     = max;
	}

	/**
	 * 
	 *
	 * @param val 
	 *
	 * @return 
	 */
	public int validate(PropertyValue val)
	{
		int result = super.validate(val);

		if (result == VALIDSOFAR)
		{
			int n = val.number();

			if ((n < m_min) || (n > m_max))
			{
				SetInvalid(val,
					m_asOwner.GetString(58, "ptmsgs_portalcommonmsgs") + " [" +
					m_min + "," + m_max + "]");
				result = INVALID;
			}
		}

		return result;
	}
}

