package com.plumtree.portalpages.common.helpers;


/**
 * @author OlegS
 */
public class OptionalProperty extends PropertyValidator
{
	protected PropertyValue m_parent;

	/**
	 * Creates a new OptionalProperty object.
	 *
	 * @param owner 
	 */
	public OptionalProperty(PropertyValidatorOwner owner)
	{
		super(owner);
		m_parent = null;
	}

	/**
	 * Creates a new OptionalProperty object.
	 *
	 * @param owner 
	 * @param parentProperty 
	 */
	public OptionalProperty(PropertyValidatorOwner owner,
		PropertyValue parentProperty)
	{
		this(owner);
		m_parent = parentProperty;
	}

	/**
	 * 
	 *
	 * @param val 
	 *
	 * @return 
	 */
	public int validate(PropertyValue val)
	{
		int result = super.validate(val);

		if (result == VALIDSOFAR)
		{
			if (val.empty())
			{
				if (m_parent == null)
				{
					result = VALID; // no parent - valid if empty
				}
				else
				{ // has parent - 

					if (m_parent.empty())
					{
						result = VALID; // valid if empty and parent is empty
					}
					else
					{
						SetInvalid(val,
							m_asOwner.GetString(56, "ptmsgs_portalcommonmsgs"));
						result = INVALID; // invalid if empty but parent is not empty
					}
				}
			}
		}

		return result;
	}
}

