package com.plumtree.portalpages.common.helpers;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author OlegS
 */
public abstract class PropertyValidator
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_COMMON),
		"com.plumtree.portalpages.common.helpers.PropertyValidator");

	
	public static final int VALID = 1;

	
	public static final int INVALID = -1;

	
	public static final int VALIDSOFAR = 0;
	protected AActivitySpace m_asOwner;
	protected PropertyValidatorOwner m_owner;

	/**
	 * Creates a new PropertyValidator object.
	 *
	 * @param owner 
	 */
	public PropertyValidator(PropertyValidatorOwner owner)
	{
		m_owner = owner;

		if (m_owner != null)
		{
			m_asOwner = m_owner.asOwner();
		}
	}

	/**
	 * 
	 *
	 * @param val 
	 * @param reason 
	 */
	public void SetInvalid(PropertyValue val, String reason)
	{
		if (m_asOwner == null)
		{
			m_asOwner = m_owner.asOwner(); // usually null at creation time
		}

		XPStringBuilder sb = new XPStringBuilder(100);
		String valtext = val.text();

		if ((valtext == null) || (valtext.length() == 0))
		{
			valtext = m_asOwner.GetString(55, "ptmsgs_portalcommonmsgs");
		}

		String valname=val.name();
		sb.Append(valname);
		sb.Append( (valname.endsWith(":")) ? " " : " = ");
		sb.Append(valtext).Append(" (").Append(reason).Append(")");

		
			log.Warn("PropertyValidator validation error - " + sb.ToString() + ".");
		

		XPStringBuilder esb = m_owner.GetErrorString();

		if (esb.GetLength() > 0)
		{
			esb.Append("; ");
		}

		esb.Append(sb.ToString());
	}

	/**
	 * 
	 *
	 * @param val 
	 *
	 * @return 
	 */
	public int validate(PropertyValue val)
	{
		if (m_asOwner == null)
		{
			m_asOwner = m_owner.asOwner(); // usually null at creation time
		}

		return VALIDSOFAR;
	}
}

