package com.plumtree.portalpages.common.helpers;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.htmlconstructs.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author OlegS
 */
public class Spacer
{
	
	public String m_height;
	protected HTMLTable m_table = null;

	/**
	 * Creates a new Spacer object.
	 *
	 * @param height 
	 */
	public Spacer(String height)
	{
		m_height = height;
	}

	/**
	 * 
	 *
	 * @param result 
	 */
	public void display(HTMLElementCollection result)
	{
		if (m_table == null)
		{
			m_table = make(m_height);
		}

		try
		{
			result.AddInnerHTMLElement(m_table);
		}
		catch (Exception e)
		{
			throw XPException.GetInstance(e);
		}
	}

	/**
	 * 
	 *
	 * @param height 
	 *
	 * @return 
	 */
	public static HTMLTable make(String height)
	{
		try
		{
			HTMLTable table = new HTMLTable();
			table.SetCellSpacing("0");
			table.SetCellPadding("0");
			table.SetWidth("100%");
			table.SetBorder("0");

			HTMLTableRow row = new HTMLTableRow();
			table.AddInnerHTMLElement(row);

			HTMLTableCell cell = new HTMLTableCell();
			row.AddInnerHTMLElement(cell);

			HTMLImg img = (HTMLImg) UIConstructFactory.GetConstruct(PTImageType.SPACER).GetHTMLElement();
			cell.AddInnerHTMLElement(img);
			img.SetHeight(height);
			img.SetWidth("1");
			img.SetBorder("0");
			img.SetAlign("absMiddle");
			img.SetAlt("");

			return table;
		}
		catch (Exception e)
		{
			throw XPException.GetInstance(e);
		}
	}
}

