package com.plumtree.portalpages.common.helpers;
import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;

public class TraceHelper {
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_COMMON),
		"com.plumtree.portalpages.common.helpers.TraceHelper");

	
	public static boolean Enabled()
	{
		return log.IsDebugEnabled();
	}
	
	public static void Trace(String s)
	{
		log.Debug(s);
	}

	public static void TraceQueryString(XPHashtable _htFormData)
	{
		try {
			if (!Enabled())
				return;

			XPStringBuilder sb = new XPStringBuilder();
			sb.Append("Query String: ");

			IXPEnumerator keys   = _htFormData.GetKeys();
			IXPEnumerator values = _htFormData.GetElements();

			while (keys.MoveNext())
			{
				values.MoveNext();
				sb.Append(keys.GetCurrent()).Append('=')
					.Append(((String[]) values.GetCurrent())[0]).Append(' ');

				String[] moreValues = (String[]) values.GetCurrent();

				for (int i = 1; i < moreValues.length; i++)
				{
					sb.Append(keys.GetCurrent()).Append('#').Append(i).Append('=')
						.Append(moreValues[i]).Append(' ');
				}
			}

			Trace(sb.ToString());
		} catch(Exception e) {
			Trace("TraceQueryString failed");
		}
	}

}

