package com.plumtree.portalpages.common.joblogs;


// Framework Imports
import com.plumtree.uiinfrastructure.constants.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This class extends EditorDP and displays the History page of the Job Editor.
 */
public class JobLogDisplayDP extends AFormDP
{
	/** The unique name for the class */
	public static final String STR_MVC_CLASS_NAME = "JobLogDisplayDP";

	/** 
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()
	*/
	public String GetFormTitle()
	{
		return m_asOwner.GetString(93, "ptmsgs_portalcommonmsgs");
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for the Job Log Display page.
	 *
	 * @return HTMLElement
	 * @throws HTMLException 
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay(HTMLTableRow)
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		//Just ask the view to display itself
		result.AddInnerHTMLElement(m_asOwner.GetView(
				JobLogDisplayView.STR_MVC_CLASS_NAME).Display());

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 *
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
				JobLogDisplayView.STR_MVC_CLASS_NAME).DisplayJavascript());

		return myScripts;
	}
	
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.form.AFormDP#GetUseJavascript()
     */
    public boolean GetUseJavascript() 
    {
        if (AccessStyles.LOW_BANDWIDTH == m_asOwner.GetAccessStyle())
        {
            return true;
        }
        else
        {
            return super.GetUseJavascript();
        }
    }
}

