/*
 * Created on Apr 8, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package com.plumtree.portalpages.common.joblogs;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author johnh
 * 
 * NOTE: Because the Init() method of this class looks for the JobLogModel,
 * the model needs to be registered before this DisplayPage.
 */
public class JobLogDownloadDP implements IDisplayPage
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_COMMON),
		"com.plumtree.portalpages.common.joblogs.JobLogDownloadDP");

	public static final String STR_MVC_CLASS_NAME = "JobLogDownloadDP";

	private AActivitySpace m_asOwner = null;
	private IModel m_model = null;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Init(AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		m_asOwner = parent;
		m_model = parent.GetModel(JobLogModel.STR_MVC_CLASS_NAME);

		if (null == m_model)
		{
			log.Error("JobLogDownloadDP.Init() unable to find JobLogModel.  Make sure it has been registered before this DisplayPage.");
		}
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Display(com.plumtree.uiinfrastructure.activityspace.IWebData)
	 */
	public void Display(IWebData arg0)
	{
		try
		{
			byte[] arOut     = null;

			//Retrive the log file as a byte array from the model			
			arOut = ((IJobLogModelRO) m_model).GetLogFile();
			 
			// arOut should contain the binary contents of the file now.
			arg0.SetData(arOut);
			//Set the "YES-PLEASE-STREAM-ME-THROUGH-THE-PLUMTREE-GATEWAY" header
			((WebData)arg0).SetSuppressAutomaticHeaders(true);
			arg0.SetHeader("PTGW-Streaming", "Yes"); 
			arg0.SetHeader(HTTPHeaderConstants.CONTENT_TYPE, "application/x-plumtree-download;");
			arg0.SetHeader(HTTPHeaderConstants.CONTENT_LENGTH, XPConvert.ToString(arOut.length));
			arg0.SetHeader(HTTPHeaderConstants.CONTENT_DISPOSITION, "attachment; filename=joblog.log");

		}
		catch (Exception e)
		{
			// TODO: Figure out error handling.
			log.Error(e, "Unknown Error attempting to download file.");
		}
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#GetOwner()
	 */
	public AActivitySpace GetOwner()
	{
		return m_asOwner;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}