package com.plumtree.portalpages.common.objects.sort;

import com.plumtree.openfoundation.util.*;
import com.plumtree.server.*;

/**
 * 
 *
 * @author OlegS
 */
public class PTObjectNameComparator implements IXPComparer
{
	protected IPTObjectNameGetter ptNameGetter = null;
	protected IPTSession ptSession			 = null;
	protected boolean ascending				 = true;

	/**
	 * Creates a new PTObjectNameComparator object.
	 *
	 * @param g 
	 * @param s 
	 * @param a 
	 */
	public PTObjectNameComparator(IPTObjectNameGetter g, IPTSession s, boolean a)
	{
		ptNameGetter     = g;
		ptSession		 = s;
		ascending		 = a;
	}

	/**
	 * 
	 *
	 * @param o1 
	 * @param o2 
	 *
	 * @return 
	 */
	public int Compare(Object o1, Object o2)
	{
		PTObjectIdNamePair p1 = (PTObjectIdNamePair) o1;
		PTObjectIdNamePair p2 = (PTObjectIdNamePair) o2;

		if (p1.id == p2.id)
		{
			return 0;
		}

		String name1 = (p1.name == null)
			? ptNameGetter.GetName(p1.id, ptSession) : p1.name;
		String name2 = (p2.name == null)
			? ptNameGetter.GetName(p2.id, ptSession) : p2.name;
		int result   = ((name1 == null) || (name2 == null)) ? 0
															: name1.compareTo(name2);

		if (!ascending)
		{
			result = -result;
		}

		return result;
	}

	/**
	 * 
	 *
	 * @param o1 
	 * @param o2 
	 *
	 * @return 
	 */
	public int compare(Object o1, Object o2)
	{
		return Compare(o1, o2);
	}
}

