/*
 * Created on Mar 5, 2003
 *
 */
package com.plumtree.portalpages.common.plugnav;

import com.plumtree.openfoundation.util.*;

/**
 * Useful helper class that forms a list of all possible 
 * page types for pluggable navigation
 * 
 * @author DavidP
 *
 */
public class NavCategoryHelper 
{
		
	private XPArrayList navCategoryArray = null;
	
	public static final NavCategoryHelper INSTANCE = new NavCategoryHelper();
	
	/**
	 * Constructs helper class with accessors for array of page types.
	 */
	private NavCategoryHelper()
	{
		navCategoryArray = new XPArrayList();
		
		for (int i=0;i < NavCategoryType.m_navCategoryTypes.length; ++i)
		{
			navCategoryArray.Add(NavCategoryType.m_navCategoryTypes[i]);	
		}
	}
	
	/**
	 * Enumerates the possible page types available.
	 * @return IXPEnumerator
	 */
	public IXPEnumerator GetCategoryTypes()
	{
		IXPEnumerator eKeys  = null;
		if (navCategoryArray != null && navCategoryArray.GetSize() > 0)
		{
			eKeys  = navCategoryArray.GetEnumerator(); 
		}
		
		return eKeys;
	}
	
	/**
	 * Enumerates the possible page types available.
	 * @return XPArrayList
	 */
	public XPArrayList GetCategoryTypeArray()
	{
		return navCategoryArray; 
	}

	/**
	 * Returns the number of page types.
	 * @return int
	 */
	public int GetNumCategoryTypes()
	{
		if (navCategoryArray != null)
		{
			return navCategoryArray.GetSize();
		}
		
		return 0;
	}	
}

