/*
 * Created on Mar 7, 2003
 */
package com.plumtree.portalpages.common.plugnav;

/**
 * Navigation link category types.  These are *different* from NavPageType because they 
 * represent groups of navigation links, and are independent of the "page type" actually 
 * showing in the center of the page.  Example: Mandatory linkshave nothing to do with 
 * the page you're on.
 *  
 * @author DavidP
 */
public class NavCategoryType 
{
	private String m_className;
	
	// enumeration of navigation link category types
	public static final NavCategoryType ADMIN = new NavCategoryType("ADMIN");				 // Administrator
	public static final NavCategoryType MYPAGE = new NavCategoryType("MYPAGE");				 // My Pages
	public static final NavCategoryType COMMUNITY = new NavCategoryType("COMMUNITY");		 // Community Pages
	public static final NavCategoryType DIRECTORY = new NavCategoryType("DIRECTORY");		 // Directory
	public static final NavCategoryType MANDATORYLINK = new NavCategoryType("MANDATORYLINK"); // (name of mandatory links folder)
	public static final NavCategoryType MANDATORYTABS = new NavCategoryType("MANDATORYTABS"); // Mandatory Communities
	public static final NavCategoryType MYCOMMUNITIES = new NavCategoryType("MYCOMMUNITIES"); // My Communities
	public static final NavCategoryType MYHOME = new NavCategoryType("MYHOME"); // My Home
	
	// array of navigation link category types
	public static final NavCategoryType[] m_navCategoryTypes = 
		{ 
			ADMIN,
			MYPAGE,
			COMMUNITY,
			DIRECTORY,
			MANDATORYLINK,
			MANDATORYTABS,
			MYCOMMUNITIES,
			MYHOME
		};
	
	/**
	 * @param className
	 */
	private NavCategoryType(String className)
	{
		m_className = className;
	}
	
	/**
	 * 
	 * @see java.lang.Object#toString()
	 */
	public String toString()
	{
		return m_className;
	}
	
	/**
	 * Hash ID
	 * @return int
	 */
	public int GetID()
	{
		return m_className.hashCode();
	}
	
	/**
	 * 
	 * @see java.lang.Object#equals(Object)
	 */
	public final boolean equals(Object o)
	{
		boolean retval = false;
		try 
		{
			retval = ((NavCategoryType)o).toString().equals(m_className);
		}
		catch( Exception e )
		{
		}
		
		return retval;
	}

}


