/*
 * Created on Mar 5, 2003
 *
 */
package com.plumtree.portalpages.common.plugnav;

import com.plumtree.openfoundation.util.*;

/**
 * Useful helper class that forms a list of all possible 
 * page types for pluggable navigation
 * 
 * @author DavidP
 *
 */
public class NavPageHelper 
{
		
	private XPArrayList navPageArray = null;
	
	public static final NavPageHelper INSTANCE = new NavPageHelper();
	
	/**
	 * Constructs helper class with accessors for array of page types.
	 */
	private NavPageHelper()
	{
		navPageArray = new XPArrayList();
		
		for (int i=0;i < NavPageType.m_navPageTypes.length; ++i)
		{
			navPageArray.Add(NavPageType.m_navPageTypes[i]);	
		}
	}
	
	/**
	 * Enumerates the possible page types available.
	 * @return IXPEnumerator
	 */
	public IXPEnumerator GetPageTypes()
	{
		IXPEnumerator eKeys  = null;
		if (navPageArray != null && navPageArray.GetSize() > 0)
		{
			eKeys  = navPageArray.GetEnumerator(); 
		}
		
		return eKeys;
	}
	
	/**
	 * Enumerates the possible page types available.
	 * @return XPArrayList
	 */
	public XPArrayList GetPageTypeArray()
	{
		return navPageArray; 
	}

	/**
	 * Returns the number of page types.
	 * @return int
	 */
	public int GetNumPageTypes()
	{
		if (navPageArray != null)
		{
			return navPageArray.GetSize();
		}
		
		return 0;
	}	
}

