/*
 * Created on Mar 5, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package com.plumtree.portalpages.common.plugnav;


/**
 * Navigation page type: Java typesafe enumerator class for page types in navigation.
 * Not the same as NavCategoryType, which refers to organized named groups of links.
 * This represent the core page you're on within navigation.  Example: Community page.
 * 
 * @author DavidP
 *
 */
public class NavPageType extends Object
{	
	private String m_className;
	
	// enumeration of page types
	public static final NavPageType COMMUNITY = new NavPageType("COMMUNITY");
	public static final NavPageType DIRECTORY = new NavPageType("DIRECTORY");
	public static final NavPageType USERPROFILE = new NavPageType("USERPROFILE");
	public static final NavPageType LOGIN = new NavPageType("LOGIN");
	public static final NavPageType MYPAGE = new NavPageType("MYPAGE");
	public static final NavPageType COMMUNITYPREVIEW = new NavPageType("COMMUNITYPREVIEW");
	/**
	 * Unknown pagetype, the current page is not among one of the unsupported pagetypes.
	 */
	public static final NavPageType UNKNOWN = new NavPageType("UNKNOWN");
	
	// array of page types
	public static final NavPageType[] m_navPageTypes = 
		{ 
			COMMUNITY,
			COMMUNITYPREVIEW,
			DIRECTORY,
			LOGIN,
			MYPAGE,
			USERPROFILE,
			UNKNOWN
		};
	
	/**
	 * @param navModel
	 */
	private NavPageType(String className)
	{
		m_className = className;
	}
	
	/**
	 * 
	 * @see java.lang.Object#toString()
	 */
	public String toString()
	{
		return m_className;
	}
	
	/**
	 * Get the Hash ID
	 * @return int
	 */
	public int GetID()
	{
		return m_className.hashCode();
	}
	
	/**
	 * 
	 * @see java.lang.Object#equals(Object)
	 */
	public final boolean equals(Object o)
	{
		boolean retval = false;
		try 
		{
			retval = ((NavPageType)o).toString().equals(m_className);
		}
		catch( Exception e )
		{
		}
		
		return retval;
	}
}

