package com.plumtree.portalpages.common.search;

import com.plumtree.portaluiinfrastructure.filter.*;
import com.plumtree.uiinfrastructure.pagecontrols.framework.*;
import com.plumtree.uiinfrastructure.pagecontrols.jsdatetimepicker.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author CraigS, based on MikeS
 *
 *   Interface that both DynamicQueryTable and RepostQueryTable implement;
 *   allows them to be used interchangably
 */
public interface IFilterQueryTable
{
	/**
	 * 
	 *
	 * @param bOperator 
	 */
	public void SetAllMustPass(boolean bOperator);

	/**
	 * 
	 *
	 * @param qc 
	 */
	public void SetBlankQueryCondition(QueryCondition qc);

	/**
	 * 
	 *
	 * @param s 
	 */
	public void SetExtraRowBelowGroupHeader(String s);

	/**
	 * 
	 *
	 * @param e 
	 */
	public void SetExtraRowBelowGroupHeader(HTMLElement e);

  public void SetHideGroupHeaderRow(boolean hide);

	/**
	 * 
	 *
	 * @param label 
	 */
	public void SetLabel(String label);

	/**
	 * 
	 *
	 * @param b 
	 */
	public void SetSuppressCheckbox(boolean b);

	/**
	 * 
	 *
	 * @param nRows 
	 */
	public void SetTableSize(int nRows);

	/**
	 * 
	 *
	 * @param b 
	 */
	public void SetUseVerboseTerminology(boolean b);

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean GetAllMustPass();

	/**
	 * 
	 *
	 * @param iIndex 
	 *
	 * @return 
	 */
	public QueryCondition GetDefinedQueryCondition(int iIndex);

	/**
	 * 
	 *
	 * @param result 
	 * @param showErrorsNextToInputs 
	 */
	public void addTableToCollection(HTMLElementCollection result,
                                   boolean showErrorsNextToInputs,
                                   JSDateTimePickerMgr jsDateTimePickerMgr, PageMgr _ptPageMgr);

	/**
	 * 
	 *
	 * @param qc 
	 */
	public void loadDefinedQueryCondition(QueryCondition qc);

	/**
	 * 
	 *
	 * @param iIndex 
	 */
	public void removeDefinedQueryCondition(int iIndex);
}

