package com.plumtree.portalpages.common.search;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This is based on MikeS/OlegS code
 * 
 *  @author CraigS
 */
public interface ITypeSelectorModelRO extends IModelRO
{
	/**
	 * 
	 *
	 * @return 
	 */
	public boolean AreDetailedOptionsShown();

	/**
	 * Returns a collection of all selected types (as Strings)
	 */
	public IXPCollection GetSelectedTypes();

	/**
	 * Returns true if the given type is selected
	 */
	public boolean IsTypeSelected(int type);

	/**
	 * Returns true if admin objects (CLASSID_ENDUSERCOUNT .. DETAILEDCOUNT-1) should be selectable
	 */
  public boolean ShouldDisplayAdminObjects();

	/**
	 * Returns true if the user can see an alternate view that lists abstractified
   * types and applications instead of the longer list of detailed types
	 */
  public boolean ShowAbstractTypeView();
  
  public int[] GetOrderedClassIds();
  
  public boolean ContentInstalled();
  
  public boolean CollabInstalled();
}

