package com.plumtree.portalpages.common.search;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.search.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 *  @author CraigS
 */
public class SimpleSelectorModel extends EditorHelperModel
	implements ISimpleSelectorModelRO
{
	
	public static final String STR_MVC_CLASS_NAME = "SimpleSelector";
	private String _elementName;
	private String _promptText;
	private String _title;
	private String[] _possibleSelections;
	private int _currentSelection;

	/**
	 * 
	 *
	 * @return 
	 */
	public Object Create()
	{
		return new SimpleSelectorModel();
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public int GetCurrentSelection()
	{
		return _currentSelection;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetElementName()
	{
		return _elementName;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String[] GetPossibleSelections()
	{
		return _possibleSelections;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetPromptText()
	{
		return _promptText;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetTitle()
	{
		return _title;
	}

	/**
	 * 
	 *
	 * @param possibleSelections 
	 * @param initialSelection 
	 * @param title 
	 * @param promptText 
	 * @param elementName 
	 */
	public void InitializePlugIn(String[] possibleSelections,
		int initialSelection, String title, String promptText,
		String elementName)
	{
		_possibleSelections     = possibleSelections;
		_currentSelection	    = initialSelection;
		_title				    = title;
		_promptText			    = promptText;
		_elementName		    = elementName;
	}

	/**
	 * 
	 *
	 * @param formData 
	 *
	 * @return 
	 */
	public int SaveSection(XPHashtable formData)
	{
		String[] data = (String[]) formData.GetElement(_elementName);

		if ((null != data) && (data.length > 0))
		{
			try
			{
				_currentSelection = XPConvert.ToInteger(data[0]);
			}
			catch (Exception e)
			{
				throw XPException.GetInstance(e);
			}
		}

		return RepostControl.PAGE_STATUS_VALID;
	}
	
	public void SetSelectionFromFormData(XPHashtable formData)
	{
		if(_possibleSelections == null || _possibleSelections.length == 0 || formData == null)
			return;
			
		String[] numRes = (String[]) formData.GetElement(StartSearchControl.REQUIRED_CONSTRAINT_PREFIX +
								SearchSettingCollection.PT_SEARCHSETTING_MAXRESULTS_S);

		if ((null != numRes) && (numRes.length > 0))
		{
			try
			{		
				for(int i = 0; i < _possibleSelections.length; i++)
					if(_possibleSelections[i].equals(numRes[0]))
					{
						_currentSelection = i;
						return;
					}
			}
			catch(Exception e)
			{
			}
		}
	}
}

