package com.plumtree.portalpages.common.uiparts;

/**
 * @author robertz
 *
 */
public class NavTypeConstants 
{
	 
	/**
	 * IDs for Plumtree's intrinsic navigation schemas
	 */
	public static final int	NAVTYPE_ID_HORIZONTAL_DHTML_DROPDOWN		= -1;  // so as not to renumber navs
	public static final int	NAVTYPE_ID_HORIZONTAL_COMBOBOX_DROPDOWN 	= -2;
	public static final int	NAVTYPE_ID_VERTICAL_TABGROUPSLEFT	 		= -3;
	public static final int	NAVTYPE_ID_VERTICAL_SIMPLELEFT 				= -4;	
	public static final int	NAVTYPE_ID_NULL_MANDATORY_ONLY		 		= -5;
	public static final int	NAVTYPE_ID_NULL						 		= -6;
	public static final int	NAVTYPE_ID_HORIZONTAL_DHTML_DROPDOWN_JSPORTALMENU	= -7;
	public static final int NAVTYPE_ID_ACCESSIBLE						= -8; // 508 compliant nav
	public static final int NAVTYPE_ID_PORTLETNAV						= -9; 

	/**
	 * The navigation type used in the 508 portal
	 */
	public static final int NAVTYPE_ID_508COMPLIANT					= NAVTYPE_ID_ACCESSIBLE;

	/**
	 * Default navigation schema to be used in the case of invalid schema
	 * being stored. Eg when subportal is set to use a custom schema that
	 * has been removed.
	 */
	public static final int NAV_TYPE_ID_DEFAULT						= NAVTYPE_ID_HORIZONTAL_DHTML_DROPDOWN_JSPORTALMENU;
	
	/**
	 * Starting ID for custom navigation schemas. This is used by TestExtNav.
	 * New navigations should use a positive offset from this base ID.
	 */
	public static final int NAV_TYPE_ID_BASE						= 100;
}

