package com.plumtree.portalpages.common.uiparts;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 * @author DustinA
 */
public class RulesDebugMSGModel implements IRepostModel {

    public static final String STR_MVC_CLASS_NAME = "RulesDebugMSGModel";
    
    private AActivitySpace m_asOwner;
    
    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.form.IRepostModel#Finish()
     */
    public void Finish() {
        // DCA - we don't need to do anything here
    }

    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.form.IRepostModel#GetRedirectAfterFinish()
     */
    public Redirect GetRedirectAfterFinish() {
        Redirect result = new Redirect();

		// JF- If the parent space is already in the cache, we redirect to it.
		if (null != m_asOwner.GetParentSpace())
		{
			result.SetLinkGetCachedSpace(m_asOwner.GetParentSpace());
		}
		// JF- If not, we redirect to a new one.
		else
		{	
			result.SetLinkCreateNewSpace(m_asOwner.GetParentSpaceName(), m_asOwner);
		}

		return (result);
    }

    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.form.IRepostModel#SavePage(java.lang.String, com.plumtree.openfoundation.util.XPHashtable)
     */
    public int SavePage(String arg0, XPHashtable arg1) {
        return RepostControl.PAGE_STATUS_VALID;
    }

    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IModel#CleanupTempData()
     */
    public void CleanupTempData() {
        // DCA - we don't need to do anything here
    }

    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IModel#CleanupAllData()
     */
    public void CleanupAllData() {
        // DCA - we don't need to do anything here
    }

    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IModel#Init(com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
     */
    public void Init(AActivitySpace parent) {
        m_asOwner = parent;
    }

    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
     */
    public String GetName() {
        return STR_MVC_CLASS_NAME;
    }

    /* (non-Javadoc)
     * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
     */
    public Object Create() {
        return new RulesDebugMSGModel();
    }

}
