/*
 * Created on Mar 5, 2003
 */
package com.plumtree.portalpages.common.uiparts.navpagetype;

import com.plumtree.portalpages.common.plugnav.*;
import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.portaluiinfrastructure.compoundlist.*;

/**
 * Delegates model methods only usable by community preview page.
 * 
 * @author DavidP
 */
public class CommunityPreviewNavPage extends NavigationPage implements ICommunityPreviewNavPageRO 
{
	/**	
	 * Unique String Name of category of object.  Critical for link blocking by pluggable nav.
	 */
	public String GetName()
	{
		return NavPageType.COMMUNITYPREVIEW.toString();
	}
	
	/**
	 * CommunityNavPage constructor.   
	 * @param model
	 */
	public CommunityPreviewNavPage(INavigationModelRO model)
	{
		super(model,NavPageType.COMMUNITYPREVIEW);
	}

	/**
	 * 
	 * @see com.plumtree.portalpages.common.plugnav.ICommunityPreviewNavPageRO#GetAccessibleCommunityID(int)
	 */
	public int GetAccessibleCommunityID(int nSubPortalCommID)
	{
		return m_model.GetAccessibleCommunityID(nSubPortalCommID);
	}

	/**
	 * 
	 * @see com.plumtree.portalpages.common.plugnav.ICommunityPreviewNavPageRO#GetCurCommunityID()
	 */
	public int GetCurCommunityID()
	{
		return m_model.GetCurCommunityID();
	}

	/**
	 * 
	 * @see com.plumtree.portalpages.common.plugnav.ICommunityPreviewNavPageRO#GetCurCommunityName()
	 */
	public String GetCurCommunityName()
	{
		return m_model.GetCurCommunityName();
	}

	/**
	 * 
	 * @see com.plumtree.portalpages.common.plugnav.ICommunityPreviewNavPageRO#GetCurRelCommunities()
	 */
	public ICPListEntryIterator GetCurRelCommunities()
	{
		return m_model.GetCurRelCommunities();
	}

	/**
	 * 
	 * @see com.plumtree.portalpages.common.plugnav.ICommunityPreviewNavPageRO#GetCurSubCommunities()
	 */
	public ICPListEntryIterator GetCurSubCommunities()
	{
		return m_model.GetCurSubCommunities();
	}

	/**
	 * 
	 * @see com.plumtree.portalpages.common.plugnav.ICommunityPreviewNavPageRO#GetDefaultCommunity()
	 */
	public int GetDefaultCommunity()
	{
		return m_model.GetDefaultCommunity();
	}

	/**
	 * 
	 * @see com.plumtree.portalpages.common.plugnav.ICommunityPreviewNavPageRO#GetMyCommunities(boolean)
	 */
	public ICPListEntryIterator GetMyCommunities(boolean bListActions)
	{
		return m_model.GetMyCommunities(bListActions);
	}

	/**
	 * 
	 * @see com.plumtree.portalpages.common.plugnav.ICommunityPreviewNavPageRO#GetParentComm()
	 */
	public ICPListEntryIterator GetParentComm()
	{
		return m_model.GetParentComm();
	}

	/**
	 * 
	 * @see com.plumtree.portalpages.common.plugnav.ICommunityPreviewNavPageRO#IsCurCommOwner()
	 */
	public boolean IsCurCommOwner()
	{
		return m_model.IsCurCommOwner();
	}
}

