package com.plumtree.portalpages.condition.conditiontypes;

import com.plumtree.uiinfrastructure.arraywrapper.*;
import com.plumtree.uiinfrastructure.expandablelist.growablelist.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author dustina
 */
public class IPAddressListView extends GrowableListView {
	
	/**
	 * Class name for the activity space */
	public static final String STR_MVC_CLASS_NAME = "IPAddressListView";
	
	public static final String HTMLINPUT_IPBOX_1 = "in_tx_IPBox1";
	public static final String HTMLINPUT_IPBOX_2 = "in_tx_IPBox2";
	public static final String HTMLINPUT_IPBOX_3 = "in_tx_IPBox3";
	public static final String HTMLINPUT_IPBOX_4 = "in_tx_IPBox4";
	
	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new IPAddressListView();
	}
	
	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
		
	/**
	 * Returns the HTML for the row _nRowIndex.
	 * Each row contains just an icon and input text.
	 *
	 * @param _saData
	 * @param _nRowIndex
	 *
	 * @return HTMLElement
	 */
	public HTMLElement GetHTMLForRow(IPTGrowableSortedArrayWrapperRO _saData,
		int _nRowIndex)
	{
		HTMLTableCell myCell;
		HTMLInput myInput;

		myCell = new HTMLTableCell();
		myCell.SetWidth("100%");
		myCell.SetHeight("30");
		myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
		myCell.SetNoWrap(true);
		myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

		// row icon
		PTImageType imgRowIcon = ((IGrowableListModelRO) m_model).GetRowIcon();

		if (null != imgRowIcon)
		{
			myCell.AddInnerHTMLElement(GetHTMLForIcon(imgRowIcon));
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
		}

		// input text
		myInput = new HTMLInput(HTMLInputTypes.TEXT,
			((IGrowableListModelRO) m_model).GetUniqueString(HTMLINPUT_IPBOX_1) + _nRowIndex, "");
		myCell.AddInnerHTMLElement(myInput);
		myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
		myInput.SetValue((String) _saData.GetItem(_nRowIndex, IPAddressListModel.EXPLIST_IPBOX_1));
		myInput.SetMaxLength("3");
		myInput.SetSize("3");
		
		myCell.AddInnerHTMLString(" <b>.</b> ");
		
		myInput = new HTMLInput(HTMLInputTypes.TEXT,
			((IGrowableListModelRO) m_model).GetUniqueString(HTMLINPUT_IPBOX_2) + _nRowIndex, "");
		myCell.AddInnerHTMLElement(myInput);
		myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
		myInput.SetValue((String) _saData.GetItem(_nRowIndex, IPAddressListModel.EXPLIST_IPBOX_2));
		myInput.SetMaxLength("3");
		myInput.SetSize("3");
		
		myCell.AddInnerHTMLString(" <b>.</b> ");
		
		myInput = new HTMLInput(HTMLInputTypes.TEXT,
			((IGrowableListModelRO) m_model).GetUniqueString(HTMLINPUT_IPBOX_3) + _nRowIndex, "");
		myCell.AddInnerHTMLElement(myInput);
		myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
		myInput.SetValue((String) _saData.GetItem(_nRowIndex, IPAddressListModel.EXPLIST_IPBOX_3));
		myInput.SetMaxLength("3");
		myInput.SetSize("3");
				
		myCell.AddInnerHTMLString(" <b>.</b> ");
		
		myInput = new HTMLInput(HTMLInputTypes.TEXT,
			((IGrowableListModelRO) m_model).GetUniqueString(HTMLINPUT_IPBOX_4) + _nRowIndex, "");
		myCell.AddInnerHTMLElement(myInput);
		myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
		myInput.SetValue((String) _saData.GetItem(_nRowIndex, IPAddressListModel.EXPLIST_IPBOX_4));
		myInput.SetMaxLength("3");
		myInput.SetSize("3");

		return myCell;
	}
}
