package com.plumtree.portalpages.devices.choosepage.common;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.devices.mypage.common.*;
import com.plumtree.uiinfrastructure.activityspace.*;


/**
 * @author SudhaS
 *
 */

public class ChoosePageDevicesControl implements IControl
{
    
    public static final String STR_MVC_CLASS_NAME = "ChoosePageDevices_Devices";

    
    public static final String m_strPORTAL_SETTINGS_DATA = "ChoosePageDevices_Devices";
    
    
    
    private AActivitySpace m_asasParent;
    private IChoosePageDevicesModelRO m_asmModel;

    /**
     * @see com.plumtree.xpshared.portalinfrastructure.activityspace.IControl#Execute()
     */
    public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
    	
        ChoosePageDevicesModel myChoosePageDevicesModel = (ChoosePageDevicesModel) m_asasParent.GetModel(ChoosePageDevicesModel.STR_MVC_CLASS_NAME);

		//SS - The current display screen for a device
        String[] sValues = (String[]) arguments.GetElement(MyPageDevicesControl.STR_LIST_ID);
        int nListID      = 0;

        if (sValues != null)
        {
            nListID = XPConvert.ToInteger(sValues[0]);
        }

        myChoosePageDevicesModel.SetListID(nListID);
        

        return null;
    }

    /**
     * @see com.plumtree.xpshared.infrastructure.activityspace.IManagedObject#Create()
     */
    public Object Create()
    {
        return new ChoosePageDevicesControl();
    }

    /**
     * @see com.plumtree.xpshared.portalinfrastructure.activityspace.IControl#GetName()
     */
    public String GetName()
    {
        return STR_MVC_CLASS_NAME;
    }

    /**
     * @see com.plumtree.xpshared.portalinfrastructure.activityspace.IControl#Init(IModel, AActivitySpace)
     */
    public void Init(IModel model, AActivitySpace space)
    {
        m_asmModel   = (IChoosePageDevicesModelRO) model;
        m_asasParent = space;
    }
}
