package com.plumtree.portalpages.devices.login.common;

import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.resultwrapper.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author SudhaS
 *
 */
public class LoginDevicesModel implements ILoginDevicesModelRO, IModel
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_DEVICES),
		"com.plumtree.portalpages.devices.login.common.LoginDevicesModel");

	
	public static final String STR_MVC_CLASS_NAME = "Login_Devices";

	private AActivitySpace m_asOwner;
	private Redirect m_Redirect = null;

	/**
	 * 
	 */
	public void CleanupTempData()
	{
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IModel#CleanupAllData()
	 */
	public void CleanupAllData()
	{
	}

	/**
	* @see com.plumtree.xpshared.infrastructure.activityspace.IManagedObject#Create()
	*/
	public Object Create()
	{
		return new LoginDevicesModel();
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String[][] GetAuthSources()
	{
		//SS - Query the authsources and return an enumeration of the name,
		//prefix, and description
		
		IPTObjectManager omAuthSources			  = ((IPTSession) m_asOwner.GetUserSession()).GetAuthSources();
		PTObjectManagerQueryWrapper qrAuthSources = new PTObjectManagerQueryWrapper(omAuthSources);
		int fields								  = PT_PROPIDS.PT_PROPID_NAME | PT_PROPIDS.PT_PROPID_DESCRIPTION |
			PT_PROPIDS.PT_PROPID_AUTHSOURCE_PREFIXSTRING;

		qrAuthSources.Query(fields, -1, null, null);

		String[][] aAuthSources = new String[qrAuthSources.GetCount()][3];

		for (int i = 0; i < qrAuthSources.GetCount(); i++)
		{
			aAuthSources[i][0]     = (String) qrAuthSources.GetItem(i,
								PT_PROPIDS.PT_PROPID_NAME);
			aAuthSources[i][1]     = (String) qrAuthSources.GetItem(i,
					PT_PROPIDS.PT_PROPID_AUTHSOURCE_PREFIXSTRING);
			aAuthSources[i][2]     = (String) qrAuthSources.GetItem(i,
								PT_PROPIDS.PT_PROPID_DESCRIPTION);
		}

		return aAuthSources;
	}

	public boolean GetIsNumericLogin()
	{
		
			log.Debug("Obtaining from portal server");
		

		IPTSession ptSession = (IPTSession) m_asOwner.GetUserSession();

		if (ptSession.GetSettingsAsInt(PT_SESSION_SETTINGS.PT_SESSION_NUMERICAUTH) == 1)
		{
			return true;
		}
		
		return false;
	}
	
	public void SetRedirect(Redirect _redirect)
	{
		m_Redirect = _redirect;
	}
	
	public Redirect GetRedirect()
	{
		return m_Redirect;
	}

	/**
	* Returns the Class name.
	*
	* @return String
	*/
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @param _asOwner 
	 */
	public void Init(AActivitySpace _asOwner)
	{
		m_asOwner = _asOwner;
	}
}

