package com.plumtree.portalpages.devices.login.wml;


import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.devices.login.common.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.devices.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author SudhaS
 *
 */


public class LoginDevicesView_WML implements IDevicesView
{
	
	public static final String STR_MVC_CLASS_NAME = "Login_WML";


	
	
	
	
	
	
	private AActivitySpace m_asOwner;
	private ILoginDevicesModelRO m_asmModel;

	/**
	 * 
	 *
	 * @return 
	 */
	public Object Create()
	{
		return new LoginDevicesView_WML();
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public HTMLElement Display()
	{
		return null;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public HTMLScript DisplayJavascript()
	{
		return null;
	}

	/**
	 * @see com.plumtree.xpshared.portalinfrastructure.activityspace.IView#Display()
	 */
	public String DisplayString()
	{
		XPStringBuilder sb;

		sb = new XPStringBuilder();

		sb.Append("<template>\n");
		sb.Append("		<do type=\"prev\"><noop/></do>\n");
		sb.Append("</template>\n");
		sb.Append(
			"<card id=\"LoginMain\" title=\"Login\" newcontext=\"true\">\n");
		sb.Append("<p align=\"center\" mode=\"wrap\">\n");
		sb.Append("<b>" + m_asOwner.GetString(1418, "ptmsgs_portalbrowsingmsgs") + "</b><br/>\n");
		
		
		sb.Append("</p>");
		sb.Append("<p align=\"left\" mode=\"nowrap\">\n");
		
	
		//SS - Only allow numeric input
		if (m_asmModel.GetIsNumericLogin())
		{
			sb.Append("Login ID: <br/>\n");
			sb.Append("		<input  name=\"" + LoginDevicesControl.HTML_INPUT_NAME +
				"\" format=\"*N\" value=\"\"/><br/>\n");
			sb.Append("PIN: <br/>\n");
			sb.Append("		<input  name=\"" + LoginDevicesControl.HTML_INPUT_PASSWORD +
				"\" type=\"password\" format=\"*N\" value=\"\"/><br/>\n");
		}
		else
		{
		
			sb.Append("User Name: <br/>\n");
			sb.Append("		<input  name=\"" + LoginDevicesControl.HTML_INPUT_NAME +
				"\" format=\"*N\" value=\"\"/><br/>\n");
			sb.Append("Password: <br/>\n");
			sb.Append("		<input  name=\"" + LoginDevicesControl.HTML_INPUT_PASSWORD +
				"\" type=\"password\" format=\"*N\" value=\"\"/><br/>\n");
			sb.Append("		<select name=\"" + LoginDevicesControl.HTML_INPUT_AUTHSRC +
				"\" id=\"login_authsrc\" value=\"\">\n");
	
			String[][] aAuthSources = m_asmModel.GetAuthSources();
	
			//SS - List the authsources
			for (int i = 0; i < aAuthSources.length; i++)
			{
				String strName   = aAuthSources[i][0];
				String strPrefix = aAuthSources[i][1];
				String strDesc   = aAuthSources[i][2];
		
				if (strPrefix == null)
				{
					strPrefix = "";
				}
							
				//SS - If there is no description, use the name for the auth src dropdown
				if ((strDesc == null) || (XPStringUtility.CompareIgnoreCase("", strDesc) == 0)) {
					sb.Append("			<option value=\"" + strPrefix + "\" id=\"Select" + i + "\">" + strName + "</option>\n");
				} else {
					sb.Append("			<option value=\"" + strPrefix + "\" id=\"Select" + i + "\">" + strDesc + "</option>\n");
				}
					
			}

			sb.Append("		</select>\n");
		}
		
		//SS - Create the login link
		ASURL myURL = new ASURL(m_asOwner);

		myURL.SetXMLEncoding(true);
		myURL.SetLinkCreateNewSpace("Login", m_asOwner);
		myURL.SetControl(LoginDevicesControl.STR_MVC_CLASS_NAME);
		myURL.AddControlArgument(LoginDevicesControl.DO_LOGIN, true);


		

		sb.Append(" 	<anchor title=\"Submit\">Log In\n");
		sb.Append("				<go method=\"post\" href=\"" + myURL.GetURLAsString() + "\">\n");
		
		
		sb.Append("					<postfield name=\"" + LoginDevicesControl.HTML_INPUT_NAME + "\" value=\"$(" +
			LoginDevicesControl.HTML_INPUT_NAME + ")\"/>\n");
		sb.Append("					<postfield name=\"" + LoginDevicesControl.HTML_INPUT_PASSWORD + "\" value=\"$(" +
			LoginDevicesControl.HTML_INPUT_PASSWORD + ")\"/>\n");
		sb.Append("					<postfield name=\"" + LoginDevicesControl.HTML_INPUT_AUTHSRC + "\" value=\"$(" +
			LoginDevicesControl.HTML_INPUT_AUTHSRC + ")\"/>\n");
		sb.Append("					<postfield name=\"" + LoginDevicesControl.DO_LOGIN + "\" value=\"$(" +
			LoginDevicesControl.DO_LOGIN + ")\"/>\n");
		sb.Append("					<postfield name=\"RedirectURL\" value=\"" +
			myURL.GetURLAsString() + "\"/>\n");
		
		
		sb.Append("				</go>\n");
		sb.Append("		</anchor>\n");


		//sb.Append("<a href=\"" + myURL.GetURLAsString() + "\">XYZ</a>");
		//sb.Append("<a href=\"" + strLink + "\">Boolahboolahboolah</a>");

		sb.Append("</p>\n");
		sb.Append("</card>\n");

		return (sb.ToString());
	}

	/**
	 * @see com.plumtree.xpshared.portalinfrastructure.activityspace.IView#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**PortalSettings
	 * @see com.plumtree.xpshared.portalinfrastructure.activityspace.IView#Init(IModelRO, AActivitySpace)
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		m_asmModel     = (ILoginDevicesModelRO) model;
		m_asOwner	   = parent;
	}
}

