package com.plumtree.portalpages.devices.mypage.common;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author SudhaS
 *
 */


public class MyPageDevicesControl implements IControl
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_DEVICES),
		"com.plumtree.portalpages.devices.mypage.common.MyPageDevicesControl");

	
	public static final String STR_MVC_CLASS_NAME = "MyPageDevices_Devices";

	//public static final String STR_MVC_CLASS_NAME = "MyPage_WML";
	
	public static final String STR_PAGE_ID = "PageID";

	
	public static final String STR_COMMUNITY_ID = "CommunityID";
	
	public static final String STR_PAGE_NAME	= "PageName";
	
		
	public static final String STR_LIST_ID = "ListID";

	
	public static final String m_strPORTAL_SETTINGS_DATA = "MyPage_WML";
	private AActivitySpace m_asasParent;
	private IMyPageDevicesModelRO m_asmModel;

	/**
	 * @see com.plumtree.xpshared.portalinfrastructure.activityspace.IControl#Execute()
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		MyPageDevicesModel myPageDevicesModel = (MyPageDevicesModel) m_asasParent.GetModel(MyPageDevicesModel.STR_MVC_CLASS_NAME);

		String[] sValues = (String[]) arguments.GetElement(STR_PAGE_ID);

		if (sValues == null)
		{
			
				log.Error("could not find page ID in query string.");
			

			return null;
		}
		


		int nPageID = XPConvert.ToInteger(sValues[0]);

		if (nPageID == 0)
		{
			IPTSession objSession = (IPTSession) m_asasParent.GetUserSession();
			int nUserID			  = objSession.GetSessionInfo().GetCurrentUserID();
			nPageID				  = -1 * nUserID;
		}

		myPageDevicesModel.SetPageID(nPageID);
		
		sValues = (String[]) arguments.GetElement(MyPageDevicesControl.STR_PAGE_NAME);
		if (sValues != null)
		{
			myPageDevicesModel.SetPageName(sValues[0]);
		}
		
		sValues = (String[]) arguments.GetElement(STR_PAGE_NAME);
		if (sValues != null) myPageDevicesModel.SetPageName(sValues[0]);

		sValues = (String[]) arguments.GetElement(STR_COMMUNITY_ID);

		if (sValues == null)
		{
			myPageDevicesModel.SetCommunityID(0);

			
				log.Info("could not find community ID in query string.");
			

			//return null;
		}
		else
		{
			int nCommunityID = XPConvert.ToInteger(sValues[0]);
			myPageDevicesModel.SetCommunityID(nCommunityID);
		}

		//SS - Create a link to the appropriate page
		ASURL myASURL = new ASURL(m_asasParent);
		myASURL.SetLinkGetCachedSpace(m_asasParent);
		myASURL.SetControl(STR_MVC_CLASS_NAME);
		myASURL.AddControlArgument(STR_PAGE_ID, nPageID);

		// we need to add ampersand at the end, so that PT-Return-URI + "#GID" will work.
		//		-- moose
		myPageDevicesModel.SetHostPageURI(myASURL.GetURLAsString() +
			LinkConstants.AMPERSAND);

		int nListID;
		sValues = (String[]) arguments.GetElement(STR_LIST_ID);

		if (sValues == null)
		{
			nListID = 0;
		}
		else
		{
			nListID = XPConvert.ToInteger(sValues[0]);
		}

		myPageDevicesModel.SetListID(nListID);

		return null;
	}

	/**
	 * @see com.plumtree.xpshared.infrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new MyPageDevicesControl();
	}

	/**
	 * @see com.plumtree.xpshared.portalinfrastructure.activityspace.IControl#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.xpshared.portalinfrastructure.activityspace.IControl#Init(IModel, AActivitySpace)
	 */
	public void Init(IModel model, AActivitySpace space)
	{
		m_asmModel		 = (IMyPageDevicesModelRO) model;
		m_asasParent     = space;
	}
}

