package com.plumtree.portalpages.devices.portlet.common;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.devices.mypage.common.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author SudhaS
 *
 */


public class PortletDevicesControl implements IControl
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_DEVICES),
		"com.plumtree.portalpages.devices.portlet.common.PortletDevicesControl");

	public static final String STR_GADGET_INDEX = "GadgetIndex";
	
	public static final String STR_PAGE_ID = "PageID";

	
	public static final String STR_COMMUNITY_ID = "CommunityID";

	
	public static final String STR_LIST_ID = "ListID";

	
	public static final String STR_MVC_CLASS_NAME = "PortletDevices_Devices";

	
	public static final String m_strPORTAL_SETTINGS_DATA = "PortletDevices_Devices";
	private AActivitySpace m_asasParent;
	private IPortletDevicesModelRO m_asmModel;

	/**
	 * @see com.plumtree.xpshared.portalinfrastructure.activityspace.IControl#Execute()
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		PortletDevicesModel gadgetDevicesModel = (PortletDevicesModel) m_asasParent.GetModel(PortletDevicesModel.STR_MVC_CLASS_NAME);

		String[] sValues = (String[]) arguments.GetElement(STR_PAGE_ID);

		if (sValues == null)
		{
			
				log.Error("could not find page ID in query string.");
			

			return null;
		}

		int nPageID = XPConvert.ToInteger(sValues[0]);

		if (nPageID == 0)
		{
			IPTSession objSession = (IPTSession) m_asasParent.GetUserSession();
			int nUserID			  = objSession.GetSessionInfo()
				.GetCurrentUserID();
			nPageID				  = -1 * nUserID;
		}

		gadgetDevicesModel.SetPageID(nPageID);
		
		sValues = (String[]) arguments.GetElement(MyPageDevicesControl.STR_PAGE_NAME);
		if (sValues != null)
		{
			gadgetDevicesModel.SetPageName(sValues[0]);
		}
		


		sValues = (String[]) arguments.GetElement(STR_COMMUNITY_ID);

		if (sValues == null)
		{
			gadgetDevicesModel.SetCommunityID(0);

			
				log.Info("could not find community ID in query string.");
			

			return null;
		}
		else
		{
			int nCommunityID = XPConvert.ToInteger(sValues[0]);
			gadgetDevicesModel.SetCommunityID(nCommunityID);
		}

		ASURL myASURL = new ASURL(m_asasParent);
		myASURL.SetLinkGetCachedSpace(m_asasParent);
		myASURL.SetControl(STR_MVC_CLASS_NAME);
		myASURL.AddControlArgument(STR_PAGE_ID, nPageID);

		// we need to add ampersand at the end, so that PT-Return-URI + "#GID" will work.
		//		-- moose
		gadgetDevicesModel.SetHostPageURI(myASURL.GetURLAsString() +
			LinkConstants.AMPERSAND);

		int nListID;
		sValues = (String[]) arguments.GetElement(STR_LIST_ID);

		if (sValues == null)
		{
			nListID = 0;
		}
		else
		{
			nListID = XPConvert.ToInteger(sValues[0]);
		}

		gadgetDevicesModel.SetListID(nListID);
		
		int nIndex;
		sValues = (String[]) arguments.GetElement(STR_GADGET_INDEX);

		if (sValues == null)
		{
			nIndex = 0;
		}
		else
		{
			nIndex = XPConvert.ToInteger(sValues[0]);
		}

		gadgetDevicesModel.SetIndex(nIndex);
		

		return null;
	}

	/**
	 * @see com.plumtree.xpshared.infrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new PortletDevicesControl();
	}

	/**
	 * @see com.plumtree.xpshared.portalinfrastructure.activityspace.IControl#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.xpshared.portalinfrastructure.activityspace.IControl#Init(IModel, AActivitySpace)
	 */
	public void Init(IModel model, AActivitySpace space)
	{
		m_asmModel		 = (IPortletDevicesModelRO) model;
		m_asasParent     = space;
	}
}

