package com.plumtree.portalpages.pei;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.pei.util.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This class handles validating new passwords for native users.
 * 
 * This does not affect LDAP users or other users stored in external user stores.
 */
public class PTCreateAccountActions implements ICreateAccountActions
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.pei.PTCreateAccountActions");

	public void OnAfterAcceptInvite(AActivitySpace _asCurrentSpace,
			IPTSession _ptUserSession, String _strInviteCode) {
	}

	public String OnBeforeCreateAccount(AActivitySpace _asCurrentSpace,
			IPTSession _ptUserSession, String _strUserName, String _strPassword)
	{
		PasswordValidator validator = new PasswordValidator();

		// This validates that the password follows the password strength rules.
		return validator.ValidatePassword(_strPassword, _strUserName, _asCurrentSpace, log);
	}
}