package com.plumtree.portalpages.pei;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.portalsettings.password.*;
import com.plumtree.portalpages.pei.util.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This class handles validating changed passwords for native users.
 * 
 * This does not affect LDAP users or other users stored in external user stores.
 */
public class PTPasswordActions implements IPasswordActions
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_BROWSING),
		"com.plumtree.portalpages.pei.PTPasswordActions");

	public String OnBeforeChangePassword(AActivitySpace _asCurrentSpace,
			IPTSession _ptUserSession, XPHashtable _htFormData)
	{
		// New password
		String[] sValues = (String[]) _htFormData.GetElement(PasswordView.HTML_INPUT_NEW_PASSWORD);

		if (sValues == null)
		{
			// No new password, let portal handle it.  The code that calls this PEI verifies
			// that the password exists.
			return null;
		}

		String strNewPassword = sValues[0];
		
		String strUserID = _ptUserSession.GetSessionInfo().GetCurrentUserLoginName();

		PasswordValidator validator = new PasswordValidator();

		// This validates that the password follows the password strength rules.
		return validator.ValidatePassword(strNewPassword, strUserID, _asCurrentSpace, log);
	}
}