package com.plumtree.portalpages.pei;

import com.plumtree.analytics.openusage.*;
import com.plumtree.portalpages.browsing.myportal.*;
import com.plumtree.portalpages.browsing.myportal.communities.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.pei.*;
import com.plumtree.xpshared.htmlelements.*;

public class ProfileViewActions implements IPageActions {

	public HTMLComment OnPageFinish(AActivitySpace _asCurrentSpace, Object _oUserSession, String _strServerName) {
		// DCA - check if page being viewed is a user profile page
		if (CommunityPageAS.STR_MVC_CLASS_NAME.equals(_asCurrentSpace.GetName())) {
			MyPortalModel portalModel = (MyPortalModel) _asCurrentSpace.GetModel(MyPortalModel.STR_MVC_CLASS_NAME);
			if (null != portalModel && portalModel.m_bIsProfilePage && portalModel.GetProfileID() > 0) {
				// DCA - user viewing profile page, send event to analytics
				// DCA - the USER_VIEW type event is defined in analytics
				IManagedEvent userView = ASEventFactory.createManagedEvent("USER_VIEW", "http://www.bea.com/analytics/graffiti");
				
				int nCurrentUserId = ((IPTSession) _oUserSession).GetSessionInfo().GetCurrentUserID();
				userView.setParameter("USER_ID", new Integer(nCurrentUserId));
				int nViewedUserId = portalModel.GetProfileID();
				userView.setParameter("VIEWED_USER_ID", new Integer(nViewedUserId));
				
				userView.sendEvent();
			}
		}
		return null;
	}

	public void OnPageStart(AActivitySpace _asCurrentSpace, Object _oUserSession, String _strServerName) {

	}

}
