package com.plumtree.portalpages.portlets.headerfooter;

import com.plumtree.openlog.OpenLogService;
import com.plumtree.openlog.OpenLogger;
import com.plumtree.portaluiinfrastructure.intrinsicportlets.*;
import com.plumtree.portaluiinfrastructure.statichelpers.PTDebugHelpers;

/**
 * An intrinsic portlet that wraps the DefaultHeaderView.
 * Assigned to the default Experience Definition.
 * 
 * @author DavidP
 */
public class StandardHeaderModel extends IntrinsicPortletModel 
{
	private static OpenLogger log = OpenLogService.GetLogger(
			OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_PORTLETS),
			"com.plumtree.portalpages.portlets.headerfooter.StandardHeaderModel");
	

	public static final String STR_MVC_CLASS_NAME = "StandardHeader";

	/* (non-Javadoc)
	 * @see com.plumtree.portaluiinfrastructure.intrinsicportlets.IIntrinsicPortletModelRO#ControlExists()
	 */
	public boolean ControlExists() 
	{
		return true;
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName() 
	{
		return STR_MVC_CLASS_NAME;
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create() 
	{
		return new StandardHeaderModel();
	}

	/* (non-Javadoc)
	 * @see com.plumtree.uiinfrastructure.activityspace.AClearModel#GetNewTempData()
	 */
	public Object GetNewTempData() 
	{
		return null;
	}

}
