package com.plumtree.portalpages.portlets.intrinsicpageletparamprefeditor;

import com.plumtree.portalpages.common.constants.*;
import com.plumtree.portaluiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * Activityspace to edit community preference for portlets for ensemble pagelets 
 * @author rozhang
 */
public class IntrinsicPrefsEditorForPageletParametersAS extends PTEditorAS
{
	public static final String STR_MVC_CLASS_NAME = "IntrinsicPrefsEditorForPageletParameters";

	/**
	 * 
	 * @see com.plumtree.uiinfrastructure.editor.EditorAS#Init()
	 */
	public void Init()
	{
		m_strModelName = IntrinsicPrefsEditorForPageletParametersModel.STR_MVC_CLASS_NAME;

		// Warning: m_strModelName must be initialized before super.Init() is called.
		super.Init();

		IModel myModel = GetModel(IntrinsicPrefsEditorForPageletParametersModel.STR_MVC_CLASS_NAME);


		// Register DisplayPages
		IntrinsicPrefsEditorForPageletParametersDP dp = new IntrinsicPrefsEditorForPageletParametersDP();
		RegisterPage(dp);

		// Register Views
		RegisterView(IntrinsicPrefsEditorForPageletParametersView.STR_MVC_CLASS_NAME, myModel);

		// Set default page
		SetCurrentPage(IntrinsicPrefsEditorForPageletParametersDP.STR_MVC_CLASS_NAME);

	}
	
	/**
	 * 
	 * @see com.plumtree.uiinfrastructure.editor.EditorAS#SetCurrentPage(com.plumtree.uiinfrastructure.activityspace.IDisplayPage)
	 */
	public void SetCurrentPage(IDisplayPage page)
	{
		super.SetCurrentPage(page);
	}
	
	
	/**
	 * 
	 * @see com.plumtree.uiinfrastructure.editor.EditorAS#GetEditorTitle()
	 */
	public String GetEditorTitle()
	{
		// Portlet Community Preferences 
		return GetString(1990, ResourceConstants.PORTALBROWSINGMSGS);
	}

	/**
	 * 
	 * @see com.plumtree.uiinfrastructure.form.AFormAS#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#Create()
	 */
	public Object Create()
	{
		return new IntrinsicPrefsEditorForPageletParametersAS();
	}

}
