package com.plumtree.portalpages.portlets.jobhistory;

import com.plumtree.portaluiinfrastructure.intrinsicportlets.*;
import com.plumtree.server.*;

/**
 * The read-only version of the Job History portlet model
 *
 * @author JohnH
 */
public interface IJobHistoryPortletModelRO extends IIntrinsicPortletModelRO
{
	/**
	 * Returns the portlet name
	 *
	 * @return String
	 */
	public String GetPortletName();
	
	/**
	 * Returns the log page currently being displayed.
	 * @return int
	 */
	public int GetCurrentLogPage();

	/**
	 * Returns CurrentPage setting.
	 *
	 * @return int
	 */
	public int GetCurrentPage();

	/**
	 * Returns the jobID.
	 *
	 * @return int
	 */
	public int GetJobID();

	/**
	 * Returns the jobName.
	 * @return String
	 */
	public String GetJobName();

	/**
	 * Returns the Plumtree Session object.
	 *
	 * @return IPTSession
	 */
	public IPTSession GetPTSession();

	/**
	 * Returns the job history row to display in the job log detail viewer.
	 *
	 * @return int
	 */
	public int GetRowToDisplay();

	/**
	 * Returns the runTime.
	 * @return String
	 */
	public String GetRunTime();

	/**
	 * Returns boolean indicating whether the last request was a log search.
	 *
	 * @return boolean
	 */
	public boolean IsSearchRequest();
	
	/**
	 * Returns the target string to be used for a log search.
	 *
	 * @return String
	 */
	public String GetSearchString();

}

