package com.plumtree.portalpages.portlets.savedsearch.prefs;

import com.plumtree.portaluiinfrastructure.intrinsicportlets.prefs.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * Display page for intrinsic portlet, which uses the the editor framework.
 *
 * @author mikes
 */
public class SavedSearchPortletPrefsDP extends EditorDP
{
	/** Class name for SavedSearchPortletPrefsDP */
	public static final String STR_MVC_CLASS_NAME = "SavedSearchPortletPrefs";

	/**
	 * Returns the String to display on the left navigation menu,  linking to
	 * that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return m_asOwner.GetString(471, "ptmsgs_portalcommonmsgs");
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for that Page.
	 *
	 * @return HTMLElement
	 *
	 * @throws HTMLException
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		// Determine what kind of prefs we are modifying.
		ISavedSearchPortletPrefsModelRO iModel = (ISavedSearchPortletPrefsModelRO) m_asOwner.GetModel(SavedSearchPortletPrefsModel.STR_MVC_CLASS_NAME);

		if (IntrinsicPortletPrefsEditorModel.PREF_TYPE_ADMIN == iModel.GetPrefType())
		{
			// sq Admin Prefs
			views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(SavedSearchPortletAdminPrefsView.STR_MVC_CLASS_NAME)).Display());
			
			// display fields exp list
			views.AddInnerHTMLElement(EditorView.GetSpacerTable());
			views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(SavedSearchPortletPrefsEditorAS.STR_MVC_SELECT_DISPLAY_FIELDS)).Display());

			// parameteric fields exp list
			views.AddInnerHTMLElement(EditorView.GetSpacerTable());
			views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(SavedSearchPortletPrefsEditorAS.STR_MVC_SELECT_PARAMETRIC_FIELDS)).Display());
		}

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		/* *****************************************
		 * EDITOR WITH NO HEADER AND NO LEFT NAV?
		 *
		 * Replace the code above with the 2 lines below:
		 *
		 * HTMLElementCollection result = new HTMLElementCollection();
		 * result.AddInnerHTMLElement(((EditorView)m_asOwner.GetView(SavedSearchPortletPrefsView.STR_MVC_CLASS_NAME)).Display());
		 *
		 ******************************************
		 */
		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 *
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild() 
	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		ISavedSearchPortletPrefsModelRO iModel = (ISavedSearchPortletPrefsModelRO) m_asOwner.
				GetModel(SavedSearchPortletPrefsModel.STR_MVC_CLASS_NAME);

		// Determine what kind of prefs we are modifying.
		if (IntrinsicPortletPrefsEditorModel.PREF_TYPE_ADMIN == iModel.GetPrefType())
		{
			HTMLScript myScript = m_asOwner.GetView(
			        SavedSearchPortletAdminPrefsView.STR_MVC_CLASS_NAME).DisplayJavascript();

			if (null != myScript)
			{
				myScripts.AddInnerHTMLElement(myScript);
			}
			
			myScripts.AddInnerHTMLElement(m_asOwner.
			        GetView(SavedSearchPortletPrefsEditorAS.STR_MVC_SELECT_DISPLAY_FIELDS).
			        	DisplayJavascript());

			myScripts.AddInnerHTMLElement(m_asOwner.
			        GetView(SavedSearchPortletPrefsEditorAS.STR_MVC_SELECT_PARAMETRIC_FIELDS).
			        	DisplayJavascript());
		}

		return myScripts;
	}
}

