package com.plumtree.portalpages.portlets.savedsearch.prefs;

import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.expandablelist.*;

/**
 * EditorRepostControl for our intrinsic portlet, which uses the editor
 * framework.
 *
 * @author mikes
 */
public class SavedSearchPortletPrefsRepostControl extends EditorRepostControl
{
	/** SavedSearchPortletPrefsRepost */
	public static final String STR_MVC_CLASS_NAME = "SavedSearchPortletPrefsRepost";

	/** Add an admin folder */
	public final static int POSTTOSELF_ACTION_CHANGESAVSRCHID = 10;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SavedSearchPortletPrefsRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Switch between the action modes and call  the associated method for each
	 * action.
	 *
	 * @param _nAction
	 */
	protected void PerformAction(int _nAction)
	{
		super.PerformAction(_nAction);

		((ExpListControl) m_asOwner.GetControl(SavedSearchPortletPrefsEditorAS.STR_MVC_SELECT_PARAMETRIC_FIELDS)).PerformRepostAction(_nAction, m_htFormData);
		((ExpListControl) m_asOwner.GetControl(SavedSearchPortletPrefsEditorAS.STR_MVC_SELECT_DISPLAY_FIELDS)).PerformRepostAction(_nAction, m_htFormData);
		((SavedSearchPortletPrefsModel) m_model).CheckDisplayFieldsInExpList();
		
		switch (_nAction)
		{
		case POSTTOSELF_ACTION_CHANGESAVSRCHID:
			((SavedSearchPortletPrefsModel) m_model).ChangeSavedSearchIDOnRepost();

			break;
		}
	}
}

