package com.plumtree.portalpages.portlets.search;

import com.plumtree.portalpages.browsing.search.results.*;
import com.plumtree.portaluiinfrastructure.intrinsicportlets.*;
import com.plumtree.server.*;

/**
 *  @author CraigS
 */
public class SearchPortletModel extends IntrinsicPortletModel
{
	
	public static final String STR_MVC_CLASS_NAME = "SearchPortlet";

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean ControlExists()
	{
		return false;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public Object Create()
	{
		return new SearchPortletModel();
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public Object GetNewTempData()
	{
		if (0 != m_nPageID)
		{
			return GetSettingValues(SETTINGSTYPE_PORTLET, (String[])null);
		}
		else
		{
			// We're in preview mode
			return null;
		}
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public Object[][] GetRecentSearches()
	{
		Object o = m_asOwner.GetSubSession().GetAttribute(BannerStartSearchControl.CACHED_RECENT_KEY);

		if ((null != o) && (o instanceof RecentSearchHistory))
		{
			RecentSearchHistory hist = (RecentSearchHistory) o;

			// Check that this was cached by the same user
			IPTSession session  = (IPTSession) m_asOwner.GetUserSession();
			IPTSessionInfo info = session.GetSessionInfo();

			if (info.GetCurrentUserID() == hist.userId)
			{
				return hist.recentSearches;
			}
		}

		return null;
	}
}

