package com.plumtree.portalpages.portlets.search;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.portaluiinfrastructure.intrinsicportlets.*;
import com.plumtree.portaluiinfrastructure.search.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 *  @author CraigS
 */
public class SearchPortletView extends IntrinsicPortletView
{
	public static final String STR_MVC_CLASS_NAME = SearchPortletModel.STR_MVC_CLASS_NAME;
	private SearchPortletModel _model;

	/**
	 *
	 *
	 * @return
	 */
	public Object Create()
	{
		return new SearchPortletView();
	}

	/**
	 *
	 *
	 * @return
	 */
	public HTMLScript DisplayJavascript()
	{
		return null;
	}

	/**
	 *
	 *
	 * @return
	 */
	public HTMLElement DisplayPortlet()
	{
		Object[][] saved = (Object[][]) _model.GetNewTempData();
		Object[][] recent = _model.GetRecentSearches();

		HTMLTable wrapperTable = new HTMLTable();

		try
		{
			wrapperTable.SetCellSpacing("0");
			wrapperTable.SetCellPadding("0");
			wrapperTable.SetBorder("0");
			wrapperTable.SetWidth("100%");

			HTMLTableRow wrapperRow = new HTMLTableRow();
			HTMLTableCell wrapperCell = new HTMLTableCell();
			wrapperRow.AddInnerHTMLElement(wrapperCell);
			wrapperTable.AddInnerHTMLElement(wrapperRow);
			wrapperRow.SetStyleClass(PTStyleClass.PLATPORTLET_LIGHT_BG);

			SearchFormFactory factory = new SearchFormFactory("searchportlet", "searchportlet", m_asOwner, 
			/* completeForm= */ true);
			factory.ForceBannerSearchDefaults();

			HTMLForm form = factory.GetForm();

			wrapperCell.AddInnerHTMLElement(form);

			HTMLTable table = new HTMLTable();
			table.SetCellSpacing("0");
			table.SetCellPadding("3");

			form.AddInnerHTMLElement(table);

			HTMLTableRow row = new HTMLTableRow();
			row.SetStyleClass(PTStyleClass.PLATPORTLET_LIGHT_BG);
			table.AddInnerHTMLElement(row);

			HTMLTableCell cell = new HTMLTableCell();
			cell.SetHeight("25");
			cell.SetVAlign("middle");
			row.AddInnerHTMLElement(cell);
			cell.SetStyleClass(PTStyleClass.OBJECTSEARCH_HEADER);
			cell.SetNoWrap(true);
			cell.AddInnerHTMLString(m_asOwner.GetString(566, "ptmsgs_portalcommonmsgs"));

			cell = new HTMLTableCell();
			cell.SetHeight("25");
			cell.SetVAlign("middle");

			HTMLInput input = new HTMLInput(HTMLInputTypes.TEXT, factory.GetInputBoxName(), "portletsearchbox");
			String keyDown = factory.GetInputBoxOnKeyDown();

			if (null != keyDown)
			{
				input.SetOnKeyDown(keyDown);
			}
                        else
                        {
                                // 508 mode - need alt and title tags for input box.  Use "Search for Text:" from advanced search
                                input.SetAlt(m_asOwner.GetString(737, "ptmsgs_portalcommonmsgs"));
                                input.SetTitle(m_asOwner.GetString(737, "ptmsgs_portalcommonmsgs"));
                        }

			input.SetSize("32");
			input.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
			cell.AddInnerHTMLElement(new HTMLGenericElement(" "));
			cell.AddInnerHTMLElement(input);
			row.AddInnerHTMLElement(cell);

			// Add submit button
			cell = new HTMLTableCell();
			cell.SetHeight("25");
			cell.SetVAlign("middle");
			row.AddInnerHTMLElement(cell);

			String onClick = factory.GetAnchorOnClick();

			if (null != onClick)
			{
				HTMLAnchor submitLink = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
				submitLink.SetOnClick(onClick);
				submitLink.AddInnerHTMLElement(SearchFormFactory.GetSearchButton(m_asOwner));
				cell.AddInnerHTMLElement(submitLink);
			}
			else
			{
				// 508 mode, use simple submit
				HTMLInput button = new HTMLInput(HTMLInputTypes.SUBMIT, "in_su_searchportlet", "in_su_searchportlet");
				button.SetStyleClass(PTStyleClass.FORM_BTN_TEXT);
				button.SetValue(m_asOwner.GetString(567, "ptmsgs_portalcommonmsgs"));
                                button.SetTitle(m_asOwner.GetString(567, "ptmsgs_portalcommonmsgs"));
				cell.AddInnerHTMLElement(button);
			}

			cell = new HTMLTableCell();
			cell.SetWidth("100%");
			row.AddInnerHTMLElement(cell);

			if (hasLinks(saved) || hasLinks(recent))
			{
				table = new HTMLTable();
				table.SetCellSpacing("0");
				table.SetCellPadding("3");

				form.AddInnerHTMLElement(table);

				if (hasLinks(saved))
				{
					table.AddInnerHTMLElement(MakeLinkRow(m_asOwner.GetString(569, "ptmsgs_portalcommonmsgs"), saved));
				}

				if (hasLinks(recent))
				{
					table.AddInnerHTMLElement(MakeLinkRow(m_asOwner.GetString(568, "ptmsgs_portalcommonmsgs"), recent));
				}
			}
		}
		catch (Exception e)
		{
			throw new XPException(m_asOwner.GetString(565, "ptmsgs_portalcommonmsgs"), e);
		}

		return wrapperTable;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.intrinsicportlets.IntrinsicPortletView#DisplayPortletWML()
	 */
	public String DisplayPortletWML()
	{
		return null;
	}

	/**
	 *
	 *
	 * @return
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 *
	 *
	 * @param model
	 * @param parent
	 */
	public void Init(IModelRO model, AActivitySpace parent)
	{
		super.Init(model, parent);

		_model = (SearchPortletModel) model;
	}

	/**
	 *
	 *
	 * @param text
	 * @param links
	 *
	 * @return
	 *
	 * @throws HTMLException
	 */
	private HTMLTableRow MakeLinkRow(String text, Object[][] links)
	{
		HTMLTableRow row = new HTMLTableRow();
		row.SetStyleClass(PTStyleClass.PLATPORTLET_LIGHT_BG);

		HTMLTableCell cell = new HTMLTableCell();
		row.AddInnerHTMLElement(cell);

		cell.SetVAlign("top");

		HTMLSpan span = new HTMLSpan();
		cell.SetStyleClass(PTStyleClass.OBJECTSEARCH_HEADER);
		span.AddInnerHTMLString(text);

		cell.AddInnerHTMLElement(span);
		cell.AddInnerHTMLString("&nbsp;&nbsp;");

		cell = new HTMLTableCell();
		cell.SetStyleClass(PTStyleClass.OBJECTSEARCH_TEXT);
		row.AddInnerHTMLElement(cell);

		for (int j = 0; j < links[0].length; j++)
		{
			if ((null != links[0][j]) && (null != links[1][j]))
			{
				String url = (String) (links[1][j]);

				// if the URL doesn't already have the application base (i.e. "/portal/HTTPInterpreter.aspx")
				// stuck on the front of it..
				if (!url.startsWith("/"))
				{
					// add it now
					url = ConfigHelper.GetApplicationBaseURL(m_asOwner) + url;
				}

				HTMLAnchor anchor = new HTMLAnchor(url);
				String title = XPHttpUtility.HtmlEncode((String) (links[0][j]));
				anchor.AddInnerHTMLString(title);
				anchor.SetTitle(title);
				cell.AddInnerHTMLElement(anchor);
				cell.AddInnerHTMLElement(new HTMLBr());
			}
		}

		return row;
	}

	/**
	 *
	 *
	 * @param o
	 *
	 * @return
	 */
	private boolean hasLinks(Object o)
	{
		if (null == o)
		{
			return false;
		}

		if (!(o instanceof Object[][]))
		{
			return false;
		}

		Object[][] a = (Object[][]) o;

		return ((a.length > 0) && (a[0].length > 0));
	}
}

