package com.plumtree.portalpages.portlets.sitemap;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.sitemap.sitemappage.*;
import com.plumtree.portalpages.portlets.sitemap.prefs.*;
import com.plumtree.portaluiinfrastructure.compoundlist.*;
import com.plumtree.portaluiinfrastructure.intrinsicportlets.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 * 
 *
 * @author josephc
 */
public class SiteMapPortletModel extends IntrinsicPortletModel
	implements ISiteMapPortletModelRO, IRepostModel
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_PORTLETS),
		"com.plumtree.portalpages.portlets.sitemap.SiteMapPortletModel");

	/** Class name for the model */
	public static final String STR_MVC_CLASS_NAME = "SiteMapPortlet";
	private String m_strLinkOrder = "";
	private boolean m_bShowDescriptions;
	private int m_nFolderID;
	private int m_nMaxNumLinksToDisplay = 10;
	private int m_nNumTotalLinks;

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean ControlExists()
	{
		return true;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SiteMapPortletModel();
	}

	/**
	 * Implement some code to execute when the user clicks on "Finish".
	 */
	public void Finish()
	{
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public int GetCommunityID()
	{
		if (PT_CLASSIDS.PT_COMMUNITY_ID == m_nContainerClassID)
		{
			return m_nContainerObjectID;
		}
		return 0;
	}

	/**
	 * 
	 *
	 * @return 
	 *
	 * @throws XPException 
	 */
	public String GetData()
	{
		try
		{
			/*
			IPTGadget ptPortlet = m_ptPortlet;

			IPTAdminSettings ptAdminSettings = (IPTAdminSettings) ptPortlet.GetInterfaces("IPTAdminSettings");

			Object[] aSettings = new Object[1];
			aSettings[0] = ADMINGADGETSETTING_FOLDERID;

			Object[][] arData = (Object[][]) ptAdminSettings.LookupAdminGadgetSettings(aSettings);
			String strData    = (String) arData[1][0];

			return strData;
			*/
			return null;
		}
		catch (Exception e)
		{
			
				log.Error(e, "SiteMapPortletModel::GetData. " +
					m_asOwner.GetString(590, "ptmsgs_portalcommonmsgs"));
			

			throw new XPException(m_asOwner.GetString(590, "ptmsgs_portalcommonmsgs"), e);
		}
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public int GetFolderID()
	{
		return m_nFolderID;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetFolderName()
	{
		IPTSiteMapFolderInfo ptSiteMapFolderInfo = (IPTSiteMapFolderInfo) GetTempData();

		if ((ptSiteMapFolderInfo != null) &&
				(0 != ptSiteMapFolderInfo.GetObjectID()))
		{
			String strName = ptSiteMapFolderInfo.GetName();

			if ("".equals(strName) || (strName == null))
			{
				return m_asOwner.GetString(589, "ptmsgs_portalcommonmsgs");
			}
			else
			{
				return strName;
			}
		}
		else
		{
			return m_asOwner.GetString(589, "ptmsgs_portalcommonmsgs");
		}
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean GetHasEditAccessToCommunity()
	{
		IPTCommunityManager ptOM		 = (IPTCommunityManager) m_ptSession.GetCommunities();
		IPTCommunityInfo ptCommunityInfo = ptOM.CachedOpenCommunityInfo(GetCommunityID(), false);

		boolean bHasEditAccess = false;

		if ((ptCommunityInfo != null) && (0 != ptCommunityInfo.GetObjectID()))
		{
			bHasEditAccess = ptCommunityInfo.GetAccessLevel() >= PT_ACCESS_LEVELS.PT_ACCESS_LEVEL_EDIT;
		}

		return bHasEditAccess;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean GetHasEditAccessToFolder()
	{
		IPTSiteMapFolderInfo ptSiteMapFolderInfo = (IPTSiteMapFolderInfo) GetTempData();
		boolean bHasEditAccess					 = false;

		if ((ptSiteMapFolderInfo != null) &&
				(0 != ptSiteMapFolderInfo.GetObjectID()))
		{
			bHasEditAccess = ptSiteMapFolderInfo.GetAccessLevel() >= PT_ACCESS_LEVELS.PT_ACCESS_LEVEL_EDIT;
		}

		return bHasEditAccess;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean GetHasReadAccessToFolder()
	{
		IPTSiteMapFolderInfo ptSiteMapFolderInfo = (IPTSiteMapFolderInfo) GetTempData();
		boolean bHasEditAccess					 = false;

		if ((ptSiteMapFolderInfo != null) &&
				(0 != ptSiteMapFolderInfo.GetObjectID()))
		{
			bHasEditAccess = ptSiteMapFolderInfo.GetAccessLevel() >= PT_ACCESS_LEVELS.PT_ACCESS_LEVEL_READ;
		}

		return bHasEditAccess;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public ICPListEntryIterator GetLinks()
	{
		ASCompoundList cpList = new ASCompoundList();

		try
		{
			IPTSiteMapFolderInfo ptSiteMapFolderInfo = (IPTSiteMapFolderInfo) GetTempData();

			if ((ptSiteMapFolderInfo != null) &&
					(0 != ptSiteMapFolderInfo.GetObjectID()))
			{
				m_nNumTotalLinks = SiteMapModel.CreateSortedLinks(ptSiteMapFolderInfo,
						cpList, m_strLinkOrder, m_asOwner);
			}
		}
		catch (Exception e)
		{
			
				log.Warn("Failed getting links for community links portlet.");
			
		}

		return cpList;
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public Object GetNewTempData()
	{
		SetFolderID(0);

		Object[][] arSettings = GetSettingValues(SETTINGSTYPE_COMMUNITYPORTLET, (String[])null);

		if (null != arSettings)
		{
			for (int i = 0; i < arSettings[0].length; i++)
			{
				String strSettingName = (String) arSettings[0][i];

				if (strSettingName.equals(
							SiteMapPortletPrefsModel.SETTING_NAME_FOLDERID))
				{
					SetFolderID(XPConvert.ToInteger(arSettings[1][i]));
				}
				else if (strSettingName.equals(
							SiteMapPortletPrefsModel.SETTING_NAME_LINKORDER))
				{
					String strLinkOrder = (String) arSettings[1][i];
					SetLinkOrder(strLinkOrder);
				}
				else if (strSettingName.equals(
							SiteMapPortletPrefsModel.SETTING_NAME_SHOWDESC))
				{
					SetShowDescriptions(XPConvert.ToInteger(arSettings[1][i]));
				}
				else if (strSettingName.equals(
							SiteMapPortletPrefsModel.SETTING_NAME_NUMLINKS))
				{
					SetNumLinksToDisplay(XPConvert.ToInteger(arSettings[1][i]));
				}
			}
		}

		int nSiteMapFolder						 = GetFolderID();
		IPTSiteMapFolderManager ptOM			 = (IPTSiteMapFolderManager) m_ptSession.GetSiteMapFolders();
		IPTSiteMapFolderInfo ptSiteMapFolderInfo = ptOM.CachedOpenSiteMapFolderInfo(nSiteMapFolder);

		// DCA - check to make sure site map folder exists if nSiteMapFolder is non-zero
		try {
			if (0 != nSiteMapFolder) {
				ptSiteMapFolderInfo.GetAccessLevel();
			}
		} catch (Exception e) {
			// reset folderID to 0
			SetFolderID(0);
			ptSiteMapFolderInfo = ptOM.CachedOpenSiteMapFolderInfo(0);
		}
		return ptSiteMapFolderInfo;
	}

	/**
	 *
	 * @see com.plumtree.portalpages.portlets.sitemap.ISiteMapPortletModelRO#GetNumLinksToDisplay()
	 */
	public int GetNumLinksToDisplay()
	{
		return m_nMaxNumLinksToDisplay;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetPrefsURL()
	{
		String strPrefsURL = GatewayHelpers.ConstructCommunityPrefsLink(m_asOwner,
				GetPortletID(), GetCommunityID(),
				m_nPageID, true);

		return strPrefsURL;
	}

	/**
	 * Returns the Redirect object  (this is were we need to go at the end of
	 * the Editor).
	 *
	 * @return Redirect
	 */
	public Redirect GetRedirectAfterFinish()
	{
		return null;
	}

	/**
	 * Calls the right save function according to the page name passed in
	 * argument.
	 *
	 * @param _sPageName
	 * @param _htFormData
	 *
	 * @return 
	 */
	public int SavePage(String _sPageName, XPHashtable _htFormData)
	{
		return RepostControl.PAGE_STATUS_VALID;
	}

	/**
	 * 
	 *
	 * @param strData 
	 *
	 * @throws XPException 
	 */
	public void SetData(String strData)
	{
		/*   try
		   {
		       //IPTGadget ptPortlet = GetPortlet(_nPortletID);
		       IPTObjectManager ptOM = m_ptSession.GetGadgets();
		       IPTGadget ptPortlet   = (IPTGadget) ptOM.Open(m_nPortletID, false);

		       IPTAdminSettings ptAdminSettings = (IPTAdminSettings) ptPortlet.GetInterfaces("IPTAdminSettings");
		       ptAdminSettings.AddAdminGadgetSetting(m_strAdminSettingKey, strData);

		       IPTServerContext ptSC = (IPTServerContext) ptPortlet.GetInterfaces("IPTServerContext");
		       ptSC.LockObject();
		       ptSC.Store();
		       ptSC.UnlockObject();
		   }
		   catch (Exception e)
		   {
		       if ( log.IsErrorEnabled() )
		       {
		           log.Error("SamplePortletModel::SetData. " + m_asOwner.GetString(591, "ptmsgs_portalcommonmsgs") + ":" + e.getMessage());
		       }

		       throw new XPException(m_asOwner.GetString(591, "ptmsgs_portalcommonmsgs"), e);
		   }
		   */
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public void SetFolderID(int nFolderID)
	{
		m_nFolderID = nFolderID;
	}

	/**
	 *
	 * @see com.plumtree.portalpages.portlets.sitemap.ISiteMapPortletModelRO#ShowDescriptions()
	 */
	public boolean ShowDescriptions()
	{
		return m_bShowDescriptions;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean ShowMoreLink()
	{
		if (m_nFolderID == 0)
		{
			return false;
		}

		return (m_nMaxNumLinksToDisplay < m_nNumTotalLinks);
	}

	/**
	 * 
	 *
	 * @param strLinkOrder 
	 */
	private void SetLinkOrder(String strLinkOrder)
	{
		m_strLinkOrder = strLinkOrder;
	}

	/**
	 *
	 * @param intNumLinks
	 */
	private void SetNumLinksToDisplay(int intNumLinksToDisplay)
	{
		m_nMaxNumLinksToDisplay = intNumLinksToDisplay;
	}

	/**
	 *
	 * @param intShowDesc
	 */
	private void SetShowDescriptions(int intShowDesc)
	{
		m_bShowDescriptions = (1 == intShowDesc);
	}
}

