package com.plumtree.portalpages.portlets.sitemap.prefs;

// Framework Imports
import com.plumtree.portalpages.browsing.editors.sitemap.sitemapfolderplugin.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * Display page for intrinsic portlet, which uses the the editor framework.
 *
 * @version $Revision$
 * @author josephc
 */
public class SiteMapPortletPrefsDP extends EditorDP
{
	/** SiteMapPortletPrefs */
	public static final String STR_MVC_CLASS_NAME = "SiteMapPortletPrefs";

	/**
	 * Returns the String to display on the left navigation menu,  linking to
	 * that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return m_asOwner.GetString(570, "ptmsgs_portalcommonmsgs");
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for that Page.
	 *
	 * @return HTMLElement
	 *
	 * @throws HTMLException
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()

	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
				SiteMapPortletPrefsView.STR_MVC_CLASS_NAME)).Display());

		if (m_asOwner.GetIsAccessStyleStandard()) {
    		views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
    			SiteMapPortletPrefsSortedLinksView.STR_MVC_CLASS_NAME)).Display());
        }
				
		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 *
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = new HTMLScriptCollection(); //super.DisplayJavaScriptFromChild();

		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
			SiteMapPortletPrefsView.STR_MVC_CLASS_NAME).DisplayJavascript());
		SiteMapPortletPrefsModel prefsModel = (SiteMapPortletPrefsModel) m_asOwner.GetModel(SiteMapPortletPrefsModel.STR_MVC_CLASS_NAME);
		if(prefsModel.GetFolderID() != 0) {
			myScripts.AddInnerHTMLElement(m_asOwner.GetView(
				SiteMapPortletPrefsSortedLinksView.STR_MVC_CLASS_NAME)
				.DisplayJavascript());
			myScripts.AddInnerHTMLElement(m_asOwner.GetView(SiteMapFolderPlugInView.STR_MVC_CLASS_NAME).DisplayJavascript());
			// DCA - display javascript for delete action
			myScripts.AddInnerHTMLElement(((SiteMapFolderPlugInView) 
				m_asOwner.GetView(SiteMapFolderPlugInView.STR_MVC_CLASS_NAME)).DisplayDeleteJavascript());
		}
		HTMLScript script = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);

		script.SetSrc(ConfigHelper.GetPortalImageServerJavaScriptURL(m_asOwner) +
			"opennewwindow.js");

		myScripts.AddInnerHTMLElement(script);

		return myScripts;
	}
}

