package com.plumtree.portalpages.portlets.sitemap.prefs;


// Framework Imports
import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.editors.sitemap.sitemapfolderplugin.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * 
 *
 * @author NaveenP
 */
public class SiteMapPortletPrefsView extends EditorView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_PORTLETS),
		"com.plumtree.portalpages.portlets.sitemap.prefs.SiteMapPortletPrefsView");

	/** SiteMapPortletPrefs */
	public static final String STR_MVC_CLASS_NAME = "SiteMapPortletPrefs";

	public static final String HTMLINPUT_FOLDERNAME = "in_tx_FolderName";

	public static final String HTMLBUTTON_REPOST = "in_bu_repost";

	public static final String HTMLBUTTON_OPENPOPUP = "in_bu_open";

	public static final String HTMLBUTTON_SHOWDESC = "in_cb_description";

	public static final String HTMLBUTTON_ALPHA = "in_cb_alpha";

	public static final String HTMLINPUT_NUMLINKS = "in_tx_numlinks";

	public static final String JSFUNCTION_VALIDNUMLINKS = "ValidateNumLinks";
	
	public static final String JSFUNCTION_VALIDNAME = "ValidatePortletName";
	
	public static final String JSFUNCTION_VALIDATE_AND_SUBMIT = "ValidateNewFolderNameAndSubmit";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SiteMapPortletPrefsView();
	}

	/**
	 * Returns the HTML for the Section.
	 *
	 * @return HTMLElement
	 *
	 * @throws XPException 
	 */
	public HTMLElement Display()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		HTMLTable myTable;
		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLInput myInput;
		HTMLSpan mySpan;
		HTMLB myBold;

		try
		{
			// ***CHANGEHERE*** Write the HTML for your Section.
			// ***COMMENT_1*** The HTML below can be used as a reference 
			//       to write some HTMLElements.
			// ***COMMENT_2*** Also look at PropMainView and PropAdvView in template1
			//      for more HTML example.
			HTMLComment myComment = new HTMLComment( "Begin: Display SiteMapPortletPrefsView");
			result.AddInnerHTMLElement(myComment);

			// Break MVC rules just for testing
			ISiteMapPortletPrefsModelRO iModel = (ISiteMapPortletPrefsModelRO) m_model;

			//result.AddInnerHTMLString(iModel.GetPortletName());
			myTable = new HTMLTable();
			result.AddInnerHTMLElement(myTable);
			myTable.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
			myTable.SetBorder(CommonHTMLStrings.ZERO);
			myTable.SetCellPadding(CommonHTMLStrings.FIVE);
			myTable.SetCellSpacing(CommonHTMLStrings.ZERO);
			
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.OBJECT_HEADER_BG);	
			
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetColSpan(CommonHTMLStrings.THREE);
			myCell.SetHeight("20");
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.OBJECT_HEADER);
			mySpan.AddInnerHTMLString(m_asOwner.GetString(665, "ptmsgs_portalcommonmsgs"));
			
			// create folder row begin
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.DIR_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetColSpan(CommonHTMLStrings.FOUR);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);

			if (iModel.GetSiteMapFolderIsNull())
			{
				mySpan.AddInnerHTMLString(m_asOwner.GetString(575, "ptmsgs_portalcommonmsgs"));
			}
			else
			{
				mySpan.AddInnerHTMLString(m_asOwner.GetString(576, "ptmsgs_portalcommonmsgs"));
			}

			myRow = GetHTMLForNameRow();
			myTable.AddInnerHTMLElement(myRow);
			
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.DIR_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.SetColSpan(CommonHTMLStrings.THREE);
			myInput = new HTMLInput(HTMLInputTypes.CHECKBOX,
						HTMLBUTTON_SHOWDESC, m_asOwner.GetString(588, "ptmsgs_portalcommonmsgs"));
			myInput.SetChecked(iModel.ShowDescriptions());
			myInput.SetOnClick("postToSelf('" +	// mj: removed 'Javascript:' from function name
				SiteMapPortletPrefsRepostControl.POSTTOSELF_ACTION_SHOWDESC +
				"')");
			mySpan.AddInnerHTMLElement(myInput);
			myBold = new HTMLB();
			myBold.AddInnerHTMLString(m_asOwner.GetString(588, "ptmsgs_portalcommonmsgs"));
			mySpan.AddInnerHTMLElement(myBold);

			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.DIR_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myCell.SetColSpan(CommonHTMLStrings.THREE);
			myInput = new HTMLInput(HTMLInputTypes.CHECKBOX,
					HTMLBUTTON_ALPHA, m_asOwner.GetString(577, "ptmsgs_portalcommonmsgs"));
			myInput.SetChecked(iModel.OrderAlpha());
			myInput.SetOnClick("postToSelf('" +	// mj: removed 'Javascript:' from function name
				SiteMapPortletPrefsRepostControl.POSTTOSELF_ACTION_ORDERALPHA +
				"')");
			
			
			mySpan.AddInnerHTMLElement(myInput);
			myBold = new HTMLB();
			myBold.AddInnerHTMLString(m_asOwner.GetString(577, "ptmsgs_portalcommonmsgs"));
			mySpan.AddInnerHTMLElement(myBold);

			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myRow.SetStyleClass(PTStyleClass.DIR_CONTENT_BG);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			mySpan = new HTMLSpan();
			myCell.AddInnerHTMLElement(mySpan);
			mySpan.SetStyleClass(PTStyleClass.OBJECT_TEXT);
			myBold = new HTMLB();
			myBold.AddInnerHTMLString(m_asOwner.GetString(582, "ptmsgs_portalcommonmsgs"));
			mySpan.AddInnerHTMLElement(myBold);

			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myInput = new HTMLInput(HTMLInputTypes.TEXT,
					HTMLINPUT_NUMLINKS, "");
			myCell.AddInnerHTMLElement(myInput);
			myCell.SetAlign(CommonHTMLStrings.LEFT);
			myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
			myInput.SetValue(XPConvert.ToString(
					iModel.GetNumLinksToDisplay()));
			myInput.SetSize(CommonHTMLStrings.TWO);
			myInput.SetMaxLength(CommonHTMLStrings.TWO);
			
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetWidth("50%");
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
			
			myRow = new HTMLTableRow();
			myTable.AddInnerHTMLElement(myRow);
			myCell = new HTMLTableCell();
			myRow.AddInnerHTMLElement(myCell);
			myCell.SetColSpan(CommonHTMLStrings.THREE);
			myCell.SetHeight("5");
			myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

			myComment = new HTMLComment( "End: Display SiteMapPortletPrefsView");
			result.AddInnerHTMLElement(myComment);
			
		}
		catch (Exception e)
		{
			// ***CHANGE_HERE*** Update the error messages (log and exception).
			
				log.Error(e, "SiteMapPortletPrefsView::Display An error occured when trying to display the HTML.");
			

			throw new XPException(m_asOwner.GetString(579, "ptmsgs_portalcommonmsgs"), e);
		}

		return result;
	}

	/**
	 * This method returns the HTMLScript that encompasses the Javascript on
	 * the page.
	 *
	 * @return HTMLScript
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()
	 */
	public HTMLScript DisplayJavascript()
	{
		int nNumCurrLinks = ((SiteMapPortletPrefsSortedLinksModel) m_asOwner.GetModel(SiteMapPortletPrefsSortedLinksModel.STR_MVC_CLASS_NAME)).GetCurrNumLinks();
		HTMLScript myScript = new HTMLScript("text/javaScript");
		XPStringBuilder sb  = new XPStringBuilder(200);

		sb.Append("\n" + "function " + JSFUNCTION_VALIDNUMLINKS + "()\n");
		sb.Append("{\n");
		if (((ISiteMapPortletPrefsModelRO) m_model).GetFolderID() != 0)
		{
			String strJSUtilVersionPrefix = ConfigHelper.GetJSIncluderVersionPrefix(ConfigHelper.JSCOMPONENT_JSUTIL);
			
			sb.Append("		var txtBox = document." + AFormDP.HTMLFORM_NAME + "." +
				HTMLINPUT_NUMLINKS + ";\n");
			sb.Append("		if(txtBox) {\n");
			sb.Append(
				"			if(txtBox.value == '' || !"+strJSUtilVersionPrefix+"PTNumberUtil.isPositiveInteger(txtBox.value) || (txtBox.value < 1 && " +
				nNumCurrLinks + " != 0)) {\n");
			sb.Append("				alert('" +
				XPResourceManager.FormatMessage(m_asOwner.GetString(581, "ptmsgs_portalcommonmsgs"),
					XPConvert.ToString(nNumCurrLinks)) + "');\n");
			sb.Append("				txtBox.focus();\n");
			sb.Append("				return false;\n");
			sb.Append("			}\n");
			sb.Append("		}\n");
		}
		sb.Append("		return true;\n");
		sb.Append("}\n");
		
		sb.Append("\n" + "function " + JSFUNCTION_VALIDNAME + "()\n");
		sb.Append("{\n");

		sb.Append("		var txtBox = document." + AFormDP.HTMLFORM_NAME + "." +
			HTMLINPUT_FOLDERNAME + ";\n");
		sb.Append("		if(txtBox) {\n");
		sb.Append("			if(txtBox.value == '') {\n");
		sb.Append("				alert('" +
			m_asOwner.GetString(753, "ptmsgs_portalcommonmsgs") + "');\n");
		sb.Append("				txtBox.focus();\n");
		sb.Append("				return false;\n");
		sb.Append("			}\n");
		sb.Append("			if (-1 != txtBox.value.lastIndexOf(\"\\\\\") || " + 
			"-1 != txtBox.value.lastIndexOf(\"\\t\") || -1 != txtBox.value.lastIndexOf(\"\\n\")) {\n"); 
		sb.Append("				alert('" +
			m_asOwner.GetString(754, "ptmsgs_portalcommonmsgs") + "');\n");
		sb.Append("				txtBox.focus();\n");
		sb.Append("				return false;\n");	
		sb.Append("			}\n");
		sb.Append("		}\n");

		sb.Append("		return true;\n");
		sb.Append("}\n");
		
		try
		{
			myScript.AddInnerHTMLString(sb.ToString());
		}
		catch (Exception e)
		{
			log.Error(e, "Error Displaying Prefs JS.");
		}

		return myScript;
	}

	/**
	 * Returns the HTML for the sub header.
	 *
	 * @return HTMLTableRow
	 * @throws Exception
	 */
	public HTMLTableRow GetHTMLForNameRow()

	{
		HTMLTableRow myRow;
		HTMLTableCell myCell;
		HTMLInput myInput;
		HTMLSpan mySpan;

		// Row 1 - Cell 1 - input box for the site map folder name
		SiteMapFolderPlugInModel plugInModel = (SiteMapFolderPlugInModel)
			m_asOwner.GetModel(SiteMapFolderPlugInModel.STR_MVC_CLASS_NAME); 
		
		myRow = new HTMLTableRow();
		myRow.SetStyleClass(PTStyleClass.DIR_CONTENT_BG);
		
		myCell = new HTMLTableCell();
		myCell.SetNoWrap(true);
		myCell.SetStyleClass(PTStyleClass.OBJECT_TEXT);
		myRow.AddInnerHTMLElement(myCell);
		mySpan = new HTMLSpan();
		mySpan.SetStyleClass(PTStyleClass.LIST_SUBTITLE);
		mySpan.AddInnerHTMLString(m_asOwner.GetString(787, "ptmsgs_portalcommonmsgs"));
		mySpan.AddInnerHTMLString(CommonHTMLStrings.SPACE);
		myCell.AddInnerHTMLElement(mySpan);
		
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myInput = new HTMLInput(HTMLInputTypes.TEXT, HTMLINPUT_FOLDERNAME, m_asOwner.GetString(787, "ptmsgs_portalcommonmsgs"));
		myInput.SetStyleClass(PTStyleClass.FORM_INPUT_BOX_TEXT);
		myInput.SetSize("30");
		IPTObject objFolder = plugInModel.GetPTObject();
		if(objFolder != null) {
			//MES- NOTE:  This value should NOT be localized, since it will be stored as
			//	the primary name of the Site Map
			myInput.SetValue( objFolder.GetName() );
		} else {
			myInput.SetValue( m_asOwner.GetString(683, "ptmsgs_portalcommonmsgs") );	
		}
		myCell.SetAlign(CommonHTMLStrings.RIGHT);
		myCell.AddInnerHTMLElement(myInput);

		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetWidth("50%");
		myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);

		return myRow;
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}

