package com.plumtree.portalpages.portlets.userprofile.eoddisplay.prefs;

import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author JHQ
 * @author jennifersu
 *
 * Pop up page where user enters name and description of new category.
 */
public class EODPortletPrefsNewCtgDP extends EditorDP
{
	/** object name */
	public static final String STR_MVC_CLASS_NAME = "EODDisplayPrefsNewCtg";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return m_asOwner.GetString(1001, "ptmsgs_portaladminmsgs");
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()
	{
		EditorView view = (EditorView) m_asOwner.GetView(EODPortletPrefsNewCtgView.STR_MVC_CLASS_NAME);
		HTMLElementCollection result = new HTMLElementCollection();

		result.AddInnerHTMLElement(view.Display());

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();
		myScripts.AddInnerHTMLElement(m_asOwner.GetView(EODPortletPrefsNewCtgView.STR_MVC_CLASS_NAME).DisplayJavascript());

		return myScripts;
	}
}

