package com.plumtree.portalpages.portlets.userprofile.infrastructure;

import com.plumtree.openfoundation.util.*;

/**
 * Represents a row in the ProfileTable. Each ProfileRow object contains an
 * arbitrary number of ProfileCell objects. To preserve the integrity of the
 * ProfileTable, all the ProfileRow objects should have the same number of
 * ProfileCell objects in them.
 *
 * @author chrisb
 */
public interface IProfileRow
{
	/**
	 * Returns the number of ProfileCell objects in the ProfileRow.
	 *
	 * @return The number of ProfileCell objects in the ProfileRow.
	 */
	public int GetNumProfileCells();

	/**
	 * Returns an XPEnumerator containing the ProfileCell objects that belong
	 * in this row.
	 *
	 * @return An XPEnumerator containing the ProfileCell objects in this
	 *         ProfileRow.
	 */
	public IXPEnumerator GetProfileCells();
}

