package com.plumtree.portalpages.rest;

import com.plumtree.openfoundation.internationalization.*;


/**
 * Abstract base class for the mechanics of REST errors.
 */
public abstract class ARESTErrors implements IRESTError
{
	protected int m_nCode;
	protected String m_strMessage;

	protected ARESTErrors(int _nCode, String _strMessage)
	{
		m_nCode = _nCode;
		m_strMessage = _strMessage;

		RESTErrors.AddRestError(this);
	}
	
	public IRESTError ParameterizeRESTError(String param1)
	{
		m_strMessage = XPResourceManager.FormatMessage( m_strMessage, param1 ) ;
		return this;
	}
	
	public IRESTError ParameterizeRESTError(String param1, String param2)
	{
		m_strMessage = XPResourceManager.FormatMessage( m_strMessage, param1, param2 );
		return this;
	}
	
	public IRESTError ParameterizedRESTError(String param1, String param2, String param3)
	{
		 m_strMessage = XPResourceManager.FormatMessage( m_strMessage, param1, param2, param3 );
		 return this;
	}
	

	/**
	 * @see com.plumtree.portalpages.rest.IRESTError.GetCode()
	 */
	public int GetCode()
	{
		return m_nCode;
	}

	/**
	 * @see com.plumtree.portalpages.rest.IRESTError.GetMessage()
	 */
	public String GetMessage()
	{
		return m_strMessage;
	}
	
	protected void SetMessage(String message)
	{
		m_strMessage = message;
	}
}