/**
 * 
 */
package com.plumtree.portalpages.rest;


/**
 * Abstract class for all REST models
 * 
 * @author rozhang
 */
public class ARESTModel
{
	/**
	 * Contains the current error object
	 * Usually set by a control and read by a displaypage
	 */
	protected IRESTError m_error = null;
	
	/**
	 * Set an error object for the current REST request
	 * Usually called by a REST control
	 * 
	 * @param _error
	 */
	public void SetError(IRESTError _error) 
	{
		m_error = _error;
	}

	/**
	 * Gets an error object for the current REST request if one exists
	 * Usually called by a REST display page
	 * @return
	 */
	public IRESTError GetError() 
	{
		return m_error;
	}
	
	
}
