package com.plumtree.portalpages.rest;

/**
 * These constants describe the .
 * 
 * This class contains constants for the Rest API JSON/XML error
 * output format.  These can be used in both the JSON format and
 * the XML format.
 * 
 * Each constant is marked with input and/or output depending on
 * whether it can be used as an input to the API, an output, or both.
 */
public class RESTErrorConstants
{
	/**
	 * The name of the error object in the format (i.e. the object
	 * itself, not a member of the object).
	 * output
	 */
	public static final String ERROR_FORMAT_NAME = "error";

	/**
	 * The key for the error text member.
	 * output
	 */
	public static final String ERROR_TEXT = "text";

	/**
	 * The key for the error code member.
	 * output
	 */
	public static final String ERROR_CODE = "code";
}