/**
 * 
 */
package com.plumtree.portalpages.rest.ldap;

import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author rozhang
 *
 */
public class UserIdLookupAS extends AActivitySpace
{
	public static final String STR_MVC_CLASS_NAME = "ldaplookup";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(java.lang.String, java.lang.String, boolean)
	 */
	public boolean CheckBasicAccess(String strPage, String strControl, boolean sameSpace)
	{
		IPTSession ptSession = (IPTSession) this.GetUserSession();
		return !ptSession.GetSessionInfo().CheckCurrentUserIsGuest(); // don't give guest users access to this AS
	}
	
	/**
	 * @see com.plumtree.xpshared.activityspace.AActivitySpace#Init()
	 **/
	public void Init()
	{
		super.Init();

		RegisterModel(UserIdLookupModel.STR_MVC_CLASS_NAME);
		IModel model = GetModel(UserIdLookupModel.STR_MVC_CLASS_NAME);

		RegisterPage(new UserIdLookupDP());

		RegisterControl(UserIdLookupControl.STR_MVC_CLASS_NAME, model);
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#Create()
	 */
	public Object Create()
	{
		return new UserIdLookupAS();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
	
	
}
