package com.plumtree.portalpages.rest.ldap;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.rest.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.statichelpers.*;

/**
 * Sets the name reqest parameter on the model 
 * 
 * @author rozhang
 */
public class UserIdLookupControl implements IControl
{
	public static final String STR_MVC_CLASS_NAME = "getid";

	public static final String QS_AUTHNAME = "name";
	
	protected AActivitySpace m_space;
	protected UserIdLookupModel m_model;
	
	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#CheckActionSecurityAndExecute(com.plumtree.openfoundation.util.XPHashtable)
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		String authName = HTTPHelpers.GetArgumentAsString(arguments, QS_AUTHNAME, null);
		if ( authName != null ) {
			m_model.SetAuthName(authName);
		} else {
			m_model.SetError(CommonRestErrors.PARAM_MISSING_REQUESTARGUMENT.ParameterizeRESTError(QS_AUTHNAME) );
		}
		return GetDPRedirect();
	}
	
	public Redirect GetDPRedirect()
	{
		Redirect redirect = new Redirect();
		redirect.SetLinkGetCachedSpace(m_space);
		redirect.SetDisplayPage(UserIdLookupDP.STR_MVC_CLASS_NAME);

		return redirect;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#Init(com.plumtree.uiinfrastructure.activityspace.IModel, com.plumtree.uiinfrastructure.activityspace.AActivitySpace)
	 */
	public void Init(IModel model, AActivitySpace space)
	{
		m_space = space;
		m_model = (UserIdLookupModel)model;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new UserIdLookupControl() ;
	}
}
