package com.plumtree.portalpages.rest.user;

import com.plumtree.portalpages.rest.*;

/**
 * This interface describes the setter and action methods for the user REST API model.
 */
public interface IUserRestModel extends IUserRestModelRO
{
	/**
	 * Join the specified community.
	 * 
	 * @param _nCommunityID the community to join.
	 */
	public void JoinCommunity(int _nCommunityID);

	/**
	 * Leave the specified community.
	 * 
	 * @param _nCommunityID the community to leave.
	 */
	public void LeaveCommunity(int _nCommunityID);

	/**
	 * Sets an error for later display.
	 * 
	 * @param _error the current error.
	 */
	public void SetError(IRESTError _error);
}
