package com.plumtree.portalpages.rest.user;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This space contains the MVC objects that handle processing the User REST API requests.
 */
public class UserRESTAS extends AActivitySpace
{
	public static final String STR_MVC_CLASS_NAME = "UserREST";

	@Override
	public boolean CheckBasicAccess(String strPage, String strControl,
			boolean bSameSpace) {
		// No need to check security here.  The control will handle that.
		// We only need to make sure we're going to the control correctly,
		// or that this is a redirect from within the same space (i.e. from
		// the control).
		return (bSameSpace ||
				(XPStringUtility.CompareIgnoreCase(UserRESTControl.STR_MVC_CLASS_NAME, strControl) == 0));
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.AActivitySpace#Init()
	 */
	public void Init()
	{
		super.Init();

		RegisterModel(UserRESTModel.STR_MVC_CLASS_NAME);
		IModel model = GetModel(UserRESTModel.STR_MVC_CLASS_NAME);

		RegisterPage(new UserRESTDP());

		RegisterControl(UserRESTControl.STR_MVC_CLASS_NAME, model);
	}

	@Override
	public Object Create() {
		return new UserRESTAS();
	}

	@Override
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}
}