package com.plumtree.portalpages.rest.user;

/**
 * This class contains constants for the KD Rest API.  These can
 * be used in both the JSON format and the XML format.
 * 
 * Each constant is marked with input and/or output depending on
 * whether it can be used as an input to the API, an output, or both.
 */
public class UserRESTConstants
{
	// These constants describe the JSON/XML input/output format.

	/**
	 * The name of the user object in the format (i.e. the object
	 * itself, not a member of the object).
	 * input/output
	 */
	public static final String USER_FORMAT_NAME = "user";

	/**
	 * The key for the user community to join member.
	 * input/output
	 */
	public static final String USER_JOIN_COMMUNITIES = "joincommunityid";

	/**
	 * The key for the user community to leave member.
	 * input/output
	 */
	public static final String USER_LEAVE_COMMUNITIES = "leavecommunityid";
}