package com.plumtree.portalpages.rest.user;

import com.plumtree.portalpages.rest.*;

/**
 * This class enumerates the common errors generated by the User Rest APIs.
 * 
 * 2500 - 2999 is reserved for User errors.
 */
public class UserRestErrors extends ARESTErrors implements IRESTError
{
	public static final IRESTError NO_JSON_USER_OBJECT = new UserRestErrors(2500, "User node not " +
		"in JSON document.");
	public static final IRESTError NO_JOIN_COMMUNITY_ID = new UserRestErrors(2510, "The API data did not include a valid community ID to join.");
	public static final IRESTError NO_LEAVE_COMMUNITY_ID = new UserRestErrors(2520, "The API data did not include a valid community ID to join.");
	public static final IRESTError INVALID_USER_ID = new UserRestErrors(2530, "The User REST API found an invalid user ID.  The API currently only supports [" +
		UserRESTControl.CURRENT_USER + "] as a value.");
	public static final IRESTError JOIN_COMMUNITY_ERROR = new UserRestErrors(2540, "Unable to join the specified community.  This community may no longer exist or be visible to this user.");
	public static final IRESTError LEAVE_COMMUNITY_ERROR = new UserRestErrors(2550, "Unable to leave the specified community.  This community may no longer exist or be visible to this user.");

	private UserRestErrors(int _nCode, String _strMessage)
	{
		super(_nCode, _strMessage);
	}
}