package com.plumtree.portalpages.rest.utils;

import com.plumtree.openfoundation.util.*;

/**
 * This JSON parser handles simple objects only.
 * It is very limited, and does not handle arrays, or non-string
 * object types.  It also only handles escaped quotes and slashes.
 */
public interface IJSONParser
{
	/**
	 * Parses the supplied JSON object.
	 * 
	 * @param _strJSON the JSON string to be parsed.
	 * @throws XPFormatException
	 */
	public void ParseJSONObject(String _strJSON);

	/**
	 * @return the top-level JSON object name.
	 */
	public String GetObjectName();

	/**
	 * @param _strName The key for the JSON member to be returned.
	 * @return the requested JSON member value.
	 */
	public String GetMember(String _strName);
}
