/*
 * Created on Jan 28, 2005
 */
package com.plumtree.taskapi.portalui;

import com.plumtree.openfoundation.web.*;

/**
 * Class description
 * 
 * @author robertz
 */
public class TaskAPIUIHTTP
{
	public static final String ENCODING_UTF8 = "UTF-8";
	
	
	/**
	 * Returns a URL-encoded version of the input 
	 * string, or empty string if input is null. 
	 * @param strValue a string of characters to encode for use i.
	 * @param strEncoding the encoding used to interpret the encoded bytes.  
	 * Use <code>ENCODING_UTF8</code>
	 * @return an encoded version of the input, or empty string if null.
	 */
	public static String URLEncode(String strValue, String strEncoding)
	{
		return XPHttpUtility.UrlEncode(strValue, strEncoding);
	}
	
	/**
	 * Returns a decoded version of the input string, 
	 * assuming it was a valid URL encoding.
	 * 
	 * 
	 * @param strValue the string to decode
	 * @param strEncoding the encoding used to interpret the encoded bytes
	 * @return a decoded version of the input.
	 * @throws XPNullPointerException if input null
	 * @throws XPUnsupportedEncodingException if invalid ampersand escape found
	 */
	public static String URLDecode(String strValue, String strEncoding)
	{
		return XPHttpUtility.UrlDecode(strValue, strEncoding);
	}
	
	
}
