package com.plumtree.taskapi.portalui.util;

/**
 * This class contains constants for the data keys
 * for the submit simple data source HashTableDataObjects
 * returned by the ITaskAPIUIDirectory methods for submit
 * data sources.
 * 
 * NOTE: Do not change these constants, as they are used
 * in an external API in the SubmitDataSourceTag.
 */
public class SubmitDataSourceConstants
{
	/**
	 * The name of the Data Source.
	 */
	public static final String NAME = "name";

	/**
	 * The object ID of the data source.
	 */
	public static final String ID = "id";

	/**
	 * The type of the data source, either "file" or "web".
	 */
	public static final String TYPE = "type";

	/**
	 * The file value of the data source type.
	 */
	public static final String TYPE_FILE = "file";

	/**
	 * The web value of the data source type.
	 */
	public static final String TYPE_WEB = "web";

	/**
	 * The remote upload URL of the data source, if it has one.
	 */
	public static final String URL = "url";

	/**
	 * The object ID of the web service associated with this data source.
	 */
	public static final String WEB_SERVICE_ID = "wsid";
}