package com.plumtree.portalpages.browsing.mock.condition;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.portaluiinfrastructure.condition.*;

public class MockXPLimitedRequest extends XPLimitedRequest {

	private XPHashtable headers;
	
	public MockXPLimitedRequest(IXPRequest xpRealRequest) {
		super(xpRealRequest);
		headers = new XPHashtable();
	}

	/**
	 * Returns the value of the given HTTP header 
	 *  
	 * @param  name 	Name of the HTTP header. For e.g. HTTP_USER_AGENT
	 * @return 			The given HTTP header as a String, null if not found.
	 * 
	 * @see com.plumtree.openfoundation.web.IXPRequest#GetHeader(java.lang.String)
	 */
	public String GetHeader(String name) {
		return (String) headers.GetElement(name);
	}

	public void SetHeader(String name, String value) {
		headers.PutElement(name, value);
	}
}
