package com.plumtree.portalpages.browsing.mock.directory;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.browsing.directory.*;
import com.plumtree.portaluiinfrastructure.pathways.tagging.ITaggingModel;
import com.plumtree.portalpages.common.folder.*;
import com.plumtree.portaluiinfrastructure.resultwrapper.*;
import com.plumtree.portaluiinfrastructure.search.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.arraywrapper.*;
import com.plumtree.uiinfrastructure.form.sort.*;
import com.plumtree.xpshared.htmlelements.*;

public class MockDirModel implements IDirModel, ISortModelRO, ITaggingModel
{
	private IASQueryResult m_folderQueryResult;
	private IASQueryResult m_breadCrumbPath;
	private IXPList m_headerProperties;
	private XPHashtable m_relatedResourcesMap;
	private IASQueryResult m_qrDocuments;
	private int[] m_cardRange;
	private int m_numDocsPerPage;
	private XPHashtable m_FolderPaths = new XPHashtable();
	private IASQueryResult m_qrDataSources;

	public String m_strCardName = null;
	public int m_nCardID = 0;
	public int m_nCardSubmitDataSourceID = 0;
	public String m_strCardSubmitDescription = null;
	public String m_strCardSubmitURL = null;
	public int m_nCardSubmitFolder = 0;
	public int m_nCardSubmitError = -1;
	public boolean m_bCardSubmitted = false;

	public String m_strDocUploadID = null;
	public String m_strDocUploadServerID = null;
	public String m_strDocUploadType = null;

	public boolean ABOJobIDsToDisplay() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean CheckFoldersForDelete() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean CheckForActivityRight(int nActivityRight) {
		// TODO Auto-generated method stub
		return false;
	}

	public int[] GetABOJobIDs() {
		// TODO Auto-generated method stub
		return null;
	}

	public XPSortedDictionary GetBasicCardProperties() {
		// TODO Auto-generated method stub
		return null;
	}

	public IASQueryResult GetBreadCrumbPath() {
		return m_breadCrumbPath;
	}
	
	public void SetBreadCrumbPath(IASQueryResult breadCrumbPath) {
		m_breadCrumbPath = breadCrumbPath;
	}

	public int GetBrowseBy() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetBrowseBySource() {
		return DirConstants.BROWSE_BY_SEARCH;
	}

	public int GetCardID() {
		return m_nCardID;
	}

	public XPSortedDictionary GetCardInformation() {
		// TODO Auto-generated method stub
		return null;
	}

	public String GetCardName() {
		return m_strCardName;
	}

	public String GetCardName(int nCardID) {
		if (nCardID == m_nCardID)
		{
			return m_strCardName;
		}

		return null;
	}

	public int[] GetCardRange() {
		return m_cardRange;
	}
	
	public void SetCardRange(int[] cardRange) {
		m_cardRange = cardRange;
	}

	public int GetCardRangeBegin() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetCardSubmitDataSource() {
		return m_nCardSubmitDataSourceID;
	}

	public int GetCardSubmitMode() {
		// TODO Auto-generated method stub
		return 0;
	}

	public String GetCardSubmitURL(boolean bIsWebDataSource) {
		// TODO Auto-generated method stub
		return null;
	}

	public int GetCardSubmitFolder() {
		return m_nCardSubmitFolder;
	}

	public int GetCardSubmitError() {
		// default of -1 means no error
		return m_nCardSubmitError;
	}

	public int GetClassID() {
		// TODO Auto-generated method stub
		return 0;
	}

	public String GetCopyTargetFolderTREESUBSPACE() {
		// TODO Auto-generated method stub
		return null;
	}

	public int GetCreatedFolderID() {
		// TODO Auto-generated method stub
		return 0;
	}

	public XPSortedDictionary GetCustomCardProperties() {
		// TODO Auto-generated method stub
		return null;
	}

	public XPArrayList GetCustomFields(int _nObjectIndex,
			XPArrayList xpCustomProps, XPLocale xpLocale, XPTimeZone xpTimeZone) {
		// TODO Auto-generated method stub
		return null;
	}

	public String GetDataSourceName(int nDataSourceID)
	{
		if (m_qrDataSources != null)
		{
			for (int i = 0; i < m_qrDataSources.GetCount(); i++)
			{
				int nCurID = XPConvert.ToInteger(m_qrDataSources.GetFields(i, PT_PROPIDS.PT_PROPID_OBJECTID));
				if (nCurID == nDataSourceID)
				{
					return (String) m_qrDataSources.GetFields(i, PT_PROPIDS.PT_PROPID_NAME);
				}
			}
			
		}

		return null;
	}

	public String GetDataSourceTREESUBSPACE() {
		// TODO Auto-generated method stub
		return null;
	}

	public int GetDirectoryMode() {
		// TODO Auto-generated method stub
		return 0;
	}

	public String GetDocDescriptionType() {
		return DirConstants.DIR_DOC_DESC_ABBR;
	}

	public void SetDataSourcesQueryResult(IASQueryResult _result)
	{
		m_qrDataSources = _result;	
	}

	public IASQueryResult GetFilteredDataSources() {
		return m_qrDataSources;
	}

	public String GetFolderDescriptionType() {
		// TODO Auto-generated method stub
		return null;
	}

	public String GetFolderName(int nFolderID) {
		// TODO Auto-generated method stub
		return null;
	}

	public void SetFolderPath(int nFolderID, String strPath)
	{
		m_FolderPaths.PutElement(new Integer(nFolderID), strPath);
	}

	public String GetFolderPath(int nFolderID) {
		return (String) m_FolderPaths.GetElement(new Integer(nFolderID));
	}

	public int GetFolderSearchMapping(int nUnmappedIndex) {
		// TODO Auto-generated method stub
		return 0;
	}

	public IPTSearchResponse GetFolderSearchResponse() {
		// TODO Auto-generated method stub
		return null;
	}

	public IXPList GetHeaderProperties() {
		return m_headerProperties;
	}
	
	public void SetHeaderProperties(IXPList headerPropeties) {
		m_headerProperties = headerPropeties;
	}

	public int GetMoreFolderID() {
		// TODO Auto-generated method stub
		return 0;
	}

	public Object[][] GetMoreRelatedResources(int nRelatedResourceID) {
		// TODO Auto-generated method stub
		return null;
	}

	public String GetMoveTargetFolderTREESUBSPACE() {
		// TODO Auto-generated method stub
		return null;
	}

	public int GetNumDocsPerPage() {
		return m_numDocsPerPage;
	}
	
	public void SetNumDocsPerPage(int numDocsPerPage) {
		m_numDocsPerPage = numDocsPerPage;
	}

	public int GetNumFolderColumns() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetNumSubSubFolders() {
		// TODO Auto-generated method stub
		return 0;
	}

	public String GetObjectBannerText() {
		// TODO Auto-generated method stub
		return null;
	}

	public int GetObjectID() {
		// TODO Auto-generated method stub
		return 0;
	}

	public XPDateTime GetObjectNewTagDate() {
		// TODO Auto-generated method stub
		return null;
	}

	public String GetObjectUUID() {
		// TODO Auto-generated method stub
		return null;
	}

	public XPDateTime GetObjectUpdateTagDate() {
		// TODO Auto-generated method stub
		return null;
	}

	public int GetParentDefaultDataSourceIDRecursive() {
		// TODO Auto-generated method stub
		return 0;
	}

	public XPArrayList GetPropColumns() {
		return  new XPArrayList();
	}

	public int GetRRCategory() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetRRObjectID() {
		// TODO Auto-generated method stub
		return 0;
	}

	public IASQueryResult GetRelatedResource(int nRelatedResourceID) {
		return (IASQueryResult) m_relatedResourcesMap.GetElement(XPConvert.ToString(nRelatedResourceID));
	}
	
	public void SetRelatedResource(int nRelatedResourceID, IASQueryResult qrRelatedResources) {
		m_relatedResourcesMap.PutElement(XPConvert.ToString(nRelatedResourceID), qrRelatedResources);
	}

	public int[] GetRelatedResourceIDs() {
		// TODO Auto-generated method stub
		return null;
	}

	public String GetRelatedResourceString(int nRelatedResourceID) {
		// TODO Auto-generated method stub
		return null;
	}

	public int GetRelatedResourcesLocation() {
		// TODO Auto-generated method stub
		return 0;
	}

	public IPTSession GetSession() {
		// TODO Auto-generated method stub
		return null;
	}

	public int GetSubPortalAccessType() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetTotalResults() {
		// TODO Auto-generated method stub
		return 0;
	}

	public String GetUploadWSURL(int _nDataSourceID) {
		// TODO Auto-generated method stub
		return null;
	}

	public XPLocale GetUserPrefLocale() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean GetUserPrefOpenDocInNewWindow() {
		// TODO Auto-generated method stub
		return false;
	}

	public XPTimeZone GetUserPrefTimeZone() {
		// TODO Auto-generated method stub
		return null;
	}

	public SearchExecutionWarning GetWarning() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean HasAccessToApproveCardInFolder() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean HasAccessToEditCard() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean HasAccessToEditFolder() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean HasSelfSelectExpertRightOnThisFolder() {
		return false;
	}

	public boolean InUnclassifiedCardsFolder() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean IsAtMaxFolderLevel() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean IsRelatedExpert() {
		return false;
	}

	public boolean IsWebDataSource(int nDataSourceID) {
		// TODO Auto-generated method stub
		return false;
	}

	public int RefreshItemFromCopyTargetFolderTree() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int RefreshItemFromDataSourceTree() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int RefreshItemFromMoveTargetFolderTree() {
		// TODO Auto-generated method stub
		return 0;
	}

	public boolean RetrieveSubFoldersThroughSearch() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean ShowFolderActionBanner() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean ShowRelatedResources() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean SupportsUpload(int _nDataSourceID) {
		// TODO Auto-generated method stub
		return false;
	}

	public String GetName() {
		// TODO Auto-generated method stub
		return null;
	}

	public void OpenSubFolder(int ID) {
		// TODO Auto-generated method stub

	}

	public void SetFirstItemIndex(int nFirstItemIndex) {
		// TODO Auto-generated method stub

	}

	public void SetLastItemIndex(int nLastItemIndex) {
		// TODO Auto-generated method stub

	}

	public void CleanupAllData() {
		// TODO Auto-generated method stub

	}

	public void CleanupTempData() {
		// TODO Auto-generated method stub

	}

	public void Init(AActivitySpace parent) {
		m_relatedResourcesMap = new XPHashtable();
	}

	public Object Create() {
		// TODO Auto-generated method stub
		return null;
	}

	public int GetCurrentFolderID() {
		return 200;
	}

	public int GetCurrentFolderLevel() {
		return 2;
	}

	public String GetCurrentFolderName() {
		return "my folder";
	}

	public int GetFirstFolderIndex() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetFolderColumnCount() {
		// TODO Auto-generated method stub
		return 0;
	}

	public IASQueryResult GetFolderObjectCount() {
		// TODO Auto-generated method stub
		return null;
	}

	public IASQueryResult GetFolderQueryResult() {
		return m_folderQueryResult;
	}
	
	public void SetFolderQueryResult(IASQueryResult folderQueryResult) {
		m_folderQueryResult = folderQueryResult;
	}

	public IFolderViewHelper GetFolderViewHelper() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean GetIsFolderSelected(int nFolderID) {
		// TODO Auto-generated method stub
		return false;
	}

	public int GetLastFolderIndex() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetNumSubSubFoldersToDisplay() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetParentFolderID() {
		// TODO Auto-generated method stub
		return 0;
	}

	public Object[] GetParentFolderIDs() {
		// TODO Auto-generated method stub
		return null;
	}

	public String GetPath() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean GetShowCheckbox() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean GetShowFolderBanner() {
		// TODO Auto-generated method stub
		return false;
	}

	public int GetSubFolderCount(int nFolderLevel) {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetSubFolderCount() {
		// TODO Auto-generated method stub
		return 0;
	}

	public boolean InRootFolder() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean DoNotShowObject(int nIndex) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean GetDisplayPaginationHiddenInputs() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean GetDisplaySortHiddenInputs() {
		// TODO Auto-generated method stub
		return false;
	}

	public int GetHeaderCount() {
		// TODO Auto-generated method stub
		return 0;
	}

	public boolean GetHeaderHasCheckbox() {
		// TODO Auto-generated method stub
		return false;
	}

	public HTMLTableRow GetHeaderRow() {
		// TODO Auto-generated method stub
		return null;
	}

	public String GetHeaderText(int nHeaderIndex) {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean GetIsCollapsable() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean GetIsObjectSelected(int nObjectID) {
		// TODO Auto-generated method stub
		return false;
	}

	public String GetObjectBannerTitle() {
		// TODO Auto-generated method stub
		return null;
	}

	public int GetObjectColumnCount() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetObjectCount() {
		return m_qrDocuments.GetCount();
	}

	public Object GetObjectFields(int nIndex, int nPropID) {
		return m_qrDocuments.GetFields(nIndex, nPropID);
	}
	
	public void SetDocuments(IASQueryResult qrDocuments) {
		m_qrDocuments = qrDocuments;
	}

	public int GetObjectSubType(int nIndex) {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetObjectType() {
		// TODO Auto-generated method stub
		return 0;
	}

	public boolean GetObjectViewIsCollapsed() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean GetShowPagination() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean GetSortable() {
		// TODO Auto-generated method stub
		return false;
	}

	public String GetSpaceID() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean ShowObjectBanner() {
		// TODO Auto-generated method stub
		return false;
	}

	public int GetSortDirection() {
		return PTSortedArrayWrapper.PTSAW_SORT_DESCENDING;
	}

	public int GetSortedHeader() {
		return 202;
	}
	
	public int GetNumCardsPerPage()
	{
		return 10;
	}

	public int GetDocumentTypeId() {		
		return 106;
	}

	public void ABODeleteFolders(int[] arFolderIDs) {
		// TODO Auto-generated method stub
		
	}

	public void ClearCardRange() {
		// TODO Auto-generated method stub
		
	}

	public void CopyCards(int[] arCardIDs, int nTargetFolder) {
		// TODO Auto-generated method stub
		
	}

	public void CopyFolders(int[] arFolderIDs, int nTargetFolder) {
		// TODO Auto-generated method stub
		
	}

	public void CreateDirectoryFolder(String strName, String strDescription) {
		// TODO Auto-generated method stub
		
	}

	public void DeleteCards(int[] arCardIDs) {
		// TODO Auto-generated method stub
		
	}

	public void DeleteFolders(int[] arFolderIDs) {
		// TODO Auto-generated method stub
		
	}

	public void MigrateObjects(int nClassID, int[] nObjects, String sComment) {
		// TODO Auto-generated method stub
		
	}

	public void MoveCards(int[] arCardIDs, int nTargetFolder) {
		// TODO Auto-generated method stub
		
	}

	public void MoveFolders(int[] arFolderIDs, int nTargetFolder) {
		// TODO Auto-generated method stub
		
	}

	public int OpenFolderByPath(String strPath) {
		// TODO Auto-generated method stub
		return 0;
	}

	public IPTSearchResponse SearchSubFolders(int nFolderID, int nCurrentLevel) {
		// TODO Auto-generated method stub
		return null;
	}

	public void SetCardID(int nCardID) {
		// TODO Auto-generated method stub
		
	}

	public void SetCardRange(int nRangeBegin, int nRangeEnd) {
		// TODO Auto-generated method stub
		
	}

	public void SetCardSubmitDataSource(int nDataSourceID) {
		m_nCardSubmitDataSourceID = nDataSourceID;
	}

	public void SetCardSubmitDescription(String strDescription) {
		m_strCardSubmitDescription = strDescription;
	}

	public void SetCardSubmitError(int _nErrorCode) {
		// TODO Auto-generated method stub
		
	}

	public void SetCardSubmitFolder(int _nFolderID) {
		m_nCardSubmitFolder = _nFolderID;
	}

	public void SetCardSubmitMode(int nCardID) {
		// TODO Auto-generated method stub
		
	}

	public void SetCardSubmitName(String strName) {
		// I believe this winds up being the same as the card name.
		m_strCardName = strName;
	}

	public void SetCardSubmitURL(String strURL) {
		m_strCardSubmitURL = strURL;
	}

	public void SetDefaultCardRefreshSettings(int nCardID) {
		// TODO Auto-generated method stub
		
	}

	public void SetDirectoryMode(int nMode) {
		// TODO Auto-generated method stub
		
	}

	public void SetDocUploadParams(String _duID, String _duServer) {
		m_strDocUploadID = _duID;
		m_strDocUploadServerID = _duServer;
	}

	public void SetDocumentTypeId(String documentTypeId) {
		// TODO Auto-generated method stub
		
	}

	public void SetObjectType(int nNewObjectType) {
		// TODO Auto-generated method stub
		
	}

	public void SubmitCard() {
		m_bCardSubmitted = true;
	}

	public void SubmitCard(String _strPath, int _nCSSelectedDataSource) {
		m_strCardSubmitURL = _strPath;
		m_nCardSubmitDataSourceID = _nCSSelectedDataSource;
		m_bCardSubmitted = true;
	}

	public void SubmitCard(String _path, String _type, String _docID) {
		m_strCardSubmitURL = _path;
		m_strDocUploadType = _type;
		m_strDocUploadID = _docID;
		m_bCardSubmitted = true;
	}

	public void SubmitCardWithPropertyBag(int nDataSourceID, String strCardName, String strCardDescription, IXPPropertyBag pbagCardProp, int nFolderID) {
		// TODO Auto-generated method stub
		
	}

	public void SubmitCardWithPropertyBag(int[] arFolderIDs, String strLanguage, int nDocTypeID, int nDataSourceID, IXPPropertyBag pbagCardProp, String strCardName, String strCardDescription) {
		// TODO Auto-generated method stub
		
	}

	public void doApproval(int[] arCardIDs, int nAction) {
		// TODO Auto-generated method stub
		
	}

	public boolean IsValidSimpleSubmitSource(int _nDataSourceID) {
		// TODO Auto-generated method stub
		return false;
	}

	public IXPList GetDocumentTags(int id) {
		// TODO Auto-generated method stub
		return null;
	}

	public void AddRemoveObjectTag(String tag, String id, int action, String ptsource) throws XPIllegalStateException {
		// TODO Auto-generated method stub

	}
	
	public void RenameObjectTag(String tag, String id, String ptsource, String renametag) throws XPIllegalStateException {
		// TODO Auto-generated method stub

	}

	public IXPList GetObjectTags(int id) {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean IsTaggingEnabled() {
		// TODO Auto-generated method stub
		return true;
	}



	public XPException GetPathwaysTaggingError() {
		// TODO Auto-generated method stub
		return null;
	}



	public void SetPathwaysTaggingError(XPException e) {
		// TODO Auto-generated method stub
		
	}
}