/**
 * 
 */
package com.plumtree.portalpages.browsing.mock.prefs;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.portlets.intrinsicpageletparamprefeditor.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author rozhang
 *
 */
public class MockIntrinsicPrefsEditorForPageletParametersModel extends IntrinsicPrefsEditorForPageletParametersModel
{
	public IPTGadget m_mockPortlet = null;
	
	
	protected XPHashtable m_setttings = new XPHashtable();	
	// hashtable of xparraylist, one for each settings type, with the elements
	protected XPHashtable m_typeTable = new XPHashtable();
	
	public MockIntrinsicPrefsEditorForPageletParametersModel()
	{
		
	}
	
	/**
	 * Only works as if arFilter is always null
	 * @see com.plumtree.portaluiinfrastructure.intrinsicportlets.prefs.IntrinsicPortletPrefsEditorModel#GetSettingValues(int, java.lang.String[])
	 */
	public Object[][] GetSettingValues(int nSettingType, String[] arFilter)
	{
		XPHashtable list = (XPHashtable)m_typeTable.GetElement(nSettingType);
		if ( list == null ) { list = new XPHashtable(); }
		IXPEnumerator typeEnum = list.GetKeys();
		Object[][] arSettings =  new Object[2][list.GetSize()];
		int counter = 0;
		while (typeEnum.MoveNext()) {

			String name = (String)typeEnum.GetCurrent();
			String value = (String)list.GetElement(name);
			arSettings[0][counter] = name;
			arSettings[1][counter] = value;
			counter++;
		}
		
		return arSettings;
	}
	
	public Object GetSettingValue(int nSettingType, String strName)
	{
		return m_setttings.GetElement(ConstructHashKey(nSettingType, strName));
	}
	
	public void RemoveSettingValue(int nSettingType, String strName)
	{
		XPHashtable list = (XPHashtable)m_typeTable.GetElement(nSettingType);
		if (list != null) {
			list.RemoveElement(strName);
		}
		m_setttings.RemoveElement(ConstructHashKey(nSettingType, strName));
	}
	
	public void SetSettingValue(int nSettingType, String strName, Object oValue)
	{
		if ( m_typeTable.ContainsKey(new Integer(nSettingType)) ) {
			((XPHashtable)m_typeTable.GetElement(nSettingType)).PutElement(strName, oValue);
		} else {
			XPHashtable list = new XPHashtable();
			list.PutElement(strName, oValue);
			m_typeTable.PutElement(new Integer(nSettingType), list);
		}
		
		m_setttings.PutElement(ConstructHashKey(nSettingType, strName), oValue);
	}
	
	protected IPTGadget GetPortletFromSpace(AActivitySpace asParent)
	{
		return m_mockPortlet;
		
	}
	
	protected void SetMockPortlet(IPTGadget mockPortlet)
	{
		m_mockPortlet = mockPortlet;
	}
	
	protected String ConstructHashKey(int type, String name)
	{
		return name+type;
	}
}
