package com.plumtree.portalpages.browsing.mock.search.advanced;

import com.plumtree.openfoundation.util.XPHashtable;
import com.plumtree.portalpages.browsing.search.advanced.IAdvancedSearchModelRO;
import com.plumtree.portalpages.browsing.search.results.SearchPageModeHelper;
import com.plumtree.portaluiinfrastructure.filter.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.editor.EditorModel;

public class MockAdvancedSearchModel extends EditorModel
implements IAdvancedSearchModelRO {
	
	public static final String STR_MVC_CLASS_NAME = "MockAdvancedSearchModel";

	public static final String HTML_SELECT_NUMRESULTS = "in_se_numresults";

	// Passthru IFilterIteratorIO methods
	private FilterIterator _filterIterator;
	private IPTFilter _filter;
	private IPTSession _session;
	private boolean _showErrorsOnPage;
	protected String _mode = SearchPageModeHelper.BROWSE_MODE;


	@Override
	public boolean CheckEditorAccessAndStart(XPHashtable _htFormData) {
		
		_session     = (IPTSession) m_asOwner.GetUserSession();
		
		// Create a temporary filter
		try
		{
			_filter = FilterForm.BuildFilterFromForm(m_asOwner,
			_htFormData, "");
		}
		catch(Exception e)
		{
		}
		if(_filter == null)
			_filter			    = PortalObjectsFactory.CreateSearchFilter();
		
		_filterIterator     = new FilterIterator(_session, _filter, m_asOwner);

		// Don't show potential errors until the user first attempts to submit
		_showErrorsOnPage = false;

		return true;
	}

	@Override
	public Object Create() {
		return new MockAdvancedSearchModel();
	}

	@Override
	public void Finish() {
		// nothing to do here
		
	}

	@Override
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	@Override
	public int SavePage(String pageName, XPHashtable formData) {
		// TODO Auto-generated method stub
		return 0;
	}

	public String GetMode() {
		return _mode;
	}

	public boolean GetShowPotentialErrors() {
		return _showErrorsOnPage;
	}

	public IFilterIteratorRO GetFilterIterator() {
		// TODO Auto-generated method stub
		return null;
	}



}
