package com.plumtree.portalpages.common.documentlanguage;

import com.plumtree.openfoundation.util.XPHashtable;
import com.plumtree.portaluiinfrastructure.application.varpacks.PTSearchLocaleVarPack;
import com.plumtree.portaluiinfrastructure.mock.application.varpacks.MockPTSearchLocaleVarPack;
import com.plumtree.uiinfrastructure.application.varpacks.AppConstants;
import com.plumtree.uiinfrastructure.editor.EditorHelperModel;
import com.plumtree.uiinfrastructure.web.*;

public class MockCardLanguagePlugInModel extends EditorHelperModel implements
		ICardLanguagePlugInModelRO {
	
	public static final String ENGLISH_LOCALE_CODE = "en";	// This should never be needed.
	public boolean m_bIncludeAllLanguagesOption = false;

	private MockPTSearchLocaleVarPack m_vpPTSearchLocales;
	private String m_strCardLanguageCode	    = "";
	private String m_strDefaultLanguage  = "";
	private String m_strInstructionLabel = "";
	private String m_strViewTitle		 = "";
//	private boolean m_bDisplayPopularOnly = false;
	public static final String STR_MVC_CLASS_NAME = "MockCardLanguagePlugIn";

	/**
	 * To initialize this plug-in you need to set the DP name
	 * and the default value of the plug-in setting.
	 *
	 * @param _sPlugInSetting
	 */
	public void InitializePlugIn(String strCardLanguage, String strViewTitle,
		String strInstructionLabel, boolean bIncludeAllLanguagesOption)
	{
		m_strDefaultLanguage = strCardLanguage;
		m_strViewTitle = strViewTitle;
//		m_strDefaultLanguage = XPLocale.GetDefault().GetLanguage();
		m_bIncludeAllLanguagesOption = bIncludeAllLanguagesOption;
		m_strCardLanguageCode = m_strDefaultLanguage;
		m_strInstructionLabel = strInstructionLabel;

		IApplication application = ApplicationManager.GetInstance()
		.GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		m_vpPTSearchLocales = (MockPTSearchLocaleVarPack) application.GetVarPackManager()
		.GetVariablePackage(MockPTSearchLocaleVarPack.VARPACK_ID);

	}
	
	@Override
	public Object Create() {
		return new MockCardLanguagePlugInModel();
	}

	@Override
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	@Override
	public int SaveSection(XPHashtable formData) {
		// TODO Auto-generated method stub
		return 0;
	}

	public String[] GetAllLanguageCodes() {
		return m_vpPTSearchLocales.GetAllLanguageCodes();
	}

	public String[] GetAllLanguageNames() {
		return m_vpPTSearchLocales.GetAllLanguageNames(m_strDefaultLanguage);
	}

	public String GetCardLanguageCode() {
		return m_strCardLanguageCode;
	}

	public boolean GetDisplayOnlyPopularLanguages() {
		// TODO Auto-generated method stub
		return false;
	}

	public String GetInstructionLabel() {
		return m_strInstructionLabel;
	}

	public String[] GetPopularLanguageCodes() {
		// TODO Auto-generated method stub
		return null;
	}

	public String[] GetPopularLanguageNames() {
		// TODO Auto-generated method stub
		return null;
	}

	public String GetViewTitle() {
		return m_strViewTitle;
	}

	public boolean IncludeAllLanguagesOption() {
		return m_bIncludeAllLanguagesOption;
	}
}
