package com.plumtree.portalpages.common.search;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.browsing.editors.folder.IFolderEditorModelRO;
import com.plumtree.portaluiinfrastructure.resultwrapper.IASQueryResult;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.editor.EditorHelperModel;
import com.plumtree.uiinfrastructure.tree.*;

public class MockFolderSelectorModel extends EditorHelperModel
		implements IFolderSelectorModelRO, IFolderSelectorModel{

	public static final String STR_MVC_CLASS_NAME = "MockFolderSelector";
	private String _lastAdmTreeSpaceId;
	private String _lastCatTreeSpaceId;
	private XPArrayList _admSelections;
	private XPArrayList _catSelections;
	private boolean _includeSubfolders = true;
	private boolean _multiSelectMode;
	
	@Override
	public Object Create() {
		return new MockFolderSelectorModel();
	}

	@Override
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	public void InitializePlugIn(boolean multiSelectMode)
	{
		_catSelections		    = new XPArrayList();
		_admSelections		    = new XPArrayList();
		_lastCatTreeSpaceId     = null;
		_lastAdmTreeSpaceId     = null;

		_multiSelectMode = multiSelectMode;
	}
	
	@Override
	public int SaveSection(XPHashtable formData) {
		// TODO Auto-generated method stub
		return 0;
	}

	public String GetFolderSelections(boolean isAdmin) {
		XPArrayList folderList = (isAdmin ? _admSelections : _catSelections);
		String retval = "";
		for (int j = 0; j < folderList.GetSize(); j++)
		{
			for (int k = 0; k < folderList.GetSize(); k++)
			{
				TreeLeafNode node = (TreeLeafNode) folderList.GetElement(k);

				// Add classid,
				retval = commaAdd(retval,(isAdmin) ? "20" : "17");
				// Add objectid,
				retval = commaAdd(retval, XPConvert.ToString(node.m_nObjectID));
			}
		}
		return retval;
	}
	
	private String commaAdd(String initial, String addend)
	{
		if(initial != null && ! initial.equals("") )
			return initial + "," + addend;
		else
			return addend;
	}

	public boolean GetIncludeSubfolders() {
		return _includeSubfolders;
	}

	public String GetLastTreeSpaceId(boolean isAdmin) {
		if (_multiSelectMode)
		{
			// In multiselect mode, reuse the same tree
			if (isAdmin)
			{
				return _lastAdmTreeSpaceId;
			}
			else
			{
				return _lastCatTreeSpaceId;
			}
		}
		else
		{
			return null;
		}
	}

	public boolean GetMultiSelectMode() {
		return _multiSelectMode;
	}

	public IXPCollection GetSelections(boolean isAdmin) {
		if (isAdmin)
		{
			return _admSelections;
		}
		else
		{
			return _catSelections;
		}
	}

	public void AddFoldersFromTreeSelections(boolean adminListOrCatalogList,
			ITreeModel tree) {
		// TODO Auto-generated method stub
		
	}

	public void DeleteFolders(boolean adminListOrCatalogList, int[] folderIDs) {
		// TODO Auto-generated method stub
		
	}

}
