package com.plumtree.portalpages.common.search;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.search.SearchObjectTypes;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.editor.EditorHelperModel;

public class MockTypeSelectorModel extends EditorHelperModel implements
		ITypeSelectorModelRO {

	public static final String STR_MVC_CLASS_NAME = "MockTypeSelector";

	private XPArrayList _selectedTypes	    = null;
	private boolean _showingDetailedOptions;
	private boolean _showAbstractTypeView;
	protected boolean isPathwaysEnabled		= false;

	
	@Override
	public Object Create() {
		return new MockTypeSelectorModel();
	}

	@Override
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}
	
	/**
	 * 
	 */
	public void InitializePlugIn(boolean showAbstractTypeView, boolean noTypesSelected)
	{
		_showAbstractTypeView = showAbstractTypeView;
		_showingDetailedOptions = ! _showAbstractTypeView;

		// Preselect the end-user types
		_selectedTypes = new XPArrayList();

		if(noTypesSelected)
			return;
			
		_selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.CLASSID_00));
		_selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.CLASSID_01));
		_selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.CLASSID_02));
		_selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.CLASSID_25));  // community pages
		_selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.CLASSID_03));
		_selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.CLASSID_04));

		_selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.CONTENT_APPLICATION_ON_DETAIL_PAGE));
		_selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.COLLAB_APPLICATION_ON_DETAIL_PAGE));

	    if (_showAbstractTypeView) {
	      _selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.DOCUMENT_ABSTRACTTYPE));
	      _selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.FOLDER_ABSTRACTTYPE));
	      _selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.OTHER_ABSTRACTTYPE));
	
	      _selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.PORTAL_APPLICATION));
	      _selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.CONTENT_APPLICATION));
	      _selectedTypes.Add(XPConvert.ToString(SearchObjectTypes.COLLAB_APPLICATION));
	    }
	}


	@Override
	public int SaveSection(XPHashtable formData) {
		// TODO Auto-generated method stub
		return 0;
	}

	public boolean AreDetailedOptionsShown() {
		return _showingDetailedOptions;
	}

	public boolean CollabInstalled() {
		return false;
	}

	public boolean ContentInstalled() {
		return false;
	}

	public int[] GetOrderedClassIds() {
		return SearchObjectTypes.GetOrderedSearchObjectTypes();
	}

	public IXPCollection GetSelectedTypes() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean IsTypeSelected(int type) {
		return _selectedTypes.Contains(XPConvert.ToString(type));
	}

	public boolean ShouldDisplayAdminObjects() {
	    return ((IPTSession) m_asOwner.GetUserSession()).GetSessionInfo().
        CheckForActivityRight(PT_ACTIVITY_RIGHTS.PT_ACTIVITY_RIGHT_ACCESS_ADMINISTRATION);
	}

	public boolean ShowAbstractTypeView() {
		return _showAbstractTypeView;
	}

}
