package com.plumtree.portalpages.test;

import junit.framework.*;
import xpunit.framework.*;

import com.plumtree.portalpages.test.admin.*;
import com.plumtree.portalpages.test.browsing.myportal.*;
import com.plumtree.portalpages.test.condition.*;
import com.plumtree.portalpages.test.pei.*;
import com.plumtree.portalpages.test.rest.*;
import com.plumtree.taskapi.test.portalui.*;

public class PortalPagesTestSuite
{
	public static final String SUITENAME = "Portal Pages Unit Tests";

	public static Test suite() {
		XpTestSuite suite = new XpTestSuite(SUITENAME);
		suite.addTest(ConditionTestSuite.suite());
		suite.addTest(RESTTestSuite.suite());
		suite.addTest(MyPortalTestSuite.suite());
		suite.addTest(PEITestSuite.suite());
		suite.addTest(AdminTestSuite.suite());
		suite.addTest(TaskAPITestSuite.suite());

		return suite;
	}
}