using System;
using com.plumtree.uiinfrastructure.application.varpacks;
namespace com.plumtree.portaluiinfrastructure.application.varpacks
{
  /// <summary>
  /// This class contains constants for PTconfig.xml and the x_config.xml files.
  /// </summary>
  public class PTConfigConstants : ConfigConstants
  {
    ////////////
    // Main URLs
    ////////////
    // WilliamA - move the following constant to ConfigConstants 
    // (in uiinfrastructure)
    // public static final String MAIN_URLS_SECTION = "MainURLs";
    //	MainURLs		
    //	  ApplicationBaseURL
    //	  ImageServerBaseURL
    //	  ImageServerSecureBaseURL
    //	  AdminSiteBaseURL
    ////////////
    // Documents
    ////////////
    
    /// <summary>
    /// The Documents section 
    /// </summary>
    public const String DOCUMENTS_SECTION = "Documents";
    //	Documents
    //	  NewDocumentTime
    //	  DocumentLastUpdated
    //	  OpenNewWindow
    //    SubFolderBrowseThroughSearch
    ///////////
    // Crawlers
    ///////////
    
    /// <summary>
    /// The Crawlers section 
    /// </summary>
    public const String CRAWLERS_SECTION = "Crawlers";
    //	Crawlers
    //	  MaxCrawlRadius
    /////////
    // Search
    /////////
    
    /// <summary>
    /// The Search section 
    /// </summary>
    public const String SEARCH_SECTION = "Search";
    //	Search
    //	  NumSearchResultsPerPage
    //////////
    // MyPages
    //////////
    
    /// <summary>
    /// The MyPages section 
    /// </summary>
    /// <deprecated>User STYLE_SECTION instead.</deprecated>
    public const String MY_PAGES_SECTION = "MyPages";
    public const String STYLE_SECTION = "Style";
    //	MyPages
    //	  MyPageRefreshRate
    //	  StyleSheetName
    //////////////
    // Communities
    //////////////
    
    /// <summary>
    /// The Communities section 
    /// </summary>
    public const String COMMUNITIES_SECTION = "Communities";
    //	Communities
    //	  DefaultCommuntyID
    //	  CommKnowledgeDirLinksPerPage
    //	  SiteMapEnabledForGuest
    
    /// <summary>
    /// The CommKnowledgeDirLinksPerPage sub-section in Communities 
    /// </summary>
    public const String COMM_KD_LINKS_PER_PAGE_SUBSECTION = "CommKnowledgeDirLinksPerPage";
    
    /// <summary>
    /// The SiteMapEnabled sub-section in Communities 
    /// </summary>
    public const String SITE_MAP_ENABLED_FOR_GUEST_SUBSECTION = "SiteMapEnabledForGuest";
    /////////////////
    // Administration
    /////////////////
    
    /// <summary>
    /// The Administration section 
    /// </summary>
    public const String ADMINISTRATION_SECTION = "Administration";
    
    /// <summary>
    /// The Is Admin Site sub-section in administration 
    /// </summary>
    public const String IS_ADMIN_SITE_SUBSECTION = "IsAdminSite";
    
    /// <summary>
    /// The Admin Objects Per Page sub-section in administration 
    /// </summary>
    public const String ADMIN_OBJECTS_PER_PAGE_SUBSECTION = "AdminObjectsPerPage";
    
    /// <summary>
    /// The Max Results To Display sub-section in administration 
    /// </summary>
    public const String MAX_RESULTS_TO_DISPLAY_SUBSECTION = "MaxResultsToDisplay";
    
    /// <summary>
    /// The Invitations Section 
    /// </summary>
    public const String INVITATIONS_SECTION = "Invitations";
    
    /// <summary>
    /// Setting Name: Is the Invitation URL Secure
    /// </summary>
    public const String IS_INVITATION_URL_SECURE = "IsInvitationURLSecure";
    /////////////////
    // Authentication
    /////////////////
    
    /// <summary>
    /// The Authentication section 
    /// </summary>
    public const String AUTHENTICATION_SECTION = "Authentication";
    //	Authentication	
    //	  AllowDefaultLoginPageAuthSource
    //	  DefaultAuthSourcePrefix
    //	  AllowAutoConnect
    //	  SSOVendor		
    //	  CookiePath
    //	  CookieDomain
    //	  SSOCookieIsSecure
    //	  CaptureBasicAuthenticationForPortlets
    
    /// <summary>
    /// The BrowserLoginTokenExpiration sub-section 
    /// </summary>
    public const String BROWSERLOGINTOKENEXPIRATION_SUBSECTION = "BrowserLoginTokenExpiration";
    //////////////////////
    // Garbage Collection
    //////////////////////
    
    /// <summary>
    /// The Garbage Collection Section 
    /// </summary>
    public const String GARBAGE_COLLECTION_SECTION = "GarbageCollection";
    //  GarbageCollection
    //    ThreadInterval
    //    ThreadPriority
    
    /// <summary>
    /// The Thread Interval sub-section in garbage collection 
    /// </summary>
    public const String THREAD_INTERVAL_SUBSECTION = "ThreadInterval";
    
    /// <summary>
    /// The Thread Priority sub-section in garbage collection 
    /// </summary>
    public const String THREAD_PRIORITY_SUBSECTION = "ThreadPriority";
    /////////////////
    // Gateway
    /////////////////
    
    /// <summary>
    /// The Gateway section 
    /// </summary>
    public const String GATEWAY_SECTION = "Gateway";
    
    /// <summary>
    /// The Failover section 
    /// </summary>
    public const String FAILOVER_SECTION = "Failover";
    /////////////////
    // Analytics (as of Portal 6.5, Analytics settings are included part of Portal)
    /////////////////
    
    /// <summary>
    /// Flag that enables Analytics 
    /// </summary>
    public const String ANALYTICS_ENABLED_SETTING = "analytics-communication:enabled";
    
    /// <summary>
    /// Flag that enableds Analytics clustering 
    /// </summary>
    public const String ANALYTICS_CLUSTERING_ENABLED_SETTING = "clustering:enabled";
    
    /// <summary>
    /// Analytics cluster name 
    /// </summary>
    public const String ANALYTICS_CLUSTER_NAME_SETTING = "analytics-cluster:name";
    
    /// <summary>
    /// Analytics cluster timeout 
    /// </summary>
    public const String ANALYTICS_CLUSTER_TIMEOUT_SETTING = "analytics-cluster:timeout-period";
    
    /// <summary>
    /// Analytics cluster port 
    /// </summary>
    public const String ANALYTICS_CLUSTER_PORT_SETTING = "analytics-cluster:listening-port";
    
    /// <summary>
    /// Flag that enables Analytics unicast 
    /// </summary>
    public const String ANALYTICS_UNICAST_ENABLED_SETTING = "unicast:enabled";
    
    /// <summary>
    /// Analytics Collector hostname 
    /// </summary>
    public const String ANALYTICS_COLLECTOR_HOST_SETTING = "analytics-collector:host";
    
    /// <summary>
    /// Analytics Collector port 
    /// </summary>
    public const String ANALYTICS_COLLECTOR_PORT_SETTING = "analytics-collector:port";
    
    /// <summary>
    /// Analytics logging level 
    /// </summary>
    public const String ANALYTICS_LOGGING_LEVEL_SETTING = "logging:level";
    
    /// <summary>
    /// Flag that enables Analytics console logging 
    /// </summary>
    public const String ANALYTICS_CONSOLE_LOGGING_SETTING = "console-logging:enabled";
    }
}