using System;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.approval;
using com.plumtree.xpshared.htmlconstructs;
namespace com.plumtree.portaluiinfrastructure.approval
{
  /// <summary>
  /// This class represents a portal-specific ApprovalItemType.  The public enumeration 
  /// presented by this class defines the set of object types available for approval.
  /// </summary>
  /// <author>Ben Geislinger</author>
  public class ApprovalPortalItemType : ApprovalItemType
  {
    public static readonly ApprovalPortalItemType EXTERNAL_OPERATION = new ApprovalPortalItemType("externaloperation",
     PTImageType.ICON_EXTERNAL_OPERATION, PT_CLASSIDS.PT_EXTOPERATION_ID,
     2357, 2358);
    public static readonly ApprovalPortalItemType DOCUMENT = new ApprovalPortalItemType("document",
     PTImageType.ICON_DOCUMENT, PT_CLASSIDS.PT_CATALOGCARD_ID, 2352, 2295);
    public static readonly ApprovalPortalItemType USER = new ApprovalPortalItemType("user",
     PTImageType.ICON_USER, PT_CLASSIDS.PT_USER_ID, 2296, 2297);
    public static readonly ApprovalPortalItemType CRAWLER = new ApprovalPortalItemType("crawler",
     PTImageType.ICON_CRAWLER, PT_CLASSIDS.PT_CRAWLER_ID, 2298, 2299);
    public static readonly ApprovalPortalItemType DATASOURCE = new ApprovalPortalItemType("datasource",
     PTImageType.ICON_DATA_SOURCE, PT_CLASSIDS.PT_DATASOURCE_ID, 2300, 2301);
    public static readonly ApprovalPortalItemType GROUP = new ApprovalPortalItemType("group",
     PTImageType.ICON_GROUP, PT_CLASSIDS.PT_USERGROUP_ID, 2302, 2303);
    public static readonly ApprovalPortalItemType PORTLET = new ApprovalPortalItemType("portlet",
     PTImageType.ICON_PORTLET, PT_CLASSIDS.PT_GADGET_ID, 2304, 2305);
    public static readonly ApprovalPortalItemType COMMUNITY = new ApprovalPortalItemType("community",
     PTImageType.ICON_COMMUNITY, PT_CLASSIDS.PT_COMMUNITY_ID, 2306, 2307);
    public static readonly ApprovalPortalItemType AUTHSOURCE = new ApprovalPortalItemType("authsource",
     PTImageType.ICON_AUTH_SOURCE, PT_CLASSIDS.PT_AUTHSOURCE_ID, 2308, 2309);
    public static readonly ApprovalPortalItemType COMMUNITY_TEMPLATE = new ApprovalPortalItemType("community_template",
     PTImageType.ICON_COMMUNITY_TEMPLATE, PT_CLASSIDS.PT_COMMUNITYTEMPLATE_ID,
     2310, 2311);
    public static readonly ApprovalPortalItemType DOCUMENT_TYPE = new ApprovalPortalItemType("document_type",
     PTImageType.ICON_DOCUMENT_TYPE, PT_CLASSIDS.PT_DOCUMENTTYPE_ID, 2312,
     2313);
    public static readonly ApprovalPortalItemType FEDERATED_PORTAL = new ApprovalPortalItemType("federated_portal",
     PTImageType.ICON_NETWORK_SEARCH, PT_CLASSIDS.PT_FEDERATEDPORTAL_ID, 2651,
     2650);
    public static readonly ApprovalPortalItemType FILTER = new ApprovalPortalItemType("filter",
     PTImageType.ICON_FILTER, PT_CLASSIDS.PT_FILTER_ID, 2316, 2317);
    public static readonly ApprovalPortalItemType JOB = new ApprovalPortalItemType("job",
     PTImageType.ICON_JOB, PT_CLASSIDS.PT_JOB_ID, 2318, 2319);
    public static readonly ApprovalPortalItemType PAGE_TEMPLATE = new ApprovalPortalItemType("page_template",
     PTImageType.ICON_PAGE_TEMPLATE, PT_CLASSIDS.PT_PAGETEMPLATE_ID, 2320,
     2321);
    public static readonly ApprovalPortalItemType PROPERTY = new ApprovalPortalItemType("property",
     PTImageType.ICON_PROPERTY, PT_CLASSIDS.PT_PROPERTY_ID, 2322, 2323);
    public static readonly ApprovalPortalItemType PROPERTYMAP = new ApprovalPortalItemType("property_map",
     PTImageType.ICON_PROPERTY, PT_CLASSIDS.PT_PROPERTYMAP_ID, 2324, 2325);
    public static readonly ApprovalPortalItemType SAVED_SEARCH = new ApprovalPortalItemType("saved_search",
     PTImageType.ICON_SAVED_SEARCH, PT_CLASSIDS.PT_SAVEDSEARCH_ID, 2326, 2327);
    public static readonly ApprovalPortalItemType SCHEDULE = new ApprovalPortalItemType("schedule",
     PTImageType.ICON_CALENDAR, PT_CLASSIDS.PT_SCHEDULE_ID, 2328, 2329);
    public static readonly ApprovalPortalItemType SITE_MAP_FOLDER = new ApprovalPortalItemType("site_map_folder",
     PTImageType.ICON_FOLDER, PT_CLASSIDS.PT_SITEMAPFOLDER_ID, 2330, 2331);
    //  todo name ids
    public static readonly ApprovalPortalItemType SUBPORTAL = new ApprovalPortalItemType("subportal",
     PTImageType.ICON_SUB_PORTAL, PT_CLASSIDS.PT_SUBPORTAL_ID, 2332, 2333);
    public static readonly ApprovalPortalItemType USER_INTERFACE = new ApprovalPortalItemType("user_interface",
     PTImageType.ICON_ARROW_ASCEND, PT_CLASSIDS.PT_USERINTERFACE_ID, 2334,
     2335);
    public static readonly ApprovalPortalItemType WEB_SERVICE = new ApprovalPortalItemType("web_service",
     PTImageType.ICON_WEB_SERVICE, PT_CLASSIDS.PT_WEBSERVICE_ID, 2336, 2337);
    public static readonly ApprovalPortalItemType INVITATION = new ApprovalPortalItemType("invitation",
     PTImageType.ICON_INVITATION, PT_CLASSIDS.PT_INVITATION_ID, 2338, 2339);
    public static readonly ApprovalPortalItemType PORTLET_BUNDLE = new ApprovalPortalItemType("portlet_bundle",
     PTImageType.ICON_PORTLET_BUNDLE, PT_CLASSIDS.PT_GADGETBUNDLE_ID, 2340,
     2341);
    public static readonly ApprovalPortalItemType REMOTE_SERVER = new ApprovalPortalItemType("remote_server",
     PTImageType.ICON_REMOTE_SERVER, PT_CLASSIDS.PT_GADGETCONTENTSERVER_ID,
     2342, 2343);
    public static readonly ApprovalPortalItemType PORTLET_TEMPLATE = new ApprovalPortalItemType("portlet_template",
     PTImageType.ICON_PORTLET_TEMPLATE, PT_CLASSIDS.PT_GADGETTEMPLATE_ID,
     2344, 2345);
    public static readonly ApprovalPortalItemType ADMIN_FOLDER = new ApprovalPortalItemType("admin_folder",
     PTImageType.ICON_FOLDER, PT_CLASSIDS.PT_ADMIN_FOLDER_ID, 2346, 2347);
    public static readonly ApprovalPortalItemType DOCUMENT_FOLDER = new ApprovalPortalItemType("document_folder",
     PTImageType.ICON_FOLDER, PT_CLASSIDS.PT_CATALOGFOLDER_ID, 2348, 2349);
    public static readonly ApprovalPortalItemType PROFILE_SOURCE = new ApprovalPortalItemType("profile_source",
     PTImageType.ICON_PROFILE_SOURCE, PT_CLASSIDS.PT_PROFILESOURCE_ID, 2350,
     2351);
    public static readonly ApprovalPortalItemType PAGE = new ApprovalPortalItemType("page",
     PTImageType.ICON_MYPAGE, PT_CLASSIDS.PT_PAGE_ID, 3128, 3129);
    private PTImageType imageType;
    private String sName;
    private int iClassID = -1;
    private int iNameIDPlural;
    private int iNameIDSingular;
    
    /// <summary>
    /// Creates a new ApprovalItemType object.
    /// </summary>
    /// <param name="name"></param>
    /// <param name="iType"></param>
    /// <param name="classID"></param>
    public ApprovalPortalItemType(String name, PTImageType iType, int classID,
     int iIDs, int iIDp) : base()
    {
      sName = name;
      imageType = iType;
      iClassID = classID;
      iNameIDSingular = iIDs;
      iNameIDPlural = iIDp;
    }
    
    /// <returns></returns>
    public virtual int GetClassID()
    {
      return iClassID;
    }
    
    /// <returns></returns>
    public override PTImageType GetItemImageType()
    {
      return imageType;
    }
    
    /// <returns></returns>
    public override int GetLocalizedNameIDPlural()
    {
      return iNameIDPlural;
    }
    
    /// <returns></returns>
    public override int GetLocalizedNameIDSingular()
    {
      return iNameIDSingular;
    }
    
    /// <returns></returns>
    public override String GetName()
    {
      return sName;
    }
    
    /// <param name="sName"></param>
    /// <returns></returns>
    public override ApprovalItemType GetType(String sName)
    {
      ApprovalPortalItemType itTemp = null;
      if (DOCUMENT.GetName().Equals(sName))
      {
        itTemp = DOCUMENT;
      } else
      if (USER.GetName().Equals(sName))
      {
        itTemp = USER;
      } else
      if (CRAWLER.GetName().Equals(sName))
      {
        itTemp = CRAWLER;
      } else
      if (DATASOURCE.GetName().Equals(sName))
      {
        itTemp = DATASOURCE;
      } else
      if (GROUP.GetName().Equals(sName))
      {
        itTemp = GROUP;
      } else
      if (PORTLET.GetName().Equals(sName))
      {
        itTemp = PORTLET;
      } else
      if (COMMUNITY.GetName().Equals(sName))
      {
        itTemp = COMMUNITY;
      } else
      if (AUTHSOURCE.GetName().Equals(sName))
      {
        itTemp = AUTHSOURCE;
      } else
      if (COMMUNITY_TEMPLATE.GetName().Equals(sName))
      {
        itTemp = COMMUNITY_TEMPLATE;
      } else
      if (DOCUMENT_TYPE.GetName().Equals(sName))
      {
        itTemp = DOCUMENT_TYPE;
      } else
      if (FEDERATED_PORTAL.GetName().Equals(sName))
      {
        itTemp = FEDERATED_PORTAL;
      } else
      if (FILTER.GetName().Equals(sName))
      {
        itTemp = FILTER;
      } else
      if (JOB.GetName().Equals(sName))
      {
        itTemp = JOB;
      } else
      if (PAGE_TEMPLATE.GetName().Equals(sName))
      {
        itTemp = PAGE_TEMPLATE;
      } else
      if (PROPERTY.GetName().Equals(sName))
      {
        itTemp = PROPERTY;
      } else
      if (PROPERTYMAP.GetName().Equals(sName))
      {
        itTemp = PROPERTYMAP;
      } else
      if (SAVED_SEARCH.GetName().Equals(sName))
      {
        itTemp = SAVED_SEARCH;
      } else
      if (SCHEDULE.GetName().Equals(sName))
      {
        itTemp = SCHEDULE;
      } else
      if (SITE_MAP_FOLDER.GetName().Equals(sName))
      {
        itTemp = SITE_MAP_FOLDER;
      } else
      if (SUBPORTAL.GetName().Equals(sName))
      {
        itTemp = SUBPORTAL;
      } else
      if (USER_INTERFACE.GetName().Equals(sName))
      {
        itTemp = USER_INTERFACE;
      } else
      if (WEB_SERVICE.GetName().Equals(sName))
      {
        itTemp = WEB_SERVICE;
      } else
      if (INVITATION.GetName().Equals(sName))
      {
        itTemp = INVITATION;
      } else
      if (PORTLET_BUNDLE.GetName().Equals(sName))
      {
        itTemp = PORTLET_BUNDLE;
      } else
      if (REMOTE_SERVER.GetName().Equals(sName))
      {
        itTemp = REMOTE_SERVER;
      } else
      if (PORTLET_TEMPLATE.GetName().Equals(sName))
      {
        itTemp = PORTLET_TEMPLATE;
      } else
      if (ADMIN_FOLDER.GetName().Equals(sName))
      {
        itTemp = ADMIN_FOLDER;
      } else
      if (DOCUMENT_FOLDER.GetName().Equals(sName))
      {
        itTemp = DOCUMENT_FOLDER;
      } else
      if (PROFILE_SOURCE.GetName().Equals(sName))
      {
        itTemp = PROFILE_SOURCE;
      } else
      if (EXTERNAL_OPERATION.GetName().Equals(sName))
      {
        itTemp = EXTERNAL_OPERATION;
      } else
      if (PAGE.GetName().Equals(sName))
      {
        itTemp = PAGE;
      }
      return itTemp;
    }
    
    /// <returns></returns>
    public override String ToString()
    {
      return sName;
    }
  }
}