using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
namespace com.plumtree.portaluiinfrastructure.classtypedescriptors
{
  /// <author>John Osborne</author>
  public class ClassTypeComparator : IXPComparer
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_UI_INFRASTRUCTURE),
     "com.plumtree.portaluiinfrastructure.classtypedescriptors.classframework.ClassTypeComparator");
    private String m_strLangID;
    
    /// <summary>
    /// Creates a new ClassTypeComparator object.
    /// </summary>
    /// <param name="_strLangID"></param>
    public ClassTypeComparator(String _strLangID)
    {
      m_strLangID = _strLangID;
    }
    
    /// <param name="_obj1"></param>
    /// <param name="_obj2"></param>
    /// <returns></returns>
    public virtual int Compare(Object _obj1, Object _obj2)
    {
      APTClassTypeDesc obj1 = (APTClassTypeDesc) _obj1;
      APTClassTypeDesc obj2 = (APTClassTypeDesc) _obj2;
      String strLocalizedName1;
      String strLocalizedName2;
      try
      {
        strLocalizedName1 = obj1.GetClassTypeLocalizedName(m_strLangID);
        strLocalizedName2 = obj2.GetClassTypeLocalizedName(m_strLangID);
      }
      catch (Exception e)
      {
        strLocalizedName1 = null;
        strLocalizedName2 = null;
      }
      if (strLocalizedName1 == null || strLocalizedName2 == null)
      {
        log.Fatal("The creation of the alphabetized Create New menu failed. This is usually due to poorly formed or non-existent string resource files.");
        throw new XPException("The creation of the alphabetized Create New menu failed. This is usually due to poorly formed or non-existent string resource files.");
        }
      return XPStringUtility.Compare(strLocalizedName1, strLocalizedName2);
      }
    
    /// <param name="_obj1"></param>
    /// <param name="_obj2"></param>
    /// <returns></returns>
    public virtual int compare(Object _obj1, Object _obj2)
    {
      return Compare(_obj1, _obj2);
    }
  }
}