using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.friendlyurl;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portaluiinfrastructure.classtypedescriptors
{
  public interface IFriendlyURLManager
  {
    
    /// <summary>
    /// Returns the Opener redirect for this class type.
    /// </summary>
    /// <param name="_fURLParser"></param>
    /// <param name="_asParent"></param>
    /// <param name="_userSession"></param>
    /// <returns>The redirect for this request.</returns>
    Redirect GetFriendlyViewOpenerRedirect(IFriendlyURLParser _fURLParser,
     AActivitySpace _asParent, Object _userSession);
    
    /// <summary>
    /// Returns the friendly URL key for the particular class
    /// </summary>
    /// <param name="_strClassId">class id of the key that we want</param>
    /// <returns>The friendly URL key</returns>
    String LookupFriendlyURLKeyFromClassId(String _strClassId);
    
    /// <summary>
    /// Sets the lookup table in the Manager
    /// </summary>
    /// <param name="htLookupTable">table of class Id to keyword mappings</param>
    void SetFriendlyURLLookupTable(XPHashtable htLookupTable);
    
    /// <summary>
    /// Returns the friendly URL using the FriendlyURL and AActivitySpace class provided.
    /// </summary>
    /// <param name="url"></param>
    /// <param name="space"></param>
    /// <returns>The friendly URL</returns>
    String ConstructFriendlyURL(FriendlyURL url, AActivitySpace space);
  }
}