using System;
using com.plumtree.portaluiinfrastructure.classtypedescriptors.providerframework;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.opener.types;
namespace com.plumtree.portaluiinfrastructure.classtypedescriptors
{
  public interface IPTClassTypeDescManager : IClassTypeManager
  {
    String GetProviderEnglishNameForExistingObject(int _nClassID, int _nObjectID,
     IPTSession _ptSession);
    String GetProviderEnglishNameGivenCLSID(String _sCLSID);
    
    /// <summary>
    /// Returns an array containing all the registered providers for a particular
    /// class.
    /// </summary>
    /// <param name="_nClassID">The class ID of the type. (i.e. 38 for Crawler)</param>
    /// <returns>
    /// An array containing all the registered providers for a class. If
    /// there are none installed, you get back null.
    /// </returns>
    IProvInfo[] GetRegisteredProvInfoForClassType(int _nClassID);
    
    /// <summary>
    /// Given the English name of a provider this passes back the ProvInfo
    /// descriptor.
    /// </summary>
    /// <param name="_strProvInfoEngName">The provider English name.</param>
    /// <returns>The ProvInfo class. Null if not found.</returns>
    IProvInfo GetRegisteredProvInfoGivenEnglishName(String _strProvInfoEngName);
    }
}