using System;
// Framework Imports
using IXPComparer=com.plumtree.openfoundation.util.IXPComparer;
using XPException=com.plumtree.openfoundation.util.XPException;
using XPStringUtility=com.plumtree.openfoundation.util.XPStringUtility;
using OpenLogService=com.plumtree.openlog.OpenLogService;
using OpenLogger=com.plumtree.openlog.OpenLogger;
using PTDebugHelpers=com.plumtree.portaluiinfrastructure.statichelpers.PTDebugHelpers;
namespace com.plumtree.portaluiinfrastructure.classtypedescriptors
{
  /// <summary>
  /// This is class is used to print out together the Views for
  /// the object lock manager.
  /// </summary>
  /// <author>John Hogan</author>
  public class LockManagerObjectComparator : IXPComparer
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_UI_INFRASTRUCTURE),
     "com.plumtree.portaluiinfrastructure.classtypedescriptors.classframework.ClassTypeComparator");
    private String m_strLangID;
    
    /// <summary>
    /// Creates a new LockManagerObjectComparator object.
    /// </summary>
    /// <param name="_strLangID"></param>
    public LockManagerObjectComparator(String _strLangID)
    {
      m_strLangID = _strLangID;
    }
    
    /// <param name="_obj1"></param>
    /// <param name="_obj2"></param>
    /// <returns></returns>
    public virtual int Compare(Object _obj1, Object _obj2)
    {
      IPTClassTypeDesc obj1 = (IPTClassTypeDesc) _obj1;
      IPTClassTypeDesc obj2 = (IPTClassTypeDesc) _obj2;
      String strLocalizedName1;
      String strLocalizedName2;
      try
      {
        strLocalizedName1 = obj1.GetObjectLockManagerLocalizedName(m_strLangID);
        strLocalizedName2 = obj2.GetObjectLockManagerLocalizedName(m_strLangID);
        }
      catch (Exception e)
      {
        strLocalizedName1 = null;
        strLocalizedName2 = null;
      }
      if (strLocalizedName1 == null || strLocalizedName2 == null)
      {
        log.Fatal("The creation of the  page navigation links failed for Object Lock manager. This is usually due to non-existent string resource file for class type descriptors");
        throw new XPException("The creation of the  page navigation links failed for Object Lock manager. This is usually due to non-existent string resource file for class type descriptors");
        }
      return XPStringUtility.Compare(strLocalizedName1, strLocalizedName2);
      }
    
    /// <param name="_obj1"></param>
    /// <param name="_obj2"></param>
    /// <returns></returns>
    public virtual int compare(Object _obj1, Object _obj2)
    {
      return Compare(_obj1, _obj2);
    }
  }
}