using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.classtypedescriptors;
using com.plumtree.portaluiinfrastructure.friendlyurl;
using com.plumtree.portaluiinfrastructure.opener.plugins;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.server.marshalers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.application;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.htmlconstructs;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.web;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portaluiinfrastructure.classtypedescriptors.classtypes
{
  /// <author>michaeld</author>
  public class PTMyPages : APTNonExtClassTypeDesc
  {
    public const String MYPAGE_AS_NAME = "MyPage";
    public const String MYPAGE_CONTROL_NAME = "SetPage";
    public const String STR_PAGE_ID = "PageID";
    public const String EDITPAGE_AS_NAME = "EditMyPortalPage";
    public const String EDITPAGE_CONTROL_NAME = "EditorStart";
    public const String STR_OPENERPAGE_ID = "OpenerPageID";
    public const String STR_OPENERCONTAINER_ID = "OpenerCommunityID";
    public const String STR_EDITORTYPE_ID = "editorType";
    public const String STR_CREATE_MYPAGE = "CreateMyPage";
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_UI_INFRASTRUCTURE),
     "com.plumtree.portaluiinfrastructure.classtypedescriptors.classtypes.PTMyPages");
    private static OpenLogger fulog = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_FRIENDLYURL),
     "com.plumtree.portaluiinfrastructure.classtypedescriptors.classtypes.PTMyPages");
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.classtypedescriptors.APTNonExtClassTypeDesc#GetASNameForEditor()"></seealso>
    public override String GetASNameForEditor()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.classtypedescriptors.IPTClassTypeDesc#AppearsInMainCreateNewClassMenu()"></seealso>
    public override bool AppearsInMainCreateNewClassMenu()
    {
      return false;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.classtypedescriptors.IPTClassTypeDesc#GetClassID()"></seealso>
    public override int GetClassID()
    {
      return PT_CLASSIDS.PT_MYPAGESCONTAINER_ID;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.classtypedescriptors.IPTClassTypeDesc#GetClassTypeLocalizedName(java.lang.String)"></seealso>
    public override String GetClassTypeLocalizedName(String _strLangID)
    {
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      XPResourceManager rm = (XPResourceManager) application.GetCachingManager().GetEntry("ResourceManager");
      return rm.GetString(506, "ptmsgs_portalinfrastructure", _strLangID);
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.classtypedescriptors.APTClassTypeDesc#GetCreateActivityID()"></seealso>
    public override int GetCreateActivityID()
    {
      return 0;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.classtypedescriptors.IPTClassTypeDesc#GetDefaultIcon()"></seealso>
    public override HTMLImg GetDefaultIcon()
    {
      try
      {
        HTMLImg imgIcon = (HTMLImg) UIConstructFactory.GetConstruct(PTImageType.ICON_MYPAGE).GetHTMLElement();
        return imgIcon;
      }
      catch (Exception e)
      {
        return null;
      }
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.classtypedescriptors.IPTClassTypeDesc#GetRelatedClassTypeIDs()"></seealso>
    public override int[] GetRelatedClassTypeIDs()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.classtypedescriptors.IPTClassTypeDesc#HasGlobalClassTypeMap()"></seealso>
    public override bool HasGlobalClassTypeMap()
    {
      return false;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetRedirectCreateNew(com.plumtree.openfoundation.util.XPHashtable,com.plumtree.uiinfrastructure.activityspace.AActivitySpace,com.plumtree.server.IPTSession)"></seealso>
    public override Redirect GetRedirectCreateNew(XPHashtable _htArguments,
     AActivitySpace _asParent, Object _userSession)
    {
      Redirect resultingRedirect = new Redirect();
      resultingRedirect.SetLinkCreateNewSpace(EDITPAGE_AS_NAME, _asParent);
      resultingRedirect.SetControl(EDITPAGE_CONTROL_NAME);
      resultingRedirect.AddControlArgument(STR_CREATE_MYPAGE, true);
      resultingRedirect.AddControlArgument(STR_EDITORTYPE_ID, 10);
      return resultingRedirect;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetRedirectOpenObject(com.plumtree.openfoundation.util.XPHashtable,com.plumtree.uiinfrastructure.activityspace.AActivitySpace,com.plumtree.server.IPTSession)"></seealso>
    public override Redirect GetRedirectOpenObject(XPHashtable _htArguments,
     AActivitySpace _asParent, Object _userSession)
    {
      // if user is a guest user
      ISessionManager sessionMan = _asParent.GetSubSession();
      Object sesValid = sessionMan.GetAttribute(Interpreter.USERSESSIONVALID);
      bool bIsGuest = false;
      if (sesValid == null)
      {
        bIsGuest = false;
      } else
      {
        bIsGuest = !XPConvert.ToBoolean(sesValid);
      }
      if (bIsGuest)
      {
        return GetRedirectViewObject(_htArguments, _asParent, _userSession);
        }
      int nPageID = HTTPHelpers.GetArgumentAsInt(_htArguments, STR_PAGE_ID,
       0);
      Redirect resultingRedirect = new Redirect();
      resultingRedirect.SetLinkCreateNewSpace(EDITPAGE_AS_NAME, _asParent);
      resultingRedirect.SetControl(EDITPAGE_CONTROL_NAME);
      resultingRedirect.AddControlArgument(STR_OPENERPAGE_ID, nPageID);
      resultingRedirect.AddControlArgument(STR_EDITORTYPE_ID, 10);
      return resultingRedirect;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetRedirectViewObject(com.plumtree.openfoundation.util.XPHashtable,com.plumtree.uiinfrastructure.activityspace.AActivitySpace,com.plumtree.server.IPTSession)"></seealso>
    public override Redirect GetRedirectViewObject(XPHashtable _htArguments,
     AActivitySpace _asParent, Object _userSession)
    {
      Redirect resultingRedirect = new Redirect();
      int nPageID = HTTPHelpers.GetArgumentAsInt(_htArguments, STR_PAGE_ID,
       0);
      // in view mode, we go to the community.
      resultingRedirect.SetLinkCreateNewSpace(MYPAGE_AS_NAME, _asParent);
      resultingRedirect.SetControl(MYPAGE_CONTROL_NAME);
      resultingRedirect.AddControlArgument(STR_PAGE_ID, nPageID);
      resultingRedirect.SetStripParentSpace(true);
      return resultingRedirect;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.classtypedescriptors.classframework.IPTClassTypeDesc#GetRedirectViewObject()"></seealso>
    public override Redirect GetRedirectViewObject(IFriendlyURLParser _fURLParser,
     AActivitySpace _asParent, Object _userSession)
    {
      Redirect resultingRedirect = new Redirect();
      // DCA - used cached version if available in case it's a repost
      resultingRedirect.SetLinkGetSpaceIfCached(MYPAGE_AS_NAME, _asParent);
      resultingRedirect.SetControl(MYPAGE_CONTROL_NAME);
      int nMyPageId = _fURLParser.GetObjectId();
      String strMypageName = _fURLParser.GetObjectName(true);
      IPTSessionInfo sinfo = ((IPTSession) _userSession).GetSessionInfo();
      IPTQueryResult qRes = sinfo.GetCurrentMyPages();
      if (nMyPageId == 0)
      {
        for (int i = 0;i < qRes.RowCount();i++)
        {
          String curPageName = qRes.ItemAsString(i, PT_PROPIDS.PT_PROPID_NAME);
          if (XPStringUtility.EqualsIgnoreCase(strMypageName, FriendlyURL.DeNormalizeObjectName(curPageName)))
          {
            nMyPageId = qRes.ItemAsInt(i, PT_PROPIDS.PT_PROPID_OBJECTID);
            break;
          }
        }
      }
      if (nMyPageId > 0)
      {
        fulog.Debug("PTMyPages:GetRedirectViewObject Redirecting to my page with Id: " + nMyPageId);
        resultingRedirect.AddControlArgument(STR_PAGE_ID, nMyPageId);
      } else
      {
        fulog.Info("No MyPage found with name \"" + strMypageName + "\" for user with id: " + sinfo.GetCurrentUserID());
        throw new PTException("An error occured while trying to parse the request. Check that the URL is valid.",
         PT_RESULTCODES.PT_E_FAIL);
      }
      return resultingRedirect;
    }
    
    /// <seealso cref="IPTClassTypeDesc#ConstructFriendlyURL(String,int,String)">Generates a friendly Url for user mypages</seealso>
    public override String ConstructFriendlyURL(FriendlyURL url, AActivitySpace space)
    {
      String pageName = url.GetOjectName();
      int pageId = url.GetObjectId();
      XPStringBuilder buf = new XPStringBuilder(200);
      if (("".Equals(pageName) || pageName == null) && pageId < 0)
      {
        throw new PTException("Both page name and id are missing. At least one needs to be specified to create a friendly Url.",
         PT_RESULTCODES.PT_E_INVALIDARGUMENT);
      }
      IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
      IFriendlyURLManager ptFriendlyURLMgr = (IFriendlyURLManager) application.GetCachingManager().GetEntry(AppWarmUp.KEY_CACHEMAN_CLASS_TYPE_MANAGER);
      String pageKeyword = ptFriendlyURLMgr.LookupFriendlyURLKeyFromClassId(PT_CLASSIDS.PT_MYPAGESCONTAINER_ID + "");
      if (pageKeyword == null)
      {
        throw new PTException("No Friendly URL keyword was found for my pages. " + "Verify that a mapping entry exists in FriendlyURL.xml.",
         PT_RESULTCODES.PT_E_FAIL);
      }
      buf.Append("/").Append(pageKeyword);
      // looking up pageName if only pageid is given and FriendlyURL returns pagename as null or ""
      if ("".Equals(pageName) || pageName == null)
      {
        IPTSessionInfo sinfo = ((IPTSession) space.GetUserSession()).GetSessionInfo();
        IPTQueryResult qRes = sinfo.GetCurrentMyPages();
        if (pageId > 0)
        {
          for (int i = 0;i < qRes.RowCount();i++)
          {
            if (pageId == qRes.ItemAsInt(i, PT_PROPIDS.PT_PROPID_OBJECTID))
            {
              pageName = qRes.ItemAsString(i, PT_PROPIDS.PT_PROPID_NAME);
              break;
            }
          }
        } else
        {
          pageName = qRes.ItemAsString(0, PT_PROPIDS.PT_PROPID_NAME);
        }
      }
      if (pageName == null)
      {
        throw new PTException("Unable to look up page with id " + pageId + ".",
         PT_RESULTCODES.PT_E_FAIL);
      }
      String normPageName = FriendlyURL.NormalizeObjectName(pageName);
      // DCA - we're encoding in case it has non-ASCII chars
      normPageName = XPHttpUtility.UrlEncode(normPageName, LinkConstants.UTF_8_ENCODING);
      buf.Append("/").Append(normPageName);
      if (FriendlyURLPlugin.UseObjectId())
      {
        buf.Append("/").Append(pageId);
      }
      return buf.ToString();
    }
    /* (non-Javadoc)
     * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.classframework.IPTClassTypeDesc#GetRedirectViewObjectMetaData(com.plumtree.openfoundation.util.XPHashtable, com.plumtree.uiinfrastructure.activityspace.AActivitySpace, com.plumtree.server.IPTSession)
     */
     
    public override Redirect GetRedirectViewObjectMetaData(XPHashtable _htArguments,
     AActivitySpace _asParent, Object _userSession)
    {
      return GetRedirectViewObject(_htArguments, _asParent, _userSession);
      }
  }
}