using System;
namespace com.plumtree.portaluiinfrastructure.compoundlist
{
  /// <summary>
  /// Iterator Interface for Compoundlist 
  /// </summary>
  /// <author>robertz</author>
  public interface ICPListEntryIterator
  {
    
    /// <summary>
    /// Gets the current entry. Doesn't advance the iterator
    /// </summary>
    /// <returns>Current entry</returns>
    ListEntry GetEntry();
    
    /// <summary>
    /// Gets the entry at a specified entry
    /// </summary>
    /// <param name="nIndex">Index of the entry</param>
    /// <returns>Entry at the specified index</returns>
    ListEntry GetEntryAtIndex(int nIndex);
    
    /// <summary>
    /// Resets the iterator
    /// </summary>
    void GetIterator();
    
    /// <summary>
    /// Gets the amount of entries in the list
    /// </summary>
    /// <returns>Number of entries in the list</returns>
    int GetTotalCount();
    
    /// <summary>
    /// Advance the iterator to next entry.
    /// </summary>
    /// <returns>false if no more entries, otherwise true.</returns>
    bool Next();
  }
}