using System;
// Plumtree Server Imports
using com.plumtree.server;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portaluiinfrastructure.editor
{
  /// <summary>
  /// This is the interface for the read-only Model. This interface is implemented
  /// by ObjEditorModel. Any read-only Model interface should extend this one.
  /// </summary>
  /// <author>Julie Fournier</author>
  public interface IObjEditorModelRO : IEditorModelRO
  {
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.ObjEditorModel#GetClassID()"></seealso>
    int GetClassID();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.ObjEditorModel#GetObject()"></seealso>
    IPTObject GetObject();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.ObjEditorModel#GetObjectDescription()"></seealso>
    String GetObjectDescription();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.ObjEditorModel#GetObjectID()"></seealso>
    int GetObjectID();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.ObjEditorModel#GetObjectName()"></seealso>
    String GetObjectName();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.ObjEditorModel#GetPTSession()"></seealso>
    IPTSession GetPTSession();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.ObjEditorModel#GetParentFolderPath()"></seealso>
    String GetParentFolderPath();
  }
}