using System;
// Framework imports
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portaluiinfrastructure.editor
{
  /// <summary>
  /// This is the DP for the dependencies page. It's the
  /// last page of the save pop-up and has a confirmation
  /// message and some links to create other objects that
  /// depend on the one that was just created.
  /// </summary>
  /// <author>Julie Fournier</author>
  public class ObjDependenciesDP : AFormDP
  {
    
    /// <summary>
    /// Class name for the activity space
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "ObjDependencies";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()"></seealso>
    public override String GetFormTitle()
    {
      return m_asOwner.GetString(127, "ptmsgs_portalinfrastructure");
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      return m_asOwner.GetView(((ObjEditorAS) m_asOwner).GetDependenciesViewName()).Display();
      }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(((ObjEditorAS) m_asOwner).GetDependenciesViewName()).DisplayJavascript());
      return myScripts;
    }
  }
}