using System;
using com.plumtree.portaluiinfrastructure.opener;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portaluiinfrastructure.editor
{
  /// <summary>
  /// This is the Activity Space class for the ObjEditor Framework.
  /// Editor Activity Space classes should extend this class.
  /// </summary>
  /// <author>Julie Fournier</author>
  public abstract class PTEditorAS : EditorAS
  {
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.IFormAS#DisplayCommonJavaScript()"></seealso>
    public override HTMLScriptCollection DisplayCommonJavaScript()
    {
      HTMLScriptCollection scripts = base.DisplayCommonJavaScript();
      // Add common object opener javascript
      scripts.AddInnerHTMLElement(PTOpenerLinks.GetOpenerJavascript(this));
      return scripts;
    }
    
    /// <summary>
    /// Returns the class name of the Editor Repost Control.
    /// Editors should also implement that method and return
    /// the name of their own repost  control, unless they
    /// don't have any. In that case they don't need to implement
    /// the method and EditorRepostControl will be used by default.
    /// </summary>
    /// <returns>String</returns>
    public override String GetRepostControlName()
    {
      return (EditorRepostControl.STR_MVC_CLASS_NAME);
    }
  }
}