using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.arraywrapper;
using com.plumtree.uiinfrastructure.expandablelist;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portaluiinfrastructure.editor.commonpages.keywords
{
  /// <author>michaeld</author>
  public class KeywordsView : ExpListView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_UI_INFRASTRUCTURE),
     "com.plumtree.portaluiinfrastructure.editor.commonpages.keywords.KeywordsView");
    
    /// <summary>
    /// Class name for the activity space 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "Keywords";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.ExpListView#GetHTMLForRow(com.plumtree.uiinfrastructure.arraywrapper.IPTGrowableSortedArrayWrapperRO,int)"></seealso>
    public override HTMLElement GetHTMLForRow(IPTGrowableSortedArrayWrapperRO _saData,
     int _nRowIndex)
    {
      //MES- Get the data for the row
      String sKeyword = (String) _saData.GetItem(_nRowIndex, KeywordsModel.KEYWORDSMODEL_COL_KEYWORD);
      String sURL = (String) _saData.GetItem(_nRowIndex, KeywordsModel.KEYWORDSMODEL_COL_URL);
      HTMLElementCollection myRow = new HTMLElementCollection();
      HTMLTableCell myCell;
      //MJD- Add the keyword
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetHeight("30");
      myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
      myCell.SetNoWrap(true);
      myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
      myCell.AddInnerHTMLEncodedString(sKeyword);
      //MJD- Next column is url	
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
      myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
      myCell.SetNoWrap(true);
      //MJD- The anchor to open keyword URL
      HTMLAnchor myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
      myAnchor.SetOnClick(ConstructStaticHelpers.BLANK_URL);
      // TODO-MJD : does there need to be some kind of encoding on this URL?
      myAnchor.SetOnClick("window.open(\'" + sURL + "\'); return false;");
      myAnchor.AddInnerHTMLEncodedString(sURL);
      myCell.AddInnerHTMLElement(myAnchor);
      return myRow;
    }
    
    /// <summary>
    /// No Action Bar for keywords
    /// </summary>
    protected override HTMLTable GetHTMLForActionBar()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new KeywordsView();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
  }
}