using System;
namespace com.plumtree.portaluiinfrastructure.editor.commonpages.localizednames
{
  /// <author>josephc</author>
  public interface ILocNamesModel : ILocNamesModelRO
  {
    
    /// <summary>
    /// Call this method if the default name label is not appropriate.
    /// </summary>
    /// <param name="sNameLabel"></param>
    void SetNameLabel(String sNameLabel);
    
    /// <summary>
    /// If this method is not called, then it will default to using descriptions unless the Object does not support it.
    /// </summary>
    /// <param name="bNoDescriptions"></param>
    void SetIsNoDescriptions(bool bNoDescriptions);
    
    /// <summary>
    /// Call this method if you want the popup display page to be something other than LocNamesPopUpDP.STR_MVC_CLASS_NAME
    /// </summary>
    /// <param name="sPopUpDisplayPageName"></param>
    void SetPopUpDisplayPageName(String sPopUpDisplayPageName);
    
    /// <param name="sPrimaryLang"></param>
    void SetPrimaryLang(String sPrimaryLang);
    
    /// <param name="bIsLocalized"></param>
    void SetIsLocalized(bool bIsLocalized);
    
    /// <param name="nRowToEdit"></param>
    void SetRowToEdit(int nRowToEdit);
  }
}