using System;
using com.plumtree.uiinfrastructure.expandablelist;
using com.plumtree.xpshared.htmlconstructs;
namespace com.plumtree.portaluiinfrastructure.editor.commonpages.localizednames
{
  /// <summary>
  /// This interface is implemented by the Model. It contains all the read-only
  /// methods of the Model accessed by the Views.
  /// </summary>
  /// <author>MichaelS</author>
  public interface ILocNamesModelRO : IExpListModelRO
  {
    
    /// <seealso cref="com.plumtree.uiinfrastructure.expandablelist.GrowableListModel#GetRowIcon()"></seealso>
    PTImageType GetRowIcon();
    
    /// <returns>Name label</returns>
    String GetNameLabel();
    
    /// <returns>boolean - No Descriptions</returns>
    bool IsNoDescriptions();
    
    /// <returns>Name of Pop Up Display Page</returns>
    String GetPopUpDisplayPageName();
    
    /// <returns></returns>
    int GetClassID();
    
    /// <returns></returns>
    int GetObjectID();
    
    /// <returns></returns>
    String GetObjectUUID();
    
    /// <returns></returns>
    String GetPrimaryName();
    
    /// <returns></returns>
    String GetPrimaryDesc();
    
    /// <returns></returns>
    String GetPrimaryLang();
    
    /// <returns></returns>
    bool GetIsLocalized();
    
    /// <returns></returns>
    int GetRowToEdit();
    
    /// <returns></returns>
    bool SupportsLocalization();
    
    /// <returns></returns>
    bool HasMandatoryLang();
    
    /// <returns></returns>
    bool IsUsingMaxNameOverride();
    
    /// <returns></returns>
    int GetMaxNameOverride();
  }
}