using System;
// Framework Imports
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portaluiinfrastructure.editor.commonpages.localizednames
{
  /// <summary>
  /// MES- The LocNamesPopUpDP class is a Display Page for the Localized Names
  /// popup.  The popup is used to edit the name and description for a given
  /// language, or add a new name/description.
  /// </summary>
  /// <version>1.0</version>
  /// <author>MichaelS</author>
  public class LocNamesPopUpDP : AFormDP
  {
    
    /// <summary>
    /// MES- The name of this object 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "LocNamesPopUp";
    
    /// <summary>
    /// Returns the String to display on the left navigation menu,  linking to
    /// that page.
    /// </summary>
    /// <returns>String</returns>
    public virtual String GetLeftNavString()
    {
      // JF- This is not used here.
      return "";
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the title for the form
    /// </summary>
    /// <returns>String</returns>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#GetFormTitle()"></seealso>
    public override String GetFormTitle()
    {
      //MES- Localized Name and Description
      return m_asOwner.GetString(428, "ptmsgs_portalinfrastructure");
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#GetFormPageType()"></seealso>
    public override FormPageTypes GetFormPageType()
    {
      return FormPageTypes.NO_BUTTONS;
    }
    
    /// <summary>
    /// Returns the HTML for that Page.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      //MES- Just ask the popup view to write itself
      HTMLElementCollection result = new HTMLElementCollection();
      result.AddInnerHTMLElement(((IView) m_asOwner.GetView(LocNamesPopUpView.STR_MVC_CLASS_NAME)).Display());
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      //MES- Ask the superclass if it's got anything.
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      //MES- And ask the popup view if it's got anything
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(LocNamesPopUpView.STR_MVC_CLASS_NAME).DisplayJavascript());
      return myScripts;
    }
  }
}