using System;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portaluiinfrastructure.editor.commonpages.migrationhistory
{
  /// <summary>
  /// Plugin page used by object editors to display migration history and status.
  /// </summary>
  /// <version>$Revision$</version>
  /// <author>ArvindS</author>
  public class MigrationHistoryPluginDP : EditorDP
  {
    
    /// <summary>
    /// The name of this display page 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "MigrationHistoryPlugin";
    
    /// <summary>
    /// Returns the string used in the left nav link of the editor for this page.
    /// </summary>
    /// <returns>The left nav link name for this page.</returns>
    public override String GetLeftNavString()
    {
      return m_asOwner.GetString(71, "ptmsgs_portalinfrastructure");
    }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(269, "ptmsgs_portalinfrastructure"),
       this.m_asOwner);
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Displays the page
    /// </summary>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // Insert super class HTML
      result.AddInnerHTMLElement(base.PageDisplay());
      HTMLElementCollection views = new HTMLElementCollection();
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(MigrationHistoryView.STR_MVC_CLASS_NAME)).Display());
      result.AddInnerHTMLElement(CreateLeftNavBar(views));
      return result;
    }
  }
}