using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.portaluiinfrastructure.editor;
namespace com.plumtree.portaluiinfrastructure.editor.commonpages.objectproperties
{
  /// <summary>
  /// Activity space for browsing object properties
  /// </summary>
  /// <author>josephc</author>
  public class ObjPropEditorAS : ObjEditorAS
  {
    
    /// <summary>
    /// Class name for ObjPropEditorAS 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "ObjPropEditor";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new ObjPropEditorAS();
    }
    
    /// <summary>
    /// Sets the Editor title.
    /// </summary>
    /// <returns>Editor title</returns>
    public override String GetEditorTitle()
    {
      return XPResourceManager.FormatMessage(GetString(279, "ptmsgs_portalinfrastructure"),
       GetObjectName());
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Registers all the classes for this Activity Space.
    /// </summary>
    public override void Init()
    {
      m_strModelName = ObjPropEditorModel.STR_MVC_CLASS_NAME;
      base.Init();
      // Register Plug-In: Browse Object Properties
      RegisterView(ObjPropBrowseView.STR_MVC_CLASS_NAME, GetModel(ObjPropModel.STR_MVC_CLASS_NAME));
      RegisterPage(new ObjPropBrowseDP());
    }
  }
}