using System;
// Framework Imports
using com.plumtree.portaluiinfrastructure.expandablelist.selectptobject;
namespace com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity
{
  /// <summary>
  /// This interface is implemented by the Model.
  /// It contains all the read-only mothods of the Model
  /// accessed by the Views.
  /// </summary>
  /// <author>Julie Fournier</author>
  public interface IObjectSecurityModelRO : ISelectPTObjectModelRO
  {
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.ObjectSecurityModel#GetAccessLevelString()"></seealso>
    String GetAccessLevelString(int _nAccessLevelID);
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.ObjectSecurityModel#GetAccessLevels()"></seealso>
    int[] GetAccessLevels();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.ObjectSecurityModel#GetLeftNavString()"></seealso>
    String GetLeftNavString();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.ObjectSecurityModel#GetShowHeaderAndLeftNav()"></seealso>
    bool GetShowHeaderAndLeftNav();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.ObjectSecurityModel#GetSupportMandatoryColumn()"></seealso>
    int GetSupportMandatoryColumn();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.ObjectSecurityModel#HasEditAccessToGroup()"></seealso>
    bool HasEditAccessToGroup(int _nGroupID);
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.ObjectSecurityModel#GetIsCardACL()"></seealso>
    bool GetIsCardACL();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.ObjectSecurityModel#IsEveryoneGroup()"></seealso>
    bool IsEveryoneGroup(int _nRowIndex);
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.ObjectSecurityModel#DisplayGroupMembersTree()"></seealso>
    bool DisplayGroupMembersTree(int _nGroupID);
  }
}