using System;
// Framework imports
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portaluiinfrastructure.editor.saveobject
{
  /// <summary>
  /// This interface is implemented by the Model.
  /// It contains all the read-only mothods of the Model
  /// accessed by the Views.
  /// </summary>
  /// <author>Julie Fournier</author>
  public interface ISaveObjectModelRO : IModelRO
  {
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#ForceSaveInFolder()"></seealso>
    bool ForceSaveInFolder();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetAdminFolderID()"></seealso>
    int GetAdminFolderID();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetCurrentTab()"></seealso>
    int GetCurrentTab();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetFolderName()"></seealso>
    String GetFolderName();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetObjectDescription()"></seealso>
    String GetObjectDescription();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetObjectName()"></seealso>
    String GetObjectName();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetRecentlyUsedFolders()"></seealso>
    Object[][] GetRecentlyUsedFolders();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetRepostBodyFromBottomFrame()"></seealso>
    bool GetRepostBodyFromBottomFrame();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetRepostBodyFromTopFrame()"></seealso>
    bool GetRepostBodyFromTopFrame();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetRepostTreeAndSave()"></seealso>
    bool GetRepostTreeAndSave();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetRepostTreeRecentFoldersFrame()"></seealso>
    bool GetRepostTreeRecentFoldersFrame();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetTitle()"></seealso>
    String GetTitle();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#HideSecurityTab()"></seealso>
    bool HideSecurityTab();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#IsAdminFolderInRecentFolders()"></seealso>
    bool IsAdminFolderInRecentFolders(int _nFolderID);
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#IsMigrationApproved()"></seealso>
    bool IsMigrationApproved();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#IsSysAdmin()"></seealso>
    bool IsSysAdmin();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#IsDescriptionDisabled()"></seealso>
    bool IsDescriptionDisabled();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#IsCurrentObjectCommunity()"></seealso>
    bool IsCurrentObjectCommunity();
  }
}