using System;
// Framework imports
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portaluiinfrastructure.editor.saveobject
{
  /// <summary>
  /// This is the DP is to replace the folder tree when the admin
  /// folder cannot be changed.
  /// </summary>
  /// <author>Julie Fournier</author>
  public class SaveObjectCantChangeFolderDP : AFormDP
  {
    
    /// <summary>
    /// Class name for the activity space
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "SaveObjectCantChangeFolder";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()"></seealso>
    public override String GetFormTitle()
    {
      // JF- This DP in inside a frame. No need to set the form title here.
      return "";
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      return m_asOwner.GetView(SaveObjectCantChangeFolderView.STR_MVC_CLASS_NAME).Display();
      }
  }
}