using System;
// Framework Imports
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.expandablelist;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portaluiinfrastructure.expandablelist.selectptobject
{
  /// <summary>
  /// This interface is implemented by the Model.
  /// It contains all the read-only mothods of the Model
  /// accessed by the Views.
  /// </summary>
  /// <author>Julie Fournier</author>
  public interface ISelectPTObjectModelRO : IExpListModelRO
  {
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetAccessLevel()"></seealso>
    int GetAccessLevel();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetCommunityMode()"></seealso>
    int GetCommunityMode();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetCommunityFolderID()"></seealso>
    int GetCommunityFolderID();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetCreateNewInfo()"></seealso>
    Object[][] GetCreateNewInfo();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetCreateNewURL()"></seealso>
    ASURL GetCreateNewURL(int _nClassID, String _sEditorASName);
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetEditObjectURL()"></seealso>
    ASURL GetEditObjectURL(int _nClassID, int _nObjectID);
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#ClearHiddenObjects()"></seealso>
    void ClearHiddenObjects();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetHiddenObjects()"></seealso>
    String GetHiddenObjects();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetObjectClassIDs()"></seealso>
    String GetObjectClassIDs();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetRowIcon()"></seealso>
    PTImageType GetDefaultRowIcon();
    
    /// <summary>
    /// Returns the value of the m_bNoRowIcons member variable.  True if no
    /// icons are to be displayed on each selected row.
    /// </summary>
    /// <returns>boolean</returns>
    bool GetNoRowIcons();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetRowIconByClassID()"></seealso>
    PTImageType GetRowIconByClassID(int _nClassID);
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetSelectedItems()"></seealso>
    String GetSelectedItems();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetSelectedNamesAsHTML()"></seealso>
    HTMLElementCollection GetSelectedNamesAsHTML();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetTreeLeafType()"></seealso>
    int GetTreeLeafType();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetTreeMultiSelect()"></seealso>
    String GetTreeMultiSelect();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetTreeQueryFilter()"></seealso>
    String GetTreeQueryFilter();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetTreeSpaceID()"></seealso>
    String GetTreeSpaceID();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetTreeSubTitle()"></seealso>
    String GetTreeSubTitle();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetTreeTitle()"></seealso>
    String GetTreeTitle();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#IsEditLinkEnabled()"></seealso>
    bool IsEditLinkEnabled(int _nClassID);
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetDisplayObjects()"></seealso>
    String GetDisplayObjects();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#IsObjectReadOnly()"></seealso>
    bool IsObjectReadOnly(int _nClassID, int _nObjectID);
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetUniquePopUpName()"></seealso>
    String GetUniquePopUpName(String _sName);
  }
}