using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openkernel.sharedcache;
namespace com.plumtree.portaluiinfrastructure.failover
{
  /// <summary>
  /// DOCUMENT_ME
  /// </summary>
  /// <author>ErickS, JosephC</author>
  public class CleanupCache : IXPRunnable
  {
    private IOKSharedCache m_sharedCache;
    
    /// <summary>
    /// Creates a new CleanupCache object.
    /// </summary>
    /// <param name="sharedCache">DOCUMENT_ME</param>
    public CleanupCache(IOKSharedCache sharedCache)
    {
      m_sharedCache = sharedCache;
    }
    
    /// <summary>
    /// DOCUMENT_ME
    /// </summary>
    public virtual void run()
    {
      XPArrayList arrToDelete = new XPArrayList();
      lock (m_sharedCache) {
        IXPEnumerator xpKeys = m_sharedCache.GetKeys();
        while (xpKeys.MoveNext())
        {
          String replicationToken = (String) xpKeys.GetCurrent();
          XPDateTime lastModified = ReplicationCache.GetLastModified(replicationToken);
          if (lastModified != null)
          {
            // if dtLastModified >= CLEANUP_MINUTES, add it to the toDelete array
            if (ReplicationCache.IsExpired(lastModified, ReplicationCache.CLEANUP_MINUTES))
            {
              arrToDelete.Add(replicationToken);
            }
          }
        }
        // Perform cleanup after iteration is done.
        for (int i = 0;i < arrToDelete.GetSize();i++)
        {
          String replicationToken = (String) arrToDelete.GetElement(i);
          ReplicationCache.Remove(replicationToken);
        }
      }
    }
  }
}