using System;
using com.plumtree.portaluiinfrastructure.resultwrapper;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portaluiinfrastructure.filter
{
  /// <author>CraigS, based on MikeS code</author>
  public interface IFilterIteratorRO : IModelRO
  {
    
    /// <summary>
    /// Make a brand-new QueryCondition.
    /// </summary>
    QueryCondition MakeQueryCondition();
    
    /// <summary>
    /// Gets the depth of the current clause.
    /// </summary>
    /// <returns>the depth of the current clause.</returns>
    int GetCurrentClauseDepth();
    
    /// <summary>
    /// Gets the operator (AND or OR) that joins the current clause together.
    /// </summary>
    /// <returns>the operator</returns>
    bool GetCurrentClauseOperator();
    
    /// <summary>
    /// Gets the filter's top-level search string.
    /// </summary>
    /// <returns>the search string</returns>
    String GetTextSearchString();
    
    /// <returns></returns>
    bool GetNextClausePosition();
    
    /// <param name="qc"></param>
    /// <returns></returns>
    bool GetNextStatementAndSetQC(QueryCondition qc);
    
    /// <param name="qc"></param>
    /// <returns></returns>
    bool AddSetProperty(QueryCondition qc);
    
    /// <summary>
    /// Convenience method to return the number of items in the first clause;
    /// basically an easy way to see if this filter contains anything of interest
    /// </summary>
    int GetNumItemsInFirstClause();
    
    /// <summary>
    /// Queries the database for the set of properties this user can see (on the
    /// first call), returns a cached value on subsequent calls.
    /// </summary>
    IASQueryResult GetPropertiesVisibleToCurrentUser();
    
    /// <returns></returns>
    bool GetTopLevelAllMustPass();
    
    /// <summary>
    /// Resets this iterator to the beginning.
    /// </summary>
    void SetIteratorToStart();
  }
}