using System;
using com.plumtree.openfoundation.util;
namespace com.plumtree.portaluiinfrastructure.friendlyurl
{
  /// <summary>
  /// Friendly URL parser specific to community URLs. Checks the URL for community Id,
  /// and community page name.
  /// </summary>
  /// <author>duang</author>
  public class CommunityFriendlyURLParser : FriendlyURLParser
  {
    public CommunityFriendlyURLParser(String strKeyword, String strClassId,
     XPStringTokenizer stURLTokens) : base(strKeyword, strClassId, stURLTokens)
    {
      // DCA - there are 4 different ways to specify a community page, we must handle all
      // /community_name/
      // /community_name/community_id/ 
      // /community_name/page_name/
      // /community_name/community_id/page_name/
      // /community_name/community_id/page_name/page_id
      if (stURLTokens.HasMoreTokens())
      {
        String strTemp = stURLTokens.GetNextToken();
        for (int i = 0;i < strTemp.Length;i++)
        {
          if (!XPCharacterUtility.IsASCIIDecimalDigit(XPStringUtility.CharAt(strTemp,
           i)))
          {
            m_strChildName = URLDecode(strTemp);
            break;
          }
        }
        if (null == m_strChildName)
        {
          try
          {
            m_nObjectId = XPConvert.ToInteger(strTemp);
          }
          catch (XPException e)
          {
          }
        }
      }
      // invalid page id
      // just ignore it and try to use the name instead
      if (stURLTokens.HasMoreTokens())
      {
        // DCA - this has to be the page name
        m_strChildName = URLDecode(stURLTokens.GetNextToken());
      }
      if (stURLTokens.HasMoreTokens())
      {
        // ROB - and page id
        try
        {
          m_nChildId = XPConvert.ToInteger(stURLTokens.GetNextToken());
        }
        catch (XPException e)
        {
        }
      }
    }
  }
}
// invalid page id
// just ignore it and try to use the name instead
