using System;
using com.plumtree.openfoundation.util;
namespace com.plumtree.portaluiinfrastructure.friendlyurl
{
  /// <summary>
  /// Friendly URL parser specific to document URLs. Checks the URL for folder Id.
  /// </summary>
  /// <author>duang</author>
  public class DocumentFriendlyURLParser : FriendlyURLParser
  {
    public DocumentFriendlyURLParser(String strKeyword, String strClassId,
     XPStringTokenizer stURLTokens)
    {
      m_strKeyword = strKeyword;
      m_strClassId = strClassId;
      // /document_id/filename
      // /filename
      if (stURLTokens.HasMoreTokens())
      {
        // DCA - this could the the document id or the filename
        String strTemp = stURLTokens.GetNextToken();
        for (int i = 0;i < strTemp.Length;i++)
        {
          if (!XPCharacterUtility.IsASCIIDecimalDigit(XPStringUtility.CharAt(strTemp,
           i)))
          {
            m_strObjectName = URLDecode(strTemp);
            break;
          }
        }
        if (null == m_strObjectName)
        {
          m_nObjectId = XPConvert.ToInteger(strTemp);
        }
      }
      if (stURLTokens.HasMoreTokens())
      {
        // DCA - this has to be the filename
        String strFileName = stURLTokens.GetNextToken();
        m_strObjectName = URLDecode(strFileName);
      }
    }
  }
}