using System;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlconstructs;
namespace com.plumtree.portaluiinfrastructure.helpers
{
  public interface IAppDataObjectFactory
  {
    // Returns the app data state object. This function is used by everyone but the gateway.
    IPTState GetAppDataObject(int iCommunityID, int iPageID, String strHostPageURI,
     AActivitySpace asOwner);
    // Returns the app data state object. This function is used by everyone but the gateway.
    IPTState GetAppDataObject(int iCommunityID, int iPageID, String strHostPageURI,
     AActivitySpace asOwner, bool bResolveSecureBase);
    
    /// <summary>
    /// Return GetAppDataObject(int iCommunityID, int iPageID, int iGWParams,
    /// String strHostPageURI, AActivitySpace asOwner,
    /// boolean bResolveSecureBase)
    /// with the default value of bResolveSecureBase set to true.
    /// </summary>
    /// <param name="iCommunityID"></param>
    /// <param name="iPageID"></param>
    /// <param name="iGWParams"></param>
    /// <param name="strHostPageURI"></param>
    /// <param name="asOwner"></param>
    /// <returns></returns>
    IPTState GetAppDataObject(int iCommunityID, int iPageID, int iGWParams,
     String strHostPageURI, AActivitySpace asOwner);
    
    /// <summary>
    /// Returns the app data state object. This function is used by the gateway directly.
    /// The bResolveSecureBase specifies that in security mode 3 the method should resolve
    /// strSecureAppBaseURL by passing it to PTConfigHelper.GetApplicationBaseURL or not
    /// </summary>
    /// <param name="iCommunityID"></param>
    /// <param name="iPageID"></param>
    /// <param name="iGWParams"></param>
    /// <param name="strHostPageURI"></param>
    /// <param name="asOwner"></param>
    /// <param name="bResolveSecureBase"></param>
    /// <returns></returns>
    IPTState GetAppDataObject(int iCommunityID, int iPageID, int iGWParams,
     String strHostPageURI, AActivitySpace asOwner, bool bResolveSecureBase);
    
    /// <summary>
    /// Calculate the style sheet for this gatewayed page.
    /// If this page is not coming from a community, then we use the subportal's
    /// style sheet.
    /// If it is coming from a community, then we first check to see if there is
    /// a community style sheet; if there is not, then we default to the
    /// subportal.
    /// </summary>
    PTStyleSheetLink GetStyleSheet(int iCommunityID, IPTSession ptSession,
     AActivitySpace asOwner);
  }
}