using System;
using com.plumtree.server;
using AActivitySpace=com.plumtree.uiinfrastructure.activityspace.AActivitySpace;
using XPArrayList=com.plumtree.openfoundation.util.XPArrayList;
namespace com.plumtree.portaluiinfrastructure.helpers
{
  public interface IBannerSearchHelper
  {
    
    /// <summary>
    /// looks up the bitmask for search object constraints
    /// this function came from BannerStartSearchControl.GetPreferences()
    /// </summary>
    /// <param name="owner">AActivityspace to get user session</param>
    XPArrayList GetSearchConstraints(AActivitySpace owner);
    
    /// <summary>
    /// helper method to decipher the bitmask value
    /// </summary>
    /// <param name="objectTypeBitmask">The bitmask value of the object types to search for</param>
    /// <returns>list of Portal Object Types from User Search Preferences.</returns>
    XPArrayList GetPortalObjectTypes(IPTSessionInfo sessionInfo, int objectTypeBitmask);
    /*
     * Setting the search terms to search within results for pathways
     * @param queryArray is the array of search terms used
     */
     
    String SetPathwaysSearchHistory(Object[] queryArray);
    //	public String GetPathwaysSearchString(String searchString);
    String GetBannerSearchPreferenceSortOrder(AActivitySpace _parent);
    /*
     * helper method to get the string value of object via classid to pass to pathways
     * @param filterId String representation of the classid
     */
     
    String GetPathwaysClassIdStringValue(int filterId);
    /*
     * helper method to set collab items into search constraints for pathways
     * @param collabFilter the list to add search filter terms
     */
     
    XPArrayList setCollabItems(XPArrayList collabFilter);
    /*
     * helper method to set content items into search constraints for pathways
     * @param contentFilter the list to add search filter terms
     */
     
    XPArrayList setContentItems(XPArrayList contentFilter);
    
    /// <summary>
    /// Helper method to get a String setting out of the database
    /// </summary>
    /// <param name="sessionInfo">the current user's IPTSessionInfo object.</param>
    /// <param name="settingName">the name of the desired setting.</param>
    /// <param name="def">a default value to return if the setting is not found in the database.</param>
    /// <returns>the value of the setting, or <c>def</c> if not found.</returns>
    String GetStringSetting(IPTSessionInfo sessionInfo, String settingName,
     String def);
    
    /// <summary>
    /// Helper method to get an integer setting out of the database
    /// </summary>
    /// <param name="sessionInfo">the current user's IPTSessionInfo object.</param>
    /// <param name="settingName">the name of the desired setting.</param>
    /// <param name="def">a default value to return if the setting is not found in the database.</param>
    /// <returns>the value of the setting, or <c>def</c> if not found.</returns>
    int GetIntSetting(IPTSessionInfo sessionInfo, String settingName, int def);
    
    /// <summary>
    /// Helper method to get an integer setting from the user's session.
    /// </summary>
    /// <param name="sessionInfo">the current user's IPTSessionInfo object.</param>
    /// <param name="settingName">the name of the desired setting.</param>
    /// <param name="def">a default value to return if the setting is not found in the session.</param>
    /// <returns>the value of the setting, or <c>def</c> if not found.</returns>
    int GetIntSessionSetting(IPTSessionInfo sessionInfo, String settingName,
     int def);
  }
}