using System;
using com.plumtree.server;
namespace com.plumtree.portaluiinfrastructure.helpers
{
  /// <summary>
  /// The ICollaboratonHelper handles common functionality related to
  /// Collab integrations.  Built for Pathways Search integration.
  /// </summary>
  public interface ICollaborationHelper
  {
    
    /// <param name="_session">the current user session.</param>
    /// <returns>whether or not Collab is installed.</returns>
    bool IsCollaborationInstalled(IPTSession _session);
    
    /// <param name="_session">the current user session.</param>
    /// <returns>
    /// the ID of the Web Service ID.  -1 if it
    /// is not installed.
    /// </returns>
    int GetWebServiceID(IPTSession _session);
  }
}