using System;
using com.plumtree.server;
namespace com.plumtree.portaluiinfrastructure.helpers
{
  /// <summary>
  /// The IEnsembleHelper handles common functionality related to
  /// Ensemble integrations.
  /// </summary>
  public interface IEnsembleHelper
  {
    
    /// <param name="_session">the current user session.</param>
    /// <returns>whether or not Ensemble is installed.</returns>
    bool IsEnsembleInstalled(IPTSession _session);
    
    /// <param name="_session">the current user session.</param>
    /// <returns>
    /// the ID of the Ensemble Remote Server.  -1 if it
    /// is not installed.
    /// </returns>
    int GetRemoteServerID(IPTSession _session);
  }
}