using System;
using com.plumtree.portaluiinfrastructure.classtypedescriptors;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.helpers;
using com.plumtree.uiinfrastructure.web;
namespace com.plumtree.portaluiinfrastructure.helpers
{
  public interface IPTConfigHelper : IConfigHelper
  {
    
    /// <summary>
    /// Helper method to access an int variable from x_config.xml.
    /// </summary>
    /// <param name="strSection">strSection</param>
    /// <param name="strSubSection">strSubSection</param>
    /// <param name="strAttribute">strAttribute</param>
    /// <param name="space">the current space</param>
    /// <returns>int the requested variable</returns>
    int GetConfigVariableAsInt(String strSection, String strSubSection, String strAttribute,
     AActivitySpace space);
    
    /// <summary>
    /// Helper method to access a String variable from x_config.xml.
    /// </summary>
    /// <param name="strSection">strSection</param>
    /// <param name="strSubSection">strSubSection</param>
    /// <param name="strAttribute">strAttribute</param>
    /// <param name="space">the current space</param>
    /// <returns>String the requested variable</returns>
    String GetConfigVariableAsString(String strSection, String strSubSection,
     String strAttribute, AActivitySpace space);
    
    /// <summary>
    /// Helper method to access a String variable from x_config.xml.
    /// </summary>
    /// <param name="strSection">strSection</param>
    /// <param name="strSubSection">strSubSection</param>
    /// <param name="strAttribute">strAttribute</param>
    /// <param name="application">the current IApplication</param>
    /// <returns>String the requested variable</returns>
    String GetConfigVariableAsString(String strSection, String strSubSection,
     String strAttribute, IApplication app);
    
    /// <summary>
    /// Helper method to access a String variable from x_config.xml.
    /// </summary>
    /// <param name="strSection">strSection</param>
    /// <param name="strSubSection">strSubSection</param>
    /// <param name="strAttribute">strAttribute</param>
    /// <param name="space">the current space</param>
    /// <returns>String the requested variable</returns>
    Object[] GetConfigVariables(String strSection, String strSubSection, String strAttribute,
     AActivitySpace space);
    
    /// <summary>
    /// Helper method to access a String variable from x_config.xml.
    /// </summary>
    /// <param name="strSection">strSection</param>
    /// <param name="strSubSection">strSubSection</param>
    /// <param name="strAttribute">strAttribute</param>
    /// <param name="space">the current space</param>
    /// <returns>String the requested variable</returns>
    Object[] GetConfigVariables(String strSection, String strSubSection, String strAttribute,
     IApplication application);
    
    /// <summary>
    /// Helper method to retrieve the ClassTypeDescrManager from the cache
    /// </summary>
    /// <returns>IPTClassTypeDescManager</returns>
    IPTClassTypeDescManager GetPTClassTypeDescrManager();
    
    /// <param name="_space">The current Activity Space.</param>
    /// <param name="_strRequestURL">The current request URL.</param>
    /// <returns>the absolute image server root URL.</returns>
    String GetAbsoluteImageServerRootURL(AActivitySpace _space, String _strRequestURL);
    
    /// <param name="_space">The current Activity Space.</param>
    /// <param name="_strRequestURL">The current request URL.</param>
    /// <returns>the absolute image server base URL.</returns>
    String GetAbsoluteImageServerBaseURL(AActivitySpace _space, String _strRequestURL);
    
    /// <summary>
    /// Checks whether the classId supports friendly URLs
    /// </summary>
    /// <param name="classId"></param>
    /// <param name="queryStringArgs"></param>
    /// <returns></returns>
    bool UseFriendlyURLS(int classId, String queryStringArgs);
  }
}