using System;
using com.plumtree.server;
namespace com.plumtree.portaluiinfrastructure.helpers
{
  /// <summary>
  /// The IPublisher handles common functionality related to
  /// Publisher integrations.  Built for fix to bug 7817807 and other future uses.
  /// </summary>
  public interface IPublisherHelper
  {
    
    /// <param name="_session">the current user session.</param>
    /// <returns>whether or not Publisher is installed.</returns>
    bool IsPublisherInstalled(IPTSession _session);
    
    /// <param name="_session">the current user session.</param>
    /// <returns>
    /// the ID of the Web Service ID.  -1 if it
    /// is not installed.
    /// </returns>
    int GetWebServiceID(IPTSession _session);
  }
}