using System;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portaluiinfrastructure.intrinsicportlets
{
  /// <summary>
  /// This interface contains all read-only methods that are common to intrinsic portlets.
  /// </summary>
  /// <author>josephc</author>
  public interface IIntrinsicPortletModelRO : IModelRO
  {
    
    /// <summary>
    /// Returns true if the portlet has a control associated with it. This
    /// method is used by the MyPortal view when dynamically registering views
    /// for intrinsic portlets.
    /// </summary>
    /// <returns>Returns true if portlet has control. Otherwise return false.</returns>
    bool ControlExists();
    
    /// <summary>
    /// Returns portlet ID
    /// </summary>
    /// <returns>Portlet ID</returns>
    int GetPortletID();
  }
}