using System;
using com.plumtree.uiinfrastructure.editor;
namespace com.plumtree.portaluiinfrastructure.intrinsicportlets.prefs
{
  /// <summary>
  /// This interface contains all read-only methods that are common to intrinsic
  /// portlets pref pages.
  /// </summary>
  /// <author>josephc</author>
  public interface IIntrinsicPortletPrefsModelRO : IEditorModelRO
  {
    
    /// <summary>
    /// Get portlet name
    /// </summary>
    /// <returns>Portlet name</returns>
    String GetPortletName();
    
    /// <summary>
    /// Returns the type of preference that is being requested.
    /// </summary>
    /// <returns>Preference type</returns>
    int GetPrefType();
    
    /// <summary>
    /// Returns the community Id if the portlet is on a community
    /// </summary>
    /// <returns>community id</returns>
    int GetCommunityId();
  }
}