using System;
using com.plumtree.openfoundation.reflect;
using com.plumtree.portaluiinfrastructure.layout.impl;
namespace com.plumtree.portaluiinfrastructure.layout
{
  public class LayoutFactory : ILayoutFactory
  {
    
    /// <summary>
    /// To make sure people don't create LayoutFactories directly, we require
    /// a special key that only the LayoutService has.  Call LayoutService.getFactoryInstance()
    /// instead to get the Layout Factory.
    /// </summary>
    /// <param name="_oKey"></param>
    public LayoutFactory(Object _oKey)
    {
      if (!LayoutService.isValid(_oKey))
      {
        throw new XPIllegalAccessException("Layout Factory can only be created by the Layout Service. " + "Call LayoutService.getFactoryInstance() to access the Layout Factory.");
        }
    }
    public virtual ILayoutDisplay CreateDisplay()
    {
      return new LayoutDisplay();
    }
  }
}