using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.layout;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.portaluiinfrastructure.tags.displaytree;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portaluiinfrastructure.layout.impl
{
  public class LayoutDisplay : ILayoutDisplay
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_UI_INFRASTRUCTURE),
     "com.plumtree.portaluiinfrastructure.layout.impl.LayoutDisplay");
    public virtual HTMLElement ProcessLayout(Object[][] _markup, AActivitySpace _currentSpace)
    {
      HTMLElement result;
      try
      {
        result = DisplayTree.ProcessTagMarkup(_currentSpace, _markup);
      }
      catch (Exception e)
      {
        log.Warn(e, "Error rendering markup for layout.");
        throw new XPException("Error rendering markup for layout.", e);
      }
      return result;
    }
    public virtual HTMLElement ProcessMainPageLayout(Object[][] _markup, AActivitySpace _currentSpace)
    {
      HeadPreprocessor preprocessor = new HeadPreprocessor();
      // This will ensure that we have a location to place the CSAPI &
      // JS Includes in the head element.
      Object[][] processedMarkup = preprocessor.PreprocessHead(_markup, _currentSpace.GetSubSession(),
       _currentSpace, true);
      return ProcessLayout(processedMarkup, _currentSpace);
    }
  }
}