/*
 * Created on Mar 27, 2003
 */
 
using System;
using com.plumtree.openfoundation.util;
namespace com.plumtree.portaluiinfrastructure.navtype
{
  /// <summary>
  /// Enumeration of core features used on each page which can be turned on or off
  /// </summary>
  /// <author>DavidP</author>
  public class NavFeatureEnum
  {
    private int m_navFeatureID;
    // enumeration of page types
    public static readonly NavFeatureEnum TOPBAR = new NavFeatureEnum(0);
    public static readonly NavFeatureEnum HEADER = new NavFeatureEnum(1);
    public static readonly NavFeatureEnum FOOTER = new NavFeatureEnum(2);
    // array of page types
    public static readonly NavFeatureEnum[] m_navFeatureEnums = {TOPBAR, HEADER,
     FOOTER};
    
    /// <param name="navFeatureID"></param>
    private NavFeatureEnum(int navFeatureID)
    {
      m_navFeatureID = navFeatureID;
    }
    
    /// <seealso cref="java.lang.Object#toString()"></seealso>
    public override String ToString()
    {
      return XPConvert.ToString(m_navFeatureID);
    }
    
    /// <returns>int</returns>
    public virtual int GetID()
    {
      return m_navFeatureID;
    }
    
    /// <seealso cref="java.lang.Object#equals(Object)"></seealso>
    public sealed override bool Equals(Object o)
    {
      bool retval = false;
      try
      {
        retval = (((NavFeatureEnum) o).GetID() == m_navFeatureID);
      }
      catch (Exception e)
      {
      }
      return retval;
    }
  }
}