using System;
using com.plumtree.uiinfrastructure.opener;
namespace com.plumtree.portaluiinfrastructure.opener
{
  /// <summary>
  /// Constants for use by the Common Opener.
  /// </summary>
  /// <author>John Osborne</author>
  public class IPTOpenerConstants : IOpenerConstants
  {
    // common querystring name arguments. these
    // arguments are everywhere so keep them short.
    public const String QS_UUID = "uuID";
    public const String QS_USERID = "userID";
    public const String QS_KEYWORD = "tbb";
    // special querystring name arguments.  these
    // arguments will usually not be copy/pasted
    // so they can be more descriptive.
    public const String QS_FOLDERID = "folderID";
    public const String QS_PROV_ENG_NAME = "provEngName";
    // javascript includes.
    public const String FILENAME_JS_COMMONOPENER = "ptcommonopener.js";
    public const String JS_METHOD_GETOPENERURL = "PTCommonOpener.getOpenerURL";
    public const String JS_METHOD_GETOPENERURL_OPENAS = "PTCommonOpener.getOpenerURLOpenAS";
    public const String JS_METHOD_GETOPENERURL_OPENUUID = "PTCommonOpener.getOpenerURLOpenUUID";
    public const String JS_METHOD_GETOPENERURL_OPENOBJID = "PTCommonOpener.getOpenerURLOpenObjID";
    public const String JS_METHOD_GETOPENERURL_CREATE = "PTCommonOpener.getOpenerURLCreate";
    public const String JS_METHOD_GETOPENERURL_CREATEEXT = "PTCommonOpener.getOpenerURLCreateExt";
    public const String JS_METHOD_OPEN_NEW_WINDOW = "PTCommonOpener.openInNewWindow";
    public const String JS_METHOD_OPEN_SAME_WINDOW = "PTCommonOpener.openInSameWindow";
    public const String JS_METHOD_GETAPPLICATIONBASEURL = "OpenerAS_GetApplicationBaseURL";
    public const String JS_METHOD_GETCURRENTUSERID = "OpenerAS_GetCurrentUserID";
    public const String JS_METHOD_PARENTSPACE_NAME = "OpenerAS_GetParentSpaceName";
    public const String JS_METHOD_PARENTSPACE_ID = "OpenerAS_GetParentSpaceID";
    // to be deprecated querystring name arguments.
    public const String STR_QS_FOLDERID = "in_hi_FolderID";
    public const String STR_QS_PROVIDER_ENG_NAME = "in_hi_ProvEngName";
    public const String STR_QS_FORCESAVEINFOLDER = "bForceSaveInFolder";
    public const String STR_QS_FOLDERNOTREQUIRED = "folderNotRequired";
  }
}