using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portaluiinfrastructure.opener
{
  public class PTOpenerService : IPTOpenerHelper
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_UI_INFRASTRUCTURE),
     "com.plumtree.portaluiinfrastructure.opener.PTOpenerService");
    //the singleton instance
    private static IPTOpenerHelper m_HelperInstance;
    // This stores whether or not the factory is in test mode.
    private static bool m_bIsProduction = false;
    // Private constructor to ensure controlled access to the singleton.
    private PTOpenerService()
    {
    }
    
    /// <returns>The singleton config helper.</returns>
    public static IPTOpenerHelper getInstance()
    {
      if (m_HelperInstance == null)
      {
        m_bIsProduction = true;
        m_HelperInstance = new PTOpenerService();
      }
      return m_HelperInstance;
    }
    
    /// <summary>
    /// Unit tests should use this method to overwrite/teardown existing helper singleton.
    /// DO NOT USE for production code. 
    /// </summary>
    public static void setTestInstance(IPTOpenerHelper testHelper)
    {
      if (m_bIsProduction)
      {
        String strMessage = "Can\'t override ConfigHelper instance for testing... ConfigService has already been initialized.";
        log.Error(strMessage);
        throw new XPException(strMessage);
      }
      m_HelperInstance = testHelper;
    }
    public virtual HTMLScriptCollection GetOpenerJavascript(AActivitySpace _asOwner)
    {
      return PTOpenerLinks.GetOpenerJavascript(_asOwner);
    }
  }
}