/*
 * Created on Dec 8, 2004
 */
 
using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.tags.data;
using com.plumtree.uiinfrastructure.statichelpers;
namespace com.plumtree.portaluiinfrastructure.ptlink
{
  /// <summary>
  /// Full URL type
  /// </summary>
  public class FullURL : APTURL,IDataObject
  {
    
    /// <summary>
    /// The Full URL
    /// </summary>
    public const String KEY_FULLURL_FULLURL = "url";
    
    /// <summary>
    /// Baseurl 
    /// </summary>
    public const String KEY_FULLURL_BASEURL = "baseurl";
    
    /// <summary>
    /// URI
    /// </summary>
    public const String KEY_FULLURL_URI = "uri";
    
    /// <summary>
    /// URL Type.
    /// </summary>
    public const String URL_TYPE_FULLURL = "fullurl";
    protected String m_strBaseURL;
    protected String m_strURI;
    
    /// <param name="strTitle"></param>
    /// <param name="strFullURL">URL, null URLs are accepted</param>
    public FullURL(String strTitle, String strFullURL) : base(strTitle)
    {
      if (null == strFullURL)
      {
        m_strBaseURL = null;
        m_strURI = null;
        return;
      }
      XPStringTokenizer tok = new XPStringTokenizer(strFullURL, "?");
      if (tok.HasMoreTokens())
      {
        m_strBaseURL = tok.GetNextToken();
      }
      if (tok.HasMoreTokens())
      {
        m_strURI = tok.GetNextToken();
      }
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.ptlink.IPTURL#GetFullURL()"></seealso>
    public override String GetFullURL()
    {
      XPStringBuilder buf = new XPStringBuilder();
      buf.Append(m_strBaseURL);
      if (null != m_strURI || m_listParamNames != null)
      {
        buf.Append("?");
      }
      if (null != m_strURI)
      {
        buf.Append(m_strURI);
      }
      if (m_listParamNames != null && m_listParamNames.GetSize() > 0)
      {
        buf.Append(HTTPHelpers.GetParameterListAsString(m_listParamNames,
         m_listParamValues));
      }
      return buf.ToString();
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.ptlink.IPTURL#GetURI()"></seealso>
    public override String GetURI()
    {
      return m_strURI;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.data.IDataObject#GetData(java.lang.String)"></seealso>
    public override String GetData(String strKey)
    {
      if (KEY_FULLURL_FULLURL.Equals(strKey))
      {
        return GetFullURL();
      } else
      if (KEY_FULLURL_BASEURL.Equals(strKey))
      {
        return m_strBaseURL;
      } else
      if (KEY_FULLURL_URI.Equals(strKey))
      {
        return GetURI();
      } else
      if (KEY_URLTYPE.Equals(strKey))
      {
        return URL_TYPE_FULLURL;
      }
      return base.GetData(strKey);
    }
  }
}