using System;
namespace com.plumtree.portaluiinfrastructure.ptlink
{
  /// <summary>
  /// Constant definitions of common URL components 
  /// </summary>
  public class PTURLConstants
  {
    
    /// <summary>
    /// URL title
    /// </summary>
    public const String KEY_TITLE = "title";
    
    /// <summary>
    /// Icon associated with the URL.
    /// </summary>
    public const String KEY_ICONIMG = "img";
    
    /// <summary>
    /// Width of the icon.
    /// </summary>
    public const String KEY_ICONIMGWIDTH = "imgwidth";
    
    /// <summary>
    /// Height of the icon.
    /// </summary>
    public const String KEY_ICONIMGHEIGHT = "imgheight";
    
    /// <summary>
    /// Alternative text of the icon.
    /// </summary>
    public const String KEY_ICONIMGALT = "imgalt";
    
    /// <summary>
    /// The full URL.
    /// </summary>
    public const String KEY_FULLURL = "url";
    
    /// <summary>
    /// URI part of the URL.
    /// </summary>
    public const String KEY_URI = "uri";
    
    /// <summary>
    /// Current marker. This flag should be set if the URL is pointing to the current page.
    /// </summary>
    public const String KEY_CURRENTMARKER = "currpage";
    
    /// <summary>
    /// Javascript action associated with an URL. 
    /// </summary>
    public const String KEY_JAVASCRIPT_ACTION = "jsaction";
    
    /// <summary>
    /// Lists all parameters in the query string. 
    /// </summary>
    public const String KEY_PARAMS = "params";
    
    /// <summary>
    /// The type of URL
    /// </summary>
    public const String KEY_URLTYPE = "urltype";
    
    /// <summary>
    /// The object ID of the object represented by this URL
    /// </summary>
    public const String KEY_OBJECTID = "objectid";
    
    /// <summary>
    /// The class ID of the object represented by this URL
    /// </summary>
    public const String KEY_CLASSID = "classid";
  }
}