using System;
using com.plumtree.openfoundation.util;
namespace com.plumtree.portaluiinfrastructure.restconsumerframework
{
  /// <summary>
  /// Stores preference data for an ensemble pagelet 
  /// </summary>
  /// <TODO>: rename to param data</TODO>
  /// <author>rozhang</author>
  public class EnsemblePageletPrefsRestData
  {
    public const String PARAM_NAME = "name";
    public const String PARAM_DESCRIPTION = "desc";
    public const String PARAM_ISMANDATORY = "isMandatory";
    protected String[] m_paramNames = null;
    protected String[] m_paramDescs = null;
    protected bool[] m_paramIsMandatory = null;
    public virtual bool Init(XPHashtable data)
    {
      bool success = false;
      Object paramData = data.GetElement(EnsembleRestAPIService.PARAMETERS);
      if (paramData != null && paramData is XPHashtable)
      {
        XPHashtable paramContainer = (XPHashtable) paramData;
        Object rawParam = paramContainer.GetElement("PageletParam");
        if (rawParam is XPHashtable)
        {
          XPHashtable mapParam = (XPHashtable) rawParam;
          m_paramNames = new String[1];
          m_paramDescs = new String[1];
          m_paramIsMandatory = new bool[1];
          ParseSingleParam(mapParam, 0);
        } else
        if (rawParam is XPArrayList)
        {
          XPArrayList listParams = (XPArrayList) rawParam;
          int numParams = listParams.GetSize();
          m_paramNames = new String[numParams];
          m_paramDescs = new String[numParams];
          m_paramIsMandatory = new bool[numParams];
          for (int i = 0;i < numParams;i++)
          {
            XPHashtable par = (XPHashtable) listParams.GetElement(i);
            ParseSingleParam(par, i);
          }
        }
        success = true;
      }
      return success;
    }
    internal virtual void ParseSingleParam(XPHashtable param, int arrayIndex)
    {
      String name = (String) param.GetElement(PARAM_NAME);
      bool isMand = XPConvert.ToBoolean(param.GetElement(PARAM_ISMANDATORY));
      String desc = (String) param.GetElement(PARAM_DESCRIPTION);
      m_paramNames[arrayIndex] = name;
      m_paramIsMandatory[arrayIndex] = isMand;
      m_paramDescs[arrayIndex] = (desc == null) ? "" : desc;
    }
    public virtual String[] GetParameterNames()
    {
      if (m_paramNames == null)
      {
        m_paramNames = new String[0];
      }
      return m_paramNames;
    }
    public virtual bool[] GetParamIsMandatory()
    {
      if (m_paramIsMandatory == null)
      {
        m_paramIsMandatory = new bool[0];
      }
      return m_paramIsMandatory;
    }
    public virtual String[] GetParameterDescriptions()
    {
      if (m_paramDescs == null)
      {
        m_paramDescs = new String[0];
      }
      return m_paramDescs;
    }
  }
}