using System;
using com.plumtree.openfoundation.util;
namespace com.plumtree.portaluiinfrastructure.restconsumerframework
{
  public interface IRestResponse
  {
    
    /// <summary>
    /// Returns the name of a node list under the root node. All the nodes
    /// under the root node has to share the same name to be considered a valid
    /// node list. 
    /// </summary>
    /// <returns>null if the response content doesn't contain a list </returns>
    String GetListName();
    
    /// <summary>
    /// Gets the name of the top level element
    /// </summary>
    /// <returns></returns>
    String GetRootElementName();
    
    /// <summary>
    /// Exclusive from GetResponseList method, only one is valid in any one response
    /// </summary>
    /// <returns>null if the response is actually a list of items</returns>
    XPHashtable GetSingleDataItem();
    
    /// <summary>
    /// Exclusive from GetSingleDataItem method, only one is valid in any one response
    /// </summary>
    /// <returns>
    /// null if the current response does not contain a top level list, XPArrayList contains 
    /// XPHashtables
    /// </returns>
    XPArrayList GetResponseList();
  }
}