using System;
namespace com.plumtree.portaluiinfrastructure.resultwrapper
{
  /// <summary>
  /// MES- The IASQueryResult interface is used by PTObjectManagerQueryWrapper
  /// and ASQueryResultWrapper to make IPTQueryResults and IPTTurboQueryResults
  /// look the same to clients
  /// </summary>
  /// <author>MichaelS</author>
  public interface IASQueryResult
  {
    
    /// <summary>
    /// MES- GetCount should return the number of ROWS in the
    /// result set
    /// </summary>
    /// <returns>the number of rows in the result set</returns>
    int GetCount();
    
    /// <summary>
    /// MES- GetFields is used to get the value of a particular
    /// cell in the array.
    /// </summary>
    /// <param name="iRowNum">is the row that contains the data of interest</param>
    /// <param name="iPropertyID">
    /// is the PropertyID of the data of interest
    /// (e.g. PT_PROPIDS.PT_PROPID_NAME)
    /// </param>
    /// <returns>the value of the cell</returns>
    Object GetFields(int iRowNum, int iPropertyID);
    
    /// <summary>
    /// MES- IsComplete returns a boolean indicating if the rows
    /// we can return are the complete rowset (i.e. have we truncated
    /// the rowset because it's too large to bring to the client.)
    /// </summary>
    /// <returns>A boolean indicating completeness.</returns>
    bool IsComplete();
  }
}