using System;
namespace com.plumtree.portaluiinfrastructure.search
{
  /// <author>CraigS</author>
  public interface ISaveSearchModelRO
  {
    
    /// <summary>
    /// Returns true if this search has already been saved.
    /// </summary>
    bool GetHasBeenSaved();
    
    /// <summary>
    /// Returns an int that clients can set via
    /// ISaveSearchModel.setSavedSearchErrorCode()
    /// to communicate conditions like "a saved search
    /// already exists with that name".
    /// Default is zero.
    /// </summary>
    int GetSavedSearchErrorCode();
    
    /// <summary>
    /// Returns the name of the search if the search has been saved,
    /// or null otherwise.
    /// </summary>
    String GetSavedSearchName();
  }
}