using System;
using com.plumtree.server;
namespace com.plumtree.portaluiinfrastructure.search
{
  /// <author>
  /// CraigS
  /// This is a small helper class that holds a user's query, which
  /// may be either a simple String for a basic (e.g. banner) search
  /// or an IPTFilter for an advanced search.
  /// </author>
  public class QueryArguments
  {
    
    /// <summary>
    /// User's query string, if and only if this is a basic (e.g. banner) search.
    /// For an advanced search, userQuery will always be null and is not used.
    /// </summary>
    public String userQuery = null;
    
    /// <summary>
    /// Fields searched by a basic (e.g. banner) search.  May be null, in which
    /// case the default fields (name, description, and full-text) are searched.
    /// For an advanced search, basicFields will always be null and is ignored.
    /// </summary>
    public String basicFields = null;
    
    /// <summary>
    /// IPTFilter used as the query for an advanced search.  If this is a basic
    /// search, advancedFilter will be null.
    /// </summary>
    public IPTFilter advancedFilter = null;
  }
}