using System;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portaluiinfrastructure.search
{
  /// <summary>
  /// SearchExecutionError indicates an error that occurred while a search
  /// was running, for example, a missing search server.
  /// </summary>
  public class SearchExecutionError : SearchExecutionException
  {
    
    /// <summary>
    /// Creates a new SearchExecutionError object.
    /// </summary>
    /// <param name="msg"></param>
    public SearchExecutionError(String msg) : base(msg)
    {
    }
    
    /// <summary>
    /// Used by subclasses to return un-internationalized error messsages as HTML comments. See Error6321Exception.
    /// </summary>
    public virtual HTMLComment GetComment()
    {
      return null;
    }
  }
}