using System;
namespace com.plumtree.portaluiinfrastructure.search
{
  /// <summary>
  /// SearchExecutionWarning indicates a warning that occurred while a search
  /// was running.  Such a warning should be displayed to the user, but does
  /// not indicate that the search failed.  For example, the user's query might
  /// have timed out and returned an incomplete result set.
  /// </summary>
  public class SearchExecutionWarning : SearchExecutionException
  {
    
    /// <summary>
    /// Creates a new SearchExecutionWarning object.
    /// </summary>
    /// <param name="msg"></param>
    public SearchExecutionWarning(String msg) : base(msg)
    {
    }
  }
}