using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.search;
namespace com.plumtree.portaluiinfrastructure.search.exceptions
{
  /// <summary>
  /// ArgumentBoundsException indicates that an argument to a get()
  /// accessor method was out of range, e.g. getResultName(11) when only
  /// 10 results were returned
  /// </summary>
  public class ArgumentBoundsException : SearchModelException
  {
    
    /// <summary>
    /// Creates a new ArgumentBoundsException object.
    /// </summary>
    /// <param name="arg"></param>
    /// <param name="value"></param>
    public ArgumentBoundsException(String arg, int value) : base("Argument out of range: " + arg + "," + XPConvert.ToString(value))
    {
    }
  }
}