using System;
using com.plumtree.portaluiinfrastructure.search;
namespace com.plumtree.portaluiinfrastructure.search.exceptions
{
  /// <summary>
  /// InvalidArgumentException indicates that a method on
  /// ISearchResultModel was passed an invalid argument.
  /// </summary>
  public class InvalidArgumentException : SearchExecutionError
  {
    
    /// <summary>
    /// Creates a new InvalidArgumentException object.
    /// </summary>
    /// <param name="msg"></param>
    public InvalidArgumentException(String msg) : base(msg)
    {
    }
    
    /// <summary>
    /// Creates a new InvalidArgumentException object.
    /// </summary>
    /// <param name="badArg"></param>
    /// <param name="badValue"></param>
    public InvalidArgumentException(String badArg, String badValue) : base(badValue + " is an invalid argument for " + badArg)
    {
    }
  }
}