using System;
using XPNotImplementedException=com.plumtree.openfoundation.util.XPNotImplementedException;
using OpenLogService=com.plumtree.openlog.OpenLogService;
using OpenLogger=com.plumtree.openlog.OpenLogger;
using PTDebugHelpers=com.plumtree.portaluiinfrastructure.statichelpers.PTDebugHelpers;
using com.plumtree.server;
using InternalSession=com.plumtree.server.impl.core.InternalSession;
using PTSearchRequest=com.plumtree.server.impl.search.PTSearchRequest;
namespace com.plumtree.portaluiinfrastructure.search.pathways
{
  /// <author>Administrator</author>
  public class PathwaysSearchRequest : PTSearchRequest
  {
    internal PathwaysQueryArguments _pathwaysQueryArg;
    private static OpenLogger pathwayslog = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PATHWAYS),
     "com.plumtree.portaluiinfrastructure.search.pathways.PathwaysSearchRequest");
    
    /// <param name="internalSession"></param>
    public PathwaysSearchRequest(InternalSession internalSession, PathwaysQueryArguments pqArgs) : base(internalSession)
    {
      _pathwaysQueryArg = pqArgs;
      SetGlobalSpellingCheck(internalSession);
    }
    public virtual bool GetGlobalSpellingCheck()
    {
      return _globalAllowSpellchecking;
    }
    /*
     * this method returns the global spelling check for searches
     */
     
    public virtual void SetGlobalSpellingCheck(InternalSession internalSession)
    {
      IPTServerConfigSettings myconfig = (IPTServerConfigSettings) internalSession.GetSession().OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS,
       true);
      _globalAllowSpellchecking = myconfig.GetSettingAsBoolean(PT_SERVER_CONFIG_SETTINGNAME.PT_SEARCH_ALLOW_SPELLCHECK);
      }
    /* (non-Javadoc)
     * @see com.plumtree.server.IPTSearchRequest#CreateAdvancedQuery(com.plumtree.server.IPTFilter)
     */
     
    public override IPTSearchQuery CreateAdvancedQuery(IPTFilter filter)
    {
      throw new XPNotImplementedException("CreateAdvancedQuery is not supported for a Pathways search request");
      }
    /* (non-Javadoc)
     * @see com.plumtree.server.IPTSearchRequest#CreateBasicQuery(java.lang.String, java.lang.String)
     */
     
    public override IPTSearchQuery CreateBasicQuery(String searchString, String fields)
    {
      throw new XPNotImplementedException("CreateBasicQuery is not supported for a Pathways search request");
      }
    /* (non-Javadoc)
     * @see com.plumtree.server.IPTSearchRequest#FollowupSearch(java.lang.Object)
     */
     
    public override IPTSearchResponse FollowupSearch(Object queryArray)
    {
      throw new XPNotImplementedException("FollowupSearch is not supported for a Pathways search request");
      }
    /* (non-Javadoc)
     * @see com.plumtree.server.IPTSearchRequest#Search(com.plumtree.server.IPTSearchQuery)
     */
     
    public override IPTSearchResponse Search(IPTSearchQuery query)
    {
      throw new XPNotImplementedException("Search is not supported for a Pathways search request");
      }
  }
}