using System;
using com.plumtree.uiinfrastructure.form;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portaluiinfrastructure.securitymatrix
{
  /// <summary>
  /// This display page is a popup that asks the user if he wants to use ABO.
  /// </summary>
  /// <author>RickyW</author>
  public class ABOPopupSelectDP : AFormDP
  {
    
    /// <summary>
    /// class name *
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "ABOPopupSelectDP";
    
    /// <summary>
    /// View Name *
    /// </summary>
    private String m_strViewName = ABOPopupSelectView.STR_MVC_CLASS_NAME;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()"></seealso>
    public override String GetFormTitle()
    {
      return m_asOwner.GetString(1691, "ptmsgs_portaladminmsgs");
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()"></seealso>
    public override HTMLElement PageDisplay()
    {
      return m_asOwner.GetView(m_strViewName).Display();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#GetFormPageType()"></seealso>
    public override FormPageTypes GetFormPageType()
    {
      return FormPageTypes.NO_BUTTONS;
    }
    
    /// <summary>
    /// Returns the JavaScript from any views shown by this DP.
    /// </summary>
    /// <returns>HTMLScriptCollection the Javascript from the Child IViews</returns>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection scripts = new HTMLScriptCollection();
      scripts.AddInnerHTMLElement(GetOwner().GetView(m_strViewName).DisplayJavascript());
      return scripts;
    }
    
    /// <summary>
    /// View Name defaults to ABOPopupSelectView.STR_MVC_CLASS_NAME if this method is not called.
    /// </summary>
    /// <param name="_strViewName">
    /// - the name of the view to be displayed by this display page. 
    /// Should be the name of a view that subclasses ABOPopupSelectView, but will not throw an exception if otherwise.
    /// </param>
    public virtual void SetViewName(String _strViewName)
    {
      m_strViewName = _strViewName;
    }
  }
}