using System;
using com.plumtree.portaluiinfrastructure.editor;
namespace com.plumtree.portaluiinfrastructure.securitymatrix
{
  /// <author>MichaelD</author>
  public interface IFolderSecurityABOModelRO : IObjEditorModelRO
  {
    
    /// <summary>
    /// This method returns whether or not there is a job ID to display.
    /// </summary>
    /// <returns>boolean true implies there is a job ID to display.</returns>
    bool ABOJobIDToDisplay();
    
    /// <summary>
    /// This method returns the job ID for a security change job.
    /// </summary>
    /// <returns>int the job ID for security changes.</returns>
    int GetABOJobID();
    
    /// <summary>
    /// Retrieves the name of the job created by ABO.
    /// </summary>
    String GetCreatedJobName();
    
    /// <summary>
    /// Retrieves the name of the folder that ABO created the job in.
    /// </summary>
    String GetFolderNameForCreatedJobs();
  }
}