using System;
// Framework Imports
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portaluiinfrastructure.securitymatrix
{
  /// <summary>
  /// This interface is implemented by the Model.
  /// It contains all the read-only mothods of the Model
  /// accessed by the Views.
  /// </summary>
  /// <author>Julie Fournier</author>
  public interface ISecurityMatrixModelRO : IFolderSecurityABOModelRO
  {
    
    /// <summary>
    /// Returns the URL to edit the object.
    /// </summary>
    /// <param name="_nClassID"></param>
    /// <param name="_nObjectID"></param>
    /// <param name="_sEditorASName"></param>
    /// <returns>ASURL URL to the Editor</returns>
    ASURL GetEditObjectURL(int _nClassID, int _nObjectID);
    
    /// <summary>
    /// Returns the number of SubPortals that were loaded.
    /// </summary>
    /// <returns>int number of SubPortals</returns>
    int GetNumSubPortals();
    
    /// <summary>
    /// Returns the id of a regular folder.
    /// </summary>
    /// <returns>String ID of regular folder</returns>
    String GetRegularFolderID();
    
    /// <summary>
    /// Returns the id of the selected subportal.
    /// </summary>
    /// <returns>String ID of selected subportal</returns>
    String GetSelectedSubPortalID();
    
    /// <summary>
    /// Returns the id of the SubPortal at a given position. This is returned
    /// as a string because we only need to do html with the id.
    /// </summary>
    /// <returns>String ID of SubPortal</returns>
    String GetSubPortalID(int pos);
    
    /// <summary>
    /// Returns the name of the SubPortal at a given position.
    /// </summary>
    /// <returns>String name of SubPortal</returns>
    String GetSubPortalName(int pos);
  }
}