using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.portaluiinfrastructure.sso;
namespace com.plumtree.portaluiinfrastructure.sso.integrations
{
  /// <summary>
  /// Handles SSO integration with Windows Integrated Authentication, aka NTLM.
  /// </summary>
  /// <author>Mike Jahr</author>
  public class Netegrity : ISSOIntegration
  {
    //    private IXPRequest m_request;
    private static readonly String[] HEADERS = {"SM_", "Authorization"};
    private static readonly String[] COOKIES = {"SMSESSION"};
    
    /// <summary>
    /// Creates a new Netegrity object.
    /// </summary>
    public Netegrity()
    {
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#GetLoginInfo()"></seealso>
    public virtual SSOLoginInfo GetLoginInfo(IXPRequest request)
    {
      return new SSOLoginInfo(request.GetHeader("SM_USER"), request.GetHeader("SM_PASSWORD"));
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#GetSSOProductName()"></seealso>
    public virtual String GetSSOProductName()
    {
      return "Netegrity SiteMinder";
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#GetSecureCookies()"></seealso>
    public virtual String[] GetSecureCookies()
    {
      return COOKIES;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#GetSecureHeaders()"></seealso>
    public virtual String[] GetSecureHeaders()
    {
      return HEADERS;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#Initialize()"></seealso>
    public virtual bool Initialize(XPHashtable mapSettings)
    {
      return true;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#Logout()"></seealso>
    public virtual bool OnLogout(IXPResponse response, String sReturnURL)
    {
      return false;
    }
  }
}