using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openfoundation.web;
using com.plumtree.portaluiinfrastructure.sso;
namespace com.plumtree.portaluiinfrastructure.sso.integrations
{
  /// <summary>
  /// SSO Integration file for Oblix NetPoint.
  /// </summary>
  /// <author>Mike Jahr</author>
  public class Oblix : ISSOIntegration
  {
    private static readonly String[] HEADERS = null;
    private static readonly String[] COOKIES = {"ObSSOCookie"};
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#GetLoginInfo(IXPRequest)"></seealso>
    public virtual SSOLoginInfo GetLoginInfo(IXPRequest request)
    {
      return new SSOLoginInfo(request.GetHeader("UID"));
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#GetSSOProductName()"></seealso>
    public virtual String GetSSOProductName()
    {
      return "Oblix NetPoint";
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#GetSecureCookies()"></seealso>
    public virtual String[] GetSecureCookies()
    {
      return COOKIES;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#GetSecureHeaders()"></seealso>
    public virtual String[] GetSecureHeaders()
    {
      return HEADERS;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#Initialize()"></seealso>
    public virtual bool Initialize(XPHashtable mapSettings)
    {
      return true;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#Logout()"></seealso>
    public virtual bool OnLogout(IXPResponse response, String sReturnURL)
    {
      return false;
    }
  }
}