using System;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portaluiinfrastructure.subscribematrix
{
  /// <summary>
  /// This page shows the results from using ABO.
  /// </summary>
  /// <author>RickyW</author>
  public class ABOSubPopupResultsDP : IDisplayPage
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_UI_INFRASTRUCTURE),
     "com.plumtree.portaluiinfrastructure.subscribematrix.ABOSubPopupResultsDP");
    
    /// <summary>
    /// class name *
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "ABOSubPopupResultsDP";
    
    /// <summary>
    /// owner object 
    /// </summary>
    protected AActivitySpace m_asOwner;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Display()"></seealso>
    public virtual void Display(IWebData pageData)
    {
      HTMLPage myPage = new HTMLPage();
      // Set the HTMLPage as the data to be sent to the browser.
      pageData.SetData(myPage);
      HTMLHead myHead = new HTMLHead();
      myPage.SetHead(myHead);
      HTMLTitle myTitle = new HTMLTitle(m_asOwner.GetString(1692, "ptmsgs_portaladminmsgs"));
      HTMLBody myBody = new HTMLBody();
      myPage.SetBody(myBody);
      myBody.SetMarginHeight("0");
      myBody.SetMarginWidth("0");
      myBody.SetLeftMargin("0");
      myBody.SetTopMargin("0");
      myBody.SetOnUnload(ABOSubPopupResultsView.JAVASCRIPT_CLOSE + "()");
      try
      {
        // set to dark background color
        myBody.SetStyleClass(PTStyleClass.ALERT_DIALOG_BG);
        myHead.AddInnerHTMLElement(myTitle);
        myHead.AddInnerHTMLElement(m_asOwner.GetStyleSheetLinks());
        HTMLScript myScript = DisplayJavascript();
        if (myScript != null)
        {
          myHead.AddInnerHTMLElement(myScript);
        }
        myBody.AddInnerHTMLElement(m_asOwner.GetView(ABOSubPopupResultsView.STR_MVC_CLASS_NAME).Display());
        }
      catch (HTMLException he)
      {
        log.Error(he, "Display: The following HTML error occured when trying to display the HTML.");
        }
      catch (Exception e)
      {
        log.Error(e, "Display: The following error occured when trying to display the HTML.");
        }
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IDisplayPage#GetOwner()"></seealso>
    public virtual AActivitySpace GetOwner()
    {
      return m_asOwner;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Init(AActivitySpace)"></seealso>
    public virtual void Init(AActivitySpace parent)
    {
      m_asOwner = parent;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()"></seealso>
    public virtual HTMLElement PageDisplay()
    {
      return m_asOwner.GetView(ABOSubPopupResultsView.STR_MVC_CLASS_NAME).Display();
      }
    
    /// <summary>
    /// Returns the JavaScript from any views shown by this DP.
    /// </summary>
    protected virtual HTMLScript DisplayJavascript()
    {
      return m_asOwner.GetView(ABOSubPopupResultsView.STR_MVC_CLASS_NAME).DisplayJavascript();
      }
  }
}