using System;
using com.plumtree.portaluiinfrastructure.tags.tagdef;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portaluiinfrastructure.tags
{
  /// <summary>
  /// Base class for Tags that retrieves and displays stored Tag Output Definitions 
  /// </summary>
  /// <author>rozhang</author>
  public abstract class ATagDefDisplay : ATag
  {
    
    /// <summary>
    /// Retrieves stored Tag Output Definition and returns the transformed content
    /// </summary>
    /// <param name="defId"></param>
    /// <param name="version"></param>
    /// <returns>null value if the definition wasn't found</returns>
    protected virtual HTMLElement ProcessStoredTagContent(String defId, String version)
    {
      TagOutputDefinitionManager mgr = TagOutputDefinitionManager.GetInstance();
      HTMLElement result = mgr.RetrieveAndSetTagDefinition(defId, version,
       GetTagHelper());
      return result;
    }
  }
}