/*
 * Created on Jun 1, 2005
 */
 
using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.tags;
namespace com.plumtree.portaluiinfrastructure.tags.data
{
  /// <summary>
  /// Helper object that defines and provides a protocol for getting  list of PTURL DO  data
  /// in different Tag Scopes.
  /// </summary>
  public class TagDataGetterPTURLDOList
  {
    // TODOCR DONH: Why is this list called PTURLDOList?  There's nothing in
    // it that's specific to PTURLDO's.  It seems like this should either be
    // generalized, or moved into one of the nav tag libraries if it's nav
    // specific.  It doesn't seem like it belongs here.  It's not part of the
    // framework.  This is something specifically for the nav taglibs, right?
    internal Scope m_scope = null;
    
    /// <summary>
    /// Constructor 
    /// </summary>
    public TagDataGetterPTURLDOList(Scope scope)
    {
      m_scope = scope;
    }
    
    /// <summary>
    /// Gets PTURL IOD data.
    /// </summary>
    /// <param name="tagObj">A reference to the current Atag object</param>
    /// <param name="tagAttrib">A string attribute, where its value is used as the name of the data set on the Tag Scope</param>
    /// <returns>An list with the PTURL IOD data </returns>
    public virtual IXPList GetMemoryData(ITagState state, String strKey)
    {
      IXPList memList = (IXPList) state.GetSharedVariable(strKey, m_scope);
      return memList;
    }
    
    /// <summary>
    /// Sets the Tag scope to set PTURL data on 
    /// </summary>
    /// <param name="scope"></param>
    public virtual void SetScope(Scope scope)
    {
      m_scope = scope;
    }
  }
}