using System;
using com.plumtree.portaluiinfrastructure.common.constants;
using com.plumtree.uiinfrastructure.editor;
using com.plumtree.uiinfrastructure.statichelpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portaluiinfrastructure.tags.manager.taglibmanager
{
  /// <summary>
  /// This class is used to print out the list of tag libs.
  /// </summary>
  /// <author>donh</author>
  public class TagLibDP : EditorDP
  {
    public const String STR_MVC_CLASS_NAME = "TagLib";
    
    /// <summary>
    /// Returns the String to display in the left navigation menu,
    /// linking to this page.
    /// </summary>
    /// <returns>String</returns>
    public override String GetLeftNavString()
    {
      // Tag Libraries
      return m_asOwner.GetString(772, ResourceConstants.PORTALCOMMONMSGS);
      }
    
    /// <summary>
    /// Implement this method to add HTML below the sub header.
    /// </summary>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLElement GetHTMLBelowSubHeader()
    {
      // Commented out until bug#45342 is fixed - reload can
      // recycle the .net app, and doesn't really work in Java.
      // This page allows you to view and reload the tag libraries for this portal machine.
      //		return HTMLConstructHelpers.GetSubHeader(
      //			m_asOwner.GetString(778, ResourceConstants.PORTALCOMMONMSGS),
      //			this.m_asOwner);
      // This page allows you to view the tag libraries for this portal machine.
      return HTMLConstructHelpers.GetSubHeader(m_asOwner.GetString(796, ResourceConstants.PORTALCOMMONMSGS),
       this.m_asOwner);
    }
    
    /// <summary>
    /// Returns the Class name.
    /// </summary>
    /// <returns>String</returns>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <summary>
    /// Returns the HTML for this Page.
    /// </summary>
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()"></seealso>
    /// <returns>HTMLElement</returns>
    /// <throws>HTMLException</throws>
    public override HTMLElement PageDisplay()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      // Insert super class HTML
      result.AddInnerHTMLElement(base.PageDisplay());
      HTMLElementCollection views = new HTMLElementCollection();
      views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(TagLibManagerAS.STR_MVC_STORAGE_NAME_MULTI_COLUMN_LIST)).Display());
      result.AddInnerHTMLElement(CreateLeftNavBar(views));
      return result;
    }
    
    /// <summary>
    /// Display the Javascripts for the Views.
    /// </summary>
    /// <returns>HTMLScriptCollection</returns>
    /// <throws>HTMLException</throws>
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScripts = base.DisplayJavaScriptFromChild();
      // Display JavaScript for the MultiColumn Array.
      myScripts.AddInnerHTMLElement(m_asOwner.GetView(TagLibManagerAS.STR_MVC_STORAGE_NAME_MULTI_COLUMN_LIST).DisplayJavascript());
      return myScripts;
    }
  }
}