using System;
namespace com.plumtree.portaluiinfrastructure.tags.metadata
{
  /// <summary>
  /// This base class provides programmatic access
  /// to the tag meta data for required and related
  /// parent and child tags.
  /// <p />
  /// Adding public static final member variables of
  /// the various ARelatedTag classes turns on
  /// validation that a tag is being used in the
  /// correct context, as well as providing useful
  /// documentation information.
  /// </summary>
  public abstract class ARelatedTag
  {
    protected ITagMetaData m_TagData;
    
    /// <summary>
    /// Creates a new related tag meta data object.
    /// </summary>
    /// <param name="_TagData">The parent tag data</param>
    public ARelatedTag(ITagMetaData _TagData)
    {
      m_TagData = _TagData;
    }
    
    /// <summary>
    /// Gets the data about the related tag.
    /// </summary>
    /// <returns>ITagMetaData The related tag data</returns>
    public virtual ITagMetaData GetTagData()
    {
      return m_TagData;
    }
  }
}