using System;
using com.plumtree.portaluiinfrastructure.tags.helper;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.pei;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portaluiinfrastructure.tags.pei
{
  /// <summary>
  /// This PEI resets the tag page request data at the end
  /// of every HTTP request.
  /// </summary>
  /// <author>DonH</author>
  public class TagPageActions : IPageActions
  {
    
    /// <seealso cref="com.plumtree.uiinfrastructure.pei.IPageActions#OnPageFinish(AActivitySpace,Object,String)"></seealso>
    public virtual HTMLComment OnPageFinish(AActivitySpace _asCurrentSpace,
     Object _oUserSession, String _strServerName)
    {
      // Reset the page request data at the end of every http request.
      // This could also be done at the start of the request.
      TagState.ResetPageRequestData(_asCurrentSpace);
      return null;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.pei.IPageActions#OnPageStart(AActivitySpace,Object,String)"></seealso>
    public virtual void OnPageStart(AActivitySpace _asCurrentSpace, Object _oUserSession,
     String _strServerName)
    {
    }
  }
}