using System;
using com.plumtree.openfoundation.util;
using com.plumtree.server;
namespace com.plumtree.portaluiinfrastructure.tags.xml
{
  /// <summary>
  /// Basic implementation of IXMLFragment.
  /// </summary>
  public class XMLFragment : IXMLFragment
  {
    private Object[][] m_arrXML;
    public XMLFragment(XPArrayList arAttributes)
    {
      int iNumAtts = arAttributes.GetSize();
      m_arrXML = new Object[PT_XML_ARRAY_COLS.PT_XML_ARRAY_NUM_COLS][];
      for (int j2c_index = 0;j2c_index < PT_XML_ARRAY_COLS.PT_XML_ARRAY_NUM_COLS;
      j2c_index++)
      {
        m_arrXML[j2c_index] = new Object[iNumAtts];
      }
      for (int iAtt = 0;iAtt < iNumAtts;iAtt++)
      {
        Object[] att = (Object[]) arAttributes.GetElement(iAtt);
        m_arrXML[PT_XML_ARRAY_COLS.PT_XML_ARRAY_COLS_NAME][iAtt] = att[PT_XML_ARRAY_COLS.PT_XML_ARRAY_COLS_NAME];
        m_arrXML[PT_XML_ARRAY_COLS.PT_XML_ARRAY_COLS_VALUE][iAtt] = att[PT_XML_ARRAY_COLS.PT_XML_ARRAY_COLS_VALUE];
        m_arrXML[PT_XML_ARRAY_COLS.PT_XML_ARRAY_COLS_TYPE][iAtt] = att[PT_XML_ARRAY_COLS.PT_XML_ARRAY_COLS_TYPE];
        }
    }
    public XMLFragment(Object[][] _objectXML)
    {
      m_arrXML = _objectXML;
    }
    /* (non-Javadoc)
     * @see com.plumtree.transformer.xml.IXMLFragment#GetType(int)
     */
     
    public virtual int GetType(int _nRowIndex)
    {
      return XPConvert.ToInteger(m_arrXML[PT_XML_ARRAY_COLS.PT_XML_ARRAY_COLS_TYPE][_nRowIndex]);
      }
    /* (non-Javadoc)
     * @see com.plumtree.transformer.xml.IXMLFragment#GetName(int)
     */
     
    public virtual String GetName(int _nRowIndex)
    {
      return XPConvert.ToString(m_arrXML[PT_XML_ARRAY_COLS.PT_XML_ARRAY_COLS_NAME][_nRowIndex]);
      }
    /* (non-Javadoc)
     * @see com.plumtree.transformer.xml.IXMLFragment#GetValue(int)
     */
     
    public virtual String GetValue(int _nRowIndex)
    {
      return XPConvert.ToString(m_arrXML[PT_XML_ARRAY_COLS.PT_XML_ARRAY_COLS_VALUE][_nRowIndex]);
      }
    /* (non-Javadoc)
     * @see com.plumtree.transformer.xml.IXMLFragment#GetNumberOfRows()
     */
     
    public virtual int GetNumberOfRows()
    {
      return m_arrXML[PT_XML_ARRAY_COLS.PT_XML_ARRAY_COLS_TYPE].Length;
    }
    /* (non-Javadoc)
     * @see com.plumtree.transformer.xml.IXMLFragment#GetObjectXML()
     */
     
    public virtual Object[][] GetObjectXML()
    {
      return m_arrXML;
    }
  }
}