using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.login;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.tips;
namespace com.plumtree.portaluiinfrastructure.tips
{
  /// <summary>
  /// This is an abstract model extended by various concrete error model.
  /// </summary>
  /// <author>Beng</author>
  public class PortalTipsModel : TipsModel
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_UI_INFRASTRUCTURE),
     "com.plumtree.portaluiinfrastructure.tips.PortalTipsModel");
    public const String STR_MVC_CLASS_NAME = "PortalTipsModel";
    // JF- Associated Activity Space
    protected AActivitySpace m_asOwner;
    private bool bDoDisplay = true;
    private bool bDoDisplaySet = false;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new PortalTipsModel();
    }
    
    /// <returns></returns>
    public override bool GetDoDisplayTipsBox()
    {
      log.Debug("GetDoDisplayTipsBox()");
      if (!bDoDisplaySet)
      {
        bool bo;
        Object o = null;
        o = PTPersonalSettingsHelper.GetPersonalSettingValue(PersonalSettingNames.DISPLAY_TIPS,
         this.m_asOwner);
        if (o != null)
        {
          bo = XPConvert.ToBoolean(o);
        } else
        {
          bo = true;
        }
        bDoDisplay = bo;
      }
      return bDoDisplay;
    }
    
    /// <seealso cref="com.plumtree.xpshared.activityspace.IModel#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <param name="b"></param>
    public override void SetDoDisplayTipsBox(bool b)
    {
      bDoDisplay = b;
      PTPersonalSettingsHelper.SetAndCachePersonalSetting(PersonalSettingNames.DISPLAY_TIPS,
       b, this.m_asOwner);
    }
  }
}