using System;
using com.plumtree.openfoundation.util;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.tree;
namespace com.plumtree.portaluiinfrastructure.tree
{
  /// <author>
  /// Naveen Pai
  /// This control is used to re-open a previously opened tree and refresh
  /// the contents (which objects are selected, etc...) for a server tree.
  /// </author>
  public class ServerRefreshTreeControl : IControl
  {
    
    /// <summary>
    /// name of the refresh tree control 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "ServerRefreshTree";
    protected ATreeAS m_asOwner;
    
    /// <summary>
    /// Internal data *
    /// </summary>
    protected ITreeModel m_asModel;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IControl#CheckActionSecurityAndExecute(XPHashtable)"></seealso>
    public virtual Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      String[] sValues;
      // Object ids to select (class id, object id pairs)
      sValues = (String[]) arguments.GetElement(AStartTreeControl.SELECTED_ITEMS);
      if (sValues != null)
      {
        ((IServerTreeModel) m_asModel).SetLocationsToSelect(sValues[0]);
      }
      return null;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new ServerRefreshTreeControl();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IControl#Init(IModel,AActivitySpace)"></seealso>
    public virtual void Init(IModel model, AActivitySpace space)
    {
      m_asModel = (ITreeModel) model;
      m_asOwner = (ATreeAS) space;
    }
  }
}