using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.tree;
namespace com.plumtree.portaluiinfrastructure.tree
{
  /// <author>Don Hayler</author>
  public class ServerTreeAS : ATreeAS
  {
    
    /// <summary>
    /// Object Name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "ServerTree";
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(String,String,boolean)"></seealso>
    public override bool CheckBasicAccess(String strPage, String strControl,
     bool bSameSpace)
    {
      return true;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new ServerTreeAS();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.AActivitySpace#Init()"></seealso>
    public override void Init()
    {
      base.Init();
      RegisterModel(ServerTreeModel.STR_MVC_CLASS_NAME, TREEMODEL);
      IModel myModel = GetModel(TREEMODEL);
      RegisterView(TreeBarView.STR_MVC_CLASS_NAME, TreeDP.TREE_BAR_STORAGE_NAME,
       myModel);
      RegisterView(TreeView.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(ServerStartTreeControl.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(TreeRepostControl.STR_MVC_CLASS_NAME, myModel);
      RegisterControl(ServerRefreshTreeControl.STR_MVC_CLASS_NAME, myModel);
      }
  }
}