using System;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.tree;
namespace com.plumtree.portaluiinfrastructure.tree
{
  /// <summary>
  /// This adds the selected items frame at the bottom
  /// </summary>
  /// <author>Don Hayler</author>
  public class TreeSearchFrameDP : TreeFrameDP
  {
    
    /// <summary>
    /// Frameset object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "TreeSearchFrame";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameScrollBottom()"></seealso>
    public override bool GetFrameScrollBottom()
    {
      return true;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameSetAttributes()"></seealso>
    public override String GetFrameSetAttributes()
    {
      return "40px,50%,75px";
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameURLBottom()"></seealso>
    public override ASURL GetFrameURLBottom()
    {
      // Display the tree itself
      ASURL result = new ASURL(m_asOwner);
      result.SetLinkGetCachedSpace(m_asOwner);
      result.SetDisplayPage(TreeSelectDP.STR_MVC_CLASS_NAME);
      return result;
    }
  }
}