using System;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.common.constants;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlconstructs;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portaluiinfrastructure.tree.template
{
  /// <author>michaeld</author>
  public class InheritTemplateView : IView
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.browsing.editors.community.templatetree.InheritTemplateView");
    
    /// <summary>
    /// MVC object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "InheritTemplate";
    
    /// <summary>
    /// Checkbox for Inherit Page Template 
    /// </summary>
    public const String HTMLBUTTON_CHECKBOX = "in_cb_InheritTemplate";
    private IInheritTemplateModelRO m_Model;
    private AActivitySpace m_asOwner;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Display()"></seealso>
    public virtual HTMLElement Display()
    {
      HTMLElement result = new HTMLElementCollection();
      HTMLTable innerTable = new HTMLTable();
      result.AddInnerHTMLElement(innerTable);
      innerTable.SetBorder(CommonHTMLStrings.ZERO);
      HTMLTableRow myRow = new HTMLTableRow();
      innerTable.AddInnerHTMLElement(myRow);
      HTMLTableCell myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetColSpan(CommonHTMLStrings.TWO);
      HTMLSpan mySpan = new HTMLSpan();
      myCell.AddInnerHTMLElement(mySpan);
      mySpan.SetStyleClass(PTStyleClass.DIALOGUE_TEXT);
      mySpan.AddInnerHTMLString(m_asOwner.GetString(529, ResourceConstants.PORTALINFRASTRUCTURE));
      myRow = new HTMLTableRow();
      innerTable.AddInnerHTMLElement(myRow);
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      myCell.SetNoWrap(true);
      myCell.SetVAlign(CommonHTMLStrings.TOP);
      // Add select all check box (check all)
      /* in_cb_InheritTemplate */
      HTMLInput myInput = new HTMLInput(HTMLInputTypes.CHECKBOX, HTMLBUTTON_CHECKBOX,
       m_asOwner.GetString(528, ResourceConstants.PORTALINFRASTRUCTURE));
      myCell.AddInnerHTMLElement(myInput);
      myInput.SetValue("true");
      myInput.SetChecked(m_Model.IsTemplateInherited());
      myCell = new HTMLTableCell();
      myRow.AddInnerHTMLElement(myCell);
      mySpan = new HTMLSpan();
      myCell.AddInnerHTMLElement(mySpan);
      mySpan.SetStyleClass(PTStyleClass.DIALOGUE_TEXT);
      mySpan.AddInnerHTMLString(m_asOwner.GetString(528, ResourceConstants.PORTALINFRASTRUCTURE));
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#DisplayJavascript()"></seealso>
    public virtual HTMLScript DisplayJavascript()
    {
      return null;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IView#Init(com.plumtree.uiinfrastructure.activityspace.IModelRO,com.plumtree.uiinfrastructure.activityspace.AActivitySpace)"></seealso>
    public virtual void Init(IModelRO model, AActivitySpace parent)
    {
      m_Model = (IInheritTemplateModelRO) model;
      m_asOwner = parent;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public virtual String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public virtual Object Create()
    {
      return new InheritTemplateView();
    }
  }
}