using System;
using com.plumtree.portaluiinfrastructure.tree;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.plumtree.portaluiinfrastructure.tree.template
{
  /// <author>michaeld</author>
  public class TemplateTreeFrameDP : TreeSearchFrameDP
  {
    
    /// <summary>
    /// Frameset object name 
    /// </summary>
    public const String STR_MVC_CLASS_NAME = "TemplateTreeFrame";
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameURLBody()"></seealso>
    public override ASURL GetFrameURLBody()
    {
      if (((TemplateTreeModel) m_asOwner.GetModel(TemplateTreeAS.TREEMODEL)).GetDisplayInheritTemplate())
      {
        // Display the inherit template frame
        ASURL result = new ASURL(m_asOwner);
        result.SetLinkGetCachedSpace(m_asOwner);
        result.SetDisplayPage(InheritTemplateDP.STR_MVC_CLASS_NAME);
        return result;
      }
      return base.GetFrameURLBody();
    }
  }
}