using System;
using com.plumtree.openfoundation.util;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.tree;
namespace com.plumtree.portaluiinfrastructure.tree.template
{
  /// <author>michaeld</author>
  public class TemplateTreeRepostControl : TreeRepostControl
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
     "com.plumtree.portalpages.browsing.editors.community.templatetree.TemplateTreeRepostControl");
    public const String STR_MVC_CLASS_NAME = "TemplateTreeRepost";
    public const int POSTTOSELF_ACTION_SELECTTEMPLATE = 99;
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()"></seealso>
    public override Object Create()
    {
      return new TemplateTreeRepostControl();
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()"></seealso>
    public override String GetName()
    {
      return STR_MVC_CLASS_NAME;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.activityspace.IControl#CheckActionSecurityAndExecute(com.plumtree.openfoundation.util.XPHashtable)"></seealso>
    public override Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
    {
      Redirect result = base.CheckActionSecurityAndExecute(arguments);
      if (POSTTOSELF_ACTION_SELECTTEMPLATE == m_nAction)
      {
        result.SetDisplayPage(InheritTemplateDP.STR_MVC_CLASS_NAME);
      }
      return result;
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.RepostControl#SetRepostAction()"></seealso>
    protected override void SetRepostAction()
    {
      base.SetRepostAction();
      if (POSTTOSELF_ACTION_SELECTTEMPLATE == m_nAction && ((TemplateTreeModel) m_model).GetDisplayInheritTemplate())
      {
        m_nAction = POSTTOSELF_ACTION_FINISH;
      }
    }
    
    /// <seealso cref="com.plumtree.uiinfrastructure.form.RepostControl#PerformAction(int)"></seealso>
    protected override void PerformAction(int _nAction)
    {
      base.PerformAction(_nAction);
      if (POSTTOSELF_ACTION_CANCEL == m_nAction)
      {
        ((TemplateTreeModel) m_asOwner.GetModel(TemplateTreeAS.TREEMODEL)).SetDisplayInheritTemplate(false);
        }
    }
  }
}