using System;
using IXPList=com.plumtree.openfoundation.util.IXPList;
using XPArrayList=com.plumtree.openfoundation.util.XPArrayList;
using XPException=com.plumtree.openfoundation.util.XPException;
using XPHashtable=com.plumtree.openfoundation.util.XPHashtable;
using XPIllegalStateException=com.plumtree.openfoundation.util.XPIllegalStateException;
using XPStringUtility=com.plumtree.openfoundation.util.XPStringUtility;
using ITaggingModel=com.plumtree.portaluiinfrastructure.pathways.tagging.ITaggingModel;
using TaggingControl=com.plumtree.portaluiinfrastructure.pathways.tagging.TaggingControl;
using PathwaysConstants=com.plumtree.portaluiinfrastructure.restconsumerframework.pathways.PathwaysConstants;
using HashtableDataObject=com.plumtree.portaluiinfrastructure.tags.data.HashtableDataObject;
using AActivitySpace=com.plumtree.uiinfrastructure.activityspace.AActivitySpace;
using IModel=com.plumtree.uiinfrastructure.activityspace.IModel;
namespace com.plumtree.portaluiinfrastructure.mock.pathways.tagging
{
  /// <author>Ravi Tunuguntla</author>
  public class MockTaggingModel : IModel,ITaggingModel
  {
    private XPHashtable m_relatedResourcesMap;
    public bool m_bTagged = false;
    public bool m_bUnTagged = false;
    private String m_strTag = null;
    private String m_strId = null;
    private int m_nAction;
    private String m_strSource = null;
    /* (non-Javadoc)
     * @see com.plumtree.portaluiinfrastructure.pathways.tagging.ITaggingModel#AddRemoveObjectTag(java.lang.String, java.lang.String, int, String)
     */
     
    public virtual void AddRemoveObjectTag(String tag, String id, int action,
     String ptsource)
    {
      m_strTag = tag;
      m_strId = id;
      m_nAction = action;
      m_strSource = ptsource;
      m_bTagged = ((null != m_strTag) && (XPStringUtility.IndexOf(m_strId,
       "_") > 0) && (XPStringUtility.Compare(m_strSource, PathwaysConstants.PTSOURCE_PORTAL) == 0) && (m_nAction == 0 || m_nAction == 2));
      m_bUnTagged = ((null != m_strTag) && (XPStringUtility.IndexOf(m_strId,
       "_") > 0) && (XPStringUtility.Compare(m_strSource, PathwaysConstants.PTSOURCE_PORTAL) == 0) && (m_nAction == 1));
      }
    /* (non-Javadoc)
     * @see com.plumtree.portaluiinfrastructure.pathways.tagging.ITaggingModel#RenameObjectTag(java.lang.String, java.lang.String, java.lang.String, java.lang.String)
     */
     
    public virtual void RenameObjectTag(String tag, String id, String ptsource,
     String renametag)
    {
      m_strTag = renametag;
      m_strId = id;
      m_nAction = TaggingControl.ACTION_RENAME_TAG;
      m_strSource = ptsource;
      m_bTagged = ((null != m_strTag) && (null != tag) && (XPStringUtility.IndexOf(m_strId,
       "_") > 0) && (XPStringUtility.Compare(m_strSource, PathwaysConstants.PTSOURCE_PORTAL) == 0) && (m_nAction == 0 || m_nAction == 2));
      m_bUnTagged = ((null != m_strTag) && (null != tag) && (XPStringUtility.IndexOf(m_strId,
       "_") > 0) && (XPStringUtility.Compare(m_strSource, PathwaysConstants.PTSOURCE_PORTAL) == 0) && (m_nAction == 1));
      }
    /* (non-Javadoc)
     * @see com.plumtree.portaluiinfrastructure.pathways.tagging.ITaggingModel#GetObjectTags(int)
     */
     
    public virtual IXPList GetObjectTags(int id)
    {
      return null;
    }
    /* (non-Javadoc)
     * @see com.plumtree.portaluiinfrastructure.pathways.tagging.ITaggingModel#IsTaggingEnabled()
     */
     
    public virtual bool IsTaggingEnabled()
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual void CleanupAllData()
    {
    }
    // TODO Auto-generated method stub
    public virtual void CleanupTempData()
    {
    }
    // TODO Auto-generated method stub
    public virtual void Init(AActivitySpace parent)
    {
      m_relatedResourcesMap = new XPHashtable();
    }
    public virtual String GetName()
    {
      // TODO Auto-generated method stub
      return TaggingControl.STR_MVC_CLASS_NAME;
    }
    public virtual Object Create()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual XPException GetPathwaysTaggingError()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual void SetPathwaysTaggingError(XPException e)
    {
    }
  }
}
// TODO Auto-generated method stub
