using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.restconsumerframework;
namespace com.plumtree.portaluiinfrastructure.mock.restapi
{
  public class MockRestRequest : RestRequest
  {
    protected String m_responseFileLocation = null;
    protected String m_responseContent = null;
    public MockRestRequest(String content, bool loadFile)
    {
      if (loadFile)
      {
        m_responseFileLocation = content;
      } else
      {
        m_responseContent = content;
      }
    }
    public override IRestResponse Submit()
    {
      IRestResponse response = null;
      String content = null;
      if (m_responseFileLocation != null)
      {
      } else
      if (m_responseContent != null)
      {
        content = m_responseContent;
      } else
      {
        return null;
      }
      if (XPStringUtility.StartsWith(content, "<?xml"))
      {
        response = new RestXMLResponse(content);
      } else
      if (XPStringUtility.StartsWith(content, "{"))
      {
        // @TODO once we have a jumpable JSON parser
        throw new XPNotImplementedException("Rest JSON Responses are not supported by this framework at this time.");
        } else
      {
        throw new XPIllegalStateException("Unknown REST response received, unable to parse as either XML or JSON: " + content);
        }
      return response;
    }
  }
}