using System;
using com.plumtree.openfoundation.util;
using PathwaysTagRestData=com.plumtree.portaluiinfrastructure.restconsumerframework.pathways.PathwaysTagRestData;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portaluiinfrastructure.mock.search
{
  /// <summary>
  /// Mock search result, for use by mock search results model.  This
  /// way a mock result can be made and tested against without actually
  /// requiring search to run.
  /// </summary>
  /// <author>smahendr</author>
  public class MockSearchResult
  {
    private String name = null;
    private HTMLAnchor clickthroughURL = null;
    private HTMLAnchor propertiesURL = null;
    private bool bIsBestBet = false;
    private String app = null;
    private int classID = 0;
    private int objectID = 0;
    private int folderID = 0;
    private HTMLImg icon = null;
    private String kwic = null;
    private XPDateTime lastModified = null;
    private String contentLastPubUser = null;
    private int[] contentPortletIDs = null;
    private PathwaysTagRestData[] resultTags = null;
    private double score = 0.0;
    public MockSearchResult()
    {
    }
    public virtual void setName(String name)
    {
      this.name = name;
    }
    public virtual void setClickthroughURL(HTMLAnchor clickthroughURL)
    {
      this.clickthroughURL = clickthroughURL;
    }
    public virtual void setPropertiesURL(HTMLAnchor propertiesURL)
    {
      this.propertiesURL = propertiesURL;
    }
    public virtual void setBestBet(bool bIsBestBet)
    {
      this.bIsBestBet = bIsBestBet;
    }
    public virtual void setApp(String app)
    {
      this.app = app;
    }
    public virtual void setClassID(int classID)
    {
      this.classID = classID;
    }
    public virtual void setObjectID(int objectID)
    {
      this.objectID = objectID;
    }
    public virtual void setFolderID(int folderID)
    {
      this.folderID = folderID;
    }
    public virtual void setIcon(HTMLImg icon)
    {
      this.icon = icon;
    }
    public virtual void setKwic(String kwic)
    {
      this.kwic = kwic;
    }
    public virtual void setLastModified(XPDateTime lastModified)
    {
      this.lastModified = lastModified;
    }
    public virtual void setContentLastPubUser(String contentLastPubUser)
    {
      this.contentLastPubUser = contentLastPubUser;
    }
    public virtual void setContentPortletIDs(int[] contentPortletIDs)
    {
      this.contentPortletIDs = contentPortletIDs;
    }
    public virtual void setPathwaysResultTags(PathwaysTagRestData[] resultTags)
    {
      this.resultTags = resultTags;
    }
    public virtual void setPathwaysResultScore(double score)
    {
      this.score = score;
    }
    public virtual String getName()
    {
      return name;
    }
    public virtual HTMLAnchor getClickthroughURL()
    {
      return clickthroughURL;
    }
    public virtual HTMLAnchor getPropertiesURL()
    {
      return propertiesURL;
    }
    public virtual bool isBestBet()
    {
      return bIsBestBet;
    }
    public virtual String getApp()
    {
      return app;
    }
    public virtual int getClassID()
    {
      return classID;
    }
    public virtual int getObjectID()
    {
      return objectID;
    }
    public virtual int getFolderID()
    {
      return folderID;
    }
    public virtual HTMLImg getIcon()
    {
      return icon;
    }
    public virtual String getKwic()
    {
      return kwic;
    }
    public virtual XPDateTime getLastModified()
    {
      return lastModified;
    }
    public virtual String getContentLastPubUser()
    {
      return contentLastPubUser;
    }
    public virtual int[] getContentPortletIDs()
    {
      return contentPortletIDs;
    }
    public virtual PathwaysTagRestData[] getPathwaysResultTags()
    {
      return resultTags;
    }
    public virtual double getPathwaysResultScore()
    {
      return score;
    }
  }
}