using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.helper;
using com.plumtree.portaluiinfrastructure.tags.manager;
using com.plumtree.portaluiinfrastructure.tags.metadata;
namespace com.plumtree.portaluiinfrastructure.mock.tags
{
  public class MockTagLibManager : ITagLibManager
  {
    public XPHashtable m_libraries = new XPHashtable();
    public XPHashtable m_tags = new XPHashtable();
    public String m_strTagLibrary;
    public virtual void SetLibraries(XPHashtable _libraries)
    {
      m_libraries = _libraries;
    }
    public virtual XPHashtable GetLibraries()
    {
      return m_libraries;
    }
    public virtual XPArrayList GetLibraryTagList(String _sLibname, double _dVersion)
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual XPArrayList GetLibraryTags(String _sLibname, double _dVersion)
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual int GetNumCustomTagLibraries()
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual int GetNumCustomTags()
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual void SetTag(ATag _tag, String _strName, String _strLibrary)
    {
      m_tags.PutElement(_strName, _tag);
      if ((m_strTagLibrary != null) && !m_strTagLibrary.Equals(_strLibrary))
      {
        throw new XPIllegalStateException("Mock Tag Library only supports a single library. Can\'t replace " + m_strTagLibrary + " with " + _strLibrary + ".");
        }
      m_strTagLibrary = _strLibrary;
      m_libraries.PutElement(_strLibrary, new Object());
      TagLibraryMetaData libraryData = new TagLibraryMetaData(_strLibrary + " Display Name",
       _strLibrary, _strLibrary + " Description", 1.0);
      TagMetaDataHelper helper = new TagMetaDataHelper();
      helper.Init(_tag, libraryData);
      _tag.SetTagMetaDataHelper(helper);
    }
    public virtual ATag GetTag(String _strTagName, String _strLibraryName,
     double _dLibraryVersion)
    {
      if (_strLibraryName.Equals(m_strTagLibrary))
      {
        return (ATag) m_tags.GetElement(_strTagName);
      }
      return null;
    }
    public virtual ATag GetTag(String _strTagName, String _strLibraryName)
    {
      if (_strLibraryName.Equals(m_strTagLibrary))
      {
        ATag template = (ATag) m_tags.GetElement(_strTagName);
        ATag instance = template.Create();
        TagLibraryMetaData libraryData = new TagLibraryMetaData(_strLibraryName + " Display Name",
         _strLibraryName, _strLibraryName + " Description", 1.0);
        TagMetaDataHelper helper = new TagMetaDataHelper();
        helper.Init(instance, libraryData);
        instance.SetTagMetaDataHelper(helper);
        return instance;
      }
      return null;
    }
    public virtual TagLibraryMetaData GetTagLibMetadata(String _sLibname,
     double _dVersion)
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual void GetTagMetadata(String _sLibname, double _dVersion,
     String _sTagname)
    {
    }
    // TODO Auto-generated method stub
    public virtual bool HasTag(String _strTagName, String _strLibraryName,
     double _dLibraryVersion)
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual bool HasTag(String _strTagName, String _strLibraryName)
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual void LoadClasses(String strLibDir, String strConfigFile)
    {
    }
    // TODO Auto-generated method stub
    public virtual void LoadCustomClasses(String strLibDir, String strConfigFile)
    {
    }
    // TODO Auto-generated method stub
    public virtual void ReloadAllTagLibraries()
    {
    }
    // TODO Auto-generated method stub
    public virtual void ReloadTagLibrary(String _sLibname, double _dVersion)
    {
    }
  }
}
// TODO Auto-generated method stub
