using System;
using com.plumtree.openfoundation.internationalization;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.helpers;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portaluiinfrastructure.mock.uiinfrastructure
{
  public class MockConfigHelper : IConfigHelper
  {
    public const String MOCK_PREFIX = "Mock-JS-";
    public const String MOCK_BASE_URL = "http://mock.base.com/portal/server.pt?";
    public virtual String GetJSIncluderComponentPath(String strJSComponentName,
     String strImageServerURL)
    {
      return MOCK_PREFIX + strJSComponentName;
    }
    public virtual HTMLElementCollection GetJSIncluderJSComponentInclude(String strJSComponentName,
     AActivitySpace owner)
    {
      HTMLElementCollection result = new HTMLElementCollection();
      result.AddInnerHTMLString(MOCK_PREFIX + strJSComponentName);
      return result;
    }
    public virtual HTMLElementCollection GetJSIncluderJSComponentInclude(String strJSComponentName,
     bool bEnableDebug, AActivitySpace owner, XPLocale locale)
    {
      HTMLElementCollection result = new HTMLElementCollection();
      result.AddInnerHTMLString(MOCK_PREFIX + strJSComponentName);
      return result;
    }
    public virtual String GetJSIncluderVersionPrefix(String strJSComponentName)
    {
      return MOCK_PREFIX + strJSComponentName;
    }
    public virtual String GetApplicationBaseURL(String _sNormalizedBaseURL,
     bool _bSecure)
    {
      return MOCK_BASE_URL;
    }
    public virtual String GetApplicationBaseURL(AActivitySpace asSpace)
    {
      return MOCK_BASE_URL;
    }
    public virtual String GetApplicationBaseURL(String _sNormalizedBaseURL)
    {
      return MOCK_BASE_URL;
    }
    public virtual String GetApplicationBaseURLToAS(String _sNormalizedBaseURL,
     String _sASName, bool _bIsSubSpace)
    {
      return MOCK_BASE_URL;
    }
    public virtual String GetHTTPEntryPoint()
    {
      return "server.pt";
    }
    public virtual String GetMainServerApplicationURL(bool _bIsSecure)
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual String GetImageServerBaseURL(AActivitySpace asSpace)
    {
      return MOCK_BASE_URL;
    }
    public virtual String GetNormalizedBaseURL(String _sURL)
    {
      return MOCK_BASE_URL;
    }
  }
}