using System;
using junit.framework;
using xpunit.framework;
using com.plumtree.portaluiinfrastructure.test.friendlyurl;
using HelperTestSuite=com.plumtree.portaluiinfrastructure.test.helper.HelperTestSuite;
using com.plumtree.portaluiinfrastructure.test.layout;
using PathwaysTestSuite=com.plumtree.portaluiinfrastructure.test.pathways.PathwaysTestSuite;
using SearchTestSuite=com.plumtree.portaluiinfrastructure.test.search.SearchTestSuite;
using com.plumtree.portaluiinfrastructure.test.server;
using com.plumtree.portaluiinfrastructure.test.statichelpers;
using com.plumtree.portaluiinfrastructure.test.tags;
using com.plumtree.portaluiinfrastructure.test.uiinfrastructure;
namespace com.plumtree.portaluiinfrastructure.test
{
  /// <author>danielf</author>
  public class PortalUIInfrastructureTestSuite
  {
    public const String SUITENAME = "Portal UI Infrastructure Unit Tests";
    public static Test suite()
    {
      XpTestSuite suite = new XpTestSuite(SUITENAME);
      suite.addTest(LayoutTestSuite.suite());
      suite.addTest(FriendlyURLTestSuite.suite());
      suite.addTest(TagsTestSuite.suite());
      suite.addTestSuite(typeof(GatewayHelpersTest));
      suite.addTest(UIInfrastructureTestSuite.suite());
      suite.addTest(ServerUnitTestSuite.suite());
      suite.addTest(PathwaysTestSuite.suite());
      suite.addTest(SearchTestSuite.suite());
      suite.addTest(HelperTestSuite.suite());
      return suite;
    }
  }
}