using System;
using junit.framework;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.classtypedescriptors;
using com.plumtree.portaluiinfrastructure.classtypedescriptors.classtypes;
using com.plumtree.portaluiinfrastructure.friendlyurl;
using com.plumtree.portaluiinfrastructure.mock.friendlyurl;
using com.plumtree.portaluiinfrastructure.mock.tags;
using com.plumtree.server;
using com.plumtree.server.mock.core;
using com.plumtree.uiinfrastructure.application;
using com.plumtree.uiinfrastructure.application.varpacks;
using com.plumtree.uiinfrastructure.helpers;
using com.plumtree.uiinfrastructure.web;
namespace com.plumtree.portaluiinfrastructure.test.classtypedescriptors.classtypes
{
  public class PTCommunitiesTestURLGeneration : TestCase
  {
    public MockEnvironment m_space = new MockEnvironment();
    public MockPTSession m_session = new MockPTSession();
    protected PTCommunities testObject = null;
    internal String commToken = null;
    public PTCommunitiesTestURLGeneration(String name) : base(name)
    {
    }
    public override void setUp()
    {
      testObject = new PTCommunities();
      m_space.SetUserSession(m_session);
      //String commToken = ((IFriendlyURLManager)PTConfigHelper.GetTypeDescrManager()).LookupFriendlyURLKeyFromClassId(PT_CLASSIDS.PT_COMMUNITY_ID+"");
      commToken = "communities";
      IApplication application = new Application("", "");
      ApplicationManager.SetTestInstance(new MockApplicationManager());
      ((MockApplicationManager) ApplicationManager.GetInstance()).SetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString(),
       application);
      XPHashtable htLookupTable = new XPHashtable();
      htLookupTable.PutElement(XPConvert.ToString(PT_CLASSIDS.PT_COMMUNITY_ID),
       "communities");
      IFriendlyURLManager friendlyURLManager = new MockClassTypeDescManager();
      friendlyURLManager.SetFriendlyURLLookupTable(htLookupTable);
      application.GetCachingManager().SetEntry(AppWarmUp.KEY_CACHEMAN_CLASS_TYPE_MANAGER,
       friendlyURLManager);
    }
    
    /// <summary>
    /// Generate URL from just passing in community name
    /// </summary>
    public virtual void testGenerateFriendlyURLForWithCommunityName()
    {
    }
    // @TODO Need to setup the mock objects properly
    //		String commName = "My Community";
    //		
    //		
    //		FriendlyURL url = new FriendlyURL(PT_CLASSIDS.PT_COMMUNITY_ID, commName);
    //		// This case should not need to use the activityspace since we are providing the object name
    //		String friendlyURL = testObject.ConstructFriendlyURL(url, m_space);
    //		Assert.assertEquals("/"+commToken+"/my_community", friendlyURL);
    
    /// <summary>
    /// Generate URL from passing in community and page name
    /// </summary>
    public virtual void testGenerateFriendlyURLForWithCommunityPageName()
    {
    }
    // @TODO Need to setup the mock objects properly
    //		String commName = "My Community";
    //		String pageName = "Community Page";
    //		FriendlyURL url = new FriendlyURL(PT_CLASSIDS.PT_COMMUNITY_ID, commName);
    //		url.SetChildName(pageName);
    //		
    //		// This case should not need to use the activityspace since we are providing the object name
    //		MockEnvironment space = new MockEnvironment();
    //		String friendlyURL = testObject.ConstructFriendlyURL(url, m_space);
    //		Assert.assertEquals("/"+commToken+"/my_community/community_page", friendlyURL);
    
    /// <TODO>add tests that use the mock community manager</TODO>
    public virtual void testGenerateFriendlyURLForWithCommunityId()
    {
    }
  }
}