using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.friendlyurl;
using com.plumtree.server;
using junit.framework;
namespace com.plumtree.portaluiinfrastructure.test.friendlyurl
{
  public class FriendlyURLParserTest : TestCase
  {
    protected IFriendlyURLParser testObject;
    protected String objectName = "object name";
    protected String objectNameNormalized = "object_name";
    public FriendlyURLParserTest(String name) : base(name)
    {
    }
    
    /// <summary>
    /// Setup if any is required.
    /// </summary>
    public override void setUp()
    {
      base.setUp();
      XPStringTokenizer stURLTokens = new XPStringTokenizer("/" + objectNameNormalized + "/",
       "/", false);
      testObject = new FriendlyURLParser("mypages", XPConvert.ToString(PT_CLASSIDS.PT_MYPAGESCONTAINER_ID),
       stURLTokens);
    }
    
    /// <seealso cref="TestCase#tearDown()"></seealso>
    public override void tearDown()
    {
      base.tearDown();
      testObject = null;
    }
    public virtual void testGetObjectName()
    {
      String name = testObject.GetObjectName(false);
      Assert.assertEquals("Wrong name was returned.", name, objectNameNormalized);
      }
    public virtual void testGetObjectNameDeNormalized()
    {
      String name = testObject.GetObjectName(true);
      Assert.assertEquals("Wrong name was returned.", name, objectName);
    }
  }
}