using System;
using com.plumtree.portaluiinfrastructure.friendlyurl;
using junit.framework;
namespace com.plumtree.portaluiinfrastructure.test.friendlyurl
{
  public class FriendlyURLTest : TestCase
  {
    protected String strDeNormalizedString1 = "test name";
    protected String strNormalizedString1 = "test_name";
    protected String strDeNormalizedString2 = "test  name";
    protected String strNormalizedString2 = "test__name";
    protected String strDeNormalizedString3 = "test na-me";
    protected String strNormalizedString3 = "test_na-me";
    protected String specialCharString = "!@#$%^&*<>()-=~?";
    protected String deNormalizedSpecialCharString = "!@ $      ()-=~ ";
    protected String normalizedSpecialCharString = "!@_$______()-=~_";
    public FriendlyURLTest(String name) : base(name)
    {
    }
    
    /// <summary>
    /// Setup if any is required.
    /// </summary>
    public override void setUp()
    {
      base.setUp();
    }
    
    /// <seealso cref="TestCase#tearDown()"></seealso>
    public override void tearDown()
    {
      base.tearDown();
    }
    public virtual void testNormalizeObjectName()
    {
      String test1 = FriendlyURL.NormalizeObjectName(strDeNormalizedString1);
      Assert.assertEquals(test1, strNormalizedString1);
      String test2 = FriendlyURL.NormalizeObjectName(strNormalizedString1);
      Assert.assertEquals(test2, strNormalizedString1);
      String test3 = FriendlyURL.NormalizeObjectName(strDeNormalizedString2);
      Assert.assertEquals(test3, strNormalizedString2);
      String test4 = FriendlyURL.NormalizeObjectName(strDeNormalizedString3);
      Assert.assertEquals(test4, strNormalizedString3);
      String test5 = FriendlyURL.NormalizeObjectName(specialCharString);
      Assert.assertEquals(normalizedSpecialCharString, test5);
    }
    public virtual void testDeNormalizeObjectName()
    {
      String test1 = FriendlyURL.DeNormalizeObjectName(strNormalizedString1);
      Assert.assertEquals(test1, strDeNormalizedString1);
      String test2 = FriendlyURL.DeNormalizeObjectName(strNormalizedString2);
      Assert.assertEquals(test2, strDeNormalizedString2);
      String test3 = FriendlyURL.DeNormalizeObjectName(strNormalizedString3);
      Assert.assertEquals(test3, strDeNormalizedString3);
      String test4 = FriendlyURL.DeNormalizeObjectName(specialCharString);
      Assert.assertEquals(deNormalizedSpecialCharString, test4);
    }
  }
}