using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.friendlyurl;
using com.plumtree.server;
using junit.framework;
namespace com.plumtree.portaluiinfrastructure.test.friendlyurl
{
  public class KDFriendlyURLParserTest : TestCase
  {
    protected KDFriendlyURLParser testObject;
    protected String objectName = "object name";
    protected String objectNameNormalized = "object_name";
    protected int objectId = 200;
    public KDFriendlyURLParserTest(String name) : base(name)
    {
    }
    
    /// <summary>
    /// Setup if any is required.
    /// </summary>
    public override void setUp()
    {
      base.setUp();
    }
    
    /// <seealso cref="TestCase#tearDown()"></seealso>
    public override void tearDown()
    {
      base.tearDown();
      testObject = null;
    }
    public virtual void testGetObjectNameAndId()
    {
      XPStringTokenizer stURLTokens = new XPStringTokenizer("/" + objectNameNormalized + "/" + objectId,
       "/", false);
      testObject = new KDFriendlyURLParser("directory", XPConvert.ToString(PT_CLASSIDS.PT_CATALOGFOLDER_ID),
       stURLTokens);
      String name = testObject.GetObjectName(true);
      Assert.assertEquals("Wrong name was returned.", name, objectName);
      int id = testObject.GetObjectId();
      Assert.assertEquals("Wrong id was returned.", id, objectId);
    }
  }
}