using System;
using TestCase=junit.framework.TestCase;
using com.plumtree.portaluiinfrastructure.helpers;
using MockEnvironment=com.plumtree.portaluiinfrastructure.mock.tags.MockEnvironment;
using com.plumtree.server;
using com.plumtree.server.mock.core;
using com.plumtree.server.mock.webservice;
namespace com.plumtree.portaluiinfrastructure.test.helper
{
  //TODO what is hte purpose of the unit test?  DESCRIPTION
  public class CollaborationHelperServiceTest : TestCase
  {
    public const String COLLAB_WEB_SERVICE_UUID = "{AC0A5760-B0AC-40DA-A977-67F6E2F3949C}";
    public const String COLLAB_WEB_SERVICE_NAME = "Collab Web Service ID";
    public const int COLLAB_WEB_SERVICE_ID = 307;
    protected MockEnvironment m_environment;
    protected MockPTWebServiceManager m_wsMgr;
    protected MockPTSession ptSession;
    public override void setUp()
    {
      base.setUp();
      m_environment = new MockEnvironment();
      ptSession = (MockPTSession) m_environment.GetUserSession();
      //Mock web service
      m_wsMgr = (MockPTWebServiceManager) ptSession.GetWebServices();
      //constructing web service query result
      int[] wsColumns = {PT_PROPIDS.PT_PROPID_OBJECTID};
      Object[][] wsData = {new Object[]{COLLAB_WEB_SERVICE_ID}};
      MockPTQueryResult ptqrWebService = new MockPTQueryResult();
      ptqrWebService.SetData(wsColumns, wsData, true);
      //setting up objects in mock objects
      ((MockPTSession) m_environment.GetUserSession()).m_WSObjectManager.m_queryResult = ptqrWebService;
      m_wsMgr = ptSession.m_WSObjectManager;
      m_wsMgr.m_bUseStatic = false;
      m_wsMgr.m_queryResult = ptqrWebService;
    }
    public override void tearDown()
    {
      m_wsMgr = null;
      ptSession = null;
      m_environment = null;
    }
    public virtual void testLoadCollaborationWebService()
    {
      //calling this to setup the query filter necessary to continue tests.
      ICollaborationHelper collabHelper = CollaborationHelperService.getInstance();
      int webserviceid = collabHelper.GetWebServiceID(ptSession);
      //TODO reverse all he strings b/c they are errors only.
      //ie:  !collab web service id is found.
      //introduce a bug into the code to make sure that unit tests actually catches the bugs/errors.
      assertEquals("collab web service id should have been found.", COLLAB_WEB_SERVICE_ID,
       webserviceid);
      bool isInstalled = collabHelper.IsCollaborationInstalled(ptSession);
      assertTrue("Collaboration should be installed.", isInstalled);
      Object[][] filter = m_wsMgr.m_queryFilterUsed;
      assertNotNull("Query filter used to call object manager should not be null",
       filter);
      assertEquals("Checking for filter operand, should be UUID value.", PT_PROPIDS.PT_PROPID_UUID,
       filter[0][0]);
      assertEquals("Checking for filter operator, should be \"=\".", PT_FILTEROPS.PT_FILTEROP_EQ,
       filter[1][0]);
      String wsUUID = (String) filter[2][0];
      assertNotNull("query filter uuid string value should not be null.",
       wsUUID);
      assertEquals("Checking uuid item value should be the same.", COLLAB_WEB_SERVICE_UUID,
       wsUUID);
    }
  }
}