using System;
using junit.framework;
using com.plumtree.server;
using com.plumtree.server.impl.core;
using com.plumtree.server.impl.portlet.providers;
namespace com.plumtree.portaluiinfrastructure.test.server.impl.core
{
  public class ProvidersFactoryTest : TestCase
  {
    public virtual void testPortletProviders()
    {
      IPTAsyncGadgetProvider prov = ProvidersFactory.CreatePortletProvider(PageletProvider.STR_CLSID);
      assertTrue("Factory did not return an instance of the pagelet provider.",
       prov is PageletProvider);
      prov = ProvidersFactory.CreatePortletProvider(CSPPortletProvider.STR_CLSID);
      assertTrue("Factory did not return an instance of the CSP portlet provider.",
       prov is CSPPortletProvider);
      prov = ProvidersFactory.CreatePortletProvider(IntrinsicPortletProviderObject.STR_CLSID);
      assertTrue("Factory did not return an instance of the intrinsic portlet provider.",
       prov is IntrinsicPortletProviderObject);
    }
  }
}