using System;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.portaluiinfrastructure.test.tags
{
  public class TestSimpleTag : ATestTag
  {
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    public static readonly ITagMetaData TAG;
    public static readonly RequiredTagAttribute TESTATTRIBUTE;
    static TestSimpleTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("testsimpletag", "This tag evaluates the attribute as a Transformer Tag attribute " + "and displays the value.",
       "");
      TESTATTRIBUTE = new RequiredTagAttribute("testvalue", "The value to be displayed.");
      }
    
    /// <summary>
    /// Override
    /// </summary>
    public override HTMLElement DisplayTag()
    {
      return new HTMLGenericElement(GetTagAttributeAsString(TESTATTRIBUTE));
      }
    
    /// <summary>
    /// Override
    /// </summary>
    public override ATag Create()
    {
      return new TestSimpleTag();
    }
  }
}