using System;
using xpunit.framework;
using com.plumtree.uiinfrastructure.arraywrapper;
namespace com.plumtree.portaluiinfrastructure.test.uiinfrastructure.arraywrapper
{
  public class PTSortedArrayWrapperTest : XpTestCase
  {
    public const int COLUMN_1 = 1;
    public const int COLUMN_2 = 2;
    
    /// <summary>
    /// This tests trying to sort an empty array.
    /// XDK bug#64089
    /// Portal bugs#64086 and 64062
    /// The XDK bug still exists, but it has been worked around in the
    /// PTSortedArrayWrapper to avoid the problem.
    /// This is a .NET only problem, so this doesn't currently test this
    /// since we don't run .NET tests as part of the build.
    /// </summary>
    public static void testSortEmptyArray()
    {
      PTSortedArrayWrapper wrapper = new PTSortedArrayWrapper();
      // Column mapping
      int[] arrColumns = new int[]{COLUMN_1, COLUMN_2};
      // Sort array
      // The array will always be sorted by the 1st column.
      int[][] arrSort = new int[1][];
      for (int j2c_index = 0;j2c_index < 1;j2c_index++)
      {
        arrSort[j2c_index] = new int[2];
      }
      arrSort[0][PTSortedArrayWrapper.PTSAW_SORT_ROW_PROPID] = COLUMN_1;
      arrSort[0][PTSortedArrayWrapper.PTSAW_SORT_ROW_DIRECTION] = PTSortedArrayWrapper.PTSAW_SORT_ASCENDING;
      // Don't initalize the list itself (null below)
      wrapper.Initialize(arrColumns, null, arrSort, true);
      // Reverse the sort
      arrSort[0][PTSortedArrayWrapper.PTSAW_SORT_ROW_PROPID] = COLUMN_2;
      // On .NET, this call use to throw a NPE because we're sorting an empty list.
      wrapper.Sort(arrSort);
    }
  }
}