package com.plumtree.portaluiinfrastructure.application.varpacks;

import com.plumtree.uiinfrastructure.application.varpacks.*;


/**
 * This class contains constants for PTconfig.xml and the x_config.xml files.
 */
public class PTConfigConstants extends ConfigConstants
{
	////////////
	// Main URLs
	////////////

	// WilliamA - move the following constant to ConfigConstants 
	// (in uiinfrastructure)
	/** The Main URLs section */
	// public static final String MAIN_URLS_SECTION = "MainURLs";

	//	MainURLs		
	//	  ApplicationBaseURL
	//	  ImageServerBaseURL
	//	  ImageServerSecureBaseURL
	//	  AdminSiteBaseURL

	////////////
	// Documents
	////////////

	/** The Documents section */
	public static final String DOCUMENTS_SECTION = "Documents";

	//	Documents
	//	  NewDocumentTime
	//	  DocumentLastUpdated
	//	  OpenNewWindow
	//    SubFolderBrowseThroughSearch

	///////////
	// Crawlers
	///////////

	/** The Crawlers section */
	public static final String CRAWLERS_SECTION = "Crawlers";
	
	//	Crawlers
	//	  MaxCrawlRadius

	/////////
	// Search
	/////////

	/** The Search section */
	public static final String SEARCH_SECTION = "Search";

	//	Search
	//	  NumSearchResultsPerPage

	//////////
	// MyPages
	//////////

	/** The MyPages section 
	 * @deprecated User STYLE_SECTION instead.
	 */	
	public static final String MY_PAGES_SECTION = "MyPages";
	
	public static final String STYLE_SECTION = "Style";

	//	MyPages
	//	  MyPageRefreshRate
	//	  StyleSheetName

	//////////////
	// Communities
	//////////////

	/** The Communities section */
	public static final String COMMUNITIES_SECTION = "Communities";

	//	Communities
	//	  DefaultCommuntyID
	//	  CommKnowledgeDirLinksPerPage
	//	  SiteMapEnabledForGuest

	/** The CommKnowledgeDirLinksPerPage sub-section in Communities */
	public static final String COMM_KD_LINKS_PER_PAGE_SUBSECTION = "CommKnowledgeDirLinksPerPage";

	/** The SiteMapEnabled sub-section in Communities */
	public static final String SITE_MAP_ENABLED_FOR_GUEST_SUBSECTION = "SiteMapEnabledForGuest";

	/////////////////
	// Administration
	/////////////////

	/** The Administration section */
	public static final String ADMINISTRATION_SECTION = "Administration";

	/** The Is Admin Site sub-section in administration */
	public static final String IS_ADMIN_SITE_SUBSECTION = "IsAdminSite";

	/** The Admin Objects Per Page sub-section in administration */
	public static final String ADMIN_OBJECTS_PER_PAGE_SUBSECTION = "AdminObjectsPerPage";
	
	/** The Max Results To Display sub-section in administration */
	public static final String MAX_RESULTS_TO_DISPLAY_SUBSECTION = "MaxResultsToDisplay";
	
	/** The Invitations Section */
	public static final String INVITATIONS_SECTION = "Invitations";
	
	/** Setting Name: Is the Invitation URL Secure*/
	public static final String IS_INVITATION_URL_SECURE = "IsInvitationURLSecure";

	/////////////////
	// Authentication
	/////////////////

	/** The Authentication section */
	public static final String AUTHENTICATION_SECTION = "Authentication";

	//	Authentication	
	//	  AllowDefaultLoginPageAuthSource
	//	  DefaultAuthSourcePrefix
	//	  AllowAutoConnect
	//	  SSOVendor		
	//	  CookiePath
	//	  CookieDomain
	//	  SSOCookieIsSecure
	//	  CaptureBasicAuthenticationForPortlets

	/** The BrowserLoginTokenExpiration sub-section */
	public static final String BROWSERLOGINTOKENEXPIRATION_SUBSECTION = "BrowserLoginTokenExpiration";

	//////////////////////
	// Garbage Collection
	//////////////////////
	
	/** The Garbage Collection Section */
	public static final String GARBAGE_COLLECTION_SECTION = "GarbageCollection";
	
	//  GarbageCollection
	//    ThreadInterval
	//    ThreadPriority

	/** The Thread Interval sub-section in garbage collection */
	public static final String THREAD_INTERVAL_SUBSECTION = "ThreadInterval";

	/** The Thread Priority sub-section in garbage collection */
	public static final String THREAD_PRIORITY_SUBSECTION = "ThreadPriority";

	/////////////////
	// Gateway
	/////////////////

	/** The Gateway section */
	public static final String GATEWAY_SECTION = "Gateway";
	
	/** The Failover section */
	public static final String FAILOVER_SECTION = "Failover";
	
	/////////////////
	// Analytics (as of Portal 6.5, Analytics settings are included part of Portal)
	/////////////////
	
	/** Flag that enables Analytics */
	public static final String ANALYTICS_ENABLED_SETTING = "analytics-communication:enabled";

	/** Flag that enableds Analytics clustering */
	public static final String ANALYTICS_CLUSTERING_ENABLED_SETTING = "clustering:enabled";
	
	/** Analytics cluster name */
	public static final String ANALYTICS_CLUSTER_NAME_SETTING = "analytics-cluster:name";
	
	/** Analytics cluster timeout */
	public static final String ANALYTICS_CLUSTER_TIMEOUT_SETTING = "analytics-cluster:timeout-period";

	/** Analytics cluster port */
	public static final String ANALYTICS_CLUSTER_PORT_SETTING = "analytics-cluster:listening-port";

	/** Flag that enables Analytics unicast */
	public static final String ANALYTICS_UNICAST_ENABLED_SETTING = "unicast:enabled";

	/** Analytics Collector hostname */
	public static final String ANALYTICS_COLLECTOR_HOST_SETTING = "analytics-collector:host";

	/** Analytics Collector port */
	public static final String ANALYTICS_COLLECTOR_PORT_SETTING = "analytics-collector:port";

	/** Analytics logging level */
	public static final String ANALYTICS_LOGGING_LEVEL_SETTING = "logging:level";

	/** Flag that enables Analytics console logging */
	public static final String ANALYTICS_CONSOLE_LOGGING_SETTING = "console-logging:enabled";
}

