package com.plumtree.portaluiinfrastructure.approval;

import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.approval.*;
import com.plumtree.xpshared.htmlconstructs.*;

/**
 *
 *	This class represents a portal-specific ApprovalItemType.  The public enumeration 
 *	presented by this class defines the set of object types available for approval.
 *
 * @author Ben Geislinger
 *
 */
public class ApprovalPortalItemType extends ApprovalItemType
{
	


	
	public static final ApprovalPortalItemType EXTERNAL_OPERATION   = new ApprovalPortalItemType("externaloperation",
			PTImageType.ICON_EXTERNAL_OPERATION, PT_CLASSIDS.PT_EXTOPERATION_ID, 2357, 2358);
		
	
	
	public static final ApprovalPortalItemType DOCUMENT   = new ApprovalPortalItemType("document",
			PTImageType.ICON_DOCUMENT, PT_CLASSIDS.PT_CATALOGCARD_ID, 2352, 2295);

	
	public static final ApprovalPortalItemType USER		  = new ApprovalPortalItemType("user",
			PTImageType.ICON_USER, PT_CLASSIDS.PT_USER_ID, 2296, 2297);

	
	public static final ApprovalPortalItemType CRAWLER    = new ApprovalPortalItemType("crawler",
			PTImageType.ICON_CRAWLER, PT_CLASSIDS.PT_CRAWLER_ID, 2298, 2299);

	
	public static final ApprovalPortalItemType DATASOURCE = new ApprovalPortalItemType("datasource",
			PTImageType.ICON_DATA_SOURCE, PT_CLASSIDS.PT_DATASOURCE_ID, 2300,
			2301);

	
	public static final ApprovalPortalItemType GROUP	  = new ApprovalPortalItemType("group",
			PTImageType.ICON_GROUP, PT_CLASSIDS.PT_USERGROUP_ID, 2302, 2303);

	
	public static final ApprovalPortalItemType PORTLET    = new ApprovalPortalItemType("portlet",
			PTImageType.ICON_PORTLET, PT_CLASSIDS.PT_GADGET_ID, 2304, 2305);

	
	public static final ApprovalPortalItemType COMMUNITY  = new ApprovalPortalItemType("community",
			PTImageType.ICON_COMMUNITY, PT_CLASSIDS.PT_COMMUNITY_ID, 2306, 2307);

	
	public static final ApprovalPortalItemType AUTHSOURCE = new ApprovalPortalItemType("authsource",
			PTImageType.ICON_AUTH_SOURCE, PT_CLASSIDS.PT_AUTHSOURCE_ID, 2308,
			2309);

	
	public static final ApprovalPortalItemType COMMUNITY_TEMPLATE = new ApprovalPortalItemType("community_template",
			PTImageType.ICON_COMMUNITY_TEMPLATE,
			PT_CLASSIDS.PT_COMMUNITYTEMPLATE_ID, 2310, 2311);

	
	public static final ApprovalPortalItemType DOCUMENT_TYPE = new ApprovalPortalItemType("document_type",
			PTImageType.ICON_DOCUMENT_TYPE, PT_CLASSIDS.PT_DOCUMENTTYPE_ID,
			2312, 2313);


	
	public static final ApprovalPortalItemType FEDERATED_PORTAL = new ApprovalPortalItemType("federated_portal",
			PTImageType.ICON_NETWORK_SEARCH, PT_CLASSIDS.PT_FEDERATEDPORTAL_ID, 2651, 2650);

	
	public static final ApprovalPortalItemType FILTER = new ApprovalPortalItemType("filter",
			PTImageType.ICON_FILTER, PT_CLASSIDS.PT_FILTER_ID, 2316, 2317);

	
	public static final ApprovalPortalItemType JOB = new ApprovalPortalItemType("job",
			PTImageType.ICON_JOB, PT_CLASSIDS.PT_JOB_ID, 2318, 2319);


	
	public static final ApprovalPortalItemType PAGE_TEMPLATE = new ApprovalPortalItemType("page_template",
			PTImageType.ICON_PAGE_TEMPLATE, PT_CLASSIDS.PT_PAGETEMPLATE_ID, 2320,
			2321);

	
	public static final ApprovalPortalItemType PROPERTY = new ApprovalPortalItemType("property",
			PTImageType.ICON_PROPERTY, PT_CLASSIDS.PT_PROPERTY_ID, 2322, 2323);


	
	public static final ApprovalPortalItemType PROPERTYMAP = new ApprovalPortalItemType("property_map",
			PTImageType.ICON_PROPERTY, PT_CLASSIDS.PT_PROPERTYMAP_ID, 2324, 2325);


	
	public static final ApprovalPortalItemType SAVED_SEARCH = new ApprovalPortalItemType("saved_search",
			PTImageType.ICON_SAVED_SEARCH, PT_CLASSIDS.PT_SAVEDSEARCH_ID, 2326, 2327);


	
	public static final ApprovalPortalItemType SCHEDULE = new ApprovalPortalItemType("schedule",
			PTImageType.ICON_CALENDAR, PT_CLASSIDS.PT_SCHEDULE_ID, 2328, 2329);


	
	public static final ApprovalPortalItemType SITE_MAP_FOLDER = new ApprovalPortalItemType("site_map_folder",
			PTImageType.ICON_FOLDER, PT_CLASSIDS.PT_SITEMAPFOLDER_ID, 2330, 2331);

	//  todo name ids

	
	public static final ApprovalPortalItemType SUBPORTAL = new ApprovalPortalItemType("subportal",
			PTImageType.ICON_SUB_PORTAL, PT_CLASSIDS.PT_SUBPORTAL_ID, 2332, 2333);


	
	public static final ApprovalPortalItemType USER_INTERFACE = new ApprovalPortalItemType("user_interface",
			PTImageType.ICON_ARROW_ASCEND, PT_CLASSIDS.PT_USERINTERFACE_ID, 2334,
			2335);


	
	public static final ApprovalPortalItemType WEB_SERVICE = new ApprovalPortalItemType("web_service",
			PTImageType.ICON_WEB_SERVICE, PT_CLASSIDS.PT_WEBSERVICE_ID, 2336, 2337);

	
	public static final ApprovalPortalItemType INVITATION = new ApprovalPortalItemType("invitation",
			PTImageType.ICON_INVITATION, PT_CLASSIDS.PT_INVITATION_ID, 2338, 2339);


	
	public static final ApprovalPortalItemType PORTLET_BUNDLE = new ApprovalPortalItemType("portlet_bundle",
			PTImageType.ICON_PORTLET_BUNDLE, PT_CLASSIDS.PT_GADGETBUNDLE_ID, 2340, 2341);


	
	public static final ApprovalPortalItemType REMOTE_SERVER = new ApprovalPortalItemType("remote_server",
			PTImageType.ICON_REMOTE_SERVER, PT_CLASSIDS.PT_GADGETCONTENTSERVER_ID, 2342,
			2343);


	
	public static final ApprovalPortalItemType PORTLET_TEMPLATE = new ApprovalPortalItemType("portlet_template",
			PTImageType.ICON_PORTLET_TEMPLATE, PT_CLASSIDS.PT_GADGETTEMPLATE_ID, 2344, 2345);

	
	public static final ApprovalPortalItemType ADMIN_FOLDER = new ApprovalPortalItemType("admin_folder",
			PTImageType.ICON_FOLDER, PT_CLASSIDS.PT_ADMIN_FOLDER_ID, 2346, 2347);
			

	
	public static final ApprovalPortalItemType DOCUMENT_FOLDER = new ApprovalPortalItemType("document_folder",
			PTImageType.ICON_FOLDER, PT_CLASSIDS.PT_CATALOGFOLDER_ID, 2348, 2349);
			
	
	public static final ApprovalPortalItemType PROFILE_SOURCE = new ApprovalPortalItemType("profile_source",
			PTImageType.ICON_PROFILE_SOURCE, PT_CLASSIDS.PT_PROFILESOURCE_ID, 2350, 2351);
			

	public static final ApprovalPortalItemType PAGE = new ApprovalPortalItemType("page",
			PTImageType.ICON_MYPAGE, PT_CLASSIDS.PT_PAGE_ID, 3128,
			3129);



			
	private PTImageType imageType;
	private String sName;
	private int iClassID	    = -1;
	private int iNameIDPlural;
	private int iNameIDSingular;

	/**
	 * Creates a new ApprovalItemType object.
	 *
	 * @param name 
	 * @param iType 
	 * @param classID 
	 */
	public ApprovalPortalItemType(String name, PTImageType iType, int classID,
		int iIDs, int iIDp)
	{
		super();

		sName			    = name;
		imageType		    = iType;
		iClassID		    = classID;
		iNameIDSingular     = iIDs;
		iNameIDPlural	    = iIDp;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public int GetClassID()
	{
		return iClassID;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public PTImageType GetItemImageType()
	{
		return imageType;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public int GetLocalizedNameIDPlural()
	{
		return iNameIDPlural;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public int GetLocalizedNameIDSingular()
	{
		return iNameIDSingular;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetName()
	{
		return sName;
	}

	/**
	 * 
	 *
	 * @param sName 
	 * @return 
	 */
	public ApprovalItemType GetType(String sName)
	{
		ApprovalPortalItemType itTemp = null;

		if (DOCUMENT.GetName().equals(sName))
		{
			itTemp = DOCUMENT;
		}
		else if (USER.GetName().equals(sName))
		{
			itTemp = USER;
		}
		else if (CRAWLER.GetName().equals(sName))
		{
			itTemp = CRAWLER;
		}
		else if (DATASOURCE.GetName().equals(sName))
		{
			itTemp = DATASOURCE;
		}
		else if (GROUP.GetName().equals(sName))
		{
			itTemp = GROUP;
		}
		else if (PORTLET.GetName().equals(sName))
		{
			itTemp = PORTLET;
		}
		else if (COMMUNITY.GetName().equals(sName))
		{
			itTemp = COMMUNITY;
		}

		else if (AUTHSOURCE.GetName().equals(sName))
		{
			itTemp = AUTHSOURCE;
		}
		else if (COMMUNITY_TEMPLATE.GetName().equals(sName))
		{
			itTemp = COMMUNITY_TEMPLATE;
		}
		else if (DOCUMENT_TYPE.GetName().equals(sName))
		{
			itTemp = DOCUMENT_TYPE;
		}
		else if (FEDERATED_PORTAL.GetName().equals(sName))
		{
			itTemp = FEDERATED_PORTAL;
		}
		else if (FILTER.GetName().equals(sName))
		{
			itTemp = FILTER;
		}
		else if (JOB.GetName().equals(sName))
		{
			itTemp = JOB;
		}
		else if (PAGE_TEMPLATE.GetName().equals(sName))
		{
			itTemp = PAGE_TEMPLATE;
		}
		else if (PROPERTY.GetName().equals(sName))
		{
			itTemp = PROPERTY;
		}
		else if (PROPERTYMAP.GetName().equals(sName))
		{
			itTemp = PROPERTYMAP;
		}
		else if (SAVED_SEARCH.GetName().equals(sName))
		{
			itTemp = SAVED_SEARCH;
		}
		else if (SCHEDULE.GetName().equals(sName))
		{
			itTemp = SCHEDULE;
		}
		else if (SITE_MAP_FOLDER.GetName().equals(sName))
		{
			itTemp = SITE_MAP_FOLDER;
		}
		else if (SUBPORTAL.GetName().equals(sName))
		{
			itTemp = SUBPORTAL;
		}
		else if (USER_INTERFACE.GetName().equals(sName))
		{
			itTemp = USER_INTERFACE;
		}
		else if (WEB_SERVICE.GetName().equals(sName))
		{
			itTemp = WEB_SERVICE;
		}
		else if (INVITATION.GetName().equals(sName))
		{
			itTemp = INVITATION;
		}
		else if (PORTLET_BUNDLE.GetName().equals(sName))
		{
			itTemp = PORTLET_BUNDLE;
		}
		else if (REMOTE_SERVER.GetName().equals(sName))
		{
			itTemp = REMOTE_SERVER;
		}
		else if (PORTLET_TEMPLATE.GetName().equals(sName))
		{
			itTemp = PORTLET_TEMPLATE;
		}
		else if (ADMIN_FOLDER.GetName().equals(sName))
		{
			itTemp = ADMIN_FOLDER;
		}
		else if (DOCUMENT_FOLDER.GetName().equals(sName))
		{
			itTemp = DOCUMENT_FOLDER;
		}
		else if ( PROFILE_SOURCE.GetName().equals(sName))
		{
			itTemp = PROFILE_SOURCE;
		}
		else if ( EXTERNAL_OPERATION.GetName().equals(sName))
		{
			itTemp = EXTERNAL_OPERATION;
		}
		else if (PAGE.GetName().equals(sName))
		{
			itTemp = PAGE;
		}

		return itTemp;
	}

	/**
	 * 
	 *
	 * @return 
	 */
	public String ToString()
	{
		return sName;
	}
}

