package com.plumtree.portaluiinfrastructure.classtypedescriptors;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.friendlyurl.*;
import com.plumtree.uiinfrastructure.activityspace.*;

public interface IFriendlyURLManager {

	/**
	 * Returns the Opener redirect for this class type.
	 * 
	 * @param _fURLParser
	 * @param _asParent
	 * @param _userSession
	 * @return The redirect for this request.
	 */
	public Redirect GetFriendlyViewOpenerRedirect(IFriendlyURLParser _fURLParser,
			AActivitySpace _asParent, Object _userSession);
	
	/**
	 * Returns the friendly URL key for the particular class
	 * 
	 * @param _strClassId 	class id of the key that we want
	 * @return The friendly URL key
	 */
	public String LookupFriendlyURLKeyFromClassId(String _strClassId);
	
	/**
	 * Sets the lookup table in the Manager
	 * 
	 * @param htLookupTable		table of class Id to keyword mappings
	 */
	public void SetFriendlyURLLookupTable(XPHashtable htLookupTable);
	
	/**
	 * Returns the friendly URL using the FriendlyURL and AActivitySpace class provided.
	 * 
	 * @param url
	 * @param space
	 * @return The friendly URL
	 */
	public String ConstructFriendlyURL(FriendlyURL url, AActivitySpace space);
}
