package com.plumtree.portaluiinfrastructure.classtypedescriptors;

import com.plumtree.portaluiinfrastructure.classtypedescriptors.providerframework.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.opener.types.*;

public interface IPTClassTypeDescManager extends IClassTypeManager
{
	public String GetProviderEnglishNameForExistingObject(int _nClassID,
			int _nObjectID, IPTSession _ptSession);

	public String GetProviderEnglishNameGivenCLSID(String _sCLSID);

	/**
	 * Returns an array containing all the registered providers for a particular
	 * class.
	 *
	 * @param _nClassID The class ID of the type. (i.e. 38 for Crawler)
	 *
	 * @return An array containing all the registered providers for a class. If
	 *         there are none installed, you get back null.
	 */
	public IProvInfo[] GetRegisteredProvInfoForClassType(int _nClassID);

	/**
	 * Given the English name of a provider this passes back the ProvInfo
	 * descriptor.
	 *
	 * @param _strProvInfoEngName The provider English name.
	 *
	 * @return The ProvInfo class. Null if not found.
	 */
	public IProvInfo GetRegisteredProvInfoGivenEnglishName(
			String _strProvInfoEngName);
}