package com.plumtree.portaluiinfrastructure.classtypedescriptors;


// Framework Imports
import com.plumtree.openfoundation.util.IXPComparer;
import com.plumtree.openfoundation.util.XPException;
import com.plumtree.openfoundation.util.XPStringUtility;
import com.plumtree.openlog.OpenLogService;
import com.plumtree.openlog.OpenLogger;
import com.plumtree.portaluiinfrastructure.statichelpers.PTDebugHelpers;

/**
 * This is class is used to print out together the Views for
 * the object lock manager.
 *
 * @author John Hogan
 */
public class LockManagerObjectComparator implements IXPComparer {
    private static OpenLogger log = OpenLogService.GetLogger(
            OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_UI_INFRASTRUCTURE),
            "com.plumtree.portaluiinfrastructure.classtypedescriptors.classframework.ClassTypeComparator");

    
    private String m_strLangID;

    /**
     * Creates a new LockManagerObjectComparator object.
     *
     * @param _strLangID 
     */
    public LockManagerObjectComparator(String _strLangID) {
        m_strLangID = _strLangID;
    }

    /**
     * 
     *
     * @param _obj1 
     * @param _obj2 
     *
     * @return 
     */
    public int Compare(Object _obj1, Object _obj2) {
        IPTClassTypeDesc obj1 = (IPTClassTypeDesc) _obj1;
        IPTClassTypeDesc obj2 = (IPTClassTypeDesc) _obj2;

        String strLocalizedName1;
        String strLocalizedName2;

        try {
            strLocalizedName1 = obj1.GetObjectLockManagerLocalizedName(m_strLangID);
            strLocalizedName2 = obj2.GetObjectLockManagerLocalizedName(m_strLangID);
        } catch (Exception e) {
            strLocalizedName1 = null;
            strLocalizedName2 = null;
        }

        if (strLocalizedName1 == null || strLocalizedName2 == null) {
            log.Fatal("The creation of the  page navigation links failed for Object Lock manager. This is usually due to non-existent string resource file for class type descriptors");
            throw new XPException("The creation of the  page navigation links failed for Object Lock manager. This is usually due to non-existent string resource file for class type descriptors");
        }
        return XPStringUtility.Compare(strLocalizedName1,strLocalizedName2);
    }

    /**
     * 
     *
     * @param _obj1 
     * @param _obj2 
     *
     * @return 
     */
    public int compare(Object _obj1, Object _obj2) {
        return Compare(_obj1, _obj2);
    }
}

