package com.plumtree.portaluiinfrastructure.classtypedescriptors.classtypes;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.classtypedescriptors.*;
import com.plumtree.portaluiinfrastructure.friendlyurl.*;
import com.plumtree.portaluiinfrastructure.opener.plugins.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.server.*;
import com.plumtree.server.marshalers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.application.*;
import com.plumtree.uiinfrastructure.application.varpacks.*;
import com.plumtree.uiinfrastructure.htmlconstructs.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.web.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author michaeld
 */
public class PTMyPages extends APTNonExtClassTypeDesc
{
	public static final String MYPAGE_AS_NAME = "MyPage";	
	public static final String MYPAGE_CONTROL_NAME = "SetPage";	
	public static final String STR_PAGE_ID = "PageID";
	public static final String EDITPAGE_AS_NAME = "EditMyPortalPage";
	public static final String EDITPAGE_CONTROL_NAME = "EditorStart";
	public static final String STR_OPENERPAGE_ID = "OpenerPageID";
	public static final String STR_OPENERCONTAINER_ID = "OpenerCommunityID";
	public static final String STR_EDITORTYPE_ID = "editorType";
	public static final String STR_CREATE_MYPAGE = "CreateMyPage";

	private static OpenLogger log = OpenLogService.GetLogger(
			OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_UI_INFRASTRUCTURE),
			"com.plumtree.portaluiinfrastructure.classtypedescriptors.classtypes.PTMyPages");
	
	private static OpenLogger fulog = OpenLogService.GetLogger(
			OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_FRIENDLYURL),
			"com.plumtree.portaluiinfrastructure.classtypedescriptors.classtypes.PTMyPages");
	/**
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.APTNonExtClassTypeDesc#GetASNameForEditor()
	 */
	public String GetASNameForEditor()
	{
		return null;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IPTClassTypeDesc#AppearsInMainCreateNewClassMenu()
	 */
	public boolean AppearsInMainCreateNewClassMenu()
	{
		return false;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IPTClassTypeDesc#GetClassID()
	 */
	public int GetClassID()
	{
		return PT_CLASSIDS.PT_MYPAGESCONTAINER_ID;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IPTClassTypeDesc#GetClassTypeLocalizedName(java.lang.String)
	 */
	public String GetClassTypeLocalizedName(String _strLangID)
	{
		IApplication application = ApplicationManager.GetInstance()
			.GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		XPResourceManager rm = (XPResourceManager) application.GetCachingManager()
			.GetEntry("ResourceManager");

		return rm.GetString(506, "ptmsgs_portalinfrastructure", _strLangID);
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.APTClassTypeDesc#GetCreateActivityID()
	 */
	public int GetCreateActivityID()
	{
		return 0;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IPTClassTypeDesc#GetDefaultIcon()
	 */
	public HTMLImg GetDefaultIcon()
	{
		try
		{
			HTMLImg imgIcon = (HTMLImg) UIConstructFactory.GetConstruct(
				PTImageType.ICON_MYPAGE).GetHTMLElement();

			return imgIcon;
		}
		catch (Exception e)
		{
			return null;
		}
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IPTClassTypeDesc#GetRelatedClassTypeIDs()
	 */
	public int[] GetRelatedClassTypeIDs()
	{
		return null;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IPTClassTypeDesc#HasGlobalClassTypeMap()
	 */
	public boolean HasGlobalClassTypeMap()
	{
		return false;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetRedirectCreateNew(com.plumtree.openfoundation.util.XPHashtable, com.plumtree.uiinfrastructure.activityspace.AActivitySpace, com.plumtree.server.IPTSession)
	 */
	public Redirect GetRedirectCreateNew(XPHashtable _htArguments, AActivitySpace _asParent, Object _userSession)
	{
		Redirect resultingRedirect = new Redirect();

		resultingRedirect.SetLinkCreateNewSpace(EDITPAGE_AS_NAME, _asParent);
		resultingRedirect.SetControl(EDITPAGE_CONTROL_NAME);
		resultingRedirect.AddControlArgument(STR_CREATE_MYPAGE, true);
		resultingRedirect.AddControlArgument(STR_EDITORTYPE_ID, 10);

		return resultingRedirect;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetRedirectOpenObject(com.plumtree.openfoundation.util.XPHashtable, com.plumtree.uiinfrastructure.activityspace.AActivitySpace, com.plumtree.server.IPTSession)
	 */
	public Redirect GetRedirectOpenObject(XPHashtable _htArguments, AActivitySpace _asParent, Object _userSession)
	{
		// if user is a guest user
		ISessionManager sessionMan = _asParent.GetSubSession();
		Object sesValid		   = sessionMan.GetAttribute(Interpreter.USERSESSIONVALID);
		boolean bIsGuest = false;
		if (sesValid == null)
		{
			bIsGuest = false;
		}
		else
		{
			bIsGuest = !XPConvert.ToBoolean(sesValid);
		}
		
		if (bIsGuest)
		{
			return GetRedirectViewObject(_htArguments, _asParent, _userSession);
		}

		int nPageID = HTTPHelpers.GetArgumentAsInt(_htArguments, STR_PAGE_ID, 0);

		Redirect resultingRedirect = new Redirect();

		resultingRedirect.SetLinkCreateNewSpace(EDITPAGE_AS_NAME, _asParent);
		resultingRedirect.SetControl(EDITPAGE_CONTROL_NAME);
		resultingRedirect.AddControlArgument(STR_OPENERPAGE_ID, nPageID);
		resultingRedirect.AddControlArgument(STR_EDITORTYPE_ID, 10);

		return resultingRedirect;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.IClassTypeDesc#GetRedirectViewObject(com.plumtree.openfoundation.util.XPHashtable, com.plumtree.uiinfrastructure.activityspace.AActivitySpace, com.plumtree.server.IPTSession)
	 */
	public Redirect GetRedirectViewObject(XPHashtable _htArguments, AActivitySpace _asParent, Object _userSession)
	{
		Redirect resultingRedirect = new Redirect();

		int nPageID = HTTPHelpers.GetArgumentAsInt(_htArguments, STR_PAGE_ID, 0);

		// in view mode, we go to the community.
		resultingRedirect.SetLinkCreateNewSpace(MYPAGE_AS_NAME, _asParent);
		resultingRedirect.SetControl(MYPAGE_CONTROL_NAME);
		resultingRedirect.AddControlArgument(STR_PAGE_ID, nPageID);
		resultingRedirect.SetStripParentSpace(true);

		return resultingRedirect;
	}
	
	
	/**
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.classframework.IPTClassTypeDesc#GetRedirectViewObject()
	 * 
	 */
	public Redirect GetRedirectViewObject(IFriendlyURLParser _fURLParser, AActivitySpace _asParent, Object _userSession)
	{
		Redirect resultingRedirect = new Redirect();
		// DCA - used cached version if available in case it's a repost
		resultingRedirect.SetLinkGetSpaceIfCached(MYPAGE_AS_NAME, _asParent);
		resultingRedirect.SetControl(MYPAGE_CONTROL_NAME);
		
		int nMyPageId 		= _fURLParser.GetObjectId();
		String strMypageName = _fURLParser.GetObjectName(true);
		IPTSessionInfo sinfo = ((IPTSession) _userSession).GetSessionInfo();
		IPTQueryResult qRes =   sinfo.GetCurrentMyPages();

		if ( nMyPageId == 0 ) {
			for( int i =0; i < qRes.RowCount(); i++){
				String curPageName = qRes.ItemAsString(i, PT_PROPIDS.PT_PROPID_NAME);
				if (strMypageName.equalsIgnoreCase( FriendlyURL.DeNormalizeObjectName(curPageName) )) {
					nMyPageId = qRes.ItemAsInt(i, PT_PROPIDS.PT_PROPID_OBJECTID);
					break;
				}
			}
		}
				
		if(nMyPageId > 0){
			fulog.Debug("PTMyPages:GetRedirectViewObject Redirecting to my page with Id: " + nMyPageId );
			resultingRedirect.AddControlArgument(STR_PAGE_ID, nMyPageId);
		} else {
			fulog.Info("No MyPage found with name \""+strMypageName+"\" for user with id: "+sinfo.GetCurrentUserID());
			throw new PTException("An error occured while trying to parse the request. Check that the URL is valid.", PT_RESULTCODES.PT_E_FAIL);
		}
				
		return resultingRedirect;
	}
	
	/**
	 * 
	 * @see IPTClassTypeDesc#ConstructFriendlyURL(String, int, String)
	 * 
	 * Generates a friendly Url for user mypages
	 */	
	public String ConstructFriendlyURL(FriendlyURL url, AActivitySpace space)
	{		
		String pageName = url.GetOjectName();
		int pageId = url.GetObjectId();

		XPStringBuilder buf = new XPStringBuilder(200);		
		if ( ("".equals(pageName) || pageName == null) && pageId < 0 ) { 
			throw new PTException("Both page name and id are missing. At least one needs to be specified to create a friendly Url.", PT_RESULTCODES.PT_E_INVALIDARGUMENT); }
		
		IApplication application = ApplicationManager.GetInstance().GetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString());
		IFriendlyURLManager ptFriendlyURLMgr = (IFriendlyURLManager) application.GetCachingManager().GetEntry(AppWarmUp.KEY_CACHEMAN_CLASS_TYPE_MANAGER);
		String pageKeyword = ptFriendlyURLMgr.LookupFriendlyURLKeyFromClassId(PT_CLASSIDS.PT_MYPAGESCONTAINER_ID+"");

		if ( pageKeyword == null ) {
			throw new PTException("No Friendly URL keyword was found for my pages. "+
					"Verify that a mapping entry exists in FriendlyURL.xml.", PT_RESULTCODES.PT_E_FAIL);
		}
		buf.Append("/").Append(pageKeyword);
		
		// looking up pageName if only pageid is given and FriendlyURL returns pagename as null or ""
		if ( ("".equals(pageName) || pageName == null) ) {
			
			IPTSessionInfo sinfo = ((IPTSession) space.GetUserSession()).GetSessionInfo();
			IPTQueryResult qRes =   sinfo.GetCurrentMyPages();
			
			if (pageId > 0) {
				for( int i =0; i < qRes.RowCount(); i++){
					if (pageId == qRes.ItemAsInt(i, PT_PROPIDS.PT_PROPID_OBJECTID)){
						pageName = qRes.ItemAsString(i, PT_PROPIDS.PT_PROPID_NAME);
						break;
					}
				}			
			} else {
				pageName = qRes.ItemAsString(0, PT_PROPIDS.PT_PROPID_NAME);
			}
		}
		
		if(pageName == null ){
			throw new PTException("Unable to look up page with id " + pageId + ".",  PT_RESULTCODES.PT_E_FAIL);
		}
		String normPageName = FriendlyURL.NormalizeObjectName(pageName);
		// DCA - we're encoding in case it has non-ASCII chars
		normPageName = XPHttpUtility.UrlEncode(normPageName, LinkConstants.UTF_8_ENCODING);
		buf.Append("/").Append(normPageName);
		
		if ( FriendlyURLPlugin.UseObjectId() ) {
			buf.Append("/").Append(pageId);
		}
		
		return buf.ToString();
	}

	
	/* (non-Javadoc)
	 * @see com.plumtree.portaluiinfrastructure.classtypedescriptors.classframework.IPTClassTypeDesc#GetRedirectViewObjectMetaData(com.plumtree.openfoundation.util.XPHashtable, com.plumtree.uiinfrastructure.activityspace.AActivitySpace, com.plumtree.server.IPTSession)
	 */
	public Redirect GetRedirectViewObjectMetaData(XPHashtable _htArguments,
		AActivitySpace _asParent, Object _userSession)
	{
	    return GetRedirectViewObject(_htArguments, _asParent, _userSession);
	}

}
