package com.plumtree.portaluiinfrastructure.classtypedescriptors.providerframework;

import com.plumtree.server.*;

/**
 * 
 *
 * @author John Osborne
 */
public interface IProvInfo
{
	/**
	 * Returns a boolean that tells the client if this provider 
	 * should appear in the main create new object menu.
	 *
	 * @param IPTSession the current user session.
	 * @return A boolean that tells the client if this provider 
	 * type should appear in the main create new object menu.
	 */
	public boolean AppearsInMainCreateNewClassMenu(IPTSession _session);

	/**
	 * 
	 *
	 * @return 
	 */
	public int[] GetArrayOfClassIDsRelatedTo();

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetBinFileName();

	/**
	 * 
	 *
	 * @param _strLangID 
	 * @param __nClassID 
	 *
	 * @return 
	 */
	public String GetProviderAndClassLocalizedName(String _strLangID,
		int _nClassID);

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetProviderCLSID();

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetProviderEnglishName();

	/**
	 * 
	 *
	 * @param _strLangID 
	 *
	 * @return 
	 */
	public String GetProviderLocalizedName(String _strLangID);

	/**
	 * 
	 *
	 * @param _nClassIDToCreate 
	 *
	 * @return 
	 */
	public ClassIDProvCLSIDPair RequiresObjectChoiceOnStart(
		int _nClassIDToCreate);
}

