package com.plumtree.portaluiinfrastructure.compoundlist;


/**
 * Iterator Interface for Compoundlist 
 * 
 * @author robertz
 */
public interface ICPListEntryIterator
{
	/**
	 * Gets the current entry. Doesn't advance the iterator
	 *
	 * @return Current entry
	 */
	public ListEntry GetEntry();

	/**
	 * Gets the entry at a specified entry
	 *
	 * @param nIndex Index of the entry
	 *
	 * @return Entry at the specified index
	 */
	public ListEntry GetEntryAtIndex(int nIndex);

	/**
	 * Resets the iterator
	 */
	public void GetIterator();

	/**
	 * Gets the amount of entries in the list
	 *
	 * @return Number of entries in the list
	 */
	public int GetTotalCount();

	/**
	 * Advance the iterator to next entry.
	 *
	 * @return false if no more entries, otherwise true.
	 */
	public boolean Next();
}

