package com.plumtree.portaluiinfrastructure.editor;


// Plumtree Server Imports
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.editor.*;

/**
 * This is the interface for the read-only Model. This interface is implemented
 * by ObjEditorModel. Any read-only Model interface should extend this one.
 *
 * @author Julie Fournier
 */
public interface IObjEditorModelRO extends IEditorModelRO
{
	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.ObjEditorModel#GetClassID()
	 *
	 */
	public int GetClassID();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.ObjEditorModel#GetObject()
	 *
	 */
	public IPTObject GetObject();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.ObjEditorModel#GetObjectDescription()
	 *
	 */
	public String GetObjectDescription();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.ObjEditorModel#GetObjectID()
	 *
	 */
	public int GetObjectID();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.ObjEditorModel#GetObjectName()
	 *
	 */
	public String GetObjectName();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.ObjEditorModel#GetPTSession()
	 *
	 */
	public IPTSession GetPTSession();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.ObjEditorModel#GetParentFolderPath()
	 *
	 */
	public String GetParentFolderPath();
}

