package com.plumtree.portaluiinfrastructure.editor;


// Framework imports
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This is the DP for the dependencies page. It's the
 * last page of the save pop-up and has a confirmation
 * message and some links to create other objects that
 * depend on the one that was just created.
 *
 * @author Julie Fournier
 */
public class ObjDependenciesDP extends AFormDP
{
	/**
	 * Class name for the activity space
	 */
	public static final String STR_MVC_CLASS_NAME = "ObjDependencies";

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()
	 */
	public String GetFormTitle()
	{
		return m_asOwner.GetString(127, "ptmsgs_portalinfrastructure");
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()

	{
		return m_asOwner.GetView(((ObjEditorAS) m_asOwner).GetDependenciesViewName())
		.Display();
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();
		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
				((ObjEditorAS) m_asOwner).GetDependenciesViewName())
			.DisplayJavascript());

		return myScripts;
	}
}

