package com.plumtree.portaluiinfrastructure.editor;

import com.plumtree.portaluiinfrastructure.opener.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This is the Activity Space class for the ObjEditor Framework.
 * Editor Activity Space classes should extend this class.
 *
 * @author Julie Fournier
 */
public abstract class PTEditorAS extends EditorAS
{
	/**
	 * @see com.plumtree.uiinfrastructure.form.IFormAS#DisplayCommonJavaScript()
	 */
	public HTMLScriptCollection DisplayCommonJavaScript()

	{
		HTMLScriptCollection scripts = super.DisplayCommonJavaScript();

		// Add common object opener javascript
		scripts.AddInnerHTMLElement(PTOpenerLinks.GetOpenerJavascript(this));

		return scripts;
	}

	/**
	 * Returns the class name of the Editor Repost Control.
	 *
	 * Editors should also implement that method and return
	 * the name of their own repost  control, unless they
	 * don't have any. In that case they don't need to implement
	 * the method and EditorRepostControl will be used by default.
	 *
	 * @return String
	 */
	public String GetRepostControlName()
	{
		return (EditorRepostControl.STR_MVC_CLASS_NAME);
	}
}

