package com.plumtree.portaluiinfrastructure.editor.commonpages.keywords;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.arraywrapper.*;
import com.plumtree.uiinfrastructure.expandablelist.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author michaeld
 */
public class KeywordsView extends ExpListView
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_UI_INFRASTRUCTURE),
		"com.plumtree.portaluiinfrastructure.editor.commonpages.keywords.KeywordsView");

	/** Class name for the activity space */
	public static final String STR_MVC_CLASS_NAME = "Keywords";

	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.ExpListView#GetHTMLForRow(com.plumtree.uiinfrastructure.arraywrapper.IPTGrowableSortedArrayWrapperRO, int)
	 */
	public HTMLElement GetHTMLForRow(
		IPTGrowableSortedArrayWrapperRO _saData,
		int _nRowIndex)
	{
		//MES- Get the data for the row
		String sKeyword = (String) _saData.GetItem(_nRowIndex, KeywordsModel.KEYWORDSMODEL_COL_KEYWORD);
		String sURL = (String) _saData.GetItem(_nRowIndex, KeywordsModel.KEYWORDSMODEL_COL_URL);

		HTMLElementCollection myRow = new HTMLElementCollection();

		HTMLTableCell myCell;

		//MJD- Add the keyword
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetHeight("30");
		myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
		myCell.SetNoWrap(true);
		myCell.AddInnerHTMLString(CommonHTMLStrings.SPACE);
		myCell.AddInnerHTMLEncodedString(sKeyword);

		//MJD- Next column is url	
		myCell = new HTMLTableCell();
		myRow.AddInnerHTMLElement(myCell);
		myCell.SetWidth(CommonHTMLStrings.ONE_HUNDRED_PERCENT);
		myCell.SetStyleClass(PTStyleClass.LIST_TEXT);
		myCell.SetNoWrap(true);

		//MJD- The anchor to open keyword URL
		HTMLAnchor myAnchor = new HTMLAnchor(ConstructStaticHelpers.BLANK_URL);
		myAnchor.SetOnClick(ConstructStaticHelpers.BLANK_URL);
		// TODO-MJD : does there need to be some kind of encoding on this URL?
		myAnchor.SetOnClick("window.open('" + sURL + "'); return false;");
		myAnchor.AddInnerHTMLEncodedString(sURL);

		myCell.AddInnerHTMLElement(myAnchor);

		return myRow;
	}

	/**
	 * No Action Bar for keywords
	 */
	protected HTMLTable GetHTMLForActionBar()
	{
		return null;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new KeywordsView();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

}
