package com.plumtree.portaluiinfrastructure.editor.commonpages.localizednames;

import com.plumtree.uiinfrastructure.expandablelist.*;
import com.plumtree.xpshared.htmlconstructs.*;

/**
 * This interface is implemented by the Model. It contains all the read-only
 * methods of the Model accessed by the Views.
 *
 * @author MichaelS
 */
public interface ILocNamesModelRO extends IExpListModelRO
{
	/**
	 * @see com.plumtree.uiinfrastructure.expandablelist.GrowableListModel#GetRowIcon()
	 */
	public PTImageType GetRowIcon();

	/**
	 * @return Name label
	 */
	public String GetNameLabel();
	
	/**
	 * @return boolean - No Descriptions
	 */
	public boolean IsNoDescriptions();
	
	/**
	 * @return Name of Pop Up Display Page
	 */
	public String GetPopUpDisplayPageName();

	/**
	 * 
	 *
	 * @return 
	 */
	public int GetClassID();

	/**
	 * 
	 *
	 * @return 
	 */
	public int GetObjectID();

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetObjectUUID();

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetPrimaryName();

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetPrimaryDesc();

	/**
	 * 
	 *
	 * @return 
	 */
	public String GetPrimaryLang();

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean GetIsLocalized();

	/**
	 * 
	 *
	 * @return 
	 */
	public int GetRowToEdit();

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean SupportsLocalization();

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean HasMandatoryLang();
	
	/**
	 * 
	 *
	 * @return 
	 */
	public boolean IsUsingMaxNameOverride();
	
	/**
	 * 
	 *
	 * @return 
	 */
	public int GetMaxNameOverride();	
}

