package com.plumtree.portaluiinfrastructure.editor.commonpages.localizednames;


// Framework Imports
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * MES- The LocNamesPopUpDP class is a Display Page for the Localized Names
 * popup.  The popup is used to edit the name and description for a given
 * language, or add a new name/description.
 *
 * @version 1.0
 * @author MichaelS
 */
public class LocNamesPopUpDP extends AFormDP
{
	/** MES- The name of this object */
	public static final String STR_MVC_CLASS_NAME = "LocNamesPopUp";

	/**
	 * Returns the String to display on the left navigation menu,  linking to
	 * that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		// JF- This is not used here.
		return "";
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
	
	
	/**
	 * Returns the title for the form
	 *
	 * @return String
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#GetFormTitle()
	 */
	public String GetFormTitle()
	{
		//MES- Localized Name and Description
		return m_asOwner.GetString(428, "ptmsgs_portalinfrastructure");
	}
	
	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormPageType()
	 */
	public FormPageTypes GetFormPageType()
	{
		return FormPageTypes.NO_BUTTONS;
	}
	
	

	/**
	 * Returns the HTML for that Page.
	 *
	 * @return HTMLElement
	 *
	 * @throws HTMLException
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()
	{
		//MES- Just ask the popup view to write itself
		HTMLElementCollection result = new HTMLElementCollection();
		result.AddInnerHTMLElement(((IView) m_asOwner.GetView(
				LocNamesPopUpView.STR_MVC_CLASS_NAME)).Display());

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 *
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		//MES- Ask the superclass if it's got anything.
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		//MES- And ask the popup view if it's got anything
		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
				LocNamesPopUpView.STR_MVC_CLASS_NAME).DisplayJavascript());

		return myScripts;
	}
}

