package com.plumtree.portaluiinfrastructure.editor.commonpages.migrationhistory;

import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * Interface used to retrieve migration status of an object
 * in an editor.
 *
 * @version $Revision$
 * @author ArvindS
 */
public interface IMigrationHistoryModelRO extends IModelRO
{
	/**
	 * Retrieves the current migration status of the underlying PTObject.
	 *
	 */
	public int GetCurrentMigrationStatus();

	/**
	 * Retrieves the history item at the index specified by _nIndex
	 *
	 */
	public MigrationHistoryItem GetHistoryItem(int _nIndex);

	/**
	 * Returns the number of items in the history for the underlying PTObject.
	 *
	 */
	public int GetNumHistoryItems();

	/**
	 * Retrieves the flag indicating whether or not we are being
	 * hosted by another activity space, or our own.
	 */
	public boolean IsStandalone();
	
	/**
	 * Retrieves the flag indicating whether or not to display
	 * the approval checkbox (currently only for full sysadmins)
	 */
	public boolean ShouldDisplayApproval();
	
	/**
	 * Retrieves the flag indicating whether the checkbox has
	 * been checked in this editor session.
	 */
	public boolean IsMigrationCheckboxChecked();
	
}

