package com.plumtree.portaluiinfrastructure.editor.commonpages.migrationhistory;

import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;


/**
 * Plugin page used by object editors to display migration history and status.
 * 
 * @version $Revision$
 * @author ArvindS
 */
public class MigrationHistoryPluginDP extends EditorDP {
	/** The name of this display page */
	public static final String STR_MVC_CLASS_NAME = "MigrationHistoryPlugin";

	/**
	 * Returns the string used in the left nav link of the editor for this page.
	 *
	 * @return The left nav link name for this page.
	 */
	public String GetLeftNavString() {

		return m_asOwner.GetString(71, "ptmsgs_portalinfrastructure");
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader() {
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(269, "ptmsgs_portalinfrastructure"),
			this.m_asOwner);
	}

	/** The page title */



	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.IDisplayPage#GetName()
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Displays the page
	 *
	 */
	public HTMLElement PageDisplay() {
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		views.AddInnerHTMLElement(
			((EditorView) m_asOwner
				.GetView(MigrationHistoryView.STR_MVC_CLASS_NAME))
				.Display());

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}
}

