package com.plumtree.portaluiinfrastructure.editor.commonpages.objectproperties;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.portaluiinfrastructure.editor.*;

/**
 * Activity space for browsing object properties
 *
 * @author josephc
 */
public class ObjPropEditorAS extends ObjEditorAS
{
	/** Class name for ObjPropEditorAS */
	public static final String STR_MVC_CLASS_NAME = "ObjPropEditor";


	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new ObjPropEditorAS();
	}

	/**
	 * Sets the Editor title.
	 *
	 * @return Editor title
	 */
	public String GetEditorTitle()
	{
		return XPResourceManager.FormatMessage(GetString(279, "ptmsgs_portalinfrastructure"), GetObjectName());
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Registers all the classes for this Activity Space.
	 */
	public void Init()
	{
		m_strModelName = ObjPropEditorModel.STR_MVC_CLASS_NAME;

		super.Init();

		// Register Plug-In: Browse Object Properties
		RegisterView(ObjPropBrowseView.STR_MVC_CLASS_NAME, GetModel(ObjPropModel.STR_MVC_CLASS_NAME));
		RegisterPage(new ObjPropBrowseDP());
	}
}

