package com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity;

// Framework Imports
import com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.*;

/**
 * This interface is implemented by the Model.
 * It contains all the read-only mothods of the Model
 * accessed by the Views.
 *
 * @author Julie Fournier
 */
public interface IObjectSecurityModelRO extends ISelectPTObjectModelRO
{
	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.ObjectSecurityModel#GetAccessLevelString()
	 *
	 */
	public String GetAccessLevelString(int _nAccessLevelID);

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.ObjectSecurityModel#GetAccessLevels()
	 *
	 */
	public int[] GetAccessLevels();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.ObjectSecurityModel#GetLeftNavString()
	 *
	 */
	public String GetLeftNavString();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.ObjectSecurityModel#GetShowHeaderAndLeftNav()
	 *
	 */
	public boolean GetShowHeaderAndLeftNav();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.ObjectSecurityModel#GetSupportMandatoryColumn()
	 *
	 */
	public int GetSupportMandatoryColumn();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.ObjectSecurityModel#HasEditAccessToGroup()
	 *
	 */
	public boolean HasEditAccessToGroup(int _nGroupID);
	
	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.ObjectSecurityModel#GetIsCardACL()
	 *
	 */
	public boolean GetIsCardACL();
	
	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.ObjectSecurityModel#IsEveryoneGroup()
	 *
	 */
	public boolean IsEveryoneGroup(int _nRowIndex);

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.ObjectSecurityModel#DisplayGroupMembersTree()
	 *
	 */	
	public boolean DisplayGroupMembersTree(int _nGroupID);
}

