package com.plumtree.portaluiinfrastructure.editor.saveobject;

// Framework imports
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This interface is implemented by the Model.
 * It contains all the read-only mothods of the Model
 * accessed by the Views.
 *
 * @author Julie Fournier
 */
public interface ISaveObjectModelRO extends IModelRO
{
	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#ForceSaveInFolder()
	 *
	 */
	public boolean ForceSaveInFolder();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetAdminFolderID()
	 *
	 */
	public int GetAdminFolderID();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetCurrentTab()
	 *
	 */
	public int GetCurrentTab();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetFolderName()
	 *
	 */
	public String GetFolderName();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetObjectDescription()
	 *
	 */
	public String GetObjectDescription();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetObjectName()
	 *
	 */
	public String GetObjectName();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetRecentlyUsedFolders()
	 *
	 */
	public Object[][] GetRecentlyUsedFolders();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetRepostBodyFromBottomFrame()
	 *
	 */
	public boolean GetRepostBodyFromBottomFrame();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetRepostBodyFromTopFrame()
	 *
	 */
	public boolean GetRepostBodyFromTopFrame();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetRepostTreeAndSave()
	 *
	 */
	public boolean GetRepostTreeAndSave();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetRepostTreeRecentFoldersFrame()
	 *
	 */
	public boolean GetRepostTreeRecentFoldersFrame();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#GetTitle()
	 *
	 */
	public String GetTitle();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#HideSecurityTab()
	 *
	 */
	public boolean HideSecurityTab();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#IsAdminFolderInRecentFolders()
	 *
	 */
	public boolean IsAdminFolderInRecentFolders(int _nFolderID);

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#IsMigrationApproved()
	 *
	 */
	public boolean IsMigrationApproved();

	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#IsSysAdmin()
	 *
	 */
	public boolean IsSysAdmin();
	
	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#IsDescriptionDisabled()
	 *
	 */
	public boolean IsDescriptionDisabled();
	
	/**
	 * @see com.plumtree.portaluiinfrastructure.editor.saveobject.SaveObjectModel#IsCurrentObjectCommunity()
	 *
	 */
	public boolean IsCurrentObjectCommunity();
}

