package com.plumtree.portaluiinfrastructure.editor.saveobject;

// Framework imports
import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This is the DP for the Bottom frame.
 * It displays the name and description Section.
 * This DP is displayed by the Main Frame DP: SaveObjectMainFrameDP.
 *
 * @author Julie Fournier
 */
public class SaveObjectTopFrameDP extends AFormDP
{
	/**
	 * Class name for the activity space
	 */
	public static final String STR_MVC_CLASS_NAME = "SaveObjectTopFrame";

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()
	 */
	public String GetFormTitle()
	{
		// JF- This DP in inside a frame. No need to set the form title here.
		return "";
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()

	{
		return m_asOwner.GetView(SaveObjectMenuView.STR_MVC_CLASS_NAME).Display();
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();
		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
				SaveObjectMenuView.STR_MVC_CLASS_NAME).DisplayJavascript());

		return myScripts;
	}
}

