package com.plumtree.portaluiinfrastructure.expandablelist.selectptobject;


// Framework Imports
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.expandablelist.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This interface is implemented by the Model.
 * It contains all the read-only mothods of the Model
 * accessed by the Views.
 *
 * @author Julie Fournier
 */
public interface ISelectPTObjectModelRO extends IExpListModelRO
{
	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetAccessLevel()
	 *
	 */
	public int GetAccessLevel();

	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetCommunityMode()
	 *
	 */
	public int GetCommunityMode();

	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetCommunityFolderID()
	 *
	 */
	public int GetCommunityFolderID();

	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetCreateNewInfo()
	 *
	 */
	public Object[][] GetCreateNewInfo();

	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetCreateNewURL()
	 *
	 */
	public ASURL GetCreateNewURL(int _nClassID, String _sEditorASName);

	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetEditObjectURL()
	 *
	 */
	public ASURL GetEditObjectURL(int _nClassID, int _nObjectID);


	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#ClearHiddenObjects()
	 *
	 */
	public void ClearHiddenObjects();

	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetHiddenObjects()
	 *
	 */
	public String GetHiddenObjects();

	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetObjectClassIDs()
	 *
	 */
	public String GetObjectClassIDs();

	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetRowIcon()
	 *
	 */
	public PTImageType GetDefaultRowIcon();

	/**
	 * Returns the value of the m_bNoRowIcons member variable.  True if no
	 * icons are to be displayed on each selected row.
	 *
	 * @return boolean
	 */
	public boolean GetNoRowIcons();
	
	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetRowIconByClassID()
	 *
	 */
	public PTImageType GetRowIconByClassID(int _nClassID);

	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetSelectedItems()
	 *
	 */
	public String GetSelectedItems();

	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetSelectedNamesAsHTML()
	 *
	 */
	public HTMLElementCollection GetSelectedNamesAsHTML()
		throws HTMLException;

	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetTreeLeafType()
	 *
	 */
	public int GetTreeLeafType();

	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetTreeMultiSelect()
	 *
	 */
	public String GetTreeMultiSelect();

	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetTreeQueryFilter()
	 *
	 */
	public String GetTreeQueryFilter();

	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetTreeSpaceID()
	 *
	 */
	public String GetTreeSpaceID();

	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetTreeSubTitle()
	 *
	 */
	public String GetTreeSubTitle();

	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetTreeTitle()
	 *
	 */
	public String GetTreeTitle();

	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#IsEditLinkEnabled()
	 *
	 */
	public boolean IsEditLinkEnabled(int _nClassID);
	
	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetDisplayObjects()
	 *
	 */
	public String GetDisplayObjects();
	
	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#IsObjectReadOnly()
	 *
	 */
	public boolean IsObjectReadOnly(int _nClassID, int _nObjectID);
	
	/**
	 * @see com.plumtree.portaluiinfrastructure.expandablelist.selectptobject.SelectPTObjectModel#GetUniquePopUpName()
	 *
	 */
	public String GetUniquePopUpName(String _sName);
}

