package com.plumtree.portaluiinfrastructure.failover;

import com.plumtree.openfoundation.util.*;

import com.plumtree.openkernel.sharedcache.*;

/**
 * DOCUMENT_ME
 * 
 * @author ErickS, JosephC
 */
public class CleanupCache implements IXPRunnable
{
	private IOKSharedCache m_sharedCache;
	
	/**
	 * Creates a new CleanupCache object.
	 *
	 * @param sharedCache DOCUMENT_ME
	 */
	public CleanupCache(IOKSharedCache sharedCache)
	{
		m_sharedCache = sharedCache;
	}

	/**
	 * DOCUMENT_ME
	 */
	public void run()
	{
		XPArrayList arrToDelete = new XPArrayList();

		synchronized (m_sharedCache)
		{
			IXPEnumerator xpKeys = m_sharedCache.GetKeys();

			while (xpKeys.MoveNext())
			{
				String replicationToken = (String) xpKeys.GetCurrent();
				XPDateTime lastModified = ReplicationCache.GetLastModified(replicationToken);
				
				if (lastModified != null)
				{
					// if dtLastModified >= CLEANUP_MINUTES, add it to the toDelete array
					if (ReplicationCache.IsExpired(lastModified, ReplicationCache.CLEANUP_MINUTES))
					{
						arrToDelete.Add(replicationToken);
					}
				}
			}
			
			// Perform cleanup after iteration is done.
			for (int i = 0; i < arrToDelete.GetSize(); i++)
			{
				String replicationToken = (String)arrToDelete.GetElement(i);
				ReplicationCache.Remove(replicationToken);
			}
		}
	}
}
