package com.plumtree.portaluiinfrastructure.filter;

import com.plumtree.portaluiinfrastructure.resultwrapper.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * @author CraigS, based on MikeS code
 */
public interface IFilterIteratorRO extends IModelRO
{
  /**
   *  Make a brand-new QueryCondition.
   */
	public QueryCondition MakeQueryCondition();

	/**
	 * Gets the depth of the current clause.
	 * @return the depth of the current clause.
	 */
	public int GetCurrentClauseDepth();

	/**
   *  Gets the operator (AND or OR) that joins the current clause together.
	 * @return the operator
	 */
	public boolean GetCurrentClauseOperator();

	/**
	 * Gets the filter's top-level search string.
	 * @return the search string
	 */
	public String GetTextSearchString();

	/**
	 * 
	 * @return 
	 */
	public boolean GetNextClausePosition();

	/**
	 * 
	 *
	 * @param qc 
	 *
	 * @return 
	 */
	public boolean GetNextStatementAndSetQC(QueryCondition qc);

	/**
	 * 
	 *
	 * @param qc 
	 *
	 * @return 
	 */
	public boolean AddSetProperty(QueryCondition qc);
	
	/**
	 * Convenience method to return the number of items in the first clause;
   * basically an easy way to see if this filter contains anything of interest
	 */
	public int GetNumItemsInFirstClause();

	/**
	 * Queries the database for the set of properties this user can see (on the
   * first call), returns a cached value on subsequent calls.
	 */
	public IASQueryResult GetPropertiesVisibleToCurrentUser();

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean GetTopLevelAllMustPass();

	/**
	 * Resets this iterator to the beginning.
	 */
	public void SetIteratorToStart();
}

