package com.plumtree.portaluiinfrastructure.friendlyurl;

import com.plumtree.openfoundation.util.*;

/**
 * Friendly URL parser specific to document URLs. Checks the URL for folder Id.
 * 
 * @author duang
 */
public class DocumentFriendlyURLParser extends FriendlyURLParser {

	public DocumentFriendlyURLParser(String strKeyword, String strClassId, XPStringTokenizer stURLTokens) {
		m_strKeyword = strKeyword;
		m_strClassId = strClassId;
		
		// /document_id/filename
		// /filename
		if (stURLTokens.HasMoreTokens()) {
			// DCA - this could the the document id or the filename
			String strTemp = stURLTokens.GetNextToken();
			for (int i=0; i<strTemp.length(); i++) {
				if (!XPCharacterUtility.IsASCIIDecimalDigit(strTemp.charAt(i))) {
					m_strObjectName = URLDecode(strTemp);
					break;
				}
			}
			if (null == m_strObjectName) {
				m_nObjectId = XPConvert.ToInteger(strTemp);
			}
		}
		if (stURLTokens.HasMoreTokens()) {
			// DCA - this has to be the filename
			String strFileName = stURLTokens.GetNextToken();
			m_strObjectName = URLDecode(strFileName);
		}
	}
}