package com.plumtree.portaluiinfrastructure.helpers;

import com.plumtree.portaluiinfrastructure.classtypedescriptors.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.helpers.*;
import com.plumtree.uiinfrastructure.web.*;

public interface IPTConfigHelper extends IConfigHelper
{
	/**
	 * Helper method to access an int variable from x_config.xml.
	 *
	 * @param strSection strSection
	 * @param strSubSection strSubSection
	 * @param strAttribute strAttribute
	 * @param space the current space
	 *
	 * @return int the requested variable
	 */
	public int GetConfigVariableAsInt(String strSection,
		String strSubSection, String strAttribute, AActivitySpace space);

	/**
	 * Helper method to access a String variable from x_config.xml.
	 *
	 * @param strSection strSection
	 * @param strSubSection strSubSection
	 * @param strAttribute strAttribute
	 * @param space the current space
	 *
	 * @return String the requested variable
	 */
	public String GetConfigVariableAsString(String strSection,
		String strSubSection, String strAttribute, AActivitySpace space);

	/**
	 * Helper method to access a String variable from x_config.xml.
	 *
	 * @param strSection strSection
	 * @param strSubSection strSubSection
	 * @param strAttribute strAttribute
	 * @param application the current IApplication
	 *
	 * @return String the requested variable
	 */
	public String GetConfigVariableAsString(String strSection,
		String strSubSection, String strAttribute, IApplication app);

	/**
	 * Helper method to access a String variable from x_config.xml.
	 *
	 * @param strSection strSection
	 * @param strSubSection strSubSection
	 * @param strAttribute strAttribute
	 * @param space the current space
	 *
	 * @return String the requested variable
	 */
	public Object[] GetConfigVariables(String strSection,
		String strSubSection, String strAttribute, AActivitySpace space);

	/**
	 * Helper method to access a String variable from x_config.xml.
	 *
	 * @param strSection strSection
	 * @param strSubSection strSubSection
	 * @param strAttribute strAttribute
	 * @param space the current space
	 *
	 * @return String the requested variable
	 */
	public  Object[] GetConfigVariables(String strSection,
		String strSubSection, String strAttribute, IApplication application);
	
	/**
	 * Helper method to retrieve the ClassTypeDescrManager from the cache
	 * 
	 * @return IPTClassTypeDescManager
	 */
	public IPTClassTypeDescManager GetPTClassTypeDescrManager();

	/**
	 * @param _space The current Activity Space.
	 * @param _strRequestURL The current request URL.
	 * @return the absolute image server root URL.
	 */
	public String GetAbsoluteImageServerRootURL(AActivitySpace _space, String _strRequestURL);
	
	/**
	 * @param _space The current Activity Space.
	 * @param _strRequestURL The current request URL.
	 * @return the absolute image server base URL.
	 */
	public String GetAbsoluteImageServerBaseURL(AActivitySpace _space, String _strRequestURL);
	
	/**
	 * Checks whether the classId supports friendly URLs
	 * 
	 * @param classId
	 * @param queryStringArgs
	 * @return
	 */
	public boolean UseFriendlyURLS(int classId, String queryStringArgs);
}