package com.plumtree.portaluiinfrastructure.intrinsicportlets;

import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This interface contains all read-only methods that are common to intrinsic portlets.
 *
 * @author josephc
 */
public interface IIntrinsicPortletModelRO extends IModelRO
{
	/**
	 * Returns true if the portlet has a control associated with it. This
	 * method is used by the MyPortal view when dynamically registering views
	 * for intrinsic portlets.
	 *
	 * @return Returns true if portlet has control. Otherwise return false.
	 */
	public boolean ControlExists();

	/**
	 * Returns portlet ID
	 *
	 * @return Portlet ID
	 */
	public int GetPortletID();
}

