package com.plumtree.portaluiinfrastructure.intrinsicportlets.prefs;

import com.plumtree.uiinfrastructure.editor.*;

/**
 * This interface contains all read-only methods that are common to intrinsic
 * portlets pref pages.
 *
 * @author josephc
 */
public interface IIntrinsicPortletPrefsModelRO extends IEditorModelRO
{
	/**
	 * Get portlet name
	 *
	 * @return Portlet name
	 */
	public String GetPortletName();

	/**
	 * Returns the type of preference that is being requested.
	 *
	 * @return Preference type
	 */
	public int GetPrefType();
	
	/**
	 * Returns the community Id if the portlet is on a community
	 * @return community id
	 */
	public int GetCommunityId();
}

