package com.plumtree.portaluiinfrastructure.layout;

import com.plumtree.openfoundation.reflect.*;
import com.plumtree.portaluiinfrastructure.layout.impl.*;

public class LayoutFactory implements ILayoutFactory 
{
	/**
	 * To make sure people don't create LayoutFactories directly, we require
	 * a special key that only the LayoutService has.  Call LayoutService.getFactoryInstance()
	 * instead to get the Layout Factory.
	 * @param _oKey
	 */
	public LayoutFactory(Object _oKey)
	{
		if (!LayoutService.isValid(_oKey))
		{
			throw new XPIllegalAccessException("Layout Factory can only be created by the Layout Service. " +
				"Call LayoutService.getFactoryInstance() to access the Layout Factory.");
		}
	}

	public ILayoutDisplay CreateDisplay()
	{
		return new LayoutDisplay();
	}
}