package com.plumtree.portaluiinfrastructure.layout.impl;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.layout.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.portaluiinfrastructure.tags.displaytree.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlelements.*;

public class LayoutDisplay implements ILayoutDisplay
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_UI_INFRASTRUCTURE),
		"com.plumtree.portaluiinfrastructure.layout.impl.LayoutDisplay");

	public HTMLElement ProcessLayout(Object[][] _markup,
			AActivitySpace _currentSpace)
	{
		HTMLElement result;

		try
		{
			result =  DisplayTree.ProcessTagMarkup(_currentSpace, _markup);
		}
		catch (Exception e)
		{
			log.Warn(e, "Error rendering markup for layout.");

			throw new XPException("Error rendering markup for layout.", e);
		}

		return result;
	}

	public HTMLElement ProcessMainPageLayout(Object[][] _markup, AActivitySpace _currentSpace)
	{
		HeadPreprocessor preprocessor = new HeadPreprocessor();
		// This will ensure that we have a location to place the CSAPI &
		// JS Includes in the head element.
		Object[][] processedMarkup = preprocessor.PreprocessHead(_markup,
			_currentSpace.GetSubSession(), _currentSpace, true);

		return ProcessLayout(processedMarkup, _currentSpace);
	}
}