/*
 * Created on Mar 27, 2003
 */
package com.plumtree.portaluiinfrastructure.navtype;

import com.plumtree.openfoundation.util.*;

/**
 * Enumeration of core features used on each page which can be turned on or off
 * 
 * @author DavidP
 */
public class NavFeatureEnum 
{
	private int m_navFeatureID;
	
	// enumeration of page types
	public static final NavFeatureEnum TOPBAR = new NavFeatureEnum(0);
	public static final NavFeatureEnum HEADER = new NavFeatureEnum(1);
	public static final NavFeatureEnum FOOTER = new NavFeatureEnum(2);

	
	// array of page types
	public static final NavFeatureEnum[] m_navFeatureEnums = 
		{
			TOPBAR,
			HEADER,
			FOOTER 
		};
	
	/**
	 * @param navFeatureID
	 */
	private NavFeatureEnum(int navFeatureID)
	{
		m_navFeatureID = navFeatureID;
	}
	
	/**
	 * 
	 * @see java.lang.Object#toString()
	 */
	public String toString()
	{
		return XPConvert.ToString(m_navFeatureID);
	}
	
	/**
	 * 
	 * @return int
	 */
	public int GetID()
	{
		return m_navFeatureID;
	}
	
	/**
	 * 
	 * @see java.lang.Object#equals(Object)
	 */
	public final boolean equals(Object o)
	{
		boolean retval = false;
		try 
		{
			retval = (((NavFeatureEnum)o).GetID() == m_navFeatureID);
		}
		catch( Exception e )
		{
		}
		
		return retval;
	}

}

