package com.plumtree.portaluiinfrastructure.opener;

import com.plumtree.uiinfrastructure.opener.*;

/**
 * Constants for use by the Common Opener.
 *
 * @author John Osborne
 */
public class IPTOpenerConstants extends IOpenerConstants
{
	// common querystring name arguments. these
	// arguments are everywhere so keep them short.
	public static final String QS_UUID 		= "uuID";
	public static final String QS_USERID	= "userID";
	public static final String QS_KEYWORD	= "tbb";

	// special querystring name arguments.  these
	// arguments will usually not be copy/pasted
	// so they can be more descriptive.
	public static final String QS_FOLDERID		= "folderID";
	public static final String QS_PROV_ENG_NAME	= "provEngName";
	
	// javascript includes.
	public static final String FILENAME_JS_COMMONOPENER 		= "ptcommonopener.js";	
	public static final String JS_METHOD_GETOPENERURL 			= "PTCommonOpener.getOpenerURL";
	public static final String JS_METHOD_GETOPENERURL_OPENAS 	= "PTCommonOpener.getOpenerURLOpenAS";
	public static final String JS_METHOD_GETOPENERURL_OPENUUID 	= "PTCommonOpener.getOpenerURLOpenUUID";
	public static final String JS_METHOD_GETOPENERURL_OPENOBJID = "PTCommonOpener.getOpenerURLOpenObjID";
	public static final String JS_METHOD_GETOPENERURL_CREATE 	= "PTCommonOpener.getOpenerURLCreate";
	public static final String JS_METHOD_GETOPENERURL_CREATEEXT = "PTCommonOpener.getOpenerURLCreateExt";
	public static final String JS_METHOD_OPEN_NEW_WINDOW 		= "PTCommonOpener.openInNewWindow";
	public static final String JS_METHOD_OPEN_SAME_WINDOW 		= "PTCommonOpener.openInSameWindow";
	public static final String JS_METHOD_GETAPPLICATIONBASEURL	= "OpenerAS_GetApplicationBaseURL";
	public static final String JS_METHOD_GETCURRENTUSERID 		= "OpenerAS_GetCurrentUserID";	
	public static final String JS_METHOD_PARENTSPACE_NAME 		= "OpenerAS_GetParentSpaceName";	
	public static final String JS_METHOD_PARENTSPACE_ID			= "OpenerAS_GetParentSpaceID";	
	
    // to be deprecated querystring name arguments.
	public static final String STR_QS_FOLDERID 			= "in_hi_FolderID";
	public static final String STR_QS_PROVIDER_ENG_NAME = "in_hi_ProvEngName";
	public static final String STR_QS_FORCESAVEINFOLDER = "bForceSaveInFolder";
	public static final String STR_QS_FOLDERNOTREQUIRED = "folderNotRequired";
}