package com.plumtree.portaluiinfrastructure.opener;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlelements.*;

public class PTOpenerService implements IPTOpenerHelper
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_UI_INFRASTRUCTURE),
		"com.plumtree.portaluiinfrastructure.opener.PTOpenerService");

	//the singleton instance
	private static IPTOpenerHelper m_HelperInstance;

	// This stores whether or not the factory is in test mode.
	private static boolean m_bIsProduction = false;

	// Private constructor to ensure controlled access to the singleton.
	private PTOpenerService() {}

	/**
	 * @return The singleton config helper.
	 */
	public static IPTOpenerHelper getInstance()
    {
		if (m_HelperInstance == null)
		{
			m_bIsProduction = true;
			m_HelperInstance = new PTOpenerService();
		}
		return m_HelperInstance;
	}

    /**
     * Unit tests should use this method to overwrite/teardown existing helper singleton.
     * DO NOT USE for production code. 
     */
	public static void setTestInstance(IPTOpenerHelper testHelper)
	{
		if (m_bIsProduction)
		{
			String strMessage = "Can't override ConfigHelper instance for testing... ConfigService has already been initialized.";
			log.Error(strMessage);
			throw new XPException(strMessage);
		}

		m_HelperInstance = testHelper;
	}

	public HTMLScriptCollection GetOpenerJavascript(AActivitySpace _asOwner) {
		return PTOpenerLinks.GetOpenerJavascript(_asOwner);
	}
}