/*
 * Created on Dec 8, 2004
 */
package com.plumtree.portaluiinfrastructure.ptlink;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.tags.data.*;
import com.plumtree.uiinfrastructure.statichelpers.*;

/**
 * Full URL type
 * 
 */
public class FullURL extends APTURL implements IDataObject
{
	/**
	 * The Full URL
	 */
	public final static String KEY_FULLURL_FULLURL = "url";
	/**
	 * Baseurl 
	 */
	public final static String KEY_FULLURL_BASEURL = "baseurl";
	/**
	 * URI
	 */
	public final static String KEY_FULLURL_URI = "uri";
	/**
	 * URL Type.
	 */
	public final static String URL_TYPE_FULLURL = "fullurl";
	
	protected String m_strBaseURL;
	protected String m_strURI;
	
	/**
	 * 
	 * 
	 * 
	 * @param strTitle
	 * @param strFullURL	URL, null URLs are accepted 
	 */
	public FullURL(String strTitle, String strFullURL)
	{
		super(strTitle);
		
		if ( null == strFullURL ) {
			m_strBaseURL = null;
			m_strURI = null;
			return;
		}
			
		XPStringTokenizer tok = new XPStringTokenizer(strFullURL, "?");
		
		if ( tok.HasMoreTokens() )
			m_strBaseURL = tok.GetNextToken();
		if ( tok.HasMoreTokens() )
			m_strURI = tok.GetNextToken();
		
	}
	
	/**
	 * @see com.plumtree.portaluiinfrastructure.ptlink.IPTURL#GetFullURL()
	 */
	public String GetFullURL()
	{
		XPStringBuilder buf = new XPStringBuilder(); 
		buf.Append( m_strBaseURL);
		
		if ( null != m_strURI || m_listParamNames != null )
		{
			buf.Append("?");
		}
		
		if (null != m_strURI)
		{
			buf.Append(m_strURI);
		}
		
		if ( m_listParamNames != null && m_listParamNames.GetSize() > 0 ) {
			buf.Append(HTTPHelpers.GetParameterListAsString(m_listParamNames, m_listParamValues));
		}
		
		return buf.ToString();
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.ptlink.IPTURL#GetURI()
	 */
	public String GetURI()
	{
		return m_strURI;
	}
	
	/**
	 * 
	 * 
	 * @see com.plumtree.portaluiinfrastructure.tags.data.IDataObject#GetData(java.lang.String)
	 */
	public String GetData(String strKey)
	{
		if ( KEY_FULLURL_FULLURL.equals(strKey) )
		{
			return GetFullURL();
		}
		else if ( KEY_FULLURL_BASEURL.equals(strKey) )
		{
			return m_strBaseURL;
		}
		else if  ( KEY_FULLURL_URI.equals(strKey) )
		{
			return GetURI();
		}
		else if ( KEY_URLTYPE.equals(strKey) )
		{
			return URL_TYPE_FULLURL;
		}
		return super.GetData(strKey);
	}
	


}
