package com.plumtree.portaluiinfrastructure.ptlink;

/**
 * Constant definitions of common URL components 
 * 
 */
public class PTURLConstants
{
	/**
	 * URL title
	 */
	public final static String KEY_TITLE = "title";
	/**
	 * Icon associated with the URL.
	 */
	public final static String KEY_ICONIMG = "img";
	/**
	 * Width of the icon.
	 */
	public final static String KEY_ICONIMGWIDTH = "imgwidth";
	/**
	 * Height of the icon.
	 */
	public final static String KEY_ICONIMGHEIGHT = "imgheight";
	/**
	 * Alternative text of the icon.
	 */
	public final static String KEY_ICONIMGALT = "imgalt";
	
	/**
	 * The full URL.
	 */
	public final static String KEY_FULLURL = "url";
	/**
	 * URI part of the URL.
	 */
	public final static String KEY_URI = "uri";
	/**
	 * Current marker. This flag should be set if the URL is pointing to the current page.
	 */
	public final static String KEY_CURRENTMARKER = "currpage";
	/**
	 *	Javascript action associated with an URL. 
	 */
	public final static String KEY_JAVASCRIPT_ACTION = "jsaction";
	/**
	 * Lists all parameters in the query string. 
	 */
	public final static String KEY_PARAMS = "params";
	/**
	 * The type of URL
	 */
	public final static String KEY_URLTYPE = "urltype";

	/**
	 * The object ID of the object represented by this URL
	 */
	public final static String KEY_OBJECTID = "objectid";
	/**
	 * The class ID of the object represented by this URL
	 */
	public final static String KEY_CLASSID = "classid";
}
