package com.plumtree.portaluiinfrastructure.ptmulticolumnlist;


// Framework Imports
import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.expandablelist.*;

/**
 * This class contains the additional repost actions.
 * The ones specific to the Property Editor (other than
 * "change page", "finish" and "cancel" actions).
 *
 * @author Julie Fournier
 */
public class PTMultiColumnListRepostControl extends ExpListControl
{
	/** Unique identifier for the control */
	public static final String STR_MVC_CLASS_NAME = "PTMultiColumnListRepost";

	/** The edit action - sets the row being edited on the model */
	public final static int POSTTOSELF_ACTION_EDIT = 10;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new PTMultiColumnListRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Calls the method associated to the repost action.
	 * Editors using this framework need to call that method from
	 * the PerformRepostAction method of the main RepostControl.
	 *
	 * @param _nAction
	 * @param _htFormData
	 */
	public void PerformRepostAction(int _nAction, XPHashtable _htFormData)
	{
		super.PerformRepostAction(_nAction, _htFormData);

		PTMultiColumnListModel myMultiColumnListModel = (PTMultiColumnListModel) m_model;

		if (_nAction == myMultiColumnListModel.GetUniqueInt(
					POSTTOSELF_ACTION_EDIT))
		{
			myMultiColumnListModel.ModifyRow(_htFormData);
		}
	}
}

