package com.plumtree.portaluiinfrastructure.restconsumerframework;

import com.plumtree.openfoundation.util.*;

/**
 * Stores preference data for an ensemble pagelet 
 * @TODO: rename to param data
 * @author rozhang
 */
public class EnsemblePageletPrefsRestData 
{
	public static final String PARAM_NAME = "name";
	public static final String PARAM_DESCRIPTION = "desc";
	public static final String PARAM_ISMANDATORY = "isMandatory";
	
	protected String[]  m_paramNames = null;
	protected String[]  m_paramDescs = null;
	protected boolean[] m_paramIsMandatory = null;
	
	public boolean Init(XPHashtable data)
	{
		boolean success = false;
		
		Object paramData = data.GetElement(EnsembleRestAPIService.PARAMETERS);
		if ( paramData != null && paramData instanceof XPHashtable ) {
			XPHashtable paramContainer = (XPHashtable)paramData;

			Object rawParam = paramContainer.GetElement("PageletParam");
			
			if ( rawParam instanceof XPHashtable ) {
				XPHashtable mapParam = (XPHashtable)rawParam;
				m_paramNames = new String[1];
				m_paramDescs = new String[1];
				m_paramIsMandatory = new boolean[1];
				ParseSingleParam(mapParam, 0);
			} else if ( rawParam instanceof XPArrayList ) {
				XPArrayList listParams = (XPArrayList)rawParam;
				int numParams = listParams.GetSize();
				m_paramNames = new String[numParams];
				m_paramDescs = new String[numParams];
				m_paramIsMandatory = new boolean[numParams];
				
				for ( int i = 0; i < numParams; i++ ) {
					XPHashtable par = (XPHashtable)listParams.GetElement(i);
					ParseSingleParam(par, i);
				}
			}
			success = true;
		}
		
		return success;
	}
	
	void ParseSingleParam(XPHashtable param, int arrayIndex)
	{
		String name = (String)param.GetElement(PARAM_NAME);
		boolean isMand = XPConvert.ToBoolean( param.GetElement(PARAM_ISMANDATORY) );
		String desc = (String)param.GetElement(PARAM_DESCRIPTION);
		m_paramNames[arrayIndex] = name;
		m_paramIsMandatory[arrayIndex] = isMand;
		m_paramDescs[arrayIndex] = (desc == null) ? "" : desc;
	}
	
	public String[] GetParameterNames()
	{
		if (m_paramNames == null) {
			m_paramNames = new String[0];
		}
		return m_paramNames;
	}
	
	public boolean[] GetParamIsMandatory()
	{
		if (m_paramIsMandatory == null) {
			m_paramIsMandatory = new boolean[0];
		}
		return m_paramIsMandatory;
	}
	
	public String[] GetParameterDescriptions()
	{
		if (m_paramDescs == null) {
			m_paramDescs = new String[0];
		}
		return m_paramDescs;
		
	}
	
	
}
