package com.plumtree.portaluiinfrastructure.restconsumerframework;

import com.plumtree.openfoundation.util.*;

/**
 * Container for Ensemble Pagelet data
 * 
 * @author rozhang
 */
public class EnsemblePageletRestData
{
		
	public int 			id = 0;
	public String		name = null;
	public String 		description = null;
	public XPDateTime 	lastModified = null;
	public XPDateTime 	created = null;
	public String 		libraryName = null;
	
	public String 		parentResourceName = null;
	public String 		parentResourceDescription = null;
	public String 		parentResourceId = null;
	public String[] 	parentResourceExternalUrlList = null;
	
	public String 		codeSample = null;
	public boolean 		publishDocs = false;
	public boolean 		addInlineRefreshToAllUrls = false;
	
	public int 			refreshInterval = 0;
	
	public String 		urlSuffix = null;
	public String 		pageletExternalUrl = null;
	public String 		parametersTransport = null;
	public boolean 		allowAll = false;
		
	public EnsemblePageletPrefsRestData prefsData = null;
		
	public EnsemblePageletRestData() 
	{
		
	}
	
	public boolean Init(XPHashtable data)
	{
		try {
			id 							= XPConvert.ToInteger( data.GetElement(EnsembleRestAPIService.ID) );
		} catch (XPException e) {
			// ignore
		}
		name 						= (String)GetDataElement(EnsembleRestAPIService.NAME, null, data); 
		description 				= (String)GetDataElement(EnsembleRestAPIService.DESCRIPTION, "", data);
		//lastModified = XPDateFormat.GetDateTimeInstance(XPDateFormat.LONG, XPDateFormat.LONG).Parse((String)data.GetElement(LASTMODIFIED)); 
		//created = XPDateFormat.GetDateTimeInstance(XPDateFormat.LONG, XPDateFormat.LONG).Parse((String)data.GetElement(CREATED)); 
		libraryName 				= (String)GetDataElement(EnsembleRestAPIService.LIBRARYNAME, null, data); 
		parentResourceName 			= (String)GetDataElement(EnsembleRestAPIService.PARENT_RESOURCE_NAME, "", data); 
		parentResourceDescription 	= (String)GetDataElement(EnsembleRestAPIService.PARENT_RESOURCE_DESCRIPTION, "", data); 
		parentResourceId 			= (String)GetDataElement(EnsembleRestAPIService.PARENT_RESOURCE_ID, "", data); 
		Object o 					= data.GetElement(EnsembleRestAPIService.PARENT_RESOURCE_EXTURL_LIST);
		if ( o != null ) {
			if ( o instanceof String ) {
				parentResourceExternalUrlList = new String[] {(String)o};
			} else if (o instanceof String[]) {
				parentResourceExternalUrlList = (String[])o;
			}
		}
		  
		codeSample 					= (String)GetDataElement(EnsembleRestAPIService.CODESAMPLE, "", data); 
		publishDocs 				= XPConvert.ToBoolean( GetDataElement(EnsembleRestAPIService.PUBLISHDOCS, Boolean.FALSE, data) ); 
		addInlineRefreshToAllUrls 	= XPConvert.ToBoolean( GetDataElement(EnsembleRestAPIService.ADD_INLINEREFRESH, Boolean.FALSE, data) );  
		refreshInterval 			= XPConvert.ToInteger( GetDataElement(EnsembleRestAPIService.REFRESH_INTERVAL, 0, data) ); 
		urlSuffix 					= (String)GetDataElement(EnsembleRestAPIService.URL_SUFFIX, "", data); 
		pageletExternalUrl 			= (String)GetDataElement(EnsembleRestAPIService.PAGELET_EXTURL, "", data); 
		//parametersTransport 		= (String)GetDataElement(EnsembleRestAPIService.PARAMETERS_TRANSPORT, null, data); 
		//allowAll 					= XPConvert.ToBoolean( GetDataElement(EnsembleRestAPIService.ALLOW_ALL, null, data) );
		
		prefsData = new EnsemblePageletPrefsRestData();
		prefsData.Init(data);
		
		return true;
		
	}
	
	protected Object GetDataElement(String elementName, Object defaultValue, XPHashtable data)
	{
		Object rawVal = data.GetElement(elementName);
		if ( rawVal == null ) {
			if ( defaultValue == null ) {
				throw new XPFormatException("Missing required value from Ensemble Pagelet Rest response. Required element with name: "+elementName+" was not found!");
			}
			return defaultValue;
		}
		return rawVal;
	}
}
