package com.plumtree.portaluiinfrastructure.restconsumerframework;

import com.plumtree.openfoundation.util.*;

public interface IRestResponse 
{
	/**
	 * Returns the name of a node list under the root node. All the nodes
	 * under the root node has to share the same name to be considered a valid
	 * node list. 
	 * 
	 * @return null if the response content doesn't contain a list 
	 */
	public String GetListName();
	
	/**
	 * Gets the name of the top level element
	 * 
	 * @return
	 */
	public String GetRootElementName();

	/**
	 * Exclusive from GetResponseList method, only one is valid in any one response
	 * 
	 * @return null if the response is actually a list of items
	 */
	public XPHashtable GetSingleDataItem();
	
	/**
	 * Exclusive from GetSingleDataItem method, only one is valid in any one response
	 * 
	 * @return null if the current response does not contain a top level list, XPArrayList contains 
	 * XPHashtables
	 */
	public XPArrayList GetResponseList();
	
}
