package com.plumtree.portaluiinfrastructure.resultwrapper;


/**
 * MES- The IASQueryResult interface is used by PTObjectManagerQueryWrapper
 * and ASQueryResultWrapper to make IPTQueryResults and IPTTurboQueryResults
 * look the same to clients
 *
 * @author MichaelS
 */
public interface IASQueryResult
{
	/**
	 * MES- GetCount should return the number of ROWS in the
	 * result set
	 *
	 * @return the number of rows in the result set
	 */
	public int GetCount();

	/**
	 * MES- GetFields is used to get the value of a particular
	 * cell in the array.
	 *
	 * @param iRowNum is the row that contains the data of interest
	 * @param iPropertyID is the PropertyID of the data of interest
	 * (e.g. PT_PROPIDS.PT_PROPID_NAME)
	 *
	 * @return the value of the cell
	 */
	public Object GetFields(int iRowNum, int iPropertyID);

	/**
	* MES- IsComplete returns a boolean indicating if the rows
	* we can return are the complete rowset (i.e. have we truncated
	* the rowset because it's too large to bring to the client.)
	*
	* @return A boolean indicating completeness.
	*/
	public boolean IsComplete();
}

