package com.plumtree.portaluiinfrastructure.search;


/**
 * @author CraigS
 */
public interface ISaveSearchModelRO
{
	/**
	 *  Returns true if this search has already been saved.
	 */
	public boolean GetHasBeenSaved();

	/**
	 *  Returns an int that clients can set via
	 *  ISaveSearchModel.setSavedSearchErrorCode()
	 *  to communicate conditions like "a saved search
	 *  already exists with that name".
	 *  Default is zero.
	 */
	public int GetSavedSearchErrorCode();

	/**
	 *  Returns the name of the search if the search has been saved,
	 *  or null otherwise.
	 */
	public String GetSavedSearchName();
}

