package com.plumtree.portaluiinfrastructure.search;


/**
 * @author CraigS
 */
public interface ISearchQueryRO extends IBaseSearchQueryRO
{
	/**
	 *  Returns true if this advanced search consists of a nested
	 *  set of clauses that are too complex to easily summarize.
	 */
	public boolean IsASTooComplexToSummarize();

	/**
	 *  If advanced search, returns the operator for the indicated
	 *  property condition (localized).
	 */
	public String GetASConstraintOperator(int condition);

	/**
	 *  If advanced search, returns the property name for the indicated
	 *  property condition.
	 */
	public String GetASConstraintProperty(int condition);

	/**
	 *  If advanced search, returns the comparison value for the indicated
	 *  property condition.
	 */
	public String GetASConstraintValue(int condition);

	/**
	 *  If advanced search, returns the number of property restrictions.
	 */
	public int GetASNumPropertyConstraints();

	/**
	 *  If advanced search, returns whether individual property conditions
	 *  are ANDed or ORed together (true <-> AND).
	 */
	public boolean GetASPropertyClauseOperator();

	/**
	 *  If advanced search, returns whether text and property conditions
	 *  (as a group) are ANDed or ORed together (true <-> AND).
	 */
	public boolean GetASTopLevelOperator();

	/**
	 *  Returns true if this result was generated by an advanced search.
	 */
	public boolean isAdvancedSearch();
}

