package com.plumtree.portaluiinfrastructure.search;

import com.plumtree.server.*;

/**
 * @author CraigS
 *
 *  This is a small helper class that holds a user's query, which
 *  may be either a simple String for a basic (e.g. banner) search
 *  or an IPTFilter for an advanced search.
 */
public class QueryArguments
{
  /** 
   *  User's query string, if and only if this is a basic (e.g. banner) search.
   *  For an advanced search, userQuery will always be null and is not used.
   */
  public String userQuery = null;

  /** 
   *  Fields searched by a basic (e.g. banner) search.  May be null, in which
   *  case the default fields (name, description, and full-text) are searched.
   *  For an advanced search, basicFields will always be null and is ignored.
   */
  public String basicFields = null;

  /** 
   *  IPTFilter used as the query for an advanced search.  If this is a basic
   *  search, advancedFilter will be null.
   */
  public IPTFilter advancedFilter = null;
}

