package com.plumtree.portaluiinfrastructure.search.exceptions;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.search.*;

/**
 *  ArgumentBoundsException indicates that an argument to a get()
 *  accessor method was out of range, e.g. getResultName(11) when only
 *  10 results were returned
 */
public class ArgumentBoundsException extends SearchModelException
{
	/**
	 * Creates a new ArgumentBoundsException object.
	 *
	 * @param arg 
	 * @param value 
	 */
	public ArgumentBoundsException(String arg, int value)
	{
		super("Argument out of range: " + arg + "," + XPConvert.ToString(value));
	}
}

