package com.plumtree.portaluiinfrastructure.search.exceptions;

import com.plumtree.portaluiinfrastructure.search.*;

/**
 *  InvalidArgumentException indicates that a method on
 *  ISearchResultModel was passed an invalid argument.
 */
public class InvalidArgumentException extends SearchExecutionError
{
	/**
	 * Creates a new InvalidArgumentException object.
	 *
	 * @param msg 
	 */
	public InvalidArgumentException(String msg)
	{
		super(msg);
	}

	/**
	 * Creates a new InvalidArgumentException object.
	 *
	 * @param badArg 
	 * @param badValue 
	 */
	public InvalidArgumentException(String badArg, String badValue)
	{
		super(badValue + " is an invalid argument for " + badArg);
	}
}

