/**
 * 
 */
package com.plumtree.portaluiinfrastructure.search.pathways;

import com.plumtree.openfoundation.util.XPNotImplementedException;
import com.plumtree.openlog.OpenLogService;
import com.plumtree.openlog.OpenLogger;
import com.plumtree.portaluiinfrastructure.statichelpers.PTDebugHelpers;
import com.plumtree.server.*;
import com.plumtree.server.impl.core.InternalSession;
import com.plumtree.server.impl.search.PTSearchRequest;

/**
 * @author Administrator
 *
 */
public class PathwaysSearchRequest extends PTSearchRequest {
	
	PathwaysQueryArguments _pathwaysQueryArg;

	private static OpenLogger pathwayslog = OpenLogService.GetLogger(
			OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PATHWAYS),
		"com.plumtree.portaluiinfrastructure.search.pathways.PathwaysSearchRequest");

	/**
	 * @param internalSession
	 */
	public PathwaysSearchRequest(InternalSession internalSession, PathwaysQueryArguments pqArgs) {
		super(internalSession);

		_pathwaysQueryArg = pqArgs;
		SetGlobalSpellingCheck(internalSession);
	}
	
	public boolean GetGlobalSpellingCheck()
	{
		return _globalAllowSpellchecking;
	}
	
	/*
	 * this method returns the global spelling check for searches
	 */
	public void SetGlobalSpellingCheck(InternalSession internalSession)
	{
		IPTServerConfigSettings myconfig = (IPTServerConfigSettings) internalSession.GetSession().OpenGlobalObject(PT_GLOBALOBJECTS.PT_GLOBAL_SERVERCONFIGSETTINGS, true);

		_globalAllowSpellchecking = myconfig.GetSettingAsBoolean(PT_SERVER_CONFIG_SETTINGNAME.PT_SEARCH_ALLOW_SPELLCHECK);
	}

	/* (non-Javadoc)
	 * @see com.plumtree.server.IPTSearchRequest#CreateAdvancedQuery(com.plumtree.server.IPTFilter)
	 */
	public IPTSearchQuery CreateAdvancedQuery(IPTFilter filter) {
		throw new XPNotImplementedException("CreateAdvancedQuery is not supported for a Pathways search request");
	}

	/* (non-Javadoc)
	 * @see com.plumtree.server.IPTSearchRequest#CreateBasicQuery(java.lang.String, java.lang.String)
	 */
	public IPTSearchQuery CreateBasicQuery(String searchString, String fields) {
		throw new XPNotImplementedException("CreateBasicQuery is not supported for a Pathways search request");
	}

	/* (non-Javadoc)
	 * @see com.plumtree.server.IPTSearchRequest#FollowupSearch(java.lang.Object)
	 */
	public IPTSearchResponse FollowupSearch(Object queryArray) {
		throw new XPNotImplementedException("FollowupSearch is not supported for a Pathways search request");
	}
	
	/* (non-Javadoc)
	 * @see com.plumtree.server.IPTSearchRequest#Search(com.plumtree.server.IPTSearchQuery)
	 */
	public IPTSearchResponse Search(IPTSearchQuery query) {
		throw new XPNotImplementedException("Search is not supported for a Pathways search request");
	}
		
	
	
	
	
}
