package com.plumtree.portaluiinfrastructure.securitymatrix;

import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.opener.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlconstructs.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This page shows the results from using ABO.
 *
 * @author RickyW
 */
public class ABOPopupResultsDP implements IDisplayPage
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_UI_INFRASTRUCTURE),
		"com.plumtree.portaluiinfrastructure.securitymatrix.ABOPopupResultsDP");

	/** class name **/
	public static final String STR_MVC_CLASS_NAME = "ABOPopupResultsDP";

	/** owner object */
	protected AActivitySpace m_asOwner;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Display()
	 */
	public void Display(IWebData pageData)
	{
		HTMLPage myPage = new HTMLPage();

		// Set the HTMLPage as the data to be sent to the browser.
		pageData.SetData(myPage);

		HTMLHead myHead = new HTMLHead();
		myPage.SetHead(myHead);

		HTMLTitle myTitle = new HTMLTitle(m_asOwner.GetString(1692, "ptmsgs_portaladminmsgs"));

		HTMLBody myBody = new HTMLBody();
		myPage.SetBody(myBody);
		myBody.SetMarginHeight("0");
		myBody.SetMarginWidth("0");
		myBody.SetLeftMargin("0");
		myBody.SetTopMargin("0");
		myBody.SetOnUnload(ABOPopupResultsView.JAVASCRIPT_CLOSE + "()");

		try
		{
			// set to dark background color
			myBody.SetStyleClass(PTStyleClass.ALERT_DIALOG_BG);

			myHead.AddInnerHTMLElement(myTitle);

			myHead.AddInnerHTMLElement(m_asOwner.GetStyleSheetLinks());

			HTMLScript myScript = DisplayJavascript();

			if (myScript != null)
			{
				myHead.AddInnerHTMLElement(myScript);
			}
			
			// Add jsportlet to the page
			HTMLScriptCollection jsportletScript = new HTMLScriptCollection();
			jsportletScript.AddInnerHTMLElement( ConfigHelper.GetJSIncluderJSComponentInclude(ConfigHelper.JSCOMPONENT_JSPORTLET, GetOwner()) );
			myHead.AddInnerHTMLElement(jsportletScript);
			
			
			// get js functions from opener
			HTMLScriptCollection myScriptCollection = PTOpenerLinks.GetOpenerJavascript(m_asOwner);
			if (myScriptCollection != null)
			{
				myHead.AddInnerHTMLElement(myScriptCollection);
			}			

			myBody.AddInnerHTMLElement(m_asOwner.GetView(
					ABOPopupResultsView.STR_MVC_CLASS_NAME).Display());
		}
		catch (HTMLException he)
		{
			
				log.Error(he, "Display: The following HTML error occured when trying to display the HTML.");
			
		}
		catch (Exception e)
		{
			
				log.Error(e, "Display: The following error occured when trying to display the HTML.");
			
		}
	}

	/** logger setup */
	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#GetOwner()
	 */
	public AActivitySpace GetOwner()
	{
		return m_asOwner;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IDisplayPage#Init(AActivitySpace)
	 */
	public void Init(AActivitySpace parent)
	{
		m_asOwner = parent;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay()
	{
		return m_asOwner.GetView(ABOPopupResultsView.STR_MVC_CLASS_NAME)
		.Display();
	}

	/**
	 * Returns the JavaScript from any views shown by this DP.
	 */
	protected HTMLScript DisplayJavascript()
	{
		return m_asOwner.GetView(ABOPopupResultsView.STR_MVC_CLASS_NAME)
		.DisplayJavascript();
	}
}

