package com.plumtree.portaluiinfrastructure.securitymatrix;

import com.plumtree.uiinfrastructure.form.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This display page is a popup that asks the user if he wants to use ABO.
 *
 * @author RickyW
 */
public class ABOPopupSelectDP extends AFormDP {
	/** class name **/
	public static final String STR_MVC_CLASS_NAME = "ABOPopupSelectDP";
	
	/** View Name **/
	private String m_strViewName = ABOPopupSelectView.STR_MVC_CLASS_NAME;

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormTitle()
	 */
	public String GetFormTitle() {
		return m_asOwner.GetString(1691, "ptmsgs_portaladminmsgs");
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName() {
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#PageDisplay()
	 */
	public HTMLElement PageDisplay() {
		return m_asOwner.GetView(m_strViewName).Display();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#GetFormPageType()
	 */
	public FormPageTypes GetFormPageType()
	{
		return FormPageTypes.NO_BUTTONS;
	}

	/**
	*Returns the JavaScript from any views shown by this DP.
	 *
	 * @return HTMLScriptCollection the Javascript from the Child IViews
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild() {
		HTMLScriptCollection scripts = new HTMLScriptCollection();

		scripts.AddInnerHTMLElement(GetOwner().GetView(m_strViewName).DisplayJavascript());

		return scripts;
	}
	
	/**
	 * View Name defaults to ABOPopupSelectView.STR_MVC_CLASS_NAME if this method is not called.
	 * 
	 * @param _strViewName - the name of the view to be displayed by this display page. 
	 * 		Should be the name of a view that subclasses ABOPopupSelectView, but will not throw an exception if otherwise.
	 */
	public void SetViewName(String _strViewName)
	{
		m_strViewName = _strViewName;
	}
}

