package com.plumtree.portaluiinfrastructure.securitymatrix;

import com.plumtree.portaluiinfrastructure.editor.*;

/**
 * @author MichaelD
 */
public interface IFolderSecurityABOModelRO extends IObjEditorModelRO
{
	/**
	 * This method returns whether or not there is a job ID to display.
	 *
	 * @return boolean true implies there is a job ID to display.
	 */
	public boolean ABOJobIDToDisplay();

	/**
	 * This method returns the job ID for a security change job.
	 *
	 * @return int the job ID for security changes.
	 */
	public int GetABOJobID();

	/**
	 * Retrieves the name of the job created by ABO.
	 */
	public String GetCreatedJobName();

	/**
	 * Retrieves the name of the folder that ABO created the job in.
	 */
	public String GetFolderNameForCreatedJobs();

}
