package com.plumtree.portaluiinfrastructure.securitymatrix;


// Framework Imports
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * This interface is implemented by the Model.
 * It contains all the read-only mothods of the Model
 * accessed by the Views.
 *
 * @author Julie Fournier
 */
public interface ISecurityMatrixModelRO extends IFolderSecurityABOModelRO
{
	/**
	 * Returns the URL to edit the object.
	 *
	 * @param _nClassID
	 * @param _nObjectID
	 * @param _sEditorASName
	 *
	 * @return ASURL URL to the Editor
	 */
	public ASURL GetEditObjectURL(int _nClassID, int _nObjectID);

	/**
	 * Returns the number of SubPortals that were loaded.
	 *
	 * @return int number of SubPortals
	 */
	public int GetNumSubPortals();

	/**
	 * Returns the id of a regular folder.
	 *
	 * @return String ID of regular folder
	 */
	public String GetRegularFolderID();

	/**
	 * Returns the id of the selected subportal.
	 *
	 * @return String ID of selected subportal
	 */
	public String GetSelectedSubPortalID();

	/**
	 * Returns the id of the SubPortal at a given position. This is returned
	 * as a string because we only need to do html with the id.
	 *
	 * @return String ID of SubPortal
	 */
	public String GetSubPortalID(int pos);

	/**
	 * Returns the name of the SubPortal at a given position.
	 *
	 * @return String name of SubPortal
	 */
	public String GetSubPortalName(int pos);
}

