package com.plumtree.portaluiinfrastructure.securitymatrix;


// Framework Imports
import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.expandablelist.*;

/**
 * This class handles the repost actions for the
 * Multi Security page.
 *
 * @author Julie Fournier
 */
public class MultiObjectsSecurityControl extends ExpListControl
{
	/**
	 * Class name for the activity space */
	public static final String STR_MVC_CLASS_NAME = "MultiObjectsSecurity";

	/**
	 * Will clear all the changes and redisplay the matrix as it was when we first displayed it. */
	public static final int POSTTOSELF_ACTION_RESET = 40;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new MultiObjectsSecurityControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Calls the method associated to the repost action.
	 * Editors using this framework need to call that method from
	 * the PerformRepostAction method of the main RepostControl.
	 *
	 * @param _nAction
	 * @param _htFormData
	 */
	public void PerformRepostAction(int _nAction, XPHashtable _htFormData)
	{
		super.PerformRepostAction(_nAction, _htFormData);

		if (_nAction == ((MultiObjectsSecurityModel) m_model).GetUniqueInt(
					POSTTOSELF_ACTION_RESET))
		{
			((MultiObjectsSecurityModel) m_model).ResetSettings();
		}
	}
}

