package com.plumtree.portaluiinfrastructure.securitymatrix;


// Framework Imports
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This is class is used to print out together the Views for
 * the Multi objects security page.
 *
 * @author Julie Fournier
 */
public class SecurityMatrixDP extends EditorDP
{
	/**
	 * Class name for the activity space */
	public static final String STR_MVC_CLASS_NAME = "SecurityMatrix";

	/**
	 * Returns the String to display on the left navigation menu,
	 * linking to that page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		return m_asOwner.GetString(151, "ptmsgs_portalinfrastructure");
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for that Page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()
	 *
	 * @return HTMLElement
	 * @throws HTMLException
	 */
	public HTMLElement PageDisplay()

	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
				SecurityMatrixEditorAS.STR_MVC_STORAGE_NAME_MULTI_SECURITY)).Display());

		result.AddInnerHTMLElement(CreateContentTable(views, null));

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();
		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
				SecurityMatrixEditorAS.STR_MVC_STORAGE_NAME_MULTI_SECURITY)
			.DisplayJavascript());

		return myScripts;
	}

	/**
	 * We don't want a help subheader here.
	 * @see com.plumtree.uiinfrastructure.editor.EditorDP#GetHTMLBelowSubHeader()
	 */
	protected HTMLElement GetHTMLBelowSubHeader()
	{
		return null;
	}
}

