package com.plumtree.portaluiinfrastructure.sso.integrations;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.portaluiinfrastructure.sso.*;

/**
 * Handles SSO integration with Windows Integrated Authentication, aka NTLM.
 *
 * @author Mike Jahr
 */
public class Netegrity implements ISSOIntegration
{
	//    private IXPRequest m_request;
	private static final String[] HEADERS = { "SM_", "Authorization" };
	private static final String[] COOKIES = { "SMSESSION" };

	/**
	 * Creates a new Netegrity object.
	 */
	public Netegrity()
	{
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#GetLoginInfo()
	 */
	public SSOLoginInfo GetLoginInfo(IXPRequest request)
	{
		return new SSOLoginInfo(request.GetHeader("SM_USER"), request.GetHeader("SM_PASSWORD"));
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#GetSSOProductName()
	 */
	public String GetSSOProductName()
	{
		return "Netegrity SiteMinder";
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#GetSecureCookies()
	 */
	public String[] GetSecureCookies()
	{
		return COOKIES;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#GetSecureHeaders()
	 */
	public String[] GetSecureHeaders()
	{
		return HEADERS;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#Initialize()
	 */
	public boolean Initialize(XPHashtable mapSettings)
	{
		return true;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#Logout()
	 */
	public boolean OnLogout(IXPResponse response, String sReturnURL)
	{
        return false;
	}
}

