package com.plumtree.portaluiinfrastructure.sso.integrations;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.*;
import com.plumtree.portaluiinfrastructure.sso.*;

/**
 * SSO Integration file for Oblix NetPoint.
 *
 * @author Mike Jahr
 */
public class Oblix implements ISSOIntegration
{
	private static final String[] HEADERS = null;
	private static final String[] COOKIES = { "ObSSOCookie" };

	/**
	 * @see com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#GetLoginInfo(IXPRequest)
	 */
	public SSOLoginInfo GetLoginInfo(IXPRequest request)
	{
		return new SSOLoginInfo(request.GetHeader("UID"));
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#GetSSOProductName()
	 */
	public String GetSSOProductName()
	{
		return "Oblix NetPoint";
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#GetSecureCookies()
	 */
	public String[] GetSecureCookies()
	{
		return COOKIES;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#GetSecureHeaders()
	 */
	public String[] GetSecureHeaders()
	{
		return HEADERS;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#Initialize()
	 */
	public boolean Initialize(XPHashtable mapSettings)
	{
		return true;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.sso.ISSOIntegration#Logout()
	 */
	public boolean OnLogout(IXPResponse response, String sReturnURL)
	{
        return false;
	}
}

