package com.plumtree.portaluiinfrastructure.subscribematrix;


// Framework Imports
import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.editor.commonpages.objectsecurity.*;

/**
 * This interface is implemented by the Model.
 * It contains all the read-only mothods of the Model
 * accessed by the Views.
 *
 * @author Julie Fournier
 */
public interface IMultiObjectsSubscribeModelRO extends IObjectSecurityModelRO
{
	public int GetJobID();
	
	public String GetJobName();
	
	public String GetJobFolderName();

	/**
	 * @see com.plumtree.portaluiinfrastructure.securitymatrix.MultiObjectsSecurityModel#GetColumns()
	 *
	 */
	public int[] GetColumns();

	/**
	 * @see com.plumtree.portaluiinfrastructure.securitymatrix.MultiObjectsSecurityModel#GetObjectArray()
	 *
	 */
	public XPArrayList GetObjectArray();
}

