package com.plumtree.portaluiinfrastructure.subscribematrix;


// Framework Imports
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.expandablelist.*;
import com.plumtree.uiinfrastructure.form.*;

/**
 * This class contains the additional repost actions.
 * The ones specific to this Editor.
 *
 * @author Julie Fournier
 */
public class SubscribeMatrixRepostControl extends EditorRepostControl
{
	/**
	 * Class name for the activity space */
	public static final String STR_MVC_CLASS_NAME = "SubscribeMatrixRepost";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new SubscribeMatrixRepostControl();
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Switch between the action modes and call
	 * the associated method for each action.
	 *
	 * @param int
	 */
	protected void PerformAction(int _nAction)
	{
		// abo - set false for non-normal finish
		boolean doNormalFinish = false;

		// abo - where to go next page
		Redirect myRedirect = null;
		
		((ExpListControl) m_asOwner.GetControl(SubscribeMatrixEditorAS.STR_MVC_STORAGE_NAME_MULTI_SUBSCRIBE)).
			PerformRepostAction(_nAction, m_htFormData);

		// abo - intercept done button. if there
		// were subscriptions, then redirect 
		// to blank DP that presents ABO option.
		if ((_nAction == POSTTOSELF_ACTION_FINISH))	
		{
			if (((SubscribeMatrixModel) m_model).HasExecutedFinish())
			{
				// execute regular finish
				doNormalFinish = true;
			}
			else
			{
				// call the finish manually
				((SubscribeMatrixModel) m_model).Finish();
			
				if (((MultiObjectsSubscribeModel) m_asOwner.
					GetModel(SubscribeMatrixEditorAS.STR_MVC_STORAGE_NAME_MULTI_SUBSCRIBE)).
					HaveSubscriptionsBeenMade())
				{
					// redirect to a blank page that will
					// popup the results of the created job
					myRedirect = new Redirect();
					myRedirect.SetLinkGetCachedSpace(m_asOwner);
					myRedirect.SetDisplayPage(ABOSubBlankResultsDP.STR_MVC_CLASS_NAME);
					SetRedirect(myRedirect);
				}
			}
		}

		if ((doNormalFinish && POSTTOSELF_ACTION_FINISH == _nAction) || (POSTTOSELF_ACTION_CANCEL == _nAction))
		{
			myRedirect = new Redirect();
			myRedirect.SetLinkGetCachedSpace(m_asOwner);
			myRedirect.SetDisplayPage(ClosePopUpDP.STR_MVC_CLASS_NAME);

			SetRedirect(myRedirect);
		}
	}
}

