/**
 * 
 */
package com.plumtree.portaluiinfrastructure.tags;

import com.plumtree.portaluiinfrastructure.tags.tagdef.*;
import com.plumtree.xpshared.htmlelements.*;


/**
 * Base class for Tags that retrieves and displays stored Tag Output Definitions 
 * 
 * @author rozhang
 */
public abstract class ATagDefDisplay extends ATag
{
	/**
	 * Retrieves stored Tag Output Definition and returns the transformed content
	 * 
	 * @param defId
	 * @param version
	 * @return null value if the definition wasn't found
	 */
	protected HTMLElement ProcessStoredTagContent(String defId, String version)
	{
		TagOutputDefinitionManager mgr = TagOutputDefinitionManager.GetInstance();
		
		HTMLElement result = mgr.RetrieveAndSetTagDefinition(defId, version, GetTagHelper());
		
		return result;
	}

}
