package com.plumtree.portaluiinfrastructure.tags;

/**
 * This enumeration specifies the type of the tag.
 * <p>
 * SIMPLE tags call ProcessTagBody at most once,
 * whereas LOOPING tags can call it multiple times.
 * NO_BODY tags do not display any tags or HTML
 * nested inside them.
 */
public class TagType
{
	/**
	 * Does not ever call ProcessTagBody.
	 */
	public static final TagType NO_BODY = new TagType();

	/**
	 * Calls ProcessTagBody 0 or 1 times.
	 */
	public static final TagType SIMPLE = new TagType();

	/**
	 * Calls ProcessTagBody 0, 1 or more times.
	 */
	public static final TagType LOOPING = new TagType();

	/**
	 * Private constructor to ensure that instances of
	 * this class form a specific enumeration of values.
	 */
	private TagType() {}
}
