/*
 * Created on Jun 1, 2005
 */
package com.plumtree.portaluiinfrastructure.tags.data;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.tags.*;

/**
 * Helper object that defines and provides a protocol for getting  list of PTURL DO  data
 * in different Tag Scopes.
 */
public class TagDataGetterPTURLDOList
{
	// TODOCR DONH: Why is this list called PTURLDOList?  There's nothing in
	// it that's specific to PTURLDO's.  It seems like this should either be
	// generalized, or moved into one of the nav tag libraries if it's nav
	// specific.  It doesn't seem like it belongs here.  It's not part of the
	// framework.  This is something specifically for the nav taglibs, right?
	
	Scope m_scope = null;
	 
	/**
	 * Constructor 
	 *
	 */
	public TagDataGetterPTURLDOList(Scope scope)
	{
		m_scope = scope;
	}
	
	/**
	 * Gets PTURL IOD data.
	 * @param tagObj	A reference to the current Atag object
	 * @param tagAttrib	A string attribute, where its value is used as the name of the data set on the Tag Scope
	 * 
	 * @return An list with the PTURL IOD data 
	 */
	public IXPList GetMemoryData(ITagState state, String strKey)
	{
		
		
		IXPList memList = (IXPList)state.GetSharedVariable(strKey, m_scope);
		
		return memList;
		
	}
	
	/**
	 * Sets the Tag scope to set PTURL data on 
	 * 
	 * @param scope
	 */
	public void SetScope(Scope scope)
	{
		m_scope = scope;
	}
	
}
