package com.plumtree.portaluiinfrastructure.tags.manager.taglibmanager;

import com.plumtree.portaluiinfrastructure.common.constants.*;
import com.plumtree.uiinfrastructure.editor.*;
import com.plumtree.uiinfrastructure.statichelpers.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This class is used to print out the list of tag libs.
 *
 * @author donh
 */
public class TagLibDP extends EditorDP
{
	public static final String STR_MVC_CLASS_NAME = "TagLib";

	/**
	 * Returns the String to display in the left navigation menu,
	 * linking to this page.
	 *
	 * @return String
	 */
	public String GetLeftNavString()
	{
		// Tag Libraries
		return m_asOwner.GetString(772, ResourceConstants.PORTALCOMMONMSGS);
	}

	/**
	* Implement this method to add HTML below the sub header.
	*
	* @return HTMLElement
	*
	* @throws HTMLException
	*/
	protected HTMLElement GetHTMLBelowSubHeader()
	{
		// Commented out until bug#45342 is fixed - reload can
		// recycle the .net app, and doesn't really work in Java.
		// This page allows you to view and reload the tag libraries for this portal machine.
//		return HTMLConstructHelpers.GetSubHeader(
//			m_asOwner.GetString(778, ResourceConstants.PORTALCOMMONMSGS),
//			this.m_asOwner);

		// This page allows you to view the tag libraries for this portal machine.
		return HTMLConstructHelpers.GetSubHeader(
			m_asOwner.GetString(796, ResourceConstants.PORTALCOMMONMSGS),
			this.m_asOwner);
	}

	/**
	 * Returns the Class name.
	 *
	 * @return String
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * Returns the HTML for this Page.
	 *
	 * @see com.plumtree.uiinfrastructure.activityspace.AFormDP#PageDisplay()
	 *
	 * @return HTMLElement
	 * @throws HTMLException
	 */
	public HTMLElement PageDisplay()
	{
		HTMLElementCollection result = new HTMLElementCollection();

		// Insert super class HTML
		result.AddInnerHTMLElement(super.PageDisplay());

		HTMLElementCollection views = new HTMLElementCollection();

		views.AddInnerHTMLElement(((EditorView) m_asOwner.GetView(
			TagLibManagerAS.STR_MVC_STORAGE_NAME_MULTI_COLUMN_LIST)).Display());

		result.AddInnerHTMLElement(CreateLeftNavBar(views));

		return result;
	}

	/**
	 * Display the Javascripts for the Views.
	 *
	 * @return HTMLScriptCollection
	 * @throws HTMLException
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()

	{
		HTMLScriptCollection myScripts = super.DisplayJavaScriptFromChild();

		// Display JavaScript for the MultiColumn Array.
		myScripts.AddInnerHTMLElement(m_asOwner.GetView(
			TagLibManagerAS.STR_MVC_STORAGE_NAME_MULTI_COLUMN_LIST)
			.DisplayJavascript());

		return myScripts;
	}
}