package com.plumtree.portaluiinfrastructure.tags.metadata;

/**
 * This base class provides programmatic access
 * to the tag meta data for required and related
 * parent and child tags.
 * <p>
 * Adding public static final member variables of
 * the various ARelatedTag classes turns on
 * validation that a tag is being used in the
 * correct context, as well as providing useful
 * documentation information.
 */
public abstract class ARelatedTag
{
	protected ITagMetaData m_TagData;

	/**
	 * Creates a new related tag meta data object.
	 * 
	 * @param _TagData The parent tag data
	 */
	public ARelatedTag(ITagMetaData _TagData)
	{
		m_TagData = _TagData;
	}

	/**
	 * Gets the data about the related tag.
	 * 
	 * @return ITagMetaData The related tag data
	 */
	public ITagMetaData GetTagData()
	{
		return m_TagData; 
	}
}
