package com.plumtree.portaluiinfrastructure.tags.pei;

import com.plumtree.portaluiinfrastructure.tags.helper.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.pei.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This PEI resets the tag page request data at the end
 * of every HTTP request.
 * 
 * @author DonH
 */
public class TagPageActions implements IPageActions
{
	/**
	 * @see com.plumtree.uiinfrastructure.pei.IPageActions#OnPageFinish(AActivitySpace, Object, String)
	 */
	public HTMLComment OnPageFinish(AActivitySpace _asCurrentSpace,
		Object _oUserSession, String _strServerName)
	{
		// Reset the page request data at the end of every http request.
		// This could also be done at the start of the request.
		TagState.ResetPageRequestData(_asCurrentSpace);

		return null;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.pei.IPageActions#OnPageStart(AActivitySpace, Object, String)
	 */
	public void OnPageStart(AActivitySpace _asCurrentSpace,
		Object _oUserSession, String _strServerName)
	{
	}
}
