package com.plumtree.portaluiinfrastructure.tags.xml;

import com.plumtree.openfoundation.util.*;
import com.plumtree.server.*;

/**
 * Basic implementation of IXMLFragment.
 */
public class XMLFragment implements IXMLFragment
{
	private Object[][] m_arrXML;

	public XMLFragment(XPArrayList arAttributes)
	{
		int iNumAtts = arAttributes.GetSize();
		m_arrXML = new Object[PT_XML_ARRAY_COLS.PT_XML_ARRAY_NUM_COLS][iNumAtts];
			
		for (int iAtt = 0; iAtt < iNumAtts; iAtt++)
		{
			Object[] att = (Object[])arAttributes.GetElement(iAtt);
				
			m_arrXML[PT_XML_ARRAY_COLS.PT_XML_ARRAY_COLS_NAME][iAtt] = att[PT_XML_ARRAY_COLS.PT_XML_ARRAY_COLS_NAME];
			m_arrXML[PT_XML_ARRAY_COLS.PT_XML_ARRAY_COLS_VALUE][iAtt] = att[PT_XML_ARRAY_COLS.PT_XML_ARRAY_COLS_VALUE];
			m_arrXML[PT_XML_ARRAY_COLS.PT_XML_ARRAY_COLS_TYPE][iAtt] = att[PT_XML_ARRAY_COLS.PT_XML_ARRAY_COLS_TYPE];
		}	
	}

	public XMLFragment(Object[][] _objectXML)
	{
		m_arrXML = _objectXML;
	}

	/* (non-Javadoc)
	 * @see com.plumtree.transformer.xml.IXMLFragment#GetType(int)
	 */
	public int GetType(int _nRowIndex)
	{
		return XPConvert.ToInteger(
			m_arrXML[PT_XML_ARRAY_COLS.PT_XML_ARRAY_COLS_TYPE][_nRowIndex] );
	}

	/* (non-Javadoc)
	 * @see com.plumtree.transformer.xml.IXMLFragment#GetName(int)
	 */
	public String GetName(int _nRowIndex)
	{
		return XPConvert.ToString(
			m_arrXML[PT_XML_ARRAY_COLS.PT_XML_ARRAY_COLS_NAME][_nRowIndex]);
	}

	/* (non-Javadoc)
	 * @see com.plumtree.transformer.xml.IXMLFragment#GetValue(int)
	 */
	public String GetValue(int _nRowIndex)
	{
		return XPConvert.ToString(
			m_arrXML[PT_XML_ARRAY_COLS.PT_XML_ARRAY_COLS_VALUE][_nRowIndex]);
	}

	/* (non-Javadoc)
	 * @see com.plumtree.transformer.xml.IXMLFragment#GetNumberOfRows()
	 */
	public int GetNumberOfRows()
	{
		return m_arrXML[PT_XML_ARRAY_COLS.PT_XML_ARRAY_COLS_TYPE].length;
	}

	/* (non-Javadoc)
	 * @see com.plumtree.transformer.xml.IXMLFragment#GetObjectXML()
	 */
	public Object[][] GetObjectXML()
	{
		return m_arrXML;
	}
}