package com.plumtree.portaluiinfrastructure.tips;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.login.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.tips.*;


/**
 *     This is an abstract model extended by various concrete error model.
 *
 * @author Beng
 */
public class PortalTipsModel extends TipsModel
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_UI_INFRASTRUCTURE),
		"com.plumtree.portaluiinfrastructure.tips.PortalTipsModel");

	
	public static final String STR_MVC_CLASS_NAME = "PortalTipsModel";

	// JF- Associated Activity Space
	protected AActivitySpace m_asOwner;
	private boolean bDoDisplay = true;
	private boolean bDoDisplaySet = false;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new PortalTipsModel();
	}



	

	/**
	 * 
	 *
	 * @return 
	 */
	public boolean GetDoDisplayTipsBox()
	{
		
			log.Debug("GetDoDisplayTipsBox()");
		

		if (!bDoDisplaySet)
		{
			boolean bo;
			Object o = null;

			o = PTPersonalSettingsHelper.GetPersonalSettingValue(PersonalSettingNames.DISPLAY_TIPS,
					this.m_asOwner);

			if (o != null)
			{
				bo = XPConvert.ToBoolean(o);
			}
			else
			{
				bo = true;
			}

			bDoDisplay = bo;
		}

		return bDoDisplay;
	}

	/**
	 * @see com.plumtree.xpshared.activityspace.IModel#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * 
	 *
	 * @param b 
	 */
	public void SetDoDisplayTipsBox(boolean b)
	{
		bDoDisplay = b;

		PTPersonalSettingsHelper.SetAndCachePersonalSetting(PersonalSettingNames.DISPLAY_TIPS,
			new Boolean(b), this.m_asOwner);
	}
}

