package com.plumtree.portaluiinfrastructure.tree;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.tree.*;

/**
 * @author Naveen Pai
 *
 * This control is used to re-open a previously opened tree and refresh
 * the contents (which objects are selected, etc...) for a server tree.
 */
public class ServerRefreshTreeControl implements IControl
{
	/** name of the refresh tree control */
	public static final String STR_MVC_CLASS_NAME = "ServerRefreshTree";
	protected ATreeAS m_asOwner;

	/** Internal data **/
	protected ITreeModel m_asModel;

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#CheckActionSecurityAndExecute(XPHashtable)
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		String[] sValues;

		// Object ids to select (class id, object id pairs)
		sValues = (String[]) arguments.GetElement(AStartTreeControl.SELECTED_ITEMS);

		if (sValues != null)
		{
			((IServerTreeModel)m_asModel).SetLocationsToSelect(sValues[0]);
		}

		return null;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new ServerRefreshTreeControl();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#Init(IModel, AActivitySpace)
	 */
	public void Init(IModel model, AActivitySpace space)
	{
		m_asModel     = (ITreeModel) model;
		m_asOwner     = (ATreeAS) space;
	}
}

