package com.plumtree.portaluiinfrastructure.tree;

import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.tree.*;

/**
 * @author Don Hayler
 *
 */
public class ServerTreeAS extends ATreeAS
{
	/** Object Name */
	public static final String STR_MVC_CLASS_NAME = "ServerTree";

	/**
	 * @see com.plumtree.portaluiinfrastructure.activityspace.AActivitySpace#CheckBasicAccess(String, String, boolean)
	 */
	public boolean CheckBasicAccess(String strPage, String strControl,
		boolean bSameSpace)
	{
		return true;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new ServerTreeAS();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.AActivitySpace#Init()
	 */
	public void Init()
	{
		super.Init();

		RegisterModel(ServerTreeModel.STR_MVC_CLASS_NAME, TREEMODEL);

		IModel myModel = GetModel(TREEMODEL);

		RegisterView(TreeBarView.STR_MVC_CLASS_NAME,
			TreeDP.TREE_BAR_STORAGE_NAME, myModel);
		RegisterView(TreeView.STR_MVC_CLASS_NAME, myModel);

		RegisterControl(ServerStartTreeControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(TreeRepostControl.STR_MVC_CLASS_NAME, myModel);
		RegisterControl(ServerRefreshTreeControl.STR_MVC_CLASS_NAME, myModel);
	}
}

