package com.plumtree.portaluiinfrastructure.tree;

import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.tree.*;

/**
 * This adds the selected items frame at the bottom
 * 
 * @author Don Hayler
 */
public class TreeSearchFrameDP extends TreeFrameDP
{
	/** Frameset object name */
	public static final String STR_MVC_CLASS_NAME = "TreeSearchFrame";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameScrollBottom()
	 */
	public boolean GetFrameScrollBottom()
	{
		return true;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameSetAttributes()
	 */
	public String GetFrameSetAttributes()
	{
		return "40px,50%,75px";
	}

	/**
	 * @see com.plumtree.uiinfrastructure.common.FrameSetDP#GetFrameURLBottom()
	 */
	public ASURL GetFrameURLBottom()
	{
		// Display the tree itself
		ASURL result = new ASURL(m_asOwner);
		result.SetLinkGetCachedSpace(m_asOwner);
		result.SetDisplayPage(TreeSelectDP.STR_MVC_CLASS_NAME);

		return result;
	}
}

