package com.plumtree.portaluiinfrastructure.tree;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.tree.*;

/**
 * This repost control overrides the base tree repost control in order
 * to switch back to browsing mode when the user closes the tree (if it
 * is in search mode).
 * 
 * @author donh
 */
public class TreeSearchRepostControl extends TreeRepostControl
{
	public static final String STR_MVC_CLASS_NAME = "TreeSearchRepost";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#Execute()
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		Redirect result = super.CheckActionSecurityAndExecute(arguments);

		if ((m_nAction == POSTTOSELF_ACTION_FINISH) ||
			(m_nAction == POSTTOSELF_ACTION_CANCEL))
		{
			// If we are finishing out of the tree, reset it to browsing
			// mode.  This is so that if a user re-opens the tree, it is
			// in the default state rather than the search state, which
			// could be confusing.
			((IObjectTreeModel) m_model).ResetToBrowsingMode();
		}

		return result;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new TreeSearchRepostControl();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
}

