package com.plumtree.portaluiinfrastructure.tree.template;

import com.plumtree.openfoundation.util.*;
import com.plumtree.uiinfrastructure.common.*;
import com.plumtree.uiinfrastructure.tree.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * @author michaeld
 */
public class TemplateTreeHeaderDP extends TreeHeaderDP
{
	/** Frameset object name */
	public static final String STR_MVC_CLASS_NAME = "TemplateTreeHeader";

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}

	/**
	 * @see com.plumtree.uiinfrastructure.form.AFormDP#DisplayJavaScriptFromChild()
	 */
	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection scripts = new HTMLScriptCollection();

		XPStringBuilder sb = new XPStringBuilder(50);
		sb.Append("\n");
		sb.Append("var ").Append(JAVASCRIPT_SUBMIT_TRIES).Append(" = 0;\n");
		sb.Append("\n");
		sb.Append("function ").Append(JAVASCRIPT_SUBMIT_TREE).Append("()\n");
		sb.Append("{\n");

		// Check if body has been loaded yet, and retry later if it hasn't.
		sb.Append("  if (parent.").Append(FrameSetDP.BODY_FRAME).Append(".")
		.Append(TreeView.JAVASCRIPT_PAGE_LOADED).Append(" == false) {\n");
		sb.Append("    if (").Append(JAVASCRIPT_SUBMIT_TRIES).Append(" < 5) {\n");
		sb.Append("      ").Append(JAVASCRIPT_SUBMIT_TRIES).Append("++;\n");
		// The page is not loaded yet.  Try to run this function again in one second
		sb.Append("      setTimeout(\"").Append(JAVASCRIPT_SUBMIT_TREE).Append("()\", 1000);\n");
		sb.Append("    } else {\n");
		sb.Append("      ").Append(JAVASCRIPT_SUBMIT_TRIES).Append(" = 0;\n");
		sb.Append("    }\n");
		sb.Append("    return false;\n");
		sb.Append("  }\n");

		sb.Append("  parent.").Append(FrameSetDP.BODY_FRAME).Append(".")
		.Append(JAVASCRIPT_SUBMIT_FORM).Append("(").Append(TemplateTreeRepostControl.POSTTOSELF_ACTION_SELECTTEMPLATE).Append(");\n");
		sb.Append("  return false;\n");
		sb.Append("}\n");

		HTMLScript myScript = new HTMLScript("text/javaScript");
		myScript.AddInnerHTMLString(sb.ToString());
		scripts.AddInnerHTMLElement(myScript);

		return scripts;
	}
}
