package com.plumtree.portaluiinfrastructure.tree.template;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openlog.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.tree.*;

/**
 * @author michaeld
 */
public class TemplateTreeRepostControl extends TreeRepostControl
{
	private static OpenLogger log = OpenLogService.GetLogger(
		OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADMIN),
		"com.plumtree.portalpages.browsing.editors.community.templatetree.TemplateTreeRepostControl");
	
	public static final String STR_MVC_CLASS_NAME = "TemplateTreeRepost";
	
	public static final int POSTTOSELF_ACTION_SELECTTEMPLATE = 99;
	
	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IManagedObject#Create()
	 */
	public Object Create()
	{
		return new TemplateTreeRepostControl();
	}

	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IMVCObject#GetName()
	 */
	public String GetName()
	{
		return STR_MVC_CLASS_NAME;
	}
	
	/**
	 * @see com.plumtree.uiinfrastructure.activityspace.IControl#CheckActionSecurityAndExecute(com.plumtree.openfoundation.util.XPHashtable)
	 */
	public Redirect CheckActionSecurityAndExecute(XPHashtable arguments)
	{
		Redirect result = super.CheckActionSecurityAndExecute(arguments);
		
		if (POSTTOSELF_ACTION_SELECTTEMPLATE == m_nAction)
		{
			result.SetDisplayPage(InheritTemplateDP.STR_MVC_CLASS_NAME);
		}
		
		return result;
	}
	
	/**
	 * @see com.plumtree.uiinfrastructure.form.RepostControl#SetRepostAction()
	 */
	protected void SetRepostAction()
	{
		super.SetRepostAction();
		
		if (POSTTOSELF_ACTION_SELECTTEMPLATE == m_nAction && ((TemplateTreeModel)m_model).GetDisplayInheritTemplate())
		{
			m_nAction = POSTTOSELF_ACTION_FINISH;
		}
	}
	
	/**
	 * @see com.plumtree.uiinfrastructure.form.RepostControl#PerformAction(int)
	 */
	protected void PerformAction(int _nAction)
	{
		super.PerformAction(_nAction);
		
		if (POSTTOSELF_ACTION_CANCEL == m_nAction)
		{
			((TemplateTreeModel)m_asOwner.GetModel(TemplateTreeAS.TREEMODEL)).SetDisplayInheritTemplate(false);
		}
	}
}
