package com.plumtree.portaluiinfrastructure.mock.friendlyurl;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.classtypedescriptors.*;
import com.plumtree.portaluiinfrastructure.classtypedescriptors.providerframework.*;
import com.plumtree.portaluiinfrastructure.friendlyurl.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.opener.types.*;

public class MockClassTypeDescManager implements
	IClassTypeManager, IPTClassTypeDescManager, IFriendlyURLManager
{	
	private XPHashtable m_htLookupTable;
	private XPHashtable m_htCLSIDToEnglish;
	private XPHashtable m_htEnglishToProvInfo;

	public Redirect GetFriendlyViewOpenerRedirect(IFriendlyURLParser _fURLParser, AActivitySpace _asParent, Object _userSession) {
		if (null != _fURLParser.GetClassId() && null != _fURLParser.GetObjectName(false)) {
			return new Redirect();
		} else {
			return null;
		}
	}

	public String LookupFriendlyURLKeyFromClassId(String _strClassId) {
		return (String) m_htLookupTable.GetElement(_strClassId);
	}

	public void SetFriendlyURLLookupTable(XPHashtable htLookupTable) {
		m_htLookupTable = htLookupTable;
	}
	
	public String ConstructFriendlyURL(FriendlyURL url, AActivitySpace space) {
		return "";
	}

	public int GetDefaultOpenerMode(String arg0) {
		// TODO Auto-generated method stub
		return 0;
	}

	public Redirect GetOpenerRedirect(String arg0, int arg1, XPHashtable arg2, AActivitySpace arg3, Object arg4) {
		// TODO Auto-generated method stub
		return null;
	}

	public String GetProviderEnglishNameForExistingObject(int _nClassID, int _nObjectID, IPTSession _ptSession) {
		// TODO Auto-generated method stub
		return null;
	}

	public void SetCLSIDToEnglishNameLookupTable(XPHashtable htCLSIDLookupTable) {
		m_htCLSIDToEnglish = htCLSIDLookupTable;
	}

	public String GetProviderEnglishNameGivenCLSID(String _sCLSID) {
		return (String) m_htCLSIDToEnglish.GetElement(_sCLSID);
	}

	public IProvInfo[] GetRegisteredProvInfoForClassType(int _nClassID) {
		// TODO Auto-generated method stub
		return null;
	}

	public void SetEnglishToProvInfoLookupTable(XPHashtable htProvInfoLookupTable) {
		m_htEnglishToProvInfo = htProvInfoLookupTable;
	}

	public IProvInfo GetRegisteredProvInfoGivenEnglishName(String _strProvInfoEngName) {
		return (IProvInfo) m_htEnglishToProvInfo.GetElement(_strProvInfoEngName);
	}
}