/**
 * 
 */
package com.plumtree.portaluiinfrastructure.mock.pathways.tagging;

import com.plumtree.openfoundation.util.IXPList;
import com.plumtree.openfoundation.util.XPArrayList;
import com.plumtree.openfoundation.util.XPException;
import com.plumtree.openfoundation.util.XPHashtable;
import com.plumtree.openfoundation.util.XPIllegalStateException;
import com.plumtree.openfoundation.util.XPStringUtility;
import com.plumtree.portaluiinfrastructure.pathways.tagging.ITaggingModel;
import com.plumtree.portaluiinfrastructure.pathways.tagging.TaggingControl;
import com.plumtree.portaluiinfrastructure.restconsumerframework.pathways.PathwaysConstants;
import com.plumtree.portaluiinfrastructure.tags.data.HashtableDataObject;
import com.plumtree.uiinfrastructure.activityspace.AActivitySpace;
import com.plumtree.uiinfrastructure.activityspace.IModel;

/**
 * @author Ravi Tunuguntla
 *
 */
public class MockTaggingModel implements IModel, ITaggingModel {
	
	
	private XPHashtable m_relatedResourcesMap;
	public boolean m_bTagged = false;
	
	public boolean m_bUnTagged = false;
	
	private String m_strTag = null;
	
	private String m_strId = null;
	private int m_nAction;
	private String m_strSource = null;

	/* (non-Javadoc)
	 * @see com.plumtree.portaluiinfrastructure.pathways.tagging.ITaggingModel#AddRemoveObjectTag(java.lang.String, java.lang.String, int, String)
	 */
	public void AddRemoveObjectTag(String tag, String id, int action, String ptsource) throws XPIllegalStateException {
		
		m_strTag = tag;
		m_strId = id;
		m_nAction = action;
		m_strSource = ptsource;
		
		
		m_bTagged = ( (null != m_strTag) 
						&& (XPStringUtility.IndexOf(m_strId, "_") > 0) 
						&& (XPStringUtility.Compare(m_strSource, PathwaysConstants.PTSOURCE_PORTAL) == 0) 
						&& (m_nAction == 0 || m_nAction == 2) );

		m_bUnTagged =  ( (null != m_strTag) 
						&& (XPStringUtility.IndexOf(m_strId, "_") > 0) 
						&& (XPStringUtility.Compare(m_strSource, PathwaysConstants.PTSOURCE_PORTAL) == 0) 
						&& (m_nAction == 1) ); 
		
	}

	/* (non-Javadoc)
	 * @see com.plumtree.portaluiinfrastructure.pathways.tagging.ITaggingModel#RenameObjectTag(java.lang.String, java.lang.String, java.lang.String, java.lang.String)
	 */
	public void RenameObjectTag(String tag, String id, String ptsource, String renametag) throws XPIllegalStateException {
		m_strTag = renametag;
		m_strId = id;
		m_nAction = TaggingControl.ACTION_RENAME_TAG;
		m_strSource = ptsource;		
		
		m_bTagged = ( (null != m_strTag)
						&& (null != tag)
						&& (XPStringUtility.IndexOf(m_strId, "_") > 0) 
						&& (XPStringUtility.Compare(m_strSource, PathwaysConstants.PTSOURCE_PORTAL) == 0) 
						&& (m_nAction == 0 || m_nAction == 2) );

		m_bUnTagged =  ( (null != m_strTag)
						&& (null != tag)
						&& (XPStringUtility.IndexOf(m_strId, "_") > 0) 
						&& (XPStringUtility.Compare(m_strSource, PathwaysConstants.PTSOURCE_PORTAL) == 0) 
						&& (m_nAction == 1) );
	}
	
	/* (non-Javadoc)
	 * @see com.plumtree.portaluiinfrastructure.pathways.tagging.ITaggingModel#GetObjectTags(int)
	 */
	public IXPList GetObjectTags(int id) {
		
		return null;
	}

	/* (non-Javadoc)
	 * @see com.plumtree.portaluiinfrastructure.pathways.tagging.ITaggingModel#IsTaggingEnabled()
	 */
	public boolean IsTaggingEnabled() {
		// TODO Auto-generated method stub
		return false;
	}

	public void CleanupAllData() {
		// TODO Auto-generated method stub
		
	}

	public void CleanupTempData() {
		// TODO Auto-generated method stub
		
	}

	public void Init(AActivitySpace parent) {
		m_relatedResourcesMap = new XPHashtable();
	}

	public String GetName() {
		// TODO Auto-generated method stub
		return TaggingControl.STR_MVC_CLASS_NAME;
	}

	public Object Create() {
		// TODO Auto-generated method stub
		return null;
	}

	public XPException GetPathwaysTaggingError() {
		// TODO Auto-generated method stub
		return null;
	}

	public void SetPathwaysTaggingError(XPException e) {
		// TODO Auto-generated method stub
		
	}

}
