package com.plumtree.portaluiinfrastructure.mock.restapi;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.restconsumerframework.*;

public class MockRestRequest extends RestRequest 
{
	protected String m_responseFileLocation = null;
	protected String m_responseContent 		= null;
	
	public MockRestRequest(String content, boolean loadFile)
	{
		if (loadFile) {
			m_responseFileLocation  = content;
		} else {
			m_responseContent 		= content;
		}
		
	}
	
	public IRestResponse Submit()
	{
		IRestResponse response = null;
		String content = null;
		
		if ( m_responseFileLocation != null) {
			
		}
		else if ( m_responseContent != null) {
			content = m_responseContent;
		}
		else {
			return null;
		}
		
		if ( content.startsWith("<?xml") ) {
				response = new RestXMLResponse(content);
			} else if ( content.startsWith("{") ) {
				// @TODO once we have a jumpable JSON parser
				throw new XPNotImplementedException("Rest JSON Responses are not supported by this framework at this time.");
			} else  {
				throw new XPIllegalStateException("Unknown REST response received, unable to parse as either XML or JSON: "+content);
			}
		return response;
	}
	
	

}
