package com.plumtree.portaluiinfrastructure.mock.tags;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.portaluiinfrastructure.tags.helper.*;
import com.plumtree.portaluiinfrastructure.tags.manager.*;
import com.plumtree.portaluiinfrastructure.tags.metadata.*;

public class MockTagLibManager implements ITagLibManager
{
	public XPHashtable m_libraries = new XPHashtable();
	public XPHashtable m_tags = new XPHashtable();
	public String m_strTagLibrary;

	public void SetLibraries(XPHashtable _libraries)
	{
		m_libraries = _libraries;
	}

	public XPHashtable GetLibraries()
	{
		return m_libraries;
	}

	public XPArrayList GetLibraryTagList(String _sLibname, double _dVersion) {
		// TODO Auto-generated method stub
		return null;
	}

	public XPArrayList GetLibraryTags(String _sLibname, double _dVersion) {
		// TODO Auto-generated method stub
		return null;
	}

	public int GetNumCustomTagLibraries() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetNumCustomTags() {
		// TODO Auto-generated method stub
		return 0;
	}

	public void SetTag(ATag _tag, String _strName, String _strLibrary)
	{
		m_tags.PutElement(_strName, _tag);

		if ((m_strTagLibrary != null) && !m_strTagLibrary.equals(_strLibrary))
		{
			throw new XPIllegalStateException("Mock Tag Library only supports a single library. Can't replace " +
				m_strTagLibrary + " with " + _strLibrary + ".");
		}
		m_strTagLibrary = _strLibrary;

		m_libraries.PutElement(_strLibrary, new Object());

		TagLibraryMetaData libraryData = new TagLibraryMetaData(_strLibrary + " Display Name",
			_strLibrary, _strLibrary + " Description", 1.0);

		TagMetaDataHelper helper = new TagMetaDataHelper();
		helper.Init(_tag, libraryData);
		_tag.SetTagMetaDataHelper(helper);
	}

	public ATag GetTag(String _strTagName, String _strLibraryName,
	        double _dLibraryVersion)
	{
		if (_strLibraryName.equals(m_strTagLibrary))
		{
			return (ATag) m_tags.GetElement(_strTagName);
		}

		return null;
	}

	public ATag GetTag(String _strTagName, String _strLibraryName)
	{
		if (_strLibraryName.equals(m_strTagLibrary))
		{
			ATag template = (ATag) m_tags.GetElement(_strTagName);
			ATag instance = template.Create();
			TagLibraryMetaData libraryData = new TagLibraryMetaData(_strLibraryName + " Display Name",
					_strLibraryName, _strLibraryName + " Description", 1.0);
			
			TagMetaDataHelper helper = new TagMetaDataHelper();
			helper.Init(instance, libraryData);
			instance.SetTagMetaDataHelper(helper);
			
			return instance;
		}

		return null;
	}

	public TagLibraryMetaData GetTagLibMetadata(String _sLibname,
			double _dVersion) {
		// TODO Auto-generated method stub
		return null;
	}

	public void GetTagMetadata(String _sLibname, double _dVersion,
			String _sTagname) {
		// TODO Auto-generated method stub

	}

	public boolean HasTag(String _strTagName, String _strLibraryName,
			double _dLibraryVersion) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean HasTag(String _strTagName, String _strLibraryName) {
		// TODO Auto-generated method stub
		return false;
	}

	public void LoadClasses(String strLibDir, String strConfigFile) {
		// TODO Auto-generated method stub

	}

	public void LoadCustomClasses(String strLibDir, String strConfigFile) {
		// TODO Auto-generated method stub

	}

	public void ReloadAllTagLibraries() {
		// TODO Auto-generated method stub

	}

	public void ReloadTagLibrary(String _sLibname, double _dVersion) {
		// TODO Auto-generated method stub

	}
}