package com.plumtree.portaluiinfrastructure.mock.uiinfrastructure;

import com.plumtree.openfoundation.internationalization.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.helpers.*;
import com.plumtree.xpshared.htmlelements.*;

public class MockConfigHelper implements IConfigHelper
{
	public static final String MOCK_PREFIX = "Mock-JS-";
	public static final String MOCK_BASE_URL = "http://mock.base.com/portal/server.pt?";

	public String GetJSIncluderComponentPath(String strJSComponentName, String strImageServerURL) {
		return MOCK_PREFIX + strJSComponentName;
	}

	public HTMLElementCollection GetJSIncluderJSComponentInclude(String strJSComponentName, AActivitySpace owner) {
		HTMLElementCollection result = new HTMLElementCollection();
		result.AddInnerHTMLString(MOCK_PREFIX + strJSComponentName);
		return result;
	}

	public HTMLElementCollection GetJSIncluderJSComponentInclude(String strJSComponentName, boolean bEnableDebug, AActivitySpace owner,  XPLocale locale) {
		HTMLElementCollection result = new HTMLElementCollection();
		result.AddInnerHTMLString(MOCK_PREFIX + strJSComponentName);
		return result;
	}

	public String GetJSIncluderVersionPrefix(String strJSComponentName) {
		return MOCK_PREFIX + strJSComponentName;
	}

	public String GetApplicationBaseURL(String _sNormalizedBaseURL, boolean _bSecure) {
		return MOCK_BASE_URL;
	}

	public String GetApplicationBaseURL(AActivitySpace asSpace) {
		return MOCK_BASE_URL;
	}

	public String GetApplicationBaseURL(String _sNormalizedBaseURL) {
		return MOCK_BASE_URL;
	}

	public String GetApplicationBaseURLToAS(String _sNormalizedBaseURL, String _sASName, boolean _bIsSubSpace) {
		return MOCK_BASE_URL;
	}

	public String GetHTTPEntryPoint() {
		return "server.pt";
	}

	public String GetMainServerApplicationURL(boolean _bIsSecure) {
		// TODO Auto-generated method stub
		return null;
	}
	
	public String GetImageServerBaseURL(AActivitySpace asSpace) {
		return MOCK_BASE_URL;
	}

	public String GetNormalizedBaseURL(String _sURL) {
		return MOCK_BASE_URL;
	}
}