package com.plumtree.portaluiinfrastructure.test;

import junit.framework.*;
import xpunit.framework.*;

import com.plumtree.portaluiinfrastructure.test.friendlyurl.*;
import com.plumtree.portaluiinfrastructure.test.helper.HelperTestSuite;
import com.plumtree.portaluiinfrastructure.test.layout.*;
import com.plumtree.portaluiinfrastructure.test.pathways.PathwaysTestSuite;
import com.plumtree.portaluiinfrastructure.test.search.SearchTestSuite;
import com.plumtree.portaluiinfrastructure.test.server.*;
import com.plumtree.portaluiinfrastructure.test.statichelpers.*;
import com.plumtree.portaluiinfrastructure.test.tags.*;
import com.plumtree.portaluiinfrastructure.test.uiinfrastructure.*;

/**
 * @author danielf
 *
 */
public class PortalUIInfrastructureTestSuite
{
	public static final String SUITENAME = "Portal UI Infrastructure Unit Tests";

	public static Test suite() {
		XpTestSuite suite = new XpTestSuite(SUITENAME);
        suite.addTest(LayoutTestSuite.suite());
        suite.addTest(FriendlyURLTestSuite.suite());
        suite.addTest(TagsTestSuite.suite());
		suite.addTestSuite(GatewayHelpersTest.class);
        suite.addTest(UIInfrastructureTestSuite.suite());
        suite.addTest(ServerUnitTestSuite.suite());
        suite.addTest(PathwaysTestSuite.suite());
        suite.addTest(SearchTestSuite.suite());
        suite.addTest(HelperTestSuite.suite());
 		return suite;
	}
}