package com.plumtree.portaluiinfrastructure.test.friendlyurl;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.friendlyurl.*;
import com.plumtree.server.*;

import junit.framework.*;

public class FriendlyURLParserTest extends TestCase {
	
	protected IFriendlyURLParser testObject;
	protected String objectName = "object name";
	protected String objectNameNormalized = "object_name";
	
	/**
	 */
	public FriendlyURLParserTest(String name)
   	{
		super(name);
   	}
   
   	/**
	 * Setup if any is required.
	 */
   	public void setUp() throws Exception
   	{
   		super.setUp();
   		XPStringTokenizer stURLTokens = new XPStringTokenizer("/" + objectNameNormalized + "/", "/", false);
   		testObject = new FriendlyURLParser("mypages", XPConvert.ToString(PT_CLASSIDS.PT_MYPAGESCONTAINER_ID), stURLTokens);
   	}
   	
   	/**
	 * @see TestCase#tearDown()
	 */
	public void tearDown() throws Exception
	{
		super.tearDown();
		testObject = null;
	}

	public void testGetObjectName() 
	{
		String name = testObject.GetObjectName(false);
		Assert.assertEquals("Wrong name was returned.", name, objectNameNormalized);
	}
	
	public void testGetObjectNameDeNormalized() 
	{
		String name = testObject.GetObjectName(true);
		Assert.assertEquals("Wrong name was returned.", name, objectName);
	}
}
