package com.plumtree.portaluiinfrastructure.test.friendlyurl;

import com.plumtree.portaluiinfrastructure.friendlyurl.*;

import junit.framework.*;

public class FriendlyURLTest extends TestCase {
	
	protected String strDeNormalizedString1 = "test name";
	protected String strNormalizedString1 = "test_name";
	protected String strDeNormalizedString2 = "test  name";
	protected String strNormalizedString2 = "test__name";
	protected String strDeNormalizedString3 = "test na-me";
	protected String strNormalizedString3 = "test_na-me";
	
	protected String specialCharString = "!@#$%^&*<>()-=~?";
	protected String deNormalizedSpecialCharString = "!@ $      ()-=~ ";
	protected String normalizedSpecialCharString = "!@_$______()-=~_";
	
	/**
	 */
	public FriendlyURLTest(String name)
   	{
		super(name);
   	}
   
   	/**
	 * Setup if any is required.
	 */
   	public void setUp() throws Exception
   	{
   		super.setUp();
   	}
   	
   	/**
	 * @see TestCase#tearDown()
	 */
	public void tearDown() throws Exception
	{
		super.tearDown();
	}

	public void testNormalizeObjectName() 
	{
		String test1 = FriendlyURL.NormalizeObjectName(strDeNormalizedString1);
		Assert.assertEquals(test1, strNormalizedString1);
		
		String test2 = FriendlyURL.NormalizeObjectName(strNormalizedString1);
		Assert.assertEquals(test2, strNormalizedString1);
		
		String test3 = FriendlyURL.NormalizeObjectName(strDeNormalizedString2);
		Assert.assertEquals(test3, strNormalizedString2);
		
		String test4 = FriendlyURL.NormalizeObjectName(strDeNormalizedString3);
		Assert.assertEquals(test4, strNormalizedString3);
		
		String test5 = FriendlyURL.NormalizeObjectName(specialCharString);
		Assert.assertEquals(normalizedSpecialCharString, test5);
	}
	
	public void testDeNormalizeObjectName() 
	{
		String test1 = FriendlyURL.DeNormalizeObjectName(strNormalizedString1);
		Assert.assertEquals(test1, strDeNormalizedString1);
		
		String test2 = FriendlyURL.DeNormalizeObjectName(strNormalizedString2);
		Assert.assertEquals(test2, strDeNormalizedString2);
		
		String test3 = FriendlyURL.DeNormalizeObjectName(strNormalizedString3);
		Assert.assertEquals(test3, strDeNormalizedString3);
		
		String test4 = FriendlyURL.DeNormalizeObjectName(specialCharString);
		Assert.assertEquals(deNormalizedSpecialCharString, test4);
	}
}
