package com.plumtree.portaluiinfrastructure.test.friendlyurl;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.friendlyurl.*;
import com.plumtree.server.*;

import junit.framework.*;

public class KDFriendlyURLParserTest extends TestCase {
	
	protected KDFriendlyURLParser testObject;
	protected String objectName = "object name";
	protected String objectNameNormalized = "object_name";
	protected int objectId = 200;
	
	/**
	 */
	public KDFriendlyURLParserTest(String name)
   	{
		super(name);
   	}
   
   	/**
	 * Setup if any is required.
	 */
   	public void setUp() throws Exception
   	{
   		super.setUp();
   	}
   	
   	/**
	 * @see TestCase#tearDown()
	 */
	public void tearDown() throws Exception
	{
		super.tearDown();
		testObject = null;
	}

	public void testGetObjectNameAndId() 
	{
		XPStringTokenizer stURLTokens = new XPStringTokenizer("/" + objectNameNormalized + "/" + objectId, "/", false);
   		testObject = new KDFriendlyURLParser("directory", XPConvert.ToString(PT_CLASSIDS.PT_CATALOGFOLDER_ID), stURLTokens);
   		
		String name = testObject.GetObjectName(true);
		Assert.assertEquals("Wrong name was returned.", name, objectName);
		int id = testObject.GetObjectId();
		Assert.assertEquals("Wrong id was returned.", id, objectId);
	}
}
