package com.plumtree.portaluiinfrastructure.test.tags;

import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.portaluiinfrastructure.tags.metadata.*;

/**
 * This is a test tag implementation.
 * 
 * @author donh
 */
public class TestTag extends ATestTag
{
	// Constants for tests
	public static final String DEFAULT_STRING_VALUE = "default";
	public static final String DEFAULT_INT_VALUE_STRING = "57";

	// Tag Data
	public static ITagMetaData TAG = new TagMetaData("test", "test description");

	//Required
	public static RequiredTagAttribute TESTATTRIBUTE = new RequiredTagAttribute("testattr", "test attr description");
	public static RequiredTagAttribute TESTREQINTATTRIBUTE = new RequiredTagAttribute("testreqintattr", "test required int attr description", AttributeType.INT);

	// Optional
	public static OptionalTagAttribute TESTINTATTRIBUTE = new OptionalTagAttribute("testintattr", "test int attr description",
		AttributeType.INT, "65");
	public static OptionalTagAttribute TEST2ATTRIBUTE = new OptionalTagAttribute("testattr2", "test attr2 description",
		AttributeType.STRING, DEFAULT_STRING_VALUE);
	public static OptionalTagAttribute TESTINT2ATTRIBUTE = new OptionalTagAttribute("testintattr2", "test int attr2 description",
		AttributeType.INT, DEFAULT_INT_VALUE_STRING);
	public static OptionalTagAttribute TESTBADINTATTRIBUTE = new OptionalTagAttribute("testbadintattr", "test bad int attr description",
		AttributeType.INT, DEFAULT_INT_VALUE_STRING);

	// Required Parent Tag (at least one must be present)
	// NOTE: This will not work because it is pointing to itself.
	public static RequiredParentTag REQUIRED_PARENT_A = new RequiredParentTag(TAG);
	public static RequiredParentTag REQUIRED_PARENT_B = new RequiredParentTag(TAG);

	// Required Child Tags -- NOTE: This has to be an array, otherwise the fake ITagMetaData's will
	// break meta data discovery.
	public static ITagMetaData[] REQUIRED_CHILDREN_FOR_TEST = new ITagMetaData[]
	{ new TagMetaData("test1", "test1 description"), new TagMetaData("test2", "test2 description") };
	public static RequiredChildTag REQUIRED_FIRST_CHILD = new RequiredChildTag(REQUIRED_CHILDREN_FOR_TEST[0]);
	public static RequiredChildTag REQUIRED_SECOND_CHILD = new RequiredChildTag(REQUIRED_CHILDREN_FOR_TEST[1]);

	// Related Child Tags -- NOTE: This will work because it used for documentation only.
	public static RelatedChildTag RELATED_FIRST_CHILD = new RelatedChildTag(TAG);
	public static RelatedChildTag RELATED_SECOND_CHILD = new RelatedChildTag(TAG);

	/* (non-Javadoc)
	 * @see com.plumtree.portaluiinfrastructure.tags.ATag#ReleaseTag()
	 */
	public void ReleaseTag()
	{
		// TODO Auto-generated method stub
	}

	/* (non-Javadoc)
	 * @see com.plumtree.portaluiinfrastructure.tags.ATag#Create()
	 */
	public ATag Create()
	{
		return new TestTag();
	}
}