package com.plumtree.portaluiinfrastructure.test.uiinfrastructure.arraywrapper;

import com.plumtree.uiinfrastructure.arraywrapper.*;

import xpunit.framework.*;

public class PTGrowableSortedArrayWrapperTest extends XpTestCase
{
	public static final int COLUMN_1 = 1;
	public static final int COLUMN_2 = 2;

	/**
	 * This tests trying to add an empty row to an array.
	 * 
	 * Portal bugs#64151
	 */
	public static void testAddEmptyArray()
	{
		PTGrowableSortedArrayWrapper wrapper = new PTGrowableSortedArrayWrapper();

		// Column mapping
		int[] arrColumns = new int[] { COLUMN_1, COLUMN_2 };

		// Sort array
		// The array will always be sorted by the 1st column.
		int[][] arrSort = new int[1][2];
		arrSort[0][PTSortedArrayWrapper.PTSAW_SORT_ROW_PROPID]		  = COLUMN_1;
		arrSort[0][PTSortedArrayWrapper.PTSAW_SORT_ROW_DIRECTION]     = PTSortedArrayWrapper.PTSAW_SORT_ASCENDING;

		// Don't initalize the list itself (null below)
		wrapper.Initialize(arrColumns, null, arrSort, true);

		Object[][] emptyRows = new Object[][] { null, null, null };

		// This used to throw an NPE.
		wrapper.AddRows(emptyRows);
	}
}
