using System;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.taskapi.portalui;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.common
{
  /// <summary>
  /// Tag that displays current imageserver url
  /// </summary>
  /// <author>rozhang</author>
  public class ImageServerUrlTag : ATag
  {
    public static readonly ITagMetaData TAG;
    static ImageServerUrlTag()
    {
      // The TAG member variable needs to be initialized first since it can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("imageserverurl", "Outputs the imageserver url for the current page. If the page is in secured mode the secure imageserver url is returned.",
       EncodeForTagDoc("<pt:common.imageserverurl/>"));
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()"></seealso>
    public override HTMLElement DisplayTag()
    {
      AActivitySpace space = (AActivitySpace) GetEnvironment();
      String imgsvrUrl = TaskAPIUIPortalConfig.GetImageServerBaseURL(space);
      return new HTMLGenericElement(imgsvrUrl);
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#Create()"></seealso>
    public override ATag Create()
    {
      return new ImageServerUrlTag();
    }
  }
}