using System;
using com.plumtree.openfoundation.util;
namespace com.plumtree.taglib.logic
{
  public class ArithmeticOperators
  {
    public static readonly ArithmeticOperators OP_ADD = new ArithmeticOperators("+");
    public static readonly ArithmeticOperators OP_SUBTRACT = new ArithmeticOperators("-");
    public static readonly ArithmeticOperators OP_MULTIPLY = new ArithmeticOperators("*");
    public static readonly ArithmeticOperators OP_DIVIDE = new ArithmeticOperators("/");
    public static readonly ArithmeticOperators OP_MOD = new ArithmeticOperators("%");
    public static readonly ArithmeticOperators[] ops = {OP_ADD, OP_SUBTRACT,
     OP_MULTIPLY, OP_DIVIDE, OP_MOD};
    protected String m_strOperator;
    private ArithmeticOperators(String _strOperator)
    {
      m_strOperator = _strOperator;
    }
    
    /// <summary>
    /// Helper method to convert a string constant into an airthmetic operator.
    /// </summary>
    /// <param name="_strOperator"></param>
    /// <returns>The corresponding IntOperator.</returns>
    public static ArithmeticOperators GetArithmeticOperator(String _strOperator)
    {
      for (int i = 0;i < ops.Length;i++)
      {
        if (0 == XPStringUtility.Compare(ops[i].m_strOperator, _strOperator))
        {
          return ops[i];
        }
      }
      throw new XPIllegalArgumentException("Unable to convert string operator " + _strOperator + " into an IntOperator.  Invalid value.");
      }
    
    /// <returns>The underlying String constant.</returns>
    public override String ToString()
    {
      return m_strOperator;
    }
  }
}