using System;
using com.plumtree.openfoundation.util;
namespace com.plumtree.taglib.logic
{
  public class BooleanOperators
  {
    public static readonly BooleanOperators OP_AND = new BooleanOperators("&&");
    public static readonly BooleanOperators OP_OR = new BooleanOperators("||");
    public static readonly BooleanOperators OP_EQUAL = new BooleanOperators("==");
    public static readonly BooleanOperators OP_NOT_EQUAL = new BooleanOperators("!=");
    public static readonly BooleanOperators[] ops = {OP_AND, OP_OR, OP_EQUAL,
     OP_NOT_EQUAL};
    protected String m_strOperator;
    private BooleanOperators(String _strOperator)
    {
      m_strOperator = _strOperator;
    }
    
    /// <summary>
    /// Helper method to convert a string constant into a boolean operator.
    /// </summary>
    /// <param name="_strOperator"></param>
    /// <returns>The corresponding BooleanOperator.</returns>
    public static BooleanOperators GetBooleanOperator(String _strOperator)
    {
      for (int i = 0;i < ops.Length;i++)
      {
        if (0 == XPStringUtility.Compare(ops[i].m_strOperator, _strOperator))
        {
          return ops[i];
        }
      }
      throw new XPIllegalArgumentException("Unable to convert string operator " + _strOperator + " into a BooleanOperator.  Invalid value.");
      }
    
    /// <returns>The underlying String constant.</returns>
    public override String ToString()
    {
      return m_strOperator;
    }
  }
}