using System;
using com.plumtree.openfoundation.util;
namespace com.plumtree.taglib.logic
{
  public class IntOperators
  {
    public static readonly IntOperators OP_GREATER_THAN = new IntOperators(">");
    public static readonly IntOperators OP_LESS_THAN = new IntOperators("<");
    public static readonly IntOperators OP_EQUAL = new IntOperators("==");
    public static readonly IntOperators OP_NOT_EQUAL = new IntOperators("!=");
    public static readonly IntOperators[] ops = {OP_GREATER_THAN, OP_LESS_THAN,
     OP_EQUAL, OP_NOT_EQUAL};
    protected String m_strOperator;
    private IntOperators(String _strOperator)
    {
      m_strOperator = _strOperator;
    }
    
    /// <summary>
    /// Helper method to convert a string constant into an integer operator.
    /// </summary>
    /// <param name="_strOperator"></param>
    /// <returns>The corresponding IntOperator.</returns>
    public static IntOperators GetIntOperator(String _strOperator)
    {
      for (int i = 0;i < ops.Length;i++)
      {
        if (0 == XPStringUtility.Compare(ops[i].m_strOperator, _strOperator))
        {
          return ops[i];
        }
      }
      throw new XPIllegalArgumentException("Unable to convert string operator " + _strOperator + " into an IntOperator.  Invalid value.");
      }
    
    /// <returns>The underlying String constant.</returns>
    public override String ToString()
    {
      return m_strOperator;
    }
  }
}