using System;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.metadata;
namespace com.plumtree.taglib.logic
{
  /// <summary>
  /// Meta-data for the logic tag library.
  /// </summary>
  public class LogicTagLibraryData : ITagLibraryMetaData
  {
    public static readonly TagLibraryMetaData LIBRARY = new TagLibraryMetaData("Logic Tags",
     "logic", "This library provides a basic set of logic tags.<![CDATA[<p>]]>" + "Many of these tags have a scope argument.  The valid values " + "for the scope argument are \"" + Scope.TAG + "\", \"" + Scope.PORTLET_REQUEST + "\", \"" + Scope.HTTP_REQUEST + "\", \"" + Scope.SESSION + "\", \"" + Scope.PERSISTENT_SESSION + "\", \"" + Scope.APPLICATION + "\".  NOTE: These values are not case-sensitive, " + "but it is considered a best practice to use all lower case.<![CDATA[<p>]]>" + "Various tags also set editable shared variables as part of their " + "execution.  If a variable with the same name already exists, it will " + "be overwritten.  If the pre-existing variable is not editable, then " + "the tag will fail.  Variable names cannot contain the reserved " + "character \'.\'.",
     1.1);
    public const String SCOPE_REFERENCE = "See the Logic tag library description " + "for details about valid scope arguments.";
    }
}