using System;
using com.plumtree.openfoundation.util;
namespace com.plumtree.taglib.logic
{
  public class StringOperators
  {
    public static readonly StringOperators OP_EQUAL = new StringOperators("==");
    public static readonly StringOperators OP_NOT_EQUAL = new StringOperators("!=");
    public static readonly StringOperators[] ops = {OP_EQUAL, OP_NOT_EQUAL};
    protected String m_strOperator;
    private StringOperators(String _strOperator)
    {
      m_strOperator = _strOperator;
    }
    
    /// <summary>
    /// Helper method to convert a string constant into a string operator.
    /// </summary>
    /// <param name="_strOperator"></param>
    /// <returns>The corresponding StringOperator.</returns>
    public static StringOperators GetStringOperator(String _strOperator)
    {
      for (int i = 0;i < ops.Length;i++)
      {
        if (0 == XPStringUtility.Compare(ops[i].m_strOperator, _strOperator))
        {
          return ops[i];
        }
      }
      throw new XPIllegalArgumentException("Unable to convert string operator " + _strOperator + " into a StringOperator.  Invalid value.");
      }
    
    /// <returns>The underlying String constant.</returns>
    public override String ToString()
    {
      return m_strOperator;
    }
  }
}