package com.plumtree.taglib.logic;

import com.plumtree.openfoundation.util.*;

public class ArithmeticOperators
{
	public static final ArithmeticOperators OP_ADD = new ArithmeticOperators("+");
	public static final ArithmeticOperators OP_SUBTRACT = new ArithmeticOperators("-");
	public static final ArithmeticOperators OP_MULTIPLY = new ArithmeticOperators("*");
	public static final ArithmeticOperators OP_DIVIDE = new ArithmeticOperators("/");
	public static final ArithmeticOperators OP_MOD = new ArithmeticOperators("%");

	public static final ArithmeticOperators[] ops = { OP_ADD, OP_SUBTRACT, OP_MULTIPLY, OP_DIVIDE, OP_MOD };

	protected String m_strOperator;

	private ArithmeticOperators(String _strOperator)
	{
		m_strOperator = _strOperator;
	}

    /**
     * Helper method to convert a string constant into an airthmetic operator.
     *
     * @param _strOperator
     * @return The corresponding IntOperator.
     */
    public static ArithmeticOperators GetArithmeticOperator(String _strOperator)
    {
		for (int i = 0; i < ops.length; i++)
        {
            if (0 == XPStringUtility.Compare(ops[i].m_strOperator, _strOperator))
            {
                return ops[i];
            }
        }

        throw new XPIllegalArgumentException("Unable to convert string operator "
            + _strOperator + " into an IntOperator.  Invalid value.");
    }

    /**
     * @return The underlying String constant.
     */
    public String toString()
    {
        return m_strOperator;
    }
}