package com.plumtree.taglib.logic;

import com.plumtree.openfoundation.util.*;

public class BooleanOperators
{
	public static final BooleanOperators OP_AND = new BooleanOperators("&&");
	public static final BooleanOperators OP_OR = new BooleanOperators("||");
	public static final BooleanOperators OP_EQUAL = new BooleanOperators("==");
	public static final BooleanOperators OP_NOT_EQUAL = new BooleanOperators("!=");

	public static final BooleanOperators[] ops = { OP_AND, OP_OR, OP_EQUAL, OP_NOT_EQUAL };

	protected String m_strOperator;

	private BooleanOperators(String _strOperator)
	{
		m_strOperator = _strOperator;
	}

    /**
     * Helper method to convert a string constant into a boolean operator.
     *
     * @param _strOperator
     * @return The corresponding BooleanOperator.
     */
    public static BooleanOperators GetBooleanOperator(String _strOperator)
    {
        for (int i = 0; i < ops.length; i++)
        {
            if (0 == XPStringUtility.Compare(ops[i].m_strOperator, _strOperator))
            {
                return ops[i];
            }
        }

        throw new XPIllegalArgumentException("Unable to convert string operator "
            + _strOperator + " into a BooleanOperator.  Invalid value.");
    }

    /**
     * @return The underlying String constant.
     */
    public String toString()
    {
        return m_strOperator;
    }
}