package com.plumtree.taglib.logic;

import com.plumtree.openfoundation.util.*;

public class IntOperators
{
	public static final IntOperators OP_GREATER_THAN = new IntOperators(">");
	public static final IntOperators OP_LESS_THAN = new IntOperators("<");
	public static final IntOperators OP_EQUAL = new IntOperators("==");
	public static final IntOperators OP_NOT_EQUAL = new IntOperators("!=");

	public static final IntOperators[] ops = { OP_GREATER_THAN, OP_LESS_THAN, OP_EQUAL, OP_NOT_EQUAL };

	protected String m_strOperator;

	private IntOperators(String _strOperator)
	{
		m_strOperator = _strOperator;
	}

    /**
     * Helper method to convert a string constant into an integer operator.
     *
     * @param _strOperator
     * @return The corresponding IntOperator.
     */
    public static IntOperators GetIntOperator(String _strOperator)
    {
		for (int i = 0; i < ops.length; i++)
        {
            if (0 == XPStringUtility.Compare(ops[i].m_strOperator, _strOperator))
            {
                return ops[i];
            }
        }

        throw new XPIllegalArgumentException("Unable to convert string operator "
            + _strOperator + " into an IntOperator.  Invalid value.");
    }

    /**
     * @return The underlying String constant.
     */
    public String toString()
    {
        return m_strOperator;
    }
}