package com.plumtree.taglib.logic;

import com.plumtree.openfoundation.util.*;

public class StringOperators
{
	public static final StringOperators OP_EQUAL = new StringOperators("==");
	public static final StringOperators OP_NOT_EQUAL = new StringOperators("!=");

	public static final StringOperators[] ops = { OP_EQUAL, OP_NOT_EQUAL };

	protected String m_strOperator;

	private StringOperators(String _strOperator)
	{
		m_strOperator = _strOperator;
	}

	/**
	 * Helper method to convert a string constant into a string operator.
	 *
	 * @param _strOperator
	 * @return The corresponding StringOperator.
	 */
	public static StringOperators GetStringOperator(String _strOperator)
	{
		for (int i = 0; i < ops.length; i++)
		{
			if (0 == XPStringUtility.Compare(ops[i].m_strOperator, _strOperator))
			{
				return ops[i];
			}
		}

		throw new XPIllegalArgumentException("Unable to convert string operator "
			+ _strOperator + " into a StringOperator.  Invalid value.");
	}

	/**
	 * @return The underlying String constant.
	 */
	public String toString()
	{
		return m_strOperator;
	}
}