using System;
using com.plumtree.portaluiinfrastructure.ptlink;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.data;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.taskapi.portalui;
using com.plumtree.uiinfrastructure.uitasks;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.ptdata
{
  /// <summary>
  /// Implementation of the AdvancedSearch PTURL DO Data Tag
  /// </summary>
  public class AdvancedSearchDataTag : APTURLDODataTag
  {
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    public static readonly ITagMetaData TAG;
    static AdvancedSearchDataTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("advancedsearchdata", COMMON_PRETAGMETADATA_SINGLE_DESC + "with the link information for the Advanced Search Page. " + COMMON_TAGVAR_DESC + COMMON_COLLECTION_DESC + COMMON_PROPLIST_HEADER + COMMON_POSTTAGMETADATA_DESC);
      }
    internal TagDataSetterPTURLDOData m_URLSetter = new TagDataSetterPTURLDOData();
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()"></seealso>
    public override HTMLElement DisplayTag()
    {
      IEnvironment env = GetEnvironment();
      IPTURL url = TaskAPIUISearch.GetURLForAdvancedSearchPage(TaskAPIUICommon.GetEnvTypeObject(env));
      SetPTURLDataEntry(url);
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#Create()"></seealso>
    public override ATag Create()
    {
      return new AdvancedSearchDataTag();
    }
  }
}