/*
 */
 
using System;
using com.plumtree.portaluiinfrastructure.ptlink;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.taskapi.portalui;
using com.plumtree.uiinfrastructure.uitasks;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.ptdata
{
  /// <summary>
  /// Implementation of the CommunityKnowledgeDirectory PTURL DO Data Tag
  /// </summary>
  public class CommunityKnowledgeDirectoryDataTag : APTURLDODataTag
  {
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    public static readonly ITagMetaData TAG;
    static CommunityKnowledgeDirectoryDataTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("communitykddata", COMMON_PRETAGMETADATA_SINGLE_DESC + "with the link information for Community Knowledge Directory of the current Community. " + COMMON_TAGVAR_DESC + "This data tag only creates this data collection when in a Community with Community Knowledge Directory enabled. " + "Nothing is set in the Tag variable otherwise." + COMMON_COLLECTION_DESC + COMMON_PROPLIST_HEADER + COMMON_POSTTAGMETADATA_DESC);
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()"></seealso>
    public override HTMLElement DisplayTag()
    {
      IEnvironment env = GetEnvironment();
      int nCurrCommID = TaskAPIUICommunity.GetCurrentCommunityID(TaskAPIUICommon.GetEnvTypeObject(env));
      IPTURL url = TaskAPIUICommunity.GetURLForCommunityKnowledgeDirectory(TaskAPIUICommon.GetEnvTypeObject(env),
       nCurrCommID);
      SetPTURLDataEntry(url);
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#Create()"></seealso>
    public override ATag Create()
    {
      return new CommunityKnowledgeDirectoryDataTag();
    }
  }
}