using System;
using com.plumtree.openlog;
using com.plumtree.portaluiinfrastructure.ptlink;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.taskapi.portalui;
using com.plumtree.uiinfrastructure.uitasks;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.ptdata
{
  public class CurrentPageDataTag : APTURLDODataTag
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADAPTIVETAGS),
     typeof(CurrentPageDataTag));
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    public static readonly ITagMetaData TAG;
    static CurrentPageDataTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("currpagedata", COMMON_PRETAGMETADATA_LIST_DESC + "with the link information for the current page (Name, page id, url and more for MyPage or Community pages). " + COMMON_TAGVAR_DESC + "Nothing is set in the Tag variable if the current page is not a MyPage or Community page. " + COMMON_COLLECTION_DESC + COMMON_PROPLIST_HEADER + "<![CDATA[<code>]]>pageid<![CDATA[</code>]]>: Community Page Id <![CDATA[<br/>]]>" + "<![CDATA[<code>]]>pagename<![CDATA[</code>]]>: Community Page name <![CDATA[<br/>]]>" + "<![CDATA[<code>]]>commid<![CDATA[</code>]]> Community id <![CDATA[<br/>]]>" + "<![CDATA[<code>]]>commname<![CDATA[</code>]]> Community name <![CDATA[<br/>]]>" + "<![CDATA[<code>]]>classid<![CDATA[</code>]]> Set to \'518\' when on MyPages and \'514\' when on Community Pages <![CDATA[<br/>]]>" + COMMON_POSTTAGMETADATA_DESC,
       EncodeForTagDoc("<pt:ptdata.currpagedata pt:id=\"currpage\" pt:noarray=\"true\" /><br/>" + "<pt:logic.value pt:value=\"$currpage.pageid\"/>   // Page Id<br/>" + "<pt:logic.value pt:value=\"$currpage.pagename\"/> // Page Name<br/>" + "<pt:logic.value pt:value=\"$currpage.commid\"/>   // Community Id<br/>" + "<pt:logic.value pt:value=\"$currpage.commname\"/> // Community Name<br/>" + "<pt:logic.value pt:value=\"$currpage.url\"/> \t   // URL to the page<br/>" + "<pt:logic.value pt:value=\"$currpage.classid\"/>  // Class id of the Page <br/>" + ""));
      }
    public override HTMLElement DisplayTag()
    {
      IEnvironment env = GetEnvironment();
      IPTURL url = TaskAPIUICommunity.GetCurrentPageAsURL(TaskAPIUICommon.GetEnvTypeObject(env));
      if (url == null)
      {
        log.Warn("Tag currpagedata did not find any Page data. No data to set to datavar: \'{0}\' in scope \'{1}\'",
         GetTagAttributeAsString(ATTRIB_ID), GetTagAttributeAsString(ATTRIB_SCOPE));
        } else
      {
        SetPTURLDataEntry(url);
      }
      return null;
    }
    public override ATag Create()
    {
      return new CurrentPageDataTag();
    }
  }
}