using System;
using com.plumtree.portaluiinfrastructure.ptlink;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.data;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.taskapi.portalui;
using com.plumtree.uiinfrastructure.uitasks;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.ptdata
{
  /// <summary>
  /// Implementation of the CurrentParentCommunities PTURL DO Data Tag
  /// </summary>
  public class CurrentParentCommunityDataTag : APTURLDODataTag
  {
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    public static readonly ITagMetaData TAG;
    static CurrentParentCommunityDataTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("currparentcommunitydata", COMMON_PRETAGMETADATA_SINGLE_DESC + "with the link information for the Parent Community " + "(The Community above the current Community in the administrative hierarchy) of the current Community . " + COMMON_TAGVAR_DESC + COMMON_COLLECTION_DESC + COMMON_PROPLIST_HEADER + COMMON_COMMS_DESC + COMMON_POSTTAGMETADATA_DESC + COMMON_CURRENTMARKER_DESC,
       EncodeForTagDoc("<pt:ptdata.currparentcommunitydata pt:noarray=\"true\"/><br/>" + "<pt:logic.value pt:value=\"parent.commid\"/>   // Community Id<br/>" + "<pt:logic.value pt:value=\"parent.commname\"/> // Community Name<br/>" + "<pt:logic.value pt:value=\"parent.url\"/> \t // URL to Community home page<br/>" + ""));
      }
    internal TagDataSetterPTURLDOData m_URLSetter = new TagDataSetterPTURLDOData();
    public override HTMLElement DisplayTag()
    {
      IEnvironment env = GetEnvironment();
      IPTURL url = TaskAPIUICommunity.GetCurrentParentCommunityAsURL(TaskAPIUICommon.GetEnvTypeObject(env));
      SetPTURLDataEntry(url);
      return null;
    }
    public override ATag Create()
    {
      return new CurrentParentCommunityDataTag();
    }
  }
}