/*
 */
 
using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.taskapi.portalui;
using com.plumtree.uiinfrastructure.uitasks;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.ptdata
{
  /// <summary>
  /// Implementation of the CurrentSubCommunities PTURL DO Data Tag
  /// </summary>
  public class CurrentSubCommunitiesDataTag : APTURLDODataTag
  {
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    public static readonly ITagMetaData TAG;
    static CurrentSubCommunitiesDataTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("currsubcommunitiesdata", COMMON_PRETAGMETADATA_LIST_DESC + "with the link information for the Subcommunity " + "(Communities inside another Community in the Admin hierarchy) of the current Community. " + COMMON_TAGVAR_DESC + "Nothing is set in the Tag variable if this tag is not used in a Community. " + COMMON_COLLECTION_DESC + COMMON_PROPLIST_HEADER + COMMON_COMMS_DESC + COMMON_POSTTAGMETADATA_DESC + COMMON_CURRENTMARKER_DESC,
       EncodeForTagDoc("<pt:ptdata.currsubcommunitiesdata pt:id=\"subcomms\" /><br/>" + "<pt:logic.foreach pt:data=\"subcomms\" pt:var=\"curr\" /> //display values for each community page <br/>" + "&nbsp; &nbsp; <pt:logic.value pt:value=\"$curr.commid\"/>   // Community Id<br/>" + "&nbsp; &nbsp; <pt:logic.value pt:value=\"$curr.commname\"/> // Community Name<br/>" + "&nbsp; &nbsp; <pt:logic.value pt:value=\"$curr.url\"/> \t // URL to the page<br/>" + "</pt:logic.foreach>" + ""));
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()"></seealso>
    public override HTMLElement DisplayTag()
    {
      IEnvironment env = GetEnvironment();
      XPArrayList urls = TaskAPIUICommunity.GetCurrentSubCommunitiesAsURLs(TaskAPIUICommon.GetEnvTypeObject(env));
      SetPTURLDataCollection(urls);
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#Create()"></seealso>
    public override ATag Create()
    {
      return new CurrentSubCommunitiesDataTag();
    }
  }
}