/*
 * Created on Jan 19, 2005
 */
 
using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.taskapi.portalui;
using com.plumtree.uiinfrastructure.uitasks;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.ptdata
{
  /// <summary>
  /// Implementation of the MandatoryCommunities PTURL DO Data Tag
  /// </summary>
  public class MandatoryCommunitiesDataTag : APTURLDODataTag
  {
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    public static readonly ITagMetaData TAG;
    static MandatoryCommunitiesDataTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("mandtabcommsdata", COMMON_PRETAGMETADATA_LIST_DESC + "containing users\'s Mandatory Communities " + "(List of Communities a user cannot unsubscribe from) link information. " + COMMON_TAGVAR_DESC + COMMON_COLLECTION_DESC + COMMON_PROPLIST_HEADER + COMMON_COMMS_DESC + COMMON_POSTTAGMETADATA_DESC + COMMON_CURRENTMARKER_DESC);
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()"></seealso>
    public override HTMLElement DisplayTag()
    {
      IEnvironment env = GetEnvironment();
      XPArrayList urls = TaskAPIUICommunity.GetMyMandatoryCommunitiesWithTabsAsURLs(TaskAPIUICommon.GetEnvTypeObject(env),
       true);
      SetPTURLDataCollection(urls);
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#Create()"></seealso>
    public override ATag Create()
    {
      return new MandatoryCommunitiesDataTag();
    }
  }
}