/*
 * Created on Jan 20, 2005
 */
 
using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.taskapi.portalui;
using com.plumtree.uiinfrastructure.uitasks;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.ptdata
{
  /// <summary>
  /// Implementation of the MyPagesActions PTURL DO Data Tag
  /// </summary>
  public class MyPagesActionsDataTag : APTURLDODataTag
  {
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    public static readonly ITagMetaData TAG;
    public static readonly OptionalTagAttribute TAG_INCLUDE_ONECLICK_CREATE;
    static MyPagesActionsDataTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("mypageactionsdata", COMMON_PRETAGMETADATA_LIST_DESC + "with the link information for a users\'s My Page actions (My Page actions such " + "as \'Create New MyPage\' or \'Edit Page\'. Some actions are only included when currently on a MyPage). " + COMMON_TAGVAR_DESC + COMMON_COLLECTION_DESC + COMMON_PROPLIST_HEADER + COMMON_POSTTAGMETADATA_DESC);
      TAG_INCLUDE_ONECLICK_CREATE = new OptionalTagAttribute("includeoneclick",
       "Indicates inclusion of \'one-click page creation\' link", AttributeType.BOOLEAN,
       XPConvert.ToString(false));
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()"></seealso>
    public override HTMLElement DisplayTag()
    {
      IEnvironment env = GetEnvironment();
      XPArrayList urls = TaskAPIUIMyPages.GetMyPageActionsAsURLs(TaskAPIUICommon.GetEnvTypeObject(env),
       GetTagAttributeAsBoolean(TAG_INCLUDE_ONECLICK_CREATE));
      SetPTURLDataCollection(urls);
      return null;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#Create()"></seealso>
    public override ATag Create()
    {
      return new MyPagesActionsDataTag();
    }
  }
}