/*
 */
package  com.plumtree.taglib.ptdata;

import com.plumtree.portaluiinfrastructure.ptlink.*;
import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.portaluiinfrastructure.tags.metadata.*;
import com.plumtree.taskapi.portalui.*;
import com.plumtree.uiinfrastructure.uitasks.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * Implementation of the CommunityKnowledgeDirectory PTURL DO Data Tag
 * 
 */
public class CommunityKnowledgeDirectoryDataTag extends APTURLDODataTag
{
	// All public static final metadata objects should be initialized
	// in a static initializer so that we can control the order of
	// initialization.
	public static final ITagMetaData TAG;

	static
	{
		// The TAG member variable needs to be initialized first since it
		// can be used in other tags (i.e. as a RequiredParentTag) that
		// are referenced by member variables of this tag (i.e. as a
		// RelatedChildTag).  This is necessary for tags that have
		// circular references such as a parent / child tag relationship.
		TAG = new TagMetaData("communitykddata",
			COMMON_PRETAGMETADATA_SINGLE_DESC+"with the link information for Community Knowledge Directory of the current Community. " +
			COMMON_TAGVAR_DESC+
			"This data tag only creates this data collection when in a Community with Community Knowledge Directory enabled. " +
			"Nothing is set in the Tag variable otherwise."+
			COMMON_COLLECTION_DESC+
			COMMON_PROPLIST_HEADER+
			COMMON_POSTTAGMETADATA_DESC
			);
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()
	 */
	public HTMLElement DisplayTag()
	{
		IEnvironment env = GetEnvironment();
		int nCurrCommID = TaskAPIUICommunity.GetCurrentCommunityID(TaskAPIUICommon.GetEnvTypeObject(env));
		IPTURL url = TaskAPIUICommunity.GetURLForCommunityKnowledgeDirectory(TaskAPIUICommon.GetEnvTypeObject(env), nCurrCommID);
		
		SetPTURLDataEntry(url);
		
		return null;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.tags.ATag#Create()
	 */
	public ATag Create()
	{
		return new CommunityKnowledgeDirectoryDataTag();
	}
}
