package com.plumtree.taglib.ptdata;

import com.plumtree.portaluiinfrastructure.ptlink.*;
import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.portaluiinfrastructure.tags.data.*;
import com.plumtree.portaluiinfrastructure.tags.metadata.*;
import com.plumtree.taskapi.portalui.*;
import com.plumtree.uiinfrastructure.uitasks.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * Implementation of the CurrentParentCommunities PTURL DO Data Tag
 * 
 */
public class CurrentParentCommunityDataTag extends APTURLDODataTag
{
	// All public static final metadata objects should be initialized
	// in a static initializer so that we can control the order of
	// initialization.
	public static final ITagMetaData TAG;

	static
	{
		// The TAG member variable needs to be initialized first since it
		// can be used in other tags (i.e. as a RequiredParentTag) that
		// are referenced by member variables of this tag (i.e. as a
		// RelatedChildTag).  This is necessary for tags that have
		// circular references such as a parent / child tag relationship.
		TAG = new TagMetaData("currparentcommunitydata",
			COMMON_PRETAGMETADATA_SINGLE_DESC+ "with the link information for the Parent Community " +
					"(The Community above the current Community in the administrative hierarchy) of the current Community . "+
			COMMON_TAGVAR_DESC+
			COMMON_COLLECTION_DESC+
			COMMON_PROPLIST_HEADER+
			COMMON_COMMS_DESC+
			COMMON_POSTTAGMETADATA_DESC+
			COMMON_CURRENTMARKER_DESC,
			EncodeForTagDoc(
				"<pt:ptdata.currparentcommunitydata pt:noarray=\"true\"/><br/>"+
				"<pt:logic.value pt:value=\"parent.commid\"/>   // Community Id<br/>"+
				"<pt:logic.value pt:value=\"parent.commname\"/> // Community Name<br/>"+
				"<pt:logic.value pt:value=\"parent.url\"/> 	 // URL to Community home page<br/>"+
				""));

	}

	 TagDataSetterPTURLDOData m_URLSetter = new TagDataSetterPTURLDOData();

	public HTMLElement DisplayTag()
	{
		IEnvironment env = GetEnvironment();
		
		IPTURL url = TaskAPIUICommunity.GetCurrentParentCommunityAsURL(TaskAPIUICommon.GetEnvTypeObject(env));
		
		SetPTURLDataEntry(url);
		
		return null;
	}

	public ATag Create()
	{
		return new CurrentParentCommunityDataTag();
	}

}
