/*
 * Created on Jan 20, 2005
 */
package  com.plumtree.taglib.ptdata;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.ptlink.*;
import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.portaluiinfrastructure.tags.metadata.*;
import com.plumtree.server.*;
import com.plumtree.taskapi.portalui.*;
import com.plumtree.uiinfrastructure.uitasks.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * Implementation of the EditDirectory PTURL DO Data Tag
 * 
 */
public class EditDirectoryDataTag extends APTURLDODataTag
{
	// All public static final metadata objects should be initialized
	// in a static initializer so that we can control the order of
	// initialization.
	public static final ITagMetaData TAG;
	public static final OptionalTagAttribute FOLDER_ID;

	static
	{
		// The TAG member variable needs to be initialized first since it
		// can be used in other tags (i.e. as a RequiredParentTag) that
		// are referenced by member variables of this tag (i.e. as a
		// RelatedChildTag).  This is necessary for tags that have
		// circular references such as a parent / child tag relationship.
		TAG = new TagMetaData("directoryeditdata",
			COMMON_PRETAGMETADATA_SINGLE_DESC + " with the link information for the specified Knowledge Directory Folder in edit mode. The link goes to the " +
			"root folder if no folder ID is specified. " +
			COMMON_TAGVAR_DESC+
			"Nothing is set in the Tag variable if a user does not have access to edit the Knowledge Directory. "+
			COMMON_COLLECTION_DESC+
			COMMON_PROPLIST_HEADER+
			COMMON_POSTTAGMETADATA_DESC);

		FOLDER_ID = new OptionalTagAttribute("folderid",
			"Knowledge Directory Folder ID. If no folder is specified the default folder is the root folder.",	
			AttributeType.INT,
			XPConvert.ToString(PT_INTRINSICS.PT_FOLDER_ROOTFOLDER) );
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()
	 */
	public HTMLElement DisplayTag()
	{
		IEnvironment env = GetEnvironment();
		
		int nFolderID = GetTagAttributeAsInt(FOLDER_ID);
		IPTURL url = TaskAPIUIDirectory.GetURLForEditDirectory(TaskAPIUICommon.GetEnvTypeObject(env), nFolderID);
		
		SetPTURLDataEntry(url);
		
		return null;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.tags.ATag#Create()
	 */
	public ATag Create()
	{
		return new EditDirectoryDataTag();
	}
}
