/*
 * Created on Jan 20, 2005
 */
package  com.plumtree.taglib.ptdata;

import com.plumtree.portaluiinfrastructure.ptlink.*;
import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.portaluiinfrastructure.tags.metadata.*;
import com.plumtree.taskapi.portalui.*;
import com.plumtree.uiinfrastructure.uitasks.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * Implementation of the EditMyPagePortletPreferencesAction PTURL DO Data Tag
 * 
 */
public class EditMyPagePortletPreferencesActionDataTag extends APTURLDODataTag
{
	// All public static final metadata objects should be initialized
	// in a static initializer so that we can control the order of
	// initialization.
	public static final ITagMetaData TAG;

	static
	{
		// The TAG member variable needs to be initialized first since it
		// can be used in other tags (i.e. as a RequiredParentTag) that
		// are referenced by member variables of this tag (i.e. as a
		// RelatedChildTag).  This is necessary for tags that have
		// circular references such as a parent / child tag relationship.
		TAG = new TagMetaData("editmypageportletprefsdata",
			COMMON_PRETAGMETADATA_SINGLE_DESC +"with the link information for the Edit Portlet Preferences for MyPage editor (Editor " +
			"to edit all portlet preferences on the current page)." +
			COMMON_TAGVAR_DESC+
			COMMON_COLLECTION_DESC+
			COMMON_PROPLIST_HEADER+
			COMMON_POSTTAGMETADATA_DESC);
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()
	 */
	public HTMLElement DisplayTag()
	{
		IEnvironment env = GetEnvironment();
		
		IPTURL url = TaskAPIUIMyPages.GetURLForEditMyPagePortletPreferencesEditor(TaskAPIUICommon.GetEnvTypeObject(env));
		
		SetPTURLDataEntry(url);
		
		return null;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.tags.ATag#Create()
	 */
	public ATag Create()
	{
		return new EditMyPagePortletPreferencesActionDataTag();
	}
}
