/*
 * Created on Nov 27, 2007
 */
package com.plumtree.taglib.ptdata;

import com.plumtree.portaluiinfrastructure.ptlink.*;
import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.portaluiinfrastructure.tags.data.*;
import com.plumtree.portaluiinfrastructure.tags.metadata.*;
import com.plumtree.server.*;
import com.plumtree.taskapi.portalui.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.uitasks.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * Implementation of the MyProfile PTURL DO Data Tag
 * 
 */
public class MyProfileDataTag extends APTURLDODataTag {

	// All public static final metadata objects should be initialized
	// in a static initializer so that we can control the order of
	// initialization.
	public static final ITagMetaData TAG;
	
	static
	{
		// The TAG member variable needs to be initialized first since it
		// can be used in other tags (i.e. as a RequiredParentTag) that
		// are referenced by member variables of this tag (i.e. as a
		// RelatedChildTag).  This is necessary for tags that have
		// circular references such as a parent / child tag relationship.
		TAG = new TagMetaData("myprofiledata",
			COMMON_PRETAGMETADATA_SINGLE_DESC +"with the link information for the user's Profile Page (Goes to the User Profile " +
			"page where users can view personal profile information). " +
			COMMON_TAGVAR_DESC+
			COMMON_COLLECTION_DESC+
			COMMON_PROPLIST_HEADER+
			COMMON_POSTTAGMETADATA_DESC);
	}

	TagDataSetterPTURLDOData m_URLSetter = new TagDataSetterPTURLDOData();
	
	/**
	 * @see com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()
	 */
	public HTMLElement DisplayTag()
	{
		IEnvironment env = GetEnvironment();
		AActivitySpace owner = (AActivitySpace)TaskAPIUICommon.GetEnvTypeObject(env);
		IPTSession session = (IPTSession)env.GetUserSession();

		IPTURL url = TaskAPIUICommunity.CreateUserProfilePageCommonOpenerURL(
				owner, 
				session.GetSessionInfo().GetCurrentUserID(),
				session.GetSessionInfo().GetCurrentUserName(),
				owner.GetString(1308, "ptmsgs_portalbrowsingmsgs"));
				
		SetPTURLDataEntry(url);
		
		return null;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.tags.ATag#Create()
	 */
	public ATag Create()
	{
		return new MyProfileDataTag();
	}
}