/*
 * Created on Jan 31, 2005
 */
package  com.plumtree.taglib.ptdata;

import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.portaluiinfrastructure.ptlink.*;
import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.portaluiinfrastructure.tags.data.*;
import com.plumtree.portaluiinfrastructure.tags.metadata.*;
import com.plumtree.taskapi.portalui.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.uitasks.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * Implementation of the MyAccount PTURL DO Data Tag
 * 
 */
public class RulesDebugDataTag extends APTURLDODataTag
{
	// All public static final metadata objects should be initialized
	// in a static initializer so that we can control the order of
	// initialization.
	public static final ITagMetaData TAG;

	static
	{
		// The TAG member variable needs to be initialized first since it
		// can be used in other tags (i.e. as a RequiredParentTag) that
		// are referenced by member variables of this tag (i.e. as a
		// RelatedChildTag).  This is necessary for tags that have
		// circular references such as a parent / child tag relationship.
		TAG = new TagMetaData("rulesdebugdata",
			COMMON_PRETAGMETADATA_SINGLE_DESC +"with the link information for the Rules Debug Popup Page (Where users can view debug messages sent by the experience definition rules engine). " +
			COMMON_TAGVAR_DESC+
			COMMON_COLLECTION_DESC+
			COMMON_PROPLIST_HEADER+
			COMMON_POSTTAGMETADATA_DESC);
		
	}

	TagDataSetterPTURLDOData m_URLSetter = new TagDataSetterPTURLDOData();
	
	/**
	 * @see com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()
	 */
	public HTMLElement DisplayTag()
	{
		IEnvironment env = GetEnvironment();
		AActivitySpace owner = TaskAPIUICommon.GetEnvTypeObject(env);
		
		FullURL url = null;
		if (RulesDebugMSGAS.GetIsRulesDebugEnabled(TaskAPIUICommon.GetEnvTypeObject(GetEnvironment())))
		{
			String strText 						= owner.GetString(2969, "ptmsgs_portaladminmsgs");
			
			ASURL urlDebugPopUp = new ASURL(owner);
			urlDebugPopUp.SetLinkGetSpaceIfCached(RulesDebugMSGAS.STR_MVC_CLASS_NAME, owner);
			urlDebugPopUp.SetDisplayPage(RulesDebugMSGDP.STR_MVC_CLASS_NAME);
			String strRulesDebugURL   =  urlDebugPopUp.GetURLAsString();
			
			url = new FullURL(strText, strRulesDebugURL);
		}
		
		SetPTURLDataEntry(url);
		
		
		return null;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.tags.ATag#Create()
	 */
	public ATag Create()
	{
		return new RulesDebugDataTag();
	}
}
