using System;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.portaluiinfrastructure.tags;
namespace com.plumtree.navtags
{
  /// <summary>
  /// Pluggable Navigation tag library meta data
  /// </summary>
  public class PlugNavTagLibraryData : ITagLibraryMetaData
  {
    public static readonly TagLibraryMetaData LIBRARY = new TagLibraryMetaData("Navigation Tags",
     "plugnav", "This library provides display tags for navigation use. <![CDATA[<p>]]>" + "Display tags need data tags to provide them with content to display since " + "they only contain the logic for formatting and generating HTML. " + "The actual content is provided with data tags. <![CDATA[<p>]]>" + "Every display tag has a mechanism to consume data tags. " + "The most straight-forward way is via an attribute that takes an identifier (ID) " + "that every Data Tag needs to declare. <![CDATA[<p>]]>" + "Some of these tags have a scope argument.  The valid values " + "for the scope argument are \"" + Scope.TAG + "\", \"" + Scope.PORTLET_REQUEST + "\", \"" + Scope.HTTP_REQUEST + "\", \"" + Scope.SESSION + "\", \"" + Scope.PERSISTENT_SESSION + "\", \"" + Scope.APPLICATION + "\".  These values are not case-sensitive, " + "although it is considered a best practice to use all lower case.<![CDATA[<p>]]>" + "The display tags in the Navigation tag library (plugnav) require PTURL DO data found in the Data Tag library (ptdata). <![CDATA[<p>]]>" + "See the Data tag library (ptdata) for definitions of the different types of data.",
     1.0);
  }
}