using System;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.taglib.standard.basetags;
namespace com.plumtree.taglib.standard
{
  /// <summary>
  /// This tag outputs a URL to a tree that allows users to
  /// select options from a structured list of Plumtree objects.
  /// This URL is suitable for use in JavaScript.
  /// </summary>
  public class TreeURLTag : ATreeURLTag
  {
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    
    /// <summary>
    /// The public static final ITagMetaData has to be in this
    /// class instead of the base class, otherwise dynamic
    /// discovery will get confused if we try to override it.
    /// </summary>
    public static readonly ITagMetaData TAG;
    static TreeURLTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("treeurl", TREE_URL_TAG_DESCRIPTION, TREE_URL_TAG_EXAMPLES);
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#Create()"></seealso>
    public override ATag Create()
    {
      return new TreeURLTag();
    }
  }
}