using System;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.portaluiinfrastructure.tags.metadata.legacy;
using com.plumtree.taglib.standard.basetags;
namespace com.plumtree.taglib.standard.legacynames
{
  /// <summary>
  /// This tag outputs the name of the current portal page
  /// (My Page or Community) or left blank otherwise. The
  /// localized name is used if one is available.
  /// </summary>
  public class LegacyPageNameTag : APageNameTag
  {
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    
    /// <summary>
    /// The public static final ITagMetaData has to be in this
    /// class instead of the base class, otherwise dynamic
    /// discovery will get confused if we try to override it.
    /// </summary>
    public static readonly ITagMetaData TAG;
    static LegacyPageNameTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new LegacyTagMetaData("pageName", PAGE_NAME_TAG_DESCRIPTION);
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#Create()"></seealso>
    public override ATag Create()
    {
      return new LegacyPageNameTag();
    }
  }
}