using System;
using XPHashtable=com.plumtree.openfoundation.util.XPHashtable;
using com.plumtree.portalpages.browsing.search.advanced;
using CardLanguagePlugInView=com.plumtree.portalpages.common.documentlanguage.CardLanguagePlugInView;
using TypeSelectorView=com.plumtree.portalpages.common.search.TypeSelectorView;
using com.plumtree.portaluiinfrastructure.tags;
using CommonTagAttributeConstants=com.plumtree.portaluiinfrastructure.tags.common.CommonTagAttributeConstants;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using PT_CLASSIDS=com.plumtree.server.PT_CLASSIDS;
using AActivitySpace=com.plumtree.uiinfrastructure.activityspace.AActivitySpace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.advancedSearch
{
  /// <summary>
  /// This tag implements the advancedsearch.advsearchbutton tag.  This tag can only be used in an advanced search layout.
  /// This tag adds the search button in the advanced search page that will execute an advanced search.  
  /// This doesn't create the advanced search Form tag as the mainform AFormDP will generate that for us.
  /// </summary>
  /// <author>lmah</author>
  public class AdvSearchButtonTag : AdvancedSearchPageTag
  {
    private const String TAG_NAME = "advsearchbutton";
    public static readonly ITagMetaData TAG;
    public static readonly String DATATAG_DESCRIPTION = ATag.EncodeForTagDoc("This tag outputs the advanced search button that executes the advanced search.  This tag can only be used" + "for an advanced search layout.<br/>");
    static AdvSearchButtonTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData(TAG_NAME, DATATAG_DESCRIPTION);
    }
    public override ATag Create()
    {
      return new AdvSearchButtonTag();
    }
    public override HTMLElement DisplayTag()
    {
      AActivitySpace asOwner = (AActivitySpace) GetEnvironment();
      //creates the search button
      ASButtonView myButtonView = new ASButtonView();
      IAdvancedSearchModelRO mymodel = GetAdvancedSearchModel();
      myButtonView.Init(mymodel, asOwner);
      HTMLElement searchFormItems = new HTMLElementCollection();
      searchFormItems.AddInnerHTMLElement(myButtonView.Display());
      return searchFormItems;
    }
  }
}