using System;
using com.plumtree.portalpages.browsing.search.advanced;
using com.plumtree.portaluiinfrastructure.tags;
using CommonTagAttributeConstants=com.plumtree.portaluiinfrastructure.tags.common.CommonTagAttributeConstants;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using AActivitySpace=com.plumtree.uiinfrastructure.activityspace.AActivitySpace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.advancedSearch
{
  /// <summary>
  /// This tag implements the advancedsearch.folderfilter tag.  This tag can only be used in an advanced search layout.
  /// It returns the admin and KD folders to limit the search by.
  /// </summary>
  /// <author>lmah</author>
  public class AdvancedSearchFolderFilterTag : AdvancedSearchPageTag
  {
    private const String TAG_NAME = "folderfilter";
    public static readonly ITagMetaData TAG;
    public static readonly String DATATAG_DESCRIPTION = ATag.EncodeForTagDoc("This tag creates the administration and knowledge directory filter for the advanced search.  " + "This tag can only be used for an advanced search layout.<br/>");
    static AdvancedSearchFolderFilterTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData(TAG_NAME, DATATAG_DESCRIPTION);
    }
    public override ATag Create()
    {
      return new AdvancedSearchFolderFilterTag();
    }
    public override HTMLElement DisplayTag()
    {
      AActivitySpace asOwner = (AActivitySpace) GetEnvironment();
      //We are checking to ensure that this tag is only being used for an advanced search layout, not used otherwise.
      IAdvancedSearchModelRO advSearchModel = GetAdvancedSearchModel();
      HTMLElement folderFilter = new HTMLElementCollection();
      folderFilter.AddInnerHTMLElement(asOwner.GetView(ASFoldersView.STR_MVC_CLASS_NAME).Display());
      return folderFilter;
    }
  }
}