using System;
using IAdvancedSearchModelRO=com.plumtree.portalpages.browsing.search.advanced.IAdvancedSearchModelRO;
using com.plumtree.portalpages.common.documentlanguage;
using com.plumtree.portaluiinfrastructure.tags;
using CommonTagAttributeConstants=com.plumtree.portaluiinfrastructure.tags.common.CommonTagAttributeConstants;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using AActivitySpace=com.plumtree.uiinfrastructure.activityspace.AActivitySpace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.advancedSearch
{
  /// <summary>
  /// This tag implements the advancedsearch.languagefilter tag.  This tag can only be used with an advanced search layout.
  /// This tag generates the language filter.
  /// </summary>
  /// <author>Administrator</author>
  public class AdvancedSearchLanguageFilterTag : AdvancedSearchPageTag
  {
    private const String TAG_NAME = "languagefilter";
    public static readonly ITagMetaData TAG;
    public static readonly String DATATAG_DESCRIPTION = ATag.EncodeForTagDoc("This tag creates the language filter for the advanced search.  This tag can only be used in the advanced" + "search layout.  This tag is not supported to work with a Pathways enabled advanced search.<br/>");
    static AdvancedSearchLanguageFilterTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData(TAG_NAME, DATATAG_DESCRIPTION);
    }
    public override ATag Create()
    {
      return new AdvancedSearchLanguageFilterTag();
    }
    public override HTMLElement DisplayTag()
    {
      AActivitySpace asOwner = (AActivitySpace) GetEnvironment();
      //We are checking to ensure that this tag is only being used for an advanced search layout, not used otherwise.
      IAdvancedSearchModelRO advSearchModel = GetAdvancedSearchModel();
      //creates the language filter
      HTMLElement languageFilter = asOwner.GetView(CardLanguagePlugInView.STR_MVC_CLASS_NAME).Display();
      HTMLElement languageItem = new HTMLElementCollection();
      languageItem.AddInnerHTMLElement(languageFilter);
      return languageItem;
    }
  }
}