using System;
using XPNullPointerException=com.plumtree.openfoundation.util.XPNullPointerException;
using com.plumtree.portalpages.browsing.search.advanced;
using com.plumtree.portalpages.common.documentlanguage;
using ATag=com.plumtree.portaluiinfrastructure.tags.ATag;
using AActivitySpace=com.plumtree.uiinfrastructure.activityspace.AActivitySpace;
using com.plumtree.openfoundation.util;
namespace com.plumtree.taglib.advancedSearch
{
  /// <summary>
  /// Abstract base class to simplify advanced search page tag development. Used to retrieve the
  /// model (IAdvancedSarchModelRO)
  /// </summary>
  public abstract class AdvancedSearchPageTag : ATag
  {
    protected const String ADVANCED_SEARCH_ONLY_CONSTANT = "This tag only works with " + "the Advanced Search Page Adaptive Layout.";
    protected virtual IAdvancedSearchModelRO GetAdvancedSearchModel()
    {
      AActivitySpace space = (AActivitySpace) GetEnvironment();
      if (space.GetModelExists(AdvancedSearchModel.STR_MVC_CLASS_NAME))
      {
        return (IAdvancedSearchModelRO) space.GetModel(AdvancedSearchModel.STR_MVC_CLASS_NAME);
        } else
      {
        throw new XPIllegalStateException(GetName() + " tag can only be used in " + "the Advanced Search page.");
        }
    }
  }
}