using System;
using com.plumtree.portalpages.browsing.search.advanced;
using com.plumtree.portaluiinfrastructure.tags;
using CommonTagAttributeConstants=com.plumtree.portaluiinfrastructure.tags.common.CommonTagAttributeConstants;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.advancedSearch
{
  /// <summary>
  /// This class implements the advancedsearch.searchhelp tag.  I do not limit this tag to the advanced search layout only
  /// b/c it seems harmless to allow users to be able to add the search sample helper.
  /// Adds the search help text to the page.
  /// </summary>
  /// <author>Administrator</author>
  public class ExampleSearchTextTag : ATag
  {
    private const String TAG_NAME = "searchhelp";
    public static readonly ITagMetaData TAG;
    public static readonly String DATATAG_DESCRIPTION = ATag.EncodeForTagDoc("This tag creates the sample search help text for advanced search.<br/>");
    static ExampleSearchTextTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData(TAG_NAME, DATATAG_DESCRIPTION);
    }
    public override ATag Create()
    {
      return new ExampleSearchTextTag();
    }
    public override HTMLElement DisplayTag()
    {
      AActivitySpace asOwner = (AActivitySpace) GetEnvironment();
      HTMLElement searchHelp = new HTMLElementCollection();
      searchHelp.AddInnerHTMLElement(AdvancedSearchDP.MakeSearchHelpText(asOwner));
      return searchHelp;
    }
  }
}