using System;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.search.advanced;
using PTDebugHelpers=com.plumtree.portaluiinfrastructure.statichelpers.PTDebugHelpers;
using com.plumtree.portaluiinfrastructure.tags;
using CommonTagAttributeConstants=com.plumtree.portaluiinfrastructure.tags.common.CommonTagAttributeConstants;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.plumtree.taglib.advancedSearch
{
  /// <summary>
  /// This tag implements the advancedsearch.searchcriteria tag.  This tag can only be used with an advanced search layout.
  /// This tag generates the search criteria filter.
  /// </summary>
  /// <author>lmah</author>
  public class SearchCriteriaDisplayTag : AdvancedSearchPageTag
  {
    public const String TAG_NAME = "searchcriteria";
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.	
    public static readonly ITagMetaData TAG;
    public static readonly String DATATAG_DESCRIPTION = ATag.EncodeForTagDoc("Generates the search criteria data, which includes the properties that a user has access to search against," + " the operators associated to each property, and property value text.  This tag can only be used for an" + "advanced search layout.<br/>");
    static SearchCriteriaDisplayTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData(TAG_NAME, DATATAG_DESCRIPTION);
    }
    public override ATag Create()
    {
      return new SearchCriteriaDisplayTag();
    }
    public override HTMLElement DisplayTag()
    {
      AActivitySpace ownerAS = (AActivitySpace) GetEnvironment();
      //We are checking to ensure that this tag is only being used for an advanced search layout, not used otherwise.
      IAdvancedSearchModelRO advSearchModel = GetAdvancedSearchModel();
      HTMLElement filterElement = new HTMLElementCollection();
      filterElement.AddInnerHTMLElement(ownerAS.GetView(ASFilterView.STR_MVC_CLASS_NAME).Display());
      return filterElement;
    }
  }
}