using System;
using junit.framework;
using XPHashtable=com.plumtree.openfoundation.util.XPHashtable;
using MockAdvancedSearchModel=com.plumtree.portalpages.browsing.mock.search.advanced.MockAdvancedSearchModel;
using AdvancedSearchModel=com.plumtree.portalpages.browsing.search.advanced.AdvancedSearchModel;
using MockEnvironment=com.plumtree.portaluiinfrastructure.mock.tags.MockEnvironment;
using com.plumtree.portaluiinfrastructure.utils;
using com.plumtree.taglib.advancedSearch;
using HTMLElement=com.plumtree.xpshared.htmlelements.HTMLElement;
using com.plumtree.openfoundation.util;
namespace com.bea.alui.taglib.advancedSearch.test
{
  /// <summary>
  /// Tests the advanced search button tag by loading up the tag on the page and comparing the HTML. 
  /// </summary>
  /// <author>lmah</author>
  public class TestAdvSearchButtonTag : TestCase
  {
    public MockEnvironment m_environment;
    internal static readonly String TAG_LIBNAME = AdvancedSearchTagLibraryData.LIBRARY.GetName();
    internal static readonly String TAG_NAME = AdvSearchButtonTag.TAG.GetName();
    public MockAdvancedSearchModel myModel;
    public override void setUp()
    {
      m_environment = TagTestHelper.SetupTagTestEnvironment();
      TagTestHelper.CreateTestTag(TAG_LIBNAME, TAG_NAME, new AdvSearchButtonTag());
      myModel = new MockAdvancedSearchModel();
      myModel.Init(m_environment);
      m_environment.m_models.PutElement(AdvancedSearchModel.STR_MVC_CLASS_NAME,
       myModel);
    }
    public virtual void testAdvSearchButton()
    {
      XPHashtable newhash = new XPHashtable();
      HTMLElement testAdvSearchButton = TagTestHelper.RunSingleTag(TAG_LIBNAME,
       TAG_NAME, newhash, m_environment);
      //IsDataTagResult checks for null or empty value, so verifying it's FALSE.
      assertFalse("Data tag returned the following error HTML:\n " + testAdvSearchButton.GetDisplayString(),
       TagTestHelper.VerifyNoTagContent(testAdvSearchButton));
      //verifying the html
      String htmlResult = testAdvSearchButton.GetDisplayString();
      assertTrue("Advanced search button not found in html!", (XPStringUtility.IndexOf(htmlResult,
       "name=\"in_bu_submitsearch\"") != -1));
    }
  }
}