using System;
using XPHashtable=com.plumtree.openfoundation.util.XPHashtable;
using MockAdvancedSearchModel=com.plumtree.portalpages.browsing.mock.search.advanced.MockAdvancedSearchModel;
using com.plumtree.portalpages.browsing.search.advanced;
using MockCardLanguagePlugInModel=com.plumtree.portalpages.common.documentlanguage.MockCardLanguagePlugInModel;
using MockFolderSelectorModel=com.plumtree.portalpages.common.search.MockFolderSelectorModel;
using MockEnvironment=com.plumtree.portaluiinfrastructure.mock.tags.MockEnvironment;
using TagTestHelper=com.plumtree.portaluiinfrastructure.utils.TagTestHelper;
using com.plumtree.taglib.advancedSearch;
using HTMLElement=com.plumtree.xpshared.htmlelements.HTMLElement;
using TestCase=junit.framework.TestCase;
using com.plumtree.openfoundation.util;
namespace com.bea.alui.taglib.advancedSearch.test
{
  public class TestAdvancedSearchFolderFilterTag : TestCase
  {
    public MockEnvironment m_environment;
    internal static readonly String TAG_LIBNAME = AdvancedSearchTagLibraryData.LIBRARY.GetName();
    internal static readonly String TAG_NAME = AdvancedSearchFolderFilterTag.TAG.GetName();
    public MockAdvancedSearchModel myModel;
    public MockFolderSelectorModel folderModel;
    public override void setUp()
    {
      m_environment = TagTestHelper.SetupTagTestEnvironment();
      TagTestHelper.CreateTestTag(TAG_LIBNAME, TAG_NAME, new AdvancedSearchFolderFilterTag());
      //to satisfy the test that advancedsearch is calling the tag for use
      myModel = new MockAdvancedSearchModel();
      myModel.Init(m_environment);
      m_environment.m_models.PutElement(AdvancedSearchModel.STR_MVC_CLASS_NAME,
       myModel);
      folderModel = new MockFolderSelectorModel();
      folderModel.Init(m_environment);
      folderModel.InitializePlugIn(true);
      m_environment.m_models.PutElement(MockFolderSelectorModel.STR_MVC_CLASS_NAME,
       folderModel);
      ASFoldersView folderView = new ASFoldersView();
      folderView.Init(folderModel, m_environment);
      m_environment.m_views.PutElement(ASFoldersView.STR_MVC_CLASS_NAME, folderView);
      }
    public virtual void testAdvancedSearchFolderFilterTag()
    {
      XPHashtable newhash = new XPHashtable();
      // TODO pass in null for newhash, remove top
      HTMLElement folderFilter = TagTestHelper.RunSingleTag(TAG_LIBNAME, TAG_NAME,
       newhash, m_environment);
      //IsDataTagResult checks for null or empty value, so verifying it's FALSE.
      assertFalse("Data tag returned the following error HTML:\n " + folderFilter.GetDisplayString(),
       TagTestHelper.VerifyNoTagContent(folderFilter));
      //verifying the html
      String htmlResult = folderFilter.GetDisplayString();
      assertTrue("Advanced search language filter not found in html!", (XPStringUtility.IndexOf(htmlResult,
       "name=\"in_cb_subfoldersearch\"") != -1));
    }
  }
}