using System;
using TestCase=junit.framework.TestCase;
using XPHashtable=com.plumtree.openfoundation.util.XPHashtable;
using MockAdvancedSearchModel=com.plumtree.portalpages.browsing.mock.search.advanced.MockAdvancedSearchModel;
using AdvancedSearchModel=com.plumtree.portalpages.browsing.search.advanced.AdvancedSearchModel;
using com.plumtree.portalpages.common.search;
using MockEnvironment=com.plumtree.portaluiinfrastructure.mock.tags.MockEnvironment;
using TagTestHelper=com.plumtree.portaluiinfrastructure.utils.TagTestHelper;
using com.plumtree.taglib.advancedSearch;
using HTMLElement=com.plumtree.xpshared.htmlelements.HTMLElement;
using com.plumtree.openfoundation.util;
namespace com.bea.alui.taglib.advancedSearch.test
{
  public class TestAdvancedSearchResultCount : TestCase
  {
    public MockEnvironment m_environment;
    internal static readonly String TAG_LIBNAME = AdvancedSearchTagLibraryData.LIBRARY.GetName();
    internal static readonly String TAG_NAME = AdvancedSearchResultCountTag.TAG.GetName();
    public MockAdvancedSearchModel myModel;
    public MockSimpleSelectorModel simpleModel;
    public override void setUp()
    {
      m_environment = TagTestHelper.SetupTagTestEnvironment();
      TagTestHelper.CreateTestTag(TAG_LIBNAME, TAG_NAME, new AdvancedSearchResultCountTag());
      //to satisfy the test that advancedsearch is calling the tag for use
      myModel = new MockAdvancedSearchModel();
      myModel.Init(m_environment);
      m_environment.m_models.PutElement(AdvancedSearchModel.STR_MVC_CLASS_NAME,
       myModel);
      simpleModel = new MockSimpleSelectorModel();
      simpleModel.InitializePlugIn(new String[]{"10", "20", "50", "100"},
       /* initialSelection= */
      0, "Result Size", "Results Per Page", AdvancedSearchModel.HTML_SELECT_NUMRESULTS);
      SimpleSelectorView myview = new SimpleSelectorView();
      myview.Init(simpleModel, m_environment);
      m_environment.m_views.PutElement(SimpleSelectorView.STR_MVC_CLASS_NAME,
       myview);
    }
    public virtual void testAdvancedSearchResultCountTag()
    {
      XPHashtable newhash = new XPHashtable();
      HTMLElement srCount = TagTestHelper.RunSingleTag(TAG_LIBNAME, TAG_NAME,
       newhash, m_environment);
      //IsDataTagResult checks for null or empty value, so verifying it's FALSE.
      assertFalse("Data tag returned the following error HTML:\n " + srCount.GetDisplayString(),
       TagTestHelper.VerifyNoTagContent(srCount));
      String srResult = srCount.GetDisplayString();
      assertTrue("Result Count filter not found in html!", (XPStringUtility.IndexOf(srResult,
       "name=\"in_se_numresults\"") != -1));
    }
  }
}