using System;
using XPHashtable=com.plumtree.openfoundation.util.XPHashtable;
using MockAdvancedSearchModel=com.plumtree.portalpages.browsing.mock.search.advanced.MockAdvancedSearchModel;
using com.plumtree.portalpages.browsing.search.advanced;
using MockCardLanguagePlugInModel=com.plumtree.portalpages.common.documentlanguage.MockCardLanguagePlugInModel;
using com.plumtree.portalpages.common.search;
using MockEnvironment=com.plumtree.portaluiinfrastructure.mock.tags.MockEnvironment;
using TagTestHelper=com.plumtree.portaluiinfrastructure.utils.TagTestHelper;
using com.plumtree.taglib.advancedSearch;
using HTMLElement=com.plumtree.xpshared.htmlelements.HTMLElement;
using TestCase=junit.framework.TestCase;
using com.plumtree.openfoundation.util;
namespace com.bea.alui.taglib.advancedSearch.test
{
  public class TestAdvancedSearchResultTypesTag : TestCase
  {
    public MockEnvironment m_environment;
    internal static readonly String TAG_LIBNAME = AdvancedSearchTagLibraryData.LIBRARY.GetName();
    internal static readonly String TAG_NAME = AdvancedSearchResultTypesTag.TAG.GetName();
    public MockAdvancedSearchModel myModel;
    public MockTypeSelectorModel typeModel;
    public override void setUp()
    {
      m_environment = TagTestHelper.SetupTagTestEnvironment();
      TagTestHelper.CreateTestTag(TAG_LIBNAME, TAG_NAME, new AdvancedSearchResultTypesTag());
      //to satisfy the test that advancedsearch is calling the tag for use
      myModel = new MockAdvancedSearchModel();
      myModel.Init(m_environment);
      m_environment.m_models.PutElement(AdvancedSearchModel.STR_MVC_CLASS_NAME,
       myModel);
      typeModel = new MockTypeSelectorModel();
      typeModel.Init(m_environment);
      typeModel.InitializePlugIn(false, false);
      m_environment.m_models.PutElement(MockTypeSelectorModel.STR_MVC_CLASS_NAME,
       typeModel);
      ASTypesView typeView = new ASTypesView();
      typeView.Init(typeModel, m_environment);
      m_environment.m_views.PutElement(ASTypesView.STR_MVC_CLASS_NAME, typeView);
      }
    public virtual void testAdvancedSearchResultTypesTag()
    {
      XPHashtable newhash = new XPHashtable();
      HTMLElement resTypes = TagTestHelper.RunSingleTag(TAG_LIBNAME, TAG_NAME,
       newhash, m_environment);
      //IsDataTagResult checks for null or empty value, so verifying it's FALSE.
      assertFalse("Data tag returned the following error HTML:\n " + resTypes.GetDisplayString(),
       TagTestHelper.VerifyNoTagContent(resTypes));
      //verifying the html
      String htmlResult = resTypes.GetDisplayString();
      assertTrue("Advanced search result types filter not found in html!",
       (XPStringUtility.IndexOf(htmlResult, "name=\"in_cb_classiddetail\"") != -1));
      }
  }
}