using System;
using XPHashtable=com.plumtree.openfoundation.util.XPHashtable;
using MockAdvancedSearchModel=com.plumtree.portalpages.browsing.mock.search.advanced.MockAdvancedSearchModel;
using AdvancedSearchModel=com.plumtree.portalpages.browsing.search.advanced.AdvancedSearchModel;
using MockEnvironment=com.plumtree.portaluiinfrastructure.mock.tags.MockEnvironment;
using TagTestHelper=com.plumtree.portaluiinfrastructure.utils.TagTestHelper;
using com.plumtree.taglib.advancedSearch;
using HTMLElement=com.plumtree.xpshared.htmlelements.HTMLElement;
using TestCase=junit.framework.TestCase;
using com.plumtree.openfoundation.util;
namespace com.bea.alui.taglib.advancedSearch.test
{
  public class TestClearButtonTag : TestCase
  {
    public MockEnvironment m_environment;
    internal static readonly String TAG_LIBNAME = AdvancedSearchTagLibraryData.LIBRARY.GetName();
    internal static readonly String TAG_NAME = ClearButtonTag.TAG.GetName();
    public MockAdvancedSearchModel myModel;
    public override void setUp()
    {
      m_environment = TagTestHelper.SetupTagTestEnvironment();
      TagTestHelper.CreateTestTag(TAG_LIBNAME, TAG_NAME, new ClearButtonTag());
      myModel = new MockAdvancedSearchModel();
      myModel.Init(m_environment);
      m_environment.m_models.PutElement(AdvancedSearchModel.STR_MVC_CLASS_NAME,
       myModel);
    }
    public virtual void testClearButtonTag()
    {
      XPHashtable newhash = new XPHashtable();
      HTMLElement testClearButton = TagTestHelper.RunSingleTag(TAG_LIBNAME,
       TAG_NAME, newhash, m_environment);
      //IsDataTagResult checks for null or empty value, so verifying it's FALSE.
      assertFalse("Data tag returned the following error HTML:\n " + testClearButton.GetDisplayString(),
       TagTestHelper.VerifyNoTagContent(testClearButton));
      //verifying the html
      String htmlResult = testClearButton.GetDisplayString();
      assertTrue("Clear button not found in html!", (XPStringUtility.IndexOf(htmlResult,
       "name=\"in_bu_reset\"") != -1));
    }
  }
}