using System;
using TestCase=junit.framework.TestCase;
using XPHashtable=com.plumtree.openfoundation.util.XPHashtable;
using MockAdvancedSearchModel=com.plumtree.portalpages.browsing.mock.search.advanced.MockAdvancedSearchModel;
using MockFolderSelectorModel=com.plumtree.portalpages.common.search.MockFolderSelectorModel;
using MockEnvironment=com.plumtree.portaluiinfrastructure.mock.tags.MockEnvironment;
using TagTestHelper=com.plumtree.portaluiinfrastructure.utils.TagTestHelper;
using com.plumtree.taglib.advancedSearch;
using HTMLElement=com.plumtree.xpshared.htmlelements.HTMLElement;
using com.plumtree.openfoundation.util;
namespace com.bea.alui.taglib.advancedSearch.test
{
  public class TestExampleSearchTextTag : TestCase
  {
    public MockEnvironment m_environment;
    internal static readonly String TAG_LIBNAME = AdvancedSearchTagLibraryData.LIBRARY.GetName();
    internal static readonly String TAG_NAME = ExampleSearchTextTag.TAG.GetName();
    public MockAdvancedSearchModel myModel;
    public MockFolderSelectorModel folderModel;
    public override void setUp()
    {
      m_environment = TagTestHelper.SetupTagTestEnvironment();
      TagTestHelper.CreateTestTag(TAG_LIBNAME, TAG_NAME, new ExampleSearchTextTag());
      }
    public virtual void testExampleSearchTextTag()
    {
      XPHashtable newhash = new XPHashtable();
      HTMLElement langFilter = TagTestHelper.RunSingleTag(TAG_LIBNAME, TAG_NAME,
       newhash, m_environment);
      //IsDataTagResult checks for null or empty value, so verifying it's FALSE.
      assertFalse("Data tag returned the following error HTML:\n " + langFilter.GetDisplayString(),
       TagTestHelper.VerifyNoTagContent(langFilter));
      //the search text helper returns a table with localized placeholder string, so searching for that
      assertTrue("ExampleSearchTextTag not found in html!", (XPStringUtility.IndexOf(langFilter.GetDisplayString(),
       "localized placeholder") != -1));
    }
  }
}