package com.plumtree.taglib.advancedSearch;

import com.plumtree.portalpages.browsing.search.advanced.IAdvancedSearchModelRO;
import com.plumtree.portalpages.common.documentlanguage.*;
import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.portaluiinfrastructure.tags.common.CommonTagAttributeConstants;
import com.plumtree.portaluiinfrastructure.tags.metadata.*;
import com.plumtree.uiinfrastructure.activityspace.AActivitySpace;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This tag implements the advancedsearch.languagefilter tag.  This tag can only be used with an advanced search layout.
 * This tag generates the language filter.
 * @author Administrator
 *
 */
public class AdvancedSearchLanguageFilterTag extends AdvancedSearchPageTag {

	private static final String TAG_NAME = "languagefilter";
	
	public static final ITagMetaData TAG;
	
	public static final String DATATAG_DESCRIPTION = ATag.EncodeForTagDoc(
			"This tag creates the language filter for the advanced search.  This tag can only be used in the advanced" +
			"search layout.  This tag is not supported to work with a Pathways enabled advanced search.<br/>");

	
	static
	{
		// The TAG member variable needs to be initialized first since it
		// can be used in other tags (i.e. as a RequiredParentTag) that
		// are referenced by member variables of this tag (i.e. as a
		// RelatedChildTag).  This is necessary for tags that have
		// circular references such as a parent / child tag relationship.
		TAG = new TagMetaData(TAG_NAME, DATATAG_DESCRIPTION);
	}

	@Override
	public ATag Create() {
		return new AdvancedSearchLanguageFilterTag();
	}

	@Override
	public HTMLElement DisplayTag() {
	    AActivitySpace asOwner = (AActivitySpace) GetEnvironment();
		//We are checking to ensure that this tag is only being used for an advanced search layout, not used otherwise.
		IAdvancedSearchModelRO advSearchModel = GetAdvancedSearchModel();
	    
	    //creates the language filter
	    HTMLElement languageFilter = asOwner.GetView(CardLanguagePlugInView.STR_MVC_CLASS_NAME).Display();	    
	    HTMLElement languageItem = new HTMLElementCollection();
	    languageItem.AddInnerHTMLElement(languageFilter);
	    return languageItem;
	}

}
