package com.plumtree.taglib.advancedSearch;

import com.plumtree.openfoundation.util.XPNullPointerException;
import com.plumtree.portalpages.browsing.search.advanced.*;
import com.plumtree.portalpages.common.documentlanguage.*;
import com.plumtree.portaluiinfrastructure.tags.ATag;
import com.plumtree.uiinfrastructure.activityspace.AActivitySpace;
import com.plumtree.openfoundation.util.*;

/**
 * Abstract base class to simplify advanced search page tag development. Used to retrieve the
 * model (IAdvancedSarchModelRO)
 * 
 */

public abstract class AdvancedSearchPageTag extends ATag {

	protected static final String ADVANCED_SEARCH_ONLY_CONSTANT = "This tag only works with " +
	"the Advanced Search Page Adaptive Layout.";
	
	protected IAdvancedSearchModelRO GetAdvancedSearchModel() {
		AActivitySpace space = (AActivitySpace) GetEnvironment();
		if (space.GetModelExists(AdvancedSearchModel.STR_MVC_CLASS_NAME)) {
			return (IAdvancedSearchModelRO) space.GetModel(AdvancedSearchModel.STR_MVC_CLASS_NAME);
		} else {
			throw new XPIllegalStateException(GetName() + " tag can only be used in " +
			"the Advanced Search page.");
		}
	
	}
}
