package com.plumtree.taglib.advancedSearch;

import com.plumtree.portalpages.browsing.search.advanced.*;
import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.portaluiinfrastructure.tags.common.CommonTagAttributeConstants;
import com.plumtree.portaluiinfrastructure.tags.metadata.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This class implements the advancedsearch.searchhelp tag.  I do not limit this tag to the advanced search layout only
 * b/c it seems harmless to allow users to be able to add the search sample helper.
 * Adds the search help text to the page.
 * @author Administrator
 *
 */
public class ExampleSearchTextTag extends ATag {
	
	private static final String TAG_NAME = "searchhelp";
	
	public static final ITagMetaData TAG;
	
	public static final String DATATAG_DESCRIPTION = ATag.EncodeForTagDoc(
			"This tag creates the sample search help text for advanced search.<br/>");

	
	static
	{
		// The TAG member variable needs to be initialized first since it
		// can be used in other tags (i.e. as a RequiredParentTag) that
		// are referenced by member variables of this tag (i.e. as a
		// RelatedChildTag).  This is necessary for tags that have
		// circular references such as a parent / child tag relationship.
		TAG = new TagMetaData(TAG_NAME, DATATAG_DESCRIPTION);
	}


	@Override
	public ATag Create() {
		return new ExampleSearchTextTag();
	}

	@Override
	public HTMLElement DisplayTag() {
		AActivitySpace asOwner = (AActivitySpace)GetEnvironment();

		HTMLElement searchHelp = new HTMLElementCollection();
		searchHelp.AddInnerHTMLElement(AdvancedSearchDP.MakeSearchHelpText(asOwner));
		return searchHelp;
	}

}
