package com.bea.alui.taglib.advancedSearch.test;

import junit.framework.*;

import com.plumtree.openfoundation.util.XPHashtable;
import com.plumtree.portalpages.browsing.mock.search.advanced.MockAdvancedSearchModel;
import com.plumtree.portalpages.browsing.search.advanced.AdvancedSearchModel;
import com.plumtree.portaluiinfrastructure.mock.tags.MockEnvironment;
import com.plumtree.portaluiinfrastructure.utils.*;
import com.plumtree.taglib.advancedSearch.*;
import com.plumtree.xpshared.htmlelements.HTMLElement;

/**
 * Tests the advanced search button tag by loading up the tag on the page and comparing the HTML. 
 * @author lmah
 *
 */
public class TestAdvSearchButtonTag extends TestCase {
	
	public MockEnvironment m_environment;
	static final String TAG_LIBNAME  	= AdvancedSearchTagLibraryData.LIBRARY.GetName();
	static final String TAG_NAME     	= AdvSearchButtonTag.TAG.GetName();
	
	public MockAdvancedSearchModel myModel;

	
	public void setUp() 
	{
		m_environment = TagTestHelper.SetupTagTestEnvironment();
		TagTestHelper.CreateTestTag(TAG_LIBNAME, TAG_NAME, new AdvSearchButtonTag());
		myModel = new MockAdvancedSearchModel();
		myModel.Init(m_environment);
		m_environment.m_models.PutElement(AdvancedSearchModel.STR_MVC_CLASS_NAME, myModel);
			
	}
	
	public void testAdvSearchButton()
	{
		XPHashtable newhash = new XPHashtable();
		HTMLElement testAdvSearchButton = TagTestHelper.RunSingleTag(TAG_LIBNAME, TAG_NAME, newhash, m_environment);
		//IsDataTagResult checks for null or empty value, so verifying it's FALSE.
		assertFalse("Data tag returned the following error HTML:\n "+testAdvSearchButton.GetDisplayString(),
				TagTestHelper.VerifyNoTagContent(testAdvSearchButton));

		//verifying the html
		String htmlResult = testAdvSearchButton.GetDisplayString();
		assertTrue("Advanced search button not found in html!", (htmlResult.indexOf("name=\"in_bu_submitsearch\"") != -1) );
		
	}
	
}
