package com.bea.alui.taglib.advancedSearch.test;

import com.plumtree.openfoundation.util.XPHashtable;
import com.plumtree.portalpages.browsing.mock.search.advanced.MockAdvancedSearchModel;
import com.plumtree.portalpages.browsing.search.advanced.*;
import com.plumtree.portalpages.common.documentlanguage.MockCardLanguagePlugInModel;
import com.plumtree.portalpages.common.search.MockFolderSelectorModel;
import com.plumtree.portaluiinfrastructure.mock.tags.MockEnvironment;
import com.plumtree.portaluiinfrastructure.utils.TagTestHelper;
import com.plumtree.taglib.advancedSearch.*;
import com.plumtree.xpshared.htmlelements.HTMLElement;

import junit.framework.TestCase;

public class TestAdvancedSearchFolderFilterTag extends TestCase {
	public MockEnvironment m_environment;
	static final String TAG_LIBNAME  	= AdvancedSearchTagLibraryData.LIBRARY.GetName();
	static final String TAG_NAME     	= AdvancedSearchFolderFilterTag.TAG.GetName();
	
	public MockAdvancedSearchModel myModel;
	public MockFolderSelectorModel folderModel;
	
	public void setUp() 
	{
		m_environment = TagTestHelper.SetupTagTestEnvironment();
		TagTestHelper.CreateTestTag(TAG_LIBNAME, TAG_NAME, new AdvancedSearchFolderFilterTag());
		//to satisfy the test that advancedsearch is calling the tag for use
		myModel = new MockAdvancedSearchModel();
		myModel.Init(m_environment);
		m_environment.m_models.PutElement(AdvancedSearchModel.STR_MVC_CLASS_NAME, myModel);
		
		folderModel = new MockFolderSelectorModel();
		folderModel.Init(m_environment);
		folderModel.InitializePlugIn(true);
		m_environment.m_models.PutElement(MockFolderSelectorModel.STR_MVC_CLASS_NAME, folderModel);
		
		ASFoldersView folderView = new ASFoldersView();
		folderView.Init(folderModel, m_environment);
		m_environment.m_views.PutElement(ASFoldersView.STR_MVC_CLASS_NAME, folderView);
		
	}
	
	public void testAdvancedSearchFolderFilterTag()
	{
		XPHashtable newhash = new XPHashtable();
		// TODO pass in null for newhash, remove top
		HTMLElement folderFilter = TagTestHelper.RunSingleTag(TAG_LIBNAME, TAG_NAME, newhash, m_environment);
		//IsDataTagResult checks for null or empty value, so verifying it's FALSE.
		assertFalse("Data tag returned the following error HTML:\n "+folderFilter.GetDisplayString(),
				TagTestHelper.VerifyNoTagContent(folderFilter));
		
		//verifying the html
		String htmlResult = folderFilter.GetDisplayString();
		assertTrue("Advanced search language filter not found in html!", (htmlResult.indexOf("name=\"in_cb_subfoldersearch\"") != -1) );
	}

}
