package com.bea.alui.taglib.advancedSearch.test;

import com.plumtree.openfoundation.util.XPHashtable;
import com.plumtree.portalpages.browsing.mock.search.advanced.MockAdvancedSearchModel;
import com.plumtree.portalpages.browsing.search.advanced.AdvancedSearchModel;
import com.plumtree.portalpages.common.documentlanguage.*;
import com.plumtree.portalpages.common.search.*;
import com.plumtree.portaluiinfrastructure.application.varpacks.PTSearchLocaleVarPack;
import com.plumtree.portaluiinfrastructure.mock.application.varpacks.MockPTSearchLocaleVarPack;
import com.plumtree.portaluiinfrastructure.mock.friendlyurl.MockApplicationManager;
import com.plumtree.portaluiinfrastructure.mock.tags.MockEnvironment;
import com.plumtree.portaluiinfrastructure.utils.TagTestHelper;
import com.plumtree.taglib.advancedSearch.*;
import com.plumtree.uiinfrastructure.application.varpacks.AppConstants;
import com.plumtree.uiinfrastructure.web.*;
import com.plumtree.xpshared.htmlelements.HTMLElement;

import junit.framework.TestCase;

public class TestAdvancedSearchLanguageFilterTag extends TestCase {
	public MockEnvironment m_environment;
	static final String TAG_LIBNAME  	= AdvancedSearchTagLibraryData.LIBRARY.GetName();
	static final String TAG_NAME     	= AdvancedSearchLanguageFilterTag.TAG.GetName();
	
	public MockAdvancedSearchModel myModel;
	public MockCardLanguagePlugInModel languageModel;
	
	public void setUp() 
	{
		m_environment = TagTestHelper.SetupTagTestEnvironment();
		TagTestHelper.CreateTestTag(TAG_LIBNAME, TAG_NAME, new AdvancedSearchLanguageFilterTag());
		//to satisfy the test that advancedsearch is calling the tag for use
		myModel = new MockAdvancedSearchModel();
		myModel.Init(m_environment);
		m_environment.m_models.PutElement(AdvancedSearchModel.STR_MVC_CLASS_NAME, myModel);
		
		//setting the varpack
		IApplication mockApp = m_environment.GetApplication();
		MockApplicationManager test = (MockApplicationManager) ApplicationManager.GetInstance();
		MockPTSearchLocaleVarPack vpPTSearchLocales = new MockPTSearchLocaleVarPack();
		vpPTSearchLocales.LoadForTest();
		mockApp.GetVarPackManager().AddVariablePackage(vpPTSearchLocales);
		test.SetApplication(AppConstants.MAIN_APPLICATION_NAME.ToString(), mockApp);	
		m_environment.SetApplication(mockApp);
		
		languageModel = new MockCardLanguagePlugInModel();
		languageModel.Init(m_environment);
		String lastLang = CardLanguagePlugInView.s_AllLanguagesOptionCode;
		languageModel.InitializePlugIn(lastLang, "Language", "Results in this language", true); 
		m_environment.m_models.PutElement(MockCardLanguagePlugInModel.STR_MVC_CLASS_NAME, languageModel);
		
		CardLanguagePlugInView cview = new CardLanguagePlugInView();
		cview.Init(languageModel, m_environment);
		m_environment.m_views.PutElement(CardLanguagePlugInView.STR_MVC_CLASS_NAME, cview);

	}
	
	public void testAdvancedSearchLanguageFilterTag()
	{
		XPHashtable newhash = new XPHashtable();
		HTMLElement langFilter = TagTestHelper.RunSingleTag(TAG_LIBNAME, TAG_NAME, newhash, m_environment);
		//IsDataTagResult checks for null or empty value, so verifying it's FALSE.
		assertFalse("Data tag returned the following error HTML:\n "+langFilter.GetDisplayString(),
				TagTestHelper.VerifyNoTagContent(langFilter));

		//verifying the html
		String htmlResult = langFilter.GetDisplayString();
		assertTrue("Advanced search language filter not found in html!", (htmlResult.indexOf("name=\"in_se_CardLanguage\"") != -1) );

		
	}
}
