package com.bea.alui.taglib.advancedSearch.test;

import junit.framework.TestCase;

import com.plumtree.openfoundation.util.XPHashtable;
import com.plumtree.portalpages.browsing.mock.search.advanced.MockAdvancedSearchModel;
import com.plumtree.portalpages.browsing.search.advanced.AdvancedSearchModel;
import com.plumtree.portalpages.common.search.*;
import com.plumtree.portaluiinfrastructure.mock.tags.MockEnvironment;
import com.plumtree.portaluiinfrastructure.utils.TagTestHelper;
import com.plumtree.taglib.advancedSearch.*;
import com.plumtree.xpshared.htmlelements.HTMLElement;

public class TestAdvancedSearchResultCount extends TestCase {
	
	public MockEnvironment m_environment;
	static final String TAG_LIBNAME  	= AdvancedSearchTagLibraryData.LIBRARY.GetName();
	static final String TAG_NAME     	= AdvancedSearchResultCountTag.TAG.GetName();
	
	public MockAdvancedSearchModel myModel;
	public MockSimpleSelectorModel simpleModel;

	
	public void setUp() 
	{
		m_environment = TagTestHelper.SetupTagTestEnvironment();
		TagTestHelper.CreateTestTag(TAG_LIBNAME, TAG_NAME, new AdvancedSearchResultCountTag());
		//to satisfy the test that advancedsearch is calling the tag for use
		myModel = new MockAdvancedSearchModel();
		myModel.Init(m_environment);
		m_environment.m_models.PutElement(AdvancedSearchModel.STR_MVC_CLASS_NAME, myModel);
		
		simpleModel = new MockSimpleSelectorModel();
		simpleModel.InitializePlugIn(new String[] { "10", "20", "50", "100" },
				/* initialSelection= */ 0, 
				"Result Size", "Results Per Page",	AdvancedSearchModel.HTML_SELECT_NUMRESULTS);
		
		SimpleSelectorView myview = new SimpleSelectorView();
		myview.Init(simpleModel, m_environment);
		m_environment.m_views.PutElement(SimpleSelectorView.STR_MVC_CLASS_NAME, myview);
			
	}

	public void testAdvancedSearchResultCountTag()
	{
		XPHashtable newhash = new XPHashtable();
		HTMLElement srCount = TagTestHelper.RunSingleTag(TAG_LIBNAME, TAG_NAME, newhash, m_environment);
		//IsDataTagResult checks for null or empty value, so verifying it's FALSE.
		assertFalse("Data tag returned the following error HTML:\n "+srCount.GetDisplayString(),
				TagTestHelper.VerifyNoTagContent(srCount));
				
		String srResult = srCount.GetDisplayString();
		assertTrue("Result Count filter not found in html!", (srResult.indexOf("name=\"in_se_numresults\"") != -1));
	}

}
