package com.bea.alui.taglib.advancedSearch.test;

import com.plumtree.openfoundation.util.XPHashtable;
import com.plumtree.portalpages.browsing.mock.search.advanced.MockAdvancedSearchModel;
import com.plumtree.portalpages.browsing.search.advanced.*;
import com.plumtree.portalpages.common.documentlanguage.MockCardLanguagePlugInModel;
import com.plumtree.portalpages.common.search.*;
import com.plumtree.portaluiinfrastructure.mock.tags.MockEnvironment;
import com.plumtree.portaluiinfrastructure.utils.TagTestHelper;
import com.plumtree.taglib.advancedSearch.*;
import com.plumtree.xpshared.htmlelements.HTMLElement;

import junit.framework.TestCase;

public class TestAdvancedSearchResultTypesTag extends TestCase {
	public MockEnvironment m_environment;
	static final String TAG_LIBNAME  	= AdvancedSearchTagLibraryData.LIBRARY.GetName();
	static final String TAG_NAME     	= AdvancedSearchResultTypesTag.TAG.GetName();
	
	public MockAdvancedSearchModel myModel;
	public MockTypeSelectorModel typeModel;

	
	public void setUp() 
	{
		m_environment = TagTestHelper.SetupTagTestEnvironment();
		TagTestHelper.CreateTestTag(TAG_LIBNAME, TAG_NAME, new AdvancedSearchResultTypesTag());
		//to satisfy the test that advancedsearch is calling the tag for use
		myModel = new MockAdvancedSearchModel();
		myModel.Init(m_environment);
		m_environment.m_models.PutElement(AdvancedSearchModel.STR_MVC_CLASS_NAME, myModel);
		
		typeModel = new MockTypeSelectorModel();
		typeModel.Init(m_environment);
		typeModel.InitializePlugIn(false, false);
		m_environment.m_models.PutElement(MockTypeSelectorModel.STR_MVC_CLASS_NAME, typeModel);
		
		ASTypesView typeView = new ASTypesView();
		typeView.Init(typeModel, m_environment);
		m_environment.m_views.PutElement(ASTypesView.STR_MVC_CLASS_NAME, typeView);

	}
	
	public void testAdvancedSearchResultTypesTag()
	{
		XPHashtable newhash = new XPHashtable();
		HTMLElement resTypes = TagTestHelper.RunSingleTag(TAG_LIBNAME, TAG_NAME, newhash, m_environment);
		//IsDataTagResult checks for null or empty value, so verifying it's FALSE.
		assertFalse("Data tag returned the following error HTML:\n "+resTypes.GetDisplayString(),
				TagTestHelper.VerifyNoTagContent(resTypes));
		//verifying the html
		String htmlResult = resTypes.GetDisplayString();
		assertTrue("Advanced search result types filter not found in html!", (htmlResult.indexOf("name=\"in_cb_classiddetail\"") != -1) );
	}


}
