package com.bea.alui.taglib.advancedSearch.test;

import com.plumtree.openfoundation.util.XPHashtable;
import com.plumtree.portalpages.browsing.mock.search.advanced.MockAdvancedSearchModel;
import com.plumtree.portalpages.browsing.search.advanced.AdvancedSearchModel;
import com.plumtree.portaluiinfrastructure.mock.tags.MockEnvironment;
import com.plumtree.portaluiinfrastructure.utils.TagTestHelper;
import com.plumtree.taglib.advancedSearch.*;
import com.plumtree.xpshared.htmlelements.HTMLElement;

import junit.framework.TestCase;

public class TestClearButtonTag extends TestCase {
	
	public MockEnvironment m_environment;
	static final String TAG_LIBNAME  	= AdvancedSearchTagLibraryData.LIBRARY.GetName();
	static final String TAG_NAME     	= ClearButtonTag.TAG.GetName();
	
	public MockAdvancedSearchModel myModel;

	
	public void setUp() 
	{
		m_environment = TagTestHelper.SetupTagTestEnvironment();
		TagTestHelper.CreateTestTag(TAG_LIBNAME, TAG_NAME, new ClearButtonTag());
		myModel = new MockAdvancedSearchModel();
		myModel.Init(m_environment);
		m_environment.m_models.PutElement(AdvancedSearchModel.STR_MVC_CLASS_NAME, myModel);
			
	}
	
	public void testClearButtonTag()
	{
		XPHashtable newhash = new XPHashtable();
		HTMLElement testClearButton = TagTestHelper.RunSingleTag(TAG_LIBNAME, TAG_NAME, newhash, m_environment);
		//IsDataTagResult checks for null or empty value, so verifying it's FALSE.
		assertFalse("Data tag returned the following error HTML:\n "+testClearButton.GetDisplayString(),
				TagTestHelper.VerifyNoTagContent(testClearButton));

		//verifying the html
		String htmlResult = testClearButton.GetDisplayString();
		assertTrue("Clear button not found in html!", (htmlResult.indexOf("name=\"in_bu_reset\"") != -1) );
		
	}

}
