package com.bea.alui.taglib.advancedSearch.test;

import junit.framework.TestCase;

import com.plumtree.openfoundation.util.XPHashtable;
import com.plumtree.portalpages.browsing.mock.search.advanced.MockAdvancedSearchModel;
import com.plumtree.portalpages.common.search.MockFolderSelectorModel;
import com.plumtree.portaluiinfrastructure.mock.tags.MockEnvironment;
import com.plumtree.portaluiinfrastructure.utils.TagTestHelper;
import com.plumtree.taglib.advancedSearch.*;
import com.plumtree.xpshared.htmlelements.HTMLElement;

public class TestExampleSearchTextTag extends TestCase {

	public MockEnvironment m_environment;
	static final String TAG_LIBNAME  	= AdvancedSearchTagLibraryData.LIBRARY.GetName();
	static final String TAG_NAME     	= ExampleSearchTextTag.TAG.GetName();
	
	public MockAdvancedSearchModel myModel;
	public MockFolderSelectorModel folderModel;
	
	public void setUp() 
	{
		m_environment = TagTestHelper.SetupTagTestEnvironment();
		TagTestHelper.CreateTestTag(TAG_LIBNAME, TAG_NAME, new ExampleSearchTextTag());
	}
	
	public void testExampleSearchTextTag()
	{
		XPHashtable newhash = new XPHashtable();
		HTMLElement langFilter = TagTestHelper.RunSingleTag(TAG_LIBNAME, TAG_NAME, newhash, m_environment);
		//IsDataTagResult checks for null or empty value, so verifying it's FALSE.
		assertFalse("Data tag returned the following error HTML:\n "+langFilter.GetDisplayString(),
				TagTestHelper.VerifyNoTagContent(langFilter));

		//the search text helper returns a table with localized placeholder string, so searching for that
		assertTrue("ExampleSearchTextTag not found in html!", (langFilter.GetDisplayString().indexOf("localized placeholder") != -1));
	}
}
