package com.bea.alui.taglib.advancedSearch.test;

import junit.framework.TestCase;

import com.plumtree.portalpages.browsing.mock.search.advanced.MockAdvancedSearchModel;
import com.plumtree.portalpages.browsing.search.advanced.*;
import com.plumtree.portaluiinfrastructure.mock.tags.MockEnvironment;
import com.plumtree.portaluiinfrastructure.utils.TagTestHelper;
import com.plumtree.taglib.advancedSearch.*;
import com.plumtree.xpshared.htmlelements.HTMLElement;

public class TestSearchCriteriaDisplayTag extends TestCase {
	public MockEnvironment m_environment;
	static final String TAG_LIBNAME  	= AdvancedSearchTagLibraryData.LIBRARY.GetName();
	static final String TAG_NAME     	= SearchCriteriaDisplayTag.TAG.GetName();
	
	public MockAdvancedSearchModel myModel;
	
	public void setUp() 
	{
		m_environment = TagTestHelper.SetupTagTestEnvironment();
		TagTestHelper.CreateTestTag(TAG_LIBNAME, TAG_NAME, new SearchCriteriaDisplayTag());
		//to satisfy the test that advancedsearch is calling the tag for use
		myModel = new MockAdvancedSearchModel();
		myModel.Init(m_environment);
		myModel.CheckEditorAccessAndStart(m_environment.GetCurrentFormData());
		m_environment.m_models.PutElement(AdvancedSearchModel.STR_MVC_CLASS_NAME, myModel);		
	}
	
	/*
	 * This unit test doesn't actually call the SearchCriteriaDisplay tag.  But it simulates in the mock environment what
	 * the tag would have done, which is called scView.Display() and return the html results.  
	 * The reason for why I didn't just setup the mock objects for the Display() function is that there were too many objects
	 * in the display() function that I'd need to generate mock classes for.  The benefits of mocking the classes to make
	 * the unit test pass didn't seem to outweight the time and effort it would take to make them.  Unless we see a future
	 * use in mocking ImgSvrURLHelper, PTPersonalSettingsHelper, and QueryCondition (there may be others that I'm missing).
	 */
	public void testSearchCriteriaDisplay()
	{
		ASFilterView scView = new ASFilterView();
		scView.Init(myModel, m_environment);
		
		HTMLElement htmlResult = scView.TestDisplay();
		assertTrue("Testdisplay should return test result.", htmlResult.GetDisplayString().equals("This is test data from FilterView.TestDisplay"));
	}
	
	
}
