using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.bea.alui.taglib.basepage
{
  public abstract class ABasePageTag : ATag
  {
    
    /// <returns>The current PlumtreeDP page. </returns>
    /// <throws>
    /// XPClassCastException if the current page does not
    /// extend PlumtreeDP.
    /// </throws>
    protected virtual PlumtreeDP GetPlumtreeDP()
    {
      AActivitySpace space = (AActivitySpace) GetEnvironment();
      IDisplayPage basePage = space.GetCurrentPage();
      // NOTE: Unclear if it would be more efficient to cast and just catch exceptions,
      // or to use instanceof.  Neither is particularly slow, or fast.
      if (!(basePage is PlumtreeDP))
      {
        throw new XPClassCastException(GetName() + " tag can only be used with " + "pages that extend PlumtreeDP.  " + basePage.GetName() + " does not.");
        }
      return (PlumtreeDP) basePage;
    }
  }
}