using System;
using XPException=com.plumtree.openfoundation.util.XPException;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using AActivitySpace=com.plumtree.uiinfrastructure.activityspace.AActivitySpace;
using com.plumtree.uiinfrastructure.constants;
using com.plumtree.xpshared.htmlelements;
namespace com.bea.alui.taglib.basepage
{
  /// <summary>
  /// This tag displays a Layout header.
  /// </summary>
  /// <author>Ravi Tunuguntla</author>
  public class HeaderTag : ABasePageTag
  {
    private const String TAG_NAME = "header";
    public static readonly ITagMetaData TAG;
    static HeaderTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData(TAG_NAME, "This tag displays a Header from a template");
      }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#DisplayTag()"></seealso>
    public override HTMLElement DisplayTag()
    {
      HTMLElementCollection myHeaderHTML = null;
      INavigationModelRO navModel = (INavigationModelRO) ((AActivitySpace) GetEnvironment()).GetModel(NavigationModel.STR_MVC_CLASS_NAME);
      if (navModel != null)
      {
        myHeaderHTML = navModel.GetHeaderElement();
      } else
      {
        throw new XPException("Navigation Model is null, ActivitySpace did not initialize properly");
        }
      return myHeaderHTML;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#GetTagType()"></seealso>
    public override TagType GetTagType()
    {
      return TagType.NO_BODY;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#SupportsAccessStyle(AccessStyles)"></seealso>
    public override bool SupportsAccessStyle(AccessStyles _style)
    {
      // This tag does not display any JavaScript, and therefore
      // supports all access styles.
      return true;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#Create()"></seealso>
    public override ATag Create()
    {
      return new HeaderTag();
    }
  }
}