using System;
using junit.framework;
using com.bea.alui.taglib.basepage;
using com.bea.alui.taglib.basepage.test.integration;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.application.varpacks;
using com.plumtree.portaluiinfrastructure.helpers;
using com.plumtree.portaluiinfrastructure.layout;
using com.plumtree.portaluiinfrastructure.mock.helper;
using com.plumtree.portaluiinfrastructure.mock.layout;
using com.plumtree.portaluiinfrastructure.mock.tags;
using com.plumtree.portaluiinfrastructure.mock.uiinfrastructure;
using com.plumtree.portaluiinfrastructure.tags.manager;
using com.plumtree.server;
using com.plumtree.server.mock.core;
using com.plumtree.uiinfrastructure.helpers;
using com.plumtree.xpshared.htmlelements;
namespace com.bea.alui.taglib.basepage.test
{
  // *** CR rob - high level description of what is tested by this class missing 
  public class TestNavAreaTag : TestCase
  {
    private const String TEST_HTML_OPEN_TAG = "<html>";
    private const String TEST_HEAD_OPEN_TAG = "<head>";
    private const String TEST_JS_TAG = "<script type=\"text/javascript\"></script>";
    private const String TEST_HEAD_CLOSE_TAG = "</head>";
    private const String TEST_BODY_OPEN_TAG = "<body>";
    private const String TEST_HTML_SUFFIX = "</body></html>";
    private const String TEST_PROCESSED_PREFIX = "<pt:common.headincludes/>";
    public TestLayoutPlumtreeAS m_environment;
    public TestLayoutPlumtreeDP m_layoutPage;
    public MockLayoutManager m_layoutManager;
    public MockPTSession m_session;
    public MockConfigHelper m_configHelper;
    public MockPTConfigHelper m_helper;
    public override void setUp()
    {
      m_configHelper = new MockConfigHelper();
      ConfigService.setTestInstance(m_configHelper);
      m_helper = new MockPTConfigHelper();
      PTConfigService.setTestPTInstance(m_helper);
      // Enable layouts globally in the config file
      m_helper.SetConfigVariable(PTConfigConstants.SYSTEM_PROPERTIES_SECTION,
       PTConfigConstants.LAYOUT_MODE_SUBSECTION, "1");
      m_environment = new TestLayoutPlumtreeAS();
      m_layoutPage = new TestLayoutPlumtreeDP();
      m_session = new MockPTSession();
      m_layoutPage.SetLayoutMode(true);
      m_layoutPage.Init(m_environment);
      m_environment.SetTrackCurrentPage(true);
      m_environment.SetCurrentPage(m_layoutPage);
      m_environment.SetUserSession(m_session);
      m_layoutManager = new MockLayoutManager();
      LayoutService.setManagerTestInstance(m_layoutManager);
      MockTagLibManager tagLibs = new MockTagLibManager();
      tagLibs.SetTag(new NavAreaTag(), NavAreaTag.TAG.GetName(), BasePageTagLibraryData.LIBRARY.GetName());
      TagLibManager.setTestInstance(tagLibs);
    }
    public virtual void testNavAreaTag()
    {
      Object[][] objArrMarkup = new Object[2][];
      for (int j2c_index = 0;j2c_index < 2;j2c_index++)
      {
        objArrMarkup[j2c_index] = new Object[8];
      }
      XPHashtable attrTab = new XPHashtable();
      attrTab.PutElement("area", "ABOVEHEADER");
      int i = setHeadHTML(objArrMarkup, BasePageTagLibraryData.LIBRARY.GetName() + "." + NavAreaTag.TAG.GetName(),
       attrTab);
      objArrMarkup[PT_MARKUP_ARRAY_COLS.PT_MARKUP_ARRAY_COLS_TYPE][i] = PT_MARKUP_FRAGMENT_TYPES.PT_MARKUP_FRAGMENT_TYPE_FINISHED;
      objArrMarkup[PT_MARKUP_ARRAY_COLS.PT_MARKUP_ARRAY_COLS_FRAGMENT][i] = TEST_BODY_OPEN_TAG + TEST_HTML_SUFFIX;
      i++;
      m_layoutManager.SetLayout(Layouts.BASE_PAGE.GetDefaultWebServiceID(),
       objArrMarkup);
      HTMLElement result = m_layoutPage.GetLayoutTestResult();
      assertNotNull("Page should return non-null HTMLElement.", result);
      assertEquals("Checking displayed content with NavArea tag.", TEST_HTML_OPEN_TAG + TEST_HEAD_OPEN_TAG + TEST_PROCESSED_PREFIX + TEST_HEAD_CLOSE_TAG + TEST_BODY_OPEN_TAG + TEST_HTML_SUFFIX,
       result.GetDisplayString());
    }
    
    /// <summary>
    /// This method sets up an empty head tag (with html open).  It uses
    /// up 6 spots in the array, plus one if you add HTML.
    /// </summary>
    /// <param name="_markup"></param>
    /// <param name="The">full name (lib.name) of the adaptive tag to insert into the head.</param>
    /// <returns>the index into the next empty spot in the array</returns>
    public virtual int setHeadHTML(Object[][] _markup, String _strFullTagName,
     XPHashtable attMap)
    {
      int i = 0;
      _markup[PT_MARKUP_ARRAY_COLS.PT_MARKUP_ARRAY_COLS_TYPE][i] = PT_MARKUP_FRAGMENT_TYPES.PT_MARKUP_FRAGMENT_TYPE_FINISHED;
      _markup[PT_MARKUP_ARRAY_COLS.PT_MARKUP_ARRAY_COLS_FRAGMENT][i] = TEST_HTML_OPEN_TAG;
      i++;
      _markup[PT_MARKUP_ARRAY_COLS.PT_MARKUP_ARRAY_COLS_TYPE][i] = PT_MARKUP_FRAGMENT_TYPES.PT_MARKUP_FRAGMENT_TYPE_BEGIN_HTML;
      i++;
      _markup[PT_MARKUP_ARRAY_COLS.PT_MARKUP_ARRAY_COLS_TYPE][i] = PT_MARKUP_FRAGMENT_TYPES.PT_MARKUP_FRAGMENT_TYPE_FINISHED;
      _markup[PT_MARKUP_ARRAY_COLS.PT_MARKUP_ARRAY_COLS_FRAGMENT][i] = TEST_HEAD_OPEN_TAG;
      i++;
      _markup[PT_MARKUP_ARRAY_COLS.PT_MARKUP_ARRAY_COLS_TYPE][i] = PT_MARKUP_FRAGMENT_TYPES.PT_MARKUP_FRAGMENT_TYPE_BEGIN_HEAD;
      i++;
      if (_strFullTagName != null)
      {
        _markup[PT_MARKUP_ARRAY_COLS.PT_MARKUP_ARRAY_COLS_TYPE][i] = PT_MARKUP_FRAGMENT_TYPES.PT_MARKUP_FRAGMENT_TYPE_PT_XML;
        if (attMap != null)
        {
          int arrSize = attMap.GetSize() + 2;
          Object[] tagType = new Object[arrSize];
          Object[] tagInfo = new Object[arrSize];
          Object[] tagVals = new Object[arrSize];
          tagType[0] = PT_XML_TYPES.PT_XML_TYPES_PTUI;
          tagInfo[0] = BasePageTagLibraryData.LIBRARY.GetName() + "." + NavAreaTag.TAG.GetName();
          tagVals[0] = null;
          int k = 1;
          for (IXPEnumerator e = attMap.GetKeys();e.MoveNext();)
          {
            tagType[k] = PT_XML_TYPES.PT_XML_TYPES_PTUI_ATT;
            tagInfo[k] = e.GetCurrent();
            tagVals[k] = attMap.GetElement(e.GetCurrent());
            k++;
          }
          tagType[arrSize - 1] = PT_XML_TYPES.PT_XML_TYPES_PTUI_CLOSE;
          tagInfo[arrSize - 1] = null;
          tagVals[arrSize - 1] = null;
          Object[][] singletonTagObjXML = {tagType, tagInfo, tagVals};
          _markup[PT_MARKUP_ARRAY_COLS.PT_MARKUP_ARRAY_COLS_FRAGMENT][i] = singletonTagObjXML;
          i++;
        } else
        {
          // Can't put this directly as an argument because of jump issues.
          Object[][] singletonTagObjXML = {new Object[]{PT_XML_TYPES.PT_XML_TYPES_PTUI,
           PT_XML_TYPES.PT_XML_TYPES_PTUI_CLOSE}, new Object[]{_strFullTagName,
           null}, new Object[]{null, null}};
          // Add a singleton tag
          _markup[PT_MARKUP_ARRAY_COLS.PT_MARKUP_ARRAY_COLS_FRAGMENT][i] = singletonTagObjXML;
          i++;
        }
      }
      _markup[PT_MARKUP_ARRAY_COLS.PT_MARKUP_ARRAY_COLS_TYPE][i] = PT_MARKUP_FRAGMENT_TYPES.PT_MARKUP_FRAGMENT_TYPE_END_HEAD;
      i++;
      _markup[PT_MARKUP_ARRAY_COLS.PT_MARKUP_ARRAY_COLS_TYPE][i] = PT_MARKUP_FRAGMENT_TYPES.PT_MARKUP_FRAGMENT_TYPE_FINISHED;
      _markup[PT_MARKUP_ARRAY_COLS.PT_MARKUP_ARRAY_COLS_FRAGMENT][i] = TEST_HEAD_CLOSE_TAG;
      i++;
      return i;
    }
  }
}