using System;
using com.plumtree.portalpages.common.uiparts;
using com.plumtree.portaluiinfrastructure.layout;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.bea.alui.taglib.basepage.test.integration
{
  public class TestLayoutPlumtreeDP : PlumtreeDP
  {
    public const String TEST_HEADER_CONTENT = "<div> Test Header Content </div>";
    public const String TEST_FOOTER_CONTENT = "<td><span>Test Footer Text</span><td>";
    public const String TEST_BODY_CONTENT = "<span>Test Body Content</span>";
    public const String TEST_JAVASCRIPT_CHILD_CONTENT = "var testChild = true;";
    public const String TEST_JAVASCRIPT_BASIC_CONTENT = "var testBasic = true;";
    public const String TEST_JAVASCRIPT_PAGE_ONLOAD_DEFAULT = "var testOnLoad = true;";
    public const String TEST_META_REFRESH_URL = "URL=http://meta.test.com";
    public const String TEST_META_REFRESH_EQUIV = "refresh";
    public const String TEST_PAGE_TITLE = "Page Title";
    public bool m_bLayoutMode = true;
    public String m_strOnLoadJS = TEST_JAVASCRIPT_PAGE_ONLOAD_DEFAULT;
    public virtual HTMLElement GetLayoutTestResult()
    {
      // true means main page
      return DisplayLayout(Layouts.BASE_PAGE.GetDefaultWebServiceID(), true);
      }
    public virtual void SetLayoutMode(bool _bMode)
    {
      m_bLayoutMode = _bMode;
    }
    protected virtual bool GetLayoutMode()
    {
      // Don't bother getting the config value - this is a test.
      return m_bLayoutMode;
    }
    public override HTMLElement PageDisplay()
    {
      return new HTMLGenericElement(TEST_BODY_CONTENT);
    }
    protected override HTMLScriptCollection DisplayJavaScriptFromChild()
    {
      HTMLScriptCollection myScriptCollection = new HTMLScriptCollection();
      HTMLScript myScript = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
      myScript.AddInnerHTMLString(TEST_JAVASCRIPT_CHILD_CONTENT);
      myScriptCollection.AddInnerHTMLElement(myScript);
      return myScriptCollection;
    }
    public override HTMLScriptCollection GetBasicJavascript()
    {
      HTMLScriptCollection myScriptCollection = new HTMLScriptCollection();
      HTMLScript myScript = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
      myScript.AddInnerHTMLString(TEST_JAVASCRIPT_BASIC_CONTENT);
      myScriptCollection.AddInnerHTMLElement(myScript);
      return myScriptCollection;
    }
    public virtual void SetOnLoad(String _strOnLoad)
    {
      m_strOnLoadJS = _strOnLoad;
    }
    public override String GetOnLoad()
    {
      return m_strOnLoadJS;
    }
    public override HTMLMeta GetMetaRefresh()
    {
      HTMLMeta metaRefresh = new HTMLMeta(TEST_META_REFRESH_URL);
      metaRefresh.SetHTTPEquiv(TEST_META_REFRESH_EQUIV);
      return metaRefresh;
    }
    public override String GetName()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public override String GetSubtitleForBanner()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public override String GetTitleForBanner()
    {
      return TEST_PAGE_TITLE;
    }
    public override AActivitySpace GetOwner()
    {
      return new TestLayoutPlumtreeAS();
    }
  }
}