package com.bea.alui.taglib.basepage;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.uiinfrastructure.activityspace.*;

public abstract class ABasePageTag extends ATag
{
	/**
	 * @return The current PlumtreeDP page. 
	 * @throws XPClassCastException if the current page does not
	 * extend PlumtreeDP.
	 */
	protected PlumtreeDP GetPlumtreeDP()
	{
		AActivitySpace space = (AActivitySpace) GetEnvironment();
		IDisplayPage basePage = space.GetCurrentPage();

		// NOTE: Unclear if it would be more efficient to cast and just catch exceptions,
		// or to use instanceof.  Neither is particularly slow, or fast.
		if (!(basePage instanceof PlumtreeDP))
		{
			throw new XPClassCastException(GetName() + " tag can only be used with " +
				"pages that extend PlumtreeDP.  " + basePage.GetName() + " does not.");
		}

		return (PlumtreeDP) basePage;
	}
}