/*******************************************************************************
 *  BEA Systems, Inc. CONFIDENTIAL
 * _______________________________
 * 
 *  (c) Copyright 2007  BEA Systems, Inc.
 *  All Rights Reserved.
 * 
 *  NOTICE:  All information contained herein is, and remains
 *  the property of BEA Systems, Inc. and its suppliers, if any.
 *  The intellectual and technical concepts contained herein
 *  are proprietary to BEA Systems, Inc. and its suppliers and may
 *  be covered by U.S. and Foreign Patents, patents in process,
 *  and are protected by trade secret or copyright law.
 *  Dissemination of this information or reproduction of this material
 *  is strictly forbidden unless prior written permission is obtained
 *  from BEA Systems, Inc..
 *******************************************************************************/
package com.bea.alui.taglib.basepage;

import com.plumtree.portaluiinfrastructure.tags.metadata.*;

/**
 * Meta-data for the Base Page tag library of the Adaptive Layout Framework.  This library
 * contains all of the tags for base pages in Adaptive Layouts.
 * @author Ravi Tunuguntla
 */
public class BasePageTagLibraryData implements ITagLibraryMetaData
{
	public static final TagLibraryMetaData LIBRARY = new TagLibraryMetaData
		("Base Page Tags for Adaptive Layout", "basepage",
		"This library contains the Base Page tags for the Adaptive Layout Framework.  " +
		"These tags are only available on the Base Page Adaptive Layout, which applies to " +
		"standard banner pages (i.e., pages that extend PlumtreeDP, include a banner, etc.).",
		1.0);
}
