package com.bea.alui.taglib.basepage.test;

import junit.framework.*;

import com.bea.alui.taglib.basepage.*;
import com.bea.alui.taglib.basepage.test.integration.*;
import com.plumtree.portaluiinfrastructure.mock.tags.*;
import com.plumtree.portaluiinfrastructure.tags.displaytree.*;
import com.plumtree.portaluiinfrastructure.tags.manager.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * This class tests the title tag.
 * 
 * 1) Does it display?
 * 
 * In general, the tests build up a markup array, pass it to the tag engine, and then
 * verify the results.
 */ 
public class TestTitleTag extends TestCase
{
	public TestLayoutPlumtreeAS m_environment;
	public TestLayoutPlumtreeDP m_page;

	public void setUp()
	{
		m_environment = new TestLayoutPlumtreeAS();

		m_page = new TestLayoutPlumtreeDP();
		m_page.SetLayoutMode(true);
		m_page.Init(m_environment);

		m_environment.SetTrackCurrentPage(true);
		m_environment.SetCurrentPage(m_page);

		MockTagLibManager tagLibs = new MockTagLibManager();
		tagLibs.SetTag(new TitleTag(), TitleTag.TAG.GetName(), BasePageTagLibraryData.LIBRARY.GetName());
		TagLibManager.setTestInstance(tagLibs);
	}

	/**
	 * This method tests basic display of the title tag.
	 */
	public void testTitleTag()
	{
		XMLFragmentTestHelper helper = new XMLFragmentTestHelper(BasePageTagLibraryData.LIBRARY.GetName(), TitleTag.TAG.GetName());
   		
   		Object[][] objArrMarkup = helper.ToArrayEntireFragment();
   		HTMLElement result = DisplayTree.ProcessTagMarkup(m_environment, objArrMarkup);
   		
   		Assert.assertEquals("The title of the page is incorrect.", TestLayoutPlumtreeDP.TEST_PAGE_TITLE, result.GetDisplayString());	
	}
}