package com.bea.alui.taglib.basepage.test.integration;

import com.plumtree.portalpages.common.uiparts.*;
import com.plumtree.portaluiinfrastructure.layout.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlelements.*;

public class TestLayoutPlumtreeDP extends PlumtreeDP
{
	public static final String TEST_HEADER_CONTENT = "<div> Test Header Content </div>";
	public static final String TEST_FOOTER_CONTENT = "<td><span>Test Footer Text</span><td>";
	public static final String TEST_BODY_CONTENT = "<span>Test Body Content</span>";
	public static final String TEST_JAVASCRIPT_CHILD_CONTENT = "var testChild = true;";
	public static final String TEST_JAVASCRIPT_BASIC_CONTENT = "var testBasic = true;";
	public static final String TEST_JAVASCRIPT_PAGE_ONLOAD_DEFAULT = "var testOnLoad = true;";
	public static final String TEST_META_REFRESH_URL = "URL=http://meta.test.com";
	public static final String TEST_META_REFRESH_EQUIV = "refresh";
	public static final String TEST_PAGE_TITLE = "Page Title";

	public boolean m_bLayoutMode = true;
	public String m_strOnLoadJS = TEST_JAVASCRIPT_PAGE_ONLOAD_DEFAULT;

	public HTMLElement GetLayoutTestResult()
	{
		// true means main page
		return DisplayLayout(Layouts.BASE_PAGE.GetDefaultWebServiceID(), true);
	}

	public void SetLayoutMode(boolean _bMode)
	{
		m_bLayoutMode = _bMode;
	}

	protected boolean GetLayoutMode()
	{
		// Don't bother getting the config value - this is a test.
		return m_bLayoutMode;
	}

	public HTMLElement PageDisplay() {
		return new HTMLGenericElement(TEST_BODY_CONTENT);
	}

	protected HTMLScriptCollection DisplayJavaScriptFromChild()
	{
		HTMLScriptCollection myScriptCollection = new HTMLScriptCollection();

		HTMLScript myScript = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
		myScript.AddInnerHTMLString(TEST_JAVASCRIPT_CHILD_CONTENT);
		myScriptCollection.AddInnerHTMLElement(myScript);

		return myScriptCollection;
	}

	public HTMLScriptCollection GetBasicJavascript()
	{
		HTMLScriptCollection myScriptCollection = new HTMLScriptCollection();

		HTMLScript myScript = new HTMLScript(HTMLScript.TYPE_JAVASCRIPT);
		myScript.AddInnerHTMLString(TEST_JAVASCRIPT_BASIC_CONTENT);
		myScriptCollection.AddInnerHTMLElement(myScript);

		return myScriptCollection;
	}

	public void SetOnLoad(String _strOnLoad)
	{
		m_strOnLoadJS = _strOnLoad;
	}

	public String GetOnLoad()
	{
		return m_strOnLoadJS;
	}

	public HTMLMeta GetMetaRefresh()
	{
		HTMLMeta metaRefresh = new HTMLMeta(TEST_META_REFRESH_URL);
		metaRefresh.SetHTTPEquiv(TEST_META_REFRESH_EQUIV);
		return metaRefresh;
	}

	public String GetName() {
		// TODO Auto-generated method stub
		return null;
	}

	public String GetSubtitleForBanner() {
		// TODO Auto-generated method stub
		return null;
	}

	public String GetTitleForBanner() {
		return TEST_PAGE_TITLE;
	}
	
	public AActivitySpace GetOwner(){
		return new TestLayoutPlumtreeAS();
	}
}
