using System;
using com.plumtree.openfoundation.util;
using junit.framework;
using xpunit.framework;
namespace com.bea.alui.taglib.joincommunitypageeditor.test
{
  public class TaglibJoinCommunityPageEditorTestSuite
  {
    public const String SUITENAME = "JoinCommunityPageEditor Tag Library Unit & Integration Tests";
    // All of our JS funcs should be of the form "name = function(args)".
    public const String JS_FUNCTION_SUFFIX = " = function(";
    public static Test suite()
    {
      XpTestSuite suite = new XpTestSuite(SUITENAME);
      suite.addTestSuite(typeof(TestCommunityDataTag));
      suite.addTestSuite(typeof(TestJoinCommunityBrowseBreadCrumbDataTag));
      suite.addTestSuite(typeof(TestJoinCommunityBrowseModeTag));
      suite.addTestSuite(typeof(TestJoinCommunityBrowseSubFoldersDataTag));
      suite.addTestSuite(typeof(TestJoinCommunityJSTag));
      suite.addTestSuite(typeof(TestJoinCommunityPaginationDataTag));
      suite.addTestSuite(typeof(TestJoinCommunitySearchFormTag));
      return suite;
    }
    public static void CheckFunctionName(String _strJSName, String _strOutput,
     bool bPresent)
    {
      String strFunction = _strJSName + JS_FUNCTION_SUFFIX;
      if (bPresent)
      {
        // Check that it's there.
        Assert.assertTrue("Checking that the " + _strJSName + " JS function name [" + strFunction + "] is present in output: " + _strOutput,
         XPStringUtility.IndexOf(_strOutput, strFunction) >= 0);
      } else
      {
        // Check that it's not there.
        Assert.assertTrue("Checking that the " + _strJSName + " JS function name [" + strFunction + "] is not present in output: " + _strOutput,
         XPStringUtility.IndexOf(_strOutput, strFunction) < 0);
      }
    }
  }
}