package com.bea.alui.taglib.joincommunitypageeditor.test;

import com.plumtree.openfoundation.util.*;

import junit.framework.*;
import xpunit.framework.*;

public class TaglibJoinCommunityPageEditorTestSuite 
{
	public static final String SUITENAME = "JoinCommunityPageEditor Tag Library Unit & Integration Tests";

	// All of our JS funcs should be of the form "name = function(args)".
	public static final String JS_FUNCTION_SUFFIX = " = function(";

	public static Test suite() {
		XpTestSuite suite = new XpTestSuite(SUITENAME);
		suite.addTestSuite(TestCommunityDataTag.class);
		suite.addTestSuite(TestJoinCommunityBrowseBreadCrumbDataTag.class);
		suite.addTestSuite(TestJoinCommunityBrowseModeTag.class);
		suite.addTestSuite(TestJoinCommunityBrowseSubFoldersDataTag.class);
		suite.addTestSuite(TestJoinCommunityJSTag.class);
		suite.addTestSuite(TestJoinCommunityPaginationDataTag.class);
		suite.addTestSuite(TestJoinCommunitySearchFormTag.class);
		return suite;
	}

	public static void CheckFunctionName(String _strJSName, String _strOutput, boolean bPresent)
	{
   		String strFunction = _strJSName + JS_FUNCTION_SUFFIX;
   		if (bPresent)
   		{
   			// Check that it's there.
	   		Assert.assertTrue("Checking that the " + _strJSName + " JS function name [" + strFunction +
	   			"] is present in output: " + _strOutput,
	   			XPStringUtility.IndexOf(_strOutput, strFunction) >= 0);
   		} else
   		{
   			// Check that it's not there.
	   		Assert.assertTrue("Checking that the " + _strJSName + " JS function name [" + strFunction +
		   		"] is not present in output: " + _strOutput,
	   			XPStringUtility.IndexOf(_strOutput, strFunction) < 0);
   		}
	}
}
