using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.browsing.directory;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.common;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.bea.alui.taglib.kdpage
{
  public abstract class AKDPageTag : ATag
  {
    protected const String KD_PAGE_ONLY_CONSTANT = "This tag only works with the Knowledge Directory Adaptive Layout. ";
    public const String EMPTY_STRING = "EMPTY_STRING";
    // All public static final metadata objects should be initialized
    // in a static initializer so that we can control the order of
    // initialization.
    public static readonly RequiredTagAttribute ATTRIB_ID;
    public static readonly OptionalTagAttribute ATTRIB_SCOPE;
    static AKDPageTag()
    {
      ATTRIB_ID = new RequiredTagAttribute(CommonTagAttributeConstants.ATTRIB_ID_NAME,
       CommonTagAttributeConstants.ATTRIB_ID_DESC, AttributeType.STRING);
      ATTRIB_SCOPE = new OptionalTagAttribute(CommonTagAttributeConstants.ATTRIB_SCOPE_NAME,
       CommonTagAttributeConstants.ATTRIB_SCOPE_DESC, AttributeType.STRING,
       Scope.PORTLET_REQUEST.ToString());
    }
    
    /// <returns>The current Knowledge Directory Model. </returns>
    /// <throws>
    /// XPNullPointerException if a model that
    /// implements IDirModelRO is not found.
    /// </throws>
    protected virtual IDirModelRO GetDirModel()
    {
      AActivitySpace space = (AActivitySpace) GetEnvironment();
      if (space.GetModelExists(DirModel.STR_MVC_CLASS_NAME))
      {
        return (IDirModelRO) space.GetModel(DirModel.STR_MVC_CLASS_NAME);
        } else
      {
        throw new XPNullPointerException(GetName() + " tag can only be used in " + "the Knowledge Directory Page.");
        }
    }
  }
}