using System;
using junit.framework;
using com.bea.alui.taglib.kdpage;
using com.plumtree.portalpages.browsing.directory;
using com.plumtree.portalpages.browsing.mock.directory;
using com.plumtree.portaluiinfrastructure.mock.tags;
using com.plumtree.portaluiinfrastructure.mock.uiinfrastructure;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.displaytree;
using com.plumtree.portaluiinfrastructure.tags.manager;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.helpers;
using com.plumtree.xpshared.htmlelements;
namespace com.bea.alui.taglib.kdpage.test
{
  public class CreateFolderDisplayTagTest : TestCase
  {
    private static String ID_VALUE = "createfolderdisplay";
    private AActivitySpace m_environment;
    private MockDirModel m_dirModel;
    private String strText;
    internal HTMLAnchor elmLink;
    public CreateFolderDisplayTagTest(String name) : base(name)
    {
    }
    
    /// <summary>
    /// Setup if any is required.
    /// </summary>
    public override void setUp()
    {
      strText = "Create SubFolder";
      ConfigService.setTestInstance(new MockConfigHelper());
      m_environment = new MockEnvironment();
      m_dirModel = new MockDirModel();
      ((MockEnvironment) m_environment).m_models.PutElement(DirModel.STR_MVC_CLASS_NAME,
       m_dirModel);
      MockTagLibManager tagLibs = new MockTagLibManager();
      tagLibs.SetTag(new CreateFolderDisplayTag(), CreateFolderDisplayTag.TAG.GetName(),
       KDPageTagLibraryData.LIBRARY.GetName());
      TagLibManager.setTestInstance(tagLibs);
      elmLink = new HTMLAnchor("#");
      elmLink.SetOnClick(FolderBannerView.JAVASCRIPT_CREATEFOLDER_POPUP + "(); return false;");
      elmLink.SetTitle(strText);
      elmLink.AddInnerHTMLString(strText);
    }
    
    /// <seealso cref="TestCase#tearDown()"></seealso>
    public override void tearDown()
    {
      base.tearDown();
      m_environment = null;
      m_dirModel = null;
    }
    public virtual void testDisplayTag()
    {
      XMLFragmentTestHelper helper = new XMLFragmentTestHelper(KDPageTagLibraryData.LIBRARY.GetName(),
       CreateFolderDisplayTag.TAG.GetName());
      helper.AddPTAttribute(CreateFolderDisplayTag.ATTRIB_ID.GetName(), ID_VALUE);
      helper.AddPTAttribute(CreateFolderDisplayTag.ATTRIB_SCOPE.GetName(),
       Scope.HTTP_REQUEST.ToString());
      helper.AddPTAttribute(CreateFolderDisplayTag.TEXT.GetName(), strText);
      Object[][] objArrMarkup = helper.ToArrayEntireFragment();
      HTMLElement result = DisplayTree.ProcessTagMarkup(m_environment, objArrMarkup);
      String strHTML = result.GetDisplayString();
      Assert.assertEquals("Foo Bar", strHTML, elmLink.GetDisplayString());
      }
    public virtual void testDisplaySharedJavaScript()
    {
    }
  }
}