using System;
using junit.framework;
using com.bea.alui.taglib.kdpage;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.browsing.directory;
using com.plumtree.portalpages.browsing.mock.directory;
using com.plumtree.portaluiinfrastructure.mock.tags;
using com.plumtree.portaluiinfrastructure.mock.uiinfrastructure;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.data;
using com.plumtree.portaluiinfrastructure.tags.displaytree;
using com.plumtree.portaluiinfrastructure.tags.helper;
using com.plumtree.portaluiinfrastructure.tags.manager;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.uiinfrastructure.helpers;
namespace com.bea.alui.taglib.kdpage.test
{
  public class DocumentsPerPageDataTagTest : TestCase
  {
    private static String ID_VALUE = "documentsperpagedata";
    private AActivitySpace m_environment;
    private MockDirModel m_dirModel;
    public DocumentsPerPageDataTagTest(String name) : base(name)
    {
    }
    
    /// <summary>
    /// Setup if any is required.
    /// </summary>
    public override void setUp()
    {
      ConfigService.setTestInstance(new MockConfigHelper());
      m_environment = new MockEnvironment();
      m_dirModel = new MockDirModel();
      m_dirModel.SetNumDocsPerPage(5);
      ((MockEnvironment) m_environment).m_models.PutElement(DirModel.STR_MVC_CLASS_NAME,
       m_dirModel);
      DocumentsPerPageDataTag docTag = new DocumentsPerPageDataTag();
      MockTagLibManager tagLibs = new MockTagLibManager();
      tagLibs.SetTag(docTag, DocumentsPerPageDataTag.TAG.GetName(), KDPageTagLibraryData.LIBRARY.GetName());
      TagLibManager.setTestInstance(tagLibs);
    }
    
    /// <seealso cref="TestCase#tearDown()"></seealso>
    public override void tearDown()
    {
      base.tearDown();
      m_environment = null;
      m_dirModel = null;
    }
    public virtual void testDisplayTag()
    {
      int[] arrOptions = {5, 10, 15};
      String strOptions = "";
      for (int i = 0;i < arrOptions.Length;i++)
      {
        strOptions = strOptions + ((i == 0) ? "" : ",") + XPConvert.ToString(arrOptions[i]);
        }
      XMLFragmentTestHelper helper = new XMLFragmentTestHelper(KDPageTagLibraryData.LIBRARY.GetName(),
       DocumentsPerPageDataTag.TAG.GetName());
      helper.AddPTAttribute(DocumentsPerPageDataTag.ATTRIB_ID.GetName(), ID_VALUE);
      helper.AddPTAttribute(DocumentsPerPageDataTag.ATTRIB_SCOPE.GetName(),
       Scope.HTTP_REQUEST.ToString());
      helper.AddPTAttribute(DocumentsPerPageDataTag.VALUE.GetName(), strOptions);
      Object[][] objArrMarkup = helper.ToArrayEntireFragment();
      DisplayTree.ProcessTagMarkup(m_environment, objArrMarkup);
      XPHashtable scopeData = TagState.GetHTTPRequestData(m_environment);
      // for some reason the names are prefixed with a '.'
      SharedStateVariable ssVariable = (SharedStateVariable) scopeData.GetElement("." + ID_VALUE);
      XPArrayList outItems = (XPArrayList) ssVariable.GetValue();
      for (int i = 0;i < outItems.GetSize();i++)
      {
        HashtableDataObject htObject = (HashtableDataObject) outItems.GetElement(i);
        String name = XPConvert.ToString(htObject.GetData(DocumentsPerPageDataTag.NAME));
        Assert.assertEquals("Wrong name returned for DocumentsPerPageData element.",
         XPConvert.ToString(arrOptions[i]), name);
        String value = XPConvert.ToString(htObject.GetData(DocumentsPerPageDataTag.URL));
        Assert.assertTrue("URL does not have query string for DocumentsPerPage",
         XPStringUtility.IndexOf(value, DirConstants.QS_PER_PAGE + "=" + name) > 0);
        }
    }
  }
}
//			value = XPConvert.ToString(htObject.GetData( DocumentsPerPageDataTag.SELECTED)) ;
//			Assert.assertEquals("Wrong selected value returned for DocumentsPerPageData element.", "false", value);			
