package com.bea.alui.taglib.kdpage;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.browsing.directory.*;
import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.portaluiinfrastructure.tags.common.*;
import com.plumtree.portaluiinfrastructure.tags.metadata.*;
import com.plumtree.uiinfrastructure.activityspace.*;

public abstract class AKDPageTag extends ATag
{
	protected static final String KD_PAGE_ONLY_CONSTANT = "This tag only works with the Knowledge Directory Adaptive Layout. ";
	
	public static final String EMPTY_STRING = "EMPTY_STRING";
	
	// All public static final metadata objects should be initialized
	// in a static initializer so that we can control the order of
	// initialization.
	public static final RequiredTagAttribute ATTRIB_ID;
	public static final OptionalTagAttribute ATTRIB_SCOPE;
	
	static
	{
		ATTRIB_ID = new RequiredTagAttribute(CommonTagAttributeConstants.ATTRIB_ID_NAME,
			CommonTagAttributeConstants.ATTRIB_ID_DESC,	
			AttributeType.STRING);

		ATTRIB_SCOPE = new OptionalTagAttribute(CommonTagAttributeConstants.ATTRIB_SCOPE_NAME,
			CommonTagAttributeConstants.ATTRIB_SCOPE_DESC,
			AttributeType.STRING, Scope.PORTLET_REQUEST.toString());
	}
	
	/**
	 * @return The current Knowledge Directory Model. 
	 * @throws XPNullPointerException if a model that
	 * 		implements IDirModelRO is not found.
	 */
	protected IDirModelRO GetDirModel()
	{
		AActivitySpace space = (AActivitySpace) GetEnvironment();
		if (space.GetModelExists(DirModel.STR_MVC_CLASS_NAME)) {
			return (IDirModelRO) space.GetModel(DirModel.STR_MVC_CLASS_NAME);
		} else {
			throw new XPNullPointerException(GetName() + " tag can only be used in " +
					"the Knowledge Directory Page.");
		}
	}
}
