package com.bea.alui.taglib.kdpage.test;

import junit.framework.*;

import com.bea.alui.taglib.kdpage.*;
import com.plumtree.portalpages.browsing.directory.*;
import com.plumtree.portalpages.browsing.mock.directory.*;
import com.plumtree.portaluiinfrastructure.mock.tags.*;
import com.plumtree.portaluiinfrastructure.mock.uiinfrastructure.*;
import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.portaluiinfrastructure.tags.displaytree.*;
import com.plumtree.portaluiinfrastructure.tags.manager.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.helpers.*;
import com.plumtree.xpshared.htmlelements.*;

public class CreateFolderDisplayTagTest extends TestCase 
{
	private static String ID_VALUE = "createfolderdisplay";
	

	private AActivitySpace m_environment;
	private MockDirModel m_dirModel;
	
	private String strText;
	HTMLAnchor elmLink;

	/**
	 */
	public CreateFolderDisplayTagTest(String name)
   	{
		super(name);
   	}
   
   	/**
	 * Setup if any is required.
	 */
   	public void setUp() throws Exception
   	{
   		strText = "Create SubFolder";
   		ConfigService.setTestInstance(new MockConfigHelper());

		m_environment = new MockEnvironment();		
   		m_dirModel = new MockDirModel();
   		
   		((MockEnvironment) m_environment).m_models.PutElement(DirModel.STR_MVC_CLASS_NAME, m_dirModel);
   		
   		MockTagLibManager tagLibs = new MockTagLibManager();
		tagLibs.SetTag(new CreateFolderDisplayTag(), CreateFolderDisplayTag.TAG.GetName(), KDPageTagLibraryData.LIBRARY.GetName());
		TagLibManager.setTestInstance(tagLibs);
		
		
		elmLink= new HTMLAnchor("#");
		elmLink.SetOnClick(FolderBannerView.JAVASCRIPT_CREATEFOLDER_POPUP + "(); return false;" );
		elmLink.SetTitle(strText);
		elmLink.AddInnerHTMLString(strText);
   	}
   	
   	/**
	 * @see TestCase#tearDown()
	 */
	public void tearDown() throws Exception
	{
		super.tearDown();
		
		m_environment = null;
		m_dirModel = null;

	}
	
	public void testDisplayTag() 
	{
		XMLFragmentTestHelper helper = new XMLFragmentTestHelper(KDPageTagLibraryData.LIBRARY.GetName(), CreateFolderDisplayTag.TAG.GetName());
   		helper.AddPTAttribute(CreateFolderDisplayTag.ATTRIB_ID.GetName(), ID_VALUE);
   		helper.AddPTAttribute(CreateFolderDisplayTag.ATTRIB_SCOPE.GetName(), Scope.HTTP_REQUEST.toString());
   		helper.AddPTAttribute(CreateFolderDisplayTag.TEXT.GetName(), strText);
   		
   		Object[][] objArrMarkup = helper.ToArrayEntireFragment();
   		HTMLElement result = DisplayTree.ProcessTagMarkup(m_environment, objArrMarkup);
   		
   		String strHTML = result.GetDisplayString();
   		Assert.assertEquals("Foo Bar", strHTML, elmLink.GetDisplayString());
   			
	}
	
	public void testDisplaySharedJavaScript()
	{
		
	}
}
