package com.bea.alui.taglib.kdpage.test;

import junit.framework.*;

import com.bea.alui.taglib.kdpage.*;
import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.browsing.directory.*;
import com.plumtree.portalpages.browsing.mock.directory.*;
import com.plumtree.portaluiinfrastructure.mock.tags.*;
import com.plumtree.portaluiinfrastructure.mock.uiinfrastructure.*;
import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.portaluiinfrastructure.tags.data.*;
import com.plumtree.portaluiinfrastructure.tags.displaytree.*;
import com.plumtree.portaluiinfrastructure.tags.helper.*;
import com.plumtree.portaluiinfrastructure.tags.manager.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.uiinfrastructure.helpers.*;

public class DocumentsPerPageDataTagTest extends TestCase {

	private static String ID_VALUE = "documentsperpagedata";

	
	private AActivitySpace m_environment;
	private MockDirModel m_dirModel;
	
	/**
	 */
	public DocumentsPerPageDataTagTest(String name)
   	{
		super(name);
   	}
   
   	/**
	 * Setup if any is required.
	 */
   	public void setUp() throws Exception
   	{   		
   		ConfigService.setTestInstance(new MockConfigHelper());

		m_environment = new MockEnvironment();		
   		m_dirModel = new MockDirModel();
   		m_dirModel.SetNumDocsPerPage(5);
   		
   		((MockEnvironment) m_environment).m_models.PutElement(DirModel.STR_MVC_CLASS_NAME, m_dirModel);
   		
   		DocumentsPerPageDataTag docTag = new DocumentsPerPageDataTag();

   		MockTagLibManager tagLibs = new MockTagLibManager();
   		
		tagLibs.SetTag(docTag, DocumentsPerPageDataTag.TAG.GetName(), KDPageTagLibraryData.LIBRARY.GetName());
		TagLibManager.setTestInstance(tagLibs);
   	}
   	
   	/**
	 * @see TestCase#tearDown()
	 */
	public void tearDown() throws Exception
	{
		super.tearDown();
		
		m_environment = null;
		m_dirModel = null;
	}
	
	public void testDisplayTag() 
	{
		int arrOptions[] = {5,10,15};
		
		String strOptions ="";
		for (int i =0; i< arrOptions.length; i++)
		{
			strOptions = strOptions + ((i==0)?"" : ",") +  XPConvert.ToString(arrOptions[i]);
		}
		 
		XMLFragmentTestHelper helper = new XMLFragmentTestHelper(KDPageTagLibraryData.LIBRARY.GetName(), DocumentsPerPageDataTag.TAG.GetName());
   		helper.AddPTAttribute(DocumentsPerPageDataTag.ATTRIB_ID.GetName(), ID_VALUE);
   		helper.AddPTAttribute(DocumentsPerPageDataTag.ATTRIB_SCOPE.GetName(), Scope.HTTP_REQUEST.toString());
   		helper.AddPTAttribute(DocumentsPerPageDataTag.VALUE.GetName(), strOptions);
   		
   		
   		Object[][] objArrMarkup = helper.ToArrayEntireFragment();
   		DisplayTree.ProcessTagMarkup(m_environment, objArrMarkup);
   		
   		XPHashtable scopeData = TagState.GetHTTPRequestData(m_environment);
		// for some reason the names are prefixed with a '.'
		SharedStateVariable ssVariable = (SharedStateVariable) scopeData.GetElement("."+ID_VALUE);
		XPArrayList outItems = (XPArrayList) ssVariable.GetValue();
		


		for (int i = 0; i < outItems.GetSize(); i++)
		{
			HashtableDataObject htObject =  (HashtableDataObject) outItems.GetElement(i);
			
			String name = XPConvert.ToString(htObject.GetData( DocumentsPerPageDataTag.NAME)) ;
			Assert.assertEquals("Wrong name returned for DocumentsPerPageData element.", XPConvert.ToString(arrOptions[i]), name);			
			
			
			String value = XPConvert.ToString(htObject.GetData( DocumentsPerPageDataTag.URL)) ;
			Assert.assertTrue("URL does not have query string for DocumentsPerPage", XPStringUtility.IndexOf(value, DirConstants.QS_PER_PAGE + "=" +name ) > 0 );
			
//			value = XPConvert.ToString(htObject.GetData( DocumentsPerPageDataTag.SELECTED)) ;
//			Assert.assertEquals("Wrong selected value returned for DocumentsPerPageData element.", "false", value);			
		}
		
	

		

		

	}
}
