using System;
using com.plumtree.openlog;
using com.plumtree.portalpages.browsing.myportal;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.common;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.bea.alui.taglib.portletpage
{
  public class CurrentPageLayoutIdDataTag : ATag
  {
    private static OpenLogger log = OpenLogService.GetLogger(OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADAPTIVETAGS),
     "com.bea.alui.taglib.portletpage.CurrentPageLayoutIdDataTag");
    public static readonly ITagMetaData TAG;
    public static readonly RequiredTagAttribute ATTRIB_ID;
    public static readonly OptionalTagAttribute ATTRIB_SCOPE;
    static CurrentPageLayoutIdDataTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("currpagelayoutid", "Sets a data value with the current page layout ID.");
      ATTRIB_ID = new RequiredTagAttribute("id", CommonTagAttributeConstants.ATTRIB_ID_DESC,
       AttributeType.STRING);
      ATTRIB_SCOPE = new OptionalTagAttribute("scope", CommonTagAttributeConstants.ATTRIB_SCOPE_DESC,
       AttributeType.STRING, Scope.PORTLET_REQUEST.ToString());
    }
    public override HTMLElement DisplayTag()
    {
      AActivitySpace space = (AActivitySpace) GetEnvironment();
      MyPortalModel model = null;
      int layoutID = -1;
      try
      {
        if (space.GetModelExists(MyPortalModel.STR_MVC_CLASS_NAME))
        {
          model = (MyPortalModel) space.GetModel(MyPortalModel.STR_MVC_CLASS_NAME);
          layoutID = model.GetPageType();
        }
      }
      catch (Exception e)
      {
      }
      // DCA - we're not on a my page or community page
      // set layout id as -1 (default)
      if (layoutID == -1)
      {
        log.Info("Tag currpagelayoutid is not used on a Mypage or Community Page. No page layout id is available, -1 is used");
        }
      SetStateSharedVariable(GetTagAttributeAsString(ATTRIB_ID), layoutID,
       Scope.GetScope(GetTagAttributeAsString(ATTRIB_SCOPE)), false);
      return null;
    }
    public override ATag Create()
    {
      return new CurrentPageLayoutIdDataTag();
    }
  }
}