using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.browsing.myportal;
using com.plumtree.portaluiinfrastructure.ptlink;
using com.plumtree.portaluiinfrastructure.statichelpers;
using com.plumtree.server;
using com.plumtree.taskapi.portalui;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlconstructs;
namespace com.bea.alui.taglib.portletpage.test.integration
{
  public class TestMyPortalModel : MyPortalModel,IMyPortalModelRO
  {
    protected String KEY_PORTLETNAME = "name";
    protected String KEY_PORTLETID = "objid";
    protected String KEY_PORTLETREGION = "region";
    protected String KEY_PORTLETCONTENT = "content";
    protected String KEY_PORTLETIDSTRING = "portletidstring";
    protected String KEY_PORTLETADMINPREFURL = "adminprefurl";
    protected String KEY_PORTLETCOMMPREFURL = "commprefurl";
    protected String KEY_PORTLETUSERPREFURL = "userprefurl";
    protected String KEY_PORTLETHELPURL = "helpurl";
    protected String KEY_PORTLETCOLLAPSEEXPANDURL = "collapseexpandurl";
    protected String KEY_PORTLETREMOVEURL = "removeurl";
    protected String KEY_PORTLETHASTITLEBAR = "hastitlebar";
    public bool m_isCommunityPage = true;
    public int m_pageId = 0;
    public int m_commId = 0;
    // start object ids at 200
    public int m_idcounter = 200;
    public String m_pageName = "TestMyPortalModel Page";
    public XPArrayList m_regions = new XPArrayList();
    public TestMyPortalModel(int regions)
    {
      // initialize regions list with list of portlets
      for (int i = 0;i < regions;i++)
      {
        m_regions.Add(new XPArrayList());
      }
    }
    
    /// <summary>
    /// Call this method to initialize model with portlets
    /// Adds a portlet
    /// </summary>
    /// <param name="portletName">name of portlet</param>
    /// <param name="region">1 based region index</param>
    /// <param name="portletContent">markup 2d object array (optional)</param>
    /// <param name="portletIDString">Identifier string of portlet (i.e. pt-portlet-1)</param>
    /// <param name="portletAdminPrefUrl">Admin Preference Url of portlet</param>
    /// <param name="portletCommPrefUrl">Community Preference Url of portlet</param>
    /// <param name="portletUserPrefUrl">User Preference Url of portlet</param>
    /// <param name="portletHelpUrl">Help Url of portlet</param>
    /// <param name="portletCollapseExpanUrl">Collapse/Expand Url of portlet</param>
    /// <param name="portletHasTitleBar">Is title bar displayed for portlet?</param>
    /// <returns>	generated object id of the portlet</returns>
    public virtual int addPortletInColumn(String portletName, Object[][] portletContent,
     int region, String portletIDString, String portletAdminPrefUrl, String portletCommPrefUrl,
     String portletUserPrefUrl, String portletHelpUrl, String portletCollapseExpandUrl,
     String portletRemoveUrl, bool portletHasTitleBar)
    {
      // regions are 0 based in list
      --region;
      // store portlet info
      XPHashtable table = new XPHashtable();
      table.PutElement(KEY_PORTLETID, m_idcounter);
      table.PutElement(KEY_PORTLETNAME, portletName);
      table.PutElement(KEY_PORTLETCONTENT, portletContent);
      table.PutElement(KEY_PORTLETREGION, region);
      table.PutElement(KEY_PORTLETIDSTRING, portletIDString);
      table.PutElement(KEY_PORTLETADMINPREFURL, portletAdminPrefUrl);
      table.PutElement(KEY_PORTLETCOMMPREFURL, portletCommPrefUrl);
      table.PutElement(KEY_PORTLETUSERPREFURL, portletUserPrefUrl);
      table.PutElement(KEY_PORTLETHELPURL, portletHelpUrl);
      table.PutElement(KEY_PORTLETCOLLAPSEEXPANDURL, portletCollapseExpandUrl);
      table.PutElement(KEY_PORTLETREMOVEURL, portletRemoveUrl);
      table.PutElement(KEY_PORTLETHASTITLEBAR, XPConvert.ToString(portletHasTitleBar));
      ((XPArrayList) m_regions.GetElement(region)).Add(table);
      return m_idcounter++;
    }
    public override int GetPortletCount()
    {
      int count = 0;
      for (int i = 0;i < m_regions.GetSize();i++)
      {
        count+=((XPArrayList) m_regions.GetElement(i)).GetSize();
      }
      return count;
    }
    
    /// <summary>
    /// Internal hepler function to lookup the portlet object from main index
    /// Portlets are indexed by their order in a region and the region order so
    /// index = 0 starts with the first portlet in the first region. 
    /// </summary>
    /// <param name="index"></param>
    /// <returns></returns>
    protected virtual XPHashtable GetPortletFromIndex(int index)
    {
      int totalCount = 0;
      for (int i = 0;i < m_regions.GetSize();i++)
      {
        int curCount = ((XPArrayList) m_regions.GetElement(i)).GetSize();
        // comparing size with index, so add 1 to index
        if ((totalCount + curCount) >= index + 1)
        {
          // we know the portlet is in the current region, calculate the index within the region
          int regionIndex = index - totalCount;
          XPHashtable portlet = (XPHashtable) ((XPArrayList) m_regions.GetElement(i)).GetElement(regionIndex);
          return portlet;
        }
        totalCount+=curCount;
      }
      throw new XPIllegalArgumentException("Invalid portlet index: " + index);
      }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetFirstPortletIndexInColumn(int)"></seealso>
    public override int GetFirstPortletIndexInColumn(int nPortletColumn)
    {
      XPHashtable portlet = (XPHashtable) ((XPArrayList) m_regions.GetElement(nPortletColumn)).GetElement(0);
      int id = (int) portlet.GetElement(KEY_PORTLETID);
      return id;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletColumnFromIndex(int)"></seealso>
    public override int GetPortletColumnFromIndex(int nPortletIndex)
    {
      XPHashtable portlet = GetPortletFromIndex(nPortletIndex);
      int region = (int) portlet.GetElement(KEY_PORTLETREGION);
      return region;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletIDFromIndex(int)"></seealso>
    public override int GetPortletIDFromIndex(int nPortletIndex)
    {
      XPHashtable portlet = GetPortletFromIndex(nPortletIndex);
      int id = (int) portlet.GetElement(KEY_PORTLETID);
      return id;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletNameFromIndex(int)"></seealso>
    public override String GetPortletNameFromIndex(int nPortletIndex)
    {
      XPHashtable portlet = GetPortletFromIndex(nPortletIndex);
      String name = (String) portlet.GetElement(KEY_PORTLETNAME);
      return name;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetIDStringForPortlet(int)"></seealso>
    public override String GetIDStringForPortlet(int nPortletIndex)
    {
      XPHashtable portlet = GetPortletFromIndex(nPortletIndex);
      String name = (String) portlet.GetElement(KEY_PORTLETIDSTRING);
      return name;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletHasTitleBar(int)"></seealso>
    public override bool GetPortletHasTitleBar(int nPortletIndex)
    {
      XPHashtable portlet = GetPortletFromIndex(nPortletIndex);
      bool hasTitleBar = XPConvert.ToBoolean(portlet.GetElement(KEY_PORTLETHASTITLEBAR));
      return hasTitleBar;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletHTMLTextFromIndex(int)"></seealso>
    public override Object[][] GetPortletHTMLTextFromIndex(int nPortletIndex)
    {
      XPHashtable portlet = GetPortletFromIndex(nPortletIndex);
      Object[][] content = (Object[][]) portlet.GetElement(KEY_PORTLETCONTENT);
      return content;
    }
    public override bool GetDisplayPortletHeaderDueToError(int nPortletIndex)
    {
      // @TODO: make this configurable
      return true;
    }
    public override bool GetPortletHasRefreshButton(int nPortletIndex)
    {
      // @TODO: make this configurable
      return true;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletCollapsed(int)"></seealso>
    public override bool GetPortletCollapsed(int nPortletIndex)
    {
      // @TODO: make this configurable
      return true;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletDisabledMessage(int)"></seealso>
    public override String GetPortletDisabledMessage(int nPortletIndex)
    {
      // @TODO: make this configurable
      return "Portlet disabled";
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletEnabled(int)"></seealso>
    public override bool GetPortletEnabled(int nPortletIndex)
    {
      // @TODO: make this configurable
      return false;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletHasHelpURL(int)"></seealso>
    public override bool GetPortletHasHelpURL(int nPortletIndex)
    {
      // @TODO: make this configurable
      return true;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletHasAdminPrefsURL(int)"></seealso>
    public override bool GetPortletHasAdminPrefsURL(int nPortletIndex)
    {
      XPHashtable portlet = GetPortletFromIndex(nPortletIndex);
      String adminPrefUrl = (String) portlet.GetElement(KEY_PORTLETADMINPREFURL);
      return null != adminPrefUrl;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletHasCommunityPrefsURL(int)"></seealso>
    public override bool GetPortletHasCommunityPrefsURL(int nPortletIndex)
    {
      XPHashtable portlet = GetPortletFromIndex(nPortletIndex);
      String commPrefUrl = (String) portlet.GetElement(KEY_PORTLETCOMMPREFURL);
      return null != commPrefUrl;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletHasUserPrefsURL(int)"></seealso>
    public override bool GetPortletHasUserPrefsURL(int nPortletIndex)
    {
      XPHashtable portlet = GetPortletFromIndex(nPortletIndex);
      String userPrefUrl = (String) portlet.GetElement(KEY_PORTLETUSERPREFURL);
      return null != userPrefUrl;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletHasCollapseExpandURL(int)"></seealso>
    public override bool GetPortletHasCollapseExpandURL(int nPortletIndex)
    {
      // @TODO: make this configurable
      return true;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletIsMandatory(int)"></seealso>
    public override bool GetPortletIsMandatory(int nPortletIndex)
    {
      // @TODO: make this configurable
      return false;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletSupports508(int)"></seealso>
    public override bool GetPortletSupports508(int nPortletIndex)
    {
      // @TODO: make this configurable
      return false;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletSupportsPersonalization(int)"></seealso>
    public override int GetPortletSupportsPersonalization(int nPortletIndex)
    {
      // @TODO: make this configurable
      return 7;
    }
    public override bool GetIsCommunityPage()
    {
      return m_isCommunityPage;
    }
    public override int GetPageID()
    {
      return m_pageId;
    }
    public override String GetPageName()
    {
      return m_pageName;
    }
    public override int GetCommunityID()
    {
      return m_commId;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#SetCommunity(int,int)"></seealso>
    public override bool SetCommunity(int nCommunityID, int nPageID)
    {
      m_nCommunityID = nCommunityID;
      m_pageId = nPageID;
      return true;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#SetPage(int)"></seealso>
    public override bool SetPage(int nPageID)
    {
      m_pageId = nPageID;
      return true;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPageASURL()"></seealso>
    public override ASURL GetPageASURL()
    {
      //throw new XPNotImplementedException();
      ASURL url = new ASURL(m_asOwner);
      url.SetLinkGetCachedSpace(m_asOwner);
      url.AddControlArgument(SetPageControl.STR_PAGE_ID, XPConvert.ToString(GetPageID()));
      return url;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletHelpURL(int)"></seealso>
    public override String GetPortletHelpURL(int nPortletIndex)
    {
      XPHashtable portlet = GetPortletFromIndex(nPortletIndex);
      String helpUrl = (String) portlet.GetElement(KEY_PORTLETHELPURL);
      return helpUrl;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletAdminPrefsURL(int)"></seealso>
    public override String GetPortletAdminPrefsURL(int nPortletIndex)
    {
      XPHashtable portlet = GetPortletFromIndex(nPortletIndex);
      String adminPrefUrl = (String) portlet.GetElement(KEY_PORTLETADMINPREFURL);
      return adminPrefUrl;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletCommunityPrefsURL(int)"></seealso>
    public override String GetPortletCommunityPrefsURL(int nPortletIndex)
    {
      XPHashtable portlet = GetPortletFromIndex(nPortletIndex);
      String commPrefUrl = (String) portlet.GetElement(KEY_PORTLETCOMMPREFURL);
      return commPrefUrl;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletUserPrefsURL(int)"></seealso>
    public override String GetPortletUserPrefsURL(int nPortletIndex)
    {
      XPHashtable portlet = GetPortletFromIndex(nPortletIndex);
      String userPrefUrl = (String) portlet.GetElement(KEY_PORTLETUSERPREFURL);
      return userPrefUrl;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletCollapseExpandURL(int)"></seealso>
    public override String GetPortletCollapseExpandURL(int nPortletIndex,
     String strControl)
    {
      XPHashtable portlet = GetPortletFromIndex(nPortletIndex);
      String collapseExpandUrl = (String) portlet.GetElement(KEY_PORTLETCOLLAPSEEXPANDURL);
      return collapseExpandUrl;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletRemoveURL(int)"></seealso>
    public override String GetPortletRemoveURL(int nPortletIndex)
    {
      XPHashtable portlet = GetPortletFromIndex(nPortletIndex);
      String removeUrl = (String) portlet.GetElement(KEY_PORTLETREMOVEURL);
      return removeUrl;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletPrefButtonBoolean()"></seealso>
    public override String GetPortletPrefButtonBoolean()
    {
      // @TODO: make this configurable
      return "1";
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#CollapsePortlet(int,int,int)"></seealso>
    public override void CollapsePortlet(int nCommunityID, int nPageID, int nPortletToCollapse)
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#CommunityJoinFailed()"></seealso>
    public override bool CommunityJoinFailed()
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#DeletePage(int)"></seealso>
    public override void DeletePage(int nPageID)
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#ExpandPortlet(int,int,int)"></seealso>
    public override void ExpandPortlet(int nCommunityID, int nPageID, int nPortletToExpand)
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#Finish()"></seealso>
    public override void Finish()
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetCollapsedOrErrorContent(int)"></seealso>
    public override Object[][] GetCollapsedOrErrorContent(int nPortletIndex)
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetCommunityName()"></seealso>
    public override String GetCommunityName()
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetCommunityPages()"></seealso>
    public override IPTQueryResult GetCommunityPages()
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetCommunityURL()"></seealso>
    public override String GetCommunityURL()
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetCurCommName()"></seealso>
    public override String GetCurCommName()
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetDefaultCommunityURL()"></seealso>
    public override String GetDefaultCommunityURL()
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetHelper()"></seealso>
    public override IMyPortalModelHelper GetHelper()
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetLastPortletIndexInColumn(int)"></seealso>
    public override int GetLastPortletIndexInColumn(int nPortletColumn)
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPageType()"></seealso>
    public override int GetPageType()
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetParentSpace()"></seealso>
    public override AActivitySpace GetParentSpace()
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetPortletUUID(int)"></seealso>
    public override String GetPortletUUID(int nPortletIndex)
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetProfileID()"></seealso>
    public override int GetProfileID()
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetRedirectAfterFinish()"></seealso>
    public override Redirect GetRedirectAfterFinish()
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#GetSession()"></seealso>
    public override IPTSession GetSession()
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#InitializePortletContent()"></seealso>
    public override void InitializePortletContent()
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#IsGuestSession(AActivitySpace)"></seealso>
    public static bool IsGuestSession(AActivitySpace owner)
    {
      // Assume non-guest user.
      return false;
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#IsPageAvailable()"></seealso>
    public override bool IsPageAvailable()
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#IsPreviewPage()"></seealso>
    public override bool IsPreviewPage()
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#JoinCommunity()"></seealso>
    public override bool JoinCommunity()
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#SavePage(java.lang.String,com.plumtree.openfoundation.util.XPHashtable)"></seealso>
    public override int SavePage(String _sPageName, XPHashtable _htFormData)
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#SetDisplayPortletHeaderDueToError(int,boolean)"></seealso>
    public override void SetDisplayPortletHeaderDueToError(int nPortletIndex,
     bool bDisplayHeader)
    {
      base.SetDisplayPortletHeaderDueToError(nPortletIndex, bDisplayHeader);
      }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#SetHostPageURI(java.lang.String)"></seealso>
    public override void SetHostPageURI(String strHostPageURI)
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#SetIsPreviewPage(boolean)"></seealso>
    public override void SetIsPreviewPage(bool _bIsPreviewPage)
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#SetMyPortalModelHelper(com.plumtree.portalpages.browsing.myportal.IMyPortalModelHelper)"></seealso>
    public override void SetMyPortalModelHelper(IMyPortalModelHelper myPortalModelHelper)
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#SetProfileID(int)"></seealso>
    public override bool SetProfileID(int nProfileID)
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#SetRawHeaders(java.lang.String)"></seealso>
    public override void SetRawHeaders(String strRawHeaders)
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#SetShowJoinCommConfirmPage(boolean)"></seealso>
    public override void SetShowJoinCommConfirmPage(bool show)
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#SetupIntrinsicPortlet(java.lang.String,java.lang.String,int)"></seealso>
    public override void SetupIntrinsicPortlet(String _strPortletClass, String _strStorageName,
     int _nPortletIndex)
    {
      throw new XPNotImplementedException();
    }
    
    /// <seealso cref="com.plumtree.portalpages.browsing.myportal.MyPortalModel#ShowJoinConfirmPage()"></seealso>
    public override bool ShowJoinConfirmPage()
    {
      throw new XPNotImplementedException();
    }
    public override IXPList GetPortletPreferenceActionsData(int nPortletIndex)
    {
      IXPList arPrefActions = new XPArrayList();
      String strPrefsButtonURL = null;
      String strPrefsButtonTitle = null;
      String strImageServerURL = PTConfigHelper.GetImageServerBaseURL(m_asOwner);
      bool bHasPersonalPrefs = GetPortletHasUserPrefsURL(nPortletIndex);
      bool bHasCommPrefs = GetPortletHasCommunityPrefsURL(nPortletIndex);
      bool bHasAdminPrefs = GetPortletHasAdminPrefsURL(nPortletIndex);
      if (bHasPersonalPrefs)
      {
        // get link to the community-user-gadget prefs page, because this is a user clicking on edit preferences
        // from within a community or just regular user preference link
        strPrefsButtonURL = GetPortletUserPrefsURL(nPortletIndex);
        strPrefsButtonTitle = m_asOwner.GetString(1846, "ptmsgs_portalbrowsingmsgs");
        // Add to list
        FullURL url = new FullURL(strPrefsButtonTitle, strPrefsButtonURL);
        url.SetURLImageType(PTImageType.ACTION_PORTLET_EDIT, strImageServerURL);
        url.SetURLData(PORTLET_PREF_TYPE, PERSONAL_PREF_TYPE);
        arPrefActions.Add(url);
      }
      if (bHasCommPrefs)
      {
        String strCommPrefsURL = GetPortletCommunityPrefsURL(nPortletIndex);
        String strCommPrefsTitle = m_asOwner.GetString(1847, "ptmsgs_portalbrowsingmsgs");
        // Add to list
        FullURL url = new FullURL(strCommPrefsTitle, strCommPrefsURL);
        url.SetURLImageType(PTImageType.ACTION_PORTLET_EDIT, strImageServerURL);
        url.SetURLData(PORTLET_PREF_TYPE, COMMUNITY_PREF_TYPE);
        arPrefActions.Add(url);
      }
      if (bHasAdminPrefs)
      {
        String strAdminPrefsURL = GetPortletAdminPrefsURL(nPortletIndex);
        String strAdminTitle = m_asOwner.GetString(1848, "ptmsgs_portalbrowsingmsgs");
        // Add to list
        FullURL url = new FullURL(strAdminTitle, strAdminPrefsURL);
        url.SetURLImageType(PTImageType.ACTION_PORTLET_EDIT, strImageServerURL);
        url.SetURLData(PORTLET_PREF_TYPE, ADMIN_PREF_TYPE);
        arPrefActions.Add(url);
      }
      return arPrefActions;
    }
  }
}