package com.bea.alui.taglib.portletpage;

import com.plumtree.openlog.*;
import com.plumtree.portalpages.browsing.myportal.*;
import com.plumtree.portaluiinfrastructure.statichelpers.*;
import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.portaluiinfrastructure.tags.common.*;
import com.plumtree.portaluiinfrastructure.tags.metadata.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlelements.*;

public class CurrentPageLayoutIdDataTag extends ATag 
{
		private static OpenLogger log = OpenLogService.GetLogger(
			OpenLogService.GetComponent(PTDebugHelpers.COMPONENT_PORTAL_ADAPTIVETAGS),
			"com.bea.alui.taglib.portletpage.CurrentPageLayoutIdDataTag");
		
	public static final ITagMetaData TAG;
	public static final RequiredTagAttribute ATTRIB_ID;
	public static final OptionalTagAttribute ATTRIB_SCOPE;
	
	static
	{
		// The TAG member variable needs to be initialized first since it
		// can be used in other tags (i.e. as a RequiredParentTag) that
		// are referenced by member variables of this tag (i.e. as a
		// RelatedChildTag).  This is necessary for tags that have
		// circular references such as a parent / child tag relationship.
		TAG = new TagMetaData("currpagelayoutid", "Sets a data value with the current page layout ID.");

		ATTRIB_ID = new RequiredTagAttribute("id",
			CommonTagAttributeConstants.ATTRIB_ID_DESC,	
			AttributeType.STRING);

		ATTRIB_SCOPE = new OptionalTagAttribute("scope",
			CommonTagAttributeConstants.ATTRIB_SCOPE_DESC,
			AttributeType.STRING, Scope.PORTLET_REQUEST.toString());
	}

	@Override
	public HTMLElement DisplayTag() 
	{
		AActivitySpace space = (AActivitySpace)GetEnvironment();
		MyPortalModel model = null;
		int layoutID = -1;
		try {
			if (space.GetModelExists(MyPortalModel.STR_MVC_CLASS_NAME)) {
				model = (MyPortalModel)space.GetModel(MyPortalModel.STR_MVC_CLASS_NAME);
				layoutID = model.GetPageType();
			}
		} catch (Exception e) {
			// DCA - we're not on a my page or community page
			// set layout id as -1 (default)
		}
		
		if ( layoutID == -1 ) {
			log.Info("Tag currpagelayoutid is not used on a Mypage or Community Page. No page layout id is available, -1 is used");
		}
		
		
		SetStateSharedVariable(GetTagAttributeAsString(ATTRIB_ID), layoutID, Scope.GetScope(GetTagAttributeAsString(ATTRIB_SCOPE)), false);
		
		return null;
	}
	@Override
	public ATag Create() 
	{
		return new CurrentPageLayoutIdDataTag();
	}

}
