using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.browsing.objectselection;
using com.plumtree.portaluiinfrastructure.search;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.common;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.bea.alui.taglib.portletpageeditor
{
  public class CurrentSortByPropertyIdDataTag : ATag
  {
    public static readonly ITagMetaData TAG;
    public static readonly RequiredTagAttribute ATTRIB_ID;
    public static readonly OptionalTagAttribute ATTRIB_SCOPE;
    static CurrentSortByPropertyIdDataTag()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("currsortpropid", "Sets a data value with the current portlet selection sort by property.");
      ATTRIB_ID = new RequiredTagAttribute("id", CommonTagAttributeConstants.ATTRIB_ID_DESC,
       AttributeType.STRING);
      ATTRIB_SCOPE = new OptionalTagAttribute("scope", CommonTagAttributeConstants.ATTRIB_SCOPE_DESC,
       AttributeType.STRING, Scope.PORTLET_REQUEST.ToString());
    }
    public override HTMLElement DisplayTag()
    {
      AActivitySpace env = (AActivitySpace) GetEnvironment();
      ISearchResultModel searchModel = (ISearchResultModel) env.GetModel(SearchResultModel.STR_MVC_CLASS_NAME);
      if (searchModel == null)
      {
        throw new XPIllegalStateException("This tag requires a page with the SearchResultModel. None was found in the current ActivitySpace.");
        }
      String strPropId = searchModel.GetSortOrder();
      GetState().SetSharedVariable(GetTagAttributeAsString(ATTRIB_ID), strPropId,
       Scope.GetScope(GetTagAttributeAsString(ATTRIB_SCOPE)), false);
      return ProcessTagBody();
    }
    public override ATag Create()
    {
      return new CurrentSortByPropertyIdDataTag();
    }
  }
}