using System;
using com.plumtree.portaluiinfrastructure.tags.metadata;
namespace com.bea.alui.taglib.portletpageeditor
{
  /// <summary>
  /// Meta-data for the Portlet Editor Page tag library of Adaptive Layout Framework.  This library
  /// contains all of the tags for the Portlet Editor page in Adaptive Layout Framework.
  /// </summary>
  /// <author>Ravi Tunuguntla</author>
  public class PortletPageEditorTagLibraryData : ITagLibraryMetaData
  {
    public static readonly TagLibraryMetaData LIBRARY = new TagLibraryMetaData("Portlet Page Editor Tags for Adaptive Layout",
     "portletpageeditor", "This library contains the Portlet Page Editor tags for the Adaptive Layout Framework.  " + "These tags are only available on the Portlet Selection Adaptive Layout, which applies to " + "the DHTML flyout for adding portlets to a page.",
     1.0);
    public const String FLYOUT_ONLY = "These tags are only available on the Portlet " + "Selection layout, which applies to the DHTML flyout for adding portlets to a page.";
    public static RequiredTagAttribute ATTRIB_FLYOUTID = new RequiredTagAttribute("flyoutID",
     "Specifies the ID of the div that will have the flyout effect.", AttributeType.STRING);
    }
}