using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.data;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.xpshared.htmlelements;
namespace com.bea.alui.taglib.portletpageeditor
{
  public class PortletSortPropertyEntry : ATag
  {
    public static readonly ITagMetaData TAG;
    public static readonly RequiredTagAttribute ATTRIB_ID;
    public static readonly RequiredTagAttribute ATTRIB_NAME;
    public static readonly RequiredParentTag PARENT_TAG;
    static PortletSortPropertyEntry()
    {
      // The TAG member variable needs to be initialized first since it
      // can be used in other tags (i.e. as a RequiredParentTag) that
      // are referenced by member variables of this tag (i.e. as a
      // RelatedChildTag).  This is necessary for tags that have
      // circular references such as a parent / child tag relationship.
      TAG = new TagMetaData("sortpropertyentry", "Specifies a sort property entry for the sortpropertiesdata tag. This tag is only usable with the sortpropertiesdata tag. " + "The order of the entries is preserved in the resulting data collection.",
       PortletSortPropertyDataTag.EXAMPLE);
      ATTRIB_ID = new RequiredTagAttribute("propid", ATag.EncodeForTagDoc("The ID of the property. For custom object properties, this is the ID of property object. " + "Positive value for ascending order and negative for descending order. " + "IDs for other common properties:<br/>" + "<ul><li>1 - The item name.</li>" + "<li>2 - The item description.</li>" + "<li>3 - The item creation date. </li>" + "<li>4 - The item last modified date.</li>" + "</ul>"),
       AttributeType.INT);
      ATTRIB_NAME = new RequiredTagAttribute("proptitle", "The display string for the property.",
       AttributeType.STRING);
      PARENT_TAG = new RequiredParentTag(PortletSortPropertyDataTag.TAG);
      }
    public override HTMLElement DisplayTag()
    {
      int propId = GetTagAttributeAsInt(ATTRIB_ID);
      String propName = GetTagAttributeAsString(ATTRIB_NAME);
      HashtableDataObject entry = new HashtableDataObject();
      entry.SetData(PortletSortPropertyDataTag.DATA_OBJECTID, propId + "");
      entry.SetData(PortletSortPropertyDataTag.DATA_OBJECTNAME, propName);
      XPArrayList propEntries = (XPArrayList) GetState().GetVariable(PortletSortPropertyDataTag.DATAVARNAME_PROPENTRIES,
       Scope.TAG);
      propEntries.Add(entry);
      return null;
    }
    public override ATag Create()
    {
      return new PortletSortPropertyEntry();
    }
  }
}