using System;
using com.plumtree.openfoundation.util;
using junit.framework;
using xpunit.framework;
namespace com.bea.alui.taglib.portletpageeditor.test
{
  public class TaglibPortletPageEditorTestSuite
  {
    public const String SUITENAME = "PortletPageEditor Tag Library Unit & Integration Tests";
    // All of our JS funcs should be of the form "name = function(args)".
    public const String JS_FUNCTION_SUFFIX = " = function(";
    public static Test suite()
    {
      XpTestSuite suite = new XpTestSuite(SUITENAME);
      suite.addTestSuite(typeof(FlyoutJSTagTest));
      suite.addTestSuite(typeof(TestPortletBrowseBreadCrumbDataTag));
      suite.addTestSuite(typeof(TestPortletBrowseModeTag));
      suite.addTestSuite(typeof(TestPortletBrowseSubFoldersDataTag));
      suite.addTestSuite(typeof(TestPortletDataTag));
      suite.addTestSuite(typeof(TestPortletJSTag));
      suite.addTestSuite(typeof(TestPortletPaginationDataTag));
      suite.addTestSuite(typeof(TestPortletSearchFormTag));
      suite.addTestSuite(typeof(TestPortletSortPropertyDataTag));
      return suite;
    }
    public static void CheckFunctionName(String _strJSName, String _strOutput,
     bool bPresent)
    {
      String strFunction = _strJSName + JS_FUNCTION_SUFFIX;
      if (bPresent)
      {
        // Check that it's there.
        Assert.assertTrue("Checking that the " + _strJSName + " JS function name [" + strFunction + "] is present in output: " + _strOutput,
         XPStringUtility.IndexOf(_strOutput, strFunction) >= 0);
      } else
      {
        // Check that it's not there.
        Assert.assertTrue("Checking that the " + _strJSName + " JS function name [" + strFunction + "] is not present in output: " + _strOutput,
         XPStringUtility.IndexOf(_strOutput, strFunction) < 0);
      }
    }
  }
}