using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.browsing.objectselection;
using com.plumtree.portalpages.common.folder;
using com.plumtree.portaluiinfrastructure.resultwrapper;
using com.plumtree.portaluiinfrastructure.search;
using com.plumtree.server;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.bea.alui.taglib.portletpageeditor.test.integration
{
  /// <summary>
  /// Mock object for testing purposes.
  /// </summary>
  public class MockObjectSelectionModel : IModel,IObjectSelectionModel,IObjectSelectionModelRO,
  IFolderModelRO
  {
    public SearchSettingCollection m_css = new SearchSettingCollection();
    public bool m_bDisplaySearch = false;
    public int m_nSelectedObjectID = -1;
    public IASQueryResult m_breadCrumbs;
    public IASQueryResult m_subFolders;
    // Pagination data
    public int m_nTotalItems = 0;
    private int m_nSortPropertyId = -PT_INTRINSICS.PT_PROPERTY_OBJECTLASTMODIFIED;
    //private boolean m_bSortPropSet = false;
    public int m_nObjectTypeIndex = 0;
    public XPArrayList m_ObjectClassTypeList = new XPArrayList();
    public XPArrayList m_ObjectResultsList = new XPArrayList();
    
    /// <summary>
    /// This method adds a new result item to the list.
    /// It will be accessible by index.
    /// AddObjectType() must be called before this method will work.
    /// </summary>
    /// <param name="_data">A hashtable of Integer propids to Object data.</param>
    public virtual void AddResultItem(XPHashtable _data)
    {
      XPHashtable results = (XPHashtable) m_ObjectResultsList.GetElement(m_nObjectTypeIndex);
      results.PutElement(results.GetSize(), _data);
    }
    
    /// <summary>
    /// This method must be called before adding result items.
    /// </summary>
    /// <param name="_nClassID">The class ID type to add.</param>
    public virtual void AddObjectType(int _nClassID)
    {
      m_ObjectResultsList.Add(new XPHashtable());
      m_ObjectClassTypeList.Add(_nClassID);
    }
    public virtual bool DoNotShowObjectWithID(int nObjectID)
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual void SetBreadCrumbPath(IASQueryResult _result)
    {
      m_breadCrumbs = _result;
    }
    public virtual IASQueryResult GetBreadCrumbPath()
    {
      return m_breadCrumbs;
    }
    public virtual bool GetDisplaySearch()
    {
      return m_bDisplaySearch;
    }
    public virtual String GetInputValue(String strInput)
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual bool GetMultipleSelect()
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual String GetParentFormName()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual String GetParentFormSelectedItems()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual String GetParentFormSpaceID()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual String GetParentFormSubmitFunction()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual SearchSettingCollection GetSearchSettingCollection()
    {
      return m_css;
    }
    public virtual bool GetSearchStarted()
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual String GetSelectedNamesAsString()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual int GetSelectorClassID()
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual int GetSelectorCommunityFolderID()
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual int GetSelectorObjectID()
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual int GetSelectorPageID()
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual int GetTemporaryInvitationID()
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual String GetTemporaryInvitationName()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual bool IsCommunityPage()
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual bool IsHomeMyPage()
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual bool IsMyPage()
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual bool IsPageTemplate()
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual bool DoNotShowObject(int nIndex)
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual bool GetDisplayPaginationHiddenInputs()
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual bool GetDisplaySortHiddenInputs()
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual int GetHeaderCount()
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual bool GetHeaderHasCheckbox()
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual HTMLTableRow GetHeaderRow()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual String GetHeaderText(int nHeaderIndex)
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual bool GetIsCollapsable()
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual bool GetIsObjectSelected(int nObjectID)
    {
      if (nObjectID == m_nSelectedObjectID)
      {
        return true;
      }
      return false;
    }
    public virtual String GetObjectBannerTitle()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual int GetObjectColumnCount()
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual int GetObjectCount()
    {
      return ((XPHashtable) m_ObjectResultsList.GetElement(m_nObjectTypeIndex)).GetSize();
      }
    public virtual Object GetObjectFields(int nIndex, int nPropID)
    {
      XPHashtable resultSet = (XPHashtable) m_ObjectResultsList.GetElement(m_nObjectTypeIndex);
      return ((XPHashtable) resultSet.GetElement(nIndex)).GetElement(nPropID);
      }
    public virtual int GetObjectSubType(int nIndex)
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual int GetObjectType()
    {
      return XPConvert.ToInteger(m_ObjectClassTypeList.GetElement(m_nObjectTypeIndex));
      }
    public virtual bool GetObjectViewIsCollapsed()
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual bool GetShowPagination()
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual bool GetSortable()
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual String GetSpaceID()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual bool ShowObjectBanner()
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual String GetName()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual void CleanupAllData()
    {
    }
    // TODO Auto-generated method stub
    public virtual void CleanupTempData()
    {
    }
    // TODO Auto-generated method stub
    public virtual void Init(AActivitySpace parent)
    {
    }
    // TODO Auto-generated method stub
    public virtual Object Create()
    {
      // TODO Auto-generated method stub
      return null;
    }
    
    /// <summary>
    /// IFolderModelRO methods. *
    /// </summary>
    public virtual int GetCurrentFolderID()
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual int GetCurrentFolderLevel()
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual String GetCurrentFolderName()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual int GetFirstFolderIndex()
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual int GetFolderColumnCount()
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual IASQueryResult GetFolderObjectCount()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual void SetFolderQueryResult(IASQueryResult _result)
    {
      m_subFolders = _result;
    }
    public virtual IASQueryResult GetFolderQueryResult()
    {
      return m_subFolders;
    }
    public virtual IFolderViewHelper GetFolderViewHelper()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual bool GetIsFolderSelected(int nFolderID)
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual int GetLastFolderIndex()
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual int GetNumSubSubFoldersToDisplay()
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual int GetParentFolderID()
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual Object[] GetParentFolderIDs()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual String GetPath()
    {
      // TODO Auto-generated method stub
      return null;
    }
    public virtual bool GetShowCheckbox()
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual bool GetShowFolderBanner()
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual int GetSubFolderCount(int nFolderLevel)
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual int GetSubFolderCount()
    {
      // TODO Auto-generated method stub
      return 0;
    }
    public virtual bool InRootFolder()
    {
      // TODO Auto-generated method stub
      return false;
    }
    public virtual void SetDisplaySearch(bool _bDisplaySearch)
    {
      m_bDisplaySearch = _bDisplaySearch;
    }
    public virtual void SetObjectViewIndex(int nObjectViewIndex)
    {
      m_nObjectTypeIndex = nObjectViewIndex;
    }
    public virtual void RefreshSelectedObjects()
    {
    }
    // TODO Auto-generated method stub
    public virtual bool CheckEditorAccessAndStart(XPHashtable htFormData)
    {
      return false;
    }
    public virtual int GetSortPropertyId()
    {
      return m_nSortPropertyId;
    }
    public virtual void SetFirstDisplayableItem(int _nFirstItem)
    {
    }
    // TODO Auto-generated method stub
    public virtual void SetItemsPerPage(int _nItemsPerPage)
    {
    }
    // TODO Auto-generated method stub
    public virtual int GetFirstDisplayableItem()
    {
      // TODO Auto-generated method stub
      return 1;
    }
    public virtual int GetItemsPerPage()
    {
      // TODO Auto-generated method stub
      return 10;
    }
    public virtual int GetTotalItems()
    {
      return m_nTotalItems;
    }
    public virtual int GetSelectorCommunityID()
    {
      // TODO Auto-generated method stub
      return 0;
    }
  }
}