package com.bea.alui.taglib.portletpageeditor;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.browsing.objectselection.*;
import com.plumtree.portaluiinfrastructure.search.*;
import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.portaluiinfrastructure.tags.common.*;
import com.plumtree.portaluiinfrastructure.tags.metadata.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlelements.*;

public class CurrentSortByPropertyIdDataTag extends ATag 
{
	public static final ITagMetaData TAG;
	public static final RequiredTagAttribute ATTRIB_ID;
	public static final OptionalTagAttribute ATTRIB_SCOPE;
	
	static
	{
		// The TAG member variable needs to be initialized first since it
		// can be used in other tags (i.e. as a RequiredParentTag) that
		// are referenced by member variables of this tag (i.e. as a
		// RelatedChildTag).  This is necessary for tags that have
		// circular references such as a parent / child tag relationship.
		TAG = new TagMetaData("currsortpropid", 
				"Sets a data value with the current portlet selection sort by property."
			);

		ATTRIB_ID = new RequiredTagAttribute("id",
			CommonTagAttributeConstants.ATTRIB_ID_DESC,	
			AttributeType.STRING);

		ATTRIB_SCOPE = new OptionalTagAttribute("scope",
			CommonTagAttributeConstants.ATTRIB_SCOPE_DESC,
			AttributeType.STRING, Scope.PORTLET_REQUEST.toString());
	}

	@Override
	public HTMLElement DisplayTag() 
	{
		AActivitySpace env = (AActivitySpace) GetEnvironment();
		ISearchResultModel searchModel = (ISearchResultModel) env.GetModel(SearchResultModel.STR_MVC_CLASS_NAME);
		if ( searchModel == null ) {
			throw new XPIllegalStateException("This tag requires a page with the SearchResultModel. None was found in the current ActivitySpace."); 
		}
		
		String strPropId = searchModel.GetSortOrder();
		GetState().SetSharedVariable(	GetTagAttributeAsString(ATTRIB_ID), 
										strPropId, 
										Scope.GetScope(GetTagAttributeAsString(ATTRIB_SCOPE)), 
										false);	
		
		return ProcessTagBody();
	}
	@Override
	public ATag Create() 
	{
		return new CurrentSortByPropertyIdDataTag();
	}

}
