/*******************************************************************************
 *  BEA Systems, Inc. CONFIDENTIAL
 * _______________________________
 * 
 *  (c) Copyright 2007  BEA Systems, Inc.
 *  All Rights Reserved.
 * 
 *  NOTICE:  All information contained herein is, and remains
 *  the property of BEA Systems, Inc. and its suppliers, if any.
 *  The intellectual and technical concepts contained herein
 *  are proprietary to BEA Systems, Inc. and its suppliers and may
 *  be covered by U.S. and Foreign Patents, patents in process,
 *  and are protected by trade secret or copyright law.
 *  Dissemination of this information or reproduction of this material
 *  is strictly forbidden unless prior written permission is obtained
 *  from BEA Systems, Inc..
 *******************************************************************************/
package com.bea.alui.taglib.portletpageeditor;

import com.plumtree.portaluiinfrastructure.tags.metadata.*;

/**
 * Meta-data for the Portlet Editor Page tag library of Adaptive Layout Framework.  This library
 * contains all of the tags for the Portlet Editor page in Adaptive Layout Framework.
 * @author Ravi Tunuguntla
 */
public class PortletPageEditorTagLibraryData implements ITagLibraryMetaData
{
	public static final TagLibraryMetaData LIBRARY = new TagLibraryMetaData
		("Portlet Page Editor Tags for Adaptive Layout", "portletpageeditor",
		"This library contains the Portlet Page Editor tags for the Adaptive Layout Framework.  " +
		"These tags are only available on the Portlet Selection Adaptive Layout, which applies to " +
		"the DHTML flyout for adding portlets to a page.",
		1.0);
	public static final String FLYOUT_ONLY = "These tags are only available on the Portlet " +
		"Selection layout, which applies to the DHTML flyout for adding portlets to a page.";
	
	public static RequiredTagAttribute ATTRIB_FLYOUTID = new RequiredTagAttribute("flyoutID",
			"Specifies the ID of the div that will have the flyout effect.",	
			AttributeType.STRING);
}