package com.bea.alui.taglib.portletpageeditor.test;

import com.plumtree.openfoundation.util.*;

import junit.framework.*;
import xpunit.framework.*;

public class TaglibPortletPageEditorTestSuite
{
	public static final String SUITENAME = "PortletPageEditor Tag Library Unit & Integration Tests";

	// All of our JS funcs should be of the form "name = function(args)".
	public static final String JS_FUNCTION_SUFFIX = " = function(";

	public static Test suite() {
		XpTestSuite suite = new XpTestSuite(SUITENAME);
        suite.addTestSuite(FlyoutJSTagTest.class);
        suite.addTestSuite(TestPortletBrowseBreadCrumbDataTag.class);
        suite.addTestSuite(TestPortletBrowseModeTag.class);
        suite.addTestSuite(TestPortletBrowseSubFoldersDataTag.class);
        suite.addTestSuite(TestPortletDataTag.class);
        suite.addTestSuite(TestPortletJSTag.class);
        suite.addTestSuite(TestPortletPaginationDataTag.class);
        suite.addTestSuite(TestPortletSearchFormTag.class);
        suite.addTestSuite(TestPortletSortPropertyDataTag.class);
		return suite;
	}

	public static void CheckFunctionName(String _strJSName, String _strOutput, boolean bPresent)
	{
   		String strFunction = _strJSName + JS_FUNCTION_SUFFIX;
   		if (bPresent)
   		{
   			// Check that it's there.
	   		Assert.assertTrue("Checking that the " + _strJSName + " JS function name [" + strFunction +
	   			"] is present in output: " + _strOutput,
	   			XPStringUtility.IndexOf(_strOutput, strFunction) >= 0);
   		} else
   		{
   			// Check that it's not there.
	   		Assert.assertTrue("Checking that the " + _strJSName + " JS function name [" + strFunction +
		   		"] is not present in output: " + _strOutput,
	   			XPStringUtility.IndexOf(_strOutput, strFunction) < 0);
   		}
	}
}
