package com.bea.alui.taglib.portletpageeditor.test.integration;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portalpages.browsing.objectselection.*;
import com.plumtree.portalpages.common.folder.*;
import com.plumtree.portaluiinfrastructure.resultwrapper.*;
import com.plumtree.portaluiinfrastructure.search.*;
import com.plumtree.server.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlelements.*;

/**
 * Mock object for testing purposes.
 */
public class MockObjectSelectionModel implements IModel, IObjectSelectionModel,
	IObjectSelectionModelRO, IFolderModelRO
{
	public SearchSettingCollection m_css = new SearchSettingCollection();
	public boolean m_bDisplaySearch = false;
	public int m_nSelectedObjectID = -1;
	public IASQueryResult m_breadCrumbs;
	public IASQueryResult m_subFolders;

	// Pagination data
	public int m_nTotalItems = 0;

	private int m_nSortPropertyId = -PT_INTRINSICS.PT_PROPERTY_OBJECTLASTMODIFIED;
	//private boolean m_bSortPropSet = false;
	
	public int m_nObjectTypeIndex = 0;
	public XPArrayList m_ObjectClassTypeList = new XPArrayList();
	public XPArrayList m_ObjectResultsList = new XPArrayList();

	/**
	 * This method adds a new result item to the list.
	 * It will be accessible by index.
	 * 
	 * AddObjectType() must be called before this method will work.
	 * 
	 * @param _data A hashtable of Integer propids to Object data.
	 */
	public void AddResultItem(XPHashtable _data)
	{
		XPHashtable results = (XPHashtable) m_ObjectResultsList.GetElement(m_nObjectTypeIndex);
		results.PutElement(new Integer(results.GetSize()), _data);
	}

	/**
	 * This method must be called before adding result items.
	 * 
	 * @param _nClassID The class ID type to add.
	 */
	public void AddObjectType(int _nClassID)
	{
		m_ObjectResultsList.Add(new XPHashtable());
		m_ObjectClassTypeList.Add(new Integer(_nClassID));
	}

	public boolean DoNotShowObjectWithID(int nObjectID) {
		// TODO Auto-generated method stub
		return false;
	}

	public void SetBreadCrumbPath(IASQueryResult _result)
	{
		m_breadCrumbs = _result;
	}

	public IASQueryResult GetBreadCrumbPath()
	{
		return m_breadCrumbs;
	}

	public boolean GetDisplaySearch() {
		return m_bDisplaySearch;
	}

	public String GetInputValue(String strInput) {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean GetMultipleSelect() {
		// TODO Auto-generated method stub
		return false;
	}

	public String GetParentFormName() {
		// TODO Auto-generated method stub
		return null;
	}

	public String GetParentFormSelectedItems() {
		// TODO Auto-generated method stub
		return null;
	}

	public String GetParentFormSpaceID() {
		// TODO Auto-generated method stub
		return null;
	}

	public String GetParentFormSubmitFunction() {
		// TODO Auto-generated method stub
		return null;
	}

	public SearchSettingCollection GetSearchSettingCollection() {
		return m_css;
	}

	public boolean GetSearchStarted() {
		// TODO Auto-generated method stub
		return false;
	}

	public String GetSelectedNamesAsString() {
		// TODO Auto-generated method stub
		return null;
	}

	public int GetSelectorClassID() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetSelectorCommunityFolderID() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetSelectorObjectID() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetSelectorPageID() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetTemporaryInvitationID() {
		// TODO Auto-generated method stub
		return 0;
	}

	public String GetTemporaryInvitationName() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean IsCommunityPage() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean IsHomeMyPage() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean IsMyPage() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean IsPageTemplate() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean DoNotShowObject(int nIndex) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean GetDisplayPaginationHiddenInputs() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean GetDisplaySortHiddenInputs() {
		// TODO Auto-generated method stub
		return false;
	}

	public int GetHeaderCount() {
		// TODO Auto-generated method stub
		return 0;
	}

	public boolean GetHeaderHasCheckbox() {
		// TODO Auto-generated method stub
		return false;
	}

	public HTMLTableRow GetHeaderRow() {
		// TODO Auto-generated method stub
		return null;
	}

	public String GetHeaderText(int nHeaderIndex) {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean GetIsCollapsable() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean GetIsObjectSelected(int nObjectID) {
		if (nObjectID == m_nSelectedObjectID)
		{
			return true;
		}

		return false;
	}

	public String GetObjectBannerTitle() {
		// TODO Auto-generated method stub
		return null;
	}

	public int GetObjectColumnCount() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetObjectCount() {
		return ((XPHashtable) m_ObjectResultsList.GetElement(m_nObjectTypeIndex)).GetSize();
	}

	public Object GetObjectFields(int nIndex, int nPropID)
	{
		XPHashtable resultSet = (XPHashtable) m_ObjectResultsList.GetElement(m_nObjectTypeIndex);
		return ((XPHashtable) resultSet.GetElement(new Integer(nIndex))).
			GetElement(new Integer(nPropID));
	}

	public int GetObjectSubType(int nIndex) {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetObjectType()
	{
		return XPConvert.ToInteger(m_ObjectClassTypeList.GetElement(m_nObjectTypeIndex));
	}

	public boolean GetObjectViewIsCollapsed() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean GetShowPagination() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean GetSortable() {
		// TODO Auto-generated method stub
		return false;
	}

	public String GetSpaceID() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean ShowObjectBanner() {
		// TODO Auto-generated method stub
		return false;
	}

	public String GetName() {
		// TODO Auto-generated method stub
		return null;
	}

	public void CleanupAllData() {
		// TODO Auto-generated method stub
		
	}

	public void CleanupTempData() {
		// TODO Auto-generated method stub
		
	}

	public void Init(AActivitySpace parent) {
		// TODO Auto-generated method stub
		
	}

	public Object Create() {
		// TODO Auto-generated method stub
		return null;
	}

	/** IFolderModelRO methods. **/

	public int GetCurrentFolderID() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetCurrentFolderLevel() {
		// TODO Auto-generated method stub
		return 0;
	}

	public String GetCurrentFolderName() {
		// TODO Auto-generated method stub
		return null;
	}

	public int GetFirstFolderIndex() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetFolderColumnCount() {
		// TODO Auto-generated method stub
		return 0;
	}

	public IASQueryResult GetFolderObjectCount() {
		// TODO Auto-generated method stub
		return null;
	}

	public void SetFolderQueryResult(IASQueryResult _result)
	{
		m_subFolders = _result;
	}

	public IASQueryResult GetFolderQueryResult()
	{
		return m_subFolders;
	}

	public IFolderViewHelper GetFolderViewHelper() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean GetIsFolderSelected(int nFolderID) {
		// TODO Auto-generated method stub
		return false;
	}

	public int GetLastFolderIndex() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetNumSubSubFoldersToDisplay() {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetParentFolderID() {
		// TODO Auto-generated method stub
		return 0;
	}

	public Object[] GetParentFolderIDs() {
		// TODO Auto-generated method stub
		return null;
	}

	public String GetPath() {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean GetShowCheckbox() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean GetShowFolderBanner() {
		// TODO Auto-generated method stub
		return false;
	}

	public int GetSubFolderCount(int nFolderLevel) {
		// TODO Auto-generated method stub
		return 0;
	}

	public int GetSubFolderCount() {
		// TODO Auto-generated method stub
		return 0;
	}

	public boolean InRootFolder() {
		// TODO Auto-generated method stub
		return false;
	}

	public void SetDisplaySearch(boolean _bDisplaySearch) {
		m_bDisplaySearch = _bDisplaySearch;
	}

	public void SetObjectViewIndex(int nObjectViewIndex)
	{
		m_nObjectTypeIndex = nObjectViewIndex;
	}

	public void RefreshSelectedObjects() {
		// TODO Auto-generated method stub
	}
	
	public boolean CheckEditorAccessAndStart(XPHashtable htFormData) {
		return false;
	}
	
	public int GetSortPropertyId() {
		return m_nSortPropertyId;
	}

	public void SetFirstDisplayableItem(int _nFirstItem) {
		// TODO Auto-generated method stub
		
	}

	public void SetItemsPerPage(int _nItemsPerPage) {
		// TODO Auto-generated method stub
		
	}

	public int GetFirstDisplayableItem() {
		// TODO Auto-generated method stub
		return 1;
	}

	public int GetItemsPerPage() {
		// TODO Auto-generated method stub
		return 10;
	}

	public int GetTotalItems()
	{
		return m_nTotalItems;
	}

	public int GetSelectorCommunityID() {
		// TODO Auto-generated method stub
		return 0;
	}
}