using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portaluiinfrastructure.search;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.uiinfrastructure.activityspace;
namespace com.bea.alui.taglib.searchpage
{
  /// <summary>
  /// Abstract base class to simplify search page tag development. Used to retrieve the
  /// model (ISearchResultModelRO)
  /// </summary>
  /// <author>smahendr</author>
  public abstract class ASearchPageTag : ATag
  {
    protected const String SEARCH_PAGE_ONLY_CONSTANT = "This tag only works with " + "the Search Page Adaptive Layout.";
    
    /// <returns>The current Search Results Model. </returns>
    /// <throws>
    /// XPNullPointerException if a model that
    /// implements ISearchResultModelRO is not found.
    /// </throws>
    protected virtual ISearchResultModelRO GetSearchResultModel()
    {
      AActivitySpace space = (AActivitySpace) GetEnvironment();
      if (space.GetModelExists(SearchResultModel.STR_MVC_CLASS_NAME))
      {
        return (ISearchResultModelRO) space.GetModel(SearchResultModel.STR_MVC_CLASS_NAME);
        } else
      {
        throw new XPNullPointerException(GetName() + " tag can only be used in " + "the Search Results Page.");
        }
    }
  }
}