using System;
using com.plumtree.openfoundation.util;
using com.plumtree.portalpages.browsing.search.results;
using com.plumtree.portaluiinfrastructure.search;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.common;
using com.plumtree.portaluiinfrastructure.tags.data;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.bea.alui.taglib.searchpage
{
  public class FollowupFormDataTag : ASearchPageTag
  {
    public const String TAG_NAME = "followupformdata";
    public const String INPUT_NAME = "inputName";
    public const String FOLLOWUP_OPTIONS_KEY = "followupOptionsKey";
    public const String NAME = "name";
    public const String VALUE = "value";
    public static readonly ITagMetaData TAG;
    public static readonly RequiredParentTag PARENT;
    public static readonly RequiredTagAttribute ID;
    public static readonly OptionalTagAttribute SCOPE;
    static FollowupFormDataTag()
    {
      TAG = new TagMetaData(TAG_NAME, "Stores the data necessary to " + "build the follow up search form. " + SEARCH_PAGE_ONLY_CONSTANT,
       FollowUpFormTagConstants.EXAMPLE_BUTTON);
      PARENT = new RequiredParentTag(FollowupFormTag.TAG);
      ID = new RequiredTagAttribute(CommonTagAttributeConstants.ATTRIB_ID_NAME,
       CommonTagAttributeConstants.ATTRIB_ID_DESC + " The following attributes are added to this Data Object: " + INPUT_NAME + " - returns the name to be used to submit the form with the value selected, " + FOLLOWUP_OPTIONS_KEY + " - contains the key used to store the list of follow up search options in memory. Each data object in the " + "follow up search option list has a \'" + NAME + "\' and a \'" + VALUE + "\' that can be retrieved.",
       AttributeType.STRING);
      SCOPE = new OptionalTagAttribute(CommonTagAttributeConstants.ATTRIB_SCOPE_NAME,
       CommonTagAttributeConstants.ATTRIB_SCOPE_DESC, AttributeType.STRING,
       Scope.PORTLET_REQUEST.ToString());
    }
    public override ATag Create()
    {
      return new FollowupFormDataTag();
    }
    public override HTMLElement DisplayTag()
    {
      AActivitySpace asOwner = (AActivitySpace) GetEnvironment();
      ISearchResultModelRO model = GetSearchResultModel();
      IXPList dataObjectList = new XPArrayList();
      IXPList optionsList = FollowupSearchView.GetWithinResultsOptions(model,
       asOwner);
      for (int i = 0;i < optionsList.GetSize();i++)
      {
        HTMLOption option = (HTMLOption) optionsList.GetElement(i);
        HashtableDataObject htOption = new HashtableDataObject();
        htOption.SetData(NAME, option.GetInnerHTMLDisplayString());
        htOption.SetData(VALUE, option.GetValue());
        dataObjectList.Add(htOption);
      }
      String strDataReference = GetTagAttributeAsString(ID);
      Scope tagScope = Scope.GetScope(GetTagAttributeAsString(SCOPE));
      String optionKey = strDataReference + "option";
      // DCA - populate data object
      HashtableDataObject htObject = new HashtableDataObject();
      htObject.SetData(INPUT_NAME, SearchWithinResultsControl.WITHIN_RESULTS_DATA_SE);
      htObject.SetData(FOLLOWUP_OPTIONS_KEY, optionKey);
      GetState().SetSharedVariable(strDataReference, htObject, tagScope, true);
      GetState().SetSharedVariable(optionKey, dataObjectList, tagScope, true);
      return ProcessTagBody();
    }
  }
}