using System;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.xpshared.htmlelements;
namespace com.bea.alui.taglib.searchpage
{
  public class FollowupFormSubmitLinkTag : ASearchPageTag
  {
    public const String TAG_NAME = "followupformsubmitlink";
    public static readonly ITagMetaData TAG;
    public static readonly RequiredParentTag PARENT;
    static FollowupFormSubmitLinkTag()
    {
      TAG = new TagMetaData(TAG_NAME, "Generates an HTML anchor to submit the " + "follow up search form. " + SEARCH_PAGE_ONLY_CONSTANT,
       FollowUpFormTagConstants.EXAMPLE_LINK);
      PARENT = new RequiredParentTag(FollowupFormTag.TAG);
    }
    public override ATag Create()
    {
      return new FollowupFormSubmitLinkTag();
    }
    public override HTMLElement DisplayTag()
    {
      HTMLElementCollection result = new HTMLElementCollection();
      result.AddInnerHTMLString("<a onclick=\"submitSearchPTSWR(); return false;\" href=\"#\">");
      result.AddInnerHTMLElement(ProcessTagBody());
      result.AddInnerHTMLString("</a>");
      return result;
    }
  }
}