using System;
using com.plumtree.openfoundation.util;
using XPHttpUtility=com.plumtree.openfoundation.web.XPHttpUtility;
using com.plumtree.portaluiinfrastructure.search;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.xpshared.htmlelements;
namespace com.bea.alui.taglib.searchpage
{
  public class FollowupFormTextBoxTag : ASearchPageTag
  {
    public const String TAG_NAME = "followupformtextbox";
    public static readonly ITagMetaData TAG;
    public static readonly RequiredParentTag PARENT;
    static FollowupFormTextBoxTag()
    {
      TAG = new TagMetaData(TAG_NAME, "This tag generates the search box for the follow " + "up search, including the previous query string as a default value. " + SEARCH_PAGE_ONLY_CONSTANT,
       FollowUpFormTagConstants.EXAMPLE_BUTTON);
      PARENT = new RequiredParentTag(FollowupFormTag.TAG);
    }
    public override ATag Create()
    {
      return new FollowupFormTextBoxTag();
    }
    public override TagType GetTagType()
    {
      return TagType.NO_BODY;
    }
    public override HTMLElement DisplayTag()
    {
      // TODO: CR DLH The search string and onkeydown values should be stored as part of
      // the followupformdata so that users can generate their own textbox.  This is not
      // the right way to do it because it makes it difficult to customize.
      ISearchResultModelRO model = GetSearchResultModel();
      Object oTextBoxName = GetStateSharedVariable(FollowupFormTag.SEARCH_INPUT_TEXT_NAME,
       Scope.TAG);
      String textBoxName = XPConvert.ToString(oTextBoxName);
      XPStringBuilder strb = new XPStringBuilder();
      strb.Append("<input type=\"text\" name=\"");
      strb.Append(textBoxName);
      strb.Append("\" value=\"");
      strb.Append(XPHttpUtility.HtmlEncode(model.GetLocalizedSearchString()));
      strb.Append("\" onkeydown=\"handleKeyDownPTSWR(event);\"");
      String strXMLAttributes = GetXMLTagAttributesAsString();
      if ((strXMLAttributes != null) && (strXMLAttributes.Length > 0))
      {
        strb.Append(" ");
        strb.Append(strXMLAttributes);
      }
      strb.Append("/>");
      HTMLElementCollection result = new HTMLElementCollection();
      result.AddInnerHTMLString(strb.ToString());
      return result;
    }
  }
}