using System;
using com.plumtree.portalpages.browsing.search.results;
using com.plumtree.portaluiinfrastructure.tags;
using com.plumtree.portaluiinfrastructure.tags.metadata;
using com.plumtree.uiinfrastructure.activityspace;
using com.plumtree.xpshared.htmlelements;
namespace com.bea.alui.taglib.searchpage
{
  public class SortFormTag : ASearchPageTag
  {
    public const String TAG_NAME = "sortform";
    private static readonly String DEFAULT_NAME = OrganizationView.REORGANIZATION_FORM_NAME;
    private static readonly String DEFAULT_ID = OrganizationView.REORGANIZATION_FORM_NAME;
    public static readonly ITagMetaData TAG;
    public static readonly RelatedChildTag SORTFORMOPTIONS;
    static SortFormTag()
    {
      TAG = new TagMetaData(TAG_NAME, "Displays the form and javascript necessary to change the search results sort order. " + SEARCH_PAGE_ONLY_CONSTANT,
       SortFormTagConstants.EXAMPLE);
      SORTFORMOPTIONS = new RelatedChildTag(SortFormDataTag.TAG);
    }
    public override ATag Create()
    {
      return new SortFormTag();
    }
    public override HTMLElement DisplayTag()
    {
      AActivitySpace asOwner = (AActivitySpace) GetEnvironment();
      String formName = GetXMLTagAttribute("name");
      if (formName == null || formName.Length == 0)
      {
        formName = DEFAULT_NAME;
      }
      String formId = GetXMLTagAttribute("id");
      if (formId == null || formId.Length == 0)
      {
        formId = DEFAULT_ID;
      }
      HTMLForm orgForm = new HTMLForm(formId);
      orgForm.SetMethod("get");
      orgForm.SetName(formName);
      OrganizationView orgView = (OrganizationView) asOwner.GetView(OrganizationView.STR_MVC_CLASS_NAME);
      orgView.addTargetsToOrganizationForm(orgForm, false);
      orgForm.AddInnerHTMLElement(ProcessTagBody());
      return orgForm;
    }
    
    /// <seealso cref="com.plumtree.portaluiinfrastructure.tags.ATag#DisplaySharedJavascript()"></seealso>
    public override HTMLScriptCollection DisplaySharedJavascript()
    {
      AActivitySpace asOwner = (AActivitySpace) GetEnvironment();
      OrganizationView orgView = (OrganizationView) asOwner.GetView(OrganizationView.STR_MVC_CLASS_NAME);
      String formName = GetXMLTagAttribute("name");
      if (formName == null || formName.Length == 0)
      {
        formName = DEFAULT_NAME;
      }
      HTMLScript script = orgView.GetOrganizationFormScripts(formName);
      HTMLScriptCollection collection = new HTMLScriptCollection();
      collection.AddInnerHTMLElement(script);
      return collection;
    }
  }
}