package com.bea.alui.taglib.searchpage;

import com.plumtree.openfoundation.util.*;
import com.plumtree.portaluiinfrastructure.search.*;
import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.uiinfrastructure.activityspace.*;

/**
 * Abstract base class to simplify search page tag development. Used to retrieve the
 * model (ISearchResultModelRO)
 * 
 * @author smahendr
 */
public abstract class ASearchPageTag extends ATag
{
	protected static final String SEARCH_PAGE_ONLY_CONSTANT = "This tag only works with " +
		"the Search Page Adaptive Layout.";

	/**
	 * @return The current Search Results Model. 
	 * @throws XPNullPointerException if a model that
	 * 		implements ISearchResultModelRO is not found.
	 */
	protected ISearchResultModelRO GetSearchResultModel()
	{
		AActivitySpace space = (AActivitySpace) GetEnvironment();
		if (space.GetModelExists(SearchResultModel.STR_MVC_CLASS_NAME)) {
			return (ISearchResultModelRO) space.GetModel(SearchResultModel.STR_MVC_CLASS_NAME);
		} else {
			throw new XPNullPointerException(GetName() + " tag can only be used in " +
				"the Search Results Page.");
		}
	}
}