package com.bea.alui.taglib.searchpage;

import com.plumtree.portaluiinfrastructure.tags.*;

/**
 * This class contains the common examples for the follow up form tags.
 * 
 * It needs to be separate due to static initalization ordering issues.
 */
public class FollowUpFormTagConstants
{
	public static final String TAG_NAME = "followupform";
	public static final String DATA_TAG_NAME = "followupformdata";
	public static final String TEXT_BOX_TAG_NAME = "followupformtextbox";
	public static final String LINK_TAG_NAME = "followupformsubmitlink";
	public static final String LIBRARY_NAME = "searchpage";

	// NOTE: Since these static strings are used in the main tag, and the child tags, and the
	// children tags are referenced in the static initializer block, this text string cannot
	// have direct references to the child tags.  It also needs to be in a separate class so
	// that it can be accessed by all the tags equally during static initialization.
	public static final String EXAMPLE_BASE = "<pt:" + LIBRARY_NAME + "." + TAG_NAME + "><br>" +
		"&nbsp;<pt:" + LIBRARY_NAME + "." + DATA_TAG_NAME + " pt:id=\"followupData\"/><br>" +
		"&nbsp;<pt:core.html pt:tag=\"select\" name=\"$followupData.inputName\"><br>" +
		"&nbsp;&nbsp;<pt:logic.variable pt:key=\"followupOptions\" pt:value=\"$followupData.followupOptionsKey\"/><br>" +
		"&nbsp;&nbsp;<pt:logic.foreach pt:data=\"$followupOptions\" pt:var=\"option\"><br>" +
		"&nbsp;&nbsp;&nbsp;<pt:core.html pt:tag=\"option\" value=\"$option.value\"><pt:logic.value pt:value=\"$option.name\"/></pt:core.html><br>" +
		"&nbsp;&nbsp;</pt:logic.foreach><br>" +
		"&nbsp;</pt:core.html><br>" +
		"&nbsp;<pt:" + LIBRARY_NAME + "." + TEXT_BOX_TAG_NAME + " size=\"20\"/><br>";

	public static final String EXAMPLE_SUFFIX = "</pt:" + LIBRARY_NAME + "." + TAG_NAME + ">";

	// This is an example for the follow up form tag and it's child tags.
	public static final String EXAMPLE_BUTTON = ATag.EncodeForTagDoc(EXAMPLE_BASE +
		"&nbsp;<pt:core.html pt:tag=\"input\" name=\"Search\" type=\"button\" value=\"Search\" onclick=\"$onclick\"/><br>" +
		EXAMPLE_SUFFIX);

	// This is an example for the follow up form tag and it's child tags, using a link instead of a button.
	public static final String EXAMPLE_LINK = ATag.EncodeForTagDoc(EXAMPLE_BASE +
		"&nbsp;<pt:" + LIBRARY_NAME + "." + LINK_TAG_NAME + ">" +
		"Search</pt:" + LIBRARY_NAME + "." + LINK_TAG_NAME + "><br>" +
		EXAMPLE_SUFFIX);
}