package com.bea.alui.taglib.searchpage;

import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.portaluiinfrastructure.tags.metadata.*;
import com.plumtree.xpshared.htmlelements.*;

public class FollowupFormSubmitLinkTag extends ASearchPageTag
{
	public static final String TAG_NAME = "followupformsubmitlink";

	public static final ITagMetaData TAG;
	public static final RequiredParentTag PARENT;

	static
	{
		TAG = new TagMetaData(TAG_NAME, "Generates an HTML anchor to submit the " +
			"follow up search form. " + SEARCH_PAGE_ONLY_CONSTANT, FollowUpFormTagConstants.EXAMPLE_LINK);
		PARENT = new RequiredParentTag(FollowupFormTag.TAG);
	}

	@Override
	public ATag Create() {
		return new FollowupFormSubmitLinkTag();
	}

	@Override
	public HTMLElement DisplayTag()
	{
		HTMLElementCollection result = new HTMLElementCollection();
		result.AddInnerHTMLString("<a onclick=\"submitSearchPTSWR(); return false;\" href=\"#\">");
		result.AddInnerHTMLElement(ProcessTagBody());
		result.AddInnerHTMLString("</a>");
		return result;
	}
}