package com.bea.alui.taglib.searchpage;

import com.plumtree.openfoundation.util.*;
import com.plumtree.openfoundation.web.XPHttpUtility;
import com.plumtree.portaluiinfrastructure.search.*;
import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.portaluiinfrastructure.tags.metadata.*;
import com.plumtree.xpshared.htmlelements.*;

public class FollowupFormTextBoxTag extends ASearchPageTag
{
	public static final String TAG_NAME = "followupformtextbox";

	public static final ITagMetaData TAG;
	public static final RequiredParentTag PARENT;
	
	static
	{
		TAG = new TagMetaData(TAG_NAME, "This tag generates the search box for the follow " +
			"up search, including the previous query string as a default value. " + SEARCH_PAGE_ONLY_CONSTANT,
			FollowUpFormTagConstants.EXAMPLE_BUTTON);
		PARENT = new RequiredParentTag(FollowupFormTag.TAG);
	}

	@Override
	public ATag Create() {
		return new FollowupFormTextBoxTag();
	}

	@Override
	public TagType GetTagType() {
		return TagType.NO_BODY;
	}

	@Override
	public HTMLElement DisplayTag()
	{
		// TODO: CR DLH The search string and onkeydown values should be stored as part of
		// the followupformdata so that users can generate their own textbox.  This is not
		// the right way to do it because it makes it difficult to customize.
		ISearchResultModelRO model = GetSearchResultModel();
		Object oTextBoxName = GetStateSharedVariable(FollowupFormTag.SEARCH_INPUT_TEXT_NAME, Scope.TAG);
		String textBoxName = XPConvert.ToString(oTextBoxName);
		XPStringBuilder strb = new XPStringBuilder();
		strb.Append("<input type=\"text\" name=\"");
		strb.Append(textBoxName);
		strb.Append("\" value=\"");
		strb.Append(XPHttpUtility.HtmlEncode(model.GetLocalizedSearchString()));
		strb.Append("\" onkeydown=\"handleKeyDownPTSWR(event);\"");
		String strXMLAttributes = GetXMLTagAttributesAsString();
		if ((strXMLAttributes != null) && (strXMLAttributes.length() > 0))
		{
			strb.Append(" ");
			strb.Append(strXMLAttributes);
		}
		strb.Append("/>");
		HTMLElementCollection result = new HTMLElementCollection();

		result.AddInnerHTMLString(strb.ToString());

		return result;
	}
}