package com.bea.alui.taglib.searchpage;

import com.plumtree.portalpages.browsing.search.results.*;
import com.plumtree.portaluiinfrastructure.tags.*;
import com.plumtree.portaluiinfrastructure.tags.metadata.*;
import com.plumtree.uiinfrastructure.activityspace.*;
import com.plumtree.xpshared.htmlelements.*;

public class SortFormTag extends ASearchPageTag
{
	public static final String TAG_NAME = "sortform";

	private static final String DEFAULT_NAME = OrganizationView.REORGANIZATION_FORM_NAME;
	private static final String DEFAULT_ID = OrganizationView.REORGANIZATION_FORM_NAME;

	public static final ITagMetaData TAG;
	public static final RelatedChildTag SORTFORMOPTIONS;

	static
	{
		TAG = new TagMetaData(TAG_NAME, "Displays the form and javascript necessary to change the search results sort order. " +
			SEARCH_PAGE_ONLY_CONSTANT, SortFormTagConstants.EXAMPLE);

		SORTFORMOPTIONS = new RelatedChildTag(SortFormDataTag.TAG);
	}
	
	@Override
	public ATag Create() {
		return new SortFormTag();
	}
	
	@Override
	public HTMLElement DisplayTag()
	{
        AActivitySpace asOwner = (AActivitySpace) GetEnvironment();

		String formName = GetXMLTagAttribute("name");
		if(formName == null || formName.length() == 0)
		{
			formName = DEFAULT_NAME;
		}

		String formId = GetXMLTagAttribute("id");
		if(formId == null || formId.length() == 0)
		{
			formId = DEFAULT_ID;
		}
        
		HTMLForm orgForm = new HTMLForm(formId);
		orgForm.SetMethod("get");
		orgForm.SetName(formName);
		OrganizationView orgView = (OrganizationView) asOwner.GetView(OrganizationView.STR_MVC_CLASS_NAME);
		orgView.addTargetsToOrganizationForm(orgForm, false);
		
		orgForm.AddInnerHTMLElement(ProcessTagBody());
		
		return orgForm;
	}

	/**
	 * @see com.plumtree.portaluiinfrastructure.tags.ATag#DisplaySharedJavascript()
	 */
	public HTMLScriptCollection DisplaySharedJavascript()
	{
		AActivitySpace asOwner = (AActivitySpace) GetEnvironment();
		OrganizationView orgView = (OrganizationView) asOwner.GetView(OrganizationView.STR_MVC_CLASS_NAME);
		String formName = GetXMLTagAttribute("name");
		if(formName == null || formName.length() == 0)
		{
			formName = DEFAULT_NAME;
		}
		HTMLScript script =  orgView.GetOrganizationFormScripts(formName);
		HTMLScriptCollection collection = new HTMLScriptCollection();
		collection.AddInnerHTMLElement(script);
		
		return collection;
	}
}
