package com.bea.alui.taglib.searchpage;

import com.plumtree.portaluiinfrastructure.tags.*;

/**
 * This class contains the common examples for the sort form tags.
 * 
 * It needs to be separate due to static initalization ordering issues.
 */
public class SortFormTagConstants
{
	// NOTE: Since this static string is used in the main tag, and the child tags, and the
	// children tags are referenced in the static initializer block, this text string cannot
	// have direct references to the child tags.  It also needs to be in a separate class so
	// that it can be accessed by all the tags equally during static initialization.
	public static final String EXAMPLE = ATag.EncodeForTagDoc(
		"<pt:searchpage.sortform><br>" +
		"&nbsp;<pt:searchpage.sortformdata pt:id=\"sortData\"/><br>" +
		"&nbsp;<pt:logic.concat pt:key=\"sortOnchange\" pt:value1=\"$sortData.onchange\" pt:value2=\"();\" /><br>" +
		"&nbsp;<pt:core.html pt:tag=\"select\" name=\"$sortData.inputName\" onchange=\"$sortOnchange\"><br>" +
		"&nbsp;&nbsp;<pt:logic.foreach pt:data=\"$sortData.sortOptionsKey\" pt:var=\"option\"><br>" +
		"&nbsp;&nbsp;&nbsp;<pt:logic.stringexpr pt:expr=\"($sortData.selectedValue) == ($option.value)\" pt:key=\"selectedOption\"/><br>" +
		"&nbsp;&nbsp;&nbsp;<pt:logic.if pt:expr=\"$selectedOption\"><br>" +
		"&nbsp;&nbsp;&nbsp;&nbsp;<pt:logic.iftrue><br>" +
		"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<pt:core.html pt:tag=\"option\" selected value=\"$option.value\"><pt:logic.value pt:value=\"$option.name\"/></pt:core.html><br>" +
		"&nbsp;&nbsp;&nbsp;&nbsp;</pt:logic.iftrue><br>" +
		"&nbsp;&nbsp;&nbsp;&nbsp;<pt:logic.iffalse><br>" +
		"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<pt:core.html pt:tag=\"option\" value=\"$option.value\"><pt:logic.value pt:value=\"$option.name\"/></pt:core.html><br>" +
		"&nbsp;&nbsp;&nbsp;&nbsp;</pt:logic.iffalse><br>" +
		"&nbsp;&nbsp;&nbsp;</pt:logic.if><br>" +
		"&nbsp;&nbsp;</pt:logic.foreach><br>" +
		"&nbsp;</pt:core.html><br>" +
		"</pt:searchpage.sortform>");
}
